/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var h1=["require","exports","vs/base/common/errors","vs/base/common/functional","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/arraysFind","vs/base/common/charCode","vs/base/common/collections","vs/base/common/arrays","vs/base/common/iterator","vs/base/common/lazy","vs/base/common/linkedList","vs/base/common/map","vs/base/common/stopwatch","vs/base/common/cancellation","vs/base/common/cache","vs/base/common/types","vs/base/common/objects","vs/base/common/uint","vs/base/common/strings","vs/nls!vs/base/common/platform","vs/base/common/platform","vs/nls","vs/nls!vs/base/common/worker/simpleWorker","vs/base/common/worker/simpleWorker"],a1=function(_1){for(var e=[],A=0,t=_1.length;A<t;A++)e[A]=h1[_1[A]];return e};define(h1[6],a1([0,1]),function(_1,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mb=void 0,e.$fb=A,e.$gb=t,e.$hb=G,e.$ib=$,e.$jb=Y,e.$kb=q,e.$lb=U,e.$nb=k,e.$ob=H,e.$pb=J,e.$qb=u1,e.$rb=o1;function A(y,K){const M=t(y,K);if(M!==-1)return y[M]}function t(y,K,M=y.length-1){for(let g=M;g>=0;g--){const b=y[g];if(K(b))return g}return-1}function G(y,K){const M=$(y,K);return M===-1?void 0:y[M]}function $(y,K,M=0,g=y.length){let b=M,T=g;for(;b<T;){const s=Math.floor((b+T)/2);K(y[s])?b=s+1:T=s}return b-1}function Y(y,K){const M=q(y,K);return M===y.length?void 0:y[M]}function q(y,K,M=0,g=y.length){let b=M,T=g;for(;b<T;){const s=Math.floor((b+T)/2);K(y[s])?T=s:b=s+1}return b}function U(y,K,M=0,g=y.length){const b=q(y,K,M,g);return b===y.length?-1:b}class v{static{this.assertInvariants=!1}constructor(K){this.e=K,this.c=0}findLastMonotonous(K){if(v.assertInvariants){if(this.d){for(const g of this.e)if(this.d(g)&&!K(g))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=K}const M=$(this.e,K,this.c);return this.c=M+1,M===-1?void 0:this.e[M]}}e.$mb=v;function k(y,K){if(y.length===0)return;let M=y[0];for(let g=1;g<y.length;g++){const b=y[g];K(b,M)>0&&(M=b)}return M}function H(y,K){if(y.length===0)return;let M=y[0];for(let g=1;g<y.length;g++){const b=y[g];K(b,M)>=0&&(M=b)}return M}function J(y,K){return k(y,(M,g)=>-K(M,g))}function u1(y,K){if(y.length===0)return-1;let M=0;for(let g=1;g<y.length;g++){const b=y[g];K(b,y[M])>0&&(M=g)}return M}function o1(y,K){for(const M of y){const g=K(M);if(g!==void 0)return g}}}),define(h1[7],a1([0,1]),function(_1,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharCode=void 0;var A;(function(t){t[t.Null=0]="Null",t[t.Backspace=8]="Backspace",t[t.Tab=9]="Tab",t[t.LineFeed=10]="LineFeed",t[t.CarriageReturn=13]="CarriageReturn",t[t.Space=32]="Space",t[t.ExclamationMark=33]="ExclamationMark",t[t.DoubleQuote=34]="DoubleQuote",t[t.Hash=35]="Hash",t[t.DollarSign=36]="DollarSign",t[t.PercentSign=37]="PercentSign",t[t.Ampersand=38]="Ampersand",t[t.SingleQuote=39]="SingleQuote",t[t.OpenParen=40]="OpenParen",t[t.CloseParen=41]="CloseParen",t[t.Asterisk=42]="Asterisk",t[t.Plus=43]="Plus",t[t.Comma=44]="Comma",t[t.Dash=45]="Dash",t[t.Period=46]="Period",t[t.Slash=47]="Slash",t[t.Digit0=48]="Digit0",t[t.Digit1=49]="Digit1",t[t.Digit2=50]="Digit2",t[t.Digit3=51]="Digit3",t[t.Digit4=52]="Digit4",t[t.Digit5=53]="Digit5",t[t.Digit6=54]="Digit6",t[t.Digit7=55]="Digit7",t[t.Digit8=56]="Digit8",t[t.Digit9=57]="Digit9",t[t.Colon=58]="Colon",t[t.Semicolon=59]="Semicolon",t[t.LessThan=60]="LessThan",t[t.Equals=61]="Equals",t[t.GreaterThan=62]="GreaterThan",t[t.QuestionMark=63]="QuestionMark",t[t.AtSign=64]="AtSign",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.OpenSquareBracket=91]="OpenSquareBracket",t[t.Backslash=92]="Backslash",t[t.CloseSquareBracket=93]="CloseSquareBracket",t[t.Caret=94]="Caret",t[t.Underline=95]="Underline",t[t.BackTick=96]="BackTick",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.OpenCurlyBrace=123]="OpenCurlyBrace",t[t.Pipe=124]="Pipe",t[t.CloseCurlyBrace=125]="CloseCurlyBrace",t[t.Tilde=126]="Tilde",t[t.NoBreakSpace=160]="NoBreakSpace",t[t.U_Combining_Grave_Accent=768]="U_Combining_Grave_Accent",t[t.U_Combining_Acute_Accent=769]="U_Combining_Acute_Accent",t[t.U_Combining_Circumflex_Accent=770]="U_Combining_Circumflex_Accent",t[t.U_Combining_Tilde=771]="U_Combining_Tilde",t[t.U_Combining_Macron=772]="U_Combining_Macron",t[t.U_Combining_Overline=773]="U_Combining_Overline",t[t.U_Combining_Breve=774]="U_Combining_Breve",t[t.U_Combining_Dot_Above=775]="U_Combining_Dot_Above",t[t.U_Combining_Diaeresis=776]="U_Combining_Diaeresis",t[t.U_Combining_Hook_Above=777]="U_Combining_Hook_Above",t[t.U_Combining_Ring_Above=778]="U_Combining_Ring_Above",t[t.U_Combining_Double_Acute_Accent=779]="U_Combining_Double_Acute_Accent",t[t.U_Combining_Caron=780]="U_Combining_Caron",t[t.U_Combining_Vertical_Line_Above=781]="U_Combining_Vertical_Line_Above",t[t.U_Combining_Double_Vertical_Line_Above=782]="U_Combining_Double_Vertical_Line_Above",t[t.U_Combining_Double_Grave_Accent=783]="U_Combining_Double_Grave_Accent",t[t.U_Combining_Candrabindu=784]="U_Combining_Candrabindu",t[t.U_Combining_Inverted_Breve=785]="U_Combining_Inverted_Breve",t[t.U_Combining_Turned_Comma_Above=786]="U_Combining_Turned_Comma_Above",t[t.U_Combining_Comma_Above=787]="U_Combining_Comma_Above",t[t.U_Combining_Reversed_Comma_Above=788]="U_Combining_Reversed_Comma_Above",t[t.U_Combining_Comma_Above_Right=789]="U_Combining_Comma_Above_Right",t[t.U_Combining_Grave_Accent_Below=790]="U_Combining_Grave_Accent_Below",t[t.U_Combining_Acute_Accent_Below=791]="U_Combining_Acute_Accent_Below",t[t.U_Combining_Left_Tack_Below=792]="U_Combining_Left_Tack_Below",t[t.U_Combining_Right_Tack_Below=793]="U_Combining_Right_Tack_Below",t[t.U_Combining_Left_Angle_Above=794]="U_Combining_Left_Angle_Above",t[t.U_Combining_Horn=795]="U_Combining_Horn",t[t.U_Combining_Left_Half_Ring_Below=796]="U_Combining_Left_Half_Ring_Below",t[t.U_Combining_Up_Tack_Below=797]="U_Combining_Up_Tack_Below",t[t.U_Combining_Down_Tack_Below=798]="U_Combining_Down_Tack_Below",t[t.U_Combining_Plus_Sign_Below=799]="U_Combining_Plus_Sign_Below",t[t.U_Combining_Minus_Sign_Below=800]="U_Combining_Minus_Sign_Below",t[t.U_Combining_Palatalized_Hook_Below=801]="U_Combining_Palatalized_Hook_Below",t[t.U_Combining_Retroflex_Hook_Below=802]="U_Combining_Retroflex_Hook_Below",t[t.U_Combining_Dot_Below=803]="U_Combining_Dot_Below",t[t.U_Combining_Diaeresis_Below=804]="U_Combining_Diaeresis_Below",t[t.U_Combining_Ring_Below=805]="U_Combining_Ring_Below",t[t.U_Combining_Comma_Below=806]="U_Combining_Comma_Below",t[t.U_Combining_Cedilla=807]="U_Combining_Cedilla",t[t.U_Combining_Ogonek=808]="U_Combining_Ogonek",t[t.U_Combining_Vertical_Line_Below=809]="U_Combining_Vertical_Line_Below",t[t.U_Combining_Bridge_Below=810]="U_Combining_Bridge_Below",t[t.U_Combining_Inverted_Double_Arch_Below=811]="U_Combining_Inverted_Double_Arch_Below",t[t.U_Combining_Caron_Below=812]="U_Combining_Caron_Below",t[t.U_Combining_Circumflex_Accent_Below=813]="U_Combining_Circumflex_Accent_Below",t[t.U_Combining_Breve_Below=814]="U_Combining_Breve_Below",t[t.U_Combining_Inverted_Breve_Below=815]="U_Combining_Inverted_Breve_Below",t[t.U_Combining_Tilde_Below=816]="U_Combining_Tilde_Below",t[t.U_Combining_Macron_Below=817]="U_Combining_Macron_Below",t[t.U_Combining_Low_Line=818]="U_Combining_Low_Line",t[t.U_Combining_Double_Low_Line=819]="U_Combining_Double_Low_Line",t[t.U_Combining_Tilde_Overlay=820]="U_Combining_Tilde_Overlay",t[t.U_Combining_Short_Stroke_Overlay=821]="U_Combining_Short_Stroke_Overlay",t[t.U_Combining_Long_Stroke_Overlay=822]="U_Combining_Long_Stroke_Overlay",t[t.U_Combining_Short_Solidus_Overlay=823]="U_Combining_Short_Solidus_Overlay",t[t.U_Combining_Long_Solidus_Overlay=824]="U_Combining_Long_Solidus_Overlay",t[t.U_Combining_Right_Half_Ring_Below=825]="U_Combining_Right_Half_Ring_Below",t[t.U_Combining_Inverted_Bridge_Below=826]="U_Combining_Inverted_Bridge_Below",t[t.U_Combining_Square_Below=827]="U_Combining_Square_Below",t[t.U_Combining_Seagull_Below=828]="U_Combining_Seagull_Below",t[t.U_Combining_X_Above=829]="U_Combining_X_Above",t[t.U_Combining_Vertical_Tilde=830]="U_Combining_Vertical_Tilde",t[t.U_Combining_Double_Overline=831]="U_Combining_Double_Overline",t[t.U_Combining_Grave_Tone_Mark=832]="U_Combining_Grave_Tone_Mark",t[t.U_Combining_Acute_Tone_Mark=833]="U_Combining_Acute_Tone_Mark",t[t.U_Combining_Greek_Perispomeni=834]="U_Combining_Greek_Perispomeni",t[t.U_Combining_Greek_Koronis=835]="U_Combining_Greek_Koronis",t[t.U_Combining_Greek_Dialytika_Tonos=836]="U_Combining_Greek_Dialytika_Tonos",t[t.U_Combining_Greek_Ypogegrammeni=837]="U_Combining_Greek_Ypogegrammeni",t[t.U_Combining_Bridge_Above=838]="U_Combining_Bridge_Above",t[t.U_Combining_Equals_Sign_Below=839]="U_Combining_Equals_Sign_Below",t[t.U_Combining_Double_Vertical_Line_Below=840]="U_Combining_Double_Vertical_Line_Below",t[t.U_Combining_Left_Angle_Below=841]="U_Combining_Left_Angle_Below",t[t.U_Combining_Not_Tilde_Above=842]="U_Combining_Not_Tilde_Above",t[t.U_Combining_Homothetic_Above=843]="U_Combining_Homothetic_Above",t[t.U_Combining_Almost_Equal_To_Above=844]="U_Combining_Almost_Equal_To_Above",t[t.U_Combining_Left_Right_Arrow_Below=845]="U_Combining_Left_Right_Arrow_Below",t[t.U_Combining_Upwards_Arrow_Below=846]="U_Combining_Upwards_Arrow_Below",t[t.U_Combining_Grapheme_Joiner=847]="U_Combining_Grapheme_Joiner",t[t.U_Combining_Right_Arrowhead_Above=848]="U_Combining_Right_Arrowhead_Above",t[t.U_Combining_Left_Half_Ring_Above=849]="U_Combining_Left_Half_Ring_Above",t[t.U_Combining_Fermata=850]="U_Combining_Fermata",t[t.U_Combining_X_Below=851]="U_Combining_X_Below",t[t.U_Combining_Left_Arrowhead_Below=852]="U_Combining_Left_Arrowhead_Below",t[t.U_Combining_Right_Arrowhead_Below=853]="U_Combining_Right_Arrowhead_Below",t[t.U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below=854]="U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below",t[t.U_Combining_Right_Half_Ring_Above=855]="U_Combining_Right_Half_Ring_Above",t[t.U_Combining_Dot_Above_Right=856]="U_Combining_Dot_Above_Right",t[t.U_Combining_Asterisk_Below=857]="U_Combining_Asterisk_Below",t[t.U_Combining_Double_Ring_Below=858]="U_Combining_Double_Ring_Below",t[t.U_Combining_Zigzag_Above=859]="U_Combining_Zigzag_Above",t[t.U_Combining_Double_Breve_Below=860]="U_Combining_Double_Breve_Below",t[t.U_Combining_Double_Breve=861]="U_Combining_Double_Breve",t[t.U_Combining_Double_Macron=862]="U_Combining_Double_Macron",t[t.U_Combining_Double_Macron_Below=863]="U_Combining_Double_Macron_Below",t[t.U_Combining_Double_Tilde=864]="U_Combining_Double_Tilde",t[t.U_Combining_Double_Inverted_Breve=865]="U_Combining_Double_Inverted_Breve",t[t.U_Combining_Double_Rightwards_Arrow_Below=866]="U_Combining_Double_Rightwards_Arrow_Below",t[t.U_Combining_Latin_Small_Letter_A=867]="U_Combining_Latin_Small_Letter_A",t[t.U_Combining_Latin_Small_Letter_E=868]="U_Combining_Latin_Small_Letter_E",t[t.U_Combining_Latin_Small_Letter_I=869]="U_Combining_Latin_Small_Letter_I",t[t.U_Combining_Latin_Small_Letter_O=870]="U_Combining_Latin_Small_Letter_O",t[t.U_Combining_Latin_Small_Letter_U=871]="U_Combining_Latin_Small_Letter_U",t[t.U_Combining_Latin_Small_Letter_C=872]="U_Combining_Latin_Small_Letter_C",t[t.U_Combining_Latin_Small_Letter_D=873]="U_Combining_Latin_Small_Letter_D",t[t.U_Combining_Latin_Small_Letter_H=874]="U_Combining_Latin_Small_Letter_H",t[t.U_Combining_Latin_Small_Letter_M=875]="U_Combining_Latin_Small_Letter_M",t[t.U_Combining_Latin_Small_Letter_R=876]="U_Combining_Latin_Small_Letter_R",t[t.U_Combining_Latin_Small_Letter_T=877]="U_Combining_Latin_Small_Letter_T",t[t.U_Combining_Latin_Small_Letter_V=878]="U_Combining_Latin_Small_Letter_V",t[t.U_Combining_Latin_Small_Letter_X=879]="U_Combining_Latin_Small_Letter_X",t[t.LINE_SEPARATOR=8232]="LINE_SEPARATOR",t[t.PARAGRAPH_SEPARATOR=8233]="PARAGRAPH_SEPARATOR",t[t.NEXT_LINE=133]="NEXT_LINE",t[t.U_CIRCUMFLEX=94]="U_CIRCUMFLEX",t[t.U_GRAVE_ACCENT=96]="U_GRAVE_ACCENT",t[t.U_DIAERESIS=168]="U_DIAERESIS",t[t.U_MACRON=175]="U_MACRON",t[t.U_ACUTE_ACCENT=180]="U_ACUTE_ACCENT",t[t.U_CEDILLA=184]="U_CEDILLA",t[t.U_MODIFIER_LETTER_LEFT_ARROWHEAD=706]="U_MODIFIER_LETTER_LEFT_ARROWHEAD",t[t.U_MODIFIER_LETTER_RIGHT_ARROWHEAD=707]="U_MODIFIER_LETTER_RIGHT_ARROWHEAD",t[t.U_MODIFIER_LETTER_UP_ARROWHEAD=708]="U_MODIFIER_LETTER_UP_ARROWHEAD",t[t.U_MODIFIER_LETTER_DOWN_ARROWHEAD=709]="U_MODIFIER_LETTER_DOWN_ARROWHEAD",t[t.U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING=722]="U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING",t[t.U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING=723]="U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING",t[t.U_MODIFIER_LETTER_UP_TACK=724]="U_MODIFIER_LETTER_UP_TACK",t[t.U_MODIFIER_LETTER_DOWN_TACK=725]="U_MODIFIER_LETTER_DOWN_TACK",t[t.U_MODIFIER_LETTER_PLUS_SIGN=726]="U_MODIFIER_LETTER_PLUS_SIGN",t[t.U_MODIFIER_LETTER_MINUS_SIGN=727]="U_MODIFIER_LETTER_MINUS_SIGN",t[t.U_BREVE=728]="U_BREVE",t[t.U_DOT_ABOVE=729]="U_DOT_ABOVE",t[t.U_RING_ABOVE=730]="U_RING_ABOVE",t[t.U_OGONEK=731]="U_OGONEK",t[t.U_SMALL_TILDE=732]="U_SMALL_TILDE",t[t.U_DOUBLE_ACUTE_ACCENT=733]="U_DOUBLE_ACUTE_ACCENT",t[t.U_MODIFIER_LETTER_RHOTIC_HOOK=734]="U_MODIFIER_LETTER_RHOTIC_HOOK",t[t.U_MODIFIER_LETTER_CROSS_ACCENT=735]="U_MODIFIER_LETTER_CROSS_ACCENT",t[t.U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR=741]="U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR",t[t.U_MODIFIER_LETTER_HIGH_TONE_BAR=742]="U_MODIFIER_LETTER_HIGH_TONE_BAR",t[t.U_MODIFIER_LETTER_MID_TONE_BAR=743]="U_MODIFIER_LETTER_MID_TONE_BAR",t[t.U_MODIFIER_LETTER_LOW_TONE_BAR=744]="U_MODIFIER_LETTER_LOW_TONE_BAR",t[t.U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR=745]="U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR",t[t.U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK=746]="U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK",t[t.U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK=747]="U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK",t[t.U_MODIFIER_LETTER_UNASPIRATED=749]="U_MODIFIER_LETTER_UNASPIRATED",t[t.U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD=751]="U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD",t[t.U_MODIFIER_LETTER_LOW_UP_ARROWHEAD=752]="U_MODIFIER_LETTER_LOW_UP_ARROWHEAD",t[t.U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD=753]="U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD",t[t.U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD=754]="U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD",t[t.U_MODIFIER_LETTER_LOW_RING=755]="U_MODIFIER_LETTER_LOW_RING",t[t.U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT=756]="U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT",t[t.U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT=757]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT",t[t.U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT=758]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT",t[t.U_MODIFIER_LETTER_LOW_TILDE=759]="U_MODIFIER_LETTER_LOW_TILDE",t[t.U_MODIFIER_LETTER_RAISED_COLON=760]="U_MODIFIER_LETTER_RAISED_COLON",t[t.U_MODIFIER_LETTER_BEGIN_HIGH_TONE=761]="U_MODIFIER_LETTER_BEGIN_HIGH_TONE",t[t.U_MODIFIER_LETTER_END_HIGH_TONE=762]="U_MODIFIER_LETTER_END_HIGH_TONE",t[t.U_MODIFIER_LETTER_BEGIN_LOW_TONE=763]="U_MODIFIER_LETTER_BEGIN_LOW_TONE",t[t.U_MODIFIER_LETTER_END_LOW_TONE=764]="U_MODIFIER_LETTER_END_LOW_TONE",t[t.U_MODIFIER_LETTER_SHELF=765]="U_MODIFIER_LETTER_SHELF",t[t.U_MODIFIER_LETTER_OPEN_SHELF=766]="U_MODIFIER_LETTER_OPEN_SHELF",t[t.U_MODIFIER_LETTER_LOW_LEFT_ARROW=767]="U_MODIFIER_LETTER_LOW_LEFT_ARROW",t[t.U_GREEK_LOWER_NUMERAL_SIGN=885]="U_GREEK_LOWER_NUMERAL_SIGN",t[t.U_GREEK_TONOS=900]="U_GREEK_TONOS",t[t.U_GREEK_DIALYTIKA_TONOS=901]="U_GREEK_DIALYTIKA_TONOS",t[t.U_GREEK_KORONIS=8125]="U_GREEK_KORONIS",t[t.U_GREEK_PSILI=8127]="U_GREEK_PSILI",t[t.U_GREEK_PERISPOMENI=8128]="U_GREEK_PERISPOMENI",t[t.U_GREEK_DIALYTIKA_AND_PERISPOMENI=8129]="U_GREEK_DIALYTIKA_AND_PERISPOMENI",t[t.U_GREEK_PSILI_AND_VARIA=8141]="U_GREEK_PSILI_AND_VARIA",t[t.U_GREEK_PSILI_AND_OXIA=8142]="U_GREEK_PSILI_AND_OXIA",t[t.U_GREEK_PSILI_AND_PERISPOMENI=8143]="U_GREEK_PSILI_AND_PERISPOMENI",t[t.U_GREEK_DASIA_AND_VARIA=8157]="U_GREEK_DASIA_AND_VARIA",t[t.U_GREEK_DASIA_AND_OXIA=8158]="U_GREEK_DASIA_AND_OXIA",t[t.U_GREEK_DASIA_AND_PERISPOMENI=8159]="U_GREEK_DASIA_AND_PERISPOMENI",t[t.U_GREEK_DIALYTIKA_AND_VARIA=8173]="U_GREEK_DIALYTIKA_AND_VARIA",t[t.U_GREEK_DIALYTIKA_AND_OXIA=8174]="U_GREEK_DIALYTIKA_AND_OXIA",t[t.U_GREEK_VARIA=8175]="U_GREEK_VARIA",t[t.U_GREEK_OXIA=8189]="U_GREEK_OXIA",t[t.U_GREEK_DASIA=8190]="U_GREEK_DASIA",t[t.U_IDEOGRAPHIC_FULL_STOP=12290]="U_IDEOGRAPHIC_FULL_STOP",t[t.U_LEFT_CORNER_BRACKET=12300]="U_LEFT_CORNER_BRACKET",t[t.U_RIGHT_CORNER_BRACKET=12301]="U_RIGHT_CORNER_BRACKET",t[t.U_LEFT_BLACK_LENTICULAR_BRACKET=12304]="U_LEFT_BLACK_LENTICULAR_BRACKET",t[t.U_RIGHT_BLACK_LENTICULAR_BRACKET=12305]="U_RIGHT_BLACK_LENTICULAR_BRACKET",t[t.U_OVERLINE=8254]="U_OVERLINE",t[t.UTF8_BOM=65279]="UTF8_BOM",t[t.U_FULLWIDTH_SEMICOLON=65307]="U_FULLWIDTH_SEMICOLON",t[t.U_FULLWIDTH_COMMA=65292]="U_FULLWIDTH_COMMA"})(A||(e.CharCode=A={}))}),define(h1[8],a1([0,1]),function(_1,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$K=A,e.$L=t,e.$M=G,e.$N=$;function A(Y,q){const U=Object.create(null);for(const v of Y){const k=q(v);let H=U[k];H||(H=U[k]=[]),H.push(v)}return U}function t(Y,q){const U=[],v=[];for(const k of Y)q.has(k)||U.push(k);for(const k of q)Y.has(k)||v.push(k);return{removed:U,added:v}}function G(Y,q){const U=[],v=[];for(const[k,H]of Y)q.has(k)||U.push(H);for(const[k,H]of q)Y.has(k)||v.push(H);return{removed:U,added:v}}function $(Y,q){const U=new Set;for(const v of q)Y.has(v)&&U.add(v);return U}}),define(h1[2],a1([0,1]),function(_1,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cb=e.$bb=e.$ab=e.$_=e.$$=e.$9=e.$5=e.$X=e.$W=void 0,e.setUnexpectedErrorHandler=t,e.$Z=G,e.$1=$,e.$2=Y,e.$3=q,e.$4=v,e.$6=H,e.$7=J,e.$8=u1,e.$0=y;class A{constructor(){this.b=[],this.a=function(n){setTimeout(()=>{throw n.stack?b.isErrorNoTelemetry(n)?new b(n.message+`

`+n.stack):new Error(n.message+`

`+n.stack):n},0)}}addListener(n){return this.b.push(n),()=>{this.d(n)}}c(n){this.b.forEach(u=>{u(n)})}d(n){this.b.splice(this.b.indexOf(n),1)}setUnexpectedErrorHandler(n){this.a=n}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(n){this.a(n),this.c(n)}onUnexpectedExternalError(n){this.a(n)}}e.$W=A,e.$X=new A;function t(s){e.$X.setUnexpectedErrorHandler(s)}function G(s){if(!s||typeof s!="object")return!1;const n=s;return n.code==="EPIPE"&&n.syscall?.toUpperCase()==="WRITE"}function $(s){v(s)||e.$X.onUnexpectedError(s)}function Y(s){v(s)||e.$X.onUnexpectedExternalError(s)}function q(s){if(s instanceof Error){const{name:n,message:u}=s,l=s.stacktrace||s.stack;return{$isError:!0,name:n,message:u,stack:l,noTelemetry:b.isErrorNoTelemetry(s)}}return s}const U="Canceled";function v(s){return s instanceof k?!0:s instanceof Error&&s.name===U&&s.message===U}class k extends Error{constructor(){super(U),this.name=this.message}}e.$5=k;function H(){const s=new Error(U);return s.name=s.message,s}function J(s){return s?new Error(`Illegal argument: ${s}`):new Error("Illegal argument")}function u1(s){return s?new Error(`Illegal state: ${s}`):new Error("Illegal state")}class o1 extends TypeError{constructor(n){super(n?`${n} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$9=o1;function y(s){return s?s.message?s.message:s.stack?s.stack.split(`
`)[0]:String(s):"Error"}class K extends Error{constructor(n){super("NotImplemented"),n&&(this.message=n)}}e.$$=K;class M extends Error{constructor(n){super("NotSupported"),n&&(this.message=n)}}e.$_=M;class g extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$ab=g;class b extends Error{constructor(n){super(n),this.name="CodeExpectedError"}static fromError(n){if(n instanceof b)return n;const u=new b;return u.message=n.message,u.stack=n.stack,u}static isErrorNoTelemetry(n){return n.name==="CodeExpectedError"}}e.$bb=b;class T extends Error{constructor(n){super(n||"An unexpected bug occurred."),Object.setPrototypeOf(this,T.prototype)}}e.$cb=T}),define(h1[9],a1([0,1,2,6]),function(_1,e,A,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ac=e.$_b=e.$$b=e.$9b=e.$8b=e.CompareResult=void 0,e.$sb=G,e.$tb=$,e.$ub=Y,e.$vb=q,e.$wb=U,e.$xb=v,e.$yb=k,e.$zb=H,e.$Ab=J,e.$Bb=u1,e.$Cb=o1,e.$Db=y,e.$Eb=K,e.top=M,e.$Gb=g,e.$Hb=T,e.$Ib=s,e.$Jb=n,e.$Kb=u,e.$Lb=l,e.$Mb=_,e.$Nb=I,e.$Ob=D,e.$Pb=Q,e.$Qb=g1,e.$Rb=l1,e.$Sb=j,e.$Tb=S,e.$Ub=h,e.$Vb=O,e.$Wb=B,e.$Xb=R,e.$Yb=E,e.$Zb=F,e.$1b=x,e.$2b=z,e.$3b=C,e.$4b=e1,e.$5b=X,e.$6b=L1,e.$7b=w1,e.$0b=W1;function G(c,o=0){return c[c.length-(1+o)]}function $(c){if(c.length===0)throw new Error("Invalid tail call");return[c.slice(0,c.length-1),c[c.length-1]]}function Y(c,o,f=(d,L)=>d===L){if(c===o)return!0;if(!c||!o||c.length!==o.length)return!1;for(let d=0,L=c.length;d<L;d++)if(!f(c[d],o[d]))return!1;return!0}function q(c,o){const f=c.length-1;o<f&&(c[o]=c[f]),c.pop()}function U(c,o,f){return v(c.length,d=>f(c[d],o))}function v(c,o){let f=0,d=c-1;for(;f<=d;){const L=(f+d)/2|0,Z=o(L);if(Z<0)f=L+1;else if(Z>0)d=L-1;else return L}return-(f+1)}function k(c,o,f){if(c=c|0,c>=o.length)throw new TypeError("invalid index");const d=o[Math.floor(o.length*Math.random())],L=[],Z=[],r1=[];for(const E1 of o){const d1=f(E1,d);d1<0?L.push(E1):d1>0?Z.push(E1):r1.push(E1)}return c<L.length?k(c,L,f):c<L.length+r1.length?r1[0]:k(c-(L.length+r1.length),Z,f)}function H(c,o){const f=[];let d;for(const L of c.slice(0).sort(o))!d||o(d[0],L)!==0?(d=[L],f.push(d)):d.push(L);return f}function*J(c,o){let f,d;for(const L of c)d!==void 0&&o(d,L)?f.push(L):(f&&(yield f),f=[L]),d=L;f&&(yield f)}function u1(c,o){for(let f=0;f<=c.length;f++)o(f===0?void 0:c[f-1],f===c.length?void 0:c[f])}function o1(c,o){for(let f=0;f<c.length;f++)o(f===0?void 0:c[f-1],c[f],f+1===c.length?void 0:c[f+1])}function y(c,o,f){const d=[];function L(E1,d1,A1){if(d1===0&&A1.length===0)return;const N=d[d.length-1];N&&N.start+N.deleteCount===E1?(N.deleteCount+=d1,N.toInsert.push(...A1)):d.push({start:E1,deleteCount:d1,toInsert:A1})}let Z=0,r1=0;for(;;){if(Z===c.length){L(Z,0,o.slice(r1));break}if(r1===o.length){L(Z,c.length-Z,[]);break}const E1=c[Z],d1=o[r1],A1=f(E1,d1);A1===0?(Z+=1,r1+=1):A1<0?(L(Z,1,[]),Z+=1):A1>0&&(L(Z,0,[d1]),r1+=1)}return d}function K(c,o,f){const d=y(c,o,f),L=[],Z=[];for(const r1 of d)L.push(...c.slice(r1.start,r1.start+r1.deleteCount)),Z.push(...r1.toInsert);return{removed:L,added:Z}}function M(c,o,f){if(f===0)return[];const d=c.slice(0,f).sort(o);return b(c,o,d,f,c.length),d}function g(c,o,f,d,L){return f===0?Promise.resolve([]):new Promise((Z,r1)=>{(async()=>{const E1=c.length,d1=c.slice(0,f).sort(o);for(let A1=f,N=Math.min(f+d,E1);A1<E1;A1=N,N=Math.min(N+d,E1)){if(A1>f&&await new Promise(w=>setTimeout(w)),L&&L.isCancellationRequested)throw new A.$5;b(c,o,d1,A1,N)}return d1})().then(Z,r1)})}function b(c,o,f,d,L){for(const Z=f.length;d<L;d++){const r1=c[d];if(o(r1,f[Z-1])<0){f.pop();const E1=(0,t.$kb)(f,d1=>o(r1,d1)<0);f.splice(E1,0,r1)}}}function T(c){return c.filter(o=>!!o)}function s(c){let o=0;for(let f=0;f<c.length;f++)c[f]&&(c[o]=c[f],o+=1);c.length=o}function n(c,o,f){c.splice(f,0,c.splice(o,1)[0])}function u(c){return!Array.isArray(c)||c.length===0}function l(c){return Array.isArray(c)&&c.length>0}function _(c,o=f=>f){const f=new Set;return c.filter(d=>{const L=o(d);return f.has(L)?!1:(f.add(L),!0)})}function I(c){const o=new Set;return f=>{const d=c(f);return o.has(d)?!1:(o.add(d),!0)}}function D(c,o){return c.length>0?c[0]:o}function Q(c,o){return c.length>0?c[c.length-1]:o}function g1(c,o,f=(d,L)=>d===L){let d=0;for(let L=0,Z=Math.min(c.length,o.length);L<Z&&f(c[L],o[L]);L++)d++;return d}function l1(c,o){let f=typeof o=="number"?c:0;typeof o=="number"?f=c:(f=0,o=c);const d=[];if(f<=o)for(let L=f;L<o;L++)d.push(L);else for(let L=f;L>o;L--)d.push(L);return d}function j(c,o,f){return c.reduce((d,L)=>(d[o(L)]=f?f(L):L,d),Object.create(null))}function S(c,o){return c.push(o),()=>h(c,o)}function h(c,o){const f=c.indexOf(o);if(f>-1)return c.splice(f,1),o}function O(c,o,f){const d=c.slice(0,o),L=c.slice(o);return d.concat(f,L)}function B(c,o){let f;if(typeof o=="number"){let d=o;f=()=>{const L=Math.sin(d++)*179426549;return L-Math.floor(L)}}else f=Math.random;for(let d=c.length-1;d>0;d-=1){const L=Math.floor(f()*(d+1)),Z=c[d];c[d]=c[L],c[L]=Z}}function R(c,o){const f=c.indexOf(o);f>-1&&(c.splice(f,1),c.unshift(o))}function E(c,o){const f=c.indexOf(o);f>-1&&(c.splice(f,1),c.push(o))}function F(c,o){for(const f of o)c.push(f)}function x(c,o){return Array.isArray(c)?c.map(o):o(c)}function z(c){return Array.isArray(c)?c:[c]}function C(c){return c[Math.floor(Math.random()*c.length)]}function e1(c,o,f){const d=n1(c,o),L=c.length,Z=f.length;c.length=L+Z;for(let r1=L-1;r1>=d;r1--)c[r1+Z]=c[r1];for(let r1=0;r1<Z;r1++)c[r1+d]=f[r1]}function X(c,o,f,d){const L=n1(c,o);let Z=c.splice(L,f);return Z===void 0&&(Z=[]),e1(c,L,d),Z}function n1(c,o){return o<0?Math.max(o+c.length,0):Math.min(o,c.length)}var f1;(function(c){function o(Z){return Z<0}c.isLessThan=o;function f(Z){return Z<=0}c.isLessThanOrEqual=f;function d(Z){return Z>0}c.isGreaterThan=d;function L(Z){return Z===0}c.isNeitherLessOrGreaterThan=L,c.greaterThan=1,c.lessThan=-1,c.neitherLessOrGreaterThan=0})(f1||(e.CompareResult=f1={}));function L1(c,o){return(f,d)=>o(c(f),c(d))}function w1(...c){return(o,f)=>{for(const d of c){const L=d(o,f);if(!f1.isNeitherLessOrGreaterThan(L))return L}return f1.neitherLessOrGreaterThan}}const R1=(c,o)=>c-o;e.$8b=R1;const N1=(c,o)=>(0,e.$8b)(c?1:0,o?1:0);e.$9b=N1;function W1(c){return(o,f)=>-c(o,f)}class G1{constructor(o){this.g=o,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(o){let f=this.c;for(;f<this.g.length&&o(this.g[f]);)f++;const d=f===this.c?null:this.g.slice(this.c,f);return this.c=f,d}takeFromEndWhile(o){let f=this.d;for(;f>=0&&o(this.g[f]);)f--;const d=f===this.d?null:this.g.slice(f+1,this.d+1);return this.d=f,d}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const o=this.g[this.c];return this.c++,o}removeLast(){const o=this.g[this.d];return this.d--,o}takeCount(o){const f=this.g.slice(this.c,this.c+o);return this.c+=o,f}}e.$$b=G1;class I1{static{this.empty=new I1(o=>{})}constructor(o){this.iterate=o}forEach(o){this.iterate(f=>(o(f),!0))}toArray(){const o=[];return this.iterate(f=>(o.push(f),!0)),o}filter(o){return new I1(f=>this.iterate(d=>o(d)?f(d):!0))}map(o){return new I1(f=>this.iterate(d=>f(o(d))))}some(o){let f=!1;return this.iterate(d=>(f=o(d),!f)),f}findFirst(o){let f;return this.iterate(d=>o(d)?(f=d,!1):!0),f}findLast(o){let f;return this.iterate(d=>(o(d)&&(f=d),!0)),f}findLastMaxBy(o){let f,d=!0;return this.iterate(L=>((d||f1.isGreaterThan(o(L,f)))&&(d=!1,f=L),!0)),f}}e.$_b=I1;class F1{constructor(o){this.c=o}static createSortPermutation(o,f){const d=Array.from(o.keys()).sort((L,Z)=>f(o[L],o[Z]));return new F1(d)}apply(o){return o.map((f,d)=>o[this.c[d]])}inverse(){const o=this.c.slice();for(let f=0;f<this.c.length;f++)o[this.c[f]]=f;return new F1(o)}}e.$ac=F1}),define(h1[3],a1([0,1]),function(_1,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$db=A;function A(t,G){const $=this;let Y=!1,q;return function(){if(Y)return q;if(Y=!0,G)try{q=t.apply($,arguments)}finally{G()}else q=t.apply($,arguments);return q}}}),define(h1[10],a1([0,1]),function(_1,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var A;(function(t){function G(n){return n&&typeof n=="object"&&typeof n[Symbol.iterator]=="function"}t.is=G;const $=Object.freeze([]);function Y(){return $}t.empty=Y;function*q(n){yield n}t.single=q;function U(n){return G(n)?n:q(n)}t.wrap=U;function v(n){return n||$}t.from=v;function*k(n){for(let u=n.length-1;u>=0;u--)yield n[u]}t.reverse=k;function H(n){return!n||n[Symbol.iterator]().next().done===!0}t.isEmpty=H;function J(n){return n[Symbol.iterator]().next().value}t.first=J;function u1(n,u){for(const l of n)if(u(l))return!0;return!1}t.some=u1;function o1(n,u){for(const l of n)if(u(l))return l}t.find=o1;function*y(n,u){for(const l of n)u(l)&&(yield l)}t.filter=y;function*K(n,u){let l=0;for(const _ of n)yield u(_,l++)}t.map=K;function*M(...n){for(const u of n)yield*u}t.concat=M;function g(n,u,l){let _=l;for(const I of n)_=u(_,I);return _}t.reduce=g;function*b(n,u,l=n.length){for(u<0&&(u+=n.length),l<0?l+=n.length:l>n.length&&(l=n.length);u<l;u++)yield n[u]}t.slice=b;function T(n,u=Number.POSITIVE_INFINITY){const l=[];if(u===0)return[l,n];const _=n[Symbol.iterator]();for(let I=0;I<u;I++){const D=_.next();if(D.done)return[l,t.empty()];l.push(D.value)}return[l,{[Symbol.iterator](){return _}}]}t.consume=T;async function s(n){const u=[];for await(const l of n)u.push(l);return Promise.resolve(u)}t.asyncToArray=s})(A||(e.Iterable=A={}))}),define(h1[11],a1([0,1]),function(_1,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V=void 0;class A{constructor(G){this.d=G,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(G){this.c=G}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$V=A}),define(h1[12],a1([0,1]),function(_1,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5c=void 0;class A{static{this.Undefined=new A(void 0)}constructor($){this.element=$,this.next=A.Undefined,this.prev=A.Undefined}}class t{constructor(){this.a=A.Undefined,this.b=A.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===A.Undefined}clear(){let $=this.a;for(;$!==A.Undefined;){const Y=$.next;$.prev=A.Undefined,$.next=A.Undefined,$=Y}this.a=A.Undefined,this.b=A.Undefined,this.c=0}unshift($){return this.d($,!1)}push($){return this.d($,!0)}d($,Y){const q=new A($);if(this.a===A.Undefined)this.a=q,this.b=q;else if(Y){const v=this.b;this.b=q,q.prev=v,v.next=q}else{const v=this.a;this.a=q,q.next=v,v.prev=q}this.c+=1;let U=!1;return()=>{U||(U=!0,this.e(q))}}shift(){if(this.a!==A.Undefined){const $=this.a.element;return this.e(this.a),$}}pop(){if(this.b!==A.Undefined){const $=this.b.element;return this.e(this.b),$}}e($){if($.prev!==A.Undefined&&$.next!==A.Undefined){const Y=$.prev;Y.next=$.next,$.next.prev=Y}else $.prev===A.Undefined&&$.next===A.Undefined?(this.a=A.Undefined,this.b=A.Undefined):$.next===A.Undefined?(this.b=this.b.prev,this.b.next=A.Undefined):$.prev===A.Undefined&&(this.a=this.a.next,this.a.prev=A.Undefined);this.c-=1}*[Symbol.iterator](){let $=this.a;for(;$!==A.Undefined;)yield $.element,$=$.next}}e.$5c=t}),define(h1[13],a1([0,1]),function(_1,e){"use strict";var A,t,G;Object.defineProperty(e,"__esModule",{value:!0}),e.$Hc=e.$Gc=e.$Fc=e.$Ec=e.$Dc=e.$Cc=e.Touch=e.$Bc=e.$Ac=void 0,e.$xc=$,e.$yc=Y,e.$zc=q,e.$Ic=T;function $(s,n,u){let l=s.get(n);return l===void 0&&(l=u,s.set(n,l)),l}function Y(s){const n=[];return s.forEach((u,l)=>{n.push(`${l} => ${u}`)}),`Map(${s.size}) {${n.join(", ")}}`}function q(s){const n=[];return s.forEach(u=>{n.push(u)}),`Set(${s.size}) {${n.join(", ")}}`}class U{constructor(n,u){this.uri=n,this.value=u}}function v(s){return Array.isArray(s)}class k{static{this.c=n=>n.toString()}constructor(n,u){if(this[A]="ResourceMap",n instanceof k)this.d=new Map(n.d),this.e=u??k.c;else if(v(n)){this.d=new Map,this.e=u??k.c;for(const[l,_]of n)this.set(l,_)}else this.d=new Map,this.e=n??k.c}set(n,u){return this.d.set(this.e(n),new U(n,u)),this}get(n){return this.d.get(this.e(n))?.value}has(n){return this.d.has(this.e(n))}get size(){return this.d.size}clear(){this.d.clear()}delete(n){return this.d.delete(this.e(n))}forEach(n,u){typeof u<"u"&&(n=n.bind(u));for(const[l,_]of this.d)n(_.value,_.uri,this)}*values(){for(const n of this.d.values())yield n.value}*keys(){for(const n of this.d.values())yield n.uri}*entries(){for(const n of this.d.values())yield[n.uri,n.value]}*[(A=Symbol.toStringTag,Symbol.iterator)](){for(const[,n]of this.d)yield[n.uri,n.value]}}e.$Ac=k;class H{constructor(n,u){this[t]="ResourceSet",!n||typeof n=="function"?this.c=new k(n):(this.c=new k(u),n.forEach(this.add,this))}get size(){return this.c.size}add(n){return this.c.set(n,n),this}clear(){this.c.clear()}delete(n){return this.c.delete(n)}forEach(n,u){this.c.forEach((l,_)=>n.call(u,_,_,this))}has(n){return this.c.has(n)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(t=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Bc=H;var J;(function(s){s[s.None=0]="None",s[s.AsOld=1]="AsOld",s[s.AsNew=2]="AsNew"})(J||(e.Touch=J={}));class u1{constructor(){this[G]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has(n){return this.c.has(n)}get(n,u=J.None){const l=this.c.get(n);if(l)return u!==J.None&&this.m(l,u),l.value}set(n,u,l=J.None){let _=this.c.get(n);if(_)_.value=u,l!==J.None&&this.m(_,l);else{switch(_={key:n,value:u,next:void 0,previous:void 0},l){case J.None:this.k(_);break;case J.AsOld:this.j(_);break;case J.AsNew:this.k(_);break;default:this.k(_);break}this.c.set(n,_),this.f++}return this}delete(n){return!!this.remove(n)}remove(n){const u=this.c.get(n);if(u)return this.c.delete(n),this.l(u),this.f--,u.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const n=this.d;return this.c.delete(n.key),this.l(n),this.f--,n.value}forEach(n,u){const l=this.g;let _=this.d;for(;_;){if(u?n.bind(u)(_.value,_.key,this):n(_.value,_.key,this),this.g!==l)throw new Error("LinkedMap got modified during iteration.");_=_.next}}keys(){const n=this,u=this.g;let l=this.d;const _={[Symbol.iterator](){return _},next(){if(n.g!==u)throw new Error("LinkedMap got modified during iteration.");if(l){const I={value:l.key,done:!1};return l=l.next,I}else return{value:void 0,done:!0}}};return _}values(){const n=this,u=this.g;let l=this.d;const _={[Symbol.iterator](){return _},next(){if(n.g!==u)throw new Error("LinkedMap got modified during iteration.");if(l){const I={value:l.value,done:!1};return l=l.next,I}else return{value:void 0,done:!0}}};return _}entries(){const n=this,u=this.g;let l=this.d;const _={[Symbol.iterator](){return _},next(){if(n.g!==u)throw new Error("LinkedMap got modified during iteration.");if(l){const I={value:[l.key,l.value],done:!1};return l=l.next,I}else return{value:void 0,done:!0}}};return _}[(G=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h(n){if(n>=this.size)return;if(n===0){this.clear();return}let u=this.d,l=this.size;for(;u&&l>n;)this.c.delete(u.key),u=u.next,l--;this.d=u,this.f=l,u&&(u.previous=void 0),this.g++}i(n){if(n>=this.size)return;if(n===0){this.clear();return}let u=this.e,l=this.size;for(;u&&l>n;)this.c.delete(u.key),u=u.previous,l--;this.e=u,this.f=l,u&&(u.next=void 0),this.g++}j(n){if(!this.d&&!this.e)this.e=n;else if(this.d)n.next=this.d,this.d.previous=n;else throw new Error("Invalid list");this.d=n,this.g++}k(n){if(!this.d&&!this.e)this.d=n;else if(this.e)n.previous=this.e,this.e.next=n;else throw new Error("Invalid list");this.e=n,this.g++}l(n){if(n===this.d&&n===this.e)this.d=void 0,this.e=void 0;else if(n===this.d){if(!n.next)throw new Error("Invalid list");n.next.previous=void 0,this.d=n.next}else if(n===this.e){if(!n.previous)throw new Error("Invalid list");n.previous.next=void 0,this.e=n.previous}else{const u=n.next,l=n.previous;if(!u||!l)throw new Error("Invalid list");u.previous=l,l.next=u}n.next=void 0,n.previous=void 0,this.g++}m(n,u){if(!this.d||!this.e)throw new Error("Invalid list");if(!(u!==J.AsOld&&u!==J.AsNew)){if(u===J.AsOld){if(n===this.d)return;const l=n.next,_=n.previous;n===this.e?(_.next=void 0,this.e=_):(l.previous=_,_.next=l),n.previous=void 0,n.next=this.d,this.d.previous=n,this.d=n,this.g++}else if(u===J.AsNew){if(n===this.e)return;const l=n.next,_=n.previous;n===this.d?(l.previous=void 0,this.d=l):(l.previous=_,_.next=l),n.next=void 0,n.previous=this.e,this.e.next=n,this.e=n,this.g++}}}toJSON(){const n=[];return this.forEach((u,l)=>{n.push([l,u])}),n}fromJSON(n){this.clear();for(const[u,l]of n)this.set(u,l)}}e.$Cc=u1;class o1 extends u1{constructor(n,u=1){super(),this.n=n,this.o=Math.min(Math.max(0,u),1)}get limit(){return this.n}set limit(n){this.n=n,this.p()}get ratio(){return this.o}set ratio(n){this.o=Math.min(Math.max(0,n),1),this.p()}get(n,u=J.AsNew){return super.get(n,u)}peek(n){return super.get(n,J.None)}set(n,u){return super.set(n,u,J.AsNew),this}p(){this.size>this.n&&this.q(Math.round(this.n*this.o))}}class y extends o1{constructor(n,u=1){super(n,u)}q(n){this.h(n)}set(n,u){return super.set(n,u),this.p(),this}}e.$Dc=y;class K extends o1{constructor(n,u=1){super(n,u)}q(n){this.i(n)}set(n,u){return this.n<=this.size&&!this.has(n)&&this.q(Math.round(this.n*this.o)-1),super.set(n,u),this}}e.$Ec=K;class M{constructor(){this.c=new Map}add(n){return this.c.set(n,(this.c.get(n)||0)+1),this}delete(n){let u=this.c.get(n)||0;return u===0?!1:(u--,u===0?this.c.delete(n):this.c.set(n,u),!0)}has(n){return this.c.has(n)}}e.$Fc=M;class g{constructor(n){if(this.c=new Map,this.d=new Map,n)for(const[u,l]of n)this.set(u,l)}clear(){this.c.clear(),this.d.clear()}set(n,u){this.c.set(n,u),this.d.set(u,n)}get(n){return this.c.get(n)}getKey(n){return this.d.get(n)}delete(n){const u=this.c.get(n);return u===void 0?!1:(this.c.delete(n),this.d.delete(u),!0)}forEach(n,u){this.c.forEach((l,_)=>{n.call(u,l,_,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}e.$Gc=g;class b{constructor(){this.c=new Map}add(n,u){let l=this.c.get(n);l||(l=new Set,this.c.set(n,l)),l.add(u)}delete(n,u){const l=this.c.get(n);l&&(l.delete(u),l.size===0&&this.c.delete(n))}forEach(n,u){const l=this.c.get(n);l&&l.forEach(u)}get(n){const u=this.c.get(n);return u||new Set}}e.$Hc=b;function T(s,n){if(s===n)return!0;if(s.size!==n.size)return!1;for(const[u,l]of s)if(!n.has(u)||n.get(u)!==l)return!1;for(const[u]of n)if(!s.has(u))return!1;return!0}}),define(h1[4],a1([0,1,9,8,13,3,10]),function(_1,e,A,t,G,$,Y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4c=e.$2c=e.$1c=e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Tc=e.$Jc=void 0,e.$Kc=k,e.$Lc=H,e.$Mc=J,e.$Nc=y,e.$Oc=K,e.$Pc=M,e.$Qc=g,e.$Rc=b,e.$Sc=T,e.$3c=l1;const q=!1;let U=null;class v{constructor(){this.b=new Map}static{this.a=0}c(h){let O=this.b.get(h);return O||(O={parent:null,source:null,isSingleton:!1,value:h,idx:v.a++},this.b.set(h,O)),O}trackDisposable(h){const O=this.c(h);O.source||(O.source=new Error().stack)}setParent(h,O){const B=this.c(h);B.parent=O}markAsDisposed(h){this.b.delete(h)}markAsSingleton(h){this.c(h).isSingleton=!0}f(h,O){const B=O.get(h);if(B)return B;const R=h.parent?this.f(this.c(h.parent),O):h;return O.set(h,R),R}getTrackedDisposables(){const h=new Map;return[...this.b.entries()].filter(([,B])=>B.source!==null&&!this.f(B,h).isSingleton).flatMap(([B])=>B)}computeLeakingDisposables(h=10,O){let B;if(O)B=O;else{const z=new Map,C=[...this.b.values()].filter(X=>X.source!==null&&!this.f(X,z).isSingleton);if(C.length===0)return;const e1=new Set(C.map(X=>X.value));if(B=C.filter(X=>!(X.parent&&e1.has(X.parent))),B.length===0)throw new Error("There are cyclic diposable chains!")}if(!B)return;function R(z){function C(X,n1){for(;X.length>0&&n1.some(f1=>typeof f1=="string"?f1===X[0]:X[0].match(f1));)X.shift()}const e1=z.source.split(`
`).map(X=>X.trim().replace("at ","")).filter(X=>X!=="");return C(e1,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),e1.reverse()}const E=new G.$Hc;for(const z of B){const C=R(z);for(let e1=0;e1<=C.length;e1++)E.add(C.slice(0,e1).join(`
`),z)}B.sort((0,A.$6b)(z=>z.idx,A.$8b));let F="",x=0;for(const z of B.slice(0,h)){x++;const C=R(z),e1=[];for(let X=0;X<C.length;X++){let n1=C[X];n1=`(shared with ${E.get(C.slice(0,X+1).join(`
`)).size}/${B.length} leaks) at ${n1}`;const L1=E.get(C.slice(0,X).join(`
`)),w1=(0,t.$K)([...L1].map(R1=>R(R1)[X]),R1=>R1);delete w1[C[X]];for(const[R1,N1]of Object.entries(w1))e1.unshift(`    - stacktraces of ${N1.length} other leaks continue with ${R1}`);e1.unshift(n1)}F+=`


==================== Leaking disposable ${x}/${B.length}: ${z.value.constructor.name} ====================
${e1.join(`
`)}
============================================================

`}return B.length>h&&(F+=`


... and ${B.length-h} more leaking disposables

`),{leaks:B,details:F}}}e.$Jc=v;function k(S){U=S}if(q){const S="__is_disposable_tracked__";k(new class{trackDisposable(h){const O=new Error("Potentially leaked disposable").stack;setTimeout(()=>{h[S]||console.log(O)},3e3)}setParent(h,O){if(h&&h!==n.None)try{h[S]=!0}catch{}}markAsDisposed(h){if(h&&h!==n.None)try{h[S]=!0}catch{}}markAsSingleton(h){}})}function H(S){return U?.trackDisposable(S),S}function J(S){U?.markAsDisposed(S)}function u1(S,h){U?.setParent(S,h)}function o1(S,h){if(U)for(const O of S)U.setParent(O,h)}function y(S){return U?.markAsSingleton(S),S}function K(S){return typeof S=="object"&&S!==null&&typeof S.dispose=="function"&&S.dispose.length===0}function M(S){if(Y.Iterable.is(S)){const h=[];for(const O of S)if(O)try{O.dispose()}catch(B){h.push(B)}if(h.length===1)throw h[0];if(h.length>1)throw new AggregateError(h,"Encountered errors while disposing of store");return Array.isArray(S)?[]:S}else if(S)return S.dispose(),S}function g(S){for(const h of S)K(h)&&h.dispose();return[]}function b(...S){const h=T(()=>M(S));return o1(S,h),h}function T(S){const h=H({dispose:(0,$.$db)(()=>{J(h),S()})});return h}class s{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,H(this)}dispose(){this.g||(J(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{M(this.f)}finally{this.f.clear()}}add(h){if(!h)return h;if(h===this)throw new Error("Cannot register a disposable on itself!");return u1(h,this),this.g?s.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(h),h}delete(h){if(h){if(h===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(h),h.dispose()}}deleteAndLeak(h){h&&this.f.has(h)&&(this.f.delete(h),u1(h,null))}}e.$Tc=s;class n{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new s,H(this),u1(this.q,this)}dispose(){J(this),this.q.dispose()}B(h){if(h===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(h)}}e.$Uc=n;class u{constructor(){this.b=!1,H(this)}get value(){return this.b?void 0:this.a}set value(h){this.b||h===this.a||(this.a?.dispose(),h&&u1(h,this),this.a=h)}clear(){this.value=void 0}dispose(){this.b=!0,J(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const h=this.a;return this.a=void 0,h&&u1(h,null),h}}e.$Vc=u;class l{constructor(h){this.a=new u,this.b=!1,this.a.value=h}get value(){return this.a.value}set value(h){this.b||h===this.a.value||(this.a.value=h)}dispose(){this.b=!0,this.a.dispose()}}e.$Wc=l;class _{constructor(h){this.b=h,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$Xc=_;class I{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,H(this)}set(h){let O=h;return this.unset=()=>O=void 0,this.isset=()=>O!==void 0,this.dispose=()=>{O&&(O(),O=void 0,J(this))},this}}e.$Yc=I;class D{constructor(){this.a=new Map}acquire(h,...O){let B=this.a.get(h);B||(B={counter:0,object:this.b(h,...O)},this.a.set(h,B));const{object:R}=B,E=(0,$.$db)(()=>{--B.counter===0&&(this.c(h,B.object),this.a.delete(h))});return B.counter++,{object:R,dispose:E}}}e.$Zc=D;class Q{constructor(h){this.a=h}async acquire(h,...O){const B=this.a.acquire(h,...O);try{return{object:await B.object,dispose:()=>B.dispose()}}catch(R){throw B.dispose(),R}}}e.$1c=Q;class g1{constructor(h){this.object=h}dispose(){}}e.$2c=g1;function l1(S){const h=new s;try{S(h)}finally{h.dispose()}}class j{constructor(){this.a=new Map,this.b=!1,H(this)}dispose(){J(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{M(this.a.values())}finally{this.a.clear()}}has(h){return this.a.has(h)}get size(){return this.a.size}get(h){return this.a.get(h)}set(h,O,B=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),B||this.a.get(h)?.dispose(),this.a.set(h,O)}deleteAndDispose(h){this.a.get(h)?.dispose(),this.a.delete(h)}deleteAndLeak(h){const O=this.a.get(h);return this.a.delete(h),O}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$4c=j}),define(h1[14],a1([0,1]),function(_1,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$be=void 0;const A=globalThis.performance&&typeof globalThis.performance.now=="function";class t{static create($){return new t($)}constructor($){this.c=A&&$===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$be=t}),define(h1[5],a1([0,1,2,3,4,12,14]),function(_1,e,A,t,G,$,Y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$ie=e.$he=e.$ge=e.$fe=e.$de=e.Event=void 0,e.$ee=u1;const q=!1,U=!1,v=!1;var k;(function(R){R.None=()=>G.$Uc.None;function E(N){if(v){const{onDidAddListener:w}=N,W=y.create();let P=0;N.onDidAddListener=()=>{++P===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),W.print()),w?.()}}}function F(N,w){return R1(N,()=>{},0,void 0,!0,void 0,w)}R.defer=F;function x(N){return(w,W=null,P)=>{let V=!1,i1;return i1=N(c1=>{if(!V)return i1?i1.dispose():V=!0,w.call(W,c1)},null,P),V&&i1.dispose(),i1}}R.once=x;function z(N,w,W){return L1((P,V=null,i1)=>N(c1=>P.call(V,w(c1)),null,i1),W)}R.map=z;function C(N,w,W){return L1((P,V=null,i1)=>N(c1=>{w(c1),P.call(V,c1)},null,i1),W)}R.forEach=C;function e1(N,w,W){return L1((P,V=null,i1)=>N(c1=>w(c1)&&P.call(V,c1),null,i1),W)}R.filter=e1;function X(N){return N}R.signal=X;function n1(...N){return(w,W=null,P)=>{const V=(0,G.$Rc)(...N.map(i1=>i1(c1=>w.call(W,c1))));return w1(V,P)}}R.any=n1;function f1(N,w,W,P){let V=W;return z(N,i1=>(V=w(V,i1),V),P)}R.reduce=f1;function L1(N,w){let W;const P={onWillAddFirstListener(){W=N(V.fire,V)},onDidRemoveLastListener(){W?.dispose()}};w||E(P);const V=new u(P);return w?.add(V),V.event}function w1(N,w){return w instanceof Array?w.push(N):w&&w.add(N),N}function R1(N,w,W=100,P=!1,V=!1,i1,c1){let b1,$1,y1,P1=0,t1;const v1={leakWarningThreshold:i1,onWillAddFirstListener(){b1=N(j1=>{P1++,$1=w($1,j1),P&&!y1&&(k1.fire($1),$1=void 0),t1=()=>{const K1=$1;$1=void 0,y1=void 0,(!P||P1>1)&&k1.fire(K1),P1=0},typeof W=="number"?(clearTimeout(y1),y1=setTimeout(t1,W)):y1===void 0&&(y1=0,queueMicrotask(t1))})},onWillRemoveListener(){V&&P1>0&&t1?.()},onDidRemoveLastListener(){t1=void 0,b1.dispose()}};c1||E(v1);const k1=new u(v1);return c1?.add(k1),k1.event}R.debounce=R1;function N1(N,w=0,W){return R.debounce(N,(P,V)=>P?(P.push(V),P):[V],w,void 0,!0,void 0,W)}R.accumulate=N1;function W1(N,w=(P,V)=>P===V,W){let P=!0,V;return e1(N,i1=>{const c1=P||!w(i1,V);return P=!1,V=i1,c1},W)}R.latch=W1;function G1(N,w,W){return[R.filter(N,w,W),R.filter(N,P=>!w(P),W)]}R.split=G1;function I1(N,w=!1,W=[],P){let V=W.slice(),i1=N($1=>{V?V.push($1):b1.fire($1)});P&&P.add(i1);const c1=()=>{V?.forEach($1=>b1.fire($1)),V=null},b1=new u({onWillAddFirstListener(){i1||(i1=N($1=>b1.fire($1)),P&&P.add(i1))},onDidAddFirstListener(){V&&(w?setTimeout(c1):c1())},onDidRemoveLastListener(){i1&&i1.dispose(),i1=null}});return P&&P.add(b1),b1.event}R.buffer=I1;function F1(N,w){return(P,V,i1)=>{const c1=w(new o);return N(function(b1){const $1=c1.evaluate(b1);$1!==c&&P.call(V,$1)},void 0,i1)}}R.chain=F1;const c=Symbol("HaltChainable");class o{constructor(){this.f=[]}map(w){return this.f.push(w),this}forEach(w){return this.f.push(W=>(w(W),W)),this}filter(w){return this.f.push(W=>w(W)?W:c),this}reduce(w,W){let P=W;return this.f.push(V=>(P=w(P,V),P)),this}latch(w=(W,P)=>W===P){let W=!0,P;return this.f.push(V=>{const i1=W||!w(V,P);return W=!1,P=V,i1?V:c}),this}evaluate(w){for(const W of this.f)if(w=W(w),w===c)break;return w}}function f(N,w,W=P=>P){const P=(...b1)=>c1.fire(W(...b1)),V=()=>N.on(w,P),i1=()=>N.removeListener(w,P),c1=new u({onWillAddFirstListener:V,onDidRemoveLastListener:i1});return c1.event}R.fromNodeEventEmitter=f;function d(N,w,W=P=>P){const P=(...b1)=>c1.fire(W(...b1)),V=()=>N.addEventListener(w,P),i1=()=>N.removeEventListener(w,P),c1=new u({onWillAddFirstListener:V,onDidRemoveLastListener:i1});return c1.event}R.fromDOMEventEmitter=d;function L(N){return new Promise(w=>x(N)(w))}R.toPromise=L;function Z(N){const w=new u;return N.then(W=>{w.fire(W)},()=>{w.fire(void 0)}).finally(()=>{w.dispose()}),w.event}R.fromPromise=Z;function r1(N,w,W){return w(W),N(P=>w(P))}R.runAndSubscribe=r1;class E1{constructor(w,W){this._observable=w,this.f=0,this.g=!1;const P={onWillAddFirstListener:()=>{w.addObserver(this)},onDidRemoveLastListener:()=>{w.removeObserver(this)}};W||E(P),this.emitter=new u(P),W&&W.add(this.emitter)}beginUpdate(w){this.f++}handlePossibleChange(w){}handleChange(w,W){this.g=!0}endUpdate(w){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function d1(N,w){return new E1(N,w).emitter.event}R.fromObservable=d1;function A1(N){return(w,W,P)=>{let V=0,i1=!1;const c1={beginUpdate(){V++},endUpdate(){V--,V===0&&(N.reportChanges(),i1&&(i1=!1,w.call(W)))},handlePossibleChange(){},handleChange(){i1=!0}};N.addObserver(c1),N.reportChanges();const b1={dispose(){N.removeObserver(c1)}};return P instanceof G.$Tc?P.add(b1):Array.isArray(P)&&P.push(b1),b1}}R.fromObservableLight=A1})(k||(e.Event=k={}));class H{static{this.all=new Set}static{this.f=0}constructor(E){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${E}_${H.f++}`,H.all.add(this)}start(E){this.g=new Y.$be,this.listenerCount=E}stop(){if(this.g){const E=this.g.elapsed();this.durations.push(E),this.elapsedOverall+=E,this.invocationCount+=1,this.g=void 0}}}e.$de=H;let J=-1;function u1(R){const E=J;return J=R,{dispose(){J=E}}}class o1{constructor(E,F,x=Math.random().toString(18).slice(2,5)){this.h=E,this.threshold=F,this.name=x,this.g=0}dispose(){this.f?.clear()}check(E,F){const x=this.threshold;if(x<=0||F<x)return;this.f||(this.f=new Map);const z=this.f.get(E.value)||0;if(this.f.set(E.value,z+1),this.g-=1,this.g<=0){this.g=x*.5;const[C,e1]=this.getMostFrequentStack(),X=`[${this.name}] potential listener LEAK detected, having ${F} listeners already. MOST frequent listener (${e1}):`;console.warn(X),console.warn(C);const n1=new K(X,C);this.h(n1)}return()=>{const C=this.f.get(E.value)||0;this.f.set(E.value,C-1)}}getMostFrequentStack(){if(!this.f)return;let E,F=0;for(const[x,z]of this.f)(!E||F<z)&&(E=[x,z],F=z);return E}}class y{static create(){const E=new Error;return new y(E.stack??"")}constructor(E){this.value=E}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class K extends Error{constructor(E,F){super(E),this.name="ListenerLeakError",this.stack=F}}e.$fe=K;class M extends Error{constructor(E,F){super(E),this.name="ListenerRefusalError",this.stack=F}}e.$ge=M;let g=0;class b{constructor(E){this.value=E,this.id=g++}}const T=2,s=(R,E)=>{if(R instanceof b)E(R);else for(let F=0;F<R.length;F++){const x=R[F];x&&E(x)}},n=q?new FinalizationRegistry(R=>{typeof R=="string"&&(console.warn("[LEAKING LISTENER] GC'ed a listener that was NOT yet disposed. This is where is was created:"),console.warn(R))}):void 0;class u{constructor(E){this.w=0,this.f=E,this.g=J>0||this.f?.leakWarningThreshold?new o1(E?.onListenerError??A.$1,this.f?.leakWarningThreshold??J):void 0,this.j=this.f?._profName?new H(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(U){const E=this.t;queueMicrotask(()=>{s(E,F=>F.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(E,F,x)=>{if(this.g&&this.w>this.g.threshold**2){const n1=`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far (${this.w} vs ${this.g.threshold})`;console.warn(n1);const f1=this.g.getMostFrequentStack()??["UNKNOWN stack",-1],L1=new M(`${n1}. HINT: Stack shows most frequent listener (${f1[1]}-times)`,f1[0]);return(this.f?.onListenerError||A.$1)(L1),G.$Uc.None}if(this.m)return G.$Uc.None;F&&(E=E.bind(F));const z=new b(E);let C,e1;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(z.stack=y.create(),C=this.g.check(z.stack,this.w+1)),U&&(z.stack=e1??y.create()),this.t?this.t instanceof b?(this.u??=new _,this.t=[this.t,z]):this.t.push(z):(this.f?.onWillAddFirstListener?.(this),this.t=z,this.f?.onDidAddFirstListener?.(this)),this.w++;const X=(0,G.$Sc)(()=>{n?.unregister(X),C?.(),this.x(z)});if(x instanceof G.$Tc?x.add(X):Array.isArray(x)&&x.push(X),n){const n1=new Error().stack.split(`
`).slice(2).join(`
`).trim();n.register(X,n1,X)}return X},this.q}x(E){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const F=this.t,x=F.indexOf(E);if(x===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,F[x]=void 0;const z=this.u.current===this;if(this.w*T<=F.length){let C=0;for(let e1=0;e1<F.length;e1++)F[e1]?F[C++]=F[e1]:z&&(this.u.end--,C<this.u.i&&this.u.i--);F.length=C}}y(E,F){if(!E)return;const x=this.f?.onListenerError||A.$1;if(!x){E.value(F);return}try{E.value(F)}catch(z){x(z)}}z(E){const F=E.current.t;for(;E.i<E.end;)this.y(F[E.i++],E.value);E.reset()}fire(E){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof b)this.y(this.t,E);else{const F=this.u;F.enqueue(this,E,this.t.length),this.z(F)}this.j?.stop()}hasListeners(){return this.w>0}}e.$he=u;const l=()=>new _;e.$ie=l;class _{constructor(){this.i=-1,this.end=0}enqueue(E,F,x){this.i=0,this.end=x,this.current=E,this.value=F}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class I extends u{async fireAsync(E,F,x){if(this.t)for(this.h||(this.h=new $.$5c),s(this.t,z=>this.h.push([z.value,E]));this.h.size>0&&!F.isCancellationRequested;){const[z,C]=this.h.shift(),e1=[],X={...C,token:F,waitUntil:n1=>{if(Object.isFrozen(e1))throw new Error("waitUntil can NOT be called asynchronous");x&&(n1=x(n1,z)),e1.push(n1)}};try{z(X)}catch(n1){(0,A.$1)(n1);continue}Object.freeze(e1),await Promise.allSettled(e1).then(n1=>{for(const f1 of n1)f1.status==="rejected"&&(0,A.$1)(f1.reason)})}}}e.$je=I;class D extends u{get isPaused(){return this.h!==0}constructor(E){super(E),this.h=0,this.s=new $.$5c,this.A=E?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const E=Array.from(this.s);this.s.clear(),super.fire(this.A(E))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(E){this.w&&(this.h!==0?this.s.push(E):super.fire(E))}}e.$ke=D;class Q extends D{constructor(E){super(E),this.k=E.delay??100}fire(E){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(E)}}e.$le=Q;class g1 extends u{constructor(E){super(E),this.h=[],this.k=E?.merge}fire(E){this.hasListeners()&&(this.h.push(E),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(F=>super.fire(F)),this.h=[]}))}}e.$me=g1;class l1{constructor(){this.g=!1,this.h=[],this.f=new u({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(E){const F={event:E,listener:null};this.h.push(F),this.g&&this.m(F);const x=()=>{this.g&&this.o(F);const z=this.h.indexOf(F);this.h.splice(z,1)};return(0,G.$Sc)((0,t.$db)(x))}j(){this.g=!0,this.h.forEach(E=>this.m(E))}k(){this.g=!1,this.h.forEach(E=>this.o(E))}m(E){E.listener=E.event(F=>this.f.fire(F))}o(E){E.listener?.dispose(),E.listener=null}dispose(){this.f.dispose();for(const E of this.h)E.listener?.dispose();this.h=[]}}e.$ne=l1;class j{constructor(E,F,x,z){this.f=new G.$Tc;const C=this.f.add(new l1),e1=this.f.add(new G.$4c);function X(n1){e1.set(n1,C.add(z(n1)))}for(const n1 of E)X(n1);this.f.add(F(n1=>{X(n1)})),this.f.add(x(n1=>{e1.deleteAndDispose(n1)})),this.event=C.event}dispose(){this.f.dispose()}}e.$oe=j;class S{constructor(){this.f=[]}wrapEvent(E,F,x){return(z,C,e1)=>E(X=>{const n1=this.f[this.f.length-1];if(!F){n1?n1.buffers.push(()=>z.call(C,X)):z.call(C,X);return}const f1=n1;if(!f1){z.call(C,F(x,X));return}f1.items??=[],f1.items.push(X),f1.buffers.length===0&&n1.buffers.push(()=>{f1.reducedResult??=x?f1.items.reduce(F,x):f1.items.reduce(F),z.call(C,f1.reducedResult)})},void 0,e1)}bufferEvents(E){const F={buffers:new Array};this.f.push(F);const x=E();return this.f.pop(),F.buffers.forEach(z=>z()),x}}e.$pe=S;class h{constructor(){this.f=!1,this.g=k.None,this.h=G.$Uc.None,this.j=new u({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(E){this.g=E,this.f&&(this.h.dispose(),this.h=E(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$qe=h;class O{static const(E){return new B(E)}constructor(E){this.g=E,this.f=new u,this.onDidChange=this.f.event}get value(){return this.g}set value(E){E!==this.g&&(this.g=E,this.f.fire(void 0))}}e.$re=O;class B{constructor(E){this.value=E,this.onDidChange=k.None}}}),define(h1[15],a1([0,1,5]),function(_1,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$se=e.CancellationToken=void 0,e.$te=q;const t=Object.freeze(function(U,v){const k=setTimeout(U.bind(v),0);return{dispose(){clearTimeout(k)}}});var G;(function(U){function v(k){return k===U.None||k===U.Cancelled||k instanceof $?!0:!k||typeof k!="object"?!1:typeof k.isCancellationRequested=="boolean"&&typeof k.onCancellationRequested=="function"}U.isCancellationToken=v,U.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:A.Event.None}),U.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:t})})(G||(e.CancellationToken=G={}));class ${constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?t:(this.b||(this.b=new A.$he),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class Y{constructor(v){this.f=void 0,this.g=void 0,this.g=v&&v.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new $),this.f}cancel(){this.f?this.f instanceof $&&this.f.cancel():this.f=G.Cancelled}dispose(v=!1){v&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof $&&this.f.dispose():this.f=G.None}}e.$se=Y;function q(U){const v=new Y;return U.add({dispose(){v.cancel()}}),v.token}}),define(h1[16],a1([0,1,15]),function(_1,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8e=e.$7e=e.$5e=void 0,e.$6e=G;class t{constructor(U){this.b=U,this.a=null}get(){if(this.a)return this.a;const U=new A.$se,v=this.b(U.token);return this.a={promise:v,dispose:()=>{this.a=null,U.cancel(),U.dispose()}},this.a}}e.$5e=t;function G(q){return q}class ${constructor(U,v){this.a=void 0,this.b=void 0,typeof U=="function"?(this.c=U,this.d=G):(this.c=v,this.d=U.getCacheKey)}get(U){const v=this.d(U);return this.b!==v&&(this.b=v,this.a=this.c(U)),this.a}}e.$7e=$;class Y{get cachedValues(){return this.a}constructor(U,v){this.a=new Map,this.b=new Map,typeof U=="function"?(this.c=U,this.d=G):(this.c=v,this.d=U.getCacheKey)}get(U){const v=this.d(U);if(this.b.has(v))return this.b.get(v);const k=this.c(U);return this.a.set(U,k),this.b.set(v,k),k}}e.$8e=Y}),define(h1[17],a1([0,1]),function(_1,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ag=A,e.$bg=t,e.$cg=G,e.$dg=$,e.$eg=Y,e.$fg=q,e.$gg=U,e.$hg=v,e.$ig=k,e.$jg=H,e.$kg=J,e.$lg=u1,e.$mg=o1,e.$ng=K,e.$og=M,e.$pg=g,e.$qg=b,e.$rg=T;function A(s){return typeof s=="string"}function t(s){return Array.isArray(s)&&s.every(n=>A(n))}function G(s){return typeof s=="object"&&s!==null&&!Array.isArray(s)&&!(s instanceof RegExp)&&!(s instanceof Date)}function $(s){const n=Object.getPrototypeOf(Uint8Array);return typeof s=="object"&&s instanceof n}function Y(s){return typeof s=="number"&&!isNaN(s)}function q(s){return!!s&&typeof s[Symbol.iterator]=="function"}function U(s){return s===!0||s===!1}function v(s){return typeof s>"u"}function k(s){return!H(s)}function H(s){return v(s)||s===null}function J(s,n){if(!s)throw new Error(n?`Unexpected type, expected '${n}'`:"Unexpected type")}function u1(s){if(H(s))throw new Error("Assertion Failed: argument is undefined or null");return s}function o1(...s){const n=[];for(let u=0;u<s.length;u++){const l=s[u];if(H(l))throw new Error(`Assertion Failed: argument at index ${u} is undefined or null`);n.push(l)}return n}const y=Object.prototype.hasOwnProperty;function K(s){if(!G(s))return!1;for(const n in s)if(y.call(s,n))return!1;return!0}function M(s){return typeof s=="function"}function g(...s){return s.length>0&&s.every(M)}function b(s,n){const u=Math.min(s.length,n.length);for(let l=0;l<u;l++)T(s[l],n[l])}function T(s,n){if(A(n)){if(typeof s!==n)throw new Error(`argument does not match constraint: typeof ${n}`)}else if(M(n)){try{if(s instanceof n)return}catch{}if(!H(s)&&s.constructor===n||n.length===1&&n.call(void 0,s)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}}),define(h1[18],a1([0,1,17]),function(_1,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9n=t,e.$0n=G,e.$$n=Y,e.$_n=U,e.$ao=v,e.$bo=k,e.$co=H,e.$do=J,e.$eo=u1,e.$fo=o1,e.$go=y,e.$ho=K,e.$io=M;function t(g){if(!g||typeof g!="object"||g instanceof RegExp)return g;const b=Array.isArray(g)?[]:{};return Object.entries(g).forEach(([T,s])=>{b[T]=s&&typeof s=="object"?t(s):s}),b}function G(g){if(!g||typeof g!="object")return g;const b=[g];for(;b.length>0;){const T=b.shift();Object.freeze(T);for(const s in T)if($.call(T,s)){const n=T[s];typeof n=="object"&&!Object.isFrozen(n)&&!(0,A.$dg)(n)&&b.push(n)}}return g}const $=Object.prototype.hasOwnProperty;function Y(g,b){return q(g,b,new Set)}function q(g,b,T){if((0,A.$jg)(g))return g;const s=b(g);if(typeof s<"u")return s;if(Array.isArray(g)){const n=[];for(const u of g)n.push(q(u,b,T));return n}if((0,A.$cg)(g)){if(T.has(g))throw new Error("Cannot clone recursive data-structure");T.add(g);const n={};for(const u in g)$.call(g,u)&&(n[u]=q(g[u],b,T));return T.delete(g),n}return g}function U(g,b,T=!0){return(0,A.$cg)(g)?((0,A.$cg)(b)&&Object.keys(b).forEach(s=>{s in g?T&&((0,A.$cg)(g[s])&&(0,A.$cg)(b[s])?U(g[s],b[s],T):g[s]=b[s]):g[s]=b[s]}),g):b}function v(g,b){if(g===b)return!0;if(g==null||b===null||b===void 0||typeof g!=typeof b||typeof g!="object"||Array.isArray(g)!==Array.isArray(b))return!1;let T,s;if(Array.isArray(g)){if(g.length!==b.length)return!1;for(T=0;T<g.length;T++)if(!v(g[T],b[T]))return!1}else{const n=[];for(s in g)n.push(s);n.sort();const u=[];for(s in b)u.push(s);if(u.sort(),!v(n,u))return!1;for(T=0;T<n.length;T++)if(!v(g[n[T]],b[n[T]]))return!1}return!0}function k(g){const b=new Set;return JSON.stringify(g,(T,s)=>{if((0,A.$cg)(s)||Array.isArray(s)){if(b.has(s))return"[Circular]";b.add(s)}return typeof s=="bigint"?`[BigInt ${s.toString()}]`:s})}function H(g,b){const T=Object.create(null);return!g||!b||Object.keys(b).forEach(n=>{const u=g[n],l=b[n];v(u,l)||(T[n]=l)}),T}function J(g,b){const T=b.toLowerCase(),s=Object.keys(g).find(n=>n.toLowerCase()===T);return s?g[s]:g[b]}function u1(g,b){const T=Object.create(null);for(const[s,n]of Object.entries(g))b(s,n)&&(T[s]=n);return T}function o1(g){let b=[];for(;Object.prototype!==g;)b=b.concat(Object.getOwnPropertyNames(g)),g=Object.getPrototypeOf(g);return b}function y(g){const b=[];for(const T of o1(g))typeof g[T]=="function"&&b.push(T);return b}function K(g,b){const T=n=>function(){const u=Array.prototype.slice.call(arguments,0);return b(n,u)},s={};for(const n of g)s[n]=T(n);return s}function M(g,b){const T={};for(const[s,n]of Object.entries(g))T[s]=b(n,s);return T}}),define(h1[19],a1([0,1]),function(_1,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Constants=void 0,e.$9e=t,e.$0e=G;var A;(function($){$[$.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",$[$.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",$[$.MAX_UINT_8=255]="MAX_UINT_8",$[$.MAX_UINT_16=65535]="MAX_UINT_16",$[$.MAX_UINT_32=4294967295]="MAX_UINT_32",$[$.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(A||(e.Constants=A={}));function t($){return $<0?0:$>A.MAX_UINT_8?A.MAX_UINT_8:$|0}function G($){return $<0?0:$>A.MAX_UINT_32?A.MAX_UINT_32:$|0}}),define(h1[20],a1([0,1,16,7,11,19]),function(_1,e,A,t,G,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_f=e.$$f=e.$0f=e.GraphemeBreakType=e.$Zf=e.$Rf=e.$Kf=e.$Jf=void 0,e.$$e=Y,e.$_e=U,e.$af=k,e.$bf=H,e.$cf=J,e.$df=u1,e.$ef=o1,e.$ff=y,e.$gf=K,e.$hf=M,e.$if=g,e.$jf=b,e.$kf=T,e.$lf=s,e.$mf=n,e.$nf=u,e.$of=l,e.$pf=_,e.$qf=I,e.$rf=D,e.$sf=Q,e.$tf=g1,e.$uf=l1,e.$vf=j,e.$wf=S,e.$xf=h,e.$yf=O,e.$zf=B,e.$Af=R,e.$Bf=E,e.$Cf=F,e.$Df=x,e.$Ef=z,e.$Ff=C,e.$Gf=e1,e.$Hf=X,e.$If=n1,e.$Lf=R1,e.$Mf=N1,e.$Nf=W1,e.$Of=G1,e.$Pf=c,e.$Qf=f,e.$Sf=d,e.$Tf=L,e.$Uf=Z,e.$Vf=r1,e.$Wf=d1,e.$Xf=A1,e.$Yf=w,e.$1f=W,e.$2f=P,e.$3f=V,e.$4f=i1,e.$5f=c1,e.$6f=b1,e.$7f=$1,e.$8f=y1,e.$9f=j1;function Y(i){return!i||typeof i!="string"?!0:i.trim().length===0}const q=/{(\d+)}/g;function U(i,...r){return r.length===0?i:i.replace(q,function(a,m){const p=parseInt(m,10);return isNaN(p)||p<0||p>=r.length?a:r[p]})}const v=/{([^}]+)}/g;function k(i,r){return Object.keys(r).length===0?i:i.replace(v,(a,m)=>r[m]??a)}function H(i){return i.replace(/[<>"'&]/g,r=>{switch(r){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return r})}function J(i){return i.replace(/[<>&]/g,function(r){switch(r){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return r}})}function u1(i){return i.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function o1(i,r){let a=0,m=i.indexOf(r);for(;m!==-1;)a++,m=i.indexOf(r,m+r.length);return a}function y(i,r,a="\u2026"){return i.length<=r?i:`${i.substr(0,r)}${a}`}function K(i,r,a="\u2026"){if(i.length<=r)return i;const m=Math.ceil(r/2)-a.length/2,p=Math.floor(r/2)-a.length/2;return`${i.substr(0,m)}${a}${i.substr(i.length-p)}`}function M(i,r=" "){const a=g(i,r);return b(a,r)}function g(i,r){if(!i||!r)return i;const a=r.length;if(a===0||i.length===0)return i;let m=0;for(;i.indexOf(r,m)===m;)m=m+a;return i.substring(m)}function b(i,r){if(!i||!r)return i;const a=r.length,m=i.length;if(a===0||m===0)return i;let p=m,s1=-1;for(;s1=i.lastIndexOf(r,p-1),!(s1===-1||s1+a!==p);){if(s1===0)return"";p=s1}return i.substring(0,p)}function T(i){return i.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function s(i){return i.replace(/\*/g,"")}function n(i,r,a={}){if(!i)throw new Error("Cannot create regex from empty string");r||(i=u1(i)),a.wholeWord&&(/\B/.test(i.charAt(0))||(i="\\b"+i),/\B/.test(i.charAt(i.length-1))||(i=i+"\\b"));let m="";return a.global&&(m+="g"),a.matchCase||(m+="i"),a.multiline&&(m+="m"),a.unicode&&(m+="u"),new RegExp(i,m)}function u(i){return i.source==="^"||i.source==="^$"||i.source==="$"||i.source==="^\\s*$"?!1:!!(i.exec("")&&i.lastIndex===0)}function l(i){return i.split(/\r\n|\r|\n/)}function _(i){const r=[],a=i.split(/(\r\n|\r|\n)/);for(let m=0;m<Math.ceil(a.length/2);m++)r.push(a[2*m]+(a[2*m+1]??""));return r}function I(i){for(let r=0,a=i.length;r<a;r++){const m=i.charCodeAt(r);if(m!==t.CharCode.Space&&m!==t.CharCode.Tab)return r}return-1}function D(i,r=0,a=i.length){for(let m=r;m<a;m++){const p=i.charCodeAt(m);if(p!==t.CharCode.Space&&p!==t.CharCode.Tab)return i.substring(r,m)}return i.substring(r,a)}function Q(i,r=i.length-1){for(let a=r;a>=0;a--){const m=i.charCodeAt(a);if(m!==t.CharCode.Space&&m!==t.CharCode.Tab)return a}return-1}function g1(i,r,a){const m=[];let p=0;for(const s1 of i.matchAll(r)){if(m.push(i.slice(p,s1.index)),s1.index===void 0)throw new Error("match.index should be defined");p=s1.index+s1[0].length,m.push(a(s1[0],...s1.slice(1),s1.index,i,s1.groups))}return m.push(i.slice(p)),Promise.all(m).then(s1=>s1.join(""))}function l1(i,r){return i<r?-1:i>r?1:0}function j(i,r,a=0,m=i.length,p=0,s1=r.length){for(;a<m&&p<s1;a++,p++){const O1=i.charCodeAt(a),T1=r.charCodeAt(p);if(O1<T1)return-1;if(O1>T1)return 1}const m1=m-a,M1=s1-p;return m1<M1?-1:m1>M1?1:0}function S(i,r){return h(i,r,0,i.length,0,r.length)}function h(i,r,a=0,m=i.length,p=0,s1=r.length){for(;a<m&&p<s1;a++,p++){let O1=i.charCodeAt(a),T1=r.charCodeAt(p);if(O1===T1)continue;if(O1>=128||T1>=128)return j(i.toLowerCase(),r.toLowerCase(),a,m,p,s1);B(O1)&&(O1-=32),B(T1)&&(T1-=32);const U1=O1-T1;if(U1!==0)return U1}const m1=m-a,M1=s1-p;return m1<M1?-1:m1>M1?1:0}function O(i){return i>=t.CharCode.Digit0&&i<=t.CharCode.Digit9}function B(i){return i>=t.CharCode.a&&i<=t.CharCode.z}function R(i){return i>=t.CharCode.A&&i<=t.CharCode.Z}function E(i,r){return i.length===r.length&&h(i,r)===0}function F(i,r){const a=r.length;return r.length>i.length?!1:h(i,r,0,a)===0}function x(i,r){const a=Math.min(i.length,r.length);let m;for(m=0;m<a;m++)if(i.charCodeAt(m)!==r.charCodeAt(m))return m;return a}function z(i,r){const a=Math.min(i.length,r.length);let m;const p=i.length-1,s1=r.length-1;for(m=0;m<a;m++)if(i.charCodeAt(p-m)!==r.charCodeAt(s1-m))return m;return a}function C(i){return 55296<=i&&i<=56319}function e1(i){return 56320<=i&&i<=57343}function X(i,r){return(i-55296<<10)+(r-56320)+65536}function n1(i,r,a){const m=i.charCodeAt(a);if(C(m)&&a+1<r){const p=i.charCodeAt(a+1);if(e1(p))return X(m,p)}return m}function f1(i,r){const a=i.charCodeAt(r-1);if(e1(a)&&r>1){const m=i.charCodeAt(r-2);if(C(m))return X(m,a)}return a}class L1{get offset(){return this.e}constructor(r,a=0){this.c=r,this.d=r.length,this.e=a}setOffset(r){this.e=r}prevCodePoint(){const r=f1(this.c,this.e);return this.e-=r>=$.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,r}nextCodePoint(){const r=n1(this.c,this.d,this.e);return this.e+=r>=$.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,r}eol(){return this.e>=this.d}}e.$Jf=L1;class w1{get offset(){return this.c.offset}constructor(r,a=0){this.c=new L1(r,a)}nextGraphemeLength(){const r=v1.getInstance(),a=this.c,m=a.offset;let p=r.getGraphemeBreakType(a.nextCodePoint());for(;!a.eol();){const s1=a.offset,m1=r.getGraphemeBreakType(a.nextCodePoint());if(P1(p,m1)){a.setOffset(s1);break}p=m1}return a.offset-m}prevGraphemeLength(){const r=v1.getInstance(),a=this.c,m=a.offset;let p=r.getGraphemeBreakType(a.prevCodePoint());for(;a.offset>0;){const s1=a.offset,m1=r.getGraphemeBreakType(a.prevCodePoint());if(P1(m1,p)){a.setOffset(s1);break}p=m1}return m-a.offset}eol(){return this.c.eol()}}e.$Kf=w1;function R1(i,r){return new w1(i,r).nextGraphemeLength()}function N1(i,r){return new w1(i,r).prevGraphemeLength()}function W1(i,r){r>0&&e1(i.charCodeAt(r))&&r--;const a=r+R1(i,r);return[a-N1(i,a),a]}function G1(i){const r=new w1(i);let a=0;for(;!r.eol();)a++,r.nextGraphemeLength();return a}let I1;function F1(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function c(i){return I1||(I1=F1()),I1.test(i)}const o=/^[\t\n\r\x20-\x7E]*$/;function f(i){return o.test(i)}e.$Rf=/[\u2028\u2029]/;function d(i){return e.$Rf.test(i)}function L(i){return i>=11904&&i<=55215||i>=63744&&i<=64255||i>=65281&&i<=65374}function Z(i){return i>=127462&&i<=127487||i===8986||i===8987||i===9200||i===9203||i>=9728&&i<=10175||i===11088||i===11093||i>=127744&&i<=128591||i>=128640&&i<=128764||i>=128992&&i<=129008||i>=129280&&i<=129535||i>=129648&&i<=129782}function r1(i,r,a=""){const m=i.trimStart();if(m.length<r)return m;const p=/\b/g;let s1=0;for(;p.test(m)&&!(m.length-p.lastIndex<r);)s1=p.lastIndex,p.lastIndex+=1;return s1===0?m:a+m.substring(s1).trimStart()}const E1=/(?:(?:\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~])|(:?\x1b\].*?\x07)/g;function*d1(i){let r=0;for(const a of i.matchAll(E1))r!==a.index&&(yield{isCode:!1,str:i.substring(r,a.index)}),yield{isCode:!0,str:a[0]},r=a.index+a[0].length;r!==i.length&&(yield{isCode:!1,str:i.substring(r)})}function A1(i){return i&&(i=i.replace(E1,"")),i}const N=/\\\[.*?\\\]/g;function w(i){return A1(i).replace(N,"")}e.$Zf=String.fromCharCode(t.CharCode.UTF8_BOM);function W(i){return!!(i&&i.length>0&&i.charCodeAt(0)===t.CharCode.UTF8_BOM)}function P(i){return W(i)?i.substr(1):i}function V(i,r){if(!i||!r||i.length<r.length)return!1;const a=r.length,m=i.toLowerCase();let p=0,s1=-1;for(;p<a;){const m1=m.indexOf(r[p],s1+1);if(m1<0)return!1;s1=m1,p++}return!0}function i1(i,r=!1){return i?(r&&(i=i.replace(/\\./g,"")),i.toLowerCase()!==i):!1}function c1(i){return i.charAt(0).toUpperCase()+i.slice(1)}function b1(i,r=1){if(r===0)return"";let a=-1;do a=i.indexOf(`
`,a+1),r--;while(r>0&&a>=0);return a===-1?i:(i[a-1]==="\r"&&a--,i.substr(0,a))}function $1(i){const r=t.CharCode.Z-t.CharCode.A+1;return i=i%(2*r),i<r?String.fromCharCode(t.CharCode.a+i):String.fromCharCode(t.CharCode.A+i-r)}function y1(i){return v1.getInstance().getGraphemeBreakType(i)}function P1(i,r){return i===t1.Other?r!==t1.Extend&&r!==t1.SpacingMark:i===t1.CR&&r===t1.LF?!1:i===t1.Control||i===t1.CR||i===t1.LF||r===t1.Control||r===t1.CR||r===t1.LF?!0:!(i===t1.L&&(r===t1.L||r===t1.V||r===t1.LV||r===t1.LVT)||(i===t1.LV||i===t1.V)&&(r===t1.V||r===t1.T)||(i===t1.LVT||i===t1.T)&&r===t1.T||r===t1.Extend||r===t1.ZWJ||r===t1.SpacingMark||i===t1.Prepend||i===t1.ZWJ&&r===t1.Extended_Pictographic||i===t1.Regional_Indicator&&r===t1.Regional_Indicator)}var t1;(function(i){i[i.Other=0]="Other",i[i.Prepend=1]="Prepend",i[i.CR=2]="CR",i[i.LF=3]="LF",i[i.Control=4]="Control",i[i.Extend=5]="Extend",i[i.Regional_Indicator=6]="Regional_Indicator",i[i.SpacingMark=7]="SpacingMark",i[i.L=8]="L",i[i.V=9]="V",i[i.T=10]="T",i[i.LV=11]="LV",i[i.LVT=12]="LVT",i[i.ZWJ=13]="ZWJ",i[i.Extended_Pictographic=14]="Extended_Pictographic"})(t1||(e.GraphemeBreakType=t1={}));class v1{static{this.c=null}static getInstance(){return v1.c||(v1.c=new v1),v1.c}constructor(){this.d=k1()}getGraphemeBreakType(r){if(r<32)return r===t.CharCode.LineFeed?t1.LF:r===t.CharCode.CarriageReturn?t1.CR:t1.Control;if(r<127)return t1.Other;const a=this.d,m=a.length/3;let p=1;for(;p<=m;)if(r<a[3*p])p=2*p;else if(r>a[3*p+1])p=2*p+1;else return a[3*p+2];return t1.Other}}function k1(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function j1(i,r){if(i===0)return 0;const a=K1(i,r);if(a!==void 0)return a;const m=new L1(r,i);return m.prevCodePoint(),m.offset}function K1(i,r){const a=new L1(r,i);let m=a.prevCodePoint();for(;z1(m)||m===q1.emojiVariantSelector||m===q1.enclosingKeyCap;){if(a.offset===0)return;m=a.prevCodePoint()}if(!Z(m))return;let p=a.offset;return p>0&&a.prevCodePoint()===q1.zwj&&(p=a.offset),p}function z1(i){return 127995<=i&&i<=127999}var q1;(function(i){i[i.zwj=8205]="zwj",i[i.emojiVariantSelector=65039]="emojiVariantSelector",i[i.enclosingKeyCap=8419]="enclosingKeyCap"})(q1||(q1={})),e.$0f="\xA0";class p1{static{this.c=new G.$V(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new A.$7e({getCacheKey:JSON.stringify},r=>{function a(U1){const S1=new Map;for(let D1=0;D1<U1.length;D1+=2)S1.set(U1[D1],U1[D1+1]);return S1}function m(U1,S1){const D1=new Map(U1);for(const[H1,V1]of S1)D1.set(H1,V1);return D1}function p(U1,S1){if(!U1)return S1;const D1=new Map;for(const[H1,V1]of U1)S1.has(H1)&&D1.set(H1,V1);return D1}const s1=this.c.value;let m1=r.filter(U1=>!U1.startsWith("_")&&U1 in s1);m1.length===0&&(m1=["_default"]);let M1;for(const U1 of m1){const S1=a(s1[U1]);M1=p(M1,S1)}const O1=a(s1._common),T1=m(O1,M1);return new p1(T1)})}static getInstance(r){return p1.d.get(Array.from(r))}static{this.e=new G.$V(()=>Object.keys(p1.c.value).filter(r=>!r.startsWith("_")))}static getLocales(){return p1.e.value}constructor(r){this.f=r}isAmbiguous(r){return this.f.has(r)}containsAmbiguousCharacter(r){for(let a=0;a<r.length;a++){const m=r.codePointAt(a);if(typeof m=="number"&&this.isAmbiguous(m))return!0}return!1}getPrimaryConfusable(r){return this.f.get(r)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$$f=p1;class B1{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(B1.c())),this.d}static isInvisibleCharacter(r){return B1.e().has(r)}static containsInvisibleCharacter(r){for(let a=0;a<r.length;a++){const m=r.codePointAt(a);if(typeof m=="number"&&B1.isInvisibleCharacter(m))return!0}return!1}static get codePoints(){return B1.e()}}e.$_f=B1}),define(h1[21],a1([23,24]),function(_1,e){return _1.create("vs/base/common/platform",e)}),define(h1[22],a1([0,1,21]),function(_1,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$I=e.$H=e.$G=e.$F=e.$E=e.OS=e.OperatingSystem=e.$B=e.$A=e.$z=e.$y=e.$x=e.Language=e.$w=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.Platform=e.$g=void 0,e.$h=u,e.$D=g1,e.$J=l1,e.$g="en";let t=!1,G=!1,$=!1,Y=!1,q=!1,U=!1,v=!1,k=!1,H=!1,J=!1,u1,o1=e.$g,y=e.$g,K,M;const g=globalThis;let b;typeof g.vscode<"u"&&typeof g.vscode.process<"u"?b=g.vscode.process:typeof process<"u"&&typeof process?.versions?.node=="string"&&(b=process);const T=typeof b?.versions?.electron=="string",s=T&&b?.type==="renderer";if(typeof b=="object"){t=b.platform==="win32",G=b.platform==="darwin",$=b.platform==="linux",Y=$&&!!b.env.SNAP&&!!b.env.SNAP_REVISION,v=T,H=!!b.env.CI||!!b.env.BUILD_ARTIFACTSTAGINGDIRECTORY,u1=e.$g,o1=e.$g;const j=b.env.VSCODE_NLS_CONFIG;if(j)try{const S=JSON.parse(j),h=S.availableLanguages["*"];u1=S.locale,y=S.osLocale,o1=h||e.$g,K=S._translationsConfigFile}catch{}q=!0}else typeof navigator=="object"&&!s?(M=navigator.userAgent,t=M.indexOf("Windows")>=0,G=M.indexOf("Macintosh")>=0,k=(M.indexOf("Macintosh")>=0||M.indexOf("iPad")>=0||M.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,$=M.indexOf("Linux")>=0,J=M?.indexOf("Mobi")>=0,U=!0,u1=A.getConfiguredDefaultLocale(A.localize(0,null))||e.$g,o1=u1,y=navigator.language):console.error("Unable to resolve platform.");var n;(function(j){j[j.Web=0]="Web",j[j.Mac=1]="Mac",j[j.Linux=2]="Linux",j[j.Windows=3]="Windows"})(n||(e.Platform=n={}));function u(j){switch(j){case n.Web:return"Web";case n.Mac:return"Mac";case n.Linux:return"Linux";case n.Windows:return"Windows"}}let l=n.Web;G?l=n.Mac:t?l=n.Windows:$&&(l=n.Linux),e.$i=t,e.$j=G,e.$k=$,e.$l=Y,e.$m=q,e.$n=v,e.$o=U,e.$p=U&&typeof g.importScripts=="function",e.$q=e.$p?g.origin:void 0,e.$r=k,e.$s=J,e.$t=H,e.$u=l,e.$v=M,e.$w=o1;var _;(function(j){function S(){return e.$w}j.value=S;function h(){return e.$w.length===2?e.$w==="en":e.$w.length>=3?e.$w[0]==="e"&&e.$w[1]==="n"&&e.$w[2]==="-":!1}j.isDefaultVariant=h;function O(){return e.$w==="en"}j.isDefault=O})(_||(e.Language=_={})),e.$x=u1,e.$y=y,e.$z=K,e.$A=typeof g.postMessage=="function"&&!g.importScripts,e.$B=(()=>{if(e.$A){const j=[];g.addEventListener("message",h=>{if(h.data&&h.data.vscodeScheduleAsyncWork)for(let O=0,B=j.length;O<B;O++){const R=j[O];if(R.id===h.data.vscodeScheduleAsyncWork){j.splice(O,1),R.callback();return}}});let S=0;return h=>{const O=++S;j.push({id:O,callback:h}),g.postMessage({vscodeScheduleAsyncWork:O},"*")}}return j=>setTimeout(j)})();var I;(function(j){j[j.Windows=1]="Windows",j[j.Macintosh=2]="Macintosh",j[j.Linux=3]="Linux"})(I||(e.OperatingSystem=I={})),e.OS=G||k?I.Macintosh:t?I.Windows:I.Linux;let D=!0,Q=!1;function g1(){if(!Q){Q=!0;const j=new Uint8Array(2);j[0]=1,j[1]=2,D=new Uint16Array(j.buffer)[0]===513}return D}e.$E=!!(e.$v&&e.$v.indexOf("Chrome")>=0),e.$F=!!(e.$v&&e.$v.indexOf("Firefox")>=0),e.$G=!!(!e.$E&&e.$v&&e.$v.indexOf("Safari")>=0),e.$H=!!(e.$v&&e.$v.indexOf("Edg/")>=0),e.$I=!!(e.$v&&e.$v.indexOf("Android")>=0);function l1(j){return parseFloat(j)>=20}}),define(h1[25],a1([0,1,2,5,4,18,22,20]),function(_1,e,A,t,G,$,Y,q){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SimpleWorkerServer=e.SimpleWorkerClient=void 0,e.logOnceWebWorkerWarning=k,e.create=u;const U="$initialize";let v=!1;function k(l){Y.$o&&(v||(v=!0,console.warn("Could not create web worker(s). Falling back to loading web worker code in main thread, which might cause UI freezes. Please see https://github.com/microsoft/monaco-editor#faq")),console.warn(l.message))}var H;(function(l){l[l.Request=0]="Request",l[l.Reply=1]="Reply",l[l.SubscribeEvent=2]="SubscribeEvent",l[l.Event=3]="Event",l[l.UnsubscribeEvent=4]="UnsubscribeEvent"})(H||(H={}));class J{constructor(_,I,D,Q){this.vsWorker=_,this.req=I,this.method=D,this.args=Q,this.type=H.Request}}class u1{constructor(_,I,D,Q){this.vsWorker=_,this.seq=I,this.res=D,this.err=Q,this.type=H.Reply}}class o1{constructor(_,I,D,Q){this.vsWorker=_,this.req=I,this.eventName=D,this.arg=Q,this.type=H.SubscribeEvent}}class y{constructor(_,I,D){this.vsWorker=_,this.req=I,this.event=D,this.type=H.Event}}class K{constructor(_,I){this.vsWorker=_,this.req=I,this.type=H.UnsubscribeEvent}}class M{constructor(_){this.a=-1,this.g=_,this.b=0,this.c=Object.create(null),this.d=new Map,this.f=new Map}setWorkerId(_){this.a=_}sendMessage(_,I){const D=String(++this.b);return new Promise((Q,g1)=>{this.c[D]={resolve:Q,reject:g1},this.o(new J(this.a,D,_,I))})}listen(_,I){let D=null;const Q=new t.$he({onWillAddFirstListener:()=>{D=String(++this.b),this.d.set(D,Q),this.o(new o1(this.a,D,_,I))},onDidRemoveLastListener:()=>{this.d.delete(D),this.o(new K(this.a,D)),D=null}});return Q.event}handleMessage(_){!_||!_.vsWorker||this.a!==-1&&_.vsWorker!==this.a||this.h(_)}h(_){switch(_.type){case H.Reply:return this.j(_);case H.Request:return this.k(_);case H.SubscribeEvent:return this.l(_);case H.Event:return this.m(_);case H.UnsubscribeEvent:return this.n(_)}}j(_){if(!this.c[_.seq]){console.warn("Got reply to unknown seq");return}const I=this.c[_.seq];if(delete this.c[_.seq],_.err){let D=_.err;_.err.$isError&&(D=new Error,D.name=_.err.name,D.message=_.err.message,D.stack=_.err.stack),I.reject(D);return}I.resolve(_.res)}k(_){const I=_.req;this.g.handleMessage(_.method,_.args).then(Q=>{this.o(new u1(this.a,I,Q,void 0))},Q=>{Q.detail instanceof Error&&(Q.detail=(0,A.$3)(Q.detail)),this.o(new u1(this.a,I,void 0,(0,A.$3)(Q)))})}l(_){const I=_.req,D=this.g.handleEvent(_.eventName,_.arg)(Q=>{this.o(new y(this.a,I,Q))});this.f.set(I,D)}m(_){if(!this.d.has(_.req)){console.warn("Got event for unknown req");return}this.d.get(_.req).fire(_.event)}n(_){if(!this.f.has(_.req)){console.warn("Got unsubscribe for unknown req");return}this.f.get(_.req).dispose(),this.f.delete(_.req)}o(_){const I=[];if(_.type===H.Request)for(let D=0;D<_.args.length;D++)_.args[D]instanceof ArrayBuffer&&I.push(_.args[D]);else _.type===H.Reply&&_.res instanceof ArrayBuffer&&I.push(_.res);this.g.sendMessage(_,I)}}class g extends G.$Uc{constructor(_,I,D){super();let Q=null;this.a=this.B(_.create("vs/base/common/worker/simpleWorker",O=>{this.c.handleMessage(O)},O=>{Q?.(O)})),this.c=new M({sendMessage:(O,B)=>{this.a.postMessage(O,B)},handleMessage:(O,B)=>{if(typeof D[O]!="function")return Promise.reject(new Error("Missing method "+O+" on main thread host."));try{return Promise.resolve(D[O].apply(D,B))}catch(R){return Promise.reject(R)}},handleEvent:(O,B)=>{if(T(O)){const R=D[O].call(D,B);if(typeof R!="function")throw new Error(`Missing dynamic event ${O} on main thread host.`);return R}if(b(O)){const R=D[O];if(typeof R!="function")throw new Error(`Missing event ${O} on main thread host.`);return R}throw new Error(`Malformed event name ${O}`)}}),this.c.setWorkerId(this.a.getId());let g1=null;const l1=globalThis.require;typeof l1<"u"&&typeof l1.getConfig=="function"?g1=l1.getConfig():typeof globalThis.requirejs<"u"&&(g1=globalThis.requirejs.s.contexts._.config);const j=(0,$.$go)(D);this.b=this.c.sendMessage(U,[this.a.getId(),JSON.parse(JSON.stringify(g1)),I,j]);const S=(O,B)=>this.g(O,B),h=(O,B)=>this.c.listen(O,B);this.f=new Promise((O,B)=>{Q=B,this.b.then(R=>{O(s(R,S,h))},R=>{B(R),this.h("Worker failed to load "+I,R)})})}getProxyObject(){return this.f}g(_,I){return new Promise((D,Q)=>{this.b.then(()=>{this.c.sendMessage(_,I).then(D,Q)},Q)})}h(_,I){console.error(_),console.info(I)}}e.SimpleWorkerClient=g;function b(l){return l[0]==="o"&&l[1]==="n"&&q.$Af(l.charCodeAt(2))}function T(l){return/^onDynamic/.test(l)&&q.$Af(l.charCodeAt(9))}function s(l,_,I){const D=l1=>function(){const j=Array.prototype.slice.call(arguments,0);return _(l1,j)},Q=l1=>function(j){return I(l1,j)},g1={};for(const l1 of l){if(T(l1)){g1[l1]=Q(l1);continue}if(b(l1)){g1[l1]=I(l1,void 0);continue}g1[l1]=D(l1)}return g1}class n{constructor(_,I){this.a=I,this.b=null,this.c=new M({sendMessage:(D,Q)=>{_(D,Q)},handleMessage:(D,Q)=>this.d(D,Q),handleEvent:(D,Q)=>this.f(D,Q)})}onmessage(_){this.c.handleMessage(_)}d(_,I){if(_===U)return this.g(I[0],I[1],I[2],I[3]);if(!this.b||typeof this.b[_]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+_));try{return Promise.resolve(this.b[_].apply(this.b,I))}catch(D){return Promise.reject(D)}}f(_,I){if(!this.b)throw new Error("Missing requestHandler");if(T(_)){const D=this.b[_].call(this.b,I);if(typeof D!="function")throw new Error(`Missing dynamic event ${_} on request handler.`);return D}if(b(_)){const D=this.b[_];if(typeof D!="function")throw new Error(`Missing event ${_} on request handler.`);return D}throw new Error(`Malformed event name ${_}`)}g(_,I,D,Q){this.c.setWorkerId(_);const j=s(Q,(S,h)=>this.c.sendMessage(S,h),(S,h)=>this.c.listen(S,h));return this.a?(this.b=this.a(j),Promise.resolve((0,$.$go)(this.b))):(I&&(typeof I.baseUrl<"u"&&delete I.baseUrl,typeof I.paths<"u"&&typeof I.paths.vs<"u"&&delete I.paths.vs,typeof I.trustedTypesPolicy<"u"&&delete I.trustedTypesPolicy,I.catchError=!0,globalThis.require.config(I)),new Promise((S,h)=>{(globalThis.require||_1)([D],B=>{if(this.b=B.create(j),!this.b){h(new Error("No RequestHandler!"));return}S((0,$.$go)(this.b))},h)}))}}e.SimpleWorkerServer=n;function u(l){return new n(l,null)}})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/fd11ed87fdf1f8e46575e027644406f51f0666f6/core/vs/base/common/worker/simpleWorker.js.map
