/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ie=["require","exports","vs/editor/common/core/range","vs/base/common/charCode","vs/base/common/errors","vs/editor/common/core/position","vs/editor/common/core/offsetRange","vs/base/common/arrays","vs/base/common/strings","vs/base/common/arraysFind","vs/editor/common/diff/defaultLinesDiffComputer/algorithms/diffAlgorithm","vs/base/common/assert","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/uint","vs/editor/common/core/lineRange","vs/base/common/map","vs/base/common/objects","vs/editor/common/diff/defaultLinesDiffComputer/utils","vs/editor/common/diff/rangeMapping","vs/base/common/platform","vs/base/common/uri","vs/base/common/functional","vs/base/common/iterator","vs/base/common/linkedList","vs/base/common/stopwatch","vs/base/common/cancellation","vs/base/common/types","vs/base/common/codiconsUtil","vs/base/common/diff/diff","vs/editor/common/core/characterClassifier","vs/editor/common/core/textLength","vs/editor/common/core/wordHelper","vs/editor/common/diff/defaultLinesDiffComputer/algorithms/myersDiffAlgorithm","vs/editor/common/diff/defaultLinesDiffComputer/linesSliceCharSequence","vs/editor/common/diff/linesDiffComputer","vs/editor/common/diff/legacyLinesDiffComputer","vs/base/common/collections","vs/base/common/color","vs/base/common/diff/diffChange","vs/base/common/keyCodes","vs/base/common/lazy","vs/base/common/marshallingIds","vs/base/common/cache","vs/base/common/codiconsLibrary","vs/base/common/codicons","vs/base/common/hash","vs/editor/common/core/editOperation","vs/editor/common/core/selection","vs/editor/common/core/positionToOffset","vs/editor/common/core/textEdit","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/diff/defaultLinesDiffComputer/heuristicSequenceOptimizations","vs/editor/common/diff/defaultLinesDiffComputer/lineSequence","vs/editor/common/diff/defaultLinesDiffComputer/algorithms/dynamicProgrammingDiffing","vs/editor/common/diff/defaultLinesDiffComputer/computeMovedLines","vs/editor/common/diff/defaultLinesDiffComputer/defaultLinesDiffComputer","vs/editor/common/diff/linesDiffComputers","vs/editor/common/encodedTokenAttributes","vs/editor/common/languages/defaultDocumentColorsComputer","vs/editor/common/languages/linkComputer","vs/editor/common/languages/supports/inplaceReplaceSupport","vs/editor/common/model","vs/editor/common/model/prefixSumComputer","vs/editor/common/model/mirrorTextModel","vs/editor/common/model/textModelSearch","vs/editor/common/services/findSectionHeaders","vs/editor/common/services/unicodeTextModelHighlighter","vs/editor/common/standalone/standaloneEnums","vs/editor/common/tokenizationRegistry","vs/nls!vs/base/common/platform","vs/nls","vs/nls!vs/editor/common/services/editorSimpleWorker","vs/base/common/process","vs/base/common/path","vs/nls!vs/editor/common/languages","vs/editor/common/languages","vs/editor/common/services/editorBaseApi","vs/css","vs/base/common/worker/simpleWorker","vs/editor/common/services/editorSimpleWorker"],re=function(q){for(var i=[],t=0,n=q.length;t<n;t++)i[t]=ie[q[t]];return i};const Xe=this,Ye=typeof global=="object"?global:{};var ve;(function(q){q.global=Xe;class i{get isWindows(){return this._detect(),this._isWindows}get isNode(){return this._detect(),this._isNode}get isElectronRenderer(){return this._detect(),this._isElectronRenderer}get isWebWorker(){return this._detect(),this._isWebWorker}get isElectronNodeIntegrationWebWorker(){return this._detect(),this._isElectronNodeIntegrationWebWorker}constructor(){this._detected=!1,this._isWindows=!1,this._isNode=!1,this._isElectronRenderer=!1,this._isWebWorker=!1,this._isElectronNodeIntegrationWebWorker=!1}_detect(){this._detected||(this._detected=!0,this._isWindows=i._isWindows(),this._isNode=typeof module<"u"&&!!module.exports,this._isElectronRenderer=typeof process<"u"&&typeof process.versions<"u"&&typeof process.versions.electron<"u"&&process.type==="renderer",this._isWebWorker=typeof q.global.importScripts=="function",this._isElectronNodeIntegrationWebWorker=this._isWebWorker&&typeof process<"u"&&typeof process.versions<"u"&&typeof process.versions.electron<"u"&&process.type==="worker")}static _isWindows(){return typeof navigator<"u"&&navigator.userAgent&&navigator.userAgent.indexOf("Windows")>=0?!0:typeof process<"u"?process.platform==="win32":!1}}q.Environment=i})(ve||(ve={}));var ve;(function(q){class i{constructor(g,v,d){this.type=g,this.detail=v,this.timestamp=d}}q.LoaderEvent=i;class t{constructor(g){this._events=[new i(1,"",g)]}record(g,v){this._events.push(new i(g,v,q.Utilities.getHighPerformanceTimestamp()))}getEvents(){return this._events}}q.LoaderEventRecorder=t;class n{record(g,v){}getEvents(){return[]}}n.INSTANCE=new n,q.NullLoaderEventRecorder=n})(ve||(ve={}));var ve;(function(q){class i{static fileUriToFilePath(n,p){if(p=decodeURI(p).replace(/%23/g,"#"),n){if(/^file:\/\/\//.test(p))return p.substr(8);if(/^file:\/\//.test(p))return p.substr(5)}else if(/^file:\/\//.test(p))return p.substr(7);return p}static startsWith(n,p){return n.length>=p.length&&n.substr(0,p.length)===p}static endsWith(n,p){return n.length>=p.length&&n.substr(n.length-p.length)===p}static containsQueryString(n){return/^[^\#]*\?/gi.test(n)}static isAbsolutePath(n){return/^((http:\/\/)|(https:\/\/)|(file:\/\/)|(\/))/.test(n)}static forEachProperty(n,p){if(n){let g;for(g in n)n.hasOwnProperty(g)&&p(g,n[g])}}static isEmpty(n){let p=!0;return i.forEachProperty(n,()=>{p=!1}),p}static recursiveClone(n){if(!n||typeof n!="object"||n instanceof RegExp||!Array.isArray(n)&&Object.getPrototypeOf(n)!==Object.prototype)return n;let p=Array.isArray(n)?[]:{};return i.forEachProperty(n,(g,v)=>{v&&typeof v=="object"?p[g]=i.recursiveClone(v):p[g]=v}),p}static generateAnonymousModule(){return"===anonymous"+i.NEXT_ANONYMOUS_ID+++"==="}static isAnonymousModule(n){return i.startsWith(n,"===anonymous")}static getHighPerformanceTimestamp(){return this.PERFORMANCE_NOW_PROBED||(this.PERFORMANCE_NOW_PROBED=!0,this.HAS_PERFORMANCE_NOW=q.global.performance&&typeof q.global.performance.now=="function"),this.HAS_PERFORMANCE_NOW?q.global.performance.now():Date.now()}}i.NEXT_ANONYMOUS_ID=1,i.PERFORMANCE_NOW_PROBED=!1,i.HAS_PERFORMANCE_NOW=!1,q.Utilities=i})(ve||(ve={}));var ve;(function(q){function i(p){if(p instanceof Error)return p;const g=new Error(p.message||String(p)||"Unknown Error");return p.stack&&(g.stack=p.stack),g}q.ensureError=i;class t{static validateConfigurationOptions(g){function v(d){if(d.phase==="loading"){console.error('Loading "'+d.moduleId+'" failed'),console.error(d),console.error("Here are the modules that depend on it:"),console.error(d.neededBy);return}if(d.phase==="factory"){console.error('The factory function of "'+d.moduleId+'" has thrown an exception'),console.error(d),console.error("Here are the modules that depend on it:"),console.error(d.neededBy);return}}if(g=g||{},typeof g.baseUrl!="string"&&(g.baseUrl=""),typeof g.isBuild!="boolean"&&(g.isBuild=!1),typeof g.paths!="object"&&(g.paths={}),typeof g.config!="object"&&(g.config={}),typeof g.catchError>"u"&&(g.catchError=!1),typeof g.recordStats>"u"&&(g.recordStats=!1),typeof g.urlArgs!="string"&&(g.urlArgs=""),typeof g.onError!="function"&&(g.onError=v),Array.isArray(g.ignoreDuplicateModules)||(g.ignoreDuplicateModules=[]),g.baseUrl.length>0&&(q.Utilities.endsWith(g.baseUrl,"/")||(g.baseUrl+="/")),typeof g.cspNonce!="string"&&(g.cspNonce=""),typeof g.preferScriptTags>"u"&&(g.preferScriptTags=!1),g.nodeCachedData&&typeof g.nodeCachedData=="object"&&(typeof g.nodeCachedData.seed!="string"&&(g.nodeCachedData.seed="seed"),(typeof g.nodeCachedData.writeDelay!="number"||g.nodeCachedData.writeDelay<0)&&(g.nodeCachedData.writeDelay=1e3*7),!g.nodeCachedData.path||typeof g.nodeCachedData.path!="string")){const d=i(new Error("INVALID cached data configuration, 'path' MUST be set"));d.phase="configuration",g.onError(d),g.nodeCachedData=void 0}return g}static mergeConfigurationOptions(g=null,v=null){let d=q.Utilities.recursiveClone(v||{});return q.Utilities.forEachProperty(g,(a,l)=>{a==="ignoreDuplicateModules"&&typeof d.ignoreDuplicateModules<"u"?d.ignoreDuplicateModules=d.ignoreDuplicateModules.concat(l):a==="paths"&&typeof d.paths<"u"?q.Utilities.forEachProperty(l,(f,$)=>d.paths[f]=$):a==="config"&&typeof d.config<"u"?q.Utilities.forEachProperty(l,(f,$)=>d.config[f]=$):d[a]=q.Utilities.recursiveClone(l)}),t.validateConfigurationOptions(d)}}q.ConfigurationOptionsUtil=t;class n{constructor(g,v){if(this._env=g,this.options=t.mergeConfigurationOptions(v),this._createIgnoreDuplicateModulesMap(),this._createSortedPathsRules(),this.options.baseUrl===""&&this.options.nodeRequire&&this.options.nodeRequire.main&&this.options.nodeRequire.main.filename&&this._env.isNode){let d=this.options.nodeRequire.main.filename,a=Math.max(d.lastIndexOf("/"),d.lastIndexOf("\\"));this.options.baseUrl=d.substring(0,a+1)}}_createIgnoreDuplicateModulesMap(){this.ignoreDuplicateModulesMap={};for(let g=0;g<this.options.ignoreDuplicateModules.length;g++)this.ignoreDuplicateModulesMap[this.options.ignoreDuplicateModules[g]]=!0}_createSortedPathsRules(){this.sortedPathsRules=[],q.Utilities.forEachProperty(this.options.paths,(g,v)=>{Array.isArray(v)?this.sortedPathsRules.push({from:g,to:v}):this.sortedPathsRules.push({from:g,to:[v]})}),this.sortedPathsRules.sort((g,v)=>v.from.length-g.from.length)}cloneAndMerge(g){return new n(this._env,t.mergeConfigurationOptions(g,this.options))}getOptionsLiteral(){return this.options}_applyPaths(g){let v;for(let d=0,a=this.sortedPathsRules.length;d<a;d++)if(v=this.sortedPathsRules[d],q.Utilities.startsWith(g,v.from)){let l=[];for(let f=0,$=v.to.length;f<$;f++)l.push(v.to[f]+g.substr(v.from.length));return l}return[g]}_addUrlArgsToUrl(g){return q.Utilities.containsQueryString(g)?g+"&"+this.options.urlArgs:g+"?"+this.options.urlArgs}_addUrlArgsIfNecessaryToUrl(g){return this.options.urlArgs?this._addUrlArgsToUrl(g):g}_addUrlArgsIfNecessaryToUrls(g){if(this.options.urlArgs)for(let v=0,d=g.length;v<d;v++)g[v]=this._addUrlArgsToUrl(g[v]);return g}moduleIdToPaths(g){if(this._env.isNode&&this.options.amdModulesPattern instanceof RegExp&&!this.options.amdModulesPattern.test(g))return this.isBuild()?["empty:"]:["node|"+g];let v=g,d;if(!q.Utilities.endsWith(v,".js")&&!q.Utilities.isAbsolutePath(v)){d=this._applyPaths(v);for(let a=0,l=d.length;a<l;a++)this.isBuild()&&d[a]==="empty:"||(q.Utilities.isAbsolutePath(d[a])||(d[a]=this.options.baseUrl+d[a]),!q.Utilities.endsWith(d[a],".js")&&!q.Utilities.containsQueryString(d[a])&&(d[a]=d[a]+".js"))}else!q.Utilities.endsWith(v,".js")&&!q.Utilities.containsQueryString(v)&&(v=v+".js"),d=[v];return this._addUrlArgsIfNecessaryToUrls(d)}requireToUrl(g){let v=g;return q.Utilities.isAbsolutePath(v)||(v=this._applyPaths(v)[0],q.Utilities.isAbsolutePath(v)||(v=this.options.baseUrl+v)),this._addUrlArgsIfNecessaryToUrl(v)}isBuild(){return this.options.isBuild}shouldInvokeFactory(g){return!!(!this.options.isBuild||q.Utilities.isAnonymousModule(g)||this.options.buildForceInvokeFactory&&this.options.buildForceInvokeFactory[g])}isDuplicateMessageIgnoredFor(g){return this.ignoreDuplicateModulesMap.hasOwnProperty(g)}getConfigForModule(g){if(this.options.config)return this.options.config[g]}shouldCatchError(){return this.options.catchError}shouldRecordStats(){return this.options.recordStats}onError(g){this.options.onError(g)}}q.Configuration=n})(ve||(ve={}));var ve;(function(q){class i{constructor(l){this._env=l,this._scriptLoader=null,this._callbackMap={}}load(l,f,$,b){if(!this._scriptLoader)if(this._env.isWebWorker)this._scriptLoader=new p;else if(this._env.isElectronRenderer){const{preferScriptTags:e}=l.getConfig().getOptionsLiteral();e?this._scriptLoader=new t:this._scriptLoader=new g(this._env)}else this._env.isNode?this._scriptLoader=new g(this._env):this._scriptLoader=new t;let L={callback:$,errorback:b};if(this._callbackMap.hasOwnProperty(f)){this._callbackMap[f].push(L);return}this._callbackMap[f]=[L],this._scriptLoader.load(l,f,()=>this.triggerCallback(f),e=>this.triggerErrorback(f,e))}triggerCallback(l){let f=this._callbackMap[l];delete this._callbackMap[l];for(let $=0;$<f.length;$++)f[$].callback()}triggerErrorback(l,f){let $=this._callbackMap[l];delete this._callbackMap[l];for(let b=0;b<$.length;b++)$[b].errorback(f)}}class t{attachListeners(l,f,$){let b=()=>{l.removeEventListener("load",L),l.removeEventListener("error",e)},L=m=>{b(),f()},e=m=>{b(),$(m)};l.addEventListener("load",L),l.addEventListener("error",e)}load(l,f,$,b){if(/^node\|/.test(f)){let L=l.getConfig().getOptionsLiteral(),e=v(l.getRecorder(),L.nodeRequire||q.global.nodeRequire),m=f.split("|"),E=null;try{E=e(m[1])}catch(R){b(R);return}l.enqueueDefineAnonymousModule([],()=>E),$()}else{let L=document.createElement("script");L.setAttribute("async","async"),L.setAttribute("type","text/javascript"),this.attachListeners(L,$,b);const{trustedTypesPolicy:e}=l.getConfig().getOptionsLiteral();e&&(f=e.createScriptURL(f)),L.setAttribute("src",f);const{cspNonce:m}=l.getConfig().getOptionsLiteral();m&&L.setAttribute("nonce",m),document.getElementsByTagName("head")[0].appendChild(L)}}}function n(a){const{trustedTypesPolicy:l}=a.getConfig().getOptionsLiteral();try{return(l?self.eval(l.createScript("","true")):new Function("true")).call(self),!0}catch{return!1}}class p{constructor(){this._cachedCanUseEval=null}_canUseEval(l){return this._cachedCanUseEval===null&&(this._cachedCanUseEval=n(l)),this._cachedCanUseEval}load(l,f,$,b){if(/^node\|/.test(f)){const L=l.getConfig().getOptionsLiteral(),e=v(l.getRecorder(),L.nodeRequire||q.global.nodeRequire),m=f.split("|");let E=null;try{E=e(m[1])}catch(R){b(R);return}l.enqueueDefineAnonymousModule([],function(){return E}),$()}else{const{trustedTypesPolicy:L}=l.getConfig().getOptionsLiteral();if(!(/^((http:)|(https:)|(file:))/.test(f)&&f.substring(0,self.origin.length)!==self.origin)&&this._canUseEval(l)){fetch(f).then(m=>{if(m.status!==200)throw new Error(m.statusText);return m.text()}).then(m=>{m=`${m}
//# sourceURL=${f}`,(L?self.eval(L.createScript("",m)):new Function(m)).call(self),$()}).then(void 0,b);return}try{L&&(f=L.createScriptURL(f)),importScripts(f),$()}catch(m){b(m)}}}}class g{constructor(l){this._env=l,this._didInitialize=!1,this._didPatchNodeRequire=!1}_init(l){this._didInitialize||(this._didInitialize=!0,this._fs=l("fs"),this._vm=l("vm"),this._path=l("path"),this._crypto=l("crypto"))}_initNodeRequire(l,f){const{nodeCachedData:$}=f.getConfig().getOptionsLiteral();if(!$||this._didPatchNodeRequire)return;this._didPatchNodeRequire=!0;const b=this,L=l("module");function e(m){const E=m.constructor;let R=function(w){try{return m.require(w)}finally{}};return R.resolve=function(w,N){return E._resolveFilename(w,m,!1,N)},R.resolve.paths=function(w){return E._resolveLookupPaths(w,m)},R.main=process.mainModule,R.extensions=E._extensions,R.cache=E._cache,R}L.prototype._compile=function(m,E){const R=L.wrap(m.replace(/^#!.*/,"")),A=f.getRecorder(),w=b._getCachedDataPath($,E),N={filename:E};let c;try{const U=b._fs.readFileSync(w);c=U.slice(0,16),N.cachedData=U.slice(16),A.record(60,w)}catch{A.record(61,w)}const u=new b._vm.Script(R,N),s=u.runInThisContext(N),o=b._path.dirname(E),h=e(this),T=[this.exports,h,this,E,o,process,Ye,Buffer],_=s.apply(this.exports,T);return b._handleCachedData(u,R,w,!N.cachedData,f),b._verifyCachedData(u,R,w,c,f),_}}load(l,f,$,b){const L=l.getConfig().getOptionsLiteral(),e=v(l.getRecorder(),L.nodeRequire||q.global.nodeRequire),m=L.nodeInstrumenter||function(R){return R};this._init(e),this._initNodeRequire(e,l);let E=l.getRecorder();if(/^node\|/.test(f)){let R=f.split("|"),A=null;try{A=e(R[1])}catch(w){b(w);return}l.enqueueDefineAnonymousModule([],()=>A),$()}else{f=q.Utilities.fileUriToFilePath(this._env.isWindows,f);const R=this._path.normalize(f),A=this._getElectronRendererScriptPathOrUri(R),w=!!L.nodeCachedData,N=w?this._getCachedDataPath(L.nodeCachedData,f):void 0;this._readSourceAndCachedData(R,N,E,(c,u,s,o)=>{if(c){b(c);return}let h;u.charCodeAt(0)===g._BOM?h=g._PREFIX+u.substring(1)+g._SUFFIX:h=g._PREFIX+u+g._SUFFIX,h=m(h,R);const T={filename:A,cachedData:s},_=this._createAndEvalScript(l,h,T,$,b);this._handleCachedData(_,h,N,w&&!s,l),this._verifyCachedData(_,h,N,o,l)})}}_createAndEvalScript(l,f,$,b,L){const e=l.getRecorder();e.record(31,$.filename);const m=new this._vm.Script(f,$),E=m.runInThisContext($),R=l.getGlobalAMDDefineFunc();let A=!1;const w=function(){return A=!0,R.apply(null,arguments)};return w.amd=R.amd,E.call(q.global,l.getGlobalAMDRequireFunc(),w,$.filename,this._path.dirname($.filename)),e.record(32,$.filename),A?b():L(new Error(`Didn't receive define call in ${$.filename}!`)),m}_getElectronRendererScriptPathOrUri(l){if(!this._env.isElectronRenderer)return l;let f=l.match(/^([a-z])\:(.*)/i);return f?`file:///${(f[1].toUpperCase()+":"+f[2]).replace(/\\/g,"/")}`:`file://${l}`}_getCachedDataPath(l,f){const $=this._crypto.createHash("md5").update(f,"utf8").update(l.seed,"utf8").update(process.arch,"").digest("hex"),b=this._path.basename(f).replace(/\.js$/,"");return this._path.join(l.path,`${b}-${$}.code`)}_handleCachedData(l,f,$,b,L){l.cachedDataRejected?this._fs.unlink($,e=>{L.getRecorder().record(62,$),this._createAndWriteCachedData(l,f,$,L),e&&L.getConfig().onError(e)}):b&&this._createAndWriteCachedData(l,f,$,L)}_createAndWriteCachedData(l,f,$,b){let L=Math.ceil(b.getConfig().getOptionsLiteral().nodeCachedData.writeDelay*(1+Math.random())),e=-1,m=0,E;const R=()=>{setTimeout(()=>{E||(E=this._crypto.createHash("md5").update(f,"utf8").digest());const A=l.createCachedData();if(!(A.length===0||A.length===e||m>=5)){if(A.length<e){R();return}e=A.length,this._fs.writeFile($,Buffer.concat([E,A]),w=>{w&&b.getConfig().onError(w),b.getRecorder().record(63,$),R()})}},L*Math.pow(4,m++))};R()}_readSourceAndCachedData(l,f,$,b){if(!f)this._fs.readFile(l,{encoding:"utf8"},b);else{let L,e,m,E=2;const R=A=>{A?b(A):--E===0&&b(void 0,L,e,m)};this._fs.readFile(l,{encoding:"utf8"},(A,w)=>{L=w,R(A)}),this._fs.readFile(f,(A,w)=>{!A&&w&&w.length>0?(m=w.slice(0,16),e=w.slice(16),$.record(60,f)):$.record(61,f),R()})}}_verifyCachedData(l,f,$,b,L){b&&(l.cachedDataRejected||setTimeout(()=>{const e=this._crypto.createHash("md5").update(f,"utf8").digest();b.equals(e)||(L.getConfig().onError(new Error(`FAILED TO VERIFY CACHED DATA, deleting stale '${$}' now, but a RESTART IS REQUIRED`)),this._fs.unlink($,m=>{m&&L.getConfig().onError(m)}))},Math.ceil(5e3*(1+Math.random()))))}}g._BOM=65279,g._PREFIX="(function (require, define, __filename, __dirname) { ",g._SUFFIX=`
});`;function v(a,l){if(l.__$__isRecorded)return l;const f=function(b){a.record(33,b);try{return l(b)}finally{a.record(34,b)}};return f.__$__isRecorded=!0,f}q.ensureRecordedNodeRequire=v;function d(a){return new i(a)}q.createScriptLoader=d})(ve||(ve={}));var ve;(function(q){class i{constructor(a){let l=a.lastIndexOf("/");l!==-1?this.fromModulePath=a.substr(0,l+1):this.fromModulePath=""}static _normalizeModuleId(a){let l=a,f;for(f=/\/\.\//;f.test(l);)l=l.replace(f,"/");for(l=l.replace(/^\.\//g,""),f=/\/(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//;f.test(l);)l=l.replace(f,"/");return l=l.replace(/^(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//,""),l}resolveModule(a){let l=a;return q.Utilities.isAbsolutePath(l)||(q.Utilities.startsWith(l,"./")||q.Utilities.startsWith(l,"../"))&&(l=i._normalizeModuleId(this.fromModulePath+l)),l}}i.ROOT=new i(""),q.ModuleIdResolver=i;class t{constructor(a,l,f,$,b,L){this.id=a,this.strId=l,this.dependencies=f,this._callback=$,this._errorback=b,this.moduleIdResolver=L,this.exports={},this.error=null,this.exportsPassedIn=!1,this.unresolvedDependenciesCount=this.dependencies.length,this._isComplete=!1}static _safeInvokeFunction(a,l){try{return{returnedValue:a.apply(q.global,l),producedError:null}}catch(f){return{returnedValue:null,producedError:f}}}static _invokeFactory(a,l,f,$){return a.shouldInvokeFactory(l)?a.shouldCatchError()?this._safeInvokeFunction(f,$):{returnedValue:f.apply(q.global,$),producedError:null}:{returnedValue:null,producedError:null}}complete(a,l,f,$){this._isComplete=!0;let b=null;if(this._callback)if(typeof this._callback=="function"){a.record(21,this.strId);let L=t._invokeFactory(l,this.strId,this._callback,f);b=L.producedError,a.record(22,this.strId),!b&&typeof L.returnedValue<"u"&&(!this.exportsPassedIn||q.Utilities.isEmpty(this.exports))&&(this.exports=L.returnedValue)}else this.exports=this._callback;if(b){let L=q.ensureError(b);L.phase="factory",L.moduleId=this.strId,L.neededBy=$(this.id),this.error=L,l.onError(L)}this.dependencies=null,this._callback=null,this._errorback=null,this.moduleIdResolver=null}onDependencyError(a){return this._isComplete=!0,this.error=a,this._errorback?(this._errorback(a),!0):!1}isComplete(){return this._isComplete}}q.Module=t;class n{constructor(){this._nextId=0,this._strModuleIdToIntModuleId=new Map,this._intModuleIdToStrModuleId=[],this.getModuleId("exports"),this.getModuleId("module"),this.getModuleId("require")}getMaxModuleId(){return this._nextId}getModuleId(a){let l=this._strModuleIdToIntModuleId.get(a);return typeof l>"u"&&(l=this._nextId++,this._strModuleIdToIntModuleId.set(a,l),this._intModuleIdToStrModuleId[l]=a),l}getStrModuleId(a){return this._intModuleIdToStrModuleId[a]}}class p{constructor(a){this.id=a}}p.EXPORTS=new p(0),p.MODULE=new p(1),p.REQUIRE=new p(2),q.RegularDependency=p;class g{constructor(a,l,f){this.id=a,this.pluginId=l,this.pluginParam=f}}q.PluginDependency=g;class v{constructor(a,l,f,$,b=0){this._env=a,this._scriptLoader=l,this._loaderAvailableTimestamp=b,this._defineFunc=f,this._requireFunc=$,this._moduleIdProvider=new n,this._config=new q.Configuration(this._env),this._hasDependencyCycle=!1,this._modules2=[],this._knownModules2=[],this._inverseDependencies2=[],this._inversePluginDependencies2=new Map,this._currentAnonymousDefineCall=null,this._recorder=null,this._buildInfoPath=[],this._buildInfoDefineStack=[],this._buildInfoDependencies=[],this._requireFunc.moduleManager=this}reset(){return new v(this._env,this._scriptLoader,this._defineFunc,this._requireFunc,this._loaderAvailableTimestamp)}getGlobalAMDDefineFunc(){return this._defineFunc}getGlobalAMDRequireFunc(){return this._requireFunc}static _findRelevantLocationInStack(a,l){let f=L=>L.replace(/\\/g,"/"),$=f(a),b=l.split(/\n/);for(let L=0;L<b.length;L++){let e=b[L].match(/(.*):(\d+):(\d+)\)?$/);if(e){let m=e[1],E=e[2],R=e[3],A=Math.max(m.lastIndexOf(" ")+1,m.lastIndexOf("(")+1);if(m=m.substr(A),m=f(m),m===$){let w={line:parseInt(E,10),col:parseInt(R,10)};return w.line===1&&(w.col-=53),w}}}throw new Error("Could not correlate define call site for needle "+a)}getBuildInfo(){if(!this._config.isBuild())return null;let a=[],l=0;for(let f=0,$=this._modules2.length;f<$;f++){let b=this._modules2[f];if(!b)continue;let L=this._buildInfoPath[b.id]||null,e=this._buildInfoDefineStack[b.id]||null,m=this._buildInfoDependencies[b.id];a[l++]={id:b.strId,path:L,defineLocation:L&&e?v._findRelevantLocationInStack(L,e):null,dependencies:m,shim:null,exports:b.exports}}return a}getRecorder(){return this._recorder||(this._config.shouldRecordStats()?this._recorder=new q.LoaderEventRecorder(this._loaderAvailableTimestamp):this._recorder=q.NullLoaderEventRecorder.INSTANCE),this._recorder}getLoaderEvents(){return this.getRecorder().getEvents()}enqueueDefineAnonymousModule(a,l){if(this._currentAnonymousDefineCall!==null)throw new Error("Can only have one anonymous define call per script file");let f=null;this._config.isBuild()&&(f=new Error("StackLocation").stack||null),this._currentAnonymousDefineCall={stack:f,dependencies:a,callback:l}}defineModule(a,l,f,$,b,L=new i(a)){let e=this._moduleIdProvider.getModuleId(a);if(this._modules2[e]){this._config.isDuplicateMessageIgnoredFor(a)||console.warn("Duplicate definition of module '"+a+"'");return}let m=new t(e,a,this._normalizeDependencies(l,L),f,$,L);this._modules2[e]=m,this._config.isBuild()&&(this._buildInfoDefineStack[e]=b,this._buildInfoDependencies[e]=(m.dependencies||[]).map(E=>this._moduleIdProvider.getStrModuleId(E.id))),this._resolve(m)}_normalizeDependency(a,l){if(a==="exports")return p.EXPORTS;if(a==="module")return p.MODULE;if(a==="require")return p.REQUIRE;let f=a.indexOf("!");if(f>=0){let $=l.resolveModule(a.substr(0,f)),b=l.resolveModule(a.substr(f+1)),L=this._moduleIdProvider.getModuleId($+"!"+b),e=this._moduleIdProvider.getModuleId($);return new g(L,e,b)}return new p(this._moduleIdProvider.getModuleId(l.resolveModule(a)))}_normalizeDependencies(a,l){let f=[],$=0;for(let b=0,L=a.length;b<L;b++)f[$++]=this._normalizeDependency(a[b],l);return f}_relativeRequire(a,l,f,$){if(typeof l=="string")return this.synchronousRequire(l,a);this.defineModule(q.Utilities.generateAnonymousModule(),l,f,$,null,a)}synchronousRequire(a,l=new i(a)){let f=this._normalizeDependency(a,l),$=this._modules2[f.id];if(!$)throw new Error("Check dependency list! Synchronous require cannot resolve module '"+a+"'. This is the first mention of this module!");if(!$.isComplete())throw new Error("Check dependency list! Synchronous require cannot resolve module '"+a+"'. This module has not been resolved completely yet.");if($.error)throw $.error;return $.exports}configure(a,l){let f=this._config.shouldRecordStats();l?this._config=new q.Configuration(this._env,a):this._config=this._config.cloneAndMerge(a),this._config.shouldRecordStats()&&!f&&(this._recorder=null)}getConfig(){return this._config}_onLoad(a){if(this._currentAnonymousDefineCall!==null){let l=this._currentAnonymousDefineCall;this._currentAnonymousDefineCall=null,this.defineModule(this._moduleIdProvider.getStrModuleId(a),l.dependencies,l.callback,null,l.stack)}}_createLoadError(a,l){let f=this._moduleIdProvider.getStrModuleId(a),$=(this._inverseDependencies2[a]||[]).map(L=>this._moduleIdProvider.getStrModuleId(L));const b=q.ensureError(l);return b.phase="loading",b.moduleId=f,b.neededBy=$,b}_onLoadError(a,l){const f=this._createLoadError(a,l);this._modules2[a]||(this._modules2[a]=new t(a,this._moduleIdProvider.getStrModuleId(a),[],()=>{},null,null));let $=[];for(let e=0,m=this._moduleIdProvider.getMaxModuleId();e<m;e++)$[e]=!1;let b=!1,L=[];for(L.push(a),$[a]=!0;L.length>0;){let e=L.shift(),m=this._modules2[e];m&&(b=m.onDependencyError(f)||b);let E=this._inverseDependencies2[e];if(E)for(let R=0,A=E.length;R<A;R++){let w=E[R];$[w]||(L.push(w),$[w]=!0)}}b||this._config.onError(f)}_hasDependencyPath(a,l){let f=this._modules2[a];if(!f)return!1;let $=[];for(let L=0,e=this._moduleIdProvider.getMaxModuleId();L<e;L++)$[L]=!1;let b=[];for(b.push(f),$[a]=!0;b.length>0;){let e=b.shift().dependencies;if(e)for(let m=0,E=e.length;m<E;m++){let R=e[m];if(R.id===l)return!0;let A=this._modules2[R.id];A&&!$[R.id]&&($[R.id]=!0,b.push(A))}}return!1}_findCyclePath(a,l,f){if(a===l||f===50)return[a];let $=this._modules2[a];if(!$)return null;let b=$.dependencies;if(b)for(let L=0,e=b.length;L<e;L++){let m=this._findCyclePath(b[L].id,l,f+1);if(m!==null)return m.push(a),m}return null}_createRequire(a){let l=(f,$,b)=>this._relativeRequire(a,f,$,b);return l.toUrl=f=>this._config.requireToUrl(a.resolveModule(f)),l.getStats=()=>this.getLoaderEvents(),l.hasDependencyCycle=()=>this._hasDependencyCycle,l.config=(f,$=!1)=>{this.configure(f,$)},l.__$__nodeRequire=q.global.nodeRequire,l}_loadModule(a){if(this._modules2[a]||this._knownModules2[a])return;this._knownModules2[a]=!0;let l=this._moduleIdProvider.getStrModuleId(a),f=this._config.moduleIdToPaths(l),$=/^@[^\/]+\/[^\/]+$/;this._env.isNode&&(l.indexOf("/")===-1||$.test(l))&&f.push("node|"+l);let b=-1,L=e=>{if(b++,b>=f.length)this._onLoadError(a,e);else{let m=f[b],E=this.getRecorder();if(this._config.isBuild()&&m==="empty:"){this._buildInfoPath[a]=m,this.defineModule(this._moduleIdProvider.getStrModuleId(a),[],null,null,null),this._onLoad(a);return}E.record(10,m),this._scriptLoader.load(this,m,()=>{this._config.isBuild()&&(this._buildInfoPath[a]=m),E.record(11,m),this._onLoad(a)},R=>{E.record(12,m),L(R)})}};L(null)}_loadPluginDependency(a,l){if(this._modules2[l.id]||this._knownModules2[l.id])return;this._knownModules2[l.id]=!0;let f=$=>{this.defineModule(this._moduleIdProvider.getStrModuleId(l.id),[],$,null,null)};f.error=$=>{this._config.onError(this._createLoadError(l.id,$))},a.load(l.pluginParam,this._createRequire(i.ROOT),f,this._config.getOptionsLiteral())}_resolve(a){let l=a.dependencies;if(l)for(let f=0,$=l.length;f<$;f++){let b=l[f];if(b===p.EXPORTS){a.exportsPassedIn=!0,a.unresolvedDependenciesCount--;continue}if(b===p.MODULE){a.unresolvedDependenciesCount--;continue}if(b===p.REQUIRE){a.unresolvedDependenciesCount--;continue}let L=this._modules2[b.id];if(L&&L.isComplete()){if(L.error){a.onDependencyError(L.error);return}a.unresolvedDependenciesCount--;continue}if(this._hasDependencyPath(b.id,a.id)){this._hasDependencyCycle=!0,console.warn("There is a dependency cycle between '"+this._moduleIdProvider.getStrModuleId(b.id)+"' and '"+this._moduleIdProvider.getStrModuleId(a.id)+"'. The cyclic path follows:");let e=this._findCyclePath(b.id,a.id,0)||[];e.reverse(),e.push(b.id),console.warn(e.map(m=>this._moduleIdProvider.getStrModuleId(m)).join(` => 
`)),a.unresolvedDependenciesCount--;continue}if(this._inverseDependencies2[b.id]=this._inverseDependencies2[b.id]||[],this._inverseDependencies2[b.id].push(a.id),b instanceof g){let e=this._modules2[b.pluginId];if(e&&e.isComplete()){this._loadPluginDependency(e.exports,b);continue}let m=this._inversePluginDependencies2.get(b.pluginId);m||(m=[],this._inversePluginDependencies2.set(b.pluginId,m)),m.push(b),this._loadModule(b.pluginId);continue}this._loadModule(b.id)}a.unresolvedDependenciesCount===0&&this._onModuleComplete(a)}_onModuleComplete(a){let l=this.getRecorder();if(a.isComplete())return;let f=a.dependencies,$=[];if(f)for(let m=0,E=f.length;m<E;m++){let R=f[m];if(R===p.EXPORTS){$[m]=a.exports;continue}if(R===p.MODULE){$[m]={id:a.strId,config:()=>this._config.getConfigForModule(a.strId)};continue}if(R===p.REQUIRE){$[m]=this._createRequire(a.moduleIdResolver);continue}let A=this._modules2[R.id];if(A){$[m]=A.exports;continue}$[m]=null}const b=m=>(this._inverseDependencies2[m]||[]).map(E=>this._moduleIdProvider.getStrModuleId(E));a.complete(l,this._config,$,b);let L=this._inverseDependencies2[a.id];if(this._inverseDependencies2[a.id]=null,L)for(let m=0,E=L.length;m<E;m++){let R=L[m],A=this._modules2[R];A.unresolvedDependenciesCount--,A.unresolvedDependenciesCount===0&&this._onModuleComplete(A)}let e=this._inversePluginDependencies2.get(a.id);if(e){this._inversePluginDependencies2.delete(a.id);for(let m=0,E=e.length;m<E;m++)this._loadPluginDependency(a.exports,e[m])}}}q.ModuleManager=v})(ve||(ve={}));var ne,ve;(function(q){const i=new q.Environment;let t=null;const n=function(d,a,l){typeof d!="string"&&(l=a,a=d,d=null),(typeof a!="object"||!Array.isArray(a))&&(l=a,a=null),a||(a=["require","exports","module"]),d?t.defineModule(d,a,l,null,null):t.enqueueDefineAnonymousModule(a,l)};n.amd={jQuery:!0};const p=function(d,a=!1){t.configure(d,a)},g=function(){if(arguments.length===1){if(arguments[0]instanceof Object&&!Array.isArray(arguments[0])){p(arguments[0]);return}if(typeof arguments[0]=="string")return t.synchronousRequire(arguments[0])}if((arguments.length===2||arguments.length===3)&&Array.isArray(arguments[0])){t.defineModule(q.Utilities.generateAnonymousModule(),arguments[0],arguments[1],arguments[2],null);return}throw new Error("Unrecognized require call")};g.config=p,g.getConfig=function(){return t.getConfig().getOptionsLiteral()},g.reset=function(){t=t.reset()},g.getBuildInfo=function(){return t.getBuildInfo()},g.getStats=function(){return t.getLoaderEvents()},g.define=n;function v(){if(typeof q.global.require<"u"||typeof require<"u"){const d=q.global.require||require;if(typeof d=="function"&&typeof d.resolve=="function"){const a=q.ensureRecordedNodeRequire(t.getRecorder(),d);q.global.nodeRequire=a,g.nodeRequire=a,g.__$__nodeRequire=a}}i.isNode&&!i.isElectronRenderer&&!i.isElectronNodeIntegrationWebWorker?module.exports=g:(i.isElectronRenderer||(q.global.define=n),q.global.require=g)}q.init=v,(typeof q.global.define!="function"||!q.global.define.amd)&&(t=new q.ModuleManager(i,q.createScriptLoader(i),n,g,q.Utilities.getHighPerformanceTimestamp()),typeof q.global.require<"u"&&typeof q.global.require!="function"&&g.config(q.global.require),ne=function(){return n.apply(null,arguments)},ne.amd=n.amd,typeof doNotInitLoader>"u"&&v())})(ve||(ve={})),ne(ie[78],re([0,1]),function(q,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.load=t;function t(d,a,l,f){if(f=f||{},(f["vs/css"]||{}).disabled){l({});return}const b=a.toUrl(d+".css");n(d,b,()=>{l({})},L=>{typeof l.error=="function"&&l.error("Could not find "+b+".")})}function n(d,a,l,f){if(p(d,a)){l();return}g(d,a,l,f)}function p(d,a){const l=window.document.getElementsByTagName("link");for(let f=0,$=l.length;f<$;f++){const b=l[f].getAttribute("data-name"),L=l[f].getAttribute("href");if(b===d||L===a)return!0}return!1}function g(d,a,l,f){const $=document.createElement("link");$.setAttribute("rel","stylesheet"),$.setAttribute("type","text/css"),$.setAttribute("data-name",d),v(d,$,l,f),$.setAttribute("href",a),(window.document.head||window.document.getElementsByTagName("head")[0]).appendChild($)}function v(d,a,l,f){const $=()=>{a.removeEventListener("load",b),a.removeEventListener("error",L)},b=e=>{$(),l()},L=e=>{$(),f(e)};a.addEventListener("load",b),a.addEventListener("error",L)}}),ne("vs/nls",["require","exports"],function(q,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.localize=f,i.localize2=$,i.getConfiguredDefaultLocale=b,i.setPseudoTranslation=L,i.create=e,i.load=m;let t=typeof document<"u"&&document.location&&document.location.hash.indexOf("pseudo=true")>=0;const n="i-default";function p(E,R){let A;return R.length===0?A=E:A=E.replace(/\{(\d+)\}/g,(w,N)=>{const c=N[0],u=R[c];let s=w;return typeof u=="string"?s=u:(typeof u=="number"||typeof u=="boolean"||u===void 0||u===null)&&(s=String(u)),s}),t&&(A="\uFF3B"+A.replace(/[aouei]/g,"$&$&")+"\uFF3D"),A}function g(E,R){let A=E[R];return A||(A=E["*"],A)?A:null}function v(E){return E.charAt(E.length-1)==="/"?E:E+"/"}async function d(E,R,A){const w=v(E)+v(R)+"vscode/"+v(A),N=await fetch(w);if(N.ok)return await N.json();throw new Error(`${N.status} - ${N.statusText}`)}function a(E){return function(R,A){const w=Array.prototype.slice.call(arguments,2);return p(E[R],w)}}function l(E){return(R,A,...w)=>({value:p(E[R],w),original:p(A,w)})}function f(E,R,...A){return p(R,A)}function $(E,R,...A){const w=p(R,A);return{value:w,original:w}}function b(E){}function L(E){t=E}function e(E,R){return{localize:a(R[E]),localize2:l(R[E]),getConfiguredDefaultLocale:R.getConfiguredDefaultLocale??(A=>{})}}function m(E,R,A,w){const N=w["vs/nls"]??{};if(!E||E.length===0)return A({localize:f,localize2:$,getConfiguredDefaultLocale:()=>N.availableLanguages?.["*"]});const c=N.availableLanguages?g(N.availableLanguages,E):null,u=c===null||c===n;let s=".nls";u||(s=s+"."+c);const o=h=>{Array.isArray(h)?(h.localize=a(h),h.localize2=l(h)):(h.localize=a(h[E]),h.localize2=l(h[E])),h.getConfiguredDefaultLocale=()=>N.availableLanguages?.["*"],A(h)};typeof N.loadBundle=="function"?N.loadBundle(E,c,(h,T)=>{h?R([E+".nls"],o):o(T)}):N.translationServiceUrl&&!u?(async()=>{try{const h=await d(N.translationServiceUrl,c,E);return o(h)}catch(h){if(!c.includes("-"))return console.error(h),R([E+".nls"],o);try{const T=c.split("-")[0],_=await d(N.translationServiceUrl,T,E);return N.availableLanguages??={},N.availableLanguages["*"]=T,o(_)}catch(T){return console.error(T),R([E+".nls"],o)}}})():R([E+s],o,h=>{if(s===".nls"){console.error("Failed trying to load default language strings",h);return}console.error(`Failed to load message bundle for language ${c}. Falling back to the default language:`,h),R([E+".nls"],o)})}}),function(){const q=globalThis.MonacoEnvironment,i=q&&q.baseUrl?q.baseUrl:"../../../";function t(f,$){if(q?.createTrustedTypesPolicy)try{return q.createTrustedTypesPolicy(f,$)}catch(b){console.warn(b);return}try{return self.trustedTypes?.createPolicy(f,$)}catch(b){console.warn(b);return}}const n=t("amdLoader",{createScriptURL:f=>f,createScript:(f,...$)=>{const b=$.slice(0,-1).join(","),L=$.pop().toString();return`(function anonymous(${b}) { ${L}
})`}});function p(){try{return(n?globalThis.eval(n.createScript("","true")):new Function("true")).call(globalThis),!0}catch{return!1}}function g(){return new Promise((f,$)=>{if(typeof globalThis.define=="function"&&globalThis.define.amd)return f();const b=i+"vs/loader.js";if(!(/^((http:)|(https:)|(file:))/.test(b)&&b.substring(0,globalThis.origin.length)!==globalThis.origin)&&p()){fetch(b).then(e=>{if(e.status!==200)throw new Error(e.statusText);return e.text()}).then(e=>{e=`${e}
//# sourceURL=${b}`,(n?globalThis.eval(n.createScript("",e)):new Function(e)).call(globalThis),f()}).then(void 0,$);return}n?importScripts(n.createScriptURL(b)):importScripts(b),f()})}function v(){require.config({baseUrl:i,catchError:!0,trustedTypesPolicy:n,amdModulesPattern:/^vs\//})}function d(f){g().then(()=>{v(),require([f],function($){setTimeout(function(){const b=$.create((L,e)=>{globalThis.postMessage(L,e)},null);for(globalThis.onmessage=L=>b.onmessage(L.data,L.ports);l.length>0;){const L=l.shift();b.onmessage(L.data,L.ports)}},0)})})}typeof globalThis.define=="function"&&globalThis.define.amd&&v();let a=!0;const l=[];globalThis.onmessage=f=>{if(!a){l.push(f);return}a=!1,d(f.data)}}(),ne(ie[9],re([0,1]),function(q,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$mb=void 0,i.$fb=t,i.$gb=n,i.$hb=p,i.$ib=g,i.$jb=v,i.$kb=d,i.$lb=a,i.$nb=f,i.$ob=$,i.$pb=b,i.$qb=L,i.$rb=e;function t(m,E){const R=n(m,E);if(R!==-1)return m[R]}function n(m,E,R=m.length-1){for(let A=R;A>=0;A--){const w=m[A];if(E(w))return A}return-1}function p(m,E){const R=g(m,E);return R===-1?void 0:m[R]}function g(m,E,R=0,A=m.length){let w=R,N=A;for(;w<N;){const c=Math.floor((w+N)/2);E(m[c])?w=c+1:N=c}return w-1}function v(m,E){const R=d(m,E);return R===m.length?void 0:m[R]}function d(m,E,R=0,A=m.length){let w=R,N=A;for(;w<N;){const c=Math.floor((w+N)/2);E(m[c])?N=c:w=c+1}return w}function a(m,E,R=0,A=m.length){const w=d(m,E,R,A);return w===m.length?-1:w}class l{static{this.assertInvariants=!1}constructor(E){this.e=E,this.c=0}findLastMonotonous(E){if(l.assertInvariants){if(this.d){for(const A of this.e)if(this.d(A)&&!E(A))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=E}const R=g(this.e,E,this.c);return this.c=R+1,R===-1?void 0:this.e[R]}}i.$mb=l;function f(m,E){if(m.length===0)return;let R=m[0];for(let A=1;A<m.length;A++){const w=m[A];E(w,R)>0&&(R=w)}return R}function $(m,E){if(m.length===0)return;let R=m[0];for(let A=1;A<m.length;A++){const w=m[A];E(w,R)>=0&&(R=w)}return R}function b(m,E){return f(m,(R,A)=>-E(R,A))}function L(m,E){if(m.length===0)return-1;let R=0;for(let A=1;A<m.length;A++){const w=m[A];E(w,m[R])>0&&(R=A)}return R}function e(m,E){for(const R of m){const A=E(R);if(A!==void 0)return A}}}),ne(ie[3],re([0,1]),function(q,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.CharCode=void 0;var t;(function(n){n[n.Null=0]="Null",n[n.Backspace=8]="Backspace",n[n.Tab=9]="Tab",n[n.LineFeed=10]="LineFeed",n[n.CarriageReturn=13]="CarriageReturn",n[n.Space=32]="Space",n[n.ExclamationMark=33]="ExclamationMark",n[n.DoubleQuote=34]="DoubleQuote",n[n.Hash=35]="Hash",n[n.DollarSign=36]="DollarSign",n[n.PercentSign=37]="PercentSign",n[n.Ampersand=38]="Ampersand",n[n.SingleQuote=39]="SingleQuote",n[n.OpenParen=40]="OpenParen",n[n.CloseParen=41]="CloseParen",n[n.Asterisk=42]="Asterisk",n[n.Plus=43]="Plus",n[n.Comma=44]="Comma",n[n.Dash=45]="Dash",n[n.Period=46]="Period",n[n.Slash=47]="Slash",n[n.Digit0=48]="Digit0",n[n.Digit1=49]="Digit1",n[n.Digit2=50]="Digit2",n[n.Digit3=51]="Digit3",n[n.Digit4=52]="Digit4",n[n.Digit5=53]="Digit5",n[n.Digit6=54]="Digit6",n[n.Digit7=55]="Digit7",n[n.Digit8=56]="Digit8",n[n.Digit9=57]="Digit9",n[n.Colon=58]="Colon",n[n.Semicolon=59]="Semicolon",n[n.LessThan=60]="LessThan",n[n.Equals=61]="Equals",n[n.GreaterThan=62]="GreaterThan",n[n.QuestionMark=63]="QuestionMark",n[n.AtSign=64]="AtSign",n[n.A=65]="A",n[n.B=66]="B",n[n.C=67]="C",n[n.D=68]="D",n[n.E=69]="E",n[n.F=70]="F",n[n.G=71]="G",n[n.H=72]="H",n[n.I=73]="I",n[n.J=74]="J",n[n.K=75]="K",n[n.L=76]="L",n[n.M=77]="M",n[n.N=78]="N",n[n.O=79]="O",n[n.P=80]="P",n[n.Q=81]="Q",n[n.R=82]="R",n[n.S=83]="S",n[n.T=84]="T",n[n.U=85]="U",n[n.V=86]="V",n[n.W=87]="W",n[n.X=88]="X",n[n.Y=89]="Y",n[n.Z=90]="Z",n[n.OpenSquareBracket=91]="OpenSquareBracket",n[n.Backslash=92]="Backslash",n[n.CloseSquareBracket=93]="CloseSquareBracket",n[n.Caret=94]="Caret",n[n.Underline=95]="Underline",n[n.BackTick=96]="BackTick",n[n.a=97]="a",n[n.b=98]="b",n[n.c=99]="c",n[n.d=100]="d",n[n.e=101]="e",n[n.f=102]="f",n[n.g=103]="g",n[n.h=104]="h",n[n.i=105]="i",n[n.j=106]="j",n[n.k=107]="k",n[n.l=108]="l",n[n.m=109]="m",n[n.n=110]="n",n[n.o=111]="o",n[n.p=112]="p",n[n.q=113]="q",n[n.r=114]="r",n[n.s=115]="s",n[n.t=116]="t",n[n.u=117]="u",n[n.v=118]="v",n[n.w=119]="w",n[n.x=120]="x",n[n.y=121]="y",n[n.z=122]="z",n[n.OpenCurlyBrace=123]="OpenCurlyBrace",n[n.Pipe=124]="Pipe",n[n.CloseCurlyBrace=125]="CloseCurlyBrace",n[n.Tilde=126]="Tilde",n[n.NoBreakSpace=160]="NoBreakSpace",n[n.U_Combining_Grave_Accent=768]="U_Combining_Grave_Accent",n[n.U_Combining_Acute_Accent=769]="U_Combining_Acute_Accent",n[n.U_Combining_Circumflex_Accent=770]="U_Combining_Circumflex_Accent",n[n.U_Combining_Tilde=771]="U_Combining_Tilde",n[n.U_Combining_Macron=772]="U_Combining_Macron",n[n.U_Combining_Overline=773]="U_Combining_Overline",n[n.U_Combining_Breve=774]="U_Combining_Breve",n[n.U_Combining_Dot_Above=775]="U_Combining_Dot_Above",n[n.U_Combining_Diaeresis=776]="U_Combining_Diaeresis",n[n.U_Combining_Hook_Above=777]="U_Combining_Hook_Above",n[n.U_Combining_Ring_Above=778]="U_Combining_Ring_Above",n[n.U_Combining_Double_Acute_Accent=779]="U_Combining_Double_Acute_Accent",n[n.U_Combining_Caron=780]="U_Combining_Caron",n[n.U_Combining_Vertical_Line_Above=781]="U_Combining_Vertical_Line_Above",n[n.U_Combining_Double_Vertical_Line_Above=782]="U_Combining_Double_Vertical_Line_Above",n[n.U_Combining_Double_Grave_Accent=783]="U_Combining_Double_Grave_Accent",n[n.U_Combining_Candrabindu=784]="U_Combining_Candrabindu",n[n.U_Combining_Inverted_Breve=785]="U_Combining_Inverted_Breve",n[n.U_Combining_Turned_Comma_Above=786]="U_Combining_Turned_Comma_Above",n[n.U_Combining_Comma_Above=787]="U_Combining_Comma_Above",n[n.U_Combining_Reversed_Comma_Above=788]="U_Combining_Reversed_Comma_Above",n[n.U_Combining_Comma_Above_Right=789]="U_Combining_Comma_Above_Right",n[n.U_Combining_Grave_Accent_Below=790]="U_Combining_Grave_Accent_Below",n[n.U_Combining_Acute_Accent_Below=791]="U_Combining_Acute_Accent_Below",n[n.U_Combining_Left_Tack_Below=792]="U_Combining_Left_Tack_Below",n[n.U_Combining_Right_Tack_Below=793]="U_Combining_Right_Tack_Below",n[n.U_Combining_Left_Angle_Above=794]="U_Combining_Left_Angle_Above",n[n.U_Combining_Horn=795]="U_Combining_Horn",n[n.U_Combining_Left_Half_Ring_Below=796]="U_Combining_Left_Half_Ring_Below",n[n.U_Combining_Up_Tack_Below=797]="U_Combining_Up_Tack_Below",n[n.U_Combining_Down_Tack_Below=798]="U_Combining_Down_Tack_Below",n[n.U_Combining_Plus_Sign_Below=799]="U_Combining_Plus_Sign_Below",n[n.U_Combining_Minus_Sign_Below=800]="U_Combining_Minus_Sign_Below",n[n.U_Combining_Palatalized_Hook_Below=801]="U_Combining_Palatalized_Hook_Below",n[n.U_Combining_Retroflex_Hook_Below=802]="U_Combining_Retroflex_Hook_Below",n[n.U_Combining_Dot_Below=803]="U_Combining_Dot_Below",n[n.U_Combining_Diaeresis_Below=804]="U_Combining_Diaeresis_Below",n[n.U_Combining_Ring_Below=805]="U_Combining_Ring_Below",n[n.U_Combining_Comma_Below=806]="U_Combining_Comma_Below",n[n.U_Combining_Cedilla=807]="U_Combining_Cedilla",n[n.U_Combining_Ogonek=808]="U_Combining_Ogonek",n[n.U_Combining_Vertical_Line_Below=809]="U_Combining_Vertical_Line_Below",n[n.U_Combining_Bridge_Below=810]="U_Combining_Bridge_Below",n[n.U_Combining_Inverted_Double_Arch_Below=811]="U_Combining_Inverted_Double_Arch_Below",n[n.U_Combining_Caron_Below=812]="U_Combining_Caron_Below",n[n.U_Combining_Circumflex_Accent_Below=813]="U_Combining_Circumflex_Accent_Below",n[n.U_Combining_Breve_Below=814]="U_Combining_Breve_Below",n[n.U_Combining_Inverted_Breve_Below=815]="U_Combining_Inverted_Breve_Below",n[n.U_Combining_Tilde_Below=816]="U_Combining_Tilde_Below",n[n.U_Combining_Macron_Below=817]="U_Combining_Macron_Below",n[n.U_Combining_Low_Line=818]="U_Combining_Low_Line",n[n.U_Combining_Double_Low_Line=819]="U_Combining_Double_Low_Line",n[n.U_Combining_Tilde_Overlay=820]="U_Combining_Tilde_Overlay",n[n.U_Combining_Short_Stroke_Overlay=821]="U_Combining_Short_Stroke_Overlay",n[n.U_Combining_Long_Stroke_Overlay=822]="U_Combining_Long_Stroke_Overlay",n[n.U_Combining_Short_Solidus_Overlay=823]="U_Combining_Short_Solidus_Overlay",n[n.U_Combining_Long_Solidus_Overlay=824]="U_Combining_Long_Solidus_Overlay",n[n.U_Combining_Right_Half_Ring_Below=825]="U_Combining_Right_Half_Ring_Below",n[n.U_Combining_Inverted_Bridge_Below=826]="U_Combining_Inverted_Bridge_Below",n[n.U_Combining_Square_Below=827]="U_Combining_Square_Below",n[n.U_Combining_Seagull_Below=828]="U_Combining_Seagull_Below",n[n.U_Combining_X_Above=829]="U_Combining_X_Above",n[n.U_Combining_Vertical_Tilde=830]="U_Combining_Vertical_Tilde",n[n.U_Combining_Double_Overline=831]="U_Combining_Double_Overline",n[n.U_Combining_Grave_Tone_Mark=832]="U_Combining_Grave_Tone_Mark",n[n.U_Combining_Acute_Tone_Mark=833]="U_Combining_Acute_Tone_Mark",n[n.U_Combining_Greek_Perispomeni=834]="U_Combining_Greek_Perispomeni",n[n.U_Combining_Greek_Koronis=835]="U_Combining_Greek_Koronis",n[n.U_Combining_Greek_Dialytika_Tonos=836]="U_Combining_Greek_Dialytika_Tonos",n[n.U_Combining_Greek_Ypogegrammeni=837]="U_Combining_Greek_Ypogegrammeni",n[n.U_Combining_Bridge_Above=838]="U_Combining_Bridge_Above",n[n.U_Combining_Equals_Sign_Below=839]="U_Combining_Equals_Sign_Below",n[n.U_Combining_Double_Vertical_Line_Below=840]="U_Combining_Double_Vertical_Line_Below",n[n.U_Combining_Left_Angle_Below=841]="U_Combining_Left_Angle_Below",n[n.U_Combining_Not_Tilde_Above=842]="U_Combining_Not_Tilde_Above",n[n.U_Combining_Homothetic_Above=843]="U_Combining_Homothetic_Above",n[n.U_Combining_Almost_Equal_To_Above=844]="U_Combining_Almost_Equal_To_Above",n[n.U_Combining_Left_Right_Arrow_Below=845]="U_Combining_Left_Right_Arrow_Below",n[n.U_Combining_Upwards_Arrow_Below=846]="U_Combining_Upwards_Arrow_Below",n[n.U_Combining_Grapheme_Joiner=847]="U_Combining_Grapheme_Joiner",n[n.U_Combining_Right_Arrowhead_Above=848]="U_Combining_Right_Arrowhead_Above",n[n.U_Combining_Left_Half_Ring_Above=849]="U_Combining_Left_Half_Ring_Above",n[n.U_Combining_Fermata=850]="U_Combining_Fermata",n[n.U_Combining_X_Below=851]="U_Combining_X_Below",n[n.U_Combining_Left_Arrowhead_Below=852]="U_Combining_Left_Arrowhead_Below",n[n.U_Combining_Right_Arrowhead_Below=853]="U_Combining_Right_Arrowhead_Below",n[n.U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below=854]="U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below",n[n.U_Combining_Right_Half_Ring_Above=855]="U_Combining_Right_Half_Ring_Above",n[n.U_Combining_Dot_Above_Right=856]="U_Combining_Dot_Above_Right",n[n.U_Combining_Asterisk_Below=857]="U_Combining_Asterisk_Below",n[n.U_Combining_Double_Ring_Below=858]="U_Combining_Double_Ring_Below",n[n.U_Combining_Zigzag_Above=859]="U_Combining_Zigzag_Above",n[n.U_Combining_Double_Breve_Below=860]="U_Combining_Double_Breve_Below",n[n.U_Combining_Double_Breve=861]="U_Combining_Double_Breve",n[n.U_Combining_Double_Macron=862]="U_Combining_Double_Macron",n[n.U_Combining_Double_Macron_Below=863]="U_Combining_Double_Macron_Below",n[n.U_Combining_Double_Tilde=864]="U_Combining_Double_Tilde",n[n.U_Combining_Double_Inverted_Breve=865]="U_Combining_Double_Inverted_Breve",n[n.U_Combining_Double_Rightwards_Arrow_Below=866]="U_Combining_Double_Rightwards_Arrow_Below",n[n.U_Combining_Latin_Small_Letter_A=867]="U_Combining_Latin_Small_Letter_A",n[n.U_Combining_Latin_Small_Letter_E=868]="U_Combining_Latin_Small_Letter_E",n[n.U_Combining_Latin_Small_Letter_I=869]="U_Combining_Latin_Small_Letter_I",n[n.U_Combining_Latin_Small_Letter_O=870]="U_Combining_Latin_Small_Letter_O",n[n.U_Combining_Latin_Small_Letter_U=871]="U_Combining_Latin_Small_Letter_U",n[n.U_Combining_Latin_Small_Letter_C=872]="U_Combining_Latin_Small_Letter_C",n[n.U_Combining_Latin_Small_Letter_D=873]="U_Combining_Latin_Small_Letter_D",n[n.U_Combining_Latin_Small_Letter_H=874]="U_Combining_Latin_Small_Letter_H",n[n.U_Combining_Latin_Small_Letter_M=875]="U_Combining_Latin_Small_Letter_M",n[n.U_Combining_Latin_Small_Letter_R=876]="U_Combining_Latin_Small_Letter_R",n[n.U_Combining_Latin_Small_Letter_T=877]="U_Combining_Latin_Small_Letter_T",n[n.U_Combining_Latin_Small_Letter_V=878]="U_Combining_Latin_Small_Letter_V",n[n.U_Combining_Latin_Small_Letter_X=879]="U_Combining_Latin_Small_Letter_X",n[n.LINE_SEPARATOR=8232]="LINE_SEPARATOR",n[n.PARAGRAPH_SEPARATOR=8233]="PARAGRAPH_SEPARATOR",n[n.NEXT_LINE=133]="NEXT_LINE",n[n.U_CIRCUMFLEX=94]="U_CIRCUMFLEX",n[n.U_GRAVE_ACCENT=96]="U_GRAVE_ACCENT",n[n.U_DIAERESIS=168]="U_DIAERESIS",n[n.U_MACRON=175]="U_MACRON",n[n.U_ACUTE_ACCENT=180]="U_ACUTE_ACCENT",n[n.U_CEDILLA=184]="U_CEDILLA",n[n.U_MODIFIER_LETTER_LEFT_ARROWHEAD=706]="U_MODIFIER_LETTER_LEFT_ARROWHEAD",n[n.U_MODIFIER_LETTER_RIGHT_ARROWHEAD=707]="U_MODIFIER_LETTER_RIGHT_ARROWHEAD",n[n.U_MODIFIER_LETTER_UP_ARROWHEAD=708]="U_MODIFIER_LETTER_UP_ARROWHEAD",n[n.U_MODIFIER_LETTER_DOWN_ARROWHEAD=709]="U_MODIFIER_LETTER_DOWN_ARROWHEAD",n[n.U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING=722]="U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING",n[n.U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING=723]="U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING",n[n.U_MODIFIER_LETTER_UP_TACK=724]="U_MODIFIER_LETTER_UP_TACK",n[n.U_MODIFIER_LETTER_DOWN_TACK=725]="U_MODIFIER_LETTER_DOWN_TACK",n[n.U_MODIFIER_LETTER_PLUS_SIGN=726]="U_MODIFIER_LETTER_PLUS_SIGN",n[n.U_MODIFIER_LETTER_MINUS_SIGN=727]="U_MODIFIER_LETTER_MINUS_SIGN",n[n.U_BREVE=728]="U_BREVE",n[n.U_DOT_ABOVE=729]="U_DOT_ABOVE",n[n.U_RING_ABOVE=730]="U_RING_ABOVE",n[n.U_OGONEK=731]="U_OGONEK",n[n.U_SMALL_TILDE=732]="U_SMALL_TILDE",n[n.U_DOUBLE_ACUTE_ACCENT=733]="U_DOUBLE_ACUTE_ACCENT",n[n.U_MODIFIER_LETTER_RHOTIC_HOOK=734]="U_MODIFIER_LETTER_RHOTIC_HOOK",n[n.U_MODIFIER_LETTER_CROSS_ACCENT=735]="U_MODIFIER_LETTER_CROSS_ACCENT",n[n.U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR=741]="U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR",n[n.U_MODIFIER_LETTER_HIGH_TONE_BAR=742]="U_MODIFIER_LETTER_HIGH_TONE_BAR",n[n.U_MODIFIER_LETTER_MID_TONE_BAR=743]="U_MODIFIER_LETTER_MID_TONE_BAR",n[n.U_MODIFIER_LETTER_LOW_TONE_BAR=744]="U_MODIFIER_LETTER_LOW_TONE_BAR",n[n.U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR=745]="U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR",n[n.U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK=746]="U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK",n[n.U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK=747]="U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK",n[n.U_MODIFIER_LETTER_UNASPIRATED=749]="U_MODIFIER_LETTER_UNASPIRATED",n[n.U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD=751]="U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD",n[n.U_MODIFIER_LETTER_LOW_UP_ARROWHEAD=752]="U_MODIFIER_LETTER_LOW_UP_ARROWHEAD",n[n.U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD=753]="U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD",n[n.U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD=754]="U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD",n[n.U_MODIFIER_LETTER_LOW_RING=755]="U_MODIFIER_LETTER_LOW_RING",n[n.U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT=756]="U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT",n[n.U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT=757]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT",n[n.U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT=758]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT",n[n.U_MODIFIER_LETTER_LOW_TILDE=759]="U_MODIFIER_LETTER_LOW_TILDE",n[n.U_MODIFIER_LETTER_RAISED_COLON=760]="U_MODIFIER_LETTER_RAISED_COLON",n[n.U_MODIFIER_LETTER_BEGIN_HIGH_TONE=761]="U_MODIFIER_LETTER_BEGIN_HIGH_TONE",n[n.U_MODIFIER_LETTER_END_HIGH_TONE=762]="U_MODIFIER_LETTER_END_HIGH_TONE",n[n.U_MODIFIER_LETTER_BEGIN_LOW_TONE=763]="U_MODIFIER_LETTER_BEGIN_LOW_TONE",n[n.U_MODIFIER_LETTER_END_LOW_TONE=764]="U_MODIFIER_LETTER_END_LOW_TONE",n[n.U_MODIFIER_LETTER_SHELF=765]="U_MODIFIER_LETTER_SHELF",n[n.U_MODIFIER_LETTER_OPEN_SHELF=766]="U_MODIFIER_LETTER_OPEN_SHELF",n[n.U_MODIFIER_LETTER_LOW_LEFT_ARROW=767]="U_MODIFIER_LETTER_LOW_LEFT_ARROW",n[n.U_GREEK_LOWER_NUMERAL_SIGN=885]="U_GREEK_LOWER_NUMERAL_SIGN",n[n.U_GREEK_TONOS=900]="U_GREEK_TONOS",n[n.U_GREEK_DIALYTIKA_TONOS=901]="U_GREEK_DIALYTIKA_TONOS",n[n.U_GREEK_KORONIS=8125]="U_GREEK_KORONIS",n[n.U_GREEK_PSILI=8127]="U_GREEK_PSILI",n[n.U_GREEK_PERISPOMENI=8128]="U_GREEK_PERISPOMENI",n[n.U_GREEK_DIALYTIKA_AND_PERISPOMENI=8129]="U_GREEK_DIALYTIKA_AND_PERISPOMENI",n[n.U_GREEK_PSILI_AND_VARIA=8141]="U_GREEK_PSILI_AND_VARIA",n[n.U_GREEK_PSILI_AND_OXIA=8142]="U_GREEK_PSILI_AND_OXIA",n[n.U_GREEK_PSILI_AND_PERISPOMENI=8143]="U_GREEK_PSILI_AND_PERISPOMENI",n[n.U_GREEK_DASIA_AND_VARIA=8157]="U_GREEK_DASIA_AND_VARIA",n[n.U_GREEK_DASIA_AND_OXIA=8158]="U_GREEK_DASIA_AND_OXIA",n[n.U_GREEK_DASIA_AND_PERISPOMENI=8159]="U_GREEK_DASIA_AND_PERISPOMENI",n[n.U_GREEK_DIALYTIKA_AND_VARIA=8173]="U_GREEK_DIALYTIKA_AND_VARIA",n[n.U_GREEK_DIALYTIKA_AND_OXIA=8174]="U_GREEK_DIALYTIKA_AND_OXIA",n[n.U_GREEK_VARIA=8175]="U_GREEK_VARIA",n[n.U_GREEK_OXIA=8189]="U_GREEK_OXIA",n[n.U_GREEK_DASIA=8190]="U_GREEK_DASIA",n[n.U_IDEOGRAPHIC_FULL_STOP=12290]="U_IDEOGRAPHIC_FULL_STOP",n[n.U_LEFT_CORNER_BRACKET=12300]="U_LEFT_CORNER_BRACKET",n[n.U_RIGHT_CORNER_BRACKET=12301]="U_RIGHT_CORNER_BRACKET",n[n.U_LEFT_BLACK_LENTICULAR_BRACKET=12304]="U_LEFT_BLACK_LENTICULAR_BRACKET",n[n.U_RIGHT_BLACK_LENTICULAR_BRACKET=12305]="U_RIGHT_BLACK_LENTICULAR_BRACKET",n[n.U_OVERLINE=8254]="U_OVERLINE",n[n.UTF8_BOM=65279]="UTF8_BOM",n[n.U_FULLWIDTH_SEMICOLON=65307]="U_FULLWIDTH_SEMICOLON",n[n.U_FULLWIDTH_COMMA=65292]="U_FULLWIDTH_COMMA"})(t||(i.CharCode=t={}))}),ne(ie[37],re([0,1]),function(q,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$K=t,i.$L=n,i.$M=p,i.$N=g;function t(v,d){const a=Object.create(null);for(const l of v){const f=d(l);let $=a[f];$||($=a[f]=[]),$.push(l)}return a}function n(v,d){const a=[],l=[];for(const f of v)d.has(f)||a.push(f);for(const f of d)v.has(f)||l.push(f);return{removed:a,added:l}}function p(v,d){const a=[],l=[];for(const[f,$]of v)d.has(f)||a.push($);for(const[f,$]of d)v.has(f)||l.push($);return{removed:a,added:l}}function g(v,d){const a=new Set;for(const l of d)v.has(l)&&a.add(l);return a}}),ne(ie[38],re([0,1,3]),function(q,i,t){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$7s=i.$6s=i.$5s=i.$4s=void 0;function n(a,l){const f=Math.pow(10,l);return Math.round(a*f)/f}class p{constructor(l,f,$,b=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,l))|0,this.g=Math.min(255,Math.max(0,f))|0,this.b=Math.min(255,Math.max(0,$))|0,this.a=n(Math.max(Math.min(1,b),0),3)}static equals(l,f){return l.r===f.r&&l.g===f.g&&l.b===f.b&&l.a===f.a}}i.$4s=p;class g{constructor(l,f,$,b){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,l),0)|0,this.s=n(Math.max(Math.min(1,f),0),3),this.l=n(Math.max(Math.min(1,$),0),3),this.a=n(Math.max(Math.min(1,b),0),3)}static equals(l,f){return l.h===f.h&&l.s===f.s&&l.l===f.l&&l.a===f.a}static fromRGBA(l){const f=l.r/255,$=l.g/255,b=l.b/255,L=l.a,e=Math.max(f,$,b),m=Math.min(f,$,b);let E=0,R=0;const A=(m+e)/2,w=e-m;if(w>0){switch(R=Math.min(A<=.5?w/(2*A):w/(2-2*A),1),e){case f:E=($-b)/w+($<b?6:0);break;case $:E=(b-f)/w+2;break;case b:E=(f-$)/w+4;break}E*=60,E=Math.round(E)}return new g(E,R,A,L)}static i(l,f,$){return $<0&&($+=1),$>1&&($-=1),$<1/6?l+(f-l)*6*$:$<1/2?f:$<2/3?l+(f-l)*(2/3-$)*6:l}static toRGBA(l){const f=l.h/360,{s:$,l:b,a:L}=l;let e,m,E;if($===0)e=m=E=b;else{const R=b<.5?b*(1+$):b+$-b*$,A=2*b-R;e=g.i(A,R,f+1/3),m=g.i(A,R,f),E=g.i(A,R,f-1/3)}return new p(Math.round(e*255),Math.round(m*255),Math.round(E*255),L)}}i.$5s=g;class v{constructor(l,f,$,b){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,l),0)|0,this.s=n(Math.max(Math.min(1,f),0),3),this.v=n(Math.max(Math.min(1,$),0),3),this.a=n(Math.max(Math.min(1,b),0),3)}static equals(l,f){return l.h===f.h&&l.s===f.s&&l.v===f.v&&l.a===f.a}static fromRGBA(l){const f=l.r/255,$=l.g/255,b=l.b/255,L=Math.max(f,$,b),e=Math.min(f,$,b),m=L-e,E=L===0?0:m/L;let R;return m===0?R=0:L===f?R=(($-b)/m%6+6)%6:L===$?R=(b-f)/m+2:R=(f-$)/m+4,new v(Math.round(R*60),E,L,l.a)}static toRGBA(l){const{h:f,s:$,v:b,a:L}=l,e=b*$,m=e*(1-Math.abs(f/60%2-1)),E=b-e;let[R,A,w]=[0,0,0];return f<60?(R=e,A=m):f<120?(R=m,A=e):f<180?(A=e,w=m):f<240?(A=m,w=e):f<300?(R=m,w=e):f<=360&&(R=e,w=m),R=Math.round((R+E)*255),A=Math.round((A+E)*255),w=Math.round((w+E)*255),new p(R,A,w,L)}}i.$6s=v;class d{static fromHex(l){return d.Format.CSS.parseHex(l)||d.red}static equals(l,f){return!l&&!f?!0:!l||!f?!1:l.equals(f)}get hsla(){return this.i?this.i:g.fromRGBA(this.rgba)}get hsva(){return this.j?this.j:v.fromRGBA(this.rgba)}constructor(l){if(l)if(l instanceof p)this.rgba=l;else if(l instanceof g)this.i=l,this.rgba=g.toRGBA(l);else if(l instanceof v)this.j=l,this.rgba=v.toRGBA(l);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(l){return!!l&&p.equals(this.rgba,l.rgba)&&g.equals(this.hsla,l.hsla)&&v.equals(this.hsva,l.hsva)}getRelativeLuminance(){const l=d.k(this.rgba.r),f=d.k(this.rgba.g),$=d.k(this.rgba.b),b=.2126*l+.7152*f+.0722*$;return n(b,4)}static k(l){const f=l/255;return f<=.03928?f/12.92:Math.pow((f+.055)/1.055,2.4)}getContrastRatio(l){const f=this.getRelativeLuminance(),$=l.getRelativeLuminance();return f>$?(f+.05)/($+.05):($+.05)/(f+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(l){const f=this.getRelativeLuminance(),$=l.getRelativeLuminance();return f>$}isDarkerThan(l){const f=this.getRelativeLuminance(),$=l.getRelativeLuminance();return f<$}lighten(l){return new d(new g(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*l,this.hsla.a))}darken(l){return new d(new g(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*l,this.hsla.a))}transparent(l){const{r:f,g:$,b,a:L}=this.rgba;return new d(new p(f,$,b,L*l))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new d(new p(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(l){const f=l.rgba,$=this.rgba.a,b=f.a,L=$+b*(1-$);if(L<1e-6)return d.transparent;const e=this.rgba.r*$/L+f.r*b*(1-$)/L,m=this.rgba.g*$/L+f.g*b*(1-$)/L,E=this.rgba.b*$/L+f.b*b*(1-$)/L;return new d(new p(e,m,E,L))}makeOpaque(l){if(this.isOpaque()||l.rgba.a!==1)return this;const{r:f,g:$,b,a:L}=this.rgba;return new d(new p(l.rgba.r-L*(l.rgba.r-f),l.rgba.g-L*(l.rgba.g-$),l.rgba.b-L*(l.rgba.b-b),1))}flatten(...l){const f=l.reduceRight(($,b)=>d.o(b,$));return d.o(this,f)}static o(l,f){const $=1-l.rgba.a;return new d(new p($*f.rgba.r+l.rgba.a*l.rgba.r,$*f.rgba.g+l.rgba.a*l.rgba.g,$*f.rgba.b+l.rgba.a*l.rgba.b))}toString(){return this.u||(this.u=d.Format.CSS.format(this)),this.u}static getLighterColor(l,f,$){if(l.isLighterThan(f))return l;$=$||.5;const b=l.getRelativeLuminance(),L=f.getRelativeLuminance();return $=$*(L-b)/L,l.lighten($)}static getDarkerColor(l,f,$){if(l.isDarkerThan(f))return l;$=$||.5;const b=l.getRelativeLuminance(),L=f.getRelativeLuminance();return $=$*(b-L)/b,l.darken($)}static{this.white=new d(new p(255,255,255,1))}static{this.black=new d(new p(0,0,0,1))}static{this.red=new d(new p(255,0,0,1))}static{this.blue=new d(new p(0,0,255,1))}static{this.green=new d(new p(0,255,0,1))}static{this.cyan=new d(new p(0,255,255,1))}static{this.lightgrey=new d(new p(211,211,211,1))}static{this.transparent=new d(new p(0,0,0,0))}}i.$7s=d,function(a){let l;(function(f){let $;(function(b){function L(s){return s.rgba.a===1?`rgb(${s.rgba.r}, ${s.rgba.g}, ${s.rgba.b})`:a.Format.CSS.formatRGBA(s)}b.formatRGB=L;function e(s){return`rgba(${s.rgba.r}, ${s.rgba.g}, ${s.rgba.b}, ${+s.rgba.a.toFixed(2)})`}b.formatRGBA=e;function m(s){return s.hsla.a===1?`hsl(${s.hsla.h}, ${(s.hsla.s*100).toFixed(2)}%, ${(s.hsla.l*100).toFixed(2)}%)`:a.Format.CSS.formatHSLA(s)}b.formatHSL=m;function E(s){return`hsla(${s.hsla.h}, ${(s.hsla.s*100).toFixed(2)}%, ${(s.hsla.l*100).toFixed(2)}%, ${s.hsla.a.toFixed(2)})`}b.formatHSLA=E;function R(s){const o=s.toString(16);return o.length!==2?"0"+o:o}function A(s){return`#${R(s.rgba.r)}${R(s.rgba.g)}${R(s.rgba.b)}`}b.formatHex=A;function w(s,o=!1){return o&&s.rgba.a===1?a.Format.CSS.formatHex(s):`#${R(s.rgba.r)}${R(s.rgba.g)}${R(s.rgba.b)}${R(Math.round(s.rgba.a*255))}`}b.formatHexA=w;function N(s){return s.isOpaque()?a.Format.CSS.formatHex(s):a.Format.CSS.formatRGBA(s)}b.format=N;function c(s){const o=s.length;if(o===0||s.charCodeAt(0)!==t.CharCode.Hash)return null;if(o===7){const h=16*u(s.charCodeAt(1))+u(s.charCodeAt(2)),T=16*u(s.charCodeAt(3))+u(s.charCodeAt(4)),_=16*u(s.charCodeAt(5))+u(s.charCodeAt(6));return new a(new p(h,T,_,1))}if(o===9){const h=16*u(s.charCodeAt(1))+u(s.charCodeAt(2)),T=16*u(s.charCodeAt(3))+u(s.charCodeAt(4)),_=16*u(s.charCodeAt(5))+u(s.charCodeAt(6)),U=16*u(s.charCodeAt(7))+u(s.charCodeAt(8));return new a(new p(h,T,_,U/255))}if(o===4){const h=u(s.charCodeAt(1)),T=u(s.charCodeAt(2)),_=u(s.charCodeAt(3));return new a(new p(16*h+h,16*T+T,16*_+_))}if(o===5){const h=u(s.charCodeAt(1)),T=u(s.charCodeAt(2)),_=u(s.charCodeAt(3)),U=u(s.charCodeAt(4));return new a(new p(16*h+h,16*T+T,16*_+_,(16*U+U)/255))}return null}b.parseHex=c;function u(s){switch(s){case t.CharCode.Digit0:return 0;case t.CharCode.Digit1:return 1;case t.CharCode.Digit2:return 2;case t.CharCode.Digit3:return 3;case t.CharCode.Digit4:return 4;case t.CharCode.Digit5:return 5;case t.CharCode.Digit6:return 6;case t.CharCode.Digit7:return 7;case t.CharCode.Digit8:return 8;case t.CharCode.Digit9:return 9;case t.CharCode.a:return 10;case t.CharCode.A:return 10;case t.CharCode.b:return 11;case t.CharCode.B:return 11;case t.CharCode.c:return 12;case t.CharCode.C:return 12;case t.CharCode.d:return 13;case t.CharCode.D:return 13;case t.CharCode.e:return 14;case t.CharCode.E:return 14;case t.CharCode.f:return 15;case t.CharCode.F:return 15}return 0}})($=f.CSS||(f.CSS={}))})(l=a.Format||(a.Format={}))}(d||(i.$7s=d={}))}),ne(ie[39],re([0,1]),function(q,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$Rv=void 0;class t{constructor(p,g,v,d){this.originalStart=p,this.originalLength=g,this.modifiedStart=v,this.modifiedLength=d}getOriginalEnd(){return this.originalStart+this.originalLength}getModifiedEnd(){return this.modifiedStart+this.modifiedLength}}i.$Rv=t}),ne(ie[4],re([0,1]),function(q,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$cb=i.$bb=i.$ab=i.$_=i.$$=i.$9=i.$5=i.$X=i.$W=void 0,i.setUnexpectedErrorHandler=n,i.$Z=p,i.$1=g,i.$2=v,i.$3=d,i.$4=l,i.$6=$,i.$7=b,i.$8=L,i.$0=m;class t{constructor(){this.b=[],this.a=function(u){setTimeout(()=>{throw u.stack?w.isErrorNoTelemetry(u)?new w(u.message+`

`+u.stack):new Error(u.message+`

`+u.stack):u},0)}}addListener(u){return this.b.push(u),()=>{this.d(u)}}c(u){this.b.forEach(s=>{s(u)})}d(u){this.b.splice(this.b.indexOf(u),1)}setUnexpectedErrorHandler(u){this.a=u}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(u){this.a(u),this.c(u)}onUnexpectedExternalError(u){this.a(u)}}i.$W=t,i.$X=new t;function n(c){i.$X.setUnexpectedErrorHandler(c)}function p(c){if(!c||typeof c!="object")return!1;const u=c;return u.code==="EPIPE"&&u.syscall?.toUpperCase()==="WRITE"}function g(c){l(c)||i.$X.onUnexpectedError(c)}function v(c){l(c)||i.$X.onUnexpectedExternalError(c)}function d(c){if(c instanceof Error){const{name:u,message:s}=c,o=c.stacktrace||c.stack;return{$isError:!0,name:u,message:s,stack:o,noTelemetry:w.isErrorNoTelemetry(c)}}return c}const a="Canceled";function l(c){return c instanceof f?!0:c instanceof Error&&c.name===a&&c.message===a}class f extends Error{constructor(){super(a),this.name=this.message}}i.$5=f;function $(){const c=new Error(a);return c.name=c.message,c}function b(c){return c?new Error(`Illegal argument: ${c}`):new Error("Illegal argument")}function L(c){return c?new Error(`Illegal state: ${c}`):new Error("Illegal state")}class e extends TypeError{constructor(u){super(u?`${u} is read-only and cannot be changed`:"Cannot change read-only property")}}i.$9=e;function m(c){return c?c.message?c.message:c.stack?c.stack.split(`
`)[0]:String(c):"Error"}class E extends Error{constructor(u){super("NotImplemented"),u&&(this.message=u)}}i.$$=E;class R extends Error{constructor(u){super("NotSupported"),u&&(this.message=u)}}i.$_=R;class A extends Error{constructor(){super(...arguments),this.isExpected=!0}}i.$ab=A;class w extends Error{constructor(u){super(u),this.name="CodeExpectedError"}static fromError(u){if(u instanceof w)return u;const s=new w;return s.message=u.message,s.stack=u.stack,s}static isErrorNoTelemetry(u){return u.name==="CodeExpectedError"}}i.$bb=w;class N extends Error{constructor(u){super(u||"An unexpected bug occurred."),Object.setPrototypeOf(this,N.prototype)}}i.$cb=N}),ne(ie[7],re([0,1,4,9]),function(q,i,t,n){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$ac=i.$_b=i.$$b=i.$9b=i.$8b=i.CompareResult=void 0,i.$sb=p,i.$tb=g,i.$ub=v,i.$vb=d,i.$wb=a,i.$xb=l,i.$yb=f,i.$zb=$,i.$Ab=b,i.$Bb=L,i.$Cb=e,i.$Db=m,i.$Eb=E,i.top=R,i.$Gb=A,i.$Hb=N,i.$Ib=c,i.$Jb=u,i.$Kb=s,i.$Lb=o,i.$Mb=h,i.$Nb=T,i.$Ob=_,i.$Pb=U,i.$Qb=M,i.$Rb=D,i.$Sb=k,i.$Tb=P,i.$Ub=j,i.$Vb=B,i.$Wb=Z,i.$Xb=O,i.$Yb=S,i.$Zb=X,i.$1b=Y,i.$2b=H,i.$3b=Q,i.$4b=C,i.$5b=F,i.$6b=oe,i.$7b=we,i.$0b=ke;function p(x,W=0){return x[x.length-(1+W)]}function g(x){if(x.length===0)throw new Error("Invalid tail call");return[x.slice(0,x.length-1),x[x.length-1]]}function v(x,W,V=(J,ee)=>J===ee){if(x===W)return!0;if(!x||!W||x.length!==W.length)return!1;for(let J=0,ee=x.length;J<ee;J++)if(!V(x[J],W[J]))return!1;return!0}function d(x,W){const V=x.length-1;W<V&&(x[W]=x[V]),x.pop()}function a(x,W,V){return l(x.length,J=>V(x[J],W))}function l(x,W){let V=0,J=x-1;for(;V<=J;){const ee=(V+J)/2|0,he=W(ee);if(he<0)V=ee+1;else if(he>0)J=ee-1;else return ee}return-(V+1)}function f(x,W,V){if(x=x|0,x>=W.length)throw new TypeError("invalid index");const J=W[Math.floor(W.length*Math.random())],ee=[],he=[],de=[];for(const Le of W){const Ne=V(Le,J);Ne<0?ee.push(Le):Ne>0?he.push(Le):de.push(Le)}return x<ee.length?f(x,ee,V):x<ee.length+de.length?de[0]:f(x-(ee.length+de.length),he,V)}function $(x,W){const V=[];let J;for(const ee of x.slice(0).sort(W))!J||W(J[0],ee)!==0?(J=[ee],V.push(J)):J.push(ee);return V}function*b(x,W){let V,J;for(const ee of x)J!==void 0&&W(J,ee)?V.push(ee):(V&&(yield V),V=[ee]),J=ee;V&&(yield V)}function L(x,W){for(let V=0;V<=x.length;V++)W(V===0?void 0:x[V-1],V===x.length?void 0:x[V])}function e(x,W){for(let V=0;V<x.length;V++)W(V===0?void 0:x[V-1],x[V],V+1===x.length?void 0:x[V+1])}function m(x,W,V){const J=[];function ee(Le,Ne,_e){if(Ne===0&&_e.length===0)return;const se=J[J.length-1];se&&se.start+se.deleteCount===Le?(se.deleteCount+=Ne,se.toInsert.push(..._e)):J.push({start:Le,deleteCount:Ne,toInsert:_e})}let he=0,de=0;for(;;){if(he===x.length){ee(he,0,W.slice(de));break}if(de===W.length){ee(he,x.length-he,[]);break}const Le=x[he],Ne=W[de],_e=V(Le,Ne);_e===0?(he+=1,de+=1):_e<0?(ee(he,1,[]),he+=1):_e>0&&(ee(he,0,[Ne]),de+=1)}return J}function E(x,W,V){const J=m(x,W,V),ee=[],he=[];for(const de of J)ee.push(...x.slice(de.start,de.start+de.deleteCount)),he.push(...de.toInsert);return{removed:ee,added:he}}function R(x,W,V){if(V===0)return[];const J=x.slice(0,V).sort(W);return w(x,W,J,V,x.length),J}function A(x,W,V,J,ee){return V===0?Promise.resolve([]):new Promise((he,de)=>{(async()=>{const Le=x.length,Ne=x.slice(0,V).sort(W);for(let _e=V,se=Math.min(V+J,Le);_e<Le;_e=se,se=Math.min(se+J,Le)){if(_e>V&&await new Promise(te=>setTimeout(te)),ee&&ee.isCancellationRequested)throw new t.$5;w(x,W,Ne,_e,se)}return Ne})().then(he,de)})}function w(x,W,V,J,ee){for(const he=V.length;J<ee;J++){const de=x[J];if(W(de,V[he-1])<0){V.pop();const Le=(0,n.$kb)(V,Ne=>W(de,Ne)<0);V.splice(Le,0,de)}}}function N(x){return x.filter(W=>!!W)}function c(x){let W=0;for(let V=0;V<x.length;V++)x[V]&&(x[W]=x[V],W+=1);x.length=W}function u(x,W,V){x.splice(V,0,x.splice(W,1)[0])}function s(x){return!Array.isArray(x)||x.length===0}function o(x){return Array.isArray(x)&&x.length>0}function h(x,W=V=>V){const V=new Set;return x.filter(J=>{const ee=W(J);return V.has(ee)?!1:(V.add(ee),!0)})}function T(x){const W=new Set;return V=>{const J=x(V);return W.has(J)?!1:(W.add(J),!0)}}function _(x,W){return x.length>0?x[0]:W}function U(x,W){return x.length>0?x[x.length-1]:W}function M(x,W,V=(J,ee)=>J===ee){let J=0;for(let ee=0,he=Math.min(x.length,W.length);ee<he&&V(x[ee],W[ee]);ee++)J++;return J}function D(x,W){let V=typeof W=="number"?x:0;typeof W=="number"?V=x:(V=0,W=x);const J=[];if(V<=W)for(let ee=V;ee<W;ee++)J.push(ee);else for(let ee=V;ee>W;ee--)J.push(ee);return J}function k(x,W,V){return x.reduce((J,ee)=>(J[W(ee)]=V?V(ee):ee,J),Object.create(null))}function P(x,W){return x.push(W),()=>j(x,W)}function j(x,W){const V=x.indexOf(W);if(V>-1)return x.splice(V,1),W}function B(x,W,V){const J=x.slice(0,W),ee=x.slice(W);return J.concat(V,ee)}function Z(x,W){let V;if(typeof W=="number"){let J=W;V=()=>{const ee=Math.sin(J++)*179426549;return ee-Math.floor(ee)}}else V=Math.random;for(let J=x.length-1;J>0;J-=1){const ee=Math.floor(V()*(J+1)),he=x[J];x[J]=x[ee],x[ee]=he}}function O(x,W){const V=x.indexOf(W);V>-1&&(x.splice(V,1),x.unshift(W))}function S(x,W){const V=x.indexOf(W);V>-1&&(x.splice(V,1),x.push(W))}function X(x,W){for(const V of W)x.push(V)}function Y(x,W){return Array.isArray(x)?x.map(W):W(x)}function H(x){return Array.isArray(x)?x:[x]}function Q(x){return x[Math.floor(Math.random()*x.length)]}function C(x,W,V){const J=z(x,W),ee=x.length,he=V.length;x.length=ee+he;for(let de=ee-1;de>=J;de--)x[de+he]=x[de];for(let de=0;de<he;de++)x[de+J]=V[de]}function F(x,W,V,J){const ee=z(x,W);let he=x.splice(ee,V);return he===void 0&&(he=[]),C(x,ee,J),he}function z(x,W){return W<0?Math.max(W+x.length,0):Math.min(W,x.length)}var fe;(function(x){function W(he){return he<0}x.isLessThan=W;function V(he){return he<=0}x.isLessThanOrEqual=V;function J(he){return he>0}x.isGreaterThan=J;function ee(he){return he===0}x.isNeitherLessOrGreaterThan=ee,x.greaterThan=1,x.lessThan=-1,x.neitherLessOrGreaterThan=0})(fe||(i.CompareResult=fe={}));function oe(x,W){return(V,J)=>W(x(V),x(J))}function we(...x){return(W,V)=>{for(const J of x){const ee=J(W,V);if(!fe.isNeitherLessOrGreaterThan(ee))return ee}return fe.neitherLessOrGreaterThan}}const r=(x,W)=>x-W;i.$8b=r;const Te=(x,W)=>(0,i.$8b)(x?1:0,W?1:0);i.$9b=Te;function ke(x){return(W,V)=>-x(W,V)}class Ve{constructor(W){this.g=W,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(W){let V=this.c;for(;V<this.g.length&&W(this.g[V]);)V++;const J=V===this.c?null:this.g.slice(this.c,V);return this.c=V,J}takeFromEndWhile(W){let V=this.d;for(;V>=0&&W(this.g[V]);)V--;const J=V===this.d?null:this.g.slice(V+1,this.d+1);return this.d=V,J}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const W=this.g[this.c];return this.c++,W}removeLast(){const W=this.g[this.d];return this.d--,W}takeCount(W){const V=this.g.slice(this.c,this.c+W);return this.c+=W,V}}i.$$b=Ve;class Ue{static{this.empty=new Ue(W=>{})}constructor(W){this.iterate=W}forEach(W){this.iterate(V=>(W(V),!0))}toArray(){const W=[];return this.iterate(V=>(W.push(V),!0)),W}filter(W){return new Ue(V=>this.iterate(J=>W(J)?V(J):!0))}map(W){return new Ue(V=>this.iterate(J=>V(W(J))))}some(W){let V=!1;return this.iterate(J=>(V=W(J),!V)),V}findFirst(W){let V;return this.iterate(J=>W(J)?(V=J,!1):!0),V}findLast(W){let V;return this.iterate(J=>(W(J)&&(V=J),!0)),V}findLastMaxBy(W){let V,J=!0;return this.iterate(ee=>((J||fe.isGreaterThan(W(ee,V)))&&(J=!1,V=ee),!0)),V}}i.$_b=Ue;class Se{constructor(W){this.c=W}static createSortPermutation(W,V){const J=Array.from(W.keys()).sort((ee,he)=>V(W[ee],W[he]));return new Se(J)}apply(W){return W.map((V,J)=>W[this.c[J]])}inverse(){const W=this.c.slice();for(let V=0;V<this.c.length;V++)W[this.c[V]]=V;return new Se(W)}}i.$ac=Se}),ne(ie[11],re([0,1,4]),function(q,i,t){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ok=n,i.$ed=p,i.$fd=g,i.$gd=v,i.$hd=d,i.$id=a;function n(l,f){if(!l)throw new Error(f?`Assertion failed (${f})`:"Assertion Failed")}function p(l,f="Unreachable"){throw new Error(f)}function g(l,f="unexpected state"){if(!l)throw new t.$cb(`Assertion Failed: ${f}`)}function v(l){l||(0,t.$1)(new t.$cb("Soft Assertion Failed"))}function d(l){if(!l()){debugger;l(),(0,t.$1)(new t.$cb("Assertion Failed"))}}function a(l,f){let $=0;for(;$<l.length-1;){const b=l[$],L=l[$+1];if(!f(b,L))return!1;$++}return!0}}),ne(ie[22],re([0,1]),function(q,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$db=t;function t(n,p){const g=this;let v=!1,d;return function(){if(v)return d;if(v=!0,p)try{d=n.apply(g,arguments)}finally{p()}else d=n.apply(g,arguments);return d}}}),ne(ie[23],re([0,1]),function(q,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.Iterable=void 0;var t;(function(n){function p(u){return u&&typeof u=="object"&&typeof u[Symbol.iterator]=="function"}n.is=p;const g=Object.freeze([]);function v(){return g}n.empty=v;function*d(u){yield u}n.single=d;function a(u){return p(u)?u:d(u)}n.wrap=a;function l(u){return u||g}n.from=l;function*f(u){for(let s=u.length-1;s>=0;s--)yield u[s]}n.reverse=f;function $(u){return!u||u[Symbol.iterator]().next().done===!0}n.isEmpty=$;function b(u){return u[Symbol.iterator]().next().value}n.first=b;function L(u,s){for(const o of u)if(s(o))return!0;return!1}n.some=L;function e(u,s){for(const o of u)if(s(o))return o}n.find=e;function*m(u,s){for(const o of u)s(o)&&(yield o)}n.filter=m;function*E(u,s){let o=0;for(const h of u)yield s(h,o++)}n.map=E;function*R(...u){for(const s of u)yield*s}n.concat=R;function A(u,s,o){let h=o;for(const T of u)h=s(h,T);return h}n.reduce=A;function*w(u,s,o=u.length){for(s<0&&(s+=u.length),o<0?o+=u.length:o>u.length&&(o=u.length);s<o;s++)yield u[s]}n.slice=w;function N(u,s=Number.POSITIVE_INFINITY){const o=[];if(s===0)return[o,u];const h=u[Symbol.iterator]();for(let T=0;T<s;T++){const _=h.next();if(_.done)return[o,n.empty()];o.push(_.value)}return[o,{[Symbol.iterator](){return h}}]}n.consume=N;async function c(u){const s=[];for await(const o of u)s.push(o);return Promise.resolve(s)}n.asyncToArray=c})(t||(i.Iterable=t={}))}),ne(ie[40],re([0,1]),function(q,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.KeyMod=i.KeyCodeUtils=i.$Lr=i.$Kr=i.$Jr=i.$Ir=i.$Hr=i.ScanCode=i.KeyCode=void 0,i.$Mr=L;var t;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.Unknown=0]="Unknown",e[e.Backspace=1]="Backspace",e[e.Tab=2]="Tab",e[e.Enter=3]="Enter",e[e.Shift=4]="Shift",e[e.Ctrl=5]="Ctrl",e[e.Alt=6]="Alt",e[e.PauseBreak=7]="PauseBreak",e[e.CapsLock=8]="CapsLock",e[e.Escape=9]="Escape",e[e.Space=10]="Space",e[e.PageUp=11]="PageUp",e[e.PageDown=12]="PageDown",e[e.End=13]="End",e[e.Home=14]="Home",e[e.LeftArrow=15]="LeftArrow",e[e.UpArrow=16]="UpArrow",e[e.RightArrow=17]="RightArrow",e[e.DownArrow=18]="DownArrow",e[e.Insert=19]="Insert",e[e.Delete=20]="Delete",e[e.Digit0=21]="Digit0",e[e.Digit1=22]="Digit1",e[e.Digit2=23]="Digit2",e[e.Digit3=24]="Digit3",e[e.Digit4=25]="Digit4",e[e.Digit5=26]="Digit5",e[e.Digit6=27]="Digit6",e[e.Digit7=28]="Digit7",e[e.Digit8=29]="Digit8",e[e.Digit9=30]="Digit9",e[e.KeyA=31]="KeyA",e[e.KeyB=32]="KeyB",e[e.KeyC=33]="KeyC",e[e.KeyD=34]="KeyD",e[e.KeyE=35]="KeyE",e[e.KeyF=36]="KeyF",e[e.KeyG=37]="KeyG",e[e.KeyH=38]="KeyH",e[e.KeyI=39]="KeyI",e[e.KeyJ=40]="KeyJ",e[e.KeyK=41]="KeyK",e[e.KeyL=42]="KeyL",e[e.KeyM=43]="KeyM",e[e.KeyN=44]="KeyN",e[e.KeyO=45]="KeyO",e[e.KeyP=46]="KeyP",e[e.KeyQ=47]="KeyQ",e[e.KeyR=48]="KeyR",e[e.KeyS=49]="KeyS",e[e.KeyT=50]="KeyT",e[e.KeyU=51]="KeyU",e[e.KeyV=52]="KeyV",e[e.KeyW=53]="KeyW",e[e.KeyX=54]="KeyX",e[e.KeyY=55]="KeyY",e[e.KeyZ=56]="KeyZ",e[e.Meta=57]="Meta",e[e.ContextMenu=58]="ContextMenu",e[e.F1=59]="F1",e[e.F2=60]="F2",e[e.F3=61]="F3",e[e.F4=62]="F4",e[e.F5=63]="F5",e[e.F6=64]="F6",e[e.F7=65]="F7",e[e.F8=66]="F8",e[e.F9=67]="F9",e[e.F10=68]="F10",e[e.F11=69]="F11",e[e.F12=70]="F12",e[e.F13=71]="F13",e[e.F14=72]="F14",e[e.F15=73]="F15",e[e.F16=74]="F16",e[e.F17=75]="F17",e[e.F18=76]="F18",e[e.F19=77]="F19",e[e.F20=78]="F20",e[e.F21=79]="F21",e[e.F22=80]="F22",e[e.F23=81]="F23",e[e.F24=82]="F24",e[e.NumLock=83]="NumLock",e[e.ScrollLock=84]="ScrollLock",e[e.Semicolon=85]="Semicolon",e[e.Equal=86]="Equal",e[e.Comma=87]="Comma",e[e.Minus=88]="Minus",e[e.Period=89]="Period",e[e.Slash=90]="Slash",e[e.Backquote=91]="Backquote",e[e.BracketLeft=92]="BracketLeft",e[e.Backslash=93]="Backslash",e[e.BracketRight=94]="BracketRight",e[e.Quote=95]="Quote",e[e.OEM_8=96]="OEM_8",e[e.IntlBackslash=97]="IntlBackslash",e[e.Numpad0=98]="Numpad0",e[e.Numpad1=99]="Numpad1",e[e.Numpad2=100]="Numpad2",e[e.Numpad3=101]="Numpad3",e[e.Numpad4=102]="Numpad4",e[e.Numpad5=103]="Numpad5",e[e.Numpad6=104]="Numpad6",e[e.Numpad7=105]="Numpad7",e[e.Numpad8=106]="Numpad8",e[e.Numpad9=107]="Numpad9",e[e.NumpadMultiply=108]="NumpadMultiply",e[e.NumpadAdd=109]="NumpadAdd",e[e.NUMPAD_SEPARATOR=110]="NUMPAD_SEPARATOR",e[e.NumpadSubtract=111]="NumpadSubtract",e[e.NumpadDecimal=112]="NumpadDecimal",e[e.NumpadDivide=113]="NumpadDivide",e[e.KEY_IN_COMPOSITION=114]="KEY_IN_COMPOSITION",e[e.ABNT_C1=115]="ABNT_C1",e[e.ABNT_C2=116]="ABNT_C2",e[e.AudioVolumeMute=117]="AudioVolumeMute",e[e.AudioVolumeUp=118]="AudioVolumeUp",e[e.AudioVolumeDown=119]="AudioVolumeDown",e[e.BrowserSearch=120]="BrowserSearch",e[e.BrowserHome=121]="BrowserHome",e[e.BrowserBack=122]="BrowserBack",e[e.BrowserForward=123]="BrowserForward",e[e.MediaTrackNext=124]="MediaTrackNext",e[e.MediaTrackPrevious=125]="MediaTrackPrevious",e[e.MediaStop=126]="MediaStop",e[e.MediaPlayPause=127]="MediaPlayPause",e[e.LaunchMediaPlayer=128]="LaunchMediaPlayer",e[e.LaunchMail=129]="LaunchMail",e[e.LaunchApp2=130]="LaunchApp2",e[e.Clear=131]="Clear",e[e.MAX_VALUE=132]="MAX_VALUE"})(t||(i.KeyCode=t={}));var n;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.None=0]="None",e[e.Hyper=1]="Hyper",e[e.Super=2]="Super",e[e.Fn=3]="Fn",e[e.FnLock=4]="FnLock",e[e.Suspend=5]="Suspend",e[e.Resume=6]="Resume",e[e.Turbo=7]="Turbo",e[e.Sleep=8]="Sleep",e[e.WakeUp=9]="WakeUp",e[e.KeyA=10]="KeyA",e[e.KeyB=11]="KeyB",e[e.KeyC=12]="KeyC",e[e.KeyD=13]="KeyD",e[e.KeyE=14]="KeyE",e[e.KeyF=15]="KeyF",e[e.KeyG=16]="KeyG",e[e.KeyH=17]="KeyH",e[e.KeyI=18]="KeyI",e[e.KeyJ=19]="KeyJ",e[e.KeyK=20]="KeyK",e[e.KeyL=21]="KeyL",e[e.KeyM=22]="KeyM",e[e.KeyN=23]="KeyN",e[e.KeyO=24]="KeyO",e[e.KeyP=25]="KeyP",e[e.KeyQ=26]="KeyQ",e[e.KeyR=27]="KeyR",e[e.KeyS=28]="KeyS",e[e.KeyT=29]="KeyT",e[e.KeyU=30]="KeyU",e[e.KeyV=31]="KeyV",e[e.KeyW=32]="KeyW",e[e.KeyX=33]="KeyX",e[e.KeyY=34]="KeyY",e[e.KeyZ=35]="KeyZ",e[e.Digit1=36]="Digit1",e[e.Digit2=37]="Digit2",e[e.Digit3=38]="Digit3",e[e.Digit4=39]="Digit4",e[e.Digit5=40]="Digit5",e[e.Digit6=41]="Digit6",e[e.Digit7=42]="Digit7",e[e.Digit8=43]="Digit8",e[e.Digit9=44]="Digit9",e[e.Digit0=45]="Digit0",e[e.Enter=46]="Enter",e[e.Escape=47]="Escape",e[e.Backspace=48]="Backspace",e[e.Tab=49]="Tab",e[e.Space=50]="Space",e[e.Minus=51]="Minus",e[e.Equal=52]="Equal",e[e.BracketLeft=53]="BracketLeft",e[e.BracketRight=54]="BracketRight",e[e.Backslash=55]="Backslash",e[e.IntlHash=56]="IntlHash",e[e.Semicolon=57]="Semicolon",e[e.Quote=58]="Quote",e[e.Backquote=59]="Backquote",e[e.Comma=60]="Comma",e[e.Period=61]="Period",e[e.Slash=62]="Slash",e[e.CapsLock=63]="CapsLock",e[e.F1=64]="F1",e[e.F2=65]="F2",e[e.F3=66]="F3",e[e.F4=67]="F4",e[e.F5=68]="F5",e[e.F6=69]="F6",e[e.F7=70]="F7",e[e.F8=71]="F8",e[e.F9=72]="F9",e[e.F10=73]="F10",e[e.F11=74]="F11",e[e.F12=75]="F12",e[e.PrintScreen=76]="PrintScreen",e[e.ScrollLock=77]="ScrollLock",e[e.Pause=78]="Pause",e[e.Insert=79]="Insert",e[e.Home=80]="Home",e[e.PageUp=81]="PageUp",e[e.Delete=82]="Delete",e[e.End=83]="End",e[e.PageDown=84]="PageDown",e[e.ArrowRight=85]="ArrowRight",e[e.ArrowLeft=86]="ArrowLeft",e[e.ArrowDown=87]="ArrowDown",e[e.ArrowUp=88]="ArrowUp",e[e.NumLock=89]="NumLock",e[e.NumpadDivide=90]="NumpadDivide",e[e.NumpadMultiply=91]="NumpadMultiply",e[e.NumpadSubtract=92]="NumpadSubtract",e[e.NumpadAdd=93]="NumpadAdd",e[e.NumpadEnter=94]="NumpadEnter",e[e.Numpad1=95]="Numpad1",e[e.Numpad2=96]="Numpad2",e[e.Numpad3=97]="Numpad3",e[e.Numpad4=98]="Numpad4",e[e.Numpad5=99]="Numpad5",e[e.Numpad6=100]="Numpad6",e[e.Numpad7=101]="Numpad7",e[e.Numpad8=102]="Numpad8",e[e.Numpad9=103]="Numpad9",e[e.Numpad0=104]="Numpad0",e[e.NumpadDecimal=105]="NumpadDecimal",e[e.IntlBackslash=106]="IntlBackslash",e[e.ContextMenu=107]="ContextMenu",e[e.Power=108]="Power",e[e.NumpadEqual=109]="NumpadEqual",e[e.F13=110]="F13",e[e.F14=111]="F14",e[e.F15=112]="F15",e[e.F16=113]="F16",e[e.F17=114]="F17",e[e.F18=115]="F18",e[e.F19=116]="F19",e[e.F20=117]="F20",e[e.F21=118]="F21",e[e.F22=119]="F22",e[e.F23=120]="F23",e[e.F24=121]="F24",e[e.Open=122]="Open",e[e.Help=123]="Help",e[e.Select=124]="Select",e[e.Again=125]="Again",e[e.Undo=126]="Undo",e[e.Cut=127]="Cut",e[e.Copy=128]="Copy",e[e.Paste=129]="Paste",e[e.Find=130]="Find",e[e.AudioVolumeMute=131]="AudioVolumeMute",e[e.AudioVolumeUp=132]="AudioVolumeUp",e[e.AudioVolumeDown=133]="AudioVolumeDown",e[e.NumpadComma=134]="NumpadComma",e[e.IntlRo=135]="IntlRo",e[e.KanaMode=136]="KanaMode",e[e.IntlYen=137]="IntlYen",e[e.Convert=138]="Convert",e[e.NonConvert=139]="NonConvert",e[e.Lang1=140]="Lang1",e[e.Lang2=141]="Lang2",e[e.Lang3=142]="Lang3",e[e.Lang4=143]="Lang4",e[e.Lang5=144]="Lang5",e[e.Abort=145]="Abort",e[e.Props=146]="Props",e[e.NumpadParenLeft=147]="NumpadParenLeft",e[e.NumpadParenRight=148]="NumpadParenRight",e[e.NumpadBackspace=149]="NumpadBackspace",e[e.NumpadMemoryStore=150]="NumpadMemoryStore",e[e.NumpadMemoryRecall=151]="NumpadMemoryRecall",e[e.NumpadMemoryClear=152]="NumpadMemoryClear",e[e.NumpadMemoryAdd=153]="NumpadMemoryAdd",e[e.NumpadMemorySubtract=154]="NumpadMemorySubtract",e[e.NumpadClear=155]="NumpadClear",e[e.NumpadClearEntry=156]="NumpadClearEntry",e[e.ControlLeft=157]="ControlLeft",e[e.ShiftLeft=158]="ShiftLeft",e[e.AltLeft=159]="AltLeft",e[e.MetaLeft=160]="MetaLeft",e[e.ControlRight=161]="ControlRight",e[e.ShiftRight=162]="ShiftRight",e[e.AltRight=163]="AltRight",e[e.MetaRight=164]="MetaRight",e[e.BrightnessUp=165]="BrightnessUp",e[e.BrightnessDown=166]="BrightnessDown",e[e.MediaPlay=167]="MediaPlay",e[e.MediaRecord=168]="MediaRecord",e[e.MediaFastForward=169]="MediaFastForward",e[e.MediaRewind=170]="MediaRewind",e[e.MediaTrackNext=171]="MediaTrackNext",e[e.MediaTrackPrevious=172]="MediaTrackPrevious",e[e.MediaStop=173]="MediaStop",e[e.Eject=174]="Eject",e[e.MediaPlayPause=175]="MediaPlayPause",e[e.MediaSelect=176]="MediaSelect",e[e.LaunchMail=177]="LaunchMail",e[e.LaunchApp2=178]="LaunchApp2",e[e.LaunchApp1=179]="LaunchApp1",e[e.SelectTask=180]="SelectTask",e[e.LaunchScreenSaver=181]="LaunchScreenSaver",e[e.BrowserSearch=182]="BrowserSearch",e[e.BrowserHome=183]="BrowserHome",e[e.BrowserBack=184]="BrowserBack",e[e.BrowserForward=185]="BrowserForward",e[e.BrowserStop=186]="BrowserStop",e[e.BrowserRefresh=187]="BrowserRefresh",e[e.BrowserFavorites=188]="BrowserFavorites",e[e.ZoomToggle=189]="ZoomToggle",e[e.MailReply=190]="MailReply",e[e.MailForward=191]="MailForward",e[e.MailSend=192]="MailSend",e[e.MAX_VALUE=193]="MAX_VALUE"})(n||(i.ScanCode=n={}));class p{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(m,E){this._keyCodeToStr[m]=E,this._strToKeyCode[E.toLowerCase()]=m}keyCodeToStr(m){return this._keyCodeToStr[m]}strToKeyCode(m){return this._strToKeyCode[m.toLowerCase()]||t.Unknown}}const g=new p,v=new p,d=new p;i.$Hr=new Array(230),i.$Ir={};const a=[],l=Object.create(null),f=Object.create(null);i.$Jr={lowerCaseToEnum:e=>f[e]||n.None,toEnum:e=>l[e]||n.None,toString:e=>a[e]||"None"},i.$Kr=[],i.$Lr=[];for(let e=0;e<=n.MAX_VALUE;e++)i.$Kr[e]=t.DependsOnKbLayout;for(let e=0;e<=t.MAX_VALUE;e++)i.$Lr[e]=n.DependsOnKbLayout;(function(){const e="",m=[[1,n.None,"None",t.Unknown,"unknown",0,"VK_UNKNOWN",e,e],[1,n.Hyper,"Hyper",t.Unknown,e,0,e,e,e],[1,n.Super,"Super",t.Unknown,e,0,e,e,e],[1,n.Fn,"Fn",t.Unknown,e,0,e,e,e],[1,n.FnLock,"FnLock",t.Unknown,e,0,e,e,e],[1,n.Suspend,"Suspend",t.Unknown,e,0,e,e,e],[1,n.Resume,"Resume",t.Unknown,e,0,e,e,e],[1,n.Turbo,"Turbo",t.Unknown,e,0,e,e,e],[1,n.Sleep,"Sleep",t.Unknown,e,0,"VK_SLEEP",e,e],[1,n.WakeUp,"WakeUp",t.Unknown,e,0,e,e,e],[0,n.KeyA,"KeyA",t.KeyA,"A",65,"VK_A",e,e],[0,n.KeyB,"KeyB",t.KeyB,"B",66,"VK_B",e,e],[0,n.KeyC,"KeyC",t.KeyC,"C",67,"VK_C",e,e],[0,n.KeyD,"KeyD",t.KeyD,"D",68,"VK_D",e,e],[0,n.KeyE,"KeyE",t.KeyE,"E",69,"VK_E",e,e],[0,n.KeyF,"KeyF",t.KeyF,"F",70,"VK_F",e,e],[0,n.KeyG,"KeyG",t.KeyG,"G",71,"VK_G",e,e],[0,n.KeyH,"KeyH",t.KeyH,"H",72,"VK_H",e,e],[0,n.KeyI,"KeyI",t.KeyI,"I",73,"VK_I",e,e],[0,n.KeyJ,"KeyJ",t.KeyJ,"J",74,"VK_J",e,e],[0,n.KeyK,"KeyK",t.KeyK,"K",75,"VK_K",e,e],[0,n.KeyL,"KeyL",t.KeyL,"L",76,"VK_L",e,e],[0,n.KeyM,"KeyM",t.KeyM,"M",77,"VK_M",e,e],[0,n.KeyN,"KeyN",t.KeyN,"N",78,"VK_N",e,e],[0,n.KeyO,"KeyO",t.KeyO,"O",79,"VK_O",e,e],[0,n.KeyP,"KeyP",t.KeyP,"P",80,"VK_P",e,e],[0,n.KeyQ,"KeyQ",t.KeyQ,"Q",81,"VK_Q",e,e],[0,n.KeyR,"KeyR",t.KeyR,"R",82,"VK_R",e,e],[0,n.KeyS,"KeyS",t.KeyS,"S",83,"VK_S",e,e],[0,n.KeyT,"KeyT",t.KeyT,"T",84,"VK_T",e,e],[0,n.KeyU,"KeyU",t.KeyU,"U",85,"VK_U",e,e],[0,n.KeyV,"KeyV",t.KeyV,"V",86,"VK_V",e,e],[0,n.KeyW,"KeyW",t.KeyW,"W",87,"VK_W",e,e],[0,n.KeyX,"KeyX",t.KeyX,"X",88,"VK_X",e,e],[0,n.KeyY,"KeyY",t.KeyY,"Y",89,"VK_Y",e,e],[0,n.KeyZ,"KeyZ",t.KeyZ,"Z",90,"VK_Z",e,e],[0,n.Digit1,"Digit1",t.Digit1,"1",49,"VK_1",e,e],[0,n.Digit2,"Digit2",t.Digit2,"2",50,"VK_2",e,e],[0,n.Digit3,"Digit3",t.Digit3,"3",51,"VK_3",e,e],[0,n.Digit4,"Digit4",t.Digit4,"4",52,"VK_4",e,e],[0,n.Digit5,"Digit5",t.Digit5,"5",53,"VK_5",e,e],[0,n.Digit6,"Digit6",t.Digit6,"6",54,"VK_6",e,e],[0,n.Digit7,"Digit7",t.Digit7,"7",55,"VK_7",e,e],[0,n.Digit8,"Digit8",t.Digit8,"8",56,"VK_8",e,e],[0,n.Digit9,"Digit9",t.Digit9,"9",57,"VK_9",e,e],[0,n.Digit0,"Digit0",t.Digit0,"0",48,"VK_0",e,e],[1,n.Enter,"Enter",t.Enter,"Enter",13,"VK_RETURN",e,e],[1,n.Escape,"Escape",t.Escape,"Escape",27,"VK_ESCAPE",e,e],[1,n.Backspace,"Backspace",t.Backspace,"Backspace",8,"VK_BACK",e,e],[1,n.Tab,"Tab",t.Tab,"Tab",9,"VK_TAB",e,e],[1,n.Space,"Space",t.Space,"Space",32,"VK_SPACE",e,e],[0,n.Minus,"Minus",t.Minus,"-",189,"VK_OEM_MINUS","-","OEM_MINUS"],[0,n.Equal,"Equal",t.Equal,"=",187,"VK_OEM_PLUS","=","OEM_PLUS"],[0,n.BracketLeft,"BracketLeft",t.BracketLeft,"[",219,"VK_OEM_4","[","OEM_4"],[0,n.BracketRight,"BracketRight",t.BracketRight,"]",221,"VK_OEM_6","]","OEM_6"],[0,n.Backslash,"Backslash",t.Backslash,"\\",220,"VK_OEM_5","\\","OEM_5"],[0,n.IntlHash,"IntlHash",t.Unknown,e,0,e,e,e],[0,n.Semicolon,"Semicolon",t.Semicolon,";",186,"VK_OEM_1",";","OEM_1"],[0,n.Quote,"Quote",t.Quote,"'",222,"VK_OEM_7","'","OEM_7"],[0,n.Backquote,"Backquote",t.Backquote,"`",192,"VK_OEM_3","`","OEM_3"],[0,n.Comma,"Comma",t.Comma,",",188,"VK_OEM_COMMA",",","OEM_COMMA"],[0,n.Period,"Period",t.Period,".",190,"VK_OEM_PERIOD",".","OEM_PERIOD"],[0,n.Slash,"Slash",t.Slash,"/",191,"VK_OEM_2","/","OEM_2"],[1,n.CapsLock,"CapsLock",t.CapsLock,"CapsLock",20,"VK_CAPITAL",e,e],[1,n.F1,"F1",t.F1,"F1",112,"VK_F1",e,e],[1,n.F2,"F2",t.F2,"F2",113,"VK_F2",e,e],[1,n.F3,"F3",t.F3,"F3",114,"VK_F3",e,e],[1,n.F4,"F4",t.F4,"F4",115,"VK_F4",e,e],[1,n.F5,"F5",t.F5,"F5",116,"VK_F5",e,e],[1,n.F6,"F6",t.F6,"F6",117,"VK_F6",e,e],[1,n.F7,"F7",t.F7,"F7",118,"VK_F7",e,e],[1,n.F8,"F8",t.F8,"F8",119,"VK_F8",e,e],[1,n.F9,"F9",t.F9,"F9",120,"VK_F9",e,e],[1,n.F10,"F10",t.F10,"F10",121,"VK_F10",e,e],[1,n.F11,"F11",t.F11,"F11",122,"VK_F11",e,e],[1,n.F12,"F12",t.F12,"F12",123,"VK_F12",e,e],[1,n.PrintScreen,"PrintScreen",t.Unknown,e,0,e,e,e],[1,n.ScrollLock,"ScrollLock",t.ScrollLock,"ScrollLock",145,"VK_SCROLL",e,e],[1,n.Pause,"Pause",t.PauseBreak,"PauseBreak",19,"VK_PAUSE",e,e],[1,n.Insert,"Insert",t.Insert,"Insert",45,"VK_INSERT",e,e],[1,n.Home,"Home",t.Home,"Home",36,"VK_HOME",e,e],[1,n.PageUp,"PageUp",t.PageUp,"PageUp",33,"VK_PRIOR",e,e],[1,n.Delete,"Delete",t.Delete,"Delete",46,"VK_DELETE",e,e],[1,n.End,"End",t.End,"End",35,"VK_END",e,e],[1,n.PageDown,"PageDown",t.PageDown,"PageDown",34,"VK_NEXT",e,e],[1,n.ArrowRight,"ArrowRight",t.RightArrow,"RightArrow",39,"VK_RIGHT","Right",e],[1,n.ArrowLeft,"ArrowLeft",t.LeftArrow,"LeftArrow",37,"VK_LEFT","Left",e],[1,n.ArrowDown,"ArrowDown",t.DownArrow,"DownArrow",40,"VK_DOWN","Down",e],[1,n.ArrowUp,"ArrowUp",t.UpArrow,"UpArrow",38,"VK_UP","Up",e],[1,n.NumLock,"NumLock",t.NumLock,"NumLock",144,"VK_NUMLOCK",e,e],[1,n.NumpadDivide,"NumpadDivide",t.NumpadDivide,"NumPad_Divide",111,"VK_DIVIDE",e,e],[1,n.NumpadMultiply,"NumpadMultiply",t.NumpadMultiply,"NumPad_Multiply",106,"VK_MULTIPLY",e,e],[1,n.NumpadSubtract,"NumpadSubtract",t.NumpadSubtract,"NumPad_Subtract",109,"VK_SUBTRACT",e,e],[1,n.NumpadAdd,"NumpadAdd",t.NumpadAdd,"NumPad_Add",107,"VK_ADD",e,e],[1,n.NumpadEnter,"NumpadEnter",t.Enter,e,0,e,e,e],[1,n.Numpad1,"Numpad1",t.Numpad1,"NumPad1",97,"VK_NUMPAD1",e,e],[1,n.Numpad2,"Numpad2",t.Numpad2,"NumPad2",98,"VK_NUMPAD2",e,e],[1,n.Numpad3,"Numpad3",t.Numpad3,"NumPad3",99,"VK_NUMPAD3",e,e],[1,n.Numpad4,"Numpad4",t.Numpad4,"NumPad4",100,"VK_NUMPAD4",e,e],[1,n.Numpad5,"Numpad5",t.Numpad5,"NumPad5",101,"VK_NUMPAD5",e,e],[1,n.Numpad6,"Numpad6",t.Numpad6,"NumPad6",102,"VK_NUMPAD6",e,e],[1,n.Numpad7,"Numpad7",t.Numpad7,"NumPad7",103,"VK_NUMPAD7",e,e],[1,n.Numpad8,"Numpad8",t.Numpad8,"NumPad8",104,"VK_NUMPAD8",e,e],[1,n.Numpad9,"Numpad9",t.Numpad9,"NumPad9",105,"VK_NUMPAD9",e,e],[1,n.Numpad0,"Numpad0",t.Numpad0,"NumPad0",96,"VK_NUMPAD0",e,e],[1,n.NumpadDecimal,"NumpadDecimal",t.NumpadDecimal,"NumPad_Decimal",110,"VK_DECIMAL",e,e],[0,n.IntlBackslash,"IntlBackslash",t.IntlBackslash,"OEM_102",226,"VK_OEM_102",e,e],[1,n.ContextMenu,"ContextMenu",t.ContextMenu,"ContextMenu",93,e,e,e],[1,n.Power,"Power",t.Unknown,e,0,e,e,e],[1,n.NumpadEqual,"NumpadEqual",t.Unknown,e,0,e,e,e],[1,n.F13,"F13",t.F13,"F13",124,"VK_F13",e,e],[1,n.F14,"F14",t.F14,"F14",125,"VK_F14",e,e],[1,n.F15,"F15",t.F15,"F15",126,"VK_F15",e,e],[1,n.F16,"F16",t.F16,"F16",127,"VK_F16",e,e],[1,n.F17,"F17",t.F17,"F17",128,"VK_F17",e,e],[1,n.F18,"F18",t.F18,"F18",129,"VK_F18",e,e],[1,n.F19,"F19",t.F19,"F19",130,"VK_F19",e,e],[1,n.F20,"F20",t.F20,"F20",131,"VK_F20",e,e],[1,n.F21,"F21",t.F21,"F21",132,"VK_F21",e,e],[1,n.F22,"F22",t.F22,"F22",133,"VK_F22",e,e],[1,n.F23,"F23",t.F23,"F23",134,"VK_F23",e,e],[1,n.F24,"F24",t.F24,"F24",135,"VK_F24",e,e],[1,n.Open,"Open",t.Unknown,e,0,e,e,e],[1,n.Help,"Help",t.Unknown,e,0,e,e,e],[1,n.Select,"Select",t.Unknown,e,0,e,e,e],[1,n.Again,"Again",t.Unknown,e,0,e,e,e],[1,n.Undo,"Undo",t.Unknown,e,0,e,e,e],[1,n.Cut,"Cut",t.Unknown,e,0,e,e,e],[1,n.Copy,"Copy",t.Unknown,e,0,e,e,e],[1,n.Paste,"Paste",t.Unknown,e,0,e,e,e],[1,n.Find,"Find",t.Unknown,e,0,e,e,e],[1,n.AudioVolumeMute,"AudioVolumeMute",t.AudioVolumeMute,"AudioVolumeMute",173,"VK_VOLUME_MUTE",e,e],[1,n.AudioVolumeUp,"AudioVolumeUp",t.AudioVolumeUp,"AudioVolumeUp",175,"VK_VOLUME_UP",e,e],[1,n.AudioVolumeDown,"AudioVolumeDown",t.AudioVolumeDown,"AudioVolumeDown",174,"VK_VOLUME_DOWN",e,e],[1,n.NumpadComma,"NumpadComma",t.NUMPAD_SEPARATOR,"NumPad_Separator",108,"VK_SEPARATOR",e,e],[0,n.IntlRo,"IntlRo",t.ABNT_C1,"ABNT_C1",193,"VK_ABNT_C1",e,e],[1,n.KanaMode,"KanaMode",t.Unknown,e,0,e,e,e],[0,n.IntlYen,"IntlYen",t.Unknown,e,0,e,e,e],[1,n.Convert,"Convert",t.Unknown,e,0,e,e,e],[1,n.NonConvert,"NonConvert",t.Unknown,e,0,e,e,e],[1,n.Lang1,"Lang1",t.Unknown,e,0,e,e,e],[1,n.Lang2,"Lang2",t.Unknown,e,0,e,e,e],[1,n.Lang3,"Lang3",t.Unknown,e,0,e,e,e],[1,n.Lang4,"Lang4",t.Unknown,e,0,e,e,e],[1,n.Lang5,"Lang5",t.Unknown,e,0,e,e,e],[1,n.Abort,"Abort",t.Unknown,e,0,e,e,e],[1,n.Props,"Props",t.Unknown,e,0,e,e,e],[1,n.NumpadParenLeft,"NumpadParenLeft",t.Unknown,e,0,e,e,e],[1,n.NumpadParenRight,"NumpadParenRight",t.Unknown,e,0,e,e,e],[1,n.NumpadBackspace,"NumpadBackspace",t.Unknown,e,0,e,e,e],[1,n.NumpadMemoryStore,"NumpadMemoryStore",t.Unknown,e,0,e,e,e],[1,n.NumpadMemoryRecall,"NumpadMemoryRecall",t.Unknown,e,0,e,e,e],[1,n.NumpadMemoryClear,"NumpadMemoryClear",t.Unknown,e,0,e,e,e],[1,n.NumpadMemoryAdd,"NumpadMemoryAdd",t.Unknown,e,0,e,e,e],[1,n.NumpadMemorySubtract,"NumpadMemorySubtract",t.Unknown,e,0,e,e,e],[1,n.NumpadClear,"NumpadClear",t.Clear,"Clear",12,"VK_CLEAR",e,e],[1,n.NumpadClearEntry,"NumpadClearEntry",t.Unknown,e,0,e,e,e],[1,n.None,e,t.Ctrl,"Ctrl",17,"VK_CONTROL",e,e],[1,n.None,e,t.Shift,"Shift",16,"VK_SHIFT",e,e],[1,n.None,e,t.Alt,"Alt",18,"VK_MENU",e,e],[1,n.None,e,t.Meta,"Meta",91,"VK_COMMAND",e,e],[1,n.ControlLeft,"ControlLeft",t.Ctrl,e,0,"VK_LCONTROL",e,e],[1,n.ShiftLeft,"ShiftLeft",t.Shift,e,0,"VK_LSHIFT",e,e],[1,n.AltLeft,"AltLeft",t.Alt,e,0,"VK_LMENU",e,e],[1,n.MetaLeft,"MetaLeft",t.Meta,e,0,"VK_LWIN",e,e],[1,n.ControlRight,"ControlRight",t.Ctrl,e,0,"VK_RCONTROL",e,e],[1,n.ShiftRight,"ShiftRight",t.Shift,e,0,"VK_RSHIFT",e,e],[1,n.AltRight,"AltRight",t.Alt,e,0,"VK_RMENU",e,e],[1,n.MetaRight,"MetaRight",t.Meta,e,0,"VK_RWIN",e,e],[1,n.BrightnessUp,"BrightnessUp",t.Unknown,e,0,e,e,e],[1,n.BrightnessDown,"BrightnessDown",t.Unknown,e,0,e,e,e],[1,n.MediaPlay,"MediaPlay",t.Unknown,e,0,e,e,e],[1,n.MediaRecord,"MediaRecord",t.Unknown,e,0,e,e,e],[1,n.MediaFastForward,"MediaFastForward",t.Unknown,e,0,e,e,e],[1,n.MediaRewind,"MediaRewind",t.Unknown,e,0,e,e,e],[1,n.MediaTrackNext,"MediaTrackNext",t.MediaTrackNext,"MediaTrackNext",176,"VK_MEDIA_NEXT_TRACK",e,e],[1,n.MediaTrackPrevious,"MediaTrackPrevious",t.MediaTrackPrevious,"MediaTrackPrevious",177,"VK_MEDIA_PREV_TRACK",e,e],[1,n.MediaStop,"MediaStop",t.MediaStop,"MediaStop",178,"VK_MEDIA_STOP",e,e],[1,n.Eject,"Eject",t.Unknown,e,0,e,e,e],[1,n.MediaPlayPause,"MediaPlayPause",t.MediaPlayPause,"MediaPlayPause",179,"VK_MEDIA_PLAY_PAUSE",e,e],[1,n.MediaSelect,"MediaSelect",t.LaunchMediaPlayer,"LaunchMediaPlayer",181,"VK_MEDIA_LAUNCH_MEDIA_SELECT",e,e],[1,n.LaunchMail,"LaunchMail",t.LaunchMail,"LaunchMail",180,"VK_MEDIA_LAUNCH_MAIL",e,e],[1,n.LaunchApp2,"LaunchApp2",t.LaunchApp2,"LaunchApp2",183,"VK_MEDIA_LAUNCH_APP2",e,e],[1,n.LaunchApp1,"LaunchApp1",t.Unknown,e,0,"VK_MEDIA_LAUNCH_APP1",e,e],[1,n.SelectTask,"SelectTask",t.Unknown,e,0,e,e,e],[1,n.LaunchScreenSaver,"LaunchScreenSaver",t.Unknown,e,0,e,e,e],[1,n.BrowserSearch,"BrowserSearch",t.BrowserSearch,"BrowserSearch",170,"VK_BROWSER_SEARCH",e,e],[1,n.BrowserHome,"BrowserHome",t.BrowserHome,"BrowserHome",172,"VK_BROWSER_HOME",e,e],[1,n.BrowserBack,"BrowserBack",t.BrowserBack,"BrowserBack",166,"VK_BROWSER_BACK",e,e],[1,n.BrowserForward,"BrowserForward",t.BrowserForward,"BrowserForward",167,"VK_BROWSER_FORWARD",e,e],[1,n.BrowserStop,"BrowserStop",t.Unknown,e,0,"VK_BROWSER_STOP",e,e],[1,n.BrowserRefresh,"BrowserRefresh",t.Unknown,e,0,"VK_BROWSER_REFRESH",e,e],[1,n.BrowserFavorites,"BrowserFavorites",t.Unknown,e,0,"VK_BROWSER_FAVORITES",e,e],[1,n.ZoomToggle,"ZoomToggle",t.Unknown,e,0,e,e,e],[1,n.MailReply,"MailReply",t.Unknown,e,0,e,e,e],[1,n.MailForward,"MailForward",t.Unknown,e,0,e,e,e],[1,n.MailSend,"MailSend",t.Unknown,e,0,e,e,e],[1,n.None,e,t.KEY_IN_COMPOSITION,"KeyInComposition",229,e,e,e],[1,n.None,e,t.ABNT_C2,"ABNT_C2",194,"VK_ABNT_C2",e,e],[1,n.None,e,t.OEM_8,"OEM_8",223,"VK_OEM_8",e,e],[1,n.None,e,t.Unknown,e,0,"VK_KANA",e,e],[1,n.None,e,t.Unknown,e,0,"VK_HANGUL",e,e],[1,n.None,e,t.Unknown,e,0,"VK_JUNJA",e,e],[1,n.None,e,t.Unknown,e,0,"VK_FINAL",e,e],[1,n.None,e,t.Unknown,e,0,"VK_HANJA",e,e],[1,n.None,e,t.Unknown,e,0,"VK_KANJI",e,e],[1,n.None,e,t.Unknown,e,0,"VK_CONVERT",e,e],[1,n.None,e,t.Unknown,e,0,"VK_NONCONVERT",e,e],[1,n.None,e,t.Unknown,e,0,"VK_ACCEPT",e,e],[1,n.None,e,t.Unknown,e,0,"VK_MODECHANGE",e,e],[1,n.None,e,t.Unknown,e,0,"VK_SELECT",e,e],[1,n.None,e,t.Unknown,e,0,"VK_PRINT",e,e],[1,n.None,e,t.Unknown,e,0,"VK_EXECUTE",e,e],[1,n.None,e,t.Unknown,e,0,"VK_SNAPSHOT",e,e],[1,n.None,e,t.Unknown,e,0,"VK_HELP",e,e],[1,n.None,e,t.Unknown,e,0,"VK_APPS",e,e],[1,n.None,e,t.Unknown,e,0,"VK_PROCESSKEY",e,e],[1,n.None,e,t.Unknown,e,0,"VK_PACKET",e,e],[1,n.None,e,t.Unknown,e,0,"VK_DBE_SBCSCHAR",e,e],[1,n.None,e,t.Unknown,e,0,"VK_DBE_DBCSCHAR",e,e],[1,n.None,e,t.Unknown,e,0,"VK_ATTN",e,e],[1,n.None,e,t.Unknown,e,0,"VK_CRSEL",e,e],[1,n.None,e,t.Unknown,e,0,"VK_EXSEL",e,e],[1,n.None,e,t.Unknown,e,0,"VK_EREOF",e,e],[1,n.None,e,t.Unknown,e,0,"VK_PLAY",e,e],[1,n.None,e,t.Unknown,e,0,"VK_ZOOM",e,e],[1,n.None,e,t.Unknown,e,0,"VK_NONAME",e,e],[1,n.None,e,t.Unknown,e,0,"VK_PA1",e,e],[1,n.None,e,t.Unknown,e,0,"VK_OEM_CLEAR",e,e]],E=[],R=[];for(const A of m){const[w,N,c,u,s,o,h,T,_]=A;if(R[N]||(R[N]=!0,a[N]=c,l[c]=N,f[c.toLowerCase()]=N,w&&(i.$Kr[N]=u,u!==t.Unknown&&u!==t.Enter&&u!==t.Ctrl&&u!==t.Shift&&u!==t.Alt&&u!==t.Meta&&(i.$Lr[u]=N))),!E[u]){if(E[u]=!0,!s)throw new Error(`String representation missing for key code ${u} around scan code ${c}`);g.define(u,s),v.define(u,T||s),d.define(u,_||T||s)}o&&(i.$Hr[o]=u),h&&(i.$Ir[h]=u)}i.$Lr[t.Enter]=n.Enter})();var $;(function(e){function m(c){return g.keyCodeToStr(c)}e.toString=m;function E(c){return g.strToKeyCode(c)}e.fromString=E;function R(c){return v.keyCodeToStr(c)}e.toUserSettingsUS=R;function A(c){return d.keyCodeToStr(c)}e.toUserSettingsGeneral=A;function w(c){return v.strToKeyCode(c)||d.strToKeyCode(c)}e.fromUserSettings=w;function N(c){if(c>=t.Numpad0&&c<=t.NumpadDivide)return null;switch(c){case t.UpArrow:return"Up";case t.DownArrow:return"Down";case t.LeftArrow:return"Left";case t.RightArrow:return"Right"}return g.keyCodeToStr(c)}e.toElectronAccelerator=N})($||(i.KeyCodeUtils=$={}));var b;(function(e){e[e.CtrlCmd=2048]="CtrlCmd",e[e.Shift=1024]="Shift",e[e.Alt=512]="Alt",e[e.WinCtrl=256]="WinCtrl"})(b||(i.KeyMod=b={}));function L(e,m){const E=(m&65535)<<16>>>0;return(e|E)>>>0}}),ne(ie[41],re([0,1]),function(q,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$V=void 0;class t{constructor(p){this.d=p,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(p){this.c=p}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}i.$V=t}),ne(ie[24],re([0,1]),function(q,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$5c=void 0;class t{static{this.Undefined=new t(void 0)}constructor(g){this.element=g,this.next=t.Undefined,this.prev=t.Undefined}}class n{constructor(){this.a=t.Undefined,this.b=t.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===t.Undefined}clear(){let g=this.a;for(;g!==t.Undefined;){const v=g.next;g.prev=t.Undefined,g.next=t.Undefined,g=v}this.a=t.Undefined,this.b=t.Undefined,this.c=0}unshift(g){return this.d(g,!1)}push(g){return this.d(g,!0)}d(g,v){const d=new t(g);if(this.a===t.Undefined)this.a=d,this.b=d;else if(v){const l=this.b;this.b=d,d.prev=l,l.next=d}else{const l=this.a;this.a=d,d.next=l,l.prev=d}this.c+=1;let a=!1;return()=>{a||(a=!0,this.e(d))}}shift(){if(this.a!==t.Undefined){const g=this.a.element;return this.e(this.a),g}}pop(){if(this.b!==t.Undefined){const g=this.b.element;return this.e(this.b),g}}e(g){if(g.prev!==t.Undefined&&g.next!==t.Undefined){const v=g.prev;v.next=g.next,g.next.prev=v}else g.prev===t.Undefined&&g.next===t.Undefined?(this.a=t.Undefined,this.b=t.Undefined):g.next===t.Undefined?(this.b=this.b.prev,this.b.next=t.Undefined):g.prev===t.Undefined&&(this.a=this.a.next,this.a.prev=t.Undefined);this.c-=1}*[Symbol.iterator](){let g=this.a;for(;g!==t.Undefined;)yield g.element,g=g.next}}i.$5c=n}),ne(ie[16],re([0,1]),function(q,i){"use strict";var t,n,p;Object.defineProperty(i,"__esModule",{value:!0}),i.$Hc=i.$Gc=i.$Fc=i.$Ec=i.$Dc=i.$Cc=i.Touch=i.$Bc=i.$Ac=void 0,i.$xc=g,i.$yc=v,i.$zc=d,i.$Ic=N;function g(c,u,s){let o=c.get(u);return o===void 0&&(o=s,c.set(u,o)),o}function v(c){const u=[];return c.forEach((s,o)=>{u.push(`${o} => ${s}`)}),`Map(${c.size}) {${u.join(", ")}}`}function d(c){const u=[];return c.forEach(s=>{u.push(s)}),`Set(${c.size}) {${u.join(", ")}}`}class a{constructor(u,s){this.uri=u,this.value=s}}function l(c){return Array.isArray(c)}class f{static{this.c=u=>u.toString()}constructor(u,s){if(this[t]="ResourceMap",u instanceof f)this.d=new Map(u.d),this.e=s??f.c;else if(l(u)){this.d=new Map,this.e=s??f.c;for(const[o,h]of u)this.set(o,h)}else this.d=new Map,this.e=u??f.c}set(u,s){return this.d.set(this.e(u),new a(u,s)),this}get(u){return this.d.get(this.e(u))?.value}has(u){return this.d.has(this.e(u))}get size(){return this.d.size}clear(){this.d.clear()}delete(u){return this.d.delete(this.e(u))}forEach(u,s){typeof s<"u"&&(u=u.bind(s));for(const[o,h]of this.d)u(h.value,h.uri,this)}*values(){for(const u of this.d.values())yield u.value}*keys(){for(const u of this.d.values())yield u.uri}*entries(){for(const u of this.d.values())yield[u.uri,u.value]}*[(t=Symbol.toStringTag,Symbol.iterator)](){for(const[,u]of this.d)yield[u.uri,u.value]}}i.$Ac=f;class ${constructor(u,s){this[n]="ResourceSet",!u||typeof u=="function"?this.c=new f(u):(this.c=new f(s),u.forEach(this.add,this))}get size(){return this.c.size}add(u){return this.c.set(u,u),this}clear(){this.c.clear()}delete(u){return this.c.delete(u)}forEach(u,s){this.c.forEach((o,h)=>u.call(s,h,h,this))}has(u){return this.c.has(u)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(n=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}i.$Bc=$;var b;(function(c){c[c.None=0]="None",c[c.AsOld=1]="AsOld",c[c.AsNew=2]="AsNew"})(b||(i.Touch=b={}));class L{constructor(){this[p]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has(u){return this.c.has(u)}get(u,s=b.None){const o=this.c.get(u);if(o)return s!==b.None&&this.m(o,s),o.value}set(u,s,o=b.None){let h=this.c.get(u);if(h)h.value=s,o!==b.None&&this.m(h,o);else{switch(h={key:u,value:s,next:void 0,previous:void 0},o){case b.None:this.k(h);break;case b.AsOld:this.j(h);break;case b.AsNew:this.k(h);break;default:this.k(h);break}this.c.set(u,h),this.f++}return this}delete(u){return!!this.remove(u)}remove(u){const s=this.c.get(u);if(s)return this.c.delete(u),this.l(s),this.f--,s.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const u=this.d;return this.c.delete(u.key),this.l(u),this.f--,u.value}forEach(u,s){const o=this.g;let h=this.d;for(;h;){if(s?u.bind(s)(h.value,h.key,this):u(h.value,h.key,this),this.g!==o)throw new Error("LinkedMap got modified during iteration.");h=h.next}}keys(){const u=this,s=this.g;let o=this.d;const h={[Symbol.iterator](){return h},next(){if(u.g!==s)throw new Error("LinkedMap got modified during iteration.");if(o){const T={value:o.key,done:!1};return o=o.next,T}else return{value:void 0,done:!0}}};return h}values(){const u=this,s=this.g;let o=this.d;const h={[Symbol.iterator](){return h},next(){if(u.g!==s)throw new Error("LinkedMap got modified during iteration.");if(o){const T={value:o.value,done:!1};return o=o.next,T}else return{value:void 0,done:!0}}};return h}entries(){const u=this,s=this.g;let o=this.d;const h={[Symbol.iterator](){return h},next(){if(u.g!==s)throw new Error("LinkedMap got modified during iteration.");if(o){const T={value:[o.key,o.value],done:!1};return o=o.next,T}else return{value:void 0,done:!0}}};return h}[(p=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h(u){if(u>=this.size)return;if(u===0){this.clear();return}let s=this.d,o=this.size;for(;s&&o>u;)this.c.delete(s.key),s=s.next,o--;this.d=s,this.f=o,s&&(s.previous=void 0),this.g++}i(u){if(u>=this.size)return;if(u===0){this.clear();return}let s=this.e,o=this.size;for(;s&&o>u;)this.c.delete(s.key),s=s.previous,o--;this.e=s,this.f=o,s&&(s.next=void 0),this.g++}j(u){if(!this.d&&!this.e)this.e=u;else if(this.d)u.next=this.d,this.d.previous=u;else throw new Error("Invalid list");this.d=u,this.g++}k(u){if(!this.d&&!this.e)this.d=u;else if(this.e)u.previous=this.e,this.e.next=u;else throw new Error("Invalid list");this.e=u,this.g++}l(u){if(u===this.d&&u===this.e)this.d=void 0,this.e=void 0;else if(u===this.d){if(!u.next)throw new Error("Invalid list");u.next.previous=void 0,this.d=u.next}else if(u===this.e){if(!u.previous)throw new Error("Invalid list");u.previous.next=void 0,this.e=u.previous}else{const s=u.next,o=u.previous;if(!s||!o)throw new Error("Invalid list");s.previous=o,o.next=s}u.next=void 0,u.previous=void 0,this.g++}m(u,s){if(!this.d||!this.e)throw new Error("Invalid list");if(!(s!==b.AsOld&&s!==b.AsNew)){if(s===b.AsOld){if(u===this.d)return;const o=u.next,h=u.previous;u===this.e?(h.next=void 0,this.e=h):(o.previous=h,h.next=o),u.previous=void 0,u.next=this.d,this.d.previous=u,this.d=u,this.g++}else if(s===b.AsNew){if(u===this.e)return;const o=u.next,h=u.previous;u===this.d?(o.previous=void 0,this.d=o):(o.previous=h,h.next=o),u.next=void 0,u.previous=this.e,this.e.next=u,this.e=u,this.g++}}}toJSON(){const u=[];return this.forEach((s,o)=>{u.push([o,s])}),u}fromJSON(u){this.clear();for(const[s,o]of u)this.set(s,o)}}i.$Cc=L;class e extends L{constructor(u,s=1){super(),this.n=u,this.o=Math.min(Math.max(0,s),1)}get limit(){return this.n}set limit(u){this.n=u,this.p()}get ratio(){return this.o}set ratio(u){this.o=Math.min(Math.max(0,u),1),this.p()}get(u,s=b.AsNew){return super.get(u,s)}peek(u){return super.get(u,b.None)}set(u,s){return super.set(u,s,b.AsNew),this}p(){this.size>this.n&&this.q(Math.round(this.n*this.o))}}class m extends e{constructor(u,s=1){super(u,s)}q(u){this.h(u)}set(u,s){return super.set(u,s),this.p(),this}}i.$Dc=m;class E extends e{constructor(u,s=1){super(u,s)}q(u){this.i(u)}set(u,s){return this.n<=this.size&&!this.has(u)&&this.q(Math.round(this.n*this.o)-1),super.set(u,s),this}}i.$Ec=E;class R{constructor(){this.c=new Map}add(u){return this.c.set(u,(this.c.get(u)||0)+1),this}delete(u){let s=this.c.get(u)||0;return s===0?!1:(s--,s===0?this.c.delete(u):this.c.set(u,s),!0)}has(u){return this.c.has(u)}}i.$Fc=R;class A{constructor(u){if(this.c=new Map,this.d=new Map,u)for(const[s,o]of u)this.set(s,o)}clear(){this.c.clear(),this.d.clear()}set(u,s){this.c.set(u,s),this.d.set(s,u)}get(u){return this.c.get(u)}getKey(u){return this.d.get(u)}delete(u){const s=this.c.get(u);return s===void 0?!1:(this.c.delete(u),this.d.delete(s),!0)}forEach(u,s){this.c.forEach((o,h)=>{u.call(s,o,h,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}i.$Gc=A;class w{constructor(){this.c=new Map}add(u,s){let o=this.c.get(u);o||(o=new Set,this.c.set(u,o)),o.add(s)}delete(u,s){const o=this.c.get(u);o&&(o.delete(s),o.size===0&&this.c.delete(u))}forEach(u,s){const o=this.c.get(u);o&&o.forEach(s)}get(u){const s=this.c.get(u);return s||new Set}}i.$Hc=w;function N(c,u){if(c===u)return!0;if(c.size!==u.size)return!1;for(const[s,o]of c)if(!u.has(s)||u.get(s)!==o)return!1;for(const[s]of u)if(!c.has(s))return!1;return!0}}),ne(ie[12],re([0,1,7,37,16,22,23]),function(q,i,t,n,p,g,v){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$4c=i.$2c=i.$1c=i.$Zc=i.$Yc=i.$Xc=i.$Wc=i.$Vc=i.$Uc=i.$Tc=i.$Jc=void 0,i.$Kc=f,i.$Lc=$,i.$Mc=b,i.$Nc=m,i.$Oc=E,i.$Pc=R,i.$Qc=A,i.$Rc=w,i.$Sc=N,i.$3c=D;const d=!1;let a=null;class l{constructor(){this.b=new Map}static{this.a=0}c(j){let B=this.b.get(j);return B||(B={parent:null,source:null,isSingleton:!1,value:j,idx:l.a++},this.b.set(j,B)),B}trackDisposable(j){const B=this.c(j);B.source||(B.source=new Error().stack)}setParent(j,B){const Z=this.c(j);Z.parent=B}markAsDisposed(j){this.b.delete(j)}markAsSingleton(j){this.c(j).isSingleton=!0}f(j,B){const Z=B.get(j);if(Z)return Z;const O=j.parent?this.f(this.c(j.parent),B):j;return B.set(j,O),O}getTrackedDisposables(){const j=new Map;return[...this.b.entries()].filter(([,Z])=>Z.source!==null&&!this.f(Z,j).isSingleton).flatMap(([Z])=>Z)}computeLeakingDisposables(j=10,B){let Z;if(B)Z=B;else{const H=new Map,Q=[...this.b.values()].filter(F=>F.source!==null&&!this.f(F,H).isSingleton);if(Q.length===0)return;const C=new Set(Q.map(F=>F.value));if(Z=Q.filter(F=>!(F.parent&&C.has(F.parent))),Z.length===0)throw new Error("There are cyclic diposable chains!")}if(!Z)return;function O(H){function Q(F,z){for(;F.length>0&&z.some(fe=>typeof fe=="string"?fe===F[0]:F[0].match(fe));)F.shift()}const C=H.source.split(`
`).map(F=>F.trim().replace("at ","")).filter(F=>F!=="");return Q(C,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),C.reverse()}const S=new p.$Hc;for(const H of Z){const Q=O(H);for(let C=0;C<=Q.length;C++)S.add(Q.slice(0,C).join(`
`),H)}Z.sort((0,t.$6b)(H=>H.idx,t.$8b));let X="",Y=0;for(const H of Z.slice(0,j)){Y++;const Q=O(H),C=[];for(let F=0;F<Q.length;F++){let z=Q[F];z=`(shared with ${S.get(Q.slice(0,F+1).join(`
`)).size}/${Z.length} leaks) at ${z}`;const oe=S.get(Q.slice(0,F).join(`
`)),we=(0,n.$K)([...oe].map(r=>O(r)[F]),r=>r);delete we[Q[F]];for(const[r,Te]of Object.entries(we))C.unshift(`    - stacktraces of ${Te.length} other leaks continue with ${r}`);C.unshift(z)}X+=`


==================== Leaking disposable ${Y}/${Z.length}: ${H.value.constructor.name} ====================
${C.join(`
`)}
============================================================

`}return Z.length>j&&(X+=`


... and ${Z.length-j} more leaking disposables

`),{leaks:Z,details:X}}}i.$Jc=l;function f(P){a=P}if(d){const P="__is_disposable_tracked__";f(new class{trackDisposable(j){const B=new Error("Potentially leaked disposable").stack;setTimeout(()=>{j[P]||console.log(B)},3e3)}setParent(j,B){if(j&&j!==u.None)try{j[P]=!0}catch{}}markAsDisposed(j){if(j&&j!==u.None)try{j[P]=!0}catch{}}markAsSingleton(j){}})}function $(P){return a?.trackDisposable(P),P}function b(P){a?.markAsDisposed(P)}function L(P,j){a?.setParent(P,j)}function e(P,j){if(a)for(const B of P)a.setParent(B,j)}function m(P){return a?.markAsSingleton(P),P}function E(P){return typeof P=="object"&&P!==null&&typeof P.dispose=="function"&&P.dispose.length===0}function R(P){if(v.Iterable.is(P)){const j=[];for(const B of P)if(B)try{B.dispose()}catch(Z){j.push(Z)}if(j.length===1)throw j[0];if(j.length>1)throw new AggregateError(j,"Encountered errors while disposing of store");return Array.isArray(P)?[]:P}else if(P)return P.dispose(),P}function A(P){for(const j of P)E(j)&&j.dispose();return[]}function w(...P){const j=N(()=>R(P));return e(P,j),j}function N(P){const j=$({dispose:(0,g.$db)(()=>{b(j),P()})});return j}class c{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,$(this)}dispose(){this.g||(b(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{R(this.f)}finally{this.f.clear()}}add(j){if(!j)return j;if(j===this)throw new Error("Cannot register a disposable on itself!");return L(j,this),this.g?c.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(j),j}delete(j){if(j){if(j===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(j),j.dispose()}}deleteAndLeak(j){j&&this.f.has(j)&&(this.f.delete(j),L(j,null))}}i.$Tc=c;class u{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new c,$(this),L(this.q,this)}dispose(){b(this),this.q.dispose()}B(j){if(j===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(j)}}i.$Uc=u;class s{constructor(){this.b=!1,$(this)}get value(){return this.b?void 0:this.a}set value(j){this.b||j===this.a||(this.a?.dispose(),j&&L(j,this),this.a=j)}clear(){this.value=void 0}dispose(){this.b=!0,b(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const j=this.a;return this.a=void 0,j&&L(j,null),j}}i.$Vc=s;class o{constructor(j){this.a=new s,this.b=!1,this.a.value=j}get value(){return this.a.value}set value(j){this.b||j===this.a.value||(this.a.value=j)}dispose(){this.b=!0,this.a.dispose()}}i.$Wc=o;class h{constructor(j){this.b=j,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}i.$Xc=h;class T{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,$(this)}set(j){let B=j;return this.unset=()=>B=void 0,this.isset=()=>B!==void 0,this.dispose=()=>{B&&(B(),B=void 0,b(this))},this}}i.$Yc=T;class _{constructor(){this.a=new Map}acquire(j,...B){let Z=this.a.get(j);Z||(Z={counter:0,object:this.b(j,...B)},this.a.set(j,Z));const{object:O}=Z,S=(0,g.$db)(()=>{--Z.counter===0&&(this.c(j,Z.object),this.a.delete(j))});return Z.counter++,{object:O,dispose:S}}}i.$Zc=_;class U{constructor(j){this.a=j}async acquire(j,...B){const Z=this.a.acquire(j,...B);try{return{object:await Z.object,dispose:()=>Z.dispose()}}catch(O){throw Z.dispose(),O}}}i.$1c=U;class M{constructor(j){this.object=j}dispose(){}}i.$2c=M;function D(P){const j=new c;try{P(j)}finally{j.dispose()}}class k{constructor(){this.a=new Map,this.b=!1,$(this)}dispose(){b(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{R(this.a.values())}finally{this.a.clear()}}has(j){return this.a.has(j)}get size(){return this.a.size}get(j){return this.a.get(j)}set(j,B,Z=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),Z||this.a.get(j)?.dispose(),this.a.set(j,B)}deleteAndDispose(j){this.a.get(j)?.dispose(),this.a.delete(j)}deleteAndLeak(j){const B=this.a.get(j);return this.a.delete(j),B}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}i.$4c=k}),ne(ie[42],re([0,1]),function(q,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.MarshalledId=void 0;var t;(function(n){n[n.Uri=1]="Uri",n[n.Regexp=2]="Regexp",n[n.ScmResource=3]="ScmResource",n[n.ScmResourceGroup=4]="ScmResourceGroup",n[n.ScmProvider=5]="ScmProvider",n[n.CommentController=6]="CommentController",n[n.CommentThread=7]="CommentThread",n[n.CommentThreadInstance=8]="CommentThreadInstance",n[n.CommentThreadReply=9]="CommentThreadReply",n[n.CommentNode=10]="CommentNode",n[n.CommentThreadNode=11]="CommentThreadNode",n[n.TimelineActionContext=12]="TimelineActionContext",n[n.NotebookCellActionContext=13]="NotebookCellActionContext",n[n.NotebookActionContext=14]="NotebookActionContext",n[n.TerminalContext=15]="TerminalContext",n[n.TestItemContext=16]="TestItemContext",n[n.Date=17]="Date",n[n.TestMessageMenuArgs=18]="TestMessageMenuArgs"})(t||(i.MarshalledId=t={}))}),ne(ie[25],re([0,1]),function(q,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$be=void 0;const t=globalThis.performance&&typeof globalThis.performance.now=="function";class n{static create(g){return new n(g)}constructor(g){this.c=t&&g===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}i.$be=n}),ne(ie[13],re([0,1,4,22,12,24,25]),function(q,i,t,n,p,g,v){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$re=i.$qe=i.$pe=i.$oe=i.$ne=i.$me=i.$le=i.$ke=i.$je=i.$ie=i.$he=i.$ge=i.$fe=i.$de=i.Event=void 0,i.$ee=L;const d=!1,a=!1,l=!1;var f;(function(O){O.None=()=>p.$Uc.None;function S(se){if(l){const{onDidAddListener:te}=se,ae=m.create();let ue=0;se.onDidAddListener=()=>{++ue===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),ae.print()),te?.()}}}function X(se,te){return r(se,()=>{},0,void 0,!0,void 0,te)}O.defer=X;function Y(se){return(te,ae=null,ue)=>{let ce=!1,me;return me=se($e=>{if(!ce)return me?me.dispose():ce=!0,te.call(ae,$e)},null,ue),ce&&me.dispose(),me}}O.once=Y;function H(se,te,ae){return oe((ue,ce=null,me)=>se($e=>ue.call(ce,te($e)),null,me),ae)}O.map=H;function Q(se,te,ae){return oe((ue,ce=null,me)=>se($e=>{te($e),ue.call(ce,$e)},null,me),ae)}O.forEach=Q;function C(se,te,ae){return oe((ue,ce=null,me)=>se($e=>te($e)&&ue.call(ce,$e),null,me),ae)}O.filter=C;function F(se){return se}O.signal=F;function z(...se){return(te,ae=null,ue)=>{const ce=(0,p.$Rc)(...se.map(me=>me($e=>te.call(ae,$e))));return we(ce,ue)}}O.any=z;function fe(se,te,ae,ue){let ce=ae;return H(se,me=>(ce=te(ce,me),ce),ue)}O.reduce=fe;function oe(se,te){let ae;const ue={onWillAddFirstListener(){ae=se(ce.fire,ce)},onDidRemoveLastListener(){ae?.dispose()}};te||S(ue);const ce=new s(ue);return te?.add(ce),ce.event}function we(se,te){return te instanceof Array?te.push(se):te&&te.add(se),se}function r(se,te,ae=100,ue=!1,ce=!1,me,$e){let Ee,Ae,ye,Oe=0,ge;const Me={leakWarningThreshold:me,onWillAddFirstListener(){Ee=se(Ge=>{Oe++,Ae=te(Ae,Ge),ue&&!ye&&(Be.fire(Ae),Ae=void 0),ge=()=>{const ze=Ae;Ae=void 0,ye=void 0,(!ue||Oe>1)&&Be.fire(ze),Oe=0},typeof ae=="number"?(clearTimeout(ye),ye=setTimeout(ge,ae)):ye===void 0&&(ye=0,queueMicrotask(ge))})},onWillRemoveListener(){ce&&Oe>0&&ge?.()},onDidRemoveLastListener(){ge=void 0,Ee.dispose()}};$e||S(Me);const Be=new s(Me);return $e?.add(Be),Be.event}O.debounce=r;function Te(se,te=0,ae){return O.debounce(se,(ue,ce)=>ue?(ue.push(ce),ue):[ce],te,void 0,!0,void 0,ae)}O.accumulate=Te;function ke(se,te=(ue,ce)=>ue===ce,ae){let ue=!0,ce;return C(se,me=>{const $e=ue||!te(me,ce);return ue=!1,ce=me,$e},ae)}O.latch=ke;function Ve(se,te,ae){return[O.filter(se,te,ae),O.filter(se,ue=>!te(ue),ae)]}O.split=Ve;function Ue(se,te=!1,ae=[],ue){let ce=ae.slice(),me=se(Ae=>{ce?ce.push(Ae):Ee.fire(Ae)});ue&&ue.add(me);const $e=()=>{ce?.forEach(Ae=>Ee.fire(Ae)),ce=null},Ee=new s({onWillAddFirstListener(){me||(me=se(Ae=>Ee.fire(Ae)),ue&&ue.add(me))},onDidAddFirstListener(){ce&&(te?setTimeout($e):$e())},onDidRemoveLastListener(){me&&me.dispose(),me=null}});return ue&&ue.add(Ee),Ee.event}O.buffer=Ue;function Se(se,te){return(ue,ce,me)=>{const $e=te(new W);return se(function(Ee){const Ae=$e.evaluate(Ee);Ae!==x&&ue.call(ce,Ae)},void 0,me)}}O.chain=Se;const x=Symbol("HaltChainable");class W{constructor(){this.f=[]}map(te){return this.f.push(te),this}forEach(te){return this.f.push(ae=>(te(ae),ae)),this}filter(te){return this.f.push(ae=>te(ae)?ae:x),this}reduce(te,ae){let ue=ae;return this.f.push(ce=>(ue=te(ue,ce),ue)),this}latch(te=(ae,ue)=>ae===ue){let ae=!0,ue;return this.f.push(ce=>{const me=ae||!te(ce,ue);return ae=!1,ue=ce,me?ce:x}),this}evaluate(te){for(const ae of this.f)if(te=ae(te),te===x)break;return te}}function V(se,te,ae=ue=>ue){const ue=(...Ee)=>$e.fire(ae(...Ee)),ce=()=>se.on(te,ue),me=()=>se.removeListener(te,ue),$e=new s({onWillAddFirstListener:ce,onDidRemoveLastListener:me});return $e.event}O.fromNodeEventEmitter=V;function J(se,te,ae=ue=>ue){const ue=(...Ee)=>$e.fire(ae(...Ee)),ce=()=>se.addEventListener(te,ue),me=()=>se.removeEventListener(te,ue),$e=new s({onWillAddFirstListener:ce,onDidRemoveLastListener:me});return $e.event}O.fromDOMEventEmitter=J;function ee(se){return new Promise(te=>Y(se)(te))}O.toPromise=ee;function he(se){const te=new s;return se.then(ae=>{te.fire(ae)},()=>{te.fire(void 0)}).finally(()=>{te.dispose()}),te.event}O.fromPromise=he;function de(se,te,ae){return te(ae),se(ue=>te(ue))}O.runAndSubscribe=de;class Le{constructor(te,ae){this._observable=te,this.f=0,this.g=!1;const ue={onWillAddFirstListener:()=>{te.addObserver(this)},onDidRemoveLastListener:()=>{te.removeObserver(this)}};ae||S(ue),this.emitter=new s(ue),ae&&ae.add(this.emitter)}beginUpdate(te){this.f++}handlePossibleChange(te){}handleChange(te,ae){this.g=!0}endUpdate(te){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function Ne(se,te){return new Le(se,te).emitter.event}O.fromObservable=Ne;function _e(se){return(te,ae,ue)=>{let ce=0,me=!1;const $e={beginUpdate(){ce++},endUpdate(){ce--,ce===0&&(se.reportChanges(),me&&(me=!1,te.call(ae)))},handlePossibleChange(){},handleChange(){me=!0}};se.addObserver($e),se.reportChanges();const Ee={dispose(){se.removeObserver($e)}};return ue instanceof p.$Tc?ue.add(Ee):Array.isArray(ue)&&ue.push(Ee),Ee}}O.fromObservableLight=_e})(f||(i.Event=f={}));class ${static{this.all=new Set}static{this.f=0}constructor(S){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${S}_${$.f++}`,$.all.add(this)}start(S){this.g=new v.$be,this.listenerCount=S}stop(){if(this.g){const S=this.g.elapsed();this.durations.push(S),this.elapsedOverall+=S,this.invocationCount+=1,this.g=void 0}}}i.$de=$;let b=-1;function L(O){const S=b;return b=O,{dispose(){b=S}}}class e{constructor(S,X,Y=Math.random().toString(18).slice(2,5)){this.h=S,this.threshold=X,this.name=Y,this.g=0}dispose(){this.f?.clear()}check(S,X){const Y=this.threshold;if(Y<=0||X<Y)return;this.f||(this.f=new Map);const H=this.f.get(S.value)||0;if(this.f.set(S.value,H+1),this.g-=1,this.g<=0){this.g=Y*.5;const[Q,C]=this.getMostFrequentStack(),F=`[${this.name}] potential listener LEAK detected, having ${X} listeners already. MOST frequent listener (${C}):`;console.warn(F),console.warn(Q);const z=new E(F,Q);this.h(z)}return()=>{const Q=this.f.get(S.value)||0;this.f.set(S.value,Q-1)}}getMostFrequentStack(){if(!this.f)return;let S,X=0;for(const[Y,H]of this.f)(!S||X<H)&&(S=[Y,H],X=H);return S}}class m{static create(){const S=new Error;return new m(S.stack??"")}constructor(S){this.value=S}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class E extends Error{constructor(S,X){super(S),this.name="ListenerLeakError",this.stack=X}}i.$fe=E;class R extends Error{constructor(S,X){super(S),this.name="ListenerRefusalError",this.stack=X}}i.$ge=R;let A=0;class w{constructor(S){this.value=S,this.id=A++}}const N=2,c=(O,S)=>{if(O instanceof w)S(O);else for(let X=0;X<O.length;X++){const Y=O[X];Y&&S(Y)}},u=d?new FinalizationRegistry(O=>{typeof O=="string"&&(console.warn("[LEAKING LISTENER] GC'ed a listener that was NOT yet disposed. This is where is was created:"),console.warn(O))}):void 0;class s{constructor(S){this.w=0,this.f=S,this.g=b>0||this.f?.leakWarningThreshold?new e(S?.onListenerError??t.$1,this.f?.leakWarningThreshold??b):void 0,this.j=this.f?._profName?new $(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(a){const S=this.t;queueMicrotask(()=>{c(S,X=>X.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(S,X,Y)=>{if(this.g&&this.w>this.g.threshold**2){const z=`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far (${this.w} vs ${this.g.threshold})`;console.warn(z);const fe=this.g.getMostFrequentStack()??["UNKNOWN stack",-1],oe=new R(`${z}. HINT: Stack shows most frequent listener (${fe[1]}-times)`,fe[0]);return(this.f?.onListenerError||t.$1)(oe),p.$Uc.None}if(this.m)return p.$Uc.None;X&&(S=S.bind(X));const H=new w(S);let Q,C;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(H.stack=m.create(),Q=this.g.check(H.stack,this.w+1)),a&&(H.stack=C??m.create()),this.t?this.t instanceof w?(this.u??=new h,this.t=[this.t,H]):this.t.push(H):(this.f?.onWillAddFirstListener?.(this),this.t=H,this.f?.onDidAddFirstListener?.(this)),this.w++;const F=(0,p.$Sc)(()=>{u?.unregister(F),Q?.(),this.x(H)});if(Y instanceof p.$Tc?Y.add(F):Array.isArray(Y)&&Y.push(F),u){const z=new Error().stack.split(`
`).slice(2).join(`
`).trim();u.register(F,z,F)}return F},this.q}x(S){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const X=this.t,Y=X.indexOf(S);if(Y===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,X[Y]=void 0;const H=this.u.current===this;if(this.w*N<=X.length){let Q=0;for(let C=0;C<X.length;C++)X[C]?X[Q++]=X[C]:H&&(this.u.end--,Q<this.u.i&&this.u.i--);X.length=Q}}y(S,X){if(!S)return;const Y=this.f?.onListenerError||t.$1;if(!Y){S.value(X);return}try{S.value(X)}catch(H){Y(H)}}z(S){const X=S.current.t;for(;S.i<S.end;)this.y(X[S.i++],S.value);S.reset()}fire(S){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof w)this.y(this.t,S);else{const X=this.u;X.enqueue(this,S,this.t.length),this.z(X)}this.j?.stop()}hasListeners(){return this.w>0}}i.$he=s;const o=()=>new h;i.$ie=o;class h{constructor(){this.i=-1,this.end=0}enqueue(S,X,Y){this.i=0,this.end=Y,this.current=S,this.value=X}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class T extends s{async fireAsync(S,X,Y){if(this.t)for(this.h||(this.h=new g.$5c),c(this.t,H=>this.h.push([H.value,S]));this.h.size>0&&!X.isCancellationRequested;){const[H,Q]=this.h.shift(),C=[],F={...Q,token:X,waitUntil:z=>{if(Object.isFrozen(C))throw new Error("waitUntil can NOT be called asynchronous");Y&&(z=Y(z,H)),C.push(z)}};try{H(F)}catch(z){(0,t.$1)(z);continue}Object.freeze(C),await Promise.allSettled(C).then(z=>{for(const fe of z)fe.status==="rejected"&&(0,t.$1)(fe.reason)})}}}i.$je=T;class _ extends s{get isPaused(){return this.h!==0}constructor(S){super(S),this.h=0,this.s=new g.$5c,this.A=S?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const S=Array.from(this.s);this.s.clear(),super.fire(this.A(S))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(S){this.w&&(this.h!==0?this.s.push(S):super.fire(S))}}i.$ke=_;class U extends _{constructor(S){super(S),this.k=S.delay??100}fire(S){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(S)}}i.$le=U;class M extends s{constructor(S){super(S),this.h=[],this.k=S?.merge}fire(S){this.hasListeners()&&(this.h.push(S),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(X=>super.fire(X)),this.h=[]}))}}i.$me=M;class D{constructor(){this.g=!1,this.h=[],this.f=new s({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(S){const X={event:S,listener:null};this.h.push(X),this.g&&this.m(X);const Y=()=>{this.g&&this.o(X);const H=this.h.indexOf(X);this.h.splice(H,1)};return(0,p.$Sc)((0,n.$db)(Y))}j(){this.g=!0,this.h.forEach(S=>this.m(S))}k(){this.g=!1,this.h.forEach(S=>this.o(S))}m(S){S.listener=S.event(X=>this.f.fire(X))}o(S){S.listener?.dispose(),S.listener=null}dispose(){this.f.dispose();for(const S of this.h)S.listener?.dispose();this.h=[]}}i.$ne=D;class k{constructor(S,X,Y,H){this.f=new p.$Tc;const Q=this.f.add(new D),C=this.f.add(new p.$4c);function F(z){C.set(z,Q.add(H(z)))}for(const z of S)F(z);this.f.add(X(z=>{F(z)})),this.f.add(Y(z=>{C.deleteAndDispose(z)})),this.event=Q.event}dispose(){this.f.dispose()}}i.$oe=k;class P{constructor(){this.f=[]}wrapEvent(S,X,Y){return(H,Q,C)=>S(F=>{const z=this.f[this.f.length-1];if(!X){z?z.buffers.push(()=>H.call(Q,F)):H.call(Q,F);return}const fe=z;if(!fe){H.call(Q,X(Y,F));return}fe.items??=[],fe.items.push(F),fe.buffers.length===0&&z.buffers.push(()=>{fe.reducedResult??=Y?fe.items.reduce(X,Y):fe.items.reduce(X),H.call(Q,fe.reducedResult)})},void 0,C)}bufferEvents(S){const X={buffers:new Array};this.f.push(X);const Y=S();return this.f.pop(),X.buffers.forEach(H=>H()),Y}}i.$pe=P;class j{constructor(){this.f=!1,this.g=f.None,this.h=p.$Uc.None,this.j=new s({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(S){this.g=S,this.f&&(this.h.dispose(),this.h=S(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}i.$qe=j;class B{static const(S){return new Z(S)}constructor(S){this.g=S,this.f=new s,this.onDidChange=this.f.event}get value(){return this.g}set value(S){S!==this.g&&(this.g=S,this.f.fire(void 0))}}i.$re=B;class Z{constructor(S){this.value=S,this.onDidChange=f.None}}}),ne(ie[26],re([0,1,13]),function(q,i,t){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$se=i.CancellationToken=void 0,i.$te=d;const n=Object.freeze(function(a,l){const f=setTimeout(a.bind(l),0);return{dispose(){clearTimeout(f)}}});var p;(function(a){function l(f){return f===a.None||f===a.Cancelled||f instanceof g?!0:!f||typeof f!="object"?!1:typeof f.isCancellationRequested=="boolean"&&typeof f.onCancellationRequested=="function"}a.isCancellationToken=l,a.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:t.Event.None}),a.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:n})})(p||(i.CancellationToken=p={}));class g{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?n:(this.b||(this.b=new t.$he),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class v{constructor(l){this.f=void 0,this.g=void 0,this.g=l&&l.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new g),this.f}cancel(){this.f?this.f instanceof g&&this.f.cancel():this.f=p.Cancelled}dispose(l=!1){l&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof g&&this.f.dispose():this.f=p.None}}i.$se=v;function d(a){const l=new v;return a.add({dispose(){l.cancel()}}),l.token}}),ne(ie[43],re([0,1,26]),function(q,i,t){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$8e=i.$7e=i.$5e=void 0,i.$6e=p;class n{constructor(a){this.b=a,this.a=null}get(){if(this.a)return this.a;const a=new t.$se,l=this.b(a.token);return this.a={promise:l,dispose:()=>{this.a=null,a.cancel(),a.dispose()}},this.a}}i.$5e=n;function p(d){return d}class g{constructor(a,l){this.a=void 0,this.b=void 0,typeof a=="function"?(this.c=a,this.d=p):(this.c=l,this.d=a.getCacheKey)}get(a){const l=this.d(a);return this.b!==l&&(this.b=l,this.a=this.c(a)),this.a}}i.$7e=g;class v{get cachedValues(){return this.a}constructor(a,l){this.a=new Map,this.b=new Map,typeof a=="function"?(this.c=a,this.d=p):(this.c=l,this.d=a.getCacheKey)}get(a){const l=this.d(a);if(this.b.has(l))return this.b.get(l);const f=this.c(a);return this.a.set(a,f),this.b.set(l,f),f}}i.$8e=v}),ne(ie[27],re([0,1]),function(q,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$ag=t,i.$bg=n,i.$cg=p,i.$dg=g,i.$eg=v,i.$fg=d,i.$gg=a,i.$hg=l,i.$ig=f,i.$jg=$,i.$kg=b,i.$lg=L,i.$mg=e,i.$ng=E,i.$og=R,i.$pg=A,i.$qg=w,i.$rg=N;function t(c){return typeof c=="string"}function n(c){return Array.isArray(c)&&c.every(u=>t(u))}function p(c){return typeof c=="object"&&c!==null&&!Array.isArray(c)&&!(c instanceof RegExp)&&!(c instanceof Date)}function g(c){const u=Object.getPrototypeOf(Uint8Array);return typeof c=="object"&&c instanceof u}function v(c){return typeof c=="number"&&!isNaN(c)}function d(c){return!!c&&typeof c[Symbol.iterator]=="function"}function a(c){return c===!0||c===!1}function l(c){return typeof c>"u"}function f(c){return!$(c)}function $(c){return l(c)||c===null}function b(c,u){if(!c)throw new Error(u?`Unexpected type, expected '${u}'`:"Unexpected type")}function L(c){if($(c))throw new Error("Assertion Failed: argument is undefined or null");return c}function e(...c){const u=[];for(let s=0;s<c.length;s++){const o=c[s];if($(o))throw new Error(`Assertion Failed: argument at index ${s} is undefined or null`);u.push(o)}return u}const m=Object.prototype.hasOwnProperty;function E(c){if(!p(c))return!1;for(const u in c)if(m.call(c,u))return!1;return!0}function R(c){return typeof c=="function"}function A(...c){return c.length>0&&c.every(R)}function w(c,u){const s=Math.min(c.length,u.length);for(let o=0;o<s;o++)N(c[o],u[o])}function N(c,u){if(t(u)){if(typeof c!==u)throw new Error(`argument does not match constraint: typeof ${u}`)}else if(R(u)){try{if(c instanceof u)return}catch{}if(!$(c)&&c.constructor===u||u.length===1&&u.call(void 0,c)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}}),ne(ie[28],re([0,1,27]),function(q,i,t){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$Uj=p,i.$Vj=g;const n=Object.create(null);function p(v,d){if((0,t.$ag)(d)){const a=n[d];if(a===void 0)throw new Error(`${v} references an unknown codicon: ${d}`);d=a}return n[v]=d,{id:v}}function g(){return n}}),ne(ie[44],re([0,1,28]),function(q,i,t){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$Wj=void 0,i.$Wj={add:(0,t.$Uj)("add",6e4),plus:(0,t.$Uj)("plus",6e4),gistNew:(0,t.$Uj)("gist-new",6e4),repoCreate:(0,t.$Uj)("repo-create",6e4),lightbulb:(0,t.$Uj)("lightbulb",60001),lightBulb:(0,t.$Uj)("light-bulb",60001),repo:(0,t.$Uj)("repo",60002),repoDelete:(0,t.$Uj)("repo-delete",60002),gistFork:(0,t.$Uj)("gist-fork",60003),repoForked:(0,t.$Uj)("repo-forked",60003),gitPullRequest:(0,t.$Uj)("git-pull-request",60004),gitPullRequestAbandoned:(0,t.$Uj)("git-pull-request-abandoned",60004),recordKeys:(0,t.$Uj)("record-keys",60005),keyboard:(0,t.$Uj)("keyboard",60005),tag:(0,t.$Uj)("tag",60006),gitPullRequestLabel:(0,t.$Uj)("git-pull-request-label",60006),tagAdd:(0,t.$Uj)("tag-add",60006),tagRemove:(0,t.$Uj)("tag-remove",60006),person:(0,t.$Uj)("person",60007),personFollow:(0,t.$Uj)("person-follow",60007),personOutline:(0,t.$Uj)("person-outline",60007),personFilled:(0,t.$Uj)("person-filled",60007),gitBranch:(0,t.$Uj)("git-branch",60008),gitBranchCreate:(0,t.$Uj)("git-branch-create",60008),gitBranchDelete:(0,t.$Uj)("git-branch-delete",60008),sourceControl:(0,t.$Uj)("source-control",60008),mirror:(0,t.$Uj)("mirror",60009),mirrorPublic:(0,t.$Uj)("mirror-public",60009),star:(0,t.$Uj)("star",60010),starAdd:(0,t.$Uj)("star-add",60010),starDelete:(0,t.$Uj)("star-delete",60010),starEmpty:(0,t.$Uj)("star-empty",60010),comment:(0,t.$Uj)("comment",60011),commentAdd:(0,t.$Uj)("comment-add",60011),alert:(0,t.$Uj)("alert",60012),warning:(0,t.$Uj)("warning",60012),search:(0,t.$Uj)("search",60013),searchSave:(0,t.$Uj)("search-save",60013),logOut:(0,t.$Uj)("log-out",60014),signOut:(0,t.$Uj)("sign-out",60014),logIn:(0,t.$Uj)("log-in",60015),signIn:(0,t.$Uj)("sign-in",60015),eye:(0,t.$Uj)("eye",60016),eyeUnwatch:(0,t.$Uj)("eye-unwatch",60016),eyeWatch:(0,t.$Uj)("eye-watch",60016),circleFilled:(0,t.$Uj)("circle-filled",60017),primitiveDot:(0,t.$Uj)("primitive-dot",60017),closeDirty:(0,t.$Uj)("close-dirty",60017),debugBreakpoint:(0,t.$Uj)("debug-breakpoint",60017),debugBreakpointDisabled:(0,t.$Uj)("debug-breakpoint-disabled",60017),debugHint:(0,t.$Uj)("debug-hint",60017),terminalDecorationSuccess:(0,t.$Uj)("terminal-decoration-success",60017),primitiveSquare:(0,t.$Uj)("primitive-square",60018),edit:(0,t.$Uj)("edit",60019),pencil:(0,t.$Uj)("pencil",60019),info:(0,t.$Uj)("info",60020),issueOpened:(0,t.$Uj)("issue-opened",60020),gistPrivate:(0,t.$Uj)("gist-private",60021),gitForkPrivate:(0,t.$Uj)("git-fork-private",60021),lock:(0,t.$Uj)("lock",60021),mirrorPrivate:(0,t.$Uj)("mirror-private",60021),close:(0,t.$Uj)("close",60022),removeClose:(0,t.$Uj)("remove-close",60022),x:(0,t.$Uj)("x",60022),repoSync:(0,t.$Uj)("repo-sync",60023),sync:(0,t.$Uj)("sync",60023),clone:(0,t.$Uj)("clone",60024),desktopDownload:(0,t.$Uj)("desktop-download",60024),beaker:(0,t.$Uj)("beaker",60025),microscope:(0,t.$Uj)("microscope",60025),vm:(0,t.$Uj)("vm",60026),deviceDesktop:(0,t.$Uj)("device-desktop",60026),file:(0,t.$Uj)("file",60027),fileText:(0,t.$Uj)("file-text",60027),more:(0,t.$Uj)("more",60028),ellipsis:(0,t.$Uj)("ellipsis",60028),kebabHorizontal:(0,t.$Uj)("kebab-horizontal",60028),mailReply:(0,t.$Uj)("mail-reply",60029),reply:(0,t.$Uj)("reply",60029),organization:(0,t.$Uj)("organization",60030),organizationFilled:(0,t.$Uj)("organization-filled",60030),organizationOutline:(0,t.$Uj)("organization-outline",60030),newFile:(0,t.$Uj)("new-file",60031),fileAdd:(0,t.$Uj)("file-add",60031),newFolder:(0,t.$Uj)("new-folder",60032),fileDirectoryCreate:(0,t.$Uj)("file-directory-create",60032),trash:(0,t.$Uj)("trash",60033),trashcan:(0,t.$Uj)("trashcan",60033),history:(0,t.$Uj)("history",60034),clock:(0,t.$Uj)("clock",60034),folder:(0,t.$Uj)("folder",60035),fileDirectory:(0,t.$Uj)("file-directory",60035),symbolFolder:(0,t.$Uj)("symbol-folder",60035),logoGithub:(0,t.$Uj)("logo-github",60036),markGithub:(0,t.$Uj)("mark-github",60036),github:(0,t.$Uj)("github",60036),terminal:(0,t.$Uj)("terminal",60037),console:(0,t.$Uj)("console",60037),repl:(0,t.$Uj)("repl",60037),zap:(0,t.$Uj)("zap",60038),symbolEvent:(0,t.$Uj)("symbol-event",60038),error:(0,t.$Uj)("error",60039),stop:(0,t.$Uj)("stop",60039),variable:(0,t.$Uj)("variable",60040),symbolVariable:(0,t.$Uj)("symbol-variable",60040),array:(0,t.$Uj)("array",60042),symbolArray:(0,t.$Uj)("symbol-array",60042),symbolModule:(0,t.$Uj)("symbol-module",60043),symbolPackage:(0,t.$Uj)("symbol-package",60043),symbolNamespace:(0,t.$Uj)("symbol-namespace",60043),symbolObject:(0,t.$Uj)("symbol-object",60043),symbolMethod:(0,t.$Uj)("symbol-method",60044),symbolFunction:(0,t.$Uj)("symbol-function",60044),symbolConstructor:(0,t.$Uj)("symbol-constructor",60044),symbolBoolean:(0,t.$Uj)("symbol-boolean",60047),symbolNull:(0,t.$Uj)("symbol-null",60047),symbolNumeric:(0,t.$Uj)("symbol-numeric",60048),symbolNumber:(0,t.$Uj)("symbol-number",60048),symbolStructure:(0,t.$Uj)("symbol-structure",60049),symbolStruct:(0,t.$Uj)("symbol-struct",60049),symbolParameter:(0,t.$Uj)("symbol-parameter",60050),symbolTypeParameter:(0,t.$Uj)("symbol-type-parameter",60050),symbolKey:(0,t.$Uj)("symbol-key",60051),symbolText:(0,t.$Uj)("symbol-text",60051),symbolReference:(0,t.$Uj)("symbol-reference",60052),goToFile:(0,t.$Uj)("go-to-file",60052),symbolEnum:(0,t.$Uj)("symbol-enum",60053),symbolValue:(0,t.$Uj)("symbol-value",60053),symbolRuler:(0,t.$Uj)("symbol-ruler",60054),symbolUnit:(0,t.$Uj)("symbol-unit",60054),activateBreakpoints:(0,t.$Uj)("activate-breakpoints",60055),archive:(0,t.$Uj)("archive",60056),arrowBoth:(0,t.$Uj)("arrow-both",60057),arrowDown:(0,t.$Uj)("arrow-down",60058),arrowLeft:(0,t.$Uj)("arrow-left",60059),arrowRight:(0,t.$Uj)("arrow-right",60060),arrowSmallDown:(0,t.$Uj)("arrow-small-down",60061),arrowSmallLeft:(0,t.$Uj)("arrow-small-left",60062),arrowSmallRight:(0,t.$Uj)("arrow-small-right",60063),arrowSmallUp:(0,t.$Uj)("arrow-small-up",60064),arrowUp:(0,t.$Uj)("arrow-up",60065),bell:(0,t.$Uj)("bell",60066),bold:(0,t.$Uj)("bold",60067),book:(0,t.$Uj)("book",60068),bookmark:(0,t.$Uj)("bookmark",60069),debugBreakpointConditionalUnverified:(0,t.$Uj)("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:(0,t.$Uj)("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:(0,t.$Uj)("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:(0,t.$Uj)("debug-breakpoint-data-unverified",60072),debugBreakpointData:(0,t.$Uj)("debug-breakpoint-data",60073),debugBreakpointDataDisabled:(0,t.$Uj)("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:(0,t.$Uj)("debug-breakpoint-log-unverified",60074),debugBreakpointLog:(0,t.$Uj)("debug-breakpoint-log",60075),debugBreakpointLogDisabled:(0,t.$Uj)("debug-breakpoint-log-disabled",60075),briefcase:(0,t.$Uj)("briefcase",60076),broadcast:(0,t.$Uj)("broadcast",60077),browser:(0,t.$Uj)("browser",60078),bug:(0,t.$Uj)("bug",60079),calendar:(0,t.$Uj)("calendar",60080),caseSensitive:(0,t.$Uj)("case-sensitive",60081),check:(0,t.$Uj)("check",60082),checklist:(0,t.$Uj)("checklist",60083),chevronDown:(0,t.$Uj)("chevron-down",60084),chevronLeft:(0,t.$Uj)("chevron-left",60085),chevronRight:(0,t.$Uj)("chevron-right",60086),chevronUp:(0,t.$Uj)("chevron-up",60087),chromeClose:(0,t.$Uj)("chrome-close",60088),chromeMaximize:(0,t.$Uj)("chrome-maximize",60089),chromeMinimize:(0,t.$Uj)("chrome-minimize",60090),chromeRestore:(0,t.$Uj)("chrome-restore",60091),circleOutline:(0,t.$Uj)("circle-outline",60092),circle:(0,t.$Uj)("circle",60092),debugBreakpointUnverified:(0,t.$Uj)("debug-breakpoint-unverified",60092),terminalDecorationIncomplete:(0,t.$Uj)("terminal-decoration-incomplete",60092),circleSlash:(0,t.$Uj)("circle-slash",60093),circuitBoard:(0,t.$Uj)("circuit-board",60094),clearAll:(0,t.$Uj)("clear-all",60095),clippy:(0,t.$Uj)("clippy",60096),closeAll:(0,t.$Uj)("close-all",60097),cloudDownload:(0,t.$Uj)("cloud-download",60098),cloudUpload:(0,t.$Uj)("cloud-upload",60099),code:(0,t.$Uj)("code",60100),collapseAll:(0,t.$Uj)("collapse-all",60101),colorMode:(0,t.$Uj)("color-mode",60102),commentDiscussion:(0,t.$Uj)("comment-discussion",60103),creditCard:(0,t.$Uj)("credit-card",60105),dash:(0,t.$Uj)("dash",60108),dashboard:(0,t.$Uj)("dashboard",60109),database:(0,t.$Uj)("database",60110),debugContinue:(0,t.$Uj)("debug-continue",60111),debugDisconnect:(0,t.$Uj)("debug-disconnect",60112),debugPause:(0,t.$Uj)("debug-pause",60113),debugRestart:(0,t.$Uj)("debug-restart",60114),debugStart:(0,t.$Uj)("debug-start",60115),debugStepInto:(0,t.$Uj)("debug-step-into",60116),debugStepOut:(0,t.$Uj)("debug-step-out",60117),debugStepOver:(0,t.$Uj)("debug-step-over",60118),debugStop:(0,t.$Uj)("debug-stop",60119),debug:(0,t.$Uj)("debug",60120),deviceCameraVideo:(0,t.$Uj)("device-camera-video",60121),deviceCamera:(0,t.$Uj)("device-camera",60122),deviceMobile:(0,t.$Uj)("device-mobile",60123),diffAdded:(0,t.$Uj)("diff-added",60124),diffIgnored:(0,t.$Uj)("diff-ignored",60125),diffModified:(0,t.$Uj)("diff-modified",60126),diffRemoved:(0,t.$Uj)("diff-removed",60127),diffRenamed:(0,t.$Uj)("diff-renamed",60128),diff:(0,t.$Uj)("diff",60129),diffSidebyside:(0,t.$Uj)("diff-sidebyside",60129),discard:(0,t.$Uj)("discard",60130),editorLayout:(0,t.$Uj)("editor-layout",60131),emptyWindow:(0,t.$Uj)("empty-window",60132),exclude:(0,t.$Uj)("exclude",60133),extensions:(0,t.$Uj)("extensions",60134),eyeClosed:(0,t.$Uj)("eye-closed",60135),fileBinary:(0,t.$Uj)("file-binary",60136),fileCode:(0,t.$Uj)("file-code",60137),fileMedia:(0,t.$Uj)("file-media",60138),filePdf:(0,t.$Uj)("file-pdf",60139),fileSubmodule:(0,t.$Uj)("file-submodule",60140),fileSymlinkDirectory:(0,t.$Uj)("file-symlink-directory",60141),fileSymlinkFile:(0,t.$Uj)("file-symlink-file",60142),fileZip:(0,t.$Uj)("file-zip",60143),files:(0,t.$Uj)("files",60144),filter:(0,t.$Uj)("filter",60145),flame:(0,t.$Uj)("flame",60146),foldDown:(0,t.$Uj)("fold-down",60147),foldUp:(0,t.$Uj)("fold-up",60148),fold:(0,t.$Uj)("fold",60149),folderActive:(0,t.$Uj)("folder-active",60150),folderOpened:(0,t.$Uj)("folder-opened",60151),gear:(0,t.$Uj)("gear",60152),gift:(0,t.$Uj)("gift",60153),gistSecret:(0,t.$Uj)("gist-secret",60154),gist:(0,t.$Uj)("gist",60155),gitCommit:(0,t.$Uj)("git-commit",60156),gitCompare:(0,t.$Uj)("git-compare",60157),compareChanges:(0,t.$Uj)("compare-changes",60157),gitMerge:(0,t.$Uj)("git-merge",60158),githubAction:(0,t.$Uj)("github-action",60159),githubAlt:(0,t.$Uj)("github-alt",60160),globe:(0,t.$Uj)("globe",60161),grabber:(0,t.$Uj)("grabber",60162),graph:(0,t.$Uj)("graph",60163),gripper:(0,t.$Uj)("gripper",60164),heart:(0,t.$Uj)("heart",60165),home:(0,t.$Uj)("home",60166),horizontalRule:(0,t.$Uj)("horizontal-rule",60167),hubot:(0,t.$Uj)("hubot",60168),inbox:(0,t.$Uj)("inbox",60169),issueReopened:(0,t.$Uj)("issue-reopened",60171),issues:(0,t.$Uj)("issues",60172),italic:(0,t.$Uj)("italic",60173),jersey:(0,t.$Uj)("jersey",60174),json:(0,t.$Uj)("json",60175),kebabVertical:(0,t.$Uj)("kebab-vertical",60176),key:(0,t.$Uj)("key",60177),law:(0,t.$Uj)("law",60178),lightbulbAutofix:(0,t.$Uj)("lightbulb-autofix",60179),linkExternal:(0,t.$Uj)("link-external",60180),link:(0,t.$Uj)("link",60181),listOrdered:(0,t.$Uj)("list-ordered",60182),listUnordered:(0,t.$Uj)("list-unordered",60183),liveShare:(0,t.$Uj)("live-share",60184),loading:(0,t.$Uj)("loading",60185),location:(0,t.$Uj)("location",60186),mailRead:(0,t.$Uj)("mail-read",60187),mail:(0,t.$Uj)("mail",60188),markdown:(0,t.$Uj)("markdown",60189),megaphone:(0,t.$Uj)("megaphone",60190),mention:(0,t.$Uj)("mention",60191),milestone:(0,t.$Uj)("milestone",60192),gitPullRequestMilestone:(0,t.$Uj)("git-pull-request-milestone",60192),mortarBoard:(0,t.$Uj)("mortar-board",60193),move:(0,t.$Uj)("move",60194),multipleWindows:(0,t.$Uj)("multiple-windows",60195),mute:(0,t.$Uj)("mute",60196),noNewline:(0,t.$Uj)("no-newline",60197),note:(0,t.$Uj)("note",60198),octoface:(0,t.$Uj)("octoface",60199),openPreview:(0,t.$Uj)("open-preview",60200),package:(0,t.$Uj)("package",60201),paintcan:(0,t.$Uj)("paintcan",60202),pin:(0,t.$Uj)("pin",60203),play:(0,t.$Uj)("play",60204),run:(0,t.$Uj)("run",60204),plug:(0,t.$Uj)("plug",60205),preserveCase:(0,t.$Uj)("preserve-case",60206),preview:(0,t.$Uj)("preview",60207),project:(0,t.$Uj)("project",60208),pulse:(0,t.$Uj)("pulse",60209),question:(0,t.$Uj)("question",60210),quote:(0,t.$Uj)("quote",60211),radioTower:(0,t.$Uj)("radio-tower",60212),reactions:(0,t.$Uj)("reactions",60213),references:(0,t.$Uj)("references",60214),refresh:(0,t.$Uj)("refresh",60215),regex:(0,t.$Uj)("regex",60216),remoteExplorer:(0,t.$Uj)("remote-explorer",60217),remote:(0,t.$Uj)("remote",60218),remove:(0,t.$Uj)("remove",60219),replaceAll:(0,t.$Uj)("replace-all",60220),replace:(0,t.$Uj)("replace",60221),repoClone:(0,t.$Uj)("repo-clone",60222),repoForcePush:(0,t.$Uj)("repo-force-push",60223),repoPull:(0,t.$Uj)("repo-pull",60224),repoPush:(0,t.$Uj)("repo-push",60225),report:(0,t.$Uj)("report",60226),requestChanges:(0,t.$Uj)("request-changes",60227),rocket:(0,t.$Uj)("rocket",60228),rootFolderOpened:(0,t.$Uj)("root-folder-opened",60229),rootFolder:(0,t.$Uj)("root-folder",60230),rss:(0,t.$Uj)("rss",60231),ruby:(0,t.$Uj)("ruby",60232),saveAll:(0,t.$Uj)("save-all",60233),saveAs:(0,t.$Uj)("save-as",60234),save:(0,t.$Uj)("save",60235),screenFull:(0,t.$Uj)("screen-full",60236),screenNormal:(0,t.$Uj)("screen-normal",60237),searchStop:(0,t.$Uj)("search-stop",60238),server:(0,t.$Uj)("server",60240),settingsGear:(0,t.$Uj)("settings-gear",60241),settings:(0,t.$Uj)("settings",60242),shield:(0,t.$Uj)("shield",60243),smiley:(0,t.$Uj)("smiley",60244),sortPrecedence:(0,t.$Uj)("sort-precedence",60245),splitHorizontal:(0,t.$Uj)("split-horizontal",60246),splitVertical:(0,t.$Uj)("split-vertical",60247),squirrel:(0,t.$Uj)("squirrel",60248),starFull:(0,t.$Uj)("star-full",60249),starHalf:(0,t.$Uj)("star-half",60250),symbolClass:(0,t.$Uj)("symbol-class",60251),symbolColor:(0,t.$Uj)("symbol-color",60252),symbolConstant:(0,t.$Uj)("symbol-constant",60253),symbolEnumMember:(0,t.$Uj)("symbol-enum-member",60254),symbolField:(0,t.$Uj)("symbol-field",60255),symbolFile:(0,t.$Uj)("symbol-file",60256),symbolInterface:(0,t.$Uj)("symbol-interface",60257),symbolKeyword:(0,t.$Uj)("symbol-keyword",60258),symbolMisc:(0,t.$Uj)("symbol-misc",60259),symbolOperator:(0,t.$Uj)("symbol-operator",60260),symbolProperty:(0,t.$Uj)("symbol-property",60261),wrench:(0,t.$Uj)("wrench",60261),wrenchSubaction:(0,t.$Uj)("wrench-subaction",60261),symbolSnippet:(0,t.$Uj)("symbol-snippet",60262),tasklist:(0,t.$Uj)("tasklist",60263),telescope:(0,t.$Uj)("telescope",60264),textSize:(0,t.$Uj)("text-size",60265),threeBars:(0,t.$Uj)("three-bars",60266),thumbsdown:(0,t.$Uj)("thumbsdown",60267),thumbsup:(0,t.$Uj)("thumbsup",60268),tools:(0,t.$Uj)("tools",60269),triangleDown:(0,t.$Uj)("triangle-down",60270),triangleLeft:(0,t.$Uj)("triangle-left",60271),triangleRight:(0,t.$Uj)("triangle-right",60272),triangleUp:(0,t.$Uj)("triangle-up",60273),twitter:(0,t.$Uj)("twitter",60274),unfold:(0,t.$Uj)("unfold",60275),unlock:(0,t.$Uj)("unlock",60276),unmute:(0,t.$Uj)("unmute",60277),unverified:(0,t.$Uj)("unverified",60278),verified:(0,t.$Uj)("verified",60279),versions:(0,t.$Uj)("versions",60280),vmActive:(0,t.$Uj)("vm-active",60281),vmOutline:(0,t.$Uj)("vm-outline",60282),vmRunning:(0,t.$Uj)("vm-running",60283),watch:(0,t.$Uj)("watch",60284),whitespace:(0,t.$Uj)("whitespace",60285),wholeWord:(0,t.$Uj)("whole-word",60286),window:(0,t.$Uj)("window",60287),wordWrap:(0,t.$Uj)("word-wrap",60288),zoomIn:(0,t.$Uj)("zoom-in",60289),zoomOut:(0,t.$Uj)("zoom-out",60290),listFilter:(0,t.$Uj)("list-filter",60291),listFlat:(0,t.$Uj)("list-flat",60292),listSelection:(0,t.$Uj)("list-selection",60293),selection:(0,t.$Uj)("selection",60293),listTree:(0,t.$Uj)("list-tree",60294),debugBreakpointFunctionUnverified:(0,t.$Uj)("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:(0,t.$Uj)("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:(0,t.$Uj)("debug-breakpoint-function-disabled",60296),debugStackframeActive:(0,t.$Uj)("debug-stackframe-active",60297),circleSmallFilled:(0,t.$Uj)("circle-small-filled",60298),debugStackframeDot:(0,t.$Uj)("debug-stackframe-dot",60298),terminalDecorationMark:(0,t.$Uj)("terminal-decoration-mark",60298),debugStackframe:(0,t.$Uj)("debug-stackframe",60299),debugStackframeFocused:(0,t.$Uj)("debug-stackframe-focused",60299),debugBreakpointUnsupported:(0,t.$Uj)("debug-breakpoint-unsupported",60300),symbolString:(0,t.$Uj)("symbol-string",60301),debugReverseContinue:(0,t.$Uj)("debug-reverse-continue",60302),debugStepBack:(0,t.$Uj)("debug-step-back",60303),debugRestartFrame:(0,t.$Uj)("debug-restart-frame",60304),debugAlt:(0,t.$Uj)("debug-alt",60305),callIncoming:(0,t.$Uj)("call-incoming",60306),callOutgoing:(0,t.$Uj)("call-outgoing",60307),menu:(0,t.$Uj)("menu",60308),expandAll:(0,t.$Uj)("expand-all",60309),feedback:(0,t.$Uj)("feedback",60310),gitPullRequestReviewer:(0,t.$Uj)("git-pull-request-reviewer",60310),groupByRefType:(0,t.$Uj)("group-by-ref-type",60311),ungroupByRefType:(0,t.$Uj)("ungroup-by-ref-type",60312),account:(0,t.$Uj)("account",60313),gitPullRequestAssignee:(0,t.$Uj)("git-pull-request-assignee",60313),bellDot:(0,t.$Uj)("bell-dot",60314),debugConsole:(0,t.$Uj)("debug-console",60315),library:(0,t.$Uj)("library",60316),output:(0,t.$Uj)("output",60317),runAll:(0,t.$Uj)("run-all",60318),syncIgnored:(0,t.$Uj)("sync-ignored",60319),pinned:(0,t.$Uj)("pinned",60320),githubInverted:(0,t.$Uj)("github-inverted",60321),serverProcess:(0,t.$Uj)("server-process",60322),serverEnvironment:(0,t.$Uj)("server-environment",60323),pass:(0,t.$Uj)("pass",60324),issueClosed:(0,t.$Uj)("issue-closed",60324),stopCircle:(0,t.$Uj)("stop-circle",60325),playCircle:(0,t.$Uj)("play-circle",60326),record:(0,t.$Uj)("record",60327),debugAltSmall:(0,t.$Uj)("debug-alt-small",60328),vmConnect:(0,t.$Uj)("vm-connect",60329),cloud:(0,t.$Uj)("cloud",60330),merge:(0,t.$Uj)("merge",60331),export:(0,t.$Uj)("export",60332),graphLeft:(0,t.$Uj)("graph-left",60333),magnet:(0,t.$Uj)("magnet",60334),notebook:(0,t.$Uj)("notebook",60335),redo:(0,t.$Uj)("redo",60336),checkAll:(0,t.$Uj)("check-all",60337),pinnedDirty:(0,t.$Uj)("pinned-dirty",60338),passFilled:(0,t.$Uj)("pass-filled",60339),circleLargeFilled:(0,t.$Uj)("circle-large-filled",60340),circleLarge:(0,t.$Uj)("circle-large",60341),circleLargeOutline:(0,t.$Uj)("circle-large-outline",60341),combine:(0,t.$Uj)("combine",60342),gather:(0,t.$Uj)("gather",60342),table:(0,t.$Uj)("table",60343),variableGroup:(0,t.$Uj)("variable-group",60344),typeHierarchy:(0,t.$Uj)("type-hierarchy",60345),typeHierarchySub:(0,t.$Uj)("type-hierarchy-sub",60346),typeHierarchySuper:(0,t.$Uj)("type-hierarchy-super",60347),gitPullRequestCreate:(0,t.$Uj)("git-pull-request-create",60348),runAbove:(0,t.$Uj)("run-above",60349),runBelow:(0,t.$Uj)("run-below",60350),notebookTemplate:(0,t.$Uj)("notebook-template",60351),debugRerun:(0,t.$Uj)("debug-rerun",60352),workspaceTrusted:(0,t.$Uj)("workspace-trusted",60353),workspaceUntrusted:(0,t.$Uj)("workspace-untrusted",60354),workspaceUnknown:(0,t.$Uj)("workspace-unknown",60355),terminalCmd:(0,t.$Uj)("terminal-cmd",60356),terminalDebian:(0,t.$Uj)("terminal-debian",60357),terminalLinux:(0,t.$Uj)("terminal-linux",60358),terminalPowershell:(0,t.$Uj)("terminal-powershell",60359),terminalTmux:(0,t.$Uj)("terminal-tmux",60360),terminalUbuntu:(0,t.$Uj)("terminal-ubuntu",60361),terminalBash:(0,t.$Uj)("terminal-bash",60362),arrowSwap:(0,t.$Uj)("arrow-swap",60363),copy:(0,t.$Uj)("copy",60364),personAdd:(0,t.$Uj)("person-add",60365),filterFilled:(0,t.$Uj)("filter-filled",60366),wand:(0,t.$Uj)("wand",60367),debugLineByLine:(0,t.$Uj)("debug-line-by-line",60368),inspect:(0,t.$Uj)("inspect",60369),layers:(0,t.$Uj)("layers",60370),layersDot:(0,t.$Uj)("layers-dot",60371),layersActive:(0,t.$Uj)("layers-active",60372),compass:(0,t.$Uj)("compass",60373),compassDot:(0,t.$Uj)("compass-dot",60374),compassActive:(0,t.$Uj)("compass-active",60375),azure:(0,t.$Uj)("azure",60376),issueDraft:(0,t.$Uj)("issue-draft",60377),gitPullRequestClosed:(0,t.$Uj)("git-pull-request-closed",60378),gitPullRequestDraft:(0,t.$Uj)("git-pull-request-draft",60379),debugAll:(0,t.$Uj)("debug-all",60380),debugCoverage:(0,t.$Uj)("debug-coverage",60381),runErrors:(0,t.$Uj)("run-errors",60382),folderLibrary:(0,t.$Uj)("folder-library",60383),debugContinueSmall:(0,t.$Uj)("debug-continue-small",60384),beakerStop:(0,t.$Uj)("beaker-stop",60385),graphLine:(0,t.$Uj)("graph-line",60386),graphScatter:(0,t.$Uj)("graph-scatter",60387),pieChart:(0,t.$Uj)("pie-chart",60388),bracket:(0,t.$Uj)("bracket",60175),bracketDot:(0,t.$Uj)("bracket-dot",60389),bracketError:(0,t.$Uj)("bracket-error",60390),lockSmall:(0,t.$Uj)("lock-small",60391),azureDevops:(0,t.$Uj)("azure-devops",60392),verifiedFilled:(0,t.$Uj)("verified-filled",60393),newline:(0,t.$Uj)("newline",60394),layout:(0,t.$Uj)("layout",60395),layoutActivitybarLeft:(0,t.$Uj)("layout-activitybar-left",60396),layoutActivitybarRight:(0,t.$Uj)("layout-activitybar-right",60397),layoutPanelLeft:(0,t.$Uj)("layout-panel-left",60398),layoutPanelCenter:(0,t.$Uj)("layout-panel-center",60399),layoutPanelJustify:(0,t.$Uj)("layout-panel-justify",60400),layoutPanelRight:(0,t.$Uj)("layout-panel-right",60401),layoutPanel:(0,t.$Uj)("layout-panel",60402),layoutSidebarLeft:(0,t.$Uj)("layout-sidebar-left",60403),layoutSidebarRight:(0,t.$Uj)("layout-sidebar-right",60404),layoutStatusbar:(0,t.$Uj)("layout-statusbar",60405),layoutMenubar:(0,t.$Uj)("layout-menubar",60406),layoutCentered:(0,t.$Uj)("layout-centered",60407),target:(0,t.$Uj)("target",60408),indent:(0,t.$Uj)("indent",60409),recordSmall:(0,t.$Uj)("record-small",60410),errorSmall:(0,t.$Uj)("error-small",60411),terminalDecorationError:(0,t.$Uj)("terminal-decoration-error",60411),arrowCircleDown:(0,t.$Uj)("arrow-circle-down",60412),arrowCircleLeft:(0,t.$Uj)("arrow-circle-left",60413),arrowCircleRight:(0,t.$Uj)("arrow-circle-right",60414),arrowCircleUp:(0,t.$Uj)("arrow-circle-up",60415),layoutSidebarRightOff:(0,t.$Uj)("layout-sidebar-right-off",60416),layoutPanelOff:(0,t.$Uj)("layout-panel-off",60417),layoutSidebarLeftOff:(0,t.$Uj)("layout-sidebar-left-off",60418),blank:(0,t.$Uj)("blank",60419),heartFilled:(0,t.$Uj)("heart-filled",60420),map:(0,t.$Uj)("map",60421),mapHorizontal:(0,t.$Uj)("map-horizontal",60421),foldHorizontal:(0,t.$Uj)("fold-horizontal",60421),mapFilled:(0,t.$Uj)("map-filled",60422),mapHorizontalFilled:(0,t.$Uj)("map-horizontal-filled",60422),foldHorizontalFilled:(0,t.$Uj)("fold-horizontal-filled",60422),circleSmall:(0,t.$Uj)("circle-small",60423),bellSlash:(0,t.$Uj)("bell-slash",60424),bellSlashDot:(0,t.$Uj)("bell-slash-dot",60425),commentUnresolved:(0,t.$Uj)("comment-unresolved",60426),gitPullRequestGoToChanges:(0,t.$Uj)("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:(0,t.$Uj)("git-pull-request-new-changes",60428),searchFuzzy:(0,t.$Uj)("search-fuzzy",60429),commentDraft:(0,t.$Uj)("comment-draft",60430),send:(0,t.$Uj)("send",60431),sparkle:(0,t.$Uj)("sparkle",60432),insert:(0,t.$Uj)("insert",60433),mic:(0,t.$Uj)("mic",60434),thumbsdownFilled:(0,t.$Uj)("thumbsdown-filled",60435),thumbsupFilled:(0,t.$Uj)("thumbsup-filled",60436),coffee:(0,t.$Uj)("coffee",60437),snake:(0,t.$Uj)("snake",60438),game:(0,t.$Uj)("game",60439),vr:(0,t.$Uj)("vr",60440),chip:(0,t.$Uj)("chip",60441),piano:(0,t.$Uj)("piano",60442),music:(0,t.$Uj)("music",60443),micFilled:(0,t.$Uj)("mic-filled",60444),repoFetch:(0,t.$Uj)("repo-fetch",60445),copilot:(0,t.$Uj)("copilot",60446),lightbulbSparkle:(0,t.$Uj)("lightbulb-sparkle",60447),robot:(0,t.$Uj)("robot",60448),sparkleFilled:(0,t.$Uj)("sparkle-filled",60449),diffSingle:(0,t.$Uj)("diff-single",60450),diffMultiple:(0,t.$Uj)("diff-multiple",60451),surroundWith:(0,t.$Uj)("surround-with",60452),share:(0,t.$Uj)("share",60453),gitStash:(0,t.$Uj)("git-stash",60454),gitStashApply:(0,t.$Uj)("git-stash-apply",60455),gitStashPop:(0,t.$Uj)("git-stash-pop",60456),vscode:(0,t.$Uj)("vscode",60457),vscodeInsiders:(0,t.$Uj)("vscode-insiders",60458),codeOss:(0,t.$Uj)("code-oss",60459),runCoverage:(0,t.$Uj)("run-coverage",60460),runAllCoverage:(0,t.$Uj)("run-all-coverage",60461),coverage:(0,t.$Uj)("coverage",60462),githubProject:(0,t.$Uj)("github-project",60463),mapVertical:(0,t.$Uj)("map-vertical",60464),foldVertical:(0,t.$Uj)("fold-vertical",60464),mapVerticalFilled:(0,t.$Uj)("map-vertical-filled",60465),foldVerticalFilled:(0,t.$Uj)("fold-vertical-filled",60465),goToSearch:(0,t.$Uj)("go-to-search",60466),percentage:(0,t.$Uj)("percentage",60467),sortPercentage:(0,t.$Uj)("sort-percentage",60467),attach:(0,t.$Uj)("attach",60468)}}),ne(ie[45],re([0,1,28,44]),function(q,i,t,n){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$Zj=i.$Yj=void 0,i.$Xj=p;function p(){return Object.values(i.$Zj)}i.$Yj={dialogError:(0,t.$Uj)("dialog-error","error"),dialogWarning:(0,t.$Uj)("dialog-warning","warning"),dialogInfo:(0,t.$Uj)("dialog-info","info"),dialogClose:(0,t.$Uj)("dialog-close","close"),treeItemExpanded:(0,t.$Uj)("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:(0,t.$Uj)("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:(0,t.$Uj)("tree-filter-on-type-off","list-selection"),treeFilterClear:(0,t.$Uj)("tree-filter-clear","close"),treeItemLoading:(0,t.$Uj)("tree-item-loading","loading"),menuSelection:(0,t.$Uj)("menu-selection","check"),menuSubmenu:(0,t.$Uj)("menu-submenu","chevron-right"),menuBarMore:(0,t.$Uj)("menubar-more","more"),scrollbarButtonLeft:(0,t.$Uj)("scrollbar-button-left","triangle-left"),scrollbarButtonRight:(0,t.$Uj)("scrollbar-button-right","triangle-right"),scrollbarButtonUp:(0,t.$Uj)("scrollbar-button-up","triangle-up"),scrollbarButtonDown:(0,t.$Uj)("scrollbar-button-down","triangle-down"),toolBarMore:(0,t.$Uj)("toolbar-more","more"),quickInputBack:(0,t.$Uj)("quick-input-back","arrow-left"),dropDownButton:(0,t.$Uj)("drop-down-button",60084),symbolCustomColor:(0,t.$Uj)("symbol-customcolor",60252),exportIcon:(0,t.$Uj)("export",60332),workspaceUnspecified:(0,t.$Uj)("workspace-unspecified",60355),newLine:(0,t.$Uj)("newline",60394),thumbsDownFilled:(0,t.$Uj)("thumbsdown-filled",60435),thumbsUpFilled:(0,t.$Uj)("thumbsup-filled",60436),gitFetch:(0,t.$Uj)("git-fetch",60445),lightbulbSparkleAutofix:(0,t.$Uj)("lightbulb-sparkle-autofix",60447),debugBreakpointPending:(0,t.$Uj)("debug-breakpoint-pending",60377)},i.$Zj={...n.$Wj,...i.$Yj}}),ne(ie[17],re([0,1,27]),function(q,i,t){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$9n=n,i.$0n=p,i.$$n=v,i.$_n=a,i.$ao=l,i.$bo=f,i.$co=$,i.$do=b,i.$eo=L,i.$fo=e,i.$go=m,i.$ho=E,i.$io=R;function n(A){if(!A||typeof A!="object"||A instanceof RegExp)return A;const w=Array.isArray(A)?[]:{};return Object.entries(A).forEach(([N,c])=>{w[N]=c&&typeof c=="object"?n(c):c}),w}function p(A){if(!A||typeof A!="object")return A;const w=[A];for(;w.length>0;){const N=w.shift();Object.freeze(N);for(const c in N)if(g.call(N,c)){const u=N[c];typeof u=="object"&&!Object.isFrozen(u)&&!(0,t.$dg)(u)&&w.push(u)}}return A}const g=Object.prototype.hasOwnProperty;function v(A,w){return d(A,w,new Set)}function d(A,w,N){if((0,t.$jg)(A))return A;const c=w(A);if(typeof c<"u")return c;if(Array.isArray(A)){const u=[];for(const s of A)u.push(d(s,w,N));return u}if((0,t.$cg)(A)){if(N.has(A))throw new Error("Cannot clone recursive data-structure");N.add(A);const u={};for(const s in A)g.call(A,s)&&(u[s]=d(A[s],w,N));return N.delete(A),u}return A}function a(A,w,N=!0){return(0,t.$cg)(A)?((0,t.$cg)(w)&&Object.keys(w).forEach(c=>{c in A?N&&((0,t.$cg)(A[c])&&(0,t.$cg)(w[c])?a(A[c],w[c],N):A[c]=w[c]):A[c]=w[c]}),A):w}function l(A,w){if(A===w)return!0;if(A==null||w===null||w===void 0||typeof A!=typeof w||typeof A!="object"||Array.isArray(A)!==Array.isArray(w))return!1;let N,c;if(Array.isArray(A)){if(A.length!==w.length)return!1;for(N=0;N<A.length;N++)if(!l(A[N],w[N]))return!1}else{const u=[];for(c in A)u.push(c);u.sort();const s=[];for(c in w)s.push(c);if(s.sort(),!l(u,s))return!1;for(N=0;N<u.length;N++)if(!l(A[u[N]],w[u[N]]))return!1}return!0}function f(A){const w=new Set;return JSON.stringify(A,(N,c)=>{if((0,t.$cg)(c)||Array.isArray(c)){if(w.has(c))return"[Circular]";w.add(c)}return typeof c=="bigint"?`[BigInt ${c.toString()}]`:c})}function $(A,w){const N=Object.create(null);return!A||!w||Object.keys(w).forEach(u=>{const s=A[u],o=w[u];l(s,o)||(N[u]=o)}),N}function b(A,w){const N=w.toLowerCase(),c=Object.keys(A).find(u=>u.toLowerCase()===N);return c?A[c]:A[w]}function L(A,w){const N=Object.create(null);for(const[c,u]of Object.entries(A))w(c,u)&&(N[c]=u);return N}function e(A){let w=[];for(;Object.prototype!==A;)w=w.concat(Object.getOwnPropertyNames(A)),A=Object.getPrototypeOf(A);return w}function m(A){const w=[];for(const N of e(A))typeof A[N]=="function"&&w.push(N);return w}function E(A,w){const N=u=>function(){const s=Array.prototype.slice.call(arguments,0);return w(u,s)},c={};for(const u of A)c[u]=N(u);return c}function R(A,w){const N={};for(const[c,u]of Object.entries(A))N[c]=w(u,c);return N}}),ne(ie[14],re([0,1]),function(q,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.Constants=void 0,i.$9e=n,i.$0e=p;var t;(function(g){g[g.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",g[g.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",g[g.MAX_UINT_8=255]="MAX_UINT_8",g[g.MAX_UINT_16=65535]="MAX_UINT_16",g[g.MAX_UINT_32=4294967295]="MAX_UINT_32",g[g.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(t||(i.Constants=t={}));function n(g){return g<0?0:g>t.MAX_UINT_8?t.MAX_UINT_8:g|0}function p(g){return g<0?0:g>t.MAX_UINT_32?t.MAX_UINT_32:g|0}}),ne(ie[8],re([0,1,43,3,41,14]),function(q,i,t,n,p,g){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$_f=i.$$f=i.$0f=i.GraphemeBreakType=i.$Zf=i.$Rf=i.$Kf=i.$Jf=void 0,i.$$e=v,i.$_e=a,i.$af=f,i.$bf=$,i.$cf=b,i.$df=L,i.$ef=e,i.$ff=m,i.$gf=E,i.$hf=R,i.$if=A,i.$jf=w,i.$kf=N,i.$lf=c,i.$mf=u,i.$nf=s,i.$of=o,i.$pf=h,i.$qf=T,i.$rf=_,i.$sf=U,i.$tf=M,i.$uf=D,i.$vf=k,i.$wf=P,i.$xf=j,i.$yf=B,i.$zf=Z,i.$Af=O,i.$Bf=S,i.$Cf=X,i.$Df=Y,i.$Ef=H,i.$Ff=Q,i.$Gf=C,i.$Hf=F,i.$If=z,i.$Lf=r,i.$Mf=Te,i.$Nf=ke,i.$Of=Ve,i.$Pf=x,i.$Qf=V,i.$Sf=J,i.$Tf=ee,i.$Uf=he,i.$Vf=de,i.$Wf=Ne,i.$Xf=_e,i.$Yf=te,i.$1f=ae,i.$2f=ue,i.$3f=ce,i.$4f=me,i.$5f=$e,i.$6f=Ee,i.$7f=Ae,i.$8f=ye,i.$9f=Ge;function v(I){return!I||typeof I!="string"?!0:I.trim().length===0}const d=/{(\d+)}/g;function a(I,...y){return y.length===0?I:I.replace(d,function(G,K){const le=parseInt(K,10);return isNaN(le)||le<0||le>=y.length?G:y[le]})}const l=/{([^}]+)}/g;function f(I,y){return Object.keys(y).length===0?I:I.replace(l,(G,K)=>y[K]??G)}function $(I){return I.replace(/[<>"'&]/g,y=>{switch(y){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return y})}function b(I){return I.replace(/[<>&]/g,function(y){switch(y){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return y}})}function L(I){return I.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function e(I,y){let G=0,K=I.indexOf(y);for(;K!==-1;)G++,K=I.indexOf(y,K+y.length);return G}function m(I,y,G="\u2026"){return I.length<=y?I:`${I.substr(0,y)}${G}`}function E(I,y,G="\u2026"){if(I.length<=y)return I;const K=Math.ceil(y/2)-G.length/2,le=Math.floor(y/2)-G.length/2;return`${I.substr(0,K)}${G}${I.substr(I.length-le)}`}function R(I,y=" "){const G=A(I,y);return w(G,y)}function A(I,y){if(!I||!y)return I;const G=y.length;if(G===0||I.length===0)return I;let K=0;for(;I.indexOf(y,K)===K;)K=K+G;return I.substring(K)}function w(I,y){if(!I||!y)return I;const G=y.length,K=I.length;if(G===0||K===0)return I;let le=K,be=-1;for(;be=I.lastIndexOf(y,le-1),!(be===-1||be+G!==le);){if(be===0)return"";le=be}return I.substring(0,le)}function N(I){return I.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function c(I){return I.replace(/\*/g,"")}function u(I,y,G={}){if(!I)throw new Error("Cannot create regex from empty string");y||(I=L(I)),G.wholeWord&&(/\B/.test(I.charAt(0))||(I="\\b"+I),/\B/.test(I.charAt(I.length-1))||(I=I+"\\b"));let K="";return G.global&&(K+="g"),G.matchCase||(K+="i"),G.multiline&&(K+="m"),G.unicode&&(K+="u"),new RegExp(I,K)}function s(I){return I.source==="^"||I.source==="^$"||I.source==="$"||I.source==="^\\s*$"?!1:!!(I.exec("")&&I.lastIndex===0)}function o(I){return I.split(/\r\n|\r|\n/)}function h(I){const y=[],G=I.split(/(\r\n|\r|\n)/);for(let K=0;K<Math.ceil(G.length/2);K++)y.push(G[2*K]+(G[2*K+1]??""));return y}function T(I){for(let y=0,G=I.length;y<G;y++){const K=I.charCodeAt(y);if(K!==n.CharCode.Space&&K!==n.CharCode.Tab)return y}return-1}function _(I,y=0,G=I.length){for(let K=y;K<G;K++){const le=I.charCodeAt(K);if(le!==n.CharCode.Space&&le!==n.CharCode.Tab)return I.substring(y,K)}return I.substring(y,G)}function U(I,y=I.length-1){for(let G=y;G>=0;G--){const K=I.charCodeAt(G);if(K!==n.CharCode.Space&&K!==n.CharCode.Tab)return G}return-1}function M(I,y,G){const K=[];let le=0;for(const be of I.matchAll(y)){if(K.push(I.slice(le,be.index)),be.index===void 0)throw new Error("match.index should be defined");le=be.index+be[0].length,K.push(G(be[0],...be.slice(1),be.index,I,be.groups))}return K.push(I.slice(le)),Promise.all(K).then(be=>be.join(""))}function D(I,y){return I<y?-1:I>y?1:0}function k(I,y,G=0,K=I.length,le=0,be=y.length){for(;G<K&&le<be;G++,le++){const je=I.charCodeAt(G),De=y.charCodeAt(le);if(je<De)return-1;if(je>De)return 1}const Re=K-G,Ie=be-le;return Re<Ie?-1:Re>Ie?1:0}function P(I,y){return j(I,y,0,I.length,0,y.length)}function j(I,y,G=0,K=I.length,le=0,be=y.length){for(;G<K&&le<be;G++,le++){let je=I.charCodeAt(G),De=y.charCodeAt(le);if(je===De)continue;if(je>=128||De>=128)return k(I.toLowerCase(),y.toLowerCase(),G,K,le,be);Z(je)&&(je-=32),Z(De)&&(De-=32);const pe=je-De;if(pe!==0)return pe}const Re=K-G,Ie=be-le;return Re<Ie?-1:Re>Ie?1:0}function B(I){return I>=n.CharCode.Digit0&&I<=n.CharCode.Digit9}function Z(I){return I>=n.CharCode.a&&I<=n.CharCode.z}function O(I){return I>=n.CharCode.A&&I<=n.CharCode.Z}function S(I,y){return I.length===y.length&&j(I,y)===0}function X(I,y){const G=y.length;return y.length>I.length?!1:j(I,y,0,G)===0}function Y(I,y){const G=Math.min(I.length,y.length);let K;for(K=0;K<G;K++)if(I.charCodeAt(K)!==y.charCodeAt(K))return K;return G}function H(I,y){const G=Math.min(I.length,y.length);let K;const le=I.length-1,be=y.length-1;for(K=0;K<G;K++)if(I.charCodeAt(le-K)!==y.charCodeAt(be-K))return K;return G}function Q(I){return 55296<=I&&I<=56319}function C(I){return 56320<=I&&I<=57343}function F(I,y){return(I-55296<<10)+(y-56320)+65536}function z(I,y,G){const K=I.charCodeAt(G);if(Q(K)&&G+1<y){const le=I.charCodeAt(G+1);if(C(le))return F(K,le)}return K}function fe(I,y){const G=I.charCodeAt(y-1);if(C(G)&&y>1){const K=I.charCodeAt(y-2);if(Q(K))return F(K,G)}return G}class oe{get offset(){return this.e}constructor(y,G=0){this.c=y,this.d=y.length,this.e=G}setOffset(y){this.e=y}prevCodePoint(){const y=fe(this.c,this.e);return this.e-=y>=g.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,y}nextCodePoint(){const y=z(this.c,this.d,this.e);return this.e+=y>=g.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,y}eol(){return this.e>=this.d}}i.$Jf=oe;class we{get offset(){return this.c.offset}constructor(y,G=0){this.c=new oe(y,G)}nextGraphemeLength(){const y=Me.getInstance(),G=this.c,K=G.offset;let le=y.getGraphemeBreakType(G.nextCodePoint());for(;!G.eol();){const be=G.offset,Re=y.getGraphemeBreakType(G.nextCodePoint());if(Oe(le,Re)){G.setOffset(be);break}le=Re}return G.offset-K}prevGraphemeLength(){const y=Me.getInstance(),G=this.c,K=G.offset;let le=y.getGraphemeBreakType(G.prevCodePoint());for(;G.offset>0;){const be=G.offset,Re=y.getGraphemeBreakType(G.prevCodePoint());if(Oe(Re,le)){G.setOffset(be);break}le=Re}return K-G.offset}eol(){return this.c.eol()}}i.$Kf=we;function r(I,y){return new we(I,y).nextGraphemeLength()}function Te(I,y){return new we(I,y).prevGraphemeLength()}function ke(I,y){y>0&&C(I.charCodeAt(y))&&y--;const G=y+r(I,y);return[G-Te(I,G),G]}function Ve(I){const y=new we(I);let G=0;for(;!y.eol();)G++,y.nextGraphemeLength();return G}let Ue;function Se(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function x(I){return Ue||(Ue=Se()),Ue.test(I)}const W=/^[\t\n\r\x20-\x7E]*$/;function V(I){return W.test(I)}i.$Rf=/[\u2028\u2029]/;function J(I){return i.$Rf.test(I)}function ee(I){return I>=11904&&I<=55215||I>=63744&&I<=64255||I>=65281&&I<=65374}function he(I){return I>=127462&&I<=127487||I===8986||I===8987||I===9200||I===9203||I>=9728&&I<=10175||I===11088||I===11093||I>=127744&&I<=128591||I>=128640&&I<=128764||I>=128992&&I<=129008||I>=129280&&I<=129535||I>=129648&&I<=129782}function de(I,y,G=""){const K=I.trimStart();if(K.length<y)return K;const le=/\b/g;let be=0;for(;le.test(K)&&!(K.length-le.lastIndex<y);)be=le.lastIndex,le.lastIndex+=1;return be===0?K:G+K.substring(be).trimStart()}const Le=/(?:(?:\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~])|(:?\x1b\].*?\x07)/g;function*Ne(I){let y=0;for(const G of I.matchAll(Le))y!==G.index&&(yield{isCode:!1,str:I.substring(y,G.index)}),yield{isCode:!0,str:G[0]},y=G.index+G[0].length;y!==I.length&&(yield{isCode:!1,str:I.substring(y)})}function _e(I){return I&&(I=I.replace(Le,"")),I}const se=/\\\[.*?\\\]/g;function te(I){return _e(I).replace(se,"")}i.$Zf=String.fromCharCode(n.CharCode.UTF8_BOM);function ae(I){return!!(I&&I.length>0&&I.charCodeAt(0)===n.CharCode.UTF8_BOM)}function ue(I){return ae(I)?I.substr(1):I}function ce(I,y){if(!I||!y||I.length<y.length)return!1;const G=y.length,K=I.toLowerCase();let le=0,be=-1;for(;le<G;){const Re=K.indexOf(y[le],be+1);if(Re<0)return!1;be=Re,le++}return!0}function me(I,y=!1){return I?(y&&(I=I.replace(/\\./g,"")),I.toLowerCase()!==I):!1}function $e(I){return I.charAt(0).toUpperCase()+I.slice(1)}function Ee(I,y=1){if(y===0)return"";let G=-1;do G=I.indexOf(`
`,G+1),y--;while(y>0&&G>=0);return G===-1?I:(I[G-1]==="\r"&&G--,I.substr(0,G))}function Ae(I){const y=n.CharCode.Z-n.CharCode.A+1;return I=I%(2*y),I<y?String.fromCharCode(n.CharCode.a+I):String.fromCharCode(n.CharCode.A+I-y)}function ye(I){return Me.getInstance().getGraphemeBreakType(I)}function Oe(I,y){return I===ge.Other?y!==ge.Extend&&y!==ge.SpacingMark:I===ge.CR&&y===ge.LF?!1:I===ge.Control||I===ge.CR||I===ge.LF||y===ge.Control||y===ge.CR||y===ge.LF?!0:!(I===ge.L&&(y===ge.L||y===ge.V||y===ge.LV||y===ge.LVT)||(I===ge.LV||I===ge.V)&&(y===ge.V||y===ge.T)||(I===ge.LVT||I===ge.T)&&y===ge.T||y===ge.Extend||y===ge.ZWJ||y===ge.SpacingMark||I===ge.Prepend||I===ge.ZWJ&&y===ge.Extended_Pictographic||I===ge.Regional_Indicator&&y===ge.Regional_Indicator)}var ge;(function(I){I[I.Other=0]="Other",I[I.Prepend=1]="Prepend",I[I.CR=2]="CR",I[I.LF=3]="LF",I[I.Control=4]="Control",I[I.Extend=5]="Extend",I[I.Regional_Indicator=6]="Regional_Indicator",I[I.SpacingMark=7]="SpacingMark",I[I.L=8]="L",I[I.V=9]="V",I[I.T=10]="T",I[I.LV=11]="LV",I[I.LVT=12]="LVT",I[I.ZWJ=13]="ZWJ",I[I.Extended_Pictographic=14]="Extended_Pictographic"})(ge||(i.GraphemeBreakType=ge={}));class Me{static{this.c=null}static getInstance(){return Me.c||(Me.c=new Me),Me.c}constructor(){this.d=Be()}getGraphemeBreakType(y){if(y<32)return y===n.CharCode.LineFeed?ge.LF:y===n.CharCode.CarriageReturn?ge.CR:ge.Control;if(y<127)return ge.Other;const G=this.d,K=G.length/3;let le=1;for(;le<=K;)if(y<G[3*le])le=2*le;else if(y>G[3*le+1])le=2*le+1;else return G[3*le+2];return ge.Other}}function Be(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Ge(I,y){if(I===0)return 0;const G=ze(I,y);if(G!==void 0)return G;const K=new oe(y,I);return K.prevCodePoint(),K.offset}function ze(I,y){const G=new oe(y,I);let K=G.prevCodePoint();for(;Qe(K)||K===We.emojiVariantSelector||K===We.enclosingKeyCap;){if(G.offset===0)return;K=G.prevCodePoint()}if(!he(K))return;let le=G.offset;return le>0&&G.prevCodePoint()===We.zwj&&(le=G.offset),le}function Qe(I){return 127995<=I&&I<=127999}var We;(function(I){I[I.zwj=8205]="zwj",I[I.emojiVariantSelector=65039]="emojiVariantSelector",I[I.enclosingKeyCap=8419]="enclosingKeyCap"})(We||(We={})),i.$0f="\xA0";class xe{static{this.c=new p.$V(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new t.$7e({getCacheKey:JSON.stringify},y=>{function G(pe){const Pe=new Map;for(let Fe=0;Fe<pe.length;Fe+=2)Pe.set(pe[Fe],pe[Fe+1]);return Pe}function K(pe,Pe){const Fe=new Map(pe);for(const[He,Ze]of Pe)Fe.set(He,Ze);return Fe}function le(pe,Pe){if(!pe)return Pe;const Fe=new Map;for(const[He,Ze]of pe)Pe.has(He)&&Fe.set(He,Ze);return Fe}const be=this.c.value;let Re=y.filter(pe=>!pe.startsWith("_")&&pe in be);Re.length===0&&(Re=["_default"]);let Ie;for(const pe of Re){const Pe=G(be[pe]);Ie=le(Ie,Pe)}const je=G(be._common),De=K(je,Ie);return new xe(De)})}static getInstance(y){return xe.d.get(Array.from(y))}static{this.e=new p.$V(()=>Object.keys(xe.c.value).filter(y=>!y.startsWith("_")))}static getLocales(){return xe.e.value}constructor(y){this.f=y}isAmbiguous(y){return this.f.has(y)}containsAmbiguousCharacter(y){for(let G=0;G<y.length;G++){const K=y.codePointAt(G);if(typeof K=="number"&&this.isAmbiguous(K))return!0}return!1}getPrimaryConfusable(y){return this.f.get(y)}getConfusableCodePoints(){return new Set(this.f.keys())}}i.$$f=xe;class qe{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(qe.c())),this.d}static isInvisibleCharacter(y){return qe.e().has(y)}static containsInvisibleCharacter(y){for(let G=0;G<y.length;G++){const K=y.codePointAt(G);if(typeof K=="number"&&qe.isInvisibleCharacter(K))return!0}return!1}static get codePoints(){return qe.e()}}i.$_f=qe}),ne(ie[46],re([0,1,8]),function(q,i,t){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$uj=i.$sj=void 0,i.$oj=n,i.$pj=p,i.$qj=g,i.$rj=d,i.$tj=m;function n(R){return p(R,0)}function p(R,A){switch(typeof R){case"object":return R===null?g(349,A):Array.isArray(R)?a(R,A):l(R,A);case"string":return d(R,A);case"boolean":return v(R,A);case"number":return g(R,A);case"undefined":return g(937,A);default:return g(617,A)}}function g(R,A){return(A<<5)-A+R|0}function v(R,A){return g(R?433:863,A)}function d(R,A){A=g(149417,A);for(let w=0,N=R.length;w<N;w++)A=g(R.charCodeAt(w),A);return A}function a(R,A){return A=g(104579,A),R.reduce((w,N)=>p(N,w),A)}function l(R,A){return A=g(181387,A),Object.keys(R).sort().reduce((w,N)=>(w=d(N,w),p(R[N],w)),A)}class f{constructor(){this.g=0}get value(){return this.g}hash(A){return this.g=p(A,this.g),this.g}}i.$sj=f;var $;(function(R){R[R.BLOCK_SIZE=64]="BLOCK_SIZE",R[R.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})($||($={}));function b(R,A,w=32){const N=w-A,c=~((1<<N)-1);return(R<<A|(c&R)>>>N)>>>0}function L(R,A=0,w=R.byteLength,N=0){for(let c=0;c<w;c++)R[A+c]=N}function e(R,A,w="0"){for(;R.length<A;)R=w+R;return R}function m(R,A=32){return R instanceof ArrayBuffer?Array.from(new Uint8Array(R)).map(w=>w.toString(16).padStart(2,"0")).join(""):e((R>>>0).toString(16),A/4)}class E{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array($.BLOCK_SIZE+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(A){const w=A.length;if(w===0)return;const N=this.p;let c=this.r,u=this.u,s,o;for(u!==0?(s=u,o=-1,u=0):(s=A.charCodeAt(0),o=0);;){let h=s;if(t.$Ff(s))if(o+1<w){const T=A.charCodeAt(o+1);t.$Gf(T)?(o++,h=t.$Hf(s,T)):h=$.UNICODE_REPLACEMENT}else{u=s;break}else t.$Gf(s)&&(h=$.UNICODE_REPLACEMENT);if(c=this.w(N,c,h),o++,o<w)s=A.charCodeAt(o);else break}this.r=c,this.u=u}w(A,w,N){return N<128?A[w++]=N:N<2048?(A[w++]=192|(N&1984)>>>6,A[w++]=128|(N&63)>>>0):N<65536?(A[w++]=224|(N&61440)>>>12,A[w++]=128|(N&4032)>>>6,A[w++]=128|(N&63)>>>0):(A[w++]=240|(N&1835008)>>>18,A[w++]=128|(N&258048)>>>12,A[w++]=128|(N&4032)>>>6,A[w++]=128|(N&63)>>>0),w>=$.BLOCK_SIZE&&(this.y(),w-=$.BLOCK_SIZE,this.t+=$.BLOCK_SIZE,A[0]=A[$.BLOCK_SIZE+0],A[1]=A[$.BLOCK_SIZE+1],A[2]=A[$.BLOCK_SIZE+2]),w}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,$.UNICODE_REPLACEMENT)),this.t+=this.r,this.x()),m(this.h)+m(this.l)+m(this.m)+m(this.n)+m(this.o)}x(){this.p[this.r++]=128,L(this.p,this.r),this.r>56&&(this.y(),L(this.p));const A=8*this.t;this.q.setUint32(56,Math.floor(A/4294967296),!1),this.q.setUint32(60,A%4294967296,!1),this.y()}y(){const A=E.g,w=this.q;for(let U=0;U<64;U+=4)A.setUint32(U,w.getUint32(U,!1),!1);for(let U=64;U<320;U+=4)A.setUint32(U,b(A.getUint32(U-12,!1)^A.getUint32(U-32,!1)^A.getUint32(U-56,!1)^A.getUint32(U-64,!1),1),!1);let N=this.h,c=this.l,u=this.m,s=this.n,o=this.o,h,T,_;for(let U=0;U<80;U++)U<20?(h=c&u|~c&s,T=1518500249):U<40?(h=c^u^s,T=1859775393):U<60?(h=c&u|c&s|u&s,T=2400959708):(h=c^u^s,T=3395469782),_=b(N,5)+h+o+T+A.getUint32(U*4,!1)&4294967295,o=s,s=u,u=b(c,30),c=N,N=_;this.h=this.h+N&4294967295,this.l=this.l+c&4294967295,this.m=this.m+u&4294967295,this.n=this.n+s&4294967295,this.o=this.o+o&4294967295}}i.$uj=E}),ne(ie[29],re([0,1,39,46,14]),function(q,i,t,n,p){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$Uv=i.$Sv=void 0,i.$Tv=v;class g{constructor(L){this.a=L}getElements(){const L=this.a,e=new Int32Array(L.length);for(let m=0,E=L.length;m<E;m++)e[m]=L.charCodeAt(m);return e}}i.$Sv=g;function v(b,L,e){return new $(new g(b),new g(L)).ComputeDiff(e).changes}class d{static Assert(L,e){if(!L)throw new Error(e)}}class a{static Copy(L,e,m,E,R){for(let A=0;A<R;A++)m[E+A]=L[e+A]}static Copy2(L,e,m,E,R){for(let A=0;A<R;A++)m[E+A]=L[e+A]}}var l;(function(b){b[b.MaxDifferencesHistory=1447]="MaxDifferencesHistory"})(l||(l={}));class f{constructor(){this.a=[],this.b=p.Constants.MAX_SAFE_SMALL_INTEGER,this.c=p.Constants.MAX_SAFE_SMALL_INTEGER,this.d=0,this.e=0}MarkNextChange(){(this.d>0||this.e>0)&&this.a.push(new t.$Rv(this.b,this.d,this.c,this.e)),this.d=0,this.e=0,this.b=p.Constants.MAX_SAFE_SMALL_INTEGER,this.c=p.Constants.MAX_SAFE_SMALL_INTEGER}AddOriginalElement(L,e){this.b=Math.min(this.b,L),this.c=Math.min(this.c,e),this.d++}AddModifiedElement(L,e){this.b=Math.min(this.b,L),this.c=Math.min(this.c,e),this.e++}getChanges(){return(this.d>0||this.e>0)&&this.MarkNextChange(),this.a}getReverseChanges(){return(this.d>0||this.e>0)&&this.MarkNextChange(),this.a.reverse(),this.a}}class ${constructor(L,e,m=null){this.a=m,this.b=L,this.c=e;const[E,R,A]=$.o(L),[w,N,c]=$.o(e);this.d=A&&c,this.e=E,this.f=R,this.g=w,this.h=N,this.k=[],this.m=[]}static n(L){return L.length>0&&typeof L[0]=="string"}static o(L){const e=L.getElements();if($.n(e)){const m=new Int32Array(e.length);for(let E=0,R=e.length;E<R;E++)m[E]=(0,n.$rj)(e[E],0);return[e,m,!0]}return e instanceof Int32Array?[[],e,!1]:[[],new Int32Array(e),!1]}p(L,e){return this.f[L]!==this.h[e]?!1:this.d?this.e[L]===this.g[e]:!0}q(L,e){if(!this.p(L,e))return!1;const m=$.r(this.b,L),E=$.r(this.c,e);return m===E}static r(L,e){return typeof L.getStrictElement=="function"?L.getStrictElement(e):null}s(L,e){return this.f[L]!==this.f[e]?!1:this.d?this.e[L]===this.e[e]:!0}u(L,e){return this.h[L]!==this.h[e]?!1:this.d?this.g[L]===this.g[e]:!0}ComputeDiff(L){return this.v(0,this.f.length-1,0,this.h.length-1,L)}v(L,e,m,E,R){const A=[!1];let w=this.w(L,e,m,E,A);return R&&(w=this.z(w)),{quitEarly:A[0],changes:w}}w(L,e,m,E,R){for(R[0]=!1;L<=e&&m<=E&&this.p(L,m);)L++,m++;for(;e>=L&&E>=m&&this.p(e,E);)e--,E--;if(L>e||m>E){let s;return m<=E?(d.Assert(L===e+1,"originalStart should only be one more than originalEnd"),s=[new t.$Rv(L,0,m,E-m+1)]):L<=e?(d.Assert(m===E+1,"modifiedStart should only be one more than modifiedEnd"),s=[new t.$Rv(L,e-L+1,m,0)]):(d.Assert(L===e+1,"originalStart should only be one more than originalEnd"),d.Assert(m===E+1,"modifiedStart should only be one more than modifiedEnd"),s=[]),s}const A=[0],w=[0],N=this.y(L,e,m,E,A,w,R),c=A[0],u=w[0];if(N!==null)return N;if(!R[0]){const s=this.w(L,c,m,u,R);let o=[];return R[0]?o=[new t.$Rv(c+1,e-(c+1)+1,u+1,E-(u+1)+1)]:o=this.w(c+1,e,u+1,E,R),this.H(s,o)}return[new t.$Rv(L,e-L+1,m,E-m+1)]}x(L,e,m,E,R,A,w,N,c,u,s,o,h,T,_,U,M,D){let k=null,P=null,j=new f,B=e,Z=m,O=h[0]-U[0]-E,S=p.Constants.MIN_SAFE_SMALL_INTEGER,X=this.k.length-1;do{const Y=O+L;Y===B||Y<Z&&c[Y-1]<c[Y+1]?(s=c[Y+1],T=s-O-E,s<S&&j.MarkNextChange(),S=s,j.AddModifiedElement(s+1,T),O=Y+1-L):(s=c[Y-1]+1,T=s-O-E,s<S&&j.MarkNextChange(),S=s-1,j.AddOriginalElement(s,T+1),O=Y-1-L),X>=0&&(c=this.k[X],L=c[0],B=1,Z=c.length-1)}while(--X>=-1);if(k=j.getReverseChanges(),D[0]){let Y=h[0]+1,H=U[0]+1;if(k!==null&&k.length>0){const Q=k[k.length-1];Y=Math.max(Y,Q.getOriginalEnd()),H=Math.max(H,Q.getModifiedEnd())}P=[new t.$Rv(Y,o-Y+1,H,_-H+1)]}else{j=new f,B=A,Z=w,O=h[0]-U[0]-N,S=p.Constants.MAX_SAFE_SMALL_INTEGER,X=M?this.m.length-1:this.m.length-2;do{const Y=O+R;Y===B||Y<Z&&u[Y-1]>=u[Y+1]?(s=u[Y+1]-1,T=s-O-N,s>S&&j.MarkNextChange(),S=s+1,j.AddOriginalElement(s+1,T+1),O=Y+1-R):(s=u[Y-1],T=s-O-N,s>S&&j.MarkNextChange(),S=s,j.AddModifiedElement(s+1,T+1),O=Y-1-R),X>=0&&(u=this.m[X],R=u[0],B=1,Z=u.length-1)}while(--X>=-1);P=j.getChanges()}return this.H(k,P)}y(L,e,m,E,R,A,w){let N=0,c=0,u=0,s=0,o=0,h=0;L--,m--,R[0]=0,A[0]=0,this.k=[],this.m=[];const T=e-L+(E-m),_=T+1,U=new Int32Array(_),M=new Int32Array(_),D=E-m,k=e-L,P=L-m,j=e-E,Z=(k-D)%2===0;U[D]=L,M[k]=e,w[0]=!1;for(let O=1;O<=T/2+1;O++){let S=0,X=0;u=this.J(D-O,O,D,_),s=this.J(D+O,O,D,_);for(let H=u;H<=s;H+=2){H===u||H<s&&U[H-1]<U[H+1]?N=U[H+1]:N=U[H-1]+1,c=N-(H-D)-P;const Q=N;for(;N<e&&c<E&&this.p(N+1,c+1);)N++,c++;if(U[H]=N,N+c>S+X&&(S=N,X=c),!Z&&Math.abs(H-k)<=O-1&&N>=M[H])return R[0]=N,A[0]=c,Q<=M[H]&&l.MaxDifferencesHistory>0&&O<=l.MaxDifferencesHistory+1?this.x(D,u,s,P,k,o,h,j,U,M,N,e,R,c,E,A,Z,w):null}const Y=(S-L+(X-m)-O)/2;if(this.a!==null&&!this.a(S,Y))return w[0]=!0,R[0]=S,A[0]=X,Y>0&&l.MaxDifferencesHistory>0&&O<=l.MaxDifferencesHistory+1?this.x(D,u,s,P,k,o,h,j,U,M,N,e,R,c,E,A,Z,w):(L++,m++,[new t.$Rv(L,e-L+1,m,E-m+1)]);o=this.J(k-O,O,k,_),h=this.J(k+O,O,k,_);for(let H=o;H<=h;H+=2){H===o||H<h&&M[H-1]>=M[H+1]?N=M[H+1]-1:N=M[H-1],c=N-(H-k)-j;const Q=N;for(;N>L&&c>m&&this.p(N,c);)N--,c--;if(M[H]=N,Z&&Math.abs(H-D)<=O&&N<=U[H])return R[0]=N,A[0]=c,Q>=U[H]&&l.MaxDifferencesHistory>0&&O<=l.MaxDifferencesHistory+1?this.x(D,u,s,P,k,o,h,j,U,M,N,e,R,c,E,A,Z,w):null}if(O<=l.MaxDifferencesHistory){let H=new Int32Array(s-u+2);H[0]=D-u+1,a.Copy2(U,u,H,1,s-u+1),this.k.push(H),H=new Int32Array(h-o+2),H[0]=k-o+1,a.Copy2(M,o,H,1,h-o+1),this.m.push(H)}}return this.x(D,u,s,P,k,o,h,j,U,M,N,e,R,c,E,A,Z,w)}z(L){for(let e=0;e<L.length;e++){const m=L[e],E=e<L.length-1?L[e+1].originalStart:this.f.length,R=e<L.length-1?L[e+1].modifiedStart:this.h.length,A=m.originalLength>0,w=m.modifiedLength>0;for(;m.originalStart+m.originalLength<E&&m.modifiedStart+m.modifiedLength<R&&(!A||this.s(m.originalStart,m.originalStart+m.originalLength))&&(!w||this.u(m.modifiedStart,m.modifiedStart+m.modifiedLength));){const c=this.q(m.originalStart,m.modifiedStart);if(this.q(m.originalStart+m.originalLength,m.modifiedStart+m.modifiedLength)&&!c)break;m.originalStart++,m.modifiedStart++}const N=[null];if(e<L.length-1&&this.I(L[e],L[e+1],N)){L[e]=N[0],L.splice(e+1,1),e--;continue}}for(let e=L.length-1;e>=0;e--){const m=L[e];let E=0,R=0;if(e>0){const s=L[e-1];E=s.originalStart+s.originalLength,R=s.modifiedStart+s.modifiedLength}const A=m.originalLength>0,w=m.modifiedLength>0;let N=0,c=this.G(m.originalStart,m.originalLength,m.modifiedStart,m.modifiedLength);for(let s=1;;s++){const o=m.originalStart-s,h=m.modifiedStart-s;if(o<E||h<R||A&&!this.s(o,o+m.originalLength)||w&&!this.u(h,h+m.modifiedLength))break;const _=(o===E&&h===R?5:0)+this.G(o,m.originalLength,h,m.modifiedLength);_>c&&(c=_,N=s)}m.originalStart-=N,m.modifiedStart-=N;const u=[null];if(e>0&&this.I(L[e-1],L[e],u)){L[e-1]=u[0],L.splice(e,1),e++;continue}}if(this.d)for(let e=1,m=L.length;e<m;e++){const E=L[e-1],R=L[e],A=R.originalStart-E.originalStart-E.originalLength,w=E.originalStart,N=R.originalStart+R.originalLength,c=N-w,u=E.modifiedStart,s=R.modifiedStart+R.modifiedLength,o=s-u;if(A<5&&c<20&&o<20){const h=this.A(w,c,u,o,A);if(h){const[T,_]=h;(T!==E.originalStart+E.originalLength||_!==E.modifiedStart+E.modifiedLength)&&(E.originalLength=T-E.originalStart,E.modifiedLength=_-E.modifiedStart,R.originalStart=T+A,R.modifiedStart=_+A,R.originalLength=N-R.originalStart,R.modifiedLength=s-R.modifiedStart)}}}return L}A(L,e,m,E,R){if(e<R||E<R)return null;const A=L+e-R+1,w=m+E-R+1;let N=0,c=0,u=0;for(let s=L;s<A;s++)for(let o=m;o<w;o++){const h=this.B(s,o,R);h>0&&h>N&&(N=h,c=s,u=o)}return N>0?[c,u]:null}B(L,e,m){let E=0;for(let R=0;R<m;R++){if(!this.p(L+R,e+R))return 0;E+=this.e[L+R].length}return E}C(L){return L<=0||L>=this.f.length-1?!0:this.d&&/^\s*$/.test(this.e[L])}D(L,e){if(this.C(L)||this.C(L-1))return!0;if(e>0){const m=L+e;if(this.C(m-1)||this.C(m))return!0}return!1}E(L){return L<=0||L>=this.h.length-1?!0:this.d&&/^\s*$/.test(this.g[L])}F(L,e){if(this.E(L)||this.E(L-1))return!0;if(e>0){const m=L+e;if(this.E(m-1)||this.E(m))return!0}return!1}G(L,e,m,E){const R=this.D(L,e)?1:0,A=this.F(m,E)?1:0;return R+A}H(L,e){const m=[];if(L.length===0||e.length===0)return e.length>0?e:L;if(this.I(L[L.length-1],e[0],m)){const E=new Array(L.length+e.length-1);return a.Copy(L,0,E,0,L.length-1),E[L.length-1]=m[0],a.Copy(e,1,E,L.length,e.length-1),E}else{const E=new Array(L.length+e.length);return a.Copy(L,0,E,0,L.length),a.Copy(e,0,E,L.length,e.length),E}}I(L,e,m){if(d.Assert(L.originalStart<=e.originalStart,"Left change is not less than or equal to right change"),d.Assert(L.modifiedStart<=e.modifiedStart,"Left change is not less than or equal to right change"),L.originalStart+L.originalLength>=e.originalStart||L.modifiedStart+L.modifiedLength>=e.modifiedStart){const E=L.originalStart;let R=L.originalLength;const A=L.modifiedStart;let w=L.modifiedLength;return L.originalStart+L.originalLength>=e.originalStart&&(R=e.originalStart+e.originalLength-L.originalStart),L.modifiedStart+L.modifiedLength>=e.modifiedStart&&(w=e.modifiedStart+e.modifiedLength-L.modifiedStart),m[0]=new t.$Rv(E,R,A,w),!0}else return m[0]=null,!1}J(L,e,m,E){if(L>=0&&L<E)return L;const R=m,A=E-m-1,w=e%2===0;if(L<0){const N=R%2===0;return w===N?0:1}else{const N=A%2===0;return w===N?E-1:E-2}}}i.$Uv=$}),ne(ie[30],re([0,1,14]),function(q,i,t){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$ot=i.$nt=void 0;class n{constructor(d){const a=(0,t.$9e)(d);this.c=a,this.a=n.d(a),this.b=new Map}static d(d){const a=new Uint8Array(256);return a.fill(d),a}set(d,a){const l=(0,t.$9e)(a);d>=0&&d<256?this.a[d]=l:this.b.set(d,l)}get(d){return d>=0&&d<256?this.a[d]:this.b.get(d)||this.c}clear(){this.a.fill(this.c),this.b.clear()}}i.$nt=n;var p;(function(v){v[v.False=0]="False",v[v.True=1]="True"})(p||(p={}));class g{constructor(){this.a=new n(p.False)}add(d){this.a.set(d,p.True)}has(d){return this.a.get(d)===p.True}clear(){return this.a.clear()}}i.$ot=g}),ne(ie[6],re([0,1,4]),function(q,i,t){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$Bv=i.$Av=void 0;class n{static addRange(v,d){let a=0;for(;a<d.length&&d[a].endExclusive<v.start;)a++;let l=a;for(;l<d.length&&d[l].start<=v.endExclusive;)l++;if(a===l)d.splice(a,0,v);else{const f=Math.min(v.start,d[a].start),$=Math.max(v.endExclusive,d[l-1].endExclusive);d.splice(a,l-a,new n(f,$))}}static tryCreate(v,d){if(!(v>d))return new n(v,d)}static ofLength(v){return new n(0,v)}static ofStartAndLength(v,d){return new n(v,v+d)}constructor(v,d){if(this.start=v,this.endExclusive=d,v>d)throw new t.$cb(`Invalid range: ${this.toString()}`)}get isEmpty(){return this.start===this.endExclusive}delta(v){return new n(this.start+v,this.endExclusive+v)}deltaStart(v){return new n(this.start+v,this.endExclusive)}deltaEnd(v){return new n(this.start,this.endExclusive+v)}get length(){return this.endExclusive-this.start}toString(){return`[${this.start}, ${this.endExclusive})`}equals(v){return this.start===v.start&&this.endExclusive===v.endExclusive}containsRange(v){return this.start<=v.start&&v.endExclusive<=this.endExclusive}contains(v){return this.start<=v&&v<this.endExclusive}join(v){return new n(Math.min(this.start,v.start),Math.max(this.endExclusive,v.endExclusive))}intersect(v){const d=Math.max(this.start,v.start),a=Math.min(this.endExclusive,v.endExclusive);if(d<=a)return new n(d,a)}intersects(v){const d=Math.max(this.start,v.start),a=Math.min(this.endExclusive,v.endExclusive);return d<a}intersectsOrTouches(v){const d=Math.max(this.start,v.start),a=Math.min(this.endExclusive,v.endExclusive);return d<=a}isBefore(v){return this.endExclusive<=v.start}isAfter(v){return this.start>=v.endExclusive}slice(v){return v.slice(this.start,this.endExclusive)}substring(v){return v.substring(this.start,this.endExclusive)}clip(v){if(this.isEmpty)throw new t.$cb(`Invalid clipping range: ${this.toString()}`);return Math.max(this.start,Math.min(this.endExclusive-1,v))}clipCyclic(v){if(this.isEmpty)throw new t.$cb(`Invalid clipping range: ${this.toString()}`);return v<this.start?this.endExclusive-(this.start-v)%this.length:v>=this.endExclusive?this.start+(v-this.start)%this.length:v}map(v){const d=[];for(let a=this.start;a<this.endExclusive;a++)d.push(v(a));return d}forEach(v){for(let d=this.start;d<this.endExclusive;d++)v(d)}}i.$Av=n;class p{constructor(){this.a=[]}addRange(v){let d=0;for(;d<this.a.length&&this.a[d].endExclusive<v.start;)d++;let a=d;for(;a<this.a.length&&this.a[a].start<=v.endExclusive;)a++;if(d===a)this.a.splice(d,0,v);else{const l=Math.min(v.start,this.a[d].start),f=Math.max(v.endExclusive,this.a[a-1].endExclusive);this.a.splice(d,a-d,new n(l,f))}}toString(){return this.a.map(v=>v.toString()).join(", ")}intersectsStrict(v){let d=0;for(;d<this.a.length&&this.a[d].endExclusive<=v.start;)d++;return d<this.a.length&&this.a[d].start<v.endExclusive}intersectWithRange(v){const d=new p;for(const a of this.a){const l=a.intersect(v);l&&d.addRange(l)}return d}intersectWithRangeLength(v){return this.intersectWithRange(v).length}get length(){return this.a.reduce((v,d)=>v+d.length,0)}}i.$Bv=p}),ne(ie[5],re([0,1]),function(q,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$bt=void 0;class t{constructor(p,g){this.lineNumber=p,this.column=g}with(p=this.lineNumber,g=this.column){return p===this.lineNumber&&g===this.column?this:new t(p,g)}delta(p=0,g=0){return this.with(this.lineNumber+p,this.column+g)}equals(p){return t.equals(this,p)}static equals(p,g){return!p&&!g?!0:!!p&&!!g&&p.lineNumber===g.lineNumber&&p.column===g.column}isBefore(p){return t.isBefore(this,p)}static isBefore(p,g){return p.lineNumber<g.lineNumber?!0:g.lineNumber<p.lineNumber?!1:p.column<g.column}isBeforeOrEqual(p){return t.isBeforeOrEqual(this,p)}static isBeforeOrEqual(p,g){return p.lineNumber<g.lineNumber?!0:g.lineNumber<p.lineNumber?!1:p.column<=g.column}static compare(p,g){const v=p.lineNumber|0,d=g.lineNumber|0;if(v===d){const a=p.column|0,l=g.column|0;return a-l}return v-d}clone(){return new t(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(p){return new t(p.lineNumber,p.column)}static isIPosition(p){return p&&typeof p.lineNumber=="number"&&typeof p.column=="number"}toJSON(){return{lineNumber:this.lineNumber,column:this.column}}}i.$bt=t}),ne(ie[2],re([0,1,5]),function(q,i,t){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$ct=void 0;class n{constructor(g,v,d,a){g>d||g===d&&v>a?(this.startLineNumber=d,this.startColumn=a,this.endLineNumber=g,this.endColumn=v):(this.startLineNumber=g,this.startColumn=v,this.endLineNumber=d,this.endColumn=a)}isEmpty(){return n.isEmpty(this)}static isEmpty(g){return g.startLineNumber===g.endLineNumber&&g.startColumn===g.endColumn}containsPosition(g){return n.containsPosition(this,g)}static containsPosition(g,v){return!(v.lineNumber<g.startLineNumber||v.lineNumber>g.endLineNumber||v.lineNumber===g.startLineNumber&&v.column<g.startColumn||v.lineNumber===g.endLineNumber&&v.column>g.endColumn)}static strictContainsPosition(g,v){return!(v.lineNumber<g.startLineNumber||v.lineNumber>g.endLineNumber||v.lineNumber===g.startLineNumber&&v.column<=g.startColumn||v.lineNumber===g.endLineNumber&&v.column>=g.endColumn)}containsRange(g){return n.containsRange(this,g)}static containsRange(g,v){return!(v.startLineNumber<g.startLineNumber||v.endLineNumber<g.startLineNumber||v.startLineNumber>g.endLineNumber||v.endLineNumber>g.endLineNumber||v.startLineNumber===g.startLineNumber&&v.startColumn<g.startColumn||v.endLineNumber===g.endLineNumber&&v.endColumn>g.endColumn)}strictContainsRange(g){return n.strictContainsRange(this,g)}static strictContainsRange(g,v){return!(v.startLineNumber<g.startLineNumber||v.endLineNumber<g.startLineNumber||v.startLineNumber>g.endLineNumber||v.endLineNumber>g.endLineNumber||v.startLineNumber===g.startLineNumber&&v.startColumn<=g.startColumn||v.endLineNumber===g.endLineNumber&&v.endColumn>=g.endColumn)}plusRange(g){return n.plusRange(this,g)}static plusRange(g,v){let d,a,l,f;return v.startLineNumber<g.startLineNumber?(d=v.startLineNumber,a=v.startColumn):v.startLineNumber===g.startLineNumber?(d=v.startLineNumber,a=Math.min(v.startColumn,g.startColumn)):(d=g.startLineNumber,a=g.startColumn),v.endLineNumber>g.endLineNumber?(l=v.endLineNumber,f=v.endColumn):v.endLineNumber===g.endLineNumber?(l=v.endLineNumber,f=Math.max(v.endColumn,g.endColumn)):(l=g.endLineNumber,f=g.endColumn),new n(d,a,l,f)}intersectRanges(g){return n.intersectRanges(this,g)}static intersectRanges(g,v){let d=g.startLineNumber,a=g.startColumn,l=g.endLineNumber,f=g.endColumn;const $=v.startLineNumber,b=v.startColumn,L=v.endLineNumber,e=v.endColumn;return d<$?(d=$,a=b):d===$&&(a=Math.max(a,b)),l>L?(l=L,f=e):l===L&&(f=Math.min(f,e)),d>l||d===l&&a>f?null:new n(d,a,l,f)}equalsRange(g){return n.equalsRange(this,g)}static equalsRange(g,v){return!g&&!v?!0:!!g&&!!v&&g.startLineNumber===v.startLineNumber&&g.startColumn===v.startColumn&&g.endLineNumber===v.endLineNumber&&g.endColumn===v.endColumn}getEndPosition(){return n.getEndPosition(this)}static getEndPosition(g){return new t.$bt(g.endLineNumber,g.endColumn)}getStartPosition(){return n.getStartPosition(this)}static getStartPosition(g){return new t.$bt(g.startLineNumber,g.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(g,v){return new n(this.startLineNumber,this.startColumn,g,v)}setStartPosition(g,v){return new n(g,v,this.endLineNumber,this.endColumn)}collapseToStart(){return n.collapseToStart(this)}static collapseToStart(g){return new n(g.startLineNumber,g.startColumn,g.startLineNumber,g.startColumn)}collapseToEnd(){return n.collapseToEnd(this)}static collapseToEnd(g){return new n(g.endLineNumber,g.endColumn,g.endLineNumber,g.endColumn)}delta(g){return new n(this.startLineNumber+g,this.startColumn,this.endLineNumber+g,this.endColumn)}static fromPositions(g,v=g){return new n(g.lineNumber,g.column,v.lineNumber,v.column)}static lift(g){return g?new n(g.startLineNumber,g.startColumn,g.endLineNumber,g.endColumn):null}static isIRange(g){return g&&typeof g.startLineNumber=="number"&&typeof g.startColumn=="number"&&typeof g.endLineNumber=="number"&&typeof g.endColumn=="number"}static areIntersectingOrTouching(g,v){return!(g.endLineNumber<v.startLineNumber||g.endLineNumber===v.startLineNumber&&g.endColumn<v.startColumn||v.endLineNumber<g.startLineNumber||v.endLineNumber===g.startLineNumber&&v.endColumn<g.startColumn)}static areIntersecting(g,v){return!(g.endLineNumber<v.startLineNumber||g.endLineNumber===v.startLineNumber&&g.endColumn<=v.startColumn||v.endLineNumber<g.startLineNumber||v.endLineNumber===g.startLineNumber&&v.endColumn<=g.startColumn)}static compareRangesUsingStarts(g,v){if(g&&v){const l=g.startLineNumber|0,f=v.startLineNumber|0;if(l===f){const $=g.startColumn|0,b=v.startColumn|0;if($===b){const L=g.endLineNumber|0,e=v.endLineNumber|0;if(L===e){const m=g.endColumn|0,E=v.endColumn|0;return m-E}return L-e}return $-b}return l-f}return(g?1:0)-(v?1:0)}static compareRangesUsingEnds(g,v){return g.endLineNumber===v.endLineNumber?g.endColumn===v.endColumn?g.startLineNumber===v.startLineNumber?g.startColumn-v.startColumn:g.startLineNumber-v.startLineNumber:g.endColumn-v.endColumn:g.endLineNumber-v.endLineNumber}static spansMultipleLines(g){return g.endLineNumber>g.startLineNumber}toJSON(){return this}}i.$ct=n}),ne(ie[47],re([0,1,2]),function(q,i,t){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$dt=void 0;class n{static insert(g,v){return{range:new t.$ct(g.lineNumber,g.column,g.lineNumber,g.column),text:v,forceMoveMarkers:!0}}static delete(g){return{range:g,text:null}}static replace(g,v){return{range:g,text:v}}static replaceMove(g,v){return{range:g,text:v,forceMoveMarkers:!0}}}i.$dt=n}),ne(ie[15],re([0,1,4,6,2,9]),function(q,i,t,n,p,g){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$Dv=i.$Cv=void 0;class v{static fromRange(l){return new v(l.startLineNumber,l.endLineNumber)}static fromRangeInclusive(l){return new v(l.startLineNumber,l.endLineNumber+1)}static subtract(l,f){return f?l.startLineNumber<f.startLineNumber&&f.endLineNumberExclusive<l.endLineNumberExclusive?[new v(l.startLineNumber,f.startLineNumber),new v(f.endLineNumberExclusive,l.endLineNumberExclusive)]:f.startLineNumber<=l.startLineNumber&&l.endLineNumberExclusive<=f.endLineNumberExclusive?[]:f.endLineNumberExclusive<l.endLineNumberExclusive?[new v(Math.max(f.endLineNumberExclusive,l.startLineNumber),l.endLineNumberExclusive)]:[new v(l.startLineNumber,Math.min(f.startLineNumber,l.endLineNumberExclusive))]:[l]}static joinMany(l){if(l.length===0)return[];let f=new d(l[0].slice());for(let $=1;$<l.length;$++)f=f.getUnion(new d(l[$].slice()));return f.ranges}static join(l){if(l.length===0)throw new t.$cb("lineRanges cannot be empty");let f=l[0].startLineNumber,$=l[0].endLineNumberExclusive;for(let b=1;b<l.length;b++)f=Math.min(f,l[b].startLineNumber),$=Math.max($,l[b].endLineNumberExclusive);return new v(f,$)}static ofLength(l,f){return new v(l,l+f)}static deserialize(l){return new v(l[0],l[1])}constructor(l,f){if(l>f)throw new t.$cb(`startLineNumber ${l} cannot be after endLineNumberExclusive ${f}`);this.startLineNumber=l,this.endLineNumberExclusive=f}contains(l){return this.startLineNumber<=l&&l<this.endLineNumberExclusive}get isEmpty(){return this.startLineNumber===this.endLineNumberExclusive}delta(l){return new v(this.startLineNumber+l,this.endLineNumberExclusive+l)}deltaLength(l){return new v(this.startLineNumber,this.endLineNumberExclusive+l)}get length(){return this.endLineNumberExclusive-this.startLineNumber}join(l){return new v(Math.min(this.startLineNumber,l.startLineNumber),Math.max(this.endLineNumberExclusive,l.endLineNumberExclusive))}toString(){return`[${this.startLineNumber},${this.endLineNumberExclusive})`}intersect(l){const f=Math.max(this.startLineNumber,l.startLineNumber),$=Math.min(this.endLineNumberExclusive,l.endLineNumberExclusive);if(f<=$)return new v(f,$)}intersectsStrict(l){return this.startLineNumber<l.endLineNumberExclusive&&l.startLineNumber<this.endLineNumberExclusive}overlapOrTouch(l){return this.startLineNumber<=l.endLineNumberExclusive&&l.startLineNumber<=this.endLineNumberExclusive}equals(l){return this.startLineNumber===l.startLineNumber&&this.endLineNumberExclusive===l.endLineNumberExclusive}toInclusiveRange(){return this.isEmpty?null:new p.$ct(this.startLineNumber,1,this.endLineNumberExclusive-1,Number.MAX_SAFE_INTEGER)}toExclusiveRange(){return new p.$ct(this.startLineNumber,1,this.endLineNumberExclusive,1)}mapToLineArray(l){const f=[];for(let $=this.startLineNumber;$<this.endLineNumberExclusive;$++)f.push(l($));return f}forEach(l){for(let f=this.startLineNumber;f<this.endLineNumberExclusive;f++)l(f)}serialize(){return[this.startLineNumber,this.endLineNumberExclusive]}includes(l){return this.startLineNumber<=l&&l<this.endLineNumberExclusive}toOffsetRange(){return new n.$Av(this.startLineNumber-1,this.endLineNumberExclusive-1)}}i.$Cv=v;class d{constructor(l=[]){this.c=l}get ranges(){return this.c}addRange(l){if(l.length===0)return;const f=(0,g.$kb)(this.c,b=>b.endLineNumberExclusive>=l.startLineNumber),$=(0,g.$ib)(this.c,b=>b.startLineNumber<=l.endLineNumberExclusive)+1;if(f===$)this.c.splice(f,0,l);else if(f===$-1){const b=this.c[f];this.c[f]=b.join(l)}else{const b=this.c[f].join(this.c[$-1]).join(l);this.c.splice(f,$-f,b)}}contains(l){const f=(0,g.$hb)(this.c,$=>$.startLineNumber<=l);return!!f&&f.endLineNumberExclusive>l}intersects(l){const f=(0,g.$hb)(this.c,$=>$.startLineNumber<l.endLineNumberExclusive);return!!f&&f.endLineNumberExclusive>l.startLineNumber}getUnion(l){if(this.c.length===0)return l;if(l.c.length===0)return this;const f=[];let $=0,b=0,L=null;for(;$<this.c.length||b<l.c.length;){let e=null;if($<this.c.length&&b<l.c.length){const m=this.c[$],E=l.c[b];m.startLineNumber<E.startLineNumber?(e=m,$++):(e=E,b++)}else $<this.c.length?(e=this.c[$],$++):(e=l.c[b],b++);L===null?L=e:L.endLineNumberExclusive>=e.startLineNumber?L=new v(L.startLineNumber,Math.max(L.endLineNumberExclusive,e.endLineNumberExclusive)):(f.push(L),L=e)}return L!==null&&f.push(L),new d(f)}subtractFrom(l){const f=(0,g.$kb)(this.c,e=>e.endLineNumberExclusive>=l.startLineNumber),$=(0,g.$ib)(this.c,e=>e.startLineNumber<=l.endLineNumberExclusive)+1;if(f===$)return new d([l]);const b=[];let L=l.startLineNumber;for(let e=f;e<$;e++){const m=this.c[e];m.startLineNumber>L&&b.push(new v(L,m.startLineNumber)),L=m.endLineNumberExclusive}return L<l.endLineNumberExclusive&&b.push(new v(L,l.endLineNumberExclusive)),new d(b)}toString(){return this.c.map(l=>l.toString()).join(", ")}getIntersection(l){const f=[];let $=0,b=0;for(;$<this.c.length&&b<l.c.length;){const L=this.c[$],e=l.c[b],m=L.intersect(e);m&&!m.isEmpty&&f.push(m),L.endLineNumberExclusive<e.endLineNumberExclusive?$++:b++}return new d(f)}getWithDelta(l){return new d(this.c.map(f=>f.delta(l)))}}i.$Dv=d}),ne(ie[48],re([0,1,5,2]),function(q,i,t,n){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$et=i.SelectionDirection=void 0;var p;(function(v){v[v.LTR=0]="LTR",v[v.RTL=1]="RTL"})(p||(i.SelectionDirection=p={}));class g extends n.$ct{constructor(d,a,l,f){super(d,a,l,f),this.selectionStartLineNumber=d,this.selectionStartColumn=a,this.positionLineNumber=l,this.positionColumn=f}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(d){return g.selectionsEqual(this,d)}static selectionsEqual(d,a){return d.selectionStartLineNumber===a.selectionStartLineNumber&&d.selectionStartColumn===a.selectionStartColumn&&d.positionLineNumber===a.positionLineNumber&&d.positionColumn===a.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?p.LTR:p.RTL}setEndPosition(d,a){return this.getDirection()===p.LTR?new g(this.startLineNumber,this.startColumn,d,a):new g(d,a,this.startLineNumber,this.startColumn)}getPosition(){return new t.$bt(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new t.$bt(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(d,a){return this.getDirection()===p.LTR?new g(d,a,this.endLineNumber,this.endColumn):new g(this.endLineNumber,this.endColumn,d,a)}static fromPositions(d,a=d){return new g(d.lineNumber,d.column,a.lineNumber,a.column)}static fromRange(d,a){return a===p.LTR?new g(d.startLineNumber,d.startColumn,d.endLineNumber,d.endColumn):new g(d.endLineNumber,d.endColumn,d.startLineNumber,d.startColumn)}static liftSelection(d){return new g(d.selectionStartLineNumber,d.selectionStartColumn,d.positionLineNumber,d.positionColumn)}static selectionsArrEqual(d,a){if(d&&!a||!d&&a)return!1;if(!d&&!a)return!0;if(d.length!==a.length)return!1;for(let l=0,f=d.length;l<f;l++)if(!this.selectionsEqual(d[l],a[l]))return!1;return!0}static isISelection(d){return d&&typeof d.selectionStartLineNumber=="number"&&typeof d.selectionStartColumn=="number"&&typeof d.positionLineNumber=="number"&&typeof d.positionColumn=="number"}static createWithDirection(d,a,l,f,$){return $===p.LTR?new g(d,a,l,f):new g(l,f,d,a)}}i.$et=g}),ne(ie[31],re([0,1,5,2]),function(q,i,t,n){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$It=void 0;class p{static{this.zero=new p(0,0)}static lengthDiffNonNegative(v,d){return d.isLessThan(v)?p.zero:v.lineCount===d.lineCount?new p(0,d.columnCount-v.columnCount):new p(d.lineCount-v.lineCount,d.columnCount)}static betweenPositions(v,d){return v.lineNumber===d.lineNumber?new p(0,d.column-v.column):new p(d.lineNumber-v.lineNumber,d.column-1)}static ofRange(v){return p.betweenPositions(v.getStartPosition(),v.getEndPosition())}static ofText(v){let d=0,a=0;for(const l of v)l===`
`?(d++,a=0):a++;return new p(d,a)}constructor(v,d){this.lineCount=v,this.columnCount=d}isZero(){return this.lineCount===0&&this.columnCount===0}isLessThan(v){return this.lineCount!==v.lineCount?this.lineCount<v.lineCount:this.columnCount<v.columnCount}isGreaterThan(v){return this.lineCount!==v.lineCount?this.lineCount>v.lineCount:this.columnCount>v.columnCount}isGreaterThanOrEqualTo(v){return this.lineCount!==v.lineCount?this.lineCount>v.lineCount:this.columnCount>=v.columnCount}equals(v){return this.lineCount===v.lineCount&&this.columnCount===v.columnCount}compare(v){return this.lineCount!==v.lineCount?this.lineCount-v.lineCount:this.columnCount-v.columnCount}add(v){return v.lineCount===0?new p(this.lineCount,this.columnCount+v.columnCount):new p(this.lineCount+v.lineCount,v.columnCount)}createRange(v){return this.lineCount===0?new n.$ct(v.lineNumber,v.column,v.lineNumber,v.column+this.columnCount):new n.$ct(v.lineNumber,v.column,v.lineNumber+this.lineCount,this.columnCount+1)}toRange(){return new n.$ct(1,1,this.lineCount+1,this.columnCount+1)}addToPosition(v){return this.lineCount===0?new t.$bt(v.lineNumber,v.column+this.columnCount):new t.$bt(v.lineNumber+this.lineCount,this.columnCount+1)}toString(){return`${this.lineCount},${this.columnCount}`}}i.$It=p}),ne(ie[49],re([0,1,9,6,5,2,31]),function(q,i,t,n,p,g,v){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$Vv=void 0;class d{constructor(l){this.text=l,this.a=[],this.a.push(0);for(let f=0;f<l.length;f++)l.charAt(f)===`
`&&this.a.push(f+1)}getOffset(l){return this.a[l.lineNumber-1]+l.column-1}getOffsetRange(l){return new n.$Av(this.getOffset(l.getStartPosition()),this.getOffset(l.getEndPosition()))}getPosition(l){const f=(0,t.$ib)(this.a,L=>L<=l),$=f+1,b=l-this.a[f]+1;return new p.$bt($,b)}getRange(l){return g.$ct.fromPositions(this.getPosition(l.start),this.getPosition(l.endExclusive))}getTextLength(l){return v.$It.ofRange(this.getRange(l))}get textLength(){const l=this.a.length-1;return new v.$It(l,this.text.length-this.a[l])}}i.$Vv=d}),ne(ie[50],re([0,1,11,4,5,49,2,31]),function(q,i,t,n,p,g,v,d){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$1v=i.$Zv=i.$Yv=i.$Xv=i.$Wv=void 0;class a{static single(m,E){return new a([new l(m,E)])}constructor(m){this.edits=m,(0,t.$hd)(()=>(0,t.$id)(m,(E,R)=>E.range.getEndPosition().isBeforeOrEqual(R.range.getStartPosition())))}normalize(){const m=[];for(const E of this.edits)if(m.length>0&&m[m.length-1].range.getEndPosition().equals(E.range.getStartPosition())){const R=m[m.length-1];m[m.length-1]=new l(R.range.plusRange(E.range),R.text+E.text)}else E.isEmpty||m.push(E);return new a(m)}mapPosition(m){let E=0,R=0,A=0;for(const w of this.edits){const N=w.range.getStartPosition(),c=w.range.getEndPosition();if(m.isBeforeOrEqual(N))break;const u=d.$It.ofText(w.text);if(m.isBefore(c)){const s=new p.$bt(N.lineNumber+E,N.column+(N.lineNumber+E===R?A:0)),o=u.addToPosition(s);return f(s,o)}E+=u.lineCount-(w.range.endLineNumber-w.range.startLineNumber),u.lineCount===0?c.lineNumber!==N.lineNumber?A+=u.columnCount-(c.column-1):A+=u.columnCount-(c.column-N.column):A=u.columnCount,R=c.lineNumber+E}return new p.$bt(m.lineNumber+E,m.column+(m.lineNumber+E===R?A:0))}mapRange(m){function E(N){return N instanceof p.$bt?N:N.getStartPosition()}function R(N){return N instanceof p.$bt?N:N.getEndPosition()}const A=E(this.mapPosition(m.getStartPosition())),w=R(this.mapPosition(m.getEndPosition()));return f(A,w)}inverseMapPosition(m,E){return this.inverse(E).mapPosition(m)}inverseMapRange(m,E){return this.inverse(E).mapRange(m)}apply(m){let E="",R=new p.$bt(1,1);for(const w of this.edits){const N=w.range,c=N.getStartPosition(),u=N.getEndPosition(),s=f(R,c);s.isEmpty()||(E+=m.getValueOfRange(s)),E+=w.text,R=u}const A=f(R,m.endPositionExclusive);return A.isEmpty()||(E+=m.getValueOfRange(A)),E}applyToString(m){const E=new L(m);return this.apply(E)}inverse(m){const E=this.getNewRanges();return new a(this.edits.map((R,A)=>new l(E[A],m.getValueOfRange(R.range))))}getNewRanges(){const m=[];let E=0,R=0,A=0;for(const w of this.edits){const N=d.$It.ofText(w.text),c=p.$bt.lift({lineNumber:w.range.startLineNumber+R,column:w.range.startColumn+(w.range.startLineNumber===E?A:0)}),u=N.createRange(c);m.push(u),R=u.endLineNumber-w.range.endLineNumber,A=u.endColumn-w.range.endColumn,E=w.range.endLineNumber}return m}}i.$Wv=a;class l{constructor(m,E){this.range=m,this.text=E}get isEmpty(){return this.range.isEmpty()&&this.text.length===0}static equals(m,E){return m.range.equalsRange(E.range)&&m.text===E.text}toSingleEditOperation(){return{range:this.range,text:this.text}}}i.$Xv=l;function f(e,m){if(e.lineNumber===m.lineNumber&&e.column===Number.MAX_SAFE_INTEGER)return v.$ct.fromPositions(m,m);if(!e.isBeforeOrEqual(m))throw new n.$cb("start must be before end");return new v.$ct(e.lineNumber,e.column,m.lineNumber,m.column)}class ${get endPositionExclusive(){return this.length.addToPosition(new p.$bt(1,1))}getValue(){return this.getValueOfRange(this.length.toRange())}}i.$Yv=$;class b extends ${constructor(m,E){(0,t.$fd)(E>=1),super(),this.c=m,this.d=E}getValueOfRange(m){if(m.startLineNumber===m.endLineNumber)return this.c(m.startLineNumber).substring(m.startColumn-1,m.endColumn-1);let E=this.c(m.startLineNumber).substring(m.startColumn-1);for(let R=m.startLineNumber+1;R<m.endLineNumber;R++)E+=`
`+this.c(R);return E+=`
`+this.c(m.endLineNumber).substring(0,m.endColumn-1),E}get length(){const m=this.c(this.d);return new d.$It(this.d-1,m.length)}}i.$Zv=b;class L extends ${constructor(m){super(),this.value=m,this.c=new g.$Vv(this.value)}getValueOfRange(m){return this.c.getOffsetRange(m).substring(this.value)}get length(){return this.c.textLength}}i.$1v=L}),ne(ie[51],re([0,1,3,16,30]),function(q,i,t,n,p){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$pt=i.WordCharacterClass=void 0,i.$qt=a;var g;(function(l){l[l.Regular=0]="Regular",l[l.Whitespace=1]="Whitespace",l[l.WordSeparator=2]="WordSeparator"})(g||(i.WordCharacterClass=g={}));class v extends p.$nt{constructor(f,$){super(g.Regular),this.e=null,this.f=null,this.g=[],this.intlSegmenterLocales=$,this.intlSegmenterLocales.length>0?this.e=new Intl.Segmenter(this.intlSegmenterLocales,{granularity:"word"}):this.e=null;for(let b=0,L=f.length;b<L;b++)this.set(f.charCodeAt(b),g.WordSeparator);this.set(t.CharCode.Space,g.Whitespace),this.set(t.CharCode.Tab,g.Whitespace)}findPrevIntlWordBeforeOrAtOffset(f,$){let b=null;for(const L of this.h(f)){if(L.index>$)break;b=L}return b}findNextIntlWordAtOrAfterOffset(f,$){for(const b of this.h(f))if(!(b.index<$))return b;return null}h(f){return this.e?this.f===f?this.g:(this.f=f,this.g=this.j(this.e.segment(f)),this.g):[]}j(f){const $=[];for(const b of f)this.k(b)&&$.push(b);return $}k(f){return!!f.isWordLike}}i.$pt=v;const d=new n.$Dc(10);function a(l,f){const $=`${l}/${f.join(",")}`;let b=d.get($);return b||(b=new v(l,f),d.set($,b)),b}}),ne(ie[32],re([0,1,23,12,24]),function(q,i,t,n,p){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$st=i.$rt=void 0,i.$tt=v,i.$ut=a,i.$vt=l,i.$rt="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function g($=""){let b="(-?\\d*\\.\\d\\w*)|([^";for(const L of i.$rt)$.indexOf(L)>=0||(b+="\\"+L);return b+="\\s]+)",new RegExp(b,"g")}i.$st=g();function v($){let b=i.$st;if($&&$ instanceof RegExp)if($.global)b=$;else{let L="g";$.ignoreCase&&(L+="i"),$.multiline&&(L+="m"),$.unicode&&(L+="u"),b=new RegExp($.source,L)}return b.lastIndex=0,b}const d=new p.$5c;d.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function a($){const b=d.unshift($);return(0,n.$Sc)(b)}function l($,b,L,e,m){if(b=v(b),m||(m=t.Iterable.first(d)),L.length>m.maxLen){let N=$-m.maxLen/2;return N<0?N=0:e+=N,L=L.substring(N,$+m.maxLen/2),l($,b,L,e,m)}const E=Date.now(),R=$-1-e;let A=-1,w=null;for(let N=1;!(Date.now()-E>=m.timeBudget);N++){const c=R-m.windowSize*N;b.lastIndex=Math.max(0,c);const u=f(b,L,R,A);if(!u&&w||(w=u,c<=0))break;A=c}if(w){const N={word:w[0],startColumn:e+1+w.index,endColumn:e+1+w.index+w[0].length};return b.lastIndex=0,N}return null}function f($,b,L,e){let m;for(;m=$.exec(b);){const E=m.index||0;if(E<=L&&$.lastIndex>=L)return m;if(e>0&&E>e)return null}return null}}),ne(ie[10],re([0,1,7,4,6]),function(q,i,t,n,p){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$12=i.$Z2=i.$Y2=i.$X2=i.$W2=void 0;class g{static trivial($,b){return new g([new v(p.$Av.ofLength($.length),p.$Av.ofLength(b.length))],!1)}static trivialTimedOut($,b){return new g([new v(p.$Av.ofLength($.length),p.$Av.ofLength(b.length))],!0)}constructor($,b){this.diffs=$,this.hitTimeout=b}}i.$W2=g;class v{static invert($,b){const L=[];return(0,t.$Bb)($,(e,m)=>{L.push(v.fromOffsetPairs(e?e.getEndExclusives():d.zero,m?m.getStarts():new d(b,(e?e.seq2Range.endExclusive-e.seq1Range.endExclusive:0)+b)))}),L}static fromOffsetPairs($,b){return new v(new p.$Av($.offset1,b.offset1),new p.$Av($.offset2,b.offset2))}constructor($,b){this.seq1Range=$,this.seq2Range=b}swap(){return new v(this.seq2Range,this.seq1Range)}toString(){return`${this.seq1Range} <-> ${this.seq2Range}`}join($){return new v(this.seq1Range.join($.seq1Range),this.seq2Range.join($.seq2Range))}delta($){return $===0?this:new v(this.seq1Range.delta($),this.seq2Range.delta($))}deltaStart($){return $===0?this:new v(this.seq1Range.deltaStart($),this.seq2Range.deltaStart($))}deltaEnd($){return $===0?this:new v(this.seq1Range.deltaEnd($),this.seq2Range.deltaEnd($))}intersectsOrTouches($){return this.seq1Range.intersectsOrTouches($.seq1Range)||this.seq2Range.intersectsOrTouches($.seq2Range)}intersect($){const b=this.seq1Range.intersect($.seq1Range),L=this.seq2Range.intersect($.seq2Range);if(!(!b||!L))return new v(b,L)}getStarts(){return new d(this.seq1Range.start,this.seq2Range.start)}getEndExclusives(){return new d(this.seq1Range.endExclusive,this.seq2Range.endExclusive)}}i.$X2=v;class d{static{this.zero=new d(0,0)}static{this.max=new d(Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER)}constructor($,b){this.offset1=$,this.offset2=b}toString(){return`${this.offset1} <-> ${this.offset2}`}delta($){return $===0?this:new d(this.offset1+$,this.offset2+$)}equals($){return this.offset1===$.offset1&&this.offset2===$.offset2}}i.$Y2=d;class a{static{this.instance=new a}isValid(){return!0}}i.$Z2=a;class l{constructor($){if(this.e=$,this.c=Date.now(),this.d=!0,$<=0)throw new n.$cb("timeout must be positive")}isValid(){if(!(Date.now()-this.c<this.e)&&this.d){this.d=!1;debugger}return this.d}disable(){this.e=Number.MAX_SAFE_INTEGER,this.isValid=()=>!0,this.d=!0}}i.$12=l}),ne(ie[33],re([0,1,6,10]),function(q,i,t,n){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$62=void 0;class p{compute(l,f,$=n.$Z2.instance){if(l.length===0||f.length===0)return n.$W2.trivial(l,f);const b=l,L=f;function e(s,o){for(;s<b.length&&o<L.length&&b.getElement(s)===L.getElement(o);)s++,o++;return s}let m=0;const E=new v;E.set(0,e(0,0));const R=new d;R.set(0,E.get(0)===0?null:new g(null,0,0,E.get(0)));let A=0;e:for(;;){if(m++,!$.isValid())return n.$W2.trivialTimedOut(b,L);const s=-Math.min(m,L.length+m%2),o=Math.min(m,b.length+m%2);for(A=s;A<=o;A+=2){let h=0;const T=A===o?-1:E.get(A+1),_=A===s?-1:E.get(A-1)+1;h++;const U=Math.min(Math.max(T,_),b.length),M=U-A;if(h++,U>b.length||M>L.length)continue;const D=e(U,M);E.set(A,D);const k=U===T?R.get(A+1):R.get(A-1);if(R.set(A,D!==U?new g(k,U,M,D-U):k),E.get(A)===b.length&&E.get(A)-A===L.length)break e}}let w=R.get(A);const N=[];let c=b.length,u=L.length;for(;;){const s=w?w.x+w.length:0,o=w?w.y+w.length:0;if((s!==c||o!==u)&&N.push(new n.$X2(new t.$Av(s,c),new t.$Av(o,u))),!w)break;c=w.x,u=w.y,w=w.prev}return N.reverse(),new n.$W2(N,!1)}}i.$62=p;class g{constructor(l,f,$,b){this.prev=l,this.x=f,this.y=$,this.length=b}}class v{constructor(){this.a=new Int32Array(10),this.b=new Int32Array(10)}get(l){return l<0?(l=-l-1,this.b[l]):this.a[l]}set(l,f){if(l<0){if(l=-l-1,l>=this.b.length){const $=this.b;this.b=new Int32Array($.length*2),this.b.set($)}this.b[l]=f}else{if(l>=this.a.length){const $=this.a;this.a=new Int32Array($.length*2),this.a.set($)}this.a[l]=f}}}class d{constructor(){this.a=[],this.b=[]}get(l){return l<0?(l=-l-1,this.b[l]):this.a[l]}set(l,f){l<0?(l=-l-1,this.b[l]=f):this.a[l]=f}}}),ne(ie[52],re([0,1,7,6,10]),function(q,i,t,n,p){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$02=g,i.$$2=l,i.$_2=f,i.$a3=b,i.$b3=L;function g(e,m,E){let R=E;return R=v(e,m,R),R=v(e,m,R),R=d(e,m,R),R}function v(e,m,E){if(E.length===0)return E;const R=[];R.push(E[0]);for(let w=1;w<E.length;w++){const N=R[R.length-1];let c=E[w];if(c.seq1Range.isEmpty||c.seq2Range.isEmpty){const u=c.seq1Range.start-N.seq1Range.endExclusive;let s;for(s=1;s<=u&&!(e.getElement(c.seq1Range.start-s)!==e.getElement(c.seq1Range.endExclusive-s)||m.getElement(c.seq2Range.start-s)!==m.getElement(c.seq2Range.endExclusive-s));s++);if(s--,s===u){R[R.length-1]=new p.$X2(new n.$Av(N.seq1Range.start,c.seq1Range.endExclusive-u),new n.$Av(N.seq2Range.start,c.seq2Range.endExclusive-u));continue}c=c.delta(-s)}R.push(c)}const A=[];for(let w=0;w<R.length-1;w++){const N=R[w+1];let c=R[w];if(c.seq1Range.isEmpty||c.seq2Range.isEmpty){const u=N.seq1Range.start-c.seq1Range.endExclusive;let s;for(s=0;s<u&&!(!e.isStronglyEqual(c.seq1Range.start+s,c.seq1Range.endExclusive+s)||!m.isStronglyEqual(c.seq2Range.start+s,c.seq2Range.endExclusive+s));s++);if(s===u){R[w+1]=new p.$X2(new n.$Av(c.seq1Range.start+u,N.seq1Range.endExclusive),new n.$Av(c.seq2Range.start+u,N.seq2Range.endExclusive));continue}s>0&&(c=c.delta(s))}A.push(c)}return R.length>0&&A.push(R[R.length-1]),A}function d(e,m,E){if(!e.getBoundaryScore||!m.getBoundaryScore)return E;for(let R=0;R<E.length;R++){const A=R>0?E[R-1]:void 0,w=E[R],N=R+1<E.length?E[R+1]:void 0,c=new n.$Av(A?A.seq1Range.endExclusive+1:0,N?N.seq1Range.start-1:e.length),u=new n.$Av(A?A.seq2Range.endExclusive+1:0,N?N.seq2Range.start-1:m.length);w.seq1Range.isEmpty?E[R]=a(w,e,m,c,u):w.seq2Range.isEmpty&&(E[R]=a(w.swap(),m,e,u,c).swap())}return E}function a(e,m,E,R,A){let N=1;for(;e.seq1Range.start-N>=R.start&&e.seq2Range.start-N>=A.start&&E.isStronglyEqual(e.seq2Range.start-N,e.seq2Range.endExclusive-N)&&N<100;)N++;N--;let c=0;for(;e.seq1Range.start+c<R.endExclusive&&e.seq2Range.endExclusive+c<A.endExclusive&&E.isStronglyEqual(e.seq2Range.start+c,e.seq2Range.endExclusive+c)&&c<100;)c++;if(N===0&&c===0)return e;let u=0,s=-1;for(let o=-N;o<=c;o++){const h=e.seq2Range.start+o,T=e.seq2Range.endExclusive+o,_=e.seq1Range.start+o,U=m.getBoundaryScore(_)+E.getBoundaryScore(h)+E.getBoundaryScore(T);U>s&&(s=U,u=o)}return e.delta(u)}function l(e,m,E){const R=[];for(const A of E){const w=R[R.length-1];if(!w){R.push(A);continue}A.seq1Range.start-w.seq1Range.endExclusive<=2||A.seq2Range.start-w.seq2Range.endExclusive<=2?R[R.length-1]=new p.$X2(w.seq1Range.join(A.seq1Range),w.seq2Range.join(A.seq2Range)):R.push(A)}return R}function f(e,m,E){const R=p.$X2.invert(E,e.length),A=[];let w=new p.$Y2(0,0);function N(u,s){if(u.offset1<w.offset1||u.offset2<w.offset2)return;const o=e.findWordContaining(u.offset1),h=m.findWordContaining(u.offset2);if(!o||!h)return;let T=new p.$X2(o,h);const _=T.intersect(s);let U=_.seq1Range.length,M=_.seq2Range.length;for(;R.length>0;){const D=R[0];if(!(D.seq1Range.intersects(T.seq1Range)||D.seq2Range.intersects(T.seq2Range)))break;const P=e.findWordContaining(D.seq1Range.start),j=m.findWordContaining(D.seq2Range.start),B=new p.$X2(P,j),Z=B.intersect(D);if(U+=Z.seq1Range.length,M+=Z.seq2Range.length,T=T.join(B),T.seq1Range.endExclusive>=D.seq1Range.endExclusive)R.shift();else break}U+M<(T.seq1Range.length+T.seq2Range.length)*2/3&&A.push(T),w=T.getEndExclusives()}for(;R.length>0;){const u=R.shift();u.seq1Range.isEmpty||(N(u.getStarts(),u),N(u.getEndExclusives().delta(-1),u))}return $(E,A)}function $(e,m){const E=[];for(;e.length>0||m.length>0;){const R=e[0],A=m[0];let w;R&&(!A||R.seq1Range.start<A.seq1Range.start)?w=e.shift():w=m.shift(),E.length>0&&E[E.length-1].seq1Range.endExclusive>=w.seq1Range.start?E[E.length-1]=E[E.length-1].join(w):E.push(w)}return E}function b(e,m,E){let R=E;if(R.length===0)return R;let A=0,w;do{w=!1;const N=[R[0]];for(let c=1;c<R.length;c++){let o=function(T,_){const U=new n.$Av(s.seq1Range.endExclusive,u.seq1Range.start);return e.getText(U).replace(/\s/g,"").length<=4&&(T.seq1Range.length+T.seq2Range.length>5||_.seq1Range.length+_.seq2Range.length>5)};const u=R[c],s=N[N.length-1];o(s,u)?(w=!0,N[N.length-1]=N[N.length-1].join(u)):N.push(u)}R=N}while(A++<10&&w);return R}function L(e,m,E){let R=E;if(R.length===0)return R;let A=0,w;do{w=!1;const c=[R[0]];for(let u=1;u<R.length;u++){let h=function(_,U){const M=new n.$Av(o.seq1Range.endExclusive,s.seq1Range.start);if(e.countLinesIn(M)>5||M.length>500)return!1;const k=e.getText(M).trim();if(k.length>20||k.split(/\r\n|\r|\n/).length>1)return!1;const P=e.countLinesIn(_.seq1Range),j=_.seq1Range.length,B=m.countLinesIn(_.seq2Range),Z=_.seq2Range.length,O=e.countLinesIn(U.seq1Range),S=U.seq1Range.length,X=m.countLinesIn(U.seq2Range),Y=U.seq2Range.length,H=2*40+50;function Q(C){return Math.min(C,H)}return Math.pow(Math.pow(Q(P*40+j),1.5)+Math.pow(Q(B*40+Z),1.5),1.5)+Math.pow(Math.pow(Q(O*40+S),1.5)+Math.pow(Q(X*40+Y),1.5),1.5)>(H**1.5)**1.5*1.3};const s=R[u],o=c[c.length-1];h(o,s)?(w=!0,c[c.length-1]=c[c.length-1].join(s)):c.push(s)}R=c}while(A++<10&&w);const N=[];return(0,t.$Cb)(R,(c,u,s)=>{let o=u;function h(k){return k.length>0&&k.trim().length<=3&&u.seq1Range.length+u.seq2Range.length>100}const T=e.extendToFullLines(u.seq1Range),_=e.getText(new n.$Av(T.start,u.seq1Range.start));h(_)&&(o=o.deltaStart(-_.length));const U=e.getText(new n.$Av(u.seq1Range.endExclusive,T.endExclusive));h(U)&&(o=o.deltaEnd(U.length));const M=p.$X2.fromOffsetPairs(c?c.getEndExclusives():p.$Y2.zero,s?s.getStarts():p.$Y2.max),D=o.intersect(M);N.length>0&&D.getStarts().equals(N[N.length-1].getEndExclusives())?N[N.length-1]=N[N.length-1].join(D):N.push(D)}),N}}),ne(ie[53],re([0,1,3]),function(q,i,t){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$92=void 0;class n{constructor(v,d){this.a=v,this.b=d}getElement(v){return this.a[v]}get length(){return this.a.length}getBoundaryScore(v){const d=v===0?0:p(this.b[v-1]),a=v===this.b.length?0:p(this.b[v]);return 1e3-(d+a)}getText(v){return this.b.slice(v.start,v.endExclusive).join(`
`)}isStronglyEqual(v,d){return this.b[v]===this.b[d]}}i.$92=n;function p(g){let v=0;for(;v<g.length&&(g.charCodeAt(v)===t.CharCode.Space||g.charCodeAt(v)===t.CharCode.Tab);)v++;return v}}),ne(ie[18],re([0,1,3]),function(q,i,t){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$42=i.$22=void 0,i.$32=p;class n{constructor(d,a){this.width=d,this.height=a,this.a=[],this.a=new Array(d*a)}get(d,a){return this.a[d+a*this.width]}set(d,a,l){this.a[d+a*this.width]=l}}i.$22=n;function p(v){return v===t.CharCode.Space||v===t.CharCode.Tab}class g{static{this.a=new Map}static b(d){let a=this.a.get(d);return a===void 0&&(a=this.a.size,this.a.set(d,a)),a}constructor(d,a,l){this.range=d,this.lines=a,this.source=l,this.d=[];let f=0;for(let $=d.startLineNumber-1;$<d.endLineNumberExclusive-1;$++){const b=a[$];for(let e=0;e<b.length;e++){f++;const m=b[e],E=g.b(m);this.d[E]=(this.d[E]||0)+1}f++;const L=g.b(`
`);this.d[L]=(this.d[L]||0)+1}this.c=f}computeSimilarity(d){let a=0;const l=Math.max(this.d.length,d.d.length);for(let f=0;f<l;f++)a+=Math.abs((this.d[f]??0)-(d.d[f]??0));return 1-a/(this.c+d.c)}}i.$42=g}),ne(ie[54],re([0,1,6,10,18]),function(q,i,t,n,p){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$52=void 0;class g{compute(d,a,l=n.$Z2.instance,f){if(d.length===0||a.length===0)return n.$W2.trivial(d,a);const $=new p.$22(d.length,a.length),b=new p.$22(d.length,a.length),L=new p.$22(d.length,a.length);for(let N=0;N<d.length;N++)for(let c=0;c<a.length;c++){if(!l.isValid())return n.$W2.trivialTimedOut(d,a);const u=N===0?0:$.get(N-1,c),s=c===0?0:$.get(N,c-1);let o;d.getElement(N)===a.getElement(c)?(N===0||c===0?o=0:o=$.get(N-1,c-1),N>0&&c>0&&b.get(N-1,c-1)===3&&(o+=L.get(N-1,c-1)),o+=f?f(N,c):1):o=-1;const h=Math.max(u,s,o);if(h===o){const T=N>0&&c>0?L.get(N-1,c-1):0;L.set(N,c,T+1),b.set(N,c,3)}else h===u?(L.set(N,c,0),b.set(N,c,1)):h===s&&(L.set(N,c,0),b.set(N,c,2));$.set(N,c,h)}const e=[];let m=d.length,E=a.length;function R(N,c){(N+1!==m||c+1!==E)&&e.push(new n.$X2(new t.$Av(N+1,m),new t.$Av(c+1,E))),m=N,E=c}let A=d.length-1,w=a.length-1;for(;A>=0&&w>=0;)b.get(A,w)===3?(R(A,w),A--,w--):b.get(A,w)===1?A--:w--;return R(-1,-1),e.reverse(),new n.$W2(e,!1)}}i.$52=g}),ne(ie[34],re([0,1,9,3,6,5,2,18]),function(q,i,t,n,p,g,v,d){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$72=void 0;class a{constructor(m,E,R){this.lines=m,this.considerWhitespaceChanges=R,this.b=[],this.c=[],this.d=[];let A=!1;E.start>0&&E.endExclusive>=m.length&&(E=new p.$Av(E.start-1,E.endExclusive),A=!0),this.lineRange=E,this.c[0]=0;for(let w=this.lineRange.start;w<this.lineRange.endExclusive;w++){let N=m[w],c=0;if(A)c=N.length,N="",A=!1;else if(!R){const u=N.trimStart();c=N.length-u.length,N=u.trimEnd()}this.d.push(c);for(let u=0;u<N.length;u++)this.b.push(N.charCodeAt(u));w<m.length-1&&(this.b.push(10),this.c[w-this.lineRange.start+1]=this.b.length)}this.d.push(0)}toString(){return`Slice: "${this.text}"`}get text(){return this.getText(new p.$Av(0,this.length))}getText(m){return this.b.slice(m.start,m.endExclusive).map(E=>String.fromCharCode(E)).join("")}getElement(m){return this.b[m]}get length(){return this.b.length}getBoundaryScore(m){const E=L(m>0?this.b[m-1]:-1),R=L(m<this.b.length?this.b[m]:-1);if(E===f.LineBreakCR&&R===f.LineBreakLF)return 0;if(E===f.LineBreakLF)return 150;let A=0;return E!==R&&(A+=10,E===f.WordLower&&R===f.WordUpper&&(A+=1)),A+=b(E),A+=b(R),A}translateOffset(m){if(this.lineRange.isEmpty)return new g.$bt(this.lineRange.start+1,1);const E=(0,t.$ib)(this.c,R=>R<=m);return new g.$bt(this.lineRange.start+E+1,m-this.c[E]+this.d[E]+1)}translateRange(m){return v.$ct.fromPositions(this.translateOffset(m.start),this.translateOffset(m.endExclusive))}findWordContaining(m){if(m<0||m>=this.b.length||!l(this.b[m]))return;let E=m;for(;E>0&&l(this.b[E-1]);)E--;let R=m;for(;R<this.b.length&&l(this.b[R]);)R++;return new p.$Av(E,R)}countLinesIn(m){return this.translateOffset(m.endExclusive).lineNumber-this.translateOffset(m.start).lineNumber}isStronglyEqual(m,E){return this.b[m]===this.b[E]}extendToFullLines(m){const E=(0,t.$hb)(this.c,A=>A<=m.start)??0,R=(0,t.$jb)(this.c,A=>m.endExclusive<=A)??this.b.length;return new p.$Av(E,R)}}i.$72=a;function l(e){return e>=n.CharCode.a&&e<=n.CharCode.z||e>=n.CharCode.A&&e<=n.CharCode.Z||e>=n.CharCode.Digit0&&e<=n.CharCode.Digit9}var f;(function(e){e[e.WordLower=0]="WordLower",e[e.WordUpper=1]="WordUpper",e[e.WordNumber=2]="WordNumber",e[e.End=3]="End",e[e.Other=4]="Other",e[e.Separator=5]="Separator",e[e.Space=6]="Space",e[e.LineBreakCR=7]="LineBreakCR",e[e.LineBreakLF=8]="LineBreakLF"})(f||(f={}));const $={[f.WordLower]:0,[f.WordUpper]:0,[f.WordNumber]:0,[f.End]:10,[f.Other]:2,[f.Separator]:30,[f.Space]:3,[f.LineBreakCR]:10,[f.LineBreakLF]:10};function b(e){return $[e]}function L(e){return e===n.CharCode.LineFeed?f.LineBreakLF:e===n.CharCode.CarriageReturn?f.LineBreakCR:(0,d.$32)(e)?f.Space:e>=n.CharCode.a&&e<=n.CharCode.z?f.WordLower:e>=n.CharCode.A&&e<=n.CharCode.Z?f.WordUpper:e>=n.CharCode.Digit0&&e<=n.CharCode.Digit9?f.WordNumber:e===-1?f.End:e===n.CharCode.Comma||e===n.CharCode.Semicolon?f.Separator:f.Other}}),ne(ie[35],re([0,1]),function(q,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$6v=i.$5v=void 0;class t{constructor(g,v,d){this.changes=g,this.moves=v,this.hitTimeout=d}}i.$5v=t;class n{constructor(g,v){this.lineRangeMapping=g,this.changes=v}flip(){return new n(this.lineRangeMapping.flip(),this.changes.map(g=>g.flip()))}}i.$6v=n}),ne(ie[19],re([0,1,4,15,2,50]),function(q,i,t,n,p,g){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$4v=i.$3v=i.$2v=void 0;class v{static inverse(f,$,b){const L=[];let e=1,m=1;for(const R of f){const A=new v(new n.$Cv(e,R.original.startLineNumber),new n.$Cv(m,R.modified.startLineNumber));A.modified.isEmpty||L.push(A),e=R.original.endLineNumberExclusive,m=R.modified.endLineNumberExclusive}const E=new v(new n.$Cv(e,$+1),new n.$Cv(m,b+1));return E.modified.isEmpty||L.push(E),L}static clip(f,$,b){const L=[];for(const e of f){const m=e.original.intersect($),E=e.modified.intersect(b);m&&!m.isEmpty&&E&&!E.isEmpty&&L.push(new v(m,E))}return L}constructor(f,$){this.original=f,this.modified=$}toString(){return`{${this.original.toString()}->${this.modified.toString()}}`}flip(){return new v(this.modified,this.original)}join(f){return new v(this.original.join(f.original),this.modified.join(f.modified))}get changedLineCount(){return Math.max(this.original.length,this.modified.length)}toRangeMapping(){const f=this.original.toInclusiveRange(),$=this.modified.toInclusiveRange();if(f&&$)return new a(f,$);if(this.original.startLineNumber===1||this.modified.startLineNumber===1){if(!(this.modified.startLineNumber===1&&this.original.startLineNumber===1))throw new t.$cb("not a valid diff");return new a(new p.$ct(this.original.startLineNumber,1,this.original.endLineNumberExclusive,1),new p.$ct(this.modified.startLineNumber,1,this.modified.endLineNumberExclusive,1))}else return new a(new p.$ct(this.original.startLineNumber-1,Number.MAX_SAFE_INTEGER,this.original.endLineNumberExclusive-1,Number.MAX_SAFE_INTEGER),new p.$ct(this.modified.startLineNumber-1,Number.MAX_SAFE_INTEGER,this.modified.endLineNumberExclusive-1,Number.MAX_SAFE_INTEGER))}}i.$2v=v;class d extends v{static fromRangeMappings(f){const $=n.$Cv.join(f.map(L=>n.$Cv.fromRangeInclusive(L.originalRange))),b=n.$Cv.join(f.map(L=>n.$Cv.fromRangeInclusive(L.modifiedRange)));return new d($,b,f)}constructor(f,$,b){super(f,$),this.innerChanges=b}flip(){return new d(this.modified,this.original,this.innerChanges?.map(f=>f.flip()))}withInnerChangesFromLineRanges(){return new d(this.original,this.modified,[this.toRangeMapping()])}}i.$3v=d;class a{constructor(f,$){this.originalRange=f,this.modifiedRange=$}toString(){return`{${this.originalRange.toString()}->${this.modifiedRange.toString()}}`}flip(){return new a(this.modifiedRange,this.originalRange)}toTextEdit(f){const $=f.getValueOfRange(this.modifiedRange);return new g.$Xv(this.originalRange,$)}}i.$4v=a}),ne(ie[55],re([0,1,10,19,7,9,16,15,6,34,18,33]),function(q,i,t,n,p,g,v,d,a,l,f,$){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$82=b;function b(w,N,c,u,s,o){let{moves:h,excludedChanges:T}=e(w,N,c,o);if(!o.isValid())return[];const _=w.filter(M=>!T.has(M)),U=m(_,u,s,N,c,o);return(0,p.$Zb)(h,U),h=R(h),h=h.filter(M=>{const D=M.original.toOffsetRange().slice(N).map(P=>P.trim());return D.join(`
`).length>=15&&L(D,P=>P.length>=2)>=2}),h=A(w,h),h}function L(w,N){let c=0;for(const u of w)N(u)&&c++;return c}function e(w,N,c,u){const s=[],o=w.filter(_=>_.modified.isEmpty&&_.original.length>=3).map(_=>new f.$42(_.original,N,_)),h=new Set(w.filter(_=>_.original.isEmpty&&_.modified.length>=3).map(_=>new f.$42(_.modified,c,_))),T=new Set;for(const _ of o){let U=-1,M;for(const D of h){const k=_.computeSimilarity(D);k>U&&(U=k,M=D)}if(U>.9&&M&&(h.delete(M),s.push(new n.$2v(_.range,M.range)),T.add(_.source),T.add(M.source)),!u.isValid())return{moves:s,excludedChanges:T}}return{moves:s,excludedChanges:T}}function m(w,N,c,u,s,o){const h=[],T=new v.$Hc;for(const k of w)for(let P=k.original.startLineNumber;P<k.original.endLineNumberExclusive-2;P++){const j=`${N[P-1]}:${N[P+1-1]}:${N[P+2-1]}`;T.add(j,{range:new d.$Cv(P,P+3)})}const _=[];w.sort((0,p.$6b)(k=>k.modified.startLineNumber,p.$8b));for(const k of w){let P=[];for(let j=k.modified.startLineNumber;j<k.modified.endLineNumberExclusive-2;j++){const B=`${c[j-1]}:${c[j+1-1]}:${c[j+2-1]}`,Z=new d.$Cv(j,j+3),O=[];T.forEach(B,({range:S})=>{for(const Y of P)if(Y.originalLineRange.endLineNumberExclusive+1===S.endLineNumberExclusive&&Y.modifiedLineRange.endLineNumberExclusive+1===Z.endLineNumberExclusive){Y.originalLineRange=new d.$Cv(Y.originalLineRange.startLineNumber,S.endLineNumberExclusive),Y.modifiedLineRange=new d.$Cv(Y.modifiedLineRange.startLineNumber,Z.endLineNumberExclusive),O.push(Y);return}const X={modifiedLineRange:Z,originalLineRange:S};_.push(X),O.push(X)}),P=O}if(!o.isValid())return[]}_.sort((0,p.$0b)((0,p.$6b)(k=>k.modifiedLineRange.length,p.$8b)));const U=new d.$Dv,M=new d.$Dv;for(const k of _){const P=k.modifiedLineRange.startLineNumber-k.originalLineRange.startLineNumber,j=U.subtractFrom(k.modifiedLineRange),B=M.subtractFrom(k.originalLineRange).getWithDelta(P),Z=j.getIntersection(B);for(const O of Z.ranges){if(O.length<3)continue;const S=O,X=O.delta(-P);h.push(new n.$2v(X,S)),U.addRange(S),M.addRange(X)}}h.sort((0,p.$6b)(k=>k.original.startLineNumber,p.$8b));const D=new g.$mb(w);for(let k=0;k<h.length;k++){const P=h[k],j=D.findLastMonotonous(Q=>Q.original.startLineNumber<=P.original.startLineNumber),B=(0,g.$hb)(w,Q=>Q.modified.startLineNumber<=P.modified.startLineNumber),Z=Math.max(P.original.startLineNumber-j.original.startLineNumber,P.modified.startLineNumber-B.modified.startLineNumber),O=D.findLastMonotonous(Q=>Q.original.startLineNumber<P.original.endLineNumberExclusive),S=(0,g.$hb)(w,Q=>Q.modified.startLineNumber<P.modified.endLineNumberExclusive),X=Math.max(O.original.endLineNumberExclusive-P.original.endLineNumberExclusive,S.modified.endLineNumberExclusive-P.modified.endLineNumberExclusive);let Y;for(Y=0;Y<Z;Y++){const Q=P.original.startLineNumber-Y-1,C=P.modified.startLineNumber-Y-1;if(Q>u.length||C>s.length||U.contains(C)||M.contains(Q)||!E(u[Q-1],s[C-1],o))break}Y>0&&(M.addRange(new d.$Cv(P.original.startLineNumber-Y,P.original.startLineNumber)),U.addRange(new d.$Cv(P.modified.startLineNumber-Y,P.modified.startLineNumber)));let H;for(H=0;H<X;H++){const Q=P.original.endLineNumberExclusive+H,C=P.modified.endLineNumberExclusive+H;if(Q>u.length||C>s.length||U.contains(C)||M.contains(Q)||!E(u[Q-1],s[C-1],o))break}H>0&&(M.addRange(new d.$Cv(P.original.endLineNumberExclusive,P.original.endLineNumberExclusive+H)),U.addRange(new d.$Cv(P.modified.endLineNumberExclusive,P.modified.endLineNumberExclusive+H))),(Y>0||H>0)&&(h[k]=new n.$2v(new d.$Cv(P.original.startLineNumber-Y,P.original.endLineNumberExclusive+H),new d.$Cv(P.modified.startLineNumber-Y,P.modified.endLineNumberExclusive+H)))}return h}function E(w,N,c){if(w.trim()===N.trim())return!0;if(w.length>300&&N.length>300)return!1;const s=new $.$62().compute(new l.$72([w],new a.$Av(0,1),!1),new l.$72([N],new a.$Av(0,1),!1),c);let o=0;const h=t.$X2.invert(s.diffs,w.length);for(const M of h)M.seq1Range.forEach(D=>{(0,f.$32)(w.charCodeAt(D))||o++});function T(M){let D=0;for(let k=0;k<w.length;k++)(0,f.$32)(M.charCodeAt(k))||D++;return D}const _=T(w.length>N.length?w:N);return o/_>.6&&_>10}function R(w){if(w.length===0)return w;w.sort((0,p.$6b)(c=>c.original.startLineNumber,p.$8b));const N=[w[0]];for(let c=1;c<w.length;c++){const u=N[N.length-1],s=w[c],o=s.original.startLineNumber-u.original.endLineNumberExclusive,h=s.modified.startLineNumber-u.modified.endLineNumberExclusive;if(o>=0&&h>=0&&o+h<=2){N[N.length-1]=u.join(s);continue}N.push(s)}return N}function A(w,N){const c=new g.$mb(w);return N=N.filter(u=>{const s=c.findLastMonotonous(T=>T.original.startLineNumber<u.original.endLineNumberExclusive)||new n.$2v(new d.$Cv(1,1),new d.$Cv(1,1)),o=(0,g.$hb)(w,T=>T.modified.startLineNumber<u.modified.endLineNumberExclusive);return s!==o}),N}}),ne(ie[56],re([0,1,7,11,15,6,2,10,54,33,55,52,53,34,35,19]),function(q,i,t,n,p,g,v,d,a,l,f,$,b,L,e,m){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$c3=void 0,i.$d3=R,i.$e3=A;class E{constructor(){this.e=new a.$52,this.f=new l.$62}computeDiff(N,c,u){if(N.length<=1&&(0,t.$ub)(N,c,(H,Q)=>H===Q))return new e.$5v([],[],!1);if(N.length===1&&N[0].length===0||c.length===1&&c[0].length===0)return new e.$5v([new m.$3v(new p.$Cv(1,N.length+1),new p.$Cv(1,c.length+1),[new m.$4v(new v.$ct(1,1,N.length,N[N.length-1].length+1),new v.$ct(1,1,c.length,c[c.length-1].length+1))])],[],!1);const s=u.maxComputationTimeMs===0?d.$Z2.instance:new d.$12(u.maxComputationTimeMs),o=!u.ignoreTrimWhitespace,h=new Map;function T(H){let Q=h.get(H);return Q===void 0&&(Q=h.size,h.set(H,Q)),Q}const _=N.map(H=>T(H.trim())),U=c.map(H=>T(H.trim())),M=new b.$92(_,N),D=new b.$92(U,c),k=M.length+D.length<1700?this.e.compute(M,D,s,(H,Q)=>N[H]===c[Q]?c[Q].length===0?.1:1+Math.log(1+c[Q].length):.99):this.f.compute(M,D);let P=k.diffs,j=k.hitTimeout;P=(0,$.$02)(M,D,P),P=(0,$.$a3)(M,D,P);const B=[],Z=H=>{if(o)for(let Q=0;Q<H;Q++){const C=O+Q,F=S+Q;if(N[C]!==c[F]){const z=this.j(N,c,new d.$X2(new g.$Av(C,C+1),new g.$Av(F,F+1)),s,o);for(const fe of z.mappings)B.push(fe);z.hitTimeout&&(j=!0)}}};let O=0,S=0;for(const H of P){(0,n.$hd)(()=>H.seq1Range.start-O===H.seq2Range.start-S);const Q=H.seq1Range.start-O;Z(Q),O=H.seq1Range.endExclusive,S=H.seq2Range.endExclusive;const C=this.j(N,c,H,s,o);C.hitTimeout&&(j=!0);for(const F of C.mappings)B.push(F)}Z(N.length-O);const X=R(B,N,c);let Y=[];return u.computeMoves&&(Y=this.h(X,N,c,_,U,s,o)),(0,n.$hd)(()=>{function H(C,F){if(C.lineNumber<1||C.lineNumber>F.length)return!1;const z=F[C.lineNumber-1];return!(C.column<1||C.column>z.length+1)}function Q(C,F){return!(C.startLineNumber<1||C.startLineNumber>F.length+1||C.endLineNumberExclusive<1||C.endLineNumberExclusive>F.length+1)}for(const C of X){if(!C.innerChanges)return!1;for(const F of C.innerChanges)if(!(H(F.modifiedRange.getStartPosition(),c)&&H(F.modifiedRange.getEndPosition(),c)&&H(F.originalRange.getStartPosition(),N)&&H(F.originalRange.getEndPosition(),N)))return!1;if(!Q(C.modified,c)||!Q(C.original,N))return!1}return!0}),new e.$5v(X,Y,j)}h(N,c,u,s,o,h,T){return(0,f.$82)(N,c,u,s,o,h).map(M=>{const D=this.j(c,u,new d.$X2(M.original.toOffsetRange(),M.modified.toOffsetRange()),h,T),k=R(D.mappings,c,u,!0);return new e.$6v(M,k)})}j(N,c,u,s,o){const h=new L.$72(N,u.seq1Range,o),T=new L.$72(c,u.seq2Range,o),_=h.length+T.length<500?this.e.compute(h,T,s):this.f.compute(h,T,s);let U=_.diffs;return U=(0,$.$02)(h,T,U),U=(0,$.$_2)(h,T,U),U=(0,$.$$2)(h,T,U),U=(0,$.$b3)(h,T,U),{mappings:U.map(D=>new m.$4v(h.translateRange(D.seq1Range),T.translateRange(D.seq2Range))),hitTimeout:_.hitTimeout}}}i.$c3=E;function R(w,N,c,u=!1){const s=[];for(const o of(0,t.$Ab)(w.map(h=>A(h,N,c)),(h,T)=>h.original.overlapOrTouch(T.original)||h.modified.overlapOrTouch(T.modified))){const h=o[0],T=o[o.length-1];s.push(new m.$3v(h.original.join(T.original),h.modified.join(T.modified),o.map(_=>_.innerChanges[0])))}return(0,n.$hd)(()=>!u&&s.length>0&&(s[0].modified.startLineNumber!==s[0].original.startLineNumber||c.length-s[s.length-1].modified.endLineNumberExclusive!==N.length-s[s.length-1].original.endLineNumberExclusive)?!1:(0,n.$id)(s,(o,h)=>h.original.startLineNumber-o.original.endLineNumberExclusive===h.modified.startLineNumber-o.modified.endLineNumberExclusive&&o.original.endLineNumberExclusive<h.original.startLineNumber&&o.modified.endLineNumberExclusive<h.modified.startLineNumber)),s}function A(w,N,c){let u=0,s=0;w.modifiedRange.endColumn===1&&w.originalRange.endColumn===1&&w.originalRange.startLineNumber+u<=w.originalRange.endLineNumber&&w.modifiedRange.startLineNumber+u<=w.modifiedRange.endLineNumber&&(s=-1),w.modifiedRange.startColumn-1>=c[w.modifiedRange.startLineNumber-1].length&&w.originalRange.startColumn-1>=N[w.originalRange.startLineNumber-1].length&&w.originalRange.startLineNumber<=w.originalRange.endLineNumber+s&&w.modifiedRange.startLineNumber<=w.modifiedRange.endLineNumber+s&&(u=1);const o=new p.$Cv(w.originalRange.startLineNumber+u,w.originalRange.endLineNumber+1+s),h=new p.$Cv(w.modifiedRange.startLineNumber+u,w.modifiedRange.endLineNumber+1+s);return new m.$3v(o,h,[w])}}),ne(ie[36],re([0,1,3,29,35,19,8,2,11,15]),function(q,i,t,n,p,g,v,d,a,l){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$8v=i.$7v=void 0;const f=3;class ${computeDiff(s,o,h){const _=new A(s,o,{maxComputationTime:h.maxComputationTimeMs,shouldIgnoreTrimWhitespace:h.ignoreTrimWhitespace,shouldComputeCharChanges:!0,shouldMakePrettyDiff:!0,shouldPostProcessCharChanges:!0}).computeDiff(),U=[];let M=null;for(const D of _.changes){let k;D.originalEndLineNumber===0?k=new l.$Cv(D.originalStartLineNumber+1,D.originalStartLineNumber+1):k=new l.$Cv(D.originalStartLineNumber,D.originalEndLineNumber+1);let P;D.modifiedEndLineNumber===0?P=new l.$Cv(D.modifiedStartLineNumber+1,D.modifiedStartLineNumber+1):P=new l.$Cv(D.modifiedStartLineNumber,D.modifiedEndLineNumber+1);let j=new g.$3v(k,P,D.charChanges?.map(B=>new g.$4v(new d.$ct(B.originalStartLineNumber,B.originalStartColumn,B.originalEndLineNumber,B.originalEndColumn),new d.$ct(B.modifiedStartLineNumber,B.modifiedStartColumn,B.modifiedEndLineNumber,B.modifiedEndColumn))));M&&(M.modified.endLineNumberExclusive===j.modified.startLineNumber||M.original.endLineNumberExclusive===j.original.startLineNumber)&&(j=new g.$3v(M.original.join(j.original),M.modified.join(j.modified),M.innerChanges&&j.innerChanges?M.innerChanges.concat(j.innerChanges):void 0),U.pop()),U.push(j),M=j}return(0,a.$hd)(()=>(0,a.$id)(U,(D,k)=>k.original.startLineNumber-D.original.endLineNumberExclusive===k.modified.startLineNumber-D.modified.endLineNumberExclusive&&D.original.endLineNumberExclusive<k.original.startLineNumber&&D.modified.endLineNumberExclusive<k.modified.startLineNumber)),new p.$5v(U,[],_.quitEarly)}}i.$7v=$;function b(u,s,o,h){return new n.$Uv(u,s,o).ComputeDiff(h)}class L{constructor(s){const o=[],h=[];for(let T=0,_=s.length;T<_;T++)o[T]=w(s[T],1),h[T]=N(s[T],1);this.lines=s,this.a=o,this.b=h}getElements(){const s=[];for(let o=0,h=this.lines.length;o<h;o++)s[o]=this.lines[o].substring(this.a[o]-1,this.b[o]-1);return s}getStrictElement(s){return this.lines[s]}getStartLineNumber(s){return s+1}getEndLineNumber(s){return s+1}createCharSequence(s,o,h){const T=[],_=[],U=[];let M=0;for(let D=o;D<=h;D++){const k=this.lines[D],P=s?this.a[D]:1,j=s?this.b[D]:k.length+1;for(let B=P;B<j;B++)T[M]=k.charCodeAt(B-1),_[M]=D+1,U[M]=B,M++;!s&&D<h&&(T[M]=t.CharCode.LineFeed,_[M]=D+1,U[M]=k.length+1,M++)}return new e(T,_,U)}}class e{constructor(s,o,h){this.a=s,this.b=o,this.d=h}toString(){return"["+this.a.map((s,o)=>(s===t.CharCode.LineFeed?"\\n":String.fromCharCode(s))+`-(${this.b[o]},${this.d[o]})`).join(", ")+"]"}e(s,o){if(s<0||s>=o.length)throw new Error("Illegal index")}getElements(){return this.a}getStartLineNumber(s){return s>0&&s===this.b.length?this.getEndLineNumber(s-1):(this.e(s,this.b),this.b[s])}getEndLineNumber(s){return s===-1?this.getStartLineNumber(s+1):(this.e(s,this.b),this.a[s]===t.CharCode.LineFeed?this.b[s]+1:this.b[s])}getStartColumn(s){return s>0&&s===this.d.length?this.getEndColumn(s-1):(this.e(s,this.d),this.d[s])}getEndColumn(s){return s===-1?this.getStartColumn(s+1):(this.e(s,this.d),this.a[s]===t.CharCode.LineFeed?1:this.d[s]+1)}}class m{constructor(s,o,h,T,_,U,M,D){this.originalStartLineNumber=s,this.originalStartColumn=o,this.originalEndLineNumber=h,this.originalEndColumn=T,this.modifiedStartLineNumber=_,this.modifiedStartColumn=U,this.modifiedEndLineNumber=M,this.modifiedEndColumn=D}static createFromDiffChange(s,o,h){const T=o.getStartLineNumber(s.originalStart),_=o.getStartColumn(s.originalStart),U=o.getEndLineNumber(s.originalStart+s.originalLength-1),M=o.getEndColumn(s.originalStart+s.originalLength-1),D=h.getStartLineNumber(s.modifiedStart),k=h.getStartColumn(s.modifiedStart),P=h.getEndLineNumber(s.modifiedStart+s.modifiedLength-1),j=h.getEndColumn(s.modifiedStart+s.modifiedLength-1);return new m(T,_,U,M,D,k,P,j)}}function E(u){if(u.length<=1)return u;const s=[u[0]];let o=s[0];for(let h=1,T=u.length;h<T;h++){const _=u[h],U=_.originalStart-(o.originalStart+o.originalLength),M=_.modifiedStart-(o.modifiedStart+o.modifiedLength);Math.min(U,M)<f?(o.originalLength=_.originalStart+_.originalLength-o.originalStart,o.modifiedLength=_.modifiedStart+_.modifiedLength-o.modifiedStart):(s.push(_),o=_)}return s}class R{constructor(s,o,h,T,_){this.originalStartLineNumber=s,this.originalEndLineNumber=o,this.modifiedStartLineNumber=h,this.modifiedEndLineNumber=T,this.charChanges=_}static createFromDiffResult(s,o,h,T,_,U,M){let D,k,P,j,B;if(o.originalLength===0?(D=h.getStartLineNumber(o.originalStart)-1,k=0):(D=h.getStartLineNumber(o.originalStart),k=h.getEndLineNumber(o.originalStart+o.originalLength-1)),o.modifiedLength===0?(P=T.getStartLineNumber(o.modifiedStart)-1,j=0):(P=T.getStartLineNumber(o.modifiedStart),j=T.getEndLineNumber(o.modifiedStart+o.modifiedLength-1)),U&&o.originalLength>0&&o.originalLength<20&&o.modifiedLength>0&&o.modifiedLength<20&&_()){const Z=h.createCharSequence(s,o.originalStart,o.originalStart+o.originalLength-1),O=T.createCharSequence(s,o.modifiedStart,o.modifiedStart+o.modifiedLength-1);if(Z.getElements().length>0&&O.getElements().length>0){let S=b(Z,O,_,!0).changes;M&&(S=E(S)),B=[];for(let X=0,Y=S.length;X<Y;X++)B.push(m.createFromDiffChange(S[X],Z,O))}}return new R(D,k,P,j,B)}}class A{constructor(s,o,h){this.a=h.shouldComputeCharChanges,this.b=h.shouldPostProcessCharChanges,this.d=h.shouldIgnoreTrimWhitespace,this.e=h.shouldMakePrettyDiff,this.f=s,this.g=o,this.h=new L(s),this.j=new L(o),this.k=c(h.maxComputationTime),this.l=c(h.maxComputationTime===0?0:Math.min(h.maxComputationTime,5e3))}computeDiff(){if(this.h.lines.length===1&&this.h.lines[0].length===0)return this.j.lines.length===1&&this.j.lines[0].length===0?{quitEarly:!1,changes:[]}:{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:1,modifiedStartLineNumber:1,modifiedEndLineNumber:this.j.lines.length,charChanges:void 0}]};if(this.j.lines.length===1&&this.j.lines[0].length===0)return{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:this.h.lines.length,modifiedStartLineNumber:1,modifiedEndLineNumber:1,charChanges:void 0}]};const s=b(this.h,this.j,this.k,this.e),o=s.changes,h=s.quitEarly;if(this.d){const M=[];for(let D=0,k=o.length;D<k;D++)M.push(R.createFromDiffResult(this.d,o[D],this.h,this.j,this.l,this.a,this.b));return{quitEarly:h,changes:M}}const T=[];let _=0,U=0;for(let M=-1,D=o.length;M<D;M++){const k=M+1<D?o[M+1]:null,P=k?k.originalStart:this.f.length,j=k?k.modifiedStart:this.g.length;for(;_<P&&U<j;){const B=this.f[_],Z=this.g[U];if(B!==Z){{let O=w(B,1),S=w(Z,1);for(;O>1&&S>1;){const X=B.charCodeAt(O-2),Y=Z.charCodeAt(S-2);if(X!==Y)break;O--,S--}(O>1||S>1)&&this.m(T,_+1,1,O,U+1,1,S)}{let O=N(B,1),S=N(Z,1);const X=B.length+1,Y=Z.length+1;for(;O<X&&S<Y;){const H=B.charCodeAt(O-1),Q=B.charCodeAt(S-1);if(H!==Q)break;O++,S++}(O<X||S<Y)&&this.m(T,_+1,O,X,U+1,S,Y)}}_++,U++}k&&(T.push(R.createFromDiffResult(this.d,k,this.h,this.j,this.l,this.a,this.b)),_+=k.originalLength,U+=k.modifiedLength)}return{quitEarly:h,changes:T}}m(s,o,h,T,_,U,M){if(this.n(s,o,h,T,_,U,M))return;let D;this.a&&(D=[new m(o,h,o,T,_,U,_,M)]),s.push(new R(o,o,_,_,D))}n(s,o,h,T,_,U,M){const D=s.length;if(D===0)return!1;const k=s[D-1];return k.originalEndLineNumber===0||k.modifiedEndLineNumber===0?!1:k.originalEndLineNumber===o&&k.modifiedEndLineNumber===_?(this.a&&k.charChanges&&k.charChanges.push(new m(o,h,o,T,_,U,_,M)),!0):k.originalEndLineNumber+1===o&&k.modifiedEndLineNumber+1===_?(k.originalEndLineNumber=o,k.modifiedEndLineNumber=_,this.a&&k.charChanges&&k.charChanges.push(new m(o,h,o,T,_,U,_,M)),!0):!1}}i.$8v=A;function w(u,s){const o=v.$qf(u);return o===-1?s:o+1}function N(u,s){const o=v.$sf(u);return o===-1?s:o+2}function c(u){if(u===0)return()=>!0;const s=Date.now();return()=>Date.now()-s<u}}),ne(ie[57],re([0,1,36,56]),function(q,i,t,n){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$f3=void 0,i.$f3={getLegacy:()=>new t.$7v,getDefault:()=>new n.$c3}}),ne(ie[58],re([0,1]),function(q,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$ft=i.MetadataConsts=i.StandardTokenType=i.ColorId=i.FontStyle=i.LanguageId=void 0;var t;(function(a){a[a.Null=0]="Null",a[a.PlainText=1]="PlainText"})(t||(i.LanguageId=t={}));var n;(function(a){a[a.NotSet=-1]="NotSet",a[a.None=0]="None",a[a.Italic=1]="Italic",a[a.Bold=2]="Bold",a[a.Underline=4]="Underline",a[a.Strikethrough=8]="Strikethrough"})(n||(i.FontStyle=n={}));var p;(function(a){a[a.None=0]="None",a[a.DefaultForeground=1]="DefaultForeground",a[a.DefaultBackground=2]="DefaultBackground"})(p||(i.ColorId=p={}));var g;(function(a){a[a.Other=0]="Other",a[a.Comment=1]="Comment",a[a.String=2]="String",a[a.RegEx=3]="RegEx"})(g||(i.StandardTokenType=g={}));var v;(function(a){a[a.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",a[a.TOKEN_TYPE_MASK=768]="TOKEN_TYPE_MASK",a[a.BALANCED_BRACKETS_MASK=1024]="BALANCED_BRACKETS_MASK",a[a.FONT_STYLE_MASK=30720]="FONT_STYLE_MASK",a[a.FOREGROUND_MASK=16744448]="FOREGROUND_MASK",a[a.BACKGROUND_MASK=4278190080]="BACKGROUND_MASK",a[a.ITALIC_MASK=2048]="ITALIC_MASK",a[a.BOLD_MASK=4096]="BOLD_MASK",a[a.UNDERLINE_MASK=8192]="UNDERLINE_MASK",a[a.STRIKETHROUGH_MASK=16384]="STRIKETHROUGH_MASK",a[a.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",a[a.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",a[a.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",a[a.SEMANTIC_USE_STRIKETHROUGH=8]="SEMANTIC_USE_STRIKETHROUGH",a[a.SEMANTIC_USE_FOREGROUND=16]="SEMANTIC_USE_FOREGROUND",a[a.SEMANTIC_USE_BACKGROUND=32]="SEMANTIC_USE_BACKGROUND",a[a.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",a[a.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",a[a.BALANCED_BRACKETS_OFFSET=10]="BALANCED_BRACKETS_OFFSET",a[a.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",a[a.FOREGROUND_OFFSET=15]="FOREGROUND_OFFSET",a[a.BACKGROUND_OFFSET=24]="BACKGROUND_OFFSET"})(v||(i.MetadataConsts=v={}));class d{static getLanguageId(l){return(l&v.LANGUAGEID_MASK)>>>v.LANGUAGEID_OFFSET}static getTokenType(l){return(l&v.TOKEN_TYPE_MASK)>>>v.TOKEN_TYPE_OFFSET}static containsBalancedBrackets(l){return(l&v.BALANCED_BRACKETS_MASK)!==0}static getFontStyle(l){return(l&v.FONT_STYLE_MASK)>>>v.FONT_STYLE_OFFSET}static getForeground(l){return(l&v.FOREGROUND_MASK)>>>v.FOREGROUND_OFFSET}static getBackground(l){return(l&v.BACKGROUND_MASK)>>>v.BACKGROUND_OFFSET}static getClassNameFromMetadata(l){let $="mtk"+this.getForeground(l);const b=this.getFontStyle(l);return b&n.Italic&&($+=" mtki"),b&n.Bold&&($+=" mtkb"),b&n.Underline&&($+=" mtku"),b&n.Strikethrough&&($+=" mtks"),$}static getInlineStyleFromMetadata(l,f){const $=this.getForeground(l),b=this.getFontStyle(l);let L=`color: ${f[$]};`;b&n.Italic&&(L+="font-style: italic;"),b&n.Bold&&(L+="font-weight: bold;");let e="";return b&n.Underline&&(e+=" underline"),b&n.Strikethrough&&(e+=" line-through"),e&&(L+=`text-decoration:${e};`),L}static getPresentationFromMetadata(l){const f=this.getForeground(l),$=this.getFontStyle(l);return{foreground:f,italic:!!($&n.Italic),bold:!!($&n.Bold),underline:!!($&n.Underline),strikethrough:!!($&n.Strikethrough)}}}i.$ft=d}),ne(ie[59],re([0,1,38]),function(q,i,t){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$g3=$;function n(b){const L=[];for(const e of b){const m=Number(e);(m||m===0&&e.replace(/\s/g,"")!=="")&&L.push(m)}return L}function p(b,L,e,m){return{red:b/255,blue:e/255,green:L/255,alpha:m}}function g(b,L){const e=L.index,m=L[0].length;if(!e)return;const E=b.positionAt(e);return{startLineNumber:E.lineNumber,startColumn:E.column,endLineNumber:E.lineNumber,endColumn:E.column+m}}function v(b,L){if(!b)return;const e=t.$7s.Format.CSS.parseHex(L);if(e)return{range:b,color:p(e.rgba.r,e.rgba.g,e.rgba.b,e.rgba.a)}}function d(b,L,e){if(!b||L.length!==1)return;const E=L[0].values(),R=n(E);return{range:b,color:p(R[0],R[1],R[2],e?R[3]:1)}}function a(b,L,e){if(!b||L.length!==1)return;const E=L[0].values(),R=n(E),A=new t.$7s(new t.$5s(R[0],R[1]/100,R[2]/100,e?R[3]:1));return{range:b,color:p(A.rgba.r,A.rgba.g,A.rgba.b,A.rgba.a)}}function l(b,L){return typeof b=="string"?[...b.matchAll(L)]:b.findMatches(L)}function f(b){const L=[],m=l(b,/\b(rgb|rgba|hsl|hsla)(\([0-9\s,.\%]*\))|(#)([A-Fa-f0-9]{3})\b|(#)([A-Fa-f0-9]{4})\b|(#)([A-Fa-f0-9]{6})\b|(#)([A-Fa-f0-9]{8})\b/gm);if(m.length>0)for(const E of m){const R=E.filter(c=>c!==void 0),A=R[1],w=R[2];if(!w)continue;let N;if(A==="rgb"){const c=/^\(\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*\)$/gm;N=d(g(b,E),l(w,c),!1)}else if(A==="rgba"){const c=/^\(\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(0[.][0-9]+|[.][0-9]+|[01][.]|[01])\s*\)$/gm;N=d(g(b,E),l(w,c),!0)}else if(A==="hsl"){const c=/^\(\s*(36[0]|3[0-5][0-9]|[12][0-9][0-9]|[1-9]?[0-9])\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*\)$/gm;N=a(g(b,E),l(w,c),!1)}else if(A==="hsla"){const c=/^\(\s*(36[0]|3[0-5][0-9]|[12][0-9][0-9]|[1-9]?[0-9])\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*,\s*(0[.][0-9]+|[.][0-9]+|[01][.]|[01])\s*\)$/gm;N=a(g(b,E),l(w,c),!0)}else A==="#"&&(N=v(g(b,E),A+w));N&&L.push(N)}return L}function $(b){return!b||typeof b.getValue!="function"||typeof b.positionAt!="function"?[]:f(b)}}),ne(ie[60],re([0,1,3,30]),function(q,i,t,n){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$R2=i.$Q2=i.State=void 0,i.$S2=L;var p;(function(e){e[e.Invalid=0]="Invalid",e[e.Start=1]="Start",e[e.H=2]="H",e[e.HT=3]="HT",e[e.HTT=4]="HTT",e[e.HTTP=5]="HTTP",e[e.F=6]="F",e[e.FI=7]="FI",e[e.FIL=8]="FIL",e[e.BeforeColon=9]="BeforeColon",e[e.AfterColon=10]="AfterColon",e[e.AlmostThere=11]="AlmostThere",e[e.End=12]="End",e[e.Accept=13]="Accept",e[e.LastKnownState=14]="LastKnownState"})(p||(i.State=p={}));class g{constructor(m,E,R){const A=new Uint8Array(m*E);for(let w=0,N=m*E;w<N;w++)A[w]=R;this.a=A,this.rows=m,this.cols=E}get(m,E){return this.a[m*this.cols+E]}set(m,E,R){this.a[m*this.cols+E]=R}}class v{constructor(m){let E=0,R=p.Invalid;for(let w=0,N=m.length;w<N;w++){const[c,u,s]=m[w];u>E&&(E=u),c>R&&(R=c),s>R&&(R=s)}E++,R++;const A=new g(R,E,p.Invalid);for(let w=0,N=m.length;w<N;w++){const[c,u,s]=m[w];A.set(c,u,s)}this.a=A,this.b=E}nextState(m,E){return E<0||E>=this.b?p.Invalid:this.a.get(m,E)}}i.$Q2=v;let d=null;function a(){return d===null&&(d=new v([[p.Start,t.CharCode.h,p.H],[p.Start,t.CharCode.H,p.H],[p.Start,t.CharCode.f,p.F],[p.Start,t.CharCode.F,p.F],[p.H,t.CharCode.t,p.HT],[p.H,t.CharCode.T,p.HT],[p.HT,t.CharCode.t,p.HTT],[p.HT,t.CharCode.T,p.HTT],[p.HTT,t.CharCode.p,p.HTTP],[p.HTT,t.CharCode.P,p.HTTP],[p.HTTP,t.CharCode.s,p.BeforeColon],[p.HTTP,t.CharCode.S,p.BeforeColon],[p.HTTP,t.CharCode.Colon,p.AfterColon],[p.F,t.CharCode.i,p.FI],[p.F,t.CharCode.I,p.FI],[p.FI,t.CharCode.l,p.FIL],[p.FI,t.CharCode.L,p.FIL],[p.FIL,t.CharCode.e,p.BeforeColon],[p.FIL,t.CharCode.E,p.BeforeColon],[p.BeforeColon,t.CharCode.Colon,p.AfterColon],[p.AfterColon,t.CharCode.Slash,p.AlmostThere],[p.AlmostThere,t.CharCode.Slash,p.End]])),d}var l;(function(e){e[e.None=0]="None",e[e.ForceTermination=1]="ForceTermination",e[e.CannotEndIn=2]="CannotEndIn"})(l||(l={}));let f=null;function $(){if(f===null){f=new n.$nt(l.None);const e=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let E=0;E<e.length;E++)f.set(e.charCodeAt(E),l.ForceTermination);const m=".,;:";for(let E=0;E<m.length;E++)f.set(m.charCodeAt(E),l.CannotEndIn)}return f}class b{static a(m,E,R,A,w){let N=w-1;do{const c=E.charCodeAt(N);if(m.get(c)!==l.CannotEndIn)break;N--}while(N>A);if(A>0){const c=E.charCodeAt(A-1),u=E.charCodeAt(N);(c===t.CharCode.OpenParen&&u===t.CharCode.CloseParen||c===t.CharCode.OpenSquareBracket&&u===t.CharCode.CloseSquareBracket||c===t.CharCode.OpenCurlyBrace&&u===t.CharCode.CloseCurlyBrace)&&N--}return{range:{startLineNumber:R,startColumn:A+1,endLineNumber:R,endColumn:N+2},url:E.substring(A,N+1)}}static computeLinks(m,E=a()){const R=$(),A=[];for(let w=1,N=m.getLineCount();w<=N;w++){const c=m.getLineContent(w),u=c.length;let s=0,o=0,h=0,T=p.Start,_=!1,U=!1,M=!1,D=!1;for(;s<u;){let k=!1;const P=c.charCodeAt(s);if(T===p.Accept){let j;switch(P){case t.CharCode.OpenParen:_=!0,j=l.None;break;case t.CharCode.CloseParen:j=_?l.None:l.ForceTermination;break;case t.CharCode.OpenSquareBracket:M=!0,U=!0,j=l.None;break;case t.CharCode.CloseSquareBracket:M=!1,j=U?l.None:l.ForceTermination;break;case t.CharCode.OpenCurlyBrace:D=!0,j=l.None;break;case t.CharCode.CloseCurlyBrace:j=D?l.None:l.ForceTermination;break;case t.CharCode.SingleQuote:case t.CharCode.DoubleQuote:case t.CharCode.BackTick:h===P?j=l.ForceTermination:h===t.CharCode.SingleQuote||h===t.CharCode.DoubleQuote||h===t.CharCode.BackTick?j=l.None:j=l.ForceTermination;break;case t.CharCode.Asterisk:j=h===t.CharCode.Asterisk?l.ForceTermination:l.None;break;case t.CharCode.Pipe:j=h===t.CharCode.Pipe?l.ForceTermination:l.None;break;case t.CharCode.Space:j=M?l.None:l.ForceTermination;break;default:j=R.get(P)}j===l.ForceTermination&&(A.push(b.a(R,c,w,o,s)),k=!0)}else if(T===p.End){let j;P===t.CharCode.OpenSquareBracket?(U=!0,j=l.None):j=R.get(P),j===l.ForceTermination?k=!0:T=p.Accept}else T=E.nextState(T,P),T===p.Invalid&&(k=!0);k&&(T=p.Start,_=!1,U=!1,D=!1,o=s+1,h=P),s++}T===p.Accept&&A.push(b.a(R,c,w,o,u))}return A}}i.$R2=b;function L(e){return!e||typeof e.getLineCount!="function"||typeof e.getLineContent!="function"?[]:b.computeLinks(e)}}),ne(ie[61],re([0,1]),function(q,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$T2=void 0;class t{constructor(){this.c=[["true","false"],["True","False"],["Private","Public","Friend","ReadOnly","Partial","Protected","WriteOnly"],["public","protected","private"]]}static{this.INSTANCE=new t}navigateValueSet(p,g,v,d,a){if(p&&g){const l=this.a(g,a);if(l)return{range:p,value:l}}if(v&&d){const l=this.a(d,a);if(l)return{range:v,value:l}}return null}a(p,g){const v=this.b(p,g);return v!==null?v:this.d(p,g)}b(p,g){const v=Math.pow(10,p.length-(p.lastIndexOf(".")+1));let d=Number(p);const a=parseFloat(p);return!isNaN(d)&&!isNaN(a)&&d===a?d===0&&!g?null:(d=Math.floor(d*v),d+=g?v:-v,String(d/v)):null}d(p,g){return this.e(this.c,p,g)}e(p,g,v){let d=null;for(let a=0,l=p.length;d===null&&a<l;a++)d=this.f(p[a],g,v);return d}f(p,g,v){let d=p.indexOf(g);return d>=0?(d+=v?1:-1,d<0?d=p.length-1:d%=p.length,p[d]):null}}i.$T2=t}),ne(ie[62],re([0,1,17]),function(q,i,t){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$uv=i.$tv=i.$sv=i.ModelConstants=i.PositionAffinity=i.TrackedRangeStickiness=i.$qv=i.$pv=i.EndOfLineSequence=i.DefaultEndOfLine=i.EndOfLinePreference=i.InjectedTextCursorStops=i.MinimapSectionHeaderStyle=i.MinimapPosition=i.GlyphMarginLane=i.OverviewRulerLane=void 0,i.$rv=e,i.$vv=N;var n;(function(c){c[c.Left=1]="Left",c[c.Center=2]="Center",c[c.Right=4]="Right",c[c.Full=7]="Full"})(n||(i.OverviewRulerLane=n={}));var p;(function(c){c[c.Left=1]="Left",c[c.Center=2]="Center",c[c.Right=3]="Right"})(p||(i.GlyphMarginLane=p={}));var g;(function(c){c[c.Inline=1]="Inline",c[c.Gutter=2]="Gutter"})(g||(i.MinimapPosition=g={}));var v;(function(c){c[c.Normal=1]="Normal",c[c.Underlined=2]="Underlined"})(v||(i.MinimapSectionHeaderStyle=v={}));var d;(function(c){c[c.Both=0]="Both",c[c.Right=1]="Right",c[c.Left=2]="Left",c[c.None=3]="None"})(d||(i.InjectedTextCursorStops=d={}));var a;(function(c){c[c.TextDefined=0]="TextDefined",c[c.LF=1]="LF",c[c.CRLF=2]="CRLF"})(a||(i.EndOfLinePreference=a={}));var l;(function(c){c[c.LF=1]="LF",c[c.CRLF=2]="CRLF"})(l||(i.DefaultEndOfLine=l={}));var f;(function(c){c[c.LF=0]="LF",c[c.CRLF=1]="CRLF"})(f||(i.EndOfLineSequence=f={}));class ${get originalIndentSize(){return this.a?"tabSize":this.indentSize}constructor(u){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,u.tabSize|0),u.indentSize==="tabSize"?(this.indentSize=this.tabSize,this.a=!0):(this.indentSize=Math.max(1,u.indentSize|0),this.a=!1),this.insertSpaces=!!u.insertSpaces,this.defaultEOL=u.defaultEOL|0,this.trimAutoWhitespace=!!u.trimAutoWhitespace,this.bracketPairColorizationOptions=u.bracketPairColorizationOptions}equals(u){return this.tabSize===u.tabSize&&this.a===u.a&&this.indentSize===u.indentSize&&this.insertSpaces===u.insertSpaces&&this.defaultEOL===u.defaultEOL&&this.trimAutoWhitespace===u.trimAutoWhitespace&&(0,t.$ao)(this.bracketPairColorizationOptions,u.bracketPairColorizationOptions)}createChangeEvent(u){return{tabSize:this.tabSize!==u.tabSize,indentSize:this.indentSize!==u.indentSize,insertSpaces:this.insertSpaces!==u.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==u.trimAutoWhitespace}}}i.$pv=$;class b{constructor(u,s){this._findMatchBrand=void 0,this.range=u,this.matches=s}}i.$qv=b;var L;(function(c){c[c.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",c[c.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",c[c.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",c[c.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(L||(i.TrackedRangeStickiness=L={}));function e(c){return c&&typeof c.read=="function"}var m;(function(c){c[c.Left=0]="Left",c[c.Right=1]="Right",c[c.None=2]="None",c[c.LeftOfInjectedText=3]="LeftOfInjectedText",c[c.RightOfInjectedText=4]="RightOfInjectedText"})(m||(i.PositionAffinity=m={}));var E;(function(c){c[c.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(E||(i.ModelConstants=E={}));class R{constructor(u,s,o,h,T,_){this.identifier=u,this.range=s,this.text=o,this.forceMoveMarkers=h,this.isAutoWhitespaceEdit=T,this._isTracked=_}}i.$sv=R;class A{constructor(u,s,o){this.regex=u,this.wordSeparators=s,this.simpleSearch=o}}i.$tv=A;class w{constructor(u,s,o){this.reverseEdits=u,this.changes=s,this.trimAutoWhitespaceLineNumbers=o}}i.$uv=w;function N(c){return!c.isTooLargeForSyncing()&&!c.isForSimpleWidget}}),ne(ie[63],re([0,1,7,14]),function(q,i,t,n){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$aw=i.$_v=i.$$v=void 0;class p{constructor(a){this.a=a,this.b=new Uint32Array(a.length),this.c=new Int32Array(1),this.c[0]=-1}getCount(){return this.a.length}insertValues(a,l){a=(0,n.$0e)(a);const f=this.a,$=this.b,b=l.length;return b===0?!1:(this.a=new Uint32Array(f.length+b),this.a.set(f.subarray(0,a),0),this.a.set(f.subarray(a),a+b),this.a.set(l,a),a-1<this.c[0]&&(this.c[0]=a-1),this.b=new Uint32Array(this.a.length),this.c[0]>=0&&this.b.set($.subarray(0,this.c[0]+1)),!0)}setValue(a,l){return a=(0,n.$0e)(a),l=(0,n.$0e)(l),this.a[a]===l?!1:(this.a[a]=l,a-1<this.c[0]&&(this.c[0]=a-1),!0)}removeValues(a,l){a=(0,n.$0e)(a),l=(0,n.$0e)(l);const f=this.a,$=this.b;if(a>=f.length)return!1;const b=f.length-a;return l>=b&&(l=b),l===0?!1:(this.a=new Uint32Array(f.length-l),this.a.set(f.subarray(0,a),0),this.a.set(f.subarray(a+l),a),this.b=new Uint32Array(this.a.length),a-1<this.c[0]&&(this.c[0]=a-1),this.c[0]>=0&&this.b.set($.subarray(0,this.c[0]+1)),!0)}getTotalSum(){return this.a.length===0?0:this.d(this.a.length-1)}getPrefixSum(a){return a<0?0:(a=(0,n.$0e)(a),this.d(a))}d(a){if(a<=this.c[0])return this.b[a];let l=this.c[0]+1;l===0&&(this.b[0]=this.a[0],l++),a>=this.a.length&&(a=this.a.length-1);for(let f=l;f<=a;f++)this.b[f]=this.b[f-1]+this.a[f];return this.c[0]=Math.max(this.c[0],a),this.b[a]}getIndexOf(a){a=Math.floor(a),this.getTotalSum();let l=0,f=this.a.length-1,$=0,b=0,L=0;for(;l<=f;)if($=l+(f-l)/2|0,b=this.b[$],L=b-this.a[$],a<L)f=$-1;else if(a>=b)l=$+1;else break;return new v($,a-L)}}i.$$v=p;class g{constructor(a){this.a=a,this.b=!1,this.c=-1,this.d=[],this.e=[]}getTotalSum(){return this.g(),this.e.length}getPrefixSum(a){return this.g(),a===0?0:this.d[a-1]}getIndexOf(a){this.g();const l=this.e[a],f=l>0?this.d[l-1]:0;return new v(l,a-f)}removeValues(a,l){this.a.splice(a,l),this.f(a)}insertValues(a,l){this.a=(0,t.$Vb)(this.a,a,l),this.f(a)}f(a){this.b=!1,this.c=Math.min(this.c,a-1)}g(){if(!this.b){for(let a=this.c+1,l=this.a.length;a<l;a++){const f=this.a[a],$=a>0?this.d[a-1]:0;this.d[a]=$+f;for(let b=0;b<f;b++)this.e[$+b]=a}this.d.length=this.a.length,this.e.length=this.d[this.d.length-1],this.b=!0,this.c=this.a.length-1}}setValue(a,l){this.a[a]!==l&&(this.a[a]=l,this.f(a))}}i.$_v=g;class v{constructor(a,l){this.index=a,this.remainder=l,this._prefixSumIndexOfResultBrand=void 0,this.index=a,this.remainder=l}}i.$aw=v}),ne(ie[64],re([0,1,8,5,63]),function(q,i,t,n,p){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$bw=void 0;class g{constructor(d,a,l,f){this.d=d,this.f=a,this.g=l,this.h=f,this.j=null,this.k=null}dispose(){this.f.length=0}get version(){return this.h}getText(){return this.k===null&&(this.k=this.f.join(this.g)),this.k}onEvents(d){d.eol&&d.eol!==this.g&&(this.g=d.eol,this.j=null);const a=d.changes;for(const l of a)this.o(l.range),this.p(new n.$bt(l.range.startLineNumber,l.range.startColumn),l.text);this.h=d.versionId,this.k=null}l(){if(!this.j){const d=this.g.length,a=this.f.length,l=new Uint32Array(a);for(let f=0;f<a;f++)l[f]=this.f[f].length+d;this.j=new p.$$v(l)}}n(d,a){this.f[d]=a,this.j&&this.j.setValue(d,this.f[d].length+this.g.length)}o(d){if(d.startLineNumber===d.endLineNumber){if(d.startColumn===d.endColumn)return;this.n(d.startLineNumber-1,this.f[d.startLineNumber-1].substring(0,d.startColumn-1)+this.f[d.startLineNumber-1].substring(d.endColumn-1));return}this.n(d.startLineNumber-1,this.f[d.startLineNumber-1].substring(0,d.startColumn-1)+this.f[d.endLineNumber-1].substring(d.endColumn-1)),this.f.splice(d.startLineNumber,d.endLineNumber-d.startLineNumber),this.j&&this.j.removeValues(d.startLineNumber,d.endLineNumber-d.startLineNumber)}p(d,a){if(a.length===0)return;const l=(0,t.$of)(a);if(l.length===1){this.n(d.lineNumber-1,this.f[d.lineNumber-1].substring(0,d.column-1)+l[0]+this.f[d.lineNumber-1].substring(d.column-1));return}l[l.length-1]+=this.f[d.lineNumber-1].substring(d.column-1),this.n(d.lineNumber-1,this.f[d.lineNumber-1].substring(0,d.column-1)+l[0]);const f=new Uint32Array(l.length-1);for(let $=1;$<l.length;$++)this.f.splice(d.lineNumber+$-1,0,l[$]),f[$-1]=l[$].length+this.g.length;this.j&&this.j.insertValues(d.lineNumber,f)}}i.$bw=g}),ne(ie[65],re([0,1,3,8,51,5,2,62]),function(q,i,t,n,p,g,v,d){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$3C=i.$1C=i.$XC=void 0,i.$YC=f,i.$ZC=$,i.$2C=E;const a=999;class l{constructor(w,N,c,u){this.searchString=w,this.isRegex=N,this.matchCase=c,this.wordSeparators=u}parseSearchRequest(){if(this.searchString==="")return null;let w;this.isRegex?w=f(this.searchString):w=this.searchString.indexOf(`
`)>=0;let N=null;try{N=n.$mf(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:w,global:!0,unicode:!0})}catch{return null}if(!N)return null;let c=!this.isRegex&&!w;return c&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(c=this.matchCase),new d.$tv(N,this.wordSeparators?(0,p.$qt)(this.wordSeparators,[]):null,c?this.searchString:null)}}i.$XC=l;function f(A){if(!A||A.length===0)return!1;for(let w=0,N=A.length;w<N;w++){const c=A.charCodeAt(w);if(c===t.CharCode.LineFeed)return!0;if(c===t.CharCode.Backslash){if(w++,w>=N)break;const u=A.charCodeAt(w);if(u===t.CharCode.n||u===t.CharCode.r||u===t.CharCode.W)return!0}}return!1}function $(A,w,N){if(!N)return new d.$qv(A,null);const c=[];for(let u=0,s=w.length;u<s;u++)c[u]=w[u];return new d.$qv(A,c)}class b{constructor(w){const N=[];let c=0;for(let u=0,s=w.length;u<s;u++)w.charCodeAt(u)===t.CharCode.LineFeed&&(N[c++]=u);this.a=N}findLineFeedCountBeforeOffset(w){const N=this.a;let c=0,u=N.length-1;if(u===-1||w<=N[0])return 0;for(;c<u;){const s=c+((u-c)/2>>0);N[s]>=w?u=s-1:N[s+1]>=w?(c=s,u=s):c=s+1}return c+1}}class L{static findMatches(w,N,c,u,s){const o=N.parseSearchRequest();return o?o.regex.multiline?this.b(w,c,new R(o.wordSeparators,o.regex),u,s):this.c(w,c,o,u,s):[]}static a(w,N,c,u,s,o){let h,T=0;u?(T=u.findLineFeedCountBeforeOffset(s),h=N+s+T):h=N+s;let _;if(u){const k=u.findLineFeedCountBeforeOffset(s+o.length)-T;_=h+o.length+k}else _=h+o.length;const U=w.getPositionAt(h),M=w.getPositionAt(_);return new v.$ct(U.lineNumber,U.column,M.lineNumber,M.column)}static b(w,N,c,u,s){const o=w.getOffsetAt(N.getStartPosition()),h=w.getValueInRange(N,d.EndOfLinePreference.LF),T=w.getEOL()===`\r
`?new b(h):null,_=[];let U=0,M;for(c.reset(0);M=c.next(h);)if(_[U++]=$(this.a(w,o,h,T,M.index,M[0]),M,u),U>=s)return _;return _}static c(w,N,c,u,s){const o=[];let h=0;if(N.startLineNumber===N.endLineNumber){const _=w.getLineContent(N.startLineNumber).substring(N.startColumn-1,N.endColumn-1);return h=this.d(c,_,N.startLineNumber,N.startColumn-1,h,o,u,s),o}const T=w.getLineContent(N.startLineNumber).substring(N.startColumn-1);h=this.d(c,T,N.startLineNumber,N.startColumn-1,h,o,u,s);for(let _=N.startLineNumber+1;_<N.endLineNumber&&h<s;_++)h=this.d(c,w.getLineContent(_),_,0,h,o,u,s);if(h<s){const _=w.getLineContent(N.endLineNumber).substring(0,N.endColumn-1);h=this.d(c,_,N.endLineNumber,0,h,o,u,s)}return o}static d(w,N,c,u,s,o,h,T){const _=w.wordSeparators;if(!h&&w.simpleSearch){const D=w.simpleSearch,k=D.length,P=N.length;let j=-k;for(;(j=N.indexOf(D,j+k))!==-1;)if((!_||E(_,N,P,j,k))&&(o[s++]=new d.$qv(new v.$ct(c,j+1+u,c,j+1+k+u),null),s>=T))return s;return s}const U=new R(w.wordSeparators,w.regex);let M;U.reset(0);do if(M=U.next(N),M&&(o[s++]=$(new v.$ct(c,M.index+1+u,c,M.index+1+M[0].length+u),M,h),s>=T))return s;while(M);return s}static findNextMatch(w,N,c,u){const s=N.parseSearchRequest();if(!s)return null;const o=new R(s.wordSeparators,s.regex);return s.regex.multiline?this.e(w,c,o,u):this.f(w,c,o,u)}static e(w,N,c,u){const s=new g.$bt(N.lineNumber,1),o=w.getOffsetAt(s),h=w.getLineCount(),T=w.getValueInRange(new v.$ct(s.lineNumber,s.column,h,w.getLineMaxColumn(h)),d.EndOfLinePreference.LF),_=w.getEOL()===`\r
`?new b(T):null;c.reset(N.column-1);const U=c.next(T);return U?$(this.a(w,o,T,_,U.index,U[0]),U,u):N.lineNumber!==1||N.column!==1?this.e(w,new g.$bt(1,1),c,u):null}static f(w,N,c,u){const s=w.getLineCount(),o=N.lineNumber,h=w.getLineContent(o),T=this.g(c,h,o,N.column,u);if(T)return T;for(let _=1;_<=s;_++){const U=(o+_-1)%s,M=w.getLineContent(U+1),D=this.g(c,M,U+1,1,u);if(D)return D}return null}static g(w,N,c,u,s){w.reset(u-1);const o=w.next(N);return o?$(new v.$ct(c,o.index+1,c,o.index+1+o[0].length),o,s):null}static findPreviousMatch(w,N,c,u){const s=N.parseSearchRequest();if(!s)return null;const o=new R(s.wordSeparators,s.regex);return s.regex.multiline?this.h(w,c,o,u):this.j(w,c,o,u)}static h(w,N,c,u){const s=this.b(w,new v.$ct(1,1,N.lineNumber,N.column),c,u,10*a);if(s.length>0)return s[s.length-1];const o=w.getLineCount();return N.lineNumber!==o||N.column!==w.getLineMaxColumn(o)?this.h(w,new g.$bt(o,w.getLineMaxColumn(o)),c,u):null}static j(w,N,c,u){const s=w.getLineCount(),o=N.lineNumber,h=w.getLineContent(o).substring(0,N.column-1),T=this.k(c,h,o,u);if(T)return T;for(let _=1;_<=s;_++){const U=(s+o-_-1)%s,M=w.getLineContent(U+1),D=this.k(c,M,U+1,u);if(D)return D}return null}static k(w,N,c,u){let s=null,o;for(w.reset(0);o=w.next(N);)s=$(new v.$ct(c,o.index+1,c,o.index+1+o[0].length),o,u);return s}}i.$1C=L;function e(A,w,N,c,u){if(c===0)return!0;const s=w.charCodeAt(c-1);if(A.get(s)!==p.WordCharacterClass.Regular||s===t.CharCode.CarriageReturn||s===t.CharCode.LineFeed)return!0;if(u>0){const o=w.charCodeAt(c);if(A.get(o)!==p.WordCharacterClass.Regular)return!0}return!1}function m(A,w,N,c,u){if(c+u===N)return!0;const s=w.charCodeAt(c+u);if(A.get(s)!==p.WordCharacterClass.Regular||s===t.CharCode.CarriageReturn||s===t.CharCode.LineFeed)return!0;if(u>0){const o=w.charCodeAt(c+u-1);if(A.get(o)!==p.WordCharacterClass.Regular)return!0}return!1}function E(A,w,N,c,u){return e(A,w,N,c,u)&&m(A,w,N,c,u)}class R{constructor(w,N){this._wordSeparators=w,this.a=N,this.b=-1,this.c=0}reset(w){this.a.lastIndex=w,this.b=-1,this.c=0}next(w){const N=w.length;let c;do{if(this.b+this.c===N||(c=this.a.exec(w),!c))return null;const u=c.index,s=c[0].length;if(u===this.b&&s===this.c){if(s===0){n.$If(w,N,this.a.lastIndex)>65535?this.a.lastIndex+=2:this.a.lastIndex+=1;continue}return null}if(this.b=u,this.c=s,!this._wordSeparators||E(this._wordSeparators,w,N,u,s))return c}while(c);return null}}i.$3C=R}),ne(ie[66],re([0,1]),function(q,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$h3=p;const t=new RegExp("\\bMARK:\\s*(.*)$","d"),n=/^-+|-+$/g;function p(l,f){let $=[];if(f.findRegionSectionHeaders&&f.foldingRules?.markers){const b=g(l,f);$=$.concat(b)}if(f.findMarkSectionHeaders){const b=v(l);$=$.concat(b)}return $}function g(l,f){const $=[],b=l.getLineCount();for(let L=1;L<=b;L++){const e=l.getLineContent(L),m=e.match(f.foldingRules.markers.start);if(m){const E={startLineNumber:L,startColumn:m[0].length+1,endLineNumber:L,endColumn:e.length+1};if(E.endColumn>E.startColumn){const R={range:E,...a(e.substring(m[0].length)),shouldBeInComments:!1};(R.text||R.hasSeparatorLine)&&$.push(R)}}}return $}function v(l){const f=[],$=l.getLineCount();for(let b=1;b<=$;b++){const L=l.getLineContent(b);d(L,b,f)}return f}function d(l,f,$){t.lastIndex=0;const b=t.exec(l);if(b){const L=b.indices[1][0]+1,e=b.indices[1][1]+1,m={startLineNumber:f,startColumn:L,endLineNumber:f,endColumn:e};if(m.endColumn>m.startColumn){const E={range:m,...a(b[1]),shouldBeInComments:!0};(E.text||E.hasSeparatorLine)&&$.push(E)}}}function a(l){l=l.trim();const f=l.startsWith("-");return l=l.replace(n,""),{text:l,hasSeparatorLine:f}}}),ne(ie[67],re([0,1,2,65,8,11,32]),function(q,i,t,n,p,g,v){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.UnicodeHighlighterReasonKind=i.$P2=void 0;class d{static computeUnicodeHighlights(e,m,E){const R=E?E.startLineNumber:1,A=E?E.endLineNumber:e.getLineCount(),w=new f(m),N=w.getCandidateCodePoints();let c;N==="allNonBasicAscii"?c=new RegExp("[^\\t\\n\\r\\x20-\\x7E]","g"):c=new RegExp(`${a(Array.from(N))}`,"g");const u=new n.$3C(null,c),s=[];let o=!1,h,T=0,_=0,U=0;e:for(let M=R,D=A;M<=D;M++){const k=e.getLineContent(M),P=k.length;u.reset(0);do if(h=u.next(k),h){let j=h.index,B=h.index+h[0].length;if(j>0){const X=k.charCodeAt(j-1);p.$Ff(X)&&j--}if(B+1<P){const X=k.charCodeAt(B-1);p.$Ff(X)&&B++}const Z=k.substring(j,B);let O=(0,v.$vt)(j+1,v.$st,k,0);O&&O.endColumn<=j+1&&(O=null);const S=w.shouldHighlightNonBasicASCII(Z,O?O.word:null);if(S!==b.None){if(S===b.Ambiguous?T++:S===b.Invisible?_++:S===b.NonBasicASCII?U++:(0,g.$ed)(S),s.length>=1e3){o=!0;break e}s.push(new t.$ct(M,j+1,M,B+1))}}while(h)}return{ranges:s,hasMore:o,ambiguousCharacterCount:T,invisibleCharacterCount:_,nonBasicAsciiCharacterCount:U}}static computeUnicodeHighlightReason(e,m){const E=new f(m);switch(E.shouldHighlightNonBasicASCII(e,null)){case b.None:return null;case b.Invisible:return{kind:l.Invisible};case b.Ambiguous:{const A=e.codePointAt(0),w=E.ambiguousCharacters.getPrimaryConfusable(A),N=p.$$f.getLocales().filter(c=>!p.$$f.getInstance(new Set([...m.allowedLocales,c])).isAmbiguous(A));return{kind:l.Ambiguous,confusableWith:String.fromCodePoint(w),notAmbiguousInLocales:N}}case b.NonBasicASCII:return{kind:l.NonBasicAscii}}}}i.$P2=d;function a(L,e){return`[${p.$df(L.map(E=>String.fromCodePoint(E)).join(""))}]`}var l;(function(L){L[L.Ambiguous=0]="Ambiguous",L[L.Invisible=1]="Invisible",L[L.NonBasicAscii=2]="NonBasicAscii"})(l||(i.UnicodeHighlighterReasonKind=l={}));class f{constructor(e){this.b=e,this.a=new Set(e.allowedCodePoints),this.ambiguousCharacters=p.$$f.getInstance(new Set(e.allowedLocales))}getCandidateCodePoints(){if(this.b.nonBasicASCII)return"allNonBasicAscii";const e=new Set;if(this.b.invisibleCharacters)for(const m of p.$_f.codePoints)$(String.fromCodePoint(m))||e.add(m);if(this.b.ambiguousCharacters)for(const m of this.ambiguousCharacters.getConfusableCodePoints())e.add(m);for(const m of this.a)e.delete(m);return e}shouldHighlightNonBasicASCII(e,m){const E=e.codePointAt(0);if(this.a.has(E))return b.None;if(this.b.nonBasicASCII)return b.NonBasicASCII;let R=!1,A=!1;if(m)for(const w of m){const N=w.codePointAt(0),c=p.$Qf(w);R=R||c,!c&&!this.ambiguousCharacters.isAmbiguous(N)&&!p.$_f.isInvisibleCharacter(N)&&(A=!0)}return!R&&A?b.None:this.b.invisibleCharacters&&!$(e)&&p.$_f.isInvisibleCharacter(E)?b.Invisible:this.b.ambiguousCharacters&&this.ambiguousCharacters.isAmbiguous(E)?b.Ambiguous:b.None}}function $(L){return L===" "||L===`
`||L==="	"}var b;(function(L){L[L.None=0]="None",L[L.NonBasicASCII=1]="NonBasicASCII",L[L.Invisible=2]="Invisible",L[L.Ambiguous=3]="Ambiguous"})(b||(b={}))}),ne(ie[68],re([0,1]),function(q,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.WrappingIndent=i.TrackedRangeStickiness=i.TextEditorCursorStyle=i.TextEditorCursorBlinkingStyle=i.SymbolTag=i.SymbolKind=i.SignatureHelpTriggerKind=i.ShowLightbulbIconMode=i.SelectionDirection=i.ScrollbarVisibility=i.ScrollType=i.RenderMinimap=i.RenderLineNumbersType=i.PositionAffinity=i.PartialAcceptTriggerKind=i.OverviewRulerLane=i.OverlayWidgetPositionPreference=i.NewSymbolNameTriggerKind=i.NewSymbolNameTag=i.MouseTargetType=i.MinimapSectionHeaderStyle=i.MinimapPosition=i.MarkerTag=i.MarkerSeverity=i.KeyCode=i.InlineEditTriggerKind=i.InlineCompletionTriggerKind=i.InlayHintKind=i.InjectedTextCursorStops=i.IndentAction=i.HoverVerbosityAction=i.GlyphMarginLane=i.EndOfLineSequence=i.EndOfLinePreference=i.EditorOption=i.EditorAutoIndentStrategy=i.DocumentHighlightKind=i.DefaultEndOfLine=i.CursorChangeReason=i.ContentWidgetPositionPreference=i.CompletionTriggerKind=i.CompletionItemTag=i.CompletionItemKind=i.CompletionItemInsertTextRule=i.CodeActionTriggerType=i.AccessibilitySupport=void 0;var t;(function(r){r[r.Unknown=0]="Unknown",r[r.Disabled=1]="Disabled",r[r.Enabled=2]="Enabled"})(t||(i.AccessibilitySupport=t={}));var n;(function(r){r[r.Invoke=1]="Invoke",r[r.Auto=2]="Auto"})(n||(i.CodeActionTriggerType=n={}));var p;(function(r){r[r.None=0]="None",r[r.KeepWhitespace=1]="KeepWhitespace",r[r.InsertAsSnippet=4]="InsertAsSnippet"})(p||(i.CompletionItemInsertTextRule=p={}));var g;(function(r){r[r.Method=0]="Method",r[r.Function=1]="Function",r[r.Constructor=2]="Constructor",r[r.Field=3]="Field",r[r.Variable=4]="Variable",r[r.Class=5]="Class",r[r.Struct=6]="Struct",r[r.Interface=7]="Interface",r[r.Module=8]="Module",r[r.Property=9]="Property",r[r.Event=10]="Event",r[r.Operator=11]="Operator",r[r.Unit=12]="Unit",r[r.Value=13]="Value",r[r.Constant=14]="Constant",r[r.Enum=15]="Enum",r[r.EnumMember=16]="EnumMember",r[r.Keyword=17]="Keyword",r[r.Text=18]="Text",r[r.Color=19]="Color",r[r.File=20]="File",r[r.Reference=21]="Reference",r[r.Customcolor=22]="Customcolor",r[r.Folder=23]="Folder",r[r.TypeParameter=24]="TypeParameter",r[r.User=25]="User",r[r.Issue=26]="Issue",r[r.Snippet=27]="Snippet"})(g||(i.CompletionItemKind=g={}));var v;(function(r){r[r.Deprecated=1]="Deprecated"})(v||(i.CompletionItemTag=v={}));var d;(function(r){r[r.Invoke=0]="Invoke",r[r.TriggerCharacter=1]="TriggerCharacter",r[r.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(d||(i.CompletionTriggerKind=d={}));var a;(function(r){r[r.EXACT=0]="EXACT",r[r.ABOVE=1]="ABOVE",r[r.BELOW=2]="BELOW"})(a||(i.ContentWidgetPositionPreference=a={}));var l;(function(r){r[r.NotSet=0]="NotSet",r[r.ContentFlush=1]="ContentFlush",r[r.RecoverFromMarkers=2]="RecoverFromMarkers",r[r.Explicit=3]="Explicit",r[r.Paste=4]="Paste",r[r.Undo=5]="Undo",r[r.Redo=6]="Redo"})(l||(i.CursorChangeReason=l={}));var f;(function(r){r[r.LF=1]="LF",r[r.CRLF=2]="CRLF"})(f||(i.DefaultEndOfLine=f={}));var $;(function(r){r[r.Text=0]="Text",r[r.Read=1]="Read",r[r.Write=2]="Write"})($||(i.DocumentHighlightKind=$={}));var b;(function(r){r[r.None=0]="None",r[r.Keep=1]="Keep",r[r.Brackets=2]="Brackets",r[r.Advanced=3]="Advanced",r[r.Full=4]="Full"})(b||(i.EditorAutoIndentStrategy=b={}));var L;(function(r){r[r.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",r[r.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",r[r.accessibilitySupport=2]="accessibilitySupport",r[r.accessibilityPageSize=3]="accessibilityPageSize",r[r.ariaLabel=4]="ariaLabel",r[r.ariaRequired=5]="ariaRequired",r[r.autoClosingBrackets=6]="autoClosingBrackets",r[r.autoClosingComments=7]="autoClosingComments",r[r.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",r[r.autoClosingDelete=9]="autoClosingDelete",r[r.autoClosingOvertype=10]="autoClosingOvertype",r[r.autoClosingQuotes=11]="autoClosingQuotes",r[r.autoIndent=12]="autoIndent",r[r.automaticLayout=13]="automaticLayout",r[r.autoSurround=14]="autoSurround",r[r.bracketPairColorization=15]="bracketPairColorization",r[r.guides=16]="guides",r[r.codeLens=17]="codeLens",r[r.codeLensFontFamily=18]="codeLensFontFamily",r[r.codeLensFontSize=19]="codeLensFontSize",r[r.colorDecorators=20]="colorDecorators",r[r.colorDecoratorsLimit=21]="colorDecoratorsLimit",r[r.columnSelection=22]="columnSelection",r[r.comments=23]="comments",r[r.contextmenu=24]="contextmenu",r[r.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",r[r.cursorBlinking=26]="cursorBlinking",r[r.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",r[r.cursorStyle=28]="cursorStyle",r[r.cursorSurroundingLines=29]="cursorSurroundingLines",r[r.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",r[r.cursorWidth=31]="cursorWidth",r[r.disableLayerHinting=32]="disableLayerHinting",r[r.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",r[r.domReadOnly=34]="domReadOnly",r[r.dragAndDrop=35]="dragAndDrop",r[r.dropIntoEditor=36]="dropIntoEditor",r[r.emptySelectionClipboard=37]="emptySelectionClipboard",r[r.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",r[r.extraEditorClassName=39]="extraEditorClassName",r[r.fastScrollSensitivity=40]="fastScrollSensitivity",r[r.find=41]="find",r[r.fixedOverflowWidgets=42]="fixedOverflowWidgets",r[r.folding=43]="folding",r[r.foldingStrategy=44]="foldingStrategy",r[r.foldingHighlight=45]="foldingHighlight",r[r.foldingImportsByDefault=46]="foldingImportsByDefault",r[r.foldingMaximumRegions=47]="foldingMaximumRegions",r[r.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",r[r.fontFamily=49]="fontFamily",r[r.fontInfo=50]="fontInfo",r[r.fontLigatures=51]="fontLigatures",r[r.fontSize=52]="fontSize",r[r.fontWeight=53]="fontWeight",r[r.fontVariations=54]="fontVariations",r[r.formatOnPaste=55]="formatOnPaste",r[r.formatOnType=56]="formatOnType",r[r.glyphMargin=57]="glyphMargin",r[r.gotoLocation=58]="gotoLocation",r[r.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",r[r.hover=60]="hover",r[r.inDiffEditor=61]="inDiffEditor",r[r.inlineSuggest=62]="inlineSuggest",r[r.inlineEdit=63]="inlineEdit",r[r.letterSpacing=64]="letterSpacing",r[r.lightbulb=65]="lightbulb",r[r.lineDecorationsWidth=66]="lineDecorationsWidth",r[r.lineHeight=67]="lineHeight",r[r.lineNumbers=68]="lineNumbers",r[r.lineNumbersMinChars=69]="lineNumbersMinChars",r[r.linkedEditing=70]="linkedEditing",r[r.links=71]="links",r[r.matchBrackets=72]="matchBrackets",r[r.minimap=73]="minimap",r[r.mouseStyle=74]="mouseStyle",r[r.mouseWheelScrollSensitivity=75]="mouseWheelScrollSensitivity",r[r.mouseWheelZoom=76]="mouseWheelZoom",r[r.multiCursorMergeOverlapping=77]="multiCursorMergeOverlapping",r[r.multiCursorModifier=78]="multiCursorModifier",r[r.multiCursorPaste=79]="multiCursorPaste",r[r.multiCursorLimit=80]="multiCursorLimit",r[r.occurrencesHighlight=81]="occurrencesHighlight",r[r.overviewRulerBorder=82]="overviewRulerBorder",r[r.overviewRulerLanes=83]="overviewRulerLanes",r[r.padding=84]="padding",r[r.pasteAs=85]="pasteAs",r[r.parameterHints=86]="parameterHints",r[r.peekWidgetDefaultFocus=87]="peekWidgetDefaultFocus",r[r.definitionLinkOpensInPeek=88]="definitionLinkOpensInPeek",r[r.quickSuggestions=89]="quickSuggestions",r[r.quickSuggestionsDelay=90]="quickSuggestionsDelay",r[r.readOnly=91]="readOnly",r[r.readOnlyMessage=92]="readOnlyMessage",r[r.renameOnType=93]="renameOnType",r[r.renderControlCharacters=94]="renderControlCharacters",r[r.renderFinalNewline=95]="renderFinalNewline",r[r.renderLineHighlight=96]="renderLineHighlight",r[r.renderLineHighlightOnlyWhenFocus=97]="renderLineHighlightOnlyWhenFocus",r[r.renderValidationDecorations=98]="renderValidationDecorations",r[r.renderWhitespace=99]="renderWhitespace",r[r.revealHorizontalRightPadding=100]="revealHorizontalRightPadding",r[r.roundedSelection=101]="roundedSelection",r[r.rulers=102]="rulers",r[r.scrollbar=103]="scrollbar",r[r.scrollBeyondLastColumn=104]="scrollBeyondLastColumn",r[r.scrollBeyondLastLine=105]="scrollBeyondLastLine",r[r.scrollPredominantAxis=106]="scrollPredominantAxis",r[r.selectionClipboard=107]="selectionClipboard",r[r.selectionHighlight=108]="selectionHighlight",r[r.selectOnLineNumbers=109]="selectOnLineNumbers",r[r.showFoldingControls=110]="showFoldingControls",r[r.showUnused=111]="showUnused",r[r.snippetSuggestions=112]="snippetSuggestions",r[r.smartSelect=113]="smartSelect",r[r.smoothScrolling=114]="smoothScrolling",r[r.stickyScroll=115]="stickyScroll",r[r.stickyTabStops=116]="stickyTabStops",r[r.stopRenderingLineAfter=117]="stopRenderingLineAfter",r[r.suggest=118]="suggest",r[r.suggestFontSize=119]="suggestFontSize",r[r.suggestLineHeight=120]="suggestLineHeight",r[r.suggestOnTriggerCharacters=121]="suggestOnTriggerCharacters",r[r.suggestSelection=122]="suggestSelection",r[r.tabCompletion=123]="tabCompletion",r[r.tabIndex=124]="tabIndex",r[r.unicodeHighlighting=125]="unicodeHighlighting",r[r.unusualLineTerminators=126]="unusualLineTerminators",r[r.useShadowDOM=127]="useShadowDOM",r[r.useTabStops=128]="useTabStops",r[r.wordBreak=129]="wordBreak",r[r.wordSegmenterLocales=130]="wordSegmenterLocales",r[r.wordSeparators=131]="wordSeparators",r[r.wordWrap=132]="wordWrap",r[r.wordWrapBreakAfterCharacters=133]="wordWrapBreakAfterCharacters",r[r.wordWrapBreakBeforeCharacters=134]="wordWrapBreakBeforeCharacters",r[r.wordWrapColumn=135]="wordWrapColumn",r[r.wordWrapOverride1=136]="wordWrapOverride1",r[r.wordWrapOverride2=137]="wordWrapOverride2",r[r.wrappingIndent=138]="wrappingIndent",r[r.wrappingStrategy=139]="wrappingStrategy",r[r.showDeprecated=140]="showDeprecated",r[r.inlayHints=141]="inlayHints",r[r.editorClassName=142]="editorClassName",r[r.pixelRatio=143]="pixelRatio",r[r.tabFocusMode=144]="tabFocusMode",r[r.layoutInfo=145]="layoutInfo",r[r.wrappingInfo=146]="wrappingInfo",r[r.defaultColorDecorators=147]="defaultColorDecorators",r[r.colorDecoratorsActivatedOn=148]="colorDecoratorsActivatedOn",r[r.inlineCompletionsAccessibilityVerbose=149]="inlineCompletionsAccessibilityVerbose"})(L||(i.EditorOption=L={}));var e;(function(r){r[r.TextDefined=0]="TextDefined",r[r.LF=1]="LF",r[r.CRLF=2]="CRLF"})(e||(i.EndOfLinePreference=e={}));var m;(function(r){r[r.LF=0]="LF",r[r.CRLF=1]="CRLF"})(m||(i.EndOfLineSequence=m={}));var E;(function(r){r[r.Left=1]="Left",r[r.Center=2]="Center",r[r.Right=3]="Right"})(E||(i.GlyphMarginLane=E={}));var R;(function(r){r[r.Increase=0]="Increase",r[r.Decrease=1]="Decrease"})(R||(i.HoverVerbosityAction=R={}));var A;(function(r){r[r.None=0]="None",r[r.Indent=1]="Indent",r[r.IndentOutdent=2]="IndentOutdent",r[r.Outdent=3]="Outdent"})(A||(i.IndentAction=A={}));var w;(function(r){r[r.Both=0]="Both",r[r.Right=1]="Right",r[r.Left=2]="Left",r[r.None=3]="None"})(w||(i.InjectedTextCursorStops=w={}));var N;(function(r){r[r.Type=1]="Type",r[r.Parameter=2]="Parameter"})(N||(i.InlayHintKind=N={}));var c;(function(r){r[r.Automatic=0]="Automatic",r[r.Explicit=1]="Explicit"})(c||(i.InlineCompletionTriggerKind=c={}));var u;(function(r){r[r.Invoke=0]="Invoke",r[r.Automatic=1]="Automatic"})(u||(i.InlineEditTriggerKind=u={}));var s;(function(r){r[r.DependsOnKbLayout=-1]="DependsOnKbLayout",r[r.Unknown=0]="Unknown",r[r.Backspace=1]="Backspace",r[r.Tab=2]="Tab",r[r.Enter=3]="Enter",r[r.Shift=4]="Shift",r[r.Ctrl=5]="Ctrl",r[r.Alt=6]="Alt",r[r.PauseBreak=7]="PauseBreak",r[r.CapsLock=8]="CapsLock",r[r.Escape=9]="Escape",r[r.Space=10]="Space",r[r.PageUp=11]="PageUp",r[r.PageDown=12]="PageDown",r[r.End=13]="End",r[r.Home=14]="Home",r[r.LeftArrow=15]="LeftArrow",r[r.UpArrow=16]="UpArrow",r[r.RightArrow=17]="RightArrow",r[r.DownArrow=18]="DownArrow",r[r.Insert=19]="Insert",r[r.Delete=20]="Delete",r[r.Digit0=21]="Digit0",r[r.Digit1=22]="Digit1",r[r.Digit2=23]="Digit2",r[r.Digit3=24]="Digit3",r[r.Digit4=25]="Digit4",r[r.Digit5=26]="Digit5",r[r.Digit6=27]="Digit6",r[r.Digit7=28]="Digit7",r[r.Digit8=29]="Digit8",r[r.Digit9=30]="Digit9",r[r.KeyA=31]="KeyA",r[r.KeyB=32]="KeyB",r[r.KeyC=33]="KeyC",r[r.KeyD=34]="KeyD",r[r.KeyE=35]="KeyE",r[r.KeyF=36]="KeyF",r[r.KeyG=37]="KeyG",r[r.KeyH=38]="KeyH",r[r.KeyI=39]="KeyI",r[r.KeyJ=40]="KeyJ",r[r.KeyK=41]="KeyK",r[r.KeyL=42]="KeyL",r[r.KeyM=43]="KeyM",r[r.KeyN=44]="KeyN",r[r.KeyO=45]="KeyO",r[r.KeyP=46]="KeyP",r[r.KeyQ=47]="KeyQ",r[r.KeyR=48]="KeyR",r[r.KeyS=49]="KeyS",r[r.KeyT=50]="KeyT",r[r.KeyU=51]="KeyU",r[r.KeyV=52]="KeyV",r[r.KeyW=53]="KeyW",r[r.KeyX=54]="KeyX",r[r.KeyY=55]="KeyY",r[r.KeyZ=56]="KeyZ",r[r.Meta=57]="Meta",r[r.ContextMenu=58]="ContextMenu",r[r.F1=59]="F1",r[r.F2=60]="F2",r[r.F3=61]="F3",r[r.F4=62]="F4",r[r.F5=63]="F5",r[r.F6=64]="F6",r[r.F7=65]="F7",r[r.F8=66]="F8",r[r.F9=67]="F9",r[r.F10=68]="F10",r[r.F11=69]="F11",r[r.F12=70]="F12",r[r.F13=71]="F13",r[r.F14=72]="F14",r[r.F15=73]="F15",r[r.F16=74]="F16",r[r.F17=75]="F17",r[r.F18=76]="F18",r[r.F19=77]="F19",r[r.F20=78]="F20",r[r.F21=79]="F21",r[r.F22=80]="F22",r[r.F23=81]="F23",r[r.F24=82]="F24",r[r.NumLock=83]="NumLock",r[r.ScrollLock=84]="ScrollLock",r[r.Semicolon=85]="Semicolon",r[r.Equal=86]="Equal",r[r.Comma=87]="Comma",r[r.Minus=88]="Minus",r[r.Period=89]="Period",r[r.Slash=90]="Slash",r[r.Backquote=91]="Backquote",r[r.BracketLeft=92]="BracketLeft",r[r.Backslash=93]="Backslash",r[r.BracketRight=94]="BracketRight",r[r.Quote=95]="Quote",r[r.OEM_8=96]="OEM_8",r[r.IntlBackslash=97]="IntlBackslash",r[r.Numpad0=98]="Numpad0",r[r.Numpad1=99]="Numpad1",r[r.Numpad2=100]="Numpad2",r[r.Numpad3=101]="Numpad3",r[r.Numpad4=102]="Numpad4",r[r.Numpad5=103]="Numpad5",r[r.Numpad6=104]="Numpad6",r[r.Numpad7=105]="Numpad7",r[r.Numpad8=106]="Numpad8",r[r.Numpad9=107]="Numpad9",r[r.NumpadMultiply=108]="NumpadMultiply",r[r.NumpadAdd=109]="NumpadAdd",r[r.NUMPAD_SEPARATOR=110]="NUMPAD_SEPARATOR",r[r.NumpadSubtract=111]="NumpadSubtract",r[r.NumpadDecimal=112]="NumpadDecimal",r[r.NumpadDivide=113]="NumpadDivide",r[r.KEY_IN_COMPOSITION=114]="KEY_IN_COMPOSITION",r[r.ABNT_C1=115]="ABNT_C1",r[r.ABNT_C2=116]="ABNT_C2",r[r.AudioVolumeMute=117]="AudioVolumeMute",r[r.AudioVolumeUp=118]="AudioVolumeUp",r[r.AudioVolumeDown=119]="AudioVolumeDown",r[r.BrowserSearch=120]="BrowserSearch",r[r.BrowserHome=121]="BrowserHome",r[r.BrowserBack=122]="BrowserBack",r[r.BrowserForward=123]="BrowserForward",r[r.MediaTrackNext=124]="MediaTrackNext",r[r.MediaTrackPrevious=125]="MediaTrackPrevious",r[r.MediaStop=126]="MediaStop",r[r.MediaPlayPause=127]="MediaPlayPause",r[r.LaunchMediaPlayer=128]="LaunchMediaPlayer",r[r.LaunchMail=129]="LaunchMail",r[r.LaunchApp2=130]="LaunchApp2",r[r.Clear=131]="Clear",r[r.MAX_VALUE=132]="MAX_VALUE"})(s||(i.KeyCode=s={}));var o;(function(r){r[r.Hint=1]="Hint",r[r.Info=2]="Info",r[r.Warning=4]="Warning",r[r.Error=8]="Error"})(o||(i.MarkerSeverity=o={}));var h;(function(r){r[r.Unnecessary=1]="Unnecessary",r[r.Deprecated=2]="Deprecated"})(h||(i.MarkerTag=h={}));var T;(function(r){r[r.Inline=1]="Inline",r[r.Gutter=2]="Gutter"})(T||(i.MinimapPosition=T={}));var _;(function(r){r[r.Normal=1]="Normal",r[r.Underlined=2]="Underlined"})(_||(i.MinimapSectionHeaderStyle=_={}));var U;(function(r){r[r.UNKNOWN=0]="UNKNOWN",r[r.TEXTAREA=1]="TEXTAREA",r[r.GUTTER_GLYPH_MARGIN=2]="GUTTER_GLYPH_MARGIN",r[r.GUTTER_LINE_NUMBERS=3]="GUTTER_LINE_NUMBERS",r[r.GUTTER_LINE_DECORATIONS=4]="GUTTER_LINE_DECORATIONS",r[r.GUTTER_VIEW_ZONE=5]="GUTTER_VIEW_ZONE",r[r.CONTENT_TEXT=6]="CONTENT_TEXT",r[r.CONTENT_EMPTY=7]="CONTENT_EMPTY",r[r.CONTENT_VIEW_ZONE=8]="CONTENT_VIEW_ZONE",r[r.CONTENT_WIDGET=9]="CONTENT_WIDGET",r[r.OVERVIEW_RULER=10]="OVERVIEW_RULER",r[r.SCROLLBAR=11]="SCROLLBAR",r[r.OVERLAY_WIDGET=12]="OVERLAY_WIDGET",r[r.OUTSIDE_EDITOR=13]="OUTSIDE_EDITOR"})(U||(i.MouseTargetType=U={}));var M;(function(r){r[r.AIGenerated=1]="AIGenerated"})(M||(i.NewSymbolNameTag=M={}));var D;(function(r){r[r.Invoke=0]="Invoke",r[r.Automatic=1]="Automatic"})(D||(i.NewSymbolNameTriggerKind=D={}));var k;(function(r){r[r.TOP_RIGHT_CORNER=0]="TOP_RIGHT_CORNER",r[r.BOTTOM_RIGHT_CORNER=1]="BOTTOM_RIGHT_CORNER",r[r.TOP_CENTER=2]="TOP_CENTER"})(k||(i.OverlayWidgetPositionPreference=k={}));var P;(function(r){r[r.Left=1]="Left",r[r.Center=2]="Center",r[r.Right=4]="Right",r[r.Full=7]="Full"})(P||(i.OverviewRulerLane=P={}));var j;(function(r){r[r.Word=0]="Word",r[r.Line=1]="Line",r[r.Suggest=2]="Suggest"})(j||(i.PartialAcceptTriggerKind=j={}));var B;(function(r){r[r.Left=0]="Left",r[r.Right=1]="Right",r[r.None=2]="None",r[r.LeftOfInjectedText=3]="LeftOfInjectedText",r[r.RightOfInjectedText=4]="RightOfInjectedText"})(B||(i.PositionAffinity=B={}));var Z;(function(r){r[r.Off=0]="Off",r[r.On=1]="On",r[r.Relative=2]="Relative",r[r.Interval=3]="Interval",r[r.Custom=4]="Custom"})(Z||(i.RenderLineNumbersType=Z={}));var O;(function(r){r[r.None=0]="None",r[r.Text=1]="Text",r[r.Blocks=2]="Blocks"})(O||(i.RenderMinimap=O={}));var S;(function(r){r[r.Smooth=0]="Smooth",r[r.Immediate=1]="Immediate"})(S||(i.ScrollType=S={}));var X;(function(r){r[r.Auto=1]="Auto",r[r.Hidden=2]="Hidden",r[r.Visible=3]="Visible"})(X||(i.ScrollbarVisibility=X={}));var Y;(function(r){r[r.LTR=0]="LTR",r[r.RTL=1]="RTL"})(Y||(i.SelectionDirection=Y={}));var H;(function(r){r.Off="off",r.OnCode="onCode",r.On="on"})(H||(i.ShowLightbulbIconMode=H={}));var Q;(function(r){r[r.Invoke=1]="Invoke",r[r.TriggerCharacter=2]="TriggerCharacter",r[r.ContentChange=3]="ContentChange"})(Q||(i.SignatureHelpTriggerKind=Q={}));var C;(function(r){r[r.File=0]="File",r[r.Module=1]="Module",r[r.Namespace=2]="Namespace",r[r.Package=3]="Package",r[r.Class=4]="Class",r[r.Method=5]="Method",r[r.Property=6]="Property",r[r.Field=7]="Field",r[r.Constructor=8]="Constructor",r[r.Enum=9]="Enum",r[r.Interface=10]="Interface",r[r.Function=11]="Function",r[r.Variable=12]="Variable",r[r.Constant=13]="Constant",r[r.String=14]="String",r[r.Number=15]="Number",r[r.Boolean=16]="Boolean",r[r.Array=17]="Array",r[r.Object=18]="Object",r[r.Key=19]="Key",r[r.Null=20]="Null",r[r.EnumMember=21]="EnumMember",r[r.Struct=22]="Struct",r[r.Event=23]="Event",r[r.Operator=24]="Operator",r[r.TypeParameter=25]="TypeParameter"})(C||(i.SymbolKind=C={}));var F;(function(r){r[r.Deprecated=1]="Deprecated"})(F||(i.SymbolTag=F={}));var z;(function(r){r[r.Hidden=0]="Hidden",r[r.Blink=1]="Blink",r[r.Smooth=2]="Smooth",r[r.Phase=3]="Phase",r[r.Expand=4]="Expand",r[r.Solid=5]="Solid"})(z||(i.TextEditorCursorBlinkingStyle=z={}));var fe;(function(r){r[r.Line=1]="Line",r[r.Block=2]="Block",r[r.Underline=3]="Underline",r[r.LineThin=4]="LineThin",r[r.BlockOutline=5]="BlockOutline",r[r.UnderlineThin=6]="UnderlineThin"})(fe||(i.TextEditorCursorStyle=fe={}));var oe;(function(r){r[r.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",r[r.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",r[r.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",r[r.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(oe||(i.TrackedRangeStickiness=oe={}));var we;(function(r){r[r.None=0]="None",r[r.Same=1]="Same",r[r.Indent=2]="Indent",r[r.DeepIndent=3]="DeepIndent"})(we||(i.WrappingIndent=we={}))}),ne(ie[69],re([0,1,13,12,58]),function(q,i,t,n,p){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$wv=void 0;class g{constructor(){this.a=new Map,this.b=new Map,this.c=new t.$he,this.onDidChange=this.c.event,this.d=null}handleChange(a){this.c.fire({changedLanguages:a,changedColorMap:!1})}register(a,l){return this.a.set(a,l),this.handleChange([a]),(0,n.$Sc)(()=>{this.a.get(a)===l&&(this.a.delete(a),this.handleChange([a]))})}get(a){return this.a.get(a)||null}registerFactory(a,l){this.b.get(a)?.dispose();const f=new v(this,a,l);return this.b.set(a,f),(0,n.$Sc)(()=>{const $=this.b.get(a);!$||$!==f||(this.b.delete(a),$.dispose())})}async getOrCreate(a){const l=this.get(a);if(l)return l;const f=this.b.get(a);return!f||f.isResolved?null:(await f.resolve(),this.get(a))}isResolved(a){if(this.get(a))return!0;const f=this.b.get(a);return!!(!f||f.isResolved)}setColorMap(a){this.d=a,this.c.fire({changedLanguages:Array.from(this.a.keys()),changedColorMap:!0})}getColorMap(){return this.d}getDefaultBackground(){return this.d&&this.d.length>p.ColorId.DefaultBackground?this.d[p.ColorId.DefaultBackground]:null}}i.$wv=g;class v extends n.$Uc{get isResolved(){return this.c}constructor(a,l,f){super(),this.f=a,this.g=l,this.h=f,this.a=!1,this.b=null,this.c=!1}dispose(){this.a=!0,super.dispose()}async resolve(){return this.b||(this.b=this.j()),this.b}async j(){const a=await this.h.tokenizationSupport;this.c=!0,a&&!this.a&&this.B(this.f.register(this.g,a))}}}),ne(ie[70],re([71,72]),function(q,i){return q.create("vs/base/common/platform",i)}),ne(ie[20],re([0,1,70]),function(q,i,t){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$I=i.$H=i.$G=i.$F=i.$E=i.OS=i.OperatingSystem=i.$B=i.$A=i.$z=i.$y=i.$x=i.Language=i.$w=i.$v=i.$u=i.$t=i.$s=i.$r=i.$q=i.$p=i.$o=i.$n=i.$m=i.$l=i.$k=i.$j=i.$i=i.Platform=i.$g=void 0,i.$h=s,i.$D=M,i.$J=D,i.$g="en";let n=!1,p=!1,g=!1,v=!1,d=!1,a=!1,l=!1,f=!1,$=!1,b=!1,L,e=i.$g,m=i.$g,E,R;const A=globalThis;let w;typeof A.vscode<"u"&&typeof A.vscode.process<"u"?w=A.vscode.process:typeof process<"u"&&typeof process?.versions?.node=="string"&&(w=process);const N=typeof w?.versions?.electron=="string",c=N&&w?.type==="renderer";if(typeof w=="object"){n=w.platform==="win32",p=w.platform==="darwin",g=w.platform==="linux",v=g&&!!w.env.SNAP&&!!w.env.SNAP_REVISION,l=N,$=!!w.env.CI||!!w.env.BUILD_ARTIFACTSTAGINGDIRECTORY,L=i.$g,e=i.$g;const k=w.env.VSCODE_NLS_CONFIG;if(k)try{const P=JSON.parse(k),j=P.availableLanguages["*"];L=P.locale,m=P.osLocale,e=j||i.$g,E=P._translationsConfigFile}catch{}d=!0}else typeof navigator=="object"&&!c?(R=navigator.userAgent,n=R.indexOf("Windows")>=0,p=R.indexOf("Macintosh")>=0,f=(R.indexOf("Macintosh")>=0||R.indexOf("iPad")>=0||R.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,g=R.indexOf("Linux")>=0,b=R?.indexOf("Mobi")>=0,a=!0,L=t.getConfiguredDefaultLocale(t.localize(0,null))||i.$g,e=L,m=navigator.language):console.error("Unable to resolve platform.");var u;(function(k){k[k.Web=0]="Web",k[k.Mac=1]="Mac",k[k.Linux=2]="Linux",k[k.Windows=3]="Windows"})(u||(i.Platform=u={}));function s(k){switch(k){case u.Web:return"Web";case u.Mac:return"Mac";case u.Linux:return"Linux";case u.Windows:return"Windows"}}let o=u.Web;p?o=u.Mac:n?o=u.Windows:g&&(o=u.Linux),i.$i=n,i.$j=p,i.$k=g,i.$l=v,i.$m=d,i.$n=l,i.$o=a,i.$p=a&&typeof A.importScripts=="function",i.$q=i.$p?A.origin:void 0,i.$r=f,i.$s=b,i.$t=$,i.$u=o,i.$v=R,i.$w=e;var h;(function(k){function P(){return i.$w}k.value=P;function j(){return i.$w.length===2?i.$w==="en":i.$w.length>=3?i.$w[0]==="e"&&i.$w[1]==="n"&&i.$w[2]==="-":!1}k.isDefaultVariant=j;function B(){return i.$w==="en"}k.isDefault=B})(h||(i.Language=h={})),i.$x=L,i.$y=m,i.$z=E,i.$A=typeof A.postMessage=="function"&&!A.importScripts,i.$B=(()=>{if(i.$A){const k=[];A.addEventListener("message",j=>{if(j.data&&j.data.vscodeScheduleAsyncWork)for(let B=0,Z=k.length;B<Z;B++){const O=k[B];if(O.id===j.data.vscodeScheduleAsyncWork){k.splice(B,1),O.callback();return}}});let P=0;return j=>{const B=++P;k.push({id:B,callback:j}),A.postMessage({vscodeScheduleAsyncWork:B},"*")}}return k=>setTimeout(k)})();var T;(function(k){k[k.Windows=1]="Windows",k[k.Macintosh=2]="Macintosh",k[k.Linux=3]="Linux"})(T||(i.OperatingSystem=T={})),i.OS=p||f?T.Macintosh:n?T.Windows:T.Linux;let _=!0,U=!1;function M(){if(!U){U=!0;const k=new Uint8Array(2);k[0]=1,k[1]=2,_=new Uint16Array(k.buffer)[0]===513}return _}i.$E=!!(i.$v&&i.$v.indexOf("Chrome")>=0),i.$F=!!(i.$v&&i.$v.indexOf("Firefox")>=0),i.$G=!!(!i.$E&&i.$v&&i.$v.indexOf("Safari")>=0),i.$H=!!(i.$v&&i.$v.indexOf("Edg/")>=0),i.$I=!!(i.$v&&i.$v.indexOf("Android")>=0);function D(k){return parseFloat(k)>=20}}),ne(ie[73],re([0,1,20]),function(q,i,t){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$ec=i.$dc=i.env=i.cwd=void 0;let n;const p=globalThis.vscode;if(typeof p<"u"&&typeof p.process<"u"){const g=p.process;n={get platform(){return g.platform},get arch(){return g.arch},get env(){return g.env},cwd(){return g.cwd()}}}else typeof process<"u"?n={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:n={get platform(){return t.$i?"win32":t.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};i.cwd=n.cwd,i.env=n.env,i.$dc=n.platform,i.$ec=n.arch}),ne(ie[74],re([0,1,73]),function(q,i,t){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$tc=i.sep=i.$rc=i.$qc=i.$pc=i.$oc=i.$nc=i.$mc=i.$lc=i.$kc=i.$jc=i.$ic=i.$hc=i.$gc=i.$fc=void 0;const n=65,p=97,g=90,v=122,d=46,a=47,l=92,f=58,$=63;class b extends Error{constructor(s,o,h){let T;typeof o=="string"&&o.indexOf("not ")===0?(T="must not be",o=o.replace(/^not /,"")):T="must be";const _=s.indexOf(".")!==-1?"property":"argument";let U=`The "${s}" ${_} ${T} of type ${o}`;U+=`. Received type ${typeof h}`,super(U),this.code="ERR_INVALID_ARG_TYPE"}}function L(u,s){if(u===null||typeof u!="object")throw new b(s,"Object",u)}function e(u,s){if(typeof u!="string")throw new b(s,"string",u)}const m=t.$dc==="win32";function E(u){return u===a||u===l}function R(u){return u===a}function A(u){return u>=n&&u<=g||u>=p&&u<=v}function w(u,s,o,h){let T="",_=0,U=-1,M=0,D=0;for(let k=0;k<=u.length;++k){if(k<u.length)D=u.charCodeAt(k);else{if(h(D))break;D=a}if(h(D)){if(!(U===k-1||M===1))if(M===2){if(T.length<2||_!==2||T.charCodeAt(T.length-1)!==d||T.charCodeAt(T.length-2)!==d){if(T.length>2){const P=T.lastIndexOf(o);P===-1?(T="",_=0):(T=T.slice(0,P),_=T.length-1-T.lastIndexOf(o)),U=k,M=0;continue}else if(T.length!==0){T="",_=0,U=k,M=0;continue}}s&&(T+=T.length>0?`${o}..`:"..",_=2)}else T.length>0?T+=`${o}${u.slice(U+1,k)}`:T=u.slice(U+1,k),_=k-U-1;U=k,M=0}else D===d&&M!==-1?++M:M=-1}return T}function N(u,s){L(s,"pathObject");const o=s.dir||s.root,h=s.base||`${s.name||""}${s.ext||""}`;return o?o===s.root?`${o}${h}`:`${o}${u}${h}`:h}i.$fc={resolve(...u){let s="",o="",h=!1;for(let T=u.length-1;T>=-1;T--){let _;if(T>=0){if(_=u[T],e(_,"path"),_.length===0)continue}else s.length===0?_=t.cwd():(_=t.env[`=${s}`]||t.cwd(),(_===void 0||_.slice(0,2).toLowerCase()!==s.toLowerCase()&&_.charCodeAt(2)===l)&&(_=`${s}\\`));const U=_.length;let M=0,D="",k=!1;const P=_.charCodeAt(0);if(U===1)E(P)&&(M=1,k=!0);else if(E(P))if(k=!0,E(_.charCodeAt(1))){let j=2,B=j;for(;j<U&&!E(_.charCodeAt(j));)j++;if(j<U&&j!==B){const Z=_.slice(B,j);for(B=j;j<U&&E(_.charCodeAt(j));)j++;if(j<U&&j!==B){for(B=j;j<U&&!E(_.charCodeAt(j));)j++;(j===U||j!==B)&&(D=`\\\\${Z}\\${_.slice(B,j)}`,M=j)}}}else M=1;else A(P)&&_.charCodeAt(1)===f&&(D=_.slice(0,2),M=2,U>2&&E(_.charCodeAt(2))&&(k=!0,M=3));if(D.length>0)if(s.length>0){if(D.toLowerCase()!==s.toLowerCase())continue}else s=D;if(h){if(s.length>0)break}else if(o=`${_.slice(M)}\\${o}`,h=k,k&&s.length>0)break}return o=w(o,!h,"\\",E),h?`${s}\\${o}`:`${s}${o}`||"."},normalize(u){e(u,"path");const s=u.length;if(s===0)return".";let o=0,h,T=!1;const _=u.charCodeAt(0);if(s===1)return R(_)?"\\":u;if(E(_))if(T=!0,E(u.charCodeAt(1))){let M=2,D=M;for(;M<s&&!E(u.charCodeAt(M));)M++;if(M<s&&M!==D){const k=u.slice(D,M);for(D=M;M<s&&E(u.charCodeAt(M));)M++;if(M<s&&M!==D){for(D=M;M<s&&!E(u.charCodeAt(M));)M++;if(M===s)return`\\\\${k}\\${u.slice(D)}\\`;M!==D&&(h=`\\\\${k}\\${u.slice(D,M)}`,o=M)}}}else o=1;else A(_)&&u.charCodeAt(1)===f&&(h=u.slice(0,2),o=2,s>2&&E(u.charCodeAt(2))&&(T=!0,o=3));let U=o<s?w(u.slice(o),!T,"\\",E):"";return U.length===0&&!T&&(U="."),U.length>0&&E(u.charCodeAt(s-1))&&(U+="\\"),h===void 0?T?`\\${U}`:U:T?`${h}\\${U}`:`${h}${U}`},isAbsolute(u){e(u,"path");const s=u.length;if(s===0)return!1;const o=u.charCodeAt(0);return E(o)||s>2&&A(o)&&u.charCodeAt(1)===f&&E(u.charCodeAt(2))},join(...u){if(u.length===0)return".";let s,o;for(let _=0;_<u.length;++_){const U=u[_];e(U,"path"),U.length>0&&(s===void 0?s=o=U:s+=`\\${U}`)}if(s===void 0)return".";let h=!0,T=0;if(typeof o=="string"&&E(o.charCodeAt(0))){++T;const _=o.length;_>1&&E(o.charCodeAt(1))&&(++T,_>2&&(E(o.charCodeAt(2))?++T:h=!1))}if(h){for(;T<s.length&&E(s.charCodeAt(T));)T++;T>=2&&(s=`\\${s.slice(T)}`)}return i.$fc.normalize(s)},relative(u,s){if(e(u,"from"),e(s,"to"),u===s)return"";const o=i.$fc.resolve(u),h=i.$fc.resolve(s);if(o===h||(u=o.toLowerCase(),s=h.toLowerCase(),u===s))return"";let T=0;for(;T<u.length&&u.charCodeAt(T)===l;)T++;let _=u.length;for(;_-1>T&&u.charCodeAt(_-1)===l;)_--;const U=_-T;let M=0;for(;M<s.length&&s.charCodeAt(M)===l;)M++;let D=s.length;for(;D-1>M&&s.charCodeAt(D-1)===l;)D--;const k=D-M,P=U<k?U:k;let j=-1,B=0;for(;B<P;B++){const O=u.charCodeAt(T+B);if(O!==s.charCodeAt(M+B))break;O===l&&(j=B)}if(B!==P){if(j===-1)return h}else{if(k>P){if(s.charCodeAt(M+B)===l)return h.slice(M+B+1);if(B===2)return h.slice(M+B)}U>P&&(u.charCodeAt(T+B)===l?j=B:B===2&&(j=3)),j===-1&&(j=0)}let Z="";for(B=T+j+1;B<=_;++B)(B===_||u.charCodeAt(B)===l)&&(Z+=Z.length===0?"..":"\\..");return M+=j,Z.length>0?`${Z}${h.slice(M,D)}`:(h.charCodeAt(M)===l&&++M,h.slice(M,D))},toNamespacedPath(u){if(typeof u!="string"||u.length===0)return u;const s=i.$fc.resolve(u);if(s.length<=2)return u;if(s.charCodeAt(0)===l){if(s.charCodeAt(1)===l){const o=s.charCodeAt(2);if(o!==$&&o!==d)return`\\\\?\\UNC\\${s.slice(2)}`}}else if(A(s.charCodeAt(0))&&s.charCodeAt(1)===f&&s.charCodeAt(2)===l)return`\\\\?\\${s}`;return u},dirname(u){e(u,"path");const s=u.length;if(s===0)return".";let o=-1,h=0;const T=u.charCodeAt(0);if(s===1)return E(T)?u:".";if(E(T)){if(o=h=1,E(u.charCodeAt(1))){let M=2,D=M;for(;M<s&&!E(u.charCodeAt(M));)M++;if(M<s&&M!==D){for(D=M;M<s&&E(u.charCodeAt(M));)M++;if(M<s&&M!==D){for(D=M;M<s&&!E(u.charCodeAt(M));)M++;if(M===s)return u;M!==D&&(o=h=M+1)}}}}else A(T)&&u.charCodeAt(1)===f&&(o=s>2&&E(u.charCodeAt(2))?3:2,h=o);let _=-1,U=!0;for(let M=s-1;M>=h;--M)if(E(u.charCodeAt(M))){if(!U){_=M;break}}else U=!1;if(_===-1){if(o===-1)return".";_=o}return u.slice(0,_)},basename(u,s){s!==void 0&&e(s,"ext"),e(u,"path");let o=0,h=-1,T=!0,_;if(u.length>=2&&A(u.charCodeAt(0))&&u.charCodeAt(1)===f&&(o=2),s!==void 0&&s.length>0&&s.length<=u.length){if(s===u)return"";let U=s.length-1,M=-1;for(_=u.length-1;_>=o;--_){const D=u.charCodeAt(_);if(E(D)){if(!T){o=_+1;break}}else M===-1&&(T=!1,M=_+1),U>=0&&(D===s.charCodeAt(U)?--U===-1&&(h=_):(U=-1,h=M))}return o===h?h=M:h===-1&&(h=u.length),u.slice(o,h)}for(_=u.length-1;_>=o;--_)if(E(u.charCodeAt(_))){if(!T){o=_+1;break}}else h===-1&&(T=!1,h=_+1);return h===-1?"":u.slice(o,h)},extname(u){e(u,"path");let s=0,o=-1,h=0,T=-1,_=!0,U=0;u.length>=2&&u.charCodeAt(1)===f&&A(u.charCodeAt(0))&&(s=h=2);for(let M=u.length-1;M>=s;--M){const D=u.charCodeAt(M);if(E(D)){if(!_){h=M+1;break}continue}T===-1&&(_=!1,T=M+1),D===d?o===-1?o=M:U!==1&&(U=1):o!==-1&&(U=-1)}return o===-1||T===-1||U===0||U===1&&o===T-1&&o===h+1?"":u.slice(o,T)},format:N.bind(null,"\\"),parse(u){e(u,"path");const s={root:"",dir:"",base:"",ext:"",name:""};if(u.length===0)return s;const o=u.length;let h=0,T=u.charCodeAt(0);if(o===1)return E(T)?(s.root=s.dir=u,s):(s.base=s.name=u,s);if(E(T)){if(h=1,E(u.charCodeAt(1))){let j=2,B=j;for(;j<o&&!E(u.charCodeAt(j));)j++;if(j<o&&j!==B){for(B=j;j<o&&E(u.charCodeAt(j));)j++;if(j<o&&j!==B){for(B=j;j<o&&!E(u.charCodeAt(j));)j++;j===o?h=j:j!==B&&(h=j+1)}}}}else if(A(T)&&u.charCodeAt(1)===f){if(o<=2)return s.root=s.dir=u,s;if(h=2,E(u.charCodeAt(2))){if(o===3)return s.root=s.dir=u,s;h=3}}h>0&&(s.root=u.slice(0,h));let _=-1,U=h,M=-1,D=!0,k=u.length-1,P=0;for(;k>=h;--k){if(T=u.charCodeAt(k),E(T)){if(!D){U=k+1;break}continue}M===-1&&(D=!1,M=k+1),T===d?_===-1?_=k:P!==1&&(P=1):_!==-1&&(P=-1)}return M!==-1&&(_===-1||P===0||P===1&&_===M-1&&_===U+1?s.base=s.name=u.slice(U,M):(s.name=u.slice(U,_),s.base=u.slice(U,M),s.ext=u.slice(_,M))),U>0&&U!==h?s.dir=u.slice(0,U-1):s.dir=s.root,s},sep:"\\",delimiter:";",win32:null,posix:null};const c=(()=>{if(m){const u=/\\/g;return()=>{const s=t.cwd().replace(u,"/");return s.slice(s.indexOf("/"))}}return()=>t.cwd()})();i.$gc={resolve(...u){let s="",o=!1;for(let h=u.length-1;h>=-1&&!o;h--){const T=h>=0?u[h]:c();e(T,"path"),T.length!==0&&(s=`${T}/${s}`,o=T.charCodeAt(0)===a)}return s=w(s,!o,"/",R),o?`/${s}`:s.length>0?s:"."},normalize(u){if(e(u,"path"),u.length===0)return".";const s=u.charCodeAt(0)===a,o=u.charCodeAt(u.length-1)===a;return u=w(u,!s,"/",R),u.length===0?s?"/":o?"./":".":(o&&(u+="/"),s?`/${u}`:u)},isAbsolute(u){return e(u,"path"),u.length>0&&u.charCodeAt(0)===a},join(...u){if(u.length===0)return".";let s;for(let o=0;o<u.length;++o){const h=u[o];e(h,"path"),h.length>0&&(s===void 0?s=h:s+=`/${h}`)}return s===void 0?".":i.$gc.normalize(s)},relative(u,s){if(e(u,"from"),e(s,"to"),u===s||(u=i.$gc.resolve(u),s=i.$gc.resolve(s),u===s))return"";const o=1,h=u.length,T=h-o,_=1,U=s.length-_,M=T<U?T:U;let D=-1,k=0;for(;k<M;k++){const j=u.charCodeAt(o+k);if(j!==s.charCodeAt(_+k))break;j===a&&(D=k)}if(k===M)if(U>M){if(s.charCodeAt(_+k)===a)return s.slice(_+k+1);if(k===0)return s.slice(_+k)}else T>M&&(u.charCodeAt(o+k)===a?D=k:k===0&&(D=0));let P="";for(k=o+D+1;k<=h;++k)(k===h||u.charCodeAt(k)===a)&&(P+=P.length===0?"..":"/..");return`${P}${s.slice(_+D)}`},toNamespacedPath(u){return u},dirname(u){if(e(u,"path"),u.length===0)return".";const s=u.charCodeAt(0)===a;let o=-1,h=!0;for(let T=u.length-1;T>=1;--T)if(u.charCodeAt(T)===a){if(!h){o=T;break}}else h=!1;return o===-1?s?"/":".":s&&o===1?"//":u.slice(0,o)},basename(u,s){s!==void 0&&e(s,"ext"),e(u,"path");let o=0,h=-1,T=!0,_;if(s!==void 0&&s.length>0&&s.length<=u.length){if(s===u)return"";let U=s.length-1,M=-1;for(_=u.length-1;_>=0;--_){const D=u.charCodeAt(_);if(D===a){if(!T){o=_+1;break}}else M===-1&&(T=!1,M=_+1),U>=0&&(D===s.charCodeAt(U)?--U===-1&&(h=_):(U=-1,h=M))}return o===h?h=M:h===-1&&(h=u.length),u.slice(o,h)}for(_=u.length-1;_>=0;--_)if(u.charCodeAt(_)===a){if(!T){o=_+1;break}}else h===-1&&(T=!1,h=_+1);return h===-1?"":u.slice(o,h)},extname(u){e(u,"path");let s=-1,o=0,h=-1,T=!0,_=0;for(let U=u.length-1;U>=0;--U){const M=u.charCodeAt(U);if(M===a){if(!T){o=U+1;break}continue}h===-1&&(T=!1,h=U+1),M===d?s===-1?s=U:_!==1&&(_=1):s!==-1&&(_=-1)}return s===-1||h===-1||_===0||_===1&&s===h-1&&s===o+1?"":u.slice(s,h)},format:N.bind(null,"/"),parse(u){e(u,"path");const s={root:"",dir:"",base:"",ext:"",name:""};if(u.length===0)return s;const o=u.charCodeAt(0)===a;let h;o?(s.root="/",h=1):h=0;let T=-1,_=0,U=-1,M=!0,D=u.length-1,k=0;for(;D>=h;--D){const P=u.charCodeAt(D);if(P===a){if(!M){_=D+1;break}continue}U===-1&&(M=!1,U=D+1),P===d?T===-1?T=D:k!==1&&(k=1):T!==-1&&(k=-1)}if(U!==-1){const P=_===0&&o?1:_;T===-1||k===0||k===1&&T===U-1&&T===_+1?s.base=s.name=u.slice(P,U):(s.name=u.slice(P,T),s.base=u.slice(P,U),s.ext=u.slice(T,U))}return _>0?s.dir=u.slice(0,_-1):o&&(s.dir="/"),s},sep:"/",delimiter:":",win32:null,posix:null},i.$gc.win32=i.$fc.win32=i.$fc,i.$gc.posix=i.$fc.posix=i.$gc,i.$hc=m?i.$fc.normalize:i.$gc.normalize,i.$ic=m?i.$fc.isAbsolute:i.$gc.isAbsolute,i.$jc=m?i.$fc.join:i.$gc.join,i.$kc=m?i.$fc.resolve:i.$gc.resolve,i.$lc=m?i.$fc.relative:i.$gc.relative,i.$mc=m?i.$fc.dirname:i.$gc.dirname,i.$nc=m?i.$fc.basename:i.$gc.basename,i.$oc=m?i.$fc.extname:i.$gc.extname,i.$pc=m?i.$fc.format:i.$gc.format,i.$qc=m?i.$fc.parse:i.$gc.parse,i.$rc=m?i.$fc.toNamespacedPath:i.$gc.toNamespacedPath,i.sep=m?i.$fc.sep:i.$gc.sep,i.$tc=m?i.$fc.delimiter:i.$gc.delimiter}),ne(ie[21],re([0,1,3,42,74,20]),function(q,i,t,n,p,g){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.URI=void 0,i.$vc=E,i.$wc=u;const v=/^\w[\w\d+.-]*$/,d=/^\//,a=/^\/\//;function l(_,U){if(!_.scheme&&U)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${_.authority}", path: "${_.path}", query: "${_.query}", fragment: "${_.fragment}"}`);if(_.scheme&&!v.test(_.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(_.path){if(_.authority){if(!d.test(_.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(a.test(_.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function f(_,U){return!_&&!U?"file":_}function $(_,U){switch(_){case"https":case"http":case"file":U?U[0]!==L&&(U=L+U):U=L;break}return U}const b="",L="/",e=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class m{static isUri(U){return U instanceof m?!0:U?typeof U.authority=="string"&&typeof U.fragment=="string"&&typeof U.path=="string"&&typeof U.query=="string"&&typeof U.scheme=="string"&&typeof U.fsPath=="string"&&typeof U.with=="function"&&typeof U.toString=="function":!1}constructor(U,M,D,k,P,j=!1){typeof U=="object"?(this.scheme=U.scheme||b,this.authority=U.authority||b,this.path=U.path||b,this.query=U.query||b,this.fragment=U.fragment||b):(this.scheme=f(U,j),this.authority=M||b,this.path=$(this.scheme,D||b),this.query=k||b,this.fragment=P||b,l(this,j))}get fsPath(){return u(this,!1)}with(U){if(!U)return this;let{scheme:M,authority:D,path:k,query:P,fragment:j}=U;return M===void 0?M=this.scheme:M===null&&(M=b),D===void 0?D=this.authority:D===null&&(D=b),k===void 0?k=this.path:k===null&&(k=b),P===void 0?P=this.query:P===null&&(P=b),j===void 0?j=this.fragment:j===null&&(j=b),M===this.scheme&&D===this.authority&&k===this.path&&P===this.query&&j===this.fragment?this:new A(M,D,k,P,j)}static parse(U,M=!1){const D=e.exec(U);return D?new A(D[2]||b,T(D[4]||b),T(D[5]||b),T(D[7]||b),T(D[9]||b),M):new A(b,b,b,b,b)}static file(U){let M=b;if(g.$i&&(U=U.replace(/\\/g,L)),U[0]===L&&U[1]===L){const D=U.indexOf(L,2);D===-1?(M=U.substring(2),U=L):(M=U.substring(2,D),U=U.substring(D)||L)}return new A("file",M,U,b,b)}static from(U,M){return new A(U.scheme,U.authority,U.path,U.query,U.fragment,M)}static joinPath(U,...M){if(!U.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let D;return g.$i&&U.scheme==="file"?D=m.file(p.$fc.join(u(U,!0),...M)).path:D=p.$gc.join(U.path,...M),U.with({path:D})}toString(U=!1){return s(this,U)}toJSON(){return this}static revive(U){if(U){if(U instanceof m)return U;{const M=new A(U);return M._formatted=U.external??null,M._fsPath=U._sep===R?U.fsPath??null:null,M}}else return U}}i.URI=m;function E(_){return!_||typeof _!="object"?!1:typeof _.scheme=="string"&&(typeof _.authority=="string"||typeof _.authority>"u")&&(typeof _.path=="string"||typeof _.path>"u")&&(typeof _.query=="string"||typeof _.query>"u")&&(typeof _.fragment=="string"||typeof _.fragment>"u")}const R=g.$i?1:void 0;class A extends m{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=u(this,!1)),this._fsPath}toString(U=!1){return U?s(this,!0):(this._formatted||(this._formatted=s(this,!1)),this._formatted)}toJSON(){const U={$mid:n.MarshalledId.Uri};return this._fsPath&&(U.fsPath=this._fsPath,U._sep=R),this._formatted&&(U.external=this._formatted),this.path&&(U.path=this.path),this.scheme&&(U.scheme=this.scheme),this.authority&&(U.authority=this.authority),this.query&&(U.query=this.query),this.fragment&&(U.fragment=this.fragment),U}}const w={[t.CharCode.Colon]:"%3A",[t.CharCode.Slash]:"%2F",[t.CharCode.QuestionMark]:"%3F",[t.CharCode.Hash]:"%23",[t.CharCode.OpenSquareBracket]:"%5B",[t.CharCode.CloseSquareBracket]:"%5D",[t.CharCode.AtSign]:"%40",[t.CharCode.ExclamationMark]:"%21",[t.CharCode.DollarSign]:"%24",[t.CharCode.Ampersand]:"%26",[t.CharCode.SingleQuote]:"%27",[t.CharCode.OpenParen]:"%28",[t.CharCode.CloseParen]:"%29",[t.CharCode.Asterisk]:"%2A",[t.CharCode.Plus]:"%2B",[t.CharCode.Comma]:"%2C",[t.CharCode.Semicolon]:"%3B",[t.CharCode.Equals]:"%3D",[t.CharCode.Space]:"%20"};function N(_,U,M){let D,k=-1;for(let P=0;P<_.length;P++){const j=_.charCodeAt(P);if(j>=t.CharCode.a&&j<=t.CharCode.z||j>=t.CharCode.A&&j<=t.CharCode.Z||j>=t.CharCode.Digit0&&j<=t.CharCode.Digit9||j===t.CharCode.Dash||j===t.CharCode.Period||j===t.CharCode.Underline||j===t.CharCode.Tilde||U&&j===t.CharCode.Slash||M&&j===t.CharCode.OpenSquareBracket||M&&j===t.CharCode.CloseSquareBracket||M&&j===t.CharCode.Colon)k!==-1&&(D+=encodeURIComponent(_.substring(k,P)),k=-1),D!==void 0&&(D+=_.charAt(P));else{D===void 0&&(D=_.substr(0,P));const B=w[j];B!==void 0?(k!==-1&&(D+=encodeURIComponent(_.substring(k,P)),k=-1),D+=B):k===-1&&(k=P)}}return k!==-1&&(D+=encodeURIComponent(_.substring(k))),D!==void 0?D:_}function c(_){let U;for(let M=0;M<_.length;M++){const D=_.charCodeAt(M);D===t.CharCode.Hash||D===t.CharCode.QuestionMark?(U===void 0&&(U=_.substr(0,M)),U+=w[D]):U!==void 0&&(U+=_[M])}return U!==void 0?U:_}function u(_,U){let M;return _.authority&&_.path.length>1&&_.scheme==="file"?M=`//${_.authority}${_.path}`:_.path.charCodeAt(0)===t.CharCode.Slash&&(_.path.charCodeAt(1)>=t.CharCode.A&&_.path.charCodeAt(1)<=t.CharCode.Z||_.path.charCodeAt(1)>=t.CharCode.a&&_.path.charCodeAt(1)<=t.CharCode.z)&&_.path.charCodeAt(2)===t.CharCode.Colon?U?M=_.path.substr(1):M=_.path[1].toLowerCase()+_.path.substr(2):M=_.path,g.$i&&(M=M.replace(/\//g,"\\")),M}function s(_,U){const M=U?c:N;let D="",{scheme:k,authority:P,path:j,query:B,fragment:Z}=_;if(k&&(D+=k,D+=":"),(P||k==="file")&&(D+=L,D+=L),P){let O=P.indexOf("@");if(O!==-1){const S=P.substr(0,O);P=P.substr(O+1),O=S.lastIndexOf(":"),O===-1?D+=M(S,!1,!1):(D+=M(S.substr(0,O),!1,!1),D+=":",D+=M(S.substr(O+1),!1,!0)),D+="@"}P=P.toLowerCase(),O=P.lastIndexOf(":"),O===-1?D+=M(P,!1,!0):(D+=M(P.substr(0,O),!1,!0),D+=P.substr(O))}if(j){if(j.length>=3&&j.charCodeAt(0)===t.CharCode.Slash&&j.charCodeAt(2)===t.CharCode.Colon){const O=j.charCodeAt(1);O>=t.CharCode.A&&O<=t.CharCode.Z&&(j=`/${String.fromCharCode(O+32)}:${j.substr(3)}`)}else if(j.length>=2&&j.charCodeAt(1)===t.CharCode.Colon){const O=j.charCodeAt(0);O>=t.CharCode.A&&O<=t.CharCode.Z&&(j=`${String.fromCharCode(O+32)}:${j.substr(2)}`)}D+=M(j,!0,!1)}return B&&(D+="?",D+=M(B,!1,!1)),Z&&(D+="#",D+=U?Z:N(Z,!1,!1)),D}function o(_){try{return decodeURIComponent(_)}catch{return _.length>3?_.substr(0,3)+o(_.substr(3)):_}}const h=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function T(_){return _.match(h)?_.replace(h,U=>o(U)):_}}),ne(ie[79],re([0,1,4,13,12,17,20,8]),function(q,i,t,n,p,g,v,d){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.SimpleWorkerServer=i.SimpleWorkerClient=void 0,i.logOnceWebWorkerWarning=f,i.create=s;const a="$initialize";let l=!1;function f(o){v.$o&&(l||(l=!0,console.warn("Could not create web worker(s). Falling back to loading web worker code in main thread, which might cause UI freezes. Please see https://github.com/microsoft/monaco-editor#faq")),console.warn(o.message))}var $;(function(o){o[o.Request=0]="Request",o[o.Reply=1]="Reply",o[o.SubscribeEvent=2]="SubscribeEvent",o[o.Event=3]="Event",o[o.UnsubscribeEvent=4]="UnsubscribeEvent"})($||($={}));class b{constructor(h,T,_,U){this.vsWorker=h,this.req=T,this.method=_,this.args=U,this.type=$.Request}}class L{constructor(h,T,_,U){this.vsWorker=h,this.seq=T,this.res=_,this.err=U,this.type=$.Reply}}class e{constructor(h,T,_,U){this.vsWorker=h,this.req=T,this.eventName=_,this.arg=U,this.type=$.SubscribeEvent}}class m{constructor(h,T,_){this.vsWorker=h,this.req=T,this.event=_,this.type=$.Event}}class E{constructor(h,T){this.vsWorker=h,this.req=T,this.type=$.UnsubscribeEvent}}class R{constructor(h){this.a=-1,this.g=h,this.b=0,this.c=Object.create(null),this.d=new Map,this.f=new Map}setWorkerId(h){this.a=h}sendMessage(h,T){const _=String(++this.b);return new Promise((U,M)=>{this.c[_]={resolve:U,reject:M},this.o(new b(this.a,_,h,T))})}listen(h,T){let _=null;const U=new n.$he({onWillAddFirstListener:()=>{_=String(++this.b),this.d.set(_,U),this.o(new e(this.a,_,h,T))},onDidRemoveLastListener:()=>{this.d.delete(_),this.o(new E(this.a,_)),_=null}});return U.event}handleMessage(h){!h||!h.vsWorker||this.a!==-1&&h.vsWorker!==this.a||this.h(h)}h(h){switch(h.type){case $.Reply:return this.j(h);case $.Request:return this.k(h);case $.SubscribeEvent:return this.l(h);case $.Event:return this.m(h);case $.UnsubscribeEvent:return this.n(h)}}j(h){if(!this.c[h.seq]){console.warn("Got reply to unknown seq");return}const T=this.c[h.seq];if(delete this.c[h.seq],h.err){let _=h.err;h.err.$isError&&(_=new Error,_.name=h.err.name,_.message=h.err.message,_.stack=h.err.stack),T.reject(_);return}T.resolve(h.res)}k(h){const T=h.req;this.g.handleMessage(h.method,h.args).then(U=>{this.o(new L(this.a,T,U,void 0))},U=>{U.detail instanceof Error&&(U.detail=(0,t.$3)(U.detail)),this.o(new L(this.a,T,void 0,(0,t.$3)(U)))})}l(h){const T=h.req,_=this.g.handleEvent(h.eventName,h.arg)(U=>{this.o(new m(this.a,T,U))});this.f.set(T,_)}m(h){if(!this.d.has(h.req)){console.warn("Got event for unknown req");return}this.d.get(h.req).fire(h.event)}n(h){if(!this.f.has(h.req)){console.warn("Got unsubscribe for unknown req");return}this.f.get(h.req).dispose(),this.f.delete(h.req)}o(h){const T=[];if(h.type===$.Request)for(let _=0;_<h.args.length;_++)h.args[_]instanceof ArrayBuffer&&T.push(h.args[_]);else h.type===$.Reply&&h.res instanceof ArrayBuffer&&T.push(h.res);this.g.sendMessage(h,T)}}class A extends p.$Uc{constructor(h,T,_){super();let U=null;this.a=this.B(h.create("vs/base/common/worker/simpleWorker",B=>{this.c.handleMessage(B)},B=>{U?.(B)})),this.c=new R({sendMessage:(B,Z)=>{this.a.postMessage(B,Z)},handleMessage:(B,Z)=>{if(typeof _[B]!="function")return Promise.reject(new Error("Missing method "+B+" on main thread host."));try{return Promise.resolve(_[B].apply(_,Z))}catch(O){return Promise.reject(O)}},handleEvent:(B,Z)=>{if(N(B)){const O=_[B].call(_,Z);if(typeof O!="function")throw new Error(`Missing dynamic event ${B} on main thread host.`);return O}if(w(B)){const O=_[B];if(typeof O!="function")throw new Error(`Missing event ${B} on main thread host.`);return O}throw new Error(`Malformed event name ${B}`)}}),this.c.setWorkerId(this.a.getId());let M=null;const D=globalThis.require;typeof D<"u"&&typeof D.getConfig=="function"?M=D.getConfig():typeof globalThis.requirejs<"u"&&(M=globalThis.requirejs.s.contexts._.config);const k=(0,g.$go)(_);this.b=this.c.sendMessage(a,[this.a.getId(),JSON.parse(JSON.stringify(M)),T,k]);const P=(B,Z)=>this.g(B,Z),j=(B,Z)=>this.c.listen(B,Z);this.f=new Promise((B,Z)=>{U=Z,this.b.then(O=>{B(c(O,P,j))},O=>{Z(O),this.h("Worker failed to load "+T,O)})})}getProxyObject(){return this.f}g(h,T){return new Promise((_,U)=>{this.b.then(()=>{this.c.sendMessage(h,T).then(_,U)},U)})}h(h,T){console.error(h),console.info(T)}}i.SimpleWorkerClient=A;function w(o){return o[0]==="o"&&o[1]==="n"&&d.$Af(o.charCodeAt(2))}function N(o){return/^onDynamic/.test(o)&&d.$Af(o.charCodeAt(9))}function c(o,h,T){const _=D=>function(){const k=Array.prototype.slice.call(arguments,0);return h(D,k)},U=D=>function(k){return T(D,k)},M={};for(const D of o){if(N(D)){M[D]=U(D);continue}if(w(D)){M[D]=T(D,void 0);continue}M[D]=_(D)}return M}class u{constructor(h,T){this.a=T,this.b=null,this.c=new R({sendMessage:(_,U)=>{h(_,U)},handleMessage:(_,U)=>this.d(_,U),handleEvent:(_,U)=>this.f(_,U)})}onmessage(h){this.c.handleMessage(h)}d(h,T){if(h===a)return this.g(T[0],T[1],T[2],T[3]);if(!this.b||typeof this.b[h]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+h));try{return Promise.resolve(this.b[h].apply(this.b,T))}catch(_){return Promise.reject(_)}}f(h,T){if(!this.b)throw new Error("Missing requestHandler");if(N(h)){const _=this.b[h].call(this.b,T);if(typeof _!="function")throw new Error(`Missing dynamic event ${h} on request handler.`);return _}if(w(h)){const _=this.b[h];if(typeof _!="function")throw new Error(`Missing event ${h} on request handler.`);return _}throw new Error(`Malformed event name ${h}`)}g(h,T,_,U){this.c.setWorkerId(h);const k=c(U,(P,j)=>this.c.sendMessage(P,j),(P,j)=>this.c.listen(P,j));return this.a?(this.b=this.a(k),Promise.resolve((0,g.$go)(this.b))):(T&&(typeof T.baseUrl<"u"&&delete T.baseUrl,typeof T.paths<"u"&&typeof T.paths.vs<"u"&&delete T.paths.vs,typeof T.trustedTypesPolicy<"u"&&delete T.trustedTypesPolicy,T.catchError=!0,globalThis.require.config(T)),new Promise((P,j)=>{(globalThis.require||q)([_],Z=>{if(this.b=Z.create(k),!this.b){j(new Error("No RequestHandler!"));return}P((0,g.$go)(this.b))},j)}))}}i.SimpleWorkerServer=u;function s(o){return new u(o,null)}}),ne(ie[75],re([71,72]),function(q,i){return q.create("vs/editor/common/languages",i)}),ne(ie[76],re([0,1,45,21,47,2,69,75]),function(q,i,t,n,p,g,v,d){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.InlineEditTriggerKind=i.ExternalUriOpenerPriority=i.$Qv=i.$Pv=i.InlayHintKind=i.CommentState=i.CommentMode=i.CommentThreadApplicability=i.CommentThreadState=i.CommentThreadCollapsibleState=i.Command=i.NewSymbolNameTriggerKind=i.NewSymbolNameTag=i.$Ov=i.$Nv=i.SymbolKinds=i.SymbolTag=i.$Lv=i.SymbolKind=i.DocumentHighlightKind=i.SignatureHelpTriggerKind=i.DocumentPasteTriggerKind=i.CodeActionTriggerType=i.$Jv=i.InlineCompletionTriggerKind=i.CompletionTriggerKind=i.PartialAcceptTriggerKind=i.CompletionItemInsertTextRule=i.CompletionItemTag=i.CompletionItemKinds=i.CompletionItemKind=i.HoverVerbosityAction=i.$Iv=i.$Hv=i.$Gv=void 0,i.$Kv=o,i.$Mv=T;class a{constructor(z,fe,oe){this.offset=z,this.type=fe,this.language=oe,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}i.$Gv=a;class l{constructor(z,fe){this.tokens=z,this.endState=fe,this._tokenizationResultBrand=void 0}}i.$Hv=l;class f{constructor(z,fe){this.tokens=z,this.endState=fe,this._encodedTokenizationResultBrand=void 0}}i.$Iv=f;var $;(function(F){F[F.Increase=0]="Increase",F[F.Decrease=1]="Decrease"})($||(i.HoverVerbosityAction=$={}));var b;(function(F){F[F.Method=0]="Method",F[F.Function=1]="Function",F[F.Constructor=2]="Constructor",F[F.Field=3]="Field",F[F.Variable=4]="Variable",F[F.Class=5]="Class",F[F.Struct=6]="Struct",F[F.Interface=7]="Interface",F[F.Module=8]="Module",F[F.Property=9]="Property",F[F.Event=10]="Event",F[F.Operator=11]="Operator",F[F.Unit=12]="Unit",F[F.Value=13]="Value",F[F.Constant=14]="Constant",F[F.Enum=15]="Enum",F[F.EnumMember=16]="EnumMember",F[F.Keyword=17]="Keyword",F[F.Text=18]="Text",F[F.Color=19]="Color",F[F.File=20]="File",F[F.Reference=21]="Reference",F[F.Customcolor=22]="Customcolor",F[F.Folder=23]="Folder",F[F.TypeParameter=24]="TypeParameter",F[F.User=25]="User",F[F.Issue=26]="Issue",F[F.Snippet=27]="Snippet"})(b||(i.CompletionItemKind=b={}));var L;(function(F){const z=new Map;z.set(b.Method,t.$Zj.symbolMethod),z.set(b.Function,t.$Zj.symbolFunction),z.set(b.Constructor,t.$Zj.symbolConstructor),z.set(b.Field,t.$Zj.symbolField),z.set(b.Variable,t.$Zj.symbolVariable),z.set(b.Class,t.$Zj.symbolClass),z.set(b.Struct,t.$Zj.symbolStruct),z.set(b.Interface,t.$Zj.symbolInterface),z.set(b.Module,t.$Zj.symbolModule),z.set(b.Property,t.$Zj.symbolProperty),z.set(b.Event,t.$Zj.symbolEvent),z.set(b.Operator,t.$Zj.symbolOperator),z.set(b.Unit,t.$Zj.symbolUnit),z.set(b.Value,t.$Zj.symbolValue),z.set(b.Enum,t.$Zj.symbolEnum),z.set(b.Constant,t.$Zj.symbolConstant),z.set(b.Enum,t.$Zj.symbolEnum),z.set(b.EnumMember,t.$Zj.symbolEnumMember),z.set(b.Keyword,t.$Zj.symbolKeyword),z.set(b.Snippet,t.$Zj.symbolSnippet),z.set(b.Text,t.$Zj.symbolText),z.set(b.Color,t.$Zj.symbolColor),z.set(b.File,t.$Zj.symbolFile),z.set(b.Reference,t.$Zj.symbolReference),z.set(b.Customcolor,t.$Zj.symbolCustomColor),z.set(b.Folder,t.$Zj.symbolFolder),z.set(b.TypeParameter,t.$Zj.symbolTypeParameter),z.set(b.User,t.$Zj.account),z.set(b.Issue,t.$Zj.issues);function fe(r){let Te=z.get(r);return Te||(console.info("No codicon found for CompletionItemKind "+r),Te=t.$Zj.symbolProperty),Te}F.toIcon=fe;const oe=new Map;oe.set("method",b.Method),oe.set("function",b.Function),oe.set("constructor",b.Constructor),oe.set("field",b.Field),oe.set("variable",b.Variable),oe.set("class",b.Class),oe.set("struct",b.Struct),oe.set("interface",b.Interface),oe.set("module",b.Module),oe.set("property",b.Property),oe.set("event",b.Event),oe.set("operator",b.Operator),oe.set("unit",b.Unit),oe.set("value",b.Value),oe.set("constant",b.Constant),oe.set("enum",b.Enum),oe.set("enum-member",b.EnumMember),oe.set("enumMember",b.EnumMember),oe.set("keyword",b.Keyword),oe.set("snippet",b.Snippet),oe.set("text",b.Text),oe.set("color",b.Color),oe.set("file",b.File),oe.set("reference",b.Reference),oe.set("customcolor",b.Customcolor),oe.set("folder",b.Folder),oe.set("type-parameter",b.TypeParameter),oe.set("typeParameter",b.TypeParameter),oe.set("account",b.User),oe.set("issue",b.Issue);function we(r,Te){let ke=oe.get(r);return typeof ke>"u"&&!Te&&(ke=b.Property),ke}F.fromString=we})(L||(i.CompletionItemKinds=L={}));var e;(function(F){F[F.Deprecated=1]="Deprecated"})(e||(i.CompletionItemTag=e={}));var m;(function(F){F[F.None=0]="None",F[F.KeepWhitespace=1]="KeepWhitespace",F[F.InsertAsSnippet=4]="InsertAsSnippet"})(m||(i.CompletionItemInsertTextRule=m={}));var E;(function(F){F[F.Word=0]="Word",F[F.Line=1]="Line",F[F.Suggest=2]="Suggest"})(E||(i.PartialAcceptTriggerKind=E={}));var R;(function(F){F[F.Invoke=0]="Invoke",F[F.TriggerCharacter=1]="TriggerCharacter",F[F.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(R||(i.CompletionTriggerKind=R={}));var A;(function(F){F[F.Automatic=0]="Automatic",F[F.Explicit=1]="Explicit"})(A||(i.InlineCompletionTriggerKind=A={}));class w{constructor(z,fe,oe,we){this.range=z,this.text=fe,this.completionKind=oe,this.isSnippetText=we}equals(z){return g.$ct.lift(this.range).equalsRange(z.range)&&this.text===z.text&&this.completionKind===z.completionKind&&this.isSnippetText===z.isSnippetText}}i.$Jv=w;var N;(function(F){F[F.Invoke=1]="Invoke",F[F.Auto=2]="Auto"})(N||(i.CodeActionTriggerType=N={}));var c;(function(F){F[F.Automatic=0]="Automatic",F[F.PasteAs=1]="PasteAs"})(c||(i.DocumentPasteTriggerKind=c={}));var u;(function(F){F[F.Invoke=1]="Invoke",F[F.TriggerCharacter=2]="TriggerCharacter",F[F.ContentChange=3]="ContentChange"})(u||(i.SignatureHelpTriggerKind=u={}));var s;(function(F){F[F.Text=0]="Text",F[F.Read=1]="Read",F[F.Write=2]="Write"})(s||(i.DocumentHighlightKind=s={}));function o(F){return F&&n.URI.isUri(F.uri)&&g.$ct.isIRange(F.range)&&(g.$ct.isIRange(F.originSelectionRange)||g.$ct.isIRange(F.targetSelectionRange))}var h;(function(F){F[F.File=0]="File",F[F.Module=1]="Module",F[F.Namespace=2]="Namespace",F[F.Package=3]="Package",F[F.Class=4]="Class",F[F.Method=5]="Method",F[F.Property=6]="Property",F[F.Field=7]="Field",F[F.Constructor=8]="Constructor",F[F.Enum=9]="Enum",F[F.Interface=10]="Interface",F[F.Function=11]="Function",F[F.Variable=12]="Variable",F[F.Constant=13]="Constant",F[F.String=14]="String",F[F.Number=15]="Number",F[F.Boolean=16]="Boolean",F[F.Array=17]="Array",F[F.Object=18]="Object",F[F.Key=19]="Key",F[F.Null=20]="Null",F[F.EnumMember=21]="EnumMember",F[F.Struct=22]="Struct",F[F.Event=23]="Event",F[F.Operator=24]="Operator",F[F.TypeParameter=25]="TypeParameter"})(h||(i.SymbolKind=h={})),i.$Lv={[h.Array]:(0,d.localize)(0,null),[h.Boolean]:(0,d.localize)(1,null),[h.Class]:(0,d.localize)(2,null),[h.Constant]:(0,d.localize)(3,null),[h.Constructor]:(0,d.localize)(4,null),[h.Enum]:(0,d.localize)(5,null),[h.EnumMember]:(0,d.localize)(6,null),[h.Event]:(0,d.localize)(7,null),[h.Field]:(0,d.localize)(8,null),[h.File]:(0,d.localize)(9,null),[h.Function]:(0,d.localize)(10,null),[h.Interface]:(0,d.localize)(11,null),[h.Key]:(0,d.localize)(12,null),[h.Method]:(0,d.localize)(13,null),[h.Module]:(0,d.localize)(14,null),[h.Namespace]:(0,d.localize)(15,null),[h.Null]:(0,d.localize)(16,null),[h.Number]:(0,d.localize)(17,null),[h.Object]:(0,d.localize)(18,null),[h.Operator]:(0,d.localize)(19,null),[h.Package]:(0,d.localize)(20,null),[h.Property]:(0,d.localize)(21,null),[h.String]:(0,d.localize)(22,null),[h.Struct]:(0,d.localize)(23,null),[h.TypeParameter]:(0,d.localize)(24,null),[h.Variable]:(0,d.localize)(25,null)};function T(F,z){return(0,d.localize)(26,null,F,i.$Lv[z])}var _;(function(F){F[F.Deprecated=1]="Deprecated"})(_||(i.SymbolTag=_={}));var U;(function(F){const z=new Map;z.set(h.File,t.$Zj.symbolFile),z.set(h.Module,t.$Zj.symbolModule),z.set(h.Namespace,t.$Zj.symbolNamespace),z.set(h.Package,t.$Zj.symbolPackage),z.set(h.Class,t.$Zj.symbolClass),z.set(h.Method,t.$Zj.symbolMethod),z.set(h.Property,t.$Zj.symbolProperty),z.set(h.Field,t.$Zj.symbolField),z.set(h.Constructor,t.$Zj.symbolConstructor),z.set(h.Enum,t.$Zj.symbolEnum),z.set(h.Interface,t.$Zj.symbolInterface),z.set(h.Function,t.$Zj.symbolFunction),z.set(h.Variable,t.$Zj.symbolVariable),z.set(h.Constant,t.$Zj.symbolConstant),z.set(h.String,t.$Zj.symbolString),z.set(h.Number,t.$Zj.symbolNumber),z.set(h.Boolean,t.$Zj.symbolBoolean),z.set(h.Array,t.$Zj.symbolArray),z.set(h.Object,t.$Zj.symbolObject),z.set(h.Key,t.$Zj.symbolKey),z.set(h.Null,t.$Zj.symbolNull),z.set(h.EnumMember,t.$Zj.symbolEnumMember),z.set(h.Struct,t.$Zj.symbolStruct),z.set(h.Event,t.$Zj.symbolEvent),z.set(h.Operator,t.$Zj.symbolOperator),z.set(h.TypeParameter,t.$Zj.symbolTypeParameter);function fe(oe){let we=z.get(oe);return we||(console.info("No codicon found for SymbolKind "+oe),we=t.$Zj.symbolProperty),we}F.toIcon=fe})(U||(i.SymbolKinds=U={}));class M{static asEditOperation(z){return p.$dt.replace(g.$ct.lift(z.range),z.text)}}i.$Nv=M;class D{static{this.Comment=new D("comment")}static{this.Imports=new D("imports")}static{this.Region=new D("region")}static fromValue(z){switch(z){case"comment":return D.Comment;case"imports":return D.Imports;case"region":return D.Region}return new D(z)}constructor(z){this.value=z}}i.$Ov=D;var k;(function(F){F[F.AIGenerated=1]="AIGenerated"})(k||(i.NewSymbolNameTag=k={}));var P;(function(F){F[F.Invoke=0]="Invoke",F[F.Automatic=1]="Automatic"})(P||(i.NewSymbolNameTriggerKind=P={}));var j;(function(F){function z(fe){return!fe||typeof fe!="object"?!1:typeof fe.id=="string"&&typeof fe.title=="string"}F.is=z})(j||(i.Command=j={}));var B;(function(F){F[F.Collapsed=0]="Collapsed",F[F.Expanded=1]="Expanded"})(B||(i.CommentThreadCollapsibleState=B={}));var Z;(function(F){F[F.Unresolved=0]="Unresolved",F[F.Resolved=1]="Resolved"})(Z||(i.CommentThreadState=Z={}));var O;(function(F){F[F.Current=0]="Current",F[F.Outdated=1]="Outdated"})(O||(i.CommentThreadApplicability=O={}));var S;(function(F){F[F.Editing=0]="Editing",F[F.Preview=1]="Preview"})(S||(i.CommentMode=S={}));var X;(function(F){F[F.Published=0]="Published",F[F.Draft=1]="Draft"})(X||(i.CommentState=X={}));var Y;(function(F){F[F.Type=1]="Type",F[F.Parameter=2]="Parameter"})(Y||(i.InlayHintKind=Y={}));class H{constructor(z){this.b=z,this.a=null}dispose(){this.a&&this.a.then(z=>{z&&z.dispose()})}get tokenizationSupport(){return this.a||(this.a=this.b()),this.a}}i.$Pv=H,i.$Qv=new v.$wv;var Q;(function(F){F[F.None=0]="None",F[F.Option=1]="Option",F[F.Default=2]="Default",F[F.Preferred=3]="Preferred"})(Q||(i.ExternalUriOpenerPriority=Q={}));var C;(function(F){F[F.Invoke=0]="Invoke",F[F.Automatic=1]="Automatic"})(C||(i.InlineEditTriggerKind=C={}))}),ne(ie[77],re([0,1,26,13,40,21,5,2,48,76,68]),function(q,i,t,n,p,g,v,d,a,l,f){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$U2=void 0,i.$V2=b;class ${static{this.CtrlCmd=p.KeyMod.CtrlCmd}static{this.Shift=p.KeyMod.Shift}static{this.Alt=p.KeyMod.Alt}static{this.WinCtrl=p.KeyMod.WinCtrl}static chord(e,m){return(0,p.$Mr)(e,m)}}i.$U2=$;function b(){return{editor:void 0,languages:void 0,CancellationTokenSource:t.$se,Emitter:n.$he,KeyCode:f.KeyCode,KeyMod:$,Position:v.$bt,Range:d.$ct,Selection:a.$et,SelectionDirection:f.SelectionDirection,MarkerSeverity:f.MarkerSeverity,MarkerTag:f.MarkerTag,Uri:g.URI,Token:l.$Gv}}}),ne(ie[80],re([0,1,29,21,5,2,64,32,60,61,77,25,67,36,57,17,4,59,66]),function(q,i,t,n,p,g,v,d,a,l,f,$,b,L,e,m,E,R,A){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.EditorSimpleWorker=void 0,i.create=c;class w extends v.$bw{get uri(){return this.d}get eol(){return this.g}getValue(){return this.getText()}findMatches(s){const o=[];for(let h=0;h<this.f.length;h++){const T=this.f[h],_=this.offsetAt(new p.$bt(h+1,1)),U=T.matchAll(s);for(const M of U)(M.index||M.index===0)&&(M.index=M.index+_),o.push(M)}return o}getLinesContent(){return this.f.slice(0)}getLineCount(){return this.f.length}getLineContent(s){return this.f[s-1]}getWordAtPosition(s,o){const h=(0,d.$vt)(s.column,(0,d.$tt)(o),this.f[s.lineNumber-1],0);return h?new g.$ct(s.lineNumber,h.startColumn,s.lineNumber,h.endColumn):null}getWordUntilPosition(s,o){const h=this.getWordAtPosition(s,o);return h?{word:this.f[s.lineNumber-1].substring(h.startColumn-1,s.column-1),startColumn:h.startColumn,endColumn:s.column}:{word:"",startColumn:s.column,endColumn:s.column}}words(s){const o=this.f,h=this.q.bind(this);let T=0,_="",U=0,M=[];return{*[Symbol.iterator](){for(;;)if(U<M.length){const D=_.substring(M[U].start,M[U].end);U+=1,yield D}else if(T<o.length)_=o[T],M=h(_,s),U=0,T+=1;else break}}}getLineWords(s,o){const h=this.f[s-1],T=this.q(h,o),_=[];for(const U of T)_.push({word:h.substring(U.start,U.end),startColumn:U.start+1,endColumn:U.end+1});return _}q(s,o){const h=[];let T;for(o.lastIndex=0;(T=o.exec(s))&&T[0].length!==0;)h.push({start:T.index,end:T.index+T[0].length});return h}getValueInRange(s){if(s=this.r(s),s.startLineNumber===s.endLineNumber)return this.f[s.startLineNumber-1].substring(s.startColumn-1,s.endColumn-1);const o=this.g,h=s.startLineNumber-1,T=s.endLineNumber-1,_=[];_.push(this.f[h].substring(s.startColumn-1));for(let U=h+1;U<T;U++)_.push(this.f[U]);return _.push(this.f[T].substring(0,s.endColumn-1)),_.join(o)}offsetAt(s){return s=this.s(s),this.l(),this.j.getPrefixSum(s.lineNumber-2)+(s.column-1)}positionAt(s){s=Math.floor(s),s=Math.max(0,s),this.l();const o=this.j.getIndexOf(s),h=this.f[o.index].length;return{lineNumber:1+o.index,column:1+Math.min(o.remainder,h)}}r(s){const o=this.s({lineNumber:s.startLineNumber,column:s.startColumn}),h=this.s({lineNumber:s.endLineNumber,column:s.endColumn});return o.lineNumber!==s.startLineNumber||o.column!==s.startColumn||h.lineNumber!==s.endLineNumber||h.column!==s.endColumn?{startLineNumber:o.lineNumber,startColumn:o.column,endLineNumber:h.lineNumber,endColumn:h.column}:s}s(s){if(!p.$bt.isIPosition(s))throw new Error("bad position");let{lineNumber:o,column:h}=s,T=!1;if(o<1)o=1,h=1,T=!0;else if(o>this.f.length)o=this.f.length,h=this.f[o-1].length+1,T=!0;else{const _=this.f[o-1].length+1;h<1?(h=1,T=!0):h>_&&(h=_,T=!0)}return T?{lineNumber:o,column:h}:s}}class N{constructor(s,o){this.d=s,this.f=Object.create(null),this.g=o,this.h=null}dispose(){this.f=Object.create(null)}j(s){return this.f[s]}k(){const s=[];return Object.keys(this.f).forEach(o=>s.push(this.f[o])),s}acceptNewModel(s){this.f[s.url]=new w(n.URI.parse(s.url),s.lines,s.EOL,s.versionId)}acceptModelChanged(s,o){if(!this.f[s])return;this.f[s].onEvents(o)}acceptRemovedModel(s){this.f[s]&&delete this.f[s]}async computeUnicodeHighlights(s,o,h){const T=this.j(s);return T?b.$P2.computeUnicodeHighlights(T,o,h):{ranges:[],hasMore:!1,ambiguousCharacterCount:0,invisibleCharacterCount:0,nonBasicAsciiCharacterCount:0}}async findSectionHeaders(s,o){const h=this.j(s);return h?(0,A.$h3)(h,o):[]}async computeDiff(s,o,h,T){const _=this.j(s),U=this.j(o);return!_||!U?null:N.l(_,U,h,T)}static l(s,o,h,T){const _=T==="advanced"?e.$f3.getDefault():e.$f3.getLegacy(),U=s.getLinesContent(),M=o.getLinesContent(),D=_.computeDiff(U,M,h),k=D.changes.length>0?!1:this.n(s,o);function P(j){return j.map(B=>[B.original.startLineNumber,B.original.endLineNumberExclusive,B.modified.startLineNumber,B.modified.endLineNumberExclusive,B.innerChanges?.map(Z=>[Z.originalRange.startLineNumber,Z.originalRange.startColumn,Z.originalRange.endLineNumber,Z.originalRange.endColumn,Z.modifiedRange.startLineNumber,Z.modifiedRange.startColumn,Z.modifiedRange.endLineNumber,Z.modifiedRange.endColumn])])}return{identical:k,quitEarly:D.hitTimeout,changes:P(D.changes),moves:D.moves.map(j=>[j.lineRangeMapping.original.startLineNumber,j.lineRangeMapping.original.endLineNumberExclusive,j.lineRangeMapping.modified.startLineNumber,j.lineRangeMapping.modified.endLineNumberExclusive,P(j.changes)])}}static n(s,o){const h=s.getLineCount(),T=o.getLineCount();if(h!==T)return!1;for(let _=1;_<=h;_++){const U=s.getLineContent(_),M=o.getLineContent(_);if(U!==M)return!1}return!0}async computeDirtyDiff(s,o,h){const T=this.j(s),_=this.j(o);if(!T||!_)return null;const U=T.getLinesContent(),M=_.getLinesContent();return new L.$8v(U,M,{shouldComputeCharChanges:!1,shouldPostProcessCharChanges:!1,shouldIgnoreTrimWhitespace:h,shouldMakePrettyDiff:!0,maxComputationTime:1e3}).computeDiff().changes}static{this.o=1e5}async computeMoreMinimalEdits(s,o,h){const T=this.j(s);if(!T)return o;const _=[];let U;o=o.slice(0).sort((D,k)=>{if(D.range&&k.range)return g.$ct.compareRangesUsingStarts(D.range,k.range);const P=D.range?0:1,j=k.range?0:1;return P-j});let M=0;for(let D=1;D<o.length;D++)g.$ct.getEndPosition(o[M].range).equals(g.$ct.getStartPosition(o[D].range))?(o[M].range=g.$ct.fromPositions(g.$ct.getStartPosition(o[M].range),g.$ct.getEndPosition(o[D].range)),o[M].text+=o[D].text):(M++,o[M]=o[D]);o.length=M+1;for(let{range:D,text:k,eol:P}of o){if(typeof P=="number"&&(U=P),g.$ct.isEmpty(D)&&!k)continue;const j=T.getValueInRange(D);if(k=k.replace(/\r\n|\n|\r/g,T.eol),j===k)continue;if(Math.max(k.length,j.length)>N.o){_.push({range:D,text:k});continue}const B=(0,t.$Tv)(j,k,h),Z=T.offsetAt(g.$ct.lift(D).getStartPosition());for(const O of B){const S=T.positionAt(Z+O.originalStart),X=T.positionAt(Z+O.originalStart+O.originalLength),Y={text:k.substr(O.modifiedStart,O.modifiedLength),range:{startLineNumber:S.lineNumber,startColumn:S.column,endLineNumber:X.lineNumber,endColumn:X.column}};T.getValueInRange(Y.range)!==Y.text&&_.push(Y)}}return typeof U=="number"&&_.push({eol:U,text:"",range:{startLineNumber:0,startColumn:0,endLineNumber:0,endColumn:0}}),_}computeHumanReadableDiff(s,o,h){const T=this.j(s);if(!T)return o;const _=[];let U;o=o.slice(0).sort((M,D)=>{if(M.range&&D.range)return g.$ct.compareRangesUsingStarts(M.range,D.range);const k=M.range?0:1,P=D.range?0:1;return k-P});for(let{range:M,text:D,eol:k}of o){let S=function(Y,H){return new p.$bt(Y.lineNumber+H.lineNumber-1,H.lineNumber===1?Y.column+H.column-1:H.column)},X=function(Y,H){const Q=[];for(let C=H.startLineNumber;C<=H.endLineNumber;C++){const F=Y[C-1];C===H.startLineNumber&&C===H.endLineNumber?Q.push(F.substring(H.startColumn-1,H.endColumn-1)):C===H.startLineNumber?Q.push(F.substring(H.startColumn-1)):C===H.endLineNumber?Q.push(F.substring(0,H.endColumn-1)):Q.push(F)}return Q};if(typeof k=="number"&&(U=k),g.$ct.isEmpty(M)&&!D)continue;const P=T.getValueInRange(M);if(D=D.replace(/\r\n|\n|\r/g,T.eol),P===D)continue;if(Math.max(D.length,P.length)>N.o){_.push({range:M,text:D});continue}const j=P.split(/\r\n|\n|\r/),B=D.split(/\r\n|\n|\r/),Z=e.$f3.getDefault().computeDiff(j,B,h),O=g.$ct.lift(M).getStartPosition();for(const Y of Z.changes)if(Y.innerChanges)for(const H of Y.innerChanges)_.push({range:g.$ct.fromPositions(S(O,H.originalRange.getStartPosition()),S(O,H.originalRange.getEndPosition())),text:X(B,H.modifiedRange).join(T.eol)});else throw new E.$cb("The experimental diff algorithm always produces inner changes")}return typeof U=="number"&&_.push({eol:U,text:"",range:{startLineNumber:0,startColumn:0,endLineNumber:0,endColumn:0}}),_}async computeLinks(s){const o=this.j(s);return o?(0,a.$S2)(o):null}async computeDefaultDocumentColors(s){const o=this.j(s);return o?(0,R.$g3)(o):null}static{this.p=1e4}async textualSuggest(s,o,h,T){const _=new $.$be,U=new RegExp(h,T),M=new Set;e:for(const D of s){const k=this.j(D);if(k){for(const P of k.words(U))if(!(P===o||!isNaN(Number(P)))&&(M.add(P),M.size>N.p))break e}}return{words:Array.from(M),duration:_.elapsed()}}async computeWordRanges(s,o,h,T){const _=this.j(s);if(!_)return Object.create(null);const U=new RegExp(h,T),M=Object.create(null);for(let D=o.startLineNumber;D<o.endLineNumber;D++){const k=_.getLineWords(D,U);for(const P of k){if(!isNaN(Number(P.word)))continue;let j=M[P.word];j||(j=[],M[P.word]=j),j.push({startLineNumber:D,startColumn:P.startColumn,endLineNumber:D,endColumn:P.endColumn})}}return M}async navigateValueSet(s,o,h,T,_){const U=this.j(s);if(!U)return null;const M=new RegExp(T,_);o.startColumn===o.endColumn&&(o={startLineNumber:o.startLineNumber,startColumn:o.startColumn,endLineNumber:o.endLineNumber,endColumn:o.endColumn+1});const D=U.getValueInRange(o),k=U.getWordAtPosition({lineNumber:o.startLineNumber,column:o.startColumn},M);if(!k)return null;const P=U.getValueInRange(k);return l.$T2.INSTANCE.navigateValueSet(o,D,k,P,h)}loadForeignModule(s,o,h){const T=(M,D)=>this.d.fhr(M,D),U={host:(0,m.$ho)(h,T),getMirrorModels:()=>this.k()};return this.g?(this.h=this.g(U,o),Promise.resolve((0,m.$go)(this.h))):new Promise((M,D)=>{q([s],k=>{this.h=k.create(U,o),M((0,m.$go)(this.h))},D)})}fmr(s,o){if(!this.h||typeof this.h[s]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+s));try{return Promise.resolve(this.h[s].apply(this.h,o))}catch(h){return Promise.reject(h)}}}i.EditorSimpleWorker=N;function c(u){return new N(u,null)}typeof importScripts=="function"&&(globalThis.monaco=(0,f.$V2)())})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/fd11ed87fdf1f8e46575e027644406f51f0666f6/core/vs/base/worker/workerMain.js.map
