/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var pe=["exports","require","vs/base/common/lifecycle","vs/base/common/event","vs/base/browser/dom","vs/base/common/platform","vs/base/common/errors","vs/css!vs/code/electron-sandbox/processExplorer/processExplorerMain","vs/base/common/keyCodes","vs/base/common/arrays","vs/base/common/types","vs/base/common/strings","vs/base/common/async","vs/nls!vs/code/electron-sandbox/processExplorer/processExplorerMain","vs/nls","vs/base/browser/ui/hover/hoverDelegateFactory","vs/base/browser/keyboardEvent","vs/base/common/uri","vs/base/common/charCode","vs/base/browser/browser","vs/base/common/scrollable","vs/base/common/codicons","vs/base/common/themables","vs/base/browser/mouseEvent","vs/base/browser/ui/widget","vs/base/browser/window","vs/base/common/lazy","vs/base/browser/event","vs/base/common/path","vs/base/common/observableInternal/debugName","vs/base/common/observableInternal/logging","vs/base/browser/touch","vs/base/browser/ui/hover/hoverDelegate2","vs/base/browser/ui/tree/tree","vs/base/common/decorators","vs/base/common/iterator","vs/base/common/observableInternal/base","vs/base/common/cancellation","vs/base/parts/sandbox/electron-sandbox/globals","vs/base/common/network","vs/base/browser/ui/list/list","vs/base/common/assert","vs/base/common/equals","vs/base/common/map","vs/base/common/numbers","vs/base/common/observableInternal/autorun","vs/base/common/observableInternal/derived","vs/base/common/range","vs/base/common/buffer","vs/base/common/codiconsUtil","vs/base/common/filters","vs/base/common/actions","vs/base/common/resources","vs/base/browser/ui/scrollbar/scrollbarArrow","vs/base/browser/ui/list/listWidget","vs/platform/instantiation/common/instantiation","vs/base/browser/fastDomNode","vs/base/browser/ui/scrollbar/scrollbarState","vs/base/common/functional","vs/base/common/linkedList","vs/base/common/marshallingIds","vs/base/common/observable","vs/base/common/symbols","vs/base/common/objects","vs/base/common/uint","vs/base/common/hash","vs/base/common/iconLabels","vs/css!vs/base/browser/ui/actionbar/actionbar","vs/base/browser/canIUse","vs/base/common/marshalling","vs/base/browser/dnd","vs/base/browser/formattedTextRenderer","vs/base/browser/globalPointerMoveMonitor","vs/base/browser/ui/aria/aria","vs/base/browser/ui/contextview/contextview","vs/base/browser/ui/tree/indexTreeModel","vs/base/browser/ui/scrollbar/abstractScrollbar","vs/base/browser/ui/scrollbar/scrollableElement","vs/base/browser/ui/list/listView","vs/base/browser/ui/actionbar/actionViewItems","vs/base/browser/ui/actionbar/actionbar","vs/base/browser/ui/inputbox/inputBox","vs/base/browser/ui/toggle/toggle","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/base/browser/iframe","vs/base/browser/ui/list/splice","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/color","vs/base/common/diff/diffChange","vs/base/common/idGenerator","vs/base/common/marked/marked","vs/base/common/naturalLanguage/korean","vs/base/common/navigator","vs/base/common/history","vs/base/browser/ui/list/rangeMap","vs/base/common/stopwatch","vs/base/common/cache","vs/base/common/observableInternal/promise","vs/base/common/observableInternal/utils","vs/base/common/stream","vs/base/common/codiconsLibrary","vs/base/common/diff/diff","vs/base/common/ternarySearchTree","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/base/parts/contextmenu/electron-sandbox/contextmenu","vs/css!vs/base/browser/ui/aria/aria","vs/css!vs/base/browser/ui/codicons/codicon/codicon","vs/css!vs/base/browser/ui/codicons/codicon/codicon-modifiers","vs/base/browser/ui/codicons/codiconStyles","vs/css!vs/base/browser/ui/contextview/contextview","vs/css!vs/base/browser/ui/findinput/findInput","vs/css!vs/base/browser/ui/inputbox/inputBox","vs/css!vs/base/browser/ui/list/list","vs/css!vs/base/browser/ui/scrollbar/media/scrollbars","vs/css!vs/base/browser/ui/selectBox/selectBox","vs/css!vs/base/browser/ui/selectBox/selectBoxCustom","vs/css!vs/base/browser/ui/toggle/toggle","vs/css!vs/base/browser/ui/tree/media/tree","vs/css!vs/code/electron-sandbox/processExplorer/media/processExplorer","vs/nls!vs/base/browser/ui/actionbar/actionViewItems","vs/nls!vs/base/browser/ui/findinput/findInput","vs/nls!vs/base/browser/ui/findinput/findInputToggles","vs/nls!vs/base/browser/ui/inputbox/inputBox","vs/nls!vs/base/browser/ui/selectBox/selectBoxCustom","vs/nls!vs/base/browser/ui/tree/abstractTree","vs/nls!vs/base/common/actions","vs/nls!vs/base/common/platform","vs/base/common/keybindings","vs/base/common/process","vs/base/common/extpath","vs/base/common/mime","vs/base/browser/dompurify/dompurify","vs/base/browser/ui/iconLabel/iconLabels","vs/base/browser/ui/list/rowCache","vs/base/browser/ui/scrollbar/scrollbarVisibilityController","vs/base/browser/ui/selectBox/selectBoxNative","vs/base/browser/ui/tree/objectTreeModel","vs/base/browser/ui/scrollbar/horizontalScrollbar","vs/base/browser/ui/scrollbar/verticalScrollbar","vs/base/common/htmlContent","vs/base/browser/markdownRenderer","vs/base/browser/ui/selectBox/selectBoxCustom","vs/base/browser/ui/selectBox/selectBox","vs/base/browser/ui/findinput/findInputToggles","vs/base/browser/ui/findinput/findInput","vs/base/browser/ui/tree/abstractTree","vs/base/browser/ui/tree/dataTree","vs/base/parts/ipc/electron-sandbox/ipc.electron","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/theme/common/iconRegistry","vs/platform/diagnostics/common/diagnostics","vs/platform/files/common/files","vs/platform/ipc/common/mainProcessService","vs/platform/ipc/electron-sandbox/mainProcessService","vs/platform/native/common/nativeHostService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/theme/common/iconRegistry","vs/platform/theme/browser/iconsStyleSheet","vs/platform/window/common/window","vs/platform/window/electron-sandbox/window","vs/code/electron-sandbox/processExplorer/processExplorerMain"],we=function(oe){for(var t=[],i=0,n=oe.length;i<n;i++)t[i]=pe[oe[i]];return t};/*! @license DOMPurify 3.0.5 | (c) Cure53 and other contributors | Released under the Apache license 2.0 and Mozilla Public License 2.0 | github.com/cure53/DOMPurify/blob/3.0.5/LICENSE */const{entries:Ut,setPrototypeOf:Ct,isFrozen:ii,getPrototypeOf:ni,getOwnPropertyDescriptor:si}=Object;let{freeze:at,seal:bt,create:ri}=Object,{apply:Lt,construct:Ft}=typeof Reflect<"u"&&Reflect;Lt||(Lt=function(t,i,n){return t.apply(i,n)}),at||(at=function(t){return t}),bt||(bt=function(t){return t}),Ft||(Ft=function(t,i){return new t(...i)});const oi=gt(Array.prototype.forEach),_t=gt(Array.prototype.pop),Et=gt(Array.prototype.push),Tt=gt(String.prototype.toLowerCase),It=gt(String.prototype.toString),li=gt(String.prototype.match),$t=gt(String.prototype.replace),ai=gt(String.prototype.indexOf),ui=gt(String.prototype.trim),dt=gt(RegExp.prototype.test),yt=hi(TypeError);function gt(oe){return function(t){for(var i=arguments.length,n=new Array(i>1?i-1:0),B=1;B<i;B++)n[B-1]=arguments[B];return Lt(oe,t,n)}}function hi(oe){return function(){for(var t=arguments.length,i=new Array(t),n=0;n<t;n++)i[n]=arguments[n];return Ft(oe,i)}}function ze(oe,t,i){var n;i=(n=i)!==null&&n!==void 0?n:Tt,Ct&&Ct(oe,null);let B=t.length;for(;B--;){let O=t[B];if(typeof O=="string"){const T=i(O);T!==O&&(ii(t)||(t[B]=T),O=T)}oe[O]=!0}return oe}function wt(oe){const t=ri(null);for(const[i,n]of Ut(oe))t[i]=n;return t}function kt(oe,t){for(;oe!==null;){const n=si(oe,t);if(n){if(n.get)return gt(n.get);if(typeof n.value=="function")return gt(n.value)}oe=ni(oe)}function i(n){return console.warn("fallback value for",n),null}return i}const Ht=at(["a","abbr","acronym","address","area","article","aside","audio","b","bdi","bdo","big","blink","blockquote","body","br","button","canvas","caption","center","cite","code","col","colgroup","content","data","datalist","dd","decorator","del","details","dfn","dialog","dir","div","dl","dt","element","em","fieldset","figcaption","figure","font","footer","form","h1","h2","h3","h4","h5","h6","head","header","hgroup","hr","html","i","img","input","ins","kbd","label","legend","li","main","map","mark","marquee","menu","menuitem","meter","nav","nobr","ol","optgroup","option","output","p","picture","pre","progress","q","rp","rt","ruby","s","samp","section","select","shadow","small","source","spacer","span","strike","strong","style","sub","summary","sup","table","tbody","td","template","textarea","tfoot","th","thead","time","tr","track","tt","u","ul","var","video","wbr"]),Ot=at(["svg","a","altglyph","altglyphdef","altglyphitem","animatecolor","animatemotion","animatetransform","circle","clippath","defs","desc","ellipse","filter","font","g","glyph","glyphref","hkern","image","line","lineargradient","marker","mask","metadata","mpath","path","pattern","polygon","polyline","radialgradient","rect","stop","style","switch","symbol","text","textpath","title","tref","tspan","view","vkern"]),Mt=at(["feBlend","feColorMatrix","feComponentTransfer","feComposite","feConvolveMatrix","feDiffuseLighting","feDisplacementMap","feDistantLight","feDropShadow","feFlood","feFuncA","feFuncB","feFuncG","feFuncR","feGaussianBlur","feImage","feMerge","feMergeNode","feMorphology","feOffset","fePointLight","feSpecularLighting","feSpotLight","feTile","feTurbulence"]),ci=at(["animate","color-profile","cursor","discard","font-face","font-face-format","font-face-name","font-face-src","font-face-uri","foreignobject","hatch","hatchpath","mesh","meshgradient","meshpatch","meshrow","missing-glyph","script","set","solidcolor","unknown","use"]),Pt=at(["math","menclose","merror","mfenced","mfrac","mglyph","mi","mlabeledtr","mmultiscripts","mn","mo","mover","mpadded","mphantom","mroot","mrow","ms","mspace","msqrt","mstyle","msub","msup","msubsup","mtable","mtd","mtext","mtr","munder","munderover","mprescripts"]),fi=at(["maction","maligngroup","malignmark","mlongdiv","mscarries","mscarry","msgroup","mstack","msline","msrow","semantics","annotation","annotation-xml","mprescripts","none"]),xt=at(["#text"]),zt=at(["accept","action","align","alt","autocapitalize","autocomplete","autopictureinpicture","autoplay","background","bgcolor","border","capture","cellpadding","cellspacing","checked","cite","class","clear","color","cols","colspan","controls","controlslist","coords","crossorigin","datetime","decoding","default","dir","disabled","disablepictureinpicture","disableremoteplayback","download","draggable","enctype","enterkeyhint","face","for","headers","height","hidden","high","href","hreflang","id","inputmode","integrity","ismap","kind","label","lang","list","loading","loop","low","max","maxlength","media","method","min","minlength","multiple","muted","name","nonce","noshade","novalidate","nowrap","open","optimum","pattern","placeholder","playsinline","poster","preload","pubdate","radiogroup","readonly","rel","required","rev","reversed","role","rows","rowspan","spellcheck","scope","selected","shape","size","sizes","span","srclang","start","src","srcset","step","style","summary","tabindex","title","translate","type","usemap","valign","value","width","xmlns","slot"]),Bt=at(["accent-height","accumulate","additive","alignment-baseline","ascent","attributename","attributetype","azimuth","basefrequency","baseline-shift","begin","bias","by","class","clip","clippathunits","clip-path","clip-rule","color","color-interpolation","color-interpolation-filters","color-profile","color-rendering","cx","cy","d","dx","dy","diffuseconstant","direction","display","divisor","dur","edgemode","elevation","end","fill","fill-opacity","fill-rule","filter","filterunits","flood-color","flood-opacity","font-family","font-size","font-size-adjust","font-stretch","font-style","font-variant","font-weight","fx","fy","g1","g2","glyph-name","glyphref","gradientunits","gradienttransform","height","href","id","image-rendering","in","in2","k","k1","k2","k3","k4","kerning","keypoints","keysplines","keytimes","lang","lengthadjust","letter-spacing","kernelmatrix","kernelunitlength","lighting-color","local","marker-end","marker-mid","marker-start","markerheight","markerunits","markerwidth","maskcontentunits","maskunits","max","mask","media","method","mode","min","name","numoctaves","offset","operator","opacity","order","orient","orientation","origin","overflow","paint-order","path","pathlength","patterncontentunits","patterntransform","patternunits","points","preservealpha","preserveaspectratio","primitiveunits","r","rx","ry","radius","refx","refy","repeatcount","repeatdur","restart","result","rotate","scale","seed","shape-rendering","specularconstant","specularexponent","spreadmethod","startoffset","stddeviation","stitchtiles","stop-color","stop-opacity","stroke-dasharray","stroke-dashoffset","stroke-linecap","stroke-linejoin","stroke-miterlimit","stroke-opacity","stroke","stroke-width","style","surfacescale","systemlanguage","tabindex","targetx","targety","transform","transform-origin","text-anchor","text-decoration","text-rendering","textlength","type","u1","u2","unicode","values","viewbox","visibility","version","vert-adv-y","vert-origin-x","vert-origin-y","width","word-spacing","wrap","writing-mode","xchannelselector","ychannelselector","x","x1","x2","xmlns","y","y1","y2","z","zoomandpan"]),Wt=at(["accent","accentunder","align","bevelled","close","columnsalign","columnlines","columnspan","denomalign","depth","dir","display","displaystyle","encoding","fence","frame","height","href","id","largeop","length","linethickness","lspace","lquote","mathbackground","mathcolor","mathsize","mathvariant","maxsize","minsize","movablelimits","notation","numalign","open","rowalign","rowlines","rowspacing","rowspan","rspace","rquote","scriptlevel","scriptminsize","scriptsizemultiplier","selection","separator","separators","stretchy","subscriptshift","supscriptshift","symmetric","voffset","width","xmlns"]),Rt=at(["xlink:href","xml:id","xlink:title","xml:space","xmlns:xlink"]),di=bt(/\{\{[\w\W]*|[\w\W]*\}\}/gm),gi=bt(/<%[\w\W]*|[\w\W]*%>/gm),mi=bt(/\${[\w\W]*}/gm),bi=bt(/^data-[\-\w.\u00B7-\uFFFF]/),$i=bt(/^aria-[\-\w]+$/),Kt=bt(/^(?:(?:(?:f|ht)tps?|mailto|tel|callto|sms|cid|xmpp):|[^a-z]|[a-z+.\-]+(?:[^a-z+.\-:]|$))/i),pi=bt(/^(?:\w+script|data):/i),wi=bt(/[\u0000-\u0020\u00A0\u1680\u180E\u2000-\u2029\u205F\u3000]/g),Vt=bt(/^html$/i);var qt=Object.freeze({__proto__:null,MUSTACHE_EXPR:di,ERB_EXPR:gi,TMPLIT_EXPR:mi,DATA_ATTR:bi,ARIA_ATTR:$i,IS_ALLOWED_URI:Kt,IS_SCRIPT_OR_DATA:pi,ATTR_WHITESPACE:wi,DOCTYPE_NAME:Vt});const vi=()=>typeof window>"u"?null:window,Di=function(t,i){if(typeof t!="object"||typeof t.createPolicy!="function")return null;let n=null;const B="data-tt-policy-suffix";i&&i.hasAttribute(B)&&(n=i.getAttribute(B));const O="dompurify"+(n?"#"+n:"");try{return t.createPolicy(O,{createHTML(T){return T},createScriptURL(T){return T}})}catch{return console.warn("TrustedTypes policy "+O+" could not be created."),null}};function Gt(){let oe=arguments.length>0&&arguments[0]!==void 0?arguments[0]:vi();const t=Ce=>Gt(Ce);if(t.version="3.0.5",t.removed=[],!oe||!oe.document||oe.document.nodeType!==9)return t.isSupported=!1,t;const i=oe.document,n=i.currentScript;let{document:B}=oe;const{DocumentFragment:O,HTMLTemplateElement:T,Node:v,Element:y,NodeFilter:f,NamedNodeMap:w=oe.NamedNodeMap||oe.MozNamedAttrMap,HTMLFormElement:A,DOMParser:$,trustedTypes:m}=oe,e=y.prototype,s=kt(e,"cloneNode"),o=kt(e,"nextSibling"),h=kt(e,"childNodes"),c=kt(e,"parentNode");if(typeof T=="function"){const Ce=B.createElement("template");Ce.content&&Ce.content.ownerDocument&&(B=Ce.content.ownerDocument)}let b,k="";const{implementation:E,createNodeIterator:r,createDocumentFragment:d,getElementsByTagName:D}=B,{importNode:R}=i;let _={};t.isSupported=typeof Ut=="function"&&typeof c=="function"&&E&&E.createHTMLDocument!==void 0;const{MUSTACHE_EXPR:H,ERB_EXPR:x,TMPLIT_EXPR:p,DATA_ATTR:M,ARIA_ATTR:U,IS_SCRIPT_OR_DATA:N,ATTR_WHITESPACE:P}=qt;let{IS_ALLOWED_URI:W}=qt,ne=null;const Q=ze({},[...Ht,...Ot,...Mt,...Pt,...xt]);let Y=null;const te=ze({},[...zt,...Bt,...Wt,...Rt]);let de=Object.seal(Object.create(null,{tagNameCheck:{writable:!0,configurable:!1,enumerable:!0,value:null},attributeNameCheck:{writable:!0,configurable:!1,enumerable:!0,value:null},allowCustomizedBuiltInElements:{writable:!0,configurable:!1,enumerable:!0,value:!1}})),De=null,Le=null,Se=!0,ue=!0,J=!1,fe=!0,le=!1,ke=!1,Z=!1,me=!1,ye=!1,Oe=!1,Ie=!1,je=!0,ie=!1;const K="user-content-";let C=!0,a=!1,l={},g=null;const I=ze({},["annotation-xml","audio","colgroup","desc","foreignobject","head","iframe","math","mi","mn","mo","ms","mtext","noembed","noframes","noscript","plaintext","script","style","svg","template","thead","title","video","xmp"]);let F=null;const u=ze({},["audio","video","img","source","image","track"]);let L=null;const S=ze({},["alt","class","for","id","label","name","pattern","placeholder","role","summary","title","value","style","xmlns"]),j="http://www.w3.org/1998/Math/MathML",z="http://www.w3.org/2000/svg",q="http://www.w3.org/1999/xhtml";let ee=q,re=!1,ce=null;const Ee=ze({},[j,z,q],It);let ve;const Re=["application/xhtml+xml","text/html"],Te="text/html";let he,Fe=null;const xe=B.createElement("form"),Ye=function(ge){return ge instanceof RegExp||ge instanceof Function},et=function(ge){if(!(Fe&&Fe===ge)){if((!ge||typeof ge!="object")&&(ge={}),ge=wt(ge),ve=Re.indexOf(ge.PARSER_MEDIA_TYPE)===-1?ve=Te:ve=ge.PARSER_MEDIA_TYPE,he=ve==="application/xhtml+xml"?It:Tt,ne="ALLOWED_TAGS"in ge?ze({},ge.ALLOWED_TAGS,he):Q,Y="ALLOWED_ATTR"in ge?ze({},ge.ALLOWED_ATTR,he):te,ce="ALLOWED_NAMESPACES"in ge?ze({},ge.ALLOWED_NAMESPACES,It):Ee,L="ADD_URI_SAFE_ATTR"in ge?ze(wt(S),ge.ADD_URI_SAFE_ATTR,he):S,F="ADD_DATA_URI_TAGS"in ge?ze(wt(u),ge.ADD_DATA_URI_TAGS,he):u,g="FORBID_CONTENTS"in ge?ze({},ge.FORBID_CONTENTS,he):I,De="FORBID_TAGS"in ge?ze({},ge.FORBID_TAGS,he):{},Le="FORBID_ATTR"in ge?ze({},ge.FORBID_ATTR,he):{},l="USE_PROFILES"in ge?ge.USE_PROFILES:!1,Se=ge.ALLOW_ARIA_ATTR!==!1,ue=ge.ALLOW_DATA_ATTR!==!1,J=ge.ALLOW_UNKNOWN_PROTOCOLS||!1,fe=ge.ALLOW_SELF_CLOSE_IN_ATTR!==!1,le=ge.SAFE_FOR_TEMPLATES||!1,ke=ge.WHOLE_DOCUMENT||!1,ye=ge.RETURN_DOM||!1,Oe=ge.RETURN_DOM_FRAGMENT||!1,Ie=ge.RETURN_TRUSTED_TYPE||!1,me=ge.FORCE_BODY||!1,je=ge.SANITIZE_DOM!==!1,ie=ge.SANITIZE_NAMED_PROPS||!1,C=ge.KEEP_CONTENT!==!1,a=ge.IN_PLACE||!1,W=ge.ALLOWED_URI_REGEXP||Kt,ee=ge.NAMESPACE||q,de=ge.CUSTOM_ELEMENT_HANDLING||{},ge.CUSTOM_ELEMENT_HANDLING&&Ye(ge.CUSTOM_ELEMENT_HANDLING.tagNameCheck)&&(de.tagNameCheck=ge.CUSTOM_ELEMENT_HANDLING.tagNameCheck),ge.CUSTOM_ELEMENT_HANDLING&&Ye(ge.CUSTOM_ELEMENT_HANDLING.attributeNameCheck)&&(de.attributeNameCheck=ge.CUSTOM_ELEMENT_HANDLING.attributeNameCheck),ge.CUSTOM_ELEMENT_HANDLING&&typeof ge.CUSTOM_ELEMENT_HANDLING.allowCustomizedBuiltInElements=="boolean"&&(de.allowCustomizedBuiltInElements=ge.CUSTOM_ELEMENT_HANDLING.allowCustomizedBuiltInElements),le&&(ue=!1),Oe&&(ye=!0),l&&(ne=ze({},[...xt]),Y=[],l.html===!0&&(ze(ne,Ht),ze(Y,zt)),l.svg===!0&&(ze(ne,Ot),ze(Y,Bt),ze(Y,Rt)),l.svgFilters===!0&&(ze(ne,Mt),ze(Y,Bt),ze(Y,Rt)),l.mathMl===!0&&(ze(ne,Pt),ze(Y,Wt),ze(Y,Rt))),ge.ADD_TAGS&&(ne===Q&&(ne=wt(ne)),ze(ne,ge.ADD_TAGS,he)),ge.ADD_ATTR&&(Y===te&&(Y=wt(Y)),ze(Y,ge.ADD_ATTR,he)),ge.ADD_URI_SAFE_ATTR&&ze(L,ge.ADD_URI_SAFE_ATTR,he),ge.FORBID_CONTENTS&&(g===I&&(g=wt(g)),ze(g,ge.FORBID_CONTENTS,he)),C&&(ne["#text"]=!0),ke&&ze(ne,["html","head","body"]),ne.table&&(ze(ne,["tbody"]),delete De.tbody),ge.TRUSTED_TYPES_POLICY){if(typeof ge.TRUSTED_TYPES_POLICY.createHTML!="function")throw yt('TRUSTED_TYPES_POLICY configuration option must provide a "createHTML" hook.');if(typeof ge.TRUSTED_TYPES_POLICY.createScriptURL!="function")throw yt('TRUSTED_TYPES_POLICY configuration option must provide a "createScriptURL" hook.');b=ge.TRUSTED_TYPES_POLICY,k=b.createHTML("")}else b===void 0&&(b=Di(m,n)),b!==null&&typeof k=="string"&&(k=b.createHTML(""));at&&at(ge),Fe=ge}},ot=ze({},["mi","mo","mn","ms","mtext"]),it=ze({},["foreignobject","desc","title","annotation-xml"]),Ke=ze({},["title","style","font","a","script"]),Xe=ze({},Ot);ze(Xe,Mt),ze(Xe,ci);const X=ze({},Pt);ze(X,fi);const ae=function(ge){let Me=c(ge);(!Me||!Me.tagName)&&(Me={namespaceURI:ee,tagName:"template"});const Be=Tt(ge.tagName),Ve=Tt(Me.tagName);return ce[ge.namespaceURI]?ge.namespaceURI===z?Me.namespaceURI===q?Be==="svg":Me.namespaceURI===j?Be==="svg"&&(Ve==="annotation-xml"||ot[Ve]):!!Xe[Be]:ge.namespaceURI===j?Me.namespaceURI===q?Be==="math":Me.namespaceURI===z?Be==="math"&&it[Ve]:!!X[Be]:ge.namespaceURI===q?Me.namespaceURI===z&&!it[Ve]||Me.namespaceURI===j&&!ot[Ve]?!1:!X[Be]&&(Ke[Be]||!Xe[Be]):!!(ve==="application/xhtml+xml"&&ce[ge.namespaceURI]):!1},$e=function(ge){Et(t.removed,{element:ge});try{ge.parentNode.removeChild(ge)}catch{ge.remove()}},Ae=function(ge,Me){try{Et(t.removed,{attribute:Me.getAttributeNode(ge),from:Me})}catch{Et(t.removed,{attribute:null,from:Me})}if(Me.removeAttribute(ge),ge==="is"&&!Y[ge])if(ye||Oe)try{$e(Me)}catch{}else try{Me.setAttribute(ge,"")}catch{}},Pe=function(ge){let Me,Be;if(me)ge="<remove></remove>"+ge;else{const ct=li(ge,/^[\r\n\t ]+/);Be=ct&&ct[0]}ve==="application/xhtml+xml"&&ee===q&&(ge='<html xmlns="http://www.w3.org/1999/xhtml"><head></head><body>'+ge+"</body></html>");const Ve=b?b.createHTML(ge):ge;if(ee===q)try{Me=new $().parseFromString(Ve,ve)}catch{}if(!Me||!Me.documentElement){Me=E.createDocument(ee,"template",null);try{Me.documentElement.innerHTML=re?k:Ve}catch{}}const st=Me.body||Me.documentElement;return ge&&Be&&st.insertBefore(B.createTextNode(Be),st.childNodes[0]||null),ee===q?D.call(Me,ke?"html":"body")[0]:ke?Me.documentElement:st},He=function(ge){return r.call(ge.ownerDocument||ge,ge,f.SHOW_ELEMENT|f.SHOW_COMMENT|f.SHOW_TEXT,null,!1)},Qe=function(ge){return ge instanceof A&&(typeof ge.nodeName!="string"||typeof ge.textContent!="string"||typeof ge.removeChild!="function"||!(ge.attributes instanceof w)||typeof ge.removeAttribute!="function"||typeof ge.setAttribute!="function"||typeof ge.namespaceURI!="string"||typeof ge.insertBefore!="function"||typeof ge.hasChildNodes!="function")},rt=function(ge){return typeof v=="object"?ge instanceof v:ge&&typeof ge=="object"&&typeof ge.nodeType=="number"&&typeof ge.nodeName=="string"},tt=function(ge,Me,Be){_[ge]&&oi(_[ge],Ve=>{Ve.call(t,Me,Be,Fe)})},ut=function(ge){let Me;if(tt("beforeSanitizeElements",ge,null),Qe(ge))return $e(ge),!0;const Be=he(ge.nodeName);if(tt("uponSanitizeElement",ge,{tagName:Be,allowedTags:ne}),ge.hasChildNodes()&&!rt(ge.firstElementChild)&&(!rt(ge.content)||!rt(ge.content.firstElementChild))&&dt(/<[/\w]/g,ge.innerHTML)&&dt(/<[/\w]/g,ge.textContent))return $e(ge),!0;if(!ne[Be]||De[Be]){if(!De[Be]&&lt(Be)&&(de.tagNameCheck instanceof RegExp&&dt(de.tagNameCheck,Be)||de.tagNameCheck instanceof Function&&de.tagNameCheck(Be)))return!1;if(C&&!g[Be]){const Ve=c(ge)||ge.parentNode,st=h(ge)||ge.childNodes;if(st&&Ve){const ct=st.length;for(let Ze=ct-1;Ze>=0;--Ze)Ve.insertBefore(s(st[Ze],!0),o(ge))}}return $e(ge),!0}return ge instanceof y&&!ae(ge)||(Be==="noscript"||Be==="noembed"||Be==="noframes")&&dt(/<\/no(script|embed|frames)/i,ge.innerHTML)?($e(ge),!0):(le&&ge.nodeType===3&&(Me=ge.textContent,Me=$t(Me,H," "),Me=$t(Me,x," "),Me=$t(Me,p," "),ge.textContent!==Me&&(Et(t.removed,{element:ge.cloneNode()}),ge.textContent=Me)),tt("afterSanitizeElements",ge,null),!1)},nt=function(ge,Me,Be){if(je&&(Me==="id"||Me==="name")&&(Be in B||Be in xe))return!1;if(!(ue&&!Le[Me]&&dt(M,Me))){if(!(Se&&dt(U,Me))){if(!Y[Me]||Le[Me]){if(!(lt(ge)&&(de.tagNameCheck instanceof RegExp&&dt(de.tagNameCheck,ge)||de.tagNameCheck instanceof Function&&de.tagNameCheck(ge))&&(de.attributeNameCheck instanceof RegExp&&dt(de.attributeNameCheck,Me)||de.attributeNameCheck instanceof Function&&de.attributeNameCheck(Me))||Me==="is"&&de.allowCustomizedBuiltInElements&&(de.tagNameCheck instanceof RegExp&&dt(de.tagNameCheck,Be)||de.tagNameCheck instanceof Function&&de.tagNameCheck(Be))))return!1}else if(!L[Me]){if(!dt(W,$t(Be,P,""))){if(!((Me==="src"||Me==="xlink:href"||Me==="href")&&ge!=="script"&&ai(Be,"data:")===0&&F[ge])){if(!(J&&!dt(N,$t(Be,P,"")))){if(Be)return!1}}}}}}return!0},lt=function(ge){return ge.indexOf("-")>0},ht=function(ge){let Me,Be,Ve,st;tt("beforeSanitizeAttributes",ge,null);const{attributes:ct}=ge;if(!ct)return;const Ze={attrName:"",attrValue:"",keepAttr:!0,allowedAttributes:Y};for(st=ct.length;st--;){Me=ct[st];const{name:mt,namespaceURI:vt}=Me;if(Be=mt==="value"?Me.value:ui(Me.value),Ve=he(mt),Ze.attrName=Ve,Ze.attrValue=Be,Ze.keepAttr=!0,Ze.forceKeepAttr=void 0,tt("uponSanitizeAttribute",ge,Ze),Be=Ze.attrValue,Ze.forceKeepAttr||(Ae(mt,ge),!Ze.keepAttr))continue;if(!fe&&dt(/\/>/i,Be)){Ae(mt,ge);continue}le&&(Be=$t(Be,H," "),Be=$t(Be,x," "),Be=$t(Be,p," "));const At=he(ge.nodeName);if(nt(At,Ve,Be)){if(ie&&(Ve==="id"||Ve==="name")&&(Ae(mt,ge),Be=K+Be),b&&typeof m=="object"&&typeof m.getAttributeType=="function"&&!vt)switch(m.getAttributeType(At,Ve)){case"TrustedHTML":{Be=b.createHTML(Be);break}case"TrustedScriptURL":{Be=b.createScriptURL(Be);break}}try{vt?ge.setAttributeNS(vt,mt,Be):ge.setAttribute(mt,Be),_t(t.removed)}catch{}}}tt("afterSanitizeAttributes",ge,null)},pt=function Ce(ge){let Me;const Be=He(ge);for(tt("beforeSanitizeShadowDOM",ge,null);Me=Be.nextNode();)tt("uponSanitizeShadowNode",Me,null),!ut(Me)&&(Me.content instanceof O&&Ce(Me.content),ht(Me));tt("afterSanitizeShadowDOM",ge,null)};return t.sanitize=function(Ce){let ge=arguments.length>1&&arguments[1]!==void 0?arguments[1]:{},Me,Be,Ve,st;if(re=!Ce,re&&(Ce="<!-->"),typeof Ce!="string"&&!rt(Ce))if(typeof Ce.toString=="function"){if(Ce=Ce.toString(),typeof Ce!="string")throw yt("dirty is not a string, aborting")}else throw yt("toString is not a function");if(!t.isSupported)return Ce;if(Z||et(ge),t.removed=[],typeof Ce=="string"&&(a=!1),a){if(Ce.nodeName){const mt=he(Ce.nodeName);if(!ne[mt]||De[mt])throw yt("root node is forbidden and cannot be sanitized in-place")}}else if(Ce instanceof v)Me=Pe("<!---->"),Be=Me.ownerDocument.importNode(Ce,!0),Be.nodeType===1&&Be.nodeName==="BODY"||Be.nodeName==="HTML"?Me=Be:Me.appendChild(Be);else{if(!ye&&!le&&!ke&&Ce.indexOf("<")===-1)return b&&Ie?b.createHTML(Ce):Ce;if(Me=Pe(Ce),!Me)return ye?null:Ie?k:""}Me&&me&&$e(Me.firstChild);const ct=He(a?Ce:Me);for(;Ve=ct.nextNode();)ut(Ve)||(Ve.content instanceof O&&pt(Ve.content),ht(Ve));if(a)return Ce;if(ye){if(Oe)for(st=d.call(Me.ownerDocument);Me.firstChild;)st.appendChild(Me.firstChild);else st=Me;return(Y.shadowroot||Y.shadowrootmode)&&(st=R.call(i,st,!0)),st}let Ze=ke?Me.outerHTML:Me.innerHTML;return ke&&ne["!doctype"]&&Me.ownerDocument&&Me.ownerDocument.doctype&&Me.ownerDocument.doctype.name&&dt(Vt,Me.ownerDocument.doctype.name)&&(Ze="<!DOCTYPE "+Me.ownerDocument.doctype.name+`>
`+Ze),le&&(Ze=$t(Ze,H," "),Ze=$t(Ze,x," "),Ze=$t(Ze,p," ")),b&&Ie?b.createHTML(Ze):Ze},t.setConfig=function(Ce){et(Ce),Z=!0},t.clearConfig=function(){Fe=null,Z=!1},t.isValidAttribute=function(Ce,ge,Me){Fe||et({});const Be=he(Ce),Ve=he(ge);return nt(Be,Ve,Me)},t.addHook=function(Ce,ge){typeof ge=="function"&&(_[Ce]=_[Ce]||[],Et(_[Ce],ge))},t.removeHook=function(Ce){if(_[Ce])return _t(_[Ce])},t.removeHooks=function(Ce){_[Ce]&&(_[Ce]=[])},t.removeAllHooks=function(){_={}},t}var Ei=Gt();define("vs/base/browser/dompurify/dompurify",function(){return Ei}),define(pe[56],we([1,0]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$XS=void 0,t.$YS=B;class i{constructor(T){this.domNode=T,this.a="",this.b="",this.c="",this.d="",this.e="",this.f="",this.g="",this.h="",this.i="",this.j="",this.k="",this.l="",this.m="",this.n="",this.o="",this.p="",this.q="",this.r="",this.s="",this.t="",this.u="",this.v="",this.w="",this.x="",this.y="",this.z="",this.A=!1,this.B="none",this.C=""}setMaxWidth(T){const v=n(T);this.a!==v&&(this.a=v,this.domNode.style.maxWidth=this.a)}setWidth(T){const v=n(T);this.b!==v&&(this.b=v,this.domNode.style.width=this.b)}setHeight(T){const v=n(T);this.c!==v&&(this.c=v,this.domNode.style.height=this.c)}setTop(T){const v=n(T);this.d!==v&&(this.d=v,this.domNode.style.top=this.d)}setLeft(T){const v=n(T);this.e!==v&&(this.e=v,this.domNode.style.left=this.e)}setBottom(T){const v=n(T);this.f!==v&&(this.f=v,this.domNode.style.bottom=this.f)}setRight(T){const v=n(T);this.g!==v&&(this.g=v,this.domNode.style.right=this.g)}setPaddingTop(T){const v=n(T);this.h!==v&&(this.h=v,this.domNode.style.paddingTop=this.h)}setPaddingLeft(T){const v=n(T);this.i!==v&&(this.i=v,this.domNode.style.paddingLeft=this.i)}setPaddingBottom(T){const v=n(T);this.j!==v&&(this.j=v,this.domNode.style.paddingBottom=this.j)}setPaddingRight(T){const v=n(T);this.k!==v&&(this.k=v,this.domNode.style.paddingRight=this.k)}setFontFamily(T){this.l!==T&&(this.l=T,this.domNode.style.fontFamily=this.l)}setFontWeight(T){this.m!==T&&(this.m=T,this.domNode.style.fontWeight=this.m)}setFontSize(T){const v=n(T);this.n!==v&&(this.n=v,this.domNode.style.fontSize=this.n)}setFontStyle(T){this.o!==T&&(this.o=T,this.domNode.style.fontStyle=this.o)}setFontFeatureSettings(T){this.p!==T&&(this.p=T,this.domNode.style.fontFeatureSettings=this.p)}setFontVariationSettings(T){this.q!==T&&(this.q=T,this.domNode.style.fontVariationSettings=this.q)}setTextDecoration(T){this.r!==T&&(this.r=T,this.domNode.style.textDecoration=this.r)}setLineHeight(T){const v=n(T);this.s!==v&&(this.s=v,this.domNode.style.lineHeight=this.s)}setLetterSpacing(T){const v=n(T);this.t!==v&&(this.t=v,this.domNode.style.letterSpacing=this.t)}setClassName(T){this.u!==T&&(this.u=T,this.domNode.className=this.u)}toggleClassName(T,v){this.domNode.classList.toggle(T,v),this.u=this.domNode.className}setDisplay(T){this.v!==T&&(this.v=T,this.domNode.style.display=this.v)}setPosition(T){this.w!==T&&(this.w=T,this.domNode.style.position=this.w)}setVisibility(T){this.x!==T&&(this.x=T,this.domNode.style.visibility=this.x)}setColor(T){this.y!==T&&(this.y=T,this.domNode.style.color=this.y)}setBackgroundColor(T){this.z!==T&&(this.z=T,this.domNode.style.backgroundColor=this.z)}setLayerHinting(T){this.A!==T&&(this.A=T,this.domNode.style.transform=this.A?"translate3d(0px, 0px, 0px)":"")}setBoxShadow(T){this.C!==T&&(this.C=T,this.domNode.style.boxShadow=T)}setContain(T){this.B!==T&&(this.B=T,this.domNode.style.contain=this.B)}setAttribute(T,v){this.domNode.setAttribute(T,v)}removeAttribute(T){this.domNode.removeAttribute(T)}appendChild(T){this.domNode.appendChild(T.domNode)}removeChild(T){this.domNode.removeChild(T.domNode)}}t.$XS=i;function n(O){return typeof O=="number"?`${O}px`:O}function B(O){return new i(O)}}),define(pe[85],we([1,0]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$dR=void 0,t.$eR=O;const i=new WeakMap;function n(v){if(!v.parent||v.parent===v)return null;try{const y=v.location,f=v.parent.location;if(y.origin!=="null"&&f.origin!=="null"&&y.origin!==f.origin)return null}catch{return null}return v.parent}class B{static a(y){let f=i.get(y);if(!f){f=[],i.set(y,f);let w=y,A;do A=n(w),A?f.push({window:new WeakRef(w),iframeElement:w.frameElement||null}):f.push({window:new WeakRef(w),iframeElement:null}),w=A;while(w)}return f.slice(0)}static getPositionOfChildWindowRelativeToAncestorWindow(y,f){if(!f||y===f)return{top:0,left:0};let w=0,A=0;const $=this.a(y);for(const m of $){const e=m.window.deref();if(w+=e?.scrollY??0,A+=e?.scrollX??0,e===f||!m.iframeElement)break;const s=m.iframeElement.getBoundingClientRect();w+=s.top,A+=s.left}return{top:w,left:A}}}t.$dR=B;async function O(v,y){if(!crypto.subtle)throw new Error("'crypto.subtle' is not available so webviews will not work. This is likely because the editor is not running in a secure context (https://developer.mozilla.org/en-US/docs/Web/Security/Secure_Contexts).");const f=JSON.stringify({parentOrigin:v,salt:y}),A=new TextEncoder().encode(f),$=await crypto.subtle.digest("sha-256",A);return T($)}function T(v){const f=Array.from(new Uint8Array(v)).map(w=>w.toString(16).padStart(2,"0")).join("");return BigInt(`0x${f}`).toString(32).padStart(52,"0")}}),define(pe[32],we([1,0]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$5T=n,t.$6T=B;let i={showHover:()=>{},hideHover:()=>{},showAndFocusLastHover:()=>{},setupUpdatableHover:()=>null,triggerUpdatableHover:()=>{}};function n(O){i=O}function B(){return i}}),define(pe[40],we([1,0]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$HT=t.$GT=t.$FT=t.ListDragOverEffectPosition=t.ListDragOverEffectType=void 0;var i;(function(T){T[T.Copy=0]="Copy",T[T.Move=1]="Move"})(i||(t.ListDragOverEffectType=i={}));var n;(function(T){T.Over="drop-target",T.Before="drop-target-before",T.After="drop-target-after"})(n||(t.ListDragOverEffectPosition=n={})),t.$FT={reject(){return{accept:!1}},accept(){return{accept:!0}}};class B extends Error{constructor(v,y){super(`ListError [${v}] ${y}`)}}t.$GT=B;class O{constructor(){this.c=new WeakMap}getHeight(v){return this.c.get(v)??this.d(v)}setDynamicHeight(v,y){y>0&&this.c.set(v,y)}}t.$HT=O}),define(pe[86],we([1,0]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$vT=void 0;class i{constructor(B){this.a=B}splice(B,O,T){this.a.forEach(v=>v.splice(B,O,T))}}t.$vT=i}),define(pe[57],we([1,0]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$4S=void 0;const i=20;class n{constructor(O,T,v,y,f,w){this.a=Math.round(T),this.b=Math.round(v),this.c=Math.round(O),this.d=y,this.e=f,this.f=w,this.g=0,this.h=!1,this.i=0,this.j=0,this.k=0,this.m()}clone(){return new n(this.c,this.a,this.b,this.d,this.e,this.f)}setVisibleSize(O){const T=Math.round(O);return this.d!==T?(this.d=T,this.m(),!0):!1}setScrollSize(O){const T=Math.round(O);return this.e!==T?(this.e=T,this.m(),!0):!1}setScrollPosition(O){const T=Math.round(O);return this.f!==T?(this.f=T,this.m(),!0):!1}setScrollbarSize(O){this.a=Math.round(O)}setOppositeScrollbarSize(O){this.b=Math.round(O)}static l(O,T,v,y,f){const w=Math.max(0,v-O),A=Math.max(0,w-2*T),$=y>0&&y>v;if(!$)return{computedAvailableSize:Math.round(w),computedIsNeeded:$,computedSliderSize:Math.round(A),computedSliderRatio:0,computedSliderPosition:0};const m=Math.round(Math.max(i,Math.floor(v*A/y))),e=(A-m)/(y-v),s=f*e;return{computedAvailableSize:Math.round(w),computedIsNeeded:$,computedSliderSize:Math.round(m),computedSliderRatio:e,computedSliderPosition:Math.round(s)}}m(){const O=n.l(this.b,this.c,this.d,this.e,this.f);this.g=O.computedAvailableSize,this.h=O.computedIsNeeded,this.i=O.computedSliderSize,this.j=O.computedSliderRatio,this.k=O.computedSliderPosition}getArrowSize(){return this.c}getScrollPosition(){return this.f}getRectangleLargeSize(){return this.g}getRectangleSmallSize(){return this.a}isNeeded(){return this.h}getSliderSize(){return this.i}getSliderPosition(){return this.k}getDesiredScrollPositionFromOffset(O){if(!this.h)return 0;const T=O-this.c-this.i/2;return Math.round(T/this.j)}getDesiredScrollPositionFromOffsetPaged(O){if(!this.h)return 0;const T=O-this.c;let v=this.f;return T<this.k?v-=this.d:v+=this.d,v}getDesiredScrollPositionFromDelta(O){if(!this.h)return 0;const T=this.k+O;return Math.round(T/this.j)}}t.$4S=n}),define(pe[33],we([1,0,40]),function(oe,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$EV=t.$DV=t.$CV=t.TreeDragOverBubble=t.TreeMouseEventTarget=t.ObjectTreeElementCollapseState=t.TreeVisibility=void 0;var n;(function(f){f[f.Hidden=0]="Hidden",f[f.Visible=1]="Visible",f[f.Recurse=2]="Recurse"})(n||(t.TreeVisibility=n={}));var B;(function(f){f[f.Expanded=0]="Expanded",f[f.Collapsed=1]="Collapsed",f[f.PreserveOrExpanded=2]="PreserveOrExpanded",f[f.PreserveOrCollapsed=3]="PreserveOrCollapsed"})(B||(t.ObjectTreeElementCollapseState=B={}));var O;(function(f){f[f.Unknown=0]="Unknown",f[f.Twistie=1]="Twistie",f[f.Element=2]="Element",f[f.Filter=3]="Filter"})(O||(t.TreeMouseEventTarget=O={}));var T;(function(f){f[f.Down=0]="Down",f[f.Up=1]="Up"})(T||(t.TreeDragOverBubble=T={})),t.$CV={acceptBubbleUp(){return{accept:!0,bubble:T.Up}},acceptBubbleDown(f=!1){return{accept:!0,bubble:T.Down,autoExpand:f}},acceptCopyBubbleUp(){return{accept:!0,bubble:T.Up,effect:{type:i.ListDragOverEffectType.Copy,position:i.ListDragOverEffectPosition.Over}}},acceptCopyBubbleDown(f=!1){return{accept:!0,bubble:T.Down,effect:{type:i.ListDragOverEffectType.Copy,position:i.ListDragOverEffectPosition.Over},autoExpand:f}}};class v extends Error{constructor(w,A){super(`TreeError [${w}] ${A}`)}}t.$DV=v;class y{constructor(w){this.a=w,this.b=new WeakMap}map(w){let A=this.b.get(w);return A||(A=this.a(w),this.b.set(w,A)),A}}t.$EV=y}),define(pe[25],we([1,0]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$TQ=void 0,t.$SQ=i,t.$UQ=n;function i(B,O){const T=B;typeof T.vscodeWindowId!="number"&&Object.defineProperty(T,"vscodeWindowId",{get:()=>O})}t.$TQ=window;function n(B){return B===t.$TQ?!1:typeof B?.vscodeWindowId=="number"}}),define(pe[87],we([1,0]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$mb=void 0,t.$fb=i,t.$gb=n,t.$hb=B,t.$ib=O,t.$jb=T,t.$kb=v,t.$lb=y,t.$nb=w,t.$ob=A,t.$pb=$,t.$qb=m,t.$rb=e;function i(s,o){const h=n(s,o);if(h!==-1)return s[h]}function n(s,o,h=s.length-1){for(let c=h;c>=0;c--){const b=s[c];if(o(b))return c}return-1}function B(s,o){const h=O(s,o);return h===-1?void 0:s[h]}function O(s,o,h=0,c=s.length){let b=h,k=c;for(;b<k;){const E=Math.floor((b+k)/2);o(s[E])?b=E+1:k=E}return b-1}function T(s,o){const h=v(s,o);return h===s.length?void 0:s[h]}function v(s,o,h=0,c=s.length){let b=h,k=c;for(;b<k;){const E=Math.floor((b+k)/2);o(s[E])?k=E:b=E+1}return b}function y(s,o,h=0,c=s.length){const b=v(s,o,h,c);return b===s.length?-1:b}class f{static{this.assertInvariants=!1}constructor(o){this.e=o,this.c=0}findLastMonotonous(o){if(f.assertInvariants){if(this.d){for(const c of this.e)if(this.d(c)&&!o(c))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=o}const h=O(this.e,o,this.c);return this.c=h+1,h===-1?void 0:this.e[h]}}t.$mb=f;function w(s,o){if(s.length===0)return;let h=s[0];for(let c=1;c<s.length;c++){const b=s[c];o(b,h)>0&&(h=b)}return h}function A(s,o){if(s.length===0)return;let h=s[0];for(let c=1;c<s.length;c++){const b=s[c];o(b,h)>=0&&(h=b)}return h}function $(s,o){return w(s,(h,c)=>-o(h,c))}function m(s,o){if(s.length===0)return-1;let h=0;for(let c=1;c<s.length;c++){const b=s[c];o(b,s[h])>0&&(h=c)}return h}function e(s,o){for(const h of s){const c=o(h);if(c!==void 0)return c}}}),define(pe[18],we([1,0]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CharCode=void 0;var i;(function(n){n[n.Null=0]="Null",n[n.Backspace=8]="Backspace",n[n.Tab=9]="Tab",n[n.LineFeed=10]="LineFeed",n[n.CarriageReturn=13]="CarriageReturn",n[n.Space=32]="Space",n[n.ExclamationMark=33]="ExclamationMark",n[n.DoubleQuote=34]="DoubleQuote",n[n.Hash=35]="Hash",n[n.DollarSign=36]="DollarSign",n[n.PercentSign=37]="PercentSign",n[n.Ampersand=38]="Ampersand",n[n.SingleQuote=39]="SingleQuote",n[n.OpenParen=40]="OpenParen",n[n.CloseParen=41]="CloseParen",n[n.Asterisk=42]="Asterisk",n[n.Plus=43]="Plus",n[n.Comma=44]="Comma",n[n.Dash=45]="Dash",n[n.Period=46]="Period",n[n.Slash=47]="Slash",n[n.Digit0=48]="Digit0",n[n.Digit1=49]="Digit1",n[n.Digit2=50]="Digit2",n[n.Digit3=51]="Digit3",n[n.Digit4=52]="Digit4",n[n.Digit5=53]="Digit5",n[n.Digit6=54]="Digit6",n[n.Digit7=55]="Digit7",n[n.Digit8=56]="Digit8",n[n.Digit9=57]="Digit9",n[n.Colon=58]="Colon",n[n.Semicolon=59]="Semicolon",n[n.LessThan=60]="LessThan",n[n.Equals=61]="Equals",n[n.GreaterThan=62]="GreaterThan",n[n.QuestionMark=63]="QuestionMark",n[n.AtSign=64]="AtSign",n[n.A=65]="A",n[n.B=66]="B",n[n.C=67]="C",n[n.D=68]="D",n[n.E=69]="E",n[n.F=70]="F",n[n.G=71]="G",n[n.H=72]="H",n[n.I=73]="I",n[n.J=74]="J",n[n.K=75]="K",n[n.L=76]="L",n[n.M=77]="M",n[n.N=78]="N",n[n.O=79]="O",n[n.P=80]="P",n[n.Q=81]="Q",n[n.R=82]="R",n[n.S=83]="S",n[n.T=84]="T",n[n.U=85]="U",n[n.V=86]="V",n[n.W=87]="W",n[n.X=88]="X",n[n.Y=89]="Y",n[n.Z=90]="Z",n[n.OpenSquareBracket=91]="OpenSquareBracket",n[n.Backslash=92]="Backslash",n[n.CloseSquareBracket=93]="CloseSquareBracket",n[n.Caret=94]="Caret",n[n.Underline=95]="Underline",n[n.BackTick=96]="BackTick",n[n.a=97]="a",n[n.b=98]="b",n[n.c=99]="c",n[n.d=100]="d",n[n.e=101]="e",n[n.f=102]="f",n[n.g=103]="g",n[n.h=104]="h",n[n.i=105]="i",n[n.j=106]="j",n[n.k=107]="k",n[n.l=108]="l",n[n.m=109]="m",n[n.n=110]="n",n[n.o=111]="o",n[n.p=112]="p",n[n.q=113]="q",n[n.r=114]="r",n[n.s=115]="s",n[n.t=116]="t",n[n.u=117]="u",n[n.v=118]="v",n[n.w=119]="w",n[n.x=120]="x",n[n.y=121]="y",n[n.z=122]="z",n[n.OpenCurlyBrace=123]="OpenCurlyBrace",n[n.Pipe=124]="Pipe",n[n.CloseCurlyBrace=125]="CloseCurlyBrace",n[n.Tilde=126]="Tilde",n[n.NoBreakSpace=160]="NoBreakSpace",n[n.U_Combining_Grave_Accent=768]="U_Combining_Grave_Accent",n[n.U_Combining_Acute_Accent=769]="U_Combining_Acute_Accent",n[n.U_Combining_Circumflex_Accent=770]="U_Combining_Circumflex_Accent",n[n.U_Combining_Tilde=771]="U_Combining_Tilde",n[n.U_Combining_Macron=772]="U_Combining_Macron",n[n.U_Combining_Overline=773]="U_Combining_Overline",n[n.U_Combining_Breve=774]="U_Combining_Breve",n[n.U_Combining_Dot_Above=775]="U_Combining_Dot_Above",n[n.U_Combining_Diaeresis=776]="U_Combining_Diaeresis",n[n.U_Combining_Hook_Above=777]="U_Combining_Hook_Above",n[n.U_Combining_Ring_Above=778]="U_Combining_Ring_Above",n[n.U_Combining_Double_Acute_Accent=779]="U_Combining_Double_Acute_Accent",n[n.U_Combining_Caron=780]="U_Combining_Caron",n[n.U_Combining_Vertical_Line_Above=781]="U_Combining_Vertical_Line_Above",n[n.U_Combining_Double_Vertical_Line_Above=782]="U_Combining_Double_Vertical_Line_Above",n[n.U_Combining_Double_Grave_Accent=783]="U_Combining_Double_Grave_Accent",n[n.U_Combining_Candrabindu=784]="U_Combining_Candrabindu",n[n.U_Combining_Inverted_Breve=785]="U_Combining_Inverted_Breve",n[n.U_Combining_Turned_Comma_Above=786]="U_Combining_Turned_Comma_Above",n[n.U_Combining_Comma_Above=787]="U_Combining_Comma_Above",n[n.U_Combining_Reversed_Comma_Above=788]="U_Combining_Reversed_Comma_Above",n[n.U_Combining_Comma_Above_Right=789]="U_Combining_Comma_Above_Right",n[n.U_Combining_Grave_Accent_Below=790]="U_Combining_Grave_Accent_Below",n[n.U_Combining_Acute_Accent_Below=791]="U_Combining_Acute_Accent_Below",n[n.U_Combining_Left_Tack_Below=792]="U_Combining_Left_Tack_Below",n[n.U_Combining_Right_Tack_Below=793]="U_Combining_Right_Tack_Below",n[n.U_Combining_Left_Angle_Above=794]="U_Combining_Left_Angle_Above",n[n.U_Combining_Horn=795]="U_Combining_Horn",n[n.U_Combining_Left_Half_Ring_Below=796]="U_Combining_Left_Half_Ring_Below",n[n.U_Combining_Up_Tack_Below=797]="U_Combining_Up_Tack_Below",n[n.U_Combining_Down_Tack_Below=798]="U_Combining_Down_Tack_Below",n[n.U_Combining_Plus_Sign_Below=799]="U_Combining_Plus_Sign_Below",n[n.U_Combining_Minus_Sign_Below=800]="U_Combining_Minus_Sign_Below",n[n.U_Combining_Palatalized_Hook_Below=801]="U_Combining_Palatalized_Hook_Below",n[n.U_Combining_Retroflex_Hook_Below=802]="U_Combining_Retroflex_Hook_Below",n[n.U_Combining_Dot_Below=803]="U_Combining_Dot_Below",n[n.U_Combining_Diaeresis_Below=804]="U_Combining_Diaeresis_Below",n[n.U_Combining_Ring_Below=805]="U_Combining_Ring_Below",n[n.U_Combining_Comma_Below=806]="U_Combining_Comma_Below",n[n.U_Combining_Cedilla=807]="U_Combining_Cedilla",n[n.U_Combining_Ogonek=808]="U_Combining_Ogonek",n[n.U_Combining_Vertical_Line_Below=809]="U_Combining_Vertical_Line_Below",n[n.U_Combining_Bridge_Below=810]="U_Combining_Bridge_Below",n[n.U_Combining_Inverted_Double_Arch_Below=811]="U_Combining_Inverted_Double_Arch_Below",n[n.U_Combining_Caron_Below=812]="U_Combining_Caron_Below",n[n.U_Combining_Circumflex_Accent_Below=813]="U_Combining_Circumflex_Accent_Below",n[n.U_Combining_Breve_Below=814]="U_Combining_Breve_Below",n[n.U_Combining_Inverted_Breve_Below=815]="U_Combining_Inverted_Breve_Below",n[n.U_Combining_Tilde_Below=816]="U_Combining_Tilde_Below",n[n.U_Combining_Macron_Below=817]="U_Combining_Macron_Below",n[n.U_Combining_Low_Line=818]="U_Combining_Low_Line",n[n.U_Combining_Double_Low_Line=819]="U_Combining_Double_Low_Line",n[n.U_Combining_Tilde_Overlay=820]="U_Combining_Tilde_Overlay",n[n.U_Combining_Short_Stroke_Overlay=821]="U_Combining_Short_Stroke_Overlay",n[n.U_Combining_Long_Stroke_Overlay=822]="U_Combining_Long_Stroke_Overlay",n[n.U_Combining_Short_Solidus_Overlay=823]="U_Combining_Short_Solidus_Overlay",n[n.U_Combining_Long_Solidus_Overlay=824]="U_Combining_Long_Solidus_Overlay",n[n.U_Combining_Right_Half_Ring_Below=825]="U_Combining_Right_Half_Ring_Below",n[n.U_Combining_Inverted_Bridge_Below=826]="U_Combining_Inverted_Bridge_Below",n[n.U_Combining_Square_Below=827]="U_Combining_Square_Below",n[n.U_Combining_Seagull_Below=828]="U_Combining_Seagull_Below",n[n.U_Combining_X_Above=829]="U_Combining_X_Above",n[n.U_Combining_Vertical_Tilde=830]="U_Combining_Vertical_Tilde",n[n.U_Combining_Double_Overline=831]="U_Combining_Double_Overline",n[n.U_Combining_Grave_Tone_Mark=832]="U_Combining_Grave_Tone_Mark",n[n.U_Combining_Acute_Tone_Mark=833]="U_Combining_Acute_Tone_Mark",n[n.U_Combining_Greek_Perispomeni=834]="U_Combining_Greek_Perispomeni",n[n.U_Combining_Greek_Koronis=835]="U_Combining_Greek_Koronis",n[n.U_Combining_Greek_Dialytika_Tonos=836]="U_Combining_Greek_Dialytika_Tonos",n[n.U_Combining_Greek_Ypogegrammeni=837]="U_Combining_Greek_Ypogegrammeni",n[n.U_Combining_Bridge_Above=838]="U_Combining_Bridge_Above",n[n.U_Combining_Equals_Sign_Below=839]="U_Combining_Equals_Sign_Below",n[n.U_Combining_Double_Vertical_Line_Below=840]="U_Combining_Double_Vertical_Line_Below",n[n.U_Combining_Left_Angle_Below=841]="U_Combining_Left_Angle_Below",n[n.U_Combining_Not_Tilde_Above=842]="U_Combining_Not_Tilde_Above",n[n.U_Combining_Homothetic_Above=843]="U_Combining_Homothetic_Above",n[n.U_Combining_Almost_Equal_To_Above=844]="U_Combining_Almost_Equal_To_Above",n[n.U_Combining_Left_Right_Arrow_Below=845]="U_Combining_Left_Right_Arrow_Below",n[n.U_Combining_Upwards_Arrow_Below=846]="U_Combining_Upwards_Arrow_Below",n[n.U_Combining_Grapheme_Joiner=847]="U_Combining_Grapheme_Joiner",n[n.U_Combining_Right_Arrowhead_Above=848]="U_Combining_Right_Arrowhead_Above",n[n.U_Combining_Left_Half_Ring_Above=849]="U_Combining_Left_Half_Ring_Above",n[n.U_Combining_Fermata=850]="U_Combining_Fermata",n[n.U_Combining_X_Below=851]="U_Combining_X_Below",n[n.U_Combining_Left_Arrowhead_Below=852]="U_Combining_Left_Arrowhead_Below",n[n.U_Combining_Right_Arrowhead_Below=853]="U_Combining_Right_Arrowhead_Below",n[n.U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below=854]="U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below",n[n.U_Combining_Right_Half_Ring_Above=855]="U_Combining_Right_Half_Ring_Above",n[n.U_Combining_Dot_Above_Right=856]="U_Combining_Dot_Above_Right",n[n.U_Combining_Asterisk_Below=857]="U_Combining_Asterisk_Below",n[n.U_Combining_Double_Ring_Below=858]="U_Combining_Double_Ring_Below",n[n.U_Combining_Zigzag_Above=859]="U_Combining_Zigzag_Above",n[n.U_Combining_Double_Breve_Below=860]="U_Combining_Double_Breve_Below",n[n.U_Combining_Double_Breve=861]="U_Combining_Double_Breve",n[n.U_Combining_Double_Macron=862]="U_Combining_Double_Macron",n[n.U_Combining_Double_Macron_Below=863]="U_Combining_Double_Macron_Below",n[n.U_Combining_Double_Tilde=864]="U_Combining_Double_Tilde",n[n.U_Combining_Double_Inverted_Breve=865]="U_Combining_Double_Inverted_Breve",n[n.U_Combining_Double_Rightwards_Arrow_Below=866]="U_Combining_Double_Rightwards_Arrow_Below",n[n.U_Combining_Latin_Small_Letter_A=867]="U_Combining_Latin_Small_Letter_A",n[n.U_Combining_Latin_Small_Letter_E=868]="U_Combining_Latin_Small_Letter_E",n[n.U_Combining_Latin_Small_Letter_I=869]="U_Combining_Latin_Small_Letter_I",n[n.U_Combining_Latin_Small_Letter_O=870]="U_Combining_Latin_Small_Letter_O",n[n.U_Combining_Latin_Small_Letter_U=871]="U_Combining_Latin_Small_Letter_U",n[n.U_Combining_Latin_Small_Letter_C=872]="U_Combining_Latin_Small_Letter_C",n[n.U_Combining_Latin_Small_Letter_D=873]="U_Combining_Latin_Small_Letter_D",n[n.U_Combining_Latin_Small_Letter_H=874]="U_Combining_Latin_Small_Letter_H",n[n.U_Combining_Latin_Small_Letter_M=875]="U_Combining_Latin_Small_Letter_M",n[n.U_Combining_Latin_Small_Letter_R=876]="U_Combining_Latin_Small_Letter_R",n[n.U_Combining_Latin_Small_Letter_T=877]="U_Combining_Latin_Small_Letter_T",n[n.U_Combining_Latin_Small_Letter_V=878]="U_Combining_Latin_Small_Letter_V",n[n.U_Combining_Latin_Small_Letter_X=879]="U_Combining_Latin_Small_Letter_X",n[n.LINE_SEPARATOR=8232]="LINE_SEPARATOR",n[n.PARAGRAPH_SEPARATOR=8233]="PARAGRAPH_SEPARATOR",n[n.NEXT_LINE=133]="NEXT_LINE",n[n.U_CIRCUMFLEX=94]="U_CIRCUMFLEX",n[n.U_GRAVE_ACCENT=96]="U_GRAVE_ACCENT",n[n.U_DIAERESIS=168]="U_DIAERESIS",n[n.U_MACRON=175]="U_MACRON",n[n.U_ACUTE_ACCENT=180]="U_ACUTE_ACCENT",n[n.U_CEDILLA=184]="U_CEDILLA",n[n.U_MODIFIER_LETTER_LEFT_ARROWHEAD=706]="U_MODIFIER_LETTER_LEFT_ARROWHEAD",n[n.U_MODIFIER_LETTER_RIGHT_ARROWHEAD=707]="U_MODIFIER_LETTER_RIGHT_ARROWHEAD",n[n.U_MODIFIER_LETTER_UP_ARROWHEAD=708]="U_MODIFIER_LETTER_UP_ARROWHEAD",n[n.U_MODIFIER_LETTER_DOWN_ARROWHEAD=709]="U_MODIFIER_LETTER_DOWN_ARROWHEAD",n[n.U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING=722]="U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING",n[n.U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING=723]="U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING",n[n.U_MODIFIER_LETTER_UP_TACK=724]="U_MODIFIER_LETTER_UP_TACK",n[n.U_MODIFIER_LETTER_DOWN_TACK=725]="U_MODIFIER_LETTER_DOWN_TACK",n[n.U_MODIFIER_LETTER_PLUS_SIGN=726]="U_MODIFIER_LETTER_PLUS_SIGN",n[n.U_MODIFIER_LETTER_MINUS_SIGN=727]="U_MODIFIER_LETTER_MINUS_SIGN",n[n.U_BREVE=728]="U_BREVE",n[n.U_DOT_ABOVE=729]="U_DOT_ABOVE",n[n.U_RING_ABOVE=730]="U_RING_ABOVE",n[n.U_OGONEK=731]="U_OGONEK",n[n.U_SMALL_TILDE=732]="U_SMALL_TILDE",n[n.U_DOUBLE_ACUTE_ACCENT=733]="U_DOUBLE_ACUTE_ACCENT",n[n.U_MODIFIER_LETTER_RHOTIC_HOOK=734]="U_MODIFIER_LETTER_RHOTIC_HOOK",n[n.U_MODIFIER_LETTER_CROSS_ACCENT=735]="U_MODIFIER_LETTER_CROSS_ACCENT",n[n.U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR=741]="U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR",n[n.U_MODIFIER_LETTER_HIGH_TONE_BAR=742]="U_MODIFIER_LETTER_HIGH_TONE_BAR",n[n.U_MODIFIER_LETTER_MID_TONE_BAR=743]="U_MODIFIER_LETTER_MID_TONE_BAR",n[n.U_MODIFIER_LETTER_LOW_TONE_BAR=744]="U_MODIFIER_LETTER_LOW_TONE_BAR",n[n.U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR=745]="U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR",n[n.U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK=746]="U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK",n[n.U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK=747]="U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK",n[n.U_MODIFIER_LETTER_UNASPIRATED=749]="U_MODIFIER_LETTER_UNASPIRATED",n[n.U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD=751]="U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD",n[n.U_MODIFIER_LETTER_LOW_UP_ARROWHEAD=752]="U_MODIFIER_LETTER_LOW_UP_ARROWHEAD",n[n.U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD=753]="U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD",n[n.U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD=754]="U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD",n[n.U_MODIFIER_LETTER_LOW_RING=755]="U_MODIFIER_LETTER_LOW_RING",n[n.U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT=756]="U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT",n[n.U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT=757]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT",n[n.U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT=758]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT",n[n.U_MODIFIER_LETTER_LOW_TILDE=759]="U_MODIFIER_LETTER_LOW_TILDE",n[n.U_MODIFIER_LETTER_RAISED_COLON=760]="U_MODIFIER_LETTER_RAISED_COLON",n[n.U_MODIFIER_LETTER_BEGIN_HIGH_TONE=761]="U_MODIFIER_LETTER_BEGIN_HIGH_TONE",n[n.U_MODIFIER_LETTER_END_HIGH_TONE=762]="U_MODIFIER_LETTER_END_HIGH_TONE",n[n.U_MODIFIER_LETTER_BEGIN_LOW_TONE=763]="U_MODIFIER_LETTER_BEGIN_LOW_TONE",n[n.U_MODIFIER_LETTER_END_LOW_TONE=764]="U_MODIFIER_LETTER_END_LOW_TONE",n[n.U_MODIFIER_LETTER_SHELF=765]="U_MODIFIER_LETTER_SHELF",n[n.U_MODIFIER_LETTER_OPEN_SHELF=766]="U_MODIFIER_LETTER_OPEN_SHELF",n[n.U_MODIFIER_LETTER_LOW_LEFT_ARROW=767]="U_MODIFIER_LETTER_LOW_LEFT_ARROW",n[n.U_GREEK_LOWER_NUMERAL_SIGN=885]="U_GREEK_LOWER_NUMERAL_SIGN",n[n.U_GREEK_TONOS=900]="U_GREEK_TONOS",n[n.U_GREEK_DIALYTIKA_TONOS=901]="U_GREEK_DIALYTIKA_TONOS",n[n.U_GREEK_KORONIS=8125]="U_GREEK_KORONIS",n[n.U_GREEK_PSILI=8127]="U_GREEK_PSILI",n[n.U_GREEK_PERISPOMENI=8128]="U_GREEK_PERISPOMENI",n[n.U_GREEK_DIALYTIKA_AND_PERISPOMENI=8129]="U_GREEK_DIALYTIKA_AND_PERISPOMENI",n[n.U_GREEK_PSILI_AND_VARIA=8141]="U_GREEK_PSILI_AND_VARIA",n[n.U_GREEK_PSILI_AND_OXIA=8142]="U_GREEK_PSILI_AND_OXIA",n[n.U_GREEK_PSILI_AND_PERISPOMENI=8143]="U_GREEK_PSILI_AND_PERISPOMENI",n[n.U_GREEK_DASIA_AND_VARIA=8157]="U_GREEK_DASIA_AND_VARIA",n[n.U_GREEK_DASIA_AND_OXIA=8158]="U_GREEK_DASIA_AND_OXIA",n[n.U_GREEK_DASIA_AND_PERISPOMENI=8159]="U_GREEK_DASIA_AND_PERISPOMENI",n[n.U_GREEK_DIALYTIKA_AND_VARIA=8173]="U_GREEK_DIALYTIKA_AND_VARIA",n[n.U_GREEK_DIALYTIKA_AND_OXIA=8174]="U_GREEK_DIALYTIKA_AND_OXIA",n[n.U_GREEK_VARIA=8175]="U_GREEK_VARIA",n[n.U_GREEK_OXIA=8189]="U_GREEK_OXIA",n[n.U_GREEK_DASIA=8190]="U_GREEK_DASIA",n[n.U_IDEOGRAPHIC_FULL_STOP=12290]="U_IDEOGRAPHIC_FULL_STOP",n[n.U_LEFT_CORNER_BRACKET=12300]="U_LEFT_CORNER_BRACKET",n[n.U_RIGHT_CORNER_BRACKET=12301]="U_RIGHT_CORNER_BRACKET",n[n.U_LEFT_BLACK_LENTICULAR_BRACKET=12304]="U_LEFT_BLACK_LENTICULAR_BRACKET",n[n.U_RIGHT_BLACK_LENTICULAR_BRACKET=12305]="U_RIGHT_BLACK_LENTICULAR_BRACKET",n[n.U_OVERLINE=8254]="U_OVERLINE",n[n.UTF8_BOM=65279]="UTF8_BOM",n[n.U_FULLWIDTH_SEMICOLON=65307]="U_FULLWIDTH_SEMICOLON",n[n.U_FULLWIDTH_COMMA=65292]="U_FULLWIDTH_COMMA"})(i||(t.CharCode=i={}))}),define(pe[88],we([1,0]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$K=i,t.$L=n,t.$M=B,t.$N=O;function i(T,v){const y=Object.create(null);for(const f of T){const w=v(f);let A=y[w];A||(A=y[w]=[]),A.push(f)}return y}function n(T,v){const y=[],f=[];for(const w of T)v.has(w)||y.push(w);for(const w of v)T.has(w)||f.push(w);return{removed:y,added:f}}function B(T,v){const y=[],f=[];for(const[w,A]of T)v.has(w)||y.push(A);for(const[w,A]of v)T.has(w)||f.push(A);return{removed:y,added:f}}function O(T,v){const y=new Set;for(const f of v)T.has(f)&&y.add(f);return y}}),define(pe[89],we([1,0,18]),function(oe,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$7s=t.$6s=t.$5s=t.$4s=void 0;function n(y,f){const w=Math.pow(10,f);return Math.round(y*w)/w}class B{constructor(f,w,A,$=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,f))|0,this.g=Math.min(255,Math.max(0,w))|0,this.b=Math.min(255,Math.max(0,A))|0,this.a=n(Math.max(Math.min(1,$),0),3)}static equals(f,w){return f.r===w.r&&f.g===w.g&&f.b===w.b&&f.a===w.a}}t.$4s=B;class O{constructor(f,w,A,$){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,f),0)|0,this.s=n(Math.max(Math.min(1,w),0),3),this.l=n(Math.max(Math.min(1,A),0),3),this.a=n(Math.max(Math.min(1,$),0),3)}static equals(f,w){return f.h===w.h&&f.s===w.s&&f.l===w.l&&f.a===w.a}static fromRGBA(f){const w=f.r/255,A=f.g/255,$=f.b/255,m=f.a,e=Math.max(w,A,$),s=Math.min(w,A,$);let o=0,h=0;const c=(s+e)/2,b=e-s;if(b>0){switch(h=Math.min(c<=.5?b/(2*c):b/(2-2*c),1),e){case w:o=(A-$)/b+(A<$?6:0);break;case A:o=($-w)/b+2;break;case $:o=(w-A)/b+4;break}o*=60,o=Math.round(o)}return new O(o,h,c,m)}static i(f,w,A){return A<0&&(A+=1),A>1&&(A-=1),A<1/6?f+(w-f)*6*A:A<1/2?w:A<2/3?f+(w-f)*(2/3-A)*6:f}static toRGBA(f){const w=f.h/360,{s:A,l:$,a:m}=f;let e,s,o;if(A===0)e=s=o=$;else{const h=$<.5?$*(1+A):$+A-$*A,c=2*$-h;e=O.i(c,h,w+1/3),s=O.i(c,h,w),o=O.i(c,h,w-1/3)}return new B(Math.round(e*255),Math.round(s*255),Math.round(o*255),m)}}t.$5s=O;class T{constructor(f,w,A,$){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,f),0)|0,this.s=n(Math.max(Math.min(1,w),0),3),this.v=n(Math.max(Math.min(1,A),0),3),this.a=n(Math.max(Math.min(1,$),0),3)}static equals(f,w){return f.h===w.h&&f.s===w.s&&f.v===w.v&&f.a===w.a}static fromRGBA(f){const w=f.r/255,A=f.g/255,$=f.b/255,m=Math.max(w,A,$),e=Math.min(w,A,$),s=m-e,o=m===0?0:s/m;let h;return s===0?h=0:m===w?h=((A-$)/s%6+6)%6:m===A?h=($-w)/s+2:h=(w-A)/s+4,new T(Math.round(h*60),o,m,f.a)}static toRGBA(f){const{h:w,s:A,v:$,a:m}=f,e=$*A,s=e*(1-Math.abs(w/60%2-1)),o=$-e;let[h,c,b]=[0,0,0];return w<60?(h=e,c=s):w<120?(h=s,c=e):w<180?(c=e,b=s):w<240?(c=s,b=e):w<300?(h=s,b=e):w<=360&&(h=e,b=s),h=Math.round((h+o)*255),c=Math.round((c+o)*255),b=Math.round((b+o)*255),new B(h,c,b,m)}}t.$6s=T;class v{static fromHex(f){return v.Format.CSS.parseHex(f)||v.red}static equals(f,w){return!f&&!w?!0:!f||!w?!1:f.equals(w)}get hsla(){return this.i?this.i:O.fromRGBA(this.rgba)}get hsva(){return this.j?this.j:T.fromRGBA(this.rgba)}constructor(f){if(f)if(f instanceof B)this.rgba=f;else if(f instanceof O)this.i=f,this.rgba=O.toRGBA(f);else if(f instanceof T)this.j=f,this.rgba=T.toRGBA(f);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(f){return!!f&&B.equals(this.rgba,f.rgba)&&O.equals(this.hsla,f.hsla)&&T.equals(this.hsva,f.hsva)}getRelativeLuminance(){const f=v.k(this.rgba.r),w=v.k(this.rgba.g),A=v.k(this.rgba.b),$=.2126*f+.7152*w+.0722*A;return n($,4)}static k(f){const w=f/255;return w<=.03928?w/12.92:Math.pow((w+.055)/1.055,2.4)}getContrastRatio(f){const w=this.getRelativeLuminance(),A=f.getRelativeLuminance();return w>A?(w+.05)/(A+.05):(A+.05)/(w+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(f){const w=this.getRelativeLuminance(),A=f.getRelativeLuminance();return w>A}isDarkerThan(f){const w=this.getRelativeLuminance(),A=f.getRelativeLuminance();return w<A}lighten(f){return new v(new O(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*f,this.hsla.a))}darken(f){return new v(new O(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*f,this.hsla.a))}transparent(f){const{r:w,g:A,b:$,a:m}=this.rgba;return new v(new B(w,A,$,m*f))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new v(new B(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(f){const w=f.rgba,A=this.rgba.a,$=w.a,m=A+$*(1-A);if(m<1e-6)return v.transparent;const e=this.rgba.r*A/m+w.r*$*(1-A)/m,s=this.rgba.g*A/m+w.g*$*(1-A)/m,o=this.rgba.b*A/m+w.b*$*(1-A)/m;return new v(new B(e,s,o,m))}makeOpaque(f){if(this.isOpaque()||f.rgba.a!==1)return this;const{r:w,g:A,b:$,a:m}=this.rgba;return new v(new B(f.rgba.r-m*(f.rgba.r-w),f.rgba.g-m*(f.rgba.g-A),f.rgba.b-m*(f.rgba.b-$),1))}flatten(...f){const w=f.reduceRight((A,$)=>v.o($,A));return v.o(this,w)}static o(f,w){const A=1-f.rgba.a;return new v(new B(A*w.rgba.r+f.rgba.a*f.rgba.r,A*w.rgba.g+f.rgba.a*f.rgba.g,A*w.rgba.b+f.rgba.a*f.rgba.b))}toString(){return this.u||(this.u=v.Format.CSS.format(this)),this.u}static getLighterColor(f,w,A){if(f.isLighterThan(w))return f;A=A||.5;const $=f.getRelativeLuminance(),m=w.getRelativeLuminance();return A=A*(m-$)/m,f.lighten(A)}static getDarkerColor(f,w,A){if(f.isDarkerThan(w))return f;A=A||.5;const $=f.getRelativeLuminance(),m=w.getRelativeLuminance();return A=A*($-m)/$,f.darken(A)}static{this.white=new v(new B(255,255,255,1))}static{this.black=new v(new B(0,0,0,1))}static{this.red=new v(new B(255,0,0,1))}static{this.blue=new v(new B(0,0,255,1))}static{this.green=new v(new B(0,255,0,1))}static{this.cyan=new v(new B(0,255,255,1))}static{this.lightgrey=new v(new B(211,211,211,1))}static{this.transparent=new v(new B(0,0,0,0))}}t.$7s=v,function(y){let f;(function(w){let A;(function($){function m(d){return d.rgba.a===1?`rgb(${d.rgba.r}, ${d.rgba.g}, ${d.rgba.b})`:y.Format.CSS.formatRGBA(d)}$.formatRGB=m;function e(d){return`rgba(${d.rgba.r}, ${d.rgba.g}, ${d.rgba.b}, ${+d.rgba.a.toFixed(2)})`}$.formatRGBA=e;function s(d){return d.hsla.a===1?`hsl(${d.hsla.h}, ${(d.hsla.s*100).toFixed(2)}%, ${(d.hsla.l*100).toFixed(2)}%)`:y.Format.CSS.formatHSLA(d)}$.formatHSL=s;function o(d){return`hsla(${d.hsla.h}, ${(d.hsla.s*100).toFixed(2)}%, ${(d.hsla.l*100).toFixed(2)}%, ${d.hsla.a.toFixed(2)})`}$.formatHSLA=o;function h(d){const D=d.toString(16);return D.length!==2?"0"+D:D}function c(d){return`#${h(d.rgba.r)}${h(d.rgba.g)}${h(d.rgba.b)}`}$.formatHex=c;function b(d,D=!1){return D&&d.rgba.a===1?y.Format.CSS.formatHex(d):`#${h(d.rgba.r)}${h(d.rgba.g)}${h(d.rgba.b)}${h(Math.round(d.rgba.a*255))}`}$.formatHexA=b;function k(d){return d.isOpaque()?y.Format.CSS.formatHex(d):y.Format.CSS.formatRGBA(d)}$.format=k;function E(d){const D=d.length;if(D===0||d.charCodeAt(0)!==i.CharCode.Hash)return null;if(D===7){const R=16*r(d.charCodeAt(1))+r(d.charCodeAt(2)),_=16*r(d.charCodeAt(3))+r(d.charCodeAt(4)),H=16*r(d.charCodeAt(5))+r(d.charCodeAt(6));return new y(new B(R,_,H,1))}if(D===9){const R=16*r(d.charCodeAt(1))+r(d.charCodeAt(2)),_=16*r(d.charCodeAt(3))+r(d.charCodeAt(4)),H=16*r(d.charCodeAt(5))+r(d.charCodeAt(6)),x=16*r(d.charCodeAt(7))+r(d.charCodeAt(8));return new y(new B(R,_,H,x/255))}if(D===4){const R=r(d.charCodeAt(1)),_=r(d.charCodeAt(2)),H=r(d.charCodeAt(3));return new y(new B(16*R+R,16*_+_,16*H+H))}if(D===5){const R=r(d.charCodeAt(1)),_=r(d.charCodeAt(2)),H=r(d.charCodeAt(3)),x=r(d.charCodeAt(4));return new y(new B(16*R+R,16*_+_,16*H+H,(16*x+x)/255))}return null}$.parseHex=E;function r(d){switch(d){case i.CharCode.Digit0:return 0;case i.CharCode.Digit1:return 1;case i.CharCode.Digit2:return 2;case i.CharCode.Digit3:return 3;case i.CharCode.Digit4:return 4;case i.CharCode.Digit5:return 5;case i.CharCode.Digit6:return 6;case i.CharCode.Digit7:return 7;case i.CharCode.Digit8:return 8;case i.CharCode.Digit9:return 9;case i.CharCode.a:return 10;case i.CharCode.A:return 10;case i.CharCode.b:return 11;case i.CharCode.B:return 11;case i.CharCode.c:return 12;case i.CharCode.C:return 12;case i.CharCode.d:return 13;case i.CharCode.D:return 13;case i.CharCode.e:return 14;case i.CharCode.E:return 14;case i.CharCode.f:return 15;case i.CharCode.F:return 15}return 0}})(A=w.CSS||(w.CSS={}))})(f=y.Format||(y.Format={}))}(v||(t.$7s=v={}))}),define(pe[34],we([1,0]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$5h=n,t.$6h=B,t.$7h=O;function i(T){return(v,y,f)=>{let w=null,A=null;if(typeof f.value=="function"?(w="value",A=f.value):typeof f.get=="function"&&(w="get",A=f.get),!A)throw new Error("not supported");f[w]=T(A,y)}}function n(T,v,y){let f=null,w=null;if(typeof y.value=="function"?(f="value",w=y.value,w.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof y.get=="function"&&(f="get",w=y.get),!w)throw new Error("not supported");const A=`$memoize$${v}`;y[f]=function(...$){return this.hasOwnProperty(A)||Object.defineProperty(this,A,{configurable:!1,enumerable:!1,writable:!1,value:w.apply(this,$)}),this[A]}}function B(T,v,y){return i((f,w)=>{const A=`$debounce$${w}`,$=`$debounce$result$${w}`;return function(...m){this[$]||(this[$]=y?y():void 0),clearTimeout(this[A]),v&&(this[$]=v(this[$],...m),m=[this[$]]),this[A]=setTimeout(()=>{f.apply(this,m),this[$]=y?y():void 0},T)}})}function O(T,v,y){return i((f,w)=>{const A=`$throttle$timer$${w}`,$=`$throttle$result$${w}`,m=`$throttle$lastRun$${w}`,e=`$throttle$pending$${w}`;return function(...s){if(this[$]||(this[$]=y?y():void 0),(this[m]===null||this[m]===void 0)&&(this[m]=-Number.MAX_VALUE),v&&(this[$]=v(this[$],...s)),this[e])return;const o=this[m]+T;o<=Date.now()?(this[m]=Date.now(),f.apply(this,[this[$]]),this[$]=y?y():void 0):(this[e]=!0,this[A]=setTimeout(()=>{this[e]=!1,this[m]=Date.now(),f.apply(this,[this[$]]),this[$]=y?y():void 0},o-Date.now()))}})}}),define(pe[90],we([1,0]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Rv=void 0;class i{constructor(B,O,T,v){this.originalStart=B,this.originalLength=O,this.modifiedStart=T,this.modifiedLength=v}getOriginalEnd(){return this.originalStart+this.originalLength}getModifiedEnd(){return this.modifiedStart+this.modifiedLength}}t.$Rv=i}),define(pe[6],we([1,0]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$cb=t.$bb=t.$ab=t.$_=t.$$=t.$9=t.$5=t.$X=t.$W=void 0,t.setUnexpectedErrorHandler=n,t.$Z=B,t.$1=O,t.$2=T,t.$3=v,t.$4=f,t.$6=A,t.$7=$,t.$8=m,t.$0=s;class i{constructor(){this.b=[],this.a=function(r){setTimeout(()=>{throw r.stack?b.isErrorNoTelemetry(r)?new b(r.message+`

`+r.stack):new Error(r.message+`

`+r.stack):r},0)}}addListener(r){return this.b.push(r),()=>{this.d(r)}}c(r){this.b.forEach(d=>{d(r)})}d(r){this.b.splice(this.b.indexOf(r),1)}setUnexpectedErrorHandler(r){this.a=r}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(r){this.a(r),this.c(r)}onUnexpectedExternalError(r){this.a(r)}}t.$W=i,t.$X=new i;function n(E){t.$X.setUnexpectedErrorHandler(E)}function B(E){if(!E||typeof E!="object")return!1;const r=E;return r.code==="EPIPE"&&r.syscall?.toUpperCase()==="WRITE"}function O(E){f(E)||t.$X.onUnexpectedError(E)}function T(E){f(E)||t.$X.onUnexpectedExternalError(E)}function v(E){if(E instanceof Error){const{name:r,message:d}=E,D=E.stacktrace||E.stack;return{$isError:!0,name:r,message:d,stack:D,noTelemetry:b.isErrorNoTelemetry(E)}}return E}const y="Canceled";function f(E){return E instanceof w?!0:E instanceof Error&&E.name===y&&E.message===y}class w extends Error{constructor(){super(y),this.name=this.message}}t.$5=w;function A(){const E=new Error(y);return E.name=E.message,E}function $(E){return E?new Error(`Illegal argument: ${E}`):new Error("Illegal argument")}function m(E){return E?new Error(`Illegal state: ${E}`):new Error("Illegal state")}class e extends TypeError{constructor(r){super(r?`${r} is read-only and cannot be changed`:"Cannot change read-only property")}}t.$9=e;function s(E){return E?E.message?E.message:E.stack?E.stack.split(`
`)[0]:String(E):"Error"}class o extends Error{constructor(r){super("NotImplemented"),r&&(this.message=r)}}t.$$=o;class h extends Error{constructor(r){super("NotSupported"),r&&(this.message=r)}}t.$_=h;class c extends Error{constructor(){super(...arguments),this.isExpected=!0}}t.$ab=c;class b extends Error{constructor(r){super(r),this.name="CodeExpectedError"}static fromError(r){if(r instanceof b)return r;const d=new b;return d.message=r.message,d.stack=r.stack,d}static isErrorNoTelemetry(r){return r.name==="CodeExpectedError"}}t.$bb=b;class k extends Error{constructor(r){super(r||"An unexpected bug occurred."),Object.setPrototypeOf(this,k.prototype)}}t.$cb=k}),define(pe[9],we([1,0,6,87]),function(oe,t,i,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ac=t.$_b=t.$$b=t.$9b=t.$8b=t.CompareResult=void 0,t.$sb=B,t.$tb=O,t.$ub=T,t.$vb=v,t.$wb=y,t.$xb=f,t.$yb=w,t.$zb=A,t.$Ab=$,t.$Bb=m,t.$Cb=e,t.$Db=s,t.$Eb=o,t.top=h,t.$Gb=c,t.$Hb=k,t.$Ib=E,t.$Jb=r,t.$Kb=d,t.$Lb=D,t.$Mb=R,t.$Nb=_,t.$Ob=H,t.$Pb=x,t.$Qb=p,t.$Rb=M,t.$Sb=U,t.$Tb=N,t.$Ub=P,t.$Vb=W,t.$Wb=ne,t.$Xb=Q,t.$Yb=Y,t.$Zb=te,t.$1b=de,t.$2b=De,t.$3b=Le,t.$4b=Se,t.$5b=ue,t.$6b=le,t.$7b=ke,t.$0b=ye;function B(ie,K=0){return ie[ie.length-(1+K)]}function O(ie){if(ie.length===0)throw new Error("Invalid tail call");return[ie.slice(0,ie.length-1),ie[ie.length-1]]}function T(ie,K,C=(a,l)=>a===l){if(ie===K)return!0;if(!ie||!K||ie.length!==K.length)return!1;for(let a=0,l=ie.length;a<l;a++)if(!C(ie[a],K[a]))return!1;return!0}function v(ie,K){const C=ie.length-1;K<C&&(ie[K]=ie[C]),ie.pop()}function y(ie,K,C){return f(ie.length,a=>C(ie[a],K))}function f(ie,K){let C=0,a=ie-1;for(;C<=a;){const l=(C+a)/2|0,g=K(l);if(g<0)C=l+1;else if(g>0)a=l-1;else return l}return-(C+1)}function w(ie,K,C){if(ie=ie|0,ie>=K.length)throw new TypeError("invalid index");const a=K[Math.floor(K.length*Math.random())],l=[],g=[],I=[];for(const F of K){const u=C(F,a);u<0?l.push(F):u>0?g.push(F):I.push(F)}return ie<l.length?w(ie,l,C):ie<l.length+I.length?I[0]:w(ie-(l.length+I.length),g,C)}function A(ie,K){const C=[];let a;for(const l of ie.slice(0).sort(K))!a||K(a[0],l)!==0?(a=[l],C.push(a)):a.push(l);return C}function*$(ie,K){let C,a;for(const l of ie)a!==void 0&&K(a,l)?C.push(l):(C&&(yield C),C=[l]),a=l;C&&(yield C)}function m(ie,K){for(let C=0;C<=ie.length;C++)K(C===0?void 0:ie[C-1],C===ie.length?void 0:ie[C])}function e(ie,K){for(let C=0;C<ie.length;C++)K(C===0?void 0:ie[C-1],ie[C],C+1===ie.length?void 0:ie[C+1])}function s(ie,K,C){const a=[];function l(F,u,L){if(u===0&&L.length===0)return;const S=a[a.length-1];S&&S.start+S.deleteCount===F?(S.deleteCount+=u,S.toInsert.push(...L)):a.push({start:F,deleteCount:u,toInsert:L})}let g=0,I=0;for(;;){if(g===ie.length){l(g,0,K.slice(I));break}if(I===K.length){l(g,ie.length-g,[]);break}const F=ie[g],u=K[I],L=C(F,u);L===0?(g+=1,I+=1):L<0?(l(g,1,[]),g+=1):L>0&&(l(g,0,[u]),I+=1)}return a}function o(ie,K,C){const a=s(ie,K,C),l=[],g=[];for(const I of a)l.push(...ie.slice(I.start,I.start+I.deleteCount)),g.push(...I.toInsert);return{removed:l,added:g}}function h(ie,K,C){if(C===0)return[];const a=ie.slice(0,C).sort(K);return b(ie,K,a,C,ie.length),a}function c(ie,K,C,a,l){return C===0?Promise.resolve([]):new Promise((g,I)=>{(async()=>{const F=ie.length,u=ie.slice(0,C).sort(K);for(let L=C,S=Math.min(C+a,F);L<F;L=S,S=Math.min(S+a,F)){if(L>C&&await new Promise(j=>setTimeout(j)),l&&l.isCancellationRequested)throw new i.$5;b(ie,K,u,L,S)}return u})().then(g,I)})}function b(ie,K,C,a,l){for(const g=C.length;a<l;a++){const I=ie[a];if(K(I,C[g-1])<0){C.pop();const F=(0,n.$kb)(C,u=>K(I,u)<0);C.splice(F,0,I)}}}function k(ie){return ie.filter(K=>!!K)}function E(ie){let K=0;for(let C=0;C<ie.length;C++)ie[C]&&(ie[K]=ie[C],K+=1);ie.length=K}function r(ie,K,C){ie.splice(C,0,ie.splice(K,1)[0])}function d(ie){return!Array.isArray(ie)||ie.length===0}function D(ie){return Array.isArray(ie)&&ie.length>0}function R(ie,K=C=>C){const C=new Set;return ie.filter(a=>{const l=K(a);return C.has(l)?!1:(C.add(l),!0)})}function _(ie){const K=new Set;return C=>{const a=ie(C);return K.has(a)?!1:(K.add(a),!0)}}function H(ie,K){return ie.length>0?ie[0]:K}function x(ie,K){return ie.length>0?ie[ie.length-1]:K}function p(ie,K,C=(a,l)=>a===l){let a=0;for(let l=0,g=Math.min(ie.length,K.length);l<g&&C(ie[l],K[l]);l++)a++;return a}function M(ie,K){let C=typeof K=="number"?ie:0;typeof K=="number"?C=ie:(C=0,K=ie);const a=[];if(C<=K)for(let l=C;l<K;l++)a.push(l);else for(let l=C;l>K;l--)a.push(l);return a}function U(ie,K,C){return ie.reduce((a,l)=>(a[K(l)]=C?C(l):l,a),Object.create(null))}function N(ie,K){return ie.push(K),()=>P(ie,K)}function P(ie,K){const C=ie.indexOf(K);if(C>-1)return ie.splice(C,1),K}function W(ie,K,C){const a=ie.slice(0,K),l=ie.slice(K);return a.concat(C,l)}function ne(ie,K){let C;if(typeof K=="number"){let a=K;C=()=>{const l=Math.sin(a++)*179426549;return l-Math.floor(l)}}else C=Math.random;for(let a=ie.length-1;a>0;a-=1){const l=Math.floor(C()*(a+1)),g=ie[a];ie[a]=ie[l],ie[l]=g}}function Q(ie,K){const C=ie.indexOf(K);C>-1&&(ie.splice(C,1),ie.unshift(K))}function Y(ie,K){const C=ie.indexOf(K);C>-1&&(ie.splice(C,1),ie.push(K))}function te(ie,K){for(const C of K)ie.push(C)}function de(ie,K){return Array.isArray(ie)?ie.map(K):K(ie)}function De(ie){return Array.isArray(ie)?ie:[ie]}function Le(ie){return ie[Math.floor(Math.random()*ie.length)]}function Se(ie,K,C){const a=J(ie,K),l=ie.length,g=C.length;ie.length=l+g;for(let I=l-1;I>=a;I--)ie[I+g]=ie[I];for(let I=0;I<g;I++)ie[I+a]=C[I]}function ue(ie,K,C,a){const l=J(ie,K);let g=ie.splice(l,C);return g===void 0&&(g=[]),Se(ie,l,a),g}function J(ie,K){return K<0?Math.max(K+ie.length,0):Math.min(K,ie.length)}var fe;(function(ie){function K(g){return g<0}ie.isLessThan=K;function C(g){return g<=0}ie.isLessThanOrEqual=C;function a(g){return g>0}ie.isGreaterThan=a;function l(g){return g===0}ie.isNeitherLessOrGreaterThan=l,ie.greaterThan=1,ie.lessThan=-1,ie.neitherLessOrGreaterThan=0})(fe||(t.CompareResult=fe={}));function le(ie,K){return(C,a)=>K(ie(C),ie(a))}function ke(...ie){return(K,C)=>{for(const a of ie){const l=a(K,C);if(!fe.isNeitherLessOrGreaterThan(l))return l}return fe.neitherLessOrGreaterThan}}const Z=(ie,K)=>ie-K;t.$8b=Z;const me=(ie,K)=>(0,t.$8b)(ie?1:0,K?1:0);t.$9b=me;function ye(ie){return(K,C)=>-ie(K,C)}class Oe{constructor(K){this.g=K,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(K){let C=this.c;for(;C<this.g.length&&K(this.g[C]);)C++;const a=C===this.c?null:this.g.slice(this.c,C);return this.c=C,a}takeFromEndWhile(K){let C=this.d;for(;C>=0&&K(this.g[C]);)C--;const a=C===this.d?null:this.g.slice(C+1,this.d+1);return this.d=C,a}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const K=this.g[this.c];return this.c++,K}removeLast(){const K=this.g[this.d];return this.d--,K}takeCount(K){const C=this.g.slice(this.c,this.c+K);return this.c+=K,C}}t.$$b=Oe;class Ie{static{this.empty=new Ie(K=>{})}constructor(K){this.iterate=K}forEach(K){this.iterate(C=>(K(C),!0))}toArray(){const K=[];return this.iterate(C=>(K.push(C),!0)),K}filter(K){return new Ie(C=>this.iterate(a=>K(a)?C(a):!0))}map(K){return new Ie(C=>this.iterate(a=>C(K(a))))}some(K){let C=!1;return this.iterate(a=>(C=K(a),!C)),C}findFirst(K){let C;return this.iterate(a=>K(a)?(C=a,!1):!0),C}findLast(K){let C;return this.iterate(a=>(K(a)&&(C=a),!0)),C}findLastMaxBy(K){let C,a=!0;return this.iterate(l=>((a||fe.isGreaterThan(K(l,C)))&&(a=!1,C=l),!0)),C}}t.$_b=Ie;class je{constructor(K){this.c=K}static createSortPermutation(K,C){const a=Array.from(K.keys()).sort((l,g)=>C(K[l],K[g]));return new je(a)}apply(K){return K.map((C,a)=>K[this.c[a]])}inverse(){const K=this.c.slice();for(let C=0;C<this.c.length;C++)K[this.c[C]]=C;return new je(K)}}t.$ac=je}),define(pe[41],we([1,0,6]),function(oe,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ok=n,t.$ed=B,t.$fd=O,t.$gd=T,t.$hd=v,t.$id=y;function n(f,w){if(!f)throw new Error(w?`Assertion failed (${w})`:"Assertion Failed")}function B(f,w="Unreachable"){throw new Error(w)}function O(f,w="unexpected state"){if(!f)throw new i.$cb(`Assertion Failed: ${w}`)}function T(f){f||(0,i.$1)(new i.$cb("Soft Assertion Failed"))}function v(f){if(!f()){debugger;f(),(0,i.$1)(new i.$cb("Assertion Failed"))}}function y(f,w){let A=0;for(;A<f.length-1;){const $=f[A],m=f[A+1];if(!w($,m))return!1;A++}return!0}}),define(pe[42],we([1,0,9]),function(oe,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$6c=void 0,t.$7c=B,t.$8c=O,t.$9c=T,t.$0c=v,t.$$c=y,t.$_c=f;const n=(m,e)=>m===e;t.$6c=n;function B(m=t.$6c){return(e,s)=>i.$ub(e,s,m)}function O(){return(m,e)=>JSON.stringify(m)===JSON.stringify(e)}function T(){return(m,e)=>m.equals(e)}function v(m,e,s){return!m||!e?m===e:s(m,e)}function y(m,e){if(m===e)return!0;if(Array.isArray(m)&&Array.isArray(e)){if(m.length!==e.length)return!1;for(let s=0;s<m.length;s++)if(!y(m[s],e[s]))return!1;return!0}if(m&&typeof m=="object"&&e&&typeof e=="object"&&Object.getPrototypeOf(m)===Object.prototype&&Object.getPrototypeOf(e)===Object.prototype){const s=m,o=e,h=Object.keys(s),c=Object.keys(o),b=new Set(c);if(h.length!==c.length)return!1;for(const k of h)if(!b.has(k)||!y(s[k],o[k]))return!1;return!0}return!1}function f(m){return JSON.stringify($(m))}let w=0;const A=new WeakMap;function $(m){if(Array.isArray(m))return m.map($);if(m&&typeof m=="object")if(Object.getPrototypeOf(m)===Object.prototype){const e=m,s=Object.create(null);for(const o of Object.keys(e).sort())s[o]=$(e[o]);return s}else{let e=A.get(m);return e===void 0&&(e=w++,A.set(m,e)),e+"----2b76a038c20c4bcc"}return m}}),define(pe[58],we([1,0]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$db=i;function i(n,B){const O=this;let T=!1,v;return function(){if(T)return v;if(T=!0,B)try{v=n.apply(O,arguments)}finally{B()}else v=n.apply(O,arguments);return v}}}),define(pe[91],we([1,0]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$1O=t.$ZO=void 0;class i{constructor(B){this.a=B,this.b=0}nextId(){return this.a+ ++this.b}}t.$ZO=i,t.$1O=new i("id#")}),define(pe[35],we([1,0]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Iterable=void 0;var i;(function(n){function B(r){return r&&typeof r=="object"&&typeof r[Symbol.iterator]=="function"}n.is=B;const O=Object.freeze([]);function T(){return O}n.empty=T;function*v(r){yield r}n.single=v;function y(r){return B(r)?r:v(r)}n.wrap=y;function f(r){return r||O}n.from=f;function*w(r){for(let d=r.length-1;d>=0;d--)yield r[d]}n.reverse=w;function A(r){return!r||r[Symbol.iterator]().next().done===!0}n.isEmpty=A;function $(r){return r[Symbol.iterator]().next().value}n.first=$;function m(r,d){for(const D of r)if(d(D))return!0;return!1}n.some=m;function e(r,d){for(const D of r)if(d(D))return D}n.find=e;function*s(r,d){for(const D of r)d(D)&&(yield D)}n.filter=s;function*o(r,d){let D=0;for(const R of r)yield d(R,D++)}n.map=o;function*h(...r){for(const d of r)yield*d}n.concat=h;function c(r,d,D){let R=D;for(const _ of r)R=d(R,_);return R}n.reduce=c;function*b(r,d,D=r.length){for(d<0&&(d+=r.length),D<0?D+=r.length:D>r.length&&(D=r.length);d<D;d++)yield r[d]}n.slice=b;function k(r,d=Number.POSITIVE_INFINITY){const D=[];if(d===0)return[D,r];const R=r[Symbol.iterator]();for(let _=0;_<d;_++){const H=R.next();if(H.done)return[D,n.empty()];D.push(H.value)}return[D,{[Symbol.iterator](){return R}}]}n.consume=k;async function E(r){const d=[];for await(const D of r)d.push(D);return Promise.resolve(d)}n.asyncToArray=E})(i||(t.Iterable=i={}))}),define(pe[8],we([1,0]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.KeyMod=t.KeyCodeUtils=t.$Lr=t.$Kr=t.$Jr=t.$Ir=t.$Hr=t.ScanCode=t.KeyCode=void 0,t.$Mr=m;var i;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.Unknown=0]="Unknown",e[e.Backspace=1]="Backspace",e[e.Tab=2]="Tab",e[e.Enter=3]="Enter",e[e.Shift=4]="Shift",e[e.Ctrl=5]="Ctrl",e[e.Alt=6]="Alt",e[e.PauseBreak=7]="PauseBreak",e[e.CapsLock=8]="CapsLock",e[e.Escape=9]="Escape",e[e.Space=10]="Space",e[e.PageUp=11]="PageUp",e[e.PageDown=12]="PageDown",e[e.End=13]="End",e[e.Home=14]="Home",e[e.LeftArrow=15]="LeftArrow",e[e.UpArrow=16]="UpArrow",e[e.RightArrow=17]="RightArrow",e[e.DownArrow=18]="DownArrow",e[e.Insert=19]="Insert",e[e.Delete=20]="Delete",e[e.Digit0=21]="Digit0",e[e.Digit1=22]="Digit1",e[e.Digit2=23]="Digit2",e[e.Digit3=24]="Digit3",e[e.Digit4=25]="Digit4",e[e.Digit5=26]="Digit5",e[e.Digit6=27]="Digit6",e[e.Digit7=28]="Digit7",e[e.Digit8=29]="Digit8",e[e.Digit9=30]="Digit9",e[e.KeyA=31]="KeyA",e[e.KeyB=32]="KeyB",e[e.KeyC=33]="KeyC",e[e.KeyD=34]="KeyD",e[e.KeyE=35]="KeyE",e[e.KeyF=36]="KeyF",e[e.KeyG=37]="KeyG",e[e.KeyH=38]="KeyH",e[e.KeyI=39]="KeyI",e[e.KeyJ=40]="KeyJ",e[e.KeyK=41]="KeyK",e[e.KeyL=42]="KeyL",e[e.KeyM=43]="KeyM",e[e.KeyN=44]="KeyN",e[e.KeyO=45]="KeyO",e[e.KeyP=46]="KeyP",e[e.KeyQ=47]="KeyQ",e[e.KeyR=48]="KeyR",e[e.KeyS=49]="KeyS",e[e.KeyT=50]="KeyT",e[e.KeyU=51]="KeyU",e[e.KeyV=52]="KeyV",e[e.KeyW=53]="KeyW",e[e.KeyX=54]="KeyX",e[e.KeyY=55]="KeyY",e[e.KeyZ=56]="KeyZ",e[e.Meta=57]="Meta",e[e.ContextMenu=58]="ContextMenu",e[e.F1=59]="F1",e[e.F2=60]="F2",e[e.F3=61]="F3",e[e.F4=62]="F4",e[e.F5=63]="F5",e[e.F6=64]="F6",e[e.F7=65]="F7",e[e.F8=66]="F8",e[e.F9=67]="F9",e[e.F10=68]="F10",e[e.F11=69]="F11",e[e.F12=70]="F12",e[e.F13=71]="F13",e[e.F14=72]="F14",e[e.F15=73]="F15",e[e.F16=74]="F16",e[e.F17=75]="F17",e[e.F18=76]="F18",e[e.F19=77]="F19",e[e.F20=78]="F20",e[e.F21=79]="F21",e[e.F22=80]="F22",e[e.F23=81]="F23",e[e.F24=82]="F24",e[e.NumLock=83]="NumLock",e[e.ScrollLock=84]="ScrollLock",e[e.Semicolon=85]="Semicolon",e[e.Equal=86]="Equal",e[e.Comma=87]="Comma",e[e.Minus=88]="Minus",e[e.Period=89]="Period",e[e.Slash=90]="Slash",e[e.Backquote=91]="Backquote",e[e.BracketLeft=92]="BracketLeft",e[e.Backslash=93]="Backslash",e[e.BracketRight=94]="BracketRight",e[e.Quote=95]="Quote",e[e.OEM_8=96]="OEM_8",e[e.IntlBackslash=97]="IntlBackslash",e[e.Numpad0=98]="Numpad0",e[e.Numpad1=99]="Numpad1",e[e.Numpad2=100]="Numpad2",e[e.Numpad3=101]="Numpad3",e[e.Numpad4=102]="Numpad4",e[e.Numpad5=103]="Numpad5",e[e.Numpad6=104]="Numpad6",e[e.Numpad7=105]="Numpad7",e[e.Numpad8=106]="Numpad8",e[e.Numpad9=107]="Numpad9",e[e.NumpadMultiply=108]="NumpadMultiply",e[e.NumpadAdd=109]="NumpadAdd",e[e.NUMPAD_SEPARATOR=110]="NUMPAD_SEPARATOR",e[e.NumpadSubtract=111]="NumpadSubtract",e[e.NumpadDecimal=112]="NumpadDecimal",e[e.NumpadDivide=113]="NumpadDivide",e[e.KEY_IN_COMPOSITION=114]="KEY_IN_COMPOSITION",e[e.ABNT_C1=115]="ABNT_C1",e[e.ABNT_C2=116]="ABNT_C2",e[e.AudioVolumeMute=117]="AudioVolumeMute",e[e.AudioVolumeUp=118]="AudioVolumeUp",e[e.AudioVolumeDown=119]="AudioVolumeDown",e[e.BrowserSearch=120]="BrowserSearch",e[e.BrowserHome=121]="BrowserHome",e[e.BrowserBack=122]="BrowserBack",e[e.BrowserForward=123]="BrowserForward",e[e.MediaTrackNext=124]="MediaTrackNext",e[e.MediaTrackPrevious=125]="MediaTrackPrevious",e[e.MediaStop=126]="MediaStop",e[e.MediaPlayPause=127]="MediaPlayPause",e[e.LaunchMediaPlayer=128]="LaunchMediaPlayer",e[e.LaunchMail=129]="LaunchMail",e[e.LaunchApp2=130]="LaunchApp2",e[e.Clear=131]="Clear",e[e.MAX_VALUE=132]="MAX_VALUE"})(i||(t.KeyCode=i={}));var n;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.None=0]="None",e[e.Hyper=1]="Hyper",e[e.Super=2]="Super",e[e.Fn=3]="Fn",e[e.FnLock=4]="FnLock",e[e.Suspend=5]="Suspend",e[e.Resume=6]="Resume",e[e.Turbo=7]="Turbo",e[e.Sleep=8]="Sleep",e[e.WakeUp=9]="WakeUp",e[e.KeyA=10]="KeyA",e[e.KeyB=11]="KeyB",e[e.KeyC=12]="KeyC",e[e.KeyD=13]="KeyD",e[e.KeyE=14]="KeyE",e[e.KeyF=15]="KeyF",e[e.KeyG=16]="KeyG",e[e.KeyH=17]="KeyH",e[e.KeyI=18]="KeyI",e[e.KeyJ=19]="KeyJ",e[e.KeyK=20]="KeyK",e[e.KeyL=21]="KeyL",e[e.KeyM=22]="KeyM",e[e.KeyN=23]="KeyN",e[e.KeyO=24]="KeyO",e[e.KeyP=25]="KeyP",e[e.KeyQ=26]="KeyQ",e[e.KeyR=27]="KeyR",e[e.KeyS=28]="KeyS",e[e.KeyT=29]="KeyT",e[e.KeyU=30]="KeyU",e[e.KeyV=31]="KeyV",e[e.KeyW=32]="KeyW",e[e.KeyX=33]="KeyX",e[e.KeyY=34]="KeyY",e[e.KeyZ=35]="KeyZ",e[e.Digit1=36]="Digit1",e[e.Digit2=37]="Digit2",e[e.Digit3=38]="Digit3",e[e.Digit4=39]="Digit4",e[e.Digit5=40]="Digit5",e[e.Digit6=41]="Digit6",e[e.Digit7=42]="Digit7",e[e.Digit8=43]="Digit8",e[e.Digit9=44]="Digit9",e[e.Digit0=45]="Digit0",e[e.Enter=46]="Enter",e[e.Escape=47]="Escape",e[e.Backspace=48]="Backspace",e[e.Tab=49]="Tab",e[e.Space=50]="Space",e[e.Minus=51]="Minus",e[e.Equal=52]="Equal",e[e.BracketLeft=53]="BracketLeft",e[e.BracketRight=54]="BracketRight",e[e.Backslash=55]="Backslash",e[e.IntlHash=56]="IntlHash",e[e.Semicolon=57]="Semicolon",e[e.Quote=58]="Quote",e[e.Backquote=59]="Backquote",e[e.Comma=60]="Comma",e[e.Period=61]="Period",e[e.Slash=62]="Slash",e[e.CapsLock=63]="CapsLock",e[e.F1=64]="F1",e[e.F2=65]="F2",e[e.F3=66]="F3",e[e.F4=67]="F4",e[e.F5=68]="F5",e[e.F6=69]="F6",e[e.F7=70]="F7",e[e.F8=71]="F8",e[e.F9=72]="F9",e[e.F10=73]="F10",e[e.F11=74]="F11",e[e.F12=75]="F12",e[e.PrintScreen=76]="PrintScreen",e[e.ScrollLock=77]="ScrollLock",e[e.Pause=78]="Pause",e[e.Insert=79]="Insert",e[e.Home=80]="Home",e[e.PageUp=81]="PageUp",e[e.Delete=82]="Delete",e[e.End=83]="End",e[e.PageDown=84]="PageDown",e[e.ArrowRight=85]="ArrowRight",e[e.ArrowLeft=86]="ArrowLeft",e[e.ArrowDown=87]="ArrowDown",e[e.ArrowUp=88]="ArrowUp",e[e.NumLock=89]="NumLock",e[e.NumpadDivide=90]="NumpadDivide",e[e.NumpadMultiply=91]="NumpadMultiply",e[e.NumpadSubtract=92]="NumpadSubtract",e[e.NumpadAdd=93]="NumpadAdd",e[e.NumpadEnter=94]="NumpadEnter",e[e.Numpad1=95]="Numpad1",e[e.Numpad2=96]="Numpad2",e[e.Numpad3=97]="Numpad3",e[e.Numpad4=98]="Numpad4",e[e.Numpad5=99]="Numpad5",e[e.Numpad6=100]="Numpad6",e[e.Numpad7=101]="Numpad7",e[e.Numpad8=102]="Numpad8",e[e.Numpad9=103]="Numpad9",e[e.Numpad0=104]="Numpad0",e[e.NumpadDecimal=105]="NumpadDecimal",e[e.IntlBackslash=106]="IntlBackslash",e[e.ContextMenu=107]="ContextMenu",e[e.Power=108]="Power",e[e.NumpadEqual=109]="NumpadEqual",e[e.F13=110]="F13",e[e.F14=111]="F14",e[e.F15=112]="F15",e[e.F16=113]="F16",e[e.F17=114]="F17",e[e.F18=115]="F18",e[e.F19=116]="F19",e[e.F20=117]="F20",e[e.F21=118]="F21",e[e.F22=119]="F22",e[e.F23=120]="F23",e[e.F24=121]="F24",e[e.Open=122]="Open",e[e.Help=123]="Help",e[e.Select=124]="Select",e[e.Again=125]="Again",e[e.Undo=126]="Undo",e[e.Cut=127]="Cut",e[e.Copy=128]="Copy",e[e.Paste=129]="Paste",e[e.Find=130]="Find",e[e.AudioVolumeMute=131]="AudioVolumeMute",e[e.AudioVolumeUp=132]="AudioVolumeUp",e[e.AudioVolumeDown=133]="AudioVolumeDown",e[e.NumpadComma=134]="NumpadComma",e[e.IntlRo=135]="IntlRo",e[e.KanaMode=136]="KanaMode",e[e.IntlYen=137]="IntlYen",e[e.Convert=138]="Convert",e[e.NonConvert=139]="NonConvert",e[e.Lang1=140]="Lang1",e[e.Lang2=141]="Lang2",e[e.Lang3=142]="Lang3",e[e.Lang4=143]="Lang4",e[e.Lang5=144]="Lang5",e[e.Abort=145]="Abort",e[e.Props=146]="Props",e[e.NumpadParenLeft=147]="NumpadParenLeft",e[e.NumpadParenRight=148]="NumpadParenRight",e[e.NumpadBackspace=149]="NumpadBackspace",e[e.NumpadMemoryStore=150]="NumpadMemoryStore",e[e.NumpadMemoryRecall=151]="NumpadMemoryRecall",e[e.NumpadMemoryClear=152]="NumpadMemoryClear",e[e.NumpadMemoryAdd=153]="NumpadMemoryAdd",e[e.NumpadMemorySubtract=154]="NumpadMemorySubtract",e[e.NumpadClear=155]="NumpadClear",e[e.NumpadClearEntry=156]="NumpadClearEntry",e[e.ControlLeft=157]="ControlLeft",e[e.ShiftLeft=158]="ShiftLeft",e[e.AltLeft=159]="AltLeft",e[e.MetaLeft=160]="MetaLeft",e[e.ControlRight=161]="ControlRight",e[e.ShiftRight=162]="ShiftRight",e[e.AltRight=163]="AltRight",e[e.MetaRight=164]="MetaRight",e[e.BrightnessUp=165]="BrightnessUp",e[e.BrightnessDown=166]="BrightnessDown",e[e.MediaPlay=167]="MediaPlay",e[e.MediaRecord=168]="MediaRecord",e[e.MediaFastForward=169]="MediaFastForward",e[e.MediaRewind=170]="MediaRewind",e[e.MediaTrackNext=171]="MediaTrackNext",e[e.MediaTrackPrevious=172]="MediaTrackPrevious",e[e.MediaStop=173]="MediaStop",e[e.Eject=174]="Eject",e[e.MediaPlayPause=175]="MediaPlayPause",e[e.MediaSelect=176]="MediaSelect",e[e.LaunchMail=177]="LaunchMail",e[e.LaunchApp2=178]="LaunchApp2",e[e.LaunchApp1=179]="LaunchApp1",e[e.SelectTask=180]="SelectTask",e[e.LaunchScreenSaver=181]="LaunchScreenSaver",e[e.BrowserSearch=182]="BrowserSearch",e[e.BrowserHome=183]="BrowserHome",e[e.BrowserBack=184]="BrowserBack",e[e.BrowserForward=185]="BrowserForward",e[e.BrowserStop=186]="BrowserStop",e[e.BrowserRefresh=187]="BrowserRefresh",e[e.BrowserFavorites=188]="BrowserFavorites",e[e.ZoomToggle=189]="ZoomToggle",e[e.MailReply=190]="MailReply",e[e.MailForward=191]="MailForward",e[e.MailSend=192]="MailSend",e[e.MAX_VALUE=193]="MAX_VALUE"})(n||(t.ScanCode=n={}));class B{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(s,o){this._keyCodeToStr[s]=o,this._strToKeyCode[o.toLowerCase()]=s}keyCodeToStr(s){return this._keyCodeToStr[s]}strToKeyCode(s){return this._strToKeyCode[s.toLowerCase()]||i.Unknown}}const O=new B,T=new B,v=new B;t.$Hr=new Array(230),t.$Ir={};const y=[],f=Object.create(null),w=Object.create(null);t.$Jr={lowerCaseToEnum:e=>w[e]||n.None,toEnum:e=>f[e]||n.None,toString:e=>y[e]||"None"},t.$Kr=[],t.$Lr=[];for(let e=0;e<=n.MAX_VALUE;e++)t.$Kr[e]=i.DependsOnKbLayout;for(let e=0;e<=i.MAX_VALUE;e++)t.$Lr[e]=n.DependsOnKbLayout;(function(){const e="",s=[[1,n.None,"None",i.Unknown,"unknown",0,"VK_UNKNOWN",e,e],[1,n.Hyper,"Hyper",i.Unknown,e,0,e,e,e],[1,n.Super,"Super",i.Unknown,e,0,e,e,e],[1,n.Fn,"Fn",i.Unknown,e,0,e,e,e],[1,n.FnLock,"FnLock",i.Unknown,e,0,e,e,e],[1,n.Suspend,"Suspend",i.Unknown,e,0,e,e,e],[1,n.Resume,"Resume",i.Unknown,e,0,e,e,e],[1,n.Turbo,"Turbo",i.Unknown,e,0,e,e,e],[1,n.Sleep,"Sleep",i.Unknown,e,0,"VK_SLEEP",e,e],[1,n.WakeUp,"WakeUp",i.Unknown,e,0,e,e,e],[0,n.KeyA,"KeyA",i.KeyA,"A",65,"VK_A",e,e],[0,n.KeyB,"KeyB",i.KeyB,"B",66,"VK_B",e,e],[0,n.KeyC,"KeyC",i.KeyC,"C",67,"VK_C",e,e],[0,n.KeyD,"KeyD",i.KeyD,"D",68,"VK_D",e,e],[0,n.KeyE,"KeyE",i.KeyE,"E",69,"VK_E",e,e],[0,n.KeyF,"KeyF",i.KeyF,"F",70,"VK_F",e,e],[0,n.KeyG,"KeyG",i.KeyG,"G",71,"VK_G",e,e],[0,n.KeyH,"KeyH",i.KeyH,"H",72,"VK_H",e,e],[0,n.KeyI,"KeyI",i.KeyI,"I",73,"VK_I",e,e],[0,n.KeyJ,"KeyJ",i.KeyJ,"J",74,"VK_J",e,e],[0,n.KeyK,"KeyK",i.KeyK,"K",75,"VK_K",e,e],[0,n.KeyL,"KeyL",i.KeyL,"L",76,"VK_L",e,e],[0,n.KeyM,"KeyM",i.KeyM,"M",77,"VK_M",e,e],[0,n.KeyN,"KeyN",i.KeyN,"N",78,"VK_N",e,e],[0,n.KeyO,"KeyO",i.KeyO,"O",79,"VK_O",e,e],[0,n.KeyP,"KeyP",i.KeyP,"P",80,"VK_P",e,e],[0,n.KeyQ,"KeyQ",i.KeyQ,"Q",81,"VK_Q",e,e],[0,n.KeyR,"KeyR",i.KeyR,"R",82,"VK_R",e,e],[0,n.KeyS,"KeyS",i.KeyS,"S",83,"VK_S",e,e],[0,n.KeyT,"KeyT",i.KeyT,"T",84,"VK_T",e,e],[0,n.KeyU,"KeyU",i.KeyU,"U",85,"VK_U",e,e],[0,n.KeyV,"KeyV",i.KeyV,"V",86,"VK_V",e,e],[0,n.KeyW,"KeyW",i.KeyW,"W",87,"VK_W",e,e],[0,n.KeyX,"KeyX",i.KeyX,"X",88,"VK_X",e,e],[0,n.KeyY,"KeyY",i.KeyY,"Y",89,"VK_Y",e,e],[0,n.KeyZ,"KeyZ",i.KeyZ,"Z",90,"VK_Z",e,e],[0,n.Digit1,"Digit1",i.Digit1,"1",49,"VK_1",e,e],[0,n.Digit2,"Digit2",i.Digit2,"2",50,"VK_2",e,e],[0,n.Digit3,"Digit3",i.Digit3,"3",51,"VK_3",e,e],[0,n.Digit4,"Digit4",i.Digit4,"4",52,"VK_4",e,e],[0,n.Digit5,"Digit5",i.Digit5,"5",53,"VK_5",e,e],[0,n.Digit6,"Digit6",i.Digit6,"6",54,"VK_6",e,e],[0,n.Digit7,"Digit7",i.Digit7,"7",55,"VK_7",e,e],[0,n.Digit8,"Digit8",i.Digit8,"8",56,"VK_8",e,e],[0,n.Digit9,"Digit9",i.Digit9,"9",57,"VK_9",e,e],[0,n.Digit0,"Digit0",i.Digit0,"0",48,"VK_0",e,e],[1,n.Enter,"Enter",i.Enter,"Enter",13,"VK_RETURN",e,e],[1,n.Escape,"Escape",i.Escape,"Escape",27,"VK_ESCAPE",e,e],[1,n.Backspace,"Backspace",i.Backspace,"Backspace",8,"VK_BACK",e,e],[1,n.Tab,"Tab",i.Tab,"Tab",9,"VK_TAB",e,e],[1,n.Space,"Space",i.Space,"Space",32,"VK_SPACE",e,e],[0,n.Minus,"Minus",i.Minus,"-",189,"VK_OEM_MINUS","-","OEM_MINUS"],[0,n.Equal,"Equal",i.Equal,"=",187,"VK_OEM_PLUS","=","OEM_PLUS"],[0,n.BracketLeft,"BracketLeft",i.BracketLeft,"[",219,"VK_OEM_4","[","OEM_4"],[0,n.BracketRight,"BracketRight",i.BracketRight,"]",221,"VK_OEM_6","]","OEM_6"],[0,n.Backslash,"Backslash",i.Backslash,"\\",220,"VK_OEM_5","\\","OEM_5"],[0,n.IntlHash,"IntlHash",i.Unknown,e,0,e,e,e],[0,n.Semicolon,"Semicolon",i.Semicolon,";",186,"VK_OEM_1",";","OEM_1"],[0,n.Quote,"Quote",i.Quote,"'",222,"VK_OEM_7","'","OEM_7"],[0,n.Backquote,"Backquote",i.Backquote,"`",192,"VK_OEM_3","`","OEM_3"],[0,n.Comma,"Comma",i.Comma,",",188,"VK_OEM_COMMA",",","OEM_COMMA"],[0,n.Period,"Period",i.Period,".",190,"VK_OEM_PERIOD",".","OEM_PERIOD"],[0,n.Slash,"Slash",i.Slash,"/",191,"VK_OEM_2","/","OEM_2"],[1,n.CapsLock,"CapsLock",i.CapsLock,"CapsLock",20,"VK_CAPITAL",e,e],[1,n.F1,"F1",i.F1,"F1",112,"VK_F1",e,e],[1,n.F2,"F2",i.F2,"F2",113,"VK_F2",e,e],[1,n.F3,"F3",i.F3,"F3",114,"VK_F3",e,e],[1,n.F4,"F4",i.F4,"F4",115,"VK_F4",e,e],[1,n.F5,"F5",i.F5,"F5",116,"VK_F5",e,e],[1,n.F6,"F6",i.F6,"F6",117,"VK_F6",e,e],[1,n.F7,"F7",i.F7,"F7",118,"VK_F7",e,e],[1,n.F8,"F8",i.F8,"F8",119,"VK_F8",e,e],[1,n.F9,"F9",i.F9,"F9",120,"VK_F9",e,e],[1,n.F10,"F10",i.F10,"F10",121,"VK_F10",e,e],[1,n.F11,"F11",i.F11,"F11",122,"VK_F11",e,e],[1,n.F12,"F12",i.F12,"F12",123,"VK_F12",e,e],[1,n.PrintScreen,"PrintScreen",i.Unknown,e,0,e,e,e],[1,n.ScrollLock,"ScrollLock",i.ScrollLock,"ScrollLock",145,"VK_SCROLL",e,e],[1,n.Pause,"Pause",i.PauseBreak,"PauseBreak",19,"VK_PAUSE",e,e],[1,n.Insert,"Insert",i.Insert,"Insert",45,"VK_INSERT",e,e],[1,n.Home,"Home",i.Home,"Home",36,"VK_HOME",e,e],[1,n.PageUp,"PageUp",i.PageUp,"PageUp",33,"VK_PRIOR",e,e],[1,n.Delete,"Delete",i.Delete,"Delete",46,"VK_DELETE",e,e],[1,n.End,"End",i.End,"End",35,"VK_END",e,e],[1,n.PageDown,"PageDown",i.PageDown,"PageDown",34,"VK_NEXT",e,e],[1,n.ArrowRight,"ArrowRight",i.RightArrow,"RightArrow",39,"VK_RIGHT","Right",e],[1,n.ArrowLeft,"ArrowLeft",i.LeftArrow,"LeftArrow",37,"VK_LEFT","Left",e],[1,n.ArrowDown,"ArrowDown",i.DownArrow,"DownArrow",40,"VK_DOWN","Down",e],[1,n.ArrowUp,"ArrowUp",i.UpArrow,"UpArrow",38,"VK_UP","Up",e],[1,n.NumLock,"NumLock",i.NumLock,"NumLock",144,"VK_NUMLOCK",e,e],[1,n.NumpadDivide,"NumpadDivide",i.NumpadDivide,"NumPad_Divide",111,"VK_DIVIDE",e,e],[1,n.NumpadMultiply,"NumpadMultiply",i.NumpadMultiply,"NumPad_Multiply",106,"VK_MULTIPLY",e,e],[1,n.NumpadSubtract,"NumpadSubtract",i.NumpadSubtract,"NumPad_Subtract",109,"VK_SUBTRACT",e,e],[1,n.NumpadAdd,"NumpadAdd",i.NumpadAdd,"NumPad_Add",107,"VK_ADD",e,e],[1,n.NumpadEnter,"NumpadEnter",i.Enter,e,0,e,e,e],[1,n.Numpad1,"Numpad1",i.Numpad1,"NumPad1",97,"VK_NUMPAD1",e,e],[1,n.Numpad2,"Numpad2",i.Numpad2,"NumPad2",98,"VK_NUMPAD2",e,e],[1,n.Numpad3,"Numpad3",i.Numpad3,"NumPad3",99,"VK_NUMPAD3",e,e],[1,n.Numpad4,"Numpad4",i.Numpad4,"NumPad4",100,"VK_NUMPAD4",e,e],[1,n.Numpad5,"Numpad5",i.Numpad5,"NumPad5",101,"VK_NUMPAD5",e,e],[1,n.Numpad6,"Numpad6",i.Numpad6,"NumPad6",102,"VK_NUMPAD6",e,e],[1,n.Numpad7,"Numpad7",i.Numpad7,"NumPad7",103,"VK_NUMPAD7",e,e],[1,n.Numpad8,"Numpad8",i.Numpad8,"NumPad8",104,"VK_NUMPAD8",e,e],[1,n.Numpad9,"Numpad9",i.Numpad9,"NumPad9",105,"VK_NUMPAD9",e,e],[1,n.Numpad0,"Numpad0",i.Numpad0,"NumPad0",96,"VK_NUMPAD0",e,e],[1,n.NumpadDecimal,"NumpadDecimal",i.NumpadDecimal,"NumPad_Decimal",110,"VK_DECIMAL",e,e],[0,n.IntlBackslash,"IntlBackslash",i.IntlBackslash,"OEM_102",226,"VK_OEM_102",e,e],[1,n.ContextMenu,"ContextMenu",i.ContextMenu,"ContextMenu",93,e,e,e],[1,n.Power,"Power",i.Unknown,e,0,e,e,e],[1,n.NumpadEqual,"NumpadEqual",i.Unknown,e,0,e,e,e],[1,n.F13,"F13",i.F13,"F13",124,"VK_F13",e,e],[1,n.F14,"F14",i.F14,"F14",125,"VK_F14",e,e],[1,n.F15,"F15",i.F15,"F15",126,"VK_F15",e,e],[1,n.F16,"F16",i.F16,"F16",127,"VK_F16",e,e],[1,n.F17,"F17",i.F17,"F17",128,"VK_F17",e,e],[1,n.F18,"F18",i.F18,"F18",129,"VK_F18",e,e],[1,n.F19,"F19",i.F19,"F19",130,"VK_F19",e,e],[1,n.F20,"F20",i.F20,"F20",131,"VK_F20",e,e],[1,n.F21,"F21",i.F21,"F21",132,"VK_F21",e,e],[1,n.F22,"F22",i.F22,"F22",133,"VK_F22",e,e],[1,n.F23,"F23",i.F23,"F23",134,"VK_F23",e,e],[1,n.F24,"F24",i.F24,"F24",135,"VK_F24",e,e],[1,n.Open,"Open",i.Unknown,e,0,e,e,e],[1,n.Help,"Help",i.Unknown,e,0,e,e,e],[1,n.Select,"Select",i.Unknown,e,0,e,e,e],[1,n.Again,"Again",i.Unknown,e,0,e,e,e],[1,n.Undo,"Undo",i.Unknown,e,0,e,e,e],[1,n.Cut,"Cut",i.Unknown,e,0,e,e,e],[1,n.Copy,"Copy",i.Unknown,e,0,e,e,e],[1,n.Paste,"Paste",i.Unknown,e,0,e,e,e],[1,n.Find,"Find",i.Unknown,e,0,e,e,e],[1,n.AudioVolumeMute,"AudioVolumeMute",i.AudioVolumeMute,"AudioVolumeMute",173,"VK_VOLUME_MUTE",e,e],[1,n.AudioVolumeUp,"AudioVolumeUp",i.AudioVolumeUp,"AudioVolumeUp",175,"VK_VOLUME_UP",e,e],[1,n.AudioVolumeDown,"AudioVolumeDown",i.AudioVolumeDown,"AudioVolumeDown",174,"VK_VOLUME_DOWN",e,e],[1,n.NumpadComma,"NumpadComma",i.NUMPAD_SEPARATOR,"NumPad_Separator",108,"VK_SEPARATOR",e,e],[0,n.IntlRo,"IntlRo",i.ABNT_C1,"ABNT_C1",193,"VK_ABNT_C1",e,e],[1,n.KanaMode,"KanaMode",i.Unknown,e,0,e,e,e],[0,n.IntlYen,"IntlYen",i.Unknown,e,0,e,e,e],[1,n.Convert,"Convert",i.Unknown,e,0,e,e,e],[1,n.NonConvert,"NonConvert",i.Unknown,e,0,e,e,e],[1,n.Lang1,"Lang1",i.Unknown,e,0,e,e,e],[1,n.Lang2,"Lang2",i.Unknown,e,0,e,e,e],[1,n.Lang3,"Lang3",i.Unknown,e,0,e,e,e],[1,n.Lang4,"Lang4",i.Unknown,e,0,e,e,e],[1,n.Lang5,"Lang5",i.Unknown,e,0,e,e,e],[1,n.Abort,"Abort",i.Unknown,e,0,e,e,e],[1,n.Props,"Props",i.Unknown,e,0,e,e,e],[1,n.NumpadParenLeft,"NumpadParenLeft",i.Unknown,e,0,e,e,e],[1,n.NumpadParenRight,"NumpadParenRight",i.Unknown,e,0,e,e,e],[1,n.NumpadBackspace,"NumpadBackspace",i.Unknown,e,0,e,e,e],[1,n.NumpadMemoryStore,"NumpadMemoryStore",i.Unknown,e,0,e,e,e],[1,n.NumpadMemoryRecall,"NumpadMemoryRecall",i.Unknown,e,0,e,e,e],[1,n.NumpadMemoryClear,"NumpadMemoryClear",i.Unknown,e,0,e,e,e],[1,n.NumpadMemoryAdd,"NumpadMemoryAdd",i.Unknown,e,0,e,e,e],[1,n.NumpadMemorySubtract,"NumpadMemorySubtract",i.Unknown,e,0,e,e,e],[1,n.NumpadClear,"NumpadClear",i.Clear,"Clear",12,"VK_CLEAR",e,e],[1,n.NumpadClearEntry,"NumpadClearEntry",i.Unknown,e,0,e,e,e],[1,n.None,e,i.Ctrl,"Ctrl",17,"VK_CONTROL",e,e],[1,n.None,e,i.Shift,"Shift",16,"VK_SHIFT",e,e],[1,n.None,e,i.Alt,"Alt",18,"VK_MENU",e,e],[1,n.None,e,i.Meta,"Meta",91,"VK_COMMAND",e,e],[1,n.ControlLeft,"ControlLeft",i.Ctrl,e,0,"VK_LCONTROL",e,e],[1,n.ShiftLeft,"ShiftLeft",i.Shift,e,0,"VK_LSHIFT",e,e],[1,n.AltLeft,"AltLeft",i.Alt,e,0,"VK_LMENU",e,e],[1,n.MetaLeft,"MetaLeft",i.Meta,e,0,"VK_LWIN",e,e],[1,n.ControlRight,"ControlRight",i.Ctrl,e,0,"VK_RCONTROL",e,e],[1,n.ShiftRight,"ShiftRight",i.Shift,e,0,"VK_RSHIFT",e,e],[1,n.AltRight,"AltRight",i.Alt,e,0,"VK_RMENU",e,e],[1,n.MetaRight,"MetaRight",i.Meta,e,0,"VK_RWIN",e,e],[1,n.BrightnessUp,"BrightnessUp",i.Unknown,e,0,e,e,e],[1,n.BrightnessDown,"BrightnessDown",i.Unknown,e,0,e,e,e],[1,n.MediaPlay,"MediaPlay",i.Unknown,e,0,e,e,e],[1,n.MediaRecord,"MediaRecord",i.Unknown,e,0,e,e,e],[1,n.MediaFastForward,"MediaFastForward",i.Unknown,e,0,e,e,e],[1,n.MediaRewind,"MediaRewind",i.Unknown,e,0,e,e,e],[1,n.MediaTrackNext,"MediaTrackNext",i.MediaTrackNext,"MediaTrackNext",176,"VK_MEDIA_NEXT_TRACK",e,e],[1,n.MediaTrackPrevious,"MediaTrackPrevious",i.MediaTrackPrevious,"MediaTrackPrevious",177,"VK_MEDIA_PREV_TRACK",e,e],[1,n.MediaStop,"MediaStop",i.MediaStop,"MediaStop",178,"VK_MEDIA_STOP",e,e],[1,n.Eject,"Eject",i.Unknown,e,0,e,e,e],[1,n.MediaPlayPause,"MediaPlayPause",i.MediaPlayPause,"MediaPlayPause",179,"VK_MEDIA_PLAY_PAUSE",e,e],[1,n.MediaSelect,"MediaSelect",i.LaunchMediaPlayer,"LaunchMediaPlayer",181,"VK_MEDIA_LAUNCH_MEDIA_SELECT",e,e],[1,n.LaunchMail,"LaunchMail",i.LaunchMail,"LaunchMail",180,"VK_MEDIA_LAUNCH_MAIL",e,e],[1,n.LaunchApp2,"LaunchApp2",i.LaunchApp2,"LaunchApp2",183,"VK_MEDIA_LAUNCH_APP2",e,e],[1,n.LaunchApp1,"LaunchApp1",i.Unknown,e,0,"VK_MEDIA_LAUNCH_APP1",e,e],[1,n.SelectTask,"SelectTask",i.Unknown,e,0,e,e,e],[1,n.LaunchScreenSaver,"LaunchScreenSaver",i.Unknown,e,0,e,e,e],[1,n.BrowserSearch,"BrowserSearch",i.BrowserSearch,"BrowserSearch",170,"VK_BROWSER_SEARCH",e,e],[1,n.BrowserHome,"BrowserHome",i.BrowserHome,"BrowserHome",172,"VK_BROWSER_HOME",e,e],[1,n.BrowserBack,"BrowserBack",i.BrowserBack,"BrowserBack",166,"VK_BROWSER_BACK",e,e],[1,n.BrowserForward,"BrowserForward",i.BrowserForward,"BrowserForward",167,"VK_BROWSER_FORWARD",e,e],[1,n.BrowserStop,"BrowserStop",i.Unknown,e,0,"VK_BROWSER_STOP",e,e],[1,n.BrowserRefresh,"BrowserRefresh",i.Unknown,e,0,"VK_BROWSER_REFRESH",e,e],[1,n.BrowserFavorites,"BrowserFavorites",i.Unknown,e,0,"VK_BROWSER_FAVORITES",e,e],[1,n.ZoomToggle,"ZoomToggle",i.Unknown,e,0,e,e,e],[1,n.MailReply,"MailReply",i.Unknown,e,0,e,e,e],[1,n.MailForward,"MailForward",i.Unknown,e,0,e,e,e],[1,n.MailSend,"MailSend",i.Unknown,e,0,e,e,e],[1,n.None,e,i.KEY_IN_COMPOSITION,"KeyInComposition",229,e,e,e],[1,n.None,e,i.ABNT_C2,"ABNT_C2",194,"VK_ABNT_C2",e,e],[1,n.None,e,i.OEM_8,"OEM_8",223,"VK_OEM_8",e,e],[1,n.None,e,i.Unknown,e,0,"VK_KANA",e,e],[1,n.None,e,i.Unknown,e,0,"VK_HANGUL",e,e],[1,n.None,e,i.Unknown,e,0,"VK_JUNJA",e,e],[1,n.None,e,i.Unknown,e,0,"VK_FINAL",e,e],[1,n.None,e,i.Unknown,e,0,"VK_HANJA",e,e],[1,n.None,e,i.Unknown,e,0,"VK_KANJI",e,e],[1,n.None,e,i.Unknown,e,0,"VK_CONVERT",e,e],[1,n.None,e,i.Unknown,e,0,"VK_NONCONVERT",e,e],[1,n.None,e,i.Unknown,e,0,"VK_ACCEPT",e,e],[1,n.None,e,i.Unknown,e,0,"VK_MODECHANGE",e,e],[1,n.None,e,i.Unknown,e,0,"VK_SELECT",e,e],[1,n.None,e,i.Unknown,e,0,"VK_PRINT",e,e],[1,n.None,e,i.Unknown,e,0,"VK_EXECUTE",e,e],[1,n.None,e,i.Unknown,e,0,"VK_SNAPSHOT",e,e],[1,n.None,e,i.Unknown,e,0,"VK_HELP",e,e],[1,n.None,e,i.Unknown,e,0,"VK_APPS",e,e],[1,n.None,e,i.Unknown,e,0,"VK_PROCESSKEY",e,e],[1,n.None,e,i.Unknown,e,0,"VK_PACKET",e,e],[1,n.None,e,i.Unknown,e,0,"VK_DBE_SBCSCHAR",e,e],[1,n.None,e,i.Unknown,e,0,"VK_DBE_DBCSCHAR",e,e],[1,n.None,e,i.Unknown,e,0,"VK_ATTN",e,e],[1,n.None,e,i.Unknown,e,0,"VK_CRSEL",e,e],[1,n.None,e,i.Unknown,e,0,"VK_EXSEL",e,e],[1,n.None,e,i.Unknown,e,0,"VK_EREOF",e,e],[1,n.None,e,i.Unknown,e,0,"VK_PLAY",e,e],[1,n.None,e,i.Unknown,e,0,"VK_ZOOM",e,e],[1,n.None,e,i.Unknown,e,0,"VK_NONAME",e,e],[1,n.None,e,i.Unknown,e,0,"VK_PA1",e,e],[1,n.None,e,i.Unknown,e,0,"VK_OEM_CLEAR",e,e]],o=[],h=[];for(const c of s){const[b,k,E,r,d,D,R,_,H]=c;if(h[k]||(h[k]=!0,y[k]=E,f[E]=k,w[E.toLowerCase()]=k,b&&(t.$Kr[k]=r,r!==i.Unknown&&r!==i.Enter&&r!==i.Ctrl&&r!==i.Shift&&r!==i.Alt&&r!==i.Meta&&(t.$Lr[r]=k))),!o[r]){if(o[r]=!0,!d)throw new Error(`String representation missing for key code ${r} around scan code ${E}`);O.define(r,d),T.define(r,_||d),v.define(r,H||_||d)}D&&(t.$Hr[D]=r),R&&(t.$Ir[R]=r)}t.$Lr[i.Enter]=n.Enter})();var A;(function(e){function s(E){return O.keyCodeToStr(E)}e.toString=s;function o(E){return O.strToKeyCode(E)}e.fromString=o;function h(E){return T.keyCodeToStr(E)}e.toUserSettingsUS=h;function c(E){return v.keyCodeToStr(E)}e.toUserSettingsGeneral=c;function b(E){return T.strToKeyCode(E)||v.strToKeyCode(E)}e.fromUserSettings=b;function k(E){if(E>=i.Numpad0&&E<=i.NumpadDivide)return null;switch(E){case i.UpArrow:return"Up";case i.DownArrow:return"Down";case i.LeftArrow:return"Left";case i.RightArrow:return"Right"}return O.keyCodeToStr(E)}e.toElectronAccelerator=k})(A||(t.KeyCodeUtils=A={}));var $;(function(e){e[e.CtrlCmd=2048]="CtrlCmd",e[e.Shift=1024]="Shift",e[e.Alt=512]="Alt",e[e.WinCtrl=256]="WinCtrl"})($||(t.KeyMod=$={}));function m(e,s){const o=(s&65535)<<16>>>0;return(e|o)>>>0}}),define(pe[26],we([1,0]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$V=void 0;class i{constructor(B){this.d=B,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(B){this.c=B}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}t.$V=i}),define(pe[15],we([1,0,26]),function(oe,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$gT=v,t.$hT=y,t.$iT=f;let B=()=>({get delay(){return-1},dispose:()=>{},showHover:()=>{}});const O=new i.$V(()=>B("mouse",!1)),T=new i.$V(()=>B("element",!1));function v(w){B=w}function y(w){return w==="element"?T.value:O.value}function f(){return B("element",!0)}}),define(pe[59],we([1,0]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$5c=void 0;class i{static{this.Undefined=new i(void 0)}constructor(O){this.element=O,this.next=i.Undefined,this.prev=i.Undefined}}class n{constructor(){this.a=i.Undefined,this.b=i.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===i.Undefined}clear(){let O=this.a;for(;O!==i.Undefined;){const T=O.next;O.prev=i.Undefined,O.next=i.Undefined,O=T}this.a=i.Undefined,this.b=i.Undefined,this.c=0}unshift(O){return this.d(O,!1)}push(O){return this.d(O,!0)}d(O,T){const v=new i(O);if(this.a===i.Undefined)this.a=v,this.b=v;else if(T){const f=this.b;this.b=v,v.prev=f,f.next=v}else{const f=this.a;this.a=v,v.next=f,f.prev=v}this.c+=1;let y=!1;return()=>{y||(y=!0,this.e(v))}}shift(){if(this.a!==i.Undefined){const O=this.a.element;return this.e(this.a),O}}pop(){if(this.b!==i.Undefined){const O=this.b.element;return this.e(this.b),O}}e(O){if(O.prev!==i.Undefined&&O.next!==i.Undefined){const T=O.prev;T.next=O.next,O.next.prev=T}else O.prev===i.Undefined&&O.next===i.Undefined?(this.a=i.Undefined,this.b=i.Undefined):O.next===i.Undefined?(this.b=this.b.prev,this.b.next=i.Undefined):O.prev===i.Undefined&&(this.a=this.a.next,this.a.prev=i.Undefined);this.c-=1}*[Symbol.iterator](){let O=this.a;for(;O!==i.Undefined;)yield O.element,O=O.next}}t.$5c=n}),define(pe[43],we([1,0]),function(oe,t){"use strict";var i,n,B;Object.defineProperty(t,"__esModule",{value:!0}),t.$Hc=t.$Gc=t.$Fc=t.$Ec=t.$Dc=t.$Cc=t.Touch=t.$Bc=t.$Ac=void 0,t.$xc=O,t.$yc=T,t.$zc=v,t.$Ic=k;function O(E,r,d){let D=E.get(r);return D===void 0&&(D=d,E.set(r,D)),D}function T(E){const r=[];return E.forEach((d,D)=>{r.push(`${D} => ${d}`)}),`Map(${E.size}) {${r.join(", ")}}`}function v(E){const r=[];return E.forEach(d=>{r.push(d)}),`Set(${E.size}) {${r.join(", ")}}`}class y{constructor(r,d){this.uri=r,this.value=d}}function f(E){return Array.isArray(E)}class w{static{this.c=r=>r.toString()}constructor(r,d){if(this[i]="ResourceMap",r instanceof w)this.d=new Map(r.d),this.e=d??w.c;else if(f(r)){this.d=new Map,this.e=d??w.c;for(const[D,R]of r)this.set(D,R)}else this.d=new Map,this.e=r??w.c}set(r,d){return this.d.set(this.e(r),new y(r,d)),this}get(r){return this.d.get(this.e(r))?.value}has(r){return this.d.has(this.e(r))}get size(){return this.d.size}clear(){this.d.clear()}delete(r){return this.d.delete(this.e(r))}forEach(r,d){typeof d<"u"&&(r=r.bind(d));for(const[D,R]of this.d)r(R.value,R.uri,this)}*values(){for(const r of this.d.values())yield r.value}*keys(){for(const r of this.d.values())yield r.uri}*entries(){for(const r of this.d.values())yield[r.uri,r.value]}*[(i=Symbol.toStringTag,Symbol.iterator)](){for(const[,r]of this.d)yield[r.uri,r.value]}}t.$Ac=w;class A{constructor(r,d){this[n]="ResourceSet",!r||typeof r=="function"?this.c=new w(r):(this.c=new w(d),r.forEach(this.add,this))}get size(){return this.c.size}add(r){return this.c.set(r,r),this}clear(){this.c.clear()}delete(r){return this.c.delete(r)}forEach(r,d){this.c.forEach((D,R)=>r.call(d,R,R,this))}has(r){return this.c.has(r)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(n=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}t.$Bc=A;var $;(function(E){E[E.None=0]="None",E[E.AsOld=1]="AsOld",E[E.AsNew=2]="AsNew"})($||(t.Touch=$={}));class m{constructor(){this[B]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has(r){return this.c.has(r)}get(r,d=$.None){const D=this.c.get(r);if(D)return d!==$.None&&this.m(D,d),D.value}set(r,d,D=$.None){let R=this.c.get(r);if(R)R.value=d,D!==$.None&&this.m(R,D);else{switch(R={key:r,value:d,next:void 0,previous:void 0},D){case $.None:this.k(R);break;case $.AsOld:this.j(R);break;case $.AsNew:this.k(R);break;default:this.k(R);break}this.c.set(r,R),this.f++}return this}delete(r){return!!this.remove(r)}remove(r){const d=this.c.get(r);if(d)return this.c.delete(r),this.l(d),this.f--,d.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const r=this.d;return this.c.delete(r.key),this.l(r),this.f--,r.value}forEach(r,d){const D=this.g;let R=this.d;for(;R;){if(d?r.bind(d)(R.value,R.key,this):r(R.value,R.key,this),this.g!==D)throw new Error("LinkedMap got modified during iteration.");R=R.next}}keys(){const r=this,d=this.g;let D=this.d;const R={[Symbol.iterator](){return R},next(){if(r.g!==d)throw new Error("LinkedMap got modified during iteration.");if(D){const _={value:D.key,done:!1};return D=D.next,_}else return{value:void 0,done:!0}}};return R}values(){const r=this,d=this.g;let D=this.d;const R={[Symbol.iterator](){return R},next(){if(r.g!==d)throw new Error("LinkedMap got modified during iteration.");if(D){const _={value:D.value,done:!1};return D=D.next,_}else return{value:void 0,done:!0}}};return R}entries(){const r=this,d=this.g;let D=this.d;const R={[Symbol.iterator](){return R},next(){if(r.g!==d)throw new Error("LinkedMap got modified during iteration.");if(D){const _={value:[D.key,D.value],done:!1};return D=D.next,_}else return{value:void 0,done:!0}}};return R}[(B=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h(r){if(r>=this.size)return;if(r===0){this.clear();return}let d=this.d,D=this.size;for(;d&&D>r;)this.c.delete(d.key),d=d.next,D--;this.d=d,this.f=D,d&&(d.previous=void 0),this.g++}i(r){if(r>=this.size)return;if(r===0){this.clear();return}let d=this.e,D=this.size;for(;d&&D>r;)this.c.delete(d.key),d=d.previous,D--;this.e=d,this.f=D,d&&(d.next=void 0),this.g++}j(r){if(!this.d&&!this.e)this.e=r;else if(this.d)r.next=this.d,this.d.previous=r;else throw new Error("Invalid list");this.d=r,this.g++}k(r){if(!this.d&&!this.e)this.d=r;else if(this.e)r.previous=this.e,this.e.next=r;else throw new Error("Invalid list");this.e=r,this.g++}l(r){if(r===this.d&&r===this.e)this.d=void 0,this.e=void 0;else if(r===this.d){if(!r.next)throw new Error("Invalid list");r.next.previous=void 0,this.d=r.next}else if(r===this.e){if(!r.previous)throw new Error("Invalid list");r.previous.next=void 0,this.e=r.previous}else{const d=r.next,D=r.previous;if(!d||!D)throw new Error("Invalid list");d.previous=D,D.next=d}r.next=void 0,r.previous=void 0,this.g++}m(r,d){if(!this.d||!this.e)throw new Error("Invalid list");if(!(d!==$.AsOld&&d!==$.AsNew)){if(d===$.AsOld){if(r===this.d)return;const D=r.next,R=r.previous;r===this.e?(R.next=void 0,this.e=R):(D.previous=R,R.next=D),r.previous=void 0,r.next=this.d,this.d.previous=r,this.d=r,this.g++}else if(d===$.AsNew){if(r===this.e)return;const D=r.next,R=r.previous;r===this.d?(D.previous=void 0,this.d=D):(D.previous=R,R.next=D),r.next=void 0,r.previous=this.e,this.e.next=r,this.e=r,this.g++}}}toJSON(){const r=[];return this.forEach((d,D)=>{r.push([D,d])}),r}fromJSON(r){this.clear();for(const[d,D]of r)this.set(d,D)}}t.$Cc=m;class e extends m{constructor(r,d=1){super(),this.n=r,this.o=Math.min(Math.max(0,d),1)}get limit(){return this.n}set limit(r){this.n=r,this.p()}get ratio(){return this.o}set ratio(r){this.o=Math.min(Math.max(0,r),1),this.p()}get(r,d=$.AsNew){return super.get(r,d)}peek(r){return super.get(r,$.None)}set(r,d){return super.set(r,d,$.AsNew),this}p(){this.size>this.n&&this.q(Math.round(this.n*this.o))}}class s extends e{constructor(r,d=1){super(r,d)}q(r){this.h(r)}set(r,d){return super.set(r,d),this.p(),this}}t.$Dc=s;class o extends e{constructor(r,d=1){super(r,d)}q(r){this.i(r)}set(r,d){return this.n<=this.size&&!this.has(r)&&this.q(Math.round(this.n*this.o)-1),super.set(r,d),this}}t.$Ec=o;class h{constructor(){this.c=new Map}add(r){return this.c.set(r,(this.c.get(r)||0)+1),this}delete(r){let d=this.c.get(r)||0;return d===0?!1:(d--,d===0?this.c.delete(r):this.c.set(r,d),!0)}has(r){return this.c.has(r)}}t.$Fc=h;class c{constructor(r){if(this.c=new Map,this.d=new Map,r)for(const[d,D]of r)this.set(d,D)}clear(){this.c.clear(),this.d.clear()}set(r,d){this.c.set(r,d),this.d.set(d,r)}get(r){return this.c.get(r)}getKey(r){return this.d.get(r)}delete(r){const d=this.c.get(r);return d===void 0?!1:(this.c.delete(r),this.d.delete(d),!0)}forEach(r,d){this.c.forEach((D,R)=>{r.call(d,D,R,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}t.$Gc=c;class b{constructor(){this.c=new Map}add(r,d){let D=this.c.get(r);D||(D=new Set,this.c.set(r,D)),D.add(d)}delete(r,d){const D=this.c.get(r);D&&(D.delete(d),D.size===0&&this.c.delete(r))}forEach(r,d){const D=this.c.get(r);D&&D.forEach(d)}get(r){const d=this.c.get(r);return d||new Set}}t.$Hc=b;function k(E,r){if(E===r)return!0;if(E.size!==r.size)return!1;for(const[d,D]of E)if(!r.has(d)||r.get(d)!==D)return!1;for(const[d]of r)if(!E.has(d))return!1;return!0}}),define(pe[2],we([1,0,9,88,43,58,35]),function(oe,t,i,n,B,O,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$4c=t.$2c=t.$1c=t.$Zc=t.$Yc=t.$Xc=t.$Wc=t.$Vc=t.$Uc=t.$Tc=t.$Jc=void 0,t.$Kc=w,t.$Lc=A,t.$Mc=$,t.$Nc=s,t.$Oc=o,t.$Pc=h,t.$Qc=c,t.$Rc=b,t.$Sc=k,t.$3c=M;const v=!1;let y=null;class f{constructor(){this.b=new Map}static{this.a=0}c(P){let W=this.b.get(P);return W||(W={parent:null,source:null,isSingleton:!1,value:P,idx:f.a++},this.b.set(P,W)),W}trackDisposable(P){const W=this.c(P);W.source||(W.source=new Error().stack)}setParent(P,W){const ne=this.c(P);ne.parent=W}markAsDisposed(P){this.b.delete(P)}markAsSingleton(P){this.c(P).isSingleton=!0}f(P,W){const ne=W.get(P);if(ne)return ne;const Q=P.parent?this.f(this.c(P.parent),W):P;return W.set(P,Q),Q}getTrackedDisposables(){const P=new Map;return[...this.b.entries()].filter(([,ne])=>ne.source!==null&&!this.f(ne,P).isSingleton).flatMap(([ne])=>ne)}computeLeakingDisposables(P=10,W){let ne;if(W)ne=W;else{const De=new Map,Le=[...this.b.values()].filter(ue=>ue.source!==null&&!this.f(ue,De).isSingleton);if(Le.length===0)return;const Se=new Set(Le.map(ue=>ue.value));if(ne=Le.filter(ue=>!(ue.parent&&Se.has(ue.parent))),ne.length===0)throw new Error("There are cyclic diposable chains!")}if(!ne)return;function Q(De){function Le(ue,J){for(;ue.length>0&&J.some(fe=>typeof fe=="string"?fe===ue[0]:ue[0].match(fe));)ue.shift()}const Se=De.source.split(`
`).map(ue=>ue.trim().replace("at ","")).filter(ue=>ue!=="");return Le(Se,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),Se.reverse()}const Y=new B.$Hc;for(const De of ne){const Le=Q(De);for(let Se=0;Se<=Le.length;Se++)Y.add(Le.slice(0,Se).join(`
`),De)}ne.sort((0,i.$6b)(De=>De.idx,i.$8b));let te="",de=0;for(const De of ne.slice(0,P)){de++;const Le=Q(De),Se=[];for(let ue=0;ue<Le.length;ue++){let J=Le[ue];J=`(shared with ${Y.get(Le.slice(0,ue+1).join(`
`)).size}/${ne.length} leaks) at ${J}`;const le=Y.get(Le.slice(0,ue).join(`
`)),ke=(0,n.$K)([...le].map(Z=>Q(Z)[ue]),Z=>Z);delete ke[Le[ue]];for(const[Z,me]of Object.entries(ke))Se.unshift(`    - stacktraces of ${me.length} other leaks continue with ${Z}`);Se.unshift(J)}te+=`


==================== Leaking disposable ${de}/${ne.length}: ${De.value.constructor.name} ====================
${Se.join(`
`)}
============================================================

`}return ne.length>P&&(te+=`


... and ${ne.length-P} more leaking disposables

`),{leaks:ne,details:te}}}t.$Jc=f;function w(N){y=N}if(v){const N="__is_disposable_tracked__";w(new class{trackDisposable(P){const W=new Error("Potentially leaked disposable").stack;setTimeout(()=>{P[N]||console.log(W)},3e3)}setParent(P,W){if(P&&P!==r.None)try{P[N]=!0}catch{}}markAsDisposed(P){if(P&&P!==r.None)try{P[N]=!0}catch{}}markAsSingleton(P){}})}function A(N){return y?.trackDisposable(N),N}function $(N){y?.markAsDisposed(N)}function m(N,P){y?.setParent(N,P)}function e(N,P){if(y)for(const W of N)y.setParent(W,P)}function s(N){return y?.markAsSingleton(N),N}function o(N){return typeof N=="object"&&N!==null&&typeof N.dispose=="function"&&N.dispose.length===0}function h(N){if(T.Iterable.is(N)){const P=[];for(const W of N)if(W)try{W.dispose()}catch(ne){P.push(ne)}if(P.length===1)throw P[0];if(P.length>1)throw new AggregateError(P,"Encountered errors while disposing of store");return Array.isArray(N)?[]:N}else if(N)return N.dispose(),N}function c(N){for(const P of N)o(P)&&P.dispose();return[]}function b(...N){const P=k(()=>h(N));return e(N,P),P}function k(N){const P=A({dispose:(0,O.$db)(()=>{$(P),N()})});return P}class E{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,A(this)}dispose(){this.g||($(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{h(this.f)}finally{this.f.clear()}}add(P){if(!P)return P;if(P===this)throw new Error("Cannot register a disposable on itself!");return m(P,this),this.g?E.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(P),P}delete(P){if(P){if(P===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(P),P.dispose()}}deleteAndLeak(P){P&&this.f.has(P)&&(this.f.delete(P),m(P,null))}}t.$Tc=E;class r{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new E,A(this),m(this.q,this)}dispose(){$(this),this.q.dispose()}B(P){if(P===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(P)}}t.$Uc=r;class d{constructor(){this.b=!1,A(this)}get value(){return this.b?void 0:this.a}set value(P){this.b||P===this.a||(this.a?.dispose(),P&&m(P,this),this.a=P)}clear(){this.value=void 0}dispose(){this.b=!0,$(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const P=this.a;return this.a=void 0,P&&m(P,null),P}}t.$Vc=d;class D{constructor(P){this.a=new d,this.b=!1,this.a.value=P}get value(){return this.a.value}set value(P){this.b||P===this.a.value||(this.a.value=P)}dispose(){this.b=!0,this.a.dispose()}}t.$Wc=D;class R{constructor(P){this.b=P,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}t.$Xc=R;class _{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,A(this)}set(P){let W=P;return this.unset=()=>W=void 0,this.isset=()=>W!==void 0,this.dispose=()=>{W&&(W(),W=void 0,$(this))},this}}t.$Yc=_;class H{constructor(){this.a=new Map}acquire(P,...W){let ne=this.a.get(P);ne||(ne={counter:0,object:this.b(P,...W)},this.a.set(P,ne));const{object:Q}=ne,Y=(0,O.$db)(()=>{--ne.counter===0&&(this.c(P,ne.object),this.a.delete(P))});return ne.counter++,{object:Q,dispose:Y}}}t.$Zc=H;class x{constructor(P){this.a=P}async acquire(P,...W){const ne=this.a.acquire(P,...W);try{return{object:await ne.object,dispose:()=>ne.dispose()}}catch(Q){throw ne.dispose(),Q}}}t.$1c=x;class p{constructor(P){this.object=P}dispose(){}}t.$2c=p;function M(N){const P=new E;try{N(P)}finally{P.dispose()}}class U{constructor(){this.a=new Map,this.b=!1,A(this)}dispose(){$(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{h(this.a.values())}finally{this.a.clear()}}has(P){return this.a.has(P)}get size(){return this.a.size}get(P){return this.a.get(P)}set(P,W,ne=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),ne||this.a.get(P)?.dispose(),this.a.set(P,W)}deleteAndDispose(P){this.a.get(P)?.dispose(),this.a.delete(P)}deleteAndLeak(P){const W=this.a.get(P);return this.a.delete(P),W}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}t.$4c=U}),function(oe,t){typeof define=="function"&&define.amd?define(pe[92],we([0]),t):typeof exports=="object"&&typeof module<"u"?t(exports):(oe=typeof globalThis<"u"?globalThis:oe||self,t(oe.marked={}))}(this,function(oe){"use strict";function t(K,C){for(var a=0;a<C.length;a++){var l=C[a];l.enumerable=l.enumerable||!1,l.configurable=!0,"value"in l&&(l.writable=!0),Object.defineProperty(K,l.key,l)}}function i(K,C,a){return C&&t(K.prototype,C),a&&t(K,a),Object.defineProperty(K,"prototype",{writable:!1}),K}function n(K,C){if(K){if(typeof K=="string")return B(K,C);var a=Object.prototype.toString.call(K).slice(8,-1);if(a==="Object"&&K.constructor&&(a=K.constructor.name),a==="Map"||a==="Set")return Array.from(K);if(a==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(a))return B(K,C)}}function B(K,C){(C==null||C>K.length)&&(C=K.length);for(var a=0,l=new Array(C);a<C;a++)l[a]=K[a];return l}function O(K,C){var a=typeof Symbol<"u"&&K[Symbol.iterator]||K["@@iterator"];if(a)return(a=a.call(K)).next.bind(a);if(Array.isArray(K)||(a=n(K))||C&&K&&typeof K.length=="number"){a&&(K=a);var l=0;return function(){return l>=K.length?{done:!0}:{done:!1,value:K[l++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function T(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}oe.defaults=T();function v(K){oe.defaults=K}var y=/[&<>"']/,f=/[&<>"']/g,w=/[<>"']|&(?!#?\w+;)/,A=/[<>"']|&(?!#?\w+;)/g,$={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},m=function(C){return $[C]};function e(K,C){if(C){if(y.test(K))return K.replace(f,m)}else if(w.test(K))return K.replace(A,m);return K}var s=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function o(K){return K.replace(s,function(C,a){return a=a.toLowerCase(),a==="colon"?":":a.charAt(0)==="#"?a.charAt(1)==="x"?String.fromCharCode(parseInt(a.substring(2),16)):String.fromCharCode(+a.substring(1)):""})}var h=/(^|[^\[])\^/g;function c(K,C){K=typeof K=="string"?K:K.source,C=C||"";var a={replace:function(g,I){return I=I.source||I,I=I.replace(h,"$1"),K=K.replace(g,I),a},getRegex:function(){return new RegExp(K,C)}};return a}var b=/[^\w:]/g,k=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function E(K,C,a){if(K){var l;try{l=decodeURIComponent(o(a)).replace(b,"").toLowerCase()}catch{return null}if(l.indexOf("javascript:")===0||l.indexOf("vbscript:")===0||l.indexOf("data:")===0)return null}C&&!k.test(a)&&(a=_(C,a));try{a=encodeURI(a).replace(/%25/g,"%")}catch{return null}return a}var r={},d=/^[^:]+:\/*[^/]*$/,D=/^([^:]+:)[\s\S]*$/,R=/^([^:]+:\/*[^/]*)[\s\S]*$/;function _(K,C){r[" "+K]||(d.test(K)?r[" "+K]=K+"/":r[" "+K]=M(K,"/",!0)),K=r[" "+K];var a=K.indexOf(":")===-1;return C.substring(0,2)==="//"?a?C:K.replace(D,"$1")+C:C.charAt(0)==="/"?a?C:K.replace(R,"$1")+C:K+C}var H={exec:function(){}};function x(K){for(var C=1,a,l;C<arguments.length;C++){a=arguments[C];for(l in a)Object.prototype.hasOwnProperty.call(a,l)&&(K[l]=a[l])}return K}function p(K,C){var a=K.replace(/\|/g,function(I,F,u){for(var L=!1,S=F;--S>=0&&u[S]==="\\";)L=!L;return L?"|":" |"}),l=a.split(/ \|/),g=0;if(l[0].trim()||l.shift(),l.length>0&&!l[l.length-1].trim()&&l.pop(),l.length>C)l.splice(C);else for(;l.length<C;)l.push("");for(;g<l.length;g++)l[g]=l[g].trim().replace(/\\\|/g,"|");return l}function M(K,C,a){var l=K.length;if(l===0)return"";for(var g=0;g<l;){var I=K.charAt(l-g-1);if(I===C&&!a)g++;else if(I!==C&&a)g++;else break}return K.slice(0,l-g)}function U(K,C){if(K.indexOf(C[1])===-1)return-1;for(var a=K.length,l=0,g=0;g<a;g++)if(K[g]==="\\")g++;else if(K[g]===C[0])l++;else if(K[g]===C[1]&&(l--,l<0))return g;return-1}function N(K){K&&K.sanitize&&!K.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function P(K,C){if(C<1)return"";for(var a="";C>1;)C&1&&(a+=K),C>>=1,K+=K;return a+K}function W(K,C,a,l){var g=C.href,I=C.title?e(C.title):null,F=K[1].replace(/\\([\[\]])/g,"$1");if(K[0].charAt(0)!=="!"){l.state.inLink=!0;var u={type:"link",raw:a,href:g,title:I,text:F,tokens:l.inlineTokens(F)};return l.state.inLink=!1,u}return{type:"image",raw:a,href:g,title:I,text:e(F)}}function ne(K,C){var a=K.match(/^(\s+)(?:```)/);if(a===null)return C;var l=a[1];return C.split(`
`).map(function(g){var I=g.match(/^\s+/);if(I===null)return g;var F=I[0];return F.length>=l.length?g.slice(l.length):g}).join(`
`)}var Q=function(){function K(a){this.options=a||oe.defaults}var C=K.prototype;return C.space=function(l){var g=this.rules.block.newline.exec(l);if(g&&g[0].length>0)return{type:"space",raw:g[0]}},C.code=function(l){var g=this.rules.block.code.exec(l);if(g){var I=g[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:g[0],codeBlockStyle:"indented",text:this.options.pedantic?I:M(I,`
`)}}},C.fences=function(l){var g=this.rules.block.fences.exec(l);if(g){var I=g[0],F=ne(I,g[3]||"");return{type:"code",raw:I,lang:g[2]?g[2].trim():g[2],text:F}}},C.heading=function(l){var g=this.rules.block.heading.exec(l);if(g){var I=g[2].trim();if(/#$/.test(I)){var F=M(I,"#");(this.options.pedantic||!F||/ $/.test(F))&&(I=F.trim())}return{type:"heading",raw:g[0],depth:g[1].length,text:I,tokens:this.lexer.inline(I)}}},C.hr=function(l){var g=this.rules.block.hr.exec(l);if(g)return{type:"hr",raw:g[0]}},C.blockquote=function(l){var g=this.rules.block.blockquote.exec(l);if(g){var I=g[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:g[0],tokens:this.lexer.blockTokens(I,[]),text:I}}},C.list=function(l){var g=this.rules.block.list.exec(l);if(g){var I,F,u,L,S,j,z,q,ee,re,ce,Ee,ve=g[1].trim(),Re=ve.length>1,Te={type:"list",raw:"",ordered:Re,start:Re?+ve.slice(0,-1):"",loose:!1,items:[]};ve=Re?"\\d{1,9}\\"+ve.slice(-1):"\\"+ve,this.options.pedantic&&(ve=Re?ve:"[*+-]");for(var he=new RegExp("^( {0,3}"+ve+")((?:[	 ][^\\n]*)?(?:\\n|$))");l&&(Ee=!1,!(!(g=he.exec(l))||this.rules.block.hr.test(l)));){if(I=g[0],l=l.substring(I.length),q=g[2].split(`
`,1)[0],ee=l.split(`
`,1)[0],this.options.pedantic?(L=2,ce=q.trimLeft()):(L=g[2].search(/[^ ]/),L=L>4?1:L,ce=q.slice(L),L+=g[1].length),j=!1,!q&&/^ *$/.test(ee)&&(I+=ee+`
`,l=l.substring(ee.length+1),Ee=!0),!Ee)for(var Fe=new RegExp("^ {0,"+Math.min(3,L-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),xe=new RegExp("^ {0,"+Math.min(3,L-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),Ye=new RegExp("^ {0,"+Math.min(3,L-1)+"}(?:```|~~~)"),et=new RegExp("^ {0,"+Math.min(3,L-1)+"}#");l&&(re=l.split(`
`,1)[0],q=re,this.options.pedantic&&(q=q.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(Ye.test(q)||et.test(q)||Fe.test(q)||xe.test(l)));){if(q.search(/[^ ]/)>=L||!q.trim())ce+=`
`+q.slice(L);else if(!j)ce+=`
`+q;else break;!j&&!q.trim()&&(j=!0),I+=re+`
`,l=l.substring(re.length+1)}Te.loose||(z?Te.loose=!0:/\n *\n *$/.test(I)&&(z=!0)),this.options.gfm&&(F=/^\[[ xX]\] /.exec(ce),F&&(u=F[0]!=="[ ] ",ce=ce.replace(/^\[[ xX]\] +/,""))),Te.items.push({type:"list_item",raw:I,task:!!F,checked:u,loose:!1,text:ce}),Te.raw+=I}Te.items[Te.items.length-1].raw=I.trimRight(),Te.items[Te.items.length-1].text=ce.trimRight(),Te.raw=Te.raw.trimRight();var ot=Te.items.length;for(S=0;S<ot;S++){this.lexer.state.top=!1,Te.items[S].tokens=this.lexer.blockTokens(Te.items[S].text,[]);var it=Te.items[S].tokens.filter(function(Xe){return Xe.type==="space"}),Ke=it.every(function(Xe){for(var X=Xe.raw.split(""),ae=0,$e=O(X),Ae;!(Ae=$e()).done;){var Pe=Ae.value;if(Pe===`
`&&(ae+=1),ae>1)return!0}return!1});!Te.loose&&it.length&&Ke&&(Te.loose=!0,Te.items[S].loose=!0)}return Te}},C.html=function(l){var g=this.rules.block.html.exec(l);if(g){var I={type:"html",raw:g[0],pre:!this.options.sanitizer&&(g[1]==="pre"||g[1]==="script"||g[1]==="style"),text:g[0]};if(this.options.sanitize){var F=this.options.sanitizer?this.options.sanitizer(g[0]):e(g[0]);I.type="paragraph",I.text=F,I.tokens=this.lexer.inline(F)}return I}},C.def=function(l){var g=this.rules.block.def.exec(l);if(g){g[3]&&(g[3]=g[3].substring(1,g[3].length-1));var I=g[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:I,raw:g[0],href:g[2],title:g[3]}}},C.table=function(l){var g=this.rules.block.table.exec(l);if(g){var I={type:"table",header:p(g[1]).map(function(z){return{text:z}}),align:g[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:g[3]&&g[3].trim()?g[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(I.header.length===I.align.length){I.raw=g[0];var F=I.align.length,u,L,S,j;for(u=0;u<F;u++)/^ *-+: *$/.test(I.align[u])?I.align[u]="right":/^ *:-+: *$/.test(I.align[u])?I.align[u]="center":/^ *:-+ *$/.test(I.align[u])?I.align[u]="left":I.align[u]=null;for(F=I.rows.length,u=0;u<F;u++)I.rows[u]=p(I.rows[u],I.header.length).map(function(z){return{text:z}});for(F=I.header.length,L=0;L<F;L++)I.header[L].tokens=this.lexer.inline(I.header[L].text);for(F=I.rows.length,L=0;L<F;L++)for(j=I.rows[L],S=0;S<j.length;S++)j[S].tokens=this.lexer.inline(j[S].text);return I}}},C.lheading=function(l){var g=this.rules.block.lheading.exec(l);if(g)return{type:"heading",raw:g[0],depth:g[2].charAt(0)==="="?1:2,text:g[1],tokens:this.lexer.inline(g[1])}},C.paragraph=function(l){var g=this.rules.block.paragraph.exec(l);if(g){var I=g[1].charAt(g[1].length-1)===`
`?g[1].slice(0,-1):g[1];return{type:"paragraph",raw:g[0],text:I,tokens:this.lexer.inline(I)}}},C.text=function(l){var g=this.rules.block.text.exec(l);if(g)return{type:"text",raw:g[0],text:g[0],tokens:this.lexer.inline(g[0])}},C.escape=function(l){var g=this.rules.inline.escape.exec(l);if(g)return{type:"escape",raw:g[0],text:e(g[1])}},C.tag=function(l){var g=this.rules.inline.tag.exec(l);if(g)return!this.lexer.state.inLink&&/^<a /i.test(g[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(g[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(g[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(g[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:g[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(g[0]):e(g[0]):g[0]}},C.link=function(l){var g=this.rules.inline.link.exec(l);if(g){var I=g[2].trim();if(!this.options.pedantic&&/^</.test(I)){if(!/>$/.test(I))return;var F=M(I.slice(0,-1),"\\");if((I.length-F.length)%2===0)return}else{var u=U(g[2],"()");if(u>-1){var L=g[0].indexOf("!")===0?5:4,S=L+g[1].length+u;g[2]=g[2].substring(0,u),g[0]=g[0].substring(0,S).trim(),g[3]=""}}var j=g[2],z="";if(this.options.pedantic){var q=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(j);q&&(j=q[1],z=q[3])}else z=g[3]?g[3].slice(1,-1):"";return j=j.trim(),/^</.test(j)&&(this.options.pedantic&&!/>$/.test(I)?j=j.slice(1):j=j.slice(1,-1)),W(g,{href:j&&j.replace(this.rules.inline._escapes,"$1"),title:z&&z.replace(this.rules.inline._escapes,"$1")},g[0],this.lexer)}},C.reflink=function(l,g){var I;if((I=this.rules.inline.reflink.exec(l))||(I=this.rules.inline.nolink.exec(l))){var F=(I[2]||I[1]).replace(/\s+/g," ");if(F=g[F.toLowerCase()],!F||!F.href){var u=I[0].charAt(0);return{type:"text",raw:u,text:u}}return W(I,F,I[0],this.lexer)}},C.emStrong=function(l,g,I){I===void 0&&(I="");var F=this.rules.inline.emStrong.lDelim.exec(l);if(F&&!(F[3]&&I.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var u=F[1]||F[2]||"";if(!u||u&&(I===""||this.rules.inline.punctuation.exec(I))){var L=F[0].length-1,S,j,z=L,q=0,ee=F[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(ee.lastIndex=0,g=g.slice(-1*l.length+L);(F=ee.exec(g))!=null;)if(S=F[1]||F[2]||F[3]||F[4]||F[5]||F[6],!!S){if(j=S.length,F[3]||F[4]){z+=j;continue}else if((F[5]||F[6])&&L%3&&!((L+j)%3)){q+=j;continue}if(z-=j,!(z>0)){if(j=Math.min(j,j+z+q),Math.min(L,j)%2){var re=l.slice(1,L+F.index+j);return{type:"em",raw:l.slice(0,L+F.index+j+1),text:re,tokens:this.lexer.inlineTokens(re)}}var ce=l.slice(2,L+F.index+j-1);return{type:"strong",raw:l.slice(0,L+F.index+j+1),text:ce,tokens:this.lexer.inlineTokens(ce)}}}}}},C.codespan=function(l){var g=this.rules.inline.code.exec(l);if(g){var I=g[2].replace(/\n/g," "),F=/[^ ]/.test(I),u=/^ /.test(I)&&/ $/.test(I);return F&&u&&(I=I.substring(1,I.length-1)),I=e(I,!0),{type:"codespan",raw:g[0],text:I}}},C.br=function(l){var g=this.rules.inline.br.exec(l);if(g)return{type:"br",raw:g[0]}},C.del=function(l){var g=this.rules.inline.del.exec(l);if(g)return{type:"del",raw:g[0],text:g[2],tokens:this.lexer.inlineTokens(g[2])}},C.autolink=function(l,g){var I=this.rules.inline.autolink.exec(l);if(I){var F,u;return I[2]==="@"?(F=e(this.options.mangle?g(I[1]):I[1]),u="mailto:"+F):(F=e(I[1]),u=F),{type:"link",raw:I[0],text:F,href:u,tokens:[{type:"text",raw:F,text:F}]}}},C.url=function(l,g){var I;if(I=this.rules.inline.url.exec(l)){var F,u;if(I[2]==="@")F=e(this.options.mangle?g(I[0]):I[0]),u="mailto:"+F;else{var L;do L=I[0],I[0]=this.rules.inline._backpedal.exec(I[0])[0];while(L!==I[0]);F=e(I[0]),I[1]==="www."?u="http://"+F:u=F}return{type:"link",raw:I[0],text:F,href:u,tokens:[{type:"text",raw:F,text:F}]}}},C.inlineText=function(l,g){var I=this.rules.inline.text.exec(l);if(I){var F;return this.lexer.state.inRawBlock?F=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(I[0]):e(I[0]):I[0]:F=e(this.options.smartypants?g(I[0]):I[0]),{type:"text",raw:I[0],text:F}}},K}(),Y={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:H,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};Y._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,Y._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,Y.def=c(Y.def).replace("label",Y._label).replace("title",Y._title).getRegex(),Y.bullet=/(?:[*+-]|\d{1,9}[.)])/,Y.listItemStart=c(/^( *)(bull) */).replace("bull",Y.bullet).getRegex(),Y.list=c(Y.list).replace(/bull/g,Y.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+Y.def.source+")").getRegex(),Y._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",Y._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,Y.html=c(Y.html,"i").replace("comment",Y._comment).replace("tag",Y._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),Y.paragraph=c(Y._paragraph).replace("hr",Y.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",Y._tag).getRegex(),Y.blockquote=c(Y.blockquote).replace("paragraph",Y.paragraph).getRegex(),Y.normal=x({},Y),Y.gfm=x({},Y.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),Y.gfm.table=c(Y.gfm.table).replace("hr",Y.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",Y._tag).getRegex(),Y.gfm.paragraph=c(Y._paragraph).replace("hr",Y.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",Y.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",Y._tag).getRegex(),Y.pedantic=x({},Y.normal,{html:c(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",Y._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:H,paragraph:c(Y.normal._paragraph).replace("hr",Y.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",Y.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var te={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:H,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:H,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};te._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",te.punctuation=c(te.punctuation).replace(/punctuation/g,te._punctuation).getRegex(),te.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,te.escapedEmSt=/\\\*|\\_/g,te._comment=c(Y._comment).replace("(?:-->|$)","-->").getRegex(),te.emStrong.lDelim=c(te.emStrong.lDelim).replace(/punct/g,te._punctuation).getRegex(),te.emStrong.rDelimAst=c(te.emStrong.rDelimAst,"g").replace(/punct/g,te._punctuation).getRegex(),te.emStrong.rDelimUnd=c(te.emStrong.rDelimUnd,"g").replace(/punct/g,te._punctuation).getRegex(),te._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,te._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,te._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,te.autolink=c(te.autolink).replace("scheme",te._scheme).replace("email",te._email).getRegex(),te._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,te.tag=c(te.tag).replace("comment",te._comment).replace("attribute",te._attribute).getRegex(),te._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,te._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,te._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,te.link=c(te.link).replace("label",te._label).replace("href",te._href).replace("title",te._title).getRegex(),te.reflink=c(te.reflink).replace("label",te._label).replace("ref",Y._label).getRegex(),te.nolink=c(te.nolink).replace("ref",Y._label).getRegex(),te.reflinkSearch=c(te.reflinkSearch,"g").replace("reflink",te.reflink).replace("nolink",te.nolink).getRegex(),te.normal=x({},te),te.pedantic=x({},te.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:c(/^!?\[(label)\]\((.*?)\)/).replace("label",te._label).getRegex(),reflink:c(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",te._label).getRegex()}),te.gfm=x({},te.normal,{escape:c(te.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),te.gfm.url=c(te.gfm.url,"i").replace("email",te.gfm._extended_email).getRegex(),te.breaks=x({},te.gfm,{br:c(te.br).replace("{2,}","*").getRegex(),text:c(te.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function de(K){return K.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function De(K){var C="",a,l,g=K.length;for(a=0;a<g;a++)l=K.charCodeAt(a),Math.random()>.5&&(l="x"+l.toString(16)),C+="&#"+l+";";return C}var Le=function(){function K(a){this.tokens=[],this.tokens.links=Object.create(null),this.options=a||oe.defaults,this.options.tokenizer=this.options.tokenizer||new Q,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var l={block:Y.normal,inline:te.normal};this.options.pedantic?(l.block=Y.pedantic,l.inline=te.pedantic):this.options.gfm&&(l.block=Y.gfm,this.options.breaks?l.inline=te.breaks:l.inline=te.gfm),this.tokenizer.rules=l}K.lex=function(l,g){var I=new K(g);return I.lex(l)},K.lexInline=function(l,g){var I=new K(g);return I.inlineTokens(l)};var C=K.prototype;return C.lex=function(l){l=l.replace(/\r\n|\r/g,`
`),this.blockTokens(l,this.tokens);for(var g;g=this.inlineQueue.shift();)this.inlineTokens(g.src,g.tokens);return this.tokens},C.blockTokens=function(l,g){var I=this;g===void 0&&(g=[]),this.options.pedantic?l=l.replace(/\t/g,"    ").replace(/^ +$/gm,""):l=l.replace(/^( *)(\t+)/gm,function(z,q,ee){return q+"    ".repeat(ee.length)});for(var F,u,L,S;l;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(z){return(F=z.call({lexer:I},l,g))?(l=l.substring(F.raw.length),g.push(F),!0):!1}))){if(F=this.tokenizer.space(l)){l=l.substring(F.raw.length),F.raw.length===1&&g.length>0?g[g.length-1].raw+=`
`:g.push(F);continue}if(F=this.tokenizer.code(l)){l=l.substring(F.raw.length),u=g[g.length-1],u&&(u.type==="paragraph"||u.type==="text")?(u.raw+=`
`+F.raw,u.text+=`
`+F.text,this.inlineQueue[this.inlineQueue.length-1].src=u.text):g.push(F);continue}if(F=this.tokenizer.fences(l)){l=l.substring(F.raw.length),g.push(F);continue}if(F=this.tokenizer.heading(l)){l=l.substring(F.raw.length),g.push(F);continue}if(F=this.tokenizer.hr(l)){l=l.substring(F.raw.length),g.push(F);continue}if(F=this.tokenizer.blockquote(l)){l=l.substring(F.raw.length),g.push(F);continue}if(F=this.tokenizer.list(l)){l=l.substring(F.raw.length),g.push(F);continue}if(F=this.tokenizer.html(l)){l=l.substring(F.raw.length),g.push(F);continue}if(F=this.tokenizer.def(l)){l=l.substring(F.raw.length),u=g[g.length-1],u&&(u.type==="paragraph"||u.type==="text")?(u.raw+=`
`+F.raw,u.text+=`
`+F.raw,this.inlineQueue[this.inlineQueue.length-1].src=u.text):this.tokens.links[F.tag]||(this.tokens.links[F.tag]={href:F.href,title:F.title});continue}if(F=this.tokenizer.table(l)){l=l.substring(F.raw.length),g.push(F);continue}if(F=this.tokenizer.lheading(l)){l=l.substring(F.raw.length),g.push(F);continue}if(L=l,this.options.extensions&&this.options.extensions.startBlock&&function(){var z=1/0,q=l.slice(1),ee=void 0;I.options.extensions.startBlock.forEach(function(re){ee=re.call({lexer:this},q),typeof ee=="number"&&ee>=0&&(z=Math.min(z,ee))}),z<1/0&&z>=0&&(L=l.substring(0,z+1))}(),this.state.top&&(F=this.tokenizer.paragraph(L))){u=g[g.length-1],S&&u.type==="paragraph"?(u.raw+=`
`+F.raw,u.text+=`
`+F.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=u.text):g.push(F),S=L.length!==l.length,l=l.substring(F.raw.length);continue}if(F=this.tokenizer.text(l)){l=l.substring(F.raw.length),u=g[g.length-1],u&&u.type==="text"?(u.raw+=`
`+F.raw,u.text+=`
`+F.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=u.text):g.push(F);continue}if(l){var j="Infinite loop on byte: "+l.charCodeAt(0);if(this.options.silent){console.error(j);break}else throw new Error(j)}}return this.state.top=!0,g},C.inline=function(l,g){return g===void 0&&(g=[]),this.inlineQueue.push({src:l,tokens:g}),g},C.inlineTokens=function(l,g){var I=this;g===void 0&&(g=[]);var F,u,L,S=l,j,z,q;if(this.tokens.links){var ee=Object.keys(this.tokens.links);if(ee.length>0)for(;(j=this.tokenizer.rules.inline.reflinkSearch.exec(S))!=null;)ee.includes(j[0].slice(j[0].lastIndexOf("[")+1,-1))&&(S=S.slice(0,j.index)+"["+P("a",j[0].length-2)+"]"+S.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(j=this.tokenizer.rules.inline.blockSkip.exec(S))!=null;)S=S.slice(0,j.index)+"["+P("a",j[0].length-2)+"]"+S.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(j=this.tokenizer.rules.inline.escapedEmSt.exec(S))!=null;)S=S.slice(0,j.index)+"++"+S.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;l;)if(z||(q=""),z=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(ce){return(F=ce.call({lexer:I},l,g))?(l=l.substring(F.raw.length),g.push(F),!0):!1}))){if(F=this.tokenizer.escape(l)){l=l.substring(F.raw.length),g.push(F);continue}if(F=this.tokenizer.tag(l)){l=l.substring(F.raw.length),u=g[g.length-1],u&&F.type==="text"&&u.type==="text"?(u.raw+=F.raw,u.text+=F.text):g.push(F);continue}if(F=this.tokenizer.link(l)){l=l.substring(F.raw.length),g.push(F);continue}if(F=this.tokenizer.reflink(l,this.tokens.links)){l=l.substring(F.raw.length),u=g[g.length-1],u&&F.type==="text"&&u.type==="text"?(u.raw+=F.raw,u.text+=F.text):g.push(F);continue}if(F=this.tokenizer.emStrong(l,S,q)){l=l.substring(F.raw.length),g.push(F);continue}if(F=this.tokenizer.codespan(l)){l=l.substring(F.raw.length),g.push(F);continue}if(F=this.tokenizer.br(l)){l=l.substring(F.raw.length),g.push(F);continue}if(F=this.tokenizer.del(l)){l=l.substring(F.raw.length),g.push(F);continue}if(F=this.tokenizer.autolink(l,De)){l=l.substring(F.raw.length),g.push(F);continue}if(!this.state.inLink&&(F=this.tokenizer.url(l,De))){l=l.substring(F.raw.length),g.push(F);continue}if(L=l,this.options.extensions&&this.options.extensions.startInline&&function(){var ce=1/0,Ee=l.slice(1),ve=void 0;I.options.extensions.startInline.forEach(function(Re){ve=Re.call({lexer:this},Ee),typeof ve=="number"&&ve>=0&&(ce=Math.min(ce,ve))}),ce<1/0&&ce>=0&&(L=l.substring(0,ce+1))}(),F=this.tokenizer.inlineText(L,de)){l=l.substring(F.raw.length),F.raw.slice(-1)!=="_"&&(q=F.raw.slice(-1)),z=!0,u=g[g.length-1],u&&u.type==="text"?(u.raw+=F.raw,u.text+=F.text):g.push(F);continue}if(l){var re="Infinite loop on byte: "+l.charCodeAt(0);if(this.options.silent){console.error(re);break}else throw new Error(re)}}return g},i(K,null,[{key:"rules",get:function(){return{block:Y,inline:te}}}]),K}(),Se=function(){function K(a){this.options=a||oe.defaults}var C=K.prototype;return C.code=function(l,g,I){var F=(g||"").match(/\S*/)[0];if(this.options.highlight){var u=this.options.highlight(l,F);u!=null&&u!==l&&(I=!0,l=u)}return l=l.replace(/\n$/,"")+`
`,F?'<pre><code class="'+this.options.langPrefix+e(F,!0)+'">'+(I?l:e(l,!0))+`</code></pre>
`:"<pre><code>"+(I?l:e(l,!0))+`</code></pre>
`},C.blockquote=function(l){return`<blockquote>
`+l+`</blockquote>
`},C.html=function(l){return l},C.heading=function(l,g,I,F){if(this.options.headerIds){var u=this.options.headerPrefix+F.slug(I);return"<h"+g+' id="'+u+'">'+l+"</h"+g+`>
`}return"<h"+g+">"+l+"</h"+g+`>
`},C.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},C.list=function(l,g,I){var F=g?"ol":"ul",u=g&&I!==1?' start="'+I+'"':"";return"<"+F+u+`>
`+l+"</"+F+`>
`},C.listitem=function(l){return"<li>"+l+`</li>
`},C.checkbox=function(l){return"<input "+(l?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},C.paragraph=function(l){return"<p>"+l+`</p>
`},C.table=function(l,g){return g&&(g="<tbody>"+g+"</tbody>"),`<table>
<thead>
`+l+`</thead>
`+g+`</table>
`},C.tablerow=function(l){return`<tr>
`+l+`</tr>
`},C.tablecell=function(l,g){var I=g.header?"th":"td",F=g.align?"<"+I+' align="'+g.align+'">':"<"+I+">";return F+l+("</"+I+`>
`)},C.strong=function(l){return"<strong>"+l+"</strong>"},C.em=function(l){return"<em>"+l+"</em>"},C.codespan=function(l){return"<code>"+l+"</code>"},C.br=function(){return this.options.xhtml?"<br/>":"<br>"},C.del=function(l){return"<del>"+l+"</del>"},C.link=function(l,g,I){if(l=E(this.options.sanitize,this.options.baseUrl,l),l===null)return I;var F='<a href="'+e(l)+'"';return g&&(F+=' title="'+g+'"'),F+=">"+I+"</a>",F},C.image=function(l,g,I){if(l=E(this.options.sanitize,this.options.baseUrl,l),l===null)return I;var F='<img src="'+l+'" alt="'+I+'"';return g&&(F+=' title="'+g+'"'),F+=this.options.xhtml?"/>":">",F},C.text=function(l){return l},K}(),ue=function(){function K(){}var C=K.prototype;return C.strong=function(l){return l},C.em=function(l){return l},C.codespan=function(l){return l},C.del=function(l){return l},C.html=function(l){return l},C.text=function(l){return l},C.link=function(l,g,I){return""+I},C.image=function(l,g,I){return""+I},C.br=function(){return""},K}(),J=function(){function K(){this.seen={}}var C=K.prototype;return C.serialize=function(l){return l.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},C.getNextSafeSlug=function(l,g){var I=l,F=0;if(this.seen.hasOwnProperty(I)){F=this.seen[l];do F++,I=l+"-"+F;while(this.seen.hasOwnProperty(I))}return g||(this.seen[l]=F,this.seen[I]=0),I},C.slug=function(l,g){g===void 0&&(g={});var I=this.serialize(l);return this.getNextSafeSlug(I,g.dryrun)},K}(),fe=function(){function K(a){this.options=a||oe.defaults,this.options.renderer=this.options.renderer||new Se,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new ue,this.slugger=new J}K.parse=function(l,g){var I=new K(g);return I.parse(l)},K.parseInline=function(l,g){var I=new K(g);return I.parseInline(l)};var C=K.prototype;return C.parse=function(l,g){g===void 0&&(g=!0);var I="",F,u,L,S,j,z,q,ee,re,ce,Ee,ve,Re,Te,he,Fe,xe,Ye,et,ot=l.length;for(F=0;F<ot;F++){if(ce=l[F],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ce.type]&&(et=this.options.extensions.renderers[ce.type].call({parser:this},ce),et!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(ce.type))){I+=et||"";continue}switch(ce.type){case"space":continue;case"hr":{I+=this.renderer.hr();continue}case"heading":{I+=this.renderer.heading(this.parseInline(ce.tokens),ce.depth,o(this.parseInline(ce.tokens,this.textRenderer)),this.slugger);continue}case"code":{I+=this.renderer.code(ce.text,ce.lang,ce.escaped);continue}case"table":{for(ee="",q="",S=ce.header.length,u=0;u<S;u++)q+=this.renderer.tablecell(this.parseInline(ce.header[u].tokens),{header:!0,align:ce.align[u]});for(ee+=this.renderer.tablerow(q),re="",S=ce.rows.length,u=0;u<S;u++){for(z=ce.rows[u],q="",j=z.length,L=0;L<j;L++)q+=this.renderer.tablecell(this.parseInline(z[L].tokens),{header:!1,align:ce.align[L]});re+=this.renderer.tablerow(q)}I+=this.renderer.table(ee,re);continue}case"blockquote":{re=this.parse(ce.tokens),I+=this.renderer.blockquote(re);continue}case"list":{for(Ee=ce.ordered,ve=ce.start,Re=ce.loose,S=ce.items.length,re="",u=0;u<S;u++)he=ce.items[u],Fe=he.checked,xe=he.task,Te="",he.task&&(Ye=this.renderer.checkbox(Fe),Re?he.tokens.length>0&&he.tokens[0].type==="paragraph"?(he.tokens[0].text=Ye+" "+he.tokens[0].text,he.tokens[0].tokens&&he.tokens[0].tokens.length>0&&he.tokens[0].tokens[0].type==="text"&&(he.tokens[0].tokens[0].text=Ye+" "+he.tokens[0].tokens[0].text)):he.tokens.unshift({type:"text",text:Ye}):Te+=Ye),Te+=this.parse(he.tokens,Re),re+=this.renderer.listitem(Te,xe,Fe);I+=this.renderer.list(re,Ee,ve);continue}case"html":{I+=this.renderer.html(ce.text);continue}case"paragraph":{I+=this.renderer.paragraph(this.parseInline(ce.tokens));continue}case"text":{for(re=ce.tokens?this.parseInline(ce.tokens):ce.text;F+1<ot&&l[F+1].type==="text";)ce=l[++F],re+=`
`+(ce.tokens?this.parseInline(ce.tokens):ce.text);I+=g?this.renderer.paragraph(re):re;continue}default:{var it='Token with "'+ce.type+'" type was not found.';if(this.options.silent){console.error(it);return}else throw new Error(it)}}}return I},C.parseInline=function(l,g){g=g||this.renderer;var I="",F,u,L,S=l.length;for(F=0;F<S;F++){if(u=l[F],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[u.type]&&(L=this.options.extensions.renderers[u.type].call({parser:this},u),L!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(u.type))){I+=L||"";continue}switch(u.type){case"escape":{I+=g.text(u.text);break}case"html":{I+=g.html(u.text);break}case"link":{I+=g.link(u.href,u.title,this.parseInline(u.tokens,g));break}case"image":{I+=g.image(u.href,u.title,u.text);break}case"strong":{I+=g.strong(this.parseInline(u.tokens,g));break}case"em":{I+=g.em(this.parseInline(u.tokens,g));break}case"codespan":{I+=g.codespan(u.text);break}case"br":{I+=g.br();break}case"del":{I+=g.del(this.parseInline(u.tokens,g));break}case"text":{I+=g.text(u.text);break}default:{var j='Token with "'+u.type+'" type was not found.';if(this.options.silent){console.error(j);return}else throw new Error(j)}}}return I},K}();function le(K,C,a){if(typeof K>"u"||K===null)throw new Error("marked(): input parameter is undefined or null");if(typeof K!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(K)+", string expected");if(typeof C=="function"&&(a=C,C=null),C=x({},le.defaults,C||{}),N(C),a){var l=C.highlight,g;try{g=Le.lex(K,C)}catch(S){return a(S)}var I=function(j){var z;if(!j)try{C.walkTokens&&le.walkTokens(g,C.walkTokens),z=fe.parse(g,C)}catch(q){j=q}return C.highlight=l,j?a(j):a(null,z)};if(!l||l.length<3||(delete C.highlight,!g.length))return I();var F=0;le.walkTokens(g,function(S){S.type==="code"&&(F++,setTimeout(function(){l(S.text,S.lang,function(j,z){if(j)return I(j);z!=null&&z!==S.text&&(S.text=z,S.escaped=!0),F--,F===0&&I()})},0))}),F===0&&I();return}function u(S){if(S.message+=`
Please report this to https://github.com/markedjs/marked.`,C.silent)return"<p>An error occurred:</p><pre>"+e(S.message+"",!0)+"</pre>";throw S}try{var L=Le.lex(K,C);if(C.walkTokens){if(C.async)return Promise.all(le.walkTokens(L,C.walkTokens)).then(function(){return fe.parse(L,C)}).catch(u);le.walkTokens(L,C.walkTokens)}return fe.parse(L,C)}catch(S){u(S)}}le.options=le.setOptions=function(K){return x(le.defaults,K),v(le.defaults),le},le.getDefaults=T,le.defaults=oe.defaults,le.use=function(){for(var K=arguments.length,C=new Array(K),a=0;a<K;a++)C[a]=arguments[a];var l=x.apply(void 0,[{}].concat(C)),g=le.defaults.extensions||{renderers:{},childTokens:{}},I;C.forEach(function(F){if(F.extensions&&(I=!0,F.extensions.forEach(function(L){if(!L.name)throw new Error("extension name required");if(L.renderer){var S=g.renderers?g.renderers[L.name]:null;S?g.renderers[L.name]=function(){for(var j=arguments.length,z=new Array(j),q=0;q<j;q++)z[q]=arguments[q];var ee=L.renderer.apply(this,z);return ee===!1&&(ee=S.apply(this,z)),ee}:g.renderers[L.name]=L.renderer}if(L.tokenizer){if(!L.level||L.level!=="block"&&L.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");g[L.level]?g[L.level].unshift(L.tokenizer):g[L.level]=[L.tokenizer],L.start&&(L.level==="block"?g.startBlock?g.startBlock.push(L.start):g.startBlock=[L.start]:L.level==="inline"&&(g.startInline?g.startInline.push(L.start):g.startInline=[L.start]))}L.childTokens&&(g.childTokens[L.name]=L.childTokens)})),F.renderer&&function(){var L=le.defaults.renderer||new Se,S=function(q){var ee=L[q];L[q]=function(){for(var re=arguments.length,ce=new Array(re),Ee=0;Ee<re;Ee++)ce[Ee]=arguments[Ee];var ve=F.renderer[q].apply(L,ce);return ve===!1&&(ve=ee.apply(L,ce)),ve}};for(var j in F.renderer)S(j);l.renderer=L}(),F.tokenizer&&function(){var L=le.defaults.tokenizer||new Q,S=function(q){var ee=L[q];L[q]=function(){for(var re=arguments.length,ce=new Array(re),Ee=0;Ee<re;Ee++)ce[Ee]=arguments[Ee];var ve=F.tokenizer[q].apply(L,ce);return ve===!1&&(ve=ee.apply(L,ce)),ve}};for(var j in F.tokenizer)S(j);l.tokenizer=L}(),F.walkTokens){var u=le.defaults.walkTokens;l.walkTokens=function(L){var S=[];return S.push(F.walkTokens.call(this,L)),u&&(S=S.concat(u.call(this,L))),S}}I&&(l.extensions=g),le.setOptions(l)})},le.walkTokens=function(K,C){for(var a=[],l=function(){var u=I.value;switch(a=a.concat(C.call(le,u)),u.type){case"table":{for(var L=O(u.header),S;!(S=L()).done;){var j=S.value;a=a.concat(le.walkTokens(j.tokens,C))}for(var z=O(u.rows),q;!(q=z()).done;)for(var ee=q.value,re=O(ee),ce;!(ce=re()).done;){var Ee=ce.value;a=a.concat(le.walkTokens(Ee.tokens,C))}break}case"list":{a=a.concat(le.walkTokens(u.items,C));break}default:le.defaults.extensions&&le.defaults.extensions.childTokens&&le.defaults.extensions.childTokens[u.type]?le.defaults.extensions.childTokens[u.type].forEach(function(ve){a=a.concat(le.walkTokens(u[ve],C))}):u.tokens&&(a=a.concat(le.walkTokens(u.tokens,C)))}},g=O(K),I;!(I=g()).done;)l();return a},le.parseInline=function(K,C){if(typeof K>"u"||K===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof K!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(K)+", string expected");C=x({},le.defaults,C||{}),N(C);try{var a=Le.lexInline(K,C);return C.walkTokens&&le.walkTokens(a,C.walkTokens),fe.parseInline(a,C)}catch(l){if(l.message+=`
Please report this to https://github.com/markedjs/marked.`,C.silent)return"<p>An error occurred:</p><pre>"+e(l.message+"",!0)+"</pre>";throw l}},le.Parser=fe,le.parser=fe.parse,le.Renderer=Se,le.TextRenderer=ue,le.Lexer=Le,le.lexer=Le.lex,le.Tokenizer=Q,le.Slugger=J,le.parse=le;var ke=le.options,Z=le.setOptions,me=le.use,ye=le.walkTokens,Oe=le.parseInline,Ie=le,je=fe.parse,ie=Le.lex;oe.Lexer=Le,oe.Parser=fe,oe.Renderer=Se,oe.Slugger=J,oe.TextRenderer=ue,oe.Tokenizer=Q,oe.getDefaults=T,oe.lexer=ie,oe.marked=le,oe.options=ke,oe.parse=Ie,oe.parseInline=Oe,oe.parser=je,oe.setOptions=Z,oe.use=me,oe.walkTokens=ye,Object.defineProperty(oe,"__esModule",{value:!0})}),define(pe[60],we([1,0]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.MarshalledId=void 0;var i;(function(n){n[n.Uri=1]="Uri",n[n.Regexp=2]="Regexp",n[n.ScmResource=3]="ScmResource",n[n.ScmResourceGroup=4]="ScmResourceGroup",n[n.ScmProvider=5]="ScmProvider",n[n.CommentController=6]="CommentController",n[n.CommentThread=7]="CommentThread",n[n.CommentThreadInstance=8]="CommentThreadInstance",n[n.CommentThreadReply=9]="CommentThreadReply",n[n.CommentNode=10]="CommentNode",n[n.CommentThreadNode=11]="CommentThreadNode",n[n.TimelineActionContext=12]="TimelineActionContext",n[n.NotebookCellActionContext=13]="NotebookCellActionContext",n[n.NotebookActionContext=14]="NotebookActionContext",n[n.TerminalContext=15]="TerminalContext",n[n.TestItemContext=16]="TestItemContext",n[n.Date=17]="Date",n[n.TestMessageMenuArgs=18]="TestMessageMenuArgs"})(i||(t.MarshalledId=i={}))}),define(pe[93],we([1,0]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$zk=i;function i(s){const o=O(s);if(o&&o.length>0)return new Uint32Array(o)}let n=0;const B=new Uint32Array(10);function O(s){if(n=0,T(s,A,y.InitialConsonant),n>0||(T(s,$,y.Vowel),n>0)||(T(s,m,y.FinalConsonant),n>0)||(T(s,e,y.CompatibilityJamo),n))return B.subarray(0,n);if(s>=44032&&s<=55203){const o=s-44032,h=o%588,c=Math.floor(o/588),b=Math.floor(h/28),k=h%28-1;if(c<A.length?T(c,A,0):y.InitialConsonant+c-y.CompatibilityJamo<e.length&&T(y.InitialConsonant+c,e,y.CompatibilityJamo),b<$.length?T(b,$,0):y.Vowel+b-y.CompatibilityJamo<e.length&&T(y.Vowel+b-y.CompatibilityJamo,e,y.CompatibilityJamo),k>=0&&(k<m.length?T(k,m,0):y.FinalConsonant+k-y.CompatibilityJamo<e.length&&T(y.FinalConsonant+k-y.CompatibilityJamo,e,y.CompatibilityJamo)),n>0)return B.subarray(0,n)}}function T(s,o,h){s>=h&&s<h+o.length&&v(o[s-h])}function v(s){s!==f.NUL&&(B[n++]=s&255,s>>8&&(B[n++]=s>>8&255),s>>16&&(B[n++]=s>>16&255))}var y;(function(s){s[s.InitialConsonant=4352]="InitialConsonant",s[s.Vowel=4449]="Vowel",s[s.FinalConsonant=4520]="FinalConsonant",s[s.CompatibilityJamo=12593]="CompatibilityJamo"})(y||(y={}));var f;(function(s){s[s.NUL=0]="NUL",s[s.A=65]="A",s[s.B=66]="B",s[s.C=67]="C",s[s.D=68]="D",s[s.E=69]="E",s[s.F=70]="F",s[s.G=71]="G",s[s.H=72]="H",s[s.I=73]="I",s[s.J=74]="J",s[s.K=75]="K",s[s.L=76]="L",s[s.M=77]="M",s[s.N=78]="N",s[s.O=79]="O",s[s.P=80]="P",s[s.Q=81]="Q",s[s.R=82]="R",s[s.S=83]="S",s[s.T=84]="T",s[s.U=85]="U",s[s.V=86]="V",s[s.W=87]="W",s[s.X=88]="X",s[s.Y=89]="Y",s[s.Z=90]="Z",s[s.a=97]="a",s[s.b=98]="b",s[s.c=99]="c",s[s.d=100]="d",s[s.e=101]="e",s[s.f=102]="f",s[s.g=103]="g",s[s.h=104]="h",s[s.i=105]="i",s[s.j=106]="j",s[s.k=107]="k",s[s.l=108]="l",s[s.m=109]="m",s[s.n=110]="n",s[s.o=111]="o",s[s.p=112]="p",s[s.q=113]="q",s[s.r=114]="r",s[s.s=115]="s",s[s.t=116]="t",s[s.u=117]="u",s[s.v=118]="v",s[s.w=119]="w",s[s.x=120]="x",s[s.y=121]="y",s[s.z=122]="z"})(f||(f={}));var w;(function(s){s[s.fa=24934]="fa",s[s.fg=26470]="fg",s[s.fq=29030]="fq",s[s.fr=29286]="fr",s[s.ft=29798]="ft",s[s.fv=30310]="fv",s[s.fx=30822]="fx",s[s.hk=27496]="hk",s[s.hl=27752]="hl",s[s.ho=28520]="ho",s[s.ml=27757]="ml",s[s.nj=27246]="nj",s[s.nl=27758]="nl",s[s.np=28782]="np",s[s.qt=29809]="qt",s[s.rt=29810]="rt",s[s.sg=26483]="sg",s[s.sw=30579]="sw"})(w||(w={}));const A=new Uint8Array([f.r,f.R,f.s,f.e,f.E,f.f,f.a,f.q,f.Q,f.t,f.T,f.d,f.w,f.W,f.c,f.z,f.x,f.v,f.g]),$=new Uint16Array([f.k,f.o,f.i,f.O,f.j,f.p,f.u,f.P,f.h,w.hk,w.ho,w.hl,f.y,f.n,w.nj,w.np,w.nl,f.b,f.m,w.ml,f.l]),m=new Uint16Array([f.r,f.R,w.rt,f.s,w.sw,w.sg,f.e,f.f,w.fr,w.fa,w.fq,w.ft,w.fx,w.fv,w.fg,f.a,f.q,w.qt,f.t,f.T,f.d,f.w,f.c,f.z,f.x,f.v,f.g]),e=new Uint16Array([f.r,f.R,w.rt,f.s,w.sw,w.sg,f.e,f.E,f.f,w.fr,w.fa,w.fq,w.ft,w.fx,w.fv,w.fg,f.a,f.q,f.Q,w.qt,f.t,f.T,f.d,f.w,f.W,f.c,f.z,f.x,f.v,f.g,f.k,f.o,f.i,f.O,f.j,f.p,f.u,f.P,f.h,w.hk,w.ho,w.hl,f.y,f.n,w.nj,w.np,w.nl,f.b,f.m,w.ml,f.l])}),define(pe[94],we([1,0]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$1U=void 0;class i{constructor(B,O=0,T=B.length,v=O-1){this.a=B,this.b=O,this.c=T,this.d=v}current(){return this.d===this.b-1||this.d===this.c?null:this.a[this.d]}next(){return this.d=Math.min(this.d+1,this.c),this.current()}previous(){return this.d=Math.max(this.d-1,this.b-1),this.current()}first(){return this.d=this.b,this.current()}last(){return this.d=this.c-1,this.current()}}t.$1U=i}),define(pe[95],we([1,0,94]),function(oe,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$3U=t.$2U=void 0;class n{constructor(T=[],v=10){this.h(T),this.b=v,this.d()}getHistory(){return this.j}add(T){this.a.delete(T),this.a.add(T),this.d()}next(){return this.c.next()}previous(){return this.g()!==0?this.c.previous():null}current(){return this.c.current()}first(){return this.c.first()}last(){return this.c.last()}isFirst(){return this.g()===0}isLast(){return this.g()>=this.j.length-1}isNowhere(){return this.c.current()===null}has(T){return this.a.has(T)}clear(){this.h([]),this.d()}d(){this.f();const T=this.j;this.c=new i.$1U(T,0,T.length,T.length)}f(){const T=this.j;T.length>this.b&&this.h(T.slice(T.length-this.b))}g(){const T=this.c.current();return T?this.j.indexOf(T):-1}h(T){this.a=new Set;for(const v of T)this.a.add(v)}get j(){const T=[];return this.a.forEach(v=>T.push(v)),T}}t.$2U=n;class B{get size(){return this.f}constructor(T,v=10){if(this.g=v,T.length<1)throw new Error("not supported");this.f=1,this.b=this.c=this.d={value:T[0],previous:void 0,next:void 0},this.a=new Set([T[0]]);for(let y=1;y<T.length;y++)this.add(T[y])}add(T){const v={value:T,previous:this.c,next:void 0};for(this.c.next=v,this.c=v,this.d=this.c,this.f++,this.a.has(T)?this.h(T):this.a.add(T);this.f>this.g;)this.a.delete(this.b.value),this.b=this.b.next,this.b.previous=void 0,this.f--}replaceLast(T){if(this.c.value===T)return T;const v=this.c.value;return this.a.delete(v),this.c.value=T,this.a.has(T)?this.h(T):this.a.add(T),v}prepend(T){if(this.f===this.g||this.a.has(T))return;const v={value:T,previous:void 0,next:this.b};this.b.previous=v,this.b=v,this.f++,this.a.add(T)}isAtEnd(){return this.d===this.c}current(){return this.d.value}previous(){return this.d.previous&&(this.d=this.d.previous),this.d.value}next(){return this.d.next&&(this.d=this.d.next),this.d.value}has(T){return this.a.has(T)}resetCursor(){return this.d=this.c,this.d.value}*[Symbol.iterator](){let T=this.b;for(;T;)yield T.value,T=T.next}h(T){let v=this.b;for(;v!==this.c;)v.value===T&&(v===this.b?(this.b=this.b.next,this.b.previous=void 0):(v.previous.next=v.next,v.next.previous=v.previous),this.f--),v=v.next}}t.$3U=B}),define(pe[44],we([1,0]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Km=t.$Jm=t.$Im=void 0,t.$Gm=i,t.rot=n;function i(v,y,f){return Math.min(Math.max(v,y),f)}function n(v,y){return(y+v%y)%y}class B{constructor(){this.a=0}getNext(){return this.a++}}t.$Im=B;class O{constructor(){this.a=1,this.b=0}update(y){return this.b=this.b+(y-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}t.$Jm=O;class T{constructor(y){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(y),this.c.fill(0,0,y)}update(y){const f=this.c[this.d];return this.c[this.d]=y,this.d=(this.d+1)%this.c.length,this.e-=f,this.e+=y,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}t.$Km=T}),define(pe[29],we([1,0]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ad=void 0,t.$bd=O,t.$cd=$;class i{constructor(e,s,o){this.owner=e,this.debugNameSource=s,this.referenceFn=o}getDebugName(e){return O(e,this)}}t.$ad=i;const n=new Map,B=new WeakMap;function O(m,e){const s=B.get(m);if(s)return s;const o=T(m,e);if(o){let h=n.get(o)??0;h++,n.set(o,h);const c=h===1?o:`${o}#${h}`;return B.set(m,c),c}}function T(m,e){const s=B.get(m);if(s)return s;const o=e.owner?w(e.owner)+".":"";let h;const c=e.debugNameSource;if(c!==void 0)if(typeof c=="function"){if(h=c(),h!==void 0)return o+h}else return o+c;const b=e.referenceFn;if(b!==void 0&&(h=$(b),h!==void 0))return o+h;if(e.owner!==void 0){const k=v(e.owner,m);if(k!==void 0)return o+k}}function v(m,e){for(const s in m)if(m[s]===e)return s}const y=new Map,f=new WeakMap;function w(m){const e=f.get(m);if(e)return e;const s=A(m);let o=y.get(s)??0;o++,y.set(s,o);const h=o===1?s:`${s}#${o}`;return f.set(m,h),h}function A(m){const e=m.constructor;return e?e.name:"Object"}function $(m){const e=m.toString(),o=/\/\*\*\s*@description\s*([^*]*)\*\//.exec(e);return(o?o[1]:void 0)?.trim()}}),define(pe[30],we([1,0]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Jd=void 0,t.$Hd=n,t.$Id=B;let i;function n(s){i=s}function B(){return i}class O{constructor(){this.a=0,this.d=new WeakMap}b(o){return T([v(m("|  ",this.a)),o])}c(o){return o.hadValue?o.didChange?[v(" "),f(w(o.oldValue,70),{color:"red",strikeThrough:!0}),v(" "),f(w(o.newValue,60),{color:"green"})]:[v(" (unchanged)")]:[v(" "),f(w(o.newValue,60),{color:"green"}),v(" (initial)")]}handleObservableChanged(o,h){console.log(...this.b([y("observable value changed"),f(o.debugName,{color:"BlueViolet"}),...this.c(h)]))}formatChanges(o){if(o.size!==0)return f(" (changed deps: "+[...o].map(h=>h.debugName).join(", ")+")",{color:"gray"})}handleDerivedCreated(o){const h=o.handleChange;this.d.set(o,new Set),o.handleChange=(c,b)=>(this.d.get(o).add(c),h.apply(o,[c,b]))}handleDerivedRecomputed(o,h){const c=this.d.get(o);console.log(...this.b([y("derived recomputed"),f(o.debugName,{color:"BlueViolet"}),...this.c(h),this.formatChanges(c),{data:[{fn:o._computeFn}]}])),c.clear()}handleFromEventObservableTriggered(o,h){console.log(...this.b([y("observable from event triggered"),f(o.debugName,{color:"BlueViolet"}),...this.c(h),{data:[{fn:o._getValue}]}]))}handleAutorunCreated(o){const h=o.handleChange;this.d.set(o,new Set),o.handleChange=(c,b)=>(this.d.get(o).add(c),h.apply(o,[c,b]))}handleAutorunTriggered(o){const h=this.d.get(o);console.log(...this.b([y("autorun"),f(o.debugName,{color:"BlueViolet"}),this.formatChanges(h),{data:[{fn:o._runFn}]}])),h.clear(),this.a++}handleAutorunFinished(o){this.a--}handleBeginTransaction(o){let h=o.getDebugName();h===void 0&&(h=""),console.log(...this.b([y("transaction"),f(h,{color:"BlueViolet"}),{data:[{fn:o._fn}]}])),this.a++}handleEndTransaction(){this.a--}}t.$Jd=O;function T(s){const o=new Array,h=[];let c="";function b(E){if("length"in E)for(const r of E)r&&b(r);else"text"in E?(c+=`%c${E.text}`,o.push(E.style),E.data&&h.push(...E.data)):"data"in E&&h.push(...E.data)}b(s);const k=[c,...o];return k.push(...h),k}function v(s){return f(s,{color:"black"})}function y(s){return f(e(`${s}: `,10),{color:"black",bold:!0})}function f(s,o={color:"black"}){function h(b){return Object.entries(b).reduce((k,[E,r])=>`${k}${E}:${r};`,"")}const c={color:o.color};return o.strikeThrough&&(c["text-decoration"]="line-through"),o.bold&&(c["font-weight"]="bold"),{text:s,style:h(c)}}function w(s,o){switch(typeof s){case"number":return""+s;case"string":return s.length+2<=o?`"${s}"`:`"${s.substr(0,o-7)}"+...`;case"boolean":return s?"true":"false";case"undefined":return"undefined";case"object":return s===null?"null":Array.isArray(s)?A(s,o):$(s,o);case"symbol":return s.toString();case"function":return`[[Function${s.name?" "+s.name:""}]]`;default:return""+s}}function A(s,o){let h="[ ",c=!0;for(const b of s){if(c||(h+=", "),h.length-5>o){h+="...";break}c=!1,h+=`${w(b,o-h.length)}`}return h+=" ]",h}function $(s,o){let h="{ ",c=!0;for(const[b,k]of Object.entries(s)){if(c||(h+=", "),h.length-5>o){h+="...";break}c=!1,h+=`${b}: ${w(k,o-h.length)}`}return h+=" }",h}function m(s,o){let h="";for(let c=1;c<=o;c++)h+=s;return h}function e(s,o){for(;s.length<o;)s+=" ";return s}}),define(pe[45],we([1,0,41,2,29,30]),function(oe,t,i,n,B,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$pd=void 0,t.$jd=T,t.$kd=v,t.$ld=y,t.$md=f,t.$nd=w,t.$od=A;function T(e){return new m(new B.$ad(void 0,void 0,e),e,void 0,void 0)}function v(e,s){return new m(new B.$ad(e.owner,e.debugName,e.debugReferenceFn??s),s,void 0,void 0)}function y(e,s){return new m(new B.$ad(e.owner,e.debugName,e.debugReferenceFn??s),s,e.createEmptyChangeSummary,e.handleChange)}function f(e,s){const o=new n.$Tc,h=y({owner:e.owner,debugName:e.debugName,debugReferenceFn:e.debugReferenceFn,createEmptyChangeSummary:e.createEmptyChangeSummary,handleChange:e.handleChange},(c,b)=>{o.clear(),s(c,b,o)});return(0,n.$Sc)(()=>{h.dispose(),o.dispose()})}function w(e){const s=new n.$Tc,o=v({owner:void 0,debugName:void 0,debugReferenceFn:e},h=>{s.clear(),e(h,s)});return(0,n.$Sc)(()=>{o.dispose(),s.dispose()})}function A(e,s){let o;return v({debugReferenceFn:s},h=>{const c=e.read(h),b=o;o=c,s({lastValue:b,newValue:c})})}var $;(function(e){e[e.dependenciesMightHaveChanged=1]="dependenciesMightHaveChanged",e[e.stale=2]="stale",e[e.upToDate=3]="upToDate"})($||($={}));class m{get debugName(){return this.h.getDebugName(this)??"(anonymous)"}constructor(s,o,h,c){this.h=s,this._runFn=o,this.i=h,this.j=c,this.a=$.stale,this.b=0,this.c=!1,this.e=new Set,this.f=new Set,this.g=this.i?.(),(0,O.$Id)()?.handleAutorunCreated(this),this.k(),(0,n.$Lc)(this)}dispose(){this.c=!0;for(const s of this.e)s.removeObserver(this);this.e.clear(),(0,n.$Mc)(this)}k(){if(this.a===$.upToDate)return;const s=this.f;this.f=this.e,this.e=s,this.a=$.upToDate;const o=this.c;try{if(!o){(0,O.$Id)()?.handleAutorunTriggered(this);const h=this.g;this.g=this.i?.(),this._runFn(this,h)}}finally{o||(0,O.$Id)()?.handleAutorunFinished(this);for(const h of this.f)h.removeObserver(this);this.f.clear()}}toString(){return`Autorun<${this.debugName}>`}beginUpdate(){this.a===$.upToDate&&(this.a=$.dependenciesMightHaveChanged),this.b++}endUpdate(){if(this.b===1)do{if(this.a===$.dependenciesMightHaveChanged){this.a=$.upToDate;for(const s of this.e)if(s.reportChanges(),this.a===$.stale)break}this.k()}while(this.a!==$.upToDate);this.b--,(0,i.$hd)(()=>this.b>=0)}handlePossibleChange(s){this.a===$.upToDate&&this.e.has(s)&&!this.f.has(s)&&(this.a=$.dependenciesMightHaveChanged)}handleChange(s,o){this.e.has(s)&&!this.f.has(s)&&(!this.j||this.j({changedObservable:s,change:o,didChange:c=>c===s},this.g))&&(this.a=$.stale)}readObservable(s){if(this.c)return s.get();s.addObserver(this);const o=s.get();return this.e.add(s),this.f.delete(s),o}}t.$pd=m,function(e){e.Observer=m}(T||(t.$jd=T={}))}),define(pe[36],we([1,0,42,29,30]),function(oe,t,i,n,B){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$7d=t.$5d=t.$2d=t.$Wd=t.$Vd=void 0,t.$Sd=T,t.$Td=y,t.$Ud=w,t.$Xd=m,t.$Yd=s,t.$Zd=o,t.$1d=h,t.$3d=b,t.$4d=k,t.$6d=r;let O;function T(D){O=D}let v;function y(D){v=D}let f;function w(D){f=D}class A{get TChange(){return null}reportChanges(){this.get()}read(R){return R?R.readObservable(this):this.get()}map(R,_){const H=_===void 0?void 0:R,x=_===void 0?R:_;return f({owner:H,debugName:()=>{const p=(0,n.$cd)(x);if(p!==void 0)return p;const U=/^\s*\(?\s*([a-zA-Z_$][a-zA-Z_$0-9]*)\s*\)?\s*=>\s*\1(?:\??)\.([a-zA-Z_$][a-zA-Z_$0-9]*)\s*$/.exec(x.toString());if(U)return`${this.debugName}.${U[2]}`;if(!H)return`${this.debugName} (mapped)`},debugReferenceFn:x},p=>x(this.read(p),p))}recomputeInitiallyAndOnChange(R,_){return R.add(O(this,_)),this}keepObserved(R){return R.add(v(this)),this}get a(){return this.get()}}t.$Vd=A;class $ extends A{constructor(){super(...arguments),this.b=new Set}addObserver(R){const _=this.b.size;this.b.add(R),_===0&&this.c()}removeObserver(R){this.b.delete(R)&&this.b.size===0&&this.f()}c(){}f(){}}t.$Wd=$;function m(D,R){const _=new c(D,R);try{D(_)}finally{_.finish()}}let e;function s(D){if(e)D(e);else{const R=new c(D,void 0);e=R;try{D(R)}finally{R.finish(),e=void 0}}}async function o(D,R){const _=new c(D,R);try{await D(_)}finally{_.finish()}}function h(D,R,_){D?R(D):m(R,_)}class c{constructor(R,_){this._fn=R,this.b=_,this.a=[],(0,B.$Id)()?.handleBeginTransaction(this)}getDebugName(){return this.b?this.b():(0,n.$cd)(this._fn)}updateObserver(R,_){this.a.push({observer:R,observable:_}),R.beginUpdate(_)}finish(){const R=this.a;for(let _=0;_<R.length;_++){const{observer:H,observable:x}=R[_];H.endUpdate(x)}this.a=null,(0,B.$Id)()?.handleEndTransaction()}}t.$2d=c;function b(D,R){let _;return typeof D=="string"?_=new n.$ad(void 0,D,void 0):_=new n.$ad(D,void 0,void 0),new E(_,R,i.$6c)}function k(D,R){return new E(new n.$ad(D.owner,D.debugName,void 0),R,D.equalsFn??i.$6c)}class E extends ${get debugName(){return this.e.getDebugName(this)??"ObservableValue"}constructor(R,_,H){super(),this.e=R,this.g=H,this.d=_}get(){return this.d}set(R,_,H){if(H===void 0&&this.g(this.d,R))return;let x;_||(_=x=new c(()=>{},()=>`Setting ${this.debugName}`));try{const p=this.d;this.h(R),(0,B.$Id)()?.handleObservableChanged(this,{oldValue:p,newValue:R,change:H,didChange:!0,hadValue:!0});for(const M of this.b)_.updateObserver(M,this),M.handleChange(this,H)}finally{x&&x.finish()}}toString(){return`${this.debugName}: ${this.d}`}h(R){this.d=R}}t.$5d=E;function r(D,R){let _;return typeof D=="string"?_=new n.$ad(void 0,D,void 0):_=new n.$ad(D,void 0,void 0),new d(_,R,i.$6c)}class d extends E{h(R){this.d!==R&&(this.d&&this.d.dispose(),this.d=R)}dispose(){this.d?.dispose()}}t.$7d=d}),define(pe[46],we([1,0,41,42,2,36,29,30]),function(oe,t,i,n,B,O,T,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Rd=t.$Qd=void 0,t.$Kd=y,t.$Ld=f,t.$Md=w,t.$Nd=A,t.$Od=$,t.$Pd=m;function y(h,c){return c!==void 0?new s(new T.$ad(h,void 0,c),c,void 0,void 0,void 0,n.$6c):new s(new T.$ad(void 0,void 0,h),h,void 0,void 0,void 0,n.$6c)}function f(h,c,b){return new o(new T.$ad(h,void 0,c),c,void 0,void 0,void 0,n.$6c,b)}function w(h,c){return new s(new T.$ad(h.owner,h.debugName,h.debugReferenceFn),c,void 0,void 0,h.onLastObserverRemoved,h.equalsFn??n.$6c)}(0,O.$Ud)(w);function A(h,c){return new s(new T.$ad(h.owner,h.debugName,void 0),c,h.createEmptyChangeSummary,h.handleChange,void 0,h.equalityComparer??n.$6c)}function $(h,c){let b,k;c===void 0?(b=h,k=void 0):(k=h,b=c);const E=new B.$Tc;return new s(new T.$ad(k,void 0,b),r=>(E.clear(),b(r,E)),void 0,void 0,()=>E.dispose(),n.$6c)}function m(h,c){let b,k;c===void 0?(b=h,k=void 0):(k=h,b=c);const E=new B.$Tc;return new s(new T.$ad(k,void 0,b),r=>{E.clear();const d=b(r);return d&&E.add(d),d},void 0,void 0,()=>E.dispose(),n.$6c)}var e;(function(h){h[h.initial=0]="initial",h[h.dependenciesMightHaveChanged=1]="dependenciesMightHaveChanged",h[h.stale=2]="stale",h[h.upToDate=3]="upToDate"})(e||(e={}));class s extends O.$Wd{get debugName(){return this.m.getDebugName(this)??"(anonymous)"}constructor(c,b,k,E,r=void 0,d){super(),this.m=c,this._computeFn=b,this.n=k,this.p=E,this.q=r,this.s=d,this.e=e.initial,this.g=void 0,this.h=0,this.j=new Set,this.k=new Set,this.l=void 0,this.l=this.n?.(),(0,v.$Id)()?.handleDerivedCreated(this)}f(){this.e=e.initial,this.g=void 0;for(const c of this.j)c.removeObserver(this);this.j.clear(),this.q?.()}get(){if(this.b.size===0){const c=this._computeFn(this,this.n?.());return this.f(),c}else{do{if(this.e===e.dependenciesMightHaveChanged){for(const c of this.j)if(c.reportChanges(),this.e===e.stale)break}this.e===e.dependenciesMightHaveChanged&&(this.e=e.upToDate),this.u()}while(this.e!==e.upToDate);return this.g}}u(){if(this.e===e.upToDate)return;const c=this.k;this.k=this.j,this.j=c;const b=this.e!==e.initial,k=this.g;this.e=e.upToDate;const E=this.l;this.l=this.n?.();try{this.g=this._computeFn(this,E)}finally{for(const d of this.k)d.removeObserver(this);this.k.clear()}const r=b&&!this.s(k,this.g);if((0,v.$Id)()?.handleDerivedRecomputed(this,{oldValue:k,newValue:this.g,change:void 0,didChange:r,hadValue:b}),r)for(const d of this.b)d.handleChange(this,void 0)}toString(){return`LazyDerived<${this.debugName}>`}beginUpdate(c){this.h++;const b=this.h===1;if(this.e===e.upToDate&&(this.e=e.dependenciesMightHaveChanged,!b))for(const k of this.b)k.handlePossibleChange(this);if(b)for(const k of this.b)k.beginUpdate(this)}endUpdate(c){if(this.h--,this.h===0){const b=[...this.b];for(const k of b)k.endUpdate(this)}(0,i.$hd)(()=>this.h>=0)}handlePossibleChange(c){if(this.e===e.upToDate&&this.j.has(c)&&!this.k.has(c)){this.e=e.dependenciesMightHaveChanged;for(const b of this.b)b.handlePossibleChange(this)}}handleChange(c,b){if(this.j.has(c)&&!this.k.has(c)){const k=this.p?this.p({changedObservable:c,change:b,didChange:r=>r===c},this.l):!0,E=this.e===e.upToDate;if(k&&(this.e===e.dependenciesMightHaveChanged||E)&&(this.e=e.stale,E))for(const r of this.b)r.handlePossibleChange(this)}}readObservable(c){c.addObserver(this);const b=c.get();return this.j.add(c),this.k.delete(c),b}addObserver(c){const b=!this.b.has(c)&&this.h>0;super.addObserver(c),b&&c.beginUpdate(this)}removeObserver(c){const b=this.b.has(c)&&this.h>0;super.removeObserver(c),b&&c.endUpdate(this)}}t.$Qd=s;class o extends s{constructor(c,b,k,E,r=void 0,d,D){super(c,b,k,E,r,d),this.set=D}}t.$Rd=o}),define(pe[47],we([1,0]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Range=void 0;var i;(function(n){function B(y,f){if(y.start>=f.end||f.start>=y.end)return{start:0,end:0};const w=Math.max(y.start,f.start),A=Math.min(y.end,f.end);return A-w<=0?{start:0,end:0}:{start:w,end:A}}n.intersect=B;function O(y){return y.end-y.start<=0}n.isEmpty=O;function T(y,f){return!O(B(y,f))}n.intersects=T;function v(y,f){const w=[],A={start:y.start,end:Math.min(f.start,y.end)},$={start:Math.max(f.end,y.start),end:y.end};return O(A)||w.push(A),O($)||w.push($),w}n.relativeComplement=v})(i||(t.Range=i={}))}),define(pe[96],we([1,0,47]),function(oe,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$zT=void 0,t.$wT=n,t.$xT=B,t.$yT=O;function n(y,f){const w=[];for(const A of f){if(y.start>=A.range.end)continue;if(y.end<A.range.start)break;const $=i.Range.intersect(y,A.range);i.Range.isEmpty($)||w.push({range:$,size:A.size})}return w}function B({start:y,end:f},w){return{start:y+w,end:f+w}}function O(y){const f=[];let w=null;for(const A of y){const $=A.range.start,m=A.range.end,e=A.size;if(w&&e===w.size){w.range.end=m;continue}w={range:{start:$,end:m},size:e},f.push(w)}return f}function T(...y){return O(y.reduce((f,w)=>f.concat(w),[]))}class v{get paddingTop(){return this.c}set paddingTop(f){this.b=this.b+f-this.c,this.c=f}constructor(f){this.a=[],this.b=0,this.c=0,this.c=f??0,this.b=this.c}splice(f,w,A=[]){const $=A.length-w,m=n({start:0,end:f},this.a),e=n({start:f+w,end:Number.POSITIVE_INFINITY},this.a).map(o=>({range:B(o.range,$),size:o.size})),s=A.map((o,h)=>({range:{start:f+h,end:f+h+1},size:o.size}));this.a=T(m,s,e),this.b=this.c+this.a.reduce((o,h)=>o+h.size*(h.range.end-h.range.start),0)}get count(){const f=this.a.length;return f?this.a[f-1].range.end:0}get size(){return this.b}indexAt(f){if(f<0)return-1;if(f<this.c)return 0;let w=0,A=this.c;for(const $ of this.a){const m=$.range.end-$.range.start,e=A+m*$.size;if(f<e)return w+Math.floor((f-A)/$.size);w+=m,A=e}return w}indexAfter(f){return Math.min(this.indexAt(f)+1,this.count)}positionAt(f){if(f<0)return-1;let w=0,A=0;for(const $ of this.a){const m=$.range.end-$.range.start,e=A+m;if(f<e)return this.c+w+(f-A)*$.size;w+=m*$.size,A=e}return-1}}t.$zT=v}),define(pe[97],we([1,0]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$be=void 0;const i=globalThis.performance&&typeof globalThis.performance.now=="function";class n{static create(O){return new n(O)}constructor(O){this.c=i&&O===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}t.$be=n}),define(pe[3],we([1,0,6,58,2,59,97]),function(oe,t,i,n,B,O,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$re=t.$qe=t.$pe=t.$oe=t.$ne=t.$me=t.$le=t.$ke=t.$je=t.$ie=t.$he=t.$ge=t.$fe=t.$de=t.Event=void 0,t.$ee=m;const v=!1,y=!1,f=!1;var w;(function(Q){Q.None=()=>B.$Uc.None;function Y(S){if(f){const{onDidAddListener:j}=S,z=s.create();let q=0;S.onDidAddListener=()=>{++q===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),z.print()),j?.()}}}function te(S,j){return Z(S,()=>{},0,void 0,!0,void 0,j)}Q.defer=te;function de(S){return(j,z=null,q)=>{let ee=!1,re;return re=S(ce=>{if(!ee)return re?re.dispose():ee=!0,j.call(z,ce)},null,q),ee&&re.dispose(),re}}Q.once=de;function De(S,j,z){return le((q,ee=null,re)=>S(ce=>q.call(ee,j(ce)),null,re),z)}Q.map=De;function Le(S,j,z){return le((q,ee=null,re)=>S(ce=>{j(ce),q.call(ee,ce)},null,re),z)}Q.forEach=Le;function Se(S,j,z){return le((q,ee=null,re)=>S(ce=>j(ce)&&q.call(ee,ce),null,re),z)}Q.filter=Se;function ue(S){return S}Q.signal=ue;function J(...S){return(j,z=null,q)=>{const ee=(0,B.$Rc)(...S.map(re=>re(ce=>j.call(z,ce))));return ke(ee,q)}}Q.any=J;function fe(S,j,z,q){let ee=z;return De(S,re=>(ee=j(ee,re),ee),q)}Q.reduce=fe;function le(S,j){let z;const q={onWillAddFirstListener(){z=S(ee.fire,ee)},onDidRemoveLastListener(){z?.dispose()}};j||Y(q);const ee=new d(q);return j?.add(ee),ee.event}function ke(S,j){return j instanceof Array?j.push(S):j&&j.add(S),S}function Z(S,j,z=100,q=!1,ee=!1,re,ce){let Ee,ve,Re,Te=0,he;const Fe={leakWarningThreshold:re,onWillAddFirstListener(){Ee=S(Ye=>{Te++,ve=j(ve,Ye),q&&!Re&&(xe.fire(ve),ve=void 0),he=()=>{const et=ve;ve=void 0,Re=void 0,(!q||Te>1)&&xe.fire(et),Te=0},typeof z=="number"?(clearTimeout(Re),Re=setTimeout(he,z)):Re===void 0&&(Re=0,queueMicrotask(he))})},onWillRemoveListener(){ee&&Te>0&&he?.()},onDidRemoveLastListener(){he=void 0,Ee.dispose()}};ce||Y(Fe);const xe=new d(Fe);return ce?.add(xe),xe.event}Q.debounce=Z;function me(S,j=0,z){return Q.debounce(S,(q,ee)=>q?(q.push(ee),q):[ee],j,void 0,!0,void 0,z)}Q.accumulate=me;function ye(S,j=(q,ee)=>q===ee,z){let q=!0,ee;return Se(S,re=>{const ce=q||!j(re,ee);return q=!1,ee=re,ce},z)}Q.latch=ye;function Oe(S,j,z){return[Q.filter(S,j,z),Q.filter(S,q=>!j(q),z)]}Q.split=Oe;function Ie(S,j=!1,z=[],q){let ee=z.slice(),re=S(ve=>{ee?ee.push(ve):Ee.fire(ve)});q&&q.add(re);const ce=()=>{ee?.forEach(ve=>Ee.fire(ve)),ee=null},Ee=new d({onWillAddFirstListener(){re||(re=S(ve=>Ee.fire(ve)),q&&q.add(re))},onDidAddFirstListener(){ee&&(j?setTimeout(ce):ce())},onDidRemoveLastListener(){re&&re.dispose(),re=null}});return q&&q.add(Ee),Ee.event}Q.buffer=Ie;function je(S,j){return(q,ee,re)=>{const ce=j(new K);return S(function(Ee){const ve=ce.evaluate(Ee);ve!==ie&&q.call(ee,ve)},void 0,re)}}Q.chain=je;const ie=Symbol("HaltChainable");class K{constructor(){this.f=[]}map(j){return this.f.push(j),this}forEach(j){return this.f.push(z=>(j(z),z)),this}filter(j){return this.f.push(z=>j(z)?z:ie),this}reduce(j,z){let q=z;return this.f.push(ee=>(q=j(q,ee),q)),this}latch(j=(z,q)=>z===q){let z=!0,q;return this.f.push(ee=>{const re=z||!j(ee,q);return z=!1,q=ee,re?ee:ie}),this}evaluate(j){for(const z of this.f)if(j=z(j),j===ie)break;return j}}function C(S,j,z=q=>q){const q=(...Ee)=>ce.fire(z(...Ee)),ee=()=>S.on(j,q),re=()=>S.removeListener(j,q),ce=new d({onWillAddFirstListener:ee,onDidRemoveLastListener:re});return ce.event}Q.fromNodeEventEmitter=C;function a(S,j,z=q=>q){const q=(...Ee)=>ce.fire(z(...Ee)),ee=()=>S.addEventListener(j,q),re=()=>S.removeEventListener(j,q),ce=new d({onWillAddFirstListener:ee,onDidRemoveLastListener:re});return ce.event}Q.fromDOMEventEmitter=a;function l(S){return new Promise(j=>de(S)(j))}Q.toPromise=l;function g(S){const j=new d;return S.then(z=>{j.fire(z)},()=>{j.fire(void 0)}).finally(()=>{j.dispose()}),j.event}Q.fromPromise=g;function I(S,j,z){return j(z),S(q=>j(q))}Q.runAndSubscribe=I;class F{constructor(j,z){this._observable=j,this.f=0,this.g=!1;const q={onWillAddFirstListener:()=>{j.addObserver(this)},onDidRemoveLastListener:()=>{j.removeObserver(this)}};z||Y(q),this.emitter=new d(q),z&&z.add(this.emitter)}beginUpdate(j){this.f++}handlePossibleChange(j){}handleChange(j,z){this.g=!0}endUpdate(j){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function u(S,j){return new F(S,j).emitter.event}Q.fromObservable=u;function L(S){return(j,z,q)=>{let ee=0,re=!1;const ce={beginUpdate(){ee++},endUpdate(){ee--,ee===0&&(S.reportChanges(),re&&(re=!1,j.call(z)))},handlePossibleChange(){},handleChange(){re=!0}};S.addObserver(ce),S.reportChanges();const Ee={dispose(){S.removeObserver(ce)}};return q instanceof B.$Tc?q.add(Ee):Array.isArray(q)&&q.push(Ee),Ee}}Q.fromObservableLight=L})(w||(t.Event=w={}));class A{static{this.all=new Set}static{this.f=0}constructor(Y){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${Y}_${A.f++}`,A.all.add(this)}start(Y){this.g=new T.$be,this.listenerCount=Y}stop(){if(this.g){const Y=this.g.elapsed();this.durations.push(Y),this.elapsedOverall+=Y,this.invocationCount+=1,this.g=void 0}}}t.$de=A;let $=-1;function m(Q){const Y=$;return $=Q,{dispose(){$=Y}}}class e{constructor(Y,te,de=Math.random().toString(18).slice(2,5)){this.h=Y,this.threshold=te,this.name=de,this.g=0}dispose(){this.f?.clear()}check(Y,te){const de=this.threshold;if(de<=0||te<de)return;this.f||(this.f=new Map);const De=this.f.get(Y.value)||0;if(this.f.set(Y.value,De+1),this.g-=1,this.g<=0){this.g=de*.5;const[Le,Se]=this.getMostFrequentStack(),ue=`[${this.name}] potential listener LEAK detected, having ${te} listeners already. MOST frequent listener (${Se}):`;console.warn(ue),console.warn(Le);const J=new o(ue,Le);this.h(J)}return()=>{const Le=this.f.get(Y.value)||0;this.f.set(Y.value,Le-1)}}getMostFrequentStack(){if(!this.f)return;let Y,te=0;for(const[de,De]of this.f)(!Y||te<De)&&(Y=[de,De],te=De);return Y}}class s{static create(){const Y=new Error;return new s(Y.stack??"")}constructor(Y){this.value=Y}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class o extends Error{constructor(Y,te){super(Y),this.name="ListenerLeakError",this.stack=te}}t.$fe=o;class h extends Error{constructor(Y,te){super(Y),this.name="ListenerRefusalError",this.stack=te}}t.$ge=h;let c=0;class b{constructor(Y){this.value=Y,this.id=c++}}const k=2,E=(Q,Y)=>{if(Q instanceof b)Y(Q);else for(let te=0;te<Q.length;te++){const de=Q[te];de&&Y(de)}},r=v?new FinalizationRegistry(Q=>{typeof Q=="string"&&(console.warn("[LEAKING LISTENER] GC'ed a listener that was NOT yet disposed. This is where is was created:"),console.warn(Q))}):void 0;class d{constructor(Y){this.w=0,this.f=Y,this.g=$>0||this.f?.leakWarningThreshold?new e(Y?.onListenerError??i.$1,this.f?.leakWarningThreshold??$):void 0,this.j=this.f?._profName?new A(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(y){const Y=this.t;queueMicrotask(()=>{E(Y,te=>te.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(Y,te,de)=>{if(this.g&&this.w>this.g.threshold**2){const J=`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far (${this.w} vs ${this.g.threshold})`;console.warn(J);const fe=this.g.getMostFrequentStack()??["UNKNOWN stack",-1],le=new h(`${J}. HINT: Stack shows most frequent listener (${fe[1]}-times)`,fe[0]);return(this.f?.onListenerError||i.$1)(le),B.$Uc.None}if(this.m)return B.$Uc.None;te&&(Y=Y.bind(te));const De=new b(Y);let Le,Se;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(De.stack=s.create(),Le=this.g.check(De.stack,this.w+1)),y&&(De.stack=Se??s.create()),this.t?this.t instanceof b?(this.u??=new R,this.t=[this.t,De]):this.t.push(De):(this.f?.onWillAddFirstListener?.(this),this.t=De,this.f?.onDidAddFirstListener?.(this)),this.w++;const ue=(0,B.$Sc)(()=>{r?.unregister(ue),Le?.(),this.x(De)});if(de instanceof B.$Tc?de.add(ue):Array.isArray(de)&&de.push(ue),r){const J=new Error().stack.split(`
`).slice(2).join(`
`).trim();r.register(ue,J,ue)}return ue},this.q}x(Y){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const te=this.t,de=te.indexOf(Y);if(de===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,te[de]=void 0;const De=this.u.current===this;if(this.w*k<=te.length){let Le=0;for(let Se=0;Se<te.length;Se++)te[Se]?te[Le++]=te[Se]:De&&(this.u.end--,Le<this.u.i&&this.u.i--);te.length=Le}}y(Y,te){if(!Y)return;const de=this.f?.onListenerError||i.$1;if(!de){Y.value(te);return}try{Y.value(te)}catch(De){de(De)}}z(Y){const te=Y.current.t;for(;Y.i<Y.end;)this.y(te[Y.i++],Y.value);Y.reset()}fire(Y){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof b)this.y(this.t,Y);else{const te=this.u;te.enqueue(this,Y,this.t.length),this.z(te)}this.j?.stop()}hasListeners(){return this.w>0}}t.$he=d;const D=()=>new R;t.$ie=D;class R{constructor(){this.i=-1,this.end=0}enqueue(Y,te,de){this.i=0,this.end=de,this.current=Y,this.value=te}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class _ extends d{async fireAsync(Y,te,de){if(this.t)for(this.h||(this.h=new O.$5c),E(this.t,De=>this.h.push([De.value,Y]));this.h.size>0&&!te.isCancellationRequested;){const[De,Le]=this.h.shift(),Se=[],ue={...Le,token:te,waitUntil:J=>{if(Object.isFrozen(Se))throw new Error("waitUntil can NOT be called asynchronous");de&&(J=de(J,De)),Se.push(J)}};try{De(ue)}catch(J){(0,i.$1)(J);continue}Object.freeze(Se),await Promise.allSettled(Se).then(J=>{for(const fe of J)fe.status==="rejected"&&(0,i.$1)(fe.reason)})}}}t.$je=_;class H extends d{get isPaused(){return this.h!==0}constructor(Y){super(Y),this.h=0,this.s=new O.$5c,this.A=Y?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const Y=Array.from(this.s);this.s.clear(),super.fire(this.A(Y))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(Y){this.w&&(this.h!==0?this.s.push(Y):super.fire(Y))}}t.$ke=H;class x extends H{constructor(Y){super(Y),this.k=Y.delay??100}fire(Y){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(Y)}}t.$le=x;class p extends d{constructor(Y){super(Y),this.h=[],this.k=Y?.merge}fire(Y){this.hasListeners()&&(this.h.push(Y),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(te=>super.fire(te)),this.h=[]}))}}t.$me=p;class M{constructor(){this.g=!1,this.h=[],this.f=new d({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(Y){const te={event:Y,listener:null};this.h.push(te),this.g&&this.m(te);const de=()=>{this.g&&this.o(te);const De=this.h.indexOf(te);this.h.splice(De,1)};return(0,B.$Sc)((0,n.$db)(de))}j(){this.g=!0,this.h.forEach(Y=>this.m(Y))}k(){this.g=!1,this.h.forEach(Y=>this.o(Y))}m(Y){Y.listener=Y.event(te=>this.f.fire(te))}o(Y){Y.listener?.dispose(),Y.listener=null}dispose(){this.f.dispose();for(const Y of this.h)Y.listener?.dispose();this.h=[]}}t.$ne=M;class U{constructor(Y,te,de,De){this.f=new B.$Tc;const Le=this.f.add(new M),Se=this.f.add(new B.$4c);function ue(J){Se.set(J,Le.add(De(J)))}for(const J of Y)ue(J);this.f.add(te(J=>{ue(J)})),this.f.add(de(J=>{Se.deleteAndDispose(J)})),this.event=Le.event}dispose(){this.f.dispose()}}t.$oe=U;class N{constructor(){this.f=[]}wrapEvent(Y,te,de){return(De,Le,Se)=>Y(ue=>{const J=this.f[this.f.length-1];if(!te){J?J.buffers.push(()=>De.call(Le,ue)):De.call(Le,ue);return}const fe=J;if(!fe){De.call(Le,te(de,ue));return}fe.items??=[],fe.items.push(ue),fe.buffers.length===0&&J.buffers.push(()=>{fe.reducedResult??=de?fe.items.reduce(te,de):fe.items.reduce(te),De.call(Le,fe.reducedResult)})},void 0,Se)}bufferEvents(Y){const te={buffers:new Array};this.f.push(te);const de=Y();return this.f.pop(),te.buffers.forEach(De=>De()),de}}t.$pe=N;class P{constructor(){this.f=!1,this.g=w.None,this.h=B.$Uc.None,this.j=new d({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(Y){this.g=Y,this.f&&(this.h.dispose(),this.h=Y(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}t.$qe=P;class W{static const(Y){return new ne(Y)}constructor(Y){this.g=Y,this.f=new d,this.onDidChange=this.f.event}get value(){return this.g}set value(Y){Y!==this.g&&(this.g=Y,this.f.fire(void 0))}}t.$re=W;class ne{constructor(Y){this.value=Y,this.onDidChange=w.None}}}),define(pe[19],we([1,0,25,3]),function(oe,t,i,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$_Q=t.$$Q=t.$0Q=t.$9Q=t.$8Q=t.$7Q=t.$6Q=t.$5Q=t.$ZQ=void 0,t.$WQ=O,t.$XQ=T,t.$YQ=v,t.$1Q=y,t.$2Q=f,t.$3Q=w,t.$4Q=A,t.$aR=e,t.$bR=s;class B{constructor(){this.a=new Map,this.b=new n.$he,this.onDidChangeZoomLevel=this.b.event,this.c=new Map,this.d=new n.$he,this.onDidChangeFullscreen=this.d.event,this.e=new Map}static{this.INSTANCE=new B}getZoomLevel(h){return this.a.get(this.f(h))??0}setZoomLevel(h,c){if(this.getZoomLevel(c)===h)return;const b=this.f(c);this.a.set(b,h),this.b.fire(b)}getZoomFactor(h){return this.c.get(this.f(h))??1}setZoomFactor(h,c){this.c.set(this.f(c),h)}setFullscreen(h,c){if(this.isFullscreen(c)===h)return;const b=this.f(c);this.e.set(b,h),this.d.fire(b)}isFullscreen(h){return!!this.e.get(this.f(h))}f(h){return h.vscodeWindowId}}function O(o,h,c){typeof h=="string"&&(h=o.matchMedia(h)),h.addEventListener("change",c)}function T(o,h){B.INSTANCE.setZoomLevel(o,h)}function v(o){return B.INSTANCE.getZoomLevel(o)}t.$ZQ=B.INSTANCE.onDidChangeZoomLevel;function y(o){return B.INSTANCE.getZoomFactor(o)}function f(o,h){B.INSTANCE.setZoomFactor(o,h)}function w(o,h){B.INSTANCE.setFullscreen(o,h)}function A(o){return B.INSTANCE.isFullscreen(o)}t.$5Q=B.INSTANCE.onDidChangeFullscreen;const $=navigator.userAgent;t.$6Q=$.indexOf("Firefox")>=0,t.$7Q=$.indexOf("AppleWebKit")>=0,t.$8Q=$.indexOf("Chrome")>=0,t.$9Q=!t.$8Q&&$.indexOf("Safari")>=0,t.$0Q=!t.$8Q&&!t.$9Q&&t.$7Q,t.$$Q=$.indexOf("Electron/")>=0,t.$_Q=$.indexOf("Android")>=0;let m=!1;if(typeof i.$TQ.matchMedia=="function"){const o=i.$TQ.matchMedia("(display-mode: standalone) or (display-mode: window-controls-overlay)"),h=i.$TQ.matchMedia("(display-mode: fullscreen)");m=o.matches,O(i.$TQ,o,({matches:c})=>{m&&h.matches||(m=c)})}function e(){return m}function s(){return navigator?.windowControlsOverlay?.visible}}),define(pe[27],we([1,0,3]),function(oe,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$rT=void 0;class n{get event(){return this.a.event}constructor(O,T,v){const y=f=>this.a.fire(f);this.a=new i.$he({onWillAddFirstListener:()=>O.addEventListener(T,y,v),onDidRemoveLastListener:()=>O.removeEventListener(T,y,v)})}dispose(){this.a.dispose()}}t.$rT=n}),define(pe[37],we([1,0,3]),function(oe,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$se=t.CancellationToken=void 0,t.$te=v;const n=Object.freeze(function(y,f){const w=setTimeout(y.bind(f),0);return{dispose(){clearTimeout(w)}}});var B;(function(y){function f(w){return w===y.None||w===y.Cancelled||w instanceof O?!0:!w||typeof w!="object"?!1:typeof w.isCancellationRequested=="boolean"&&typeof w.onCancellationRequested=="function"}y.isCancellationToken=f,y.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:i.Event.None}),y.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:n})})(B||(t.CancellationToken=B={}));class O{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?n:(this.b||(this.b=new i.$he),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class T{constructor(f){this.f=void 0,this.g=void 0,this.g=f&&f.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new O),this.f}cancel(){this.f?this.f instanceof O&&this.f.cancel():this.f=B.Cancelled}dispose(f=!1){f&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof O&&this.f.dispose():this.f=B.None}}t.$se=T;function v(y){const f=new T;return y.add({dispose(){f.cancel()}}),f.token}}),define(pe[98],we([1,0,37]),function(oe,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$8e=t.$7e=t.$5e=void 0,t.$6e=B;class n{constructor(y){this.b=y,this.a=null}get(){if(this.a)return this.a;const y=new i.$se,f=this.b(y.token);return this.a={promise:f,dispose:()=>{this.a=null,y.cancel(),y.dispose()}},this.a}}t.$5e=n;function B(v){return v}class O{constructor(y,f){this.a=void 0,this.b=void 0,typeof y=="function"?(this.c=y,this.d=B):(this.c=f,this.d=y.getCacheKey)}get(y){const f=this.d(y);return this.b!==f&&(this.b=f,this.a=this.c(y)),this.a}}t.$7e=O;class T{get cachedValues(){return this.a}constructor(y,f){this.a=new Map,this.b=new Map,typeof y=="function"?(this.c=y,this.d=B):(this.c=f,this.d=y.getCacheKey)}get(y){const f=this.d(y);if(this.b.has(f))return this.b.get(f);const w=this.c(y);return this.a.set(y,w),this.b.set(f,w),w}}t.$8e=T}),define(pe[99],we([1,0,45,36,46,37,29,42,6]),function(oe,t,i,n,B,O,T,v,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$$d=t.$0d=t.$9d=t.$8d=void 0,t.$_d=m,t.$ae=e;class f{get cachedValue(){return this.a}constructor(o){this.b=o,this.a=(0,n.$3d)(this,void 0)}getValue(){let o=this.a.get();return o||(o=this.b(),this.a.set(o,void 0)),o}}t.$8d=f;class w{constructor(o){this.a=(0,n.$3d)(this,void 0),this.promiseResult=this.a,this.promise=o.then(h=>((0,n.$Xd)(c=>{this.a.set(new A(h,void 0),c)}),h),h=>{throw(0,n.$Xd)(c=>{this.a.set(new A(void 0,h),c)}),h})}}t.$9d=w;class A{constructor(o,h){this.data=o,this.error=h}getDataOrThrow(){if(this.error)throw this.error;return this.data}}t.$0d=A;class ${constructor(o){this.b=o,this.a=new f(()=>new w(this.b())),this.cachedPromiseResult=(0,B.$Kd)(this,h=>this.a.cachedValue.read(h)?.promiseResult.read(h))}getPromise(){return this.a.getValue().promise}}t.$$d=$;function m(s,o,h,c){return o||(o=b=>b!=null),new Promise((b,k)=>{let E=!0,r=!1;const d=s.map(R=>({isFinished:o(R),error:h?h(R):!1,state:R})),D=(0,i.$jd)(R=>{const{isFinished:_,error:H,state:x}=d.read(R);(_||H)&&(E?r=!0:D.dispose(),H?k(H===!0?x:H):b(x))});if(c){const R=c.onCancellationRequested(()=>{D.dispose(),R.dispose(),k(new y.$5)});if(c.isCancellationRequested){D.dispose(),R.dispose(),k(new y.$5);return}}E=!1,r&&D.dispose()})}function e(s,o){let h,c;o===void 0?(h=s,c=void 0):(c=s,h=o);let b;return new B.$Qd(new T.$ad(c,void 0,h),k=>(b&&b.dispose(!0),b=new O.$se,h(k,b.token)),void 0,void 0,()=>b?.dispose(),v.$6c)}}),define(pe[100],we([1,0,3,2,45,36,29,46,30]),function(oe,t,i,n,B,O,T,v,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Fd=t.$Bd=t.$td=void 0,t.$qd=f,t.$rd=A,t.$sd=$,t.$ud=e,t.$vd=o,t.$wd=c,t.$xd=b,t.$yd=k,t.$zd=E,t.$Ad=r,t.$Cd=D,t.$Dd=R,t.$Ed=_,t.$Gd=p;function f(M){return new w(M)}class w extends O.$Vd{constructor(U){super(),this.b=U}get debugName(){return this.toString()}get(){return this.b}addObserver(U){}removeObserver(U){}toString(){return`Const: ${this.b}`}}function A(M){const U=(0,O.$3d)("promiseValue",{});return M.then(N=>{U.set({value:N},void 0)}),U}function $(M,U){return new m(M,U)}class m extends O.$Wd{constructor(U,N){super(),this.j=U,this._getValue=N,this.g=!1,this.n=P=>{const W=this._getValue(P),ne=this.e,Q=!this.g||ne!==W;let Y=!1;Q&&(this.e=W,this.g&&(Y=!0,(0,O.$1d)(m.globalTransaction,te=>{(0,y.$Id)()?.handleFromEventObservableTriggered(this,{oldValue:ne,newValue:W,change:void 0,didChange:Q,hadValue:this.g});for(const de of this.b)te.updateObserver(de,this),de.handleChange(this,void 0)},()=>{const te=this.k();return"Event fired"+(te?`: ${te}`:"")})),this.g=!0),Y||(0,y.$Id)()?.handleFromEventObservableTriggered(this,{oldValue:ne,newValue:W,change:void 0,didChange:Q,hadValue:this.g})}}k(){return(0,T.$cd)(this._getValue)}get debugName(){const U=this.k();return"From Event"+(U?`: ${U}`:"")}c(){this.h=this.j(this.n)}f(){this.h.dispose(),this.h=void 0,this.g=!1,this.e=void 0}get(){return this.h?(this.g||this.n(void 0),this.e):this._getValue(void 0)}}t.$td=m,function(M){M.Observer=m;function U(N,P){let W=!1;m.globalTransaction===void 0&&(m.globalTransaction=N,W=!0);try{P()}finally{W&&(m.globalTransaction=void 0)}}M.batchEventsGlobally=U}($||(t.$sd=$={}));function e(M,U){return new s(M,U)}class s extends O.$Wd{constructor(U,N){super(),this.debugName=U,this.g=N,this.j=()=>{(0,O.$Xd)(P=>{for(const W of this.b)P.updateObserver(W,this),W.handleChange(this,void 0)},()=>this.debugName)}}c(){this.e=this.g(this.j)}f(){this.e.dispose(),this.e=void 0}get(){}}function o(M){return typeof M=="string"?new h(M):new h(void 0,M)}class h extends O.$Wd{get debugName(){return new T.$ad(this.g,this.e,void 0).getDebugName(this)??"Observable Signal"}constructor(U,N){super(),this.e=U,this.g=N}trigger(U,N){if(!U){(0,O.$Xd)(P=>{this.trigger(P,N)},()=>`Trigger signal ${this.debugName}`);return}for(const P of this.b)U.updateObserver(P,this),P.handleChange(this,N)}get(){}}function c(M,U,N){const P=(0,O.$3d)("debounced",void 0);let W;return N.add((0,B.$jd)(ne=>{const Q=M.read(ne);W&&clearTimeout(W),W=setTimeout(()=>{(0,O.$Xd)(Y=>{P.set(Q,Y)})},U)})),P}function b(M,U){let N=!1,P,W;return $(ne=>{const Q=(0,B.$jd)(Y=>{const te=M.read(Y);N?(W&&clearTimeout(W),W=setTimeout(()=>{P=te,ne()},U)):(N=!0,P=te)});return{dispose(){Q.dispose(),N=!1,P=void 0}}},()=>N?P:M.get())}function k(M,U,N){const P=(0,O.$3d)("triggeredRecently",!1);let W;return N.add(M(()=>{P.set(!0,void 0),W&&clearTimeout(W),W=setTimeout(()=>{P.set(!1,void 0)},U)})),P}function E(M){const U=new d(!1,void 0);return M.addObserver(U),(0,n.$Sc)(()=>{M.removeObserver(U)})}(0,O.$Td)(E);function r(M,U){const N=new d(!0,U);return M.addObserver(N),U?U(M.get()):M.reportChanges(),(0,n.$Sc)(()=>{M.removeObserver(N)})}(0,O.$Sd)(r);class d{constructor(U,N){this.b=U,this.c=N,this.a=0}beginUpdate(U){this.a++}endUpdate(U){this.a--,this.a===0&&this.b&&(this.c?this.c(U.get()):U.reportChanges())}handlePossibleChange(U){}handleChange(U,N){}}t.$Bd=d;function D(M,U){let N;return(0,v.$Kd)(M,W=>(N=U(W,N),N))}function R(M,U){let N;const P=o("derivedObservableWithWritableCache"),W=(0,v.$Kd)(M,ne=>(P.read(ne),N=U(ne,N),N));return Object.assign(W,{clearCache:ne=>{N=void 0,P.trigger(ne)},setCache:(ne,Q)=>{N=ne,P.trigger(Q)}})}function _(M,U,N,P){let W=new H(N,P);return(0,v.$Md)({debugReferenceFn:N,owner:M,onLastObserverRemoved:()=>{W.dispose(),W=new H(N)}},Q=>(W.setItems(U.read(Q)),W.getItems()))}class H{constructor(U,N){this.c=U,this.e=N,this.a=new Map,this.b=[]}dispose(){this.a.forEach(U=>U.store.dispose()),this.a.clear()}setItems(U){const N=[],P=new Set(this.a.keys());for(const W of U){const ne=this.e?this.e(W):W;let Q=this.a.get(ne);if(Q)P.delete(ne);else{const Y=new n.$Tc;Q={out:this.c(W,Y),store:Y},this.a.set(ne,Q)}N.push(Q.out)}for(const W of P)this.a.get(W).store.dispose(),this.a.delete(W);this.b=N}getItems(){return this.b}}class x{constructor(U){this.observable=U}get onDidChange(){return i.Event.fromObservableLight(this.observable)}get value(){return this.observable.get()}}t.$Fd=x;function p(M,U){return U instanceof x?U.observable:$(U.onDidChange,()=>U.value)}}),define(pe[61],we([1,0,36,46,45,100,99,30]),function(oe,t,i,n,B,O,T,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.derivedWithCancellationToken=t.waitForState=t.PromiseResult=t.ObservablePromise=t.ObservableLazyPromise=t.ObservableLazy=t.wasEventTriggeredRecently=t.observableSignalFromEvent=t.observableSignal=t.observableFromPromise=t.observableFromEvent=t.recomputeInitiallyAndOnChange=t.keepObserved=t.derivedObservableWithWritableCache=t.derivedObservableWithCache=t.debouncedObservable=t.constObservable=t.autorunWithStoreHandleChanges=t.autorunOpts=t.autorunWithStore=t.autorunHandleChanges=t.autorunDelta=t.autorun=t.derivedWithStore=t.derivedHandleChanges=t.derivedOpts=t.derived=t.subtransaction=t.transaction=t.disposableObservableValue=t.observableValue=void 0,Object.defineProperty(t,"observableValue",{enumerable:!0,get:function(){return i.$3d}}),Object.defineProperty(t,"disposableObservableValue",{enumerable:!0,get:function(){return i.$6d}}),Object.defineProperty(t,"transaction",{enumerable:!0,get:function(){return i.$Xd}}),Object.defineProperty(t,"subtransaction",{enumerable:!0,get:function(){return i.$1d}}),Object.defineProperty(t,"derived",{enumerable:!0,get:function(){return n.$Kd}}),Object.defineProperty(t,"derivedOpts",{enumerable:!0,get:function(){return n.$Md}}),Object.defineProperty(t,"derivedHandleChanges",{enumerable:!0,get:function(){return n.$Nd}}),Object.defineProperty(t,"derivedWithStore",{enumerable:!0,get:function(){return n.$Od}}),Object.defineProperty(t,"autorun",{enumerable:!0,get:function(){return B.$jd}}),Object.defineProperty(t,"autorunDelta",{enumerable:!0,get:function(){return B.$od}}),Object.defineProperty(t,"autorunHandleChanges",{enumerable:!0,get:function(){return B.$ld}}),Object.defineProperty(t,"autorunWithStore",{enumerable:!0,get:function(){return B.$nd}}),Object.defineProperty(t,"autorunOpts",{enumerable:!0,get:function(){return B.$kd}}),Object.defineProperty(t,"autorunWithStoreHandleChanges",{enumerable:!0,get:function(){return B.$md}}),Object.defineProperty(t,"constObservable",{enumerable:!0,get:function(){return O.$qd}}),Object.defineProperty(t,"debouncedObservable",{enumerable:!0,get:function(){return O.$wd}}),Object.defineProperty(t,"derivedObservableWithCache",{enumerable:!0,get:function(){return O.$Cd}}),Object.defineProperty(t,"derivedObservableWithWritableCache",{enumerable:!0,get:function(){return O.$Dd}}),Object.defineProperty(t,"keepObserved",{enumerable:!0,get:function(){return O.$zd}}),Object.defineProperty(t,"recomputeInitiallyAndOnChange",{enumerable:!0,get:function(){return O.$Ad}}),Object.defineProperty(t,"observableFromEvent",{enumerable:!0,get:function(){return O.$sd}}),Object.defineProperty(t,"observableFromPromise",{enumerable:!0,get:function(){return O.$rd}}),Object.defineProperty(t,"observableSignal",{enumerable:!0,get:function(){return O.$vd}}),Object.defineProperty(t,"observableSignalFromEvent",{enumerable:!0,get:function(){return O.$ud}}),Object.defineProperty(t,"wasEventTriggeredRecently",{enumerable:!0,get:function(){return O.$yd}}),Object.defineProperty(t,"ObservableLazy",{enumerable:!0,get:function(){return T.$8d}}),Object.defineProperty(t,"ObservableLazyPromise",{enumerable:!0,get:function(){return T.$$d}}),Object.defineProperty(t,"ObservablePromise",{enumerable:!0,get:function(){return T.$9d}}),Object.defineProperty(t,"PromiseResult",{enumerable:!0,get:function(){return T.$0d}}),Object.defineProperty(t,"waitForState",{enumerable:!0,get:function(){return T.$_d}}),Object.defineProperty(t,"derivedWithCancellationToken",{enumerable:!0,get:function(){return T.$ae}}),!1&&(0,v.$Hd)(new v.$Jd)}),define(pe[20],we([1,0,3,2]),function(oe,t,i,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$gu=t.$fu=t.$eu=t.$du=t.ScrollbarVisibility=void 0;var B;(function(m){m[m.Auto=1]="Auto",m[m.Hidden=2]="Hidden",m[m.Visible=3]="Visible"})(B||(t.ScrollbarVisibility=B={}));class O{constructor(e,s,o,h,c,b,k){this.c=e,this._scrollStateBrand=void 0,this.c&&(s=s|0,o=o|0,h=h|0,c=c|0,b=b|0,k=k|0),this.rawScrollLeft=h,this.rawScrollTop=k,s<0&&(s=0),h+s>o&&(h=o-s),h<0&&(h=0),c<0&&(c=0),k+c>b&&(k=b-c),k<0&&(k=0),this.width=s,this.scrollWidth=o,this.scrollLeft=h,this.height=c,this.scrollHeight=b,this.scrollTop=k}equals(e){return this.rawScrollLeft===e.rawScrollLeft&&this.rawScrollTop===e.rawScrollTop&&this.width===e.width&&this.scrollWidth===e.scrollWidth&&this.scrollLeft===e.scrollLeft&&this.height===e.height&&this.scrollHeight===e.scrollHeight&&this.scrollTop===e.scrollTop}withScrollDimensions(e,s){return new O(this.c,typeof e.width<"u"?e.width:this.width,typeof e.scrollWidth<"u"?e.scrollWidth:this.scrollWidth,s?this.rawScrollLeft:this.scrollLeft,typeof e.height<"u"?e.height:this.height,typeof e.scrollHeight<"u"?e.scrollHeight:this.scrollHeight,s?this.rawScrollTop:this.scrollTop)}withScrollPosition(e){return new O(this.c,this.width,this.scrollWidth,typeof e.scrollLeft<"u"?e.scrollLeft:this.rawScrollLeft,this.height,this.scrollHeight,typeof e.scrollTop<"u"?e.scrollTop:this.rawScrollTop)}createScrollEvent(e,s){const o=this.width!==e.width,h=this.scrollWidth!==e.scrollWidth,c=this.scrollLeft!==e.scrollLeft,b=this.height!==e.height,k=this.scrollHeight!==e.scrollHeight,E=this.scrollTop!==e.scrollTop;return{inSmoothScrolling:s,oldWidth:e.width,oldScrollWidth:e.scrollWidth,oldScrollLeft:e.scrollLeft,width:this.width,scrollWidth:this.scrollWidth,scrollLeft:this.scrollLeft,oldHeight:e.height,oldScrollHeight:e.scrollHeight,oldScrollTop:e.scrollTop,height:this.height,scrollHeight:this.scrollHeight,scrollTop:this.scrollTop,widthChanged:o,scrollWidthChanged:h,scrollLeftChanged:c,heightChanged:b,scrollHeightChanged:k,scrollTopChanged:E}}}t.$du=O;class T extends n.$Uc{constructor(e){super(),this._scrollableBrand=void 0,this.j=this.B(new i.$he),this.onScroll=this.j.event,this.c=e.smoothScrollDuration,this.f=e.scheduleAtNextAnimationFrame,this.g=new O(e.forceIntegerValues,0,0,0,0,0,0),this.h=null}dispose(){this.h&&(this.h.dispose(),this.h=null),super.dispose()}setSmoothScrollDuration(e){this.c=e}validateScrollPosition(e){return this.g.withScrollPosition(e)}getScrollDimensions(){return this.g}setScrollDimensions(e,s){const o=this.g.withScrollDimensions(e,s);this.n(o,!!this.h),this.h?.acceptScrollDimensions(this.g)}getFutureScrollPosition(){return this.h?this.h.to:this.g}getCurrentScrollPosition(){return this.g}setScrollPositionNow(e){const s=this.g.withScrollPosition(e);this.h&&(this.h.dispose(),this.h=null),this.n(s,!1)}setScrollPositionSmooth(e,s){if(this.c===0)return this.setScrollPositionNow(e);if(this.h){e={scrollLeft:typeof e.scrollLeft>"u"?this.h.to.scrollLeft:e.scrollLeft,scrollTop:typeof e.scrollTop>"u"?this.h.to.scrollTop:e.scrollTop};const o=this.g.withScrollPosition(e);if(this.h.to.scrollLeft===o.scrollLeft&&this.h.to.scrollTop===o.scrollTop)return;let h;s?h=new w(this.h.from,o,this.h.startTime,this.h.duration):h=this.h.combine(this.g,o,this.c),this.h.dispose(),this.h=h}else{const o=this.g.withScrollPosition(e);this.h=w.start(this.g,o,this.c)}this.h.animationFrameDisposable=this.f(()=>{this.h&&(this.h.animationFrameDisposable=null,this.m())})}hasPendingScrollAnimation(){return!!this.h}m(){if(!this.h)return;const e=this.h.tick(),s=this.g.withScrollPosition(e);if(this.n(s,!0),!!this.h){if(e.isDone){this.h.dispose(),this.h=null;return}this.h.animationFrameDisposable=this.f(()=>{this.h&&(this.h.animationFrameDisposable=null,this.m())})}}n(e,s){const o=this.g;o.equals(e)||(this.g=e,this.j.fire(this.g.createScrollEvent(o,s)))}}t.$eu=T;class v{constructor(e,s,o){this.scrollLeft=e,this.scrollTop=s,this.isDone=o}}t.$fu=v;function y(m,e){const s=e-m;return function(o){return m+s*$(o)}}function f(m,e,s){return function(o){return o<s?m(o/s):e((o-s)/(1-s))}}class w{constructor(e,s,o,h){this.from=e,this.to=s,this.duration=h,this.startTime=o,this.animationFrameDisposable=null,this.e()}e(){this.c=this.f(this.from.scrollLeft,this.to.scrollLeft,this.to.width),this.d=this.f(this.from.scrollTop,this.to.scrollTop,this.to.height)}f(e,s,o){if(Math.abs(e-s)>2.5*o){let c,b;return e<s?(c=e+.75*o,b=s-.75*o):(c=e-.75*o,b=s+.75*o),f(y(e,c),y(b,s),.33)}return y(e,s)}dispose(){this.animationFrameDisposable!==null&&(this.animationFrameDisposable.dispose(),this.animationFrameDisposable=null)}acceptScrollDimensions(e){this.to=e.withScrollPosition(this.to),this.e()}tick(){return this.g(Date.now())}g(e){const s=(e-this.startTime)/this.duration;if(s<1){const o=this.c(s),h=this.d(s);return new v(o,h,!1)}return new v(this.to.scrollLeft,this.to.scrollTop,!0)}combine(e,s,o){return w.start(e,s,o)}static start(e,s,o){o=o+10;const h=Date.now()-10;return new w(e,s,h,o)}}t.$gu=w;function A(m){return Math.pow(m,3)}function $(m){return 1-A(1-m)}}),define(pe[101],we([1,0,6,2]),function(oe,t,i,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ue=B,t.$ve=O,t.$we=T,t.$xe=v,t.$ye=f,t.$ze=w,t.$Ae=A,t.$Be=$,t.$Ce=m,t.$De=e,t.$Ee=s,t.$Fe=o,t.$Ge=h,t.$He=c,t.$Ie=b;function B(k){const E=k;return E?typeof E.read=="function":!1}function O(k){const E=k;return E?[E.on,E.pause,E.resume,E.destroy].every(r=>typeof r=="function"):!1}function T(k){const E=k;return E?O(E.stream)&&Array.isArray(E.buffer)&&typeof E.ended=="boolean":!1}function v(k,E){return new y(k,E)}class y{constructor(E,r){this.e=E,this.f=r,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(E){if(!this.a.destroyed){if(this.a.flowing)this.g(E);else if(this.b.data.push(E),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(r=>this.d.push(r))}}error(E){this.a.destroyed||(this.a.flowing?this.h(E):this.b.error.push(E))}end(E){this.a.destroyed||(typeof E<"u"&&this.write(E),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(E){this.c.data.slice(0).forEach(r=>r(E))}h(E){this.c.error.length===0?(0,i.$1)(E):this.c.error.slice(0).forEach(r=>r(E))}i(){this.c.end.slice(0).forEach(E=>E())}on(E,r){if(!this.a.destroyed)switch(E){case"data":this.c.data.push(r),this.resume();break;case"end":this.c.end.push(r),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(r),this.a.flowing&&this.k();break}}removeListener(E,r){if(this.a.destroyed)return;let d;switch(E){case"data":d=this.c.data;break;case"end":d=this.c.end;break;case"error":d=this.c.error;break}if(d){const D=d.indexOf(r);D>=0&&d.splice(D,1)}}j(){if(this.b.data.length>0){const E=this.e(this.b.data);this.g(E),this.b.data.length=0;const r=[...this.d];this.d.length=0,r.forEach(d=>d())}}k(){if(this.c.error.length>0){for(const E of this.b.error)this.h(E);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function f(k,E){const r=[];let d;for(;(d=k.read())!==null;)r.push(d);return E(r)}function w(k,E,r){const d=[];let D;for(;(D=k.read())!==null&&d.length<r;)d.push(D);return D===null&&d.length>0?E(d):{read:()=>{if(d.length>0)return d.shift();if(typeof D<"u"){const R=D;return D=void 0,R}return k.read()}}}function A(k,E){return new Promise((r,d)=>{const D=[];$(k,{onData:R=>{E&&D.push(R)},onError:R=>{E?d(R):r(void 0)},onEnd:()=>{r(E?E(D):void 0)}})})}function $(k,E,r){k.on("error",d=>{r?.isCancellationRequested||E.onError(d)}),k.on("end",()=>{r?.isCancellationRequested||E.onEnd()}),k.on("data",d=>{r?.isCancellationRequested||E.onData(d)})}function m(k,E){return new Promise((r,d)=>{const D=new n.$Tc,R=[],_=p=>{if(R.push(p),R.length>E)return D.dispose(),k.pause(),r({stream:k,buffer:R,ended:!1})},H=p=>(D.dispose(),d(p)),x=()=>(D.dispose(),r({stream:k,buffer:R,ended:!0}));D.add((0,n.$Sc)(()=>k.removeListener("error",H))),k.on("error",H),D.add((0,n.$Sc)(()=>k.removeListener("end",x))),k.on("end",x),D.add((0,n.$Sc)(()=>k.removeListener("data",_))),k.on("data",_)})}function e(k,E){const r=v(E);return r.end(k),r}function s(){const k=v(()=>{throw new Error("not supported")});return k.end(),k}function o(k){let E=!1;return{read:()=>E?null:(E=!0,k)}}function h(k,E,r){const d=v(r);return $(k,{onData:D=>d.write(E.data(D)),onError:D=>d.error(E.error?E.error(D):D),onEnd:()=>d.end()}),d}function c(k,E,r){let d=!1;return{read:()=>{const D=E.read();return d?D:(d=!0,D!==null?r([k,D]):k)}}}function b(k,E,r){let d=!1;const D=v(r);return $(E,{onData:R=>d?D.write(R):(d=!0,D.write(r([k,R]))),onError:R=>D.error(R),onEnd:()=>{d||(d=!0,D.write(k)),D.end()}}),D}}),define(pe[48],we([1,0,26,101]),function(oe,t,i,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Je=void 0,t.$Ke=f,t.$Le=w,t.$Me=A,t.$Ne=$,t.$Oe=m,t.$Pe=e,t.$Qe=s,t.$Re=o,t.$Se=h,t.$Te=c,t.$Ue=b,t.$Ve=k,t.$We=E,t.$Xe=r,t.$Ye=d,t.$Ze=D,t.$1e=R,t.$2e=_,t.$3e=H,t.$4e=M;const B=typeof Buffer<"u",O=new i.$V(()=>new Uint8Array(256));let T,v;class y{static alloc(N){return B?new y(Buffer.allocUnsafe(N)):new y(new Uint8Array(N))}static wrap(N){return B&&!Buffer.isBuffer(N)&&(N=Buffer.from(N.buffer,N.byteOffset,N.byteLength)),new y(N)}static fromString(N,P){return!(P?.dontUseNodeBuffer||!1)&&B?new y(Buffer.from(N)):(T||(T=new TextEncoder),new y(T.encode(N)))}static fromByteArray(N){const P=y.alloc(N.length);for(let W=0,ne=N.length;W<ne;W++)P.buffer[W]=N[W];return P}static concat(N,P){if(typeof P>"u"){P=0;for(let Q=0,Y=N.length;Q<Y;Q++)P+=N[Q].byteLength}const W=y.alloc(P);let ne=0;for(let Q=0,Y=N.length;Q<Y;Q++){const te=N[Q];W.set(te,ne),ne+=te.byteLength}return W}constructor(N){this.buffer=N,this.byteLength=this.buffer.byteLength}clone(){const N=y.alloc(this.byteLength);return N.set(this),N}toString(){return B?this.buffer.toString():(v||(v=new TextDecoder),v.decode(this.buffer))}slice(N,P){return new y(this.buffer.subarray(N,P))}set(N,P){if(N instanceof y)this.buffer.set(N.buffer,P);else if(N instanceof Uint8Array)this.buffer.set(N,P);else if(N instanceof ArrayBuffer)this.buffer.set(new Uint8Array(N),P);else if(ArrayBuffer.isView(N))this.buffer.set(new Uint8Array(N.buffer,N.byteOffset,N.byteLength),P);else throw new Error("Unknown argument 'array'")}readUInt32BE(N){return $(this.buffer,N)}writeUInt32BE(N,P){m(this.buffer,N,P)}readUInt32LE(N){return e(this.buffer,N)}writeUInt32LE(N,P){s(this.buffer,N,P)}readUInt8(N){return o(this.buffer,N)}writeUInt8(N,P){h(this.buffer,N,P)}indexOf(N,P=0){return f(this.buffer,N instanceof y?N.buffer:N,P)}}t.$Je=y;function f(U,N,P=0){const W=N.byteLength,ne=U.byteLength;if(W===0)return 0;if(W===1)return U.indexOf(N[0]);if(W>ne-P)return-1;const Q=O.value;Q.fill(N.length);for(let De=0;De<N.length;De++)Q[N[De]]=N.length-De-1;let Y=P+N.length-1,te=Y,de=-1;for(;Y<ne;)if(U[Y]===N[te]){if(te===0){de=Y;break}Y--,te--}else Y+=Math.max(N.length-te,Q[U[Y]]),te=N.length-1;return de}function w(U,N){return U[N+0]<<0>>>0|U[N+1]<<8>>>0}function A(U,N,P){U[P+0]=N&255,N=N>>>8,U[P+1]=N&255}function $(U,N){return U[N]*2**24+U[N+1]*2**16+U[N+2]*2**8+U[N+3]}function m(U,N,P){U[P+3]=N,N=N>>>8,U[P+2]=N,N=N>>>8,U[P+1]=N,N=N>>>8,U[P]=N}function e(U,N){return U[N+0]<<0>>>0|U[N+1]<<8>>>0|U[N+2]<<16>>>0|U[N+3]<<24>>>0}function s(U,N,P){U[P+0]=N&255,N=N>>>8,U[P+1]=N&255,N=N>>>8,U[P+2]=N&255,N=N>>>8,U[P+3]=N&255}function o(U,N){return U[N]}function h(U,N,P){U[P]=N}function c(U){return n.$ye(U,N=>y.concat(N))}function b(U){return n.$Fe(U)}function k(U){return n.$Ae(U,N=>y.concat(N))}async function E(U){return U.ended?y.concat(U.buffer):y.concat([...U.buffer,await k(U.stream)])}function r(U){return n.$De(U,N=>y.concat(N))}function d(U){return n.$Ge(U,{data:N=>typeof N=="string"?y.fromString(N):y.wrap(N)},N=>y.concat(N))}function D(U){return n.$xe(N=>y.concat(N),U)}function R(U,N){return n.$He(U,N,P=>y.concat(P))}function _(U,N){return n.$Ie(U,N,P=>y.concat(P))}function H(U){let N=0,P=0,W=0;const ne=new Uint8Array(Math.floor(U.length/4*3)),Q=te=>{switch(P){case 3:ne[W++]=N|te,P=0;break;case 2:ne[W++]=N|te>>>2,N=te<<6,P=3;break;case 1:ne[W++]=N|te>>>4,N=te<<4,P=2;break;default:N=te<<2,P=1}};for(let te=0;te<U.length;te++){const de=U.charCodeAt(te);if(de>=65&&de<=90)Q(de-65);else if(de>=97&&de<=122)Q(de-97+26);else if(de>=48&&de<=57)Q(de-48+52);else if(de===43||de===45)Q(62);else if(de===47||de===95)Q(63);else{if(de===61)break;throw new SyntaxError(`Unexpected base64 character ${U[te]}`)}}const Y=W;for(;P>0;)Q(0);return y.wrap(ne).slice(0,Y)}const x="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",p="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function M({buffer:U},N=!0,P=!1){const W=P?p:x;let ne="";const Q=U.byteLength%3;let Y=0;for(;Y<U.byteLength-Q;Y+=3){const te=U[Y+0],de=U[Y+1],De=U[Y+2];ne+=W[te>>>2],ne+=W[(te<<4|de>>>4)&63],ne+=W[(de<<2|De>>>6)&63],ne+=W[De&63]}if(Q===1){const te=U[Y+0];ne+=W[te>>>2],ne+=W[te<<4&63],N&&(ne+="==")}else if(Q===2){const te=U[Y+0],de=U[Y+1];ne+=W[te>>>2],ne+=W[(te<<4|de>>>4)&63],ne+=W[de<<2&63],N&&(ne+="=")}return ne}}),define(pe[62],we([1,0]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ce=void 0,t.$ce=Symbol("MicrotaskDelay")}),define(pe[10],we([1,0]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ag=i,t.$bg=n,t.$cg=B,t.$dg=O,t.$eg=T,t.$fg=v,t.$gg=y,t.$hg=f,t.$ig=w,t.$jg=A,t.$kg=$,t.$lg=m,t.$mg=e,t.$ng=o,t.$og=h,t.$pg=c,t.$qg=b,t.$rg=k;function i(E){return typeof E=="string"}function n(E){return Array.isArray(E)&&E.every(r=>i(r))}function B(E){return typeof E=="object"&&E!==null&&!Array.isArray(E)&&!(E instanceof RegExp)&&!(E instanceof Date)}function O(E){const r=Object.getPrototypeOf(Uint8Array);return typeof E=="object"&&E instanceof r}function T(E){return typeof E=="number"&&!isNaN(E)}function v(E){return!!E&&typeof E[Symbol.iterator]=="function"}function y(E){return E===!0||E===!1}function f(E){return typeof E>"u"}function w(E){return!A(E)}function A(E){return f(E)||E===null}function $(E,r){if(!E)throw new Error(r?`Unexpected type, expected '${r}'`:"Unexpected type")}function m(E){if(A(E))throw new Error("Assertion Failed: argument is undefined or null");return E}function e(...E){const r=[];for(let d=0;d<E.length;d++){const D=E[d];if(A(D))throw new Error(`Assertion Failed: argument at index ${d} is undefined or null`);r.push(D)}return r}const s=Object.prototype.hasOwnProperty;function o(E){if(!B(E))return!1;for(const r in E)if(s.call(E,r))return!1;return!0}function h(E){return typeof E=="function"}function c(...E){return E.length>0&&E.every(h)}function b(E,r){const d=Math.min(E.length,r.length);for(let D=0;D<d;D++)k(E[D],r[D])}function k(E,r){if(i(r)){if(typeof E!==r)throw new Error(`argument does not match constraint: typeof ${r}`)}else if(h(r)){try{if(E instanceof r)return}catch{}if(!A(E)&&E.constructor===r||r.length===1&&r.call(void 0,E)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}}),define(pe[49],we([1,0,10]),function(oe,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Uj=B,t.$Vj=O;const n=Object.create(null);function B(T,v){if((0,i.$ag)(v)){const y=n[v];if(y===void 0)throw new Error(`${T} references an unknown codicon: ${v}`);v=y}return n[T]=v,{id:T}}function O(){return n}}),define(pe[102],we([1,0,49]),function(oe,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Wj=void 0,t.$Wj={add:(0,i.$Uj)("add",6e4),plus:(0,i.$Uj)("plus",6e4),gistNew:(0,i.$Uj)("gist-new",6e4),repoCreate:(0,i.$Uj)("repo-create",6e4),lightbulb:(0,i.$Uj)("lightbulb",60001),lightBulb:(0,i.$Uj)("light-bulb",60001),repo:(0,i.$Uj)("repo",60002),repoDelete:(0,i.$Uj)("repo-delete",60002),gistFork:(0,i.$Uj)("gist-fork",60003),repoForked:(0,i.$Uj)("repo-forked",60003),gitPullRequest:(0,i.$Uj)("git-pull-request",60004),gitPullRequestAbandoned:(0,i.$Uj)("git-pull-request-abandoned",60004),recordKeys:(0,i.$Uj)("record-keys",60005),keyboard:(0,i.$Uj)("keyboard",60005),tag:(0,i.$Uj)("tag",60006),gitPullRequestLabel:(0,i.$Uj)("git-pull-request-label",60006),tagAdd:(0,i.$Uj)("tag-add",60006),tagRemove:(0,i.$Uj)("tag-remove",60006),person:(0,i.$Uj)("person",60007),personFollow:(0,i.$Uj)("person-follow",60007),personOutline:(0,i.$Uj)("person-outline",60007),personFilled:(0,i.$Uj)("person-filled",60007),gitBranch:(0,i.$Uj)("git-branch",60008),gitBranchCreate:(0,i.$Uj)("git-branch-create",60008),gitBranchDelete:(0,i.$Uj)("git-branch-delete",60008),sourceControl:(0,i.$Uj)("source-control",60008),mirror:(0,i.$Uj)("mirror",60009),mirrorPublic:(0,i.$Uj)("mirror-public",60009),star:(0,i.$Uj)("star",60010),starAdd:(0,i.$Uj)("star-add",60010),starDelete:(0,i.$Uj)("star-delete",60010),starEmpty:(0,i.$Uj)("star-empty",60010),comment:(0,i.$Uj)("comment",60011),commentAdd:(0,i.$Uj)("comment-add",60011),alert:(0,i.$Uj)("alert",60012),warning:(0,i.$Uj)("warning",60012),search:(0,i.$Uj)("search",60013),searchSave:(0,i.$Uj)("search-save",60013),logOut:(0,i.$Uj)("log-out",60014),signOut:(0,i.$Uj)("sign-out",60014),logIn:(0,i.$Uj)("log-in",60015),signIn:(0,i.$Uj)("sign-in",60015),eye:(0,i.$Uj)("eye",60016),eyeUnwatch:(0,i.$Uj)("eye-unwatch",60016),eyeWatch:(0,i.$Uj)("eye-watch",60016),circleFilled:(0,i.$Uj)("circle-filled",60017),primitiveDot:(0,i.$Uj)("primitive-dot",60017),closeDirty:(0,i.$Uj)("close-dirty",60017),debugBreakpoint:(0,i.$Uj)("debug-breakpoint",60017),debugBreakpointDisabled:(0,i.$Uj)("debug-breakpoint-disabled",60017),debugHint:(0,i.$Uj)("debug-hint",60017),terminalDecorationSuccess:(0,i.$Uj)("terminal-decoration-success",60017),primitiveSquare:(0,i.$Uj)("primitive-square",60018),edit:(0,i.$Uj)("edit",60019),pencil:(0,i.$Uj)("pencil",60019),info:(0,i.$Uj)("info",60020),issueOpened:(0,i.$Uj)("issue-opened",60020),gistPrivate:(0,i.$Uj)("gist-private",60021),gitForkPrivate:(0,i.$Uj)("git-fork-private",60021),lock:(0,i.$Uj)("lock",60021),mirrorPrivate:(0,i.$Uj)("mirror-private",60021),close:(0,i.$Uj)("close",60022),removeClose:(0,i.$Uj)("remove-close",60022),x:(0,i.$Uj)("x",60022),repoSync:(0,i.$Uj)("repo-sync",60023),sync:(0,i.$Uj)("sync",60023),clone:(0,i.$Uj)("clone",60024),desktopDownload:(0,i.$Uj)("desktop-download",60024),beaker:(0,i.$Uj)("beaker",60025),microscope:(0,i.$Uj)("microscope",60025),vm:(0,i.$Uj)("vm",60026),deviceDesktop:(0,i.$Uj)("device-desktop",60026),file:(0,i.$Uj)("file",60027),fileText:(0,i.$Uj)("file-text",60027),more:(0,i.$Uj)("more",60028),ellipsis:(0,i.$Uj)("ellipsis",60028),kebabHorizontal:(0,i.$Uj)("kebab-horizontal",60028),mailReply:(0,i.$Uj)("mail-reply",60029),reply:(0,i.$Uj)("reply",60029),organization:(0,i.$Uj)("organization",60030),organizationFilled:(0,i.$Uj)("organization-filled",60030),organizationOutline:(0,i.$Uj)("organization-outline",60030),newFile:(0,i.$Uj)("new-file",60031),fileAdd:(0,i.$Uj)("file-add",60031),newFolder:(0,i.$Uj)("new-folder",60032),fileDirectoryCreate:(0,i.$Uj)("file-directory-create",60032),trash:(0,i.$Uj)("trash",60033),trashcan:(0,i.$Uj)("trashcan",60033),history:(0,i.$Uj)("history",60034),clock:(0,i.$Uj)("clock",60034),folder:(0,i.$Uj)("folder",60035),fileDirectory:(0,i.$Uj)("file-directory",60035),symbolFolder:(0,i.$Uj)("symbol-folder",60035),logoGithub:(0,i.$Uj)("logo-github",60036),markGithub:(0,i.$Uj)("mark-github",60036),github:(0,i.$Uj)("github",60036),terminal:(0,i.$Uj)("terminal",60037),console:(0,i.$Uj)("console",60037),repl:(0,i.$Uj)("repl",60037),zap:(0,i.$Uj)("zap",60038),symbolEvent:(0,i.$Uj)("symbol-event",60038),error:(0,i.$Uj)("error",60039),stop:(0,i.$Uj)("stop",60039),variable:(0,i.$Uj)("variable",60040),symbolVariable:(0,i.$Uj)("symbol-variable",60040),array:(0,i.$Uj)("array",60042),symbolArray:(0,i.$Uj)("symbol-array",60042),symbolModule:(0,i.$Uj)("symbol-module",60043),symbolPackage:(0,i.$Uj)("symbol-package",60043),symbolNamespace:(0,i.$Uj)("symbol-namespace",60043),symbolObject:(0,i.$Uj)("symbol-object",60043),symbolMethod:(0,i.$Uj)("symbol-method",60044),symbolFunction:(0,i.$Uj)("symbol-function",60044),symbolConstructor:(0,i.$Uj)("symbol-constructor",60044),symbolBoolean:(0,i.$Uj)("symbol-boolean",60047),symbolNull:(0,i.$Uj)("symbol-null",60047),symbolNumeric:(0,i.$Uj)("symbol-numeric",60048),symbolNumber:(0,i.$Uj)("symbol-number",60048),symbolStructure:(0,i.$Uj)("symbol-structure",60049),symbolStruct:(0,i.$Uj)("symbol-struct",60049),symbolParameter:(0,i.$Uj)("symbol-parameter",60050),symbolTypeParameter:(0,i.$Uj)("symbol-type-parameter",60050),symbolKey:(0,i.$Uj)("symbol-key",60051),symbolText:(0,i.$Uj)("symbol-text",60051),symbolReference:(0,i.$Uj)("symbol-reference",60052),goToFile:(0,i.$Uj)("go-to-file",60052),symbolEnum:(0,i.$Uj)("symbol-enum",60053),symbolValue:(0,i.$Uj)("symbol-value",60053),symbolRuler:(0,i.$Uj)("symbol-ruler",60054),symbolUnit:(0,i.$Uj)("symbol-unit",60054),activateBreakpoints:(0,i.$Uj)("activate-breakpoints",60055),archive:(0,i.$Uj)("archive",60056),arrowBoth:(0,i.$Uj)("arrow-both",60057),arrowDown:(0,i.$Uj)("arrow-down",60058),arrowLeft:(0,i.$Uj)("arrow-left",60059),arrowRight:(0,i.$Uj)("arrow-right",60060),arrowSmallDown:(0,i.$Uj)("arrow-small-down",60061),arrowSmallLeft:(0,i.$Uj)("arrow-small-left",60062),arrowSmallRight:(0,i.$Uj)("arrow-small-right",60063),arrowSmallUp:(0,i.$Uj)("arrow-small-up",60064),arrowUp:(0,i.$Uj)("arrow-up",60065),bell:(0,i.$Uj)("bell",60066),bold:(0,i.$Uj)("bold",60067),book:(0,i.$Uj)("book",60068),bookmark:(0,i.$Uj)("bookmark",60069),debugBreakpointConditionalUnverified:(0,i.$Uj)("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:(0,i.$Uj)("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:(0,i.$Uj)("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:(0,i.$Uj)("debug-breakpoint-data-unverified",60072),debugBreakpointData:(0,i.$Uj)("debug-breakpoint-data",60073),debugBreakpointDataDisabled:(0,i.$Uj)("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:(0,i.$Uj)("debug-breakpoint-log-unverified",60074),debugBreakpointLog:(0,i.$Uj)("debug-breakpoint-log",60075),debugBreakpointLogDisabled:(0,i.$Uj)("debug-breakpoint-log-disabled",60075),briefcase:(0,i.$Uj)("briefcase",60076),broadcast:(0,i.$Uj)("broadcast",60077),browser:(0,i.$Uj)("browser",60078),bug:(0,i.$Uj)("bug",60079),calendar:(0,i.$Uj)("calendar",60080),caseSensitive:(0,i.$Uj)("case-sensitive",60081),check:(0,i.$Uj)("check",60082),checklist:(0,i.$Uj)("checklist",60083),chevronDown:(0,i.$Uj)("chevron-down",60084),chevronLeft:(0,i.$Uj)("chevron-left",60085),chevronRight:(0,i.$Uj)("chevron-right",60086),chevronUp:(0,i.$Uj)("chevron-up",60087),chromeClose:(0,i.$Uj)("chrome-close",60088),chromeMaximize:(0,i.$Uj)("chrome-maximize",60089),chromeMinimize:(0,i.$Uj)("chrome-minimize",60090),chromeRestore:(0,i.$Uj)("chrome-restore",60091),circleOutline:(0,i.$Uj)("circle-outline",60092),circle:(0,i.$Uj)("circle",60092),debugBreakpointUnverified:(0,i.$Uj)("debug-breakpoint-unverified",60092),terminalDecorationIncomplete:(0,i.$Uj)("terminal-decoration-incomplete",60092),circleSlash:(0,i.$Uj)("circle-slash",60093),circuitBoard:(0,i.$Uj)("circuit-board",60094),clearAll:(0,i.$Uj)("clear-all",60095),clippy:(0,i.$Uj)("clippy",60096),closeAll:(0,i.$Uj)("close-all",60097),cloudDownload:(0,i.$Uj)("cloud-download",60098),cloudUpload:(0,i.$Uj)("cloud-upload",60099),code:(0,i.$Uj)("code",60100),collapseAll:(0,i.$Uj)("collapse-all",60101),colorMode:(0,i.$Uj)("color-mode",60102),commentDiscussion:(0,i.$Uj)("comment-discussion",60103),creditCard:(0,i.$Uj)("credit-card",60105),dash:(0,i.$Uj)("dash",60108),dashboard:(0,i.$Uj)("dashboard",60109),database:(0,i.$Uj)("database",60110),debugContinue:(0,i.$Uj)("debug-continue",60111),debugDisconnect:(0,i.$Uj)("debug-disconnect",60112),debugPause:(0,i.$Uj)("debug-pause",60113),debugRestart:(0,i.$Uj)("debug-restart",60114),debugStart:(0,i.$Uj)("debug-start",60115),debugStepInto:(0,i.$Uj)("debug-step-into",60116),debugStepOut:(0,i.$Uj)("debug-step-out",60117),debugStepOver:(0,i.$Uj)("debug-step-over",60118),debugStop:(0,i.$Uj)("debug-stop",60119),debug:(0,i.$Uj)("debug",60120),deviceCameraVideo:(0,i.$Uj)("device-camera-video",60121),deviceCamera:(0,i.$Uj)("device-camera",60122),deviceMobile:(0,i.$Uj)("device-mobile",60123),diffAdded:(0,i.$Uj)("diff-added",60124),diffIgnored:(0,i.$Uj)("diff-ignored",60125),diffModified:(0,i.$Uj)("diff-modified",60126),diffRemoved:(0,i.$Uj)("diff-removed",60127),diffRenamed:(0,i.$Uj)("diff-renamed",60128),diff:(0,i.$Uj)("diff",60129),diffSidebyside:(0,i.$Uj)("diff-sidebyside",60129),discard:(0,i.$Uj)("discard",60130),editorLayout:(0,i.$Uj)("editor-layout",60131),emptyWindow:(0,i.$Uj)("empty-window",60132),exclude:(0,i.$Uj)("exclude",60133),extensions:(0,i.$Uj)("extensions",60134),eyeClosed:(0,i.$Uj)("eye-closed",60135),fileBinary:(0,i.$Uj)("file-binary",60136),fileCode:(0,i.$Uj)("file-code",60137),fileMedia:(0,i.$Uj)("file-media",60138),filePdf:(0,i.$Uj)("file-pdf",60139),fileSubmodule:(0,i.$Uj)("file-submodule",60140),fileSymlinkDirectory:(0,i.$Uj)("file-symlink-directory",60141),fileSymlinkFile:(0,i.$Uj)("file-symlink-file",60142),fileZip:(0,i.$Uj)("file-zip",60143),files:(0,i.$Uj)("files",60144),filter:(0,i.$Uj)("filter",60145),flame:(0,i.$Uj)("flame",60146),foldDown:(0,i.$Uj)("fold-down",60147),foldUp:(0,i.$Uj)("fold-up",60148),fold:(0,i.$Uj)("fold",60149),folderActive:(0,i.$Uj)("folder-active",60150),folderOpened:(0,i.$Uj)("folder-opened",60151),gear:(0,i.$Uj)("gear",60152),gift:(0,i.$Uj)("gift",60153),gistSecret:(0,i.$Uj)("gist-secret",60154),gist:(0,i.$Uj)("gist",60155),gitCommit:(0,i.$Uj)("git-commit",60156),gitCompare:(0,i.$Uj)("git-compare",60157),compareChanges:(0,i.$Uj)("compare-changes",60157),gitMerge:(0,i.$Uj)("git-merge",60158),githubAction:(0,i.$Uj)("github-action",60159),githubAlt:(0,i.$Uj)("github-alt",60160),globe:(0,i.$Uj)("globe",60161),grabber:(0,i.$Uj)("grabber",60162),graph:(0,i.$Uj)("graph",60163),gripper:(0,i.$Uj)("gripper",60164),heart:(0,i.$Uj)("heart",60165),home:(0,i.$Uj)("home",60166),horizontalRule:(0,i.$Uj)("horizontal-rule",60167),hubot:(0,i.$Uj)("hubot",60168),inbox:(0,i.$Uj)("inbox",60169),issueReopened:(0,i.$Uj)("issue-reopened",60171),issues:(0,i.$Uj)("issues",60172),italic:(0,i.$Uj)("italic",60173),jersey:(0,i.$Uj)("jersey",60174),json:(0,i.$Uj)("json",60175),kebabVertical:(0,i.$Uj)("kebab-vertical",60176),key:(0,i.$Uj)("key",60177),law:(0,i.$Uj)("law",60178),lightbulbAutofix:(0,i.$Uj)("lightbulb-autofix",60179),linkExternal:(0,i.$Uj)("link-external",60180),link:(0,i.$Uj)("link",60181),listOrdered:(0,i.$Uj)("list-ordered",60182),listUnordered:(0,i.$Uj)("list-unordered",60183),liveShare:(0,i.$Uj)("live-share",60184),loading:(0,i.$Uj)("loading",60185),location:(0,i.$Uj)("location",60186),mailRead:(0,i.$Uj)("mail-read",60187),mail:(0,i.$Uj)("mail",60188),markdown:(0,i.$Uj)("markdown",60189),megaphone:(0,i.$Uj)("megaphone",60190),mention:(0,i.$Uj)("mention",60191),milestone:(0,i.$Uj)("milestone",60192),gitPullRequestMilestone:(0,i.$Uj)("git-pull-request-milestone",60192),mortarBoard:(0,i.$Uj)("mortar-board",60193),move:(0,i.$Uj)("move",60194),multipleWindows:(0,i.$Uj)("multiple-windows",60195),mute:(0,i.$Uj)("mute",60196),noNewline:(0,i.$Uj)("no-newline",60197),note:(0,i.$Uj)("note",60198),octoface:(0,i.$Uj)("octoface",60199),openPreview:(0,i.$Uj)("open-preview",60200),package:(0,i.$Uj)("package",60201),paintcan:(0,i.$Uj)("paintcan",60202),pin:(0,i.$Uj)("pin",60203),play:(0,i.$Uj)("play",60204),run:(0,i.$Uj)("run",60204),plug:(0,i.$Uj)("plug",60205),preserveCase:(0,i.$Uj)("preserve-case",60206),preview:(0,i.$Uj)("preview",60207),project:(0,i.$Uj)("project",60208),pulse:(0,i.$Uj)("pulse",60209),question:(0,i.$Uj)("question",60210),quote:(0,i.$Uj)("quote",60211),radioTower:(0,i.$Uj)("radio-tower",60212),reactions:(0,i.$Uj)("reactions",60213),references:(0,i.$Uj)("references",60214),refresh:(0,i.$Uj)("refresh",60215),regex:(0,i.$Uj)("regex",60216),remoteExplorer:(0,i.$Uj)("remote-explorer",60217),remote:(0,i.$Uj)("remote",60218),remove:(0,i.$Uj)("remove",60219),replaceAll:(0,i.$Uj)("replace-all",60220),replace:(0,i.$Uj)("replace",60221),repoClone:(0,i.$Uj)("repo-clone",60222),repoForcePush:(0,i.$Uj)("repo-force-push",60223),repoPull:(0,i.$Uj)("repo-pull",60224),repoPush:(0,i.$Uj)("repo-push",60225),report:(0,i.$Uj)("report",60226),requestChanges:(0,i.$Uj)("request-changes",60227),rocket:(0,i.$Uj)("rocket",60228),rootFolderOpened:(0,i.$Uj)("root-folder-opened",60229),rootFolder:(0,i.$Uj)("root-folder",60230),rss:(0,i.$Uj)("rss",60231),ruby:(0,i.$Uj)("ruby",60232),saveAll:(0,i.$Uj)("save-all",60233),saveAs:(0,i.$Uj)("save-as",60234),save:(0,i.$Uj)("save",60235),screenFull:(0,i.$Uj)("screen-full",60236),screenNormal:(0,i.$Uj)("screen-normal",60237),searchStop:(0,i.$Uj)("search-stop",60238),server:(0,i.$Uj)("server",60240),settingsGear:(0,i.$Uj)("settings-gear",60241),settings:(0,i.$Uj)("settings",60242),shield:(0,i.$Uj)("shield",60243),smiley:(0,i.$Uj)("smiley",60244),sortPrecedence:(0,i.$Uj)("sort-precedence",60245),splitHorizontal:(0,i.$Uj)("split-horizontal",60246),splitVertical:(0,i.$Uj)("split-vertical",60247),squirrel:(0,i.$Uj)("squirrel",60248),starFull:(0,i.$Uj)("star-full",60249),starHalf:(0,i.$Uj)("star-half",60250),symbolClass:(0,i.$Uj)("symbol-class",60251),symbolColor:(0,i.$Uj)("symbol-color",60252),symbolConstant:(0,i.$Uj)("symbol-constant",60253),symbolEnumMember:(0,i.$Uj)("symbol-enum-member",60254),symbolField:(0,i.$Uj)("symbol-field",60255),symbolFile:(0,i.$Uj)("symbol-file",60256),symbolInterface:(0,i.$Uj)("symbol-interface",60257),symbolKeyword:(0,i.$Uj)("symbol-keyword",60258),symbolMisc:(0,i.$Uj)("symbol-misc",60259),symbolOperator:(0,i.$Uj)("symbol-operator",60260),symbolProperty:(0,i.$Uj)("symbol-property",60261),wrench:(0,i.$Uj)("wrench",60261),wrenchSubaction:(0,i.$Uj)("wrench-subaction",60261),symbolSnippet:(0,i.$Uj)("symbol-snippet",60262),tasklist:(0,i.$Uj)("tasklist",60263),telescope:(0,i.$Uj)("telescope",60264),textSize:(0,i.$Uj)("text-size",60265),threeBars:(0,i.$Uj)("three-bars",60266),thumbsdown:(0,i.$Uj)("thumbsdown",60267),thumbsup:(0,i.$Uj)("thumbsup",60268),tools:(0,i.$Uj)("tools",60269),triangleDown:(0,i.$Uj)("triangle-down",60270),triangleLeft:(0,i.$Uj)("triangle-left",60271),triangleRight:(0,i.$Uj)("triangle-right",60272),triangleUp:(0,i.$Uj)("triangle-up",60273),twitter:(0,i.$Uj)("twitter",60274),unfold:(0,i.$Uj)("unfold",60275),unlock:(0,i.$Uj)("unlock",60276),unmute:(0,i.$Uj)("unmute",60277),unverified:(0,i.$Uj)("unverified",60278),verified:(0,i.$Uj)("verified",60279),versions:(0,i.$Uj)("versions",60280),vmActive:(0,i.$Uj)("vm-active",60281),vmOutline:(0,i.$Uj)("vm-outline",60282),vmRunning:(0,i.$Uj)("vm-running",60283),watch:(0,i.$Uj)("watch",60284),whitespace:(0,i.$Uj)("whitespace",60285),wholeWord:(0,i.$Uj)("whole-word",60286),window:(0,i.$Uj)("window",60287),wordWrap:(0,i.$Uj)("word-wrap",60288),zoomIn:(0,i.$Uj)("zoom-in",60289),zoomOut:(0,i.$Uj)("zoom-out",60290),listFilter:(0,i.$Uj)("list-filter",60291),listFlat:(0,i.$Uj)("list-flat",60292),listSelection:(0,i.$Uj)("list-selection",60293),selection:(0,i.$Uj)("selection",60293),listTree:(0,i.$Uj)("list-tree",60294),debugBreakpointFunctionUnverified:(0,i.$Uj)("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:(0,i.$Uj)("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:(0,i.$Uj)("debug-breakpoint-function-disabled",60296),debugStackframeActive:(0,i.$Uj)("debug-stackframe-active",60297),circleSmallFilled:(0,i.$Uj)("circle-small-filled",60298),debugStackframeDot:(0,i.$Uj)("debug-stackframe-dot",60298),terminalDecorationMark:(0,i.$Uj)("terminal-decoration-mark",60298),debugStackframe:(0,i.$Uj)("debug-stackframe",60299),debugStackframeFocused:(0,i.$Uj)("debug-stackframe-focused",60299),debugBreakpointUnsupported:(0,i.$Uj)("debug-breakpoint-unsupported",60300),symbolString:(0,i.$Uj)("symbol-string",60301),debugReverseContinue:(0,i.$Uj)("debug-reverse-continue",60302),debugStepBack:(0,i.$Uj)("debug-step-back",60303),debugRestartFrame:(0,i.$Uj)("debug-restart-frame",60304),debugAlt:(0,i.$Uj)("debug-alt",60305),callIncoming:(0,i.$Uj)("call-incoming",60306),callOutgoing:(0,i.$Uj)("call-outgoing",60307),menu:(0,i.$Uj)("menu",60308),expandAll:(0,i.$Uj)("expand-all",60309),feedback:(0,i.$Uj)("feedback",60310),gitPullRequestReviewer:(0,i.$Uj)("git-pull-request-reviewer",60310),groupByRefType:(0,i.$Uj)("group-by-ref-type",60311),ungroupByRefType:(0,i.$Uj)("ungroup-by-ref-type",60312),account:(0,i.$Uj)("account",60313),gitPullRequestAssignee:(0,i.$Uj)("git-pull-request-assignee",60313),bellDot:(0,i.$Uj)("bell-dot",60314),debugConsole:(0,i.$Uj)("debug-console",60315),library:(0,i.$Uj)("library",60316),output:(0,i.$Uj)("output",60317),runAll:(0,i.$Uj)("run-all",60318),syncIgnored:(0,i.$Uj)("sync-ignored",60319),pinned:(0,i.$Uj)("pinned",60320),githubInverted:(0,i.$Uj)("github-inverted",60321),serverProcess:(0,i.$Uj)("server-process",60322),serverEnvironment:(0,i.$Uj)("server-environment",60323),pass:(0,i.$Uj)("pass",60324),issueClosed:(0,i.$Uj)("issue-closed",60324),stopCircle:(0,i.$Uj)("stop-circle",60325),playCircle:(0,i.$Uj)("play-circle",60326),record:(0,i.$Uj)("record",60327),debugAltSmall:(0,i.$Uj)("debug-alt-small",60328),vmConnect:(0,i.$Uj)("vm-connect",60329),cloud:(0,i.$Uj)("cloud",60330),merge:(0,i.$Uj)("merge",60331),export:(0,i.$Uj)("export",60332),graphLeft:(0,i.$Uj)("graph-left",60333),magnet:(0,i.$Uj)("magnet",60334),notebook:(0,i.$Uj)("notebook",60335),redo:(0,i.$Uj)("redo",60336),checkAll:(0,i.$Uj)("check-all",60337),pinnedDirty:(0,i.$Uj)("pinned-dirty",60338),passFilled:(0,i.$Uj)("pass-filled",60339),circleLargeFilled:(0,i.$Uj)("circle-large-filled",60340),circleLarge:(0,i.$Uj)("circle-large",60341),circleLargeOutline:(0,i.$Uj)("circle-large-outline",60341),combine:(0,i.$Uj)("combine",60342),gather:(0,i.$Uj)("gather",60342),table:(0,i.$Uj)("table",60343),variableGroup:(0,i.$Uj)("variable-group",60344),typeHierarchy:(0,i.$Uj)("type-hierarchy",60345),typeHierarchySub:(0,i.$Uj)("type-hierarchy-sub",60346),typeHierarchySuper:(0,i.$Uj)("type-hierarchy-super",60347),gitPullRequestCreate:(0,i.$Uj)("git-pull-request-create",60348),runAbove:(0,i.$Uj)("run-above",60349),runBelow:(0,i.$Uj)("run-below",60350),notebookTemplate:(0,i.$Uj)("notebook-template",60351),debugRerun:(0,i.$Uj)("debug-rerun",60352),workspaceTrusted:(0,i.$Uj)("workspace-trusted",60353),workspaceUntrusted:(0,i.$Uj)("workspace-untrusted",60354),workspaceUnknown:(0,i.$Uj)("workspace-unknown",60355),terminalCmd:(0,i.$Uj)("terminal-cmd",60356),terminalDebian:(0,i.$Uj)("terminal-debian",60357),terminalLinux:(0,i.$Uj)("terminal-linux",60358),terminalPowershell:(0,i.$Uj)("terminal-powershell",60359),terminalTmux:(0,i.$Uj)("terminal-tmux",60360),terminalUbuntu:(0,i.$Uj)("terminal-ubuntu",60361),terminalBash:(0,i.$Uj)("terminal-bash",60362),arrowSwap:(0,i.$Uj)("arrow-swap",60363),copy:(0,i.$Uj)("copy",60364),personAdd:(0,i.$Uj)("person-add",60365),filterFilled:(0,i.$Uj)("filter-filled",60366),wand:(0,i.$Uj)("wand",60367),debugLineByLine:(0,i.$Uj)("debug-line-by-line",60368),inspect:(0,i.$Uj)("inspect",60369),layers:(0,i.$Uj)("layers",60370),layersDot:(0,i.$Uj)("layers-dot",60371),layersActive:(0,i.$Uj)("layers-active",60372),compass:(0,i.$Uj)("compass",60373),compassDot:(0,i.$Uj)("compass-dot",60374),compassActive:(0,i.$Uj)("compass-active",60375),azure:(0,i.$Uj)("azure",60376),issueDraft:(0,i.$Uj)("issue-draft",60377),gitPullRequestClosed:(0,i.$Uj)("git-pull-request-closed",60378),gitPullRequestDraft:(0,i.$Uj)("git-pull-request-draft",60379),debugAll:(0,i.$Uj)("debug-all",60380),debugCoverage:(0,i.$Uj)("debug-coverage",60381),runErrors:(0,i.$Uj)("run-errors",60382),folderLibrary:(0,i.$Uj)("folder-library",60383),debugContinueSmall:(0,i.$Uj)("debug-continue-small",60384),beakerStop:(0,i.$Uj)("beaker-stop",60385),graphLine:(0,i.$Uj)("graph-line",60386),graphScatter:(0,i.$Uj)("graph-scatter",60387),pieChart:(0,i.$Uj)("pie-chart",60388),bracket:(0,i.$Uj)("bracket",60175),bracketDot:(0,i.$Uj)("bracket-dot",60389),bracketError:(0,i.$Uj)("bracket-error",60390),lockSmall:(0,i.$Uj)("lock-small",60391),azureDevops:(0,i.$Uj)("azure-devops",60392),verifiedFilled:(0,i.$Uj)("verified-filled",60393),newline:(0,i.$Uj)("newline",60394),layout:(0,i.$Uj)("layout",60395),layoutActivitybarLeft:(0,i.$Uj)("layout-activitybar-left",60396),layoutActivitybarRight:(0,i.$Uj)("layout-activitybar-right",60397),layoutPanelLeft:(0,i.$Uj)("layout-panel-left",60398),layoutPanelCenter:(0,i.$Uj)("layout-panel-center",60399),layoutPanelJustify:(0,i.$Uj)("layout-panel-justify",60400),layoutPanelRight:(0,i.$Uj)("layout-panel-right",60401),layoutPanel:(0,i.$Uj)("layout-panel",60402),layoutSidebarLeft:(0,i.$Uj)("layout-sidebar-left",60403),layoutSidebarRight:(0,i.$Uj)("layout-sidebar-right",60404),layoutStatusbar:(0,i.$Uj)("layout-statusbar",60405),layoutMenubar:(0,i.$Uj)("layout-menubar",60406),layoutCentered:(0,i.$Uj)("layout-centered",60407),target:(0,i.$Uj)("target",60408),indent:(0,i.$Uj)("indent",60409),recordSmall:(0,i.$Uj)("record-small",60410),errorSmall:(0,i.$Uj)("error-small",60411),terminalDecorationError:(0,i.$Uj)("terminal-decoration-error",60411),arrowCircleDown:(0,i.$Uj)("arrow-circle-down",60412),arrowCircleLeft:(0,i.$Uj)("arrow-circle-left",60413),arrowCircleRight:(0,i.$Uj)("arrow-circle-right",60414),arrowCircleUp:(0,i.$Uj)("arrow-circle-up",60415),layoutSidebarRightOff:(0,i.$Uj)("layout-sidebar-right-off",60416),layoutPanelOff:(0,i.$Uj)("layout-panel-off",60417),layoutSidebarLeftOff:(0,i.$Uj)("layout-sidebar-left-off",60418),blank:(0,i.$Uj)("blank",60419),heartFilled:(0,i.$Uj)("heart-filled",60420),map:(0,i.$Uj)("map",60421),mapHorizontal:(0,i.$Uj)("map-horizontal",60421),foldHorizontal:(0,i.$Uj)("fold-horizontal",60421),mapFilled:(0,i.$Uj)("map-filled",60422),mapHorizontalFilled:(0,i.$Uj)("map-horizontal-filled",60422),foldHorizontalFilled:(0,i.$Uj)("fold-horizontal-filled",60422),circleSmall:(0,i.$Uj)("circle-small",60423),bellSlash:(0,i.$Uj)("bell-slash",60424),bellSlashDot:(0,i.$Uj)("bell-slash-dot",60425),commentUnresolved:(0,i.$Uj)("comment-unresolved",60426),gitPullRequestGoToChanges:(0,i.$Uj)("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:(0,i.$Uj)("git-pull-request-new-changes",60428),searchFuzzy:(0,i.$Uj)("search-fuzzy",60429),commentDraft:(0,i.$Uj)("comment-draft",60430),send:(0,i.$Uj)("send",60431),sparkle:(0,i.$Uj)("sparkle",60432),insert:(0,i.$Uj)("insert",60433),mic:(0,i.$Uj)("mic",60434),thumbsdownFilled:(0,i.$Uj)("thumbsdown-filled",60435),thumbsupFilled:(0,i.$Uj)("thumbsup-filled",60436),coffee:(0,i.$Uj)("coffee",60437),snake:(0,i.$Uj)("snake",60438),game:(0,i.$Uj)("game",60439),vr:(0,i.$Uj)("vr",60440),chip:(0,i.$Uj)("chip",60441),piano:(0,i.$Uj)("piano",60442),music:(0,i.$Uj)("music",60443),micFilled:(0,i.$Uj)("mic-filled",60444),repoFetch:(0,i.$Uj)("repo-fetch",60445),copilot:(0,i.$Uj)("copilot",60446),lightbulbSparkle:(0,i.$Uj)("lightbulb-sparkle",60447),robot:(0,i.$Uj)("robot",60448),sparkleFilled:(0,i.$Uj)("sparkle-filled",60449),diffSingle:(0,i.$Uj)("diff-single",60450),diffMultiple:(0,i.$Uj)("diff-multiple",60451),surroundWith:(0,i.$Uj)("surround-with",60452),share:(0,i.$Uj)("share",60453),gitStash:(0,i.$Uj)("git-stash",60454),gitStashApply:(0,i.$Uj)("git-stash-apply",60455),gitStashPop:(0,i.$Uj)("git-stash-pop",60456),vscode:(0,i.$Uj)("vscode",60457),vscodeInsiders:(0,i.$Uj)("vscode-insiders",60458),codeOss:(0,i.$Uj)("code-oss",60459),runCoverage:(0,i.$Uj)("run-coverage",60460),runAllCoverage:(0,i.$Uj)("run-all-coverage",60461),coverage:(0,i.$Uj)("coverage",60462),githubProject:(0,i.$Uj)("github-project",60463),mapVertical:(0,i.$Uj)("map-vertical",60464),foldVertical:(0,i.$Uj)("fold-vertical",60464),mapVerticalFilled:(0,i.$Uj)("map-vertical-filled",60465),foldVerticalFilled:(0,i.$Uj)("fold-vertical-filled",60465),goToSearch:(0,i.$Uj)("go-to-search",60466),percentage:(0,i.$Uj)("percentage",60467),sortPercentage:(0,i.$Uj)("sort-percentage",60467),attach:(0,i.$Uj)("attach",60468)}}),define(pe[21],we([1,0,49,102]),function(oe,t,i,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Zj=t.$Yj=void 0,t.$Xj=B;function B(){return Object.values(t.$Zj)}t.$Yj={dialogError:(0,i.$Uj)("dialog-error","error"),dialogWarning:(0,i.$Uj)("dialog-warning","warning"),dialogInfo:(0,i.$Uj)("dialog-info","info"),dialogClose:(0,i.$Uj)("dialog-close","close"),treeItemExpanded:(0,i.$Uj)("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:(0,i.$Uj)("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:(0,i.$Uj)("tree-filter-on-type-off","list-selection"),treeFilterClear:(0,i.$Uj)("tree-filter-clear","close"),treeItemLoading:(0,i.$Uj)("tree-item-loading","loading"),menuSelection:(0,i.$Uj)("menu-selection","check"),menuSubmenu:(0,i.$Uj)("menu-submenu","chevron-right"),menuBarMore:(0,i.$Uj)("menubar-more","more"),scrollbarButtonLeft:(0,i.$Uj)("scrollbar-button-left","triangle-left"),scrollbarButtonRight:(0,i.$Uj)("scrollbar-button-right","triangle-right"),scrollbarButtonUp:(0,i.$Uj)("scrollbar-button-up","triangle-up"),scrollbarButtonDown:(0,i.$Uj)("scrollbar-button-down","triangle-down"),toolBarMore:(0,i.$Uj)("toolbar-more","more"),quickInputBack:(0,i.$Uj)("quick-input-back","arrow-left"),dropDownButton:(0,i.$Uj)("drop-down-button",60084),symbolCustomColor:(0,i.$Uj)("symbol-customcolor",60252),exportIcon:(0,i.$Uj)("export",60332),workspaceUnspecified:(0,i.$Uj)("workspace-unspecified",60355),newLine:(0,i.$Uj)("newline",60394),thumbsDownFilled:(0,i.$Uj)("thumbsdown-filled",60435),thumbsUpFilled:(0,i.$Uj)("thumbsup-filled",60436),gitFetch:(0,i.$Uj)("git-fetch",60445),lightbulbSparkleAutofix:(0,i.$Uj)("lightbulb-sparkle-autofix",60447),debugBreakpointPending:(0,i.$Uj)("debug-breakpoint-pending",60377)},t.$Zj={...n.$Wj,...t.$Yj}}),define(pe[63],we([1,0,10]),function(oe,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$9n=n,t.$0n=B,t.$$n=T,t.$_n=y,t.$ao=f,t.$bo=w,t.$co=A,t.$do=$,t.$eo=m,t.$fo=e,t.$go=s,t.$ho=o,t.$io=h;function n(c){if(!c||typeof c!="object"||c instanceof RegExp)return c;const b=Array.isArray(c)?[]:{};return Object.entries(c).forEach(([k,E])=>{b[k]=E&&typeof E=="object"?n(E):E}),b}function B(c){if(!c||typeof c!="object")return c;const b=[c];for(;b.length>0;){const k=b.shift();Object.freeze(k);for(const E in k)if(O.call(k,E)){const r=k[E];typeof r=="object"&&!Object.isFrozen(r)&&!(0,i.$dg)(r)&&b.push(r)}}return c}const O=Object.prototype.hasOwnProperty;function T(c,b){return v(c,b,new Set)}function v(c,b,k){if((0,i.$jg)(c))return c;const E=b(c);if(typeof E<"u")return E;if(Array.isArray(c)){const r=[];for(const d of c)r.push(v(d,b,k));return r}if((0,i.$cg)(c)){if(k.has(c))throw new Error("Cannot clone recursive data-structure");k.add(c);const r={};for(const d in c)O.call(c,d)&&(r[d]=v(c[d],b,k));return k.delete(c),r}return c}function y(c,b,k=!0){return(0,i.$cg)(c)?((0,i.$cg)(b)&&Object.keys(b).forEach(E=>{E in c?k&&((0,i.$cg)(c[E])&&(0,i.$cg)(b[E])?y(c[E],b[E],k):c[E]=b[E]):c[E]=b[E]}),c):b}function f(c,b){if(c===b)return!0;if(c==null||b===null||b===void 0||typeof c!=typeof b||typeof c!="object"||Array.isArray(c)!==Array.isArray(b))return!1;let k,E;if(Array.isArray(c)){if(c.length!==b.length)return!1;for(k=0;k<c.length;k++)if(!f(c[k],b[k]))return!1}else{const r=[];for(E in c)r.push(E);r.sort();const d=[];for(E in b)d.push(E);if(d.sort(),!f(r,d))return!1;for(k=0;k<r.length;k++)if(!f(c[r[k]],b[r[k]]))return!1}return!0}function w(c){const b=new Set;return JSON.stringify(c,(k,E)=>{if((0,i.$cg)(E)||Array.isArray(E)){if(b.has(E))return"[Circular]";b.add(E)}return typeof E=="bigint"?`[BigInt ${E.toString()}]`:E})}function A(c,b){const k=Object.create(null);return!c||!b||Object.keys(b).forEach(r=>{const d=c[r],D=b[r];f(d,D)||(k[r]=D)}),k}function $(c,b){const k=b.toLowerCase(),E=Object.keys(c).find(r=>r.toLowerCase()===k);return E?c[E]:c[b]}function m(c,b){const k=Object.create(null);for(const[E,r]of Object.entries(c))b(E,r)&&(k[E]=r);return k}function e(c){let b=[];for(;Object.prototype!==c;)b=b.concat(Object.getOwnPropertyNames(c)),c=Object.getPrototypeOf(c);return b}function s(c){const b=[];for(const k of e(c))typeof c[k]=="function"&&b.push(k);return b}function o(c,b){const k=r=>function(){const d=Array.prototype.slice.call(arguments,0);return b(r,d)},E={};for(const r of c)E[r]=k(r);return E}function h(c,b){const k={};for(const[E,r]of Object.entries(c))k[E]=b(r,E);return k}}),define(pe[22],we([1,0,21]),function(oe,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ThemeIcon=t.ThemeColor=void 0,t.$1j=B;var n;(function(T){function v(y){return y&&typeof y=="object"&&typeof y.id=="string"}T.isThemeColor=v})(n||(t.ThemeColor=n={}));function B(T){return{id:T}}var O;(function(T){T.iconNameSegment="[A-Za-z0-9]+",T.iconNameExpression="[A-Za-z0-9-]+",T.iconModifierExpression="~[A-Za-z]+",T.iconNameCharacter="[A-Za-z0-9~-]";const v=new RegExp(`^(${T.iconNameExpression})(${T.iconModifierExpression})?$`);function y(c){const b=v.exec(c.id);if(!b)return y(i.$Zj.error);const[,k,E]=b,r=["codicon","codicon-"+k];return E&&r.push("codicon-modifier-"+E.substring(1)),r}T.asClassNameArray=y;function f(c){return y(c).join(" ")}T.asClassName=f;function w(c){return"."+y(c).join(".")}T.asCSSSelector=w;function A(c){return c&&typeof c=="object"&&typeof c.id=="string"&&(typeof c.color>"u"||n.isThemeColor(c.color))}T.isThemeIcon=A;const $=new RegExp(`^\\$\\((${T.iconNameExpression}(?:${T.iconModifierExpression})?)\\)$`);function m(c){const b=$.exec(c);if(!b)return;const[,k]=b;return{id:k}}T.fromString=m;function e(c){return{id:c}}T.fromId=e;function s(c,b){let k=c.id;const E=k.lastIndexOf("~");return E!==-1&&(k=k.substring(0,E)),b&&(k=`${k}~${b}`),{id:k}}T.modify=s;function o(c){const b=c.id.lastIndexOf("~");if(b!==-1)return c.id.substring(b+1)}T.getModifier=o;function h(c,b){return c.id===b.id&&c.color?.id===b.color?.id}T.isEqual=h})(O||(t.ThemeIcon=O={}))}),define(pe[64],we([1,0]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Constants=void 0,t.$9e=n,t.$0e=B;var i;(function(O){O[O.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",O[O.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",O[O.MAX_UINT_8=255]="MAX_UINT_8",O[O.MAX_UINT_16=65535]="MAX_UINT_16",O[O.MAX_UINT_32=4294967295]="MAX_UINT_32",O[O.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(i||(t.Constants=i={}));function n(O){return O<0?0:O>i.MAX_UINT_8?i.MAX_UINT_8:O|0}function B(O){return O<0?0:O>i.MAX_UINT_32?i.MAX_UINT_32:O|0}}),define(pe[11],we([1,0,98,18,26,64]),function(oe,t,i,n,B,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$_f=t.$$f=t.$0f=t.GraphemeBreakType=t.$Zf=t.$Rf=t.$Kf=t.$Jf=void 0,t.$$e=T,t.$_e=y,t.$af=w,t.$bf=A,t.$cf=$,t.$df=m,t.$ef=e,t.$ff=s,t.$gf=o,t.$hf=h,t.$if=c,t.$jf=b,t.$kf=k,t.$lf=E,t.$mf=r,t.$nf=d,t.$of=D,t.$pf=R,t.$qf=_,t.$rf=H,t.$sf=x,t.$tf=p,t.$uf=M,t.$vf=U,t.$wf=N,t.$xf=P,t.$yf=W,t.$zf=ne,t.$Af=Q,t.$Bf=Y,t.$Cf=te,t.$Df=de,t.$Ef=De,t.$Ff=Le,t.$Gf=Se,t.$Hf=ue,t.$If=J,t.$Lf=Z,t.$Mf=me,t.$Nf=ye,t.$Of=Oe,t.$Pf=ie,t.$Qf=C,t.$Sf=a,t.$Tf=l,t.$Uf=g,t.$Vf=I,t.$Wf=u,t.$Xf=L,t.$Yf=j,t.$1f=z,t.$2f=q,t.$3f=ee,t.$4f=re,t.$5f=ce,t.$6f=Ee,t.$7f=ve,t.$8f=Re,t.$9f=Ye;function T(X){return!X||typeof X!="string"?!0:X.trim().length===0}const v=/{(\d+)}/g;function y(X,...ae){return ae.length===0?X:X.replace(v,function($e,Ae){const Pe=parseInt(Ae,10);return isNaN(Pe)||Pe<0||Pe>=ae.length?$e:ae[Pe]})}const f=/{([^}]+)}/g;function w(X,ae){return Object.keys(ae).length===0?X:X.replace(f,($e,Ae)=>ae[Ae]??$e)}function A(X){return X.replace(/[<>"'&]/g,ae=>{switch(ae){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return ae})}function $(X){return X.replace(/[<>&]/g,function(ae){switch(ae){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ae}})}function m(X){return X.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function e(X,ae){let $e=0,Ae=X.indexOf(ae);for(;Ae!==-1;)$e++,Ae=X.indexOf(ae,Ae+ae.length);return $e}function s(X,ae,$e="\u2026"){return X.length<=ae?X:`${X.substr(0,ae)}${$e}`}function o(X,ae,$e="\u2026"){if(X.length<=ae)return X;const Ae=Math.ceil(ae/2)-$e.length/2,Pe=Math.floor(ae/2)-$e.length/2;return`${X.substr(0,Ae)}${$e}${X.substr(X.length-Pe)}`}function h(X,ae=" "){const $e=c(X,ae);return b($e,ae)}function c(X,ae){if(!X||!ae)return X;const $e=ae.length;if($e===0||X.length===0)return X;let Ae=0;for(;X.indexOf(ae,Ae)===Ae;)Ae=Ae+$e;return X.substring(Ae)}function b(X,ae){if(!X||!ae)return X;const $e=ae.length,Ae=X.length;if($e===0||Ae===0)return X;let Pe=Ae,He=-1;for(;He=X.lastIndexOf(ae,Pe-1),!(He===-1||He+$e!==Pe);){if(He===0)return"";Pe=He}return X.substring(0,Pe)}function k(X){return X.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function E(X){return X.replace(/\*/g,"")}function r(X,ae,$e={}){if(!X)throw new Error("Cannot create regex from empty string");ae||(X=m(X)),$e.wholeWord&&(/\B/.test(X.charAt(0))||(X="\\b"+X),/\B/.test(X.charAt(X.length-1))||(X=X+"\\b"));let Ae="";return $e.global&&(Ae+="g"),$e.matchCase||(Ae+="i"),$e.multiline&&(Ae+="m"),$e.unicode&&(Ae+="u"),new RegExp(X,Ae)}function d(X){return X.source==="^"||X.source==="^$"||X.source==="$"||X.source==="^\\s*$"?!1:!!(X.exec("")&&X.lastIndex===0)}function D(X){return X.split(/\r\n|\r|\n/)}function R(X){const ae=[],$e=X.split(/(\r\n|\r|\n)/);for(let Ae=0;Ae<Math.ceil($e.length/2);Ae++)ae.push($e[2*Ae]+($e[2*Ae+1]??""));return ae}function _(X){for(let ae=0,$e=X.length;ae<$e;ae++){const Ae=X.charCodeAt(ae);if(Ae!==n.CharCode.Space&&Ae!==n.CharCode.Tab)return ae}return-1}function H(X,ae=0,$e=X.length){for(let Ae=ae;Ae<$e;Ae++){const Pe=X.charCodeAt(Ae);if(Pe!==n.CharCode.Space&&Pe!==n.CharCode.Tab)return X.substring(ae,Ae)}return X.substring(ae,$e)}function x(X,ae=X.length-1){for(let $e=ae;$e>=0;$e--){const Ae=X.charCodeAt($e);if(Ae!==n.CharCode.Space&&Ae!==n.CharCode.Tab)return $e}return-1}function p(X,ae,$e){const Ae=[];let Pe=0;for(const He of X.matchAll(ae)){if(Ae.push(X.slice(Pe,He.index)),He.index===void 0)throw new Error("match.index should be defined");Pe=He.index+He[0].length,Ae.push($e(He[0],...He.slice(1),He.index,X,He.groups))}return Ae.push(X.slice(Pe)),Promise.all(Ae).then(He=>He.join(""))}function M(X,ae){return X<ae?-1:X>ae?1:0}function U(X,ae,$e=0,Ae=X.length,Pe=0,He=ae.length){for(;$e<Ae&&Pe<He;$e++,Pe++){const tt=X.charCodeAt($e),ut=ae.charCodeAt(Pe);if(tt<ut)return-1;if(tt>ut)return 1}const Qe=Ae-$e,rt=He-Pe;return Qe<rt?-1:Qe>rt?1:0}function N(X,ae){return P(X,ae,0,X.length,0,ae.length)}function P(X,ae,$e=0,Ae=X.length,Pe=0,He=ae.length){for(;$e<Ae&&Pe<He;$e++,Pe++){let tt=X.charCodeAt($e),ut=ae.charCodeAt(Pe);if(tt===ut)continue;if(tt>=128||ut>=128)return U(X.toLowerCase(),ae.toLowerCase(),$e,Ae,Pe,He);ne(tt)&&(tt-=32),ne(ut)&&(ut-=32);const nt=tt-ut;if(nt!==0)return nt}const Qe=Ae-$e,rt=He-Pe;return Qe<rt?-1:Qe>rt?1:0}function W(X){return X>=n.CharCode.Digit0&&X<=n.CharCode.Digit9}function ne(X){return X>=n.CharCode.a&&X<=n.CharCode.z}function Q(X){return X>=n.CharCode.A&&X<=n.CharCode.Z}function Y(X,ae){return X.length===ae.length&&P(X,ae)===0}function te(X,ae){const $e=ae.length;return ae.length>X.length?!1:P(X,ae,0,$e)===0}function de(X,ae){const $e=Math.min(X.length,ae.length);let Ae;for(Ae=0;Ae<$e;Ae++)if(X.charCodeAt(Ae)!==ae.charCodeAt(Ae))return Ae;return $e}function De(X,ae){const $e=Math.min(X.length,ae.length);let Ae;const Pe=X.length-1,He=ae.length-1;for(Ae=0;Ae<$e;Ae++)if(X.charCodeAt(Pe-Ae)!==ae.charCodeAt(He-Ae))return Ae;return $e}function Le(X){return 55296<=X&&X<=56319}function Se(X){return 56320<=X&&X<=57343}function ue(X,ae){return(X-55296<<10)+(ae-56320)+65536}function J(X,ae,$e){const Ae=X.charCodeAt($e);if(Le(Ae)&&$e+1<ae){const Pe=X.charCodeAt($e+1);if(Se(Pe))return ue(Ae,Pe)}return Ae}function fe(X,ae){const $e=X.charCodeAt(ae-1);if(Se($e)&&ae>1){const Ae=X.charCodeAt(ae-2);if(Le(Ae))return ue(Ae,$e)}return $e}class le{get offset(){return this.e}constructor(ae,$e=0){this.c=ae,this.d=ae.length,this.e=$e}setOffset(ae){this.e=ae}prevCodePoint(){const ae=fe(this.c,this.e);return this.e-=ae>=O.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,ae}nextCodePoint(){const ae=J(this.c,this.d,this.e);return this.e+=ae>=O.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,ae}eol(){return this.e>=this.d}}t.$Jf=le;class ke{get offset(){return this.c.offset}constructor(ae,$e=0){this.c=new le(ae,$e)}nextGraphemeLength(){const ae=Fe.getInstance(),$e=this.c,Ae=$e.offset;let Pe=ae.getGraphemeBreakType($e.nextCodePoint());for(;!$e.eol();){const He=$e.offset,Qe=ae.getGraphemeBreakType($e.nextCodePoint());if(Te(Pe,Qe)){$e.setOffset(He);break}Pe=Qe}return $e.offset-Ae}prevGraphemeLength(){const ae=Fe.getInstance(),$e=this.c,Ae=$e.offset;let Pe=ae.getGraphemeBreakType($e.prevCodePoint());for(;$e.offset>0;){const He=$e.offset,Qe=ae.getGraphemeBreakType($e.prevCodePoint());if(Te(Qe,Pe)){$e.setOffset(He);break}Pe=Qe}return Ae-$e.offset}eol(){return this.c.eol()}}t.$Kf=ke;function Z(X,ae){return new ke(X,ae).nextGraphemeLength()}function me(X,ae){return new ke(X,ae).prevGraphemeLength()}function ye(X,ae){ae>0&&Se(X.charCodeAt(ae))&&ae--;const $e=ae+Z(X,ae);return[$e-me(X,$e),$e]}function Oe(X){const ae=new ke(X);let $e=0;for(;!ae.eol();)$e++,ae.nextGraphemeLength();return $e}let Ie;function je(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function ie(X){return Ie||(Ie=je()),Ie.test(X)}const K=/^[\t\n\r\x20-\x7E]*$/;function C(X){return K.test(X)}t.$Rf=/[\u2028\u2029]/;function a(X){return t.$Rf.test(X)}function l(X){return X>=11904&&X<=55215||X>=63744&&X<=64255||X>=65281&&X<=65374}function g(X){return X>=127462&&X<=127487||X===8986||X===8987||X===9200||X===9203||X>=9728&&X<=10175||X===11088||X===11093||X>=127744&&X<=128591||X>=128640&&X<=128764||X>=128992&&X<=129008||X>=129280&&X<=129535||X>=129648&&X<=129782}function I(X,ae,$e=""){const Ae=X.trimStart();if(Ae.length<ae)return Ae;const Pe=/\b/g;let He=0;for(;Pe.test(Ae)&&!(Ae.length-Pe.lastIndex<ae);)He=Pe.lastIndex,Pe.lastIndex+=1;return He===0?Ae:$e+Ae.substring(He).trimStart()}const F=/(?:(?:\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~])|(:?\x1b\].*?\x07)/g;function*u(X){let ae=0;for(const $e of X.matchAll(F))ae!==$e.index&&(yield{isCode:!1,str:X.substring(ae,$e.index)}),yield{isCode:!0,str:$e[0]},ae=$e.index+$e[0].length;ae!==X.length&&(yield{isCode:!1,str:X.substring(ae)})}function L(X){return X&&(X=X.replace(F,"")),X}const S=/\\\[.*?\\\]/g;function j(X){return L(X).replace(S,"")}t.$Zf=String.fromCharCode(n.CharCode.UTF8_BOM);function z(X){return!!(X&&X.length>0&&X.charCodeAt(0)===n.CharCode.UTF8_BOM)}function q(X){return z(X)?X.substr(1):X}function ee(X,ae){if(!X||!ae||X.length<ae.length)return!1;const $e=ae.length,Ae=X.toLowerCase();let Pe=0,He=-1;for(;Pe<$e;){const Qe=Ae.indexOf(ae[Pe],He+1);if(Qe<0)return!1;He=Qe,Pe++}return!0}function re(X,ae=!1){return X?(ae&&(X=X.replace(/\\./g,"")),X.toLowerCase()!==X):!1}function ce(X){return X.charAt(0).toUpperCase()+X.slice(1)}function Ee(X,ae=1){if(ae===0)return"";let $e=-1;do $e=X.indexOf(`
`,$e+1),ae--;while(ae>0&&$e>=0);return $e===-1?X:(X[$e-1]==="\r"&&$e--,X.substr(0,$e))}function ve(X){const ae=n.CharCode.Z-n.CharCode.A+1;return X=X%(2*ae),X<ae?String.fromCharCode(n.CharCode.a+X):String.fromCharCode(n.CharCode.A+X-ae)}function Re(X){return Fe.getInstance().getGraphemeBreakType(X)}function Te(X,ae){return X===he.Other?ae!==he.Extend&&ae!==he.SpacingMark:X===he.CR&&ae===he.LF?!1:X===he.Control||X===he.CR||X===he.LF||ae===he.Control||ae===he.CR||ae===he.LF?!0:!(X===he.L&&(ae===he.L||ae===he.V||ae===he.LV||ae===he.LVT)||(X===he.LV||X===he.V)&&(ae===he.V||ae===he.T)||(X===he.LVT||X===he.T)&&ae===he.T||ae===he.Extend||ae===he.ZWJ||ae===he.SpacingMark||X===he.Prepend||X===he.ZWJ&&ae===he.Extended_Pictographic||X===he.Regional_Indicator&&ae===he.Regional_Indicator)}var he;(function(X){X[X.Other=0]="Other",X[X.Prepend=1]="Prepend",X[X.CR=2]="CR",X[X.LF=3]="LF",X[X.Control=4]="Control",X[X.Extend=5]="Extend",X[X.Regional_Indicator=6]="Regional_Indicator",X[X.SpacingMark=7]="SpacingMark",X[X.L=8]="L",X[X.V=9]="V",X[X.T=10]="T",X[X.LV=11]="LV",X[X.LVT=12]="LVT",X[X.ZWJ=13]="ZWJ",X[X.Extended_Pictographic=14]="Extended_Pictographic"})(he||(t.GraphemeBreakType=he={}));class Fe{static{this.c=null}static getInstance(){return Fe.c||(Fe.c=new Fe),Fe.c}constructor(){this.d=xe()}getGraphemeBreakType(ae){if(ae<32)return ae===n.CharCode.LineFeed?he.LF:ae===n.CharCode.CarriageReturn?he.CR:he.Control;if(ae<127)return he.Other;const $e=this.d,Ae=$e.length/3;let Pe=1;for(;Pe<=Ae;)if(ae<$e[3*Pe])Pe=2*Pe;else if(ae>$e[3*Pe+1])Pe=2*Pe+1;else return $e[3*Pe+2];return he.Other}}function xe(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Ye(X,ae){if(X===0)return 0;const $e=et(X,ae);if($e!==void 0)return $e;const Ae=new le(ae,X);return Ae.prevCodePoint(),Ae.offset}function et(X,ae){const $e=new le(ae,X);let Ae=$e.prevCodePoint();for(;ot(Ae)||Ae===it.emojiVariantSelector||Ae===it.enclosingKeyCap;){if($e.offset===0)return;Ae=$e.prevCodePoint()}if(!g(Ae))return;let Pe=$e.offset;return Pe>0&&$e.prevCodePoint()===it.zwj&&(Pe=$e.offset),Pe}function ot(X){return 127995<=X&&X<=127999}var it;(function(X){X[X.zwj=8205]="zwj",X[X.emojiVariantSelector=65039]="emojiVariantSelector",X[X.enclosingKeyCap=8419]="enclosingKeyCap"})(it||(it={})),t.$0f="\xA0";class Ke{static{this.c=new B.$V(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new i.$7e({getCacheKey:JSON.stringify},ae=>{function $e(nt){const lt=new Map;for(let ht=0;ht<nt.length;ht+=2)lt.set(nt[ht],nt[ht+1]);return lt}function Ae(nt,lt){const ht=new Map(nt);for(const[pt,Ce]of lt)ht.set(pt,Ce);return ht}function Pe(nt,lt){if(!nt)return lt;const ht=new Map;for(const[pt,Ce]of nt)lt.has(pt)&&ht.set(pt,Ce);return ht}const He=this.c.value;let Qe=ae.filter(nt=>!nt.startsWith("_")&&nt in He);Qe.length===0&&(Qe=["_default"]);let rt;for(const nt of Qe){const lt=$e(He[nt]);rt=Pe(rt,lt)}const tt=$e(He._common),ut=Ae(tt,rt);return new Ke(ut)})}static getInstance(ae){return Ke.d.get(Array.from(ae))}static{this.e=new B.$V(()=>Object.keys(Ke.c.value).filter(ae=>!ae.startsWith("_")))}static getLocales(){return Ke.e.value}constructor(ae){this.f=ae}isAmbiguous(ae){return this.f.has(ae)}containsAmbiguousCharacter(ae){for(let $e=0;$e<ae.length;$e++){const Ae=ae.codePointAt($e);if(typeof Ae=="number"&&this.isAmbiguous(Ae))return!0}return!1}getPrimaryConfusable(ae){return this.f.get(ae)}getConfusableCodePoints(){return new Set(this.f.keys())}}t.$$f=Ke;class Xe{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(Xe.c())),this.d}static isInvisibleCharacter(ae){return Xe.e().has(ae)}static containsInvisibleCharacter(ae){for(let $e=0;$e<ae.length;$e++){const Ae=ae.codePointAt($e);if(typeof Ae=="number"&&Xe.isInvisibleCharacter(Ae))return!0}return!1}static get codePoints(){return Xe.e()}}t.$_f=Xe}),define(pe[50],we([1,0,18,43,93,11]),function(oe,t,i,n,B,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Nk=t.FuzzyScore=t.$Ck=t.$Bk=void 0,t.or=T,t.$Dk=y,t.$Ek=f,t.$Fk=$,t.$Gk=x,t.$Hk=p,t.$Ik=ne,t.$Jk=Q,t.$Kk=Y,t.$Lk=te,t.$Mk=je,t.$Ok=a,t.$Pk=I,t.$Qk=F;function T(...S){return function(j,z){for(let q=0,ee=S.length;q<ee;q++){const re=S[q](j,z);if(re)return re}return null}}t.$Bk=v.bind(void 0,!1),t.$Ck=v.bind(void 0,!0);function v(S,j,z){if(!z||z.length<j.length)return null;let q;return S?q=O.$Cf(z,j):q=z.indexOf(j)===0,q?j.length>0?[{start:0,end:j.length}]:[]:null}function y(S,j){const z=j.toLowerCase().indexOf(S.toLowerCase());return z===-1?null:[{start:z,end:z+S.length}]}function f(S,j){return w(S.toLowerCase(),j.toLowerCase(),0,0)}function w(S,j,z,q){if(z===S.length)return[];if(q===j.length)return null;if(S[z]===j[q]){let ee=null;return(ee=w(S,j,z+1,q+1))?E({start:q,end:q+1},ee):null}return w(S,j,z,q+1)}function A(S){return i.CharCode.a<=S&&S<=i.CharCode.z}function $(S){return i.CharCode.A<=S&&S<=i.CharCode.Z}function m(S){return i.CharCode.Digit0<=S&&S<=i.CharCode.Digit9}function e(S){return S===i.CharCode.Space||S===i.CharCode.Tab||S===i.CharCode.LineFeed||S===i.CharCode.CarriageReturn}const s=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(S=>s.add(S.charCodeAt(0)));function o(S){return e(S)||s.has(S)}function h(S,j){return S===j||o(S)&&o(j)}const c=new Map;function b(S){if(c.has(S))return c.get(S);let j;const z=(0,B.$zk)(S);return z&&(j=z),c.set(S,j),j}function k(S){return A(S)||$(S)||m(S)}function E(S,j){return j.length===0?j=[S]:S.end===j[0].start?j[0].start=S.start:j.unshift(S),j}function r(S,j){for(let z=j;z<S.length;z++){const q=S.charCodeAt(z);if($(q)||m(q)||z>0&&!k(S.charCodeAt(z-1)))return z}return S.length}function d(S,j,z,q){if(z===S.length)return[];if(q===j.length)return null;if(S[z]!==j[q].toLowerCase())return null;{let ee=null,re=q+1;for(ee=d(S,j,z+1,q+1);!ee&&(re=r(j,re))<j.length;)ee=d(S,j,z+1,re),re++;return ee===null?null:E({start:q,end:q+1},ee)}}function D(S){let j=0,z=0,q=0,ee=0,re=0;for(let Te=0;Te<S.length;Te++)re=S.charCodeAt(Te),$(re)&&j++,A(re)&&z++,k(re)&&q++,m(re)&&ee++;const ce=j/S.length,Ee=z/S.length,ve=q/S.length,Re=ee/S.length;return{upperPercent:ce,lowerPercent:Ee,alphaPercent:ve,numericPercent:Re}}function R(S){const{upperPercent:j,lowerPercent:z}=S;return z===0&&j>.6}function _(S){const{upperPercent:j,lowerPercent:z,alphaPercent:q,numericPercent:ee}=S;return z>.2&&j<.8&&q>.6&&ee<.2}function H(S){let j=0,z=0,q=0,ee=0;for(let re=0;re<S.length;re++)q=S.charCodeAt(re),$(q)&&j++,A(q)&&z++,e(q)&&ee++;return(j===0||z===0)&&ee===0?S.length<=30:j<=5}function x(S,j){if(!j||(j=j.trim(),j.length===0)||!H(S))return null;j.length>60&&(j=j.substring(0,60));const z=D(j);if(!_(z)){if(!R(z))return null;j=j.toLowerCase()}let q=null,ee=0;for(S=S.toLowerCase();ee<j.length&&(q=d(S,j,0,ee))===null;)ee=r(j,ee+1);return q}function p(S,j,z=!1){if(!j||j.length===0)return null;let q=null,ee=0;for(S=S.toLowerCase(),j=j.toLowerCase();ee<j.length&&(q=M(S,j,0,ee,z),q===null);)ee=U(j,ee+1);return q}function M(S,j,z,q,ee){let re=0;if(z===S.length)return[];if(q===j.length)return null;if(!h(S.charCodeAt(z),j.charCodeAt(q))){const ve=b(S.charCodeAt(z));if(!ve)return null;for(let Re=0;Re<ve.length;Re++)if(!h(ve[Re],j.charCodeAt(q+Re)))return null;re+=ve.length-1}let ce=null,Ee=q+re+1;if(ce=M(S,j,z+1,Ee,ee),!ee)for(;!ce&&(Ee=U(j,Ee))<j.length;)ce=M(S,j,z+1,Ee,ee),Ee++;if(!ce)return null;if(S.charCodeAt(z)!==j.charCodeAt(q)){const ve=b(S.charCodeAt(z));if(!ve)return ce;for(let Re=0;Re<ve.length;Re++)if(ve[Re]!==j.charCodeAt(q+Re))return ce}return E({start:q,end:q+re+1},ce)}function U(S,j){for(let z=j;z<S.length;z++)if(o(S.charCodeAt(z))||z>0&&o(S.charCodeAt(z-1)))return z;return S.length}const N=T(t.$Ck,x,y),P=T(t.$Ck,x,f),W=new n.$Dc(1e4);function ne(S,j,z=!1){if(typeof S!="string"||typeof j!="string")return null;let q=W.get(S);q||(q=new RegExp(O.$kf(S),"i"),W.set(S,q));const ee=q.exec(j);return ee?[{start:ee.index,end:ee.index+ee[0].length}]:z?P(S,j):N(S,j)}function Q(S,j){const z=a(S,S.toLowerCase(),0,j,j.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return z?te(z):null}function Y(S,j,z,q,ee,re){const ce=Math.min(13,S.length);for(;z<ce;z++){const Ee=a(S,j,z,q,ee,re,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(Ee)return Ee}return[0,re]}function te(S){if(typeof S>"u")return[];const j=[],z=S[1];for(let q=S.length-1;q>1;q--){const ee=S[q]+z,re=j[j.length-1];re&&re.end===ee?re.end=ee+1:j.push({start:ee,end:ee+1})}return j}const de=128;function De(){const S=[],j=[];for(let z=0;z<=de;z++)j[z]=0;for(let z=0;z<=de;z++)S.push(j.slice(0));return S}function Le(S){const j=[];for(let z=0;z<=S;z++)j[z]=0;return j}const Se=Le(2*de),ue=Le(2*de),J=De(),fe=De(),le=De(),ke=!1;function Z(S,j,z,q,ee){function re(Ee,ve,Re=" "){for(;Ee.length<ve;)Ee=Re+Ee;return Ee}let ce=` |   |${q.split("").map(Ee=>re(Ee,3)).join("|")}
`;for(let Ee=0;Ee<=z;Ee++)Ee===0?ce+=" |":ce+=`${j[Ee-1]}|`,ce+=S[Ee].slice(0,ee+1).map(ve=>re(ve.toString(),3)).join("|")+`
`;return ce}function me(S,j,z,q){S=S.substr(j),z=z.substr(q),console.log(Z(fe,S,S.length,z,z.length)),console.log(Z(le,S,S.length,z,z.length)),console.log(Z(J,S,S.length,z,z.length))}function ye(S,j){if(j<0||j>=S.length)return!1;const z=S.codePointAt(j);switch(z){case i.CharCode.Underline:case i.CharCode.Dash:case i.CharCode.Period:case i.CharCode.Space:case i.CharCode.Slash:case i.CharCode.Backslash:case i.CharCode.SingleQuote:case i.CharCode.DoubleQuote:case i.CharCode.Colon:case i.CharCode.DollarSign:case i.CharCode.LessThan:case i.CharCode.GreaterThan:case i.CharCode.OpenParen:case i.CharCode.CloseParen:case i.CharCode.OpenSquareBracket:case i.CharCode.CloseSquareBracket:case i.CharCode.OpenCurlyBrace:case i.CharCode.CloseCurlyBrace:return!0;case void 0:return!1;default:return!!O.$Uf(z)}}function Oe(S,j){if(j<0||j>=S.length)return!1;switch(S.charCodeAt(j)){case i.CharCode.Space:case i.CharCode.Tab:return!0;default:return!1}}function Ie(S,j,z){return j[S]!==z[S]}function je(S,j,z,q,ee,re,ce=!1){for(;j<z&&ee<re;)S[j]===q[ee]&&(ce&&(Se[j]=ee),j+=1),ee+=1;return j===z}var ie;(function(S){S[S.Diag=1]="Diag",S[S.Left=2]="Left",S[S.LeftLeft=3]="LeftLeft"})(ie||(ie={}));var K;(function(S){S.Default=[-100,0];function j(z){return!z||z.length===2&&z[0]===-100&&z[1]===0}S.isDefault=j})(K||(t.FuzzyScore=K={}));class C{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(j,z){this.firstMatchCanBeWeak=j,this.boostFullMatch=z}}t.$Nk=C;function a(S,j,z,q,ee,re,ce=C.default){const Ee=S.length>de?de:S.length,ve=q.length>de?de:q.length;if(z>=Ee||re>=ve||Ee-z>ve-re||!je(j,z,Ee,ee,re,ve,!0))return;l(Ee,ve,z,re,j,ee);let Re=1,Te=1,he=z,Fe=re;const xe=[!1];for(Re=1,he=z;he<Ee;Re++,he++){const Ke=Se[he],Xe=ue[he],X=he+1<Ee?ue[he+1]:ve;for(Te=Ke-re+1,Fe=Ke;Fe<X;Te++,Fe++){let ae=Number.MIN_SAFE_INTEGER,$e=!1;Fe<=Xe&&(ae=g(S,j,he,z,q,ee,Fe,ve,re,J[Re-1][Te-1]===0,xe));let Ae=0;ae!==Number.MAX_SAFE_INTEGER&&($e=!0,Ae=ae+fe[Re-1][Te-1]);const Pe=Fe>Ke,He=Pe?fe[Re][Te-1]+(J[Re][Te-1]>0?-5:0):0,Qe=Fe>Ke+1&&J[Re][Te-1]>0,rt=Qe?fe[Re][Te-2]+(J[Re][Te-2]>0?-5:0):0;if(Qe&&(!Pe||rt>=He)&&(!$e||rt>=Ae))fe[Re][Te]=rt,le[Re][Te]=ie.LeftLeft,J[Re][Te]=0;else if(Pe&&(!$e||He>=Ae))fe[Re][Te]=He,le[Re][Te]=ie.Left,J[Re][Te]=0;else if($e)fe[Re][Te]=Ae,le[Re][Te]=ie.Diag,J[Re][Te]=J[Re-1][Te-1]+1;else throw new Error("not possible")}}if(ke&&me(S,z,q,re),!xe[0]&&!ce.firstMatchCanBeWeak)return;Re--,Te--;const Ye=[fe[Re][Te],re];let et=0,ot=0;for(;Re>=1;){let Ke=Te;do{const Xe=le[Re][Ke];if(Xe===ie.LeftLeft)Ke=Ke-2;else if(Xe===ie.Left)Ke=Ke-1;else break}while(Ke>=1);et>1&&j[z+Re-1]===ee[re+Te-1]&&!Ie(Ke+re-1,q,ee)&&et+1>J[Re][Ke]&&(Ke=Te),Ke===Te?et++:et=1,ot||(ot=Ke),Re--,Te=Ke-1,Ye.push(Te)}ve-re===Ee&&ce.boostFullMatch&&(Ye[0]+=2);const it=ot-Ee;return Ye[0]-=it,Ye}function l(S,j,z,q,ee,re){let ce=S-1,Ee=j-1;for(;ce>=z&&Ee>=q;)ee[ce]===re[Ee]&&(ue[ce]=Ee,ce--),Ee--}function g(S,j,z,q,ee,re,ce,Ee,ve,Re,Te){if(j[z]!==re[ce])return Number.MIN_SAFE_INTEGER;let he=1,Fe=!1;return ce===z-q?he=S[z]===ee[ce]?7:5:Ie(ce,ee,re)&&(ce===0||!Ie(ce-1,ee,re))?(he=S[z]===ee[ce]?7:5,Fe=!0):ye(re,ce)&&(ce===0||!ye(re,ce-1))?he=5:(ye(re,ce-1)||Oe(re,ce-1))&&(he=5,Fe=!0),he>1&&z===q&&(Te[0]=!0),Fe||(Fe=Ie(ce,ee,re)||ye(re,ce-1)||Oe(re,ce-1)),z===q?ce>ve&&(he-=Fe?3:5):Re?he+=Fe?2:0:he+=Fe?0:1,ce+1===Ee&&(he-=Fe?3:5),he}function I(S,j,z,q,ee,re,ce){return u(S,j,z,q,ee,re,!0,ce)}function F(S,j,z,q,ee,re,ce){return u(S,j,z,q,ee,re,!1,ce)}function u(S,j,z,q,ee,re,ce,Ee){let ve=a(S,j,z,q,ee,re,Ee);if(ve&&!ce)return ve;if(S.length>=3){const Re=Math.min(7,S.length-1);for(let Te=z+1;Te<Re;Te++){const he=L(S,Te);if(he){const Fe=a(he,he.toLowerCase(),z,q,ee,re,Ee);Fe&&(Fe[0]-=3,(!ve||Fe[0]>ve[0])&&(ve=Fe))}}}return ve}function L(S,j){if(j+1>=S.length)return;const z=S[j],q=S[j+1];if(z!==q)return S.slice(0,j)+q+z+S.slice(j+2)}}),define(pe[65],we([1,0,11]),function(oe,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$uj=t.$sj=void 0,t.$oj=n,t.$pj=B,t.$qj=O,t.$rj=v,t.$tj=s;function n(h){return B(h,0)}function B(h,c){switch(typeof h){case"object":return h===null?O(349,c):Array.isArray(h)?y(h,c):f(h,c);case"string":return v(h,c);case"boolean":return T(h,c);case"number":return O(h,c);case"undefined":return O(937,c);default:return O(617,c)}}function O(h,c){return(c<<5)-c+h|0}function T(h,c){return O(h?433:863,c)}function v(h,c){c=O(149417,c);for(let b=0,k=h.length;b<k;b++)c=O(h.charCodeAt(b),c);return c}function y(h,c){return c=O(104579,c),h.reduce((b,k)=>B(k,b),c)}function f(h,c){return c=O(181387,c),Object.keys(h).sort().reduce((b,k)=>(b=v(k,b),B(h[k],b)),c)}class w{constructor(){this.g=0}get value(){return this.g}hash(c){return this.g=B(c,this.g),this.g}}t.$sj=w;var A;(function(h){h[h.BLOCK_SIZE=64]="BLOCK_SIZE",h[h.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(A||(A={}));function $(h,c,b=32){const k=b-c,E=~((1<<k)-1);return(h<<c|(E&h)>>>k)>>>0}function m(h,c=0,b=h.byteLength,k=0){for(let E=0;E<b;E++)h[c+E]=k}function e(h,c,b="0"){for(;h.length<c;)h=b+h;return h}function s(h,c=32){return h instanceof ArrayBuffer?Array.from(new Uint8Array(h)).map(b=>b.toString(16).padStart(2,"0")).join(""):e((h>>>0).toString(16),c/4)}class o{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(A.BLOCK_SIZE+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(c){const b=c.length;if(b===0)return;const k=this.p;let E=this.r,r=this.u,d,D;for(r!==0?(d=r,D=-1,r=0):(d=c.charCodeAt(0),D=0);;){let R=d;if(i.$Ff(d))if(D+1<b){const _=c.charCodeAt(D+1);i.$Gf(_)?(D++,R=i.$Hf(d,_)):R=A.UNICODE_REPLACEMENT}else{r=d;break}else i.$Gf(d)&&(R=A.UNICODE_REPLACEMENT);if(E=this.w(k,E,R),D++,D<b)d=c.charCodeAt(D);else break}this.r=E,this.u=r}w(c,b,k){return k<128?c[b++]=k:k<2048?(c[b++]=192|(k&1984)>>>6,c[b++]=128|(k&63)>>>0):k<65536?(c[b++]=224|(k&61440)>>>12,c[b++]=128|(k&4032)>>>6,c[b++]=128|(k&63)>>>0):(c[b++]=240|(k&1835008)>>>18,c[b++]=128|(k&258048)>>>12,c[b++]=128|(k&4032)>>>6,c[b++]=128|(k&63)>>>0),b>=A.BLOCK_SIZE&&(this.y(),b-=A.BLOCK_SIZE,this.t+=A.BLOCK_SIZE,c[0]=c[A.BLOCK_SIZE+0],c[1]=c[A.BLOCK_SIZE+1],c[2]=c[A.BLOCK_SIZE+2]),b}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,A.UNICODE_REPLACEMENT)),this.t+=this.r,this.x()),s(this.h)+s(this.l)+s(this.m)+s(this.n)+s(this.o)}x(){this.p[this.r++]=128,m(this.p,this.r),this.r>56&&(this.y(),m(this.p));const c=8*this.t;this.q.setUint32(56,Math.floor(c/4294967296),!1),this.q.setUint32(60,c%4294967296,!1),this.y()}y(){const c=o.g,b=this.q;for(let x=0;x<64;x+=4)c.setUint32(x,b.getUint32(x,!1),!1);for(let x=64;x<320;x+=4)c.setUint32(x,$(c.getUint32(x-12,!1)^c.getUint32(x-32,!1)^c.getUint32(x-56,!1)^c.getUint32(x-64,!1),1),!1);let k=this.h,E=this.l,r=this.m,d=this.n,D=this.o,R,_,H;for(let x=0;x<80;x++)x<20?(R=E&r|~E&d,_=1518500249):x<40?(R=E^r^d,_=1859775393):x<60?(R=E&r|E&d|r&d,_=2400959708):(R=E^r^d,_=3395469782),H=$(k,5)+R+D+_+c.getUint32(x*4,!1)&4294967295,D=d,d=r,r=$(E,30),E=k,k=H;this.h=this.h+k&4294967295,this.l=this.l+E&4294967295,this.m=this.m+r&4294967295,this.n=this.n+d&4294967295,this.o=this.o+D&4294967295}}t.$uj=o}),define(pe[103],we([1,0,90,65,64]),function(oe,t,i,n,B){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Uv=t.$Sv=void 0,t.$Tv=T;class O{constructor(m){this.a=m}getElements(){const m=this.a,e=new Int32Array(m.length);for(let s=0,o=m.length;s<o;s++)e[s]=m.charCodeAt(s);return e}}t.$Sv=O;function T($,m,e){return new A(new O($),new O(m)).ComputeDiff(e).changes}class v{static Assert(m,e){if(!m)throw new Error(e)}}class y{static Copy(m,e,s,o,h){for(let c=0;c<h;c++)s[o+c]=m[e+c]}static Copy2(m,e,s,o,h){for(let c=0;c<h;c++)s[o+c]=m[e+c]}}var f;(function($){$[$.MaxDifferencesHistory=1447]="MaxDifferencesHistory"})(f||(f={}));class w{constructor(){this.a=[],this.b=B.Constants.MAX_SAFE_SMALL_INTEGER,this.c=B.Constants.MAX_SAFE_SMALL_INTEGER,this.d=0,this.e=0}MarkNextChange(){(this.d>0||this.e>0)&&this.a.push(new i.$Rv(this.b,this.d,this.c,this.e)),this.d=0,this.e=0,this.b=B.Constants.MAX_SAFE_SMALL_INTEGER,this.c=B.Constants.MAX_SAFE_SMALL_INTEGER}AddOriginalElement(m,e){this.b=Math.min(this.b,m),this.c=Math.min(this.c,e),this.d++}AddModifiedElement(m,e){this.b=Math.min(this.b,m),this.c=Math.min(this.c,e),this.e++}getChanges(){return(this.d>0||this.e>0)&&this.MarkNextChange(),this.a}getReverseChanges(){return(this.d>0||this.e>0)&&this.MarkNextChange(),this.a.reverse(),this.a}}class A{constructor(m,e,s=null){this.a=s,this.b=m,this.c=e;const[o,h,c]=A.o(m),[b,k,E]=A.o(e);this.d=c&&E,this.e=o,this.f=h,this.g=b,this.h=k,this.k=[],this.m=[]}static n(m){return m.length>0&&typeof m[0]=="string"}static o(m){const e=m.getElements();if(A.n(e)){const s=new Int32Array(e.length);for(let o=0,h=e.length;o<h;o++)s[o]=(0,n.$rj)(e[o],0);return[e,s,!0]}return e instanceof Int32Array?[[],e,!1]:[[],new Int32Array(e),!1]}p(m,e){return this.f[m]!==this.h[e]?!1:this.d?this.e[m]===this.g[e]:!0}q(m,e){if(!this.p(m,e))return!1;const s=A.r(this.b,m),o=A.r(this.c,e);return s===o}static r(m,e){return typeof m.getStrictElement=="function"?m.getStrictElement(e):null}s(m,e){return this.f[m]!==this.f[e]?!1:this.d?this.e[m]===this.e[e]:!0}u(m,e){return this.h[m]!==this.h[e]?!1:this.d?this.g[m]===this.g[e]:!0}ComputeDiff(m){return this.v(0,this.f.length-1,0,this.h.length-1,m)}v(m,e,s,o,h){const c=[!1];let b=this.w(m,e,s,o,c);return h&&(b=this.z(b)),{quitEarly:c[0],changes:b}}w(m,e,s,o,h){for(h[0]=!1;m<=e&&s<=o&&this.p(m,s);)m++,s++;for(;e>=m&&o>=s&&this.p(e,o);)e--,o--;if(m>e||s>o){let d;return s<=o?(v.Assert(m===e+1,"originalStart should only be one more than originalEnd"),d=[new i.$Rv(m,0,s,o-s+1)]):m<=e?(v.Assert(s===o+1,"modifiedStart should only be one more than modifiedEnd"),d=[new i.$Rv(m,e-m+1,s,0)]):(v.Assert(m===e+1,"originalStart should only be one more than originalEnd"),v.Assert(s===o+1,"modifiedStart should only be one more than modifiedEnd"),d=[]),d}const c=[0],b=[0],k=this.y(m,e,s,o,c,b,h),E=c[0],r=b[0];if(k!==null)return k;if(!h[0]){const d=this.w(m,E,s,r,h);let D=[];return h[0]?D=[new i.$Rv(E+1,e-(E+1)+1,r+1,o-(r+1)+1)]:D=this.w(E+1,e,r+1,o,h),this.H(d,D)}return[new i.$Rv(m,e-m+1,s,o-s+1)]}x(m,e,s,o,h,c,b,k,E,r,d,D,R,_,H,x,p,M){let U=null,N=null,P=new w,W=e,ne=s,Q=R[0]-x[0]-o,Y=B.Constants.MIN_SAFE_SMALL_INTEGER,te=this.k.length-1;do{const de=Q+m;de===W||de<ne&&E[de-1]<E[de+1]?(d=E[de+1],_=d-Q-o,d<Y&&P.MarkNextChange(),Y=d,P.AddModifiedElement(d+1,_),Q=de+1-m):(d=E[de-1]+1,_=d-Q-o,d<Y&&P.MarkNextChange(),Y=d-1,P.AddOriginalElement(d,_+1),Q=de-1-m),te>=0&&(E=this.k[te],m=E[0],W=1,ne=E.length-1)}while(--te>=-1);if(U=P.getReverseChanges(),M[0]){let de=R[0]+1,De=x[0]+1;if(U!==null&&U.length>0){const Le=U[U.length-1];de=Math.max(de,Le.getOriginalEnd()),De=Math.max(De,Le.getModifiedEnd())}N=[new i.$Rv(de,D-de+1,De,H-De+1)]}else{P=new w,W=c,ne=b,Q=R[0]-x[0]-k,Y=B.Constants.MAX_SAFE_SMALL_INTEGER,te=p?this.m.length-1:this.m.length-2;do{const de=Q+h;de===W||de<ne&&r[de-1]>=r[de+1]?(d=r[de+1]-1,_=d-Q-k,d>Y&&P.MarkNextChange(),Y=d+1,P.AddOriginalElement(d+1,_+1),Q=de+1-h):(d=r[de-1],_=d-Q-k,d>Y&&P.MarkNextChange(),Y=d,P.AddModifiedElement(d+1,_+1),Q=de-1-h),te>=0&&(r=this.m[te],h=r[0],W=1,ne=r.length-1)}while(--te>=-1);N=P.getChanges()}return this.H(U,N)}y(m,e,s,o,h,c,b){let k=0,E=0,r=0,d=0,D=0,R=0;m--,s--,h[0]=0,c[0]=0,this.k=[],this.m=[];const _=e-m+(o-s),H=_+1,x=new Int32Array(H),p=new Int32Array(H),M=o-s,U=e-m,N=m-s,P=e-o,ne=(U-M)%2===0;x[M]=m,p[U]=e,b[0]=!1;for(let Q=1;Q<=_/2+1;Q++){let Y=0,te=0;r=this.J(M-Q,Q,M,H),d=this.J(M+Q,Q,M,H);for(let De=r;De<=d;De+=2){De===r||De<d&&x[De-1]<x[De+1]?k=x[De+1]:k=x[De-1]+1,E=k-(De-M)-N;const Le=k;for(;k<e&&E<o&&this.p(k+1,E+1);)k++,E++;if(x[De]=k,k+E>Y+te&&(Y=k,te=E),!ne&&Math.abs(De-U)<=Q-1&&k>=p[De])return h[0]=k,c[0]=E,Le<=p[De]&&f.MaxDifferencesHistory>0&&Q<=f.MaxDifferencesHistory+1?this.x(M,r,d,N,U,D,R,P,x,p,k,e,h,E,o,c,ne,b):null}const de=(Y-m+(te-s)-Q)/2;if(this.a!==null&&!this.a(Y,de))return b[0]=!0,h[0]=Y,c[0]=te,de>0&&f.MaxDifferencesHistory>0&&Q<=f.MaxDifferencesHistory+1?this.x(M,r,d,N,U,D,R,P,x,p,k,e,h,E,o,c,ne,b):(m++,s++,[new i.$Rv(m,e-m+1,s,o-s+1)]);D=this.J(U-Q,Q,U,H),R=this.J(U+Q,Q,U,H);for(let De=D;De<=R;De+=2){De===D||De<R&&p[De-1]>=p[De+1]?k=p[De+1]-1:k=p[De-1],E=k-(De-U)-P;const Le=k;for(;k>m&&E>s&&this.p(k,E);)k--,E--;if(p[De]=k,ne&&Math.abs(De-M)<=Q&&k<=x[De])return h[0]=k,c[0]=E,Le>=x[De]&&f.MaxDifferencesHistory>0&&Q<=f.MaxDifferencesHistory+1?this.x(M,r,d,N,U,D,R,P,x,p,k,e,h,E,o,c,ne,b):null}if(Q<=f.MaxDifferencesHistory){let De=new Int32Array(d-r+2);De[0]=M-r+1,y.Copy2(x,r,De,1,d-r+1),this.k.push(De),De=new Int32Array(R-D+2),De[0]=U-D+1,y.Copy2(p,D,De,1,R-D+1),this.m.push(De)}}return this.x(M,r,d,N,U,D,R,P,x,p,k,e,h,E,o,c,ne,b)}z(m){for(let e=0;e<m.length;e++){const s=m[e],o=e<m.length-1?m[e+1].originalStart:this.f.length,h=e<m.length-1?m[e+1].modifiedStart:this.h.length,c=s.originalLength>0,b=s.modifiedLength>0;for(;s.originalStart+s.originalLength<o&&s.modifiedStart+s.modifiedLength<h&&(!c||this.s(s.originalStart,s.originalStart+s.originalLength))&&(!b||this.u(s.modifiedStart,s.modifiedStart+s.modifiedLength));){const E=this.q(s.originalStart,s.modifiedStart);if(this.q(s.originalStart+s.originalLength,s.modifiedStart+s.modifiedLength)&&!E)break;s.originalStart++,s.modifiedStart++}const k=[null];if(e<m.length-1&&this.I(m[e],m[e+1],k)){m[e]=k[0],m.splice(e+1,1),e--;continue}}for(let e=m.length-1;e>=0;e--){const s=m[e];let o=0,h=0;if(e>0){const d=m[e-1];o=d.originalStart+d.originalLength,h=d.modifiedStart+d.modifiedLength}const c=s.originalLength>0,b=s.modifiedLength>0;let k=0,E=this.G(s.originalStart,s.originalLength,s.modifiedStart,s.modifiedLength);for(let d=1;;d++){const D=s.originalStart-d,R=s.modifiedStart-d;if(D<o||R<h||c&&!this.s(D,D+s.originalLength)||b&&!this.u(R,R+s.modifiedLength))break;const H=(D===o&&R===h?5:0)+this.G(D,s.originalLength,R,s.modifiedLength);H>E&&(E=H,k=d)}s.originalStart-=k,s.modifiedStart-=k;const r=[null];if(e>0&&this.I(m[e-1],m[e],r)){m[e-1]=r[0],m.splice(e,1),e++;continue}}if(this.d)for(let e=1,s=m.length;e<s;e++){const o=m[e-1],h=m[e],c=h.originalStart-o.originalStart-o.originalLength,b=o.originalStart,k=h.originalStart+h.originalLength,E=k-b,r=o.modifiedStart,d=h.modifiedStart+h.modifiedLength,D=d-r;if(c<5&&E<20&&D<20){const R=this.A(b,E,r,D,c);if(R){const[_,H]=R;(_!==o.originalStart+o.originalLength||H!==o.modifiedStart+o.modifiedLength)&&(o.originalLength=_-o.originalStart,o.modifiedLength=H-o.modifiedStart,h.originalStart=_+c,h.modifiedStart=H+c,h.originalLength=k-h.originalStart,h.modifiedLength=d-h.modifiedStart)}}}return m}A(m,e,s,o,h){if(e<h||o<h)return null;const c=m+e-h+1,b=s+o-h+1;let k=0,E=0,r=0;for(let d=m;d<c;d++)for(let D=s;D<b;D++){const R=this.B(d,D,h);R>0&&R>k&&(k=R,E=d,r=D)}return k>0?[E,r]:null}B(m,e,s){let o=0;for(let h=0;h<s;h++){if(!this.p(m+h,e+h))return 0;o+=this.e[m+h].length}return o}C(m){return m<=0||m>=this.f.length-1?!0:this.d&&/^\s*$/.test(this.e[m])}D(m,e){if(this.C(m)||this.C(m-1))return!0;if(e>0){const s=m+e;if(this.C(s-1)||this.C(s))return!0}return!1}E(m){return m<=0||m>=this.h.length-1?!0:this.d&&/^\s*$/.test(this.g[m])}F(m,e){if(this.E(m)||this.E(m-1))return!0;if(e>0){const s=m+e;if(this.E(s-1)||this.E(s))return!0}return!1}G(m,e,s,o){const h=this.D(m,e)?1:0,c=this.F(s,o)?1:0;return h+c}H(m,e){const s=[];if(m.length===0||e.length===0)return e.length>0?e:m;if(this.I(m[m.length-1],e[0],s)){const o=new Array(m.length+e.length-1);return y.Copy(m,0,o,0,m.length-1),o[m.length-1]=s[0],y.Copy(e,1,o,m.length,e.length-1),o}else{const o=new Array(m.length+e.length);return y.Copy(m,0,o,0,m.length),y.Copy(e,0,o,m.length,e.length),o}}I(m,e,s){if(v.Assert(m.originalStart<=e.originalStart,"Left change is not less than or equal to right change"),v.Assert(m.modifiedStart<=e.modifiedStart,"Left change is not less than or equal to right change"),m.originalStart+m.originalLength>=e.originalStart||m.modifiedStart+m.modifiedLength>=e.modifiedStart){const o=m.originalStart;let h=m.originalLength;const c=m.modifiedStart;let b=m.modifiedLength;return m.originalStart+m.originalLength>=e.originalStart&&(h=e.originalStart+e.originalLength-m.originalStart),m.modifiedStart+m.modifiedLength>=e.modifiedStart&&(b=e.modifiedStart+e.modifiedLength-m.modifiedStart),s[0]=new i.$Rv(o,h,c,b),!0}else return s[0]=null,!1}J(m,e,s,o){if(m>=0&&m<o)return m;const h=s,c=o-s-1,b=e%2===0;if(m<0){const k=h%2===0;return b===k?0:1}else{const k=c%2===0;return b===k?o-1:o-2}}}t.$Uv=A}),define(pe[66],we([1,0,50,11,22]),function(oe,t,i,n,B){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Rk=y,t.$Sk=w,t.$Tk=$,t.$Uk=m,t.$Vk=s,t.$Wk=o;const O="$(",T=new RegExp(`\\$\\(${B.ThemeIcon.iconNameExpression}(?:${B.ThemeIcon.iconModifierExpression})?\\)`,"g"),v=new RegExp(`(\\\\)?${T.source}`,"g");function y(h){return h.replace(v,(c,b)=>b?c:`\\${c}`)}const f=new RegExp(`\\\\${T.source}`,"g");function w(h){return h.replace(f,c=>`\\${c}`)}const A=new RegExp(`(\\s)?(\\\\)?${T.source}(\\s)?`,"g");function $(h){return h.indexOf(O)===-1?h:h.replace(A,(c,b,k,E)=>k?c:b||E||"")}function m(h){return h?h.replace(/\$\((.*?)\)/g,(c,b)=>` ${b} `).trim():""}const e=new RegExp(`\\$\\(${B.ThemeIcon.iconNameCharacter}+\\)`,"g");function s(h){e.lastIndex=0;let c="";const b=[];let k=0;for(;;){const E=e.lastIndex,r=e.exec(h),d=h.substring(E,r?.index);if(d.length>0){c+=d;for(let D=0;D<d.length;D++)b.push(k)}if(!r)break;k+=r[0].length}return{text:c,iconOffsets:b}}function o(h,c,b=!1){const{text:k,iconOffsets:E}=c;if(!E||E.length===0)return(0,i.$Ik)(h,k,b);const r=(0,n.$if)(k," "),d=k.length-r.length,D=(0,i.$Ik)(h,r,b);if(D)for(const R of D){const _=E[R.start+d]+d;R.start+=_,R.end+=_}return D}}),define(pe[104],we([1,0,9,18,11]),function(oe,t,i,n,B){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Gi=t.$Fi=t.$Ei=t.$Di=t.$Ci=void 0;class O{constructor(){this.b="",this.c=0}reset(e){return this.b=e,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(e){const s=e.charCodeAt(0),o=this.b.charCodeAt(this.c);return s-o}value(){return this.b[this.c]}}t.$Ci=O;class T{constructor(e=!0){this.e=e}reset(e){return this.b=e,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let e=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===n.CharCode.Period)if(e)this.c++;else break;else e=!1;return this}cmp(e){return this.e?(0,B.$vf)(e,this.b,0,e.length,this.c,this.d):(0,B.$xf)(e,this.b,0,e.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}t.$Di=T;class v{constructor(e=!0,s=!0){this.f=e,this.g=s}reset(e){this.d=0,this.e=0,this.b=e,this.c=e.length;for(let s=e.length-1;s>=0;s--,this.c--){const o=this.b.charCodeAt(s);if(!(o===n.CharCode.Slash||this.f&&o===n.CharCode.Backslash))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let e=!0;for(;this.e<this.c;this.e++){const s=this.b.charCodeAt(this.e);if(s===n.CharCode.Slash||this.f&&s===n.CharCode.Backslash)if(e)this.d++;else break;else e=!1}return this}cmp(e){return this.g?(0,B.$vf)(e,this.b,0,e.length,this.d,this.e):(0,B.$xf)(e,this.b,0,e.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}t.$Ei=v;var y;(function(m){m[m.Scheme=1]="Scheme",m[m.Authority=2]="Authority",m[m.Path=3]="Path",m[m.Query=4]="Query",m[m.Fragment=5]="Fragment"})(y||(y={}));class f{constructor(e,s){this.f=e,this.g=s,this.d=[],this.e=0}reset(e){return this.c=e,this.d=[],this.c.scheme&&this.d.push(y.Scheme),this.c.authority&&this.d.push(y.Authority),this.c.path&&(this.b=new v(!1,!this.f(e)),this.b.reset(e.path),this.b.value()&&this.d.push(y.Path)),this.g(e)||(this.c.query&&this.d.push(y.Query),this.c.fragment&&this.d.push(y.Fragment)),this.e=0,this}next(){return this.d[this.e]===y.Path&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===y.Path&&this.b.hasNext()||this.e<this.d.length-1}cmp(e){if(this.d[this.e]===y.Scheme)return(0,B.$wf)(e,this.c.scheme);if(this.d[this.e]===y.Authority)return(0,B.$wf)(e,this.c.authority);if(this.d[this.e]===y.Path)return this.b.cmp(e);if(this.d[this.e]===y.Query)return(0,B.$uf)(e,this.c.query);if(this.d[this.e]===y.Fragment)return(0,B.$uf)(e,this.c.fragment);throw new Error}value(){if(this.d[this.e]===y.Scheme)return this.c.scheme;if(this.d[this.e]===y.Authority)return this.c.authority;if(this.d[this.e]===y.Path)return this.b.value();if(this.d[this.e]===y.Query)return this.c.query;if(this.d[this.e]===y.Fragment)return this.c.fragment;throw new Error}}t.$Fi=f;class w{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const e=this.right;return this.right=e.left,e.left=this,this.updateHeight(),e.updateHeight(),e}rotateRight(){const e=this.left;return this.left=e.right,e.right=this,this.updateHeight(),e.updateHeight(),e}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var A;(function(m){m[m.Left=-1]="Left",m[m.Mid=0]="Mid",m[m.Right=1]="Right"})(A||(A={}));class ${static forUris(e=()=>!1,s=()=>!1){return new $(new f(e,s))}static forPaths(e=!1){return new $(new v(void 0,!e))}static forStrings(){return new $(new O)}static forConfigKeys(){return new $(new T)}constructor(e){this.b=e}clear(){this.c=void 0}fill(e,s){if(s){const o=s.slice(0);(0,i.$Wb)(o);for(const h of o)this.set(h,e)}else{const o=e.slice(0);(0,i.$Wb)(o);for(const h of o)this.set(h[0],h[1])}}set(e,s){const o=this.b.reset(e);let h;this.c||(this.c=new w,this.c.segment=o.value());const c=[];for(h=this.c;;){const k=o.cmp(h.segment);if(k>0)h.left||(h.left=new w,h.left.segment=o.value()),c.push([A.Left,h]),h=h.left;else if(k<0)h.right||(h.right=new w,h.right.segment=o.value()),c.push([A.Right,h]),h=h.right;else if(o.hasNext())o.next(),h.mid||(h.mid=new w,h.mid.segment=o.value()),c.push([A.Mid,h]),h=h.mid;else break}const b=h.value;h.value=s,h.key=e;for(let k=c.length-1;k>=0;k--){const E=c[k][1];E.updateHeight();const r=E.balanceFactor();if(r<-1||r>1){const d=c[k][0],D=c[k+1][0];if(d===A.Right&&D===A.Right)c[k][1]=E.rotateLeft();else if(d===A.Left&&D===A.Left)c[k][1]=E.rotateRight();else if(d===A.Right&&D===A.Left)E.right=c[k+1][1]=c[k+1][1].rotateRight(),c[k][1]=E.rotateLeft();else if(d===A.Left&&D===A.Right)E.left=c[k+1][1]=c[k+1][1].rotateLeft(),c[k][1]=E.rotateRight();else throw new Error;if(k>0)switch(c[k-1][0]){case A.Left:c[k-1][1].left=c[k][1];break;case A.Right:c[k-1][1].right=c[k][1];break;case A.Mid:c[k-1][1].mid=c[k][1];break}else this.c=c[0][1]}}return b}get(e){return this.d(e)?.value}d(e){const s=this.b.reset(e);let o=this.c;for(;o;){const h=s.cmp(o.segment);if(h>0)o=o.left;else if(h<0)o=o.right;else if(s.hasNext())s.next(),o=o.mid;else break}return o}has(e){const s=this.d(e);return!(s?.value===void 0&&s?.mid===void 0)}delete(e){return this.e(e,!1)}deleteSuperstr(e){return this.e(e,!0)}e(e,s){const o=this.b.reset(e),h=[];let c=this.c;for(;c;){const b=o.cmp(c.segment);if(b>0)h.push([A.Left,c]),c=c.left;else if(b<0)h.push([A.Right,c]),c=c.right;else if(o.hasNext())o.next(),h.push([A.Mid,c]),c=c.mid;else break}if(c){if(s?(c.left=void 0,c.mid=void 0,c.right=void 0,c.height=1):(c.key=void 0,c.value=void 0),!c.mid&&!c.value)if(c.left&&c.right){const b=this.f(c.right);if(b.key){const{key:k,value:E,segment:r}=b;this.e(b.key,!1),c.key=k,c.value=E,c.segment=r}}else{const b=c.left??c.right;if(h.length>0){const[k,E]=h[h.length-1];switch(k){case A.Left:E.left=b;break;case A.Mid:E.mid=b;break;case A.Right:E.right=b;break}}else this.c=b}for(let b=h.length-1;b>=0;b--){const k=h[b][1];k.updateHeight();const E=k.balanceFactor();if(E>1?(k.right.balanceFactor()>=0||(k.right=k.right.rotateRight()),h[b][1]=k.rotateLeft()):E<-1&&(k.left.balanceFactor()<=0||(k.left=k.left.rotateLeft()),h[b][1]=k.rotateRight()),b>0)switch(h[b-1][0]){case A.Left:h[b-1][1].left=h[b][1];break;case A.Right:h[b-1][1].right=h[b][1];break;case A.Mid:h[b-1][1].mid=h[b][1];break}else this.c=h[0][1]}}}f(e){for(;e.left;)e=e.left;return e}findSubstr(e){const s=this.b.reset(e);let o=this.c,h;for(;o;){const c=s.cmp(o.segment);if(c>0)o=o.left;else if(c<0)o=o.right;else if(s.hasNext())s.next(),h=o.value||h,o=o.mid;else break}return o&&o.value||h}findSuperstr(e){return this.g(e,!1)}g(e,s){const o=this.b.reset(e);let h=this.c;for(;h;){const c=o.cmp(h.segment);if(c>0)h=h.left;else if(c<0)h=h.right;else if(o.hasNext())o.next(),h=h.mid;else return h.mid?this.h(h.mid):s?h.value:void 0}}hasElementOrSubtree(e){return this.g(e,!0)!==void 0}forEach(e){for(const[s,o]of this)e(o,s)}*[Symbol.iterator](){yield*this.h(this.c)}h(e){const s=[];return this.j(e,s),s[Symbol.iterator]()}j(e,s){e&&(e.left&&this.j(e.left,s),e.value&&s.push([e.key,e.value]),e.mid&&this.j(e.mid,s),e.right&&this.j(e.right,s))}_isBalanced(){const e=s=>{if(!s)return!0;const o=s.balanceFactor();return o<-1||o>1?!1:e(s.left)&&e(s.right)};return e(this.c)}}t.$Gi=$}),define(pe[105],we([1,0]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$oW=t.$nW=void 0,t.$nW="vscode:contextmenu",t.$oW="vscode:onCloseContextMenu"}),define(pe[106],we([1,0]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$vW=void 0;class i{constructor(B,O){this.a=B,this.onMessage=O}send(B){try{this.a.send("vscode:message",B.buffer)}catch{}}disconnect(){this.a.send("vscode:disconnect",null)}}t.$vW=i}),define(pe[38],we([1,0]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$S=t.$R=t.$Q=t.$P=t.$O=void 0;const i=globalThis.vscode;t.$O=i.ipcRenderer,t.$P=i.ipcMessagePort,t.$Q=i.webFrame,t.$R=i.process,t.$S=i.context}),define(pe[107],we([1,0,105,38]),function(oe,t,i,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$rW=O;let B=0;function O(v,y,f){const w=[],A=B++,$=`vscode:onContextMenu${A}`,m=(e,s,o)=>{w[s].click?.(o)};n.$O.once($,m),n.$O.once(i.$oW,(e,s)=>{s===A&&(n.$O.removeListener($,m),f?.())}),n.$O.send(i.$nW,A,v.map(e=>T(e,w)),$,y)}function T(v,y){const f={id:y.length,label:v.label,type:v.type,accelerator:v.accelerator,checked:v.checked,enabled:typeof v.enabled=="boolean"?v.enabled:!0,visible:typeof v.visible=="boolean"?v.visible:!0};return y.push(v),Array.isArray(v.submenu)&&(f.submenu=v.submenu.map(w=>T(w,y))),f}}),define(pe[67],we([7]),{}),define(pe[108],we([7]),{}),define(pe[109],we([7]),{}),define(pe[110],we([7]),{}),define(pe[111],we([1,0,109,110]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0})}),define(pe[112],we([7]),{}),define(pe[113],we([7]),{}),define(pe[114],we([7]),{}),define(pe[115],we([7]),{}),define(pe[116],we([7]),{}),define(pe[117],we([7]),{}),define(pe[118],we([7]),{}),define(pe[119],we([7]),{}),define(pe[120],we([7]),{}),define(pe[121],we([7]),{}),define(pe[122],we([14,13]),function(oe,t){return oe.create("vs/base/browser/ui/actionbar/actionViewItems",t)}),define(pe[123],we([14,13]),function(oe,t){return oe.create("vs/base/browser/ui/findinput/findInput",t)}),define(pe[124],we([14,13]),function(oe,t){return oe.create("vs/base/browser/ui/findinput/findInputToggles",t)}),define(pe[125],we([14,13]),function(oe,t){return oe.create("vs/base/browser/ui/inputbox/inputBox",t)}),define(pe[126],we([14,13]),function(oe,t){return oe.create("vs/base/browser/ui/selectBox/selectBoxCustom",t)}),define(pe[127],we([14,13]),function(oe,t){return oe.create("vs/base/browser/ui/tree/abstractTree",t)}),define(pe[128],we([14,13]),function(oe,t){return oe.create("vs/base/common/actions",t)}),define(pe[51],we([1,0,3,2,128]),function(oe,t,i,n,B){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$jj=t.$ij=t.$hj=t.$gj=t.$fj=void 0,t.$kj=w;class O extends n.$Uc{constructor($,m="",e="",s=!0,o){super(),this.j=this.B(new i.$he),this.onDidChange=this.j.event,this.z=!0,this.m=$,this.n=m,this.w=e,this.z=s,this.D=o}get id(){return this.m}get label(){return this.n}set label($){this.F($)}F($){this.n!==$&&(this.n=$,this.j.fire({label:$}))}get tooltip(){return this.u||""}set tooltip($){this.G($)}G($){this.u!==$&&(this.u=$,this.j.fire({tooltip:$}))}get class(){return this.w}set class($){this.H($)}H($){this.w!==$&&(this.w=$,this.j.fire({class:$}))}get enabled(){return this.z}set enabled($){this.I($)}I($){this.z!==$&&(this.z=$,this.j.fire({enabled:$}))}get checked(){return this.C}set checked($){this.J($)}J($){this.C!==$&&(this.C=$,this.j.fire({checked:$}))}async run($,m){this.D&&await this.D($)}}t.$fj=O;class T extends n.$Uc{constructor(){super(...arguments),this.f=this.B(new i.$he),this.onWillRun=this.f.event,this.m=this.B(new i.$he),this.onDidRun=this.m.event}async run($,m){if(!$.enabled)return;this.f.fire({action:$});let e;try{await this.u($,m)}catch(s){e=s}this.m.fire({action:$,error:e})}async u($,m){await $.run(m)}}t.$gj=T;class v{constructor(){this.id=v.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...$){let m=[];for(const e of $)e.length&&(m.length?m=[...m,new v,...e]:m=e);return m}static{this.ID="vs.actions.separator"}async run(){}}t.$hj=v;class y{get actions(){return this.a}constructor($,m,e,s){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=$,this.label=m,this.class=s,this.a=e}async run(){}}t.$ij=y;class f extends O{static{this.ID="vs.actions.empty"}constructor(){super(f.ID,B.localize(0,null),void 0,!1)}}t.$jj=f;function w(A){return{id:A.id,label:A.label,tooltip:A.tooltip??A.label,class:A.class,enabled:A.enabled??!0,checked:A.checked,run:async(...$)=>A.run(...$)}}}),define(pe[129],we([14,13]),function(oe,t){return oe.create("vs/base/common/platform",t)}),define(pe[5],we([1,0,129]),function(oe,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$I=t.$H=t.$G=t.$F=t.$E=t.OS=t.OperatingSystem=t.$B=t.$A=t.$z=t.$y=t.$x=t.Language=t.$w=t.$v=t.$u=t.$t=t.$s=t.$r=t.$q=t.$p=t.$o=t.$n=t.$m=t.$l=t.$k=t.$j=t.$i=t.Platform=t.$g=void 0,t.$h=d,t.$D=p,t.$J=M,t.$g="en";let n=!1,B=!1,O=!1,T=!1,v=!1,y=!1,f=!1,w=!1,A=!1,$=!1,m,e=t.$g,s=t.$g,o,h;const c=globalThis;let b;typeof c.vscode<"u"&&typeof c.vscode.process<"u"?b=c.vscode.process:typeof process<"u"&&typeof process?.versions?.node=="string"&&(b=process);const k=typeof b?.versions?.electron=="string",E=k&&b?.type==="renderer";if(typeof b=="object"){n=b.platform==="win32",B=b.platform==="darwin",O=b.platform==="linux",T=O&&!!b.env.SNAP&&!!b.env.SNAP_REVISION,f=k,A=!!b.env.CI||!!b.env.BUILD_ARTIFACTSTAGINGDIRECTORY,m=t.$g,e=t.$g;const U=b.env.VSCODE_NLS_CONFIG;if(U)try{const N=JSON.parse(U),P=N.availableLanguages["*"];m=N.locale,s=N.osLocale,e=P||t.$g,o=N._translationsConfigFile}catch{}v=!0}else typeof navigator=="object"&&!E?(h=navigator.userAgent,n=h.indexOf("Windows")>=0,B=h.indexOf("Macintosh")>=0,w=(h.indexOf("Macintosh")>=0||h.indexOf("iPad")>=0||h.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,O=h.indexOf("Linux")>=0,$=h?.indexOf("Mobi")>=0,y=!0,m=i.getConfiguredDefaultLocale(i.localize(0,null))||t.$g,e=m,s=navigator.language):console.error("Unable to resolve platform.");var r;(function(U){U[U.Web=0]="Web",U[U.Mac=1]="Mac",U[U.Linux=2]="Linux",U[U.Windows=3]="Windows"})(r||(t.Platform=r={}));function d(U){switch(U){case r.Web:return"Web";case r.Mac:return"Mac";case r.Linux:return"Linux";case r.Windows:return"Windows"}}let D=r.Web;B?D=r.Mac:n?D=r.Windows:O&&(D=r.Linux),t.$i=n,t.$j=B,t.$k=O,t.$l=T,t.$m=v,t.$n=f,t.$o=y,t.$p=y&&typeof c.importScripts=="function",t.$q=t.$p?c.origin:void 0,t.$r=w,t.$s=$,t.$t=A,t.$u=D,t.$v=h,t.$w=e;var R;(function(U){function N(){return t.$w}U.value=N;function P(){return t.$w.length===2?t.$w==="en":t.$w.length>=3?t.$w[0]==="e"&&t.$w[1]==="n"&&t.$w[2]==="-":!1}U.isDefaultVariant=P;function W(){return t.$w==="en"}U.isDefault=W})(R||(t.Language=R={})),t.$x=m,t.$y=s,t.$z=o,t.$A=typeof c.postMessage=="function"&&!c.importScripts,t.$B=(()=>{if(t.$A){const U=[];c.addEventListener("message",P=>{if(P.data&&P.data.vscodeScheduleAsyncWork)for(let W=0,ne=U.length;W<ne;W++){const Q=U[W];if(Q.id===P.data.vscodeScheduleAsyncWork){U.splice(W,1),Q.callback();return}}});let N=0;return P=>{const W=++N;U.push({id:W,callback:P}),c.postMessage({vscodeScheduleAsyncWork:W},"*")}}return U=>setTimeout(U)})();var _;(function(U){U[U.Windows=1]="Windows",U[U.Macintosh=2]="Macintosh",U[U.Linux=3]="Linux"})(_||(t.OperatingSystem=_={})),t.OS=B||w?_.Macintosh:n?_.Windows:_.Linux;let H=!0,x=!1;function p(){if(!x){x=!0;const U=new Uint8Array(2);U[0]=1,U[1]=2,H=new Uint16Array(U.buffer)[0]===513}return H}t.$E=!!(t.$v&&t.$v.indexOf("Chrome")>=0),t.$F=!!(t.$v&&t.$v.indexOf("Firefox")>=0),t.$G=!!(!t.$E&&t.$v&&t.$v.indexOf("Safari")>=0),t.$H=!!(t.$v&&t.$v.indexOf("Edg/")>=0),t.$I=!!(t.$v&&t.$v.indexOf("Android")>=0);function M(U){return parseFloat(U)>=20}}),define(pe[68],we([1,0,19,25,5]),function(oe,t,i,n,B){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$cR=t.KeyboardSupport=void 0;var O;(function(T){T[T.Always=0]="Always",T[T.FullScreen=1]="FullScreen",T[T.None=2]="None"})(O||(t.KeyboardSupport=O={})),t.$cR={clipboard:{writeText:B.$m||document.queryCommandSupported&&document.queryCommandSupported("copy")||!!(navigator&&navigator.clipboard&&navigator.clipboard.writeText),readText:B.$m||!!(navigator&&navigator.clipboard&&navigator.clipboard.readText)},keyboard:B.$m||i.$aR()?O.Always:navigator.keyboard||i.$9Q?O.FullScreen:O.None,touch:"ontouchstart"in n.$TQ||navigator.maxTouchPoints>0,pointerEvents:n.$TQ.PointerEvent&&("ontouchstart"in n.$TQ||navigator.maxTouchPoints>0)}}),define(pe[23],we([1,0,19,85,5]),function(oe,t,i,n,B){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$hR=t.$gR=t.$fR=void 0;class O{constructor(f,w){this.timestamp=Date.now(),this.browserEvent=w,this.leftButton=w.button===0,this.middleButton=w.button===1,this.rightButton=w.button===2,this.buttons=w.buttons,this.target=w.target,this.detail=w.detail||1,w.type==="dblclick"&&(this.detail=2),this.ctrlKey=w.ctrlKey,this.shiftKey=w.shiftKey,this.altKey=w.altKey,this.metaKey=w.metaKey,typeof w.pageX=="number"?(this.posx=w.pageX,this.posy=w.pageY):(this.posx=w.clientX+this.target.ownerDocument.body.scrollLeft+this.target.ownerDocument.documentElement.scrollLeft,this.posy=w.clientY+this.target.ownerDocument.body.scrollTop+this.target.ownerDocument.documentElement.scrollTop);const A=n.$dR.getPositionOfChildWindowRelativeToAncestorWindow(f,w.view);this.posx-=A.left,this.posy-=A.top}preventDefault(){this.browserEvent.preventDefault()}stopPropagation(){this.browserEvent.stopPropagation()}}t.$fR=O;class T extends O{constructor(f,w){super(f,w),this.dataTransfer=w.dataTransfer}}t.$gR=T;class v{constructor(f,w=0,A=0){this.browserEvent=f||null,this.target=f?f.target||f.targetNode||f.srcElement:null,this.deltaY=A,this.deltaX=w;let $=!1;if(i.$8Q){const m=navigator.userAgent.match(/Chrome\/(\d+)/);$=(m?parseInt(m[1]):123)<=122}if(f){const m=f,e=f,s=f.view?.devicePixelRatio||1;if(typeof m.wheelDeltaY<"u")$?this.deltaY=m.wheelDeltaY/(120*s):this.deltaY=m.wheelDeltaY/120;else if(typeof e.VERTICAL_AXIS<"u"&&e.axis===e.VERTICAL_AXIS)this.deltaY=-e.detail/3;else if(f.type==="wheel"){const o=f;o.deltaMode===o.DOM_DELTA_LINE?i.$6Q&&!B.$j?this.deltaY=-f.deltaY/3:this.deltaY=-f.deltaY:this.deltaY=-f.deltaY/40}if(typeof m.wheelDeltaX<"u")i.$9Q&&B.$i?this.deltaX=-(m.wheelDeltaX/120):$?this.deltaX=m.wheelDeltaX/(120*s):this.deltaX=m.wheelDeltaX/120;else if(typeof e.HORIZONTAL_AXIS<"u"&&e.axis===e.HORIZONTAL_AXIS)this.deltaX=-f.detail/3;else if(f.type==="wheel"){const o=f;o.deltaMode===o.DOM_DELTA_LINE?i.$6Q&&!B.$j?this.deltaX=-f.deltaX/3:this.deltaX=-f.deltaX:this.deltaX=-f.deltaX/40}this.deltaY===0&&this.deltaX===0&&f.wheelDelta&&($?this.deltaY=f.wheelDelta/(120*s):this.deltaY=f.wheelDelta/120)}}preventDefault(){this.browserEvent?.preventDefault()}stopPropagation(){this.browserEvent?.stopPropagation()}}t.$hR=v}),define(pe[130],we([1,0,6,8,5]),function(oe,t,i,n,B){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Tr=t.$Sr=t.$Rr=t.$Qr=t.$Pr=void 0,t.$Nr=T,t.$Or=v;var O;(function(m){m[m.CtrlCmd=2048]="CtrlCmd",m[m.Shift=1024]="Shift",m[m.Alt=512]="Alt",m[m.WinCtrl=256]="WinCtrl",m[m.KeyCode=255]="KeyCode"})(O||(O={}));function T(m,e){if(typeof m=="number"){if(m===0)return null;const s=(m&65535)>>>0,o=(m&4294901760)>>>16;return o!==0?new w([v(s,e),v(o,e)]):new w([v(s,e)])}else{const s=[];for(let o=0;o<m.length;o++)s.push(v(m[o],e));return new w(s)}}function v(m,e){const s=!!(m&O.CtrlCmd),o=!!(m&O.WinCtrl),h=e===B.OperatingSystem.Macintosh?o:s,c=!!(m&O.Shift),b=!!(m&O.Alt),k=e===B.OperatingSystem.Macintosh?s:o,E=m&O.KeyCode;return new y(h,c,b,k,E)}class y{constructor(e,s,o,h,c){this.ctrlKey=e,this.shiftKey=s,this.altKey=o,this.metaKey=h,this.keyCode=c}equals(e){return e instanceof y&&this.ctrlKey===e.ctrlKey&&this.shiftKey===e.shiftKey&&this.altKey===e.altKey&&this.metaKey===e.metaKey&&this.keyCode===e.keyCode}getHashCode(){const e=this.ctrlKey?"1":"0",s=this.shiftKey?"1":"0",o=this.altKey?"1":"0",h=this.metaKey?"1":"0";return`K${e}${s}${o}${h}${this.keyCode}`}isModifierKey(){return this.keyCode===n.KeyCode.Unknown||this.keyCode===n.KeyCode.Ctrl||this.keyCode===n.KeyCode.Meta||this.keyCode===n.KeyCode.Alt||this.keyCode===n.KeyCode.Shift}toKeybinding(){return new w([this])}isDuplicateModifierCase(){return this.ctrlKey&&this.keyCode===n.KeyCode.Ctrl||this.shiftKey&&this.keyCode===n.KeyCode.Shift||this.altKey&&this.keyCode===n.KeyCode.Alt||this.metaKey&&this.keyCode===n.KeyCode.Meta}}t.$Pr=y;class f{constructor(e,s,o,h,c){this.ctrlKey=e,this.shiftKey=s,this.altKey=o,this.metaKey=h,this.scanCode=c}equals(e){return e instanceof f&&this.ctrlKey===e.ctrlKey&&this.shiftKey===e.shiftKey&&this.altKey===e.altKey&&this.metaKey===e.metaKey&&this.scanCode===e.scanCode}getHashCode(){const e=this.ctrlKey?"1":"0",s=this.shiftKey?"1":"0",o=this.altKey?"1":"0",h=this.metaKey?"1":"0";return`S${e}${s}${o}${h}${this.scanCode}`}isDuplicateModifierCase(){return this.ctrlKey&&(this.scanCode===n.ScanCode.ControlLeft||this.scanCode===n.ScanCode.ControlRight)||this.shiftKey&&(this.scanCode===n.ScanCode.ShiftLeft||this.scanCode===n.ScanCode.ShiftRight)||this.altKey&&(this.scanCode===n.ScanCode.AltLeft||this.scanCode===n.ScanCode.AltRight)||this.metaKey&&(this.scanCode===n.ScanCode.MetaLeft||this.scanCode===n.ScanCode.MetaRight)}}t.$Qr=f;class w{constructor(e){if(e.length===0)throw(0,i.$7)("chords");this.chords=e}getHashCode(){let e="";for(let s=0,o=this.chords.length;s<o;s++)s!==0&&(e+=";"),e+=this.chords[s].getHashCode();return e}equals(e){if(e===null||this.chords.length!==e.chords.length)return!1;for(let s=0;s<this.chords.length;s++)if(!this.chords[s].equals(e.chords[s]))return!1;return!0}}t.$Rr=w;class A{constructor(e,s,o,h,c,b){this.ctrlKey=e,this.shiftKey=s,this.altKey=o,this.metaKey=h,this.keyLabel=c,this.keyAriaLabel=b}}t.$Sr=A;class ${}t.$Tr=$}),define(pe[16],we([1,0,19,8,130,5]),function(oe,t,i,n,B,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$kR=void 0,t.$iR=A,t.$jR=$;function T(e){if(e.charCode){const o=String.fromCharCode(e.charCode).toUpperCase();return n.KeyCodeUtils.fromString(o)}const s=e.keyCode;if(s===3)return n.KeyCode.PauseBreak;if(i.$6Q)switch(s){case 59:return n.KeyCode.Semicolon;case 60:if(O.$k)return n.KeyCode.IntlBackslash;break;case 61:return n.KeyCode.Equal;case 107:return n.KeyCode.NumpadAdd;case 109:return n.KeyCode.NumpadSubtract;case 173:return n.KeyCode.Minus;case 224:if(O.$j)return n.KeyCode.Meta;break}else if(i.$7Q){if(O.$j&&s===93)return n.KeyCode.Meta;if(!O.$j&&s===92)return n.KeyCode.Meta}return n.$Hr[s]||n.KeyCode.Unknown}const v=O.$j?n.KeyMod.WinCtrl:n.KeyMod.CtrlCmd,y=n.KeyMod.Alt,f=n.KeyMod.Shift,w=O.$j?n.KeyMod.CtrlCmd:n.KeyMod.WinCtrl;function A(e){const s=[];return e.ctrlKey&&s.push("ctrl"),e.shiftKey&&s.push("shift"),e.altKey&&s.push("alt"),e.metaKey&&s.push("meta"),`modifiers: [${s.join(",")}], code: ${e.code}, keyCode: ${e.keyCode}, key: ${e.key}`}function $(e){const s=[];return e.ctrlKey&&s.push("ctrl"),e.shiftKey&&s.push("shift"),e.altKey&&s.push("alt"),e.metaKey&&s.push("meta"),`modifiers: [${s.join(",")}], code: ${e.code}, keyCode: ${e.keyCode} ('${n.KeyCodeUtils.toString(e.keyCode)}')`}class m{constructor(s){this._standardKeyboardEventBrand=!0;const o=s;this.browserEvent=o,this.target=o.target,this.ctrlKey=o.ctrlKey,this.shiftKey=o.shiftKey,this.altKey=o.altKey,this.metaKey=o.metaKey,this.altGraphKey=o.getModifierState?.("AltGraph"),this.keyCode=T(o),this.code=o.code,this.ctrlKey=this.ctrlKey||this.keyCode===n.KeyCode.Ctrl,this.altKey=this.altKey||this.keyCode===n.KeyCode.Alt,this.shiftKey=this.shiftKey||this.keyCode===n.KeyCode.Shift,this.metaKey=this.metaKey||this.keyCode===n.KeyCode.Meta,this.a=this.c(),this.b=this.d()}preventDefault(){this.browserEvent&&this.browserEvent.preventDefault&&this.browserEvent.preventDefault()}stopPropagation(){this.browserEvent&&this.browserEvent.stopPropagation&&this.browserEvent.stopPropagation()}toKeyCodeChord(){return this.b}equals(s){return this.a===s}c(){let s=n.KeyCode.Unknown;this.keyCode!==n.KeyCode.Ctrl&&this.keyCode!==n.KeyCode.Shift&&this.keyCode!==n.KeyCode.Alt&&this.keyCode!==n.KeyCode.Meta&&(s=this.keyCode);let o=0;return this.ctrlKey&&(o|=v),this.altKey&&(o|=y),this.shiftKey&&(o|=f),this.metaKey&&(o|=w),o|=s,o}d(){let s=n.KeyCode.Unknown;return this.keyCode!==n.KeyCode.Ctrl&&this.keyCode!==n.KeyCode.Shift&&this.keyCode!==n.KeyCode.Alt&&this.keyCode!==n.KeyCode.Meta&&(s=this.keyCode),new B.$Pr(this.ctrlKey,this.shiftKey,this.altKey,this.metaKey,s)}}t.$kR=m}),define(pe[131],we([1,0,5]),function(oe,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ec=t.$dc=t.env=t.cwd=void 0;let n;const B=globalThis.vscode;if(typeof B<"u"&&typeof B.process<"u"){const O=B.process;n={get platform(){return O.platform},get arch(){return O.arch},get env(){return O.env},cwd(){return O.cwd()}}}else typeof process<"u"?n={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:n={get platform(){return i.$i?"win32":i.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};t.cwd=n.cwd,t.env=n.env,t.$dc=n.platform,t.$ec=n.arch}),define(pe[28],we([1,0,131]),function(oe,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$tc=t.sep=t.$rc=t.$qc=t.$pc=t.$oc=t.$nc=t.$mc=t.$lc=t.$kc=t.$jc=t.$ic=t.$hc=t.$gc=t.$fc=void 0;const n=65,B=97,O=90,T=122,v=46,y=47,f=92,w=58,A=63;class $ extends Error{constructor(d,D,R){let _;typeof D=="string"&&D.indexOf("not ")===0?(_="must not be",D=D.replace(/^not /,"")):_="must be";const H=d.indexOf(".")!==-1?"property":"argument";let x=`The "${d}" ${H} ${_} of type ${D}`;x+=`. Received type ${typeof R}`,super(x),this.code="ERR_INVALID_ARG_TYPE"}}function m(r,d){if(r===null||typeof r!="object")throw new $(d,"Object",r)}function e(r,d){if(typeof r!="string")throw new $(d,"string",r)}const s=i.$dc==="win32";function o(r){return r===y||r===f}function h(r){return r===y}function c(r){return r>=n&&r<=O||r>=B&&r<=T}function b(r,d,D,R){let _="",H=0,x=-1,p=0,M=0;for(let U=0;U<=r.length;++U){if(U<r.length)M=r.charCodeAt(U);else{if(R(M))break;M=y}if(R(M)){if(!(x===U-1||p===1))if(p===2){if(_.length<2||H!==2||_.charCodeAt(_.length-1)!==v||_.charCodeAt(_.length-2)!==v){if(_.length>2){const N=_.lastIndexOf(D);N===-1?(_="",H=0):(_=_.slice(0,N),H=_.length-1-_.lastIndexOf(D)),x=U,p=0;continue}else if(_.length!==0){_="",H=0,x=U,p=0;continue}}d&&(_+=_.length>0?`${D}..`:"..",H=2)}else _.length>0?_+=`${D}${r.slice(x+1,U)}`:_=r.slice(x+1,U),H=U-x-1;x=U,p=0}else M===v&&p!==-1?++p:p=-1}return _}function k(r,d){m(d,"pathObject");const D=d.dir||d.root,R=d.base||`${d.name||""}${d.ext||""}`;return D?D===d.root?`${D}${R}`:`${D}${r}${R}`:R}t.$fc={resolve(...r){let d="",D="",R=!1;for(let _=r.length-1;_>=-1;_--){let H;if(_>=0){if(H=r[_],e(H,"path"),H.length===0)continue}else d.length===0?H=i.cwd():(H=i.env[`=${d}`]||i.cwd(),(H===void 0||H.slice(0,2).toLowerCase()!==d.toLowerCase()&&H.charCodeAt(2)===f)&&(H=`${d}\\`));const x=H.length;let p=0,M="",U=!1;const N=H.charCodeAt(0);if(x===1)o(N)&&(p=1,U=!0);else if(o(N))if(U=!0,o(H.charCodeAt(1))){let P=2,W=P;for(;P<x&&!o(H.charCodeAt(P));)P++;if(P<x&&P!==W){const ne=H.slice(W,P);for(W=P;P<x&&o(H.charCodeAt(P));)P++;if(P<x&&P!==W){for(W=P;P<x&&!o(H.charCodeAt(P));)P++;(P===x||P!==W)&&(M=`\\\\${ne}\\${H.slice(W,P)}`,p=P)}}}else p=1;else c(N)&&H.charCodeAt(1)===w&&(M=H.slice(0,2),p=2,x>2&&o(H.charCodeAt(2))&&(U=!0,p=3));if(M.length>0)if(d.length>0){if(M.toLowerCase()!==d.toLowerCase())continue}else d=M;if(R){if(d.length>0)break}else if(D=`${H.slice(p)}\\${D}`,R=U,U&&d.length>0)break}return D=b(D,!R,"\\",o),R?`${d}\\${D}`:`${d}${D}`||"."},normalize(r){e(r,"path");const d=r.length;if(d===0)return".";let D=0,R,_=!1;const H=r.charCodeAt(0);if(d===1)return h(H)?"\\":r;if(o(H))if(_=!0,o(r.charCodeAt(1))){let p=2,M=p;for(;p<d&&!o(r.charCodeAt(p));)p++;if(p<d&&p!==M){const U=r.slice(M,p);for(M=p;p<d&&o(r.charCodeAt(p));)p++;if(p<d&&p!==M){for(M=p;p<d&&!o(r.charCodeAt(p));)p++;if(p===d)return`\\\\${U}\\${r.slice(M)}\\`;p!==M&&(R=`\\\\${U}\\${r.slice(M,p)}`,D=p)}}}else D=1;else c(H)&&r.charCodeAt(1)===w&&(R=r.slice(0,2),D=2,d>2&&o(r.charCodeAt(2))&&(_=!0,D=3));let x=D<d?b(r.slice(D),!_,"\\",o):"";return x.length===0&&!_&&(x="."),x.length>0&&o(r.charCodeAt(d-1))&&(x+="\\"),R===void 0?_?`\\${x}`:x:_?`${R}\\${x}`:`${R}${x}`},isAbsolute(r){e(r,"path");const d=r.length;if(d===0)return!1;const D=r.charCodeAt(0);return o(D)||d>2&&c(D)&&r.charCodeAt(1)===w&&o(r.charCodeAt(2))},join(...r){if(r.length===0)return".";let d,D;for(let H=0;H<r.length;++H){const x=r[H];e(x,"path"),x.length>0&&(d===void 0?d=D=x:d+=`\\${x}`)}if(d===void 0)return".";let R=!0,_=0;if(typeof D=="string"&&o(D.charCodeAt(0))){++_;const H=D.length;H>1&&o(D.charCodeAt(1))&&(++_,H>2&&(o(D.charCodeAt(2))?++_:R=!1))}if(R){for(;_<d.length&&o(d.charCodeAt(_));)_++;_>=2&&(d=`\\${d.slice(_)}`)}return t.$fc.normalize(d)},relative(r,d){if(e(r,"from"),e(d,"to"),r===d)return"";const D=t.$fc.resolve(r),R=t.$fc.resolve(d);if(D===R||(r=D.toLowerCase(),d=R.toLowerCase(),r===d))return"";let _=0;for(;_<r.length&&r.charCodeAt(_)===f;)_++;let H=r.length;for(;H-1>_&&r.charCodeAt(H-1)===f;)H--;const x=H-_;let p=0;for(;p<d.length&&d.charCodeAt(p)===f;)p++;let M=d.length;for(;M-1>p&&d.charCodeAt(M-1)===f;)M--;const U=M-p,N=x<U?x:U;let P=-1,W=0;for(;W<N;W++){const Q=r.charCodeAt(_+W);if(Q!==d.charCodeAt(p+W))break;Q===f&&(P=W)}if(W!==N){if(P===-1)return R}else{if(U>N){if(d.charCodeAt(p+W)===f)return R.slice(p+W+1);if(W===2)return R.slice(p+W)}x>N&&(r.charCodeAt(_+W)===f?P=W:W===2&&(P=3)),P===-1&&(P=0)}let ne="";for(W=_+P+1;W<=H;++W)(W===H||r.charCodeAt(W)===f)&&(ne+=ne.length===0?"..":"\\..");return p+=P,ne.length>0?`${ne}${R.slice(p,M)}`:(R.charCodeAt(p)===f&&++p,R.slice(p,M))},toNamespacedPath(r){if(typeof r!="string"||r.length===0)return r;const d=t.$fc.resolve(r);if(d.length<=2)return r;if(d.charCodeAt(0)===f){if(d.charCodeAt(1)===f){const D=d.charCodeAt(2);if(D!==A&&D!==v)return`\\\\?\\UNC\\${d.slice(2)}`}}else if(c(d.charCodeAt(0))&&d.charCodeAt(1)===w&&d.charCodeAt(2)===f)return`\\\\?\\${d}`;return r},dirname(r){e(r,"path");const d=r.length;if(d===0)return".";let D=-1,R=0;const _=r.charCodeAt(0);if(d===1)return o(_)?r:".";if(o(_)){if(D=R=1,o(r.charCodeAt(1))){let p=2,M=p;for(;p<d&&!o(r.charCodeAt(p));)p++;if(p<d&&p!==M){for(M=p;p<d&&o(r.charCodeAt(p));)p++;if(p<d&&p!==M){for(M=p;p<d&&!o(r.charCodeAt(p));)p++;if(p===d)return r;p!==M&&(D=R=p+1)}}}}else c(_)&&r.charCodeAt(1)===w&&(D=d>2&&o(r.charCodeAt(2))?3:2,R=D);let H=-1,x=!0;for(let p=d-1;p>=R;--p)if(o(r.charCodeAt(p))){if(!x){H=p;break}}else x=!1;if(H===-1){if(D===-1)return".";H=D}return r.slice(0,H)},basename(r,d){d!==void 0&&e(d,"ext"),e(r,"path");let D=0,R=-1,_=!0,H;if(r.length>=2&&c(r.charCodeAt(0))&&r.charCodeAt(1)===w&&(D=2),d!==void 0&&d.length>0&&d.length<=r.length){if(d===r)return"";let x=d.length-1,p=-1;for(H=r.length-1;H>=D;--H){const M=r.charCodeAt(H);if(o(M)){if(!_){D=H+1;break}}else p===-1&&(_=!1,p=H+1),x>=0&&(M===d.charCodeAt(x)?--x===-1&&(R=H):(x=-1,R=p))}return D===R?R=p:R===-1&&(R=r.length),r.slice(D,R)}for(H=r.length-1;H>=D;--H)if(o(r.charCodeAt(H))){if(!_){D=H+1;break}}else R===-1&&(_=!1,R=H+1);return R===-1?"":r.slice(D,R)},extname(r){e(r,"path");let d=0,D=-1,R=0,_=-1,H=!0,x=0;r.length>=2&&r.charCodeAt(1)===w&&c(r.charCodeAt(0))&&(d=R=2);for(let p=r.length-1;p>=d;--p){const M=r.charCodeAt(p);if(o(M)){if(!H){R=p+1;break}continue}_===-1&&(H=!1,_=p+1),M===v?D===-1?D=p:x!==1&&(x=1):D!==-1&&(x=-1)}return D===-1||_===-1||x===0||x===1&&D===_-1&&D===R+1?"":r.slice(D,_)},format:k.bind(null,"\\"),parse(r){e(r,"path");const d={root:"",dir:"",base:"",ext:"",name:""};if(r.length===0)return d;const D=r.length;let R=0,_=r.charCodeAt(0);if(D===1)return o(_)?(d.root=d.dir=r,d):(d.base=d.name=r,d);if(o(_)){if(R=1,o(r.charCodeAt(1))){let P=2,W=P;for(;P<D&&!o(r.charCodeAt(P));)P++;if(P<D&&P!==W){for(W=P;P<D&&o(r.charCodeAt(P));)P++;if(P<D&&P!==W){for(W=P;P<D&&!o(r.charCodeAt(P));)P++;P===D?R=P:P!==W&&(R=P+1)}}}}else if(c(_)&&r.charCodeAt(1)===w){if(D<=2)return d.root=d.dir=r,d;if(R=2,o(r.charCodeAt(2))){if(D===3)return d.root=d.dir=r,d;R=3}}R>0&&(d.root=r.slice(0,R));let H=-1,x=R,p=-1,M=!0,U=r.length-1,N=0;for(;U>=R;--U){if(_=r.charCodeAt(U),o(_)){if(!M){x=U+1;break}continue}p===-1&&(M=!1,p=U+1),_===v?H===-1?H=U:N!==1&&(N=1):H!==-1&&(N=-1)}return p!==-1&&(H===-1||N===0||N===1&&H===p-1&&H===x+1?d.base=d.name=r.slice(x,p):(d.name=r.slice(x,H),d.base=r.slice(x,p),d.ext=r.slice(H,p))),x>0&&x!==R?d.dir=r.slice(0,x-1):d.dir=d.root,d},sep:"\\",delimiter:";",win32:null,posix:null};const E=(()=>{if(s){const r=/\\/g;return()=>{const d=i.cwd().replace(r,"/");return d.slice(d.indexOf("/"))}}return()=>i.cwd()})();t.$gc={resolve(...r){let d="",D=!1;for(let R=r.length-1;R>=-1&&!D;R--){const _=R>=0?r[R]:E();e(_,"path"),_.length!==0&&(d=`${_}/${d}`,D=_.charCodeAt(0)===y)}return d=b(d,!D,"/",h),D?`/${d}`:d.length>0?d:"."},normalize(r){if(e(r,"path"),r.length===0)return".";const d=r.charCodeAt(0)===y,D=r.charCodeAt(r.length-1)===y;return r=b(r,!d,"/",h),r.length===0?d?"/":D?"./":".":(D&&(r+="/"),d?`/${r}`:r)},isAbsolute(r){return e(r,"path"),r.length>0&&r.charCodeAt(0)===y},join(...r){if(r.length===0)return".";let d;for(let D=0;D<r.length;++D){const R=r[D];e(R,"path"),R.length>0&&(d===void 0?d=R:d+=`/${R}`)}return d===void 0?".":t.$gc.normalize(d)},relative(r,d){if(e(r,"from"),e(d,"to"),r===d||(r=t.$gc.resolve(r),d=t.$gc.resolve(d),r===d))return"";const D=1,R=r.length,_=R-D,H=1,x=d.length-H,p=_<x?_:x;let M=-1,U=0;for(;U<p;U++){const P=r.charCodeAt(D+U);if(P!==d.charCodeAt(H+U))break;P===y&&(M=U)}if(U===p)if(x>p){if(d.charCodeAt(H+U)===y)return d.slice(H+U+1);if(U===0)return d.slice(H+U)}else _>p&&(r.charCodeAt(D+U)===y?M=U:U===0&&(M=0));let N="";for(U=D+M+1;U<=R;++U)(U===R||r.charCodeAt(U)===y)&&(N+=N.length===0?"..":"/..");return`${N}${d.slice(H+M)}`},toNamespacedPath(r){return r},dirname(r){if(e(r,"path"),r.length===0)return".";const d=r.charCodeAt(0)===y;let D=-1,R=!0;for(let _=r.length-1;_>=1;--_)if(r.charCodeAt(_)===y){if(!R){D=_;break}}else R=!1;return D===-1?d?"/":".":d&&D===1?"//":r.slice(0,D)},basename(r,d){d!==void 0&&e(d,"ext"),e(r,"path");let D=0,R=-1,_=!0,H;if(d!==void 0&&d.length>0&&d.length<=r.length){if(d===r)return"";let x=d.length-1,p=-1;for(H=r.length-1;H>=0;--H){const M=r.charCodeAt(H);if(M===y){if(!_){D=H+1;break}}else p===-1&&(_=!1,p=H+1),x>=0&&(M===d.charCodeAt(x)?--x===-1&&(R=H):(x=-1,R=p))}return D===R?R=p:R===-1&&(R=r.length),r.slice(D,R)}for(H=r.length-1;H>=0;--H)if(r.charCodeAt(H)===y){if(!_){D=H+1;break}}else R===-1&&(_=!1,R=H+1);return R===-1?"":r.slice(D,R)},extname(r){e(r,"path");let d=-1,D=0,R=-1,_=!0,H=0;for(let x=r.length-1;x>=0;--x){const p=r.charCodeAt(x);if(p===y){if(!_){D=x+1;break}continue}R===-1&&(_=!1,R=x+1),p===v?d===-1?d=x:H!==1&&(H=1):d!==-1&&(H=-1)}return d===-1||R===-1||H===0||H===1&&d===R-1&&d===D+1?"":r.slice(d,R)},format:k.bind(null,"/"),parse(r){e(r,"path");const d={root:"",dir:"",base:"",ext:"",name:""};if(r.length===0)return d;const D=r.charCodeAt(0)===y;let R;D?(d.root="/",R=1):R=0;let _=-1,H=0,x=-1,p=!0,M=r.length-1,U=0;for(;M>=R;--M){const N=r.charCodeAt(M);if(N===y){if(!p){H=M+1;break}continue}x===-1&&(p=!1,x=M+1),N===v?_===-1?_=M:U!==1&&(U=1):_!==-1&&(U=-1)}if(x!==-1){const N=H===0&&D?1:H;_===-1||U===0||U===1&&_===x-1&&_===H+1?d.base=d.name=r.slice(N,x):(d.name=r.slice(N,_),d.base=r.slice(N,x),d.ext=r.slice(_,x))}return H>0?d.dir=r.slice(0,H-1):D&&(d.dir="/"),d},sep:"/",delimiter:":",win32:null,posix:null},t.$gc.win32=t.$fc.win32=t.$fc,t.$gc.posix=t.$fc.posix=t.$gc,t.$hc=s?t.$fc.normalize:t.$gc.normalize,t.$ic=s?t.$fc.isAbsolute:t.$gc.isAbsolute,t.$jc=s?t.$fc.join:t.$gc.join,t.$kc=s?t.$fc.resolve:t.$gc.resolve,t.$lc=s?t.$fc.relative:t.$gc.relative,t.$mc=s?t.$fc.dirname:t.$gc.dirname,t.$nc=s?t.$fc.basename:t.$gc.basename,t.$oc=s?t.$fc.extname:t.$gc.extname,t.$pc=s?t.$fc.format:t.$gc.format,t.$qc=s?t.$fc.parse:t.$gc.parse,t.$rc=s?t.$fc.toNamespacedPath:t.$gc.toNamespacedPath,t.sep=s?t.$fc.sep:t.$gc.sep,t.$tc=s?t.$fc.delimiter:t.$gc.delimiter}),define(pe[132],we([1,0,18,28,5,11,10]),function(oe,t,i,n,B,O,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$sg=v,t.$tg=y,t.$ug=f,t.$vg=w,t.$wg=A,t.$xg=s,t.$yg=o,t.$zg=h,t.$Ag=c,t.$Bg=b,t.$Cg=k,t.$Dg=E,t.$Eg=r,t.$Fg=d,t.$Gg=D,t.$Hg=R,t.$Ig=x;function v(p){return p===i.CharCode.Slash||p===i.CharCode.Backslash}function y(p){return p.replace(/[\\/]/g,n.$gc.sep)}function f(p){return p.indexOf("/")===-1&&(p=y(p)),/^[a-zA-Z]:(\/|$)/.test(p)&&(p="/"+p),p}function w(p,M=n.$gc.sep){if(!p)return"";const U=p.length,N=p.charCodeAt(0);if(v(N)){if(v(p.charCodeAt(1))&&!v(p.charCodeAt(2))){let W=3;const ne=W;for(;W<U&&!v(p.charCodeAt(W));W++);if(ne!==W&&!v(p.charCodeAt(W+1))){for(W+=1;W<U;W++)if(v(p.charCodeAt(W)))return p.slice(0,W+1).replace(/[\\/]/g,M)}}return M}else if(c(N)&&p.charCodeAt(1)===i.CharCode.Colon)return v(p.charCodeAt(2))?p.slice(0,2)+M:p.slice(0,2);let P=p.indexOf("://");if(P!==-1){for(P+=3;P<U;P++)if(v(p.charCodeAt(P)))return p.slice(0,P+1)}return""}function A(p){if(!B.$i||!p||p.length<5)return!1;let M=p.charCodeAt(0);if(M!==i.CharCode.Backslash||(M=p.charCodeAt(1),M!==i.CharCode.Backslash))return!1;let U=2;const N=U;for(;U<p.length&&(M=p.charCodeAt(U),M!==i.CharCode.Backslash);U++);return!(N===U||(M=p.charCodeAt(U+1),isNaN(M)||M===i.CharCode.Backslash))}const $=/[\\/:\*\?"<>\|]/g,m=/[/]/g,e=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function s(p,M=B.$i){const U=M?$:m;return!(!p||p.length===0||/^\s+$/.test(p)||(U.lastIndex=0,U.test(p))||M&&e.test(p)||p==="."||p===".."||M&&p[p.length-1]==="."||M&&p.length!==p.trim().length||p.length>255)}function o(p,M,U){const N=p===M;return!U||N?N:!p||!M?!1:(0,O.$Bf)(p,M)}function h(p,M,U,N=n.sep){if(p===M)return!0;if(!p||!M||M.length>p.length)return!1;if(U){if(!(0,O.$Cf)(p,M))return!1;if(M.length===p.length)return!0;let W=M.length;return M.charAt(M.length-1)===N&&W--,p.charAt(W)===N}return M.charAt(M.length-1)!==N&&(M+=N),p.indexOf(M)===0}function c(p){return p>=i.CharCode.A&&p<=i.CharCode.Z||p>=i.CharCode.a&&p<=i.CharCode.z}function b(p,M){return B.$i&&p.endsWith(":")&&(p+=n.sep),(0,n.$ic)(p)||(p=(0,n.$jc)(M,p)),p=(0,n.$hc)(p),k(p)}function k(p){return B.$i?(p=(0,O.$jf)(p,n.sep),p.endsWith(":")&&(p+=n.sep)):(p=(0,O.$jf)(p,n.sep),p||(p=n.sep)),p}function E(p){const M=(0,n.$hc)(p);return B.$i?p.length>3?!1:r(M)&&(p.length===2||M.charCodeAt(2)===i.CharCode.Backslash):M===n.$gc.sep}function r(p,M=B.$i){return M?c(p.charCodeAt(0))&&p.charCodeAt(1)===i.CharCode.Colon:!1}function d(p,M=B.$i){return r(p,M)?p[0]:void 0}function D(p,M,U){return M.length>p.length?-1:p===M?0:(U&&(p=p.toLowerCase(),M=M.toLowerCase()),p.indexOf(M))}function R(p){const M=p.split(":");let U,N,P;for(const W of M){const ne=Number(W);(0,T.$eg)(ne)?N===void 0?N=ne:P===void 0&&(P=ne):U=U?[U,W].join(":"):W}if(!U)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:U,line:N!==void 0?N:void 0,column:P!==void 0?P:N!==void 0?1:void 0}}const _="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",H="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function x(p,M,U=8){let N="";for(let W=0;W<U;W++){let ne;W===0&&B.$i&&!M&&(U===3||U===4)?ne=H:ne=_,N+=ne.charAt(Math.floor(Math.random()*ne.length))}let P;return M?P=`${M}-${N}`:P=N,p?(0,n.$jc)(p,P):P}}),define(pe[133],we([1,0,28]),function(oe,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Ys=void 0,t.$Zs=O,t.$1s=T,t.$2s=v,t.$3s=f,t.$Ys=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const n={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},B={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function O(w){const A=(0,i.$oc)(w),$=n[A.toLowerCase()];return $!==void 0?$:T(w)}function T(w){const A=(0,i.$oc)(w);return B[A.toLowerCase()]}function v(w){for(const A in B)if(B[A]===w)return A}const y=/^(.+)\/(.+?)(;.+)?$/;function f(w,A){const $=y.exec(w);return $?`${$[1].toLowerCase()}/${$[2].toLowerCase()}${$[3]??""}`:A?void 0:w}}),define(pe[17],we([1,0,18,60,28,5]),function(oe,t,i,n,B,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.URI=void 0,t.$vc=o,t.$wc=r;const T=/^\w[\w\d+.-]*$/,v=/^\//,y=/^\/\//;function f(H,x){if(!H.scheme&&x)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${H.authority}", path: "${H.path}", query: "${H.query}", fragment: "${H.fragment}"}`);if(H.scheme&&!T.test(H.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(H.path){if(H.authority){if(!v.test(H.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(y.test(H.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function w(H,x){return!H&&!x?"file":H}function A(H,x){switch(H){case"https":case"http":case"file":x?x[0]!==m&&(x=m+x):x=m;break}return x}const $="",m="/",e=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class s{static isUri(x){return x instanceof s?!0:x?typeof x.authority=="string"&&typeof x.fragment=="string"&&typeof x.path=="string"&&typeof x.query=="string"&&typeof x.scheme=="string"&&typeof x.fsPath=="string"&&typeof x.with=="function"&&typeof x.toString=="function":!1}constructor(x,p,M,U,N,P=!1){typeof x=="object"?(this.scheme=x.scheme||$,this.authority=x.authority||$,this.path=x.path||$,this.query=x.query||$,this.fragment=x.fragment||$):(this.scheme=w(x,P),this.authority=p||$,this.path=A(this.scheme,M||$),this.query=U||$,this.fragment=N||$,f(this,P))}get fsPath(){return r(this,!1)}with(x){if(!x)return this;let{scheme:p,authority:M,path:U,query:N,fragment:P}=x;return p===void 0?p=this.scheme:p===null&&(p=$),M===void 0?M=this.authority:M===null&&(M=$),U===void 0?U=this.path:U===null&&(U=$),N===void 0?N=this.query:N===null&&(N=$),P===void 0?P=this.fragment:P===null&&(P=$),p===this.scheme&&M===this.authority&&U===this.path&&N===this.query&&P===this.fragment?this:new c(p,M,U,N,P)}static parse(x,p=!1){const M=e.exec(x);return M?new c(M[2]||$,_(M[4]||$),_(M[5]||$),_(M[7]||$),_(M[9]||$),p):new c($,$,$,$,$)}static file(x){let p=$;if(O.$i&&(x=x.replace(/\\/g,m)),x[0]===m&&x[1]===m){const M=x.indexOf(m,2);M===-1?(p=x.substring(2),x=m):(p=x.substring(2,M),x=x.substring(M)||m)}return new c("file",p,x,$,$)}static from(x,p){return new c(x.scheme,x.authority,x.path,x.query,x.fragment,p)}static joinPath(x,...p){if(!x.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let M;return O.$i&&x.scheme==="file"?M=s.file(B.$fc.join(r(x,!0),...p)).path:M=B.$gc.join(x.path,...p),x.with({path:M})}toString(x=!1){return d(this,x)}toJSON(){return this}static revive(x){if(x){if(x instanceof s)return x;{const p=new c(x);return p._formatted=x.external??null,p._fsPath=x._sep===h?x.fsPath??null:null,p}}else return x}}t.URI=s;function o(H){return!H||typeof H!="object"?!1:typeof H.scheme=="string"&&(typeof H.authority=="string"||typeof H.authority>"u")&&(typeof H.path=="string"||typeof H.path>"u")&&(typeof H.query=="string"||typeof H.query>"u")&&(typeof H.fragment=="string"||typeof H.fragment>"u")}const h=O.$i?1:void 0;class c extends s{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=r(this,!1)),this._fsPath}toString(x=!1){return x?d(this,!0):(this._formatted||(this._formatted=d(this,!1)),this._formatted)}toJSON(){const x={$mid:n.MarshalledId.Uri};return this._fsPath&&(x.fsPath=this._fsPath,x._sep=h),this._formatted&&(x.external=this._formatted),this.path&&(x.path=this.path),this.scheme&&(x.scheme=this.scheme),this.authority&&(x.authority=this.authority),this.query&&(x.query=this.query),this.fragment&&(x.fragment=this.fragment),x}}const b={[i.CharCode.Colon]:"%3A",[i.CharCode.Slash]:"%2F",[i.CharCode.QuestionMark]:"%3F",[i.CharCode.Hash]:"%23",[i.CharCode.OpenSquareBracket]:"%5B",[i.CharCode.CloseSquareBracket]:"%5D",[i.CharCode.AtSign]:"%40",[i.CharCode.ExclamationMark]:"%21",[i.CharCode.DollarSign]:"%24",[i.CharCode.Ampersand]:"%26",[i.CharCode.SingleQuote]:"%27",[i.CharCode.OpenParen]:"%28",[i.CharCode.CloseParen]:"%29",[i.CharCode.Asterisk]:"%2A",[i.CharCode.Plus]:"%2B",[i.CharCode.Comma]:"%2C",[i.CharCode.Semicolon]:"%3B",[i.CharCode.Equals]:"%3D",[i.CharCode.Space]:"%20"};function k(H,x,p){let M,U=-1;for(let N=0;N<H.length;N++){const P=H.charCodeAt(N);if(P>=i.CharCode.a&&P<=i.CharCode.z||P>=i.CharCode.A&&P<=i.CharCode.Z||P>=i.CharCode.Digit0&&P<=i.CharCode.Digit9||P===i.CharCode.Dash||P===i.CharCode.Period||P===i.CharCode.Underline||P===i.CharCode.Tilde||x&&P===i.CharCode.Slash||p&&P===i.CharCode.OpenSquareBracket||p&&P===i.CharCode.CloseSquareBracket||p&&P===i.CharCode.Colon)U!==-1&&(M+=encodeURIComponent(H.substring(U,N)),U=-1),M!==void 0&&(M+=H.charAt(N));else{M===void 0&&(M=H.substr(0,N));const W=b[P];W!==void 0?(U!==-1&&(M+=encodeURIComponent(H.substring(U,N)),U=-1),M+=W):U===-1&&(U=N)}}return U!==-1&&(M+=encodeURIComponent(H.substring(U))),M!==void 0?M:H}function E(H){let x;for(let p=0;p<H.length;p++){const M=H.charCodeAt(p);M===i.CharCode.Hash||M===i.CharCode.QuestionMark?(x===void 0&&(x=H.substr(0,p)),x+=b[M]):x!==void 0&&(x+=H[p])}return x!==void 0?x:H}function r(H,x){let p;return H.authority&&H.path.length>1&&H.scheme==="file"?p=`//${H.authority}${H.path}`:H.path.charCodeAt(0)===i.CharCode.Slash&&(H.path.charCodeAt(1)>=i.CharCode.A&&H.path.charCodeAt(1)<=i.CharCode.Z||H.path.charCodeAt(1)>=i.CharCode.a&&H.path.charCodeAt(1)<=i.CharCode.z)&&H.path.charCodeAt(2)===i.CharCode.Colon?x?p=H.path.substr(1):p=H.path[1].toLowerCase()+H.path.substr(2):p=H.path,O.$i&&(p=p.replace(/\//g,"\\")),p}function d(H,x){const p=x?E:k;let M="",{scheme:U,authority:N,path:P,query:W,fragment:ne}=H;if(U&&(M+=U,M+=":"),(N||U==="file")&&(M+=m,M+=m),N){let Q=N.indexOf("@");if(Q!==-1){const Y=N.substr(0,Q);N=N.substr(Q+1),Q=Y.lastIndexOf(":"),Q===-1?M+=p(Y,!1,!1):(M+=p(Y.substr(0,Q),!1,!1),M+=":",M+=p(Y.substr(Q+1),!1,!0)),M+="@"}N=N.toLowerCase(),Q=N.lastIndexOf(":"),Q===-1?M+=p(N,!1,!0):(M+=p(N.substr(0,Q),!1,!0),M+=N.substr(Q))}if(P){if(P.length>=3&&P.charCodeAt(0)===i.CharCode.Slash&&P.charCodeAt(2)===i.CharCode.Colon){const Q=P.charCodeAt(1);Q>=i.CharCode.A&&Q<=i.CharCode.Z&&(P=`/${String.fromCharCode(Q+32)}:${P.substr(3)}`)}else if(P.length>=2&&P.charCodeAt(1)===i.CharCode.Colon){const Q=P.charCodeAt(0);Q>=i.CharCode.A&&Q<=i.CharCode.Z&&(P=`${String.fromCharCode(Q+32)}:${P.substr(2)}`)}M+=p(P,!0,!1)}return W&&(M+="?",M+=p(W,!1,!1)),ne&&(M+="#",M+=x?ne:k(ne,!1,!1)),M}function D(H){try{return decodeURIComponent(H)}catch{return H.length>3?H.substr(0,3)+D(H.substr(3)):H}}const R=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function _(H){return H.match(R)?H.replace(R,x=>D(x)):H}}),define(pe[69],we([1,0,48,17,60]),function(oe,t,i,n,B){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$8h=O,t.$9h=T,t.$0h=y;function O(f){return JSON.stringify(f,v)}function T(f){let w=JSON.parse(f);return w=y(w),w}function v(f,w){return w instanceof RegExp?{$mid:B.MarshalledId.Regexp,source:w.source,flags:w.flags}:w}function y(f,w=0){if(!f||w>200)return f;if(typeof f=="object"){switch(f.$mid){case B.MarshalledId.Uri:return n.URI.revive(f);case B.MarshalledId.Regexp:return new RegExp(f.source,f.flags);case B.MarshalledId.Date:return new Date(f.source)}if(f instanceof i.$Je||f instanceof Uint8Array)return f;if(Array.isArray(f))for(let A=0;A<f.length;++A)f[A]=y(f[A],w+1);else for(const A in f)Object.hasOwnProperty.call(f,A)&&(f[A]=y(f[A],w+1))}return f}}),define(pe[39],we([1,0,6,5,11,17,28]),function(oe,t,i,n,B,O,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.COI=t.$Ug=t.$Tg=t.$Sg=t.$Rg=t.$Qg=t.$Pg=t.$Ng=t.$Mg=t.$Lg=t.Schemas=void 0,t.$Jg=y,t.$Kg=f,t.$Og=A;var v;(function(e){e.inMemory="inmemory",e.vscode="vscode",e.internal="private",e.walkThrough="walkThrough",e.walkThroughSnippet="walkThroughSnippet",e.http="http",e.https="https",e.file="file",e.mailto="mailto",e.untitled="untitled",e.data="data",e.command="command",e.vscodeRemote="vscode-remote",e.vscodeRemoteResource="vscode-remote-resource",e.vscodeManagedRemoteResource="vscode-managed-remote-resource",e.vscodeUserData="vscode-userdata",e.vscodeCustomEditor="vscode-custom-editor",e.vscodeNotebookCell="vscode-notebook-cell",e.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",e.vscodeNotebookCellOutput="vscode-notebook-cell-output",e.vscodeInteractiveInput="vscode-interactive-input",e.vscodeSettings="vscode-settings",e.vscodeWorkspaceTrust="vscode-workspace-trust",e.vscodeTerminal="vscode-terminal",e.vscodeChatCodeBlock="vscode-chat-code-block",e.vscodeChatCodeCompareBlock="vscode-chat-code-compare-block",e.vscodeChatSesssion="vscode-chat-editor",e.webviewPanel="webview-panel",e.vscodeWebview="vscode-webview",e.extension="extension",e.vscodeFileResource="vscode-file",e.tmp="tmp",e.vsls="vsls",e.vscodeSourceControl="vscode-scm",e.commentsInput="comment",e.codeSetting="code-setting"})(v||(t.Schemas=v={}));function y(e,s){return O.URI.isUri(e)?(0,B.$Bf)(e.scheme,s):(0,B.$Cf)(e,s+":")}function f(e,...s){return s.some(o=>y(e,o))}t.$Lg="vscode-tkn",t.$Mg="tkn";class w{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f="/"}setPreferredWebSchema(s){this.d=s}setDelegate(s){this.e=s}setServerRootPath(s,o){this.f=A(s,o)}getServerRootPath(){return this.f}get g(){return T.$gc.join(this.f,v.vscodeRemoteResource)}set(s,o,h){this.a[s]=o,this.b[s]=h}setConnectionToken(s,o){this.c[s]=o}getPreferredWebSchema(){return this.d}rewrite(s){if(this.e)try{return this.e(s)}catch(E){return i.$1(E),s}const o=s.authority;let h=this.a[o];h&&h.indexOf(":")!==-1&&h.indexOf("[")===-1&&(h=`[${h}]`);const c=this.b[o],b=this.c[o];let k=`path=${encodeURIComponent(s.path)}`;return typeof b=="string"&&(k+=`&${t.$Mg}=${encodeURIComponent(b)}`),O.URI.from({scheme:n.$o?this.d:v.vscodeRemoteResource,authority:`${h}:${c}`,path:this.g,query:k})}}t.$Ng=new w;function A(e,s){return T.$gc.join(s??"/",`${e.quality??"oss"}-${e.commit??"dev"}`)}t.$Pg="vs/../../extensions",t.$Qg="vs/../../node_modules",t.$Rg="vs/../../node_modules.asar",t.$Sg="vs/../../node_modules.asar.unpacked",t.$Tg="vscode-app";class ${static{this.a=t.$Tg}asBrowserUri(s){const o=this.b(s,oe);return this.uriToBrowserUri(o)}uriToBrowserUri(s){return s.scheme===v.vscodeRemote?t.$Ng.rewrite(s):s.scheme===v.file&&(n.$m||n.$q===`${v.vscodeFileResource}://${$.a}`)?s.with({scheme:v.vscodeFileResource,authority:s.authority||$.a,query:null,fragment:null}):s}asFileUri(s){const o=this.b(s,oe);return this.uriToFileUri(o)}uriToFileUri(s){return s.scheme===v.vscodeFileResource?s.with({scheme:v.file,authority:s.authority!==$.a?s.authority:null,query:null,fragment:null}):s}b(s,o){return O.URI.isUri(s)?s:O.URI.parse(o.toUrl(s))}}t.$Ug=new $;var m;(function(e){const s=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);e.CoopAndCoep=Object.freeze(s.get("3"));const o="vscode-coi";function h(b){let k;typeof b=="string"?k=new URL(b).searchParams:b instanceof URL?k=b.searchParams:O.URI.isUri(b)&&(k=new URL(b.toString(!0)).searchParams);const E=k?.get(o);if(E)return s.get(E)}e.getHeadersFromQuery=h;function c(b,k,E){if(!globalThis.crossOriginIsolated)return;const r=k&&E?"3":E?"2":"1";b instanceof URLSearchParams?b.set(o,r):b[o]=r}e.addSearchParam=c})(m||(t.COI=m={}))}),define(pe[52],we([1,0,18,132,39,28,5,11,17]),function(oe,t,i,n,B,O,T,v,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DataUri=t.$jh=t.$ih=t.$hh=t.$gh=t.$fh=t.$eh=t.$dh=t.$ch=t.$bh=t.$ah=t.$_g=t.$$g=t.$0g=t.$9g=t.$8g=t.$7g=t.$6g=t.$5g=t.$4g=t.$3g=void 0,t.$2g=f,t.$kh=A,t.$lh=m;function f(e){return(0,y.$wc)(e,!0)}class w{constructor(s){this.a=s}compare(s,o,h=!1){return s===o?0:(0,v.$uf)(this.getComparisonKey(s,h),this.getComparisonKey(o,h))}isEqual(s,o,h=!1){return s===o?!0:!s||!o?!1:this.getComparisonKey(s,h)===this.getComparisonKey(o,h)}getComparisonKey(s,o=!1){return s.with({path:this.a(s)?s.path.toLowerCase():void 0,fragment:o?null:void 0}).toString()}ignorePathCasing(s){return this.a(s)}isEqualOrParent(s,o,h=!1){if(s.scheme===o.scheme){if(s.scheme===B.Schemas.file)return n.$zg(f(s),f(o),this.a(s))&&s.query===o.query&&(h||s.fragment===o.fragment);if((0,t.$gh)(s.authority,o.authority))return n.$zg(s.path,o.path,this.a(s),"/")&&s.query===o.query&&(h||s.fragment===o.fragment)}return!1}joinPath(s,...o){return y.URI.joinPath(s,...o)}basenameOrAuthority(s){return(0,t.$$g)(s)||s.authority}basename(s){return O.$gc.basename(s.path)}extname(s){return O.$gc.extname(s.path)}dirname(s){if(s.path.length===0)return s;let o;return s.scheme===B.Schemas.file?o=y.URI.file(O.$mc(f(s))).path:(o=O.$gc.dirname(s.path),s.authority&&o.length&&o.charCodeAt(0)!==i.CharCode.Slash&&(console.error(`dirname("${s.toString})) resulted in a relative path`),o="/")),s.with({path:o})}normalizePath(s){if(!s.path.length)return s;let o;return s.scheme===B.Schemas.file?o=y.URI.file(O.$hc(f(s))).path:o=O.$gc.normalize(s.path),s.with({path:o})}relativePath(s,o){if(s.scheme!==o.scheme||!(0,t.$gh)(s.authority,o.authority))return;if(s.scheme===B.Schemas.file){const b=O.$lc(f(s),f(o));return T.$i?n.$tg(b):b}let h=s.path||"/";const c=o.path||"/";if(this.a(s)){let b=0;for(const k=Math.min(h.length,c.length);b<k&&!(h.charCodeAt(b)!==c.charCodeAt(b)&&h.charAt(b).toLowerCase()!==c.charAt(b).toLowerCase());b++);h=c.substr(0,b)+h.substr(b)}return O.$gc.relative(h,c)}resolvePath(s,o){if(s.scheme===B.Schemas.file){const h=y.URI.file(O.$kc(f(s),o));return s.with({authority:h.authority,path:h.path})}return o=n.$ug(o),s.with({path:O.$gc.resolve(s.path,o)})}isAbsolutePath(s){return!!s.path&&s.path[0]==="/"}isEqualAuthority(s,o){return s===o||s!==void 0&&o!==void 0&&(0,v.$Bf)(s,o)}hasTrailingPathSeparator(s,o=O.sep){if(s.scheme===B.Schemas.file){const h=f(s);return h.length>n.$vg(h).length&&h[h.length-1]===o}else{const h=s.path;return h.length>1&&h.charCodeAt(h.length-1)===i.CharCode.Slash&&!/^[a-zA-Z]:(\/$|\\$)/.test(s.fsPath)}}removeTrailingPathSeparator(s,o=O.sep){return(0,t.$hh)(s,o)?s.with({path:s.path.substr(0,s.path.length-1)}):s}addTrailingPathSeparator(s,o=O.sep){let h=!1;if(s.scheme===B.Schemas.file){const c=f(s);h=c!==void 0&&c.length===n.$vg(c).length&&c[c.length-1]===o}else{o="/";const c=s.path;h=c.length===1&&c.charCodeAt(c.length-1)===i.CharCode.Slash}return!h&&!(0,t.$hh)(s,o)?s.with({path:s.path+"/"}):s}}t.$3g=w,t.$4g=new w(()=>!1),t.$5g=new w(e=>e.scheme===B.Schemas.file?!T.$k:!0),t.$6g=new w(e=>!0),t.$7g=t.$4g.isEqual.bind(t.$4g),t.$8g=t.$4g.isEqualOrParent.bind(t.$4g),t.$9g=t.$4g.getComparisonKey.bind(t.$4g),t.$0g=t.$4g.basenameOrAuthority.bind(t.$4g),t.$$g=t.$4g.basename.bind(t.$4g),t.$_g=t.$4g.extname.bind(t.$4g),t.$ah=t.$4g.dirname.bind(t.$4g),t.$bh=t.$4g.joinPath.bind(t.$4g),t.$ch=t.$4g.normalizePath.bind(t.$4g),t.$dh=t.$4g.relativePath.bind(t.$4g),t.$eh=t.$4g.resolvePath.bind(t.$4g),t.$fh=t.$4g.isAbsolutePath.bind(t.$4g),t.$gh=t.$4g.isEqualAuthority.bind(t.$4g),t.$hh=t.$4g.hasTrailingPathSeparator.bind(t.$4g),t.$ih=t.$4g.removeTrailingPathSeparator.bind(t.$4g),t.$jh=t.$4g.addTrailingPathSeparator.bind(t.$4g);function A(e,s){const o=[];for(let h=0;h<e.length;h++){const c=s(e[h]);e.some((b,k)=>k===h?!1:(0,t.$8g)(c,s(b)))||o.push(e[h])}return o}var $;(function(e){e.META_DATA_LABEL="label",e.META_DATA_DESCRIPTION="description",e.META_DATA_SIZE="size",e.META_DATA_MIME="mime";function s(o){const h=new Map;o.path.substring(o.path.indexOf(";")+1,o.path.lastIndexOf(";")).split(";").forEach(k=>{const[E,r]=k.split(":");E&&r&&h.set(E,r)});const b=o.path.substring(0,o.path.indexOf(";"));return b&&h.set(e.META_DATA_MIME,b),h}e.parseMetaData=s})($||(t.DataUri=$={}));function m(e,s,o){if(s){let h=e.path;return h&&h[0]!==O.$gc.sep&&(h=O.$gc.sep+h),e.with({scheme:o,authority:s,path:h})}return e.with({scheme:o})}}),define(pe[12],we([1,0,37,6,3,2,52,5,62,26]),function(oe,t,i,n,B,O,T,v,y,f){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$4h=t.$2h=t.$1h=t.$Zh=t.$Yh=t.Promises=t.$Xh=t.$Wh=t.$Vh=t.$Th=t.$Sh=t.$Rh=t.$Qh=t.$Ph=t.$Oh=t.$Nh=t.$Mh=t.$Lh=t.$Kh=t.$Jh=t.$Ih=t.$Hh=t.$Gh=t.$Ah=t.$zh=t.$yh=t.$xh=t.$wh=t.$vh=t.$uh=void 0,t.$mh=w,t.$nh=A,t.$oh=$,t.$ph=m,t.$qh=e,t.$rh=s,t.$sh=o,t.$th=h,t.$Bh=H,t.$Ch=x,t.$Dh=p,t.$Eh=M,t.$Fh=U,t.$Uh=J,t.$3h=K;function w(a){return!!a&&typeof a.then=="function"}function A(a){const l=new i.$se,g=a(l.token),I=new Promise((F,u)=>{const L=l.token.onCancellationRequested(()=>{L.dispose(),u(new n.$5)});Promise.resolve(g).then(S=>{L.dispose(),l.dispose(),F(S)},S=>{L.dispose(),l.dispose(),u(S)})});return new class{cancel(){l.cancel(),l.dispose()}then(F,u){return I.then(F,u)}catch(F){return this.then(void 0,F)}finally(F){return I.finally(F)}}}function $(a,l,g){return new Promise((I,F)=>{const u=l.onCancellationRequested(()=>{u.dispose(),I(g)});a.then(I,F).finally(()=>u.dispose())})}function m(a,l){return new Promise((g,I)=>{const F=l.onCancellationRequested(()=>{F.dispose(),I(new n.$5)});a.then(g,I).finally(()=>F.dispose())})}async function e(a){let l=-1;const g=a.map((I,F)=>I.then(u=>(l=F,u)));try{return await Promise.race(g)}finally{a.forEach((I,F)=>{F!==l&&I.cancel()})}}function s(a,l,g){let I;const F=setTimeout(()=>{I?.(void 0),g?.()},l);return Promise.race([a.finally(()=>clearTimeout(F)),new Promise(u=>I=u)])}function o(a){return new Promise((l,g)=>{const I=a();w(I)?I.then(l,g):l(I)})}function h(){let a,l;return{promise:new Promise((I,F)=>{a=I,l=F}),resolve:a,reject:l}}class c{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(l){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=l,!this.b){const g=()=>{if(this.b=null,this.f)return;const I=this.queue(this.d);return this.d=null,I};this.b=new Promise(I=>{this.a.then(g,g).then(I)})}return new Promise((g,I)=>{this.b.then(g,I)})}return this.a=l(),new Promise((g,I)=>{this.a.then(F=>{this.a=null,g(F)},F=>{this.a=null,I(F)})})}dispose(){this.f=!0}}t.$uh=c;class b{constructor(){this.a=Promise.resolve(null)}queue(l){return this.a=this.a.then(()=>l(),()=>l())}}t.$vh=b;class k{constructor(){this.a=new Map}queue(l,g){const F=(this.a.get(l)??Promise.resolve()).catch(()=>{}).then(g).finally(()=>{this.a.get(l)===F&&this.a.delete(l)});return this.a.set(l,F),F}}t.$wh=k;const E=(a,l)=>{let g=!0;const I=setTimeout(()=>{g=!1,l()},a);return{isTriggered:()=>g,dispose:()=>{clearTimeout(I),g=!1}}},r=a=>{let l=!0;return queueMicrotask(()=>{l&&(l=!1,a())}),{isTriggered:()=>l,dispose:()=>{l=!1}}};class d{constructor(l){this.defaultDelay=l,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(l,g=this.defaultDelay){this.g=l,this.h(),this.b||(this.b=new Promise((F,u)=>{this.d=F,this.f=u}).then(()=>{if(this.b=null,this.d=null,this.g){const F=this.g;return this.g=null,F()}}));const I=()=>{this.a=null,this.d?.(null)};return this.a=g===y.$ce?r(I):E(g,I),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new n.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}t.$xh=d;class D{constructor(l){this.a=new d(l),this.b=new c}trigger(l,g){return this.a.trigger(()=>this.b.queue(l),g)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}t.$yh=D;class R{constructor(){this.a=!1,this.b=new Promise((l,g)=>{this.d=l})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}t.$zh=R;class _ extends R{constructor(l){super(),this.f=setTimeout(()=>this.open(),l)}open(){clearTimeout(this.f),super.open()}}t.$Ah=_;function H(a,l){return l?new Promise((g,I)=>{const F=setTimeout(()=>{u.dispose(),g()},a),u=l.onCancellationRequested(()=>{clearTimeout(F),u.dispose(),I(new n.$5)})}):A(g=>H(a,g))}function x(a,l=0,g){const I=setTimeout(()=>{a(),g&&F.dispose()},l),F=(0,O.$Sc)(()=>{clearTimeout(I),g?.deleteAndLeak(F)});return g?.add(F),F}function p(a){const l=[];let g=0;const I=a.length;function F(){return g<I?a[g++]():null}function u(L){L!=null&&l.push(L);const S=F();return S?S.then(u):Promise.resolve(l)}return Promise.resolve(null).then(u)}function M(a,l=I=>!!I,g=null){let I=0;const F=a.length,u=()=>{if(I>=F)return Promise.resolve(g);const L=a[I++];return Promise.resolve(L()).then(j=>l(j)?Promise.resolve(j):u())};return u()}function U(a,l=I=>!!I,g=null){if(a.length===0)return Promise.resolve(g);let I=a.length;const F=()=>{I=-1;for(const u of a)u.cancel?.()};return new Promise((u,L)=>{for(const S of a)S.then(j=>{--I>=0&&l(j)?(F(),u(j)):I===0&&u(g)}).catch(j=>{--I>=0&&(F(),L(j))})})}class N{constructor(l){this.a=0,this.b=!1,this.f=l,this.g=[],this.d=0,this.h=new B.$he}whenIdle(){return this.size>0?B.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(l){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((g,I)=>{this.g.push({factory:l,c:g,e:I}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const l=this.g.shift();this.d++;const g=l.factory();g.then(l.c,l.e),g.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}t.$Gh=N;class P extends N{constructor(){super(1)}}t.$Hh=P;class W{constructor(){this.a=new fe,this.b=0}queue(l){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,l())):this.a.run(this.b++,l())}}t.$Ih=W;class ne{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const l=new Z;return this.b.add(l),l.p}g(){for(const[,l]of this.a)if(l.size>0)return!1;return!0}queueSize(l,g=T.$4g){const I=g.getComparisonKey(l);return this.a.get(I)?.size??0}queueFor(l,g,I=T.$4g){const F=I.getComparisonKey(l);let u=this.a.get(F);if(!u){u=new P;const L=this.f++,S=B.Event.once(u.onDrained)(()=>{u?.dispose(),this.a.delete(F),this.h(),this.d?.deleteAndDispose(L),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new O.$4c),this.d.set(L,S),this.a.set(F,u)}return u.queue(g)}h(){this.g()&&this.j()}j(){for(const l of this.b)l.complete();this.b.clear()}dispose(){for(const[,l]of this.a)l.dispose();this.a.clear(),this.j(),this.d?.dispose()}}t.$Jh=ne;class Q{constructor(l,g){this.b=!1,this.a=-1,typeof l=="function"&&typeof g=="number"&&this.setIfNotSet(l,g)}dispose(){this.cancel(),this.b=!0}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(l,g){if(this.b)throw new n.$cb("Calling 'cancelAndSet' on a disposed TimeoutTimer");this.cancel(),this.a=setTimeout(()=>{this.a=-1,l()},g)}setIfNotSet(l,g){if(this.b)throw new n.$cb("Calling 'setIfNotSet' on a disposed TimeoutTimer");this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,l()},g))}}t.$Kh=Q;class Y{constructor(){this.d=void 0,this.f=!1}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(l,g,I=globalThis){if(this.f)throw new n.$cb("Calling 'cancelAndSet' on a disposed IntervalTimer");this.cancel();const F=I.setInterval(()=>{l()},g);this.d=(0,O.$Sc)(()=>{I.clearInterval(F),this.d=void 0})}dispose(){this.cancel(),this.f=!0}}t.$Lh=Y;class te{constructor(l,g){this.b=-1,this.a=l,this.d=g,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(l=this.d){this.cancel(),this.b=setTimeout(this.f,l)}get delay(){return this.d}set delay(l){this.d=l}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}t.$Mh=te;class de{constructor(l,g){g%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${g}ms is not a multiple of 1000ms.`),this.a=l,this.b=g,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(l=this.b){l%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${l}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(l/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}t.$Nh=de;class De extends te{constructor(l,g){super(l,g),this.j=[]}work(l){this.j.push(l),this.isScheduled()||this.schedule()}h(){const l=this.j;this.j=[],this.a?.(l)}dispose(){this.j=[],super.dispose()}}t.$Oh=De;class Le extends O.$Uc{constructor(l,g){super(),this.g=l,this.h=g,this.a=[],this.b=this.B(new O.$Vc),this.f=!1}get pending(){return this.a.length}work(l){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+l.length>this.g.maxBufferedWork)return!1}else if(this.pending+l.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const g of l)this.a.push(g);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new te(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}t.$Ph=Le,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?t.$Rh=(a,l)=>{(0,v.$B)(()=>{if(g)return;const I=Date.now()+15;l(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,I-Date.now())}}))});let g=!1;return{dispose(){g||(g=!0)}}}:t.$Rh=(a,l,g)=>{const I=a.requestIdleCallback(l,typeof g=="number"?{timeout:g}:void 0);let F=!1;return{dispose(){F||(F=!0,a.cancelIdleCallback(I))}}},t.$Qh=a=>(0,t.$Rh)(globalThis,a)}();class Se{constructor(l,g){this.g=!1,this.d=()=>{try{this.j=g()}catch(I){this.l=I}finally{this.g=!0}},this.f=(0,t.$Rh)(l,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}t.$Sh=Se;class ue extends Se{constructor(l){super(globalThis,l)}}t.$Th=ue;async function J(a,l,g){let I;for(let F=0;F<g;F++)try{return await a()}catch(u){I=u,await H(l)}throw I}class fe{isRunning(l){return typeof l=="number"?this.a?.taskId===l:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(l,g,I){return this.a={taskId:l,cancel:()=>I?.(),promise:g},g.then(()=>this.d(l),()=>this.d(l)),g}d(l){this.a&&l===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const l=this.b;this.b=void 0,l.run().then(l.promiseResolve,l.promiseReject)}}queue(l){if(this.b)this.b.run=l;else{const{promise:g,resolve:I,reject:F}=h();this.b={run:l,promise:g,promiseResolve:I,promiseReject:F}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}t.$Vh=fe;class le{constructor(l,g=()=>Date.now()){this.d=l,this.f=g,this.a=0,this.b=0}increment(){const l=this.f();return l-this.a>this.d&&(this.a=l,this.b=0),this.b++,this.b}}t.$Wh=le;var ke;(function(a){a[a.Resolved=0]="Resolved",a[a.Rejected=1]="Rejected"})(ke||(ke={}));class Z{get isRejected(){return this.d?.outcome===ke.Rejected}get isResolved(){return this.d?.outcome===ke.Resolved}get isSettled(){return!!this.d}get value(){return this.d?.outcome===ke.Resolved?this.d?.value:void 0}constructor(){this.p=new Promise((l,g)=>{this.a=l,this.b=g})}complete(l){return new Promise(g=>{this.a(l),this.d={outcome:ke.Resolved,value:l},g()})}error(l){return new Promise(g=>{this.b(l),this.d={outcome:ke.Rejected,value:l},g()})}cancel(){return this.error(new n.$5)}}t.$Xh=Z;var me;(function(a){async function l(I){let F;const u=await Promise.all(I.map(L=>L.then(S=>S,S=>{F||(F=S)})));if(typeof F<"u")throw F;return u}a.settled=l;function g(I){return new Promise(async(F,u)=>{try{await I(F,u)}catch(L){u(L)}})}a.withAsyncBody=g})(me||(t.Promises=me={}));class ye{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(l){this.a=void 0,this.b=void 0,this.d=!1,this.promise=l.then(g=>(this.a=g,this.d=!0,g),g=>{throw this.b=g,this.d=!0,g})}requireValue(){if(!this.d)throw new n.$cb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}t.$Yh=ye;class Oe{constructor(l){this.b=l,this.a=new f.$V(()=>new ye(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}t.$Zh=Oe;var Ie;(function(a){a[a.Initial=0]="Initial",a[a.DoneOK=1]="DoneOK",a[a.DoneError=2]="DoneError"})(Ie||(Ie={}));class je{static fromArray(l){return new je(g=>{g.emitMany(l)})}static fromPromise(l){return new je(async g=>{g.emitMany(await l)})}static fromPromises(l){return new je(async g=>{await Promise.all(l.map(async I=>g.emitOne(await I)))})}static merge(l){return new je(async g=>{await Promise.all(l.map(async I=>{for await(const F of I)g.emitOne(F)}))})}static{this.EMPTY=je.fromArray([])}constructor(l,g){this.a=Ie.Initial,this.b=[],this.d=null,this.f=g,this.g=new B.$he,queueMicrotask(async()=>{const I={emitOne:F=>this.h(F),emitMany:F=>this.j(F),reject:F=>this.l(F)};try{await Promise.resolve(l(I)),this.k()}catch(F){this.l(F)}finally{I.emitOne=void 0,I.emitMany=void 0,I.reject=void 0}})}[Symbol.asyncIterator](){let l=0;return{next:async()=>{do{if(this.a===Ie.DoneError)throw this.d;if(l<this.b.length)return{done:!1,value:this.b[l++]};if(this.a===Ie.DoneOK)return{done:!0,value:void 0};await B.Event.toPromise(this.g.event)}while(!0)},return:async()=>(this.f?.(),{done:!0,value:void 0})}}static map(l,g){return new je(async I=>{for await(const F of l)I.emitOne(g(F))})}map(l){return je.map(this,l)}static filter(l,g){return new je(async I=>{for await(const F of l)g(F)&&I.emitOne(F)})}filter(l){return je.filter(this,l)}static coalesce(l){return je.filter(l,g=>!!g)}coalesce(){return je.coalesce(this)}static async toPromise(l){const g=[];for await(const I of l)g.push(I);return g}toPromise(){return je.toPromise(this)}h(l){this.a===Ie.Initial&&(this.b.push(l),this.g.fire())}j(l){this.a===Ie.Initial&&(this.b=this.b.concat(l),this.g.fire())}k(){this.a===Ie.Initial&&(this.a=Ie.DoneOK,this.g.fire())}l(l){this.a===Ie.Initial&&(this.a=Ie.DoneError,this.d=l,this.g.fire())}}t.$1h=je;class ie extends je{constructor(l,g){super(g),this.m=l}cancel(){this.m.cancel()}}t.$2h=ie;function K(a){const l=new i.$se,g=a(l.token);return new ie(l,async I=>{const F=l.token.onCancellationRequested(()=>{F.dispose(),l.dispose(),I.reject(new n.$5)});try{for await(const u of g){if(l.token.isCancellationRequested)return;I.emitOne(u)}F.dispose(),l.dispose()}catch(u){F.dispose(),l.dispose(),I.reject(u)}})}class C{constructor(l){this.a=new Z,this.b=new je(F=>{if(g){F.reject(g);return}return I&&F.emitMany(I),this.d=u=>F.reject(u),this.f=u=>F.emitOne(u),this.a.p},l);let g,I;this.f=F=>{I||(I=[]),I.push(F)},this.d=F=>{g||(g=F)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(l){this.d(l),this.a.complete()}emitOne(l){this.f(l)}}t.$4h=C}),define(pe[4],we([1,0,19,68,16,23,12,6,3,134,8,2,39,5,17,65,25]),function(oe,t,i,n,B,O,T,v,y,f,w,A,$,m,e,s,o){"use strict";var h;Object.defineProperty(t,"__esModule",{value:!0}),t.$PS=t.$NS=t.$KS=t.DetectedFullscreenMode=t.Namespace=t.$iS=t.$gS=t.$0R=t.$FR=t.$zR=t.$xR=t.$wR=t.$vR=t.$qR=t.$pR=t.$oR=t.onDidUnregisterWindow=t.onWillUnregisterWindow=t.onDidRegisterWindow=t.hasWindow=t.getWindowById=t.getWindowId=t.getWindowsCount=t.getWindows=t.getDocument=t.getWindow=t.registerWindow=void 0,t.$mR=c,t.$nR=k,t.$rR=_,t.$sR=H,t.$tR=x,t.$uR=p,t.$yR=U,t.$AR=W,t.$BR=ne,t.$CR=de,t.$DR=De,t.$ER=Le,t.$GR=J,t.$HR=fe,t.$IR=le,t.$JR=ke,t.$KR=Z,t.$LR=me,t.$MR=ye,t.$NR=Oe,t.$OR=Ie,t.$PR=je,t.$QR=K,t.$RR=C,t.$SR=l,t.$TR=I,t.$UR=F,t.$VR=u,t.$WR=L,t.$XR=S,t.$YR=j,t.$ZR=z,t.$1R=q,t.$2R=ee,t.$3R=re,t.$4R=ce,t.$5R=Ee,t.$6R=Re,t.$7R=Te,t.$8R=Fe,t.$9R=xe,t.$$R=et,t.$_R=ot,t.$aS=ae,t.$bS=$e,t.$cS=Pe,t.$dS=He,t.$eS=Qe,t.$fS=rt,t.$hS=tt,t.$jS=ut,t.$kS=nt,t.$lS=ht,t.$mS=pt,t.$nS=Ce,t.$oS=ge,t.$pS=Me,t.$=ct,t.$rS=Ze,t.$sS=mt,t.$tS=vt,t.$uS=At,t.$vS=Ai,t.$wS=Si,t.$xS=Ti,t.$yS=ki,t.$zS=Ri,t.$AS=Ni,t.$BS=Li,t.$CS=Fi,t.$DS=Ii,t.$ES=Oi,t.$FS=Zt,t.$GS=Mi,t.$HS=Pi,t.$IS=Bi,t.$JS=Jt,t.$LS=Ci,t.$MS=Hi,t.$OS=xi,t.h=Ki,t.$RS=ti,t.$SS=qi,h=function(){const V=new Map;(0,o.$SQ)(o.$TQ,1);const G={window:o.$TQ,disposables:new A.$Tc};V.set(o.$TQ.vscodeWindowId,G);const se=new y.$he,be=new y.$he,Ne=new y.$he;function _e(Ue,We){return(typeof Ue=="number"?V.get(Ue):void 0)??(We?G:void 0)}return{onDidRegisterWindow:se.event,onWillUnregisterWindow:Ne.event,onDidUnregisterWindow:be.event,registerWindow(Ue){if(V.has(Ue.vscodeWindowId))return A.$Uc.None;const We=new A.$Tc,qe={window:Ue,disposables:We.add(new A.$Tc)};return V.set(Ue.vscodeWindowId,qe),We.add((0,A.$Sc)(()=>{V.delete(Ue.vscodeWindowId),be.fire(Ue)})),We.add(k(Ue,t.$gS.BEFORE_UNLOAD,()=>{Ne.fire(Ue)})),se.fire(qe),We},getWindows(){return V.values()},getWindowsCount(){return V.size},getWindowId(Ue){return Ue.vscodeWindowId},hasWindow(Ue){return V.has(Ue)},getWindowById:_e,getWindow(Ue){const We=Ue;if(We?.ownerDocument?.defaultView)return We.ownerDocument.defaultView.window;const qe=Ue;return qe?.view?qe.view.window:o.$TQ},getDocument(Ue){const We=Ue;return(0,t.getWindow)(We).document}}}(),t.registerWindow=h.registerWindow,t.getWindow=h.getWindow,t.getDocument=h.getDocument,t.getWindows=h.getWindows,t.getWindowsCount=h.getWindowsCount,t.getWindowId=h.getWindowId,t.getWindowById=h.getWindowById,t.hasWindow=h.hasWindow,t.onDidRegisterWindow=h.onDidRegisterWindow,t.onWillUnregisterWindow=h.onWillUnregisterWindow,t.onDidUnregisterWindow=h.onDidUnregisterWindow;function c(V){for(;V.firstChild;)V.firstChild.remove()}class b{constructor(G,se,be,Ne){this.f=G,this.g=se,this.d=be,this.j=Ne||!1,this.f.addEventListener(this.g,this.d,this.j)}dispose(){this.d&&(this.f.removeEventListener(this.g,this.d,this.j),this.f=null,this.d=null)}}function k(V,G,se,be){return new b(V,G,se,be)}function E(V,G){return function(se){return G(new O.$fR(V,se))}}function r(V){return function(G){return V(new B.$kR(G))}}const d=function(G,se,be,Ne){let _e=be;return se==="click"||se==="mousedown"||se==="contextmenu"?_e=E((0,t.getWindow)(G),be):(se==="keydown"||se==="keypress"||se==="keyup")&&(_e=r(be)),k(G,se,_e,Ne)};t.$oR=d;const D=function(G,se,be){const Ne=E((0,t.getWindow)(G),se);return _(G,Ne,be)};t.$pR=D;const R=function(G,se,be){const Ne=E((0,t.getWindow)(G),se);return x(G,Ne,be)};t.$qR=R;function _(V,G,se){return k(V,m.$r&&n.$cR.pointerEvents?t.$gS.POINTER_DOWN:t.$gS.MOUSE_DOWN,G,se)}function H(V,G,se){return k(V,m.$r&&n.$cR.pointerEvents?t.$gS.POINTER_MOVE:t.$gS.MOUSE_MOVE,G,se)}function x(V,G,se){return k(V,m.$r&&n.$cR.pointerEvents?t.$gS.POINTER_UP:t.$gS.MOUSE_UP,G,se)}function p(V,G,se){return(0,T.$Rh)(V,G,se)}class M extends T.$Sh{constructor(G,se){super(G,se)}}t.$vR=M;function U(V,G,se,be){let Ne=0;const _e=V.setInterval(()=>{Ne++,(typeof be=="number"&&Ne>=be||G()===!0)&&Ue.dispose()},se),Ue=(0,A.$Sc)(()=>{V.clearInterval(_e)});return Ue}class N extends T.$Lh{constructor(G){super(),this.g=G&&(0,t.getWindow)(G)}cancelAndSet(G,se,be){return super.cancelAndSet(G,se,be??this.g)}}t.$zR=N;class P{constructor(G,se=0){this.d=G,this.priority=se,this.f=!1}dispose(){this.f=!0}execute(){if(!this.f)try{this.d()}catch(G){(0,v.$1)(G)}}static sort(G,se){return se.priority-G.priority}}(function(){const V=new Map,G=new Map,se=new Map,be=new Map,Ne=_e=>{se.set(_e,!1);const Ue=V.get(_e)??[];for(G.set(_e,Ue),V.set(_e,[]),be.set(_e,!0);Ue.length>0;)Ue.sort(P.sort),Ue.shift().execute();be.set(_e,!1)};t.$xR=(_e,Ue,We=0)=>{const qe=(0,t.getWindowId)(_e),Ge=new P(Ue,We);let ft=V.get(qe);return ft||(ft=[],V.set(qe,ft)),ft.push(Ge),se.get(qe)||(se.set(qe,!0),_e.requestAnimationFrame(()=>Ne(qe))),Ge},t.$wR=(_e,Ue,We)=>{const qe=(0,t.getWindowId)(_e);if(be.get(qe)){const Ge=new P(Ue,We);let ft=G.get(qe);return ft||(ft=[],G.set(qe,ft)),ft.push(Ge),Ge}else return(0,t.$xR)(_e,Ue,We)}})();function W(V,G){return(0,t.$xR)(V,G,1e4)}function ne(V,G){return(0,t.$xR)(V,G,-1e4)}const Q=8,Y=function(V,G){return G};class te extends A.$Uc{constructor(G,se,be,Ne=Y,_e=Q){super();let Ue=null,We=0;const qe=this.B(new T.$Kh),Ge=()=>{We=new Date().getTime(),be(Ue),Ue=null};this.B(k(G,se,ft=>{Ue=Ne(Ue,ft);const Nt=new Date().getTime()-We;Nt>=_e?(qe.cancel(),Ge()):qe.setIfNotSet(Ge,_e-Nt)}))}}function de(V,G,se,be,Ne){return new te(V,G,se,be,Ne)}function De(V){return(0,t.getWindow)(V).getComputedStyle(V,null)}function Le(V,G){const se=(0,t.getWindow)(V),be=se.document;if(V!==be.body)return new ue(V.clientWidth,V.clientHeight);if(m.$r&&se?.visualViewport)return new ue(se.visualViewport.width,se.visualViewport.height);if(se?.innerWidth&&se.innerHeight)return new ue(se.innerWidth,se.innerHeight);if(be.body&&be.body.clientWidth&&be.body.clientHeight)return new ue(be.body.clientWidth,be.body.clientHeight);if(be.documentElement&&be.documentElement.clientWidth&&be.documentElement.clientHeight)return new ue(be.documentElement.clientWidth,be.documentElement.clientHeight);if(G)return Le(G);throw new Error("Unable to figure out browser width and height")}class Se{static d(G,se){return parseFloat(se)||0}static f(G,se,be){const Ne=De(G),_e=Ne?Ne.getPropertyValue(se):"0";return Se.d(G,_e)}static getBorderLeftWidth(G){return Se.f(G,"border-left-width","borderLeftWidth")}static getBorderRightWidth(G){return Se.f(G,"border-right-width","borderRightWidth")}static getBorderTopWidth(G){return Se.f(G,"border-top-width","borderTopWidth")}static getBorderBottomWidth(G){return Se.f(G,"border-bottom-width","borderBottomWidth")}static getPaddingLeft(G){return Se.f(G,"padding-left","paddingLeft")}static getPaddingRight(G){return Se.f(G,"padding-right","paddingRight")}static getPaddingTop(G){return Se.f(G,"padding-top","paddingTop")}static getPaddingBottom(G){return Se.f(G,"padding-bottom","paddingBottom")}static getMarginLeft(G){return Se.f(G,"margin-left","marginLeft")}static getMarginTop(G){return Se.f(G,"margin-top","marginTop")}static getMarginRight(G){return Se.f(G,"margin-right","marginRight")}static getMarginBottom(G){return Se.f(G,"margin-bottom","marginBottom")}}class ue{static{this.None=new ue(0,0)}constructor(G,se){this.width=G,this.height=se}with(G=this.width,se=this.height){return G!==this.width||se!==this.height?new ue(G,se):this}static is(G){return typeof G=="object"&&typeof G.height=="number"&&typeof G.width=="number"}static lift(G){return G instanceof ue?G:new ue(G.width,G.height)}static equals(G,se){return G===se?!0:!G||!se?!1:G.width===se.width&&G.height===se.height}}t.$FR=ue;function J(V){let G=V.offsetParent,se=V.offsetTop,be=V.offsetLeft;for(;(V=V.parentNode)!==null&&V!==V.ownerDocument.body&&V!==V.ownerDocument.documentElement;){se-=V.scrollTop;const Ne=L(V)?null:De(V);Ne&&(be-=Ne.direction!=="rtl"?V.scrollLeft:-V.scrollLeft),V===G&&(be+=Se.getBorderLeftWidth(V),se+=Se.getBorderTopWidth(V),se+=V.offsetTop,be+=V.offsetLeft,G=V.offsetParent)}return{left:be,top:se}}function fe(V,G,se){typeof G=="number"&&(V.style.width=`${G}px`),typeof se=="number"&&(V.style.height=`${se}px`)}function le(V,G,se,be,Ne,_e="absolute"){typeof G=="number"&&(V.style.top=`${G}px`),typeof se=="number"&&(V.style.right=`${se}px`),typeof be=="number"&&(V.style.bottom=`${be}px`),typeof Ne=="number"&&(V.style.left=`${Ne}px`),V.style.position=_e}function ke(V){const G=V.getBoundingClientRect(),se=(0,t.getWindow)(V);return{left:G.left+se.scrollX,top:G.top+se.scrollY,width:G.width,height:G.height}}function Z(V){let G=V,se=1;do{const be=De(G).zoom;be!=null&&be!=="1"&&(se*=be),G=G.parentElement}while(G!==null&&G!==G.ownerDocument.documentElement);return se}function me(V){const G=Se.getMarginLeft(V)+Se.getMarginRight(V);return V.offsetWidth+G}function ye(V){const G=Se.getBorderLeftWidth(V)+Se.getBorderRightWidth(V),se=Se.getPaddingLeft(V)+Se.getPaddingRight(V);return V.offsetWidth-G-se}function Oe(V){const G=Se.getMarginLeft(V)+Se.getMarginRight(V);return V.scrollWidth+G}function Ie(V){const G=Se.getBorderTopWidth(V)+Se.getBorderBottomWidth(V),se=Se.getPaddingTop(V)+Se.getPaddingBottom(V);return V.offsetHeight-G-se}function je(V){const G=Se.getMarginTop(V)+Se.getMarginBottom(V);return V.offsetHeight+G}function ie(V,G){if(V===null)return 0;const se=J(V),be=J(G);return se.left-be.left}function K(V,G){const se=G.map(Ne=>Math.max(Oe(Ne),me(Ne))+ie(Ne,V)||0);return Math.max(...se)}function C(V,G){return!!G?.contains(V)}const a="parentFlowToElementId";function l(V,G){V.dataset[a]=G.id}function g(V){const G=V.dataset[a];return typeof G=="string"?V.ownerDocument.getElementById(G):null}function I(V,G){let se=V;for(;se;){if(se===G)return!0;if(se instanceof HTMLElement){const be=g(se);if(be){se=be;continue}}se=se.parentNode}return!1}function F(V,G,se){for(;V&&V.nodeType===V.ELEMENT_NODE;){if(V.classList.contains(G))return V;if(se){if(typeof se=="string"){if(V.classList.contains(se))return null}else if(V===se)return null}V=V.parentNode}return null}function u(V,G,se){return!!F(V,G,se)}function L(V){return V&&!!V.host&&!!V.mode}function S(V){return!!j(V)}function j(V){for(;V.parentNode;){if(V===V.ownerDocument?.body)return null;V=V.parentNode}return L(V)?V:null}function z(){let V=ce().activeElement;for(;V?.shadowRoot;)V=V.shadowRoot.activeElement;return V}function q(V){return z()===V}function ee(V){return C(z(),V)}function re(V){return V.ownerDocument===ce()}function ce(){return(0,t.getWindowsCount)()<=1?o.$TQ.document:Array.from((0,t.getWindows)()).map(({window:G})=>G.document).find(G=>G.hasFocus())??o.$TQ.document}function Ee(){return ce().defaultView?.window??o.$TQ}const ve=new Map;function Re(V){return ve.has(V)}function Te(){return new he}class he{constructor(){this.d="",this.f=void 0}setStyle(G){G!==this.d&&(this.d=G,this.f?this.f.innerText=G:this.f=Fe(o.$TQ.document.head,se=>se.innerText=G))}dispose(){this.f&&(this.f.remove(),this.f=void 0)}}function Fe(V=o.$TQ.document.head,G,se){const be=document.createElement("style");if(be.type="text/css",be.media="screen",G?.(be),V.appendChild(be),se&&se.add((0,A.$Sc)(()=>V.removeChild(be))),V===o.$TQ.document.head){const Ne=new Set;ve.set(be,Ne);for(const{window:_e,disposables:Ue}of(0,t.getWindows)()){if(_e===o.$TQ)continue;const We=Ue.add(Ye(be,Ne,_e));se?.add(We)}}return be}function xe(V){const G=new A.$Tc;for(const[se,be]of ve)G.add(Ye(se,be,V));return G}function Ye(V,G,se){const be=new A.$Tc,Ne=V.cloneNode(!0);se.document.head.appendChild(Ne),be.add((0,A.$Sc)(()=>se.document.head.removeChild(Ne)));for(const _e of X(V))Ne.sheet?.insertRule(_e.cssText,Ne.sheet?.cssRules.length);return be.add(t.$0R.observe(V,be,{childList:!0})(()=>{Ne.textContent=V.textContent})),G.add(Ne),be.add((0,A.$Sc)(()=>G.delete(Ne))),be}t.$0R=new class{constructor(){this.mutationObservers=new Map}observe(V,G,se){let be=this.mutationObservers.get(V);be||(be=new Map,this.mutationObservers.set(V,be));const Ne=(0,s.$oj)(se);let _e=be.get(Ne);if(_e)_e.users+=1;else{const Ue=new y.$he,We=new MutationObserver(Ge=>Ue.fire(Ge));We.observe(V,se);const qe=_e={users:1,observer:We,onDidMutate:Ue.event};G.add((0,A.$Sc)(()=>{qe.users-=1,qe.users===0&&(Ue.dispose(),We.disconnect(),be?.delete(Ne),be?.size===0&&this.mutationObservers.delete(V))})),be.set(Ne,_e)}return _e.onDidMutate}};function et(V=o.$TQ.document.head){return it("meta",V)}function ot(V=o.$TQ.document.head){return it("link",V)}function it(V,G=o.$TQ.document.head){const se=document.createElement(V);return G.appendChild(se),se}let Ke=null;function Xe(){return Ke||(Ke=Fe()),Ke}function X(V){return V?.sheet?.rules?V.sheet.rules:V?.sheet?.cssRules?V.sheet.cssRules:[]}function ae(V,G,se=Xe()){if(!(!se||!G)){se.sheet?.insertRule(`${V} {${G}}`,0);for(const be of ve.get(se)??[])ae(V,G,be)}}function $e(V,G=Xe()){if(!G)return;const se=X(G),be=[];for(let Ne=0;Ne<se.length;Ne++){const _e=se[Ne];Ae(_e)&&_e.selectorText.indexOf(V)!==-1&&be.push(Ne)}for(let Ne=be.length-1;Ne>=0;Ne--)G.sheet?.deleteRule(be[Ne]);for(const Ne of ve.get(G)??[])$e(V,Ne)}function Ae(V){return typeof V.selectorText=="string"}function Pe(V){return V instanceof MouseEvent||V instanceof(0,t.getWindow)(V).MouseEvent}function He(V){return V instanceof KeyboardEvent||V instanceof(0,t.getWindow)(V).KeyboardEvent}function Qe(V){return V instanceof PointerEvent||V instanceof(0,t.getWindow)(V).PointerEvent}function rt(V){return V instanceof DragEvent||V instanceof(0,t.getWindow)(V).DragEvent}t.$gS={CLICK:"click",AUXCLICK:"auxclick",DBLCLICK:"dblclick",MOUSE_UP:"mouseup",MOUSE_DOWN:"mousedown",MOUSE_OVER:"mouseover",MOUSE_MOVE:"mousemove",MOUSE_OUT:"mouseout",MOUSE_ENTER:"mouseenter",MOUSE_LEAVE:"mouseleave",MOUSE_WHEEL:"wheel",POINTER_UP:"pointerup",POINTER_DOWN:"pointerdown",POINTER_MOVE:"pointermove",POINTER_LEAVE:"pointerleave",CONTEXT_MENU:"contextmenu",WHEEL:"wheel",KEY_DOWN:"keydown",KEY_PRESS:"keypress",KEY_UP:"keyup",LOAD:"load",BEFORE_UNLOAD:"beforeunload",UNLOAD:"unload",PAGE_SHOW:"pageshow",PAGE_HIDE:"pagehide",PASTE:"paste",ABORT:"abort",ERROR:"error",RESIZE:"resize",SCROLL:"scroll",FULLSCREEN_CHANGE:"fullscreenchange",WK_FULLSCREEN_CHANGE:"webkitfullscreenchange",SELECT:"select",CHANGE:"change",SUBMIT:"submit",RESET:"reset",FOCUS:"focus",FOCUS_IN:"focusin",FOCUS_OUT:"focusout",BLUR:"blur",INPUT:"input",STORAGE:"storage",DRAG_START:"dragstart",DRAG:"drag",DRAG_ENTER:"dragenter",DRAG_LEAVE:"dragleave",DRAG_OVER:"dragover",DROP:"drop",DRAG_END:"dragend",ANIMATION_START:i.$7Q?"webkitAnimationStart":"animationstart",ANIMATION_END:i.$7Q?"webkitAnimationEnd":"animationend",ANIMATION_ITERATION:i.$7Q?"webkitAnimationIteration":"animationiteration"};function tt(V){const G=V;return!!(G&&typeof G.preventDefault=="function"&&typeof G.stopPropagation=="function")}t.$iS={stop:(V,G)=>(V.preventDefault(),G&&V.stopPropagation(),V)};function ut(V){const G=[];for(let se=0;V&&V.nodeType===V.ELEMENT_NODE;se++)G[se]=V.scrollTop,V=V.parentNode;return G}function nt(V,G){for(let se=0;V&&V.nodeType===V.ELEMENT_NODE;se++)V.scrollTop!==G[se]&&(V.scrollTop=G[se]),V=V.parentNode}class lt extends A.$Uc{static m(G){if(G instanceof HTMLElement){const se=j(G),be=se?se.activeElement:G.ownerDocument.activeElement;return C(be,G)}else{const se=G;return C(se.document.activeElement,se.document)}}constructor(G){super(),this.f=this.B(new y.$he),this.onDidFocus=this.f.event,this.g=this.B(new y.$he),this.onDidBlur=this.g.event;let se=lt.m(G),be=!1;const Ne=()=>{be=!1,se||(se=!0,this.f.fire())},_e=()=>{se&&(be=!0,(G instanceof HTMLElement?(0,t.getWindow)(G):G).setTimeout(()=>{be&&(be=!1,se=!1,this.g.fire())},0))};this.j=()=>{lt.m(G)!==se&&(se?_e():Ne())},this.B(k(G,t.$gS.FOCUS,Ne,!0)),this.B(k(G,t.$gS.BLUR,_e,!0)),G instanceof HTMLElement&&(this.B(k(G,t.$gS.FOCUS_IN,()=>this.j())),this.B(k(G,t.$gS.FOCUS_OUT,()=>this.j())))}refreshState(){this.j()}}function ht(V){return new lt(V)}function pt(V,G){return V.after(G),G}function Ce(V,...G){if(V.append(...G),G.length===1&&typeof G[0]!="string")return G[0]}function ge(V,G){return V.insertBefore(G,V.firstChild),G}function Me(V,...G){V.innerText="",Ce(V,...G)}const Be=/([\w\-]+)?(#([\w\-]+))?((\.([\w\-]+))*)/;var Ve;(function(V){V.HTML="http://www.w3.org/1999/xhtml",V.SVG="http://www.w3.org/2000/svg"})(Ve||(t.Namespace=Ve={}));function st(V,G,se,...be){const Ne=Be.exec(G);if(!Ne)throw new Error("Bad use of emmet");const _e=Ne[1]||"div";let Ue;return V!==Ve.HTML?Ue=document.createElementNS(V,_e):Ue=document.createElement(_e),Ne[3]&&(Ue.id=Ne[3]),Ne[4]&&(Ue.className=Ne[4].replace(/\./g," ").trim()),se&&Object.entries(se).forEach(([We,qe])=>{typeof qe>"u"||(/^on\w+$/.test(We)?Ue[We]=qe:We==="selected"?qe&&Ue.setAttribute(We,"true"):Ue.setAttribute(We,qe))}),Ue.append(...be),Ue}function ct(V,G,...se){return st(Ve.HTML,V,G,...se)}ct.SVG=function(V,G,...se){return st(Ve.SVG,V,G,...se)};function Ze(V,G){const se=[];return V.forEach((be,Ne)=>{Ne>0&&(G instanceof Node?se.push(G.cloneNode()):se.push(document.createTextNode(G))),se.push(be)}),se}function mt(V,...G){V?vt(...G):At(...G)}function vt(...V){for(const G of V)G.style.display="",G.removeAttribute("aria-hidden")}function At(...V){for(const G of V)G.style.display="none",G.setAttribute("aria-hidden","true")}function Yt(V,G){for(;V&&V.nodeType===V.ELEMENT_NODE;){if(V instanceof HTMLElement&&V.hasAttribute(G))return V;V=V.parentNode}return null}function Ai(V){!V||!V.hasAttribute("tabIndex")||(V.ownerDocument.activeElement===V&&Yt(V.parentElement,"tabIndex")?.focus(),V.removeAttribute("tabindex"))}function Si(V){return G=>{G.preventDefault(),G.stopPropagation(),V(G)}}function Ti(V){return new Promise(G=>{if(V.document.readyState==="complete"||V.document&&V.document.body!==null)G(void 0);else{const be=()=>{V.window.removeEventListener("DOMContentLoaded",be,!1),G()};V.window.addEventListener("DOMContentLoaded",be,!1)}})}function ki(V,G){const se=V.devicePixelRatio*G;return Math.max(1,Math.floor(se))/V.devicePixelRatio}function Ri(V){o.$TQ.open(V,"_blank","noopener")}const Xt=780,Qt=640;function Ni(V){const G=Math.floor(o.$TQ.screenLeft+o.$TQ.innerWidth/2-Xt/2),se=Math.floor(o.$TQ.screenTop+o.$TQ.innerHeight/2-Qt/2);o.$TQ.open(V,"_blank",`width=${Xt},height=${Qt},top=${se},left=${G}`)}function Li(V,G=!0){const se=o.$TQ.open();return se?(G&&(se.opener=null),se.location.href=V,!0):!1}function Fi(V,G){const se=()=>{G(),be=(0,t.$xR)(V,se)};let be=(0,t.$xR)(V,se);return(0,A.$Sc)(()=>be.dispose())}$.$Ng.setPreferredWebSchema(/^https:/.test(o.$TQ.location.href)?"https":"http");function Ii(V){return V?`url('${$.$Ug.uriToBrowserUri(V).toString(!0).replace(/'/g,"%27")}')`:"url('')"}function Oi(V){return`'${V.replace(/'/g,"%27")}'`}function Zt(V,G){if(V!==void 0){const se=V.match(/^\s*var\((.+)\)$/);if(se){const be=se[1].split(",",2);return be.length===2&&(G=Zt(be[1].trim(),G)),`var(${be[0]}, ${G})`}return V}return G}function Mi(V,G){let se;if(e.URI.isUri(V))se=V.toString(!0);else{const _e=new Blob([V]);se=URL.createObjectURL(_e),setTimeout(()=>URL.revokeObjectURL(se))}const be=Ee(),Ne=document.createElement("a");be.document.body.appendChild(Ne),Ne.download=G,Ne.href=se,Ne.click(),setTimeout(()=>be.document.body.removeChild(Ne))}function Pi(){return new Promise(V=>{const G=Ee(),se=document.createElement("input");G.document.body.appendChild(se),se.type="file",se.multiple=!0,y.Event.once(y.Event.fromDOMEventEmitter(se,"input"))(()=>{V(se.files??void 0)}),se.click(),setTimeout(()=>G.document.body.removeChild(se))})}var St;(function(V){V[V.DOCUMENT=1]="DOCUMENT",V[V.BROWSER=2]="BROWSER"})(St||(t.DetectedFullscreenMode=St={}));function Bi(V){return V.document.fullscreenElement||V.document.webkitFullscreenElement||V.document.webkitIsFullScreen?{mode:St.DOCUMENT,guess:!1}:V.innerHeight===V.screen.height?{mode:St.BROWSER,guess:!1}:(m.$j||m.$k)&&V.outerHeight===V.screen.height&&V.outerWidth===V.screen.width?{mode:St.BROWSER,guess:!0}:null}function Jt(V,G=!1){const se=document.createElement("a");return f.addHook("afterSanitizeAttributes",be=>{for(const Ne of["href","src"])if(be.hasAttribute(Ne)){const _e=be.getAttribute(Ne);if(Ne==="href"&&_e.startsWith("#"))continue;if(se.href=_e,!V.includes(se.protocol.replace(/:$/,""))){if(G&&Ne==="src"&&se.href.startsWith("data:"))continue;be.removeAttribute(Ne)}}}),(0,A.$Sc)(()=>{f.removeHook("afterSanitizeAttributes")})}const ji=[$.Schemas.http,$.Schemas.https,$.Schemas.command];t.$KS=Object.freeze(["a","abbr","b","bdo","blockquote","br","caption","cite","code","col","colgroup","dd","del","details","dfn","div","dl","dt","em","figcaption","figure","h1","h2","h3","h4","h5","h6","hr","i","img","input","ins","kbd","label","li","mark","ol","p","pre","q","rp","rt","ruby","samp","small","small","source","span","strike","strong","sub","summary","sup","table","tbody","td","tfoot","th","thead","time","tr","tt","u","ul","var","video","wbr"]);const Ui=Object.freeze({ALLOWED_TAGS:["a","button","blockquote","code","div","h1","h2","h3","h4","h5","h6","hr","input","label","li","p","pre","select","small","span","strong","textarea","ul","ol"],ALLOWED_ATTR:["href","data-href","data-command","target","title","name","src","alt","class","id","role","tabindex","style","data-code","width","height","align","x-dispatch","required","checked","placeholder","type","start"],RETURN_DOM:!1,RETURN_DOM_FRAGMENT:!1,RETURN_TRUSTED_TYPE:!0});function Ci(V,G){const se=Jt(ji);try{const be=f.sanitize(G,Ui);V.innerHTML=be}finally{se.dispose()}}function _i(V){const G=new Uint16Array(V.length);for(let Ne=0;Ne<G.length;Ne++)G[Ne]=V.charCodeAt(Ne);let se="";const be=new Uint8Array(G.buffer);for(let Ne=0;Ne<be.length;Ne++)se+=String.fromCharCode(be[Ne]);return se}function Hi(V){return btoa(_i(V))}class Dt extends y.$he{constructor(){super(),this.o=new A.$Tc,this.A={altKey:!1,shiftKey:!1,ctrlKey:!1,metaKey:!1},this.o.add(y.Event.runAndSubscribe(t.onDidRegisterWindow,({window:G,disposables:se})=>this.C(G,se),{window:o.$TQ,disposables:this.o}))}C(G,se){se.add(k(G,"keydown",be=>{if(be.defaultPrevented)return;const Ne=new B.$kR(be);if(!(Ne.keyCode===w.KeyCode.Alt&&be.repeat)){if(be.altKey&&!this.A.altKey)this.A.lastKeyPressed="alt";else if(be.ctrlKey&&!this.A.ctrlKey)this.A.lastKeyPressed="ctrl";else if(be.metaKey&&!this.A.metaKey)this.A.lastKeyPressed="meta";else if(be.shiftKey&&!this.A.shiftKey)this.A.lastKeyPressed="shift";else if(Ne.keyCode!==w.KeyCode.Alt)this.A.lastKeyPressed=void 0;else return;this.A.altKey=be.altKey,this.A.ctrlKey=be.ctrlKey,this.A.metaKey=be.metaKey,this.A.shiftKey=be.shiftKey,this.A.lastKeyPressed&&(this.A.event=be,this.fire(this.A))}},!0)),se.add(k(G,"keyup",be=>{be.defaultPrevented||(!be.altKey&&this.A.altKey?this.A.lastKeyReleased="alt":!be.ctrlKey&&this.A.ctrlKey?this.A.lastKeyReleased="ctrl":!be.metaKey&&this.A.metaKey?this.A.lastKeyReleased="meta":!be.shiftKey&&this.A.shiftKey?this.A.lastKeyReleased="shift":this.A.lastKeyReleased=void 0,this.A.lastKeyPressed!==this.A.lastKeyReleased&&(this.A.lastKeyPressed=void 0),this.A.altKey=be.altKey,this.A.ctrlKey=be.ctrlKey,this.A.metaKey=be.metaKey,this.A.shiftKey=be.shiftKey,this.A.lastKeyReleased&&(this.A.event=be,this.fire(this.A)))},!0)),se.add(k(G.document.body,"mousedown",()=>{this.A.lastKeyPressed=void 0},!0)),se.add(k(G.document.body,"mouseup",()=>{this.A.lastKeyPressed=void 0},!0)),se.add(k(G.document.body,"mousemove",be=>{be.buttons&&(this.A.lastKeyPressed=void 0)},!0)),se.add(k(G,"blur",()=>{this.resetKeyStatus()}))}get keyStatus(){return this.A}get isModifierPressed(){return this.A.altKey||this.A.ctrlKey||this.A.metaKey||this.A.shiftKey}resetKeyStatus(){this.D(),this.fire(this.A)}D(){this.A={altKey:!1,shiftKey:!1,ctrlKey:!1,metaKey:!1}}static getInstance(){return Dt.B||(Dt.B=new Dt),Dt.B}dispose(){super.dispose(),this.o.dispose()}}t.$NS=Dt;function xi(V){const G=document.cookie.match("(^|[^;]+)\\s*"+V+"\\s*=\\s*([^;]+)");return G?G.pop():void 0}class zi extends A.$Uc{constructor(G,se){super(),this.j=G,this.m=se,this.f=0,this.g=0,this.n()}n(){this.m.onDragStart&&this.B(k(this.j,t.$gS.DRAG_START,G=>{this.m.onDragStart?.(G)})),this.m.onDrag&&this.B(k(this.j,t.$gS.DRAG,G=>{this.m.onDrag?.(G)})),this.B(k(this.j,t.$gS.DRAG_ENTER,G=>{this.f++,this.g=G.timeStamp,this.m.onDragEnter?.(G)})),this.B(k(this.j,t.$gS.DRAG_OVER,G=>{G.preventDefault(),this.m.onDragOver?.(G,G.timeStamp-this.g)})),this.B(k(this.j,t.$gS.DRAG_LEAVE,G=>{this.f--,this.f===0&&(this.g=0,this.m.onDragLeave?.(G))})),this.B(k(this.j,t.$gS.DRAG_END,G=>{this.f=0,this.g=0,this.m.onDragEnd?.(G)})),this.B(k(this.j,t.$gS.DROP,G=>{this.f=0,this.g=0,this.m.onDrop?.(G)}))}}t.$PS=zi;const Wi=/(?<tag>[\w\-]+)?(?:#(?<id>[\w\-]+))?(?<class>(?:\.(?:[\w\-]+))*)(?:@(?<name>(?:[\w\_])+))?/;function Ki(V,...G){let se,be;Array.isArray(G[0])?(se={},be=G[0]):(se=G[0]||{},be=G[1]);const Ne=Wi.exec(V);if(!Ne||!Ne.groups)throw new Error("Bad use of h");const _e=Ne.groups.tag||"div",Ue=document.createElement(_e);Ne.groups.id&&(Ue.id=Ne.groups.id);const We=[];if(Ne.groups.class)for(const Ge of Ne.groups.class.split("."))Ge!==""&&We.push(Ge);if(se.className!==void 0)for(const Ge of se.className.split("."))Ge!==""&&We.push(Ge);We.length>0&&(Ue.className=We.join(" "));const qe={};if(Ne.groups.name&&(qe[Ne.groups.name]=Ue),be)for(const Ge of be)Ge instanceof HTMLElement?Ue.appendChild(Ge):typeof Ge=="string"?Ue.append(Ge):"root"in Ge&&(Object.assign(qe,Ge),Ue.appendChild(Ge.root));for(const[Ge,ft]of Object.entries(se))if(Ge!=="className")if(Ge==="style")for(const[Nt,jt]of Object.entries(ft))Ue.style.setProperty(ei(Nt),typeof jt=="number"?jt+"px":""+jt);else Ge==="tabIndex"?Ue.tabIndex=ft:Ue.setAttribute(ei(Ge),ft.toString());return qe.root=Ue,qe}function ei(V){return V.replace(/([a-z])([A-Z])/g,"$1-$2").toLowerCase()}function ti(V,G,se){for(const{name:be,value:Ne}of V.attributes)(!se||se.includes(be))&&G.setAttribute(be,Ne)}function Vi(V,G,se){const be=V.getAttribute(se);be?G.setAttribute(se,be):G.removeAttribute(se)}function qi(V,G,se){ti(V,G,se);const be=new A.$Tc;return be.add(t.$0R.observe(V,be,{attributes:!0,attributeFilter:se})(Ne=>{for(const _e of Ne)_e.type==="attributes"&&_e.attributeName&&Vi(V,G,_e.attributeName)})),be}}),define(pe[70],we([1,0,4,2,133]),function(oe,t,i,n,B){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$US=t.$TS=void 0,t.$VS=T;class O extends n.$Uc{constructor(y,f){super(),this.B((0,i.$nR)(y,"dragover",w=>{w.preventDefault(),this.a||(this.a=setTimeout(()=>{f(),this.a=null},800))})),["dragleave","drop","dragend"].forEach(w=>{this.B((0,i.$nR)(y,w,()=>{this.b()}))})}b(){this.a&&(clearTimeout(this.a),this.a=null)}dispose(){super.dispose(),this.b()}}t.$TS=O,t.$US={RESOURCES:"ResourceURLs",DOWNLOAD_URL:"DownloadURL",FILES:"Files",TEXT:B.$Ys.text,INTERNAL_URI_LIST:"application/vnd.code.uri-list"};function T(v,y,f,w,A){const $=document.createElement("div");if($.className=f,$.textContent=y,A&&($.style.color=A),w&&($.style.background=w),v.dataTransfer){const m=(0,i.getWindow)(v).document;m.body.appendChild($),v.dataTransfer.setDragImage($,-10,-10),setTimeout(()=>m.body.removeChild($),0)}}}),define(pe[71],we([1,0,4]),function(oe,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$oT=n,t.$pT=B,t.$qT=O;function n($,m={}){const e=O(m);return e.textContent=$,e}function B($,m={}){const e=O(m);return y(e,f($,!!m.renderCodeSegments),m.actionHandler,m.renderCodeSegments),e}function O($){const m=$.inline?"span":"div",e=document.createElement(m);return $.className&&(e.className=$.className),e}class T{constructor(m){this.b=m,this.c=0}eos(){return this.c>=this.b.length}next(){const m=this.peek();return this.advance(),m}peek(){return this.b[this.c]}advance(){this.c++}}var v;(function($){$[$.Invalid=0]="Invalid",$[$.Root=1]="Root",$[$.Text=2]="Text",$[$.Bold=3]="Bold",$[$.Italics=4]="Italics",$[$.Action=5]="Action",$[$.ActionClose=6]="ActionClose",$[$.Code=7]="Code",$[$.NewLine=8]="NewLine"})(v||(v={}));function y($,m,e,s){let o;if(m.type===v.Text)o=document.createTextNode(m.content||"");else if(m.type===v.Bold)o=document.createElement("b");else if(m.type===v.Italics)o=document.createElement("i");else if(m.type===v.Code&&s)o=document.createElement("code");else if(m.type===v.Action&&e){const h=document.createElement("a");e.disposables.add(i.$oR(h,"click",c=>{e.callback(String(m.index),c)})),o=h}else m.type===v.NewLine?o=document.createElement("br"):m.type===v.Root&&(o=$);o&&$!==o&&$.appendChild(o),o&&Array.isArray(m.children)&&m.children.forEach(h=>{y(o,h,e,s)})}function f($,m){const e={type:v.Root,children:[]};let s=0,o=e;const h=[],c=new T($);for(;!c.eos();){let b=c.next();const k=b==="\\"&&A(c.peek(),m)!==v.Invalid;if(k&&(b=c.next()),!k&&w(b,m)&&b===c.peek()){c.advance(),o.type===v.Text&&(o=h.pop());const E=A(b,m);if(o.type===E||o.type===v.Action&&E===v.ActionClose)o=h.pop();else{const r={type:E,children:[]};E===v.Action&&(r.index=s,s++),o.children.push(r),h.push(o),o=r}}else if(b===`
`)o.type===v.Text&&(o=h.pop()),o.children.push({type:v.NewLine});else if(o.type!==v.Text){const E={type:v.Text,content:b};o.children.push(E),h.push(o),o=E}else o.content+=b}return o.type===v.Text&&(o=h.pop()),h.length,e}function w($,m){return A($,m)!==v.Invalid}function A($,m){switch($){case"*":return v.Bold;case"_":return v.Italics;case"[":return v.Action;case"]":return v.ActionClose;case"`":return m?v.Code:v.Invalid;default:return v.Invalid}}}),define(pe[72],we([1,0,4,2]),function(oe,t,i,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ZS=void 0;class B{constructor(){this.a=new n.$Tc,this.b=null,this.c=null}dispose(){this.stopMonitoring(!1),this.a.dispose()}stopMonitoring(T,v){if(!this.isMonitoring())return;this.a.clear(),this.b=null;const y=this.c;this.c=null,T&&y&&y(v)}isMonitoring(){return!!this.b}startMonitoring(T,v,y,f,w){this.isMonitoring()&&this.stopMonitoring(!1),this.b=f,this.c=w;let A=T;try{T.setPointerCapture(v),this.a.add((0,n.$Sc)(()=>{try{T.releasePointerCapture(v)}catch{}}))}catch{A=i.getWindow(T)}this.a.add(i.$nR(A,i.$gS.POINTER_MOVE,$=>{if($.buttons!==y){this.stopMonitoring(!0);return}$.preventDefault(),this.b($)})),this.a.add(i.$nR(A,i.$gS.POINTER_UP,$=>this.stopMonitoring(!0)))}}t.$ZS=B});var Je=this&&this.__decorate||function(oe,t,i,n){var B=arguments.length,O=B<3?t:n===null?n=Object.getOwnPropertyDescriptor(t,i):n,T;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")O=Reflect.decorate(oe,t,i,n);else for(var v=oe.length-1;v>=0;v--)(T=oe[v])&&(O=(B<3?T(O):B>3?T(t,i,O):T(t,i))||O);return B>3&&O&&Object.defineProperty(t,i,O),O};define(pe[31],we([1,0,4,25,9,34,3,2,59]),function(oe,t,i,n,B,O,T,v,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$WS=t.EventType=void 0;var f;(function(A){A.Tap="-monaco-gesturetap",A.Change="-monaco-gesturechange",A.Start="-monaco-gesturestart",A.End="-monaco-gesturesend",A.Contextmenu="-monaco-gesturecontextmenu"})(f||(t.EventType=f={}));class w extends v.$Uc{static{this.c=-.005}static{this.g=700}static{this.u=400}constructor(){super(),this.h=!1,this.j=new y.$5c,this.m=new y.$5c,this.r={},this.n=null,this.s=0,this.B(T.Event.runAndSubscribe(i.onDidRegisterWindow,({window:$,disposables:m})=>{m.add(i.$nR($.document,"touchstart",e=>this.w(e),{passive:!1})),m.add(i.$nR($.document,"touchend",e=>this.z($,e))),m.add(i.$nR($.document,"touchmove",e=>this.G(e),{passive:!1}))},{window:n.$TQ,disposables:this.q}))}static addTarget($){if(!w.isTouchDevice())return v.$Uc.None;w.f||(w.f=(0,v.$Nc)(new w));const m=w.f.j.push($);return(0,v.$Sc)(m)}static ignoreTarget($){if(!w.isTouchDevice())return v.$Uc.None;w.f||(w.f=(0,v.$Nc)(new w));const m=w.f.m.push($);return(0,v.$Sc)(m)}static isTouchDevice(){return"ontouchstart"in n.$TQ||navigator.maxTouchPoints>0}dispose(){this.n&&(this.n.dispose(),this.n=null),super.dispose()}w($){const m=Date.now();this.n&&(this.n.dispose(),this.n=null);for(let e=0,s=$.targetTouches.length;e<s;e++){const o=$.targetTouches.item(e);this.r[o.identifier]={id:o.identifier,initialTarget:o.target,initialTimeStamp:m,initialPageX:o.pageX,initialPageY:o.pageY,rollingTimestamps:[m],rollingPageX:[o.pageX],rollingPageY:[o.pageY]};const h=this.C(f.Start,o.target);h.pageX=o.pageX,h.pageY=o.pageY,this.D(h)}this.h&&($.preventDefault(),$.stopPropagation(),this.h=!1)}z($,m){const e=Date.now(),s=Object.keys(this.r).length;for(let o=0,h=m.changedTouches.length;o<h;o++){const c=m.changedTouches.item(o);if(!this.r.hasOwnProperty(String(c.identifier))){console.warn("move of an UNKNOWN touch",c);continue}const b=this.r[c.identifier],k=Date.now()-b.initialTimeStamp;if(k<w.g&&Math.abs(b.initialPageX-B.$sb(b.rollingPageX))<30&&Math.abs(b.initialPageY-B.$sb(b.rollingPageY))<30){const E=this.C(f.Tap,b.initialTarget);E.pageX=B.$sb(b.rollingPageX),E.pageY=B.$sb(b.rollingPageY),this.D(E)}else if(k>=w.g&&Math.abs(b.initialPageX-B.$sb(b.rollingPageX))<30&&Math.abs(b.initialPageY-B.$sb(b.rollingPageY))<30){const E=this.C(f.Contextmenu,b.initialTarget);E.pageX=B.$sb(b.rollingPageX),E.pageY=B.$sb(b.rollingPageY),this.D(E)}else if(s===1){const E=B.$sb(b.rollingPageX),r=B.$sb(b.rollingPageY),d=B.$sb(b.rollingTimestamps)-b.rollingTimestamps[0],D=E-b.rollingPageX[0],R=r-b.rollingPageY[0],_=[...this.j].filter(H=>b.initialTarget instanceof Node&&H.contains(b.initialTarget));this.F($,_,e,Math.abs(D)/d,D>0?1:-1,E,Math.abs(R)/d,R>0?1:-1,r)}this.D(this.C(f.End,b.initialTarget)),delete this.r[c.identifier]}this.h&&(m.preventDefault(),m.stopPropagation(),this.h=!1)}C($,m){const e=document.createEvent("CustomEvent");return e.initEvent($,!1,!0),e.initialTarget=m,e.tapCount=0,e}D($){if($.type===f.Tap){const m=new Date().getTime();let e=0;m-this.s>w.u?e=1:e=2,this.s=m,$.tapCount=e}else($.type===f.Change||$.type===f.Contextmenu)&&(this.s=0);if($.initialTarget instanceof Node){for(const e of this.m)if(e.contains($.initialTarget))return;const m=[];for(const e of this.j)if(e.contains($.initialTarget)){let s=0,o=$.initialTarget;for(;o&&o!==e;)s++,o=o.parentElement;m.push([s,e])}m.sort((e,s)=>e[0]-s[0]);for(const[e,s]of m)s.dispatchEvent($),this.h=!0}}F($,m,e,s,o,h,c,b,k){this.n=i.$xR($,()=>{const E=Date.now(),r=E-e;let d=0,D=0,R=!0;s+=w.c*r,c+=w.c*r,s>0&&(R=!1,d=o*s*r),c>0&&(R=!1,D=b*c*r);const _=this.C(f.Change);_.translationX=d,_.translationY=D,m.forEach(H=>H.dispatchEvent(_)),R||this.F($,m,E,s,o,h+d,c,b,k+D)})}G($){const m=Date.now();for(let e=0,s=$.changedTouches.length;e<s;e++){const o=$.changedTouches.item(e);if(!this.r.hasOwnProperty(String(o.identifier))){console.warn("end of an UNKNOWN touch",o);continue}const h=this.r[o.identifier],c=this.C(f.Change,h.initialTarget);c.translationX=o.pageX-B.$sb(h.rollingPageX),c.translationY=o.pageY-B.$sb(h.rollingPageY),c.pageX=o.pageX,c.pageY=o.pageY,this.D(c),h.rollingPageX.length>3&&(h.rollingPageX.shift(),h.rollingPageY.shift(),h.rollingTimestamps.shift()),h.rollingPageX.push(o.pageX),h.rollingPageY.push(o.pageY),h.rollingTimestamps.push(m)}this.h&&($.preventDefault(),$.stopPropagation(),this.h=!1)}}t.$WS=w,Je([O.$5h],w,"isTouchDevice",null)}),define(pe[73],we([1,0,4,108]),function(oe,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$sT=f,t.$tT=w,t.$uT=A;const n=2e4;let B,O,T,v,y;function f(m){B=document.createElement("div"),B.className="monaco-aria-container";const e=()=>{const o=document.createElement("div");return o.className="monaco-alert",o.setAttribute("role","alert"),o.setAttribute("aria-atomic","true"),B.appendChild(o),o};O=e(),T=e();const s=()=>{const o=document.createElement("div");return o.className="monaco-status",o.setAttribute("aria-live","polite"),o.setAttribute("aria-atomic","true"),B.appendChild(o),o};v=s(),y=s(),m.appendChild(B)}function w(m){B&&(O.textContent!==m?(i.$mR(T),$(O,m)):(i.$mR(O),$(T,m)))}function A(m){B&&(v.textContent!==m?(i.$mR(y),$(v,m)):(i.$mR(v),$(y,m)))}function $(m,e){i.$mR(m),e.length>n&&(e=e.substr(0,n)),m.textContent=e,m.style.visibility="hidden",m.style.visibility="visible"}}),define(pe[74],we([1,0,68,4,2,5,47,112]),function(oe,t,i,n,B,O,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$nT=t.LayoutAnchorMode=t.LayoutAnchorPosition=t.AnchorAxisAlignment=t.AnchorPosition=t.AnchorAlignment=t.ContextViewDOMPosition=void 0,t.$lT=y,t.$mT=e;var v;(function(h){h[h.ABSOLUTE=1]="ABSOLUTE",h[h.FIXED=2]="FIXED",h[h.FIXED_SHADOW=3]="FIXED_SHADOW"})(v||(t.ContextViewDOMPosition=v={}));function y(h){const c=h;return!!c&&typeof c.x=="number"&&typeof c.y=="number"}var f;(function(h){h[h.LEFT=0]="LEFT",h[h.RIGHT=1]="RIGHT"})(f||(t.AnchorAlignment=f={}));var w;(function(h){h[h.BELOW=0]="BELOW",h[h.ABOVE=1]="ABOVE"})(w||(t.AnchorPosition=w={}));var A;(function(h){h[h.VERTICAL=0]="VERTICAL",h[h.HORIZONTAL=1]="HORIZONTAL"})(A||(t.AnchorAxisAlignment=A={}));var $;(function(h){h[h.Before=0]="Before",h[h.After=1]="After"})($||(t.LayoutAnchorPosition=$={}));var m;(function(h){h[h.AVOID=0]="AVOID",h[h.ALIGN=1]="ALIGN"})(m||(t.LayoutAnchorMode=m={}));function e(h,c,b){const k=b.mode===m.ALIGN?b.offset:b.offset+b.size,E=b.mode===m.ALIGN?b.offset+b.size:b.offset;return b.position===$.Before?c<=h-k?k:c<=E?E-c:Math.max(h-c,0):c<=E?E-c:c<=h-k?k:0}class s extends B.$Uc{static{this.a=["click","keydown","focus","blur"]}static{this.b=["click"]}constructor(c,b){super(),this.c=null,this.g=!1,this.h=!1,this.j=null,this.m=B.$Uc.None,this.n=B.$Uc.None,this.r=null,this.s=null,this.f=n.$(".context-view"),n.$uS(this.f),this.setContainer(c,b),this.B((0,B.$Sc)(()=>this.setContainer(null,v.ABSOLUTE)))}setContainer(c,b){this.g=b!==v.ABSOLUTE;const k=this.h;if(this.h=b===v.FIXED_SHADOW,!(c===this.c&&k===this.h)&&(this.c&&(this.n.dispose(),this.r?(this.r.removeChild(this.f),this.r=null,this.s?.remove(),this.s=null):this.c.removeChild(this.f),this.c=null),c)){if(this.c=c,this.h){this.s=n.$(".shadow-root-host"),this.c.appendChild(this.s),this.r=this.s.attachShadow({mode:"open"});const r=document.createElement("style");r.textContent=o,this.r.appendChild(r),this.r.appendChild(this.f),this.r.appendChild(n.$("slot"))}else this.c.appendChild(this.f);const E=new B.$Tc;s.a.forEach(r=>{E.add(n.$oR(this.c,r,d=>{this.w(d,!1)}))}),s.b.forEach(r=>{E.add(n.$oR(this.c,r,d=>{this.w(d,!0)},!0))}),this.n=E}}show(c){this.u()&&this.hide(),n.$mR(this.f),this.f.className="context-view monaco-component",this.f.style.top="0px",this.f.style.left="0px",this.f.style.zIndex=`${2575+(c.layer??0)}`,this.f.style.position=this.g?"fixed":"absolute",n.$tS(this.f),this.m=c.render(this.f)||B.$Uc.None,this.j=c,this.t(),this.j.focus?.()}getViewElement(){return this.f}layout(){if(this.u()){if(this.j.canRelayout===!1&&!(O.$r&&i.$cR.pointerEvents)){this.hide();return}this.j?.layout?.(),this.t()}}t(){if(!this.u())return;const c=this.j.getAnchor();let b;if(c instanceof HTMLElement){const p=n.$JR(c),M=n.$KR(c);b={top:p.top*M,left:p.left*M,width:p.width*M,height:p.height*M}}else y(c)?b={top:c.y,left:c.x,width:c.width||1,height:c.height||2}:b={top:c.posy,left:c.posx,width:2,height:2};const k=n.$LR(this.f),E=n.$PR(this.f),r=this.j.anchorPosition||w.BELOW,d=this.j.anchorAlignment||f.LEFT,D=this.j.anchorAxisAlignment||A.VERTICAL;let R,_;const H=n.$5R();if(D===A.VERTICAL){const p={offset:b.top-H.pageYOffset,size:b.height,position:r===w.BELOW?$.Before:$.After},M={offset:b.left,size:b.width,position:d===f.LEFT?$.Before:$.After,mode:m.ALIGN};R=e(H.innerHeight,E,p)+H.pageYOffset,T.Range.intersects({start:R,end:R+E},{start:p.offset,end:p.offset+p.size})&&(M.mode=m.AVOID),_=e(H.innerWidth,k,M)}else{const p={offset:b.left,size:b.width,position:d===f.LEFT?$.Before:$.After},M={offset:b.top,size:b.height,position:r===w.BELOW?$.Before:$.After,mode:m.ALIGN};_=e(H.innerWidth,k,p),T.Range.intersects({start:_,end:_+k},{start:p.offset,end:p.offset+p.size})&&(M.mode=m.AVOID),R=e(H.innerHeight,E,M)+H.pageYOffset}this.f.classList.remove("top","bottom","left","right"),this.f.classList.add(r===w.BELOW?"bottom":"top"),this.f.classList.add(d===f.LEFT?"left":"right"),this.f.classList.toggle("fixed",this.g);const x=n.$JR(this.c);this.f.style.top=`${R-(this.g?n.$JR(this.f).top:x.top)}px`,this.f.style.left=`${_-(this.g?n.$JR(this.f).left:x.left)}px`,this.f.style.width="initial"}hide(c){const b=this.j;this.j=null,b?.onHide&&b.onHide(c),this.m.dispose(),n.$uS(this.f)}u(){return!!this.j}w(c,b){this.j&&(this.j.onDOMEvent?this.j.onDOMEvent(c,n.getWindow(c).document.activeElement):b&&!n.$RR(c.target,this.c)&&this.hide())}dispose(){this.hide(),super.dispose()}}t.$nT=s;const o=`
	:host {
		all: initial; /* 1st rule so subsequent properties are reset. */
	}

	.codicon[class*='codicon-'] {
		font: normal normal normal 16px/1 codicon;
		display: inline-block;
		text-decoration: none;
		text-rendering: auto;
		text-align: center;
		-webkit-font-smoothing: antialiased;
		-moz-osx-font-smoothing: grayscale;
		user-select: none;
		-webkit-user-select: none;
		-ms-user-select: none;
	}

	:host {
		font-family: -apple-system, BlinkMacSystemFont, "Segoe WPC", "Segoe UI", "HelveticaNeue-Light", system-ui, "Ubuntu", "Droid Sans", sans-serif;
	}

	:host-context(.mac) { font-family: -apple-system, BlinkMacSystemFont, sans-serif; }
	:host-context(.mac:lang(zh-Hans)) { font-family: -apple-system, BlinkMacSystemFont, "PingFang SC", "Hiragino Sans GB", sans-serif; }
	:host-context(.mac:lang(zh-Hant)) { font-family: -apple-system, BlinkMacSystemFont, "PingFang TC", sans-serif; }
	:host-context(.mac:lang(ja)) { font-family: -apple-system, BlinkMacSystemFont, "Hiragino Kaku Gothic Pro", sans-serif; }
	:host-context(.mac:lang(ko)) { font-family: -apple-system, BlinkMacSystemFont, "Nanum Gothic", "Apple SD Gothic Neo", "AppleGothic", sans-serif; }

	:host-context(.windows) { font-family: "Segoe WPC", "Segoe UI", sans-serif; }
	:host-context(.windows:lang(zh-Hans)) { font-family: "Segoe WPC", "Segoe UI", "Microsoft YaHei", sans-serif; }
	:host-context(.windows:lang(zh-Hant)) { font-family: "Segoe WPC", "Segoe UI", "Microsoft Jhenghei", sans-serif; }
	:host-context(.windows:lang(ja)) { font-family: "Segoe WPC", "Segoe UI", "Yu Gothic UI", "Meiryo UI", sans-serif; }
	:host-context(.windows:lang(ko)) { font-family: "Segoe WPC", "Segoe UI", "Malgun Gothic", "Dotom", sans-serif; }

	:host-context(.linux) { font-family: system-ui, "Ubuntu", "Droid Sans", sans-serif; }
	:host-context(.linux:lang(zh-Hans)) { font-family: system-ui, "Ubuntu", "Droid Sans", "Source Han Sans SC", "Source Han Sans CN", "Source Han Sans", sans-serif; }
	:host-context(.linux:lang(zh-Hant)) { font-family: system-ui, "Ubuntu", "Droid Sans", "Source Han Sans TC", "Source Han Sans TW", "Source Han Sans", sans-serif; }
	:host-context(.linux:lang(ja)) { font-family: system-ui, "Ubuntu", "Droid Sans", "Source Han Sans J", "Source Han Sans JP", "Source Han Sans", sans-serif; }
	:host-context(.linux:lang(ko)) { font-family: system-ui, "Ubuntu", "Droid Sans", "Source Han Sans K", "Source Han Sans JR", "Source Han Sans", "UnDotum", "FBaekmuk Gulim", sans-serif; }
`}),define(pe[135],we([1,0,4,22]),function(oe,t,i,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$XT=O,t.$YT=T;const B=new RegExp(`(\\\\)?\\$\\((${n.ThemeIcon.iconNameExpression}(?:${n.ThemeIcon.iconModifierExpression})?)\\)`,"g");function O(v){const y=new Array;let f,w=0,A=0;for(;(f=B.exec(v))!==null;){A=f.index||0,w<A&&y.push(v.substring(w,A)),w=(f.index||0)+f[0].length;const[,$,m]=f;y.push($?`$(${m})`:T({id:m}))}return w<v.length&&y.push(v.substring(w)),y}function T(v){const y=i.$("span");return y.classList.add(...n.ThemeIcon.asClassNameArray(v)),y}}),define(pe[136],we([1,0,4]),function(oe,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$AT=void 0;function n(O){try{O.parentElement?.removeChild(O)}catch{}}class B{constructor(T){this.d=T,this.a=new Map,this.b=new Set,this.c=!1}alloc(T){let v=this.h(T).pop(),y=!1;if(v)y=this.b.has(v.domNode),y&&this.b.delete(v.domNode);else{const f=(0,i.$)(".monaco-list-row"),A=this.i(T).renderTemplate(f);v={domNode:f,templateId:T,templateData:A}}return{row:v,isReusingConnectedDomNode:y}}release(T){T&&this.f(T)}transact(T){if(this.c)throw new Error("Already in transaction");this.c=!0;try{T()}finally{for(const v of this.b)this.g(v);this.b.clear(),this.c=!1}}f(T){const{domNode:v,templateId:y}=T;v&&(this.c?this.b.add(v):this.g(v)),this.h(y).push(T)}g(T){T.classList.remove("scrolling"),n(T)}h(T){let v=this.a.get(T);return v||(v=[],this.a.set(T,v)),v}dispose(){this.a.forEach((T,v)=>{for(const y of T)this.i(v).disposeTemplate(y.templateData),y.templateData=null}),this.a.clear(),this.b.clear()}i(T){const v=this.d.get(T);if(!v)throw new Error(`No renderer found for ${T}`);return v}}t.$AT=B}),define(pe[137],we([1,0,12,2,20]),function(oe,t,i,n,B){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$5S=void 0;class O extends n.$Uc{constructor(v,y,f){super(),this.a=v,this.b=y,this.c=f,this.f=null,this.m=!1,this.j=!1,this.g=!1,this.h=!1,this.n=this.B(new i.$Kh)}setVisibility(v){this.a!==v&&(this.a=v,this.s())}setShouldBeVisible(v){this.g=v,this.s()}r(){return this.a===B.ScrollbarVisibility.Hidden?!1:this.a===B.ScrollbarVisibility.Visible?!0:this.g}s(){const v=this.r();this.h!==v&&(this.h=v,this.ensureVisibility())}setIsNeeded(v){this.j!==v&&(this.j=v,this.ensureVisibility())}setDomNode(v){this.f=v,this.f.setClassName(this.c),this.setShouldBeVisible(!1)}ensureVisibility(){if(!this.j){this.u(!1);return}this.h?this.t():this.u(!0)}t(){this.m||(this.m=!0,this.n.setIfNotSet(()=>{this.f?.setClassName(this.b)},0))}u(v){this.n.cancel(),this.m&&(this.m=!1,this.f?.setClassName(this.c+(v?" fade":"")))}}t.$5S=O}),define(pe[138],we([1,0,4,31,9,3,8,2,5]),function(oe,t,i,n,B,O,T,v,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$8T=void 0;class f extends v.$Uc{constructor(A,$,m,e){super(),this.f=0,this.b=e||Object.create(null),this.c=[],this.a=document.createElement("select"),this.a.className="monaco-select-box",typeof this.b.ariaLabel=="string"&&this.a.setAttribute("aria-label",this.b.ariaLabel),typeof this.b.ariaDescription=="string"&&this.a.setAttribute("aria-description",this.b.ariaDescription),this.g=this.B(new O.$he),this.h=m,this.j(),this.setOptions(A,$)}j(){this.B(n.$WS.addTarget(this.a)),[n.EventType.Tap].forEach(A=>{this.B(i.$nR(this.a,A,$=>{this.a.focus()}))}),this.B(i.$oR(this.a,"click",A=>{i.$iS.stop(A,!0)})),this.B(i.$oR(this.a,"change",A=>{this.a.title=A.target.value,this.g.fire({index:A.target.selectedIndex,selected:A.target.value})})),this.B(i.$oR(this.a,"keydown",A=>{let $=!1;y.$j?(A.keyCode===T.KeyCode.DownArrow||A.keyCode===T.KeyCode.UpArrow||A.keyCode===T.KeyCode.Space)&&($=!0):(A.keyCode===T.KeyCode.DownArrow&&A.altKey||A.keyCode===T.KeyCode.Space||A.keyCode===T.KeyCode.Enter)&&($=!0),$&&A.stopPropagation()}))}get onDidSelect(){return this.g.event}setOptions(A,$){(!this.c||!B.$ub(this.c,A))&&(this.c=A,this.a.options.length=0,this.c.forEach((m,e)=>{this.a.add(this.m(m.text,e,m.isDisabled))})),$!==void 0&&this.select($)}select(A){this.c.length===0?this.f=0:A>=0&&A<this.c.length?this.f=A:A>this.c.length-1?this.select(this.c.length-1):this.f<0&&(this.f=0),this.a.selectedIndex=this.f,this.f<this.c.length&&typeof this.c[this.f].text=="string"?this.a.title=this.c[this.f].text:this.a.title=""}setAriaLabel(A){this.b.ariaLabel=A,this.a.setAttribute("aria-label",A)}focus(){this.a&&(this.a.tabIndex=0,this.a.focus())}blur(){this.a&&(this.a.tabIndex=-1,this.a.blur())}setEnabled(A){this.a.disabled=!A}setFocusable(A){this.a.tabIndex=A?0:-1}render(A){A.classList.add("select-container"),A.appendChild(this.a),this.setOptions(this.c,this.f),this.applyStyles()}style(A){this.h=A,this.applyStyles()}applyStyles(){this.a&&(this.a.style.backgroundColor=this.h.selectBackground??"",this.a.style.color=this.h.selectForeground??"",this.a.style.borderColor=this.h.selectBorder??"")}m(A,$,m){const e=document.createElement("option");return e.value=A,e.text=A,e.disabled=!!m,e}}t.$8T=f}),define(pe[75],we([1,0,33,9,12,62,103,3,35]),function(oe,t,i,n,B,O,T,v,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$HV=void 0,t.$FV=f,t.$GV=w;function f(m){return typeof m=="object"&&"visibility"in m&&"data"in m}function w(m){switch(m){case!0:return i.TreeVisibility.Visible;case!1:return i.TreeVisibility.Hidden;default:return m}}function A(m){return typeof m.collapsible=="boolean"}class ${constructor(e,s,o,h={}){this.p=e,this.q=s,this.rootRef=[],this.d=new v.$pe,this.f=new v.$he,this.onDidChangeCollapseState=this.d.wrapEvent(this.f.event),this.g=new v.$he,this.onDidChangeRenderNodeCount=this.d.wrapEvent(this.g.event),this.m=new v.$he,this.onDidSplice=this.m.event,this.o=new B.$xh(O.$ce),this.h=typeof h.collapseByDefault>"u"?!1:h.collapseByDefault,this.j=h.allowNonCollapsibleParents??!1,this.k=h.filter,this.l=typeof h.autoExpandSingleChildren>"u"?!1:h.autoExpandSingleChildren,this.c={parent:void 0,element:o,children:[],depth:0,visibleChildrenCount:0,visibleChildIndex:-1,collapsible:!1,collapsed:!1,renderNodeCount:0,visibility:i.TreeVisibility.Visible,visible:!0,filterData:void 0}}splice(e,s,o=y.Iterable.empty(),h={}){if(e.length===0)throw new i.$DV(this.p,"Invalid tree location");h.diffIdentityProvider?this.s(h.diffIdentityProvider,e,s,o,h):this.t(e,s,o,h)}s(e,s,o,h=y.Iterable.empty(),c,b=c.diffDepth??0){const{parentNode:k}=this.H(s);if(!k.lastDiffIds)return this.t(s,o,h,c);const E=[...h],r=s[s.length-1],d=new T.$Uv({getElements:()=>k.lastDiffIds},{getElements:()=>[...k.children.slice(0,r),...E,...k.children.slice(r+o)].map(x=>e.getId(x.element).toString())}).ComputeDiff(!1);if(d.quitEarly)return k.lastDiffIds=void 0,this.t(s,o,E,c);const D=s.slice(0,-1),R=(x,p,M)=>{if(b>0)for(let U=0;U<M;U++)x--,p--,this.s(e,[...D,x,0],Number.MAX_SAFE_INTEGER,E[p].children,c,b-1)};let _=Math.min(k.children.length,r+o),H=E.length;for(const x of d.changes.sort((p,M)=>M.originalStart-p.originalStart))R(_,H,_-(x.originalStart+x.originalLength)),_=x.originalStart,H=x.modifiedStart-r,this.t([...D,_],x.originalLength,y.Iterable.slice(E,H,H+x.modifiedLength),c);R(_,H,_)}t(e,s,o=y.Iterable.empty(),{onDidCreateNode:h,onDidDeleteNode:c,diffIdentityProvider:b}){const{parentNode:k,listIndex:E,revealed:r,visible:d}=this.H(e),D=[],R=y.Iterable.map(o,W=>this.x(W,k,k.visible?i.TreeVisibility.Visible:i.TreeVisibility.Hidden,r,D,h)),_=e[e.length-1];let H=0;for(let W=_;W>=0&&W<k.children.length;W--){const ne=k.children[W];if(ne.visible){H=ne.visibleChildIndex;break}}const x=[];let p=0,M=0;for(const W of R)x.push(W),M+=W.renderNodeCount,W.visible&&(W.visibleChildIndex=H+p++);const U=(0,n.$5b)(k.children,_,s,x);b?k.lastDiffIds?(0,n.$5b)(k.lastDiffIds,_,s,x.map(W=>b.getId(W.element).toString())):k.lastDiffIds=k.children.map(W=>b.getId(W.element).toString()):k.lastDiffIds=void 0;let N=0;for(const W of U)W.visible&&N++;if(N!==0)for(let W=_+x.length;W<k.children.length;W++){const ne=k.children[W];ne.visible&&(ne.visibleChildIndex-=N)}if(k.visibleChildrenCount+=p-N,r&&d){const W=U.reduce((ne,Q)=>ne+(Q.visible?Q.renderNodeCount:0),0);this.C(k,M-W),this.q.splice(E,W,D)}if(U.length>0&&c){const W=ne=>{c(ne),ne.children.forEach(W)};U.forEach(W)}this.m.fire({insertedNodes:x,deletedNodes:U});let P=k;for(;P;){if(P.visibility===i.TreeVisibility.Recurse){this.o.trigger(()=>this.refilter());break}P=P.parent}}rerender(e){if(e.length===0)throw new i.$DV(this.p,"Invalid tree location");const{node:s,listIndex:o,revealed:h}=this.G(e);s.visible&&h&&this.q.splice(o,1,[s])}updateElementHeight(e,s){if(e.length===0)throw new i.$DV(this.p,"Invalid tree location");const{listIndex:o}=this.G(e);this.q.updateElementHeight(o,s)}has(e){return this.E(e)}getListIndex(e){const{listIndex:s,visible:o,revealed:h}=this.G(e);return o&&h?s:-1}getListRenderCount(e){return this.F(e).renderNodeCount}isCollapsible(e){return this.F(e).collapsible}setCollapsible(e,s){const o=this.F(e);typeof s>"u"&&(s=!o.collapsible);const h={collapsible:s};return this.d.bufferEvents(()=>this.u(e,h))}isCollapsed(e){return this.F(e).collapsed}setCollapsed(e,s,o){const h=this.F(e);typeof s>"u"&&(s=!h.collapsed);const c={collapsed:s,recursive:o||!1};return this.d.bufferEvents(()=>this.u(e,c))}u(e,s){const{node:o,listIndex:h,revealed:c}=this.G(e),b=this.v(o,h,c,s);if(o!==this.c&&this.l&&b&&!A(s)&&o.collapsible&&!o.collapsed&&!s.recursive){let k=-1;for(let E=0;E<o.children.length;E++)if(o.children[E].visible)if(k>-1){k=-1;break}else k=E;k>-1&&this.u([...e,k],s)}return b}v(e,s,o,h){const c=this.w(e,h,!1);if(!o||!e.visible||!c)return c;const b=e.renderNodeCount,k=this.y(e),E=b-(s===-1?0:1);return this.q.splice(s+1,E,k.slice(1)),c}w(e,s,o){let h;if(e===this.c?h=!1:(A(s)?(h=e.collapsible!==s.collapsible,e.collapsible=s.collapsible):e.collapsible?(h=e.collapsed!==s.collapsed,e.collapsed=s.collapsed):h=!1,h&&this.f.fire({node:e,deep:o})),!A(s)&&s.recursive)for(const c of e.children)h=this.w(c,s,!0)||h;return h}expandTo(e){this.d.bufferEvents(()=>{let s=this.F(e);for(;s.parent;)s=s.parent,e=e.slice(0,e.length-1),s.collapsed&&this.u(e,{collapsed:!1,recursive:!1})})}refilter(){const e=this.c.renderNodeCount,s=this.A(this.c);this.q.splice(0,e,s),this.o.cancel()}x(e,s,o,h,c,b){const k={parent:s,element:e.element,children:[],depth:s.depth+1,visibleChildrenCount:0,visibleChildIndex:-1,collapsible:typeof e.collapsible=="boolean"?e.collapsible:typeof e.collapsed<"u",collapsed:typeof e.collapsed>"u"?this.h:e.collapsed,renderNodeCount:1,visibility:i.TreeVisibility.Visible,visible:!0,filterData:void 0},E=this.D(k,o);k.visibility=E,h&&c.push(k);const r=e.children||y.Iterable.empty(),d=h&&E!==i.TreeVisibility.Hidden&&!k.collapsed;let D=0,R=1;for(const _ of r){const H=this.x(_,k,E,d,c,b);k.children.push(H),R+=H.renderNodeCount,H.visible&&(H.visibleChildIndex=D++)}return this.j||(k.collapsible=k.collapsible||k.children.length>0),k.visibleChildrenCount=D,k.visible=E===i.TreeVisibility.Recurse?D>0:E===i.TreeVisibility.Visible,k.visible?k.collapsed||(k.renderNodeCount=R):(k.renderNodeCount=0,h&&c.pop()),b?.(k),k}y(e){const s=e.renderNodeCount,o=[];return this.z(e,o),this.C(e.parent,o.length-s),o}z(e,s){if(e.visible===!1)return 0;if(s.push(e),e.renderNodeCount=1,!e.collapsed)for(const o of e.children)e.renderNodeCount+=this.z(o,s);return this.g.fire(e),e.renderNodeCount}A(e){const s=e.renderNodeCount,o=[];return this.B(e,e.visible?i.TreeVisibility.Visible:i.TreeVisibility.Hidden,o),this.C(e.parent,o.length-s),o}B(e,s,o,h=!0){let c;if(e!==this.c){if(c=this.D(e,s),c===i.TreeVisibility.Hidden)return e.visible=!1,e.renderNodeCount=0,!1;h&&o.push(e)}const b=o.length;e.renderNodeCount=e===this.c?0:1;let k=!1;if(!e.collapsed||c!==i.TreeVisibility.Hidden){let E=0;for(const r of e.children)k=this.B(r,c,o,h&&!e.collapsed)||k,r.visible&&(r.visibleChildIndex=E++);e.visibleChildrenCount=E}else e.visibleChildrenCount=0;return e!==this.c&&(e.visible=c===i.TreeVisibility.Recurse?k:c===i.TreeVisibility.Visible,e.visibility=c),e.visible?e.collapsed||(e.renderNodeCount+=o.length-b):(e.renderNodeCount=0,h&&o.pop()),this.g.fire(e),e.visible}C(e,s){if(s!==0)for(;e;)e.renderNodeCount+=s,this.g.fire(e),e=e.parent}D(e,s){const o=this.k?this.k.filter(e.element,s):i.TreeVisibility.Visible;return typeof o=="boolean"?(e.filterData=void 0,o?i.TreeVisibility.Visible:i.TreeVisibility.Hidden):f(o)?(e.filterData=o.data,w(o.visibility)):(e.filterData=void 0,w(o))}E(e,s=this.c){if(!e||e.length===0)return!0;const[o,...h]=e;return o<0||o>s.children.length?!1:this.E(h,s.children[o])}F(e,s=this.c){if(!e||e.length===0)return s;const[o,...h]=e;if(o<0||o>s.children.length)throw new i.$DV(this.p,"Invalid tree location");return this.F(h,s.children[o])}G(e){if(e.length===0)return{node:this.c,listIndex:-1,revealed:!0,visible:!1};const{parentNode:s,listIndex:o,revealed:h,visible:c}=this.H(e),b=e[e.length-1];if(b<0||b>s.children.length)throw new i.$DV(this.p,"Invalid tree location");const k=s.children[b];return{node:k,listIndex:o,revealed:h,visible:c&&k.visible}}H(e,s=this.c,o=0,h=!0,c=!0){const[b,...k]=e;if(b<0||b>s.children.length)throw new i.$DV(this.p,"Invalid tree location");for(let E=0;E<b;E++)o+=s.children[E].renderNodeCount;return h=h&&!s.collapsed,c=c&&s.visible,k.length===0?{parentNode:s,listIndex:o,revealed:h,visible:c}:this.H(k,s.children[b],o+1,h,c)}getNode(e=[]){return this.F(e)}getNodeLocation(e){const s=[];let o=e;for(;o.parent;)s.push(o.parent.children.indexOf(o)),o=o.parent;return s.reverse()}getParentNodeLocation(e){if(e.length!==0)return e.length===1?[]:(0,n.$tb)(e)[0]}getFirstElementChild(e){const s=this.F(e);if(s.children.length!==0)return s.children[0].element}getLastElementAncestor(e=[]){const s=this.F(e);if(s.children.length!==0)return this.I(s)}I(e){return e.children.length===0?e.element:this.I(e.children[e.children.length-1])}}t.$HV=$}),define(pe[139],we([1,0,75,33,35]),function(oe,t,i,n,B){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$OV=void 0;class O{get size(){return this.d.size}constructor(v,y,f={}){this.k=v,this.rootRef=null,this.d=new Map,this.f=new Map,this.c=new i.$HV(v,y,null,f),this.onDidSplice=this.c.onDidSplice,this.onDidChangeCollapseState=this.c.onDidChangeCollapseState,this.onDidChangeRenderNodeCount=this.c.onDidChangeRenderNodeCount,f.sorter&&(this.j={compare(w,A){return f.sorter.compare(w.element,A.element)}}),this.h=f.identityProvider}setChildren(v,y=B.Iterable.empty(),f={}){const w=this.o(v);this.l(w,this.m(y),f)}l(v,y=B.Iterable.empty(),f){const w=new Set,A=new Set,$=e=>{if(e.element===null)return;const s=e;if(w.add(s.element),this.d.set(s.element,s),this.h){const o=this.h.getId(s.element).toString();A.add(o),this.f.set(o,s)}f.onDidCreateNode?.(s)},m=e=>{if(e.element===null)return;const s=e;if(w.has(s.element)||this.d.delete(s.element),this.h){const o=this.h.getId(s.element).toString();A.has(o)||this.f.delete(o)}f.onDidDeleteNode?.(s)};this.c.splice([...v,0],Number.MAX_VALUE,y,{...f,onDidCreateNode:$,onDidDeleteNode:m})}m(v=B.Iterable.empty()){return this.j&&(v=[...v].sort(this.j.compare.bind(this.j))),B.Iterable.map(v,y=>{let f=this.d.get(y.element);if(!f&&this.h){const $=this.h.getId(y.element).toString();f=this.f.get($)}if(!f){let $;return typeof y.collapsed>"u"?$=void 0:y.collapsed===n.ObjectTreeElementCollapseState.Collapsed||y.collapsed===n.ObjectTreeElementCollapseState.PreserveOrCollapsed?$=!0:y.collapsed===n.ObjectTreeElementCollapseState.Expanded||y.collapsed===n.ObjectTreeElementCollapseState.PreserveOrExpanded?$=!1:$=!!y.collapsed,{...y,children:this.m(y.children),collapsed:$}}const w=typeof y.collapsible=="boolean"?y.collapsible:f.collapsible;let A;return typeof y.collapsed>"u"||y.collapsed===n.ObjectTreeElementCollapseState.PreserveOrCollapsed||y.collapsed===n.ObjectTreeElementCollapseState.PreserveOrExpanded?A=f.collapsed:y.collapsed===n.ObjectTreeElementCollapseState.Collapsed?A=!0:y.collapsed===n.ObjectTreeElementCollapseState.Expanded?A=!1:A=!!y.collapsed,{...y,collapsible:w,collapsed:A,children:this.m(y.children)}})}rerender(v){const y=this.o(v);this.c.rerender(y)}updateElementHeight(v,y){const f=this.o(v);this.c.updateElementHeight(f,y)}resort(v=null,y=!0){if(!this.j)return;const f=this.o(v),w=this.c.getNode(f);this.l(f,this.n(w,y),{})}n(v,y,f=!0){let w=[...v.children];return(y||f)&&(w=w.sort(this.j.compare.bind(this.j))),B.Iterable.map(w,A=>({element:A.element,collapsible:A.collapsible,collapsed:A.collapsed,children:this.n(A,y,!1)}))}getFirstElementChild(v=null){const y=this.o(v);return this.c.getFirstElementChild(y)}getLastElementAncestor(v=null){const y=this.o(v);return this.c.getLastElementAncestor(y)}has(v){return this.d.has(v)}getListIndex(v){const y=this.o(v);return this.c.getListIndex(y)}getListRenderCount(v){const y=this.o(v);return this.c.getListRenderCount(y)}isCollapsible(v){const y=this.o(v);return this.c.isCollapsible(y)}setCollapsible(v,y){const f=this.o(v);return this.c.setCollapsible(f,y)}isCollapsed(v){const y=this.o(v);return this.c.isCollapsed(y)}setCollapsed(v,y,f){const w=this.o(v);return this.c.setCollapsed(w,y,f)}expandTo(v){const y=this.o(v);this.c.expandTo(y)}refilter(){this.c.refilter()}getNode(v=null){if(v===null)return this.c.getNode(this.c.rootRef);const y=this.d.get(v);if(!y)throw new n.$DV(this.k,`Tree element not found: ${v}`);return y}getNodeLocation(v){return v.element}getParentNodeLocation(v){if(v===null)throw new n.$DV(this.k,"Invalid getParentNodeLocation call");const y=this.d.get(v);if(!y)throw new n.$DV(this.k,`Tree element not found: ${v}`);const f=this.c.getNodeLocation(y),w=this.c.getParentNodeLocation(f);return this.c.getNode(w).element}o(v){if(v===null)return[];const y=this.d.get(v);if(!y)throw new n.$DV(this.k,`Tree element not found: ${v}`);return this.c.getNodeLocation(y)}}t.$OV=O}),define(pe[24],we([1,0,4,16,23,31,2]),function(oe,t,i,n,B,O,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$1S=void 0;class v extends T.$Uc{f(f,w){this.B(i.$nR(f,i.$gS.CLICK,A=>w(new B.$fR(i.getWindow(f),A))))}j(f,w){this.B(i.$nR(f,i.$gS.MOUSE_DOWN,A=>w(new B.$fR(i.getWindow(f),A))))}m(f,w){this.B(i.$nR(f,i.$gS.MOUSE_OVER,A=>w(new B.$fR(i.getWindow(f),A))))}u(f,w){this.B(i.$nR(f,i.$gS.MOUSE_LEAVE,A=>w(new B.$fR(i.getWindow(f),A))))}z(f,w){this.B(i.$nR(f,i.$gS.KEY_DOWN,A=>w(new n.$kR(A))))}C(f,w){this.B(i.$nR(f,i.$gS.KEY_UP,A=>w(new n.$kR(A))))}D(f,w){this.B(i.$nR(f,i.$gS.INPUT,w))}F(f,w){this.B(i.$nR(f,i.$gS.BLUR,w))}G(f,w){this.B(i.$nR(f,i.$gS.FOCUS,w))}H(f,w){this.B(i.$nR(f,i.$gS.CHANGE,w))}I(f){return O.$WS.ignoreTarget(f)}}t.$1S=v}),define(pe[53],we([1,0,72,24,12,22,4]),function(oe,t,i,n,B,O,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$3S=t.$2S=void 0,t.$2S=11;class v extends n.$1S{constructor(f){super(),this.a=f.onActivate,this.bgDomNode=document.createElement("div"),this.bgDomNode.className="arrow-background",this.bgDomNode.style.position="absolute",this.bgDomNode.style.width=f.bgWidth+"px",this.bgDomNode.style.height=f.bgHeight+"px",typeof f.top<"u"&&(this.bgDomNode.style.top="0px"),typeof f.left<"u"&&(this.bgDomNode.style.left="0px"),typeof f.bottom<"u"&&(this.bgDomNode.style.bottom="0px"),typeof f.right<"u"&&(this.bgDomNode.style.right="0px"),this.domNode=document.createElement("div"),this.domNode.className=f.className,this.domNode.classList.add(...O.ThemeIcon.asClassNameArray(f.icon)),this.domNode.style.position="absolute",this.domNode.style.width=t.$2S+"px",this.domNode.style.height=t.$2S+"px",typeof f.top<"u"&&(this.domNode.style.top=f.top+"px"),typeof f.left<"u"&&(this.domNode.style.left=f.left+"px"),typeof f.bottom<"u"&&(this.domNode.style.bottom=f.bottom+"px"),typeof f.right<"u"&&(this.domNode.style.right=f.right+"px"),this.g=this.B(new i.$ZS),this.B(T.$oR(this.bgDomNode,T.$gS.POINTER_DOWN,w=>this.h(w))),this.B(T.$oR(this.domNode,T.$gS.POINTER_DOWN,w=>this.h(w))),this.b=this.B(new T.$zR),this.c=this.B(new B.$Kh)}h(f){if(!f.target||!(f.target instanceof Element))return;const w=()=>{this.b.cancelAndSet(()=>this.a(),1e3/24,T.getWindow(f))};this.a(),this.b.cancel(),this.c.cancelAndSet(w,200),this.g.startMonitoring(f.target,f.pointerId,f.buttons,A=>{},()=>{this.b.cancel(),this.c.cancel()}),f.preventDefault()}}t.$3S=v}),define(pe[76],we([1,0,4,56,72,53,137,24,5]),function(oe,t,i,n,B,O,T,v,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$6S=void 0;const f=140;class w extends v.$1S{constructor($){super(),this.g=$.lazyRender,this.a=$.host,this.b=$.scrollable,this.c=$.scrollByPage,this.h=$.scrollbarState,this.n=this.B(new T.$5S($.visibility,"visible scrollbar "+$.extraScrollbarClassName,"invisible scrollbar "+$.extraScrollbarClassName)),this.n.setIsNeeded(this.h.isNeeded()),this.r=this.B(new B.$ZS),this.s=!0,this.domNode=(0,n.$YS)(document.createElement("div")),this.domNode.setAttribute("role","presentation"),this.domNode.setAttribute("aria-hidden","true"),this.n.setDomNode(this.domNode),this.domNode.setPosition("absolute"),this.B(i.$nR(this.domNode.domNode,i.$gS.POINTER_DOWN,m=>this.M(m)))}t($){const m=this.B(new O.$3S($));this.domNode.domNode.appendChild(m.bgDomNode),this.domNode.domNode.appendChild(m.domNode)}w($,m,e,s){this.slider=(0,n.$YS)(document.createElement("div")),this.slider.setClassName("slider"),this.slider.setPosition("absolute"),this.slider.setTop($),this.slider.setLeft(m),typeof e=="number"&&this.slider.setWidth(e),typeof s=="number"&&this.slider.setHeight(s),this.slider.setLayerHinting(!0),this.slider.setContain("strict"),this.domNode.domNode.appendChild(this.slider.domNode),this.B(i.$nR(this.slider.domNode,i.$gS.POINTER_DOWN,o=>{o.button===0&&(o.preventDefault(),this.O(o))})),this.f(this.slider.domNode,o=>{o.leftButton&&o.stopPropagation()})}y($){return this.h.setVisibleSize($)&&(this.n.setIsNeeded(this.h.isNeeded()),this.s=!0,this.g||this.render()),this.s}J($){return this.h.setScrollSize($)&&(this.n.setIsNeeded(this.h.isNeeded()),this.s=!0,this.g||this.render()),this.s}L($){return this.h.setScrollPosition($)&&(this.n.setIsNeeded(this.h.isNeeded()),this.s=!0,this.g||this.render()),this.s}beginReveal(){this.n.setShouldBeVisible(!0)}beginHide(){this.n.setShouldBeVisible(!1)}render(){this.s&&(this.s=!1,this.Q(this.h.getRectangleLargeSize(),this.h.getRectangleSmallSize()),this.R(this.h.getSliderSize(),this.h.getArrowSize()+this.h.getSliderPosition()))}M($){$.target===this.domNode.domNode&&this.N($)}delegatePointerDown($){const m=this.domNode.domNode.getClientRects()[0].top,e=m+this.h.getSliderPosition(),s=m+this.h.getSliderPosition()+this.h.getSliderSize(),o=this.U($);e<=o&&o<=s?$.button===0&&($.preventDefault(),this.O($)):this.N($)}N($){let m,e;if($.target===this.domNode.domNode&&typeof $.offsetX=="number"&&typeof $.offsetY=="number")m=$.offsetX,e=$.offsetY;else{const o=i.$JR(this.domNode.domNode);m=$.pageX-o.left,e=$.pageY-o.top}const s=this.S(m,e);this.P(this.c?this.h.getDesiredScrollPositionFromOffsetPaged(s):this.h.getDesiredScrollPositionFromOffset(s)),$.button===0&&($.preventDefault(),this.O($))}O($){if(!$.target||!($.target instanceof Element))return;const m=this.U($),e=this.W($),s=this.h.clone();this.slider.toggleClassName("active",!0),this.r.startMonitoring($.target,$.pointerId,$.buttons,o=>{const h=this.W(o),c=Math.abs(h-e);if(y.$i&&c>f){this.P(s.getScrollPosition());return}const k=this.U(o)-m;this.P(s.getDesiredScrollPositionFromDelta(k))},()=>{this.slider.toggleClassName("active",!1),this.a.onDragEnd()}),this.a.onDragStart()}P($){const m={};this.writeScrollPosition(m,$),this.b.setScrollPositionNow(m)}updateScrollbarSize($){this.X($),this.h.setScrollbarSize($),this.s=!0,this.g||this.render()}isNeeded(){return this.h.isNeeded()}}t.$6S=w}),define(pe[140],we([1,0,23,76,53,57,21,20]),function(oe,t,i,n,B,O,T,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$7S=void 0;class y extends n.$6S{constructor(w,A,$){const m=w.getScrollDimensions(),e=w.getCurrentScrollPosition();if(super({lazyRender:A.lazyRender,host:$,scrollbarState:new O.$4S(A.horizontalHasArrows?A.arrowSize:0,A.horizontal===v.ScrollbarVisibility.Hidden?0:A.horizontalScrollbarSize,A.vertical===v.ScrollbarVisibility.Hidden?0:A.verticalScrollbarSize,m.width,m.scrollWidth,e.scrollLeft),visibility:A.horizontal,extraScrollbarClassName:"horizontal",scrollable:w,scrollByPage:A.scrollByPage}),A.horizontalHasArrows){const s=(A.arrowSize-B.$2S)/2,o=(A.horizontalScrollbarSize-B.$2S)/2;this.t({className:"scra",icon:T.$Zj.scrollbarButtonLeft,top:o,left:s,bottom:void 0,right:void 0,bgWidth:A.arrowSize,bgHeight:A.horizontalScrollbarSize,onActivate:()=>this.a.onMouseWheel(new i.$hR(null,1,0))}),this.t({className:"scra",icon:T.$Zj.scrollbarButtonRight,top:o,left:void 0,bottom:void 0,right:s,bgWidth:A.arrowSize,bgHeight:A.horizontalScrollbarSize,onActivate:()=>this.a.onMouseWheel(new i.$hR(null,-1,0))})}this.w(Math.floor((A.horizontalScrollbarSize-A.horizontalSliderSize)/2),0,void 0,A.horizontalSliderSize)}R(w,A){this.slider.setWidth(w),this.slider.setLeft(A)}Q(w,A){this.domNode.setWidth(w),this.domNode.setHeight(A),this.domNode.setLeft(0),this.domNode.setBottom(0)}onDidScroll(w){return this.s=this.J(w.scrollWidth)||this.s,this.s=this.L(w.scrollLeft)||this.s,this.s=this.y(w.width)||this.s,this.s}S(w,A){return w}U(w){return w.pageX}W(w){return w.pageY}X(w){this.slider.setHeight(w)}writeScrollPosition(w,A){w.scrollLeft=A}updateOptions(w){this.updateScrollbarSize(w.horizontal===v.ScrollbarVisibility.Hidden?0:w.horizontalScrollbarSize),this.h.setOppositeScrollbarSize(w.vertical===v.ScrollbarVisibility.Hidden?0:w.verticalScrollbarSize),this.n.setVisibility(w.horizontal),this.c=w.scrollByPage}}t.$7S=y}),define(pe[141],we([1,0,23,76,53,57,21,20]),function(oe,t,i,n,B,O,T,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$8S=void 0;class y extends n.$6S{constructor(w,A,$){const m=w.getScrollDimensions(),e=w.getCurrentScrollPosition();if(super({lazyRender:A.lazyRender,host:$,scrollbarState:new O.$4S(A.verticalHasArrows?A.arrowSize:0,A.vertical===v.ScrollbarVisibility.Hidden?0:A.verticalScrollbarSize,0,m.height,m.scrollHeight,e.scrollTop),visibility:A.vertical,extraScrollbarClassName:"vertical",scrollable:w,scrollByPage:A.scrollByPage}),A.verticalHasArrows){const s=(A.arrowSize-B.$2S)/2,o=(A.verticalScrollbarSize-B.$2S)/2;this.t({className:"scra",icon:T.$Zj.scrollbarButtonUp,top:s,left:o,bottom:void 0,right:void 0,bgWidth:A.verticalScrollbarSize,bgHeight:A.arrowSize,onActivate:()=>this.a.onMouseWheel(new i.$hR(null,0,1))}),this.t({className:"scra",icon:T.$Zj.scrollbarButtonDown,top:void 0,left:o,bottom:s,right:void 0,bgWidth:A.verticalScrollbarSize,bgHeight:A.arrowSize,onActivate:()=>this.a.onMouseWheel(new i.$hR(null,0,-1))})}this.w(0,Math.floor((A.verticalScrollbarSize-A.verticalSliderSize)/2),A.verticalSliderSize,void 0)}R(w,A){this.slider.setHeight(w),this.slider.setTop(A)}Q(w,A){this.domNode.setWidth(A),this.domNode.setHeight(w),this.domNode.setRight(0),this.domNode.setTop(0)}onDidScroll(w){return this.s=this.J(w.scrollHeight)||this.s,this.s=this.L(w.scrollTop)||this.s,this.s=this.y(w.height)||this.s,this.s}S(w,A){return A}U(w){return w.pageY}W(w){return w.pageX}X(w){this.slider.setWidth(w)}writeScrollPosition(w,A){w.scrollTop=A}updateOptions(w){this.updateScrollbarSize(w.vertical===v.ScrollbarVisibility.Hidden?0:w.verticalScrollbarSize),this.h.setOppositeScrollbarSize(0),this.n.setVisibility(w.vertical),this.c=w.scrollByPage}}t.$8S=y}),define(pe[77],we([1,0,19,4,56,23,140,141,24,12,3,2,5,20,116]),function(oe,t,i,n,B,O,T,v,y,f,w,A,$,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$aT=t.$_S=t.$$S=t.$0S=t.$9S=void 0;const e=500,s=50,o=!0;class h{constructor(R,_,H){this.timestamp=R,this.deltaX=_,this.deltaY=H,this.score=0}}class c{static{this.INSTANCE=new c}constructor(){this.a=5,this.b=[],this.c=-1,this.d=-1}isPhysicalMouseWheel(){if(this.c===-1&&this.d===-1)return!1;let R=1,_=0,H=1,x=this.d;do{const p=x===this.c?R:Math.pow(2,-H);if(R-=p,_+=this.b[x].score*p,x===this.c)break;x=(this.a+x-1)%this.a,H++}while(!0);return _<=.5}acceptStandardWheelEvent(R){if(i.$8Q){const _=n.getWindow(R.browserEvent),H=(0,i.$1Q)(_);this.accept(Date.now(),R.deltaX*H,R.deltaY*H)}else this.accept(Date.now(),R.deltaX,R.deltaY)}accept(R,_,H){let x=null;const p=new h(R,_,H);this.c===-1&&this.d===-1?(this.b[0]=p,this.c=0,this.d=0):(x=this.b[this.d],this.d=(this.d+1)%this.a,this.d===this.c&&(this.c=(this.c+1)%this.a),this.b[this.d]=p),p.score=this.f(p,x)}f(R,_){if(Math.abs(R.deltaX)>0&&Math.abs(R.deltaY)>0)return 1;let H=.5;if((!this.g(R.deltaX)||!this.g(R.deltaY))&&(H+=.25),_){const x=Math.abs(R.deltaX),p=Math.abs(R.deltaY),M=Math.abs(_.deltaX),U=Math.abs(_.deltaY),N=Math.max(Math.min(x,M),1),P=Math.max(Math.min(p,U),1),W=Math.max(x,M),ne=Math.max(p,U);W%N===0&&ne%P===0&&(H-=.5)}return Math.min(Math.max(H,0),1)}g(R){return Math.abs(Math.round(R)-R)<.01}}t.$9S=c;class b extends y.$1S{get options(){return this.a}constructor(R,_,H){super(),this.O=this.B(new w.$he),this.onScroll=this.O.event,this.P=this.B(new w.$he),this.onWillScroll=this.P.event,R.style.overflow="hidden",this.a=d(_),this.b=H,this.B(this.b.onScroll(p=>{this.P.fire(p),this.S(p),this.O.fire(p)}));const x={onMouseWheel:p=>this.R(p),onDragStart:()=>this.W(),onDragEnd:()=>this.X()};this.c=this.B(new v.$8S(this.b,this.a,x)),this.g=this.B(new T.$7S(this.b,this.a,x)),this.h=document.createElement("div"),this.h.className="monaco-scrollable-element "+this.a.className,this.h.setAttribute("role","presentation"),this.h.style.position="relative",this.h.style.overflow="hidden",this.h.appendChild(R),this.h.appendChild(this.g.domNode.domNode),this.h.appendChild(this.c.domNode.domNode),this.a.useShadows?(this.n=(0,B.$YS)(document.createElement("div")),this.n.setClassName("shadow"),this.h.appendChild(this.n.domNode),this.r=(0,B.$YS)(document.createElement("div")),this.r.setClassName("shadow"),this.h.appendChild(this.r.domNode),this.s=(0,B.$YS)(document.createElement("div")),this.s.setClassName("shadow"),this.h.appendChild(this.s.domNode)):(this.n=null,this.r=null,this.s=null),this.t=this.a.listenOnDomNode||this.h,this.w=[],this.Q(this.a.handleMouseWheel),this.m(this.t,p=>this.Z(p)),this.u(this.t,p=>this.Y(p)),this.L=this.B(new f.$Kh),this.y=!1,this.J=!1,this.M=!0,this.N=!0}dispose(){this.w=(0,A.$Pc)(this.w),super.dispose()}getDomNode(){return this.h}getOverviewRulerLayoutInfo(){return{parent:this.h,insertBefore:this.c.domNode.domNode}}delegateVerticalScrollbarPointerDown(R){this.c.delegatePointerDown(R)}getScrollDimensions(){return this.b.getScrollDimensions()}setScrollDimensions(R){this.b.setScrollDimensions(R,!1)}updateClassName(R){this.a.className=R,$.$j&&(this.a.className+=" mac"),this.h.className="monaco-scrollable-element "+this.a.className}updateOptions(R){typeof R.handleMouseWheel<"u"&&(this.a.handleMouseWheel=R.handleMouseWheel,this.Q(this.a.handleMouseWheel)),typeof R.mouseWheelScrollSensitivity<"u"&&(this.a.mouseWheelScrollSensitivity=R.mouseWheelScrollSensitivity),typeof R.fastScrollSensitivity<"u"&&(this.a.fastScrollSensitivity=R.fastScrollSensitivity),typeof R.scrollPredominantAxis<"u"&&(this.a.scrollPredominantAxis=R.scrollPredominantAxis),typeof R.horizontal<"u"&&(this.a.horizontal=R.horizontal),typeof R.vertical<"u"&&(this.a.vertical=R.vertical),typeof R.horizontalScrollbarSize<"u"&&(this.a.horizontalScrollbarSize=R.horizontalScrollbarSize),typeof R.verticalScrollbarSize<"u"&&(this.a.verticalScrollbarSize=R.verticalScrollbarSize),typeof R.scrollByPage<"u"&&(this.a.scrollByPage=R.scrollByPage),this.g.updateOptions(this.a),this.c.updateOptions(this.a),this.a.lazyRender||this.U()}setRevealOnScroll(R){this.N=R}delegateScrollFromMouseWheelEvent(R){this.R(new O.$hR(R))}Q(R){if(this.w.length>0!==R&&(this.w=(0,A.$Pc)(this.w),R)){const H=x=>{this.R(new O.$hR(x))};this.w.push(n.$nR(this.t,n.$gS.MOUSE_WHEEL,H,{passive:!1}))}}R(R){if(R.browserEvent?.defaultPrevented)return;const _=c.INSTANCE;o&&_.acceptStandardWheelEvent(R);let H=!1;if(R.deltaY||R.deltaX){let p=R.deltaY*this.a.mouseWheelScrollSensitivity,M=R.deltaX*this.a.mouseWheelScrollSensitivity;this.a.scrollPredominantAxis&&(this.a.scrollYToX&&M+p===0?M=p=0:Math.abs(p)>=Math.abs(M)?M=0:p=0),this.a.flipAxes&&([p,M]=[M,p]);const U=!$.$j&&R.browserEvent&&R.browserEvent.shiftKey;(this.a.scrollYToX||U)&&!M&&(M=p,p=0),R.browserEvent&&R.browserEvent.altKey&&(M=M*this.a.fastScrollSensitivity,p=p*this.a.fastScrollSensitivity);const N=this.b.getFutureScrollPosition();let P={};if(p){const W=s*p,ne=N.scrollTop-(W<0?Math.floor(W):Math.ceil(W));this.c.writeScrollPosition(P,ne)}if(M){const W=s*M,ne=N.scrollLeft-(W<0?Math.floor(W):Math.ceil(W));this.g.writeScrollPosition(P,ne)}P=this.b.validateScrollPosition(P),(N.scrollLeft!==P.scrollLeft||N.scrollTop!==P.scrollTop)&&(o&&this.a.mouseWheelSmoothScroll&&_.isPhysicalMouseWheel()?this.b.setScrollPositionSmooth(P):this.b.setScrollPositionNow(P),H=!0)}let x=H;!x&&this.a.alwaysConsumeMouseWheel&&(x=!0),!x&&this.a.consumeMouseWheelIfScrollbarIsNeeded&&(this.c.isNeeded()||this.g.isNeeded())&&(x=!0),x&&(R.preventDefault(),R.stopPropagation())}S(R){this.M=this.g.onDidScroll(R)||this.M,this.M=this.c.onDidScroll(R)||this.M,this.a.useShadows&&(this.M=!0),this.N&&this.$(),this.a.lazyRender||this.U()}renderNow(){if(!this.a.lazyRender)throw new Error("Please use `lazyRender` together with `renderNow`!");this.U()}U(){if(this.M&&(this.M=!1,this.g.render(),this.c.render(),this.a.useShadows)){const R=this.b.getCurrentScrollPosition(),_=R.scrollTop>0,H=R.scrollLeft>0,x=H?" left":"",p=_?" top":"",M=H||_?" top-left-corner":"";this.n.setClassName(`shadow${x}`),this.r.setClassName(`shadow${p}`),this.s.setClassName(`shadow${M}${p}${x}`)}}W(){this.y=!0,this.$()}X(){this.y=!1,this.ab()}Y(R){this.J=!1,this.ab()}Z(R){this.J=!0,this.$()}$(){this.c.beginReveal(),this.g.beginReveal(),this.bb()}ab(){!this.J&&!this.y&&(this.c.beginHide(),this.g.beginHide())}bb(){!this.J&&!this.y&&this.L.cancelAndSet(()=>this.ab(),e)}}t.$0S=b;class k extends b{constructor(R,_){_=_||{},_.mouseWheelSmoothScroll=!1;const H=new m.$eu({forceIntegerValues:!0,smoothScrollDuration:0,scheduleAtNextAnimationFrame:x=>n.$xR(n.getWindow(R),x)});super(R,_,H),this.B(H)}setScrollPosition(R){this.b.setScrollPositionNow(R)}getScrollPosition(){return this.b.getCurrentScrollPosition()}}t.$$S=k;class E extends b{constructor(R,_,H){super(R,_,H)}setScrollPosition(R){R.reuseAnimation?this.b.setScrollPositionSmooth(R,R.reuseAnimation):this.b.setScrollPositionNow(R)}getScrollPosition(){return this.b.getCurrentScrollPosition()}}t.$_S=E;class r extends b{constructor(R,_){_=_||{},_.mouseWheelSmoothScroll=!1;const H=new m.$eu({forceIntegerValues:!1,smoothScrollDuration:0,scheduleAtNextAnimationFrame:x=>n.$xR(n.getWindow(R),x)});super(R,_,H),this.B(H),this.cb=R,this.B(this.onScroll(x=>{x.scrollTopChanged&&(this.cb.scrollTop=x.scrollTop),x.scrollLeftChanged&&(this.cb.scrollLeft=x.scrollLeft)})),this.scanDomNode()}setScrollPosition(R){this.b.setScrollPositionNow(R)}getScrollPosition(){return this.b.getCurrentScrollPosition()}scanDomNode(){this.setScrollDimensions({width:this.cb.clientWidth,scrollWidth:this.cb.scrollWidth,height:this.cb.clientHeight,scrollHeight:this.cb.scrollHeight}),this.setScrollPosition({scrollLeft:this.cb.scrollLeft,scrollTop:this.cb.scrollTop})}}t.$aT=r;function d(D){const R={lazyRender:typeof D.lazyRender<"u"?D.lazyRender:!1,className:typeof D.className<"u"?D.className:"",useShadows:typeof D.useShadows<"u"?D.useShadows:!0,handleMouseWheel:typeof D.handleMouseWheel<"u"?D.handleMouseWheel:!0,flipAxes:typeof D.flipAxes<"u"?D.flipAxes:!1,consumeMouseWheelIfScrollbarIsNeeded:typeof D.consumeMouseWheelIfScrollbarIsNeeded<"u"?D.consumeMouseWheelIfScrollbarIsNeeded:!1,alwaysConsumeMouseWheel:typeof D.alwaysConsumeMouseWheel<"u"?D.alwaysConsumeMouseWheel:!1,scrollYToX:typeof D.scrollYToX<"u"?D.scrollYToX:!1,mouseWheelScrollSensitivity:typeof D.mouseWheelScrollSensitivity<"u"?D.mouseWheelScrollSensitivity:1,fastScrollSensitivity:typeof D.fastScrollSensitivity<"u"?D.fastScrollSensitivity:5,scrollPredominantAxis:typeof D.scrollPredominantAxis<"u"?D.scrollPredominantAxis:!0,mouseWheelSmoothScroll:typeof D.mouseWheelSmoothScroll<"u"?D.mouseWheelSmoothScroll:!0,arrowSize:typeof D.arrowSize<"u"?D.arrowSize:11,listenOnDomNode:typeof D.listenOnDomNode<"u"?D.listenOnDomNode:null,horizontal:typeof D.horizontal<"u"?D.horizontal:m.ScrollbarVisibility.Auto,horizontalScrollbarSize:typeof D.horizontalScrollbarSize<"u"?D.horizontalScrollbarSize:10,horizontalSliderSize:typeof D.horizontalSliderSize<"u"?D.horizontalSliderSize:0,horizontalHasArrows:typeof D.horizontalHasArrows<"u"?D.horizontalHasArrows:!1,vertical:typeof D.vertical<"u"?D.vertical:m.ScrollbarVisibility.Auto,verticalScrollbarSize:typeof D.verticalScrollbarSize<"u"?D.verticalScrollbarSize:10,verticalHasArrows:typeof D.verticalHasArrows<"u"?D.verticalHasArrows:!1,verticalSliderSize:typeof D.verticalSliderSize<"u"?D.verticalSliderSize:0,scrollByPage:typeof D.scrollByPage<"u"?D.scrollByPage:!1};return R.horizontalSliderSize=typeof D.horizontalSliderSize<"u"?D.horizontalSliderSize:R.horizontalScrollbarSize,R.verticalSliderSize=typeof D.verticalSliderSize<"u"?D.verticalSliderSize:R.verticalScrollbarSize,$.$j&&(R.className+=" mac"),R}}),define(pe[78],we([1,0,70,4,27,31,77,9,12,34,3,2,47,20,40,96,136,6,44]),function(oe,t,i,n,B,O,T,v,y,f,w,A,$,m,e,s,o,h,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ET=t.$DT=t.$CT=t.$BT=t.ListViewTargetSector=void 0;const b={CurrentDragAndDropData:void 0};var k;(function(x){x[x.TOP=0]="TOP",x[x.CENTER_TOP=1]="CENTER_TOP",x[x.CENTER_BOTTOM=2]="CENTER_BOTTOM",x[x.BOTTOM=3]="BOTTOM"})(k||(t.ListViewTargetSector=k={}));const E={useShadows:!0,verticalScrollMode:m.ScrollbarVisibility.Auto,setRowLineHeight:!0,setRowHeight:!0,supportDynamicHeights:!1,dnd:{getDragElements(x){return[x]},getDragURI(){return null},onDragStart(){},onDragOver(){return!1},drop(){},dispose(){}},horizontalScrolling:!1,transformOptimization:!0,alwaysConsumeMouseWheel:!0};class r{get context(){return this.d}set context(p){this.d=p}constructor(p){this.elements=p}update(){}getData(){return this.elements}}t.$BT=r;class d{constructor(p){this.elements=p}update(){}getData(){return this.elements}}t.$CT=d;class D{constructor(){this.types=[],this.files=[]}update(p){if(p.types&&this.types.splice(0,this.types.length,...p.types),p.files){this.files.splice(0,this.files.length);for(let M=0;M<p.files.length;M++){const U=p.files.item(M);U&&(U.size||U.type)&&this.files.push(U)}}}getData(){return{types:this.types,files:this.files}}}t.$DT=D;function R(x,p){return Array.isArray(x)&&Array.isArray(p)?(0,v.$ub)(x,p):x===p}class _{constructor(p){p?.getSetSize?this.getSetSize=p.getSetSize.bind(p):this.getSetSize=(M,U,N)=>N,p?.getPosInSet?this.getPosInSet=p.getPosInSet.bind(p):this.getPosInSet=(M,U)=>U+1,p?.getRole?this.getRole=p.getRole.bind(p):this.getRole=M=>"listitem",p?.isChecked?this.isChecked=p.isChecked.bind(p):this.isChecked=M=>{}}}class H{static{this.c=0}get contentHeight(){return this.g.size}get contentWidth(){return this.E??0}get onDidScroll(){return this.q.onScroll}get onWillScroll(){return this.q.onWillScroll}get containerDomNode(){return this.o}get scrollableElementDomNode(){return this.q.getDomNode()}get Q(){return this.P}set Q(p){if(p!==this.P){if(p&&this.B)throw new Error("Horizontal scrolling and dynamic heights not supported simultaneously");if(this.P=p,this.domNode.classList.toggle("horizontal-scrolling",this.P),this.P){for(const M of this.d)this.ab(M);this.X(),this.q.setScrollDimensions({width:(0,n.$MR)(this.domNode)}),this.o.style.width=`${Math.max(this.E||0,this.n)}px`}else this.u.cancel(),this.q.setScrollDimensions({width:this.n,scrollWidth:this.n}),this.o.style.width=""}}constructor(p,M,U,N=E){if(this.R=M,this.domId=`list_id_${++H.c}`,this.j=new Map,this.n=0,this.s=0,this.t=null,this.u=new y.$xh(50),this.v=!1,this.x=A.$Uc.None,this.y=0,this.G=!1,this.K=A.$Uc.None,this.L=A.$Uc.None,this.M=new A.$Tc,this.N=new w.$he,this.O=new w.$he,this.onDidChangeContentHeight=w.Event.latch(this.N.event,void 0,this.M),this.onDidChangeContentWidth=w.Event.latch(this.O.event,void 0,this.M),this.P=!1,N.horizontalScrolling&&N.supportDynamicHeights)throw new Error("Horizontal scrolling and dynamic heights not supported simultaneously");this.d=[],this.f=0,this.g=this.S(N.paddingTop??0);for(const W of U)this.j.set(W.templateId,W);this.h=this.M.add(new o.$AT(this.j)),this.k=0,this.m=0,this.domNode=document.createElement("div"),this.domNode.className="monaco-list",this.domNode.classList.add(this.domId),this.domNode.tabIndex=0,this.domNode.classList.toggle("mouse-support",typeof N.mouseSupport=="boolean"?N.mouseSupport:!0),this.P=N.horizontalScrolling??E.horizontalScrolling,this.domNode.classList.toggle("horizontal-scrolling",this.P),this.C=typeof N.paddingBottom>"u"?0:N.paddingBottom,this.D=new _(N.accessibilityProvider),this.o=document.createElement("div"),this.o.className="monaco-list-rows",(N.transformOptimization??E.transformOptimization)&&(this.o.style.transform="translate3d(0px, 0px, 0px)",this.o.style.overflow="hidden",this.o.style.contain="strict"),this.M.add(O.$WS.addTarget(this.o)),this.p=this.M.add(new m.$eu({forceIntegerValues:!0,smoothScrollDuration:N.smoothScrolling??!1?125:0,scheduleAtNextAnimationFrame:W=>(0,n.$xR)((0,n.getWindow)(this.domNode),W)})),this.q=this.M.add(new T.$_S(this.o,{alwaysConsumeMouseWheel:N.alwaysConsumeMouseWheel??E.alwaysConsumeMouseWheel,horizontal:m.ScrollbarVisibility.Auto,vertical:N.verticalScrollMode??E.verticalScrollMode,useShadows:N.useShadows??E.useShadows,mouseWheelScrollSensitivity:N.mouseWheelScrollSensitivity,fastScrollSensitivity:N.fastScrollSensitivity,scrollByPage:N.scrollByPage},this.p)),this.domNode.appendChild(this.q.getDomNode()),p.appendChild(this.domNode),this.q.onScroll(this.ib,this,this.M),this.M.add((0,n.$nR)(this.o,O.EventType.Change,W=>this.jb(W))),this.M.add((0,n.$nR)(this.q.getDomNode(),"scroll",W=>W.target.scrollTop=0)),this.M.add((0,n.$nR)(this.domNode,"dragover",W=>this.lb(this.hb(W)))),this.M.add((0,n.$nR)(this.domNode,"drop",W=>this.nb(this.hb(W)))),this.M.add((0,n.$nR)(this.domNode,"dragleave",W=>this.mb(this.hb(W)))),this.M.add((0,n.$nR)(this.domNode,"dragend",W=>this.ob(W))),this.z=N.setRowLineHeight??E.setRowLineHeight,this.A=N.setRowHeight??E.setRowHeight,this.B=N.supportDynamicHeights??E.supportDynamicHeights,this.F=N.dnd??this.M.add(E.dnd),this.layout(N.initialSize?.height,N.initialSize?.width)}updateOptions(p){p.paddingBottom!==void 0&&(this.C=p.paddingBottom,this.q.setScrollDimensions({scrollHeight:this.scrollHeight})),p.smoothScrolling!==void 0&&this.p.setSmoothScrollDuration(p.smoothScrolling?125:0),p.horizontalScrolling!==void 0&&(this.Q=p.horizontalScrolling);let M;if(p.scrollByPage!==void 0&&(M={...M??{},scrollByPage:p.scrollByPage}),p.mouseWheelScrollSensitivity!==void 0&&(M={...M??{},mouseWheelScrollSensitivity:p.mouseWheelScrollSensitivity}),p.fastScrollSensitivity!==void 0&&(M={...M??{},fastScrollSensitivity:p.fastScrollSensitivity}),M&&this.q.updateOptions(M),p.paddingTop!==void 0&&p.paddingTop!==this.g.paddingTop){const U=this.vb(this.k,this.m),N=p.paddingTop-this.g.paddingTop;this.g.paddingTop=p.paddingTop,this.Y(U,Math.max(0,this.k+N),this.m,void 0,void 0,!0),this.setScrollTop(this.k),this.V(),this.B&&this.wb(this.k,this.m)}}delegateScrollFromMouseWheelEvent(p){this.q.delegateScrollFromMouseWheelEvent(p)}delegateVerticalScrollbarPointerDown(p){this.q.delegateVerticalScrollbarPointerDown(p)}updateElementHeight(p,M,U){if(p<0||p>=this.d.length)return;const N=this.d[p].size;if(typeof M>"u"){if(!this.B){console.warn("Dynamic heights not supported");return}this.d[p].lastDynamicHeightWidth=void 0,M=N+this.xb(p)}if(N===M)return;const P=this.vb(this.k,this.m);let W=0;p<P.start||U!==null&&U>p&&U<P.end?W=M-N:W=0,this.g.splice(p,1,[{size:M}]),this.d[p].size=M,this.Y(P,Math.max(0,this.k+W),this.m,void 0,void 0,!0),this.setScrollTop(this.k),this.V(),this.B&&this.wb(this.k,this.m)}S(p){return new s.$zT(p)}splice(p,M,U=[]){if(this.v)throw new Error("Can't run recursive splices.");this.v=!0;try{return this.U(p,M,U)}finally{this.v=!1,this.N.fire(this.contentHeight)}}U(p,M,U=[]){const N=this.vb(this.k,this.m),P={start:p,end:p+M},W=$.Range.intersect(N,P),ne=new Map;for(let me=W.end-1;me>=W.start;me--){const ye=this.d[me];if(ye.dragStartDisposable.dispose(),ye.checkedDisposable.dispose(),ye.row){let Oe=ne.get(ye.templateId);Oe||(Oe=[],ne.set(ye.templateId,Oe));const Ie=this.j.get(ye.templateId);Ie&&Ie.disposeElement&&Ie.disposeElement(ye.element,me,ye.row.templateData,ye.size),Oe.unshift(ye.row)}ye.row=null,ye.stale=!0}const Q={start:p+M,end:this.d.length},Y=$.Range.intersect(Q,N),te=$.Range.relativeComplement(Q,N),de=U.map(me=>({id:String(this.f++),element:me,templateId:this.R.getTemplateId(me),size:this.R.getHeight(me),width:void 0,hasDynamicHeight:!!this.R.hasDynamicHeight&&this.R.hasDynamicHeight(me),lastDynamicHeightWidth:void 0,row:null,uri:void 0,dropTarget:!1,dragStartDisposable:A.$Uc.None,checkedDisposable:A.$Uc.None,stale:!1}));let De;p===0&&M>=this.d.length?(this.g=this.S(this.g.paddingTop),this.g.splice(0,0,de),De=this.d,this.d=de):(this.g.splice(p,M,de),De=this.d.splice(p,M,...de));const Le=U.length-M,Se=this.vb(this.k,this.m),ue=(0,s.$xT)(Y,Le),J=$.Range.intersect(Se,ue);for(let me=J.start;me<J.end;me++)this.bb(this.d[me],me);const fe=$.Range.relativeComplement(ue,Se);for(const me of fe)for(let ye=me.start;ye<me.end;ye++)this.db(ye);const le=te.map(me=>(0,s.$xT)(me,Le)),Z=[{start:p,end:p+U.length},...le].map(me=>$.Range.intersect(Se,me)).reverse();for(const me of Z)for(let ye=me.end-1;ye>=me.start;ye--){const Oe=this.d[ye],je=ne.get(Oe.templateId)?.pop();this.Z(ye,je)}for(const me of ne.values())for(const ye of me)this.h.release(ye);return this.V(),this.B&&this.wb(this.scrollTop,this.renderHeight),De.map(me=>me.element)}V(){this.s=this.contentHeight,this.o.style.height=`${this.s}px`,this.t||(this.t=(0,n.$xR)((0,n.getWindow)(this.domNode),()=>{this.q.setScrollDimensions({scrollHeight:this.scrollHeight}),this.X(),this.t=null}))}W(){if(!this.Q){this.u.cancel();return}this.u.trigger(()=>this.X())}X(){if(!this.Q)return;let p=0;for(const M of this.d)typeof M.width<"u"&&(p=Math.max(p,M.width));this.E=p,this.q.setScrollDimensions({scrollWidth:p===0?0:p+10}),this.O.fire(this.E)}updateWidth(p){if(!this.Q||typeof this.E>"u")return;const M=this.d[p];this.ab(M),typeof M.width<"u"&&M.width>this.E&&(this.E=M.width,this.q.setScrollDimensions({scrollWidth:this.E+10}),this.O.fire(this.E))}rerender(){if(this.B){for(const p of this.d)p.lastDynamicHeightWidth=void 0;this.wb(this.k,this.m)}}get length(){return this.d.length}get renderHeight(){return this.q.getScrollDimensions().height}get firstVisibleIndex(){return this.vb(this.k,this.m).start}get firstMostlyVisibleIndex(){const p=this.firstVisibleIndex,M=this.g.positionAt(p),U=this.g.positionAt(p+1);return U!==-1&&(U-M)/2+M<this.scrollTop?p+1:p}get lastVisibleIndex(){return this.vb(this.k,this.m).end-1}element(p){return this.d[p].element}indexOf(p){return this.d.findIndex(M=>M.element===p)}domElement(p){const M=this.d[p].row;return M&&M.domNode}elementHeight(p){return this.d[p].size}elementTop(p){return this.g.positionAt(p)}indexAt(p){return this.g.indexAt(p)}indexAfter(p){return this.g.indexAfter(p)}layout(p,M){const U={height:typeof p=="number"?p:(0,n.$OR)(this.domNode)};this.t&&(this.t.dispose(),this.t=null,U.scrollHeight=this.scrollHeight),this.q.setScrollDimensions(U),typeof M<"u"&&(this.n=M,this.B&&this.wb(this.scrollTop,this.renderHeight)),this.Q&&this.q.setScrollDimensions({width:typeof M=="number"?M:(0,n.$MR)(this.domNode)})}Y(p,M,U,N,P,W=!1){const ne=this.vb(M,U),Q=$.Range.relativeComplement(ne,p).reverse(),Y=$.Range.relativeComplement(p,ne);if(W){const te=$.Range.intersect(p,ne);for(let de=te.start;de<te.end;de++)this.bb(this.d[de],de)}this.h.transact(()=>{for(const te of Y)for(let de=te.start;de<te.end;de++)this.db(de);for(const te of Q)for(let de=te.end-1;de>=te.start;de--)this.Z(de)}),N!==void 0&&(this.o.style.left=`-${N}px`),this.o.style.top=`-${M}px`,this.Q&&P!==void 0&&(this.o.style.width=`${Math.max(P,this.n)}px`),this.k=M,this.m=U}Z(p,M){const U=this.d[p];if(!U.row)if(M)U.row=M,U.stale=!0;else{const Q=this.h.alloc(U.templateId);U.row=Q.row,U.stale||=Q.isReusingConnectedDomNode}const N=this.D.getRole(U.element)||"listitem";U.row.domNode.setAttribute("role",N);const P=this.D.isChecked(U.element);if(typeof P=="boolean")U.row.domNode.setAttribute("aria-checked",String(!!P));else if(P){const Q=Y=>U.row.domNode.setAttribute("aria-checked",String(!!Y));Q(P.value),U.checkedDisposable=P.onDidChange(()=>Q(P.value))}if(U.stale||!U.row.domNode.parentElement){const Q=this.d.at(p+1)?.row?.domNode??null;(U.row.domNode.parentElement!==this.o||U.row.domNode.nextElementSibling!==Q)&&this.o.insertBefore(U.row.domNode,Q),U.stale=!1}this.bb(U,p);const W=this.j.get(U.templateId);if(!W)throw new Error(`No renderer found for template id ${U.templateId}`);W?.renderElement(U.element,p,U.row.templateData,U.size);const ne=this.F.getDragURI(U.element);U.dragStartDisposable.dispose(),U.row.domNode.draggable=!!ne,ne&&(U.dragStartDisposable=(0,n.$nR)(U.row.domNode,"dragstart",Q=>this.kb(U.element,ne,Q))),this.Q&&(this.ab(U),this.W())}ab(p){if(!p.row||!p.row.domNode)return;p.row.domNode.style.width="fit-content",p.width=(0,n.$MR)(p.row.domNode);const M=(0,n.getWindow)(p.row.domNode).getComputedStyle(p.row.domNode);M.paddingLeft&&(p.width+=parseFloat(M.paddingLeft)),M.paddingRight&&(p.width+=parseFloat(M.paddingRight)),p.row.domNode.style.width=""}bb(p,M){p.row.domNode.style.top=`${this.elementTop(M)}px`,this.A&&(p.row.domNode.style.height=`${p.size}px`),this.z&&(p.row.domNode.style.lineHeight=`${p.size}px`),p.row.domNode.setAttribute("data-index",`${M}`),p.row.domNode.setAttribute("data-last-element",M===this.length-1?"true":"false"),p.row.domNode.setAttribute("data-parity",M%2===0?"even":"odd"),p.row.domNode.setAttribute("aria-setsize",String(this.D.getSetSize(p.element,M,this.length))),p.row.domNode.setAttribute("aria-posinset",String(this.D.getPosInSet(p.element,M))),p.row.domNode.setAttribute("id",this.getElementDomId(M)),p.row.domNode.classList.toggle("drop-target",p.dropTarget)}db(p){const M=this.d[p];if(M.dragStartDisposable.dispose(),M.checkedDisposable.dispose(),M.row){const U=this.j.get(M.templateId);U&&U.disposeElement&&U.disposeElement(M.element,p,M.row.templateData,M.size),this.h.release(M.row),M.row=null}this.Q&&this.W()}getScrollTop(){return this.q.getScrollPosition().scrollTop}setScrollTop(p,M){this.t&&(this.t.dispose(),this.t=null,this.q.setScrollDimensions({scrollHeight:this.scrollHeight})),this.q.setScrollPosition({scrollTop:p,reuseAnimation:M})}getScrollLeft(){return this.q.getScrollPosition().scrollLeft}setScrollLeft(p){this.t&&(this.t.dispose(),this.t=null,this.q.setScrollDimensions({scrollWidth:this.E})),this.q.setScrollPosition({scrollLeft:p})}get scrollTop(){return this.getScrollTop()}set scrollTop(p){this.setScrollTop(p)}get scrollHeight(){return this.s+(this.Q?10:0)+this.C}get onMouseClick(){return w.Event.map(this.M.add(new B.$rT(this.domNode,"click")).event,p=>this.eb(p),this.M)}get onMouseDblClick(){return w.Event.map(this.M.add(new B.$rT(this.domNode,"dblclick")).event,p=>this.eb(p),this.M)}get onMouseMiddleClick(){return w.Event.filter(w.Event.map(this.M.add(new B.$rT(this.domNode,"auxclick")).event,p=>this.eb(p),this.M),p=>p.browserEvent.button===1,this.M)}get onMouseUp(){return w.Event.map(this.M.add(new B.$rT(this.domNode,"mouseup")).event,p=>this.eb(p),this.M)}get onMouseDown(){return w.Event.map(this.M.add(new B.$rT(this.domNode,"mousedown")).event,p=>this.eb(p),this.M)}get onMouseOver(){return w.Event.map(this.M.add(new B.$rT(this.domNode,"mouseover")).event,p=>this.eb(p),this.M)}get onMouseMove(){return w.Event.map(this.M.add(new B.$rT(this.domNode,"mousemove")).event,p=>this.eb(p),this.M)}get onMouseOut(){return w.Event.map(this.M.add(new B.$rT(this.domNode,"mouseout")).event,p=>this.eb(p),this.M)}get onContextMenu(){return w.Event.any(w.Event.map(this.M.add(new B.$rT(this.domNode,"contextmenu")).event,p=>this.eb(p),this.M),w.Event.map(this.M.add(new B.$rT(this.domNode,O.EventType.Contextmenu)).event,p=>this.gb(p),this.M))}get onTouchStart(){return w.Event.map(this.M.add(new B.$rT(this.domNode,"touchstart")).event,p=>this.fb(p),this.M)}get onTap(){return w.Event.map(this.M.add(new B.$rT(this.o,O.EventType.Tap)).event,p=>this.gb(p),this.M)}eb(p){const M=this.ub(p.target||null),U=typeof M>"u"?void 0:this.d[M],N=U&&U.element;return{browserEvent:p,index:M,element:N}}fb(p){const M=this.ub(p.target||null),U=typeof M>"u"?void 0:this.d[M],N=U&&U.element;return{browserEvent:p,index:M,element:N}}gb(p){const M=this.ub(p.initialTarget||null),U=typeof M>"u"?void 0:this.d[M],N=U&&U.element;return{browserEvent:p,index:M,element:N}}hb(p){const M=this.ub(p.target||null),U=typeof M>"u"?void 0:this.d[M],N=U&&U.element,P=this.tb(p,M);return{browserEvent:p,index:M,element:N,sector:P}}ib(p){try{const M=this.vb(this.k,this.m);this.Y(M,p.scrollTop,p.height,p.scrollLeft,p.scrollWidth),this.B&&this.wb(p.scrollTop,p.height,p.inSmoothScrolling)}catch(M){throw console.error("Got bad scroll event:",p),M}}jb(p){p.preventDefault(),p.stopPropagation(),this.scrollTop-=p.translationY}kb(p,M,U){if(!U.dataTransfer)return;const N=this.F.getDragElements(p);if(U.dataTransfer.effectAllowed="copyMove",U.dataTransfer.setData(i.$US.TEXT,M),U.dataTransfer.setDragImage){let P;this.F.getDragLabel&&(P=this.F.getDragLabel(N,U)),typeof P>"u"&&(P=String(N.length));const W=(0,n.$)(".monaco-drag-image");W.textContent=P;const Q=(Y=>{for(;Y&&!Y.classList.contains("monaco-workbench");)Y=Y.parentElement;return Y||this.domNode.ownerDocument})(this.domNode);Q.appendChild(W),U.dataTransfer.setDragImage(W,-10,-10),setTimeout(()=>Q.removeChild(W),0)}this.domNode.classList.add("dragging"),this.H=new r(N),b.CurrentDragAndDropData=new d(N),this.F.onDragStart?.(this.H,U)}lb(p){if(p.browserEvent.preventDefault(),this.L.dispose(),b.CurrentDragAndDropData&&b.CurrentDragAndDropData.getData()==="vscode-ui"||(this.qb(p.browserEvent),!p.browserEvent.dataTransfer))return!1;if(!this.H)if(b.CurrentDragAndDropData)this.H=b.CurrentDragAndDropData;else{if(!p.browserEvent.dataTransfer.types)return!1;this.H=new D}const M=this.F.onDragOver(this.H,p.element,p.index,p.sector,p.browserEvent);if(this.G=typeof M=="boolean"?M:M.accept,!this.G)return this.I=void 0,this.K.dispose(),!1;p.browserEvent.dataTransfer.dropEffect=typeof M!="boolean"&&M.effect?.type===e.ListDragOverEffectType.Copy?"copy":"move";let U;typeof M!="boolean"&&M.feedback?U=M.feedback:typeof p.index>"u"?U=[-1]:U=[p.index],U=(0,v.$Mb)(U).filter(P=>P>=-1&&P<this.length).sort((P,W)=>P-W),U=U[0]===-1?[-1]:U;let N=typeof M!="boolean"&&M.effect&&M.effect.position?M.effect.position:e.ListDragOverEffectPosition.Over;if(R(this.I,U)&&this.J===N)return!0;if(this.I=U,this.J=N,this.K.dispose(),U[0]===-1)this.domNode.classList.add(N),this.o.classList.add(N),this.K=(0,A.$Sc)(()=>{this.domNode.classList.remove(N),this.o.classList.remove(N)});else{if(U.length>1&&N!==e.ListDragOverEffectPosition.Over)throw new Error("Can't use multiple feedbacks with position different than 'over'");N===e.ListDragOverEffectPosition.After&&U[0]<this.length-1&&(U[0]+=1,N=e.ListDragOverEffectPosition.Before);for(const P of U){const W=this.d[P];W.dropTarget=!0,W.row?.domNode.classList.add(N)}this.K=(0,A.$Sc)(()=>{for(const P of U){const W=this.d[P];W.dropTarget=!1,W.row?.domNode.classList.remove(N)}})}return!0}mb(p){this.L.dispose(),this.L=(0,y.$Ch)(()=>this.pb(),100,this.M),this.H&&this.F.onDragLeave?.(this.H,p.element,p.index,p.browserEvent)}nb(p){if(!this.G)return;const M=this.H;this.sb(),this.pb(),this.domNode.classList.remove("dragging"),this.H=void 0,b.CurrentDragAndDropData=void 0,!(!M||!p.browserEvent.dataTransfer)&&(p.browserEvent.preventDefault(),M.update(p.browserEvent.dataTransfer),this.F.drop(M,p.element,p.index,p.sector,p.browserEvent))}ob(p){this.G=!1,this.sb(),this.pb(),this.domNode.classList.remove("dragging"),this.H=void 0,b.CurrentDragAndDropData=void 0,this.F.onDragEnd?.(p)}pb(){this.I=void 0,this.J=void 0,this.K.dispose(),this.K=A.$Uc.None}qb(p){if(!this.w){const M=(0,n.$GR)(this.domNode).top;this.w=(0,n.$CS)((0,n.getWindow)(this.domNode),this.rb.bind(this,M))}this.x.dispose(),this.x=(0,y.$Ch)(()=>{this.w&&(this.w.dispose(),this.w=void 0)},1e3,this.M),this.y=p.pageY}rb(p){if(this.y===void 0)return;const M=this.y-p,U=this.renderHeight-35;M<35?this.scrollTop+=Math.max(-14,Math.floor(.3*(M-35))):M>U&&(this.scrollTop+=Math.min(14,Math.floor(.3*(M-U))))}sb(){this.x.dispose(),this.w&&(this.w.dispose(),this.w=void 0)}tb(p,M){if(M===void 0)return;const U=p.offsetY/this.d[M].size,N=Math.floor(U/.25);return(0,c.$Gm)(N,0,3)}ub(p){const M=this.q.getDomNode();let U=p;for(;U instanceof HTMLElement&&U!==this.o&&M.contains(U);){const N=U.getAttribute("data-index");if(N){const P=Number(N);if(!isNaN(P))return P}U=U.parentElement}}vb(p,M){return{start:this.g.indexAt(p),end:this.g.indexAfter(p+M-1)}}wb(p,M,U){const N=this.vb(p,M);let P,W;p===this.elementTop(N.start)?(P=N.start,W=0):N.end-N.start>1&&(P=N.start+1,W=this.elementTop(P)-p);let ne=0;for(;;){const Q=this.vb(p,M);let Y=!1;for(let te=Q.start;te<Q.end;te++){const de=this.xb(te);de!==0&&this.g.splice(te,1,[this.d[te]]),ne+=de,Y=Y||de!==0}if(!Y){ne!==0&&this.V();const te=$.Range.relativeComplement(N,Q);for(const De of te)for(let Le=De.start;Le<De.end;Le++)this.d[Le].row&&this.db(Le);const de=$.Range.relativeComplement(Q,N).reverse();for(const De of de)for(let Le=De.end-1;Le>=De.start;Le--)this.Z(Le);for(let De=Q.start;De<Q.end;De++)this.d[De].row&&this.bb(this.d[De],De);if(typeof P=="number"){const De=this.p.getFutureScrollPosition().scrollTop-p,Le=this.elementTop(P)-W+De;this.setScrollTop(Le,U)}this.N.fire(this.contentHeight);return}}}xb(p){const M=this.d[p];if(this.R.getDynamicHeight){const W=this.R.getDynamicHeight(M.element);if(W!==null){const ne=M.size;return M.size=W,M.lastDynamicHeightWidth=this.n,W-ne}}if(!M.hasDynamicHeight||M.lastDynamicHeightWidth===this.n||this.R.hasDynamicHeight&&!this.R.hasDynamicHeight(M.element))return 0;const U=M.size;if(M.row)return M.row.domNode.style.height="",M.size=M.row.domNode.offsetHeight,M.size===0&&!(0,n.$RR)(M.row.domNode,(0,n.getWindow)(M.row.domNode).document.body)&&console.warn("Measuring item node that is not in DOM! Add ListView to the DOM before measuring row height!"),M.lastDynamicHeightWidth=this.n,M.size-U;const{row:N}=this.h.alloc(M.templateId);N.domNode.style.height="",this.o.appendChild(N.domNode);const P=this.j.get(M.templateId);if(!P)throw new h.$cb("Missing renderer for templateId: "+M.templateId);return P.renderElement(M.element,p,N.templateData,void 0),M.size=N.domNode.offsetHeight,P.disposeElement?.(M.element,p,N.templateData,void 0),this.R.setDynamicHeight?.(M.element,M.size),M.lastDynamicHeightWidth=this.n,this.o.removeChild(N.domNode),this.h.release(N),M.size-U}getElementDomId(p){return`${this.domId}_${p}`}dispose(){for(const p of this.d)if(p.dragStartDisposable.dispose(),p.checkedDisposable.dispose(),p.row){const M=this.j.get(p.row.templateId);M&&(M.disposeElement?.(p.element,-1,p.row.templateData,void 0),M.disposeTemplate(p.row.templateData))}this.d=[],this.domNode&&this.domNode.parentNode&&this.domNode.parentNode.removeChild(this.domNode),this.w?.dispose(),this.M.dispose()}}t.$ET=H,Je([f.$5h],H.prototype,"onMouseClick",null),Je([f.$5h],H.prototype,"onMouseDblClick",null),Je([f.$5h],H.prototype,"onMouseMiddleClick",null),Je([f.$5h],H.prototype,"onMouseUp",null),Je([f.$5h],H.prototype,"onMouseDown",null),Je([f.$5h],H.prototype,"onMouseOver",null),Je([f.$5h],H.prototype,"onMouseMove",null),Je([f.$5h],H.prototype,"onMouseOut",null),Je([f.$5h],H.prototype,"onContextMenu",null),Je([f.$5h],H.prototype,"onTouchStart",null),Je([f.$5h],H.prototype,"onTap",null)}),define(pe[54],we([1,0,4,27,16,31,73,86,9,12,89,34,3,50,8,2,44,5,10,40,78,23,61,115]),function(oe,t,i,n,B,O,T,v,y,f,w,A,$,m,e,s,o,h,c,b,k,E,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$WT=t.$VT=t.$UT=t.$TT=t.$QT=t.TypeNavigationMode=void 0,t.$IT=H,t.$JT=p,t.$KT=M,t.$LT=U,t.$MT=N,t.$NT=P,t.$OT=W,t.$PT=ne,t.$RT=Le,t.$ST=Se;class d{constructor(a){this.d=a,this.c=[]}get templateId(){return`template:${this.d.name}`}renderTemplate(a){return a}renderElement(a,l,g){const I=this.c.findIndex(F=>F.templateData===g);if(I>=0){const F=this.c[I];this.d.unrender(g),F.index=l}else{const F={index:l,templateData:g};this.c.push(F)}this.d.renderIndex(l,g)}splice(a,l,g){const I=[];for(const F of this.c)F.index<a?I.push(F):F.index>=a+l&&I.push({index:F.index+g-l,templateData:F.templateData});this.c=I}renderIndexes(a){for(const{index:l,templateData:g}of this.c)a.indexOf(l)>-1&&this.d.renderIndex(l,g)}disposeTemplate(a){const l=this.c.findIndex(g=>g.templateData===a);l<0||this.c.splice(l,1)}}class D{get name(){return this.g}get renderer(){return new d(this)}constructor(a){this.g=a,this.c=[],this.d=[],this.f=new $.$he,this.onChange=this.f.event}splice(a,l,g){const I=g.length-l,F=a+l,u=[];let L=0;for(;L<this.d.length&&this.d[L]<a;)u.push(this.d[L++]);for(let S=0;S<g.length;S++)g[S]&&u.push(S+a);for(;L<this.d.length&&this.d[L]>=F;)u.push(this.d[L++]+I);this.renderer.splice(a,l,g.length),this.h(u,u)}renderIndex(a,l){l.classList.toggle(this.g,this.contains(a))}unrender(a){a.classList.remove(this.g)}set(a,l){return this.h(a,[...a].sort(Oe),l)}h(a,l,g){const I=this.c,F=this.d;this.c=a,this.d=l;const u=me(F,a);return this.renderer.renderIndexes(u),this.f.fire({indexes:a,browserEvent:g}),I}get(){return this.c}contains(a){return(0,y.$wb)(this.d,a,Oe)>=0}dispose(){(0,s.$Pc)(this.f)}}Je([A.$5h],D.prototype,"renderer",null);class R extends D{constructor(a){super("selected"),this.k=a}renderIndex(a,l){super.renderIndex(a,l),this.k&&(this.contains(a)?l.setAttribute("aria-selected","true"):l.setAttribute("aria-selected","false"))}}class _{constructor(a,l,g){this.c=a,this.d=l,this.f=g}splice(a,l,g){if(!this.f)return this.c.splice(a,l,new Array(g.length).fill(!1));const I=this.c.get().map(L=>this.f.getId(this.d.element(L)).toString());if(I.length===0)return this.c.splice(a,l,new Array(g.length).fill(!1));const F=new Set(I),u=g.map(L=>F.has(this.f.getId(L).toString()));this.c.splice(a,l,u)}}function H(C){return C.tagName==="INPUT"||C.tagName==="TEXTAREA"}function x(C,a){return C.classList.contains(a)?!0:C.classList.contains("monaco-list")||!C.parentElement?!1:x(C.parentElement,a)}function p(C){return x(C,"monaco-editor")}function M(C){return x(C,"monaco-custom-toggle")}function U(C){return x(C,"action-item")}function N(C){return x(C,"monaco-tl-twistie")}function P(C){return x(C,"monaco-tree-sticky-row")}function W(C){return C.classList.contains("monaco-tree-sticky-container")}function ne(C){return C.tagName==="A"&&C.classList.contains("monaco-button")||C.tagName==="DIV"&&C.classList.contains("monaco-button-dropdown")?!0:C.classList.contains("monaco-list")||!C.parentElement?!1:ne(C.parentElement)}class Q{get g(){return $.Event.chain(this.c.add(new n.$rT(this.k.domNode,"keydown")).event,a=>a.filter(l=>!H(l.target)).map(l=>new B.$kR(l)))}constructor(a,l,g){this.h=a,this.k=l,this.c=new s.$Tc,this.d=new s.$Tc,this.f=g.multipleSelectionSupport,this.c.add(this.g(I=>{switch(I.keyCode){case e.KeyCode.Enter:return this.l(I);case e.KeyCode.UpArrow:return this.o(I);case e.KeyCode.DownArrow:return this.p(I);case e.KeyCode.PageUp:return this.q(I);case e.KeyCode.PageDown:return this.s(I);case e.KeyCode.Escape:return this.u(I);case e.KeyCode.KeyA:this.f&&(h.$j?I.metaKey:I.ctrlKey)&&this.t(I)}}))}updateOptions(a){a.multipleSelectionSupport!==void 0&&(this.f=a.multipleSelectionSupport)}l(a){a.preventDefault(),a.stopPropagation(),this.h.setSelection(this.h.getFocus(),a.browserEvent)}o(a){a.preventDefault(),a.stopPropagation(),this.h.focusPrevious(1,!1,a.browserEvent);const l=this.h.getFocus()[0];this.h.setAnchor(l),this.h.reveal(l),this.k.domNode.focus()}p(a){a.preventDefault(),a.stopPropagation(),this.h.focusNext(1,!1,a.browserEvent);const l=this.h.getFocus()[0];this.h.setAnchor(l),this.h.reveal(l),this.k.domNode.focus()}q(a){a.preventDefault(),a.stopPropagation(),this.h.focusPreviousPage(a.browserEvent);const l=this.h.getFocus()[0];this.h.setAnchor(l),this.h.reveal(l),this.k.domNode.focus()}s(a){a.preventDefault(),a.stopPropagation(),this.h.focusNextPage(a.browserEvent);const l=this.h.getFocus()[0];this.h.setAnchor(l),this.h.reveal(l),this.k.domNode.focus()}t(a){a.preventDefault(),a.stopPropagation(),this.h.setSelection((0,y.$Rb)(this.h.length),a.browserEvent),this.h.setAnchor(void 0),this.k.domNode.focus()}u(a){this.h.getSelection().length&&(a.preventDefault(),a.stopPropagation(),this.h.setSelection([],a.browserEvent),this.h.setAnchor(void 0),this.k.domNode.focus())}dispose(){this.c.dispose(),this.d.dispose()}}Je([A.$5h],Q.prototype,"g",null);var Y;(function(C){C[C.Automatic=0]="Automatic",C[C.Trigger=1]="Trigger"})(Y||(t.TypeNavigationMode=Y={}));var te;(function(C){C[C.Idle=0]="Idle",C[C.Typing=1]="Typing"})(te||(te={})),t.$QT=new class{mightProducePrintableCharacter(C){return C.ctrlKey||C.metaKey||C.altKey?!1:C.keyCode>=e.KeyCode.KeyA&&C.keyCode<=e.KeyCode.KeyZ||C.keyCode>=e.KeyCode.Digit0&&C.keyCode<=e.KeyCode.Digit9||C.keyCode>=e.KeyCode.Numpad0&&C.keyCode<=e.KeyCode.Numpad9||C.keyCode>=e.KeyCode.Semicolon&&C.keyCode<=e.KeyCode.Quote}};class de{constructor(a,l,g,I,F){this.o=a,this.p=l,this.q=g,this.s=I,this.t=F,this.c=!1,this.d=te.Idle,this.f=Y.Automatic,this.g=!1,this.h=-1,this.k=new s.$Tc,this.l=new s.$Tc,this.updateOptions(a.options)}updateOptions(a){a.typeNavigationEnabled??!0?this.u():this.v(),this.f=a.typeNavigationMode??Y.Automatic}trigger(){this.g=!this.g}u(){if(this.c)return;let a=!1;const l=$.Event.chain(this.k.add(new n.$rT(this.p.domNode,"keydown")).event,F=>F.filter(u=>!H(u.target)).filter(()=>this.f===Y.Automatic||this.g).map(u=>new B.$kR(u)).filter(u=>a||this.s(u)).filter(u=>this.t.mightProducePrintableCharacter(u)).forEach(u=>i.$iS.stop(u,!0)).map(u=>u.browserEvent.key)),g=$.Event.debounce(l,()=>null,800,void 0,void 0,void 0,this.k);$.Event.reduce($.Event.any(l,g),(F,u)=>u===null?null:(F||"")+u,void 0,this.k)(this.x,this,this.k),g(this.w,this,this.k),l(()=>a=!0,void 0,this.k),g(()=>a=!1,void 0,this.k),this.c=!0,this.g=!1}v(){this.c&&(this.k.clear(),this.c=!1,this.g=!1)}w(){const a=this.o.getFocus();if(a.length>0&&a[0]===this.h){const l=this.o.options.accessibilityProvider?.getAriaLabel(this.o.element(a[0]));typeof l=="string"?(0,T.$tT)(l):l&&(0,T.$tT)(l.get())}this.h=-1}x(a){if(!a){this.d=te.Idle,this.g=!1;return}const l=this.o.getFocus(),g=l.length>0?l[0]:0,I=this.d===te.Idle?1:0;this.d=te.Typing;for(let F=0;F<this.o.length;F++){const u=(g+F+I)%this.o.length,L=this.q.getKeyboardNavigationLabel(this.p.element(u)),S=L&&L.toString();if(this.o.options.typeNavigationEnabled){if(typeof S<"u"){if((0,m.$Ck)(a,S)){this.h=g,this.o.setFocus([u]),this.o.reveal(u);return}const j=(0,m.$Jk)(a,S);if(j&&j[0].end-j[0].start>1&&j.length===1){this.h=g,this.o.setFocus([u]),this.o.reveal(u);return}}}else if(typeof S>"u"||(0,m.$Ck)(a,S)){this.h=g,this.o.setFocus([u]),this.o.reveal(u);return}}}dispose(){this.v(),this.k.dispose(),this.l.dispose()}}class De{constructor(a,l){this.d=a,this.f=l,this.c=new s.$Tc;const g=$.Event.chain(this.c.add(new n.$rT(l.domNode,"keydown")).event,F=>F.filter(u=>!H(u.target)).map(u=>new B.$kR(u)));$.Event.chain(g,F=>F.filter(u=>u.keyCode===e.KeyCode.Tab&&!u.ctrlKey&&!u.metaKey&&!u.shiftKey&&!u.altKey))(this.g,this,this.c)}g(a){if(a.target!==this.f.domNode)return;const l=this.d.getFocus();if(l.length===0)return;const g=this.f.domElement(l[0]);if(!g)return;const I=g.querySelector("[tabIndex]");if(!I||!(I instanceof HTMLElement)||I.tabIndex===-1)return;const F=(0,i.getWindow)(I).getComputedStyle(I);F.visibility==="hidden"||F.display==="none"||(a.preventDefault(),a.stopPropagation(),I.focus())}dispose(){this.c.dispose()}}function Le(C){return h.$j?C.browserEvent.metaKey:C.browserEvent.ctrlKey}function Se(C){return C.browserEvent.shiftKey}function ue(C){return(0,i.$cS)(C)&&C.button===2}const J={isSelectionSingleChangeEvent:Le,isSelectionRangeChangeEvent:Se};class fe{constructor(a){this.k=a,this.f=new s.$Tc,this.g=new $.$he,this.onPointer=this.g.event,a.options.multipleSelectionSupport!==!1&&(this.c=this.k.options.multipleSelectionController||J),this.d=typeof a.options.mouseSupport>"u"||!!a.options.mouseSupport,this.d&&(a.onMouseDown(this.s,this,this.f),a.onContextMenu(this.t,this,this.f),a.onMouseDblClick(this.v,this,this.f),a.onTouchStart(this.s,this,this.f),this.f.add(O.$WS.addTarget(a.getHTMLElement()))),$.Event.any(a.onMouseClick,a.onMouseMiddleClick,a.onTap)(this.u,this,this.f)}updateOptions(a){a.multipleSelectionSupport!==void 0&&(this.c=void 0,a.multipleSelectionSupport&&(this.c=this.k.options.multipleSelectionController||J))}o(a){return this.c?this.c.isSelectionSingleChangeEvent(a):!1}p(a){return this.c?this.c.isSelectionRangeChangeEvent(a):!1}q(a){return this.o(a)||this.p(a)}s(a){p(a.browserEvent.target)||(0,i.$ZR)()!==a.browserEvent.target&&this.k.domFocus()}t(a){if(H(a.browserEvent.target)||p(a.browserEvent.target))return;const l=typeof a.index>"u"?[]:[a.index];this.k.setFocus(l,a.browserEvent)}u(a){if(!this.d||H(a.browserEvent.target)||p(a.browserEvent.target)||a.browserEvent.isHandledByList)return;a.browserEvent.isHandledByList=!0;const l=a.index;if(typeof l>"u"){this.k.setFocus([],a.browserEvent),this.k.setSelection([],a.browserEvent),this.k.setAnchor(void 0);return}if(this.q(a))return this.w(a);this.k.setFocus([l],a.browserEvent),this.k.setAnchor(l),ue(a.browserEvent)||this.k.setSelection([l],a.browserEvent),this.g.fire(a)}v(a){if(H(a.browserEvent.target)||p(a.browserEvent.target)||this.q(a)||a.browserEvent.isHandledByList)return;a.browserEvent.isHandledByList=!0;const l=this.k.getFocus();this.k.setSelection(l,a.browserEvent)}w(a){const l=a.index;let g=this.k.getAnchor();if(this.p(a)){typeof g>"u"&&(g=this.k.getFocus()[0]??l,this.k.setAnchor(g));const I=Math.min(g,l),F=Math.max(g,l),u=(0,y.$Rb)(I,F+1),L=this.k.getSelection(),S=Z(me(L,[g]),g);if(S.length===0)return;const j=me(u,ye(L,S));this.k.setSelection(j,a.browserEvent),this.k.setFocus([l],a.browserEvent)}else if(this.o(a)){const I=this.k.getSelection(),F=I.filter(u=>u!==l);this.k.setFocus([l]),this.k.setAnchor(l),I.length===F.length?this.k.setSelection([...F,l],a.browserEvent):this.k.setSelection(F,a.browserEvent)}}dispose(){this.f.dispose()}}t.$TT=fe;class le{constructor(a,l){this.c=a,this.d=l}style(a){const l=this.d&&`.${this.d}`,g=[];a.listBackground&&g.push(`.monaco-list${l} .monaco-list-rows { background: ${a.listBackground}; }`),a.listFocusBackground&&(g.push(`.monaco-list${l}:focus .monaco-list-row.focused { background-color: ${a.listFocusBackground}; }`),g.push(`.monaco-list${l}:focus .monaco-list-row.focused:hover { background-color: ${a.listFocusBackground}; }`)),a.listFocusForeground&&g.push(`.monaco-list${l}:focus .monaco-list-row.focused { color: ${a.listFocusForeground}; }`),a.listActiveSelectionBackground&&(g.push(`.monaco-list${l}:focus .monaco-list-row.selected { background-color: ${a.listActiveSelectionBackground}; }`),g.push(`.monaco-list${l}:focus .monaco-list-row.selected:hover { background-color: ${a.listActiveSelectionBackground}; }`)),a.listActiveSelectionForeground&&g.push(`.monaco-list${l}:focus .monaco-list-row.selected { color: ${a.listActiveSelectionForeground}; }`),a.listActiveSelectionIconForeground&&g.push(`.monaco-list${l}:focus .monaco-list-row.selected .codicon { color: ${a.listActiveSelectionIconForeground}; }`),a.listFocusAndSelectionBackground&&g.push(`
				.monaco-drag-image,
				.monaco-list${l}:focus .monaco-list-row.selected.focused { background-color: ${a.listFocusAndSelectionBackground}; }
			`),a.listFocusAndSelectionForeground&&g.push(`
				.monaco-drag-image,
				.monaco-list${l}:focus .monaco-list-row.selected.focused { color: ${a.listFocusAndSelectionForeground}; }
			`),a.listInactiveFocusForeground&&(g.push(`.monaco-list${l} .monaco-list-row.focused { color:  ${a.listInactiveFocusForeground}; }`),g.push(`.monaco-list${l} .monaco-list-row.focused:hover { color:  ${a.listInactiveFocusForeground}; }`)),a.listInactiveSelectionIconForeground&&g.push(`.monaco-list${l} .monaco-list-row.focused .codicon { color:  ${a.listInactiveSelectionIconForeground}; }`),a.listInactiveFocusBackground&&(g.push(`.monaco-list${l} .monaco-list-row.focused { background-color:  ${a.listInactiveFocusBackground}; }`),g.push(`.monaco-list${l} .monaco-list-row.focused:hover { background-color:  ${a.listInactiveFocusBackground}; }`)),a.listInactiveSelectionBackground&&(g.push(`.monaco-list${l} .monaco-list-row.selected { background-color:  ${a.listInactiveSelectionBackground}; }`),g.push(`.monaco-list${l} .monaco-list-row.selected:hover { background-color:  ${a.listInactiveSelectionBackground}; }`)),a.listInactiveSelectionForeground&&g.push(`.monaco-list${l} .monaco-list-row.selected { color: ${a.listInactiveSelectionForeground}; }`),a.listHoverBackground&&g.push(`.monaco-list${l}:not(.drop-target):not(.dragging) .monaco-list-row:hover:not(.selected):not(.focused) { background-color: ${a.listHoverBackground}; }`),a.listHoverForeground&&g.push(`.monaco-list${l}:not(.drop-target):not(.dragging) .monaco-list-row:hover:not(.selected):not(.focused) { color:  ${a.listHoverForeground}; }`);const I=(0,i.$FS)(a.listFocusAndSelectionOutline,(0,i.$FS)(a.listSelectionOutline,a.listFocusOutline??""));I&&g.push(`.monaco-list${l}:focus .monaco-list-row.focused.selected { outline: 1px solid ${I}; outline-offset: -1px;}`),a.listFocusOutline&&g.push(`
				.monaco-drag-image,
				.monaco-list${l}:focus .monaco-list-row.focused { outline: 1px solid ${a.listFocusOutline}; outline-offset: -1px; }
				.monaco-workbench.context-menu-visible .monaco-list${l}.last-focused .monaco-list-row.focused { outline: 1px solid ${a.listFocusOutline}; outline-offset: -1px; }
			`);const F=(0,i.$FS)(a.listSelectionOutline,a.listInactiveFocusOutline??"");F&&g.push(`.monaco-list${l} .monaco-list-row.focused.selected { outline: 1px dotted ${F}; outline-offset: -1px; }`),a.listSelectionOutline&&g.push(`.monaco-list${l} .monaco-list-row.selected { outline: 1px dotted ${a.listSelectionOutline}; outline-offset: -1px; }`),a.listInactiveFocusOutline&&g.push(`.monaco-list${l} .monaco-list-row.focused { outline: 1px dotted ${a.listInactiveFocusOutline}; outline-offset: -1px; }`),a.listHoverOutline&&g.push(`.monaco-list${l} .monaco-list-row:hover { outline: 1px dashed ${a.listHoverOutline}; outline-offset: -1px; }`),a.listDropOverBackground&&g.push(`
				.monaco-list${l}.drop-target,
				.monaco-list${l} .monaco-list-rows.drop-target,
				.monaco-list${l} .monaco-list-row.drop-target { background-color: ${a.listDropOverBackground} !important; color: inherit !important; }
			`),a.listDropBetweenBackground&&(g.push(`
			.monaco-list${l} .monaco-list-rows.drop-target-before .monaco-list-row:first-child::before,
			.monaco-list${l} .monaco-list-row.drop-target-before::before {
				content: ""; position: absolute; top: 0px; left: 0px; width: 100%; height: 1px;
				background-color: ${a.listDropBetweenBackground};
			}`),g.push(`
			.monaco-list${l} .monaco-list-rows.drop-target-after .monaco-list-row:last-child::after,
			.monaco-list${l} .monaco-list-row.drop-target-after::after {
				content: ""; position: absolute; bottom: 0px; left: 0px; width: 100%; height: 1px;
				background-color: ${a.listDropBetweenBackground};
			}`)),a.tableColumnsBorder&&g.push(`
				.monaco-table > .monaco-split-view2,
				.monaco-table > .monaco-split-view2 .monaco-sash.vertical::before,
				.monaco-workbench:not(.reduce-motion) .monaco-table:hover > .monaco-split-view2,
				.monaco-workbench:not(.reduce-motion) .monaco-table:hover > .monaco-split-view2 .monaco-sash.vertical::before {
					border-color: ${a.tableColumnsBorder};
				}

				.monaco-workbench:not(.reduce-motion) .monaco-table > .monaco-split-view2,
				.monaco-workbench:not(.reduce-motion) .monaco-table > .monaco-split-view2 .monaco-sash.vertical::before {
					border-color: transparent;
				}
			`),a.tableOddRowsBackgroundColor&&g.push(`
				.monaco-table .monaco-list-row[data-parity=odd]:not(.focused):not(.selected):not(:hover) .monaco-table-tr,
				.monaco-table .monaco-list:not(:focus) .monaco-list-row[data-parity=odd].focused:not(.selected):not(:hover) .monaco-table-tr,
				.monaco-table .monaco-list:not(.focused) .monaco-list-row[data-parity=odd].focused:not(.selected):not(:hover) .monaco-table-tr {
					background-color: ${a.tableOddRowsBackgroundColor};
				}
			`),this.c.textContent=g.join(`
`)}}t.$UT=le,t.$VT={listFocusBackground:"#7FB0D0",listActiveSelectionBackground:"#0E639C",listActiveSelectionForeground:"#FFFFFF",listActiveSelectionIconForeground:"#FFFFFF",listFocusAndSelectionOutline:"#90C2F9",listFocusAndSelectionBackground:"#094771",listFocusAndSelectionForeground:"#FFFFFF",listInactiveSelectionBackground:"#3F3F46",listInactiveSelectionIconForeground:"#FFFFFF",listHoverBackground:"#2A2D2E",listDropOverBackground:"#383B3D",listDropBetweenBackground:"#EEEEEE",treeIndentGuidesStroke:"#a9a9a9",treeInactiveIndentGuidesStroke:w.$7s.fromHex("#a9a9a9").transparent(.4).toString(),tableColumnsBorder:w.$7s.fromHex("#cccccc").transparent(.2).toString(),tableOddRowsBackgroundColor:w.$7s.fromHex("#cccccc").transparent(.04).toString(),listBackground:void 0,listFocusForeground:void 0,listInactiveSelectionForeground:void 0,listInactiveFocusForeground:void 0,listInactiveFocusBackground:void 0,listHoverForeground:void 0,listFocusOutline:void 0,listInactiveFocusOutline:void 0,listSelectionOutline:void 0,listHoverOutline:void 0,treeStickyScrollBackground:void 0,treeStickyScrollBorder:void 0,treeStickyScrollShadow:void 0};const ke={keyboardSupport:!0,mouseSupport:!0,multipleSelectionSupport:!0,dnd:{getDragURI(){return null},onDragStart(){},onDragOver(){return!1},drop(){},dispose(){}}};function Z(C,a){const l=C.indexOf(a);if(l===-1)return[];const g=[];let I=l-1;for(;I>=0&&C[I]===a-(l-I);)g.push(C[I--]);for(g.reverse(),I=l;I<C.length&&C[I]===a+(I-l);)g.push(C[I++]);return g}function me(C,a){const l=[];let g=0,I=0;for(;g<C.length||I<a.length;)if(g>=C.length)l.push(a[I++]);else if(I>=a.length)l.push(C[g++]);else if(C[g]===a[I]){l.push(C[g]),g++,I++;continue}else C[g]<a[I]?l.push(C[g++]):l.push(a[I++]);return l}function ye(C,a){const l=[];let g=0,I=0;for(;g<C.length||I<a.length;)if(g>=C.length)l.push(a[I++]);else if(I>=a.length)l.push(C[g++]);else if(C[g]===a[I]){g++,I++;continue}else C[g]<a[I]?l.push(C[g++]):I++;return l}const Oe=(C,a)=>C-a;class Ie{constructor(a,l){this.c=a,this.d=l}get templateId(){return this.c}renderTemplate(a){return this.d.map(l=>l.renderTemplate(a))}renderElement(a,l,g,I){let F=0;for(const u of this.d)u.renderElement(a,l,g[F++],I)}disposeElement(a,l,g,I){let F=0;for(const u of this.d)u.disposeElement?.(a,l,g[F],I),F+=1}disposeTemplate(a){let l=0;for(const g of this.d)g.disposeTemplate(a[l++])}}class je{constructor(a){this.c=a,this.templateId="a18n"}renderTemplate(a){return{container:a,disposables:new s.$Tc}}renderElement(a,l,g){const I=this.c.getAriaLabel(a),F=I&&typeof I!="string"?I:(0,r.constObservable)(I);g.disposables.add((0,r.autorun)(L=>{this.d(L.readObservable(F),g.container)}));const u=this.c.getAriaLevel&&this.c.getAriaLevel(a);typeof u=="number"?g.container.setAttribute("aria-level",`${u}`):g.container.removeAttribute("aria-level")}d(a,l){a?l.setAttribute("aria-label",a):l.removeAttribute("aria-label")}disposeElement(a,l,g,I){g.disposables.clear()}disposeTemplate(a){a.disposables.dispose()}}class ie{constructor(a,l){this.c=a,this.d=l}getDragElements(a){const l=this.c.getSelectedElements();return l.indexOf(a)>-1?l:[a]}getDragURI(a){return this.d.getDragURI(a)}getDragLabel(a,l){if(this.d.getDragLabel)return this.d.getDragLabel(a,l)}onDragStart(a,l){this.d.onDragStart?.(a,l)}onDragOver(a,l,g,I,F){return this.d.onDragOver(a,l,g,I,F)}onDragLeave(a,l,g,I){this.d.onDragLeave?.(a,l,g,I)}onDragEnd(a){this.d.onDragEnd?.(a)}drop(a,l,g,I,F){this.d.drop(a,l,g,I,F)}dispose(){this.d.dispose()}}class K{get onDidChangeFocus(){return $.Event.map(this.g.wrapEvent(this.c.onChange),a=>this.G(a),this.y)}get onDidChangeSelection(){return $.Event.map(this.g.wrapEvent(this.d.onChange),a=>this.G(a),this.y)}get domId(){return this.k.domId}get onDidScroll(){return this.k.onDidScroll}get onMouseClick(){return this.k.onMouseClick}get onMouseDblClick(){return this.k.onMouseDblClick}get onMouseMiddleClick(){return this.k.onMouseMiddleClick}get onPointer(){return this.w.onPointer}get onMouseUp(){return this.k.onMouseUp}get onMouseDown(){return this.k.onMouseDown}get onMouseOver(){return this.k.onMouseOver}get onMouseMove(){return this.k.onMouseMove}get onMouseOut(){return this.k.onMouseOut}get onTouchStart(){return this.k.onTouchStart}get onTap(){return this.k.onTap}get onContextMenu(){let a=!1;const l=$.Event.chain(this.y.add(new n.$rT(this.k.domNode,"keydown")).event,F=>F.map(u=>new B.$kR(u)).filter(u=>a=u.keyCode===e.KeyCode.ContextMenu||u.shiftKey&&u.keyCode===e.KeyCode.F10).map(u=>i.$iS.stop(u,!0)).filter(()=>!1)),g=$.Event.chain(this.y.add(new n.$rT(this.k.domNode,"keyup")).event,F=>F.forEach(()=>a=!1).map(u=>new B.$kR(u)).filter(u=>u.keyCode===e.KeyCode.ContextMenu||u.shiftKey&&u.keyCode===e.KeyCode.F10).map(u=>i.$iS.stop(u,!0)).map(({browserEvent:u})=>{const L=this.getFocus(),S=L.length?L[0]:void 0,j=typeof S<"u"?this.k.element(S):void 0,z=typeof S<"u"?this.k.domElement(S):this.k.domNode;return{index:S,element:j,anchor:z,browserEvent:u}})),I=$.Event.chain(this.k.onContextMenu,F=>F.filter(u=>!a).map(({element:u,index:L,browserEvent:S})=>({element:u,index:L,anchor:new E.$fR((0,i.getWindow)(this.k.domNode),S),browserEvent:S})));return $.Event.any(l,g,I)}get onKeyDown(){return this.y.add(new n.$rT(this.k.domNode,"keydown")).event}get onKeyUp(){return this.y.add(new n.$rT(this.k.domNode,"keyup")).event}get onKeyPress(){return this.y.add(new n.$rT(this.k.domNode,"keypress")).event}get onDidFocus(){return $.Event.signal(this.y.add(new n.$rT(this.k.domNode,"focus",!0)).event)}get onDidBlur(){return $.Event.signal(this.y.add(new n.$rT(this.k.domNode,"blur",!0)).event)}constructor(a,l,g,I,F=ke){this.A=a,this.B=F,this.c=new D("focused"),this.f=new D("anchor"),this.g=new $.$pe,this.x="",this.y=new s.$Tc,this.z=new $.$he,this.onDidDispose=this.z.event;const u=this.B.accessibilityProvider&&this.B.accessibilityProvider.getWidgetRole?this.B.accessibilityProvider?.getWidgetRole():"list";this.d=new R(u!=="listbox");const L=[this.c.renderer,this.d.renderer];this.u=F.accessibilityProvider,this.u&&(L.push(new je(this.u)),this.u.onDidChangeActiveDescendant?.(this.I,this,this.y)),I=I.map(j=>new Ie(j.templateId,[...L,j]));const S={...F,dnd:F.dnd&&new ie(this,F.dnd)};if(this.k=this.C(l,g,I,S),this.k.domNode.setAttribute("role",u),F.styleController)this.q=F.styleController(this.k.domId);else{const j=(0,i.$8R)(this.k.domNode);this.q=new le(j,this.k.domId)}if(this.o=new v.$vT([new _(this.c,this.k,F.identityProvider),new _(this.d,this.k,F.identityProvider),new _(this.f,this.k,F.identityProvider),this.k]),this.y.add(this.c),this.y.add(this.d),this.y.add(this.f),this.y.add(this.k),this.y.add(this.z),this.y.add(new De(this,this.k)),(typeof F.keyboardSupport!="boolean"||F.keyboardSupport)&&(this.v=new Q(this,this.k,F),this.y.add(this.v)),F.keyboardNavigationLabelProvider){const j=F.keyboardNavigationDelegate||t.$QT;this.t=new de(this,this.k,F.keyboardNavigationLabelProvider,F.keyboardNavigationEventFilter??(()=>!0),j),this.y.add(this.t)}this.w=this.D(F),this.y.add(this.w),this.onDidChangeFocus(this.H,this,this.y),this.onDidChangeSelection(this.J,this,this.y),this.u&&(this.ariaLabel=this.u.getWidgetAriaLabel()),this.B.multipleSelectionSupport!==!1&&this.k.domNode.setAttribute("aria-multiselectable","true")}C(a,l,g,I){return new k.$ET(a,l,g,I)}D(a){return new fe(this)}updateOptions(a={}){this.B={...this.B,...a},this.t?.updateOptions(this.B),this.B.multipleSelectionController!==void 0&&(this.B.multipleSelectionSupport?this.k.domNode.setAttribute("aria-multiselectable","true"):this.k.domNode.removeAttribute("aria-multiselectable")),this.w.updateOptions(a),this.v?.updateOptions(a),this.k.updateOptions(a)}get options(){return this.B}splice(a,l,g=[]){if(a<0||a>this.k.length)throw new b.$GT(this.A,`Invalid start index: ${a}`);if(l<0)throw new b.$GT(this.A,`Invalid delete count: ${l}`);l===0&&g.length===0||this.g.bufferEvents(()=>this.o.splice(a,l,g))}updateWidth(a){this.k.updateWidth(a)}updateElementHeight(a,l){this.k.updateElementHeight(a,l,null)}rerender(){this.k.rerender()}element(a){return this.k.element(a)}indexOf(a){return this.k.indexOf(a)}indexAt(a){return this.k.indexAt(a)}get length(){return this.k.length}get contentHeight(){return this.k.contentHeight}get contentWidth(){return this.k.contentWidth}get onDidChangeContentHeight(){return this.k.onDidChangeContentHeight}get onDidChangeContentWidth(){return this.k.onDidChangeContentWidth}get scrollTop(){return this.k.getScrollTop()}set scrollTop(a){this.k.setScrollTop(a)}get scrollLeft(){return this.k.getScrollLeft()}set scrollLeft(a){this.k.setScrollLeft(a)}get scrollHeight(){return this.k.scrollHeight}get renderHeight(){return this.k.renderHeight}get firstVisibleIndex(){return this.k.firstVisibleIndex}get firstMostlyVisibleIndex(){return this.k.firstMostlyVisibleIndex}get lastVisibleIndex(){return this.k.lastVisibleIndex}get ariaLabel(){return this.x}set ariaLabel(a){this.x=a,this.k.domNode.setAttribute("aria-label",a)}domFocus(){this.k.domNode.focus({preventScroll:!0})}layout(a,l){this.k.layout(a,l)}triggerTypeNavigation(){this.t?.trigger()}setSelection(a,l){for(const g of a)if(g<0||g>=this.length)throw new b.$GT(this.A,`Invalid index ${g}`);this.d.set(a,l)}getSelection(){return this.d.get()}getSelectedElements(){return this.getSelection().map(a=>this.k.element(a))}setAnchor(a){if(typeof a>"u"){this.f.set([]);return}if(a<0||a>=this.length)throw new b.$GT(this.A,`Invalid index ${a}`);this.f.set([a])}getAnchor(){return(0,y.$Ob)(this.f.get(),void 0)}getAnchorElement(){const a=this.getAnchor();return typeof a>"u"?void 0:this.element(a)}setFocus(a,l){for(const g of a)if(g<0||g>=this.length)throw new b.$GT(this.A,`Invalid index ${g}`);this.c.set(a,l)}focusNext(a=1,l=!1,g,I){if(this.length===0)return;const F=this.c.get(),u=this.E(F.length>0?F[0]+a:0,l,I);u>-1&&this.setFocus([u],g)}focusPrevious(a=1,l=!1,g,I){if(this.length===0)return;const F=this.c.get(),u=this.F(F.length>0?F[0]-a:0,l,I);u>-1&&this.setFocus([u],g)}async focusNextPage(a,l){let g=this.k.indexAt(this.k.getScrollTop()+this.k.renderHeight);g=g===0?0:g-1;const I=this.getFocus()[0];if(I!==g&&(I===void 0||g>I)){const F=this.F(g,!1,l);F>-1&&I!==F?this.setFocus([F],a):this.setFocus([g],a)}else{const F=this.k.getScrollTop();let u=F+this.k.renderHeight;g>I&&(u-=this.k.elementHeight(g)),this.k.setScrollTop(u),this.k.getScrollTop()!==F&&(this.setFocus([]),await(0,f.$Bh)(0),await this.focusNextPage(a,l))}}async focusPreviousPage(a,l,g=()=>0){let I;const F=g(),u=this.k.getScrollTop()+F;u===0?I=this.k.indexAt(u):I=this.k.indexAfter(u-1);const L=this.getFocus()[0];if(L!==I&&(L===void 0||L>=I)){const S=this.E(I,!1,l);S>-1&&L!==S?this.setFocus([S],a):this.setFocus([I],a)}else{const S=u;this.k.setScrollTop(u-this.k.renderHeight-F),this.k.getScrollTop()+g()!==S&&(this.setFocus([]),await(0,f.$Bh)(0),await this.focusPreviousPage(a,l,g))}}focusLast(a,l){if(this.length===0)return;const g=this.F(this.length-1,!1,l);g>-1&&this.setFocus([g],a)}focusFirst(a,l){this.focusNth(0,a,l)}focusNth(a,l,g){if(this.length===0)return;const I=this.E(a,!1,g);I>-1&&this.setFocus([I],l)}E(a,l=!1,g){for(let I=0;I<this.length;I++){if(a>=this.length&&!l)return-1;if(a=a%this.length,!g||g(this.element(a)))return a;a++}return-1}F(a,l=!1,g){for(let I=0;I<this.length;I++){if(a<0&&!l)return-1;if(a=(this.length+a%this.length)%this.length,!g||g(this.element(a)))return a;a--}return-1}getFocus(){return this.c.get()}getFocusedElements(){return this.getFocus().map(a=>this.k.element(a))}reveal(a,l,g=0){if(a<0||a>=this.length)throw new b.$GT(this.A,`Invalid index ${a}`);const I=this.k.getScrollTop(),F=this.k.elementTop(a),u=this.k.elementHeight(a);if((0,c.$eg)(l)){const L=u-this.k.renderHeight+g;this.k.setScrollTop(L*(0,o.$Gm)(l,0,1)+F-g)}else{const L=F+u,S=I+this.k.renderHeight;F<I+g&&L>=S||(F<I+g||L>=S&&u>=this.k.renderHeight?this.k.setScrollTop(F-g):L>=S&&this.k.setScrollTop(L-this.k.renderHeight))}}getRelativeTop(a,l=0){if(a<0||a>=this.length)throw new b.$GT(this.A,`Invalid index ${a}`);const g=this.k.getScrollTop(),I=this.k.elementTop(a),F=this.k.elementHeight(a);if(I<g+l||I+F>g+this.k.renderHeight)return null;const u=F-this.k.renderHeight+l;return Math.abs((g+l-I)/u)}isDOMFocused(){return(0,i.$1R)(this.k.domNode)}getHTMLElement(){return this.k.domNode}getScrollableElement(){return this.k.scrollableElementDomNode}getElementID(a){return this.k.getElementDomId(a)}getElementTop(a){return this.k.elementTop(a)}style(a){this.q.style(a)}G({indexes:a,browserEvent:l}){return{indexes:a,elements:a.map(g=>this.k.element(g)),browserEvent:l}}H(){const a=this.c.get();this.k.domNode.classList.toggle("element-focused",a.length>0),this.I()}I(){const a=this.c.get();if(a.length>0){let l;this.u?.getActiveDescendantId&&(l=this.u.getActiveDescendantId(this.k.element(a[0]))),this.k.domNode.setAttribute("aria-activedescendant",l||this.k.getElementDomId(a[0]))}else this.k.domNode.removeAttribute("aria-activedescendant")}J(){const a=this.d.get();this.k.domNode.classList.toggle("selection-none",a.length===0),this.k.domNode.classList.toggle("selection-single",a.length===1),this.k.domNode.classList.toggle("selection-multiple",a.length>1)}dispose(){this.z.fire(),this.y.dispose(),this.z.dispose()}}t.$WT=K,Je([A.$5h],K.prototype,"onDidChangeFocus",null),Je([A.$5h],K.prototype,"onDidChangeSelection",null),Je([A.$5h],K.prototype,"onContextMenu",null),Je([A.$5h],K.prototype,"onKeyDown",null),Je([A.$5h],K.prototype,"onKeyUp",null),Je([A.$5h],K.prototype,"onKeyPress",null),Je([A.$5h],K.prototype,"onDidFocus",null),Je([A.$5h],K.prototype,"onDidBlur",null)}),define(pe[142],we([1,0,6,66,52,11,17]),function(oe,t,i,n,B,O,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Xk=t.MarkdownStringTextNewlineStyle=void 0,t.$Yk=f,t.$Zk=w,t.$1k=A,t.$2k=$,t.$3k=m,t.$4k=e,t.$5k=s,t.$6k=o;var v;(function(h){h[h.Paragraph=0]="Paragraph",h[h.Break=1]="Break"})(v||(t.MarkdownStringTextNewlineStyle=v={}));class y{constructor(c="",b=!1){if(this.value=c,typeof this.value!="string")throw(0,i.$7)("value");typeof b=="boolean"?(this.isTrusted=b,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=b.isTrusted??void 0,this.supportThemeIcons=b.supportThemeIcons??!1,this.supportHtml=b.supportHtml??!1)}appendText(c,b=v.Paragraph){return this.value+=$(this.supportThemeIcons?(0,n.$Rk)(c):c).replace(/([ \t]+)/g,(k,E)=>"&nbsp;".repeat(E.length)).replace(/\>/gm,"\\>").replace(/\n/g,b===v.Break?`\\
`:`

`),this}appendMarkdown(c){return this.value+=c,this}appendCodeblock(c,b){return this.value+=`
${m(b,c)}
`,this}appendLink(c,b,k){return this.value+="[",this.value+=this.c(b,"]"),this.value+="](",this.value+=this.c(String(c),")"),k&&(this.value+=` "${this.c(this.c(k,'"'),")")}"`),this.value+=")",this}c(c,b){const k=new RegExp((0,O.$df)(b),"g");return c.replace(k,(E,r)=>c.charAt(r-1)!=="\\"?`\\${E}`:E)}}t.$Xk=y;function f(h){return w(h)?!h.value:Array.isArray(h)?h.every(f):!0}function w(h){return h instanceof y?!0:h&&typeof h=="object"?typeof h.value=="string"&&(typeof h.isTrusted=="boolean"||typeof h.isTrusted=="object"||h.isTrusted===void 0)&&(typeof h.supportThemeIcons=="boolean"||h.supportThemeIcons===void 0):!1}function A(h,c){return h===c?!0:!h||!c?!1:h.value===c.value&&h.isTrusted===c.isTrusted&&h.supportThemeIcons===c.supportThemeIcons&&h.supportHtml===c.supportHtml&&(h.baseUri===c.baseUri||!!h.baseUri&&!!c.baseUri&&(0,B.$7g)(T.URI.from(h.baseUri),T.URI.from(c.baseUri)))}function $(h){return h.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}function m(h,c){const b=h.match(/^`+/gm)?.reduce((E,r)=>E.length>r.length?E:r).length??0,k=b>=3?b+1:3;return[`${"`".repeat(k)}${c}`,h,`${"`".repeat(k)}`].join(`
`)}function e(h){return h.replace(/"/g,"&quot;")}function s(h){return h&&h.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}function o(h){const c=[],b=h.split("|").map(E=>E.trim());h=b[0];const k=b[1];if(k){const E=/height=(\d+)/.exec(k),r=/width=(\d+)/.exec(k),d=E?E[1]:"",D=r?r[1]:"",R=isFinite(parseInt(D)),_=isFinite(parseInt(d));R&&c.push(`width="${D}"`),_&&c.push(`height="${d}"`)}return{href:h,dimensions:c}}}),define(pe[143],we([1,0,4,134,27,71,16,23,135,6,3,142,66,91,8,26,2,92,69,39,63,52,11,17]),function(oe,t,i,n,B,O,T,v,y,f,w,A,$,m,e,s,o,h,c,b,k,E,r,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$1T=void 0,t.$ZT=R,t.$2T=U,t.$3T=N,t.$4T=ue;const D=Object.freeze({image:(a,l,g)=>{let I=[],F=[];return a&&({href:a,dimensions:I}=(0,A.$6k)(a),F.push(`src="${(0,A.$4k)(a)}"`)),g&&F.push(`alt="${(0,A.$4k)(g)}"`),l&&F.push(`title="${(0,A.$4k)(l)}"`),I.length&&(F=F.concat(I)),"<img "+F.join(" ")+">"},paragraph:a=>`<p>${a}</p>`,link:(a,l,g)=>typeof a!="string"?"":(a===g&&(g=(0,A.$5k)(g)),l=typeof l=="string"?(0,A.$4k)((0,A.$5k)(l)):"",a=(0,A.$5k)(a),a=a.replace(/&/g,"&amp;").replace(/</g,"&lt;").replace(/>/g,"&gt;").replace(/"/g,"&quot;").replace(/'/g,"&#39;"),`<a href="${a}" title="${l||a}" draggable="false">${g}</a>`)});function R(a,l={},g={}){const I=new o.$Tc;let F=!1;const u=(0,O.$qT)(l),L=function(ve){let Re;try{Re=(0,c.$9h)(decodeURIComponent(ve))}catch{}return Re?(Re=(0,k.$$n)(Re,Te=>{if(a.uris&&a.uris[Te])return d.URI.revive(a.uris[Te])}),encodeURIComponent(JSON.stringify(Re))):ve},S=function(ve,Re){const Te=a.uris&&a.uris[ve];let he=d.URI.revive(Te);return Re?ve.startsWith(b.Schemas.data+":")?ve:(he||(he=d.URI.parse(ve)),b.$Ug.uriToBrowserUri(he).toString(!0)):!he||d.URI.parse(ve).toString()===he.toString()?ve:(he.query&&(he=he.with({query:L(he.query)})),he.toString())},j=new h.marked.Renderer;j.image=D.image,j.link=D.link,j.paragraph=D.paragraph;const z=[],q=[];if(l.codeBlockRendererSync?j.code=(ve,Re)=>{const Te=m.$1O.nextId(),he=l.codeBlockRendererSync(_(Re),ve);return q.push([Te,he]),`<div class="code" data-code="${Te}">${(0,r.$cf)(ve)}</div>`}:l.codeBlockRenderer&&(j.code=(ve,Re)=>{const Te=m.$1O.nextId(),he=l.codeBlockRenderer(_(Re),ve);return z.push(he.then(Fe=>[Te,Fe])),`<div class="code" data-code="${Te}">${(0,r.$cf)(ve)}</div>`}),l.actionHandler){const ve=function(he){let Fe=he.target;if(!(Fe.tagName!=="A"&&(Fe=Fe.parentElement,!Fe||Fe.tagName!=="A")))try{let xe=Fe.dataset.href;xe&&(a.baseUri&&(xe=H(d.URI.from(a.baseUri),xe)),l.actionHandler.callback(xe,he))}catch(xe){(0,f.$1)(xe)}finally{he.preventDefault()}},Re=l.actionHandler.disposables.add(new B.$rT(u,"click")),Te=l.actionHandler.disposables.add(new B.$rT(u,"auxclick"));l.actionHandler.disposables.add(w.Event.any(Re.event,Te.event)(he=>{const Fe=new v.$fR(i.getWindow(u),he);!Fe.leftButton&&!Fe.middleButton||ve(Fe)})),l.actionHandler.disposables.add(i.$nR(u,"keydown",he=>{const Fe=new T.$kR(he);!Fe.equals(e.KeyCode.Space)&&!Fe.equals(e.KeyCode.Enter)||ve(Fe)}))}a.supportHtml||(g.sanitizer=ve=>l.sanitizerOptions?.replaceWithPlaintext?(0,r.$cf)(ve):(a.isTrusted?ve.match(/^(<span[^>]+>)|(<\/\s*span>)$/):void 0)?ve:"",g.sanitize=!0,g.silent=!0),g.renderer=j;let ee=a.value??"";ee.length>1e5&&(ee=`${ee.substr(0,1e5)}\u2026`),a.supportThemeIcons&&(ee=(0,$.$Sk)(ee));let re;if(l.fillInIncompleteTokens){const ve={...h.marked.defaults,...g},Re=h.marked.lexer(ee,ve),Te=ue(Re);re=h.marked.parser(Te,ve)}else re=h.marked.parse(ee,g);a.supportThemeIcons&&(re=(0,y.$XT)(re).map(Re=>typeof Re=="string"?Re:Re.outerHTML).join(""));const Ee=new DOMParser().parseFromString(p({isTrusted:a.isTrusted,...l.sanitizerOptions},re),"text/html");if(Ee.body.querySelectorAll("img, audio, video, source").forEach(ve=>{const Re=ve.getAttribute("src");if(Re){let Te=Re;try{a.baseUri&&(Te=H(d.URI.from(a.baseUri),Te))}catch{}if(ve.setAttribute("src",S(Te,!0)),l.remoteImageIsAllowed){const he=d.URI.parse(Te);he.scheme!==b.Schemas.file&&he.scheme!==b.Schemas.data&&!l.remoteImageIsAllowed(he)&&ve.replaceWith(i.$("",void 0,ve.outerHTML))}}}),Ee.body.querySelectorAll("a").forEach(ve=>{const Re=ve.getAttribute("href");if(ve.setAttribute("href",""),!Re||/^data:|javascript:/i.test(Re)||/^command:/i.test(Re)&&!a.isTrusted||/^command:(\/\/\/)?_workbench\.downloadResource/i.test(Re))ve.replaceWith(...ve.childNodes);else{let Te=S(Re,!1);a.baseUri&&(Te=H(d.URI.from(a.baseUri),Re)),ve.dataset.href=Te}}),u.innerHTML=p({isTrusted:a.isTrusted,...l.sanitizerOptions},Ee.body.innerHTML),z.length>0)Promise.all(z).then(ve=>{if(F)return;const Re=new Map(ve),Te=u.querySelectorAll("div[data-code]");for(const he of Te){const Fe=Re.get(he.dataset.code??"");Fe&&i.$pS(he,Fe)}l.asyncRenderCallback?.()});else if(q.length>0){const ve=new Map(q),Re=u.querySelectorAll("div[data-code]");for(const Te of Re){const he=ve.get(Te.dataset.code??"");he&&i.$pS(Te,he)}}if(l.asyncRenderCallback)for(const ve of u.getElementsByTagName("img")){const Re=I.add(i.$nR(ve,"load",()=>{Re.dispose(),l.asyncRenderCallback()}))}return{element:u,dispose:()=>{F=!0,I.dispose()}}}function _(a){if(!a)return"";const l=a.split(/[\s+|:|,|\{|\?]/,1);return l.length?l[0]:a}function H(a,l){return/^\w[\w\d+.-]*:/.test(l)?l:a.path.endsWith("/")?(0,E.$eh)(a,l).toString():(0,E.$eh)((0,E.$ah)(a),l).toString()}const x=["area","base","br","col","command","embed","hr","img","input","keygen","link","meta","param","source","track","wbr"];function p(a,l){const{config:g,allowedSchemes:I}=M(a),F=new o.$Tc;F.add(C("uponSanitizeAttribute",(u,L)=>{if(L.attrName==="style"||L.attrName==="class"){if(u.tagName==="SPAN"){if(L.attrName==="style"){L.keepAttr=/^(color\:(#[0-9a-fA-F]+|var\(--vscode(-[a-zA-Z]+)+\));)?(background-color\:(#[0-9a-fA-F]+|var\(--vscode(-[a-zA-Z]+)+\));)?$/.test(L.attrValue);return}else if(L.attrName==="class"){L.keepAttr=/^codicon codicon-[a-z\-]+( codicon-modifier-[a-z\-]+)?$/.test(L.attrValue);return}}L.keepAttr=!1;return}else if(u.tagName==="INPUT"&&u.attributes.getNamedItem("type")?.value==="checkbox"){if(L.attrName==="type"&&L.attrValue==="checkbox"||L.attrName==="disabled"||L.attrName==="checked"){L.keepAttr=!0;return}L.keepAttr=!1}})),F.add(C("uponSanitizeElement",(u,L)=>{if(L.tagName==="input"&&(u.attributes.getNamedItem("type")?.value==="checkbox"?u.setAttribute("disabled",""):a.replaceWithPlaintext||u.parentElement?.removeChild(u)),a.replaceWithPlaintext&&!L.allowedTags[L.tagName]&&L.tagName!=="body"&&u.parentElement){let S,j;if(L.tagName==="#comment")S=`<!--${u.textContent}-->`;else{const re=x.includes(L.tagName),ce=u.attributes.length?" "+Array.from(u.attributes).map(Ee=>`${Ee.name}="${Ee.value}"`).join(" "):"";S=`<${L.tagName}${ce}>`,re||(j=`</${L.tagName}>`)}const z=document.createDocumentFragment(),q=u.parentElement.ownerDocument.createTextNode(S);z.appendChild(q);const ee=j?u.parentElement.ownerDocument.createTextNode(j):void 0;for(;u.firstChild;)z.appendChild(u.firstChild);ee&&z.appendChild(ee),u.parentElement.replaceChild(z,u)}})),F.add(i.$JS(I));try{return n.sanitize(l,{...g,RETURN_TRUSTED_TYPE:!0})}finally{F.dispose()}}t.$1T=["align","autoplay","alt","checked","class","controls","data-code","data-href","disabled","draggable","height","href","loop","muted","playsinline","poster","src","style","target","title","type","width","start"];function M(a){const l=[b.Schemas.http,b.Schemas.https,b.Schemas.mailto,b.Schemas.data,b.Schemas.file,b.Schemas.vscodeFileResource,b.Schemas.vscodeRemote,b.Schemas.vscodeRemoteResource];return a.isTrusted&&l.push(b.Schemas.command),{config:{ALLOWED_TAGS:a.allowedTags??[...i.$KS],ALLOWED_ATTR:t.$1T,ALLOW_UNKNOWN_PROTOCOLS:!0},allowedSchemes:l}}function U(a){return typeof a=="string"?a:N(a)}function N(a,l){let g=a.value??"";g.length>1e5&&(g=`${g.substr(0,1e5)}\u2026`);const I=h.marked.parse(g,{renderer:l?Q.value:ne.value}).replace(/&(#\d+|[a-zA-Z]+);/g,F=>P.get(F)??F);return p({isTrusted:!1},I).toString()}const P=new Map([["&quot;",'"'],["&nbsp;"," "],["&amp;","&"],["&#39;","'"],["&lt;","<"],["&gt;",">"]]);function W(){const a=new h.marked.Renderer;return a.code=l=>l,a.blockquote=l=>l,a.html=l=>"",a.heading=(l,g,I)=>l+`
`,a.hr=()=>"",a.list=(l,g)=>l,a.listitem=l=>l+`
`,a.paragraph=l=>l+`
`,a.table=(l,g)=>l+g+`
`,a.tablerow=l=>l,a.tablecell=(l,g)=>l+" ",a.strong=l=>l,a.em=l=>l,a.codespan=l=>l,a.br=()=>`
`,a.del=l=>l,a.image=(l,g,I)=>"",a.text=l=>l,a.link=(l,g,I)=>I,a}const ne=new s.$V(a=>W()),Q=new s.$V(()=>{const a=W();return a.code=l=>"\n```"+l+"```\n",a});function Y(a){let l="";return a.forEach(g=>{l+=g.raw}),l}function te(a){if(a.tokens)for(let l=a.tokens.length-1;l>=0;l--){const g=a.tokens[l];if(g.type==="text"){const I=g.raw.split(`
`),F=I[I.length-1];if(F.includes("`"))return le(a);if(F.includes("**"))return Ie(a);if(F.match(/\*\w/))return ke(a);if(F.match(/(^|\s)__\w/))return je(a);if(F.match(/(^|\s)_\w/))return Z(a);if(de(F)||De(F)&&a.tokens.slice(0,l).some(u=>u.type==="text"&&u.raw.match(/\[[^\]]*$/))){const u=a.tokens.slice(l+1);return u[0]?.type==="link"&&u[1]?.type==="text"&&u[1].raw.match(/^ *"[^"]*$/)||F.match(/^[^"]* +"[^"]*$/)?ye(a):me(a)}else if(F.match(/(^|\s)\[\w*/))return Oe(a)}}}function de(a){return!!a.match(/(^|\s)\[.*\]\(\w*/)}function De(a){return!!a.match(/^[^\[]*\]\([^\)]*$/)}function Le(a){const l=a.items[a.items.length-1],g=l.tokens?l.tokens[l.tokens.length-1]:void 0;let I;if(g?.type==="text"&&!("inRawBlock"in l)&&(I=te(g)),!I||I.type!=="paragraph")return;const F=Y(a.items.slice(0,-1)),u=l.raw.match(/^(\s*(-|\d+\.) +)/)?.[0];if(!u)return;const L=u+Y(l.tokens.slice(0,-1))+I.raw,S=h.marked.lexer(F+L)[0];if(S.type==="list")return S}const Se=3;function ue(a){for(let l=0;l<Se;l++){const g=J(a);if(g)a=g;else break}return a}function J(a){let l,g;for(l=0;l<a.length;l++){const I=a[l];let F;if(I.type==="paragraph"&&(F=I.raw.match(/(\n|^)(````*)/))){const u=F[2];g=fe(a.slice(l),u);break}if(I.type==="paragraph"&&I.raw.match(/(\n|^)\|/)){g=K(a.slice(l));break}if(l===a.length-1&&I.type==="list"){const u=Le(I);if(u){g=[u];break}}if(l===a.length-1&&I.type==="paragraph"){const u=te(I);if(u){g=[u];break}}}if(g){const I=[...a.slice(0,l),...g];return I.links=a.links,I}return null}function fe(a,l){const g=Y(a);return h.marked.lexer(g+`
${l}`)}function le(a){return ie(a,"`")}function ke(a){return ie(a,"*")}function Z(a){return ie(a,"_")}function me(a){return ie(a,")")}function ye(a){return ie(a,'")')}function Oe(a){return ie(a,"](https://microsoft.com)")}function Ie(a){return ie(a,"**")}function je(a){return ie(a,"__")}function ie(a,l){const g=Y(Array.isArray(a)?a:[a]);return h.marked.lexer(g+l)[0]}function K(a){const l=Y(a),g=l.split(`
`);let I,F=!1;for(let u=0;u<g.length;u++){const L=g[u].trim();if(typeof I>"u"&&L.match(/^\s*\|/)){const S=L.match(/(\|[^\|]+)(?=\||$)/g);S&&(I=S.length)}else if(typeof I=="number")if(L.match(/^\s*\|/)){if(u!==g.length-1)return;F=!0}else return}if(typeof I=="number"&&I>0){const u=F?g.slice(0,-1).join(`
`):l,L=!!u.match(/\|\s*$/),S=u+(L?"":"|")+`
|${" --- |".repeat(I)}`;return h.marked.lexer(S)}}function C(a,l){return n.addHook(a,l),(0,o.$Sc)(()=>n.removeHook(a))}}),define(pe[144],we([1,0,4,27,16,143,74,32,15,54,9,3,8,2,5,20,126,118]),function(oe,t,i,n,B,O,T,v,y,f,w,A,$,m,e,s,o){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$7T=void 0;const h=i.$,c="selectOption.entry.template";class b{get templateId(){return c}renderTemplate(r){const d=Object.create(null);return d.root=r,d.text=i.$nS(r,h(".option-text")),d.detail=i.$nS(r,h(".option-detail")),d.decoratorRight=i.$nS(r,h(".option-decorator-right")),d}renderElement(r,d,D){const R=D,_=r.text,H=r.detail,x=r.decoratorRight,p=r.isDisabled;R.text.textContent=_,R.detail.textContent=H||"",R.decoratorRight.innerText=x||"",p?R.root.classList.add("option-disabled"):R.root.classList.remove("option-disabled")}disposeTemplate(r){}}class k extends m.$Uc{static{this.a=32}static{this.b=2}static{this.c=3}constructor(r,d,D,R,_){super(),this.m=[],this.F=0,this.H=!1,this.J=!1,this.N=!1,this.f=!1,this.s=R,this.g=_||Object.create(null),typeof this.g.minBottomMargin!="number"?this.g.minBottomMargin=k.a:this.g.minBottomMargin<0&&(this.g.minBottomMargin=0),this.h=document.createElement("select"),this.h.className="monaco-select-box monaco-select-box-dropdown-padding",typeof this.g.ariaLabel=="string"&&this.h.setAttribute("aria-label",this.g.ariaLabel),typeof this.g.ariaDescription=="string"&&this.h.setAttribute("aria-description",this.g.ariaDescription),this.r=new A.$he,this.B(this.r),this.Q(),this.P(D),this.n=d||0,r&&this.setOptions(r,d),this.S()}O(r){!this.M&&r?this.M=this.B((0,v.$6T)().setupUpdatableHover((0,y.$hT)("mouse"),this.h,r)):this.M&&this.M.update(r)}getHeight(){return 22}getTemplateId(){return c}P(r){this.u=r,this.w=i.$(".monaco-select-box-dropdown-container"),this.w.classList.add("monaco-select-box-dropdown-padding"),this.I=i.$nS(this.w,h(".select-box-details-pane"));const d=i.$nS(this.w,h(".select-box-dropdown-container-width-control")),D=i.$nS(d,h(".width-control-div"));this.D=document.createElement("span"),this.D.className="option-text-width-control",i.$nS(D,this.D),this.G=T.AnchorPosition.BELOW,this.y=i.$8R(this.w),this.w.setAttribute("draggable","true"),this.B(i.$nR(this.w,i.$gS.DRAG_START,R=>{i.$iS.stop(R,!0)}))}Q(){this.B(i.$oR(this.h,"change",d=>{this.n=d.target.selectedIndex,this.r.fire({index:d.target.selectedIndex,selected:d.target.value}),this.m[this.n]&&this.m[this.n].text&&this.O(this.m[this.n].text)})),this.B(i.$nR(this.h,i.$gS.CLICK,d=>{i.$iS.stop(d),this.f?this.Z(!0):this.Y()})),this.B(i.$nR(this.h,i.$gS.MOUSE_DOWN,d=>{i.$iS.stop(d)}));let r;this.B(i.$nR(this.h,"touchstart",d=>{r=this.f})),this.B(i.$nR(this.h,"touchend",d=>{i.$iS.stop(d),r?this.Z(!0):this.Y()})),this.B(i.$nR(this.h,i.$gS.KEY_DOWN,d=>{const D=new B.$kR(d);let R=!1;e.$j?(D.keyCode===$.KeyCode.DownArrow||D.keyCode===$.KeyCode.UpArrow||D.keyCode===$.KeyCode.Space||D.keyCode===$.KeyCode.Enter)&&(R=!0):(D.keyCode===$.KeyCode.DownArrow&&D.altKey||D.keyCode===$.KeyCode.UpArrow&&D.altKey||D.keyCode===$.KeyCode.Space||D.keyCode===$.KeyCode.Enter)&&(R=!0),R&&(this.Y(),i.$iS.stop(d,!0))}))}get onDidSelect(){return this.r.event}setOptions(r,d){w.$ub(this.m,r)||(this.m=r,this.h.options.length=0,this.H=!1,this.L=void 0,this.m.forEach((D,R)=>{this.h.add(this.X(D.text,R,D.isDisabled)),typeof D.description=="string"&&(this.H=!0)})),d!==void 0&&(this.select(d),this.F=this.n)}setEnabled(r){this.h.disabled=!r}R(){this.z?.splice(0,this.z.length,this.m)}select(r){r>=0&&r<this.m.length?this.n=r:r>this.m.length-1?this.select(this.m.length-1):this.n<0&&(this.n=0),this.h.selectedIndex=this.n,this.m[this.n]&&this.m[this.n].text&&this.O(this.m[this.n].text)}setAriaLabel(r){this.g.ariaLabel=r,this.h.setAttribute("aria-label",this.g.ariaLabel)}focus(){this.h&&(this.h.tabIndex=0,this.h.focus())}blur(){this.h&&(this.h.tabIndex=-1,this.h.blur())}setFocusable(r){this.h.tabIndex=r?0:-1}render(r){this.j=r,r.classList.add("select-container"),r.appendChild(this.h),this.U()}S(){const r=[];this.s.listFocusBackground&&r.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { background-color: ${this.s.listFocusBackground} !important; }`),this.s.listFocusForeground&&r.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { color: ${this.s.listFocusForeground} !important; }`),this.s.decoratorRightForeground&&r.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.focused) .option-decorator-right { color: ${this.s.decoratorRightForeground}; }`),this.s.selectBackground&&this.s.selectBorder&&this.s.selectBorder!==this.s.selectBackground?(r.push(`.monaco-select-box-dropdown-container { border: 1px solid ${this.s.selectBorder} } `),r.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-top { border-top: 1px solid ${this.s.selectBorder} } `),r.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-bottom { border-bottom: 1px solid ${this.s.selectBorder} } `)):this.s.selectListBorder&&(r.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-top { border-top: 1px solid ${this.s.selectListBorder} } `),r.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-bottom { border-bottom: 1px solid ${this.s.selectListBorder} } `)),this.s.listHoverForeground&&r.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { color: ${this.s.listHoverForeground} !important; }`),this.s.listHoverBackground&&r.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { background-color: ${this.s.listHoverBackground} !important; }`),this.s.listFocusOutline&&r.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { outline: 1.6px dotted ${this.s.listFocusOutline} !important; outline-offset: -1.6px !important; }`),this.s.listHoverOutline&&r.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { outline: 1.6px dashed ${this.s.listHoverOutline} !important; outline-offset: -1.6px !important; }`),r.push(".monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.option-disabled.focused { background-color: transparent !important; color: inherit !important; outline: none !important; }"),r.push(".monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.option-disabled:hover { background-color: transparent !important; color: inherit !important; outline: none !important; }"),this.y.textContent=r.join(`
`)}U(){const r=this.s.selectBackground??"",d=this.s.selectForeground??"",D=this.s.selectBorder??"";this.h.style.backgroundColor=r,this.h.style.color=d,this.h.style.borderColor=D}W(){const r=this.s.selectBackground??"",d=i.$FS(this.s.selectListBackground,r);this.C.style.backgroundColor=d,this.I.style.backgroundColor=d;const D=this.s.focusBorder??"";this.w.style.outlineColor=D,this.w.style.outlineOffset="-1px",this.z.style(this.s)}X(r,d,D){const R=document.createElement("option");return R.value=r,R.text=r,R.disabled=!!D,R}Y(){this.I.innerText="",!(!this.u||this.f)&&(this.eb(this.w),this.R(),this.u.showContextView({getAnchor:()=>this.h,render:r=>this.ab(r,!0),layout:()=>{this.cb()},onHide:()=>{this.w.classList.remove("visible"),this.h.classList.remove("synthetic-focus")},anchorPosition:this.G},this.g.optionsAsChildren?this.j:void 0),this.f=!0,this.Z(!1),this.u.showContextView({getAnchor:()=>this.h,render:r=>this.ab(r),layout:()=>this.cb(),onHide:()=>{this.w.classList.remove("visible"),this.h.classList.remove("synthetic-focus")},anchorPosition:this.G},this.g.optionsAsChildren?this.j:void 0),this.F=this.n,this.f=!0,this.h.setAttribute("aria-expanded","true"))}Z(r){!this.u||!this.f||(this.f=!1,this.h.setAttribute("aria-expanded","false"),r&&this.h.focus(),this.u.hideContextView())}ab(r,d){return r.appendChild(this.w),this.cb(d),{dispose:()=>{try{r.removeChild(this.w)}catch{}}}}bb(){let r=0;return this.m.forEach((d,D)=>{this.jb(D),this.I.offsetHeight>r&&(r=this.I.offsetHeight)}),r}cb(r){if(this.J)return!1;if(this.z){this.w.classList.add("visible");const d=i.getWindow(this.h),D=i.$JR(this.h),R=i.getWindow(this.h).getComputedStyle(this.h),_=parseFloat(R.getPropertyValue("--dropdown-padding-top"))+parseFloat(R.getPropertyValue("--dropdown-padding-bottom")),H=d.innerHeight-D.top-D.height-(this.g.minBottomMargin||0),x=D.top-k.b,p=this.h.offsetWidth,M=this.db(this.D),U=Math.max(M,Math.round(p)).toString()+"px";this.w.style.width=U,this.z.getHTMLElement().style.height="",this.z.layout();let N=this.z.contentHeight;this.H&&this.L===void 0&&(this.L=this.bb());const P=this.H?this.L:0,W=N+_+P,ne=Math.floor((H-_-P)/this.getHeight()),Q=Math.floor((x-_-P)/this.getHeight());if(r)return D.top+D.height>d.innerHeight-22||D.top<k.b||ne<1&&Q<1?!1:(ne<k.c&&Q>ne&&this.m.length>ne?(this.G=T.AnchorPosition.ABOVE,this.w.removeChild(this.C),this.w.removeChild(this.I),this.w.appendChild(this.I),this.w.appendChild(this.C),this.I.classList.remove("border-top"),this.I.classList.add("border-bottom")):(this.G=T.AnchorPosition.BELOW,this.w.removeChild(this.C),this.w.removeChild(this.I),this.w.appendChild(this.C),this.w.appendChild(this.I),this.I.classList.remove("border-bottom"),this.I.classList.add("border-top")),!0);if(D.top+D.height>d.innerHeight-22||D.top<k.b||this.G===T.AnchorPosition.BELOW&&ne<1||this.G===T.AnchorPosition.ABOVE&&Q<1)return this.Z(!0),!1;if(this.G===T.AnchorPosition.BELOW){if(this.f&&ne+Q<1)return this.Z(!0),!1;W>H&&(N=ne*this.getHeight())}else W>x&&(N=Q*this.getHeight());return this.z.layout(N),this.z.domFocus(),this.z.length>0&&(this.z.setFocus([this.n||0]),this.z.reveal(this.z.getFocus()[0]||0)),this.H?(this.z.getHTMLElement().style.height=N+_+"px",this.w.style.height=""):this.w.style.height=N+_+"px",this.jb(this.n),this.w.style.width=U,this.C.setAttribute("tabindex","0"),this.h.classList.add("synthetic-focus"),this.w.classList.add("synthetic-focus"),!0}else return!1}db(r){let d=0;if(r){let D=0,R=0;this.m.forEach((_,H)=>{const x=_.detail?_.detail.length:0,p=_.decoratorRight?_.decoratorRight.length:0,M=_.text.length+x+p;M>R&&(D=H,R=M)}),r.textContent=this.m[D].text+(this.m[D].decoratorRight?this.m[D].decoratorRight+" ":""),d=i.$LR(r)}return d}eb(r){if(this.z)return;this.C=i.$nS(r,h(".select-box-dropdown-list-container")),this.t=new b,this.z=new f.$WT("SelectBoxCustom",this.C,this,[this.t],{useShadows:!1,verticalScrollMode:s.ScrollbarVisibility.Visible,keyboardSupport:!1,mouseSupport:!1,accessibilityProvider:{getAriaLabel:R=>{let _=R.text;return R.detail&&(_+=`. ${R.detail}`),R.decoratorRight&&(_+=`. ${R.decoratorRight}`),R.description&&(_+=`. ${R.description}`),_},getWidgetAriaLabel:()=>(0,o.localize)(0,null),getRole:()=>e.$j?"":"option",getWidgetRole:()=>"listbox"}}),this.g.ariaLabel&&(this.z.ariaLabel=this.g.ariaLabel);const d=this.B(new n.$rT(this.C,"keydown")),D=A.Event.chain(d.event,R=>R.filter(()=>this.z.length>0).map(_=>new B.$kR(_)));this.B(A.Event.chain(D,R=>R.filter(_=>_.keyCode===$.KeyCode.Enter))(this.lb,this)),this.B(A.Event.chain(D,R=>R.filter(_=>_.keyCode===$.KeyCode.Tab))(this.lb,this)),this.B(A.Event.chain(D,R=>R.filter(_=>_.keyCode===$.KeyCode.Escape))(this.kb,this)),this.B(A.Event.chain(D,R=>R.filter(_=>_.keyCode===$.KeyCode.UpArrow))(this.nb,this)),this.B(A.Event.chain(D,R=>R.filter(_=>_.keyCode===$.KeyCode.DownArrow))(this.mb,this)),this.B(A.Event.chain(D,R=>R.filter(_=>_.keyCode===$.KeyCode.PageDown))(this.pb,this)),this.B(A.Event.chain(D,R=>R.filter(_=>_.keyCode===$.KeyCode.PageUp))(this.ob,this)),this.B(A.Event.chain(D,R=>R.filter(_=>_.keyCode===$.KeyCode.Home))(this.qb,this)),this.B(A.Event.chain(D,R=>R.filter(_=>_.keyCode===$.KeyCode.End))(this.rb,this)),this.B(A.Event.chain(D,R=>R.filter(_=>_.keyCode>=$.KeyCode.Digit0&&_.keyCode<=$.KeyCode.KeyZ||_.keyCode>=$.KeyCode.Semicolon&&_.keyCode<=$.KeyCode.NumpadDivide))(this.sb,this)),this.B(i.$nR(this.z.getHTMLElement(),i.$gS.POINTER_UP,R=>this.fb(R))),this.B(this.z.onMouseOver(R=>typeof R.index<"u"&&this.z.setFocus([R.index]))),this.B(this.z.onDidChangeFocus(R=>this.ib(R))),this.B(i.$nR(this.w,i.$gS.FOCUS_OUT,R=>{!this.f||i.$RR(R.relatedTarget,this.w)||this.gb()})),this.z.getHTMLElement().setAttribute("aria-label",this.g.ariaLabel||""),this.z.getHTMLElement().setAttribute("aria-expanded","true"),this.W()}fb(r){if(!this.z.length)return;i.$iS.stop(r);const d=r.target;if(!d||d.classList.contains("slider"))return;const D=d.closest(".monaco-list-row");if(!D)return;const R=Number(D.getAttribute("data-index")),_=D.classList.contains("option-disabled");R>=0&&R<this.m.length&&!_&&(this.n=R,this.select(this.n),this.z.setFocus([this.n]),this.z.reveal(this.z.getFocus()[0]),this.n!==this.F&&(this.F=this.n,this.r.fire({index:this.h.selectedIndex,selected:this.m[this.n].text}),this.m[this.n]&&this.m[this.n].text&&this.O(this.m[this.n].text)),this.Z(!0))}gb(){this.N||(this.n!==this.F&&this.select(this.F),this.Z(!1))}hb(r,d){const D=_=>{for(let H=0;H<_.childNodes.length;H++){const x=_.childNodes.item(H);(x.tagName&&x.tagName.toLowerCase())==="img"?_.removeChild(x):D(x)}},R=(0,O.$ZT)({value:r,supportThemeIcons:!0},{actionHandler:d});return R.element.classList.add("select-box-description-markdown"),D(R.element),R.element}ib(r){!this.f||!this.H||this.jb(r.indexes[0])}jb(r){this.I.innerText="";const d=this.m[r],D=d?.description??"",R=d?.descriptionIsMarkdown??!1;if(D){if(R){const _=d.descriptionMarkdownActionHandler;this.I.appendChild(this.hb(D,_))}else this.I.innerText=D;this.I.style.display="block"}else this.I.style.display="none";this.J=!0,this.u.layout(),this.J=!1}kb(r){i.$iS.stop(r),this.select(this.F),this.Z(!0)}lb(r){i.$iS.stop(r),this.n!==this.F&&(this.F=this.n,this.r.fire({index:this.h.selectedIndex,selected:this.m[this.n].text}),this.m[this.n]&&this.m[this.n].text&&this.O(this.m[this.n].text)),this.Z(!0)}mb(r){if(this.n<this.m.length-1){i.$iS.stop(r,!0);const d=this.m[this.n+1].isDisabled;if(d&&this.m.length>this.n+2)this.n+=2;else{if(d)return;this.n++}this.select(this.n),this.z.setFocus([this.n]),this.z.reveal(this.z.getFocus()[0])}}nb(r){this.n>0&&(i.$iS.stop(r,!0),this.m[this.n-1].isDisabled&&this.n>1?this.n-=2:this.n--,this.select(this.n),this.z.setFocus([this.n]),this.z.reveal(this.z.getFocus()[0]))}ob(r){i.$iS.stop(r),this.z.focusPreviousPage(),setTimeout(()=>{this.n=this.z.getFocus()[0],this.m[this.n].isDisabled&&this.n<this.m.length-1&&(this.n++,this.z.setFocus([this.n])),this.z.reveal(this.n),this.select(this.n)},1)}pb(r){i.$iS.stop(r),this.z.focusNextPage(),setTimeout(()=>{this.n=this.z.getFocus()[0],this.m[this.n].isDisabled&&this.n>0&&(this.n--,this.z.setFocus([this.n])),this.z.reveal(this.n),this.select(this.n)},1)}qb(r){i.$iS.stop(r),!(this.m.length<2)&&(this.n=0,this.m[this.n].isDisabled&&this.n>1&&this.n++,this.z.setFocus([this.n]),this.z.reveal(this.n),this.select(this.n))}rb(r){i.$iS.stop(r),!(this.m.length<2)&&(this.n=this.m.length-1,this.m[this.n].isDisabled&&this.n>1&&this.n--,this.z.setFocus([this.n]),this.z.reveal(this.n),this.select(this.n))}sb(r){const d=$.KeyCodeUtils.toString(r.keyCode);let D=-1;for(let R=0;R<this.m.length-1;R++)if(D=(R+this.n+1)%this.m.length,this.m[D].text.charAt(0).toUpperCase()===d&&!this.m[D].isDisabled){this.select(D),this.z.setFocus([D]),this.z.reveal(this.z.getFocus()[0]),i.$iS.stop(r);break}}dispose(){this.Z(!1),super.dispose()}}t.$7T=k}),define(pe[145],we([1,0,54,144,138,24,5,117]),function(oe,t,i,n,B,O,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$0T=t.$9T=void 0,t.$9T={...i.$VT,selectBackground:"#3C3C3C",selectForeground:"#F0F0F0",selectBorder:"#3C3C3C",decoratorRightForeground:void 0,selectListBackground:void 0,selectListBorder:void 0,focusBorder:void 0};class v extends O.$1S{constructor(f,w,A,$,m){super(),T.$j&&!m?.useCustomDrawn?this.a=new B.$8T(f,w,$,m):this.a=new n.$7T(f,w,A,$,m),this.B(this.a)}get onDidSelect(){return this.a.onDidSelect}setOptions(f,w){this.a.setOptions(f,w)}select(f){this.a.select(f)}setAriaLabel(f){this.a.setAriaLabel(f)}focus(){this.a.focus()}blur(){this.a.blur()}setFocusable(f){this.a.setFocusable(f)}setEnabled(f){this.a.setEnabled(f)}render(f){this.a.render(f)}}t.$0T=v}),define(pe[79],we([1,0,19,70,4,31,15,145,51,2,5,10,122,32,67]),function(oe,t,i,n,B,O,T,v,y,f,w,A,$,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$fU=t.$eU=t.$dU=void 0;class e extends f.$Uc{get action(){return this._action}constructor(c,b,k={}){super(),this.m=k,this._context=c||this,this._action=b,b instanceof y.$fj&&this.B(b.onDidChange(E=>{this.element&&this.t(E)}))}t(c){c.enabled!==void 0&&this.u(),c.checked!==void 0&&this.H(),c.class!==void 0&&this.G(),c.label!==void 0&&(this.w(),this.D()),c.tooltip!==void 0&&this.D()}get actionRunner(){return this.j||(this.j=this.B(new y.$gj)),this.j}set actionRunner(c){this.j=c}isEnabled(){return this._action.enabled}setActionContext(c){this._context=c}render(c){const b=this.element=c;this.B(O.$WS.addTarget(c));const k=this.m&&this.m.draggable;k&&(c.draggable=!0,i.$6Q&&this.B((0,B.$nR)(c,B.$gS.DRAG_START,E=>E.dataTransfer?.setData(n.$US.TEXT,this._action.label)))),this.B((0,B.$nR)(b,O.EventType.Tap,E=>this.onClick(E,!0))),this.B((0,B.$nR)(b,B.$gS.MOUSE_DOWN,E=>{k||B.$iS.stop(E,!0),this._action.enabled&&E.button===0&&b.classList.add("active")})),w.$j&&this.B((0,B.$nR)(b,B.$gS.CONTEXT_MENU,E=>{E.button===0&&E.ctrlKey===!0&&this.onClick(E)})),this.B((0,B.$nR)(b,B.$gS.CLICK,E=>{B.$iS.stop(E,!0),this.m&&this.m.isMenu||this.onClick(E)})),this.B((0,B.$nR)(b,B.$gS.DBLCLICK,E=>{B.$iS.stop(E,!0)})),[B.$gS.MOUSE_UP,B.$gS.MOUSE_OUT].forEach(E=>{this.B((0,B.$nR)(b,E,r=>{B.$iS.stop(r),b.classList.remove("active")}))})}onClick(c,b=!1){B.$iS.stop(c,!0);const k=A.$jg(this._context)?this.m?.useEventAsContext?c:{preserveFocus:b}:this._context;this.actionRunner.run(this._action,k)}focus(){this.element&&(this.element.tabIndex=0,this.element.focus(),this.element.classList.add("focused"))}isFocused(){return!!this.element?.classList.contains("focused")}blur(){this.element&&(this.element.blur(),this.element.tabIndex=-1,this.element.classList.remove("focused"))}setFocusable(c){this.element&&(this.element.tabIndex=c?0:-1)}get trapsArrowNavigation(){return!1}u(){}w(){}z(){return this.action.class}C(){return this.action.tooltip}D(){if(!this.element)return;const c=this.C()??"";if(this.F(),this.m.hoverDelegate?.showNativeHover)this.element.title=c;else if(!this.f&&c!==""){const b=this.m.hoverDelegate??(0,T.$hT)("element");this.f=this.q.add((0,m.$6T)().setupUpdatableHover(b,this.element,c))}else this.f&&this.f.update(c)}F(){if(this.element){const c=this.C()??"";this.element.setAttribute("aria-label",c)}}G(){}H(){}dispose(){this.element&&(this.element.remove(),this.element=void 0),this._context=void 0,super.dispose()}}t.$dU=e;class s extends e{constructor(c,b,k){super(c,b,k),this.m=k,this.m.icon=k.icon!==void 0?k.icon:!1,this.m.label=k.label!==void 0?k.label:!0,this.L=""}render(c){super.render(c),A.$kg(this.element);const b=document.createElement("a");if(b.classList.add("action-label"),b.setAttribute("role",this.M()),this.I=b,this.element.appendChild(b),this.m.label&&this.m.keybinding){const k=document.createElement("span");k.classList.add("keybinding"),k.textContent=this.m.keybinding,this.element.appendChild(k)}this.G(),this.w(),this.D(),this.u(),this.H()}M(){return this._action.id===y.$hj.ID?"presentation":this.m.isMenu?"menuitem":"button"}focus(){this.I&&(this.I.tabIndex=0,this.I.focus())}isFocused(){return!!this.I&&this.I?.tabIndex===0}blur(){this.I&&(this.I.tabIndex=-1)}setFocusable(c){this.I&&(this.I.tabIndex=c?0:-1)}w(){this.m.label&&this.I&&(this.I.textContent=this.action.label)}C(){let c=null;return this.action.tooltip?c=this.action.tooltip:!this.m.label&&this.action.label&&this.m.icon&&(c=this.action.label,this.m.keybinding&&(c=$.localize(0,null,c,this.m.keybinding))),c??void 0}G(){this.L&&this.I&&this.I.classList.remove(...this.L.split(" ")),this.m.icon?(this.L=this.z(),this.I&&(this.I.classList.add("codicon"),this.L&&this.I.classList.add(...this.L.split(" "))),this.u()):this.I?.classList.remove("codicon")}u(){this.action.enabled?(this.I&&(this.I.removeAttribute("aria-disabled"),this.I.classList.remove("disabled")),this.element?.classList.remove("disabled")):(this.I&&(this.I.setAttribute("aria-disabled","true"),this.I.classList.add("disabled")),this.element?.classList.add("disabled"))}F(){if(this.I){const c=this.C()??"";this.I.setAttribute("aria-label",c)}}H(){this.I&&(this.action.checked!==void 0?(this.I.classList.toggle("checked",this.action.checked),this.I.setAttribute("aria-checked",this.action.checked?"true":"false"),this.I.setAttribute("role","checkbox")):(this.I.classList.remove("checked"),this.I.removeAttribute("aria-checked"),this.I.setAttribute("role",this.M())))}}t.$eU=s;class o extends e{constructor(c,b,k,E,r,d,D){super(c,b),this.b=new v.$0T(k,E,r,d,D),this.b.setFocusable(!1),this.B(this.b),this.g()}setOptions(c,b){this.b.setOptions(c,b)}select(c){this.b.select(c)}g(){this.B(this.b.onDidSelect(c=>this.n(c.selected,c.index)))}n(c,b){this.actionRunner.run(this._action,this.r(c,b))}r(c,b){return c}setFocusable(c){this.b.setFocusable(c)}focus(){this.b?.focus()}blur(){this.b?.blur()}render(c){this.b.render(c)}}t.$fU=o}),define(pe[80],we([1,0,4,16,79,15,51,3,8,2,10,67]),function(oe,t,i,n,B,O,T,v,y,f,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$jT=t.ActionsOrientation=void 0,t.$kT=m;var A;(function(e){e[e.HORIZONTAL=0]="HORIZONTAL",e[e.VERTICAL=1]="VERTICAL"})(A||(t.ActionsOrientation=A={}));class $ extends f.$Uc{constructor(s,o={}){super(),this.j=this.B(new f.$Tc),this.s=this.B(new f.$4c),this.y=!1,this.z=!0,this.D=this.B(new v.$he),this.onDidBlur=this.D.event,this.F=this.B(new v.$he({onWillAddFirstListener:()=>this.G=!0})),this.onDidCancel=this.F.event,this.G=!1,this.H=this.B(new v.$he),this.onDidRun=this.H.event,this.I=this.B(new v.$he),this.onWillRun=this.I.event,this.b=o,this.m=o.context??null,this.n=this.b.orientation??A.HORIZONTAL,this.r={keyDown:this.b.triggerKeys?.keyDown??!1,keys:this.b.triggerKeys?.keys??[y.KeyCode.Enter,y.KeyCode.Space]},this.f=o.hoverDelegate??this.B((0,O.$iT)()),this.b.actionRunner?this.g=this.b.actionRunner:(this.g=new T.$gj,this.j.add(this.g)),this.j.add(this.g.onDidRun(b=>this.H.fire(b))),this.j.add(this.g.onWillRun(b=>this.I.fire(b))),this.viewItems=[],this.u=void 0,this.domNode=document.createElement("div"),this.domNode.className="monaco-action-bar";let h,c;switch(this.n){case A.HORIZONTAL:h=[y.KeyCode.LeftArrow],c=[y.KeyCode.RightArrow];break;case A.VERTICAL:h=[y.KeyCode.UpArrow],c=[y.KeyCode.DownArrow],this.domNode.className+=" vertical";break}this.B(i.$nR(this.domNode,i.$gS.KEY_DOWN,b=>{const k=new n.$kR(b);let E=!0;const r=typeof this.u=="number"?this.viewItems[this.u]:void 0;h&&(k.equals(h[0])||k.equals(h[1]))?E=this.Q():c&&(k.equals(c[0])||k.equals(c[1]))?E=this.P():k.equals(y.KeyCode.Escape)&&this.G?this.F.fire():k.equals(y.KeyCode.Home)?E=this.N():k.equals(y.KeyCode.End)?E=this.O():k.equals(y.KeyCode.Tab)&&r instanceof B.$dU&&r.trapsArrowNavigation?E=this.P():this.L(k)?this.r.keyDown?this.S(k):this.y=!0:E=!1,E&&(k.preventDefault(),k.stopPropagation())})),this.B(i.$nR(this.domNode,i.$gS.KEY_UP,b=>{const k=new n.$kR(b);this.L(k)?(!this.r.keyDown&&this.y&&(this.y=!1,this.S(k)),k.preventDefault(),k.stopPropagation()):(k.equals(y.KeyCode.Tab)||k.equals(y.KeyMod.Shift|y.KeyCode.Tab)||k.equals(y.KeyCode.UpArrow)||k.equals(y.KeyCode.DownArrow)||k.equals(y.KeyCode.LeftArrow)||k.equals(y.KeyCode.RightArrow))&&this.M()})),this.w=this.B(i.$lS(this.domNode)),this.B(this.w.onDidBlur(()=>{(i.$ZR()===this.domNode||!i.$RR(i.$ZR(),this.domNode))&&(this.D.fire(),this.t=this.u,this.u=void 0,this.y=!1)})),this.B(this.w.onDidFocus(()=>this.M())),this.C=document.createElement("ul"),this.C.className="actions-container",this.b.highlightToggledItems&&this.C.classList.add("highlight-toggled"),this.C.setAttribute("role",this.b.ariaRole||"toolbar"),this.b.ariaLabel&&this.C.setAttribute("aria-label",this.b.ariaLabel),this.domNode.appendChild(this.C),s.appendChild(this.domNode)}J(){this.length()>=1?this.C.setAttribute("role",this.b.ariaRole||"toolbar"):this.C.setAttribute("role","presentation")}setAriaLabel(s){s?this.C.setAttribute("aria-label",s):this.C.removeAttribute("aria-label")}setFocusable(s){if(this.z=s,this.z){const o=this.viewItems.find(h=>h instanceof B.$dU&&h.isEnabled());o instanceof B.$dU&&o.setFocusable(!0)}else this.viewItems.forEach(o=>{o instanceof B.$dU&&o.setFocusable(!1)})}L(s){let o=!1;return this.r.keys.forEach(h=>{o=o||s.equals(h)}),o}M(){for(let s=0;s<this.C.children.length;s++){const o=this.C.children[s];if(i.$RR(i.$ZR(),o)){this.u=s,this.viewItems[this.u]?.showHover?.();break}}}get context(){return this.m}set context(s){this.m=s,this.viewItems.forEach(o=>o.setActionContext(s))}get actionRunner(){return this.g}set actionRunner(s){this.g=s,this.j.clear(),this.j.add(this.g.onDidRun(o=>this.H.fire(o))),this.j.add(this.g.onWillRun(o=>this.I.fire(o))),this.viewItems.forEach(o=>o.actionRunner=s)}getContainer(){return this.domNode}hasAction(s){return this.viewItems.findIndex(o=>o.action.id===s.id)!==-1}getAction(s){if(typeof s=="number")return this.viewItems[s]?.action;if(s instanceof HTMLElement){for(;s.parentElement!==this.C;){if(!s.parentElement)return;s=s.parentElement}for(let o=0;o<this.C.childNodes.length;o++)if(this.C.childNodes[o]===s)return this.viewItems[o].action}}push(s,o={}){const h=Array.isArray(s)?s:[s];let c=w.$eg(o.index)?o.index:null;h.forEach(b=>{const k=document.createElement("li");k.className="action-item",k.setAttribute("role","presentation");let E;const r={hoverDelegate:this.f,...o};this.b.actionViewItemProvider&&(E=this.b.actionViewItemProvider(b,r)),E||(E=new B.$eU(this.context,b,r)),this.b.allowContextMenu||this.s.set(E,i.$nR(k,i.$gS.CONTEXT_MENU,d=>{i.$iS.stop(d,!0)})),E.actionRunner=this.g,E.setActionContext(this.context),E.render(k),this.z&&E instanceof B.$dU&&this.viewItems.length===0&&E.setFocusable(!0),c===null||c<0||c>=this.C.children.length?(this.C.appendChild(k),this.viewItems.push(E)):(this.C.insertBefore(k,this.C.children[c]),this.viewItems.splice(c,0,E),c++)}),typeof this.u=="number"&&this.focus(this.u),this.J()}getWidth(s){if(s>=0&&s<this.C.children.length){const o=this.C.children.item(s);if(o)return o.clientWidth}return 0}getHeight(s){if(s>=0&&s<this.C.children.length){const o=this.C.children.item(s);if(o)return o.clientHeight}return 0}pull(s){s>=0&&s<this.viewItems.length&&(this.C.removeChild(this.C.childNodes[s]),this.s.deleteAndDispose(this.viewItems[s]),(0,f.$Pc)(this.viewItems.splice(s,1)),this.J())}clear(){this.isEmpty()||(this.viewItems=(0,f.$Pc)(this.viewItems),this.s.clearAndDisposeAll(),i.$mR(this.C),this.J())}length(){return this.viewItems.length}isEmpty(){return this.viewItems.length===0}focus(s){let o=!1,h;if(s===void 0?o=!0:typeof s=="number"?h=s:typeof s=="boolean"&&(o=s),o&&typeof this.u>"u"){const c=this.viewItems.findIndex(b=>b.isEnabled());this.u=c===-1?void 0:c,this.R(void 0,void 0,!0)}else h!==void 0&&(this.u=h),this.R(void 0,void 0,!0)}N(){return this.u=this.length()-1,this.P(!0)}O(){return this.u=0,this.Q(!0)}P(s){if(typeof this.u>"u")this.u=this.viewItems.length-1;else if(this.viewItems.length<=1)return!1;const o=this.u;let h;do{if(!s&&this.b.preventLoopNavigation&&this.u+1>=this.viewItems.length)return this.u=o,!1;this.u=(this.u+1)%this.viewItems.length,h=this.viewItems[this.u]}while(this.u!==o&&(this.b.focusOnlyEnabledItems&&!h.isEnabled()||h.action.id===T.$hj.ID));return this.R(),!0}Q(s){if(typeof this.u>"u")this.u=0;else if(this.viewItems.length<=1)return!1;const o=this.u;let h;do{if(this.u=this.u-1,this.u<0){if(!s&&this.b.preventLoopNavigation)return this.u=o,!1;this.u=this.viewItems.length-1}h=this.viewItems[this.u]}while(this.u!==o&&(this.b.focusOnlyEnabledItems&&!h.isEnabled()||h.action.id===T.$hj.ID));return this.R(!0),!0}R(s,o,h=!1){typeof this.u>"u"&&this.C.focus({preventScroll:o}),this.t!==void 0&&this.t!==this.u&&this.viewItems[this.t]?.blur();const c=this.u!==void 0?this.viewItems[this.u]:void 0;if(c){let b=!0;w.$og(c.focus)||(b=!1),this.b.focusOnlyEnabledItems&&w.$og(c.isEnabled)&&!c.isEnabled()&&(b=!1),c.action.id===T.$hj.ID&&(b=!1),b?(h||this.t!==this.u)&&(c.focus(s),this.t=this.u):(this.C.focus({preventScroll:o}),this.t=void 0),b&&c.showHover?.()}}S(s){if(typeof this.u>"u")return;const o=this.viewItems[this.u];if(o instanceof B.$dU){const h=o._context===null||o._context===void 0?s:o._context;this.run(o._action,h)}}async run(s,o){await this.g.run(s,o)}dispose(){this.m=void 0,this.viewItems=(0,f.$Pc)(this.viewItems),this.getContainer().remove(),super.dispose()}}t.$jT=$;function m(e){if(!e.length)return e;let s=-1;for(let h=0;h<e.length;h++)if(e[h].id!==T.$hj.ID){s=h;break}if(s===-1)return[];e=e.slice(s);for(let h=e.length-1;h>=0&&e[h].id===T.$hj.ID;h--)e.splice(h,1);let o=!1;for(let h=e.length-1;h>=0;h--){const c=e[h].id===T.$hj.ID;c&&!o?e.splice(h,1):c?c&&(o=!1):o=!0}return e}}),define(pe[81],we([1,0,4,27,71,80,73,74,32,15,77,24,3,95,63,20,125,114]),function(oe,t,i,n,B,O,T,v,y,f,w,A,$,m,e,s,o){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$6U=t.$5U=t.$4U=t.MessageType=void 0;const h=i.$;var c;(function(E){E[E.INFO=1]="INFO",E[E.WARNING=2]="WARNING",E[E.ERROR=3]="ERROR"})(c||(t.MessageType=c={})),t.$4U={inputBackground:"#3C3C3C",inputForeground:"#CCCCCC",inputValidationInfoBorder:"#55AAFF",inputValidationInfoBackground:"#063B49",inputValidationWarningBorder:"#B89500",inputValidationWarningBackground:"#352A05",inputValidationErrorBorder:"#BE1100",inputValidationErrorBackground:"#5A1D1D",inputBorder:void 0,inputValidationErrorForeground:void 0,inputValidationInfoForeground:void 0,inputValidationWarningForeground:void 0};class b extends A.$1S{constructor(r,d,D){super(),this.w="idle",this.M=Number.POSITIVE_INFINITY,this.P=this.B(new $.$he),this.onDidChange=this.P.event,this.Q=this.B(new $.$he),this.onDidHeightChange=this.Q.event,this.a=d,this.g=D,this.h=null,this.n=this.g.placeholder||"",this.r=this.g.tooltip??(this.n||""),this.s=this.g.ariaLabel||"",this.g.validationOptions&&(this.t=this.g.validationOptions.validation),this.element=i.$nS(r,h(".monaco-inputbox.idle"));const R=this.g.flexibleHeight?"textarea":"input",_=i.$nS(this.element,h(".ibwrapper"));if(this.b=i.$nS(_,h(R+".input.empty")),this.b.setAttribute("autocorrect","off"),this.b.setAttribute("autocapitalize","off"),this.b.setAttribute("spellcheck","false"),this.G(this.b,()=>this.element.classList.add("synthetic-focus")),this.F(this.b,()=>this.element.classList.remove("synthetic-focus")),this.g.flexibleHeight){this.M=typeof this.g.flexibleMaxHeight=="number"?this.g.flexibleMaxHeight:Number.POSITIVE_INFINITY,this.y=i.$nS(_,h("div.mirror")),this.y.innerText="\xA0",this.N=new w.$$S(this.element,{vertical:s.ScrollbarVisibility.Auto}),this.g.flexibleWidth&&(this.b.setAttribute("wrap","off"),this.y.style.whiteSpace="pre",this.y.style.wordWrap="initial"),i.$nS(r,this.N.getDomNode()),this.B(this.N),this.B(this.N.onScroll(p=>this.b.scrollTop=p.scrollTop));const H=this.B(new n.$rT(r.ownerDocument,"selectionchange")),x=$.Event.filter(H.event,()=>r.ownerDocument.getSelection()?.anchorNode===_);this.B(x(this.U,this)),this.B(this.onDidHeightChange(this.U,this))}else this.b.type=this.g.type||"text",this.b.setAttribute("wrap","off");this.s&&this.b.setAttribute("aria-label",this.s),this.n&&!this.g.showPlaceholderOnFocus&&this.setPlaceHolder(this.n),this.r&&this.setTooltip(this.r),this.D(this.b,()=>this.Z()),this.F(this.b,()=>this.R()),this.G(this.b,()=>this.S()),this.B(this.I(this.b)),setTimeout(()=>this.ab(),0),this.g.actions&&(this.c=this.B(new O.$jT(this.element)),this.c.push(this.g.actions,{icon:!0,label:!1})),this.bb()}R(){this.Y(),this.g.showPlaceholderOnFocus&&this.b.setAttribute("placeholder","")}S(){this.X(),this.g.showPlaceholderOnFocus&&this.b.setAttribute("placeholder",this.n||"")}setPlaceHolder(r){this.n=r,this.b.setAttribute("placeholder",r)}setTooltip(r){this.r=r,this.O?this.O.update(r):this.O=this.B((0,y.$6T)().setupUpdatableHover((0,f.$hT)("mouse"),this.b,r))}setAriaLabel(r){this.s=r,r?this.b.setAttribute("aria-label",this.s):this.b.removeAttribute("aria-label")}getAriaLabel(){return this.s}get mirrorElement(){return this.y}get inputElement(){return this.b}get value(){return this.b.value}set value(r){this.b.value!==r&&(this.b.value=r,this.Z())}get step(){return this.b.step}set step(r){this.b.step=r}get height(){return typeof this.J=="number"?this.J:i.$PR(this.element)}focus(){this.b.focus()}blur(){this.b.blur()}hasFocus(){return i.$1R(this.b)}select(r=null){this.b.select(),r&&(this.b.setSelectionRange(r.start,r.end),r.end===this.b.value.length&&(this.b.scrollLeft=this.b.scrollWidth))}isSelectionAtEnd(){return this.b.selectionEnd===this.b.value.length&&this.b.selectionStart===this.b.selectionEnd}getSelection(){const r=this.b.selectionStart;if(r===null)return null;const d=this.b.selectionEnd??r;return{start:r,end:d}}enable(){this.b.removeAttribute("disabled")}disable(){this.blur(),this.b.disabled=!0,this.Y()}setEnabled(r){r?this.enable():this.disable()}get width(){return i.$LR(this.b)}set width(r){if(this.g.flexibleHeight&&this.g.flexibleWidth){let d=0;if(this.y){const D=parseFloat(this.y.style.paddingLeft||"")||0,R=parseFloat(this.y.style.paddingRight||"")||0;d=D+R}this.b.style.width=r-d+"px"}else this.b.style.width=r+"px";this.y&&(this.y.style.width=r+"px")}set paddingRight(r){this.b.style.width=`calc(100% - ${r}px)`,this.y&&(this.y.style.paddingRight=r+"px")}U(){if(typeof this.L!="number"||typeof this.J!="number"||!this.N)return;const r=this.L,d=this.J,D=this.b.scrollTop;this.N.setScrollDimensions({scrollHeight:r,height:d}),this.N.setScrollPosition({scrollTop:D})}showMessage(r,d){if(this.w==="open"&&(0,e.$ao)(this.h,r))return;this.h=r,this.element.classList.remove("idle"),this.element.classList.remove("info"),this.element.classList.remove("warning"),this.element.classList.remove("error"),this.element.classList.add(this.W(r.type));const D=this.stylesForType(this.h.type);this.element.style.border=`1px solid ${i.$FS(D.border,"transparent")}`,this.h.content&&(this.hasFocus()||d)&&this.X()}hideMessage(){this.h=null,this.element.classList.remove("info"),this.element.classList.remove("warning"),this.element.classList.remove("error"),this.element.classList.add("idle"),this.Y(),this.bb()}isInputValid(){return!!this.t&&!this.t(this.value)}validate(){let r=null;return this.t&&(r=this.t(this.value),r?(this.inputElement.setAttribute("aria-invalid","true"),this.showMessage(r)):this.inputElement.hasAttribute("aria-invalid")&&(this.inputElement.removeAttribute("aria-invalid"),this.hideMessage())),r?.type}stylesForType(r){const d=this.g.inputBoxStyles;switch(r){case c.INFO:return{border:d.inputValidationInfoBorder,background:d.inputValidationInfoBackground,foreground:d.inputValidationInfoForeground};case c.WARNING:return{border:d.inputValidationWarningBorder,background:d.inputValidationWarningBackground,foreground:d.inputValidationWarningForeground};default:return{border:d.inputValidationErrorBorder,background:d.inputValidationErrorBackground,foreground:d.inputValidationErrorForeground}}}W(r){switch(r){case c.INFO:return"info";case c.WARNING:return"warning";default:return"error"}}X(){if(!this.a||!this.h)return;let r;const d=()=>r.style.width=i.$LR(this.element)+"px";this.a.showContextView({getAnchor:()=>this.element,anchorAlignment:v.AnchorAlignment.RIGHT,render:R=>{if(!this.h)return null;r=i.$nS(R,h(".monaco-inputbox-container")),d();const _={inline:!0,className:"monaco-inputbox-message"},H=this.h.formatContent?(0,B.$pT)(this.h.content,_):(0,B.$oT)(this.h.content,_);H.classList.add(this.W(this.h.type));const x=this.stylesForType(this.h.type);return H.style.backgroundColor=x.background??"",H.style.color=x.foreground??"",H.style.border=x.border?`1px solid ${x.border}`:"",i.$nS(r,H),null},onHide:()=>{this.w="closed"},layout:d});let D;this.h.type===c.ERROR?D=o.localize(0,null,this.h.content):this.h.type===c.WARNING?D=o.localize(1,null,this.h.content):D=o.localize(2,null,this.h.content),T.$tT(D),this.w="open"}Y(){this.a&&(this.w==="open"&&this.a.hideContextView(),this.w="idle")}Z(){this.P.fire(this.value),this.validate(),this.ab(),this.b.classList.toggle("empty",!this.value),this.w==="open"&&this.a&&this.a.layout()}ab(){if(!this.y)return;const r=this.value,D=r.charCodeAt(r.length-1)===10?" ":"";(r+D).replace(/\u000c/g,"")?this.y.textContent=r+D:this.y.innerText="\xA0",this.layout()}bb(){const r=this.g.inputBoxStyles,d=r.inputBackground??"",D=r.inputForeground??"",R=r.inputBorder??"";this.element.style.backgroundColor=d,this.element.style.color=D,this.b.style.backgroundColor="inherit",this.b.style.color=D,this.element.style.border=`1px solid ${i.$FS(R,"transparent")}`}layout(){if(!this.y)return;const r=this.L;this.L=i.$PR(this.y),r!==this.L&&(this.J=Math.min(this.L,this.M),this.b.style.height=this.J+"px",this.Q.fire(this.L))}insertAtCursor(r){const d=this.inputElement,D=d.selectionStart,R=d.selectionEnd,_=d.value;D!==null&&R!==null&&(this.value=_.substr(0,D)+r+_.substr(R),d.setSelectionRange(D+1,D+1),this.layout())}dispose(){this.Y(),this.h=null,this.c?.dispose(),super.dispose()}}t.$5U=b;class k extends b{constructor(r,d,D){const R=o.localize(3,null,"\u21C5"),_=o.localize(4,null,"\u21C5");super(r,d,D),this.eb=this.B(new $.$he),this.onDidFocus=this.eb.event,this.fb=this.B(new $.$he),this.onDidBlur=this.fb.event,this.cb=new m.$2U(D.history,100);const H=()=>{if(D.showHistoryHint&&D.showHistoryHint()&&!this.n.endsWith(R)&&!this.n.endsWith(_)&&this.cb.getHistory().length){const x=this.n.endsWith(")")?R:_,p=this.n+x;D.showPlaceholderOnFocus&&!i.$1R(this.b)?this.n=p:this.setPlaceHolder(p)}};this.db=new MutationObserver((x,p)=>{x.forEach(M=>{M.target.textContent||H()})}),this.db.observe(this.b,{attributeFilter:["class"]}),this.G(this.b,()=>H()),this.F(this.b,()=>{const x=p=>{if(this.n.endsWith(p)){const M=this.n.slice(0,this.n.length-p.length);return D.showPlaceholderOnFocus?this.n=M:this.setPlaceHolder(M),!0}else return!1};x(_)||x(R)})}dispose(){super.dispose(),this.db&&(this.db.disconnect(),this.db=void 0)}addToHistory(r){this.value&&(r||this.value!==this.ib())&&this.cb.add(this.value)}prependHistory(r){const d=this.getHistory();this.clearHistory(),r.forEach(D=>{this.cb.add(D)}),d.forEach(D=>{this.cb.add(D)})}getHistory(){return this.cb.getHistory()}isAtFirstInHistory(){return this.cb.isFirst()}isAtLastInHistory(){return this.cb.isLast()}isNowhereInHistory(){return this.cb.isNowhere()}showNextValue(){this.cb.has(this.value)||this.addToHistory();let r=this.kb();r&&(r=r===this.value?this.kb():r),this.value=r??"",T.$uT(this.value?this.value:o.localize(5,null))}showPreviousValue(){this.cb.has(this.value)||this.addToHistory();let r=this.jb();r&&(r=r===this.value?this.jb():r),r&&(this.value=r,T.$uT(this.value))}clearHistory(){this.cb.clear()}setPlaceHolder(r){super.setPlaceHolder(r),this.setTooltip(r)}R(){super.R(),this.fb.fire()}S(){super.S(),this.eb.fire()}ib(){let r=this.cb.current();return r||(r=this.cb.last(),this.cb.next()),r}jb(){return this.cb.previous()||this.cb.first()}kb(){return this.cb.next()}}t.$6U=k}),define(pe[82],we([1,0,79,24,21,22,3,8,4,15,32,119]),function(oe,t,i,n,B,O,T,v,y,f,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$cU=t.$bU=t.$aU=t.$_T=t.$$T=void 0,t.$$T={inputActiveOptionBorder:"#007ACC00",inputActiveOptionForeground:"#FFFFFF",inputActiveOptionBackground:"#0E639C50"};class A extends i.$dU{constructor(o,h,c){super(o,h,c),this.a=this.B(new $({actionClassName:this._action.class,isChecked:!!this._action.checked,title:this.m.keybinding?`${this._action.label} (${this.m.keybinding})`:this._action.label,notFocusable:!0,inputActiveOptionBackground:c.toggleStyles?.inputActiveOptionBackground,inputActiveOptionBorder:c.toggleStyles?.inputActiveOptionBorder,inputActiveOptionForeground:c.toggleStyles?.inputActiveOptionForeground,hoverDelegate:c.hoverDelegate})),this.B(this.a.onChange(()=>this._action.checked=!!this.a&&this.a.checked))}render(o){this.element=o,this.element.appendChild(this.a.domNode)}u(){this.a&&(this.isEnabled()?this.a.enable():this.a.disable())}H(){this.a.checked=!!this._action.checked}focus(){this.a.domNode.tabIndex=0,this.a.focus()}blur(){this.a.domNode.tabIndex=-1,this.a.domNode.blur()}setFocusable(o){this.a.domNode.tabIndex=o?0:-1}}t.$_T=A;class $ extends n.$1S{constructor(o){super(),this.a=this.B(new T.$he),this.onChange=this.a.event,this.b=this.B(new T.$he),this.onKeyDown=this.b.event,this.c=o,this.s=this.c.isChecked;const h=["monaco-custom-toggle"];this.c.icon&&(this.g=this.c.icon,h.push(...O.ThemeIcon.asClassNameArray(this.g))),this.c.actionClassName&&h.push(...this.c.actionClassName.split(" ")),this.s&&h.push("checked"),this.domNode=document.createElement("div"),this.t=this.B((0,w.$6T)().setupUpdatableHover(o.hoverDelegate??(0,f.$hT)("mouse"),this.domNode,this.c.title)),this.domNode.classList.add(...h),this.c.notFocusable||(this.domNode.tabIndex=0),this.domNode.setAttribute("role","checkbox"),this.domNode.setAttribute("aria-checked",String(this.s)),this.domNode.setAttribute("aria-label",this.c.title),this.w(),this.f(this.domNode,c=>{this.enabled&&(this.checked=!this.s,this.a.fire(!1),c.preventDefault())}),this.B(this.I(this.domNode)),this.z(this.domNode,c=>{if(c.keyCode===v.KeyCode.Space||c.keyCode===v.KeyCode.Enter){this.checked=!this.s,this.a.fire(!0),c.preventDefault(),c.stopPropagation();return}this.b.fire(c)})}get enabled(){return this.domNode.getAttribute("aria-disabled")!=="true"}focus(){this.domNode.focus()}get checked(){return this.s}set checked(o){this.s=o,this.domNode.setAttribute("aria-checked",String(this.s)),this.domNode.classList.toggle("checked",this.s),this.w()}setIcon(o){this.g&&this.domNode.classList.remove(...O.ThemeIcon.asClassNameArray(this.g)),this.g=o,this.g&&this.domNode.classList.add(...O.ThemeIcon.asClassNameArray(this.g))}width(){return 22}w(){this.domNode&&(this.domNode.style.borderColor=this.s&&this.c.inputActiveOptionBorder||"",this.domNode.style.color=this.s&&this.c.inputActiveOptionForeground||"inherit",this.domNode.style.backgroundColor=this.s&&this.c.inputActiveOptionBackground||"")}enable(){this.domNode.setAttribute("aria-disabled",String(!1))}disable(){this.domNode.setAttribute("aria-disabled",String(!0))}setTitle(o){this.t.update(o),this.domNode.setAttribute("aria-label",o)}set visible(o){this.domNode.style.display=o?"":"none"}get visible(){return this.domNode.style.display!=="none"}}t.$aU=$;class m extends n.$1S{static{this.CLASS_NAME="monaco-checkbox"}constructor(o,h,c){super(),this.g=o,this.h=h,this.a=this.B(new T.$he),this.onChange=this.a.event,this.b=this.B(new $({title:this.g,isChecked:this.h,icon:B.$Zj.check,actionClassName:m.CLASS_NAME,...t.$$T})),this.domNode=this.b.domNode,this.c=c,this.n(),this.B(this.b.onChange(b=>{this.n(),this.a.fire(b)}))}get checked(){return this.b.checked}set checked(o){this.b.checked=o,this.n()}focus(){this.domNode.focus()}hasFocus(){return(0,y.$1R)(this.domNode)}enable(){this.b.enable()}disable(){this.b.disable()}n(){this.domNode.style.color=this.c.checkboxForeground||"",this.domNode.style.backgroundColor=this.c.checkboxBackground||"",this.domNode.style.borderColor=this.c.checkboxBorder||""}}t.$bU=m;class e extends i.$dU{constructor(o,h,c){super(o,h,c),this.a=this.B(new m(this._action.label,!!this._action.checked,c.checkboxStyles)),this.B(this.a.onChange(()=>this.c()))}render(o){if(this.element=o,this.element.classList.add("checkbox-action-item"),this.element.appendChild(this.a.domNode),this.m.label&&this._action.label){const h=this.element.appendChild((0,y.$)("span.checkbox-label",void 0,this._action.label));this.B((0,y.$nR)(h,y.$gS.CLICK,c=>{this.a.checked=!this.a.checked,c.stopPropagation(),c.preventDefault(),this.c()}))}this.u(),this.G(),this.H()}c(){this._action.checked=!!this.a&&this.a.checked,this.actionRunner.run(this._action,this._context)}u(){this.isEnabled()?this.a.enable():this.a.disable(),this.action.enabled?this.element?.classList.remove("disabled"):this.element?.classList.add("disabled")}H(){this.a.checked=!!this._action.checked}G(){this.b&&this.a.domNode.classList.remove(...this.b.split(" ")),this.b=this.z(),this.b&&this.a.domNode.classList.add(...this.b.split(" "))}focus(){this.a.domNode.tabIndex=0,this.a.focus()}blur(){this.a.domNode.tabIndex=-1,this.a.domNode.blur()}setFocusable(o){this.a.domNode.tabIndex=o?0:-1}}t.$cU=e}),define(pe[146],we([1,0,15,82,21,124]),function(oe,t,i,n,B,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$_U=t.$$U=t.$0U=void 0;const T=O.localize(0,null),v=O.localize(1,null),y=O.localize(2,null);class f extends n.$aU{constructor(m){super({icon:B.$Zj.caseSensitive,title:T+m.appendTitle,isChecked:m.isChecked,hoverDelegate:m.hoverDelegate??(0,i.$hT)("element"),inputActiveOptionBorder:m.inputActiveOptionBorder,inputActiveOptionForeground:m.inputActiveOptionForeground,inputActiveOptionBackground:m.inputActiveOptionBackground})}}t.$0U=f;class w extends n.$aU{constructor(m){super({icon:B.$Zj.wholeWord,title:v+m.appendTitle,isChecked:m.isChecked,hoverDelegate:m.hoverDelegate??(0,i.$hT)("element"),inputActiveOptionBorder:m.inputActiveOptionBorder,inputActiveOptionForeground:m.inputActiveOptionForeground,inputActiveOptionBackground:m.inputActiveOptionBackground})}}t.$$U=w;class A extends n.$aU{constructor(m){super({icon:B.$Zj.regex,title:y+m.appendTitle,isChecked:m.isChecked,hoverDelegate:m.hoverDelegate??(0,i.$hT)("element"),inputActiveOptionBorder:m.inputActiveOptionBorder,inputActiveOptionForeground:m.inputActiveOptionForeground,inputActiveOptionBackground:m.inputActiveOptionBackground})}}t.$_U=A}),define(pe[147],we([1,0,4,146,81,24,3,8,123,2,15,113]),function(oe,t,i,n,B,O,T,v,y,f,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$aV=void 0;const A=y.localize(0,null);class $ extends O.$1S{static{this.OPTION_CHANGE="optionChange"}constructor(e,s,o){super(),this.n=!0,this.s=!1,this.w=this.B(new f.$Vc),this.N=[],this.O=this.B(new T.$he),this.onDidOptionChange=this.O.event,this.P=this.B(new T.$he),this.onKeyDown=this.P.event,this.Q=this.B(new T.$he),this.onMouseDown=this.Q.event,this.R=this.B(new T.$he),this.onInput=this.R.event,this.S=this.B(new T.$he),this.onKeyUp=this.S.event,this.U=this.B(new T.$he),this.onCaseSensitiveKeyDown=this.U.event,this.W=this.B(new T.$he),this.onRegexKeyDown=this.W.event,this.Y=0,this.a=o.placeholder||"",this.b=o.validation,this.c=o.label||A,this.h=!!o.showCommonFindToggles;const h=o.appendCaseSensitiveLabel||"",c=o.appendWholeWordsLabel||"",b=o.appendRegexLabel||"",k=o.history||[],E=!!o.flexibleHeight,r=!!o.flexibleWidth,d=o.flexibleMaxHeight;this.domNode=document.createElement("div"),this.domNode.classList.add("monaco-findInput"),this.inputBox=this.B(new B.$6U(this.domNode,s,{placeholder:this.a||"",ariaLabel:this.c||"",validationOptions:{validation:this.b},history:k,showHistoryHint:o.showHistoryHint,flexibleHeight:E,flexibleWidth:r,flexibleMaxHeight:d,inputBoxStyles:o.inputBoxStyles}));const D=this.B((0,w.$iT)());if(this.h){this.J=this.B(new n.$_U({appendTitle:b,isChecked:!1,hoverDelegate:D,...o.toggleStyles})),this.B(this.J.onChange(_=>{this.O.fire(_),!_&&this.n&&this.inputBox.focus(),this.validate()})),this.B(this.J.onKeyDown(_=>{this.W.fire(_)})),this.L=this.B(new n.$$U({appendTitle:c,isChecked:!1,hoverDelegate:D,...o.toggleStyles})),this.B(this.L.onChange(_=>{this.O.fire(_),!_&&this.n&&this.inputBox.focus(),this.validate()})),this.M=this.B(new n.$0U({appendTitle:h,isChecked:!1,hoverDelegate:D,...o.toggleStyles})),this.B(this.M.onChange(_=>{this.O.fire(_),!_&&this.n&&this.inputBox.focus(),this.validate()})),this.B(this.M.onKeyDown(_=>{this.U.fire(_)}));const R=[this.M.domNode,this.L.domNode,this.J.domNode];this.z(this.domNode,_=>{if(_.equals(v.KeyCode.LeftArrow)||_.equals(v.KeyCode.RightArrow)||_.equals(v.KeyCode.Escape)){const H=R.indexOf(this.domNode.ownerDocument.activeElement);if(H>=0){let x=-1;_.equals(v.KeyCode.RightArrow)?x=(H+1)%R.length:_.equals(v.KeyCode.LeftArrow)&&(H===0?x=R.length-1:x=H-1),_.equals(v.KeyCode.Escape)?(R[H].blur(),this.inputBox.focus()):x>=0&&R[x].focus(),i.$iS.stop(_,!0)}}})}this.y=document.createElement("div"),this.y.className="controls",this.y.style.display=this.h?"":"none",this.M&&this.y.append(this.M.domNode),this.L&&this.y.appendChild(this.L.domNode),this.J&&this.y.appendChild(this.J.domNode),this.setAdditionalToggles(o?.additionalToggles),this.y&&this.domNode.appendChild(this.y),e?.appendChild(this.domNode),this.B(i.$nR(this.inputBox.inputElement,"compositionstart",R=>{this.s=!0})),this.B(i.$nR(this.inputBox.inputElement,"compositionend",R=>{this.s=!1,this.R.fire()})),this.z(this.inputBox.inputElement,R=>this.P.fire(R)),this.C(this.inputBox.inputElement,R=>this.S.fire(R)),this.D(this.inputBox.inputElement,R=>this.R.fire()),this.j(this.inputBox.inputElement,R=>this.Q.fire(R))}get isImeSessionInProgress(){return this.s}get onDidChange(){return this.inputBox.onDidChange}layout(e){this.inputBox.layout(),this.X(e.collapsedFindWidget)}enable(){this.domNode.classList.remove("disabled"),this.inputBox.enable(),this.J?.enable(),this.L?.enable(),this.M?.enable();for(const e of this.N)e.enable()}disable(){this.domNode.classList.add("disabled"),this.inputBox.disable(),this.J?.disable(),this.L?.disable(),this.M?.disable();for(const e of this.N)e.disable()}setFocusInputOnOptionClick(e){this.n=e}setEnabled(e){e?this.enable():this.disable()}setAdditionalToggles(e){for(const s of this.N)s.domNode.remove();this.N=[],this.w.value=new f.$Tc;for(const s of e??[])this.w.value.add(s),this.y.appendChild(s.domNode),this.w.value.add(s.onChange(o=>{this.O.fire(o),!o&&this.n&&this.inputBox.focus()})),this.N.push(s);this.N.length>0&&(this.y.style.display=""),this.X()}X(e=!1){e?this.inputBox.paddingRight=0:this.inputBox.paddingRight=(this.M?.width()??0)+(this.L?.width()??0)+(this.J?.width()??0)+this.N.reduce((s,o)=>s+o.width(),0)}clear(){this.Z(),this.setValue(""),this.focus()}getValue(){return this.inputBox.value}setValue(e){this.inputBox.value!==e&&(this.inputBox.value=e)}onSearchSubmit(){this.inputBox.addToHistory()}select(){this.inputBox.select()}focus(){this.inputBox.focus()}getCaseSensitive(){return this.M?.checked??!1}setCaseSensitive(e){this.M&&(this.M.checked=e)}getWholeWords(){return this.L?.checked??!1}setWholeWords(e){this.L&&(this.L.checked=e)}getRegex(){return this.J?.checked??!1}setRegex(e){this.J&&(this.J.checked=e,this.validate())}focusOnCaseSensitive(){this.M?.focus()}focusOnRegex(){this.J?.focus()}highlightFindOptions(){this.domNode.classList.remove("highlight-"+this.Y),this.Y=1-this.Y,this.domNode.classList.add("highlight-"+this.Y)}validate(){this.inputBox.validate()}showMessage(e){this.inputBox.showMessage(e)}clearMessage(){this.inputBox.hideMessage()}Z(){this.inputBox.hideMessage()}}t.$aV=$}),define(pe[148],we([1,0,4,27,16,80,147,81,78,54,82,75,33,51,9,12,21,22,43,3,50,8,2,44,10,127,15,61,120]),function(oe,t,i,n,B,O,T,v,y,f,w,A,$,m,e,s,o,h,c,b,k,E,r,d,D,R,_,H){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$NV=t.AbstractTreePart=t.TreeFindMatchType=t.TreeFindMode=t.$MV=t.$LV=t.$KV=t.RenderIndentGuides=t.$JV=t.$IV=void 0;class x extends y.$BT{set context(u){this.c.context=u}get context(){return this.c.context}constructor(u){super(u.elements.map(L=>L.element)),this.c=u}}function p(F){return F instanceof y.$BT?new x(F):F}class M{constructor(u,L){this.d=u,this.f=L,this.b=r.$Uc.None,this.c=new r.$Tc}getDragURI(u){return this.f.getDragURI(u.element)}getDragLabel(u,L){if(this.f.getDragLabel)return this.f.getDragLabel(u.map(S=>S.element),L)}onDragStart(u,L){this.f.onDragStart?.(p(u),L)}onDragOver(u,L,S,j,z,q=!0){const ee=this.f.onDragOver(p(u),L&&L.element,S,j,z),re=this.a!==L;if(re&&(this.b.dispose(),this.a=L),typeof L>"u")return ee;if(re&&typeof ee!="boolean"&&ee.autoExpand&&(this.b=(0,s.$Ch)(()=>{const Te=this.d(),he=Te.getNodeLocation(L);Te.isCollapsed(he)&&Te.setCollapsed(he,!1),this.a=void 0},500,this.c)),typeof ee=="boolean"||!ee.accept||typeof ee.bubble>"u"||ee.feedback){if(!q){const Te=typeof ee=="boolean"?ee:ee.accept,he=typeof ee=="boolean"?void 0:ee.effect;return{accept:Te,effect:he,feedback:[S]}}return ee}if(ee.bubble===$.TreeDragOverBubble.Up){const Te=this.d(),he=Te.getNodeLocation(L),Fe=Te.getParentNodeLocation(he),xe=Te.getNode(Fe),Ye=Fe&&Te.getListIndex(Fe);return this.onDragOver(u,xe,Ye,j,z,!1)}const ce=this.d(),Ee=ce.getNodeLocation(L),ve=ce.getListIndex(Ee),Re=ce.getListRenderCount(Ee);return{...ee,feedback:(0,e.$Rb)(ve,ve+Re)}}drop(u,L,S,j,z){this.b.dispose(),this.a=void 0,this.f.drop(p(u),L&&L.element,S,j,z)}onDragEnd(u){this.f.onDragEnd?.(u)}dispose(){this.c.dispose(),this.f.dispose()}}function U(F,u){return u&&{...u,identityProvider:u.identityProvider&&{getId(L){return u.identityProvider.getId(L.element)}},dnd:u.dnd&&new M(F,u.dnd),multipleSelectionController:u.multipleSelectionController&&{isSelectionSingleChangeEvent(L){return u.multipleSelectionController.isSelectionSingleChangeEvent({...L,element:L.element})},isSelectionRangeChangeEvent(L){return u.multipleSelectionController.isSelectionRangeChangeEvent({...L,element:L.element})}},accessibilityProvider:u.accessibilityProvider&&{...u.accessibilityProvider,getSetSize(L){const S=F(),j=S.getNodeLocation(L),z=S.getParentNodeLocation(j);return S.getNode(z).visibleChildrenCount},getPosInSet(L){return L.visibleChildIndex+1},isChecked:u.accessibilityProvider&&u.accessibilityProvider.isChecked?L=>u.accessibilityProvider.isChecked(L.element):void 0,getRole:u.accessibilityProvider&&u.accessibilityProvider.getRole?L=>u.accessibilityProvider.getRole(L.element):()=>"treeitem",getAriaLabel(L){return u.accessibilityProvider.getAriaLabel(L.element)},getWidgetAriaLabel(){return u.accessibilityProvider.getWidgetAriaLabel()},getWidgetRole:u.accessibilityProvider&&u.accessibilityProvider.getWidgetRole?()=>u.accessibilityProvider.getWidgetRole():()=>"tree",getAriaLevel:u.accessibilityProvider&&u.accessibilityProvider.getAriaLevel?L=>u.accessibilityProvider.getAriaLevel(L.element):L=>L.depth,getActiveDescendantId:u.accessibilityProvider.getActiveDescendantId&&(L=>u.accessibilityProvider.getActiveDescendantId(L.element))},keyboardNavigationLabelProvider:u.keyboardNavigationLabelProvider&&{...u.keyboardNavigationLabelProvider,getKeyboardNavigationLabel(L){return u.keyboardNavigationLabelProvider.getKeyboardNavigationLabel(L.element)}}}}class N{constructor(u){this.a=u}getHeight(u){return this.a.getHeight(u.element)}getTemplateId(u){return this.a.getTemplateId(u.element)}hasDynamicHeight(u){return!!this.a.hasDynamicHeight&&this.a.hasDynamicHeight(u.element)}setDynamicHeight(u,L){this.a.setDynamicHeight?.(u.element,L)}}t.$IV=N;class P{static lift(u){return u instanceof P?u:new P(u)}static empty(u=0){return new P({focus:[],selection:[],expanded:Object.create(null),scrollTop:u})}constructor(u){if(this.focus=new Set(u.focus),this.selection=new Set(u.selection),u.expanded instanceof Array){this.expanded=Object.create(null);for(const L of u.expanded)this.expanded[L]=1}else this.expanded=u.expanded;this.expanded=u.expanded,this.scrollTop=u.scrollTop}toJSON(){return{focus:Array.from(this.focus),selection:Array.from(this.selection),expanded:this.expanded,scrollTop:this.scrollTop}}}t.$JV=P;var W;(function(F){F.None="none",F.OnHover="onHover",F.Always="always"})(W||(t.RenderIndentGuides=W={}));class ne{get elements(){return this.b}constructor(u,L=[]){this.b=L,this.a=new r.$Tc,this.onDidChange=b.Event.forEach(u,S=>this.b=S,this.a)}dispose(){this.a.dispose()}}class Q{static{this.a=8}constructor(u,L,S,j,z,q={}){this.o=u,this.p=L,this.q=j,this.s=z,this.b=new Map,this.c=new Map,this.d=Q.a,this.f=!1,this.g=!1,this.j=new Set,this.k=r.$Uc.None,this.m=new r.$Tc,this.templateId=u.templateId,this.updateOptions(q),b.Event.map(S,ee=>ee.node)(this.u,this,this.m),u.onDidChangeTwistieState?.(this.t,this,this.m)}updateOptions(u={}){if(typeof u.indent<"u"){const L=(0,d.$Gm)(u.indent,0,40);if(L!==this.d){this.d=L;for(const[S,j]of this.c)this.v(S,j)}}if(typeof u.renderIndentGuides<"u"){const L=u.renderIndentGuides!==W.None;if(L!==this.g){this.g=L;for(const[S,j]of this.c)this.w(S,j);if(this.k.dispose(),L){const S=new r.$Tc;this.q.onDidChange(this.x,this,S),this.k=S,this.x(this.q.elements)}}}typeof u.hideTwistiesOfChildlessElements<"u"&&(this.f=u.hideTwistiesOfChildlessElements)}renderTemplate(u){const L=(0,i.$nS)(u,(0,i.$)(".monaco-tl-row")),S=(0,i.$nS)(L,(0,i.$)(".monaco-tl-indent")),j=(0,i.$nS)(L,(0,i.$)(".monaco-tl-twistie")),z=(0,i.$nS)(L,(0,i.$)(".monaco-tl-contents")),q=this.o.renderTemplate(z);return{container:u,indent:S,twistie:j,indentGuidesDisposable:r.$Uc.None,templateData:q}}renderElement(u,L,S,j){this.c.set(u,S),this.b.set(u.element,u),this.v(u,S),this.o.renderElement(u,L,S.templateData,j)}disposeElement(u,L,S,j){S.indentGuidesDisposable.dispose(),this.o.disposeElement?.(u,L,S.templateData,j),typeof j=="number"&&(this.c.delete(u),this.b.delete(u.element))}disposeTemplate(u){this.o.disposeTemplate(u.templateData)}t(u){const L=this.b.get(u);L&&this.u(L)}u(u){const L=this.c.get(u);L&&(this.x(this.q.elements),this.v(u,L))}v(u,L){const S=Q.a+(u.depth-1)*this.d;L.twistie.style.paddingLeft=`${S}px`,L.indent.style.width=`${S+this.d-16}px`,u.collapsible?L.container.setAttribute("aria-expanded",String(!u.collapsed)):L.container.removeAttribute("aria-expanded"),L.twistie.classList.remove(...h.ThemeIcon.asClassNameArray(o.$Zj.treeItemExpanded));let j=!1;this.o.renderTwistie&&(j=this.o.renderTwistie(u.element,L.twistie)),u.collapsible&&(!this.f||u.visibleChildrenCount>0)?(j||L.twistie.classList.add(...h.ThemeIcon.asClassNameArray(o.$Zj.treeItemExpanded)),L.twistie.classList.add("collapsible"),L.twistie.classList.toggle("collapsed",u.collapsed)):L.twistie.classList.remove("collapsible","collapsed"),this.w(u,L)}w(u,L){if((0,i.$mR)(L.indent),L.indentGuidesDisposable.dispose(),!this.g)return;const S=new r.$Tc,j=this.p();for(;;){const z=j.getNodeLocation(u),q=j.getParentNodeLocation(z);if(!q)break;const ee=j.getNode(q),re=(0,i.$)(".indent-guide",{style:`width: ${this.d}px`});this.j.has(ee)&&re.classList.add("active"),L.indent.childElementCount===0?L.indent.appendChild(re):L.indent.insertBefore(re,L.indent.firstElementChild),this.s.add(ee,re),S.add((0,r.$Sc)(()=>this.s.delete(ee,re))),u=ee}L.indentGuidesDisposable=S}x(u){if(!this.g)return;const L=new Set,S=this.p();u.forEach(j=>{const z=S.getNodeLocation(j);try{const q=S.getParentNodeLocation(z);j.collapsible&&j.children.length>0&&!j.collapsed?L.add(j):q&&L.add(S.getNode(q))}catch{}}),this.j.forEach(j=>{L.has(j)||this.s.forEach(j,z=>z.classList.remove("active"))}),L.forEach(j=>{this.j.has(j)||this.s.forEach(j,z=>z.classList.add("active"))}),this.j=L}dispose(){this.c.clear(),this.b.clear(),this.k.dispose(),(0,r.$Pc)(this.m)}}t.$KV=Q;class Y{get totalCount(){return this.a}get matchCount(){return this.b}set pattern(u){this.c=u,this.d=u.toLowerCase()}constructor(u,L,S){this.g=u,this.j=L,this.k=S,this.a=0,this.b=0,this.c="",this.d="",this.f=new r.$Tc,u.onWillRefilter(this.m,this,this.f)}filter(u,L){let S=$.TreeVisibility.Visible;if(this.k){const q=this.k.filter(u,L);if(typeof q=="boolean"?S=q?$.TreeVisibility.Visible:$.TreeVisibility.Hidden:(0,A.$FV)(q)?S=(0,A.$GV)(q.visibility):S=q,S===$.TreeVisibility.Hidden)return!1}if(this.a++,!this.c)return this.b++,{data:k.FuzzyScore.Default,visibility:S};const j=this.j.getKeyboardNavigationLabel(u),z=Array.isArray(j)?j:[j];for(const q of z){const ee=q&&q.toString();if(typeof ee>"u")return{data:k.FuzzyScore.Default,visibility:S};let re;if(this.g.findMatchType===Se.Contiguous){const ce=ee.toLowerCase().indexOf(this.d);if(ce>-1){re=[Number.MAX_SAFE_INTEGER,0];for(let Ee=this.d.length;Ee>0;Ee--)re.push(ce+Ee-1)}}else re=(0,k.$Ok)(this.c,this.d,0,ee,ee.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(re)return this.b++,z.length===1?{data:re,visibility:S}:{data:{label:ee,score:re},visibility:S}}return this.g.findMode===Le.Filter?typeof this.g.options.defaultFindVisibility=="number"?this.g.options.defaultFindVisibility:this.g.options.defaultFindVisibility?this.g.options.defaultFindVisibility(u):$.TreeVisibility.Recurse:{data:k.FuzzyScore.Default,visibility:S}}m(){this.a=0,this.b=0}dispose(){(0,r.$Pc)(this.f)}}class te extends w.$aU{constructor(u){super({icon:o.$Zj.listFilter,title:(0,R.localize)(0,null),isChecked:u.isChecked??!1,hoverDelegate:u.hoverDelegate??(0,_.$hT)("element"),inputActiveOptionBorder:u.inputActiveOptionBorder,inputActiveOptionForeground:u.inputActiveOptionForeground,inputActiveOptionBackground:u.inputActiveOptionBackground})}}t.$LV=te;class de extends w.$aU{constructor(u){super({icon:o.$Zj.searchFuzzy,title:(0,R.localize)(1,null),isChecked:u.isChecked??!1,hoverDelegate:u.hoverDelegate??(0,_.$hT)("element"),inputActiveOptionBorder:u.inputActiveOptionBorder,inputActiveOptionForeground:u.inputActiveOptionForeground,inputActiveOptionBackground:u.inputActiveOptionBackground})}}t.$MV=de;const De={inputBoxStyles:v.$4U,toggleStyles:w.$$T,listFilterWidgetBackground:void 0,listFilterWidgetNoMatchesOutline:void 0,listFilterWidgetOutline:void 0,listFilterWidgetShadow:void 0};var Le;(function(F){F[F.Highlight=0]="Highlight",F[F.Filter=1]="Filter"})(Le||(t.TreeFindMode=Le={}));var Se;(function(F){F[F.Fuzzy=0]="Fuzzy",F[F.Contiguous=1]="Contiguous"})(Se||(t.TreeFindMatchType=Se={}));class ue extends r.$Uc{set mode(u){this.b.checked=u===Le.Filter,this.f.inputBox.setPlaceHolder(u===Le.Filter?(0,R.localize)(2,null):(0,R.localize)(3,null))}set matchType(u){this.c.checked=u===Se.Fuzzy}get value(){return this.f.inputBox.value}set value(u){this.f.inputBox.value=u}constructor(u,L,S,j,z,q){super(),this.t=L,this.a=(0,i.h)(".monaco-tree-type-filter",[(0,i.h)(".monaco-tree-type-filter-grab.codicon.codicon-debug-gripper@grab",{tabIndex:0}),(0,i.h)(".monaco-tree-type-filter-input@findInput"),(0,i.h)(".monaco-tree-type-filter-actionbar@actionbar")]),this.j=0,this.m=0,this.s=0,this._onDidDisable=new b.$he,this.onDidDisable=this._onDidDisable.event,u.appendChild(this.a.root),this.B((0,r.$Sc)(()=>u.removeChild(this.a.root)));const ee=q?.styles??De;ee.listFilterWidgetBackground&&(this.a.root.style.backgroundColor=ee.listFilterWidgetBackground),ee.listFilterWidgetShadow&&(this.a.root.style.boxShadow=`0 0 8px 2px ${ee.listFilterWidgetShadow}`);const re=this.B((0,_.$iT)());this.b=this.B(new te({...ee.toggleStyles,isChecked:j===Le.Filter,hoverDelegate:re})),this.c=this.B(new de({...ee.toggleStyles,isChecked:z===Se.Fuzzy,hoverDelegate:re})),this.onDidChangeMode=b.Event.map(this.b.onChange,()=>this.b.checked?Le.Filter:Le.Highlight,this.q),this.onDidChangeMatchType=b.Event.map(this.c.onChange,()=>this.c.checked?Se.Fuzzy:Se.Contiguous,this.q),this.f=this.B(new T.$aV(this.a.findInput,S,{label:(0,R.localize)(4,null),additionalToggles:[this.b,this.c],showCommonFindToggles:!1,inputBoxStyles:ee.inputBoxStyles,toggleStyles:ee.toggleStyles,history:q?.history})),this.g=this.B(new O.$jT(this.a.actionbar)),this.mode=j;const ce=this.B(new n.$rT(this.f.inputBox.inputElement,"keydown")),Ee=b.Event.chain(ce.event,he=>he.map(Fe=>new B.$kR(Fe)));this.B(Ee(he=>{if(he.equals(E.KeyCode.Enter)){he.preventDefault(),he.stopPropagation(),this.f.inputBox.addToHistory(),this.t.domFocus();return}if(he.equals(E.KeyCode.DownArrow)){he.preventDefault(),he.stopPropagation(),this.f.inputBox.isAtLastInHistory()||this.f.inputBox.isNowhereInHistory()?(this.f.inputBox.addToHistory(),this.t.domFocus()):this.f.inputBox.showNextValue();return}if(he.equals(E.KeyCode.UpArrow)){he.preventDefault(),he.stopPropagation(),this.f.inputBox.showPreviousValue();return}}));const ve=this.B(new m.$fj("close",(0,R.localize)(5,null),"codicon codicon-close",!0,()=>this.dispose()));this.g.push(ve,{icon:!0,label:!1});const Re=this.B(new n.$rT(this.a.grab,"mousedown"));this.B(Re.event(he=>{const Fe=new r.$Tc,xe=Fe.add(new n.$rT((0,i.getWindow)(he),"mousemove")),Ye=Fe.add(new n.$rT((0,i.getWindow)(he),"mouseup")),et=this.m,ot=he.pageX,it=this.s,Ke=he.pageY;this.a.grab.classList.add("grabbing");const Xe=this.a.root.style.transition;this.a.root.style.transition="unset";const X=ae=>{const $e=ae.pageX-ot;this.m=et-$e;const Ae=ae.pageY-Ke;this.s=it+Ae,this.layout()};Fe.add(xe.event(X)),Fe.add(Ye.event(ae=>{X(ae),this.a.grab.classList.remove("grabbing"),this.a.root.style.transition=Xe,Fe.dispose()}))}));const Te=b.Event.chain(this.B(new n.$rT(this.a.grab,"keydown")).event,he=>he.map(Fe=>new B.$kR(Fe)));this.B(Te(he=>{let Fe,xe;if(he.keyCode===E.KeyCode.LeftArrow?Fe=Number.POSITIVE_INFINITY:he.keyCode===E.KeyCode.RightArrow?Fe=0:he.keyCode===E.KeyCode.Space&&(Fe=this.m===0?Number.POSITIVE_INFINITY:0),he.keyCode===E.KeyCode.UpArrow?xe=0:he.keyCode===E.KeyCode.DownArrow&&(xe=Number.POSITIVE_INFINITY),Fe!==void 0&&(he.preventDefault(),he.stopPropagation(),this.m=Fe,this.layout()),xe!==void 0){he.preventDefault(),he.stopPropagation(),this.s=xe;const Ye=this.a.root.style.transition;this.a.root.style.transition="unset",this.layout(),setTimeout(()=>{this.a.root.style.transition=Ye},0)}})),this.onDidChangeValue=this.f.onDidChange}getHistory(){return this.f.inputBox.getHistory()}focus(){this.f.focus()}select(){this.f.select(),this.f.inputBox.addToHistory(!0)}layout(u=this.j){this.j=u,this.m=(0,d.$Gm)(this.m,0,Math.max(0,u-212)),this.a.root.style.right=`${this.m}px`,this.s=(0,d.$Gm)(this.s,0,24),this.a.root.style.top=`${this.s}px`}showMessage(u){this.f.showMessage(u)}clearMessage(){this.f.clearMessage()}async dispose(){this._onDidDisable.fire(),this.a.root.classList.add("disabled"),await(0,s.$Bh)(300),super.dispose()}}class J{get pattern(){return this.b}get mode(){return this.d}set mode(u){u!==this.d&&(this.d=u,this.g&&(this.g.mode=this.d),this.t.refilter(),this.A(),this.k.fire(u))}get matchType(){return this.f}set matchType(u){u!==this.f&&(this.f=u,this.g&&(this.g.matchType=this.f),this.t.refilter(),this.A(),this.m.fire(u))}constructor(u,L,S,j,z,q={}){this.t=u,this.u=S,this.v=j,this.w=z,this.x=q,this.b="",this.c="",this.j=0,this.k=new b.$he,this.onDidChangeMode=this.k.event,this.m=new b.$he,this.onDidChangeMatchType=this.m.event,this.o=new b.$he,this.onDidChangePattern=this.o.event,this.p=new b.$he,this.onDidChangeOpenState=this.p.event,this.q=new r.$Tc,this.s=new r.$Tc,this.d=u.options.defaultFindMode??Le.Highlight,this.f=u.options.defaultFindMatchType??Se.Fuzzy,L.onDidSplice(this.z,this,this.s)}updateOptions(u={}){u.defaultFindMode!==void 0&&(this.mode=u.defaultFindMode),u.defaultFindMatchType!==void 0&&(this.matchType=u.defaultFindMatchType)}open(){if(this.g){this.g.focus(),this.g.select();return}this.g=new ue(this.u.getHTMLElement(),this.t,this.w,this.mode,this.matchType,{...this.x,history:this.a}),this.q.add(this.g),this.g.onDidChangeValue(this.y,this,this.q),this.g.onDidChangeMode(u=>this.mode=u,void 0,this.q),this.g.onDidChangeMatchType(u=>this.matchType=u,void 0,this.q),this.g.onDidDisable(this.close,this,this.q),this.g.layout(this.j),this.g.focus(),this.g.value=this.c,this.g.select(),this.p.fire(!0)}close(){this.g&&(this.a=this.g.getHistory(),this.g=void 0,this.q.clear(),this.c=this.pattern,this.y(""),this.t.domFocus(),this.p.fire(!1))}y(u){this.b=u,this.o.fire(u),this.v.pattern=u,this.t.refilter(),u&&this.t.focusNext(0,!0,void 0,S=>!k.FuzzyScore.isDefault(S.filterData));const L=this.t.getFocus();if(L.length>0){const S=L[0];this.t.getRelativeTop(S)===null&&this.t.reveal(S,.5)}this.A()}z(){!this.g||this.pattern.length===0||(this.t.refilter(),this.A())}A(){const u=this.v.totalCount>0&&this.v.matchCount===0;this.pattern&&u?this.t.options.showNotFoundMessage??!0?this.g?.showMessage({type:v.MessageType.WARNING,content:(0,R.localize)(6,null)}):this.g?.showMessage({type:v.MessageType.WARNING}):this.g?.clearMessage()}shouldAllowFocus(u){return!this.g||!this.pattern||this.v.totalCount>0&&this.v.matchCount<=1?!0:!k.FuzzyScore.isDefault(u.filterData)}layout(u){this.j=u,this.g?.layout(u)}dispose(){this.a=void 0,this.o.dispose(),this.q.dispose(),this.s.dispose()}}function fe(F,u){return F.position===u.position&&le(F,u)}function le(F,u){return F.node.element===u.node.element&&F.startIndex===u.startIndex&&F.height===u.height&&F.endIndex===u.endIndex}class ke{constructor(u=[]){this.stickyNodes=u}get count(){return this.stickyNodes.length}equal(u){return(0,e.$ub)(this.stickyNodes,u.stickyNodes,fe)}lastNodePartiallyVisible(){if(this.count===0)return!1;const u=this.stickyNodes[this.count-1];if(this.count===1)return u.position!==0;const L=this.stickyNodes[this.count-2];return L.position+L.height!==u.position}animationStateChanged(u){if(!(0,e.$ub)(this.stickyNodes,u.stickyNodes,le)||this.count===0)return!1;const L=this.stickyNodes[this.count-1],S=u.stickyNodes[u.count-1];return L.position!==S.position}}class Z{constrainStickyScrollNodes(u,L,S){for(let j=0;j<u.length;j++){const z=u[j];if(z.position+z.height>S||j>=L)return u.slice(0,j)}return u}}class me extends r.$Uc{constructor(u,L,S,j,z,q={}){super(),this.g=u,this.j=L,this.m=S,this.s=z,this.c=.4;const ee=this.validateStickySettings(q);this.b=ee.stickyScrollMaxItemCount,this.a=q.stickyScrollDelegate??new Z,this.f=this.B(new ye(S.getScrollableElement(),S,u,j,z,q.accessibilityProvider)),this.onDidChangeHasFocus=this.f.onDidChangeHasFocus,this.onContextMenu=this.f.onContextMenu,this.B(S.onDidScroll(()=>this.u())),this.B(S.onDidChangeContentHeight(()=>this.u())),this.B(u.onDidChangeCollapseState(()=>this.u())),this.u()}get height(){return this.f.height}get count(){return this.f.count}getNode(u){return this.f.getNode(u)}t(u){let L;if(u===0?L=this.m.firstVisibleIndex:L=this.m.indexAt(u+this.m.scrollTop),!(L<0||L>=this.m.length))return this.m.element(L)}u(){const u=this.t(0);if(!u||this.g.scrollTop===0){this.f.setState(void 0);return}const L=this.w(u);this.f.setState(L)}w(u){const L=[];let S=u,j=0,z=this.z(S,void 0,j);for(;z&&(L.push(z),j+=z.height,!(L.length<=this.b&&(S=this.y(z),!S)));)z=this.z(S,z.node,j);const q=this.H(L);return q.length?new ke(q):void 0}y(u){return this.t(u.position+u.height)}z(u,L,S){const j=this.F(u,L);if(j&&!(j===u&&(!this.J(u)||this.C(u,S))))return this.D(j,S)}C(u,L){const S=this.L(u),j=this.m.getElementTop(S),z=L;return this.m.scrollTop===j-z}D(u,L){const S=this.s.getHeight(u),{startIndex:j,endIndex:z}=this.M(u),q=this.G(z,L,S);return{node:u,position:q,height:S,startIndex:j,endIndex:z}}F(u,L=void 0){let S=u,j=this.I(S);for(;j;){if(j===L)return S;S=j,j=this.I(S)}if(L===void 0)return S}G(u,L,S){let j=this.m.getRelativeTop(u);if(j===null&&this.m.firstVisibleIndex===u&&u+1<this.m.length){const ce=this.s.getHeight(this.m.element(u)),Ee=this.m.getRelativeTop(u+1);j=Ee?Ee-ce/this.m.renderHeight:null}if(j===null)return L;const z=this.m.element(u),q=this.s.getHeight(z),re=j*this.m.renderHeight+q;return L+S>re&&L<=re?re-S:L}H(u){if(u.length===0)return[];const L=this.m.renderHeight*this.c,S=u[u.length-1];if(u.length<=this.b&&S.position+S.height<=L)return u;const j=this.a.constrainStickyScrollNodes(u,this.b,L);if(!j.length)return[];const z=j[j.length-1];if(j.length>this.b||z.position+z.height>L)throw new Error("stickyScrollDelegate violates constraints");return j}I(u){const L=this.j.getNodeLocation(u),S=this.j.getParentNodeLocation(L);return S?this.j.getNode(S):void 0}J(u){const L=this.j.getNodeLocation(u);return this.j.getListRenderCount(L)>1}L(u){const L=this.j.getNodeLocation(u);return this.j.getListIndex(L)}M(u){const L=this.j.getNodeLocation(u),S=this.j.getListIndex(L);if(S<0)throw new Error("Node not found in tree");const j=this.j.getListRenderCount(L),z=S+j-1;return{startIndex:S,endIndex:z}}nodePositionTopBelowWidget(u){const L=[];let S=this.I(u);for(;S;)L.push(S),S=this.I(S);let j=0;for(let z=0;z<L.length&&z<this.b;z++)j+=this.s.getHeight(L[z]);return j}getFocus(){return this.f.getFocus()}domFocus(){this.f.domFocus()}focusedLast(){return this.f.focusedLast()}updateOptions(u={}){if(!u.stickyScrollMaxItemCount)return;const L=this.validateStickySettings(u);this.b!==L.stickyScrollMaxItemCount&&(this.b=L.stickyScrollMaxItemCount,this.u())}validateStickySettings(u){let L=7;return typeof u.stickyScrollMaxItemCount=="number"&&(L=Math.max(u.stickyScrollMaxItemCount,1)),{stickyScrollMaxItemCount:L}}}class ye{constructor(u,L,S,j,z,q){this.g=L,this.j=S,this.k=j,this.m=z,this.o=q,this.c=[],this.d=new r.$Tc,this.a=(0,i.$)(".monaco-tree-sticky-container.empty"),u.appendChild(this.a);const ee=(0,i.$)(".monaco-tree-sticky-container-shadow");this.a.appendChild(ee),this.f=new Oe(this.a,L),this.onDidChangeHasFocus=this.f.onDidChangeHasFocus,this.onContextMenu=this.f.onContextMenu}get height(){if(!this.b)return 0;const u=this.b.stickyNodes[this.b.count-1];return u.position+u.height}get count(){return this.b?.count??0}getNode(u){return this.b?.stickyNodes.find(L=>L.node===u)}setState(u){const L=!!this.b&&this.b.count>0,S=!!u&&u.count>0;if(!L&&!S||L&&S&&this.b.equal(u))return;if(L!==S&&this.s(S),!S){this.b=void 0,this.c=[],this.d.clear();return}const j=u.stickyNodes[u.count-1];if(this.b&&u.animationStateChanged(this.b))this.c[this.b.count-1].style.top=`${j.position}px`;else{this.d.clear();const z=Array(u.count);for(let q=u.count-1;q>=0;q--){const ee=u.stickyNodes[q],{element:re,disposable:ce}=this.p(ee,q,u.count);z[q]=re,this.a.appendChild(re),this.d.add(ce)}this.f.updateElements(z,u),this.c=z}this.b=u,this.a.style.height=`${j.position+j.height}px`}p(u,L,S){const j=u.startIndex,z=document.createElement("div");z.style.top=`${u.position}px`,this.j.options.setRowHeight!==!1&&(z.style.height=`${u.height}px`),this.j.options.setRowLineHeight!==!1&&(z.style.lineHeight=`${u.height}px`),z.classList.add("monaco-tree-sticky-row"),z.classList.add("monaco-list-row"),z.setAttribute("data-index",`${j}`),z.setAttribute("data-parity",j%2===0?"even":"odd"),z.setAttribute("id",this.g.getElementID(j));const q=this.q(z,u.node.element,L,S),ee=this.m.getTemplateId(u.node),re=this.k.find(Re=>Re.templateId===ee);if(!re)throw new Error(`No renderer found for template id ${ee}`);let ce=u.node;ce===this.j.getNode(this.j.getNodeLocation(u.node))&&(ce=new Proxy(u.node,{}));const Ee=re.renderTemplate(z);re.renderElement(ce,u.startIndex,Ee,u.height);const ve=(0,r.$Sc)(()=>{q.dispose(),re.disposeElement(ce,u.startIndex,Ee,u.height),re.disposeTemplate(Ee),z.remove()});return{element:z,disposable:ve}}q(u,L,S,j){if(!this.o)return r.$Uc.None;this.o.getSetSize&&u.setAttribute("aria-setsize",String(this.o.getSetSize(L,S,j))),this.o.getPosInSet&&u.setAttribute("aria-posinset",String(this.o.getPosInSet(L,S))),this.o.getRole&&u.setAttribute("role",this.o.getRole(L)??"treeitem");const z=this.o.getAriaLabel(L),q=z&&typeof z!="string"?z:(0,H.constObservable)(z),ee=(0,H.autorun)(ce=>{const Ee=ce.readObservable(q);Ee?u.setAttribute("aria-label",Ee):u.removeAttribute("aria-label")});typeof z=="string"||z&&u.setAttribute("aria-label",z.get());const re=this.o.getAriaLevel&&this.o.getAriaLevel(L);return typeof re=="number"&&u.setAttribute("aria-level",`${re}`),u.setAttribute("aria-selected",String(!1)),ee}s(u){this.a.classList.toggle("empty",!u),u||this.f.updateElements([],void 0)}getFocus(){return this.f.getFocus()}domFocus(){this.f.domFocus()}focusedLast(){return this.f.focusedLast()}dispose(){this.f.dispose(),this.d.dispose(),this.a.remove()}}class Oe extends r.$Uc{get m(){return this.j}set m(u){u!==this.j&&(this.f.fire(u),this.j=u)}constructor(u,L){super(),this.s=u,this.t=L,this.a=-1,this.b=[],this.f=new b.$he,this.onDidChangeHasFocus=this.f.event,this.g=new b.$he,this.onContextMenu=this.g.event,this.j=!1,this.s.addEventListener("focus",()=>this.M()),this.s.addEventListener("blur",()=>this.O()),this.B(this.t.onDidFocus(()=>this.L(!1))),this.B(this.t.onKeyDown(S=>this.w(S))),this.B(this.t.onMouseDown(S=>this.y(S))),this.B(this.t.onContextMenu(S=>this.u(S)))}u(u){const L=u.browserEvent.target;if(!(0,f.$OT)(L)&&!(0,f.$NT)(L)){this.focusedLast()&&this.t.domFocus();return}if(!(0,i.$dS)(u.browserEvent)){if(!this.c)throw new Error("Context menu should not be triggered when state is undefined");const q=this.c.stickyNodes.findIndex(ee=>ee.node.element===u.element?.element);if(q===-1)throw new Error("Context menu should not be triggered when element is not in sticky scroll widget");this.s.focus(),this.F(q);return}if(!this.c||this.a<0)throw new Error("Context menu key should not be triggered when focus is not in sticky scroll widget");const j=this.c.stickyNodes[this.a].node.element,z=this.b[this.a];this.g.fire({element:j,anchor:z,browserEvent:u.browserEvent,isStickyScroll:!0})}w(u){if(this.m&&this.c){if(u.key==="ArrowUp")this.z(Math.max(0,this.a-1)),u.preventDefault(),u.stopPropagation();else if(u.key==="ArrowDown"||u.key==="ArrowRight"){if(this.a>=this.c.count-1){const L=this.c.stickyNodes[this.c.count-1].startIndex+1;this.t.domFocus(),this.t.setFocus([L]),this.C(L,this.c)}else this.z(this.a+1);u.preventDefault(),u.stopPropagation()}}}y(u){const L=u.browserEvent.target;!(0,f.$OT)(L)&&!(0,f.$NT)(L)||(u.browserEvent.preventDefault(),u.browserEvent.stopPropagation())}updateElements(u,L){if(L&&L.count===0)throw new Error("Sticky scroll state must be undefined when there are no sticky nodes");if(L&&L.count!==u.length)throw new Error("Sticky scroll focus received illigel state");const S=this.a;if(this.D(),this.b=u,this.c=L,L){const j=(0,d.$Gm)(S,0,L.count-1);this.F(j)}else this.m&&this.t.domFocus();this.s.tabIndex=L?0:-1}z(u){const L=this.c;if(!L)throw new Error("Cannot set focus when state is undefined");if(this.F(u),!(u<L.count-1)&&L.lastNodePartiallyVisible()){const S=L.stickyNodes[u];this.C(S.endIndex+1,L)}}C(u,L){const S=L.stickyNodes[L.count-1],j=L.count>1?L.stickyNodes[L.count-2]:void 0,z=this.t.getElementTop(u),q=j?j.position+j.height+S.height:S.height;this.t.scrollTop=z-q}getFocus(){if(!(!this.c||this.a===-1))return this.c.stickyNodes[this.a].node.element}domFocus(){if(!this.c)throw new Error("Cannot focus when state is undefined");this.s.focus()}focusedLast(){return this.c?this.t.getHTMLElement().classList.contains("sticky-scroll-focused"):!1}D(){this.a!==-1&&(this.G(this.b[this.a],!1),this.a=-1)}F(u){if(0>u)throw new Error("addFocus() can not remove focus");if(!this.c&&u>=0)throw new Error("Cannot set focus index when state is undefined");if(this.c&&u>=this.c.count)throw new Error("Cannot set focus index to an index that does not exist");const L=this.a;L>=0&&this.G(this.b[L],!1),u>=0&&this.G(this.b[u],!0),this.a=u}G(u,L){this.I(u,L&&this.m),this.J(u,L)}H(u){this.a!==-1&&this.I(this.b[this.a],u)}I(u,L){u.classList.toggle("focused",L)}J(u,L){u.classList.toggle("passive-focused",L)}L(u){this.t.getHTMLElement().classList.toggle("sticky-scroll-focused",u)}M(){if(!this.c||this.b.length===0)throw new Error("Cannot focus when state is undefined or elements are empty");this.m=!0,this.L(!0),this.H(!0),this.a===-1&&this.F(0)}O(){this.m=!1,this.H(!1)}dispose(){this.L(!1),this.f.fire(!1),super.dispose()}}function Ie(F){let u=$.TreeMouseEventTarget.Unknown;return(0,i.$VR)(F.browserEvent.target,"monaco-tl-twistie","monaco-tl-row")?u=$.TreeMouseEventTarget.Twistie:(0,i.$VR)(F.browserEvent.target,"monaco-tl-contents","monaco-tl-row")?u=$.TreeMouseEventTarget.Element:(0,i.$VR)(F.browserEvent.target,"monaco-tree-type-filter","monaco-list")&&(u=$.TreeMouseEventTarget.Filter),{browserEvent:F.browserEvent,element:F.element?F.element.element:null,target:u}}function je(F){const u=(0,f.$OT)(F.browserEvent.target);return{element:F.element?F.element.element:null,browserEvent:F.browserEvent,anchor:F.anchor,isStickyScroll:u}}function ie(F,u){u(F),F.children.forEach(L=>ie(L,u))}class K{get f(){return this.d||(this.d=this.m()),this.d}constructor(u,L){this.g=u,this.j=L,this.a=[],this.c=new b.$he,this.onDidChange=this.c.event}set(u,L){!L?.__forceEvent&&(0,e.$ub)(this.a,u)||this.k(u,!1,L)}k(u,L,S){if(this.a=[...u],this.b=void 0,this.d=void 0,!L){const j=this;this.c.fire({get elements(){return j.get()},browserEvent:S})}}get(){return this.b||(this.b=this.a.map(u=>u.element)),[...this.b]}getNodes(){return this.a}has(u){return this.f.has(u)}onDidModelSplice({insertedNodes:u,deletedNodes:L}){if(!this.j){const re=this.m(),ce=Ee=>re.delete(Ee);L.forEach(Ee=>ie(Ee,ce)),this.set([...re.values()]);return}const S=new Set,j=re=>S.add(this.j.getId(re.element).toString());L.forEach(re=>ie(re,j));const z=new Map,q=re=>z.set(this.j.getId(re.element).toString(),re);u.forEach(re=>ie(re,q));const ee=[];for(const re of this.a){const ce=this.j.getId(re.element).toString();if(!S.has(ce))ee.push(re);else{const ve=z.get(ce);ve&&ve.visible&&ee.push(ve)}}if(this.a.length>0&&ee.length===0){const re=this.g();re&&ee.push(re)}this.k(ee,!0)}m(){const u=new Set;for(const L of this.a)u.add(L);return u}}class C extends f.$TT{constructor(u,L,S){super(u),this.x=L,this.y=S}u(u){if((0,f.$PT)(u.browserEvent.target)||(0,f.$IT)(u.browserEvent.target)||(0,f.$JT)(u.browserEvent.target)||u.browserEvent.isHandledByList)return;const L=u.element;if(!L)return super.u(u);if(this.p(u)||this.o(u))return super.u(u);const S=u.browserEvent.target,j=S.classList.contains("monaco-tl-twistie")||S.classList.contains("monaco-icon-label")&&S.classList.contains("folder-icon")&&u.browserEvent.offsetX<16,z=(0,f.$NT)(u.browserEvent.target);let q=!1;if(z?q=!0:typeof this.x.expandOnlyOnTwistieClick=="function"?q=this.x.expandOnlyOnTwistieClick(L.element):q=!!this.x.expandOnlyOnTwistieClick,z)this.A(u,L);else{if(q&&!j&&u.browserEvent.detail!==2)return super.u(u);if(!this.x.expandOnDoubleClick&&u.browserEvent.detail===2)return super.u(u)}if(L.collapsible&&(!z||j)){const ee=this.x.getNodeLocation(L),re=u.browserEvent.altKey;if(this.x.setFocus([ee]),this.x.toggleCollapsed(ee,re),j){u.browserEvent.isHandledByList=!0;return}}z||super.u(u)}A(u,L){if((0,f.$KT)(u.browserEvent.target)||(0,f.$LT)(u.browserEvent.target))return;const S=this.y();if(!S)throw new Error("Sticky scroll controller not found");const j=this.k.indexOf(L),z=this.k.getElementTop(j),q=S.nodePositionTopBelowWidget(L);this.x.scrollTop=z-q,this.k.domFocus(),this.k.setFocus([j]),this.k.setSelection([j])}v(u){u.browserEvent.target.classList.contains("monaco-tl-twistie")||!this.x.expandOnDoubleClick||u.browserEvent.isHandledByList||super.v(u)}s(u){const L=u.browserEvent.target;if(!(0,f.$OT)(L)&&!(0,f.$NT)(L)){super.s(u);return}}t(u){const L=u.browserEvent.target;if(!(0,f.$OT)(L)&&!(0,f.$NT)(L)){super.t(u);return}}}class a extends f.$WT{constructor(u,L,S,j,z,q,ee,re){super(u,L,S,j,re),this.p=z,this.s=q,this.K=ee}D(u){return new C(this,u.tree,u.stickyScrollProvider)}splice(u,L,S=[]){if(super.splice(u,L,S),S.length===0)return;const j=[],z=[];let q;S.forEach((ee,re)=>{this.p.has(ee)&&j.push(u+re),this.s.has(ee)&&z.push(u+re),this.K.has(ee)&&(q=u+re)}),j.length>0&&super.setFocus((0,e.$Mb)([...super.getFocus(),...j])),z.length>0&&super.setSelection((0,e.$Mb)([...super.getSelection(),...z])),typeof q=="number"&&super.setAnchor(q)}setFocus(u,L,S=!1){super.setFocus(u,L),S||this.p.set(u.map(j=>this.element(j)),L)}setSelection(u,L,S=!1){super.setSelection(u,L),S||this.s.set(u.map(j=>this.element(j)),L)}setAnchor(u,L=!1){super.setAnchor(u),L||(typeof u>"u"?this.K.set([]):this.K.set([this.element(u)]))}}var l;(function(F){F[F.Tree=0]="Tree",F[F.StickyScroll=1]="StickyScroll"})(l||(t.AbstractTreePart=l={}));class g{get onDidScroll(){return this.j.onDidScroll}get onDidChangeFocus(){return this.y.wrapEvent(this.q.onDidChange)}get onDidChangeSelection(){return this.y.wrapEvent(this.w.onDidChange)}get onMouseClick(){return b.Event.map(this.j.onMouseClick,Ie)}get onMouseDblClick(){return b.Event.filter(b.Event.map(this.j.onMouseDblClick,Ie),u=>u.target!==$.TreeMouseEventTarget.Filter)}get onMouseOver(){return b.Event.map(this.j.onMouseOver,Ie)}get onMouseOut(){return b.Event.map(this.j.onMouseOut,Ie)}get onContextMenu(){return b.Event.any(b.Event.filter(b.Event.map(this.j.onContextMenu,je),u=>!u.isStickyScroll),this.B?.onContextMenu??b.Event.None)}get onTap(){return b.Event.map(this.j.onTap,Ie)}get onPointer(){return b.Event.map(this.j.onPointer,Ie)}get onKeyDown(){return this.j.onKeyDown}get onKeyUp(){return this.j.onKeyUp}get onKeyPress(){return this.j.onKeyPress}get onDidFocus(){return this.j.onDidFocus}get onDidBlur(){return this.j.onDidBlur}get onDidChangeModel(){return b.Event.signal(this.o.onDidSplice)}get onDidChangeCollapseState(){return this.o.onDidChangeCollapseState}get onDidChangeRenderNodeCount(){return this.o.onDidChangeRenderNodeCount}get findMode(){return this.z?.mode??Le.Highlight}set findMode(u){this.z&&(this.z.mode=u)}get findMatchType(){return this.z?.matchType??Se.Fuzzy}set findMatchType(u){this.z&&(this.z.matchType=u)}get onDidChangeFindPattern(){return this.z?this.z.onDidChangePattern:b.Event.None}get expandOnDoubleClick(){return typeof this.H.expandOnDoubleClick>"u"?!0:this.H.expandOnDoubleClick}get expandOnlyOnTwistieClick(){return typeof this.H.expandOnlyOnTwistieClick>"u"?!0:this.H.expandOnlyOnTwistieClick}get onDidDispose(){return this.j.onDidDispose}constructor(u,L,S,j,z={}){this.G=u,this.H=z,this.y=new b.$pe,this.onDidChangeFindOpenState=b.Event.None,this.onDidChangeStickyScrollFocused=b.Event.None,this.D=new r.$Tc,this.E=new b.$he,this.onWillRefilter=this.E.event,this.F=new b.$he,this.onDidUpdateOptions=this.F.event,this.p=new N(S);const q=new b.$qe,ee=new b.$qe,re=this.D.add(new ne(ee.event)),ce=new c.$Hc;this.k=j.map(he=>new Q(he,()=>this.o,q.event,re,ce,z));for(const he of this.k)this.D.add(he);let Ee;z.keyboardNavigationLabelProvider&&(Ee=new Y(this,z.keyboardNavigationLabelProvider,z.filter),z={...z,filter:Ee},this.D.add(Ee)),this.q=new K(()=>this.j.getFocusedElements()[0],z.identityProvider),this.w=new K(()=>this.j.getSelectedElements()[0],z.identityProvider),this.x=new K(()=>this.j.getAnchorElement(),z.identityProvider),this.j=new a(u,L,this.p,this.k,this.q,this.w,this.x,{...U(()=>this.o,z),tree:this,stickyScrollProvider:()=>this.B}),this.o=this.M(u,this.j,z),q.input=this.o.onDidChangeCollapseState;const ve=b.Event.forEach(this.o.onDidSplice,he=>{this.y.bufferEvents(()=>{this.q.onDidModelSplice(he),this.w.onDidModelSplice(he)})},this.D);ve(()=>null,null,this.D);const Re=this.D.add(new b.$he),Te=this.D.add(new s.$xh(0));if(this.D.add(b.Event.any(ve,this.q.onDidChange,this.w.onDidChange)(()=>{Te.trigger(()=>{const he=new Set;for(const Fe of this.q.getNodes())he.add(Fe);for(const Fe of this.w.getNodes())he.add(Fe);Re.fire([...he.values()])})})),ee.input=Re.event,z.keyboardSupport!==!1){const he=b.Event.chain(this.j.onKeyDown,Fe=>Fe.filter(xe=>!(0,f.$IT)(xe.target)).map(xe=>new B.$kR(xe)));b.Event.chain(he,Fe=>Fe.filter(xe=>xe.keyCode===E.KeyCode.LeftArrow))(this.J,this,this.D),b.Event.chain(he,Fe=>Fe.filter(xe=>xe.keyCode===E.KeyCode.RightArrow))(this.K,this,this.D),b.Event.chain(he,Fe=>Fe.filter(xe=>xe.keyCode===E.KeyCode.Space))(this.L,this,this.D)}if((z.findWidgetEnabled??!0)&&z.keyboardNavigationLabelProvider&&z.contextViewProvider){const he=this.options.findWidgetStyles?{styles:this.options.findWidgetStyles}:void 0;this.z=new J(this,this.o,this.j,Ee,z.contextViewProvider,he),this.A=Fe=>this.z.shouldAllowFocus(Fe),this.onDidChangeFindOpenState=this.z.onDidChangeOpenState,this.D.add(this.z),this.onDidChangeFindMode=this.z.onDidChangeMode,this.onDidChangeFindMatchType=this.z.onDidChangeMatchType}else this.onDidChangeFindMode=b.Event.None,this.onDidChangeFindMatchType=b.Event.None;z.enableStickyScroll&&(this.B=new me(this,this.o,this.j,this.k,this.p,z),this.onDidChangeStickyScrollFocused=this.B.onDidChangeHasFocus),this.C=(0,i.$8R)(this.j.getHTMLElement()),this.getHTMLElement().classList.toggle("always",this.H.renderIndentGuides===W.Always)}updateOptions(u={}){this.H={...this.H,...u};for(const L of this.k)L.updateOptions(u);this.j.updateOptions(this.H),this.z?.updateOptions(u),this.I(u),this.F.fire(this.H),this.getHTMLElement().classList.toggle("always",this.H.renderIndentGuides===W.Always)}get options(){return this.H}I(u){!this.B&&this.H.enableStickyScroll?(this.B=new me(this,this.o,this.j,this.k,this.p,this.H),this.onDidChangeStickyScrollFocused=this.B.onDidChangeHasFocus):this.B&&!this.H.enableStickyScroll&&(this.onDidChangeStickyScrollFocused=b.Event.None,this.B.dispose(),this.B=void 0),this.B?.updateOptions(u)}updateWidth(u){const L=this.o.getListIndex(u);L!==-1&&this.j.updateWidth(L)}getHTMLElement(){return this.j.getHTMLElement()}get contentHeight(){return this.j.contentHeight}get contentWidth(){return this.j.contentWidth}get onDidChangeContentHeight(){return this.j.onDidChangeContentHeight}get onDidChangeContentWidth(){return this.j.onDidChangeContentWidth}get scrollTop(){return this.j.scrollTop}set scrollTop(u){this.j.scrollTop=u}get scrollLeft(){return this.j.scrollLeft}set scrollLeft(u){this.j.scrollLeft=u}get scrollHeight(){return this.j.scrollHeight}get renderHeight(){return this.j.renderHeight}get firstVisibleElement(){let u=this.j.firstVisibleIndex;return this.B&&(u+=this.B.count),u<0||u>=this.j.length?void 0:this.j.element(u).element}get lastVisibleElement(){const u=this.j.lastVisibleIndex;return this.j.element(u).element}get ariaLabel(){return this.j.ariaLabel}set ariaLabel(u){this.j.ariaLabel=u}get selectionSize(){return this.w.getNodes().length}domFocus(){this.B?.focusedLast()?this.B.domFocus():this.j.domFocus()}isDOMFocused(){return(0,i.$1R)(this.getHTMLElement())}layout(u,L){this.j.layout(u,L),(0,D.$eg)(L)&&this.z?.layout(L)}style(u){const L=`.${this.j.domId}`,S=[];u.treeIndentGuidesStroke&&(S.push(`.monaco-list${L}:hover .monaco-tl-indent > .indent-guide, .monaco-list${L}.always .monaco-tl-indent > .indent-guide  { border-color: ${u.treeInactiveIndentGuidesStroke}; }`),S.push(`.monaco-list${L} .monaco-tl-indent > .indent-guide.active { border-color: ${u.treeIndentGuidesStroke}; }`));const j=u.treeStickyScrollBackground??u.listBackground;j&&(S.push(`.monaco-list${L} .monaco-scrollable-element .monaco-tree-sticky-container { background-color: ${j}; }`),S.push(`.monaco-list${L} .monaco-scrollable-element .monaco-tree-sticky-container .monaco-tree-sticky-row { background-color: ${j}; }`)),u.treeStickyScrollBorder&&S.push(`.monaco-list${L} .monaco-scrollable-element .monaco-tree-sticky-container { border-bottom: 1px solid ${u.treeStickyScrollBorder}; }`),u.treeStickyScrollShadow&&S.push(`.monaco-list${L} .monaco-scrollable-element .monaco-tree-sticky-container .monaco-tree-sticky-container-shadow { box-shadow: ${u.treeStickyScrollShadow} 0 6px 6px -6px inset; height: 3px; }`),u.listFocusForeground&&(S.push(`.monaco-list${L}.sticky-scroll-focused .monaco-scrollable-element .monaco-tree-sticky-container:focus .monaco-list-row.focused { color: ${u.listFocusForeground}; }`),S.push(`.monaco-list${L}:not(.sticky-scroll-focused) .monaco-scrollable-element .monaco-tree-sticky-container .monaco-list-row.focused { color: inherit; }`));const z=(0,i.$FS)(u.listFocusAndSelectionOutline,(0,i.$FS)(u.listSelectionOutline,u.listFocusOutline??""));z&&(S.push(`.monaco-list${L}.sticky-scroll-focused .monaco-scrollable-element .monaco-tree-sticky-container:focus .monaco-list-row.focused.selected { outline: 1px solid ${z}; outline-offset: -1px;}`),S.push(`.monaco-list${L}:not(.sticky-scroll-focused) .monaco-scrollable-element .monaco-tree-sticky-container .monaco-list-row.focused.selected { outline: inherit;}`)),u.listFocusOutline&&(S.push(`.monaco-list${L}.sticky-scroll-focused .monaco-scrollable-element .monaco-tree-sticky-container:focus .monaco-list-row.focused { outline: 1px solid ${u.listFocusOutline}; outline-offset: -1px; }`),S.push(`.monaco-list${L}:not(.sticky-scroll-focused) .monaco-scrollable-element .monaco-tree-sticky-container .monaco-list-row.focused { outline: inherit; }`),S.push(`.monaco-workbench.context-menu-visible .monaco-list${L}.last-focused.sticky-scroll-focused .monaco-scrollable-element .monaco-tree-sticky-container .monaco-list-row.passive-focused { outline: 1px solid ${u.listFocusOutline}; outline-offset: -1px; }`),S.push(`.monaco-workbench.context-menu-visible .monaco-list${L}.last-focused.sticky-scroll-focused .monaco-list-rows .monaco-list-row.focused { outline: inherit; }`),S.push(`.monaco-workbench.context-menu-visible .monaco-list${L}.last-focused:not(.sticky-scroll-focused) .monaco-tree-sticky-container .monaco-list-rows .monaco-list-row.focused { outline: inherit; }`)),this.C.textContent=S.join(`
`),this.j.style(u)}getParentElement(u){const L=this.o.getParentNodeLocation(u);return this.o.getNode(L).element}getFirstElementChild(u){return this.o.getFirstElementChild(u)}getNode(u){return this.o.getNode(u)}getNodeLocation(u){return this.o.getNodeLocation(u)}collapse(u,L=!1){return this.o.setCollapsed(u,!0,L)}expand(u,L=!1){return this.o.setCollapsed(u,!1,L)}toggleCollapsed(u,L=!1){return this.o.setCollapsed(u,void 0,L)}expandAll(){this.o.setCollapsed(this.o.rootRef,!1,!0)}collapseAll(){this.o.setCollapsed(this.o.rootRef,!0,!0)}isCollapsible(u){return this.o.isCollapsible(u)}setCollapsible(u,L){return this.o.setCollapsible(u,L)}isCollapsed(u){return this.o.isCollapsed(u)}expandTo(u){this.o.expandTo(u)}triggerTypeNavigation(){this.j.triggerTypeNavigation()}openFind(){this.z?.open()}closeFind(){this.z?.close()}refilter(){this.E.fire(void 0),this.o.refilter()}setAnchor(u){if(typeof u>"u")return this.j.setAnchor(void 0);this.y.bufferEvents(()=>{const L=this.o.getNode(u);this.x.set([L]);const S=this.o.getListIndex(u);S>-1&&this.j.setAnchor(S,!0)})}getAnchor(){return(0,e.$Ob)(this.x.get(),void 0)}setSelection(u,L){this.y.bufferEvents(()=>{const S=u.map(z=>this.o.getNode(z));this.w.set(S,L);const j=u.map(z=>this.o.getListIndex(z)).filter(z=>z>-1);this.j.setSelection(j,L,!0)})}getSelection(){return this.w.get()}setFocus(u,L){this.y.bufferEvents(()=>{const S=u.map(z=>this.o.getNode(z));this.q.set(S,L);const j=u.map(z=>this.o.getListIndex(z)).filter(z=>z>-1);this.j.setFocus(j,L,!0)})}focusNext(u=1,L=!1,S,j=(0,i.$dS)(S)&&S.altKey?void 0:this.A){this.j.focusNext(u,L,S,j)}focusPrevious(u=1,L=!1,S,j=(0,i.$dS)(S)&&S.altKey?void 0:this.A){this.j.focusPrevious(u,L,S,j)}focusNextPage(u,L=(0,i.$dS)(u)&&u.altKey?void 0:this.A){return this.j.focusNextPage(u,L)}focusPreviousPage(u,L=(0,i.$dS)(u)&&u.altKey?void 0:this.A){return this.j.focusPreviousPage(u,L,()=>this.B?.height??0)}focusLast(u,L=(0,i.$dS)(u)&&u.altKey?void 0:this.A){this.j.focusLast(u,L)}focusFirst(u,L=(0,i.$dS)(u)&&u.altKey?void 0:this.A){this.j.focusFirst(u,L)}getFocus(){return this.q.get()}getStickyScrollFocus(){const u=this.B?.getFocus();return u!==void 0?[u]:[]}getFocusedPart(){return this.B?.focusedLast()?l.StickyScroll:l.Tree}reveal(u,L){this.o.expandTo(u);const S=this.o.getListIndex(u);if(S!==-1)if(!this.B)this.j.reveal(S,L);else{const j=this.B.nodePositionTopBelowWidget(this.getNode(u));this.j.reveal(S,L,j)}}getRelativeTop(u){const L=this.o.getListIndex(u);if(L===-1)return null;const S=this.B?.getNode(this.getNode(u));return this.j.getRelativeTop(L,S?.position??this.B?.height)}getViewState(u=this.options.identityProvider){if(!u)throw new $.$DV(this.G,"Can't get tree view state without an identity provider");const L=q=>u.getId(q).toString(),S=P.empty(this.scrollTop);for(const q of this.getFocus())S.focus.add(L(q));for(const q of this.getSelection())S.selection.add(L(q));const j=this.o.getNode(),z=[j];for(;z.length>0;){const q=z.shift();q!==j&&q.collapsible&&(S.expanded[L(q.element)]=q.collapsed?0:1),z.push(...q.children)}return S}J(u){u.preventDefault(),u.stopPropagation();const L=this.j.getFocusedElements();if(L.length===0)return;const S=L[0],j=this.o.getNodeLocation(S);if(!this.o.setCollapsed(j,!0)){const q=this.o.getParentNodeLocation(j);if(!q)return;const ee=this.o.getListIndex(q);this.j.reveal(ee),this.j.setFocus([ee])}}K(u){u.preventDefault(),u.stopPropagation();const L=this.j.getFocusedElements();if(L.length===0)return;const S=L[0],j=this.o.getNodeLocation(S);if(!this.o.setCollapsed(j,!1)){if(!S.children.some(re=>re.visible))return;const[q]=this.j.getFocus(),ee=q+1;this.j.reveal(ee),this.j.setFocus([ee])}}L(u){u.preventDefault(),u.stopPropagation();const L=this.j.getFocusedElements();if(L.length===0)return;const S=L[0],j=this.o.getNodeLocation(S),z=u.browserEvent.altKey;this.o.setCollapsed(j,void 0,z)}navigate(u){return new I(this.j,this.o,u)}dispose(){(0,r.$Pc)(this.D),this.B?.dispose(),this.j.dispose()}}t.$NV=g;class I{constructor(u,L,S){this.b=u,this.c=L,S?this.a=this.c.getListIndex(S):this.a=-1}current(){return this.a<0||this.a>=this.b.length?null:this.b.element(this.a).element}previous(){return this.a--,this.current()}next(){return this.a++,this.current()}first(){return this.a=0,this.current()}last(){return this.a=this.b.length-1,this.current()}}}),define(pe[149],we([1,0,148,139,33,35]),function(oe,t,i,n,B,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$YV=void 0;class T extends i.$NV{constructor(y,f,w,A,$,m={}){super(y,f,w,A,m),this.f=y,this.g=$,this.d=new Map,this.c=m.identityProvider}getInput(){return this.b}setInput(y,f){if(f&&!this.c)throw new B.$DV(this.f,"Can't restore tree view state without an identity provider");if(this.b=y,!y){this.d.clear(),this.o.setChildren(null,O.Iterable.empty());return}if(!f){this.m(y);return}const w=[],A=[],$=e=>{const s=this.c.getId(e).toString();return!f.expanded[s]},m=e=>{const s=this.c.getId(e.element).toString();f.focus.has(s)&&w.push(e.element),f.selection.has(s)&&A.push(e.element)};this.m(y,$,m),this.setFocus(w),this.setSelection(A),f&&typeof f.scrollTop=="number"&&(this.scrollTop=f.scrollTop)}updateChildren(y=this.b){if(typeof this.b>"u")throw new B.$DV(this.f,"Tree input not set");let f;this.c&&(f=w=>{const A=this.c.getId(w).toString(),$=this.d.get(A);if($)return $.collapsed}),this.m(y,f)}resort(y=this.b,f=!0){this.o.resort(y===this.b?null:y,f)}refresh(y){if(y===void 0){this.j.rerender();return}this.o.rerender(y)}m(y,f,w){let A;if(this.c){const $=new Set,m=w;w=e=>{const s=this.c.getId(e.element).toString();$.add(s),this.d.set(s,e),m?.(e)},A=e=>{const s=this.c.getId(e.element).toString();$.has(s)||this.d.delete(s)}}this.o.setChildren(y===this.b?null:y,this.s(y,f).elements,{onDidCreateNode:w,onDidDeleteNode:A})}s(y,f){const w=[...this.g.getChildren(y)];return{elements:O.Iterable.map(w,$=>{const{elements:m,size:e}=this.s($,f),s=this.g.hasChildren?this.g.hasChildren($):void 0,o=e===0?void 0:f&&f($);return{element:$,children:m,collapsible:s,collapsed:o}}),size:w.length}}M(y,f,w){return new n.$OV(y,f,w)}}t.$YV=T}),define(pe[83],we([1,0,9,12,48,37,34,6,3,2,69,11,10]),function(oe,t,i,n,B,O,T,v,y,f,w,A,$){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ji=t.ProxyChannel=t.$ii=t.$fi=t.$ei=t.$di=t.RequestInitiator=t.$ci=t.$_h=t.$$h=void 0,t.$ai=H,t.$bi=x,t.$gi=W,t.$hi=ne;var m;(function(ue){ue[ue.Promise=100]="Promise",ue[ue.PromiseCancel=101]="PromiseCancel",ue[ue.EventListen=102]="EventListen",ue[ue.EventDispose=103]="EventDispose"})(m||(m={}));function e(ue){switch(ue){case m.Promise:return"req";case m.PromiseCancel:return"cancel";case m.EventListen:return"subscribe";case m.EventDispose:return"unsubscribe"}}var s;(function(ue){ue[ue.Initialize=200]="Initialize",ue[ue.PromiseSuccess=201]="PromiseSuccess",ue[ue.PromiseError=202]="PromiseError",ue[ue.PromiseErrorObj=203]="PromiseErrorObj",ue[ue.EventFire=204]="EventFire"})(s||(s={}));function o(ue){switch(ue){case s.Initialize:return"init";case s.PromiseSuccess:return"reply:";case s.PromiseError:case s.PromiseErrorObj:return"replyErr:";case s.EventFire:return"event:"}}var h;(function(ue){ue[ue.Uninitialized=0]="Uninitialized",ue[ue.Idle=1]="Idle"})(h||(h={}));function c(ue){let J=0;for(let fe=0;;fe+=7){const le=ue.read(1);if(J|=(le.buffer[0]&127)<<fe,!(le.buffer[0]&128))return J}}const b=D(0);function k(ue,J){if(J===0){ue.write(b);return}let fe=0;for(let ke=J;ke!==0;ke=ke>>>7)fe++;const le=B.$Je.alloc(fe);for(let ke=0;J!==0;ke++)le.buffer[ke]=J&127,J=J>>>7,J>0&&(le.buffer[ke]|=128);ue.write(le)}class E{constructor(J){this.b=J,this.a=0}read(J){const fe=this.b.slice(this.a,this.a+J);return this.a+=fe.byteLength,fe}}t.$$h=E;class r{constructor(){this.a=[]}get buffer(){return B.$Je.concat(this.a)}write(J){this.a.push(J)}}t.$_h=r;var d;(function(ue){ue[ue.Undefined=0]="Undefined",ue[ue.String=1]="String",ue[ue.Buffer=2]="Buffer",ue[ue.VSBuffer=3]="VSBuffer",ue[ue.Array=4]="Array",ue[ue.Object=5]="Object",ue[ue.Int=6]="Int"})(d||(d={}));function D(ue){const J=B.$Je.alloc(1);return J.writeUInt8(ue,0),J}const R={Undefined:D(d.Undefined),String:D(d.String),Buffer:D(d.Buffer),VSBuffer:D(d.VSBuffer),Array:D(d.Array),Object:D(d.Object),Uint:D(d.Int)},_=typeof Buffer<"u";function H(ue,J){if(typeof J>"u")ue.write(R.Undefined);else if(typeof J=="string"){const fe=B.$Je.fromString(J);ue.write(R.String),k(ue,fe.byteLength),ue.write(fe)}else if(_&&Buffer.isBuffer(J)){const fe=B.$Je.wrap(J);ue.write(R.Buffer),k(ue,fe.byteLength),ue.write(fe)}else if(J instanceof B.$Je)ue.write(R.VSBuffer),k(ue,J.byteLength),ue.write(J);else if(Array.isArray(J)){ue.write(R.Array),k(ue,J.length);for(const fe of J)H(ue,fe)}else if(typeof J=="number"&&(J|0)===J)ue.write(R.Uint),k(ue,J);else{const fe=B.$Je.fromString(JSON.stringify(J));ue.write(R.Object),k(ue,fe.byteLength),ue.write(fe)}}function x(ue){switch(ue.read(1).readUInt8(0)){case d.Undefined:return;case d.String:return ue.read(c(ue)).toString();case d.Buffer:return ue.read(c(ue)).buffer;case d.VSBuffer:return ue.read(c(ue));case d.Array:{const fe=c(ue),le=[];for(let ke=0;ke<fe;ke++)le.push(x(ue));return le}case d.Object:return JSON.parse(ue.read(c(ue)).toString());case d.Int:return c(ue)}}class p{constructor(J,fe,le=null,ke=1e3){this.h=J,this.j=fe,this.k=le,this.l=ke,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(Z=>this.q(Z)),this.m({type:s.Initialize})}registerChannel(J,fe){this.b.set(J,fe),setTimeout(()=>this.w(J),0)}m(J){switch(J.type){case s.Initialize:{const fe=this.o([J.type]);this.k?.logOutgoing(fe,0,M.OtherSide,o(J.type));return}case s.PromiseSuccess:case s.PromiseError:case s.EventFire:case s.PromiseErrorObj:{const fe=this.o([J.type,J.id],J.data);this.k?.logOutgoing(fe,J.id,M.OtherSide,o(J.type),J.data);return}}}o(J,fe=void 0){const le=new r;return H(le,J),H(le,fe),this.p(le.buffer)}p(J){try{return this.h.send(J),J.byteLength}catch{return 0}}q(J){const fe=new E(J),le=x(fe),ke=x(fe),Z=le[0];switch(Z){case m.Promise:return this.k?.logIncoming(J.byteLength,le[1],M.OtherSide,`${e(Z)}: ${le[2]}.${le[3]}`,ke),this.s({type:Z,id:le[1],channelName:le[2],name:le[3],arg:ke});case m.EventListen:return this.k?.logIncoming(J.byteLength,le[1],M.OtherSide,`${e(Z)}: ${le[2]}.${le[3]}`,ke),this.t({type:Z,id:le[1],channelName:le[2],name:le[3],arg:ke});case m.PromiseCancel:return this.k?.logIncoming(J.byteLength,le[1],M.OtherSide,`${e(Z)}`),this.u({type:Z,id:le[1]});case m.EventDispose:return this.k?.logIncoming(J.byteLength,le[1],M.OtherSide,`${e(Z)}`),this.u({type:Z,id:le[1]})}}s(J){const fe=this.b.get(J.channelName);if(!fe){this.v(J);return}const le=new O.$se;let ke;try{ke=fe.call(this.j,J.name,J.arg,le.token)}catch(ye){ke=Promise.reject(ye)}const Z=J.id;ke.then(ye=>{this.m({id:Z,data:ye,type:s.PromiseSuccess})},ye=>{ye instanceof Error?this.m({id:Z,data:{message:ye.message,name:ye.name,stack:ye.stack?ye.stack.split?ye.stack.split(`
`):ye.stack:void 0},type:s.PromiseError}):this.m({id:Z,data:ye,type:s.PromiseErrorObj})}).finally(()=>{me.dispose(),this.d.delete(J.id)});const me=(0,f.$Sc)(()=>le.cancel());this.d.set(J.id,me)}t(J){const fe=this.b.get(J.channelName);if(!fe){this.v(J);return}const le=J.id,Z=fe.listen(this.j,J.name,J.arg)(me=>this.m({id:le,data:me,type:s.EventFire}));this.d.set(J.id,Z)}u(J){const fe=this.d.get(J.id);fe&&(fe.dispose(),this.d.delete(J.id))}v(J){let fe=this.g.get(J.channelName);fe||(fe=[],this.g.set(J.channelName,fe));const le=setTimeout(()=>{console.error(`Unknown channel: ${J.channelName}`),J.type===m.Promise&&this.m({id:J.id,data:{name:"Unknown channel",message:`Channel name '${J.channelName}' timed out after ${this.l}ms`,stack:void 0},type:s.PromiseError})},this.l);fe.push({request:J,timeoutTimer:le})}w(J){const fe=this.g.get(J);if(fe){for(const le of fe)switch(clearTimeout(le.timeoutTimer),le.request.type){case m.Promise:this.s(le.request);break;case m.EventListen:this.t(le.request);break}this.g.delete(J)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,f.$Pc)(this.d.values()),this.d.clear()}}t.$ci=p;var M;(function(ue){ue[ue.LocalSide=0]="LocalSide",ue[ue.OtherSide=1]="OtherSide"})(M||(t.RequestInitiator=M={}));class U{constructor(J,fe=null){this.l=J,this.a=!1,this.b=h.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new y.$he,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(le=>this.s(le)),this.j=fe}getChannel(J){const fe=this;return{call(le,ke,Z){return fe.a?Promise.reject(new v.$5):fe.m(J,le,ke,Z)},listen(le,ke){return fe.a?y.Event.None:fe.o(J,le,ke)}}}m(J,fe,le,ke=O.CancellationToken.None){const Z=this.g++,me=m.Promise,ye={id:Z,type:me,channelName:J,name:fe,arg:le};if(ke.isCancellationRequested)return Promise.reject(new v.$5);let Oe;return new Promise((je,ie)=>{if(ke.isCancellationRequested)return ie(new v.$5);const K=()=>{const g=I=>{switch(I.type){case s.PromiseSuccess:this.f.delete(Z),je(I.data);break;case s.PromiseError:{this.f.delete(Z);const F=new Error(I.data.message);F.stack=Array.isArray(I.data.stack)?I.data.stack.join(`
`):I.data.stack,F.name=I.data.name,ie(F);break}case s.PromiseErrorObj:this.f.delete(Z),ie(I.data);break}};this.f.set(Z,g),this.p(ye)};let C=null;this.b===h.Idle?K():(C=(0,n.$nh)(g=>this.u()),C.then(()=>{C=null,K()}));const a=()=>{C?(C.cancel(),C=null):this.p({id:Z,type:m.PromiseCancel}),ie(new v.$5)},l=ke.onCancellationRequested(a);Oe=(0,f.$Rc)((0,f.$Sc)(a),l),this.d.add(Oe)}).finally(()=>{Oe.dispose(),this.d.delete(Oe)})}o(J,fe,le){const ke=this.g++,Z=m.EventListen,me={id:ke,type:Z,channelName:J,name:fe,arg:le};let ye=null;const Oe=new y.$he({onWillAddFirstListener:()=>{ye=(0,n.$nh)(je=>this.u()),ye.then(()=>{ye=null,this.d.add(Oe),this.p(me)})},onDidRemoveLastListener:()=>{ye?(ye.cancel(),ye=null):(this.d.delete(Oe),this.p({id:ke,type:m.EventDispose}))}}),Ie=je=>Oe.fire(je.data);return this.f.set(ke,Ie),Oe.event}p(J){switch(J.type){case m.Promise:case m.EventListen:{const fe=this.q([J.type,J.id,J.channelName,J.name],J.arg);this.j?.logOutgoing(fe,J.id,M.LocalSide,`${e(J.type)}: ${J.channelName}.${J.name}`,J.arg);return}case m.PromiseCancel:case m.EventDispose:{const fe=this.q([J.type,J.id]);this.j?.logOutgoing(fe,J.id,M.LocalSide,e(J.type));return}}}q(J,fe=void 0){const le=new r;return H(le,J),H(le,fe),this.r(le.buffer)}r(J){try{return this.l.send(J),J.byteLength}catch{return 0}}s(J){const fe=new E(J),le=x(fe),ke=x(fe),Z=le[0];switch(Z){case s.Initialize:return this.j?.logIncoming(J.byteLength,0,M.LocalSide,o(Z)),this.t({type:le[0]});case s.PromiseSuccess:case s.PromiseError:case s.EventFire:case s.PromiseErrorObj:return this.j?.logIncoming(J.byteLength,le[1],M.LocalSide,o(Z),ke),this.t({type:le[0],id:le[1],data:ke})}}t(J){if(J.type===s.Initialize){this.b=h.Idle,this.k.fire();return}this.f.get(J.id)?.(J)}get onDidInitializePromise(){return y.Event.toPromise(this.onDidInitialize)}u(){return this.b===h.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,f.$Pc)(this.d.values()),this.d.clear()}}t.$di=U,Je([T.$5h],U.prototype,"onDidInitializePromise",null);class N{get connections(){const J=[];return this.f.forEach(fe=>J.push(fe)),J}constructor(J,fe,le){this.a=new Map,this.f=new Set,this.g=new y.$he,this.onDidAddConnection=this.g.event,this.h=new y.$he,this.onDidRemoveConnection=this.h.event,this.j=new f.$Tc,this.j.add(J(({protocol:ke,onDidClientDisconnect:Z})=>{const me=y.Event.once(ke.onMessage);this.j.add(me(ye=>{const Oe=new E(ye),Ie=x(Oe),je=new p(ke,Ie,fe,le),ie=new U(ke,fe);this.a.forEach((C,a)=>je.registerChannel(a,C));const K={channelServer:je,channelClient:ie,ctx:Ie};this.f.add(K),this.g.fire(K),this.j.add(Z(()=>{je.dispose(),ie.dispose(),this.f.delete(K),this.h.fire(K)}))}))}))}getChannel(J,fe){const le=this;return{call(ke,Z,me){let ye;if((0,$.$og)(fe)){const Ie=(0,i.$3b)(le.connections.filter(fe));ye=Ie?Promise.resolve(Ie):y.Event.toPromise(y.Event.filter(le.onDidAddConnection,fe))}else ye=fe.routeCall(le,ke,Z);const Oe=ye.then(Ie=>Ie.channelClient.getChannel(J));return W(Oe).call(ke,Z,me)},listen(ke,Z){if((0,$.$og)(fe))return le.k(J,fe,ke,Z);const me=fe.routeEvent(le,ke,Z).then(ye=>ye.channelClient.getChannel(J));return W(me).listen(ke,Z)}}}k(J,fe,le,ke){const Z=this;let me;const ye=new y.$he({onWillAddFirstListener:()=>{me=new f.$Tc;const Oe=new y.$ne,Ie=new Map,je=K=>{const a=K.channelClient.getChannel(J).listen(le,ke),l=Oe.add(a);Ie.set(K,l)},ie=K=>{const C=Ie.get(K);C&&(C.dispose(),Ie.delete(K))};Z.connections.filter(fe).forEach(je),y.Event.filter(Z.onDidAddConnection,fe)(je,void 0,me),Z.onDidRemoveConnection(ie,void 0,me),Oe.event(ye.fire,ye,me),me.add(Oe)},onDidRemoveLastListener:()=>{me?.dispose(),me=void 0}});return ye.event}registerChannel(J,fe){this.a.set(J,fe);for(const le of this.f)le.channelServer.registerChannel(J,fe)}dispose(){this.j.dispose();for(const J of this.f)J.channelClient.dispose(),J.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}t.$ei=N;class P{constructor(J,fe,le=null){const ke=new r;H(ke,fe),J.send(ke.buffer),this.a=new U(J,le),this.d=new p(J,fe,le)}getChannel(J){return this.a.getChannel(J)}registerChannel(J,fe){this.d.registerChannel(J,fe)}dispose(){this.a.dispose(),this.d.dispose()}}t.$fi=P;function W(ue){return{call(J,fe,le){return ue.then(ke=>ke.call(J,fe,le))},listen(J,fe){const le=new y.$qe;return ue.then(ke=>le.input=ke.listen(J,fe)),le.event}}}function ne(ue){let J=!1;return{call(fe,le,ke){return J?ue.call(fe,le,ke):(0,n.$Bh)(0).then(()=>J=!0).then(()=>ue.call(fe,le,ke))},listen(fe,le){if(J)return ue.listen(fe,le);const ke=new y.$qe;return(0,n.$Bh)(0).then(()=>J=!0).then(()=>ke.input=ue.listen(fe,le)),ke.event}}}class Q{constructor(J){this.a=J}routeCall(J){return this.b(J)}routeEvent(J){return this.b(J)}async b(J){for(const fe of J.connections)if(await Promise.resolve(this.a(fe.ctx)))return Promise.resolve(fe);return await y.Event.toPromise(J.onDidAddConnection),await this.b(J)}}t.$ii=Q;var Y;(function(ue){function J(Z,me,ye){const Oe=Z,Ie=ye&&ye.disableMarshalling,je=new Map;for(const ie in Oe)le(ie)&&je.set(ie,y.Event.buffer(Oe[ie],!0,void 0,me));return new class{listen(ie,K,C){const a=je.get(K);if(a)return a;const l=Oe[K];if(typeof l=="function"){if(ke(K))return l.call(Oe,C);if(le(K))return je.set(K,y.Event.buffer(Oe[K],!0,void 0,me)),je.get(K)}throw new v.$bb(`Event not found: ${K}`)}call(ie,K,C){const a=Oe[K];if(typeof a=="function"){if(!Ie&&Array.isArray(C))for(let g=0;g<C.length;g++)C[g]=(0,w.$0h)(C[g]);let l=a.apply(Oe,C);return l instanceof Promise||(l=Promise.resolve(l)),l}throw new v.$bb(`Method not found: ${K}`)}}}ue.fromService=J;function fe(Z,me){const ye=me&&me.disableMarshalling;return new Proxy({},{get(Oe,Ie){if(typeof Ie=="string")return me?.properties?.has(Ie)?me.properties.get(Ie):ke(Ie)?function(je){return Z.listen(Ie,je)}:le(Ie)?Z.listen(Ie):async function(...je){let ie;me&&!(0,$.$jg)(me.context)?ie=[me.context,...je]:ie=je;const K=await Z.call(Ie,ie);return ye?K:(0,w.$0h)(K)};throw new v.$bb(`Property not found: ${String(Ie)}`)}})}ue.toService=fe;function le(Z){return Z[0]==="o"&&Z[1]==="n"&&A.$Af(Z.charCodeAt(2))}function ke(Z){return/^onDynamic/.test(Z)&&A.$Af(Z.charCodeAt(9))}})(Y||(t.ProxyChannel=Y={}));const te=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function de(ue){if(Array.isArray(ue))return ue;if(ue&&typeof ue=="object"&&typeof ue.toString=="function"){const J=ue.toString();if(J!=="[object Object]")return J}return ue}function De(ue){return Array.isArray(ue)?ue.map(de):de(ue)}function Le(ue,J,fe,le,ke,Z,me){me=De(me);const ye=te[ke],Oe=ye[le%ye.length];let Ie=[`%c[${ue}]%c[${String(J).padStart(7," ")}]%c[len: ${String(fe).padStart(5," ")}]%c${String(le).padStart(5," ")} - ${Z}`,"color: darkgreen","color: grey","color: grey",`color: ${Oe}`];/\($/.test(Z)?(Ie=Ie.concat(me),Ie.push(")")):Ie.push(me),console.log.apply(console,Ie)}class Se{constructor(J,fe){this.d=J,this.f=fe,this.a=0,this.b=0}logOutgoing(J,fe,le,ke,Z){this.b+=J,Le(this.d,this.b,J,fe,le,ke,Z)}logIncoming(J,fe,le,ke,Z){this.a+=J,Le(this.f,this.a,J,fe,le,ke,Z)}}t.$ji=Se}),define(pe[150],we([1,0,48,3,83,106,38]),function(oe,t,i,n,B,O,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$zW=void 0;class v extends B.$fi{static f(){const f=n.Event.fromNodeEventEmitter(T.$O,"vscode:message",(w,A)=>i.$Je.wrap(A));return T.$O.send("vscode:hello"),new O.$vW(T.$O,f)}constructor(f){const w=v.f();super(w,f),this.b=w}dispose(){this.b.disconnect(),super.dispose()}}t.$zW=v}),define(pe[151],we([14,13]),function(oe,t){return oe.create("vs/platform/files/common/files",t)}),define(pe[152],we([14,13]),function(oe,t){return oe.create("vs/platform/theme/common/iconRegistry",t)}),define(pe[55],we([1,0]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$zi=t._util=void 0,t.$Ai=B,t.$Bi=O;var i;(function(T){T.serviceIds=new Map,T.DI_TARGET="$di$target",T.DI_DEPENDENCIES="$di$dependencies";function v(y){return y[T.DI_DEPENDENCIES]||[]}T.getServiceDependencies=v})(i||(t._util=i={})),t.$zi=B("instantiationService");function n(T,v,y){v[i.DI_TARGET]===v?v[i.DI_DEPENDENCIES].push({id:T,index:y}):(v[i.DI_DEPENDENCIES]=[{id:T,index:y}],v[i.DI_TARGET]=v)}function B(T){if(i.serviceIds.has(T))return i.serviceIds.get(T);const v=function(y,f,w){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");n(v,y,w)};return v.toString=()=>T,i.serviceIds.set(T,v),v}function O(T){return T}}),define(pe[153],we([1,0,55]),function(oe,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$kn=t.$in=t.ID=void 0,t.$jn=n,t.ID="diagnosticsService",t.$in=(0,i.$Ai)(t.ID);function n(O){return!!O.hostName&&!!O.errorMessage}class B{async getPerformanceInfo(T,v){return{}}async getSystemInfo(T,v){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(T,v){return""}async getWorkspaceFileExtensions(T){return{extensions:[]}}async reportWorkspaceStats(T){}}t.$kn=B}),define(pe[154],we([1,0,104,28,11,10,17,151,55,5,39,26]),function(oe,t,i,n,B,O,T,v,y,f,w,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Cl=t.$zl=t.FileKind=t.$yl=t.$xl=t.$wl=t.$vl=t.$ul=t.$tl=t.$sl=t.FileOperationResult=t.$rl=t.$ql=t.$pl=t.$nl=t.FileChangeType=t.$ml=t.FileOperation=t.$gl=t.FileSystemProviderErrorCode=t.FileSystemProviderCapabilities=t.FileChangeFilter=t.FilePermission=t.FileType=t.$7k=void 0,t.$8k=$,t.$9k=o,t.$0k=c,t.$$k=b,t.$_k=k,t.$al=E,t.$bl=r,t.$cl=d,t.$dl=D,t.$el=R,t.$fl=_,t.$hl=p,t.$il=M,t.$jl=U,t.$kl=N,t.$ll=P,t.$ol=te,t.$Al=J,t.$Bl=fe,t.$Dl=ke,t.$7k=(0,y.$Ai)("fileService");function $(Z){return Z.create===!0}var m;(function(Z){Z[Z.Unknown=0]="Unknown",Z[Z.File=1]="File",Z[Z.Directory=2]="Directory",Z[Z.SymbolicLink=64]="SymbolicLink"})(m||(t.FileType=m={}));var e;(function(Z){Z[Z.Readonly=1]="Readonly",Z[Z.Locked=2]="Locked"})(e||(t.FilePermission=e={}));var s;(function(Z){Z[Z.UPDATED=2]="UPDATED",Z[Z.ADDED=4]="ADDED",Z[Z.DELETED=8]="DELETED"})(s||(t.FileChangeFilter=s={}));function o(Z){const me=Z;return!!me&&typeof me.onDidChange=="function"}var h;(function(Z){Z[Z.None=0]="None",Z[Z.FileReadWrite=2]="FileReadWrite",Z[Z.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",Z[Z.FileReadStream=16]="FileReadStream",Z[Z.FileFolderCopy=8]="FileFolderCopy",Z[Z.PathCaseSensitive=1024]="PathCaseSensitive",Z[Z.Readonly=2048]="Readonly",Z[Z.Trash=4096]="Trash",Z[Z.FileWriteUnlock=8192]="FileWriteUnlock",Z[Z.FileAtomicRead=16384]="FileAtomicRead",Z[Z.FileAtomicWrite=32768]="FileAtomicWrite",Z[Z.FileAtomicDelete=65536]="FileAtomicDelete",Z[Z.FileClone=131072]="FileClone"})(h||(t.FileSystemProviderCapabilities=h={}));function c(Z){return!!(Z.capabilities&h.FileReadWrite)}function b(Z){return!!(Z.capabilities&h.FileFolderCopy)}function k(Z){return!!(Z.capabilities&h.FileClone)}function E(Z){return!!(Z.capabilities&h.FileOpenReadWriteClose)}function r(Z){return!!(Z.capabilities&h.FileReadStream)}function d(Z){return c(Z)?!!(Z.capabilities&h.FileAtomicRead):!1}function D(Z){return c(Z)?!!(Z.capabilities&h.FileAtomicWrite):!1}function R(Z){return!!(Z.capabilities&h.FileAtomicDelete)}function _(Z){return!!(Z.capabilities&h.Readonly)}var H;(function(Z){Z.FileExists="EntryExists",Z.FileNotFound="EntryNotFound",Z.FileNotADirectory="EntryNotADirectory",Z.FileIsADirectory="EntryIsADirectory",Z.FileExceedsStorageQuota="EntryExceedsStorageQuota",Z.FileTooLarge="EntryTooLarge",Z.FileWriteLocked="EntryWriteLocked",Z.NoPermissions="NoPermissions",Z.Unavailable="Unavailable",Z.Unknown="Unknown"})(H||(t.FileSystemProviderErrorCode=H={}));class x extends Error{static create(me,ye){const Oe=new x(me.toString(),ye);return U(Oe,ye),Oe}constructor(me,ye){super(me),this.code=ye}}t.$gl=x;function p(Z,me){return x.create(Z,me)}function M(Z){return Z||p((0,v.localize)(0,null),H.Unknown)}function U(Z,me){return Z.name=me?`${me} (FileSystemError)`:"FileSystemError",Z}function N(Z){if(!Z)return H.Unknown;if(Z instanceof x)return Z.code;const me=/^(.+) \(FileSystemError\)$/.exec(Z.name);if(!me)return H.Unknown;switch(me[1]){case H.FileExists:return H.FileExists;case H.FileIsADirectory:return H.FileIsADirectory;case H.FileNotADirectory:return H.FileNotADirectory;case H.FileNotFound:return H.FileNotFound;case H.FileTooLarge:return H.FileTooLarge;case H.FileWriteLocked:return H.FileWriteLocked;case H.NoPermissions:return H.NoPermissions;case H.Unavailable:return H.Unavailable}return H.Unknown}function P(Z){if(Z instanceof de)return Z.fileOperationResult;switch(N(Z)){case H.FileNotFound:return Se.FILE_NOT_FOUND;case H.FileIsADirectory:return Se.FILE_IS_DIRECTORY;case H.FileNotADirectory:return Se.FILE_NOT_DIRECTORY;case H.FileWriteLocked:return Se.FILE_WRITE_LOCKED;case H.NoPermissions:return Se.FILE_PERMISSION_DENIED;case H.FileExists:return Se.FILE_MOVE_CONFLICT;case H.FileTooLarge:return Se.FILE_TOO_LARGE;default:return Se.FILE_OTHER_ERROR}}var W;(function(Z){Z[Z.CREATE=0]="CREATE",Z[Z.DELETE=1]="DELETE",Z[Z.MOVE=2]="MOVE",Z[Z.COPY=3]="COPY",Z[Z.WRITE=4]="WRITE"})(W||(t.FileOperation=W={}));class ne{constructor(me,ye,Oe){this.resource=me,this.operation=ye,this.target=Oe}isOperation(me){return this.operation===me}}t.$ml=ne;var Q;(function(Z){Z[Z.UPDATED=0]="UPDATED",Z[Z.ADDED=1]="ADDED",Z[Z.DELETED=2]="DELETED"})(Q||(t.FileChangeType=Q={}));class Y{static{this.a=null}constructor(me,ye){this.c=ye,this.b=void 0,this.d=new A.$V(()=>{const Oe=i.$Gi.forUris(()=>this.c);return Oe.fill(this.rawAdded.map(Ie=>[Ie,!0])),Oe}),this.f=new A.$V(()=>{const Oe=i.$Gi.forUris(()=>this.c);return Oe.fill(this.rawUpdated.map(Ie=>[Ie,!0])),Oe}),this.g=new A.$V(()=>{const Oe=i.$Gi.forUris(()=>this.c);return Oe.fill(this.rawDeleted.map(Ie=>[Ie,!0])),Oe}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const Oe of me){switch(Oe.type){case Q.ADDED:this.rawAdded.push(Oe.resource);break;case Q.UPDATED:this.rawUpdated.push(Oe.resource);break;case Q.DELETED:this.rawDeleted.push(Oe.resource);break}this.b!==Y.a&&(typeof Oe.cId=="number"?this.b===void 0?this.b=Oe.cId:this.b!==Oe.cId&&(this.b=Y.a):this.b!==void 0&&(this.b=Y.a))}}contains(me,...ye){return this.h(me,{includeChildren:!1},...ye)}affects(me,...ye){return this.h(me,{includeChildren:!0},...ye)}h(me,ye,...Oe){if(!me)return!1;const Ie=Oe.length>0;return!!((!Ie||Oe.includes(Q.ADDED))&&(this.d.value.get(me)||ye.includeChildren&&this.d.value.findSuperstr(me))||(!Ie||Oe.includes(Q.UPDATED))&&(this.f.value.get(me)||ye.includeChildren&&this.f.value.findSuperstr(me))||(!Ie||Oe.includes(Q.DELETED))&&(this.g.value.findSubstr(me)||ye.includeChildren&&this.g.value.findSuperstr(me)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(me){return this.b===me}hasCorrelation(){return typeof this.b=="number"}}t.$nl=Y;function te(Z,me,ye){return!Z||!me||Z===me||me.length>Z.length?!1:(me.charAt(me.length-1)!==n.sep&&(me+=n.sep),ye?(0,B.$Cf)(Z,me):Z.indexOf(me)===0)}class de extends Error{constructor(me,ye,Oe){super(me),this.fileOperationResult=ye,this.options=Oe}}t.$pl=de;class De extends de{constructor(me,ye,Oe,Ie){super(me,ye,Ie),this.fileOperationResult=ye,this.size=Oe}}t.$ql=De;class Le extends de{constructor(me,ye,Oe){super(me,Se.FILE_NOT_MODIFIED_SINCE,Oe),this.stat=ye}}t.$rl=Le;var Se;(function(Z){Z[Z.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",Z[Z.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",Z[Z.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",Z[Z.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",Z[Z.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",Z[Z.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",Z[Z.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",Z[Z.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",Z[Z.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",Z[Z.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",Z[Z.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(Se||(t.FileOperationResult=Se={})),t.$sl={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},t.$tl={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},t.$ul="files.associations",t.$vl="files.exclude",t.$wl="files.readonlyInclude",t.$xl="files.readonlyExclude",t.$yl="files.readonlyFromPermissions";var ue;(function(Z){Z[Z.FILE=0]="FILE",Z[Z.FOLDER=1]="FOLDER",Z[Z.ROOT_FOLDER=2]="ROOT_FOLDER"})(ue||(t.FileKind=ue={})),t.$zl="";function J(Z){if(!(typeof Z.size!="number"||typeof Z.mtime!="number"))return Z.mtime.toString(29)+Z.size.toString(31)}async function fe(Z,me){if(!me.hasProvider(T.URI.from({scheme:Z.scheme})))return new Promise(ye=>{const Oe=me.onDidChangeFileSystemProviderRegistrations(Ie=>{Ie.scheme===Z.scheme&&Ie.added&&(Oe.dispose(),ye())})})}class le{static{this.KB=1024}static{this.MB=le.KB*le.KB}static{this.GB=le.MB*le.KB}static{this.TB=le.GB*le.KB}static formatSize(me){return(0,O.$eg)(me)||(me=0),me<le.KB?(0,v.localize)(1,null,me.toFixed(0)):me<le.MB?(0,v.localize)(2,null,(me/le.KB).toFixed(2)):me<le.GB?(0,v.localize)(3,null,(me/le.MB).toFixed(2)):me<le.TB?(0,v.localize)(4,null,(me/le.GB).toFixed(2)):(0,v.localize)(5,null,(me/le.TB).toFixed(2))}}t.$Cl=le;function ke(Z){const me=typeof Z=="string"||Z?.scheme===w.Schemas.vscodeRemote;return typeof Z!="string"&&Z?.scheme===w.Schemas.file?1024*le.MB:me?10*le.MB:f.$o?50*le.MB:1024*le.MB}}),define(pe[155],we([1,0,55]),function(oe,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Zec=t.$Yec=void 0,t.$Yec=(0,i.$Ai)("mainProcessService");class n{constructor(O,T){this.a=O,this.b=T}getChannel(O){return this.a.getChannel(O,this.b)}registerChannel(O,T){this.a.registerChannel(O,T)}}t.$Zec=n}),define(pe[156],we([1,0,2,150]),function(oe,t,i,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$1ec=void 0;class B extends i.$Uc{constructor(T){super(),this.a=this.B(new n.$zW(`window:${T}`))}getChannel(T){return this.a.getChannel(T)}registerChannel(T,v){this.a.registerChannel(T,v)}}t.$1ec=B});var yi=this&&this.__param||function(oe,t){return function(i,n){t(i,n,oe)}};define(pe[157],we([1,0,83,155]),function(oe,t,i,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$2ec=void 0;let B=class{constructor(T,v){return this.windowId=T,i.ProxyChannel.toService(v.getChannel("nativeHost"),{context:T,properties:(()=>{const y=new Map;return y.set("windowId",T),y})()})}};t.$2ec=B,t.$2ec=B=Je([yi(1,n.$Yec)],B)}),define(pe[84],we([1,0,41,10]),function(oe,t,i,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$jo=void 0;class B{constructor(){this.a=new Map}add(T,v){i.ok(n.$ag(T)),i.ok(n.$cg(v)),i.ok(!this.a.has(T),"There is already an extension with this id"),this.a.set(T,v)}knows(T){return this.a.has(T)}as(T){return this.a.get(T)||null}}t.$jo=new B}),define(pe[158],we([1,0,3,84]),function(oe,t,i,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ko=void 0,t.$ko={JSONContribution:"base.contributions.json"};function B(v){return v.length>0&&v.charAt(v.length-1)==="#"?v.substring(0,v.length-1):v}class O{constructor(){this.b=new i.$he,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(y,f){this.a[B(y)]=f,this.b.fire(y)}notifySchemaChanged(y){this.b.fire(y)}getSchemaContributions(){return{schemas:this.a}}}const T=new O;n.$jo.add(t.$ko.JSONContribution,T)}),define(pe[159],we([1,0,12,21,49,22,3,10,17,152,158,84]),function(oe,t,i,n,B,O,T,v,y,f,w,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ux=t.$tx=t.$sx=t.$rx=t.$qx=t.$px=t.IconFontDefinition=t.IconContribution=t.$mx=void 0,t.$nx=o,t.$ox=h,t.$mx={IconContribution:"base.contributions.icons"};var $;(function(E){function r(d,D){let R=d.defaults;for(;O.ThemeIcon.isThemeIcon(R);){const _=s.getIcon(R.id);if(!_)return;R=_.defaults}return R}E.getDefinition=r})($||(t.IconContribution=$={}));var m;(function(E){function r(D){return{weight:D.weight,style:D.style,src:D.src.map(R=>({format:R.format,location:R.location.toString()}))}}E.toJSONObject=r;function d(D){const R=_=>(0,v.$ag)(_)?_:void 0;if(D&&Array.isArray(D.src)&&D.src.every(_=>(0,v.$ag)(_.format)&&(0,v.$ag)(_.location)))return{weight:R(D.weight),style:R(D.style),src:D.src.map(_=>({format:_.format,location:y.URI.parse(_.location)}))}}E.fromJSONObject=d})(m||(t.IconFontDefinition=m={}));class e{constructor(){this.a=new T.$he,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,f.localize)(0,null)},fontCharacter:{type:"string",description:(0,f.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${O.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(r,d,D,R){const _=this.b[r];if(_){if(D&&!_.description){_.description=D,this.d.properties[r].markdownDescription=`${D} $(${r})`;const p=this.e.enum.indexOf(r);p!==-1&&(this.e.enumDescriptions[p]=D),this.a.fire()}return _}const H={id:r,description:D,defaults:d,deprecationMessage:R};this.b[r]=H;const x={$ref:"#/definitions/icons"};return R&&(x.deprecationMessage=R),D&&(x.markdownDescription=`${D}: $(${r})`),this.d.properties[r]=x,this.e.enum.push(r),this.e.enumDescriptions.push(D||""),this.a.fire(),{id:r}}deregisterIcon(r){delete this.b[r],delete this.d.properties[r];const d=this.e.enum.indexOf(r);d!==-1&&(this.e.enum.splice(d,1),this.e.enumDescriptions.splice(d,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(r=>this.b[r])}getIcon(r){return this.b[r]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(r,d){const D=this.f[r];return D||(this.f[r]=d,this.a.fire(),d)}deregisterIconFont(r){delete this.f[r]}getIconFont(r){return this.f[r]}toString(){const r=(_,H)=>_.id.localeCompare(H.id),d=_=>{for(;O.ThemeIcon.isThemeIcon(_.defaults);)_=this.b[_.defaults.id];return`codicon codicon-${_?_.id:""}`},D=[];D.push("| preview     | identifier                        | default codicon ID                | description"),D.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const R=Object.keys(this.b).map(_=>this.b[_]);for(const _ of R.filter(H=>!!H.description).sort(r))D.push(`|<i class="${d(_)}"></i>|${_.id}|${O.ThemeIcon.isThemeIcon(_.defaults)?_.defaults.id:_.id}|${_.description||""}|`);D.push("| preview     | identifier                        "),D.push("| ----------- | --------------------------------- |");for(const _ of R.filter(H=>!O.ThemeIcon.isThemeIcon(H.defaults)).sort(r))D.push(`|<i class="${d(_)}"></i>|${_.id}|`);return D.join(`
`)}}const s=new e;A.$jo.add(t.$mx.IconContribution,s);function o(E,r,d,D){return s.registerIcon(E,r,d,D)}function h(){return s}function c(){const E=(0,B.$Vj)();for(const r in E){const d="\\"+E[r].toString(16);s.registerIcon(r,{fontCharacter:d})}}c(),t.$px="vscode://schemas/icons";const b=A.$jo.as(w.$ko.JSONContribution);b.registerSchema(t.$px,s.getIconSchema());const k=new i.$Mh(()=>b.notifySchemaChanged(t.$px),200);s.onDidChange(()=>{k.isScheduled()||k.schedule()}),t.$qx=o("widget-close",n.$Zj.close,(0,f.localize)(2,null)),t.$rx=o("goto-previous-location",n.$Zj.arrowUp,(0,f.localize)(3,null)),t.$sx=o("goto-next-location",n.$Zj.arrowDown,(0,f.localize)(4,null)),t.$tx=O.ThemeIcon.modify(n.$Zj.sync,"spin"),t.$ux=O.ThemeIcon.modify(n.$Zj.loading,"spin")}),define(pe[160],we([1,0,4,3,2,22,159]),function(oe,t,i,n,B,O,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$yKb=void 0,t.$xKb=v;function v(f){const w=new B.$Tc,A=w.add(new n.$he),$=(0,T.$ox)();return w.add($.onDidChange(()=>A.fire())),f&&w.add(f.onDidProductIconThemeChange(()=>A.fire())),{dispose:()=>w.dispose(),onDidChange:A.event,getCSS(){const m=f?f.getProductIconTheme():new y,e={},s=[],o=[];for(const h of $.getIcons()){const c=m.getIcon(h);if(!c)continue;const b=c.font,k=`--vscode-icon-${h.id}-font-family`,E=`--vscode-icon-${h.id}-content`;b?(e[b.id]=b.definition,o.push(`${k}: ${(0,i.$ES)(b.id)};`,`${E}: '${c.fontCharacter}';`),s.push(`.codicon-${h.id}:before { content: '${c.fontCharacter}'; font-family: ${(0,i.$ES)(b.id)}; }`)):(o.push(`${E}: '${c.fontCharacter}'; ${k}: 'codicon';`),s.push(`.codicon-${h.id}:before { content: '${c.fontCharacter}'; }`))}for(const h in e){const c=e[h],b=c.weight?`font-weight: ${c.weight};`:"",k=c.style?`font-style: ${c.style};`:"",E=c.src.map(r=>`${(0,i.$DS)(r.location)} format('${r.format}')`).join(", ");s.push(`@font-face { src: ${E}; font-family: ${(0,i.$ES)(h)};${b}${k} font-display: block; }`)}return s.push(`:root { ${o.join(" ")} }`),s.join(`
`)}}}class y{getIcon(w){const A=(0,T.$ox)();let $=w.defaults;for(;O.ThemeIcon.isThemeIcon($);){const m=A.getIcon($.id);if(!m)return;$=m.defaults}return $}}t.$yKb=y}),define(pe[161],we([1,0,5]),function(oe,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$RD=t.CustomTitleBarVisibility=t.TitlebarStyle=t.TitleBarSetting=t.$ID=void 0,t.$JD=n,t.$KD=B,t.$LD=O,t.$MD=T,t.$ND=v,t.$OD=A,t.$PD=$,t.$QD=m,t.$SD=e,t.$TD=s,t.$UD=o,t.$ID={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function n(h){return typeof h.parentId=="number"}function B(h){return!!h.workspaceUri}function O(h){return!!h.folderUri}function T(h){return!!h.fileUri}function v(h){const c=$(h),b=h.getValue("window.menuBarVisibility");return b==="default"||c&&b==="compact"||i.$j&&i.$m?"classic":b}var y;(function(h){h.TITLE_BAR_STYLE="window.titleBarStyle",h.CUSTOM_TITLE_BAR_VISIBILITY="window.customTitleBarVisibility"})(y||(t.TitleBarSetting=y={}));var f;(function(h){h.NATIVE="native",h.CUSTOM="custom"})(f||(t.TitlebarStyle=f={}));var w;(function(h){h.AUTO="auto",h.WINDOWED="windowed",h.NEVER="never"})(w||(t.CustomTitleBarVisibility=w={}));function A(h,c){return!0}function $(h,c){return c||(c=m(h)),c===f.NATIVE}function m(h){if(i.$o)return f.CUSTOM;const c=h.getValue("window");if(c){if(i.$j&&c.nativeTabs===!0||i.$j&&c.nativeFullScreen===!1)return f.NATIVE;const E=c.titleBarStyle;if(E===f.NATIVE||E===f.CUSTOM)return E}return i.$k?f.NATIVE:f.CUSTOM}t.$RD=35;function e(h){return!(!i.$i||i.$o||$(h))}function s(h){const c=h.getValue("window");return!c||typeof c.nativeFullScreen!="boolean"||c.nativeTabs?!0:c.nativeFullScreen!==!1}function o(h=0){return Math.pow(1.2,h)}}),define(pe[162],we([1,0,19,4,25,38,161]),function(oe,t,i,n,B,O,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$4ec=t.$3ec=t.ApplyZoomTarget=void 0,t.$5ec=y,t.$6ec=w,t.$7ec=A;var v;(function($){$[$.ACTIVE_WINDOW=1]="ACTIVE_WINDOW",$[$.ALL_WINDOWS=2]="ALL_WINDOWS"})(v||(t.ApplyZoomTarget=v={})),t.$3ec=8,t.$4ec=-8;function y($,m){$=Math.min(Math.max($,t.$4ec),t.$3ec);const e=[];m===v.ACTIVE_WINDOW?e.push((0,n.$5R)()):m===v.ALL_WINDOWS?e.push(...Array.from((0,n.getWindows)()).map(({window:s})=>s)):e.push(m);for(const s of e)f(s)?.webFrame?.setZoomLevel($),(0,i.$2Q)((0,T.$UD)($),s),(0,i.$XQ)($,s)}function f($){if($===B.$TQ)return{ipcRenderer:O.$O,webFrame:O.$Q};{const m=$;if(m?.vscode?.ipcRenderer&&m?.vscode?.webFrame)return m.vscode}}function w($){y((0,i.$YQ)(typeof $=="number"?(0,n.$5R)():$)+1,$)}function A($){y((0,i.$YQ)(typeof $=="number"?(0,n.$5R)():$)-1,$)}}),define(pe[163],we([1,0,13,4,149,12,107,38,153,154,156,157,160,162,16,8,25,121,111]),function(oe,t,i,n,B,O,T,v,y,f,w,A,$,m,e,s,o){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.startup=M;const h=/\s--inspect(?:-brk|port)?=(?<port>\d+)?/,c=/\s--inspect-port=(?<port>\d+)/;class b{getHeight(N){return 22}getTemplateId(N){return H(N)?"process":R(N)?"machine":(0,y.$jn)(N)?"error":_(N)?"header":""}}class k{hasChildren(N){return(0,y.$jn)(N)?!1:H(N)?!!N.children?.length:!0}getChildren(N){return H(N)?N.children?N.children:[]:(0,y.$jn)(N)?[]:_(N)?N.processRoots.length>1?N.processRoots:[N.processRoots[0].rootProcess]:R(N)?[N.rootProcess]:[N.processes]}}class E{constructor(){this.templateId="header"}renderTemplate(N){const P=(0,n.$nS)(N,(0,n.$)(".row")),W=(0,n.$nS)(P,(0,n.$)(".nameLabel")),ne=(0,n.$nS)(P,(0,n.$)(".cpu")),Q=(0,n.$nS)(P,(0,n.$)(".memory")),Y=(0,n.$nS)(P,(0,n.$)(".pid"));return{name:W,CPU:ne,memory:Q,PID:Y}}renderElement(N,P,W,ne){W.name.textContent=(0,i.localize)(0,null),W.CPU.textContent=(0,i.localize)(1,null),W.PID.textContent=(0,i.localize)(2,null),W.memory.textContent=(0,i.localize)(3,null)}disposeTemplate(N){}}class r{constructor(){this.templateId="machine"}renderTemplate(N){const P=Object.create(null),W=(0,n.$nS)(N,(0,n.$)(".row"));return P.name=(0,n.$nS)(W,(0,n.$)(".nameLabel")),P}renderElement(N,P,W,ne){W.name.textContent=N.element.name}disposeTemplate(N){}}class d{constructor(){this.templateId="error"}renderTemplate(N){const P=Object.create(null),W=(0,n.$nS)(N,(0,n.$)(".row"));return P.name=(0,n.$nS)(W,(0,n.$)(".nameLabel")),P}renderElement(N,P,W,ne){W.name.textContent=N.element.errorMessage}disposeTemplate(N){}}class D{constructor(N,P,W){this.a=N,this.b=P,this.c=W,this.templateId="process"}renderTemplate(N){const P=(0,n.$nS)(N,(0,n.$)(".row")),W=(0,n.$nS)(P,(0,n.$)(".nameLabel")),ne=(0,n.$nS)(P,(0,n.$)(".cpu")),Q=(0,n.$nS)(P,(0,n.$)(".memory")),Y=(0,n.$nS)(P,(0,n.$)(".pid"));return{name:W,CPU:ne,PID:Y,memory:Q}}renderElement(N,P,W,ne){const{element:Q}=N,Y=Q.pid.toFixed(0);let te=Q.name;this.c.has(Q.pid)&&(te=this.c.get(Q.pid)),W.name.textContent=te,W.name.title=Q.cmd,W.CPU.textContent=Q.load.toFixed(0),W.PID.textContent=Y,W.PID.parentElement.id=`pid-${Y}`;const de=this.a==="win32"?Q.mem:this.b*(Q.mem/100);W.memory.textContent=(de/f.$Cl.MB).toFixed(0)}disposeTemplate(N){}}function R(U){return!!U.name&&!!U.rootProcess}function _(U){return!!U.processRoots}function H(U){return!!U.pid}class x{constructor(N,P){this.f=P,this.b=new Map;const W=new w.$1ec(N);this.c=new A.$2ec(N,W),this.k(P.styles),this.g(P),v.$O.on("vscode:pidToNameResponse",(ne,Q)=>{this.b.clear();for(const[Y,te]of Q)this.b.set(Y,te)}),v.$O.on("vscode:listProcessesResponse",async(ne,Q)=>{Q.forEach((Y,te)=>{H(Y.rootProcess)&&(Y.rootProcess.name=te===0?`${this.f.applicationName} main`:"remote agent")}),this.d?(this.d.setInput({processes:{processRoots:Q}}),this.d.layout(o.$TQ.innerHeight,o.$TQ.innerWidth)):await this.h(Q),this.m(0)}),this.a=Date.now(),v.$O.send("vscode:pidToNameRequest"),v.$O.send("vscode:listProcesses")}g(N){o.$TQ.document.onkeydown=P=>{const W=N.platform==="darwin"?P.metaKey:P.ctrlKey;W&&P.keyCode===87&&(P.stopPropagation(),P.preventDefault(),v.$O.send("vscode:closeProcessExplorer")),W&&P.keyCode===187&&(0,m.$6ec)(o.$TQ),W&&P.keyCode===189&&(0,m.$7ec)(o.$TQ)}}async h(N){const P=o.$TQ.document.getElementById("process-list");if(!P)return;const{totalmem:W}=await this.c.getOSStatistics(),ne=[new D(this.f.platform,W,this.b),new E,new r,new d];this.d=new B.$YV("processExplorer",P,new b,ne,new k,{identityProvider:{getId:Q=>H(Q)?Q.pid.toString():(0,y.$jn)(Q)?Q.hostName:_(Q)?"processes":R(Q)?Q.name:"header"}}),this.d.setInput({processes:{processRoots:N}}),this.d.layout(o.$TQ.innerHeight,o.$TQ.innerWidth),this.d.onKeyDown(Q=>{const Y=new e.$kR(Q);if(Y.keyCode===s.KeyCode.KeyE&&Y.altKey){const te=this.n();Promise.all(te.map(de=>this.c.killProcess(de,"SIGTERM"))).then(()=>this.d?.refresh())}}),this.d.onContextMenu(Q=>{H(Q.element)&&this.l(Q.element,!0)}),P.style.height=`${o.$TQ.innerHeight}px`,o.$TQ.addEventListener("resize",()=>{P.style.height=`${o.$TQ.innerHeight}px`,this.d?.layout(o.$TQ.innerHeight,o.$TQ.innerWidth)})}i(N){const P=h.exec(N);return P&&P.groups.port!=="0"||N.indexOf("node ")>=0||N.indexOf("node.exe")>=0}j(N){const P={type:"node",request:"attach",name:`process ${N.pid}`};let W=h.exec(N.cmd);W?P.port=Number(W.groups.port):P.processId=String(N.pid),W=c.exec(N.cmd),W&&(P.port=Number(W.groups.port)),v.$O.send("vscode:workbenchCommand",{id:"debug.startFromConfig",from:"processExplorer",args:[P]})}k(N){const P=(0,n.$8R)(),W=[];N.listFocusBackground&&(W.push(`.monaco-list:focus .monaco-list-row.focused { background-color: ${N.listFocusBackground}; }`),W.push(`.monaco-list:focus .monaco-list-row.focused:hover { background-color: ${N.listFocusBackground}; }`)),N.listFocusForeground&&W.push(`.monaco-list:focus .monaco-list-row.focused { color: ${N.listFocusForeground}; }`),N.listActiveSelectionBackground&&(W.push(`.monaco-list:focus .monaco-list-row.selected { background-color: ${N.listActiveSelectionBackground}; }`),W.push(`.monaco-list:focus .monaco-list-row.selected:hover { background-color: ${N.listActiveSelectionBackground}; }`)),N.listActiveSelectionForeground&&W.push(`.monaco-list:focus .monaco-list-row.selected { color: ${N.listActiveSelectionForeground}; }`),N.listHoverBackground&&W.push(`.monaco-list-row:hover:not(.selected):not(.focused) { background-color: ${N.listHoverBackground}; }`),N.listHoverForeground&&W.push(`.monaco-list-row:hover:not(.selected):not(.focused) { color: ${N.listHoverForeground}; }`),N.listFocusOutline&&W.push(`.monaco-list:focus .monaco-list-row.focused { outline: 1px solid ${N.listFocusOutline}; outline-offset: -1px; }`),N.listHoverOutline&&W.push(`.monaco-list-row:hover { outline: 1px dashed ${N.listHoverOutline}; outline-offset: -1px; }`),N.scrollbarShadowColor&&W.push(`
				.monaco-scrollable-element > .shadow.top {
					box-shadow: ${N.scrollbarShadowColor} 0 6px 6px -6px inset;
				}

				.monaco-scrollable-element > .shadow.left {
					box-shadow: ${N.scrollbarShadowColor} 6px 0 6px -6px inset;
				}

				.monaco-scrollable-element > .shadow.top.left {
					box-shadow: ${N.scrollbarShadowColor} 6px 6px 6px -6px inset;
				}
			`),N.scrollbarSliderBackgroundColor&&W.push(`
				.monaco-scrollable-element > .scrollbar > .slider {
					background: ${N.scrollbarSliderBackgroundColor};
				}
			`),N.scrollbarSliderHoverBackgroundColor&&W.push(`
				.monaco-scrollable-element > .scrollbar > .slider:hover {
					background: ${N.scrollbarSliderHoverBackgroundColor};
				}
			`),N.scrollbarSliderActiveBackgroundColor&&W.push(`
				.monaco-scrollable-element > .scrollbar > .slider.active {
					background: ${N.scrollbarSliderActiveBackgroundColor};
				}
			`),P.textContent=W.join(`
`),N.color&&(o.$TQ.document.body.style.color=N.color)}l(N,P){const W=[],ne=Number(N.pid);P&&(W.push({accelerator:"Alt+E",label:(0,i.localize)(4,null),click:()=>{this.c.killProcess(ne,"SIGTERM")}}),W.push({label:(0,i.localize)(5,null),click:()=>{this.c.killProcess(ne,"SIGKILL")}}),W.push({type:"separator"})),W.push({label:(0,i.localize)(6,null),click:()=>{const Q=this.n();Q?.includes(ne)||(Q.length=0,Q.push(ne));const Y=Q?.map(te=>o.$TQ.document.getElementById(`pid-${te}`)).filter(te=>!!te);if(Y){const te=Y.map(de=>de.innerText).filter(de=>!!de);this.c.writeClipboardText(te.join(`
`))}}}),W.push({label:(0,i.localize)(7,null),click:()=>{const Q=o.$TQ.document.getElementById("process-list");Q&&this.c.writeClipboardText(Q.innerText)}}),N&&P&&this.i(N.cmd)&&(W.push({type:"separator"}),W.push({label:(0,i.localize)(8,null),click:()=>{this.j(N)}})),(0,T.$rW)(W)}m(N){setTimeout(()=>{const P=Date.now(),W=N+P-this.a;this.a=P,W>1e3?(v.$O.send("vscode:pidToNameRequest"),v.$O.send("vscode:listProcesses")):this.m(W)},200)}n(){return this.d?.getSelection()?.map(N=>{if(!(!N||!("pid"in N)))return N.pid}).filter(N=>!!N)}}function p(){const U=(0,n.$8R)();U.id="codiconStyles";const N=(0,$.$xKb)(void 0);function P(){U.textContent=N.getCSS()}const W=new O.$Mh(P,0);N.onDidChange(()=>W.schedule()),W.schedule()}function M(U){const N=U.data.platform==="win32"?"windows":U.data.platform==="linux"?"linux":"mac";o.$TQ.document.body.classList.add(N),p(),(0,m.$5ec)(U.data.zoomLevel,o.$TQ),new x(U.windowId,U.data)}})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/fd11ed87fdf1f8e46575e027644406f51f0666f6/core/vs/code/electron-sandbox/processExplorer/processExplorerMain.js.map
