/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var se=["require","exports","vs/base/common/lifecycle","vs/base/common/types","vs/nls!vs/code/node/cliProcessMain","vs/base/common/event","vs/platform/log/common/log","vs/nls","vs/base/common/async","vs/base/common/errors","vs/platform/files/common/files","vs/platform/instantiation/common/instantiation","vs/base/common/uri","vs/base/common/platform","vs/base/common/buffer","vs/base/common/network","vs/base/common/path","vs/base/common/resources","vs/platform/environment/common/environment","vs/platform/telemetry/common/telemetry","vs/base/common/arrays","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/cancellation","vs/platform/uriIdentity/common/uriIdentity","vs/platform/userDataProfile/common/userDataProfile","vs/base/node/pfs","vs/platform/extensions/common/extensions","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/objects","vs/base/common/uuid","vs/platform/configuration/common/configuration","vs/base/common/map","vs/base/common/strings","vs/platform/product/common/productService","vs/base/common/json","os","vs/base/common/errorMessage","vs/base/common/process","vs/platform/registry/common/platform","vs/platform/policy/common/policy","vs/platform/configuration/common/configurationRegistry","vs/platform/telemetry/common/telemetryUtils","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/base/common/hash","vs/base/common/semver/semver","vs/platform/request/common/request","vs/base/common/stream","vs/base/common/marshalling","vs/base/common/ternarySearchTree","vs/base/node/zip","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","vs/platform/files/common/watcher","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/common/extensionsScannerService","vs/base/common/decorators","vs/base/common/severity","vs/base/common/processes","vs/base/node/processes","vs/base/parts/ipc/common/ipc","child_process","fs","vs/platform/download/common/download","vs/platform/files/common/io","vs/base/common/extpath","vs/platform/instantiation/common/serviceCollection","vs/base/common/iterator","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/remoteHosts","vs/platform/languagePacks/common/languagePacks","vs/platform/state/node/stateService","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/storage/common/storage","vs/base/common/amd","vs/base/common/assert","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/numbers","vs/base/common/skipList","vs/base/node/macAddress","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/base/common/console","vs/amdX","vs/base/node/id","vs/base/node/powershell","vs/base/node/shell","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLI","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/log/common/log","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/platform/contextkey/common/scanner","vs/base/common/charCode","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/contextkey/common/contextkey","vs/platform/files/node/watcher/baseWatcher","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/log/node/loggerService","vs/platform/policy/common/filePolicyService","vs/platform/policy/node/nativePolicyService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/download/common/downloadService","vs/platform/request/node/proxy","url","vs/platform/shell/node/shellEnv","vs/platform/state/node/state","vs/platform/extensionManagement/common/extensionManagementCLI","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/languagePacks/node/languagePacks","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/common/telemetryService","vs/platform/product/common/product","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/telemetry","vs/platform/telemetry/node/telemetryUtils","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userData/common/fileUserDataProvider","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/externalServices/common/serviceMachineId","vs/platform/externalServices/common/marketplace","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/userDataProfile/node/userDataProfile","vs/platform/request/node/requestService","vs/base/common/lazy","vs/base/common/marshallingIds","path","vs/base/common/glob","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/base/common/linkedList","graceful-fs","vs/platform/environment/node/argvHelper","crypto","https","vs/base/common/stopwatch","zlib","vs/code/node/cliProcessMain","vs/base/node/unc"],oe=function(Q){for(var t=[],O=0,k=Q.length;O<k;O++)t[O]=se[Q[O]];return t};define(se[75],oe([0,1]),function(Q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$U=t.$T=void 0,t.$T=!1;class O{static get(){const v=new Map,I=new Map,D=new Map,S=new Map;function m(p,y){p.has(y.detail)||p.set(y.detail,-y.timestamp)}function a(p,y){const N=p.get(y.detail);N&&(N>=0||p.set(y.detail,N+y.timestamp))}let l=[];typeof Q=="function"&&typeof Q.getStats=="function"&&(l=Q.getStats().slice(0).sort((p,y)=>p.timestamp-y.timestamp));for(const p of l)switch(p.type){case LoaderEventType.BeginLoadingScript:m(v,p);break;case LoaderEventType.EndLoadingScriptOK:case LoaderEventType.EndLoadingScriptError:a(v,p);break;case LoaderEventType.BeginInvokeFactory:m(I,p);break;case LoaderEventType.EndInvokeFactory:a(I,p);break;case LoaderEventType.NodeBeginNativeRequire:m(D,p);break;case LoaderEventType.NodeEndNativeRequire:a(D,p);break;case LoaderEventType.NodeBeginEvaluatingScript:m(S,p);break;case LoaderEventType.NodeEndEvaluatingScript:a(S,p);break}let c=0;D.forEach(p=>c+=p);function f(p){const y=[];return p.forEach((N,g)=>y.push([g,N])),y}return{amdLoad:f(v),amdInvoke:f(I),nodeRequire:f(D),nodeEval:f(S),nodeRequireTotal:c}}static toMarkdownTable(v,I){let D="";const S=[];return v.forEach((m,a)=>{S[a]=m.length}),I.forEach(m=>{m.forEach((a,l)=>{typeof a>"u"&&(a=m[l]="-");const c=a.toString().length;S[l]=Math.max(c,S[l])})}),v.forEach((m,a)=>{D+=`| ${m+" ".repeat(S[a]-m.toString().length)} `}),D+=`|
`,v.forEach((m,a)=>{D+=`| ${"-".repeat(S[a])} `}),D+=`|
`,I.forEach(m=>{m.forEach((a,l)=>{typeof a<"u"&&(D+=`| ${a+" ".repeat(S[l]-a.toString().length)} `)}),D+=`|
`}),D}}t.$U=O}),define(se[55],oe([0,1]),function(Q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$5h=k,t.$6h=v,t.$7h=I;function O(D){return(S,m,a)=>{let l=null,c=null;if(typeof a.value=="function"?(l="value",c=a.value):typeof a.get=="function"&&(l="get",c=a.get),!c)throw new Error("not supported");a[l]=D(c,m)}}function k(D,S,m){let a=null,l=null;if(typeof m.value=="function"?(a="value",l=m.value,l.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof m.get=="function"&&(a="get",l=m.get),!l)throw new Error("not supported");const c=`$memoize$${S}`;m[a]=function(...f){return this.hasOwnProperty(c)||Object.defineProperty(this,c,{configurable:!1,enumerable:!1,writable:!1,value:l.apply(this,f)}),this[c]}}function v(D,S,m){return O((a,l)=>{const c=`$debounce$${l}`,f=`$debounce$result$${l}`;return function(...p){this[f]||(this[f]=m?m():void 0),clearTimeout(this[c]),S&&(this[f]=S(this[f],...p),p=[this[f]]),this[c]=setTimeout(()=>{a.apply(this,p),this[f]=m?m():void 0},D)}})}function I(D,S,m){return O((a,l)=>{const c=`$throttle$timer$${l}`,f=`$throttle$result$${l}`,p=`$throttle$lastRun$${l}`,y=`$throttle$pending$${l}`;return function(...N){if(this[f]||(this[f]=m?m():void 0),(this[p]===null||this[p]===void 0)&&(this[p]=-Number.MAX_VALUE),S&&(this[f]=S(this[f],...N)),this[y])return;const g=this[p]+D;g<=Date.now()?(this[p]=Date.now(),a.apply(this,[this[f]]),this[f]=m?m():void 0):(this[y]=!0,this[c]=setTimeout(()=>{this[y]=!1,this[p]=Date.now(),a.apply(this,[this[f]]),this[f]=m?m():void 0},g-Date.now()))}})}}),define(se[76],oe([0,1,9]),function(Q,t,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ok=k,t.$ed=v,t.$fd=I,t.$gd=D,t.$hd=S,t.$id=m;function k(a,l){if(!a)throw new Error(l?`Assertion failed (${l})`:"Assertion Failed")}function v(a,l="Unreachable"){throw new Error(l)}function I(a,l="unexpected state"){if(!a)throw new O.$cb(`Assertion Failed: ${l}`)}function D(a){a||(0,O.$1)(new O.$cb("Soft Assertion Failed"))}function S(a){if(!a()){debugger;a(),(0,O.$1)(new O.$cb("Assertion Failed"))}}function m(a,l){let c=0;for(;c<a.length-1;){const f=a[c],p=a[c+1];if(!l(f,p))return!1;c++}return!0}}),define(se[34],oe([0,1]),function(Q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ParseOptions=t.ParseErrorCode=t.SyntaxKind=t.ScanError=void 0,t.$Nn=D,t.$On=c,t.$Pn=f,t.$Qn=p,t.$Rn=y,t.$Sn=N,t.$Tn=g,t.$Un=d,t.$Vn=$,t.$Wn=P,t.$Xn=w,t.$Yn=u;var O;(function(i){i[i.None=0]="None",i[i.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=2]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",i[i.InvalidUnicode=4]="InvalidUnicode",i[i.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",i[i.InvalidCharacter=6]="InvalidCharacter"})(O||(t.ScanError=O={}));var k;(function(i){i[i.OpenBraceToken=1]="OpenBraceToken",i[i.CloseBraceToken=2]="CloseBraceToken",i[i.OpenBracketToken=3]="OpenBracketToken",i[i.CloseBracketToken=4]="CloseBracketToken",i[i.CommaToken=5]="CommaToken",i[i.ColonToken=6]="ColonToken",i[i.NullKeyword=7]="NullKeyword",i[i.TrueKeyword=8]="TrueKeyword",i[i.FalseKeyword=9]="FalseKeyword",i[i.StringLiteral=10]="StringLiteral",i[i.NumericLiteral=11]="NumericLiteral",i[i.LineCommentTrivia=12]="LineCommentTrivia",i[i.BlockCommentTrivia=13]="BlockCommentTrivia",i[i.LineBreakTrivia=14]="LineBreakTrivia",i[i.Trivia=15]="Trivia",i[i.Unknown=16]="Unknown",i[i.EOF=17]="EOF"})(k||(t.SyntaxKind=k={}));var v;(function(i){i[i.InvalidSymbol=1]="InvalidSymbol",i[i.InvalidNumberFormat=2]="InvalidNumberFormat",i[i.PropertyNameExpected=3]="PropertyNameExpected",i[i.ValueExpected=4]="ValueExpected",i[i.ColonExpected=5]="ColonExpected",i[i.CommaExpected=6]="CommaExpected",i[i.CloseBraceExpected=7]="CloseBraceExpected",i[i.CloseBracketExpected=8]="CloseBracketExpected",i[i.EndOfFileExpected=9]="EndOfFileExpected",i[i.InvalidCommentToken=10]="InvalidCommentToken",i[i.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=12]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",i[i.InvalidUnicode=14]="InvalidUnicode",i[i.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",i[i.InvalidCharacter=16]="InvalidCharacter"})(v||(t.ParseErrorCode=v={}));var I;(function(i){i.DEFAULT={allowTrailingComma:!0}})(I||(t.ParseOptions=I={}));function D(i,o=!1){let s=0;const e=i.length;let n="",r=0,h=k.Unknown,E=O.None;function R(ie){let ce=0,ue=0;for(;ce<ie;){const le=i.charCodeAt(s);if(le>=l._0&&le<=l._9)ue=ue*16+le-l._0;else if(le>=l.A&&le<=l.F)ue=ue*16+le-l.A+10;else if(le>=l.a&&le<=l.f)ue=ue*16+le-l.a+10;else break;s++,ce++}return ce<ie&&(ue=-1),ue}function A(ie){s=ie,n="",r=0,h=k.Unknown,E=O.None}function T(){const ie=s;if(i.charCodeAt(s)===l._0)s++;else for(s++;s<i.length&&a(i.charCodeAt(s));)s++;if(s<i.length&&i.charCodeAt(s)===l.dot)if(s++,s<i.length&&a(i.charCodeAt(s)))for(s++;s<i.length&&a(i.charCodeAt(s));)s++;else return E=O.UnexpectedEndOfNumber,i.substring(ie,s);let ce=s;if(s<i.length&&(i.charCodeAt(s)===l.E||i.charCodeAt(s)===l.e))if(s++,(s<i.length&&i.charCodeAt(s)===l.plus||i.charCodeAt(s)===l.minus)&&s++,s<i.length&&a(i.charCodeAt(s))){for(s++;s<i.length&&a(i.charCodeAt(s));)s++;ce=s}else E=O.UnexpectedEndOfNumber;return i.substring(ie,ce)}function C(){let ie="",ce=s;for(;;){if(s>=e){ie+=i.substring(ce,s),E=O.UnexpectedEndOfString;break}const ue=i.charCodeAt(s);if(ue===l.doubleQuote){ie+=i.substring(ce,s),s++;break}if(ue===l.backslash){if(ie+=i.substring(ce,s),s++,s>=e){E=O.UnexpectedEndOfString;break}switch(i.charCodeAt(s++)){case l.doubleQuote:ie+='"';break;case l.backslash:ie+="\\";break;case l.slash:ie+="/";break;case l.b:ie+="\b";break;case l.f:ie+="\f";break;case l.n:ie+=`
`;break;case l.r:ie+="\r";break;case l.t:ie+="	";break;case l.u:{const x=R(4);x>=0?ie+=String.fromCharCode(x):E=O.InvalidUnicode;break}default:E=O.InvalidEscapeCharacter}ce=s;continue}if(ue>=0&&ue<=31)if(m(ue)){ie+=i.substring(ce,s),E=O.UnexpectedEndOfString;break}else E=O.InvalidCharacter;s++}return ie}function M(){if(n="",E=O.None,r=s,s>=e)return r=e,h=k.EOF;let ie=i.charCodeAt(s);if(S(ie)){do s++,n+=String.fromCharCode(ie),ie=i.charCodeAt(s);while(S(ie));return h=k.Trivia}if(m(ie))return s++,n+=String.fromCharCode(ie),ie===l.carriageReturn&&i.charCodeAt(s)===l.lineFeed&&(s++,n+=`
`),h=k.LineBreakTrivia;switch(ie){case l.openBrace:return s++,h=k.OpenBraceToken;case l.closeBrace:return s++,h=k.CloseBraceToken;case l.openBracket:return s++,h=k.OpenBracketToken;case l.closeBracket:return s++,h=k.CloseBracketToken;case l.colon:return s++,h=k.ColonToken;case l.comma:return s++,h=k.CommaToken;case l.doubleQuote:return s++,n=C(),h=k.StringLiteral;case l.slash:{const ce=s-1;if(i.charCodeAt(s+1)===l.slash){for(s+=2;s<e&&!m(i.charCodeAt(s));)s++;return n=i.substring(ce,s),h=k.LineCommentTrivia}if(i.charCodeAt(s+1)===l.asterisk){s+=2;const ue=e-1;let le=!1;for(;s<ue;){if(i.charCodeAt(s)===l.asterisk&&i.charCodeAt(s+1)===l.slash){s+=2,le=!0;break}s++}return le||(s++,E=O.UnexpectedEndOfComment),n=i.substring(ce,s),h=k.BlockCommentTrivia}return n+=String.fromCharCode(ie),s++,h=k.Unknown}case l.minus:if(n+=String.fromCharCode(ie),s++,s===e||!a(i.charCodeAt(s)))return h=k.Unknown;case l._0:case l._1:case l._2:case l._3:case l._4:case l._5:case l._6:case l._7:case l._8:case l._9:return n+=T(),h=k.NumericLiteral;default:for(;s<e&&J(ie);)s++,ie=i.charCodeAt(s);if(r!==s){switch(n=i.substring(r,s),n){case"true":return h=k.TrueKeyword;case"false":return h=k.FalseKeyword;case"null":return h=k.NullKeyword}return h=k.Unknown}return n+=String.fromCharCode(ie),s++,h=k.Unknown}}function J(ie){if(S(ie)||m(ie))return!1;switch(ie){case l.closeBrace:case l.closeBracket:case l.openBrace:case l.openBracket:case l.doubleQuote:case l.colon:case l.comma:case l.slash:return!1}return!0}function ae(){let ie;do ie=M();while(ie>=k.LineCommentTrivia&&ie<=k.Trivia);return ie}return{setPosition:A,getPosition:()=>s,scan:o?ae:M,getToken:()=>h,getTokenValue:()=>n,getTokenOffset:()=>r,getTokenLength:()=>s-r,getTokenError:()=>E}}function S(i){return i===l.space||i===l.tab||i===l.verticalTab||i===l.formFeed||i===l.nonBreakingSpace||i===l.ogham||i>=l.enQuad&&i<=l.zeroWidthSpace||i===l.narrowNoBreakSpace||i===l.mathematicalSpace||i===l.ideographicSpace||i===l.byteOrderMark}function m(i){return i===l.lineFeed||i===l.carriageReturn||i===l.lineSeparator||i===l.paragraphSeparator}function a(i){return i>=l._0&&i<=l._9}var l;(function(i){i[i.nullCharacter=0]="nullCharacter",i[i.maxAsciiCharacter=127]="maxAsciiCharacter",i[i.lineFeed=10]="lineFeed",i[i.carriageReturn=13]="carriageReturn",i[i.lineSeparator=8232]="lineSeparator",i[i.paragraphSeparator=8233]="paragraphSeparator",i[i.nextLine=133]="nextLine",i[i.space=32]="space",i[i.nonBreakingSpace=160]="nonBreakingSpace",i[i.enQuad=8192]="enQuad",i[i.emQuad=8193]="emQuad",i[i.enSpace=8194]="enSpace",i[i.emSpace=8195]="emSpace",i[i.threePerEmSpace=8196]="threePerEmSpace",i[i.fourPerEmSpace=8197]="fourPerEmSpace",i[i.sixPerEmSpace=8198]="sixPerEmSpace",i[i.figureSpace=8199]="figureSpace",i[i.punctuationSpace=8200]="punctuationSpace",i[i.thinSpace=8201]="thinSpace",i[i.hairSpace=8202]="hairSpace",i[i.zeroWidthSpace=8203]="zeroWidthSpace",i[i.narrowNoBreakSpace=8239]="narrowNoBreakSpace",i[i.ideographicSpace=12288]="ideographicSpace",i[i.mathematicalSpace=8287]="mathematicalSpace",i[i.ogham=5760]="ogham",i[i._=95]="_",i[i.$=36]="$",i[i._0=48]="_0",i[i._1=49]="_1",i[i._2=50]="_2",i[i._3=51]="_3",i[i._4=52]="_4",i[i._5=53]="_5",i[i._6=54]="_6",i[i._7=55]="_7",i[i._8=56]="_8",i[i._9=57]="_9",i[i.a=97]="a",i[i.b=98]="b",i[i.c=99]="c",i[i.d=100]="d",i[i.e=101]="e",i[i.f=102]="f",i[i.g=103]="g",i[i.h=104]="h",i[i.i=105]="i",i[i.j=106]="j",i[i.k=107]="k",i[i.l=108]="l",i[i.m=109]="m",i[i.n=110]="n",i[i.o=111]="o",i[i.p=112]="p",i[i.q=113]="q",i[i.r=114]="r",i[i.s=115]="s",i[i.t=116]="t",i[i.u=117]="u",i[i.v=118]="v",i[i.w=119]="w",i[i.x=120]="x",i[i.y=121]="y",i[i.z=122]="z",i[i.A=65]="A",i[i.B=66]="B",i[i.C=67]="C",i[i.D=68]="D",i[i.E=69]="E",i[i.F=70]="F",i[i.G=71]="G",i[i.H=72]="H",i[i.I=73]="I",i[i.J=74]="J",i[i.K=75]="K",i[i.L=76]="L",i[i.M=77]="M",i[i.N=78]="N",i[i.O=79]="O",i[i.P=80]="P",i[i.Q=81]="Q",i[i.R=82]="R",i[i.S=83]="S",i[i.T=84]="T",i[i.U=85]="U",i[i.V=86]="V",i[i.W=87]="W",i[i.X=88]="X",i[i.Y=89]="Y",i[i.Z=90]="Z",i[i.ampersand=38]="ampersand",i[i.asterisk=42]="asterisk",i[i.at=64]="at",i[i.backslash=92]="backslash",i[i.bar=124]="bar",i[i.caret=94]="caret",i[i.closeBrace=125]="closeBrace",i[i.closeBracket=93]="closeBracket",i[i.closeParen=41]="closeParen",i[i.colon=58]="colon",i[i.comma=44]="comma",i[i.dot=46]="dot",i[i.doubleQuote=34]="doubleQuote",i[i.equals=61]="equals",i[i.exclamation=33]="exclamation",i[i.greaterThan=62]="greaterThan",i[i.lessThan=60]="lessThan",i[i.minus=45]="minus",i[i.openBrace=123]="openBrace",i[i.openBracket=91]="openBracket",i[i.openParen=40]="openParen",i[i.percent=37]="percent",i[i.plus=43]="plus",i[i.question=63]="question",i[i.semicolon=59]="semicolon",i[i.singleQuote=39]="singleQuote",i[i.slash=47]="slash",i[i.tilde=126]="tilde",i[i.backspace=8]="backspace",i[i.formFeed=12]="formFeed",i[i.byteOrderMark=65279]="byteOrderMark",i[i.tab=9]="tab",i[i.verticalTab=11]="verticalTab"})(l||(l={}));function c(i,o){const s=[],e=new Object;let n;const r={value:{},offset:0,length:0,type:"object",parent:void 0};let h=!1;function E(R,A,T,C){r.value=R,r.offset=A,r.length=T,r.type=C,r.colonOffset=void 0,n=r}try{P(i,{onObjectBegin:(R,A)=>{if(o<=R)throw e;n=void 0,h=o>R,s.push("")},onObjectProperty:(R,A,T)=>{if(o<A||(E(R,A,T,"property"),s[s.length-1]=R,o<=A+T))throw e},onObjectEnd:(R,A)=>{if(o<=R)throw e;n=void 0,s.pop()},onArrayBegin:(R,A)=>{if(o<=R)throw e;n=void 0,s.push(0)},onArrayEnd:(R,A)=>{if(o<=R)throw e;n=void 0,s.pop()},onLiteralValue:(R,A,T)=>{if(o<A||(E(R,A,T,u(R)),o<=A+T))throw e},onSeparator:(R,A,T)=>{if(o<=A)throw e;if(R===":"&&n&&n.type==="property")n.colonOffset=A,h=!1,n=void 0;else if(R===","){const C=s[s.length-1];typeof C=="number"?s[s.length-1]=C+1:(h=!0,s[s.length-1]=""),n=void 0}}})}catch(R){if(R!==e)throw R}return{path:s,previousNode:n,isAtPropertyKey:h,matches:R=>{let A=0;for(let T=0;A<R.length&&T<s.length;T++)if(R[A]===s[T]||R[A]==="*")A++;else if(R[A]!=="**")return!1;return A===R.length}}}function f(i,o=[],s=I.DEFAULT){let e=null,n=[];const r=[];function h(R){Array.isArray(n)?n.push(R):e!==null&&(n[e]=R)}return P(i,{onObjectBegin:()=>{const R={};h(R),r.push(n),n=R,e=null},onObjectProperty:R=>{e=R},onObjectEnd:()=>{n=r.pop()},onArrayBegin:()=>{const R=[];h(R),r.push(n),n=R,e=null},onArrayEnd:()=>{n=r.pop()},onLiteralValue:h,onError:(R,A,T)=>{o.push({error:R,offset:A,length:T})}},s),n[0]}function p(i,o=[],s=I.DEFAULT){let e={type:"array",offset:-1,length:-1,children:[],parent:void 0};function n(R){e.type==="property"&&(e.length=R-e.offset,e=e.parent)}function r(R){return e.children.push(R),R}P(i,{onObjectBegin:R=>{e=r({type:"object",offset:R,length:-1,parent:e,children:[]})},onObjectProperty:(R,A,T)=>{e=r({type:"property",offset:A,length:-1,parent:e,children:[]}),e.children.push({type:"string",value:R,offset:A,length:T,parent:e})},onObjectEnd:(R,A)=>{e.length=R+A-e.offset,e=e.parent,n(R+A)},onArrayBegin:(R,A)=>{e=r({type:"array",offset:R,length:-1,parent:e,children:[]})},onArrayEnd:(R,A)=>{e.length=R+A-e.offset,e=e.parent,n(R+A)},onLiteralValue:(R,A,T)=>{r({type:u(R),offset:A,length:T,parent:e,value:R}),n(A+T)},onSeparator:(R,A,T)=>{e.type==="property"&&(R===":"?e.colonOffset=A:R===","&&n(A))},onError:(R,A,T)=>{o.push({error:R,offset:A,length:T})}},s);const E=e.children[0];return E&&delete E.parent,E}function y(i,o){if(!i)return;let s=i;for(const e of o)if(typeof e=="string"){if(s.type!=="object"||!Array.isArray(s.children))return;let n=!1;for(const r of s.children)if(Array.isArray(r.children)&&r.children[0].value===e){s=r.children[1],n=!0;break}if(!n)return}else{const n=e;if(s.type!=="array"||n<0||!Array.isArray(s.children)||n>=s.children.length)return;s=s.children[n]}return s}function N(i){if(!i.parent||!i.parent.children)return[];const o=N(i.parent);if(i.parent.type==="property"){const s=i.parent.children[0].value;o.push(s)}else if(i.parent.type==="array"){const s=i.parent.children.indexOf(i);s!==-1&&o.push(s)}return o}function g(i){switch(i.type){case"array":return i.children.map(g);case"object":{const o=Object.create(null);for(const s of i.children){const e=s.children[1];e&&(o[s.children[0].value]=g(e))}return o}case"null":case"string":case"number":case"boolean":return i.value;default:return}}function d(i,o,s=!1){return o>=i.offset&&o<i.offset+i.length||s&&o===i.offset+i.length}function $(i,o,s=!1){if(d(i,o,s)){const e=i.children;if(Array.isArray(e))for(let n=0;n<e.length&&e[n].offset<=o;n++){const r=$(e[n],o,s);if(r)return r}return i}}function P(i,o,s=I.DEFAULT){const e=D(i,!1);function n(Y){return Y?()=>Y(e.getTokenOffset(),e.getTokenLength()):()=>!0}function r(Y){return Y?F=>Y(F,e.getTokenOffset(),e.getTokenLength()):()=>!0}const h=n(o.onObjectBegin),E=r(o.onObjectProperty),R=n(o.onObjectEnd),A=n(o.onArrayBegin),T=n(o.onArrayEnd),C=r(o.onLiteralValue),M=r(o.onSeparator),J=n(o.onComment),ae=r(o.onError),ie=s&&s.disallowComments,ce=s&&s.allowTrailingComma;function ue(){for(;;){const Y=e.scan();switch(e.getTokenError()){case O.InvalidUnicode:le(v.InvalidUnicode);break;case O.InvalidEscapeCharacter:le(v.InvalidEscapeCharacter);break;case O.UnexpectedEndOfNumber:le(v.UnexpectedEndOfNumber);break;case O.UnexpectedEndOfComment:ie||le(v.UnexpectedEndOfComment);break;case O.UnexpectedEndOfString:le(v.UnexpectedEndOfString);break;case O.InvalidCharacter:le(v.InvalidCharacter);break}switch(Y){case k.LineCommentTrivia:case k.BlockCommentTrivia:ie?le(v.InvalidCommentToken):J();break;case k.Unknown:le(v.InvalidSymbol);break;case k.Trivia:case k.LineBreakTrivia:break;default:return Y}}}function le(Y,F=[],z=[]){if(ae(Y),F.length+z.length>0){let H=e.getToken();for(;H!==k.EOF;){if(F.indexOf(H)!==-1){ue();break}else if(z.indexOf(H)!==-1)break;H=ue()}}}function x(Y){const F=e.getTokenValue();return Y?C(F):E(F),ue(),!0}function _(){switch(e.getToken()){case k.NumericLiteral:{let Y=0;try{Y=JSON.parse(e.getTokenValue()),typeof Y!="number"&&(le(v.InvalidNumberFormat),Y=0)}catch{le(v.InvalidNumberFormat)}C(Y);break}case k.NullKeyword:C(null);break;case k.TrueKeyword:C(!0);break;case k.FalseKeyword:C(!1);break;default:return!1}return ue(),!0}function B(){return e.getToken()!==k.StringLiteral?(le(v.PropertyNameExpected,[],[k.CloseBraceToken,k.CommaToken]),!1):(x(!1),e.getToken()===k.ColonToken?(M(":"),ue(),Z()||le(v.ValueExpected,[],[k.CloseBraceToken,k.CommaToken])):le(v.ColonExpected,[],[k.CloseBraceToken,k.CommaToken]),!0)}function U(){h(),ue();let Y=!1;for(;e.getToken()!==k.CloseBraceToken&&e.getToken()!==k.EOF;){if(e.getToken()===k.CommaToken){if(Y||le(v.ValueExpected,[],[]),M(","),ue(),e.getToken()===k.CloseBraceToken&&ce)break}else Y&&le(v.CommaExpected,[],[]);B()||le(v.ValueExpected,[],[k.CloseBraceToken,k.CommaToken]),Y=!0}return R(),e.getToken()!==k.CloseBraceToken?le(v.CloseBraceExpected,[k.CloseBraceToken],[]):ue(),!0}function G(){A(),ue();let Y=!1;for(;e.getToken()!==k.CloseBracketToken&&e.getToken()!==k.EOF;){if(e.getToken()===k.CommaToken){if(Y||le(v.ValueExpected,[],[]),M(","),ue(),e.getToken()===k.CloseBracketToken&&ce)break}else Y&&le(v.CommaExpected,[],[]);Z()||le(v.ValueExpected,[],[k.CloseBracketToken,k.CommaToken]),Y=!0}return T(),e.getToken()!==k.CloseBracketToken?le(v.CloseBracketExpected,[k.CloseBracketToken],[]):ue(),!0}function Z(){switch(e.getToken()){case k.OpenBracketToken:return G();case k.OpenBraceToken:return U();case k.StringLiteral:return x(!0);default:return _()}}return ue(),e.getToken()===k.EOF?s.allowEmptyContent?!0:(le(v.ValueExpected,[],[]),!1):Z()?(e.getToken()!==k.EOF&&le(v.EndOfFileExpected,[],[]),!0):(le(v.ValueExpected,[],[]),!1)}function w(i,o){const s=D(i),e=[];let n,r=0,h;do switch(h=s.getPosition(),n=s.scan(),n){case k.LineCommentTrivia:case k.BlockCommentTrivia:case k.EOF:r!==h&&e.push(i.substring(r,h)),o!==void 0&&e.push(s.getTokenValue().replace(/[^\r\n]/g,o)),r=s.getPosition();break}while(n!==k.EOF);return e.join("")}function u(i){switch(typeof i){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(i){if(Array.isArray(i))return"array"}else return"null";return"object"}default:return"null"}}}),define(se[77],oe([0,1,34]),function(Q,t,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Zn=k,t.$1n=v,t.$2n=S,t.$3n=m;function k(a,l,c){let f,p,y,N,g;if(l){for(N=l.offset,g=N+l.length,y=N;y>0&&!m(a,y-1);)y--;let h=g;for(;h<a.length&&!m(a,h);)h++;p=a.substring(y,h),f=D(p,c)}else p=a,f=0,y=0,N=0,g=a.length;const d=S(c,a);let $=!1,P=0,w;c.insertSpaces?w=I(" ",c.tabSize||4):w="	";const u=(0,O.$Nn)(p,!1);let i=!1;function o(){return d+I(w,f+P)}function s(){let h=u.scan();for($=!1;h===O.SyntaxKind.Trivia||h===O.SyntaxKind.LineBreakTrivia;)$=$||h===O.SyntaxKind.LineBreakTrivia,h=u.scan();return i=h===O.SyntaxKind.Unknown||u.getTokenError()!==O.ScanError.None,h}const e=[];function n(h,E,R){!i&&E<g&&R>N&&a.substring(E,R)!==h&&e.push({offset:E,length:R-E,content:h})}let r=s();if(r!==O.SyntaxKind.EOF){const h=u.getTokenOffset()+y,E=I(w,f);n(E,y,h)}for(;r!==O.SyntaxKind.EOF;){let h=u.getTokenOffset()+u.getTokenLength()+y,E=s(),R="";for(;!$&&(E===O.SyntaxKind.LineCommentTrivia||E===O.SyntaxKind.BlockCommentTrivia);){const T=u.getTokenOffset()+y;n(" ",h,T),h=u.getTokenOffset()+u.getTokenLength()+y,R=E===O.SyntaxKind.LineCommentTrivia?o():"",E=s()}if(E===O.SyntaxKind.CloseBraceToken)r!==O.SyntaxKind.OpenBraceToken&&(P--,R=o());else if(E===O.SyntaxKind.CloseBracketToken)r!==O.SyntaxKind.OpenBracketToken&&(P--,R=o());else{switch(r){case O.SyntaxKind.OpenBracketToken:case O.SyntaxKind.OpenBraceToken:P++,R=o();break;case O.SyntaxKind.CommaToken:case O.SyntaxKind.LineCommentTrivia:R=o();break;case O.SyntaxKind.BlockCommentTrivia:$?R=o():R=" ";break;case O.SyntaxKind.ColonToken:R=" ";break;case O.SyntaxKind.StringLiteral:if(E===O.SyntaxKind.ColonToken){R="";break}case O.SyntaxKind.NullKeyword:case O.SyntaxKind.TrueKeyword:case O.SyntaxKind.FalseKeyword:case O.SyntaxKind.NumericLiteral:case O.SyntaxKind.CloseBraceToken:case O.SyntaxKind.CloseBracketToken:E===O.SyntaxKind.LineCommentTrivia||E===O.SyntaxKind.BlockCommentTrivia?R=" ":E!==O.SyntaxKind.CommaToken&&E!==O.SyntaxKind.EOF&&(i=!0);break;case O.SyntaxKind.Unknown:i=!0;break}$&&(E===O.SyntaxKind.LineCommentTrivia||E===O.SyntaxKind.BlockCommentTrivia)&&(R=o())}const A=u.getTokenOffset()+y;n(R,h,A),r=E}return e}function v(a,l){const c=JSON.stringify(a,void 0,l.insertSpaces?l.tabSize||4:"	");return l.eol!==void 0?c.replace(/\r\n|\r|\n/g,l.eol):c}function I(a,l){let c="";for(let f=0;f<l;f++)c+=a;return c}function D(a,l){let c=0,f=0;const p=l.tabSize||4;for(;c<a.length;){const y=a.charAt(c);if(y===" ")f++;else if(y==="	")f+=p;else break;c++}return Math.floor(f/p)}function S(a,l){for(let c=0;c<l.length;c++){const f=l.charAt(c);if(f==="\r")return c+1<l.length&&l.charAt(c+1)===`
`?`\r
`:"\r";if(f===`
`)return`
`}return a&&a.eol||`
`}function m(a,l){return`\r
`.indexOf(a.charAt(l))!==-1}}),define(se[78],oe([0,1,34,77]),function(Q,t,O,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$4n=v,t.$5n=I,t.$6n=D,t.$7n=S,t.$8n=m;function v(a,l,c){return I(a,l,void 0,c)}function I(a,l,c,f,p){const y=l.slice(),N=[],g=(0,O.$Qn)(a,N);let d,$;for(;y.length>0&&($=y.pop(),d=(0,O.$Rn)(g,y),d===void 0&&c!==void 0);)typeof $=="string"?c={[$]:c}:c=[c];if(d)if(d.type==="object"&&typeof $=="string"&&Array.isArray(d.children)){const P=(0,O.$Rn)(d,[$]);if(P!==void 0)if(c===void 0){if(!P.parent)throw new Error("Malformed AST");const w=d.children.indexOf(P.parent);let u,i=P.parent.offset+P.parent.length;if(w>0){const o=d.children[w-1];u=o.offset+o.length}else u=d.offset+1,d.children.length>1&&(i=d.children[1].offset);return D(a,{offset:u,length:i-u,content:""},f)}else return D(a,{offset:P.offset,length:P.length,content:JSON.stringify(c)},f);else{if(c===void 0)return[];const w=`${JSON.stringify($)}: ${JSON.stringify(c)}`,u=p?p(d.children.map(o=>o.children[0].value)):d.children.length;let i;if(u>0){const o=d.children[u-1];i={offset:o.offset+o.length,length:0,content:","+w}}else d.children.length===0?i={offset:d.offset+1,length:0,content:w}:i={offset:d.offset+1,length:0,content:w+","};return D(a,i,f)}}else if(d.type==="array"&&typeof $=="number"&&Array.isArray(d.children))if(c!==void 0){const P=`${JSON.stringify(c)}`;let w;if(d.children.length===0||$===0)w={offset:d.offset+1,length:0,content:d.children.length===0?P:P+","};else{const u=$===-1||$>d.children.length?d.children.length:$,i=d.children[u-1];w={offset:i.offset+i.length,length:0,content:","+P}}return D(a,w,f)}else{const P=$,w=d.children[P];let u;if(d.children.length===1)u={offset:d.offset+1,length:d.length-2,content:""};else if(d.children.length-1===P){const i=d.children[P-1],o=i.offset+i.length,s=d.offset+d.length;u={offset:o,length:s-2-o,content:""}}else u={offset:w.offset,length:d.children[P+1].offset-w.offset,content:""};return D(a,u,f)}else throw new Error(`Can not add ${typeof $!="number"?"index":"property"} to parent of type ${d.type}`);else return c===void 0?[]:D(a,{offset:g?g.offset:0,length:g?g.length:0,content:JSON.stringify(c)},f)}function D(a,l,c){let f=S(a,l),p=l.offset,y=l.offset+l.content.length;if(l.length===0||l.content.length===0){for(;p>0&&!(0,k.$3n)(f,p-1);)p--;for(;y<f.length&&!(0,k.$3n)(f,y);)y++}const N=(0,k.$Zn)(f,{offset:p,length:y-p},c);for(let d=N.length-1;d>=0;d--){const $=N[d];f=S(f,$),p=Math.min(p,$.offset),y=Math.max(y,$.offset+$.length),y+=$.content.length-$.length}const g=a.length-(f.length-y)-p;return[{offset:p,length:g,content:f.substring(p,y)}]}function S(a,l){return a.substring(0,l.offset)+l.content+a.substring(l.offset+l.length)}function m(a,l){const c=l.slice(0).sort((p,y)=>{const N=p.offset-y.offset;return N===0?p.length-y.length:N});let f=a.length;for(let p=c.length-1;p>=0;p--){const y=c[p];if(y.offset+y.length<=f)a=S(a,y);else throw new Error("Overlapping edit");f=y.offset}return a}}),define(se[79],oe([0,1]),function(Q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Km=t.$Jm=t.$Im=void 0,t.$Gm=O,t.rot=k;function O(S,m,a){return Math.min(Math.max(S,m),a)}function k(S,m){return(m+S%m)%m}class v{constructor(){this.a=0}getNext(){return this.a++}}t.$Im=v;class I{constructor(){this.a=1,this.b=0}update(m){return this.b=this.b+(m-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}t.$Jm=I;class D{constructor(m){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(m),this.c.fill(0,0,m)}update(m){const a=this.c[this.d];return this.c[this.d]=m,this.d=(this.d+1)%this.c.length,this.e-=a,this.e+=m,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}t.$Km=D}),function(){function Q(v){const I=[];typeof v=="number"&&I.push("code/timeOrigin",v);function D(m){I.push(m,Date.now())}function S(){const m=[];for(let a=0;a<I.length;a+=2)m.push({name:I[a],startTime:I[a+1]});return m}return{mark:D,getMarks:S}}function t(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?Q():{mark(v){performance.mark(v)},getMarks(){let v=performance.timeOrigin;typeof v!="number"&&(v=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const I=[{name:"code/timeOrigin",startTime:Math.round(v)}];for(const D of performance.getEntriesByType("mark"))I.push({name:D.name,startTime:Math.round(v+D.startTime)});return I}};if(typeof process=="object"){const v=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return Q(v)}else return console.trace("perf-util loaded in UNKNOWN environment"),Q()}function O(v){return v.MonacoPerformanceMarks||(v.MonacoPerformanceMarks=t()),v.MonacoPerformanceMarks}var k;typeof global=="object"?k=global:typeof self=="object"?k=self:k={},typeof define=="function"?define("vs/base/common/performance",[],function(){return O(k)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=O(k):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),k.perf=O(k))}(),function(Q,t){if(typeof exports=="object"&&typeof module=="object")module.exports=t();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],t);else{var O=t();for(var k in O)(typeof exports=="object"?exports:Q)[k]=O[k]}}(typeof self<"u"?self:this,function(){return function(Q){var t={};function O(k){if(t[k])return t[k].exports;var v=t[k]={i:k,l:!1,exports:{}};return Q[k].call(v.exports,v,v.exports,O),v.l=!0,v.exports}return O.m=Q,O.c=t,O.d=function(k,v,I){O.o(k,v)||Object.defineProperty(k,v,{enumerable:!0,get:I})},O.r=function(k){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(k,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(k,"__esModule",{value:!0})},O.t=function(k,v){if(1&v&&(k=O(k)),8&v||4&v&&typeof k=="object"&&k&&k.__esModule)return k;var I=Object.create(null);if(O.r(I),Object.defineProperty(I,"default",{enumerable:!0,value:k}),2&v&&typeof k!="string")for(var D in k)O.d(I,D,function(S){return k[S]}.bind(null,D));return I},O.n=function(k){var v=k&&k.__esModule?function(){return k.default}:function(){return k};return O.d(v,"a",v),v},O.o=function(k,v){return Object.prototype.hasOwnProperty.call(k,v)},O.p="",O(O.s=0)}([function(Q,t,O){(function(k){var v;t=Q.exports=z,v=typeof k=="object"&&k.env&&k.env.NODE_DEBUG&&/\bsemver\b/i.test(k.env.NODE_DEBUG)?function(){var W=Array.prototype.slice.call(arguments,0);W.unshift("SEMVER"),console.log.apply(console,W)}:function(){},t.SEMVER_SPEC_VERSION="2.0.0";var I=256,D=Number.MAX_SAFE_INTEGER||9007199254740991,S=t.re=[],m=t.src=[],a=0,l=a++;m[l]="0|[1-9]\\d*";var c=a++;m[c]="[0-9]+";var f=a++;m[f]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var p=a++;m[p]="("+m[l]+")\\.("+m[l]+")\\.("+m[l]+")";var y=a++;m[y]="("+m[c]+")\\.("+m[c]+")\\.("+m[c]+")";var N=a++;m[N]="(?:"+m[l]+"|"+m[f]+")";var g=a++;m[g]="(?:"+m[c]+"|"+m[f]+")";var d=a++;m[d]="(?:-("+m[N]+"(?:\\."+m[N]+")*))";var $=a++;m[$]="(?:-?("+m[g]+"(?:\\."+m[g]+")*))";var P=a++;m[P]="[0-9A-Za-z-]+";var w=a++;m[w]="(?:\\+("+m[P]+"(?:\\."+m[P]+")*))";var u=a++,i="v?"+m[p]+m[d]+"?"+m[w]+"?";m[u]="^"+i+"$";var o="[v=\\s]*"+m[y]+m[$]+"?"+m[w]+"?",s=a++;m[s]="^"+o+"$";var e=a++;m[e]="((?:<|>)?=?)";var n=a++;m[n]=m[c]+"|x|X|\\*";var r=a++;m[r]=m[l]+"|x|X|\\*";var h=a++;m[h]="[v=\\s]*("+m[r]+")(?:\\.("+m[r]+")(?:\\.("+m[r]+")(?:"+m[d]+")?"+m[w]+"?)?)?";var E=a++;m[E]="[v=\\s]*("+m[n]+")(?:\\.("+m[n]+")(?:\\.("+m[n]+")(?:"+m[$]+")?"+m[w]+"?)?)?";var R=a++;m[R]="^"+m[e]+"\\s*"+m[h]+"$";var A=a++;m[A]="^"+m[e]+"\\s*"+m[E]+"$";var T=a++;m[T]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var C=a++;m[C]="(?:~>?)";var M=a++;m[M]="(\\s*)"+m[C]+"\\s+",S[M]=new RegExp(m[M],"g");var J=a++;m[J]="^"+m[C]+m[h]+"$";var ae=a++;m[ae]="^"+m[C]+m[E]+"$";var ie=a++;m[ie]="(?:\\^)";var ce=a++;m[ce]="(\\s*)"+m[ie]+"\\s+",S[ce]=new RegExp(m[ce],"g");var ue=a++;m[ue]="^"+m[ie]+m[h]+"$";var le=a++;m[le]="^"+m[ie]+m[E]+"$";var x=a++;m[x]="^"+m[e]+"\\s*("+o+")$|^$";var _=a++;m[_]="^"+m[e]+"\\s*("+i+")$|^$";var B=a++;m[B]="(\\s*)"+m[e]+"\\s*("+o+"|"+m[h]+")",S[B]=new RegExp(m[B],"g");var U=a++;m[U]="^\\s*("+m[h]+")\\s+-\\s+("+m[h]+")\\s*$";var G=a++;m[G]="^\\s*("+m[E]+")\\s+-\\s+("+m[E]+")\\s*$";var Z=a++;m[Z]="(<|>)?=?\\s*\\*";for(var Y=0;Y<35;Y++)v(Y,m[Y]),S[Y]||(S[Y]=new RegExp(m[Y]));function F(W,ee){if(W instanceof z)return W;if(typeof W!="string"||W.length>I||!(ee?S[s]:S[u]).test(W))return null;try{return new z(W,ee)}catch{return null}}function z(W,ee){if(W instanceof z){if(W.loose===ee)return W;W=W.version}else if(typeof W!="string")throw new TypeError("Invalid Version: "+W);if(W.length>I)throw new TypeError("version is longer than "+I+" characters");if(!(this instanceof z))return new z(W,ee);v("SemVer",W,ee),this.loose=ee;var te=W.trim().match(ee?S[s]:S[u]);if(!te)throw new TypeError("Invalid Version: "+W);if(this.raw=W,this.major=+te[1],this.minor=+te[2],this.patch=+te[3],this.major>D||this.major<0)throw new TypeError("Invalid major version");if(this.minor>D||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>D||this.patch<0)throw new TypeError("Invalid patch version");te[4]?this.prerelease=te[4].split(".").map(function(pe){if(/^[0-9]+$/.test(pe)){var be=+pe;if(be>=0&&be<D)return be}return pe}):this.prerelease=[],this.build=te[5]?te[5].split("."):[],this.format()}t.parse=F,t.valid=function(W,ee){var te=F(W,ee);return te?te.version:null},t.clean=function(W,ee){var te=F(W.trim().replace(/^[=v]+/,""),ee);return te?te.version:null},t.SemVer=z,z.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},z.prototype.toString=function(){return this.version},z.prototype.compare=function(W){return v("SemVer.compare",this.version,this.loose,W),W instanceof z||(W=new z(W,this.loose)),this.compareMain(W)||this.comparePre(W)},z.prototype.compareMain=function(W){return W instanceof z||(W=new z(W,this.loose)),V(this.major,W.major)||V(this.minor,W.minor)||V(this.patch,W.patch)},z.prototype.comparePre=function(W){if(W instanceof z||(W=new z(W,this.loose)),this.prerelease.length&&!W.prerelease.length)return-1;if(!this.prerelease.length&&W.prerelease.length)return 1;if(!this.prerelease.length&&!W.prerelease.length)return 0;var ee=0;do{var te=this.prerelease[ee],pe=W.prerelease[ee];if(v("prerelease compare",ee,te,pe),te===void 0&&pe===void 0)return 0;if(pe===void 0)return 1;if(te===void 0)return-1;if(te!==pe)return V(te,pe)}while(++ee)},z.prototype.inc=function(W,ee){switch(W){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",ee);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",ee);break;case"prepatch":this.prerelease.length=0,this.inc("patch",ee),this.inc("pre",ee);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",ee),this.inc("pre",ee);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var te=this.prerelease.length;--te>=0;)typeof this.prerelease[te]=="number"&&(this.prerelease[te]++,te=-2);te===-1&&this.prerelease.push(0)}ee&&(this.prerelease[0]===ee?isNaN(this.prerelease[1])&&(this.prerelease=[ee,0]):this.prerelease=[ee,0]);break;default:throw new Error("invalid increment argument: "+W)}return this.format(),this.raw=this.version,this},t.inc=function(W,ee,te,pe){typeof te=="string"&&(pe=te,te=void 0);try{return new z(W,te).inc(ee,pe).version}catch{return null}},t.diff=function(W,ee){if(q(W,ee))return null;var te=F(W),pe=F(ee);if(te.prerelease.length||pe.prerelease.length){for(var be in te)if((be==="major"||be==="minor"||be==="patch")&&te[be]!==pe[be])return"pre"+be;return"prerelease"}for(var be in te)if((be==="major"||be==="minor"||be==="patch")&&te[be]!==pe[be])return be},t.compareIdentifiers=V;var H=/^[0-9]+$/;function V(W,ee){var te=H.test(W),pe=H.test(ee);return te&&pe&&(W=+W,ee=+ee),te&&!pe?-1:pe&&!te?1:W<ee?-1:W>ee?1:0}function b(W,ee,te){return new z(W,te).compare(new z(ee,te))}function L(W,ee,te){return b(W,ee,te)>0}function j(W,ee,te){return b(W,ee,te)<0}function q(W,ee,te){return b(W,ee,te)===0}function X(W,ee,te){return b(W,ee,te)!==0}function K(W,ee,te){return b(W,ee,te)>=0}function re(W,ee,te){return b(W,ee,te)<=0}function fe(W,ee,te,pe){var be;switch(ee){case"===":typeof W=="object"&&(W=W.version),typeof te=="object"&&(te=te.version),be=W===te;break;case"!==":typeof W=="object"&&(W=W.version),typeof te=="object"&&(te=te.version),be=W!==te;break;case"":case"=":case"==":be=q(W,te,pe);break;case"!=":be=X(W,te,pe);break;case">":be=L(W,te,pe);break;case">=":be=K(W,te,pe);break;case"<":be=j(W,te,pe);break;case"<=":be=re(W,te,pe);break;default:throw new TypeError("Invalid operator: "+ee)}return be}function he(W,ee){if(W instanceof he){if(W.loose===ee)return W;W=W.value}if(!(this instanceof he))return new he(W,ee);v("comparator",W,ee),this.loose=ee,this.parse(W),this.semver===ve?this.value="":this.value=this.operator+this.semver.version,v("comp",this)}t.rcompareIdentifiers=function(W,ee){return V(ee,W)},t.major=function(W,ee){return new z(W,ee).major},t.minor=function(W,ee){return new z(W,ee).minor},t.patch=function(W,ee){return new z(W,ee).patch},t.compare=b,t.compareLoose=function(W,ee){return b(W,ee,!0)},t.rcompare=function(W,ee,te){return b(ee,W,te)},t.sort=function(W,ee){return W.sort(function(te,pe){return t.compare(te,pe,ee)})},t.rsort=function(W,ee){return W.sort(function(te,pe){return t.rcompare(te,pe,ee)})},t.gt=L,t.lt=j,t.eq=q,t.neq=X,t.gte=K,t.lte=re,t.cmp=fe,t.Comparator=he;var ve={};function me(W,ee){if(W instanceof me)return W.loose===ee?W:new me(W.raw,ee);if(W instanceof he)return new me(W.value,ee);if(!(this instanceof me))return new me(W,ee);if(this.loose=ee,this.raw=W,this.set=W.split(/\s*\|\|\s*/).map(function(te){return this.parseRange(te.trim())},this).filter(function(te){return te.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+W);this.format()}function ge(W){return!W||W.toLowerCase()==="x"||W==="*"}function de(W,ee,te,pe,be,Ae,Se,Te,Oe,De,Ue,Ne,Le){return((ee=ge(te)?"":ge(pe)?">="+te+".0.0":ge(be)?">="+te+"."+pe+".0":">="+ee)+" "+(Te=ge(Oe)?"":ge(De)?"<"+(+Oe+1)+".0.0":ge(Ue)?"<"+Oe+"."+(+De+1)+".0":Ne?"<="+Oe+"."+De+"."+Ue+"-"+Ne:"<="+Te)).trim()}function $e(W,ee){for(var te=0;te<W.length;te++)if(!W[te].test(ee))return!1;if(ee.prerelease.length){for(te=0;te<W.length;te++)if(v(W[te].semver),W[te].semver!==ve&&W[te].semver.prerelease.length>0){var pe=W[te].semver;if(pe.major===ee.major&&pe.minor===ee.minor&&pe.patch===ee.patch)return!0}return!1}return!0}function ye(W,ee,te){try{ee=new me(ee,te)}catch{return!1}return ee.test(W)}function Ie(W,ee,te,pe){var be,Ae,Se,Te,Oe;switch(W=new z(W,pe),ee=new me(ee,pe),te){case">":be=L,Ae=re,Se=j,Te=">",Oe=">=";break;case"<":be=j,Ae=K,Se=L,Te="<",Oe="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(ye(W,ee,pe))return!1;for(var De=0;De<ee.set.length;++De){var Ue=ee.set[De],Ne=null,Le=null;if(Ue.forEach(function(Ce){Ce.semver===ve&&(Ce=new he(">=0.0.0")),Ne=Ne||Ce,Le=Le||Ce,be(Ce.semver,Ne.semver,pe)?Ne=Ce:Se(Ce.semver,Le.semver,pe)&&(Le=Ce)}),Ne.operator===Te||Ne.operator===Oe||(!Le.operator||Le.operator===Te)&&Ae(W,Le.semver)||Le.operator===Oe&&Se(W,Le.semver))return!1}return!0}he.prototype.parse=function(W){var ee=this.loose?S[x]:S[_],te=W.match(ee);if(!te)throw new TypeError("Invalid comparator: "+W);this.operator=te[1],this.operator==="="&&(this.operator=""),te[2]?this.semver=new z(te[2],this.loose):this.semver=ve},he.prototype.toString=function(){return this.value},he.prototype.test=function(W){return v("Comparator.test",W,this.loose),this.semver===ve||(typeof W=="string"&&(W=new z(W,this.loose)),fe(W,this.operator,this.semver,this.loose))},he.prototype.intersects=function(W,ee){if(!(W instanceof he))throw new TypeError("a Comparator is required");var te;if(this.operator==="")return te=new me(W.value,ee),ye(this.value,te,ee);if(W.operator==="")return te=new me(this.value,ee),ye(W.semver,te,ee);var pe=!(this.operator!==">="&&this.operator!==">"||W.operator!==">="&&W.operator!==">"),be=!(this.operator!=="<="&&this.operator!=="<"||W.operator!=="<="&&W.operator!=="<"),Ae=this.semver.version===W.semver.version,Se=!(this.operator!==">="&&this.operator!=="<="||W.operator!==">="&&W.operator!=="<="),Te=fe(this.semver,"<",W.semver,ee)&&(this.operator===">="||this.operator===">")&&(W.operator==="<="||W.operator==="<"),Oe=fe(this.semver,">",W.semver,ee)&&(this.operator==="<="||this.operator==="<")&&(W.operator===">="||W.operator===">");return pe||be||Ae&&Se||Te||Oe},t.Range=me,me.prototype.format=function(){return this.range=this.set.map(function(W){return W.join(" ").trim()}).join("||").trim(),this.range},me.prototype.toString=function(){return this.range},me.prototype.parseRange=function(W){var ee=this.loose;W=W.trim(),v("range",W,ee);var te=ee?S[G]:S[U];W=W.replace(te,de),v("hyphen replace",W),W=W.replace(S[B],"$1$2$3"),v("comparator trim",W,S[B]),W=(W=(W=W.replace(S[M],"$1~")).replace(S[ce],"$1^")).split(/\s+/).join(" ");var pe=ee?S[x]:S[_],be=W.split(" ").map(function(Ae){return function(Se,Te){return v("comp",Se),Se=function(Oe,De){return Oe.trim().split(/\s+/).map(function(Ue){return function(Ne,Le){v("caret",Ne,Le);var Ce=Le?S[le]:S[ue];return Ne.replace(Ce,function(Fe,Ee,Pe,ke,Re){var je;return v("caret",Ne,Fe,Ee,Pe,ke,Re),ge(Ee)?je="":ge(Pe)?je=">="+Ee+".0.0 <"+(+Ee+1)+".0.0":ge(ke)?je=Ee==="0"?">="+Ee+"."+Pe+".0 <"+Ee+"."+(+Pe+1)+".0":">="+Ee+"."+Pe+".0 <"+(+Ee+1)+".0.0":Re?(v("replaceCaret pr",Re),Re.charAt(0)!=="-"&&(Re="-"+Re),je=Ee==="0"?Pe==="0"?">="+Ee+"."+Pe+"."+ke+Re+" <"+Ee+"."+Pe+"."+(+ke+1):">="+Ee+"."+Pe+"."+ke+Re+" <"+Ee+"."+(+Pe+1)+".0":">="+Ee+"."+Pe+"."+ke+Re+" <"+(+Ee+1)+".0.0"):(v("no pr"),je=Ee==="0"?Pe==="0"?">="+Ee+"."+Pe+"."+ke+" <"+Ee+"."+Pe+"."+(+ke+1):">="+Ee+"."+Pe+"."+ke+" <"+Ee+"."+(+Pe+1)+".0":">="+Ee+"."+Pe+"."+ke+" <"+(+Ee+1)+".0.0"),v("caret return",je),je})}(Ue,De)}).join(" ")}(Se,Te),v("caret",Se),Se=function(Oe,De){return Oe.trim().split(/\s+/).map(function(Ue){return function(Ne,Le){var Ce=Le?S[ae]:S[J];return Ne.replace(Ce,function(Fe,Ee,Pe,ke,Re){var je;return v("tilde",Ne,Fe,Ee,Pe,ke,Re),ge(Ee)?je="":ge(Pe)?je=">="+Ee+".0.0 <"+(+Ee+1)+".0.0":ge(ke)?je=">="+Ee+"."+Pe+".0 <"+Ee+"."+(+Pe+1)+".0":Re?(v("replaceTilde pr",Re),Re.charAt(0)!=="-"&&(Re="-"+Re),je=">="+Ee+"."+Pe+"."+ke+Re+" <"+Ee+"."+(+Pe+1)+".0"):je=">="+Ee+"."+Pe+"."+ke+" <"+Ee+"."+(+Pe+1)+".0",v("tilde return",je),je})}(Ue,De)}).join(" ")}(Se,Te),v("tildes",Se),Se=function(Oe,De){return v("replaceXRanges",Oe,De),Oe.split(/\s+/).map(function(Ue){return function(Ne,Le){Ne=Ne.trim();var Ce=Le?S[A]:S[R];return Ne.replace(Ce,function(Fe,Ee,Pe,ke,Re,je){v("xRange",Ne,Fe,Ee,Pe,ke,Re,je);var Me=ge(Pe),ze=Me||ge(ke),qe=ze||ge(Re);return Ee==="="&&qe&&(Ee=""),Me?Fe=Ee===">"||Ee==="<"?"<0.0.0":"*":Ee&&qe?(ze&&(ke=0),qe&&(Re=0),Ee===">"?(Ee=">=",ze?(Pe=+Pe+1,ke=0,Re=0):qe&&(ke=+ke+1,Re=0)):Ee==="<="&&(Ee="<",ze?Pe=+Pe+1:ke=+ke+1),Fe=Ee+Pe+"."+ke+"."+Re):ze?Fe=">="+Pe+".0.0 <"+(+Pe+1)+".0.0":qe&&(Fe=">="+Pe+"."+ke+".0 <"+Pe+"."+(+ke+1)+".0"),v("xRange return",Fe),Fe})}(Ue,De)}).join(" ")}(Se,Te),v("xrange",Se),Se=function(Oe,De){return v("replaceStars",Oe,De),Oe.trim().replace(S[Z],"")}(Se,Te),v("stars",Se),Se}(Ae,ee)}).join(" ").split(/\s+/);return this.loose&&(be=be.filter(function(Ae){return!!Ae.match(pe)})),be=be.map(function(Ae){return new he(Ae,ee)})},me.prototype.intersects=function(W,ee){if(!(W instanceof me))throw new TypeError("a Range is required");return this.set.some(function(te){return te.every(function(pe){return W.set.some(function(be){return be.every(function(Ae){return pe.intersects(Ae,ee)})})})})},t.toComparators=function(W,ee){return new me(W,ee).set.map(function(te){return te.map(function(pe){return pe.value}).join(" ").trim().split(" ")})},me.prototype.test=function(W){if(!W)return!1;typeof W=="string"&&(W=new z(W,this.loose));for(var ee=0;ee<this.set.length;ee++)if($e(this.set[ee],W))return!0;return!1},t.satisfies=ye,t.maxSatisfying=function(W,ee,te){var pe=null,be=null;try{var Ae=new me(ee,te)}catch{return null}return W.forEach(function(Se){Ae.test(Se)&&(pe&&be.compare(Se)!==-1||(be=new z(pe=Se,te)))}),pe},t.minSatisfying=function(W,ee,te){var pe=null,be=null;try{var Ae=new me(ee,te)}catch{return null}return W.forEach(function(Se){Ae.test(Se)&&(pe&&be.compare(Se)!==1||(be=new z(pe=Se,te)))}),pe},t.validRange=function(W,ee){try{return new me(W,ee).range||"*"}catch{return null}},t.ltr=function(W,ee,te){return Ie(W,ee,"<",te)},t.gtr=function(W,ee,te){return Ie(W,ee,">",te)},t.outside=Ie,t.prerelease=function(W,ee){var te=F(W,ee);return te&&te.prerelease.length?te.prerelease:null},t.intersects=function(W,ee,te){return W=new me(W,te),ee=new me(ee,te),W.intersects(ee)},t.coerce=function(W){if(W instanceof z)return W;if(typeof W!="string")return null;var ee=W.match(S[T]);return ee==null?null:F((ee[1]||"0")+"."+(ee[2]||"0")+"."+(ee[3]||"0"))}}).call(this,O(1))},function(Q,t){var O,k,v=Q.exports={};function I(){throw new Error("setTimeout has not been defined")}function D(){throw new Error("clearTimeout has not been defined")}function S(g){if(O===setTimeout)return setTimeout(g,0);if((O===I||!O)&&setTimeout)return O=setTimeout,setTimeout(g,0);try{return O(g,0)}catch{try{return O.call(null,g,0)}catch{return O.call(this,g,0)}}}(function(){try{O=typeof setTimeout=="function"?setTimeout:I}catch{O=I}try{k=typeof clearTimeout=="function"?clearTimeout:D}catch{k=D}})();var m,a=[],l=!1,c=-1;function f(){l&&m&&(l=!1,m.length?a=m.concat(a):c=-1,a.length&&p())}function p(){if(!l){var g=S(f);l=!0;for(var d=a.length;d;){for(m=a,a=[];++c<d;)m&&m[c].run();c=-1,d=a.length}m=null,l=!1,function($){if(k===clearTimeout)return clearTimeout($);if((k===D||!k)&&clearTimeout)return k=clearTimeout,clearTimeout($);try{k($)}catch{try{return k.call(null,$)}catch{return k.call(this,$)}}}(g)}}function y(g,d){this.fun=g,this.array=d}function N(){}v.nextTick=function(g){var d=new Array(arguments.length-1);if(arguments.length>1)for(var $=1;$<arguments.length;$++)d[$-1]=arguments[$];a.push(new y(g,d)),a.length!==1||l||S(p)},y.prototype.run=function(){this.fun.apply(null,this.array)},v.title="browser",v.browser=!0,v.env={},v.argv=[],v.version="",v.versions={},v.on=N,v.addListener=N,v.once=N,v.off=N,v.removeListener=N,v.removeAllListeners=N,v.emit=N,v.prependListener=N,v.prependOnceListener=N,v.listeners=function(g){return[]},v.binding=function(g){throw new Error("process.binding is not supported")},v.cwd=function(){return"/"},v.chdir=function(g){throw new Error("process.chdir is not supported")},v.umask=function(){return 0}}])}),define(se[80],oe([0,1]),function(Q,t){"use strict";var O;Object.defineProperty(t,"__esModule",{value:!0}),t.$Hs=void 0;class k{constructor(S,m,a){this.level=S,this.key=m,this.value=a,this.forward=[]}}const v=void 0;class I{constructor(S,m=2**16){this.comparator=S,this[O]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(m)|0),this.e=new k(this.c,v,v)}get size(){return this.f}clear(){this.e=new k(this.c,v,v),this.f=0}has(S){return!!I.g(this,S,this.comparator)}get(S){return I.g(this,S,this.comparator)?.value}set(S,m){return I.h(this,S,m,this.comparator)&&(this.f+=1),this}delete(S){const m=I.k(this,S,this.comparator);return m&&(this.f-=1),m}forEach(S,m){let a=this.e.forward[0];for(;a;)S.call(m,a.value,a.key,this),a=a.forward[0]}[(O=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let S=this.e.forward[0];for(;S;)yield[S.key,S.value],S=S.forward[0]}*keys(){let S=this.e.forward[0];for(;S;)yield S.key,S=S.forward[0]}*values(){let S=this.e.forward[0];for(;S;)yield S.value,S=S.forward[0]}toString(){let S="[SkipList]:",m=this.e.forward[0];for(;m;)S+=`node(${m.key}, ${m.value}, lvl:${m.level})`,m=m.forward[0];return S}static g(S,m,a){let l=S.e;for(let c=S.d-1;c>=0;c--)for(;l.forward[c]&&a(l.forward[c].key,m)<0;)l=l.forward[c];if(l=l.forward[0],l&&a(l.key,m)===0)return l}static h(S,m,a,l){const c=[];let f=S.e;for(let p=S.d-1;p>=0;p--){for(;f.forward[p]&&l(f.forward[p].key,m)<0;)f=f.forward[p];c[p]=f}if(f=f.forward[0],f&&l(f.key,m)===0)return f.value=a,!1;{const p=I.j(S);if(p>S.d){for(let y=S.d;y<p;y++)c[y]=S.e;S.d=p}f=new k(p,m,a);for(let y=0;y<p;y++)f.forward[y]=c[y].forward[y],c[y].forward[y]=f;return!0}}static j(S,m=.5){let a=1;for(;Math.random()<m&&a<S.c;)a+=1;return a}static k(S,m,a){const l=[];let c=S.e;for(let f=S.d-1;f>=0;f--){for(;c.forward[f]&&a(c.forward[f].key,m)<0;)c=c.forward[f];l[f]=c}if(c=c.forward[0],!c||a(c.key,m)!==0)return!1;for(let f=0;f<S.d&&l[f].forward[f]===c;f++)l[f].forward[f]=c.forward[f];for(;S.d>0&&S.e.forward[S.d-1]===v;)S.d-=1;return!0}}t.$Hs=I}),define(se[46],oe([0,1,9,2]),function(Q,t,O,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ue=v,t.$ve=I,t.$we=D,t.$xe=S,t.$ye=a,t.$ze=l,t.$Ae=c,t.$Be=f,t.$Ce=p,t.$De=y,t.$Ee=N,t.$Fe=g,t.$Ge=d,t.$He=$,t.$Ie=P;function v(w){const u=w;return u?typeof u.read=="function":!1}function I(w){const u=w;return u?[u.on,u.pause,u.resume,u.destroy].every(i=>typeof i=="function"):!1}function D(w){const u=w;return u?I(u.stream)&&Array.isArray(u.buffer)&&typeof u.ended=="boolean":!1}function S(w,u){return new m(w,u)}class m{constructor(u,i){this.e=u,this.f=i,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(u){if(!this.a.destroyed){if(this.a.flowing)this.g(u);else if(this.b.data.push(u),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(i=>this.d.push(i))}}error(u){this.a.destroyed||(this.a.flowing?this.h(u):this.b.error.push(u))}end(u){this.a.destroyed||(typeof u<"u"&&this.write(u),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(u){this.c.data.slice(0).forEach(i=>i(u))}h(u){this.c.error.length===0?(0,O.$1)(u):this.c.error.slice(0).forEach(i=>i(u))}i(){this.c.end.slice(0).forEach(u=>u())}on(u,i){if(!this.a.destroyed)switch(u){case"data":this.c.data.push(i),this.resume();break;case"end":this.c.end.push(i),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(i),this.a.flowing&&this.k();break}}removeListener(u,i){if(this.a.destroyed)return;let o;switch(u){case"data":o=this.c.data;break;case"end":o=this.c.end;break;case"error":o=this.c.error;break}if(o){const s=o.indexOf(i);s>=0&&o.splice(s,1)}}j(){if(this.b.data.length>0){const u=this.e(this.b.data);this.g(u),this.b.data.length=0;const i=[...this.d];this.d.length=0,i.forEach(o=>o())}}k(){if(this.c.error.length>0){for(const u of this.b.error)this.h(u);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function a(w,u){const i=[];let o;for(;(o=w.read())!==null;)i.push(o);return u(i)}function l(w,u,i){const o=[];let s;for(;(s=w.read())!==null&&o.length<i;)o.push(s);return s===null&&o.length>0?u(o):{read:()=>{if(o.length>0)return o.shift();if(typeof s<"u"){const e=s;return s=void 0,e}return w.read()}}}function c(w,u){return new Promise((i,o)=>{const s=[];f(w,{onData:e=>{u&&s.push(e)},onError:e=>{u?o(e):i(void 0)},onEnd:()=>{i(u?u(s):void 0)}})})}function f(w,u,i){w.on("error",o=>{i?.isCancellationRequested||u.onError(o)}),w.on("end",()=>{i?.isCancellationRequested||u.onEnd()}),w.on("data",o=>{i?.isCancellationRequested||u.onData(o)})}function p(w,u){return new Promise((i,o)=>{const s=new k.$Tc,e=[],n=E=>{if(e.push(E),e.length>u)return s.dispose(),w.pause(),i({stream:w,buffer:e,ended:!1})},r=E=>(s.dispose(),o(E)),h=()=>(s.dispose(),i({stream:w,buffer:e,ended:!0}));s.add((0,k.$Sc)(()=>w.removeListener("error",r))),w.on("error",r),s.add((0,k.$Sc)(()=>w.removeListener("end",h))),w.on("end",h),s.add((0,k.$Sc)(()=>w.removeListener("data",n))),w.on("data",n)})}function y(w,u){const i=S(u);return i.end(w),i}function N(){const w=S(()=>{throw new Error("not supported")});return w.end(),w}function g(w){let u=!1;return{read:()=>u?null:(u=!0,w)}}function d(w,u,i){const o=S(i);return f(w,{onData:s=>o.write(u.data(s)),onError:s=>o.error(u.error?u.error(s):s),onEnd:()=>o.end()}),o}function $(w,u,i){let o=!1;return{read:()=>{const s=u.read();return o?s:(o=!0,s!==null?i([w,s]):w)}}}function P(w,u,i){let o=!1;const s=S(i);return f(u,{onData:e=>o?s.write(e):(o=!0,s.write(i([w,e]))),onError:e=>s.error(e),onEnd:()=>{o||(o=!0,s.write(w)),s.end()}}),s}}),define(se[14],oe([0,1,170,46]),function(Q,t,O,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Je=void 0,t.$Ke=a,t.$Le=l,t.$Me=c,t.$Ne=f,t.$Oe=p,t.$Pe=y,t.$Qe=N,t.$Re=g,t.$Se=d,t.$Te=$,t.$Ue=P,t.$Ve=w,t.$We=u,t.$Xe=i,t.$Ye=o,t.$Ze=s,t.$1e=e,t.$2e=n,t.$3e=r,t.$4e=R;const v=typeof Buffer<"u",I=new O.$V(()=>new Uint8Array(256));let D,S;class m{static alloc(T){return v?new m(Buffer.allocUnsafe(T)):new m(new Uint8Array(T))}static wrap(T){return v&&!Buffer.isBuffer(T)&&(T=Buffer.from(T.buffer,T.byteOffset,T.byteLength)),new m(T)}static fromString(T,C){return!(C?.dontUseNodeBuffer||!1)&&v?new m(Buffer.from(T)):(D||(D=new TextEncoder),new m(D.encode(T)))}static fromByteArray(T){const C=m.alloc(T.length);for(let M=0,J=T.length;M<J;M++)C.buffer[M]=T[M];return C}static concat(T,C){if(typeof C>"u"){C=0;for(let ae=0,ie=T.length;ae<ie;ae++)C+=T[ae].byteLength}const M=m.alloc(C);let J=0;for(let ae=0,ie=T.length;ae<ie;ae++){const ce=T[ae];M.set(ce,J),J+=ce.byteLength}return M}constructor(T){this.buffer=T,this.byteLength=this.buffer.byteLength}clone(){const T=m.alloc(this.byteLength);return T.set(this),T}toString(){return v?this.buffer.toString():(S||(S=new TextDecoder),S.decode(this.buffer))}slice(T,C){return new m(this.buffer.subarray(T,C))}set(T,C){if(T instanceof m)this.buffer.set(T.buffer,C);else if(T instanceof Uint8Array)this.buffer.set(T,C);else if(T instanceof ArrayBuffer)this.buffer.set(new Uint8Array(T),C);else if(ArrayBuffer.isView(T))this.buffer.set(new Uint8Array(T.buffer,T.byteOffset,T.byteLength),C);else throw new Error("Unknown argument 'array'")}readUInt32BE(T){return f(this.buffer,T)}writeUInt32BE(T,C){p(this.buffer,T,C)}readUInt32LE(T){return y(this.buffer,T)}writeUInt32LE(T,C){N(this.buffer,T,C)}readUInt8(T){return g(this.buffer,T)}writeUInt8(T,C){d(this.buffer,T,C)}indexOf(T,C=0){return a(this.buffer,T instanceof m?T.buffer:T,C)}}t.$Je=m;function a(A,T,C=0){const M=T.byteLength,J=A.byteLength;if(M===0)return 0;if(M===1)return A.indexOf(T[0]);if(M>J-C)return-1;const ae=I.value;ae.fill(T.length);for(let le=0;le<T.length;le++)ae[T[le]]=T.length-le-1;let ie=C+T.length-1,ce=ie,ue=-1;for(;ie<J;)if(A[ie]===T[ce]){if(ce===0){ue=ie;break}ie--,ce--}else ie+=Math.max(T.length-ce,ae[A[ie]]),ce=T.length-1;return ue}function l(A,T){return A[T+0]<<0>>>0|A[T+1]<<8>>>0}function c(A,T,C){A[C+0]=T&255,T=T>>>8,A[C+1]=T&255}function f(A,T){return A[T]*2**24+A[T+1]*2**16+A[T+2]*2**8+A[T+3]}function p(A,T,C){A[C+3]=T,T=T>>>8,A[C+2]=T,T=T>>>8,A[C+1]=T,T=T>>>8,A[C]=T}function y(A,T){return A[T+0]<<0>>>0|A[T+1]<<8>>>0|A[T+2]<<16>>>0|A[T+3]<<24>>>0}function N(A,T,C){A[C+0]=T&255,T=T>>>8,A[C+1]=T&255,T=T>>>8,A[C+2]=T&255,T=T>>>8,A[C+3]=T&255}function g(A,T){return A[T]}function d(A,T,C){A[C]=T}function $(A){return k.$ye(A,T=>m.concat(T))}function P(A){return k.$Fe(A)}function w(A){return k.$Ae(A,T=>m.concat(T))}async function u(A){return A.ended?m.concat(A.buffer):m.concat([...A.buffer,await w(A.stream)])}function i(A){return k.$De(A,T=>m.concat(T))}function o(A){return k.$Ge(A,{data:T=>typeof T=="string"?m.fromString(T):m.wrap(T)},T=>m.concat(T))}function s(A){return k.$xe(T=>m.concat(T),A)}function e(A,T){return k.$He(A,T,C=>m.concat(C))}function n(A,T){return k.$Ie(A,T,C=>m.concat(C))}function r(A){let T=0,C=0,M=0;const J=new Uint8Array(Math.floor(A.length/4*3)),ae=ce=>{switch(C){case 3:J[M++]=T|ce,C=0;break;case 2:J[M++]=T|ce>>>2,T=ce<<6,C=3;break;case 1:J[M++]=T|ce>>>4,T=ce<<4,C=2;break;default:T=ce<<2,C=1}};for(let ce=0;ce<A.length;ce++){const ue=A.charCodeAt(ce);if(ue>=65&&ue<=90)ae(ue-65);else if(ue>=97&&ue<=122)ae(ue-97+26);else if(ue>=48&&ue<=57)ae(ue-48+52);else if(ue===43||ue===45)ae(62);else if(ue===47||ue===95)ae(63);else{if(ue===61)break;throw new SyntaxError(`Unexpected base64 character ${A[ce]}`)}}const ie=M;for(;C>0;)ae(0);return m.wrap(J).slice(0,ie)}const h="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",E="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function R({buffer:A},T=!0,C=!1){const M=C?E:h;let J="";const ae=A.byteLength%3;let ie=0;for(;ie<A.byteLength-ae;ie+=3){const ce=A[ie+0],ue=A[ie+1],le=A[ie+2];J+=M[ce>>>2],J+=M[(ce<<4|ue>>>4)&63],J+=M[(ue<<2|le>>>6)&63],J+=M[le&63]}if(ae===1){const ce=A[ie+0];J+=M[ce>>>2],J+=M[ce<<4&63],T&&(J+="==")}else if(ae===2){const ce=A[ie+0],ue=A[ie+1];J+=M[ce>>>2],J+=M[(ce<<4|ue>>>4)&63],J+=M[ue<<2&63],T&&(J+="=")}return J}}),define(se[28],oe([0,1,3]),function(Q,t,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$9n=k,t.$0n=v,t.$$n=D,t.$_n=m,t.$ao=a,t.$bo=l,t.$co=c,t.$do=f,t.$eo=p,t.$fo=y,t.$go=N,t.$ho=g,t.$io=d;function k($){if(!$||typeof $!="object"||$ instanceof RegExp)return $;const P=Array.isArray($)?[]:{};return Object.entries($).forEach(([w,u])=>{P[w]=u&&typeof u=="object"?k(u):u}),P}function v($){if(!$||typeof $!="object")return $;const P=[$];for(;P.length>0;){const w=P.shift();Object.freeze(w);for(const u in w)if(I.call(w,u)){const i=w[u];typeof i=="object"&&!Object.isFrozen(i)&&!(0,O.$dg)(i)&&P.push(i)}}return $}const I=Object.prototype.hasOwnProperty;function D($,P){return S($,P,new Set)}function S($,P,w){if((0,O.$jg)($))return $;const u=P($);if(typeof u<"u")return u;if(Array.isArray($)){const i=[];for(const o of $)i.push(S(o,P,w));return i}if((0,O.$cg)($)){if(w.has($))throw new Error("Cannot clone recursive data-structure");w.add($);const i={};for(const o in $)I.call($,o)&&(i[o]=S($[o],P,w));return w.delete($),i}return $}function m($,P,w=!0){return(0,O.$cg)($)?((0,O.$cg)(P)&&Object.keys(P).forEach(u=>{u in $?w&&((0,O.$cg)($[u])&&(0,O.$cg)(P[u])?m($[u],P[u],w):$[u]=P[u]):$[u]=P[u]}),$):P}function a($,P){if($===P)return!0;if($==null||P===null||P===void 0||typeof $!=typeof P||typeof $!="object"||Array.isArray($)!==Array.isArray(P))return!1;let w,u;if(Array.isArray($)){if($.length!==P.length)return!1;for(w=0;w<$.length;w++)if(!a($[w],P[w]))return!1}else{const i=[];for(u in $)i.push(u);i.sort();const o=[];for(u in P)o.push(u);if(o.sort(),!a(i,o))return!1;for(w=0;w<i.length;w++)if(!a($[i[w]],P[i[w]]))return!1}return!0}function l($){const P=new Set;return JSON.stringify($,(w,u)=>{if((0,O.$cg)(u)||Array.isArray(u)){if(P.has(u))return"[Circular]";P.add(u)}return typeof u=="bigint"?`[BigInt ${u.toString()}]`:u})}function c($,P){const w=Object.create(null);return!$||!P||Object.keys(P).forEach(i=>{const o=$[i],s=P[i];a(o,s)||(w[i]=s)}),w}function f($,P){const w=P.toLowerCase(),u=Object.keys($).find(i=>i.toLowerCase()===w);return u?$[u]:$[P]}function p($,P){const w=Object.create(null);for(const[u,i]of Object.entries($))P(u,i)&&(w[u]=i);return w}function y($){let P=[];for(;Object.prototype!==$;)P=P.concat(Object.getOwnPropertyNames($)),$=Object.getPrototypeOf($);return P}function N($){const P=[];for(const w of y($))typeof $[w]=="function"&&P.push(w);return P}function g($,P){const w=i=>function(){const o=Array.prototype.slice.call(arguments,0);return P(i,o)},u={};for(const i of $)u[i]=w(i);return u}function d($,P){const w={};for(const[u,i]of Object.entries($))w[u]=P(i,u);return w}}),define(se[43],oe([0,1,32]),function(Q,t,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$uj=t.$sj=void 0,t.$oj=k,t.$pj=v,t.$qj=I,t.$rj=S,t.$tj=N;function k(d){return v(d,0)}function v(d,$){switch(typeof d){case"object":return d===null?I(349,$):Array.isArray(d)?m(d,$):a(d,$);case"string":return S(d,$);case"boolean":return D(d,$);case"number":return I(d,$);case"undefined":return I(937,$);default:return I(617,$)}}function I(d,$){return($<<5)-$+d|0}function D(d,$){return I(d?433:863,$)}function S(d,$){$=I(149417,$);for(let P=0,w=d.length;P<w;P++)$=I(d.charCodeAt(P),$);return $}function m(d,$){return $=I(104579,$),d.reduce((P,w)=>v(w,P),$)}function a(d,$){return $=I(181387,$),Object.keys(d).sort().reduce((P,w)=>(P=S(w,P),v(d[w],P)),$)}class l{constructor(){this.g=0}get value(){return this.g}hash($){return this.g=v($,this.g),this.g}}t.$sj=l;var c;(function(d){d[d.BLOCK_SIZE=64]="BLOCK_SIZE",d[d.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(c||(c={}));function f(d,$,P=32){const w=P-$,u=~((1<<w)-1);return(d<<$|(u&d)>>>w)>>>0}function p(d,$=0,P=d.byteLength,w=0){for(let u=0;u<P;u++)d[$+u]=w}function y(d,$,P="0"){for(;d.length<$;)d=P+d;return d}function N(d,$=32){return d instanceof ArrayBuffer?Array.from(new Uint8Array(d)).map(P=>P.toString(16).padStart(2,"0")).join(""):y((d>>>0).toString(16),$/4)}class g{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(c.BLOCK_SIZE+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update($){const P=$.length;if(P===0)return;const w=this.p;let u=this.r,i=this.u,o,s;for(i!==0?(o=i,s=-1,i=0):(o=$.charCodeAt(0),s=0);;){let e=o;if(O.$Ff(o))if(s+1<P){const n=$.charCodeAt(s+1);O.$Gf(n)?(s++,e=O.$Hf(o,n)):e=c.UNICODE_REPLACEMENT}else{i=o;break}else O.$Gf(o)&&(e=c.UNICODE_REPLACEMENT);if(u=this.w(w,u,e),s++,s<P)o=$.charCodeAt(s);else break}this.r=u,this.u=i}w($,P,w){return w<128?$[P++]=w:w<2048?($[P++]=192|(w&1984)>>>6,$[P++]=128|(w&63)>>>0):w<65536?($[P++]=224|(w&61440)>>>12,$[P++]=128|(w&4032)>>>6,$[P++]=128|(w&63)>>>0):($[P++]=240|(w&1835008)>>>18,$[P++]=128|(w&258048)>>>12,$[P++]=128|(w&4032)>>>6,$[P++]=128|(w&63)>>>0),P>=c.BLOCK_SIZE&&(this.y(),P-=c.BLOCK_SIZE,this.t+=c.BLOCK_SIZE,$[0]=$[c.BLOCK_SIZE+0],$[1]=$[c.BLOCK_SIZE+1],$[2]=$[c.BLOCK_SIZE+2]),P}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,c.UNICODE_REPLACEMENT)),this.t+=this.r,this.x()),N(this.h)+N(this.l)+N(this.m)+N(this.n)+N(this.o)}x(){this.p[this.r++]=128,p(this.p,this.r),this.r>56&&(this.y(),p(this.p));const $=8*this.t;this.q.setUint32(56,Math.floor($/4294967296),!1),this.q.setUint32(60,$%4294967296,!1),this.y()}y(){const $=g.g,P=this.q;for(let h=0;h<64;h+=4)$.setUint32(h,P.getUint32(h,!1),!1);for(let h=64;h<320;h+=4)$.setUint32(h,f($.getUint32(h-12,!1)^$.getUint32(h-32,!1)^$.getUint32(h-56,!1)^$.getUint32(h-64,!1),1),!1);let w=this.h,u=this.l,i=this.m,o=this.n,s=this.o,e,n,r;for(let h=0;h<80;h++)h<20?(e=u&i|~u&o,n=1518500249):h<40?(e=u^i^o,n=1859775393):h<60?(e=u&i|u&o|i&o,n=2400959708):(e=u^i^o,n=3395469782),r=f(w,5)+e+s+n+$.getUint32(h*4,!1)&4294967295,s=o,o=i,i=f(u,30),u=w,w=r;this.h=this.h+w&4294967295,this.l=this.l+u&4294967295,this.m=this.m+i&4294967295,this.n=this.n+o&4294967295,this.o=this.o+s&4294967295}}t.$uj=g}),define(se[56],oe([0,1,32]),function(Q,t,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var k;(function(v){v[v.Ignore=0]="Ignore",v[v.Info=1]="Info",v[v.Warning=2]="Warning",v[v.Error=3]="Error"})(k||(k={})),function(v){const I="error",D="warning",S="warn",m="info",a="ignore";function l(f){return f?O.$Bf(I,f)?v.Error:O.$Bf(D,f)||O.$Bf(S,f)?v.Warning:O.$Bf(m,f)?v.Info:v.Ignore:v.Ignore}v.fromValue=l;function c(f){switch(f){case v.Error:return I;case v.Warning:return D;case v.Info:return m;default:return a}}v.toString=c}(k||(k={})),t.default=k}),define(se[29],oe([0,1]),function(Q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Wg=void 0,t.$Vg=k;const O=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function k(v){return O.test(v)}t.$Wg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let v;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?v=crypto.getRandomValues.bind(crypto):v=function(S){for(let m=0;m<S.length;m++)S[m]=Math.floor(Math.random()*256);return S};const I=new Uint8Array(16),D=[];for(let S=0;S<256;S++)D.push(S.toString(16).padStart(2,"0"));return function(){v(I),I[6]=I[6]&15|64,I[8]=I[8]&63|128;let m=0,a="";return a+=D[I[m++]],a+=D[I[m++]],a+=D[I[m++]],a+=D[I[m++]],a+="-",a+=D[I[m++]],a+=D[I[m++]],a+="-",a+=D[I[m++]],a+=D[I[m++]],a+="-",a+=D[I[m++]],a+=D[I[m++]],a+="-",a+=D[I[m++]],a+=D[I[m++]],a+=D[I[m++]],a+=D[I[m++]],a+=D[I[m++]],a+=D[I[m++]],a}}()}),define(se[81],oe([0,1,35]),function(Q,t,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$In=I;const k=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function v(D){const S=D.replace(/\-/g,":").toLowerCase();return!k.has(S)}function I(){const D=(0,O.networkInterfaces)();for(const S in D){const m=D[S];if(m){for(const{mac:a}of m)if(v(a))return a}}throw new Error("Unable to retrieve mac address (unexpected format)")}}),define(se[82],oe([7,4]),function(Q,t){return Q.create("vs/base/common/date",t)}),define(se[83],oe([0,1,82]),function(Q,t,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$7m=a,t.$8m=l,t.$9m=c;const k=60,v=k*60,I=v*24,D=I*7,S=I*30,m=I*365;function a(f,p,y,N){typeof f!="number"&&(f=f.getTime());const g=Math.round((new Date().getTime()-f)/1e3);if(g<-30)return(0,O.localize)(0,null,a(new Date().getTime()+g*1e3,!1));if(!N&&g<30)return(0,O.localize)(1,null);let d;return g<k?(d=g,p?d===1?y?(0,O.localize)(2,null,d):(0,O.localize)(3,null,d):y?(0,O.localize)(4,null,d):(0,O.localize)(5,null,d):d===1?y?(0,O.localize)(6,null,d):(0,O.localize)(7,null,d):y?(0,O.localize)(8,null,d):(0,O.localize)(9,null,d)):g<v?(d=Math.floor(g/k),p?d===1?y?(0,O.localize)(10,null,d):(0,O.localize)(11,null,d):y?(0,O.localize)(12,null,d):(0,O.localize)(13,null,d):d===1?y?(0,O.localize)(14,null,d):(0,O.localize)(15,null,d):y?(0,O.localize)(16,null,d):(0,O.localize)(17,null,d)):g<I?(d=Math.floor(g/v),p?d===1?y?(0,O.localize)(18,null,d):(0,O.localize)(19,null,d):y?(0,O.localize)(20,null,d):(0,O.localize)(21,null,d):d===1?y?(0,O.localize)(22,null,d):(0,O.localize)(23,null,d):y?(0,O.localize)(24,null,d):(0,O.localize)(25,null,d)):g<D?(d=Math.floor(g/I),p?d===1?(0,O.localize)(26,null,d):(0,O.localize)(27,null,d):d===1?(0,O.localize)(28,null,d):(0,O.localize)(29,null,d)):g<S?(d=Math.floor(g/D),p?d===1?y?(0,O.localize)(30,null,d):(0,O.localize)(31,null,d):y?(0,O.localize)(32,null,d):(0,O.localize)(33,null,d):d===1?y?(0,O.localize)(34,null,d):(0,O.localize)(35,null,d):y?(0,O.localize)(36,null,d):(0,O.localize)(37,null,d)):g<m?(d=Math.floor(g/S),p?d===1?y?(0,O.localize)(38,null,d):(0,O.localize)(39,null,d):y?(0,O.localize)(40,null,d):(0,O.localize)(41,null,d):d===1?y?(0,O.localize)(42,null,d):(0,O.localize)(43,null,d):y?(0,O.localize)(44,null,d):(0,O.localize)(45,null,d)):(d=Math.floor(g/m),p?d===1?y?(0,O.localize)(46,null,d):(0,O.localize)(47,null,d):y?(0,O.localize)(48,null,d):(0,O.localize)(49,null,d):d===1?y?(0,O.localize)(50,null,d):(0,O.localize)(51,null,d):y?(0,O.localize)(52,null,d):(0,O.localize)(53,null,d))}function l(f,p){const y=Math.abs(f/1e3);return y<1?p?(0,O.localize)(54,null,f):(0,O.localize)(55,null,f):y<k?p?(0,O.localize)(56,null,Math.round(f)/1e3):(0,O.localize)(57,null,Math.round(f)/1e3):y<v?p?(0,O.localize)(58,null,Math.round(f/(1e3*k))):(0,O.localize)(59,null,Math.round(f/(1e3*k))):y<I?p?(0,O.localize)(60,null,Math.round(f/(1e3*v))):(0,O.localize)(61,null,Math.round(f/(1e3*v))):(0,O.localize)(62,null,Math.round(f/(1e3*I)))}function c(f){return f.getFullYear()+"-"+String(f.getMonth()+1).padStart(2,"0")+"-"+String(f.getDate()).padStart(2,"0")+"T"+String(f.getHours()).padStart(2,"0")+":"+String(f.getMinutes()).padStart(2,"0")+":"+String(f.getSeconds()).padStart(2,"0")+"."+(f.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(se[84],oe([7,4]),function(Q,t){return Q.create("vs/base/common/errorMessage",t)}),define(se[36],oe([0,1,20,3,84]),function(Q,t,O,k,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$lj=m,t.$mj=a,t.$nj=l;function I(c,f){return f&&(c.stack||c.stacktrace)?v.localize(0,null,S(c),D(c.stack)||D(c.stacktrace)):S(c)}function D(c){return Array.isArray(c)?c.join(`
`):c}function S(c){return c.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${c.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof c.code=="string"&&typeof c.errno=="number"&&typeof c.syscall=="string"?v.localize(1,null,c.message):c.message||v.localize(2,null)}function m(c=null,f=!1){if(!c)return v.localize(3,null);if(Array.isArray(c)){const p=O.$Hb(c),y=m(p[0],f);return p.length>1?v.localize(4,null,y,p.length):y}if(k.$ag(c))return c;if(c.detail){const p=c.detail;if(p.error)return I(p.error,f);if(p.exception)return I(p.exception,f)}return c.stack?I(c,f):c.message?c.message:v.localize(5,null)}function a(c){const f=c;return f instanceof Error&&Array.isArray(f.actions)}function l(c,f){let p;return typeof c=="string"?p=new Error(c):p=c,p.actions=f,p}}),define(se[85],oe([7,4]),function(Q,t){return Q.create("vs/base/common/jsonErrorMessages",t)}),define(se[86],oe([0,1,85,34]),function(Q,t,O,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$zq=v;function v(I){switch(I){case k.ParseErrorCode.InvalidSymbol:return(0,O.localize)(0,null);case k.ParseErrorCode.InvalidNumberFormat:return(0,O.localize)(1,null);case k.ParseErrorCode.PropertyNameExpected:return(0,O.localize)(2,null);case k.ParseErrorCode.ValueExpected:return(0,O.localize)(3,null);case k.ParseErrorCode.ColonExpected:return(0,O.localize)(4,null);case k.ParseErrorCode.CommaExpected:return(0,O.localize)(5,null);case k.ParseErrorCode.CloseBraceExpected:return(0,O.localize)(6,null);case k.ParseErrorCode.CloseBracketExpected:return(0,O.localize)(7,null);case k.ParseErrorCode.EndOfFileExpected:return(0,O.localize)(8,null);default:return""}}}),define(se[57],oe([0,1,13]),function(Q,t,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.TerminateResponseCode=t.Source=void 0,t.$rm=I,t.$sm=D;var k;(function(S){S[S.stdout=0]="stdout",S[S.stderr=1]="stderr"})(k||(t.Source=k={}));var v;(function(S){S[S.Success=0]="Success",S[S.Unknown=1]="Unknown",S[S.AccessDenied=2]="AccessDenied",S[S.ProcessNotFound=3]="ProcessNotFound"})(v||(t.TerminateResponseCode=v={}));function I(S,...m){const a=m.reduce((f,p)=>(f[p]=!0,f),{}),l=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(S).filter(f=>!a[f]).forEach(f=>{for(let p=0;p<l.length;p++)if(f.search(l[p])!==-1){delete S[f];break}})}function D(S){S&&(delete S.DEBUG,O.$j&&delete S.DYLD_LIBRARY_PATH,O.$k&&delete S.LD_PRELOAD)}}),define(se[87],oe([0,1,12]),function(Q,t,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$4q=k,t.$5q=v,t.$6q=I,t.log=S;function k(a){const l=a;return l&&typeof l.type=="string"&&typeof l.severity=="string"}function v(a){const l=[];let c;try{const f=JSON.parse(a.arguments),p=f[f.length-1];p&&p.__$stack&&(f.pop(),c=p.__$stack),l.push(...f)}catch{l.push("Unable to log remote console arguments",a.arguments)}return{args:l,stack:c}}function I(a){if(typeof a!="string")return I(v(a).stack);const l=a;if(l){const c=D(l),f=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(c||"");if(f&&f.length===4)return{uri:O.URI.file(f[1]),line:Number(f[2]),column:Number(f[3])}}}function D(a){if(!a)return a;const l=a.indexOf(`
`);return l===-1?a:a.substring(0,l)}function S(a,l){const{args:c,stack:f}=v(a),p=typeof c[0]=="string"&&c.length===1;let y=D(f);y&&(y=`(${y.trim()})`);let N=[];if(typeof c[0]=="string"?y&&p?N=[`%c[${l}] %c${c[0]} %c${y}`,m("blue"),m(""),m("grey")]:N=[`%c[${l}] %c${c[0]}`,m("blue"),m(""),...c.slice(1)]:N=[`%c[${l}]%`,m("blue"),...c],y&&!p&&N.push(y),typeof console[a.severity]!="function")throw new Error("Unknown console method");console[a.severity].apply(console,N)}function m(a){return`color: ${a}`}}),define(se[47],oe([0,1,14,12,171]),function(Q,t,O,k,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$8h=I,t.$9h=D,t.$0h=m;function I(a){return JSON.stringify(a,S)}function D(a){let l=JSON.parse(a);return l=m(l),l}function S(a,l){return l instanceof RegExp?{$mid:v.MarshalledId.Regexp,source:l.source,flags:l.flags}:l}function m(a,l=0){if(!a||l>200)return a;if(typeof a=="object"){switch(a.$mid){case v.MarshalledId.Uri:return k.URI.revive(a);case v.MarshalledId.Regexp:return new RegExp(a.source,a.flags);case v.MarshalledId.Date:return new Date(a.source)}if(a instanceof O.$Je||a instanceof Uint8Array)return a;if(Array.isArray(a))for(let c=0;c<a.length;++c)a[c]=m(a[c],l+1);else for(const c in a)Object.hasOwnProperty.call(a,c)&&(a[c]=m(a[c],l+1))}return a}}),define(se[88],oe([0,1,75,15,13,12]),function(Q,t,O,k,v,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$dE=l;class D{constructor(f,p,y){this.id=f,this.dependencies=p,this.callback=y}}class S{static{this.INSTANCE=new S}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(f,p,y)=>{typeof f!="string"&&(y=p,p=f,f=null),(typeof p!="object"||!Array.isArray(p))&&(y=p,p=null),this.c.push(new D(f,p,y))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(f){if(f.startsWith(window.location.origin)||f.startsWith("vscode-file://vscode-app"))return f;throw new Error(`[trusted_script_src] Invalid script url: ${f}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(f){return f}})))}async load(f){this.g();const p=await(this.a?this.i(f):this.b?this.h(f):this.j(f));if(!p)throw new Error(`Did not receive a define call from script ${f}`);if(Array.isArray(p.dependencies)&&p.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${f}. The dependencies are: ${p.dependencies.join(", ")}`);return typeof p.callback=="function"?p.callback([]):p.callback}h(f){return new Promise((p,y)=>{const N=document.createElement("script");N.setAttribute("async","async"),N.setAttribute("type","text/javascript");const g=()=>{N.removeEventListener("load",d),N.removeEventListener("error",$)},d=P=>{g(),p(this.c.pop())},$=P=>{g(),y(P)};N.addEventListener("load",d),N.addEventListener("error",$),this.f&&(f=this.f.createScriptURL(f)),N.setAttribute("src",f),window.document.getElementsByTagName("head")[0].appendChild(N)})}i(f){return new Promise((p,y)=>{try{this.f&&(f=this.f.createScriptURL(f)),importScripts(f),p(this.c.pop())}catch(N){y(N)}})}async j(f){try{const p=globalThis._VSCODE_NODE_MODULES.fs,y=globalThis._VSCODE_NODE_MODULES.vm,N=globalThis._VSCODE_NODE_MODULES.module,g=I.URI.parse(f).fsPath,d=p.readFileSync(g).toString(),$=N.wrap(d.replace(/^#!.*/,""));return new y.Script($).runInThisContext().apply(),this.c.pop()}catch(p){throw p}}}const m=new Map;let a={};typeof globalThis.require=="object"&&(a=globalThis.require.paths??{});async function l(c,f,p){if(O.$T){p===void 0&&(p=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),a[c]&&(c=a[c]);const y=`${c}/${f}`;if(m.has(y))return m.get(y);let N;if(/^\w[\w\d+.-]*:\/\//.test(y))N=y;else{const P=`${p&&!v.$o?k.$Rg:k.$Qg}/${y}`;N=k.$Ug.asBrowserUri(P).toString(!0)}const g=S.INSTANCE.load(N);return m.set(y,g),g}else return await new Promise((y,N)=>{Q([c],y,N)})}}),define(se[89],oe([0,1,35,48,29,81,13]),function(Q,t,O,k,v,I,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Jn=void 0,t.$Kn=m,t.$Ln=c,t.$Mn=f,t.$Jn=new class{c(p){return this.a||(this.a=k.$Gi.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(p)}value(){if(this.b===void 0){let p=0,y=0;const N=(0,O.networkInterfaces)();for(const g in N){const d=N[g];if(d)for(const{mac:$,internal:P}of d)P||(y+=1,this.c($.toUpperCase())&&(p+=1))}this.b=y>0?p/y:0}return this.b}};let S;async function m(p){return S||(S=(async()=>await a(p)||v.$Wg())()),S}async function a(p){try{const y=await new Promise((g,d)=>{Q(["crypto"],g,d)}),N=(0,I.$In)();return y.createHash("sha256").update(N,"utf8").digest("hex")}catch(y){p(y);return}}const l="Software\\Microsoft\\SQMClient";async function c(p){if(D.$i){const y=await new Promise((N,g)=>{Q(["@vscode/windows-registry"],N,g)});try{return y.GetStringRegKey("HKEY_LOCAL_MACHINE",l,"MachineId")||""}catch(N){return p(N),""}}return""}async function f(p){try{return await(await new Promise((g,d)=>{Q(["@vscode/deviceid"],g,d)})).getDeviceId()}catch(y){return p(y),""}}}),define(se[90],oe([0,1,35,16,25]),function(Q,t,O,k,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$pm=$,t.$qm=P;const I=/^\d+$/,D=/^Microsoft.PowerShell_.*/,S=/^Microsoft.PowerShellPreview_.*/;var m;(function(w){w[w.x64=0]="x64",w[w.x86=1]="x86",w[w.ARM=2]="ARM"})(m||(m={}));let a;switch(process.arch){case"ia32":a=m.x86;break;case"arm":case"arm64":a=m.ARM;break;default:a=m.x64;break}let l;process.env.PROCESSOR_ARCHITEW6432?l=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?m.ARM:m.x64:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?l=m.ARM:process.env.PROCESSOR_ARCHITECTURE==="X86"?l=m.x86:l=m.x64;class c{constructor(u,i,o){this.exePath=u,this.displayName=i,this.a=o}async exists(){return this.a===void 0&&(this.a=await v.SymlinkSupport.existsFile(this.exePath)),this.a}}function f({useAlternateBitness:w=!1}={}){return w?a===m.x64?process.env["ProgramFiles(x86)"]||null:l===m.x64&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function p({useAlternateBitness:w=!1,findPreview:u=!1}={}){const i=f({useAlternateBitness:w});if(!i)return null;const o=k.$jc(i,"PowerShell");if(!await v.SymlinkSupport.existsDirectory(o))return null;let s=-1,e=null;for(const h of await v.Promises.readdir(o)){let E=-1;if(u){const A=h.indexOf("-");if(A<0)continue;const T=h.substring(0,A);if(!I.test(T)||h.substring(A+1)!=="preview")continue;E=parseInt(T,10)}else{if(!I.test(h))continue;E=parseInt(h,10)}if(E<=s)continue;const R=k.$jc(o,h,"pwsh.exe");await v.SymlinkSupport.existsFile(R)&&(e=R,s=E)}if(!e)return null;const n=i.includes("x86")?" (x86)":"",r=u?" Preview":"";return new c(e,`PowerShell${r}${n}`,!0)}async function y({findPreview:w}={}){if(!process.env.LOCALAPPDATA)return null;const u=k.$jc(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await v.SymlinkSupport.existsDirectory(u))return null;const{pwshMsixDirRegex:i,pwshMsixName:o}=w?{pwshMsixDirRegex:S,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:D,pwshMsixName:"PowerShell (Store)"};for(const s of await v.Promises.readdir(u))if(i.test(s)){const e=k.$jc(u,s,"pwsh.exe");return new c(e,o)}return null}function N(){const w=k.$jc(O.homedir(),".dotnet","tools","pwsh.exe");return new c(w,".NET Core PowerShell Global Tool")}function g(){const w=k.$jc(process.env.windir,a===m.x86&&l!==m.x86?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new c(w,"Windows PowerShell",!0)}async function*d(){let w=await p();w&&(yield w),w=await p({useAlternateBitness:!0}),w&&(yield w),w=await y(),w&&(yield w),w=N(),w&&(yield w),w=await p({findPreview:!0}),w&&(yield w),w=await y({findPreview:!0}),w&&(yield w),w=await p({useAlternateBitness:!0,findPreview:!0}),w&&(yield w),w=g(),w&&(yield w)}async function*$(){for await(const w of d())await w.exists()&&(yield w)}async function P(){for await(const w of $())return w;return null}}),define(se[58],oe([0,1,16,13,37,57,3,25]),function(Q,t,O,k,v,I,D,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.win32=t.TerminateResponseCode=t.Source=void 0,t.$tm=m,t.$um=a,Object.defineProperty(t,"Source",{enumerable:!0,get:function(){return I.Source}}),Object.defineProperty(t,"TerminateResponseCode",{enumerable:!0,get:function(){return I.TerminateResponseCode}});function m(c=v.env){return c.comspec||"cmd.exe"}function a(c){let f=[],p=!1;const y=function(N){if(p){f.push(N);return}(!c.send(N,d=>{if(d&&console.error(d),p=!1,f.length>0){const $=f.slice(0);f=[],$.forEach(P=>y(P))}})||k.$i)&&(p=!0)};return{send:y}}var l;(function(c){async function f(p,y,N){if(O.$ic(p))return p;if(y===void 0&&(y=v.cwd()),O.$mc(p)!=="."||(N===void 0&&D.$ag(v.env.PATH)&&(N=v.env.PATH.split(O.$tc)),N===void 0||N.length===0))return O.$jc(y,p);async function d($){if(await S.Promises.exists($)){let P;try{P=await S.Promises.stat($)}catch(w){w.message.startsWith("EACCES")&&(P=await S.Promises.lstat($))}return P?!P.isDirectory():!1}return!1}for(const $ of N){let P;if(O.$ic($)?P=O.$jc($,p):P=O.$jc(y,$,p),await d(P))return P;let w=P+".com";if(await d(w)||(w=P+".exe",await d(w)))return w}return O.$jc(y,p)}c.findExecutable=f})(l||(t.win32=l={}))}),define(se[91],oe([0,1,35,13,90,58]),function(Q,t,O,k,v,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$vm=D;async function D(c,f){return c===k.OperatingSystem.Windows?k.$i?l():I.$tm(f):m(c,f)}let S=null;function m(c,f){if(k.$k&&c===k.OperatingSystem.Macintosh||k.$j&&c===k.OperatingSystem.Linux)return"/bin/bash";if(!S){let p;if(k.$i)p="/bin/bash";else{if(p=f.SHELL,!p)try{p=(0,O.userInfo)().shell}catch{}p||(p="sh"),p==="/bin/false"&&(p="/bin/bash")}S=p}return S}let a=null;async function l(){return a||(a=(await(0,v.$qm)()).exePath),a}});var we=this&&this.__decorate||function(Q,t,O,k){var v=arguments.length,I=v<3?t:k===null?k=Object.getOwnPropertyDescriptor(t,O):k,D;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")I=Reflect.decorate(Q,t,O,k);else for(var S=Q.length-1;S>=0;S--)(D=Q[S])&&(I=(v<3?D(I):v>3?D(t,O,I):D(t,O))||I);return v>3&&I&&Object.defineProperty(t,O,I),I};define(se[59],oe([0,1,20,8,14,22,55,9,5,2,47,32,3]),function(Q,t,O,k,v,I,D,S,m,a,l,c,f){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ji=t.ProxyChannel=t.$ii=t.$fi=t.$ei=t.$di=t.RequestInitiator=t.$ci=t.$_h=t.$$h=void 0,t.$ai=r,t.$bi=h,t.$gi=M,t.$hi=J;var p;(function(B){B[B.Promise=100]="Promise",B[B.PromiseCancel=101]="PromiseCancel",B[B.EventListen=102]="EventListen",B[B.EventDispose=103]="EventDispose"})(p||(p={}));function y(B){switch(B){case p.Promise:return"req";case p.PromiseCancel:return"cancel";case p.EventListen:return"subscribe";case p.EventDispose:return"unsubscribe"}}var N;(function(B){B[B.Initialize=200]="Initialize",B[B.PromiseSuccess=201]="PromiseSuccess",B[B.PromiseError=202]="PromiseError",B[B.PromiseErrorObj=203]="PromiseErrorObj",B[B.EventFire=204]="EventFire"})(N||(N={}));function g(B){switch(B){case N.Initialize:return"init";case N.PromiseSuccess:return"reply:";case N.PromiseError:case N.PromiseErrorObj:return"replyErr:";case N.EventFire:return"event:"}}var d;(function(B){B[B.Uninitialized=0]="Uninitialized",B[B.Idle=1]="Idle"})(d||(d={}));function $(B){let U=0;for(let G=0;;G+=7){const Z=B.read(1);if(U|=(Z.buffer[0]&127)<<G,!(Z.buffer[0]&128))return U}}const P=s(0);function w(B,U){if(U===0){B.write(P);return}let G=0;for(let Y=U;Y!==0;Y=Y>>>7)G++;const Z=v.$Je.alloc(G);for(let Y=0;U!==0;Y++)Z.buffer[Y]=U&127,U=U>>>7,U>0&&(Z.buffer[Y]|=128);B.write(Z)}class u{constructor(U){this.b=U,this.a=0}read(U){const G=this.b.slice(this.a,this.a+U);return this.a+=G.byteLength,G}}t.$$h=u;class i{constructor(){this.a=[]}get buffer(){return v.$Je.concat(this.a)}write(U){this.a.push(U)}}t.$_h=i;var o;(function(B){B[B.Undefined=0]="Undefined",B[B.String=1]="String",B[B.Buffer=2]="Buffer",B[B.VSBuffer=3]="VSBuffer",B[B.Array=4]="Array",B[B.Object=5]="Object",B[B.Int=6]="Int"})(o||(o={}));function s(B){const U=v.$Je.alloc(1);return U.writeUInt8(B,0),U}const e={Undefined:s(o.Undefined),String:s(o.String),Buffer:s(o.Buffer),VSBuffer:s(o.VSBuffer),Array:s(o.Array),Object:s(o.Object),Uint:s(o.Int)},n=typeof Buffer<"u";function r(B,U){if(typeof U>"u")B.write(e.Undefined);else if(typeof U=="string"){const G=v.$Je.fromString(U);B.write(e.String),w(B,G.byteLength),B.write(G)}else if(n&&Buffer.isBuffer(U)){const G=v.$Je.wrap(U);B.write(e.Buffer),w(B,G.byteLength),B.write(G)}else if(U instanceof v.$Je)B.write(e.VSBuffer),w(B,U.byteLength),B.write(U);else if(Array.isArray(U)){B.write(e.Array),w(B,U.length);for(const G of U)r(B,G)}else if(typeof U=="number"&&(U|0)===U)B.write(e.Uint),w(B,U);else{const G=v.$Je.fromString(JSON.stringify(U));B.write(e.Object),w(B,G.byteLength),B.write(G)}}function h(B){switch(B.read(1).readUInt8(0)){case o.Undefined:return;case o.String:return B.read($(B)).toString();case o.Buffer:return B.read($(B)).buffer;case o.VSBuffer:return B.read($(B));case o.Array:{const G=$(B),Z=[];for(let Y=0;Y<G;Y++)Z.push(h(B));return Z}case o.Object:return JSON.parse(B.read($(B)).toString());case o.Int:return $(B)}}class E{constructor(U,G,Z=null,Y=1e3){this.h=U,this.j=G,this.k=Z,this.l=Y,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(F=>this.q(F)),this.m({type:N.Initialize})}registerChannel(U,G){this.b.set(U,G),setTimeout(()=>this.w(U),0)}m(U){switch(U.type){case N.Initialize:{const G=this.o([U.type]);this.k?.logOutgoing(G,0,R.OtherSide,g(U.type));return}case N.PromiseSuccess:case N.PromiseError:case N.EventFire:case N.PromiseErrorObj:{const G=this.o([U.type,U.id],U.data);this.k?.logOutgoing(G,U.id,R.OtherSide,g(U.type),U.data);return}}}o(U,G=void 0){const Z=new i;return r(Z,U),r(Z,G),this.p(Z.buffer)}p(U){try{return this.h.send(U),U.byteLength}catch{return 0}}q(U){const G=new u(U),Z=h(G),Y=h(G),F=Z[0];switch(F){case p.Promise:return this.k?.logIncoming(U.byteLength,Z[1],R.OtherSide,`${y(F)}: ${Z[2]}.${Z[3]}`,Y),this.s({type:F,id:Z[1],channelName:Z[2],name:Z[3],arg:Y});case p.EventListen:return this.k?.logIncoming(U.byteLength,Z[1],R.OtherSide,`${y(F)}: ${Z[2]}.${Z[3]}`,Y),this.t({type:F,id:Z[1],channelName:Z[2],name:Z[3],arg:Y});case p.PromiseCancel:return this.k?.logIncoming(U.byteLength,Z[1],R.OtherSide,`${y(F)}`),this.u({type:F,id:Z[1]});case p.EventDispose:return this.k?.logIncoming(U.byteLength,Z[1],R.OtherSide,`${y(F)}`),this.u({type:F,id:Z[1]})}}s(U){const G=this.b.get(U.channelName);if(!G){this.v(U);return}const Z=new I.$se;let Y;try{Y=G.call(this.j,U.name,U.arg,Z.token)}catch(H){Y=Promise.reject(H)}const F=U.id;Y.then(H=>{this.m({id:F,data:H,type:N.PromiseSuccess})},H=>{H instanceof Error?this.m({id:F,data:{message:H.message,name:H.name,stack:H.stack?H.stack.split?H.stack.split(`
`):H.stack:void 0},type:N.PromiseError}):this.m({id:F,data:H,type:N.PromiseErrorObj})}).finally(()=>{z.dispose(),this.d.delete(U.id)});const z=(0,a.$Sc)(()=>Z.cancel());this.d.set(U.id,z)}t(U){const G=this.b.get(U.channelName);if(!G){this.v(U);return}const Z=U.id,F=G.listen(this.j,U.name,U.arg)(z=>this.m({id:Z,data:z,type:N.EventFire}));this.d.set(U.id,F)}u(U){const G=this.d.get(U.id);G&&(G.dispose(),this.d.delete(U.id))}v(U){let G=this.g.get(U.channelName);G||(G=[],this.g.set(U.channelName,G));const Z=setTimeout(()=>{console.error(`Unknown channel: ${U.channelName}`),U.type===p.Promise&&this.m({id:U.id,data:{name:"Unknown channel",message:`Channel name '${U.channelName}' timed out after ${this.l}ms`,stack:void 0},type:N.PromiseError})},this.l);G.push({request:U,timeoutTimer:Z})}w(U){const G=this.g.get(U);if(G){for(const Z of G)switch(clearTimeout(Z.timeoutTimer),Z.request.type){case p.Promise:this.s(Z.request);break;case p.EventListen:this.t(Z.request);break}this.g.delete(U)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,a.$Pc)(this.d.values()),this.d.clear()}}t.$ci=E;var R;(function(B){B[B.LocalSide=0]="LocalSide",B[B.OtherSide=1]="OtherSide"})(R||(t.RequestInitiator=R={}));class A{constructor(U,G=null){this.l=U,this.a=!1,this.b=d.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new m.$he,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(Z=>this.s(Z)),this.j=G}getChannel(U){const G=this;return{call(Z,Y,F){return G.a?Promise.reject(new S.$5):G.m(U,Z,Y,F)},listen(Z,Y){return G.a?m.Event.None:G.o(U,Z,Y)}}}m(U,G,Z,Y=I.CancellationToken.None){const F=this.g++,z=p.Promise,H={id:F,type:z,channelName:U,name:G,arg:Z};if(Y.isCancellationRequested)return Promise.reject(new S.$5);let V;return new Promise((L,j)=>{if(Y.isCancellationRequested)return j(new S.$5);const q=()=>{const fe=he=>{switch(he.type){case N.PromiseSuccess:this.f.delete(F),L(he.data);break;case N.PromiseError:{this.f.delete(F);const ve=new Error(he.data.message);ve.stack=Array.isArray(he.data.stack)?he.data.stack.join(`
`):he.data.stack,ve.name=he.data.name,j(ve);break}case N.PromiseErrorObj:this.f.delete(F),j(he.data);break}};this.f.set(F,fe),this.p(H)};let X=null;this.b===d.Idle?q():(X=(0,k.$nh)(fe=>this.u()),X.then(()=>{X=null,q()}));const K=()=>{X?(X.cancel(),X=null):this.p({id:F,type:p.PromiseCancel}),j(new S.$5)},re=Y.onCancellationRequested(K);V=(0,a.$Rc)((0,a.$Sc)(K),re),this.d.add(V)}).finally(()=>{V.dispose(),this.d.delete(V)})}o(U,G,Z){const Y=this.g++,F=p.EventListen,z={id:Y,type:F,channelName:U,name:G,arg:Z};let H=null;const V=new m.$he({onWillAddFirstListener:()=>{H=(0,k.$nh)(L=>this.u()),H.then(()=>{H=null,this.d.add(V),this.p(z)})},onDidRemoveLastListener:()=>{H?(H.cancel(),H=null):(this.d.delete(V),this.p({id:Y,type:p.EventDispose}))}}),b=L=>V.fire(L.data);return this.f.set(Y,b),V.event}p(U){switch(U.type){case p.Promise:case p.EventListen:{const G=this.q([U.type,U.id,U.channelName,U.name],U.arg);this.j?.logOutgoing(G,U.id,R.LocalSide,`${y(U.type)}: ${U.channelName}.${U.name}`,U.arg);return}case p.PromiseCancel:case p.EventDispose:{const G=this.q([U.type,U.id]);this.j?.logOutgoing(G,U.id,R.LocalSide,y(U.type));return}}}q(U,G=void 0){const Z=new i;return r(Z,U),r(Z,G),this.r(Z.buffer)}r(U){try{return this.l.send(U),U.byteLength}catch{return 0}}s(U){const G=new u(U),Z=h(G),Y=h(G),F=Z[0];switch(F){case N.Initialize:return this.j?.logIncoming(U.byteLength,0,R.LocalSide,g(F)),this.t({type:Z[0]});case N.PromiseSuccess:case N.PromiseError:case N.EventFire:case N.PromiseErrorObj:return this.j?.logIncoming(U.byteLength,Z[1],R.LocalSide,g(F),Y),this.t({type:Z[0],id:Z[1],data:Y})}}t(U){if(U.type===N.Initialize){this.b=d.Idle,this.k.fire();return}this.f.get(U.id)?.(U)}get onDidInitializePromise(){return m.Event.toPromise(this.onDidInitialize)}u(){return this.b===d.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,a.$Pc)(this.d.values()),this.d.clear()}}t.$di=A,we([D.$5h],A.prototype,"onDidInitializePromise",null);class T{get connections(){const U=[];return this.f.forEach(G=>U.push(G)),U}constructor(U,G,Z){this.a=new Map,this.f=new Set,this.g=new m.$he,this.onDidAddConnection=this.g.event,this.h=new m.$he,this.onDidRemoveConnection=this.h.event,this.j=new a.$Tc,this.j.add(U(({protocol:Y,onDidClientDisconnect:F})=>{const z=m.Event.once(Y.onMessage);this.j.add(z(H=>{const V=new u(H),b=h(V),L=new E(Y,b,G,Z),j=new A(Y,G);this.a.forEach((X,K)=>L.registerChannel(K,X));const q={channelServer:L,channelClient:j,ctx:b};this.f.add(q),this.g.fire(q),this.j.add(F(()=>{L.dispose(),j.dispose(),this.f.delete(q),this.h.fire(q)}))}))}))}getChannel(U,G){const Z=this;return{call(Y,F,z){let H;if((0,f.$og)(G)){const b=(0,O.$3b)(Z.connections.filter(G));H=b?Promise.resolve(b):m.Event.toPromise(m.Event.filter(Z.onDidAddConnection,G))}else H=G.routeCall(Z,Y,F);const V=H.then(b=>b.channelClient.getChannel(U));return M(V).call(Y,F,z)},listen(Y,F){if((0,f.$og)(G))return Z.k(U,G,Y,F);const z=G.routeEvent(Z,Y,F).then(H=>H.channelClient.getChannel(U));return M(z).listen(Y,F)}}}k(U,G,Z,Y){const F=this;let z;const H=new m.$he({onWillAddFirstListener:()=>{z=new a.$Tc;const V=new m.$ne,b=new Map,L=q=>{const K=q.channelClient.getChannel(U).listen(Z,Y),re=V.add(K);b.set(q,re)},j=q=>{const X=b.get(q);X&&(X.dispose(),b.delete(q))};F.connections.filter(G).forEach(L),m.Event.filter(F.onDidAddConnection,G)(L,void 0,z),F.onDidRemoveConnection(j,void 0,z),V.event(H.fire,H,z),z.add(V)},onDidRemoveLastListener:()=>{z?.dispose(),z=void 0}});return H.event}registerChannel(U,G){this.a.set(U,G);for(const Z of this.f)Z.channelServer.registerChannel(U,G)}dispose(){this.j.dispose();for(const U of this.f)U.channelClient.dispose(),U.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}t.$ei=T;class C{constructor(U,G,Z=null){const Y=new i;r(Y,G),U.send(Y.buffer),this.a=new A(U,Z),this.d=new E(U,G,Z)}getChannel(U){return this.a.getChannel(U)}registerChannel(U,G){this.d.registerChannel(U,G)}dispose(){this.a.dispose(),this.d.dispose()}}t.$fi=C;function M(B){return{call(U,G,Z){return B.then(Y=>Y.call(U,G,Z))},listen(U,G){const Z=new m.$qe;return B.then(Y=>Z.input=Y.listen(U,G)),Z.event}}}function J(B){let U=!1;return{call(G,Z,Y){return U?B.call(G,Z,Y):(0,k.$Bh)(0).then(()=>U=!0).then(()=>B.call(G,Z,Y))},listen(G,Z){if(U)return B.listen(G,Z);const Y=new m.$qe;return(0,k.$Bh)(0).then(()=>U=!0).then(()=>Y.input=B.listen(G,Z)),Y.event}}}class ae{constructor(U){this.a=U}routeCall(U){return this.b(U)}routeEvent(U){return this.b(U)}async b(U){for(const G of U.connections)if(await Promise.resolve(this.a(G.ctx)))return Promise.resolve(G);return await m.Event.toPromise(U.onDidAddConnection),await this.b(U)}}t.$ii=ae;var ie;(function(B){function U(F,z,H){const V=F,b=H&&H.disableMarshalling,L=new Map;for(const j in V)Z(j)&&L.set(j,m.Event.buffer(V[j],!0,void 0,z));return new class{listen(j,q,X){const K=L.get(q);if(K)return K;const re=V[q];if(typeof re=="function"){if(Y(q))return re.call(V,X);if(Z(q))return L.set(q,m.Event.buffer(V[q],!0,void 0,z)),L.get(q)}throw new S.$bb(`Event not found: ${q}`)}call(j,q,X){const K=V[q];if(typeof K=="function"){if(!b&&Array.isArray(X))for(let fe=0;fe<X.length;fe++)X[fe]=(0,l.$0h)(X[fe]);let re=K.apply(V,X);return re instanceof Promise||(re=Promise.resolve(re)),re}throw new S.$bb(`Method not found: ${q}`)}}}B.fromService=U;function G(F,z){const H=z&&z.disableMarshalling;return new Proxy({},{get(V,b){if(typeof b=="string")return z?.properties?.has(b)?z.properties.get(b):Y(b)?function(L){return F.listen(b,L)}:Z(b)?F.listen(b):async function(...L){let j;z&&!(0,f.$jg)(z.context)?j=[z.context,...L]:j=L;const q=await F.call(b,j);return H?q:(0,l.$0h)(q)};throw new S.$bb(`Property not found: ${String(b)}`)}})}B.toService=G;function Z(F){return F[0]==="o"&&F[1]==="n"&&c.$Af(F.charCodeAt(2))}function Y(F){return/^onDynamic/.test(F)&&c.$Af(F.charCodeAt(9))}})(ie||(t.ProxyChannel=ie={}));const ce=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function ue(B){if(Array.isArray(B))return B;if(B&&typeof B=="object"&&typeof B.toString=="function"){const U=B.toString();if(U!=="[object Object]")return U}return B}function le(B){return Array.isArray(B)?B.map(ue):ue(B)}function x(B,U,G,Z,Y,F,z){z=le(z);const H=ce[Y],V=H[Z%H.length];let b=[`%c[${B}]%c[${String(U).padStart(7," ")}]%c[len: ${String(G).padStart(5," ")}]%c${String(Z).padStart(5," ")} - ${F}`,"color: darkgreen","color: grey","color: grey",`color: ${V}`];/\($/.test(F)?(b=b.concat(z),b.push(")")):b.push(z),console.log.apply(console,b)}class _{constructor(U,G){this.d=U,this.f=G,this.a=0,this.b=0}logOutgoing(U,G,Z,Y,F){this.b+=U,x(this.d,this.b,U,G,Z,Y,F)}logIncoming(U,G,Z,Y,F){this.a+=U,x(this.f,this.a,U,G,Z,Y,F)}}t.$ji=_}),define(se[92],oe([0,1,60,8,14,22,87,9,5,2,28,58,57,59]),function(Q,t,O,k,v,I,D,S,m,a,l,c,f,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$9q=t.$8q=void 0;class y extends p.$ci{constructor(d){super({send:$=>{try{process.send?.($.buffer.toString("base64"))}catch{}},onMessage:m.Event.fromNodeEventEmitter(process,"message",$=>v.$Je.wrap(Buffer.from($,"base64")))},d),process.once("disconnect",()=>this.dispose())}}t.$8q=y;class N{constructor(d,$){this.i=d,this.j=$,this.c=new Set,this.g=new Map,this.h=new m.$he,this.onDidProcessExit=this.h.event;const P=$&&$.timeout?$.timeout:6e4;this.b=new k.$xh(P),this.d=null,this.f=null}getChannel(d){const $=this;return{call(P,w,u){return $.k(d,P,w,u)},listen(P,w){return $.l(d,P,w)}}}k(d,$,P,w=I.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(w.isCancellationRequested)return Promise.reject(S.$6());this.b.cancel();const u=this.n(d),i=(0,k.$nh)(e=>u.call($,P,e)),o=w.onCancellationRequested(()=>i.cancel()),s=(0,a.$Sc)(()=>i.cancel());return this.c.add(s),i.finally(()=>{o.dispose(),this.c.delete(s),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),i}l(d,$,P){if(!this.b)return m.Event.None;this.b.cancel();let w;const u=new m.$he({onWillAddFirstListener:()=>{w=this.n(d).listen($,P)(u.fire,u),this.c.add(w)},onDidRemoveLastListener:()=>{this.c.delete(w),w.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return u.event}get m(){if(!this.f){const d=this.j&&this.j.args?this.j.args:[],$=Object.create(null);$.env={...(0,l.$9n)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&($.env={...$.env,...this.j.env}),this.j&&this.j.freshExecArgv&&($.execArgv=[]),this.j&&typeof this.j.debug=="number"&&($.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&($.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),$.execArgv===void 0&&($.execArgv=process.execArgv.filter(r=>!/^--inspect(-brk)?=/.test(r)).filter(r=>!r.startsWith("--vscode-"))),(0,f.$sm)($.env),this.d=(0,O.fork)(this.i,d,$);const P=new m.$he,u=m.Event.fromNodeEventEmitter(this.d,"message",r=>r)(r=>{if((0,D.$4q)(r)){(0,D.log)(r,`IPC Library: ${this.j.serverName}`);return}P.fire(v.$Je.wrap(Buffer.from(r,"base64")))}),i=this.j.useQueue?(0,c.$um)(this.d):this.d,o=r=>this.d&&this.d.connected&&i.send(r.buffer.toString("base64")),s=P.event,e={send:o,onMessage:s};this.f=new p.$di(e);const n=()=>this.o();process.once("exit",n),this.d.on("error",r=>console.warn('IPC "'+this.j.serverName+'" errored with '+r)),this.d.on("exit",(r,h)=>{process.removeListener("exit",n),u.dispose(),this.c.forEach(E=>(0,a.$Pc)(E)),this.c.clear(),r!==0&&h!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+r+" and signal "+h),this.b?.cancel(),this.o(),this.h.fire({code:r,signal:h})})}return this.f}n(d){let $=this.g.get(d);return $||($=this.m.getChannel(d),this.g.set(d,$)),$}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}t.$9q=N}),define(se[93],oe([0,1,8,5,2,47,3]),function(Q,t,O,k,v,I,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$6p=t.$5p=t.StorageState=t.StorageHint=void 0,t.$4p=m;var S;(function(f){f[f.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",f[f.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(S||(t.StorageHint=S={}));function m(f){const p=f;return p?.changed instanceof Map||p?.deleted instanceof Set}var a;(function(f){f[f.None=0]="None",f[f.Initialized=1]="Initialized",f[f.Closed=2]="Closed"})(a||(t.StorageState=a={}));class l extends v.$Uc{static{this.a=100}constructor(p,y=Object.create(null)){super(),this.r=p,this.s=y,this.b=this.B(new k.$ke),this.onDidChangeStorage=this.b.event,this.c=a.None,this.f=new Map,this.g=this.B(new O.$yh(l.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(p=>this.u(p)))}u(p){this.b.pause();try{p.changed?.forEach((y,N)=>this.w(N,y)),p.deleted?.forEach(y=>this.w(y,void 0))}finally{this.b.resume()}}w(p,y){if(this.c===a.Closed)return;let N=!1;(0,D.$jg)(y)?N=this.f.delete(p):this.f.get(p)!==y&&(this.f.set(p,y),N=!0),N&&this.b.fire({key:p,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===a.None&&(this.c=a.Initialized,this.s.hint!==S.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(p,y){const N=this.f.get(p);return(0,D.$jg)(N)?y:N}getBoolean(p,y){const N=this.get(p);return(0,D.$jg)(N)?y:N==="true"}getNumber(p,y){const N=this.get(p);return(0,D.$jg)(N)?y:parseInt(N,10)}getObject(p,y){const N=this.get(p);return(0,D.$jg)(N)?y:(0,I.$9h)(N)}async set(p,y,N=!1){if(this.c===a.Closed)return;if((0,D.$jg)(y))return this.delete(p,N);const g=(0,D.$cg)(y)||Array.isArray(y)?(0,I.$8h)(y):String(y);if(this.f.get(p)!==g)return this.f.set(p,g),this.j.set(p,g),this.h.delete(p),this.b.fire({key:p,external:N}),this.D()}async delete(p,y=!1){if(!(this.c===a.Closed||!this.f.delete(p)))return this.h.has(p)||this.h.add(p),this.j.delete(p),this.b.fire({key:p,external:y}),this.D()}async optimize(){if(this.c!==a.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=a.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const p={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(p).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(p){if(!(this.c===a.Closed||this.m))return this.D(p)}async D(p){return this.s.hint===S.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),p)}async whenFlushed(){if(this.z)return new Promise(p=>this.n.push(p))}isInMemory(){return this.s.hint===S.STORAGE_IN_MEMORY}}t.$5p=l;class c{constructor(){this.onDidChangeItemsExternal=k.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(p){p.insert?.forEach((y,N)=>this.a.set(N,y)),p.delete?.forEach(y=>this.a.delete(y))}async optimize(){}async close(){}}t.$6p=c}),define(se[94],oe([7,4]),function(Q,t){return Q.create("vs/base/node/zip",t)}),define(se[49],oe([0,1,61,8,16,3,25,94]),function(Q,t,O,k,v,I,D,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$pq=t.$oq=void 0,t.zip=g,t.$rq=d,t.$sq=P,t.$oq="end of central directory record signature not found";const m=new RegExp(t.$oq);class a extends Error{constructor(u,i){let o=i.message;switch(u){case"CorruptZip":o=`Corrupt ZIP: ${o}`;break}super(o),this.type=u,this.cause=i}}t.$pq=a;function l(w){const u=w.externalFileAttributes>>16||33188;return[448,56,7].map(i=>u&i).reduce((i,o)=>i+o,u&61440)}function c(w){if(w instanceof a)return w;let u;return m.test(w.message)&&(u="CorruptZip"),new a(u,w)}function f(w,u,i,o,s,e){const n=v.$mc(u),r=v.$jc(o,n);if(!r.startsWith(o))return Promise.reject(new Error(S.localize(0,null,u)));const h=v.$jc(o,u);let E;return e.onCancellationRequested(()=>{E?.destroy()}),Promise.resolve(D.Promises.mkdir(r,{recursive:!0})).then(()=>new Promise((R,A)=>{if(!e.isCancellationRequested)try{E=(0,O.createWriteStream)(h,{mode:i}),E.once("close",()=>R()),E.once("error",A),w.once("error",A),w.pipe(E)}catch(T){A(T)}}))}function p(w,u,i,o){let s=(0,k.$nh)(()=>Promise.resolve()),e=0;const n=o.onCancellationRequested(()=>{s.cancel(),w.close()});return new Promise((r,h)=>{const E=new k.$vh,R=A=>{A.isCancellationRequested||(e++,w.readEntry())};w.once("error",h),w.once("close",()=>s.then(()=>{o.isCancellationRequested||w.entryCount===e?r():h(new a("Incomplete",new Error(S.localize(1,null,e,w.entryCount))))},h)),w.readEntry(),w.on("entry",A=>{if(o.isCancellationRequested)return;if(!i.sourcePathRegex.test(A.fileName)){R(o);return}const T=A.fileName.replace(i.sourcePathRegex,"");if(/\/$/.test(T)){const J=v.$jc(u,T);s=(0,k.$nh)(ae=>D.Promises.mkdir(J,{recursive:!0}).then(()=>R(ae)).then(void 0,h));return}const C=N(w,A),M=l(A);s=(0,k.$nh)(J=>E.queue(()=>C.then(ae=>f(ae,T,M,u,i,J).then(()=>R(J)))).then(null,h))})}).finally(()=>n.dispose())}async function y(w,u=!1){const{open:i}=await new Promise((o,s)=>{Q(["yauzl"],o,s)});return new Promise((o,s)=>{i(w,u?{lazyEntries:!0}:void 0,(e,n)=>{e?s(c(e)):o((0,I.$lg)(n))})})}function N(w,u){return new Promise((i,o)=>{w.openReadStream(u,(s,e)=>{s?o(c(s)):i((0,I.$lg)(e))})})}async function g(w,u){const{ZipFile:i}=await new Promise((o,s)=>{Q(["yazl"],o,s)});return new Promise((o,s)=>{const e=new i;u.forEach(r=>{r.contents?e.addBuffer(typeof r.contents=="string"?Buffer.from(r.contents,"utf8"):r.contents,r.path):r.localPath&&e.addFile(r.localPath,r.path)}),e.end();const n=(0,O.createWriteStream)(w);e.outputStream.pipe(n),e.outputStream.once("error",s),n.once("error",s),n.once("finish",()=>o(w))})}function d(w,u,i={},o){const s=new RegExp(i.sourcePath?`^${i.sourcePath}`:"");let e=y(w,!0);return i.overwrite&&(e=e.then(n=>D.Promises.rm(u).then(()=>n))),e.then(n=>p(n,u,{sourcePathRegex:s},o))}function $(w,u){return y(w).then(i=>new Promise((o,s)=>{i.on("entry",e=>{e.fileName===u&&N(i,e).then(n=>o(n),n=>s(n))}),i.once("close",()=>s(new Error(S.localize(2,null,u))))}))}function P(w,u){return $(w,u).then(i=>new Promise((o,s)=>{const e=[];i.once("error",s),i.on("data",n=>e.push(n)),i.on("end",()=>o(Buffer.concat(e)))}))}}),define(se[95],oe([7,4]),function(Q,t){return Q.create("vs/platform/configuration/common/configurationRegistry",t)}),define(se[96],oe([7,4]),function(Q,t){return Q.create("vs/platform/contextkey/common/contextkey",t)}),define(se[97],oe([7,4]),function(Q,t){return Q.create("vs/platform/contextkey/common/scanner",t)}),define(se[98],oe([7,4]),function(Q,t){return Q.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",t)}),define(se[99],oe([7,4]),function(Q,t){return Q.create("vs/platform/extensionManagement/common/extensionManagement",t)}),define(se[100],oe([7,4]),function(Q,t){return Q.create("vs/platform/extensionManagement/common/extensionManagementCLI",t)}),define(se[101],oe([7,4]),function(Q,t){return Q.create("vs/platform/extensionManagement/common/extensionNls",t)}),define(se[102],oe([7,4]),function(Q,t){return Q.create("vs/platform/extensionManagement/common/extensionsScannerService",t)}),define(se[103],oe([7,4]),function(Q,t){return Q.create("vs/platform/extensionManagement/node/extensionManagementService",t)}),define(se[104],oe([7,4]),function(Q,t){return Q.create("vs/platform/extensionManagement/node/extensionManagementUtil",t)}),define(se[105],oe([7,4]),function(Q,t){return Q.create("vs/platform/extensions/common/extensionValidator",t)}),define(se[106],oe([7,4]),function(Q,t){return Q.create("vs/platform/files/common/fileService",t)}),define(se[107],oe([7,4]),function(Q,t){return Q.create("vs/platform/files/common/io",t)}),define(se[108],oe([7,4]),function(Q,t){return Q.create("vs/platform/files/node/diskFileSystemProvider",t)}),define(se[109],oe([7,4]),function(Q,t){return Q.create("vs/platform/languagePacks/common/languagePacks",t)}),define(se[110],oe([7,4]),function(Q,t){return Q.create("vs/platform/log/common/log",t)}),define(se[111],oe([7,4]),function(Q,t){return Q.create("vs/platform/request/common/request",t)}),define(se[112],oe([7,4]),function(Q,t){return Q.create("vs/platform/shell/node/shellEnv",t)}),define(se[113],oe([7,4]),function(Q,t){return Q.create("vs/platform/telemetry/common/telemetryService",t)}),define(se[114],oe([7,4]),function(Q,t){return Q.create("vs/platform/userDataProfile/common/userDataProfile",t)}),define(se[115],oe([7,4]),function(Q,t){return Q.create("vs/platform/workspace/common/workspace",t)}),define(se[116],oe([0,1,117,9,97]),function(Q,t,O,k,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$vj=t.TokenType=void 0;var I;(function(l){l[l.LParen=0]="LParen",l[l.RParen=1]="RParen",l[l.Neg=2]="Neg",l[l.Eq=3]="Eq",l[l.NotEq=4]="NotEq",l[l.Lt=5]="Lt",l[l.LtEq=6]="LtEq",l[l.Gt=7]="Gt",l[l.GtEq=8]="GtEq",l[l.RegexOp=9]="RegexOp",l[l.RegexStr=10]="RegexStr",l[l.True=11]="True",l[l.False=12]="False",l[l.In=13]="In",l[l.Not=14]="Not",l[l.And=15]="And",l[l.Or=16]="Or",l[l.Str=17]="Str",l[l.QuotedStr=18]="QuotedStr",l[l.Error=19]="Error",l[l.EOF=20]="EOF"})(I||(t.TokenType=I={}));function D(...l){switch(l.length){case 1:return(0,v.localize)(0,null,l[0]);case 2:return(0,v.localize)(1,null,l[0],l[1]);case 3:return(0,v.localize)(2,null,l[0],l[1],l[2]);default:return}}const S=(0,v.localize)(3,null),m=(0,v.localize)(4,null);class a{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(c){switch(c.type){case I.LParen:return"(";case I.RParen:return")";case I.Neg:return"!";case I.Eq:return c.isTripleEq?"===":"==";case I.NotEq:return c.isTripleEq?"!==":"!=";case I.Lt:return"<";case I.LtEq:return"<=";case I.Gt:return">=";case I.GtEq:return">=";case I.RegexOp:return"=~";case I.RegexStr:return c.lexeme;case I.True:return"true";case I.False:return"false";case I.In:return"in";case I.Not:return"not";case I.And:return"&&";case I.Or:return"||";case I.Str:return c.lexeme;case I.QuotedStr:return c.lexeme;case I.Error:return c.lexeme;case I.EOF:return"EOF";default:throw(0,k.$8)(`unhandled token type: ${JSON.stringify(c)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(c=>c.charCodeAt(0)))}static{this.b=new Map([["not",I.Not],["in",I.In],["false",I.False],["true",I.True]])}get errors(){return this.g}reset(c){return this.c=c,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case O.CharCode.OpenParen:this.k(I.LParen);break;case O.CharCode.CloseParen:this.k(I.RParen);break;case O.CharCode.ExclamationMark:if(this.h(O.CharCode.Equals)){const f=this.h(O.CharCode.Equals);this.f.push({type:I.NotEq,offset:this.d,isTripleEq:f})}else this.k(I.Neg);break;case O.CharCode.SingleQuote:this.o();break;case O.CharCode.Slash:this.q();break;case O.CharCode.Equals:if(this.h(O.CharCode.Equals)){const f=this.h(O.CharCode.Equals);this.f.push({type:I.Eq,offset:this.d,isTripleEq:f})}else this.h(O.CharCode.Tilde)?this.k(I.RegexOp):this.l(D("==","=~"));break;case O.CharCode.LessThan:this.k(this.h(O.CharCode.Equals)?I.LtEq:I.Lt);break;case O.CharCode.GreaterThan:this.k(this.h(O.CharCode.Equals)?I.GtEq:I.Gt);break;case O.CharCode.Ampersand:this.h(O.CharCode.Ampersand)?this.k(I.And):this.l(D("&&"));break;case O.CharCode.Pipe:this.h(O.CharCode.Pipe)?this.k(I.Or):this.l(D("||"));break;case O.CharCode.Space:case O.CharCode.CarriageReturn:case O.CharCode.Tab:case O.CharCode.LineFeed:case O.CharCode.NoBreakSpace:break;default:this.n()}return this.d=this.e,this.k(I.EOF),Array.from(this.f)}h(c){return this.r()||this.c.charCodeAt(this.e)!==c?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?O.CharCode.Null:this.c.charCodeAt(this.e)}k(c){this.f.push({type:c,offset:this.d})}l(c){const f=this.d,p=this.c.substring(this.d,this.e),y={type:I.Error,offset:this.d,lexeme:p};this.g.push({offset:f,lexeme:p,additionalInfo:c}),this.f.push(y)}n(){this.m.lastIndex=this.d;const c=this.m.exec(this.c);if(c){this.e=this.d+c[0].length;const f=this.c.substring(this.d,this.e),p=a.b.get(f);p?this.k(p):this.f.push({type:I.Str,lexeme:f,offset:this.d})}}o(){for(;this.j()!==O.CharCode.SingleQuote&&!this.r();)this.i();if(this.r()){this.l(S);return}this.i(),this.f.push({type:I.QuotedStr,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let c=this.e,f=!1,p=!1;for(;;){if(c>=this.c.length){this.e=c,this.l(m);return}const N=this.c.charCodeAt(c);if(f)f=!1;else if(N===O.CharCode.Slash&&!p){c++;break}else N===O.CharCode.OpenSquareBracket?p=!0:N===O.CharCode.Backslash?f=!0:N===O.CharCode.CloseSquareBracket&&(p=!1);c++}for(;c<this.c.length&&a.a.has(this.c.charCodeAt(c));)c++;this.e=c;const y=this.c.substring(this.d,this.e);this.f.push({type:I.RegexStr,lexeme:y,offset:this.d})}r(){return this.e>=this.c.length}}t.$vj=a}),define(se[118],oe([0,1,83,55,15,16,37,17,12]),function(Q,t,O,k,v,I,D,S,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$$m=t.$0m=void 0,t.$_m=l,t.$an=c,t.$0m=/^([^.]+\..+)[:=](.+)$/;class a{get appRoot(){return(0,I.$mc)(v.$Ug.asFileUri("").fsPath)}get userHome(){return m.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return m.URI.file((0,I.$jc)(this.userDataPath,"User"))}get tmpDir(){return m.URI.file(this.b.tmpDir)}get cacheHome(){return m.URI.file(this.userDataPath)}get stateResource(){return(0,S.$bh)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:v.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,S.$bh)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const p=(0,O.$9m)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,I.$jc)(this.userDataPath,"logs",p)}return m.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,S.$bh)(m.URI.file((0,I.$jc)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,S.$bh)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,S.$bh)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,S.$bh)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const p=D.env.VSCODE_PORTABLE;return p?m.URI.file((0,I.$jc)(p,"argv.json")):(0,S.$bh)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return m.URI.file((0,I.$jc)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const p=this.args["builtin-extensions-dir"];return p?(0,I.$kc)(p):(0,I.$hc)((0,I.$jc)(v.$Ug.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const p=this.args["extensions-download-dir"];return p?m.URI.file((0,I.$kc)(p)):m.URI.file((0,I.$jc)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const p=this.args["extensions-dir"];if(p)return(0,I.$kc)(p);const y=D.env.VSCODE_EXTENSIONS;if(y)return y;const N=D.env.VSCODE_PORTABLE;return N?(0,I.$jc)(N,"extensions"):(0,S.$bh)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const p=this.args.extensionDevelopmentPath;if(Array.isArray(p))return p.map(y=>/^[^:/?#]+?:\/\//.test(y)?m.URI.parse(y):m.URI.file((0,I.$hc)(y)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(p=>p==="ui"||p==="workspace"||p==="web"?p:"workspace")}get extensionTestsLocationURI(){const p=this.args.extensionTestsPath;if(p)return/^[^:/?#]+?:\/\//.test(p)?m.URI.parse(p):m.URI.file((0,I.$hc)(p))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const p=this.args["disable-extension"];if(p){if(typeof p=="string")return[p];if(Array.isArray(p)&&p.length>0)return p}return!1}get debugExtensionHost(){return l(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!D.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(p=>!t.$0m.test(p))}get extensionLogLevel(){const p=[];for(const y of this.args.log||[]){const N=t.$0m.exec(y);N&&N[1]&&N[2]&&p.push([N[1],N[2]])}return p.length?p:void 0}get serviceMachineIdResource(){return(0,S.$bh)(m.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const p=D.env.VSCODE_PORTABLE;return p?m.URI.file((0,I.$jc)(p,"policy.json")):(0,S.$bh)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(p){this.args.continueOn=p}get args(){return this.a}constructor(p,y,N){this.a=p,this.b=y,this.c=N,this.editSessionId=this.args.editSessionId}}t.$$m=a,we([k.$5h],a.prototype,"appRoot",null),we([k.$5h],a.prototype,"userHome",null),we([k.$5h],a.prototype,"userDataPath",null),we([k.$5h],a.prototype,"appSettingsHome",null),we([k.$5h],a.prototype,"tmpDir",null),we([k.$5h],a.prototype,"cacheHome",null),we([k.$5h],a.prototype,"stateResource",null),we([k.$5h],a.prototype,"userRoamingDataHome",null),we([k.$5h],a.prototype,"userDataSyncHome",null),we([k.$5h],a.prototype,"sync",null),we([k.$5h],a.prototype,"machineSettingsResource",null),we([k.$5h],a.prototype,"workspaceStorageHome",null),we([k.$5h],a.prototype,"localHistoryHome",null),we([k.$5h],a.prototype,"keyboardLayoutResource",null),we([k.$5h],a.prototype,"argvResource",null),we([k.$5h],a.prototype,"isExtensionDevelopment",null),we([k.$5h],a.prototype,"untitledWorkspacesHome",null),we([k.$5h],a.prototype,"builtinExtensionsPath",null),we([k.$5h],a.prototype,"extensionsPath",null),we([k.$5h],a.prototype,"extensionDevelopmentLocationURI",null),we([k.$5h],a.prototype,"extensionDevelopmentKind",null),we([k.$5h],a.prototype,"extensionTestsLocationURI",null),we([k.$5h],a.prototype,"debugExtensionHost",null),we([k.$5h],a.prototype,"logLevel",null),we([k.$5h],a.prototype,"extensionLogLevel",null),we([k.$5h],a.prototype,"serviceMachineIdResource",null),we([k.$5h],a.prototype,"disableTelemetry",null),we([k.$5h],a.prototype,"disableWorkspaceTrust",null),we([k.$5h],a.prototype,"useInMemorySecretStorage",null),we([k.$5h],a.prototype,"policyFile",null);function l(f,p){return c(f["inspect-extensions"],f["inspect-brk-extensions"],5870,p,f.debugId,f.extensionEnvironment)}function c(f,p,y,N,g,d){const P=Number(p||f)||(N?null:y),w=P?!!p:!1;let u;if(d)try{u=JSON.parse(d)}catch{}return{port:P,break:w,debugId:g,env:u}}}),function(){"use strict";function Q(t,O,k){function v(D,S){const m=I(D,S),a=[m];return t.isAbsolute(m)||a.unshift(k),t.resolve(...a)}function I(D,S){process.env.VSCODE_DEV&&(S="code-oss-dev");const m=process.env.VSCODE_PORTABLE;if(m)return t.join(m,"user-data");let a=process.env.VSCODE_APPDATA;if(a)return t.join(a,S);const l=D["user-data-dir"];if(l)return l;switch(process.platform){case"win32":if(a=process.env.APPDATA,!a){const c=process.env.USERPROFILE;if(typeof c!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");a=t.join(c,"AppData","Roaming")}break;case"darwin":a=t.join(O.homedir(),"Library","Application Support");break;case"linux":a=process.env.XDG_CONFIG_HOME||t.join(O.homedir(),".config");break;default:throw new Error("Platform not supported")}return t.join(a,S)}return{getUserDataPath:v}}if(typeof define=="function")define(se[119],oe([172,35,37]),function(t,O,k){return Q(t,O,k.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const t=require("path"),O=require("os");module.exports=Q(t,O,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(se[120],oe([0,1,35,118,119]),function(Q,t,O,k,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$bn=void 0,t.$cn=D,t.$dn=S;class I extends k.$$m{constructor(a,l){super(a,{homeDir:(0,O.homedir)(),tmpDir:(0,O.tmpdir)(),userDataDir:(0,v.getUserDataPath)(a,l.nameShort)},l)}}t.$bn=I;function D(m,a){return(0,k.$an)(m["inspect-ptyhost"],m["inspect-brk-ptyhost"],5877,a,m.extensionEnvironment)}function S(m,a){return(0,k.$an)(m["inspect-sharedprocess"],m["inspect-brk-sharedprocess"],5879,a,m.extensionEnvironment)}}),define(se[121],oe([0,1,3,101]),function(Q,t,O,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Aq=v;function v(D,S,m,a){try{I(D,S,m,a)}catch(l){D.error(l?.message??l)}return S}function I(D,S,m,a){const l=(c,f,p)=>{const y=c[f];if((0,O.$ag)(y)){const N=y,g=N.length;if(g>1&&N[0]==="%"&&N[g-1]==="%"){const d=N.substr(1,g-2);let $=m[d];$===void 0&&a&&($=a[d]);const P=typeof $=="string"?$:$?.message,w=a?.[d],u=typeof w=="string"?w:w?.message;if(!P){u||D.warn(`[${S.name}]: ${(0,k.localize)(0,null,d)}`);return}if(p&&(f==="title"||f==="category")&&u&&u!==P){const i={value:P,original:u};c[f]=i}else c[f]=P}}else if((0,O.$cg)(y))for(const N in y)y.hasOwnProperty(N)&&(N==="commands"?l(y,N,!0):l(y,N,p));else if(Array.isArray(y))for(let N=0;N<y.length;N++)l(y,N,p)};for(const c in S)S.hasOwnProperty(c)&&l(S,c)}}),define(se[50],oe([0,1,17,56,105,44]),function(Q,t,O,k,v,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Op=m,t.$Pp=a,t.$Qp=l,t.$Rp=c,t.$Sp=f,t.$Tp=p,t.$Up=y;const D=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,S=/^-(\d{4})(\d{2})(\d{2})$/;function m(d){return d=d.trim(),d==="*"||D.test(d)}function a(d){if(!m(d))return null;if(d=d.trim(),d==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const $=d.match(D);return $?{hasCaret:$[1]==="^",hasGreaterEquals:$[1]===">=",majorBase:$[2]==="x"?0:parseInt($[2],10),majorMustEqual:$[2]!=="x",minorBase:$[4]==="x"?0:parseInt($[4],10),minorMustEqual:$[4]!=="x",patchBase:$[6]==="x"?0:parseInt($[6],10),patchMustEqual:$[6]!=="x",preRelease:$[8]||null}:null}function l(d){if(!d)return null;const $=d.majorBase,P=d.majorMustEqual,w=d.minorBase;let u=d.minorMustEqual;const i=d.patchBase;let o=d.patchMustEqual;d.hasCaret&&($===0||(u=!1),o=!1);let s=0;if(d.preRelease){const e=S.exec(d.preRelease);if(e){const[,n,r,h]=e;s=Date.UTC(Number(n),Number(r)-1,Number(h))}}return{majorBase:$,majorMustEqual:P,minorBase:w,minorMustEqual:u,patchBase:i,patchMustEqual:o,isMinimum:d.hasGreaterEquals,notBefore:s}}function c(d,$,P){let w;typeof d=="string"?w=l(a(d)):w=d;let u;$ instanceof Date?u=$.getTime():typeof $=="string"&&(u=new Date($).getTime());let i;if(typeof P=="string"?i=l(a(P)):i=P,!w||!i)return!1;const o=w.majorBase,s=w.minorBase,e=w.patchBase;let n=i.majorBase,r=i.minorBase,h=i.patchBase;const E=i.notBefore;let R=i.majorMustEqual,A=i.minorMustEqual,T=i.patchMustEqual;return i.isMinimum?o>n?!0:o<n?!1:s>r?!0:s<r||u&&u<E?!1:e>=h:(o===1&&n===0&&(!R||!A||!T)&&(n=1,r=0,h=0,R=!0,A=!1,T=!1),o<n?!1:o>n?!R:s<r?!1:s>r?!A:e<h?!1:e>h?!T:!(u&&u<E))}function f(d,$,P,w,u){const i=[];if(typeof w.publisher<"u"&&typeof w.publisher!="string")return i.push([k.default.Error,v.localize(0,null)]),i;if(typeof w.name!="string")return i.push([k.default.Error,v.localize(1,null,"name")]),i;if(typeof w.version!="string")return i.push([k.default.Error,v.localize(2,null,"version")]),i;if(!w.engines)return i.push([k.default.Error,v.localize(3,null,"engines")]),i;if(typeof w.engines.vscode!="string")return i.push([k.default.Error,v.localize(4,null,"engines.vscode")]),i;if(typeof w.extensionDependencies<"u"&&!g(w.extensionDependencies))return i.push([k.default.Error,v.localize(5,null,"extensionDependencies")]),i;if(typeof w.activationEvents<"u"){if(!g(w.activationEvents))return i.push([k.default.Error,v.localize(6,null,"activationEvents")]),i;if(typeof w.main>"u"&&typeof w.browser>"u")return i.push([k.default.Error,v.localize(7,null,"activationEvents","main","browser")]),i}if(typeof w.extensionKind<"u"&&typeof w.main>"u"&&i.push([k.default.Warning,v.localize(8,null,"extensionKind")]),typeof w.main<"u"){if(typeof w.main!="string")return i.push([k.default.Error,v.localize(9,null,"main")]),i;{const e=(0,O.$bh)(P,w.main);(0,O.$8g)(e,P)||i.push([k.default.Warning,v.localize(10,null,e.path,P.path)])}}if(typeof w.browser<"u"){if(typeof w.browser!="string")return i.push([k.default.Error,v.localize(11,null,"browser")]),i;{const e=(0,O.$bh)(P,w.browser);(0,O.$8g)(e,P)||i.push([k.default.Warning,v.localize(12,null,e.path,P.path)])}}if(!I.valid(w.version))return i.push([k.default.Error,v.localize(13,null)]),i;const o=[];if(!p(d,$,w,u,o))for(const e of o)i.push([k.default.Error,e]);return i}function p(d,$,P,w,u){return w||typeof P.main>"u"&&typeof P.browser>"u"?!0:N(d,$,P.engines.vscode,u)}function y(d,$,P){return d==="*"||N($,P,d)}function N(d,$,P,w=[]){const u=l(a(P));if(!u)return w.push(v.localize(14,null,P)),!1;if(u.majorBase===0){if(!u.majorMustEqual||!u.minorMustEqual)return w.push(v.localize(15,null,P)),!1}else if(!u.majorMustEqual)return w.push(v.localize(16,null,P)),!1;return c(d,$,u)?!0:(w.push(v.localize(17,null,d,P)),!1)}function g(d){if(!Array.isArray(d))return!1;for(let $=0,P=d.length;$<P;$++)if(typeof d[$]!="string")return!1;return!0}}),define(se[51],oe([0,1]),function(Q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$xi=void 0;class O{constructor(v,I=[],D=!1){this.ctor=v,this.staticArguments=I,this.supportsDelayedInstantiation=D}}t.$xi=O}),define(se[122],oe([0,1,51]),function(Q,t,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.InstantiationType=void 0,t.$Fs=I,t.$Gs=D;const k=[];var v;(function(S){S[S.Eager=0]="Eager",S[S.Delayed=1]="Delayed"})(v||(t.InstantiationType=v={}));function I(S,m,a){m instanceof O.$xi||(m=new O.$xi(m,[],!!a)),k.push([S,m])}function D(){return k}}),define(se[123],oe([0,1]),function(Q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$jr=t.$ir=void 0;class O{constructor(I,D){this.key=I,this.data=D,this.incoming=new Map,this.outgoing=new Map}}t.$ir=O;class k{constructor(I){this.b=I,this.a=new Map}roots(){const I=[];for(const D of this.a.values())D.outgoing.size===0&&I.push(D);return I}insertEdge(I,D){const S=this.lookupOrInsertNode(I),m=this.lookupOrInsertNode(D);S.outgoing.set(m.key,m),m.incoming.set(S.key,S)}removeNode(I){const D=this.b(I);this.a.delete(D);for(const S of this.a.values())S.outgoing.delete(D),S.incoming.delete(D)}lookupOrInsertNode(I){const D=this.b(I);let S=this.a.get(D);return S||(S=new O(D,I),this.a.set(D,S)),S}lookup(I){return this.a.get(this.b(I))}isEmpty(){return this.a.size===0}toString(){const I=[];for(const[D,S]of this.a)I.push(`${D}
	(-> incoming)[${[...S.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...S.outgoing.keys()].join(",")}]
`);return I.join(`
`)}findCycleSlow(){for(const[I,D]of this.a){const S=new Set([I]),m=this.c(D,S);if(m)return m}}c(I,D){for(const[S,m]of I.outgoing){if(D.has(S))return[...D,S].join(" -> ");D.add(S);const a=this.c(m,D);if(a)return a;D.delete(S)}}}t.$jr=k}),define(se[30],oe([0,1,3,12,11]),function(Q,t,O,k,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ConfigurationTarget=t.$7i=void 0,t.$8i=I,t.$9i=D,t.$0i=m,t.$$i=a,t.$_i=l,t.$aj=c,t.$bj=f,t.$cj=y,t.$dj=N,t.$ej=g,t.$7i=(0,v.$Ai)("configurationService");function I(d){return d&&typeof d=="object"&&(!d.overrideIdentifier||typeof d.overrideIdentifier=="string")&&(!d.resource||d.resource instanceof k.URI)}function D(d){return d&&typeof d=="object"&&(!d.overrideIdentifiers||Array.isArray(d.overrideIdentifiers))&&!d.overrideIdentifier&&(!d.resource||d.resource instanceof k.URI)}var S;(function(d){d[d.APPLICATION=1]="APPLICATION",d[d.USER=2]="USER",d[d.USER_LOCAL=3]="USER_LOCAL",d[d.USER_REMOTE=4]="USER_REMOTE",d[d.WORKSPACE=5]="WORKSPACE",d[d.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",d[d.DEFAULT=7]="DEFAULT",d[d.MEMORY=8]="MEMORY"})(S||(t.ConfigurationTarget=S={}));function m(d){switch(d){case S.APPLICATION:return"APPLICATION";case S.USER:return"USER";case S.USER_LOCAL:return"USER_LOCAL";case S.USER_REMOTE:return"USER_REMOTE";case S.WORKSPACE:return"WORKSPACE";case S.WORKSPACE_FOLDER:return"WORKSPACE_FOLDER";case S.DEFAULT:return"DEFAULT";case S.MEMORY:return"MEMORY"}}function a(d){return d.applicationValue!==void 0||d.userValue!==void 0||d.userLocalValue!==void 0||d.userRemoteValue!==void 0||d.workspaceValue!==void 0||d.workspaceFolderValue!==void 0}function l(d,$){const P=Object.create(null);for(const w in d)c(P,w,d[w],$);return P}function c(d,$,P,w){const u=$.split("."),i=u.pop();let o=d;for(let s=0;s<u.length;s++){const e=u[s];let n=o[e];switch(typeof n){case"undefined":n=o[e]=Object.create(null);break;case"object":if(n===null){w(`Ignoring ${$} as ${u.slice(0,s+1).join(".")} is null`);return}break;default:w(`Ignoring ${$} as ${u.slice(0,s+1).join(".")} is ${JSON.stringify(n)}`);return}o=n}if(typeof o=="object"&&o!==null)try{o[i]=P}catch{w(`Ignoring ${$} as ${u.join(".")} is ${JSON.stringify(o)}`)}else w(`Ignoring ${$} as ${u.join(".")} is ${JSON.stringify(o)}`)}function f(d,$){const P=$.split(".");p(d,P)}function p(d,$){const P=$.shift();if($.length===0){delete d[P];return}if(Object.keys(d).indexOf(P)!==-1){const w=d[P];typeof w=="object"&&!Array.isArray(w)&&(p(w,$),Object.keys(w).length===0&&delete d[P])}}function y(d,$,P){function w(o,s){let e=o;for(const n of s){if(typeof e!="object"||e===null)return;e=e[n]}return e}const u=$.split("."),i=w(d,u);return typeof i>"u"?P:i}function N(d,$,P){Object.keys($).forEach(w=>{w!=="__proto__"&&(w in d?O.$cg(d[w])&&O.$cg($[w])?N(d[w],$[w],P):P&&(d[w]=$[w]):d[w]=$[w])})}function g(d){return d.replace(/[\[\]]/g,"")}}),define(se[124],oe([0,1,117,13,32,116,11,96,9]),function(Q,t,O,k,v,I,D,S,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Sj=t.$Rj=t.$Qj=t.$Pj=t.$Oj=t.$Nj=t.$Mj=t.$Lj=t.$Kj=t.$Jj=t.$Ij=t.$Hj=t.$Gj=t.$Fj=t.$Ej=t.$Dj=t.$Cj=t.$Bj=t.$yj=t.$xj=t.ContextKeyExprType=void 0,t.$wj=l,t.$zj=s,t.$Aj=e,t.$Tj=F;const a=new Map;a.set("false",!1),a.set("true",!0),a.set("isMac",k.$j),a.set("isLinux",k.$k),a.set("isWindows",k.$i),a.set("isWeb",k.$o),a.set("isMacNative",k.$j&&!k.$o),a.set("isEdge",k.$H),a.set("isFirefox",k.$F),a.set("isChrome",k.$E),a.set("isSafari",k.$G);function l(V,b){if(a.get(V)!==void 0)throw(0,m.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");a.set(V,b)}const c=Object.prototype.hasOwnProperty;var f;(function(V){V[V.False=0]="False",V[V.True=1]="True",V[V.Defined=2]="Defined",V[V.Not=3]="Not",V[V.Equals=4]="Equals",V[V.NotEquals=5]="NotEquals",V[V.And=6]="And",V[V.Regex=7]="Regex",V[V.NotRegex=8]="NotRegex",V[V.Or=9]="Or",V[V.In=10]="In",V[V.NotIn=11]="NotIn",V[V.Greater=12]="Greater",V[V.GreaterEquals=13]="GreaterEquals",V[V.Smaller=14]="Smaller",V[V.SmallerEquals=15]="SmallerEquals"})(f||(t.ContextKeyExprType=f={}));const p={regexParsingWithErrorRecovery:!0},y=(0,S.localize)(0,null),N=(0,S.localize)(1,null),g=(0,S.localize)(2,null),d=(0,S.localize)(3,null),$=(0,S.localize)(4,null),P=(0,S.localize)(5,null),w=(0,S.localize)(6,null),u=(0,S.localize)(7,null);class i{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(b=p){this.k=b,this.d=new I.$vj,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(b){if(b===""){this.h.push({message:y,offset:0,lexeme:"",additionalInfo:N});return}this.f=this.d.reset(b).scan(),this.g=0,this.h=[];try{const L=this.l();if(!this.E()){const j=this.D(),q=j.type===I.TokenType.Str?P:void 0;throw this.h.push({message:$,offset:j.offset,lexeme:I.$vj.getLexeme(j),additionalInfo:q}),i.c}return L}catch(L){if(L!==i.c)throw L;return}}l(){return this.m()}m(){const b=[this.o()];for(;this.y(I.TokenType.Or);){const L=this.o();b.push(L)}return b.length===1?b[0]:o.or(...b)}o(){const b=[this.s()];for(;this.y(I.TokenType.And);){const L=this.s();b.push(L)}return b.length===1?b[0]:o.and(...b)}s(){if(this.y(I.TokenType.Neg)){const b=this.D();switch(b.type){case I.TokenType.True:return this.z(),r.INSTANCE;case I.TokenType.False:return this.z(),h.INSTANCE;case I.TokenType.LParen:{this.z();const L=this.l();return this.A(I.TokenType.RParen,d),L?.negate()}case I.TokenType.Str:return this.z(),M.create(b.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",b)}}return this.t()}t(){const b=this.D();switch(b.type){case I.TokenType.True:return this.z(),o.true();case I.TokenType.False:return this.z(),o.false();case I.TokenType.LParen:{this.z();const L=this.l();return this.A(I.TokenType.RParen,d),L}case I.TokenType.Str:{const L=b.lexeme;if(this.z(),this.y(I.TokenType.RegexOp)){const q=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),q.type!==I.TokenType.RegexStr)throw this.B("REGEX",q);const X=q.lexeme,K=X.lastIndexOf("/"),re=K===X.length-1?void 0:this.w(X.substring(K+1));let fe;try{fe=new RegExp(X.substring(1,K),re)}catch{throw this.B("REGEX",q)}return le.create(L,fe)}switch(q.type){case I.TokenType.RegexStr:case I.TokenType.Error:{const X=[q.lexeme];this.z();let K=this.D(),re=0;for(let ge=0;ge<q.lexeme.length;ge++)q.lexeme.charCodeAt(ge)===O.CharCode.OpenParen?re++:q.lexeme.charCodeAt(ge)===O.CharCode.CloseParen&&re--;for(;!this.E()&&K.type!==I.TokenType.And&&K.type!==I.TokenType.Or;){switch(K.type){case I.TokenType.LParen:re++;break;case I.TokenType.RParen:re--;break;case I.TokenType.RegexStr:case I.TokenType.QuotedStr:for(let ge=0;ge<K.lexeme.length;ge++)K.lexeme.charCodeAt(ge)===O.CharCode.OpenParen?re++:q.lexeme.charCodeAt(ge)===O.CharCode.CloseParen&&re--}if(re<0)break;X.push(I.$vj.getLexeme(K)),this.z(),K=this.D()}const fe=X.join(""),he=fe.lastIndexOf("/"),ve=he===fe.length-1?void 0:this.w(fe.substring(he+1));let me;try{me=new RegExp(fe.substring(1,he),ve)}catch{throw this.B("REGEX",q)}return o.regex(L,me)}case I.TokenType.QuotedStr:{const X=q.lexeme;this.z();let K=null;if(!(0,v.$$e)(X)){const re=X.indexOf("/"),fe=X.lastIndexOf("/");if(re!==fe&&re>=0){const he=X.slice(re+1,fe),ve=X[fe+1]==="i"?"i":"";try{K=new RegExp(he,ve)}catch{throw this.B("REGEX",q)}}}if(K===null)throw this.B("REGEX",q);return le.create(L,K)}default:throw this.B("REGEX",this.D())}}if(this.y(I.TokenType.Not)){this.A(I.TokenType.In,g);const q=this.u();return o.notIn(L,q)}switch(this.D().type){case I.TokenType.Eq:{this.z();const q=this.u();if(this.x().type===I.TokenType.QuotedStr)return o.equals(L,q);switch(q){case"true":return o.has(L);case"false":return o.not(L);default:return o.equals(L,q)}}case I.TokenType.NotEq:{this.z();const q=this.u();if(this.x().type===I.TokenType.QuotedStr)return o.notEquals(L,q);switch(q){case"true":return o.not(L);case"false":return o.has(L);default:return o.notEquals(L,q)}}case I.TokenType.Lt:return this.z(),ce.create(L,this.u());case I.TokenType.LtEq:return this.z(),ue.create(L,this.u());case I.TokenType.Gt:return this.z(),ae.create(L,this.u());case I.TokenType.GtEq:return this.z(),ie.create(L,this.u());case I.TokenType.In:return this.z(),o.in(L,this.u());default:return o.has(L)}}case I.TokenType.EOF:throw this.h.push({message:w,offset:b.offset,lexeme:"",additionalInfo:u}),i.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const b=this.D();switch(b.type){case I.TokenType.Str:case I.TokenType.QuotedStr:return this.z(),b.lexeme;case I.TokenType.True:return this.z(),"true";case I.TokenType.False:return this.z(),"false";case I.TokenType.In:return this.z(),"in";default:return""}}w(b){return b.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(b){return this.C(b)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(b,L){if(this.C(b))return this.z();throw this.B(L,this.D())}B(b,L,j){const q=(0,S.localize)(8,null,b,I.$vj.getLexeme(L)),X=L.offset,K=I.$vj.getLexeme(L);return this.h.push({message:q,offset:X,lexeme:K,additionalInfo:j}),i.c}C(b){return this.D().type===b}D(){return this.f[this.g]}E(){return this.D().type===I.TokenType.EOF}}t.$xj=i;class o{static false(){return r.INSTANCE}static true(){return h.INSTANCE}static has(b){return E.create(b)}static equals(b,L){return R.create(b,L)}static notEquals(b,L){return C.create(b,L)}static regex(b,L){return le.create(b,L)}static in(b,L){return A.create(b,L)}static notIn(b,L){return T.create(b,L)}static not(b){return M.create(b)}static and(...b){return B.create(b,null,!0)}static or(...b){return U.create(b,null,!0)}static greater(b,L){return ae.create(b,L)}static greaterEquals(b,L){return ie.create(b,L)}static smaller(b,L){return ce.create(b,L)}static smallerEquals(b,L){return ue.create(b,L)}static{this.c=new i({regexParsingWithErrorRecovery:!1})}static deserialize(b){return b==null?void 0:this.c.parse(b)}}t.$yj=o;function s(V){const b=new i({regexParsingWithErrorRecovery:!1});return V.map(L=>(b.parse(L),b.lexingErrors.length>0?b.lexingErrors.map(j=>({errorMessage:j.additionalInfo?(0,S.localize)(9,null,j.additionalInfo):(0,S.localize)(10,null),offset:j.offset,length:j.lexeme.length})):b.parsingErrors.length>0?b.parsingErrors.map(j=>({errorMessage:j.additionalInfo?`${j.message}. ${j.additionalInfo}`:j.message,offset:j.offset,length:j.lexeme.length})):[]))}function e(V,b){const L=V?V.substituteConstants():void 0,j=b?b.substituteConstants():void 0;return!L&&!j?!0:!L||!j?!1:L.equals(j)}function n(V,b){return V.cmp(b)}class r{static{this.INSTANCE=new r}constructor(){this.type=f.False}cmp(b){return this.type-b.type}equals(b){return b.type===this.type}substituteConstants(){return this}evaluate(b){return!1}serialize(){return"false"}keys(){return[]}map(b){return this}negate(){return h.INSTANCE}}t.$Bj=r;class h{static{this.INSTANCE=new h}constructor(){this.type=f.True}cmp(b){return this.type-b.type}equals(b){return b.type===this.type}substituteConstants(){return this}evaluate(b){return!0}serialize(){return"true"}keys(){return[]}map(b){return this}negate(){return r.INSTANCE}}t.$Cj=h;class E{static create(b,L=null){const j=a.get(b);return typeof j=="boolean"?j?h.INSTANCE:r.INSTANCE:new E(b,L)}constructor(b,L){this.key=b,this.c=L,this.type=f.Defined}cmp(b){return b.type!==this.type?this.type-b.type:Z(this.key,b.key)}equals(b){return b.type===this.type?this.key===b.key:!1}substituteConstants(){const b=a.get(this.key);return typeof b=="boolean"?b?h.INSTANCE:r.INSTANCE:this}evaluate(b){return!!b.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(b){return b.mapDefined(this.key)}negate(){return this.c||(this.c=M.create(this.key,this)),this.c}}t.$Dj=E;class R{static create(b,L,j=null){if(typeof L=="boolean")return L?E.create(b,j):M.create(b,j);const q=a.get(b);return typeof q=="boolean"?L===(q?"true":"false")?h.INSTANCE:r.INSTANCE:new R(b,L,j)}constructor(b,L,j){this.c=b,this.d=L,this.f=j,this.type=f.Equals}cmp(b){return b.type!==this.type?this.type-b.type:Y(this.c,this.d,b.c,b.d)}equals(b){return b.type===this.type?this.c===b.c&&this.d===b.d:!1}substituteConstants(){const b=a.get(this.c);if(typeof b=="boolean"){const L=b?"true":"false";return this.d===L?h.INSTANCE:r.INSTANCE}return this}evaluate(b){return b.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(b){return b.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=C.create(this.c,this.d,this)),this.f}}t.$Ej=R;class A{static create(b,L){return new A(b,L)}constructor(b,L){this.d=b,this.f=L,this.type=f.In,this.c=null}cmp(b){return b.type!==this.type?this.type-b.type:Y(this.d,this.f,b.d,b.f)}equals(b){return b.type===this.type?this.d===b.d&&this.f===b.f:!1}substituteConstants(){return this}evaluate(b){const L=b.getValue(this.f),j=b.getValue(this.d);return Array.isArray(L)?L.includes(j):typeof j=="string"&&typeof L=="object"&&L!==null?c.call(L,j):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(b){return b.mapIn(this.d,this.f)}negate(){return this.c||(this.c=T.create(this.d,this.f)),this.c}}t.$Fj=A;class T{static create(b,L){return new T(b,L)}constructor(b,L){this.d=b,this.f=L,this.type=f.NotIn,this.c=A.create(b,L)}cmp(b){return b.type!==this.type?this.type-b.type:this.c.cmp(b.c)}equals(b){return b.type===this.type?this.c.equals(b.c):!1}substituteConstants(){return this}evaluate(b){return!this.c.evaluate(b)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(b){return b.mapNotIn(this.d,this.f)}negate(){return this.c}}t.$Gj=T;class C{static create(b,L,j=null){if(typeof L=="boolean")return L?M.create(b,j):E.create(b,j);const q=a.get(b);return typeof q=="boolean"?L===(q?"true":"false")?r.INSTANCE:h.INSTANCE:new C(b,L,j)}constructor(b,L,j){this.c=b,this.d=L,this.f=j,this.type=f.NotEquals}cmp(b){return b.type!==this.type?this.type-b.type:Y(this.c,this.d,b.c,b.d)}equals(b){return b.type===this.type?this.c===b.c&&this.d===b.d:!1}substituteConstants(){const b=a.get(this.c);if(typeof b=="boolean"){const L=b?"true":"false";return this.d===L?r.INSTANCE:h.INSTANCE}return this}evaluate(b){return b.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(b){return b.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=R.create(this.c,this.d,this)),this.f}}t.$Hj=C;class M{static create(b,L=null){const j=a.get(b);return typeof j=="boolean"?j?r.INSTANCE:h.INSTANCE:new M(b,L)}constructor(b,L){this.c=b,this.d=L,this.type=f.Not}cmp(b){return b.type!==this.type?this.type-b.type:Z(this.c,b.c)}equals(b){return b.type===this.type?this.c===b.c:!1}substituteConstants(){const b=a.get(this.c);return typeof b=="boolean"?b?r.INSTANCE:h.INSTANCE:this}evaluate(b){return!b.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(b){return b.mapNot(this.c)}negate(){return this.d||(this.d=E.create(this.c,this)),this.d}}t.$Ij=M;function J(V,b){if(typeof V=="string"){const L=parseFloat(V);isNaN(L)||(V=L)}return typeof V=="string"||typeof V=="number"?b(V):r.INSTANCE}class ae{static create(b,L,j=null){return J(L,q=>new ae(b,q,j))}constructor(b,L,j){this.c=b,this.d=L,this.f=j,this.type=f.Greater}cmp(b){return b.type!==this.type?this.type-b.type:Y(this.c,this.d,b.c,b.d)}equals(b){return b.type===this.type?this.c===b.c&&this.d===b.d:!1}substituteConstants(){return this}evaluate(b){return typeof this.d=="string"?!1:parseFloat(b.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(b){return b.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=ue.create(this.c,this.d,this)),this.f}}t.$Jj=ae;class ie{static create(b,L,j=null){return J(L,q=>new ie(b,q,j))}constructor(b,L,j){this.c=b,this.d=L,this.f=j,this.type=f.GreaterEquals}cmp(b){return b.type!==this.type?this.type-b.type:Y(this.c,this.d,b.c,b.d)}equals(b){return b.type===this.type?this.c===b.c&&this.d===b.d:!1}substituteConstants(){return this}evaluate(b){return typeof this.d=="string"?!1:parseFloat(b.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(b){return b.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=ce.create(this.c,this.d,this)),this.f}}t.$Kj=ie;class ce{static create(b,L,j=null){return J(L,q=>new ce(b,q,j))}constructor(b,L,j){this.c=b,this.d=L,this.f=j,this.type=f.Smaller}cmp(b){return b.type!==this.type?this.type-b.type:Y(this.c,this.d,b.c,b.d)}equals(b){return b.type===this.type?this.c===b.c&&this.d===b.d:!1}substituteConstants(){return this}evaluate(b){return typeof this.d=="string"?!1:parseFloat(b.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(b){return b.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=ie.create(this.c,this.d,this)),this.f}}t.$Lj=ce;class ue{static create(b,L,j=null){return J(L,q=>new ue(b,q,j))}constructor(b,L,j){this.c=b,this.d=L,this.f=j,this.type=f.SmallerEquals}cmp(b){return b.type!==this.type?this.type-b.type:Y(this.c,this.d,b.c,b.d)}equals(b){return b.type===this.type?this.c===b.c&&this.d===b.d:!1}substituteConstants(){return this}evaluate(b){return typeof this.d=="string"?!1:parseFloat(b.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(b){return b.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=ae.create(this.c,this.d,this)),this.f}}t.$Mj=ue;class le{static create(b,L){return new le(b,L)}constructor(b,L){this.d=b,this.f=L,this.type=f.Regex,this.c=null}cmp(b){if(b.type!==this.type)return this.type-b.type;if(this.d<b.d)return-1;if(this.d>b.d)return 1;const L=this.f?this.f.source:"",j=b.f?b.f.source:"";return L<j?-1:L>j?1:0}equals(b){if(b.type===this.type){const L=this.f?this.f.source:"",j=b.f?b.f.source:"";return this.d===b.d&&L===j}return!1}substituteConstants(){return this}evaluate(b){const L=b.getValue(this.d);return this.f?this.f.test(L):!1}serialize(){const b=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${b}`}keys(){return[this.d]}map(b){return b.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=x.create(this)),this.c}}t.$Nj=le;class x{static create(b){return new x(b)}constructor(b){this.c=b,this.type=f.NotRegex}cmp(b){return b.type!==this.type?this.type-b.type:this.c.cmp(b.c)}equals(b){return b.type===this.type?this.c.equals(b.c):!1}substituteConstants(){return this}evaluate(b){return!this.c.evaluate(b)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(b){return new x(this.c.map(b))}negate(){return this.c}}t.$Oj=x;function _(V){let b=null;for(let L=0,j=V.length;L<j;L++){const q=V[L].substituteConstants();if(V[L]!==q&&b===null){b=[];for(let X=0;X<L;X++)b[X]=V[X]}b!==null&&(b[L]=q)}return b===null?V:b}class B{static create(b,L,j){return B.d(b,L,j)}constructor(b,L){this.expr=b,this.c=L,this.type=f.And}cmp(b){if(b.type!==this.type)return this.type-b.type;if(this.expr.length<b.expr.length)return-1;if(this.expr.length>b.expr.length)return 1;for(let L=0,j=this.expr.length;L<j;L++){const q=n(this.expr[L],b.expr[L]);if(q!==0)return q}return 0}equals(b){if(b.type===this.type){if(this.expr.length!==b.expr.length)return!1;for(let L=0,j=this.expr.length;L<j;L++)if(!this.expr[L].equals(b.expr[L]))return!1;return!0}return!1}substituteConstants(){const b=_(this.expr);return b===this.expr?this:B.create(b,this.c,!1)}evaluate(b){for(let L=0,j=this.expr.length;L<j;L++)if(!this.expr[L].evaluate(b))return!1;return!0}static d(b,L,j){const q=[];let X=!1;for(const K of b)if(K){if(K.type===f.True){X=!0;continue}if(K.type===f.False)return r.INSTANCE;if(K.type===f.And){q.push(...K.expr);continue}q.push(K)}if(q.length===0&&X)return h.INSTANCE;if(q.length!==0){if(q.length===1)return q[0];q.sort(n);for(let K=1;K<q.length;K++)q[K-1].equals(q[K])&&(q.splice(K,1),K--);if(q.length===1)return q[0];for(;q.length>1;){const K=q[q.length-1];if(K.type!==f.Or)break;q.pop();const re=q.pop(),fe=q.length===0,he=U.create(K.expr.map(ve=>B.create([ve,re],null,j)),null,fe);he&&(q.push(he),q.sort(n))}if(q.length===1)return q[0];if(j){for(let K=0;K<q.length;K++)for(let re=K+1;re<q.length;re++)if(q[K].negate().equals(q[re]))return r.INSTANCE;if(q.length===1)return q[0]}return new B(q,L)}}serialize(){return this.expr.map(b=>b.serialize()).join(" && ")}keys(){const b=[];for(const L of this.expr)b.push(...L.keys());return b}map(b){return new B(this.expr.map(L=>L.map(b)),null)}negate(){if(!this.c){const b=[];for(const L of this.expr)b.push(L.negate());this.c=U.create(b,this,!0)}return this.c}}t.$Pj=B;class U{static create(b,L,j){return U.d(b,L,j)}constructor(b,L){this.expr=b,this.c=L,this.type=f.Or}cmp(b){if(b.type!==this.type)return this.type-b.type;if(this.expr.length<b.expr.length)return-1;if(this.expr.length>b.expr.length)return 1;for(let L=0,j=this.expr.length;L<j;L++){const q=n(this.expr[L],b.expr[L]);if(q!==0)return q}return 0}equals(b){if(b.type===this.type){if(this.expr.length!==b.expr.length)return!1;for(let L=0,j=this.expr.length;L<j;L++)if(!this.expr[L].equals(b.expr[L]))return!1;return!0}return!1}substituteConstants(){const b=_(this.expr);return b===this.expr?this:U.create(b,this.c,!1)}evaluate(b){for(let L=0,j=this.expr.length;L<j;L++)if(this.expr[L].evaluate(b))return!0;return!1}static d(b,L,j){let q=[],X=!1;if(b){for(let K=0,re=b.length;K<re;K++){const fe=b[K];if(fe){if(fe.type===f.False){X=!0;continue}if(fe.type===f.True)return h.INSTANCE;if(fe.type===f.Or){q=q.concat(fe.expr);continue}q.push(fe)}}if(q.length===0&&X)return r.INSTANCE;q.sort(n)}if(q.length!==0){if(q.length===1)return q[0];for(let K=1;K<q.length;K++)q[K-1].equals(q[K])&&(q.splice(K,1),K--);if(q.length===1)return q[0];if(j){for(let K=0;K<q.length;K++)for(let re=K+1;re<q.length;re++)if(q[K].negate().equals(q[re]))return h.INSTANCE;if(q.length===1)return q[0]}return new U(q,L)}}serialize(){return this.expr.map(b=>b.serialize()).join(" || ")}keys(){const b=[];for(const L of this.expr)b.push(...L.keys());return b}map(b){return new U(this.expr.map(L=>L.map(b)),null)}negate(){if(!this.c){const b=[];for(const L of this.expr)b.push(L.negate());for(;b.length>1;){const L=b.shift(),j=b.shift(),q=[];for(const X of H(L))for(const K of H(j))q.push(B.create([X,K],null,!1));b.unshift(U.create(q,null,!1))}this.c=U.create(b,this,!0)}return this.c}}t.$Qj=U;class G extends E{static{this.d=[]}static all(){return G.d.values()}constructor(b,L,j){super(b,null),this.f=L,typeof j=="object"?G.d.push({...j,key:b}):j!==!0&&G.d.push({key:b,description:j,type:L!=null?typeof L:void 0})}bindTo(b){return b.createKey(this.key,this.f)}getValue(b){return b.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(b){return R.create(this.key,b)}notEqualsTo(b){return C.create(this.key,b)}}t.$Rj=G,t.$Sj=(0,D.$Ai)("contextKeyService");function Z(V,b){return V<b?-1:V>b?1:0}function Y(V,b,L,j){return V<L?-1:V>L?1:b<j?-1:b>j?1:0}function F(V,b){if(V.type===f.False||b.type===f.True)return!0;if(V.type===f.Or)return b.type===f.Or?z(V.expr,b.expr):!1;if(b.type===f.Or){for(const L of b.expr)if(F(V,L))return!0;return!1}if(V.type===f.And){if(b.type===f.And)return z(b.expr,V.expr);for(const L of V.expr)if(F(L,b))return!0;return!1}return V.equals(b)}function z(V,b){let L=0,j=0;for(;L<V.length&&j<b.length;){const q=V[L].cmp(b[j]);if(q<0)return!1;q===0&&L++,j++}return L===V.length}function H(V){return V.type===f.Or?V.expr:[V]}}),define(se[62],oe([0,1,11]),function(Q,t,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Ro=void 0,t.$Ro=(0,O.$Ai)("downloadService")}),define(se[18],oe([0,1,11]),function(Q,t,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Ii=t.$Hi=void 0,t.$Hi=(0,O.$Ai)("environmentService"),t.$Ii=(0,O.$Bi)(t.$Hi)}),define(se[63],oe([0,1,14,9,107,10]),function(Q,t,O,k,v,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Pq=D;async function D(l,c,f,p,y,N){let g;try{await S(l,c,f,p,y,N)}catch(d){g=d}finally{g&&y.errorTransformer&&(g=y.errorTransformer(g)),typeof g<"u"&&f.error(g),f.end()}}async function S(l,c,f,p,y,N){m(N);const g=await l.open(c,{create:!1});try{m(N);let d=0,$=0,P=y&&typeof y.length=="number"?y.length:void 0,w=O.$Je.alloc(Math.min(y.bufferSize,typeof P=="number"?P:y.bufferSize)),u=y&&typeof y.position=="number"?y.position:0,i=0;do $=await l.read(g,u,w.buffer,i,w.byteLength-i),u+=$,i+=$,d+=$,typeof P=="number"&&(P-=$),i===w.byteLength&&(await f.write(p(w)),w=O.$Je.alloc(Math.min(y.bufferSize,typeof P=="number"?P:y.bufferSize)),i=0);while($>0&&(typeof P!="number"||P>0)&&m(N)&&a(d,y));if(i>0){let o=i;typeof P=="number"&&(o=Math.min(i,P)),f.write(p(w.slice(0,o)))}}catch(d){throw(0,I.$il)(d)}finally{await l.close(g)}}function m(l){if(l.isCancellationRequested)throw(0,k.$6)();return!0}function a(l,c){if(typeof c?.limits?.size=="number"&&l>c.limits.size)throw(0,I.$hl)((0,v.localize)(0,null),I.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(se[125],oe([0,1,61,2,52,5,10,12,8]),function(Q,t,O,k,v,I,D,S,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$$q=void 0;class a extends k.$Uc{constructor(){super(),this.a=this.B(new I.$he),this.onDidChangeFile=this.a.event,this.b=this.B(new I.$he),this.onDidLogMessage=this.b.event,this.c=this.B(new I.$he),this.f=this.c.event,this.g=new Set,this.h=new Map,this.j=this.B(new k.$4c),this.m=new Set,this.n=5007,this.r=new m.$Xh,this.P=!1,this.B(this.f(c=>this.s(c)))}s(c){this.t(c)&&this.w(c)}t(c){return(0,v.$Rq)(c)}async watch(c){this.r.isSettled||this.r.complete(),this.r=new m.$Xh;try{this.h.clear(),this.g.clear();for(const f of c)this.t(f)?this.h.set(f.correlationId,f):this.g.add(f);for(const[f]of this.j)this.h.has(f)||(this.j.deleteAndDispose(f),this.m.delete(f));return await this.u()}finally{this.r.complete()}}u(){return this.L([...this.g,...Array.from(this.h.values()).filter(c=>!this.j.has(c.correlationId))])}isSuspended(c){return typeof c.correlationId!="number"?!1:this.m.has(c.correlationId)?"polling":this.j.has(c.correlationId)}async w(c){if(this.j.has(c.correlationId))return;const f=new k.$Tc;this.j.set(c.correlationId,f),await this.r.p,!f.isDisposed&&(this.z(c,f),this.u())}y(c){this.j.deleteAndDispose(c.correlationId),this.m.delete(c.correlationId),this.u()}z(c,f){this.C(c,f)?(this.N(`reusing an existing recursive watcher to monitor ${c.path}`),this.m.delete(c.correlationId)):(this.D(c,f),this.m.add(c.correlationId))}C(c,f){const p=this.M?.subscribe(c.path,(y,N)=>{f.isDisposed||(y?this.z(c,f):N?.type===D.FileChangeType.ADDED&&this.F(c))});return p?(f.add(p),!0):!1}D(c,f){let p=!1;const y=(N,g)=>{if(f.isDisposed)return;const d=this.G(N),$=this.G(g),P=p;p=d,!d&&($||P)&&this.F(c)};this.N(`starting fs.watchFile() on ${c.path} (correlationId: ${c.correlationId})`);try{(0,O.watchFile)(c.path,{persistent:!1,interval:this.n},y)}catch(N){this.O(`fs.watchFile() failed with error ${N} on path ${c.path} (correlationId: ${c.correlationId})`)}f.add((0,k.$Sc)(()=>{this.N(`stopping fs.watchFile() on ${c.path} (correlationId: ${c.correlationId})`);try{(0,O.unwatchFile)(c.path,y)}catch(N){this.O(`fs.unwatchFile() failed with error ${N} on path ${c.path} (correlationId: ${c.correlationId})`)}}))}F(c){this.N(`detected ${c.path} exists again, resuming watcher (correlationId: ${c.correlationId})`);const f={resource:S.URI.file(c.path),type:D.FileChangeType.ADDED,cId:c.correlationId};this.a.fire([f]),this.H(f,c),this.y(c)}G(c){return c.ctimeMs===0&&c.ino===0}async stop(){this.j.clearAndDisposeAll(),this.m.clear()}H(c,f){if(this.P){const p=` >> normalized ${c.type===D.FileChangeType.ADDED?"[ADDED]":c.type===D.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${c.resource.fsPath}`;this.I(p,f)}}I(c,f){this.P&&this.N(`${c}${typeof f.correlationId=="number"?` <${f.correlationId}> `:""}`)}J(c){return`${c.path} (excludes: ${c.excludes.length>0?c.excludes:"<none>"}, includes: ${c.includes&&c.includes.length>0?JSON.stringify(c.includes):"<all>"}, filter: ${(0,v.$2q)(c.filter)}, correlationId: ${typeof c.correlationId=="number"?c.correlationId:"<none>"})`}async setVerboseLogging(c){this.P=c}}t.$$q=a}),define(se[126],oe([0,1,5,173,125,13,174,64]),function(Q,t,O,k,v,I,D,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$fr=void 0;class m extends v.$$q{constructor(l){super(),this.M=l,this.onDidError=O.Event.None,this.watchers=new Set}async L(l){l=this.X(l);const c=[],f=new Set(Array.from(this.watchers));for(const p of l){const y=this.S(p);y&&(0,k.$yk)(y.request.excludes,p.excludes)&&(0,k.$yk)(y.request.includes,p.includes)?f.delete(y):c.push(p)}c.length&&this.N(`Request to start watching: ${c.map(p=>this.J(p)).join(",")}`),f.size&&this.N(`Request to stop watching: ${Array.from(f).map(p=>this.J(p.request)).join(",")}`);for(const p of f)this.W(p);for(const p of c)this.U(p)}S(l){for(const c of this.watchers)if(typeof l.correlationId=="number"||typeof c.request.correlationId=="number"){if(c.request.correlationId===l.correlationId)return c}else if((0,S.$yg)(c.request.path,l.path,!I.$k))return c}U(l){const c=new D.$dr(l,this.M,p=>this.a.fire(p),()=>this.c.fire(l),p=>this.b.fire(p),this.P),f={request:l,instance:c};this.watchers.add(f)}async stop(){await super.stop();for(const l of this.watchers)this.W(l)}W(l){this.N("stopping file watcher",l),this.watchers.delete(l),l.instance.dispose()}X(l){const c=new Map;for(const f of l){const p=I.$k?f.path:f.path.toLowerCase();let y=c.get(f.correlationId);y||(y=new Map,c.set(f.correlationId,y)),y.has(p)&&this.N(`ignoring a request for watching who's path is already watched: ${this.J(f)}`),y.set(p,f)}return Array.from(c.values()).map(f=>Array.from(f.values())).flat()}async setVerboseLogging(l){super.setVerboseLogging(l);for(const c of this.watchers)c.instance.setVerboseLogging(l)}N(l,c){this.P&&this.b.fire({type:"trace",message:this.$(l,c)})}O(l){this.b.fire({type:"warn",message:this.$(l)})}$(l,c){return c?`[File Watcher (node.js)] ${l} (${this.J(c.request)})`:`[File Watcher (node.js)] ${l}`}}t.$fr=m}),define(se[127],oe([0,1,52,126]),function(Q,t,O,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$gr=void 0;class v extends O.$Uq{constructor(D,S,m){super(D,S,m),this.u()}t(D){return D.add(new k.$fr(void 0))}}t.$gr=v}),define(se[128],oe([0,1,15,59,92,52]),function(Q,t,O,k,v,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$0q=void 0;class D extends I.$Vq{constructor(m,a,l){super(m,a,l),this.u()}t(m){const a=m.add(new v.$9q(O.$Ug.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return m.add(a.onDidProcessExit(({code:l,signal:c})=>this.w(`terminated by itself with code ${l}, signal: ${c} (ETERM)`))),k.ProxyChannel.toService((0,k.$hi)(a.getChannel("watcher")))}}t.$0q=D}),define(se[65],oe([0,1]),function(Q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$yi=void 0;class O{constructor(...v){this.a=new Map;for(const[I,D]of v)this.set(I,D)}set(v,I){const D=this.a.get(v);return this.a.set(v,I),D}has(v){return this.a.has(v)}get(v){return this.a.get(v)}}t.$yi=O}),define(se[129],oe([0,1,8,9,2,51,123,11,65,175]),function(Q,t,O,k,v,I,D,S,m,a){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$lr=t.$kr=void 0;const l=!1;class c extends Error{constructor(g){super("cyclic dependency between services"),this.message=g.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${g.toString()}`}}class f{constructor(g=new m.$yi,d=!1,$,P=l){this.i=g,this.j=d,this.k=$,this.l=P,this.f=!1,this.g=new Set,this.h=new Set,this.t=new Set,this.i.set(S.$zi,this),this._globalGraph=P?$?._globalGraph??new D.$jr(w=>w):void 0}dispose(){if(!this.f){this.f=!0,(0,v.$Pc)(this.h),this.h.clear();for(const g of this.g)(0,v.$Oc)(g)&&g.dispose();this.g.clear()}}m(){if(this.f)throw new Error("InstantiationService has been disposed")}createChild(g,d){this.m();const $=this,P=new class extends f{dispose(){$.h.delete(P),super.dispose()}}(g,this.j,this,this.l);return this.h.add(P),d?.add(P),P}invokeFunction(g,...d){this.m();const $=y.traceInvocation(this.l,g);let P=!1;try{return g({get:u=>{if(P)throw(0,k.$8)("service accessor is only valid during the invocation of its target method");const i=this.s(u,$);if(!i)throw new Error(`[invokeFunction] unknown service '${u}'`);return i}},...d)}finally{P=!0,$.stop()}}createInstance(g,...d){this.m();let $,P;return g instanceof I.$xi?($=y.traceCreation(this.l,g.ctor),P=this.o(g.ctor,g.staticArguments.concat(d),$)):($=y.traceCreation(this.l,g),P=this.o(g,d,$)),$.stop(),P}o(g,d=[],$){const P=S._util.getServiceDependencies(g).sort((i,o)=>i.index-o.index),w=[];for(const i of P){const o=this.s(i.id,$);o||this.y(`[createInstance] ${g.name} depends on UNKNOWN service ${i.id}.`,!1),w.push(o)}const u=P.length>0?P[0].index:d.length;if(d.length!==u){console.trace(`[createInstance] First service dependency of ${g.name} at position ${u+1} conflicts with ${d.length} static arguments`);const i=u-d.length;i>0?d=d.concat(new Array(i)):d=d.slice(0,u)}return Reflect.construct(g,d.concat(w))}q(g,d){if(this.i.get(g)instanceof I.$xi)this.i.set(g,d);else if(this.k)this.k.q(g,d);else throw new Error("illegalState - setting UNKNOWN service instance")}r(g){const d=this.i.get(g);return!d&&this.k?this.k.r(g):d}s(g,d){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(g));const $=this.r(g);return $ instanceof I.$xi?this.u(g,$,d.branch(g,!0)):(d.branch(g,!1),$)}u(g,d,$){if(this.t.has(g))throw new Error(`illegal state - RECURSIVELY instantiating service '${g}'`);this.t.add(g);try{return this.v(g,d,$)}finally{this.t.delete(g)}}v(g,d,$){const P=new D.$jr(i=>i.id.toString());let w=0;const u=[{id:g,desc:d,_trace:$}];for(;u.length;){const i=u.pop();if(P.lookupOrInsertNode(i),w++>1e3)throw new c(P);for(const o of S._util.getServiceDependencies(i.desc.ctor)){const s=this.r(o.id);if(s||this.y(`[createInstance] ${g} depends on ${o.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(i.id),String(o.id)),s instanceof I.$xi){const e={id:o.id,desc:s,_trace:i._trace.branch(o.id,!0)};P.insertEdge(i,e),u.push(e)}}}for(;;){const i=P.roots();if(i.length===0){if(!P.isEmpty())throw new c(P);break}for(const{data:o}of i){if(this.r(o.id)instanceof I.$xi){const e=this.w(o.id,o.desc.ctor,o.desc.staticArguments,o.desc.supportsDelayedInstantiation,o._trace);this.q(o.id,e)}P.removeNode(o)}}return this.r(g)}w(g,d,$=[],P,w){if(this.i.get(g)instanceof I.$xi)return this.x(g,d,$,P,w,this.g);if(this.k)return this.k.w(g,d,$,P,w);throw new Error(`illegalState - creating UNKNOWN service instance ${d.name}`)}x(g,d,$=[],P,w,u){if(P){const i=new f(void 0,this.j,this,this.l);i.c=String(g);const o=new Map,s=new O.$Th(()=>{const e=i.o(d,$,w);for(const[n,r]of o){const h=e[n];if(typeof h=="function")for(const E of r)E.disposable=h.apply(e,E.listener)}return o.clear(),u.add(e),e});return new Proxy(Object.create(null),{get(e,n){if(!s.isInitialized&&typeof n=="string"&&(n.startsWith("onDid")||n.startsWith("onWill"))){let E=o.get(n);return E||(E=new a.$5c,o.set(n,E)),(A,T,C)=>{if(s.isInitialized)return s.value[n](A,T,C);{const M={listener:[A,T,C],disposable:void 0},J=E.push(M);return(0,v.$Sc)(()=>{J(),M.disposable?.dispose()})}}}if(n in e)return e[n];const r=s.value;let h=r[n];return typeof h!="function"||(h=h.bind(r),e[n]=h),h},set(e,n,r){return s.value[n]=r,!0},getPrototypeOf(e){return d.prototype}})}else{const i=this.o(d,$,w);return u.add(i),i}}y(g,d){if(d&&console.warn(g),this.j)throw new Error(g)}}t.$kr=f;var p;(function(N){N[N.None=0]="None",N[N.Creation=1]="Creation",N[N.Invocation=2]="Invocation",N[N.Branch=3]="Branch"})(p||(p={}));class y{static{this.all=new Set}static{this.c=new class extends y{constructor(){super(p.None,null)}stop(){}branch(){return this}}}static traceInvocation(g,d){return g?new y(p.Invocation,d.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):y.c}static traceCreation(g,d){return g?new y(p.Creation,d.name):y.c}static{this.f=0}constructor(g,d){this.type=g,this.name=d,this.g=Date.now(),this.h=[]}branch(g,d){const $=new y(p.Branch,g.toString());return this.h.push([g,d,$]),$}stop(){const g=Date.now()-this.g;y.f+=g;let d=!1;function $(w,u){const i=[],o=new Array(w+1).join("	");for(const[s,e,n]of u.h)if(e&&n){d=!0,i.push(`${o}CREATES -> ${s}`);const r=$(w+1,n);r&&i.push(r)}else i.push(`${o}uses -> ${s}`);return i.join(`
`)}const P=[`${this.type===p.Creation?"CREATE":"CALL"} ${this.name}`,`${$(1,this)}`,`DONE, took ${g.toFixed(2)}ms (grand total ${y.f.toFixed(2)}ms)`];(g>2||d)&&y.all.add(P.join(`
`))}}t.$lr=y}),define(se[6],oe([0,1,110,36,5,43,2,31,13,17,3,12,124,11]),function(Q,t,O,k,v,I,D,S,m,a,l,c,f,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$mk=t.$hk=t.$gk=t.$fk=t.$ek=t.$dk=t.$ck=t.$bk=t.$ak=t.$_j=t.$0j=t.LogLevel=t.$8j=t.$7j=void 0,t.$9j=N,t.log=d,t.$ik=h,t.$jk=E,t.$kk=R,t.$lk=A,t.$7j=(0,p.$Ai)("logService"),t.$8j=(0,p.$Ai)("loggerService");function y(){return new Date().toISOString()}function N(T){return(0,l.$eg)(T)}var g;(function(T){T[T.Off=0]="Off",T[T.Trace=1]="Trace",T[T.Debug=2]="Debug",T[T.Info=3]="Info",T[T.Warning=4]="Warning",T[T.Error=5]="Error"})(g||(t.LogLevel=g={})),t.$0j=g.Info;function d(T,C,M){switch(C){case g.Trace:T.trace(M);break;case g.Debug:T.debug(M);break;case g.Info:T.info(M);break;case g.Warning:T.warn(M);break;case g.Error:T.error(M);break;case g.Off:break;default:throw new Error(`Invalid log level ${C}`)}}function $(T,C=!1){let M="";for(let J=0;J<T.length;J++){let ae=T[J];if(ae instanceof Error&&(ae=(0,k.$lj)(ae,C)),typeof ae=="object")try{ae=JSON.stringify(ae)}catch{}M+=(J>0?" ":"")+ae}return M}class P extends D.$Uc{constructor(){super(...arguments),this.b=t.$0j,this.c=this.B(new v.$he),this.onDidChangeLogLevel=this.c.event}setLevel(C){this.b!==C&&(this.b=C,this.c.fire(this.b))}getLevel(){return this.b}f(C){return this.b!==g.Off&&this.b<=C}}t.$_j=P;class w extends P{constructor(C){super(),this.h=C}f(C){return this.h||super.f(C)}trace(C,...M){this.f(g.Trace)&&this.g(g.Trace,$([C,...M],!0))}debug(C,...M){this.f(g.Debug)&&this.g(g.Debug,$([C,...M]))}info(C,...M){this.f(g.Info)&&this.g(g.Info,$([C,...M]))}warn(C,...M){this.f(g.Warning)&&this.g(g.Warning,$([C,...M]))}error(C,...M){if(this.f(g.Error))if(C instanceof Error){const J=Array.prototype.slice.call(arguments);J[0]=C.stack,this.g(g.Error,$(J))}else this.g(g.Error,$([C,...M]))}flush(){}}t.$ak=w;class u extends P{constructor(C=t.$0j){super(),this.setLevel(C),this.g=!m.$i}trace(C,...M){this.f(g.Trace)&&(this.g?console.log(`\x1B[90m[main ${y()}]\x1B[0m`,C,...M):console.log(`[main ${y()}]`,C,...M))}debug(C,...M){this.f(g.Debug)&&(this.g?console.log(`\x1B[90m[main ${y()}]\x1B[0m`,C,...M):console.log(`[main ${y()}]`,C,...M))}info(C,...M){this.f(g.Info)&&(this.g?console.log(`\x1B[90m[main ${y()}]\x1B[0m`,C,...M):console.log(`[main ${y()}]`,C,...M))}warn(C,...M){this.f(g.Warning)&&(this.g?console.warn(`\x1B[93m[main ${y()}]\x1B[0m`,C,...M):console.warn(`[main ${y()}]`,C,...M))}error(C,...M){this.f(g.Error)&&(this.g?console.error(`\x1B[91m[main ${y()}]\x1B[0m`,C,...M):console.error(`[main ${y()}]`,C,...M))}flush(){}}t.$bk=u;class i extends P{constructor(C=t.$0j,M=!0){super(),this.g=M,this.setLevel(C)}trace(C,...M){this.f(g.Trace)&&(this.g?console.log("%cTRACE","color: #888",C,...M):console.log(C,...M))}debug(C,...M){this.f(g.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",C,...M):console.log(C,...M))}info(C,...M){this.f(g.Info)&&(this.g?console.log("%c INFO","color: #33f",C,...M):console.log(C,...M))}warn(C,...M){this.f(g.Warning)&&(this.g?console.log("%c WARN","color: #993",C,...M):console.log(C,...M))}error(C,...M){this.f(g.Error)&&(this.g?console.log("%c  ERR","color: #f33",C,...M):console.error(C,...M))}flush(){}}t.$ck=i;class o extends P{constructor(C,M=t.$0j){super(),this.g=C,this.setLevel(M)}trace(C,...M){this.f(g.Trace)&&this.g.log(g.Trace,[this.h(C),...M])}debug(C,...M){this.f(g.Debug)&&this.g.log(g.Debug,[this.h(C),...M])}info(C,...M){this.f(g.Info)&&this.g.log(g.Info,[this.h(C),...M])}warn(C,...M){this.f(g.Warning)&&this.g.log(g.Warning,[this.h(C),...M])}error(C,...M){this.f(g.Error)&&this.g.log(g.Error,[this.h(C),...M])}h(C){return typeof C=="string"?C:(0,k.$lj)(C,this.f(g.Trace))}flush(){}}t.$dk=o;class s extends P{constructor(C){super(),this.g=C,C.length&&this.setLevel(C[0].getLevel())}setLevel(C){for(const M of this.g)M.setLevel(C);super.setLevel(C)}trace(C,...M){for(const J of this.g)J.trace(C,...M)}debug(C,...M){for(const J of this.g)J.debug(C,...M)}info(C,...M){for(const J of this.g)J.info(C,...M)}warn(C,...M){for(const J of this.g)J.warn(C,...M)}error(C,...M){for(const J of this.g)J.error(C,...M)}flush(){for(const C of this.g)C.flush()}dispose(){for(const C of this.g)C.dispose();super.dispose()}}t.$ek=s;class e extends D.$Uc{constructor(C,M,J){if(super(),this.h=C,this.j=M,this.b=new S.$Ac,this.c=this.B(new v.$he),this.onDidChangeLoggers=this.c.event,this.f=this.B(new v.$he),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new v.$he),this.onDidChangeVisibility=this.g.event,J)for(const ae of J)this.b.set(ae.resource,{logger:void 0,info:ae})}m(C){return(0,l.$ag)(C)?[...this.b.values()].find(M=>M.info.id===C):this.b.get(C)}getLogger(C){return this.m(C)?.logger}createLogger(C,M){const J=this.n(C),ae=(0,l.$ag)(C)?C:M?.id??(0,I.$oj)(J.toString()).toString(16);let ie=this.b.get(J)?.logger;const ce=M?.logLevel==="always"?g.Trace:M?.logLevel;ie||(ie=this.s(J,ce??this.getLogLevel(J)??this.h,{...M,id:ae}));const ue={logger:ie,info:{resource:J,id:ae,logLevel:ce,name:M?.name,hidden:M?.hidden,extensionId:M?.extensionId,when:M?.when}};return this.registerLogger(ue.info),this.b.set(J,ue),ie}n(C){return(0,l.$ag)(C)?(0,a.$bh)(this.j,`${C}.log`):C}setLogLevel(C,M){if(c.URI.isUri(C)){const J=C,ae=M,ie=this.b.get(J);ie&&ae!==ie.info.logLevel&&(ie.info.logLevel=ae===this.h?void 0:ae,ie.logger?.setLevel(ae),this.b.set(ie.info.resource,ie),this.f.fire([J,ae]))}else{this.h=C;for(const[J,ae]of this.b.entries())this.b.get(J)?.info.logLevel===void 0&&ae.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(C,M){const J=this.m(C);J&&M!==!J.info.hidden&&(J.info.hidden=!M,this.b.set(J.info.resource,J),this.g.fire([J.info.resource,M]))}getLogLevel(C){let M;return C&&(M=this.b.get(C)?.info.logLevel),M??this.h}registerLogger(C){const M=this.b.get(C.resource);M?M.info.hidden!==C.hidden&&this.setVisibility(C.resource,!C.hidden):(this.b.set(C.resource,{info:C,logger:void 0}),this.c.fire({added:[C],removed:[]}))}deregisterLogger(C){const M=this.b.get(C);M&&(M.logger&&M.logger.dispose(),this.b.delete(C),this.c.fire({added:[],removed:[M.info]}))}*getRegisteredLoggers(){for(const C of this.b.values())yield C.info}getRegisteredLogger(C){return this.b.get(C)?.info}dispose(){this.b.forEach(C=>C.logger?.dispose()),this.b.clear(),super.dispose()}}t.$fk=e;class n{constructor(){this.onDidChangeLogLevel=new v.$he().event}setLevel(C){}getLevel(){return g.Info}trace(C,...M){}debug(C,...M){}info(C,...M){}warn(C,...M){}error(C,...M){}critical(C,...M){}dispose(){}flush(){}}t.$gk=n;class r extends n{}t.$hk=r;function h(T){if(T.verbose)return g.Trace;if(typeof T.logLevel=="string"){const C=A(T.logLevel.toLowerCase());if(C!==void 0)return C}return t.$0j}function E(T){switch(T){case g.Trace:return"trace";case g.Debug:return"debug";case g.Info:return"info";case g.Warning:return"warn";case g.Error:return"error";case g.Off:return"off"}}function R(T){switch(T){case g.Trace:return{original:"Trace",value:O.localize(0,null)};case g.Debug:return{original:"Debug",value:O.localize(1,null)};case g.Info:return{original:"Info",value:O.localize(2,null)};case g.Warning:return{original:"Warning",value:O.localize(3,null)};case g.Error:return{original:"Error",value:O.localize(4,null)};case g.Off:return{original:"Off",value:O.localize(5,null)}}}function A(T){switch(T){case"trace":return g.Trace;case"debug":return g.Debug;case"info":return g.Info;case"warn":return g.Warning;case"error":return g.Error;case"critical":return g.Error;case"off":return g.Off}}t.$mk=new f.$Rj("logLevel",E(g.Info))}),define(se[130],oe([0,1,20,8,9,5,64,2,16,52,6]),function(Q,t,O,k,v,I,D,S,m,a,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$3q=void 0;class c extends S.$Uc{constructor(p,y){super(),this.a=p,this.b=y,this.c=this.B(new I.$he),this.onDidChangeFile=this.c.event,this.g=this.B(new I.$he),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new k.$yh(0)),this.w=[],this.y=this.B(new k.$yh(0))}watch(p,y){return y.recursive||this.b?.watcher?.forceUniversal?this.n(p,y):this.z(p,y)}n(p,y){const N={path:this.J(p),excludes:y.excludes,includes:y.includes,recursive:y.recursive,filter:y.filter,correlationId:y.correlationId},g=(0,O.$Tb)(this.j,N);return this.r(),(0,S.$Sc)(()=>{g(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(p=>(0,v.$1)(p))}s(){this.h||(this.h=this.B(this.t(y=>this.c.fire((0,a.$Wq)(y)),y=>this.G(y),this.a.getLevel()===l.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===l.LogLevel.Trace)})));const p=this.b?.watcher?.recursive?.usePolling;if(p===!0)for(const y of this.j)(0,a.$Sq)(y)&&(y.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(p))for(const y of this.j)(0,a.$Sq)(y)&&p.includes(y.path)&&(y.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(p,y){const N={path:this.J(p),excludes:y.excludes,includes:y.includes,recursive:!1,filter:y.filter,correlationId:y.correlationId},g=(0,O.$Tb)(this.w,N);return this.C(),(0,S.$Sc)(()=>{g(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(p=>(0,v.$1)(p))}D(){return this.u||(this.u=this.B(this.F(p=>this.c.fire((0,a.$Wq)(p)),p=>this.G(p),this.a.getLevel()===l.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===l.LogLevel.Trace)}))),this.u.watch(this.w)}G(p){p.type==="error"&&this.g.fire(p.message),this.H(p)}H(p){this.a[p.type](p.message)}I(p){return(0,m.$hc)(p.fsPath)}J(p){const y=this.I(p);return(0,D.$Cg)(y)}}t.$3q=c});var ne=this&&this.__param||function(Q,t){return function(O,k){t(O,k,Q)}};define(se[131],oe([0,1,20,8,14,22,5,43,66,2,48,15,132,17,46,106,10,63,6,9]),function(Q,t,O,k,v,I,D,S,m,a,l,c,f,p,y,N,g,d,$,P){"use strict";var w;Object.defineProperty(t,"__esModule",{value:!0}),t.$Qq=void 0;let u=class extends a.$Uc{static{w=this}constructor(o){super(),this.b=o,this.a=256*1024,this.c=this.B(new D.$he),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new D.$he),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new D.$he),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.r=this.B(new D.$he),this.onDidRunOperation=this.r.event,this.X=this.B(new D.$he),this.Y=this.B(new D.$he),this.onDidFilesChange=this.Y.event,this.Z=this.B(new D.$he),this.onDidWatchError=this.Z.event,this.$=new Map,this.cb=this.B(new k.$Jh)}registerProvider(o,s){if(this.h.has(o))throw new Error(`A filesystem provider for the scheme '${o}' is already registered.`);(0,f.mark)(`code/registerFilesystem/${o}`);const e=new a.$Tc;return this.h.set(o,s),this.c.fire({added:!0,scheme:o,provider:s}),e.add(s.onDidChangeFile(n=>{const r=new g.$nl(n,!this.S(s));this.X.fire(r),r.hasCorrelation()||this.Y.fire(r)})),typeof s.onDidWatchError=="function"&&e.add(s.onDidWatchError(n=>this.Z.fire(new Error(n)))),e.add(s.onDidChangeCapabilities(()=>this.g.fire({provider:s,scheme:o}))),(0,a.$Sc)(()=>{this.c.fire({added:!1,scheme:o,provider:s}),this.h.delete(o),(0,a.$Pc)(e)})}getProvider(o){return this.h.get(o)}async activateProvider(o){const s=[];this.f.fire({scheme:o,join(e){s.push(e)}}),!this.h.has(o)&&await k.Promises.settled(s)}async canHandleResource(o){return await this.activateProvider(o.scheme),this.hasProvider(o)}hasProvider(o){return this.h.has(o.scheme)}hasCapability(o,s){const e=this.h.get(o.scheme);return!!(e&&e.capabilities&s)}listCapabilities(){return m.Iterable.map(this.h,([o,s])=>({scheme:o,capabilities:s.capabilities}))}async j(o){if(!(0,p.$fh)(o))throw new g.$pl((0,N.localize)(0,null,this.sb(o)),g.FileOperationResult.FILE_INVALID_PATH);await this.activateProvider(o.scheme);const s=this.h.get(o.scheme);if(!s){const e=new P.$bb;throw e.message=(0,N.localize)(1,null,o.toString()),e}return s}async m(o){const s=await this.j(o);if((0,g.$al)(s)||(0,g.$0k)(s)||(0,g.$bl)(s))return s;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async n(o){const s=await this.j(o);if((0,g.$al)(s)||(0,g.$0k)(s))return s;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(o,s){try{return await this.s(o,s)}catch(e){throw(0,g.$kl)(e)===g.FileSystemProviderErrorCode.FileNotFound?new g.$pl((0,N.localize)(2,null,this.sb(o)),g.FileOperationResult.FILE_NOT_FOUND):(0,g.$il)(e)}}async s(o,s){const e=await this.j(o),n=this.S(e),r=s?.resolveTo,h=s?.resolveSingleChildDescendants,E=s?.resolveMetadata,R=await e.stat(o);let A;return this.t(e,o,R,void 0,!!E,(T,C)=>(A||(A=l.$Gi.forUris(()=>!n),A.set(o,!0),r&&A.fill(!0,r)),A.get(T.resource)||A.findSuperstr(T.resource.with({query:null,fragment:null}))?!0:T.isDirectory&&h?C===1:!1))}async t(o,s,e,n,r,h){const{providerExtUri:E}=this.R(o),R={resource:s,name:E.basename(s),isFile:(e.type&g.FileType.File)!==0,isDirectory:(e.type&g.FileType.Directory)!==0,isSymbolicLink:(e.type&g.FileType.SymbolicLink)!==0,mtime:e.mtime,ctime:e.ctime,size:e.size,readonly:!!((e.permissions??0)&g.FilePermission.Readonly)||!!(o.capabilities&g.FileSystemProviderCapabilities.Readonly),locked:!!((e.permissions??0)&g.FilePermission.Locked),etag:(0,g.$Al)({mtime:e.mtime,size:e.size}),children:void 0};if(R.isDirectory&&h(R,n)){try{const A=await o.readdir(s),T=await k.Promises.settled(A.map(async([C,M])=>{try{const J=E.joinPath(s,C),ae=r?await o.stat(J):{type:M};return await this.t(o,J,ae,A.length,r,h)}catch(J){return this.b.trace(J),null}}));R.children=(0,O.$Hb)(T)}catch(A){this.b.trace(A),R.children=[]}return R}return R}async resolveAll(o){return k.Promises.settled(o.map(async s=>{try{return{stat:await this.s(s.resource,s.options),success:!0}}catch(e){return this.b.trace(e),{stat:void 0,success:!1}}}))}async stat(o){const s=await this.j(o),e=await s.stat(o);return this.t(s,o,e,void 0,!0,()=>!1)}async exists(o){const s=await this.j(o);try{return!!await s.stat(o)}catch{return!1}}async canCreateFile(o,s){try{await this.u(o,s)}catch(e){return e}return!0}async u(o,s){if(!s?.overwrite&&await this.exists(o))throw new g.$pl((0,N.localize)(3,null,this.sb(o)),g.FileOperationResult.FILE_MODIFIED_SINCE,s)}async createFile(o,s=v.$Je.fromString(""),e){await this.u(o,e);const n=await this.writeFile(o,s);return this.r.fire(new g.$ml(o,g.FileOperation.CREATE,n)),n}async writeFile(o,s,e){const n=this.qb(await this.n(o),o),{providerExtUri:r}=this.R(n);let h=e;if((0,g.$dl)(n)&&!h?.atomic){const E=n.enforceAtomicWriteFile?.(o);E&&(h={...e,atomic:E})}try{await this.w(n,o,h)||await this.U(n,r.dirname(o));let R;if((0,g.$0k)(n)&&!(s instanceof v.$Je))if((0,y.$ve)(s)){const A=await(0,y.$Ce)(s,3);A.ended?R=v.$Je.concat(A.buffer):R=A}else R=(0,y.$ze)(s,A=>v.$Je.concat(A),3);else R=s;!(0,g.$al)(n)||(0,g.$0k)(n)&&R instanceof v.$Je||(0,g.$0k)(n)&&(0,g.$dl)(n)&&h?.atomic?await this.hb(n,o,h,R):await this.db(n,o,h,R instanceof v.$Je?(0,v.$Ue)(R):R),this.r.fire(new g.$ml(o,g.FileOperation.WRITE))}catch(E){throw new g.$pl((0,N.localize)(4,null,this.sb(o),(0,g.$il)(E).toString()),(0,g.$ll)(E),h)}return this.resolve(o,{resolveMetadata:!0})}async w(o,s,e){const n=!!e?.unlock;if(n&&!(o.capabilities&g.FileSystemProviderCapabilities.FileWriteUnlock))throw new Error((0,N.localize)(5,null,this.sb(s)));if(!!e?.atomic){if(!(o.capabilities&g.FileSystemProviderCapabilities.FileAtomicWrite))throw new Error((0,N.localize)(6,null,this.sb(s)));if(!(o.capabilities&g.FileSystemProviderCapabilities.FileReadWrite))throw new Error((0,N.localize)(7,null,this.sb(s)));if(n)throw new Error((0,N.localize)(8,null,this.sb(s)))}let h;try{h=await o.stat(s)}catch{return}if(h.type&g.FileType.Directory)throw new g.$pl((0,N.localize)(9,null,this.sb(s)),g.FileOperationResult.FILE_IS_DIRECTORY,e);if(this.rb(s,h),typeof e?.mtime=="number"&&typeof e.etag=="string"&&e.etag!==g.$zl&&typeof h.mtime=="number"&&typeof h.size=="number"&&e.mtime<h.mtime&&e.etag!==(0,g.$Al)({mtime:e.mtime,size:h.size}))throw new g.$pl((0,N.localize)(10,null),g.FileOperationResult.FILE_MODIFIED_SINCE,e);return h}async readFile(o,s,e){const n=await this.m(o);return s?.atomic?this.z(n,o,s,e):this.C(n,o,s,e)}async z(o,s,e,n){return new Promise((r,h)=>{this.cb.queueFor(s,async()=>{try{const E=await this.C(o,s,e,n);r(E)}catch(E){h(E)}},this.R(o).providerExtUri)})}async C(o,s,e,n){const r=await this.D(o,s,{...e,preferUnbuffered:!0},n);return{...r,value:await(0,v.$Ve)(r.value)}}async readFileStream(o,s,e){const n=await this.m(o);return this.D(n,o,s,e)}async D(o,s,e,n){const r=new I.$se(n);let h=e;(0,g.$cl)(o)&&o.enforceAtomicReadFile?.(s)&&(h={...e,atomic:!0});const E=this.J(s,h).then(A=>A,A=>{throw r.dispose(!0),A});let R;try{return typeof h?.etag=="string"&&h.etag!==g.$zl&&await E,h?.atomic&&(0,g.$cl)(o)||!((0,g.$al)(o)||(0,g.$bl)(o))||(0,g.$0k)(o)&&h?.preferUnbuffered?R=this.I(o,s,h):(0,g.$bl)(o)?R=this.G(o,s,r.token,h):R=this.H(o,s,r.token,h),R.on("end",()=>r.dispose()),R.on("error",()=>r.dispose()),{...await E,value:R}}catch(A){throw R&&await(0,y.$Ae)(R),this.F(A,s,h)}}F(o,s,e){const n=(0,N.localize)(11,null,this.sb(s),(0,g.$il)(o).toString());return o instanceof g.$rl?new g.$rl(n,o.stat,e):o instanceof g.$ql?new g.$ql(n,o.fileOperationResult,o.size,o.options):new g.$pl(n,(0,g.$ll)(o),e)}G(o,s,e,n=Object.create(null)){const r=o.readFileStream(s,n,e);return(0,y.$Ge)(r,{data:h=>h instanceof v.$Je?h:v.$Je.wrap(h),error:h=>this.F(h,s,n)},h=>v.$Je.concat(h))}H(o,s,e,n=Object.create(null)){const r=(0,v.$Ze)();return(0,d.$Pq)(o,s,r,h=>h,{...n,bufferSize:this.a,errorTransformer:h=>this.F(h,s,n)},e),r}I(o,s,e){const n=(0,y.$xe)(r=>v.$Je.concat(r));return(async()=>{try{let r;e?.atomic&&(0,g.$cl)(o)?r=await o.readFile(s,{atomic:!0}):r=await o.readFile(s),typeof e?.position=="number"&&(r=r.slice(e.position)),typeof e?.length=="number"&&(r=r.slice(0,e.length)),this.L(s,r.byteLength,e),n.end(v.$Je.wrap(r))}catch(r){n.error(r),n.end()}})(),n}async J(o,s){const e=await this.resolve(o,{resolveMetadata:!0});if(e.isDirectory)throw new g.$pl((0,N.localize)(12,null,this.sb(o)),g.FileOperationResult.FILE_IS_DIRECTORY,s);if(typeof s?.etag=="string"&&s.etag!==g.$zl&&s.etag===e.etag)throw new g.$rl((0,N.localize)(13,null),e,s);return this.L(o,e.size,s),e}L(o,s,e){if(typeof e?.limits?.size=="number"&&s>e.limits.size)throw new g.$ql((0,N.localize)(14,null,this.sb(o)),g.FileOperationResult.FILE_TOO_LARGE,s,e)}async canMove(o,s,e){return this.M(o,s,"move",e)}async canCopy(o,s,e){return this.M(o,s,"copy",e)}async M(o,s,e,n){if(o.toString()!==s.toString())try{const r=e==="move"?this.qb(await this.n(o),o):await this.m(o),h=this.qb(await this.n(s),s);await this.Q(r,o,h,s,e,n)}catch(r){return r}return!0}async move(o,s,e){const n=this.qb(await this.n(o),o),r=this.qb(await this.n(s),s),h=await this.N(n,o,r,s,"move",!!e),E=await this.resolve(s,{resolveMetadata:!0});return this.r.fire(new g.$ml(o,h==="move"?g.FileOperation.MOVE:g.FileOperation.COPY,E)),E}async copy(o,s,e){const n=await this.m(o),r=this.qb(await this.n(s),s),h=await this.N(n,o,r,s,"copy",!!e),E=await this.resolve(s,{resolveMetadata:!0});return this.r.fire(new g.$ml(o,h==="copy"?g.FileOperation.COPY:g.FileOperation.MOVE,E)),E}async N(o,s,e,n,r,h){if(s.toString()===n.toString())return r;const{exists:E,isSameResourceWithDifferentPathCase:R}=await this.Q(o,s,e,n,r,h);if(E&&!R&&h&&await this.del(n,{recursive:!0}),await this.U(e,this.R(e).providerExtUri.dirname(n)),r==="copy"){if(o===e&&(0,g.$$k)(o))await o.copy(s,n,{overwrite:h});else{const A=await this.resolve(s);A.isDirectory?await this.P(o,A,e,n):await this.O(o,s,e,n)}return r}else return o===e?(await o.rename(s,n,{overwrite:h}),r):(await this.N(o,s,e,n,"copy",h),await this.del(s,{recursive:!0}),"copy")}async O(o,s,e,n){if((0,g.$al)(o)&&(0,g.$al)(e))return this.jb(o,s,e,n);if((0,g.$al)(o)&&(0,g.$0k)(e))return this.pb(o,s,e,n);if((0,g.$0k)(o)&&(0,g.$al)(e))return this.nb(o,s,e,n);if((0,g.$0k)(o)&&(0,g.$0k)(e))return this.lb(o,s,e,n)}async P(o,s,e,n){await e.mkdir(n),Array.isArray(s.children)&&await k.Promises.settled(s.children.map(async r=>{const h=this.R(e).providerExtUri.joinPath(n,r.name);return r.isDirectory?this.P(o,await this.resolve(r.resource),e,h):this.O(o,r.resource,e,h)}))}async Q(o,s,e,n,r,h){let E=!1;if(o===e){const{providerExtUri:A,isPathCaseSensitive:T}=this.R(o);if(T||(E=A.isEqual(s,n)),E&&r==="copy")throw new Error((0,N.localize)(15,null,this.sb(s),this.sb(n)));if(!E&&A.isEqualOrParent(n,s))throw new Error((0,N.localize)(16,null,this.sb(s),this.sb(n)))}const R=await this.exists(n);if(R&&!E){if(!h)throw new g.$pl((0,N.localize)(17,null,this.sb(s),this.sb(n)),g.FileOperationResult.FILE_MOVE_CONFLICT);if(o===e){const{providerExtUri:A}=this.R(o);if(A.isEqualOrParent(s,n))throw new Error((0,N.localize)(18,null,this.sb(s),this.sb(n)))}}return{exists:R,isSameResourceWithDifferentPathCase:E}}R(o){const s=this.S(o);return{providerExtUri:s?p.$4g:p.$6g,isPathCaseSensitive:s}}S(o){return!!(o.capabilities&g.FileSystemProviderCapabilities.PathCaseSensitive)}async createFolder(o){const s=this.qb(await this.j(o),o);await this.U(s,o);const e=await this.resolve(o,{resolveMetadata:!0});return this.r.fire(new g.$ml(o,g.FileOperation.CREATE,e)),e}async U(o,s){const e=[],{providerExtUri:n}=this.R(o);for(;!n.isEqual(s,n.dirname(s));)try{if(!((await o.stat(s)).type&g.FileType.Directory))throw new Error((0,N.localize)(19,null,this.sb(s)));break}catch(r){if((0,g.$kl)(r)!==g.FileSystemProviderErrorCode.FileNotFound)throw r;e.push(n.basename(s)),s=n.dirname(s)}for(let r=e.length-1;r>=0;r--){s=n.joinPath(s,e[r]);try{await o.mkdir(s)}catch(h){if((0,g.$kl)(h)!==g.FileSystemProviderErrorCode.FileExists)throw h}}}async canDelete(o,s){try{await this.W(o,s)}catch(e){return e}return!0}async W(o,s){const e=this.qb(await this.j(o),o),n=!!s?.useTrash;if(n&&!(e.capabilities&g.FileSystemProviderCapabilities.Trash))throw new Error((0,N.localize)(20,null,this.sb(o)));const r=s?.atomic;if(r&&!(e.capabilities&g.FileSystemProviderCapabilities.FileAtomicDelete))throw new Error((0,N.localize)(21,null,this.sb(o)));if(n&&r)throw new Error((0,N.localize)(22,null,this.sb(o)));let h;try{h=await e.stat(o)}catch{}if(h)this.rb(o,h);else throw new g.$pl((0,N.localize)(23,null,this.sb(o)),g.FileOperationResult.FILE_NOT_FOUND);if(!!!s?.recursive){const R=await this.resolve(o);if(R.isDirectory&&Array.isArray(R.children)&&R.children.length>0)throw new Error((0,N.localize)(24,null,this.sb(o)))}return e}async del(o,s){const e=await this.W(o,s);let n=s;if((0,g.$el)(e)&&!n?.atomic){const R=e.enforceAtomicDelete?.(o);R&&(n={...s,atomic:R})}const r=!!n?.useTrash,h=!!n?.recursive,E=n?.atomic??!1;await e.delete(o,{recursive:h,useTrash:r,atomic:E}),this.r.fire(new g.$ml(o,g.FileOperation.DELETE))}async cloneFile(o,s){const e=await this.j(o),n=this.qb(await this.n(s),s);if(!(e===n&&this.R(e).providerExtUri.isEqual(o,s)))return e===n&&(0,g.$_k)(e)?e.cloneFile(o,s):(await this.U(n,this.R(n).providerExtUri.dirname(s)),e===n&&(0,g.$$k)(e)?this.cb.queueFor(o,()=>e.copy(o,s,{overwrite:!0}),this.R(e).providerExtUri):this.cb.queueFor(o,()=>this.O(e,o,n,s),this.R(e).providerExtUri))}static{this.ab=0}createWatcher(o,s){return this.watch(o,{...s,correlationId:w.ab++})}watch(o,s={recursive:!1,excludes:[]}){const e=new a.$Tc;let n=!1,r=()=>{n=!0};e.add((0,a.$Sc)(()=>r())),(async()=>{try{const E=await this.bb(o,s);n?(0,a.$Pc)(E):r=()=>(0,a.$Pc)(E)}catch(E){this.b.error(E)}})();const h=s.correlationId;if(typeof h=="number"){const E=e.add(new D.$he);return e.add(this.X.event(A=>{A.correlates(h)&&E.fire(A)})),{onDidChange:E.event,dispose:()=>e.dispose()}}return e}async bb(o,s){const e=await this.j(o),n=(0,S.$oj)([this.R(e).providerExtUri.getComparisonKey(o),s]);let r=this.$.get(n);return r||(r={count:0,disposable:e.watch(o,s)},this.$.set(n,r)),r.count+=1,(0,a.$Sc)(()=>{r&&(r.count--,r.count===0&&((0,a.$Pc)(r.disposable),this.$.delete(n)))})}dispose(){super.dispose();for(const[,o]of this.$)(0,a.$Pc)(o.disposable);this.$.clear()}async db(o,s,e,n){return this.cb.queueFor(s,async()=>{const r=await o.open(s,{create:!0,unlock:e?.unlock??!1});try{(0,y.$ve)(n)||(0,y.$we)(n)?await this.eb(o,r,n):await this.fb(o,r,n)}catch(h){throw(0,g.$il)(h)}finally{await o.close(r)}},this.R(o).providerExtUri)}async eb(o,s,e){let n=0,r;if((0,y.$we)(e)){if(e.buffer.length>0){const h=v.$Je.concat(e.buffer);await this.gb(o,s,h,h.byteLength,n,0),n+=h.byteLength}if(e.ended)return;r=e.stream}else r=e;return new Promise((h,E)=>{(0,y.$Be)(r,{onData:async R=>{r.pause();try{await this.gb(o,s,R,R.byteLength,n,0)}catch(A){return E(A)}n+=R.byteLength,setTimeout(()=>r.resume())},onError:R=>E(R),onEnd:()=>h()})})}async fb(o,s,e){let n=0,r;for(;(r=e.read())!==null;)await this.gb(o,s,r,r.byteLength,n,0),n+=r.byteLength}async gb(o,s,e,n,r,h){let E=0;for(;E<n;){const R=await o.write(s,r+E,e.buffer,h+E,n-E);E+=R}}async hb(o,s,e,n){return this.cb.queueFor(s,()=>this.ib(o,s,e,n),this.R(o).providerExtUri)}async ib(o,s,e,n){let r;n instanceof v.$Je?r=n:(0,y.$ve)(n)?r=await(0,v.$Ve)(n):(0,y.$we)(n)?r=await(0,v.$We)(n):r=(0,v.$Te)(n),await o.writeFile(s,r.buffer,{create:!0,overwrite:!0,unlock:e?.unlock??!1,atomic:e?.atomic??!1})}async jb(o,s,e,n){return this.cb.queueFor(n,()=>this.kb(o,s,e,n),this.R(e).providerExtUri)}async kb(o,s,e,n){let r,h;try{r=await o.open(s,{create:!1}),h=await e.open(n,{create:!0,unlock:!1});const E=v.$Je.alloc(this.a);let R=0,A=0,T=0;do T=await o.read(r,R,E.buffer,A,E.byteLength-A),await this.gb(e,h,E,T,R,A),R+=T,A+=T,A===E.byteLength&&(A=0);while(T>0)}catch(E){throw(0,g.$il)(E)}finally{await k.Promises.settled([typeof r=="number"?o.close(r):Promise.resolve(),typeof h=="number"?e.close(h):Promise.resolve()])}}async lb(o,s,e,n){return this.cb.queueFor(n,()=>this.mb(o,s,e,n),this.R(e).providerExtUri)}async mb(o,s,e,n){return e.writeFile(n,await o.readFile(s),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async nb(o,s,e,n){return this.cb.queueFor(n,()=>this.ob(o,s,e,n),this.R(e).providerExtUri)}async ob(o,s,e,n){const r=await e.open(n,{create:!0,unlock:!1});try{const h=await o.readFile(s);await this.gb(e,r,v.$Je.wrap(h),h.byteLength,0,0)}catch(h){throw(0,g.$il)(h)}finally{await e.close(r)}}async pb(o,s,e,n){const r=await(0,v.$Ve)(this.H(o,s,I.CancellationToken.None));await this.hb(e,n,void 0,r)}qb(o,s){if(o.capabilities&g.FileSystemProviderCapabilities.Readonly)throw new g.$pl((0,N.localize)(25,null,this.sb(s)),g.FileOperationResult.FILE_PERMISSION_DENIED);return o}rb(o,s){if((s.permissions??0)&g.FilePermission.Readonly)throw new g.$pl((0,N.localize)(26,null,this.sb(o)),g.FileOperationResult.FILE_PERMISSION_DENIED)}sb(o){return o.scheme===c.Schemas.file?o.fsPath:o.toString(!0)}};t.$Qq=u,t.$Qq=u=w=we([ne(0,$.$7j)],u)}),define(se[133],oe([0,1,61,176,8,31,14,5,64,2,16,13,17,46,25,108,10,63,130,36,128,127]),function(Q,t,O,k,v,I,D,S,m,a,l,c,f,p,y,N,g,d,$,P,w,u){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$hr=void 0,(()=>{try{(0,k.gracefulify)(O)}catch(o){console.error(`Error enabling graceful-fs: ${(0,P.$lj)(o)}`)}})();class i extends $.$3q{static{this.L=!1}constructor(s,e){super(s,e),this.onDidChangeCapabilities=S.Event.None,this.P=new I.$Ac(n=>f.$5g.getComparisonKey(n)),this.X=new Map,this.Y=new Map,this.Z=new Map}get capabilities(){return this.M||(this.M=g.FileSystemProviderCapabilities.FileReadWrite|g.FileSystemProviderCapabilities.FileOpenReadWriteClose|g.FileSystemProviderCapabilities.FileReadStream|g.FileSystemProviderCapabilities.FileFolderCopy|g.FileSystemProviderCapabilities.FileWriteUnlock|g.FileSystemProviderCapabilities.FileAtomicRead|g.FileSystemProviderCapabilities.FileAtomicWrite|g.FileSystemProviderCapabilities.FileAtomicDelete|g.FileSystemProviderCapabilities.FileClone,c.$k&&(this.M|=g.FileSystemProviderCapabilities.PathCaseSensitive)),this.M}async stat(s){try{const{stat:e,symbolicLink:n}=await y.SymlinkSupport.stat(this.I(s));return{type:this.O(e,n),ctime:e.birthtime.getTime(),mtime:e.mtime.getTime(),size:e.size,permissions:e.mode&128?void 0:g.FilePermission.Locked}}catch(e){throw this.hb(e)}}async N(s){try{return await this.stat(s)}catch{return}}async readdir(s){try{const e=await y.Promises.readdir(this.I(s),{withFileTypes:!0}),n=[];return await Promise.all(e.map(async r=>{try{let h;r.isSymbolicLink()?h=(await this.stat((0,f.$bh)(s,r.name))).type:h=this.O(r),n.push([r.name,h])}catch(h){this.a.trace(h)}})),n}catch(e){throw this.hb(e)}}O(s,e){let n;return e?.dangling?n=g.FileType.Unknown:s.isFile()?n=g.FileType.File:s.isDirectory()?n=g.FileType.Directory:n=g.FileType.Unknown,e&&(n|=g.FileType.SymbolicLink),n}async Q(s){const e=this.I(s);this.R(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${e})`);let n;for(;n=this.P.get(s);)this.R(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${e})`),await n.wait();const r=new v.$zh;return this.P.set(s,r),this.R(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${e})`),(0,a.$Sc)(()=>{this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${e})`),this.P.get(s)===r&&(this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${e})`),this.P.delete(s)),this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${e})`),r.open()})}async readFile(s,e){let n;try{e?.atomic&&(this.R(`[Disk FileSystemProvider]: atomic read operation started (${this.I(s)})`),n=await this.Q(s));const r=this.I(s);return await y.Promises.readFile(r)}catch(r){throw this.hb(r)}finally{n?.dispose()}}R(s){i.L&&this.a.trace(s)}readFileStream(s,e,n){const r=(0,p.$xe)(h=>D.$Je.concat(h.map(E=>D.$Je.wrap(E))).buffer);return(0,d.$Pq)(this,s,r,h=>h.buffer,{...e,bufferSize:256*1024},n),r}async writeFile(s,e,n){return n?.atomic!==!1&&n?.atomic?.postfix&&await this.S(s)?this.U(s,(0,f.$bh)((0,f.$ah)(s),`${(0,f.$$g)(s)}${n.atomic.postfix}`),e,n):this.W(s,e,n)}async S(s){try{const e=this.I(s),{symbolicLink:n}=await y.SymlinkSupport.stat(e);if(n)return!1}catch{}return!0}async U(s,e,n,r){const h=new a.$Tc;try{h.add(await this.Q(s)),h.add(await this.Q(e)),await this.W(e,n,r,!0);try{await this.rename(e,s,{overwrite:!0})}catch(E){try{await this.delete(e,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw E}}finally{h.dispose()}}async W(s,e,n,r){let h;try{const E=this.I(s);if(!n.create||!n.overwrite){if(await y.Promises.exists(E)){if(!n.overwrite)throw(0,g.$hl)((0,N.localize)(0,null),g.FileSystemProviderErrorCode.FileExists)}else if(!n.create)throw(0,g.$hl)((0,N.localize)(1,null),g.FileSystemProviderErrorCode.FileNotFound)}h=await this.open(s,{create:!0,unlock:n.unlock},r),await this.write(h,0,e,0,e.byteLength)}catch(E){throw await this.ib(s,E)}finally{typeof h=="number"&&await this.close(h)}}static{this.$=!0}static configureFlushOnWrite(s){i.$=s}async open(s,e,n){const r=this.I(s);let h;(0,g.$8k)(e)&&!n&&(h=await this.Q(s));let E;try{if((0,g.$8k)(e)&&e.unlock)try{const{stat:A}=await y.SymlinkSupport.stat(r);A.mode&128||await y.Promises.chmod(r,A.mode|128)}catch(A){A.code!=="ENOENT"&&this.a.trace(A)}let R;if((0,g.$8k)(e)){if(c.$i)try{await y.Promises.truncate(r,0),R="r+"}catch(A){A.code!=="ENOENT"&&this.a.trace(A)}R||(R="w")}else R="r";E=await y.Promises.open(r,R)}catch(R){throw h?.dispose(),(0,g.$8k)(e)?await this.ib(s,R):this.hb(R)}if(this.X.set(E,0),(0,g.$8k)(e)&&this.Z.set(E,s),h){const R=this.Y.get(E);this.R(`[Disk FileSystemProvider]: open() - storing lock for handle ${E} (${r})`),this.Y.set(E,h),R&&(this.R(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${E} (${r})`),R.dispose())}return E}async close(s){const e=this.Y.get(s);try{if(this.X.delete(s),this.Z.delete(s)&&i.$)try{await y.Promises.fdatasync(s)}catch(n){i.configureFlushOnWrite(!1),this.a.error(n)}return await y.Promises.close(s)}catch(n){throw this.hb(n)}finally{e&&(this.Y.get(s)===e&&(this.R(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${s}`),this.Y.delete(s)),this.R(`[Disk FileSystemProvider]: close() - disposing lock for handle ${s}`),e.dispose())}}async read(s,e,n,r,h){const E=this.ab(s,e);let R=null;try{R=(await y.Promises.read(s,n,r,h,E)).bytesRead}catch(A){throw this.hb(A)}finally{this.bb(s,E,R)}return R}ab(s,e){return e===this.X.get(s)?null:e}bb(s,e,n){const r=this.X.get(s);typeof r=="number"&&(typeof e=="number"||(typeof n=="number"?this.X.set(s,r+n):this.X.delete(s)))}async write(s,e,n,r,h){return(0,v.$Uh)(()=>this.cb(s,e,n,r,h),100,3)}async cb(s,e,n,r,h){const E=this.ab(s,e);let R=null;try{R=(await y.Promises.write(s,n,r,h,E)).bytesWritten}catch(A){throw await this.ib(this.Z.get(s),A)}finally{this.bb(s,E,R)}return R}async mkdir(s){try{await y.Promises.mkdir(this.I(s))}catch(e){throw this.hb(e)}}async delete(s,e){try{const n=this.I(s);if(e.recursive){let r;e?.atomic!==!1&&e.atomic.postfix&&(r=(0,l.$jc)((0,l.$mc)(n),`${(0,l.$nc)(n)}${e.atomic.postfix}`)),await y.Promises.rm(n,y.RimRafMode.MOVE,r)}else try{await y.Promises.unlink(n)}catch(r){if(r.code==="EPERM"||r.code==="EISDIR"){let h=!1;try{const{stat:E,symbolicLink:R}=await y.SymlinkSupport.stat(n);h=E.isDirectory()&&!R}catch{}if(h)await y.Promises.rmdir(n);else throw r}else throw r}}catch(n){throw this.hb(n)}}async rename(s,e,n){const r=this.I(s),h=this.I(e);if(r!==h)try{await this.db(s,e,"move",n.overwrite),await y.Promises.rename(r,h)}catch(E){throw(E.code==="EINVAL"||E.code==="EBUSY"||E.code==="ENAMETOOLONG")&&(E=new Error((0,N.localize)(2,null,(0,l.$nc)(r),(0,l.$nc)((0,l.$mc)(h)),E.toString()))),this.hb(E)}}async copy(s,e,n){const r=this.I(s),h=this.I(e);if(r!==h)try{await this.db(s,e,"copy",n.overwrite),await y.Promises.copy(r,h,{preserveSymlinks:!0})}catch(E){throw(E.code==="EINVAL"||E.code==="EBUSY"||E.code==="ENAMETOOLONG")&&(E=new Error((0,N.localize)(3,null,(0,l.$nc)(r),(0,l.$nc)((0,l.$mc)(h)),E.toString()))),this.hb(E)}}async db(s,e,n,r){const h=this.I(s),E=this.I(e);let R=!1;if(!!(this.capabilities&g.FileSystemProviderCapabilities.PathCaseSensitive)||(R=(0,m.$yg)(h,E,!0)),R){if(n==="copy")throw(0,g.$hl)((0,N.localize)(4,null),g.FileSystemProviderErrorCode.FileExists);if(n==="move")return}const T=await this.N(s);if(!T)throw(0,g.$hl)((0,N.localize)(5,null),g.FileSystemProviderErrorCode.FileNotFound);const C=await this.N(e);if(C){if(!r)throw(0,g.$hl)((0,N.localize)(6,null),g.FileSystemProviderErrorCode.FileExists);T.type&g.FileType.File&&C.type&g.FileType.File||await this.delete(e,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(s,e){return this.eb(s,e,!1)}async eb(s,e,n){const r=this.I(s),h=this.I(e),E=!!(this.capabilities&g.FileSystemProviderCapabilities.PathCaseSensitive);if((0,m.$yg)(r,h,!E))return;const R=new a.$Tc;try{R.add(await this.Q(s)),R.add(await this.Q(e)),n&&await y.Promises.mkdir((0,l.$mc)(h),{recursive:!0}),await y.Promises.copyFile(r,h)}catch(A){if(A.code==="ENOENT"&&!n)return this.eb(s,e,!0);throw this.hb(A)}finally{R.dispose()}}t(s,e,n){return new w.$0q(r=>s(r),r=>e(r),n)}F(s,e,n){return new u.$gr(r=>s(r),r=>e(r),n)}hb(s){if(s instanceof g.$gl)return s;let e=s,n;switch(s.code){case"ENOENT":n=g.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":n=g.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":n=g.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":n=g.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":n=g.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":e=`${s.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,n=g.FileSystemProviderErrorCode.Unknown;break;default:n=g.FileSystemProviderErrorCode.Unknown}return(0,g.$hl)(e,n)}async ib(s,e){let n=this.hb(e);if(s&&n.code===g.FileSystemProviderErrorCode.NoPermissions)try{const{stat:r}=await y.SymlinkSupport.stat(this.I(s));r.mode&128||(n=(0,g.$hl)(e,g.FileSystemProviderErrorCode.FileWriteLocked))}catch(r){this.a.trace(r)}return n}}t.$hr=i}),define(se[134],oe([0,1,2,6]),function(Q,t,O,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$iQ=void 0;class v extends O.$Uc{constructor(D,S=[]){super(),this.a=new k.$ek([D,...S]),this.B(D.onDidChangeLogLevel(m=>this.setLevel(m)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(D){this.a.setLevel(D)}getLevel(){return this.a.getLevel()}trace(D,...S){this.a.trace(D,...S)}debug(D,...S){this.a.debug(D,...S)}info(D,...S){this.a.info(D,...S)}warn(D,...S){this.a.warn(D,...S)}error(D,...S){this.a.error(D,...S)}flush(){this.a.flush()}}t.$iQ=v}),define(se[135],oe([0,1,10,6]),function(Q,t,O,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$0P=void 0;var v;(function(a){a[a.Trace=0]="Trace",a[a.Debug=1]="Debug",a[a.Info=2]="Info",a[a.Warning=3]="Warning",a[a.Error=4]="Error",a[a.Critical=5]="Critical",a[a.Off=6]="Off"})(v||(v={}));async function I(a,l,c,f,p){try{const y=await new Promise((g,d)=>{Q(["@vscode/spdlog"],g,d)});y.setFlushOn(v.Trace);const N=await y.createAsyncRotatingLogger(a,l,c,f);return p?N.clearFormatters():N.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),N}catch(y){console.error(y)}return null}function D(a,l,c){switch(l){case k.LogLevel.Trace:a.trace(c);break;case k.LogLevel.Debug:a.debug(c);break;case k.LogLevel.Info:a.info(c);break;case k.LogLevel.Warning:a.warn(c);break;case k.LogLevel.Error:a.error(c);break;case k.LogLevel.Off:break;default:throw new Error(`Invalid log level ${l}`)}}function S(a,l){switch(l){case k.LogLevel.Trace:a.setLevel(v.Trace);break;case k.LogLevel.Debug:a.setLevel(v.Debug);break;case k.LogLevel.Info:a.setLevel(v.Info);break;case k.LogLevel.Warning:a.setLevel(v.Warning);break;case k.LogLevel.Error:a.setLevel(v.Error);break;case k.LogLevel.Off:a.setLevel(v.Off);break;default:throw new Error(`Invalid log level ${l}`)}}class m extends k.$ak{constructor(l,c,f,p,y){super(),this.m=[],this.setLevel(y),this.n=this.s(l,c,f,p),this.B(this.onDidChangeLogLevel(N=>{this.r&&S(this.r,N)}))}async s(l,c,f,p){const y=f?6:1,N=30/y*O.$Cl.MB,g=await I(l,c,N,y,p);if(g){this.r=g,S(this.r,this.getLevel());for(const{level:d,message:$}of this.m)D(this.r,d,$);this.m=[]}}g(l,c){this.r?D(this.r,l,c):this.getLevel()<=l&&this.m.push({level:l,message:c})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u()),super.dispose()}u(){this.r&&(this.r.drop(),this.r=void 0)}}t.$0P=m}),define(se[136],oe([0,1,29,6,135]),function(Q,t,O,k,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$$P=void 0;class I extends k.$fk{s(S,m,a){return new v.$0P((0,O.$Wg)(),S.fsPath,!a?.donotRotate,!!a?.donotUseFormatters,m)}}t.$$P=I}),define(se[39],oe([0,1,5,66,2,11]),function(Q,t,O,k,v,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$no=t.$mo=t.$lo=void 0,t.$lo=(0,I.$Ai)("policy");class D extends v.$Uc{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new O.$he),this.onDidChange=this.h.event}async updatePolicyDefinitions(a){const l=Object.keys(this.f).length;return this.f={...a,...this.f},l!==Object.keys(this.f).length&&await this.j(a),k.Iterable.reduce(this.g.entries(),(c,[f,p])=>({...c,[f]:p}),{})}getPolicyValue(a){return this.g.get(a)}serialize(){return k.Iterable.reduce(Object.entries(this.f),(a,[l,c])=>({...a,[l]:{definition:c,value:this.g.get(l)}}),{})}}t.$mo=D;class S{constructor(){this.onDidChange=O.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}t.$no=S}),define(se[137],oe([0,1,8,5,66,3,10,6,39]),function(Q,t,O,k,v,I,D,S,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Wec=void 0;function a(c,f){const p=[];for(const y of new Set(v.Iterable.concat(c.keys(),f.keys())))c.get(y)!==f.get(y)&&p.push(y);return p}let l=class extends m.$mo{constructor(f,p,y){super(),this.m=f,this.n=p,this.s=y,this.c=this.B(new O.$yh(500));const N=k.Event.filter(p.onDidFilesChange,g=>g.affects(f));this.B(p.watch(f)),this.B(N(()=>this.c.trigger(()=>this.w())))}async j(){await this.w()}async u(){const f=new Map;try{const p=await this.n.readFile(this.m),y=JSON.parse(p.value.toString());if(!(0,I.$cg)(y))throw new Error("Policy file isn't a JSON object");for(const N of Object.keys(y))this.f[N]&&f.set(N,y[N])}catch(p){p.fileOperationResult!==D.FileOperationResult.FILE_NOT_FOUND&&this.s.error("[FilePolicyService] Failed to read policies",p)}return f}async w(){const f=await this.u(),p=a(this.g,f);this.g=f,p.length>0&&this.h.fire(p)}};t.$Wec=l,t.$Wec=l=we([ne(1,D.$7k),ne(2,S.$7j)],l)}),define(se[138],oe([0,1,39,8,2,6]),function(Q,t,O,k,v,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Vec=void 0;let D=class extends O.$mo{constructor(m,a){super(),this.m=m,this.n=a,this.a=new k.$uh,this.b=this.B(new v.$Vc)}async j(m){this.m.trace(`NativePolicyService#_updatePolicyDefinitions - Found ${Object.keys(m).length} policy definitions`);const{createWatcher:a}=await new Promise((l,c)=>{Q(["@vscode/policy-watcher"],l,c)});await this.a.queue(()=>new Promise((l,c)=>{try{this.b.value=a(this.n,m,f=>{this.t(f),l()})}catch(f){this.m.error("NativePolicyService#_updatePolicyDefinitions - Error creating watcher:",f),c(f)}}))}t(m){this.m.trace(`NativePolicyService#_onDidPolicyChange - Updated policy values: ${JSON.stringify(m)}`);for(const a in m){const l=m[a];l===void 0?this.g.delete(a):this.g.set(a,l)}this.h.fire(Object.keys(m))}};t.$Vec=D,t.$Vec=D=we([ne(0,I.$7j)],D)}),define(se[33],oe([0,1,11]),function(Q,t,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ok=t.$nk=void 0,t.$nk=(0,O.$Ai)("productService"),t.$ok="vscode://schemas/vscode-product"}),define(se[38],oe([0,1,76,3]),function(Q,t,O,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$jo=void 0;class v{constructor(){this.a=new Map}add(D,S){O.ok(k.$ag(D)),O.ok(k.$cg(S)),O.ok(!this.a.has(D),"There is already an extension with this id"),this.a.set(D,S)}knows(D){return this.a.has(D)}as(D){return this.a.get(D)||null}}t.$jo=new v}),define(se[139],oe([0,1,5,38]),function(Q,t,O,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ko=void 0,t.$ko={JSONContribution:"base.contributions.json"};function v(S){return S.length>0&&S.charAt(S.length-1)==="#"?S.substring(0,S.length-1):S}class I{constructor(){this.b=new O.$he,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(m,a){this.a[v(m)]=a,this.b.fire(m)}notifySchemaChanged(m){this.b.fire(m)}getSchemaContributions(){return{schemas:this.a}}}const D=new I;k.$jo.add(t.$ko.JSONContribution,D)}),define(se[40],oe([0,1,20,5,3,95,30,139,38]),function(Q,t,O,k,v,I,D,S,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$yo=t.$xo=t.$wo=t.$vo=t.$uo=t.$to=t.$so=t.$ro=t.$qo=t.$po=t.ConfigurationScope=t.$oo=t.EditPresentationTypes=void 0,t.$zo=N,t.$Ao=g,t.$Bo=d,t.$Co=P,t.$Do=w;var a;(function(u){u.Multiline="multilineText",u.Singleline="singlelineText"})(a||(t.EditPresentationTypes=a={})),t.$oo={Configuration:"base.contributions.configuration"};var l;(function(u){u[u.APPLICATION=1]="APPLICATION",u[u.MACHINE=2]="MACHINE",u[u.WINDOW=3]="WINDOW",u[u.RESOURCE=4]="RESOURCE",u[u.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",u[u.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(l||(t.ConfigurationScope=l={})),t.$po={properties:{},patternProperties:{}},t.$qo={properties:{},patternProperties:{}},t.$ro={properties:{},patternProperties:{}},t.$so={properties:{},patternProperties:{}},t.$to={properties:{},patternProperties:{}},t.$uo={properties:{},patternProperties:{}},t.$vo="vscode://schemas/settings/resourceLanguage",t.$wo="vscode://schemas/settings/configurationDefaults";const c=m.$jo.as(S.$ko.JSONContribution);class f{constructor(){this.h=new Set,this.i=new k.$he,this.onDidSchemaChange=this.i.event,this.j=new k.$he,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:I.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},c.registerSchema(t.$vo,this.g),this.v()}registerConfiguration(i,o=!0){this.registerConfigurations([i],o)}registerConfigurations(i,o=!0){const s=new Set;this.n(i,o,s),c.registerSchema(t.$vo,this.g),this.i.fire(),this.j.fire({properties:s})}deregisterConfigurations(i){const o=new Set;this.o(i,o),c.registerSchema(t.$vo,this.g),this.i.fire(),this.j.fire({properties:o})}updateConfigurations({add:i,remove:o}){const s=new Set;this.o(o,s),this.n(i,!1,s),c.registerSchema(t.$vo,this.g),this.i.fire(),this.j.fire({properties:s})}registerDefaultConfigurations(i){const o=new Set;this.k(i,o),this.i.fire(),this.j.fire({properties:o,defaultsOverrides:!0})}k(i,o){const s=[];for(const{overrides:e,source:n}of i)for(const r in e)if(o.add(r),t.$yo.test(r)){const h=this.a.get(r),E=h?.valuesSources??new Map;if(n)for(const C of Object.keys(e[r]))E.set(C,n);const R={...h?.value||{},...e[r]};this.a.set(r,{source:n,value:R,valuesSources:E});const A=(0,D.$ej)(r),T={type:"object",default:R,description:I.localize(1,null,A),$ref:t.$vo,defaultDefaultValue:R,source:v.$ag(n)?void 0:n,defaultValueSource:n};s.push(...N(r)),this.d[r]=T,this.b.properties[r]=T}else{this.a.set(r,{value:e[r],source:n});const h=this.d[r];h&&(this.w(r,h),this.r(r,h))}this.m(s)}deregisterDefaultConfigurations(i){const o=new Set;this.l(i,o),this.i.fire(),this.j.fire({properties:o,defaultsOverrides:!0})}l(i,o){for(const{overrides:s,source:e}of i)for(const n in s){const r=this.a.get(n),h=v.$ag(e)?e:e?.id,E=v.$ag(r?.source)?r?.source:r?.source?.id;if(h===E)if(o.add(n),this.a.delete(n),t.$yo.test(n))delete this.d[n],delete this.b.properties[n];else{const R=this.d[n];R&&(this.w(n,R),this.r(n,R))}}this.u()}deltaConfiguration(i){let o=!1;const s=new Set;i.removedDefaults&&(this.l(i.removedDefaults,s),o=!0),i.addedDefaults&&(this.k(i.addedDefaults,s),o=!0),i.removedConfigurations&&this.o(i.removedConfigurations,s),i.addedConfigurations&&this.n(i.addedConfigurations,!1,s),this.i.fire(),this.j.fire({properties:s,defaultsOverrides:o})}notifyConfigurationSchemaUpdated(...i){this.i.fire()}registerOverrideIdentifiers(i){this.m(i),this.i.fire()}m(i){for(const o of i)this.h.add(o);this.u()}n(i,o,s){i.forEach(e=>{this.p(e,o,e.extensionInfo,e.restrictedProperties,void 0,s),this.c.push(e),this.q(e)})}o(i,o){const s=e=>{if(e.properties)for(const n in e.properties){o.add(n);const r=this.d[n];r?.policy?.name&&this.e.delete(r.policy.name),delete this.d[n],this.s(n,e.properties[n])}e.allOf?.forEach(n=>s(n))};for(const e of i){s(e);const n=this.c.indexOf(e);n!==-1&&this.c.splice(n,1)}}p(i,o=!0,s,e,n=l.WINDOW,r){n=v.$jg(i.scope)?n:i.scope;const h=i.properties;if(h)for(const R in h){const A=h[R];if(o&&P(R,A)){delete h[R];continue}if(A.source=s,A.defaultDefaultValue=h[R].default,this.w(R,A),t.$yo.test(R)?A.scope=void 0:(A.scope=v.$jg(A.scope)?n:A.scope,A.restricted=v.$jg(A.restricted)?!!e?.includes(R):A.restricted),h[R].hasOwnProperty("included")&&!h[R].included){this.f[R]=h[R],delete h[R];continue}else this.d[R]=h[R],h[R].policy?.name&&this.e.set(h[R].policy.name,R);!h[R].deprecationMessage&&h[R].markdownDeprecationMessage&&(h[R].deprecationMessage=h[R].markdownDeprecationMessage),r.add(R)}const E=i.allOf;if(E)for(const R of E)this.p(R,o,s,e,n,r)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(i){const o=s=>{const e=s.properties;if(e)for(const r in e)this.r(r,e[r]);s.allOf?.forEach(o)};o(i)}r(i,o){switch(t.$po.properties[i]=o,o.scope){case l.APPLICATION:t.$qo.properties[i]=o;break;case l.MACHINE:t.$ro.properties[i]=o;break;case l.MACHINE_OVERRIDABLE:t.$so.properties[i]=o;break;case l.WINDOW:t.$to.properties[i]=o;break;case l.RESOURCE:t.$uo.properties[i]=o;break;case l.LANGUAGE_OVERRIDABLE:t.$uo.properties[i]=o,this.g.properties[i]=o;break}}s(i,o){switch(delete t.$po.properties[i],o.scope){case l.APPLICATION:delete t.$qo.properties[i];break;case l.MACHINE:delete t.$ro.properties[i];break;case l.MACHINE_OVERRIDABLE:delete t.$so.properties[i];break;case l.WINDOW:delete t.$to.properties[i];break;case l.RESOURCE:case l.LANGUAGE_OVERRIDABLE:delete t.$uo.properties[i],delete this.g.properties[i];break}}u(){for(const i of this.h.values()){const o=`[${i}]`,s={type:"object",description:I.localize(2,null),errorMessage:I.localize(3,null),$ref:t.$vo};this.w(o,s),t.$po.properties[o]=s,t.$qo.properties[o]=s,t.$ro.properties[o]=s,t.$so.properties[o]=s,t.$to.properties[o]=s,t.$uo.properties[o]=s}}v(){const i={type:"object",description:I.localize(4,null),errorMessage:I.localize(5,null),$ref:t.$vo};t.$po.patternProperties[t.$xo]=i,t.$qo.patternProperties[t.$xo]=i,t.$ro.patternProperties[t.$xo]=i,t.$so.patternProperties[t.$xo]=i,t.$to.patternProperties[t.$xo]=i,t.$uo.patternProperties[t.$xo]=i,this.i.fire()}w(i,o){const s=this.a.get(i);let e=s?.value,n=s?.source;v.$hg(e)&&(e=o.defaultDefaultValue,n=void 0),v.$hg(e)&&(e=d(o.type)),o.default=e,o.defaultValueSource=n}}const p="\\[([^\\]]+)\\]",y=new RegExp(p,"g");t.$xo=`^(${p})+$`,t.$yo=new RegExp(t.$xo);function N(u){const i=[];if(t.$yo.test(u)){let o=y.exec(u);for(;o?.length;){const s=o[1].trim();s&&i.push(s),o=y.exec(u)}}return(0,O.$Mb)(i)}function g(u){return u.reduce((i,o)=>`${i}[${o}]`,"")}function d(u){switch(Array.isArray(u)?u[0]:u){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const $=new f;m.$jo.add(t.$oo.Configuration,$);function P(u,i){return u.trim()?t.$yo.test(u)?I.localize(7,null,u):$.getConfigurationProperties()[u]!==void 0?I.localize(8,null,u):i.policy?.name&&$.getPolicyConfigurations().get(i.policy?.name)!==void 0?I.localize(9,null,u,i.policy?.name,$.getPolicyConfigurations().get(i.policy?.name)):null:I.localize(6,null)}function w(){const u=[],i=$.getConfigurationProperties();for(const o of Object.keys(i))u.push([o,i[o].scope]);return u.push(["launch",l.RESOURCE]),u.push(["task",l.RESOURCE]),u}}),define(se[67],oe([0,1,20,5,34,2,31,28,3,12,30,40,10,38]),function(Q,t,O,k,v,I,D,S,m,a,l,c,f,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Jo=t.$Ho=t.$Go=t.$Fo=t.$Eo=void 0,t.$Io=w;function y(s){return Object.isFrozen(s)?s:S.$0n(s)}class N{static createEmptyModel(e){return new N({},[],[],void 0,e)}constructor(e,n,r,h,E){this.b=e,this.c=n,this.d=r,this.raw=h,this.f=E,this.a=new Map}get rawConfiguration(){if(!this.g)if(this.raw?.length){const e=this.raw.map(n=>{if(n instanceof N)return n;const r=new g("",this.f);return r.parseRaw(n),r.configurationModel});this.g=e.reduce((n,r)=>r===n?r:n.merge(r),e[0])}else this.g=this;return this.g}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(e){return e?(0,l.$cj)(this.contents,e):this.contents}inspect(e,n){const r=this;return{get value(){return y(r.rawConfiguration.getValue(e))},get override(){return n?y(r.rawConfiguration.getOverrideValue(e,n)):void 0},get merged(){return y(n?r.rawConfiguration.override(n).getValue(e):r.rawConfiguration.getValue(e))},get overrides(){const h=[];for(const{contents:E,identifiers:R,keys:A}of r.rawConfiguration.overrides){const T=new N(E,A,[],void 0,r.f).getValue(e);T!==void 0&&h.push({identifiers:R,value:T})}return h.length?y(h):void 0}}}getOverrideValue(e,n){const r=this.j(n);return r?e?(0,l.$cj)(r,e):r:void 0}getKeysForOverrideIdentifier(e){const n=[];for(const r of this.overrides)r.identifiers.includes(e)&&n.push(...r.keys);return O.$Mb(n)}getAllOverrideIdentifiers(){const e=[];for(const n of this.overrides)e.push(...n.identifiers);return O.$Mb(e)}override(e){let n=this.a.get(e);return n||(n=this.h(e),this.a.set(e,n)),n}merge(...e){const n=S.$9n(this.contents),r=S.$9n(this.overrides),h=[...this.keys],E=this.raw?.length?[...this.raw]:[this];for(const R of e)if(E.push(...R.raw?.length?R.raw:[R]),!R.isEmpty()){this.i(n,R.contents);for(const A of R.overrides){const[T]=r.filter(C=>O.$ub(C.identifiers,A.identifiers));T?(this.i(T.contents,A.contents),T.keys.push(...A.keys),T.keys=O.$Mb(T.keys)):r.push(S.$9n(A))}for(const A of R.keys)h.indexOf(A)===-1&&h.push(A)}return new N(n,h,r,E.every(R=>R instanceof N)?void 0:E,this.f)}h(e){const n=this.j(e);if(!n||typeof n!="object"||!Object.keys(n).length)return this;const r={};for(const h of O.$Mb([...Object.keys(this.contents),...Object.keys(n)])){let E=this.contents[h];const R=n[h];R&&(typeof E=="object"&&typeof R=="object"?(E=S.$9n(E),this.i(E,R)):E=R),r[h]=E}return new N(r,this.keys,this.overrides,void 0,this.f)}i(e,n){for(const r of Object.keys(n)){if(r in e&&m.$cg(e[r])&&m.$cg(n[r])){this.i(e[r],n[r]);continue}e[r]=S.$9n(n[r])}}j(e){let n=null,r=null;const h=E=>{E&&(r?this.i(r,E):r=S.$9n(E))};for(const E of this.overrides)E.identifiers.length===1&&E.identifiers[0]===e?n=E.contents:E.identifiers.includes(e)&&h(E.contents);return h(n),r}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(e,n){this.k(e,n,!0)}setValue(e,n){this.k(e,n,!1)}removeValue(e){const n=this.keys.indexOf(e);n!==-1&&(this.keys.splice(n,1),(0,l.$bj)(this.contents,e),c.$yo.test(e)&&this.overrides.splice(this.overrides.findIndex(r=>O.$ub(r.identifiers,(0,c.$zo)(e))),1))}k(e,n,r){(0,l.$aj)(this.contents,e,n,h=>this.f.error(h)),r=r||this.keys.indexOf(e)===-1,r&&this.keys.push(e),c.$yo.test(e)&&this.overrides.push({identifiers:(0,c.$zo)(e),keys:Object.keys(this.contents[e]),contents:(0,l.$_i)(this.contents[e],h=>this.f.error(h))})}}t.$Eo=N;class g{constructor(e,n){this.f=e,this.g=n,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||N.createEmptyModel(this.g)}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(e,n){if(!m.$jg(e)){const r=this.h(e);this.parseRaw(r,n)}}reparse(e){this.a&&this.parseRaw(this.a,e)}parseRaw(e,n){this.a=e;const{contents:r,keys:h,overrides:E,restricted:R,hasExcludedProperties:A}=this.i(e,n);this.b=new N(r,h,E,A?[e]:void 0,this.g),this.c=R||[]}h(e){let n={},r=null,h=[];const E=[],R=[];function A(C){Array.isArray(h)?h.push(C):r!==null&&(h[r]=C)}const T={onObjectBegin:()=>{const C={};A(C),E.push(h),h=C,r=null},onObjectProperty:C=>{r=C},onObjectEnd:()=>{h=E.pop()},onArrayBegin:()=>{const C=[];A(C),E.push(h),h=C,r=null},onArrayEnd:()=>{h=E.pop()},onLiteralValue:A,onError:(C,M,J)=>{R.push({error:C,offset:M,length:J})}};if(e)try{v.$Wn(e,T),n=h[0]||{}}catch(C){this.g.error(`Error while parsing settings file ${this.f}: ${C}`),this.d=[C]}return n}i(e,n){const r=p.$jo.as(c.$oo.Configuration).getConfigurationProperties(),h=this.j(e,r,!0,n);e=h.raw;const E=(0,l.$_i)(e,T=>this.g.error(`Conflict in settings file ${this.f}: ${T}`)),R=Object.keys(e),A=this.l(e,T=>this.g.error(`Conflict in settings file ${this.f}: ${T}`));return{contents:E,keys:R,overrides:A,restricted:h.restricted,hasExcludedProperties:h.hasExcludedProperties}}j(e,n,r,h){let E=!1;if(!h?.scopes&&!h?.skipRestricted&&!h?.exclude?.length)return{raw:e,restricted:[],hasExcludedProperties:E};const R={},A=[];for(const T in e)if(c.$yo.test(T)&&r){const C=this.j(e[T],n,!1,h);R[T]=C.raw,E=E||C.hasExcludedProperties,A.push(...C.restricted)}else{const C=n[T],M=C?typeof C.scope<"u"?C.scope:c.ConfigurationScope.WINDOW:void 0;C?.restricted&&A.push(T),!h.exclude?.includes(T)&&(h.include?.includes(T)||(M===void 0||h.scopes===void 0||h.scopes.includes(M))&&!(h.skipRestricted&&C?.restricted))?R[T]=e[T]:E=!0}return{raw:R,restricted:A,hasExcludedProperties:E}}l(e,n){const r=[];for(const h of Object.keys(e))if(c.$yo.test(h)){const E={};for(const R in e[h])E[R]=e[h][R];r.push({identifiers:(0,c.$zo)(h),keys:Object.keys(E),contents:(0,l.$_i)(E,n)})}return r}}t.$Fo=g;class d extends I.$Uc{constructor(e,n,r,h,E){super(),this.c=e,this.f=n,this.g=h,this.h=E,this.b=this.B(new k.$he),this.onDidChange=this.b.event,this.a=new g(this.c.toString(),E),this.B(this.g.watch(r.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(k.Event.any(k.Event.filter(this.g.onDidFilesChange,R=>R.contains(this.c)),k.Event.filter(this.g.onDidRunOperation,R=>(R.isOperation(f.FileOperation.CREATE)||R.isOperation(f.FileOperation.COPY)||R.isOperation(f.FileOperation.DELETE)||R.isOperation(f.FileOperation.WRITE))&&r.isEqual(R.resource,e)))(()=>this.b.fire()))}async loadConfiguration(){try{const e=await this.g.readFile(this.c);return this.a.parse(e.value.toString()||"{}",this.f),this.a.configurationModel}catch{return N.createEmptyModel(this.h)}}reparse(e){return e&&(this.f=e),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}t.$Go=d;class ${constructor(e,n,r,h,E,R,A,T,C,M,J,ae,ie){this.a=e,this.b=n,this.c=r,this.overrideIdentifiers=h,this.d=E,this.f=R,this.g=A,this.h=T,this.i=C,this.j=M,this.k=J,this.l=ae,this.m=ie}get value(){return y(this.c)}n(e){return e?.value!==void 0||e?.override!==void 0||e?.overrides!==void 0?e:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class P{constructor(e,n,r,h,E,R,A,T,C,M){this.j=e,this.l=n,this.m=r,this.n=h,this.p=E,this.q=R,this.r=A,this.s=T,this.t=C,this.u=M,this.h=null,this.i=new D.$Ac,this.v=null}getValue(e,n,r){return this.w(e,n,r).getValue(e)}updateValue(e,n,r={}){let h;r.resource?(h=this.t.get(r.resource),h||(h=N.createEmptyModel(this.u),this.t.set(r.resource,h))):h=this.s,n===void 0?h.removeValue(e):h.setValue(e,n),r.resource||(this.h=null)}inspect(e,n,r){const h=this.w(e,n,r),E=this.A(n.resource,r),R=n.resource?this.t.get(n.resource)||this.s:this.s,A=new Set;for(const T of h.overrides)for(const C of T.identifiers)h.getOverrideValue(e,C)!==void 0&&A.add(C);return new $(e,n,h.getValue(e),A.size?[...A]:void 0,this.j,this.l.isEmpty()?void 0:this.l,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,r?this.q:void 0,E||void 0,R)}keys(e){const n=this.A(void 0,e);return{default:this.j.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.q.keys.slice(0),workspaceFolder:n?n.keys.slice(0):[]}}updateDefaultConfiguration(e){this.j=e,this.h=null,this.i.clear()}updatePolicyConfiguration(e){this.l=e}updateApplicationConfiguration(e){this.m=e,this.h=null,this.i.clear()}updateLocalUserConfiguration(e){this.n=e,this.v=null,this.h=null,this.i.clear()}updateRemoteUserConfiguration(e){this.p=e,this.v=null,this.h=null,this.i.clear()}updateWorkspaceConfiguration(e){this.q=e,this.h=null,this.i.clear()}updateFolderConfiguration(e,n){this.r.set(e,n),this.i.delete(e)}deleteFolderConfiguration(e){this.folderConfigurations.delete(e),this.i.delete(e)}compareAndUpdateDefaultConfiguration(e,n){const r=[];if(!n){const{added:h,updated:E,removed:R}=i(this.j,e);n=[...h,...E,...R]}for(const h of n)for(const E of(0,c.$zo)(h)){const R=this.j.getKeysForOverrideIdentifier(E),A=e.getKeysForOverrideIdentifier(E),T=[...A.filter(C=>R.indexOf(C)===-1),...R.filter(C=>A.indexOf(C)===-1),...R.filter(C=>!S.$ao(this.j.override(E).getValue(C),e.override(E).getValue(C)))];r.push([E,T])}return this.updateDefaultConfiguration(e),{keys:n,overrides:r}}compareAndUpdatePolicyConfiguration(e){const{added:n,updated:r,removed:h}=i(this.l,e),E=[...n,...r,...h];return E.length&&this.updatePolicyConfiguration(e),{keys:E,overrides:[]}}compareAndUpdateApplicationConfiguration(e){const{added:n,updated:r,removed:h,overrides:E}=i(this.applicationConfiguration,e),R=[...n,...r,...h];return R.length&&this.updateApplicationConfiguration(e),{keys:R,overrides:E}}compareAndUpdateLocalUserConfiguration(e){const{added:n,updated:r,removed:h,overrides:E}=i(this.localUserConfiguration,e),R=[...n,...r,...h];return R.length&&this.updateLocalUserConfiguration(e),{keys:R,overrides:E}}compareAndUpdateRemoteUserConfiguration(e){const{added:n,updated:r,removed:h,overrides:E}=i(this.remoteUserConfiguration,e),R=[...n,...r,...h];return R.length&&this.updateRemoteUserConfiguration(e),{keys:R,overrides:E}}compareAndUpdateWorkspaceConfiguration(e){const{added:n,updated:r,removed:h,overrides:E}=i(this.workspaceConfiguration,e),R=[...n,...r,...h];return R.length&&this.updateWorkspaceConfiguration(e),{keys:R,overrides:E}}compareAndUpdateFolderConfiguration(e,n){const r=this.folderConfigurations.get(e),{added:h,updated:E,removed:R,overrides:A}=i(r,n),T=[...h,...E,...R];return(T.length||!r)&&this.updateFolderConfiguration(e,n),{keys:T,overrides:A}}compareAndDeleteFolderConfiguration(e){const n=this.folderConfigurations.get(e);if(!n)throw new Error("Unknown folder");this.deleteFolderConfiguration(e);const{added:r,updated:h,removed:E,overrides:R}=i(n,void 0);return{keys:[...r,...h,...E],overrides:R}}get defaults(){return this.j}get applicationConfiguration(){return this.m}get userConfiguration(){return this.v||(this.v=this.p.isEmpty()?this.n:this.n.merge(this.p)),this.v}get localUserConfiguration(){return this.n}get remoteUserConfiguration(){return this.p}get workspaceConfiguration(){return this.q}get folderConfigurations(){return this.r}w(e,n,r){let h=this.x(n,r);return n.overrideIdentifier&&(h=h.override(n.overrideIdentifier)),!this.l.isEmpty()&&this.l.getValue(e)!==void 0&&(h=h.merge(this.l)),h}x({resource:e},n){let r=this.y();if(n&&e){const h=n.getFolder(e);h&&(r=this.z(h.uri)||r);const E=this.t.get(e);E&&(r=r.merge(E))}return r}y(){return this.h||(this.h=this.j.merge(this.applicationConfiguration,this.userConfiguration,this.q,this.s)),this.h}z(e){let n=this.i.get(e);if(!n){const r=this.y(),h=this.r.get(e);h?(n=r.merge(h),this.i.set(e,n)):n=r}return n}A(e,n){if(n&&e){const r=n.getFolder(e);if(r)return this.r.get(r.uri)}}toData(){return{defaults:{contents:this.j.contents,overrides:this.j.overrides,keys:this.j.keys},policy:{contents:this.l.contents,overrides:this.l.overrides,keys:this.l.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.q.contents,overrides:this.q.overrides,keys:this.q.keys},folders:[...this.r.keys()].reduce((e,n)=>{const{contents:r,overrides:h,keys:E}=this.r.get(n);return e.push([n,{contents:r,overrides:h,keys:E}]),e},[])}}allKeys(){const e=new Set;return this.j.keys.forEach(n=>e.add(n)),this.userConfiguration.keys.forEach(n=>e.add(n)),this.q.keys.forEach(n=>e.add(n)),this.r.forEach(n=>n.keys.forEach(r=>e.add(r))),[...e.values()]}B(){const e=new Set;return this.j.getAllOverrideIdentifiers().forEach(n=>e.add(n)),this.userConfiguration.getAllOverrideIdentifiers().forEach(n=>e.add(n)),this.q.getAllOverrideIdentifiers().forEach(n=>e.add(n)),this.r.forEach(n=>n.getAllOverrideIdentifiers().forEach(r=>e.add(r))),[...e.values()]}D(e){const n=new Set;return this.j.getKeysForOverrideIdentifier(e).forEach(r=>n.add(r)),this.userConfiguration.getKeysForOverrideIdentifier(e).forEach(r=>n.add(r)),this.q.getKeysForOverrideIdentifier(e).forEach(r=>n.add(r)),this.r.forEach(r=>r.getKeysForOverrideIdentifier(e).forEach(h=>n.add(h))),[...n.values()]}static parse(e,n){const r=this.E(e.defaults,n),h=this.E(e.policy,n),E=this.E(e.application,n),R=this.E(e.user,n),A=this.E(e.workspace,n),T=e.folders.reduce((C,M)=>(C.set(a.URI.revive(M[0]),this.E(M[1],n)),C),new D.$Ac);return new P(r,h,E,R,N.createEmptyModel(n),A,T,N.createEmptyModel(n),new D.$Ac,n)}static E(e,n){return new N(e.contents,e.keys,e.overrides,void 0,n)}}t.$Ho=P;function w(...s){if(s.length===0)return{keys:[],overrides:[]};if(s.length===1)return s[0];const e=new Set,n=new Map;for(const h of s)h.keys.forEach(E=>e.add(E)),h.overrides.forEach(([E,R])=>{const A=(0,D.$xc)(n,E,new Set);R.forEach(T=>A.add(T))});const r=[];return n.forEach((h,E)=>r.push([E,[...h.values()]])),{keys:[...e.values()],overrides:r}}class u{constructor(e,n,r,h,E){this.change=e,this.f=n,this.g=r,this.h=h,this.i=E,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.j=void 0;for(const R of e.keys)this.affectedKeys.add(R);for(const[,R]of e.overrides)for(const A of R)this.affectedKeys.add(A);this.d=this.a;for(const R of this.affectedKeys)this.d+=R+this.a}get previousConfiguration(){return!this.j&&this.f&&(this.j=P.parse(this.f.data,this.i)),this.j}affectsConfiguration(e,n){const r=this.a+e,h=this.d.indexOf(r);if(h<0)return!1;const E=h+r.length;if(E>=this.d.length)return!1;const R=this.d.charCodeAt(E);if(R!==this.b&&R!==this.c)return!1;if(n){const A=this.previousConfiguration?this.previousConfiguration.getValue(e,n,this.f?.workspace):void 0,T=this.g.getValue(e,n,this.h);return!S.$ao(A,T)}return!0}}t.$Jo=u;function i(s,e){const{added:n,removed:r,updated:h}=o(e?.rawConfiguration,s?.rawConfiguration),E=[],R=s?.getAllOverrideIdentifiers()||[],A=e?.getAllOverrideIdentifiers()||[];if(e){const T=A.filter(C=>!R.includes(C));for(const C of T)E.push([C,e.getKeysForOverrideIdentifier(C)])}if(s){const T=R.filter(C=>!A.includes(C));for(const C of T)E.push([C,s.getKeysForOverrideIdentifier(C)])}if(e&&s){for(const T of R)if(A.includes(T)){const C=o({contents:s.getOverrideValue(void 0,T)||{},keys:s.getKeysForOverrideIdentifier(T)},{contents:e.getOverrideValue(void 0,T)||{},keys:e.getKeysForOverrideIdentifier(T)});E.push([T,[...C.added,...C.removed,...C.updated]])}}return{added:n,removed:r,updated:h,overrides:E}}function o(s,e){const n=s?e?s.keys.filter(E=>e.keys.indexOf(E)===-1):[...s.keys]:[],r=e?s?e.keys.filter(E=>s.keys.indexOf(E)===-1):[...e.keys]:[],h=[];if(s&&e){for(const E of e.keys)if(s.keys.indexOf(E)!==-1){const R=(0,l.$cj)(e.contents,E),A=(0,l.$cj)(s.contents,E);S.$ao(R,A)||h.push(E)}}return{added:n,removed:r,updated:h}}}),define(se[140],oe([0,1,20,5,2,28,3,67,40,6,39,38]),function(Q,t,O,k,v,I,D,S,m,a,l,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Mo=t.$Lo=t.$Ko=void 0;class f extends v.$Uc{get configurationModel(){return this.b}constructor(g){super(),this.c=g,this.a=this.B(new k.$he),this.onDidChangeConfiguration=this.a.event,this.b=S.$Eo.createEmptyModel(this.c)}async initialize(){return this.h(),this.B(c.$jo.as(m.$oo.Configuration).onDidUpdateConfiguration(({properties:g,defaultsOverrides:d})=>this.f(Array.from(g),d))),this.configurationModel}reload(){return this.h(),this.configurationModel}f(g,d){this.j(g,c.$jo.as(m.$oo.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:g})}g(){return{}}h(){this.b=S.$Eo.createEmptyModel(this.c);const g=c.$jo.as(m.$oo.Configuration).getConfigurationProperties();this.j(Object.keys(g),g)}j(g,d){const $=this.g();for(const P of g){const w=$[P],u=d[P];w!==void 0?this.b.addValue(P,w):u?this.b.addValue(P,u.default):this.b.removeValue(P)}}}t.$Ko=f;class p{constructor(){this.onDidChangeConfiguration=k.Event.None,this.configurationModel=S.$Eo.createEmptyModel(new a.$hk)}async initialize(){return this.configurationModel}}t.$Lo=p;let y=class extends v.$Uc{get configurationModel(){return this.b}constructor(g,d,$){super(),this.c=g,this.f=d,this.g=$,this.a=this.B(new k.$he),this.onDidChangeConfiguration=this.a.event,this.b=S.$Eo.createEmptyModel(this.g)}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.m(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(g=>this.j(g))),this.B(this.c.onDidChangeConfiguration(async({properties:g})=>this.m(await this.h(g),!0))),this.b}async h(g){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",g);const d={},$=[],P=c.$jo.as(m.$oo.Configuration).getConfigurationProperties();for(const w of g){const u=P[w];if(!u){$.push(w);continue}if(u.policy){if(u.type!=="string"&&u.type!=="number"){this.g.warn(`Policy ${u.policy.name} has unsupported type ${u.type}`);continue}$.push(w),d[u.policy.name]={type:u.type}}}return(0,D.$ng)(d)||await this.f.updatePolicyDefinitions(d),$}j(g){this.g.trace("PolicyConfiguration#onDidChangePolicies",g);const d=c.$jo.as(m.$oo.Configuration).getPolicyConfigurations(),$=(0,O.$Hb)(g.map(P=>d.get(P)));this.m($,!0)}m(g,d){this.g.trace("PolicyConfiguration#update",g);const $=c.$jo.as(m.$oo.Configuration).getConfigurationProperties(),P=[],w=this.b.isEmpty();for(const u of g){const i=$[u]?.policy?.name;if(i){const o=this.f.getPolicyValue(i);(w?o!==void 0:!(0,I.$ao)(this.b.getValue(u),o))&&P.push([u,o])}else this.b.getValue(u)!==void 0&&P.push([u,void 0])}if(P.length){this.g.trace("PolicyConfiguration#changed",P);const u=this.b;this.b=S.$Eo.createEmptyModel(this.g);for(const i of u.keys)this.b.setValue(i,u.getValue(i));for(const[i,o]of P)o===void 0?this.b.removeValue(i):this.b.setValue(i,o);d&&this.a.fire(this.b)}}};t.$Mo=y,t.$Mo=y=we([ne(1,l.$lo),ne(2,a.$7j)],y)}),define(se[141],oe([0,1,20,8,14,5,34,78,2,31,28,13,17,30,67,40,140,10,39]),function(Q,t,O,k,v,I,D,S,m,a,l,c,f,p,y,N,g,d,$){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$No=void 0;class P extends m.$Uc{constructor(i,o,s,e){super(),this.m=i,this.n=e,this.h=this.B(new I.$he),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new g.$Ko(e)),this.c=s instanceof $.$no?new g.$Lo:this.B(new g.$Mo(this.b,s,e)),this.f=this.B(new y.$Go(this.m,{},f.$5g,o,e)),this.a=new y.$Ho(this.b.configurationModel,this.c.configurationModel,y.$Eo.createEmptyModel(e),y.$Eo.createEmptyModel(e),y.$Eo.createEmptyModel(e),y.$Eo.createEmptyModel(e),new a.$Ac,y.$Eo.createEmptyModel(e),new a.$Ac,e),this.j=new w(i,o,this),this.g=this.B(new k.$Mh(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:n,properties:r})=>this.s(n,r))),this.B(this.c.onDidChangeConfiguration(n=>this.t(n))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[i,o,s]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new y.$Ho(i,o,y.$Eo.createEmptyModel(this.n),s,y.$Eo.createEmptyModel(this.n),y.$Eo.createEmptyModel(this.n),new a.$Ac,y.$Eo.createEmptyModel(this.n),new a.$Ac,this.n)}getConfigurationData(){return this.a.toData()}getValue(i,o){const s=typeof i=="string"?i:void 0,e=(0,p.$8i)(i)?i:(0,p.$8i)(o)?o:{};return this.a.getValue(s,e,void 0)}async updateValue(i,o,s,e,n){const r=(0,p.$9i)(s)?s:(0,p.$8i)(s)?{resource:s.resource,overrideIdentifiers:s.overrideIdentifier?[s.overrideIdentifier]:void 0}:void 0,h=r?e:s;if(h!==void 0&&h!==p.ConfigurationTarget.USER_LOCAL&&h!==p.ConfigurationTarget.USER)throw new Error(`Unable to write ${i} to target ${h}.`);r?.overrideIdentifiers&&(r.overrideIdentifiers=(0,O.$Mb)(r.overrideIdentifiers),r.overrideIdentifiers=r.overrideIdentifiers.length?r.overrideIdentifiers:void 0);const E=this.inspect(i,{resource:r?.resource,overrideIdentifier:r?.overrideIdentifiers?r.overrideIdentifiers[0]:void 0});if(E.policyValue!==void 0)throw new Error(`Unable to write ${i} because it is configured in system policy.`);if((0,l.$ao)(o,E.defaultValue)&&(o=void 0),r?.overrideIdentifiers?.length&&r.overrideIdentifiers.length>1){const A=r.overrideIdentifiers.sort(),T=this.a.localUserConfiguration.overrides.find(C=>(0,O.$ub)([...C.identifiers].sort(),A));T&&(r.overrideIdentifiers=T.identifiers)}const R=r?.overrideIdentifiers?.length?[(0,N.$Ao)(r.overrideIdentifiers),i]:[i];await this.j.write(R,o),await this.reloadConfiguration()}inspect(i,o={}){return this.a.inspect(i,o,void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const i=await this.f.loadConfiguration();this.r(i)}r(i){const o=this.a.toData(),s=this.a.compareAndUpdateLocalUserConfiguration(i);this.u(s,o,p.ConfigurationTarget.USER)}s(i,o){const s=this.a.toData(),e=this.a.compareAndUpdateDefaultConfiguration(i,o);this.u(e,s,p.ConfigurationTarget.DEFAULT)}t(i){const o=this.a.toData(),s=this.a.compareAndUpdatePolicyConfiguration(i);this.u(s,o,p.ConfigurationTarget.DEFAULT)}u(i,o,s){const e=new y.$Jo(i,{data:o},this.a,void 0,this.n);e.source=s,this.h.fire(e)}}t.$No=P;class w{constructor(i,o,s){this.b=i,this.c=o,this.d=s,this.a=new k.$Hh}write(i,o){return this.a.queue(()=>this.e(i,o))}async e(i,o){let s;try{s=(await this.c.readFile(this.b)).value.toString()}catch(r){if(r.fileOperationResult===d.FileOperationResult.FILE_NOT_FOUND)s="{}";else throw r}const e=[];if((0,D.$Pn)(s,e,{allowTrailingComma:!0,allowEmptyContent:!0}),e.length>0)throw new Error("Unable to write into the settings file. Please open the file to correct errors/warnings in the file and try again.");const n=this.f(s,i,o);s=(0,S.$8n)(s,n),await this.c.writeFile(this.b,v.$Je.fromString(s))}f(i,o,s){const{tabSize:e,insertSpaces:n,eol:r}=this.h;if(!o.length){const h=JSON.stringify(s,null,n?" ".repeat(e):"	");return[{content:h,length:h.length,offset:0}]}return(0,S.$5n)(i,o,s,{tabSize:e,insertSpaces:n,eol:r})}get h(){if(!this.g){let i=c.OS===c.OperatingSystem.Linux||c.OS===c.OperatingSystem.Macintosh?`
`:`\r
`;const o=this.d.getValue("files.eol",{overrideIdentifier:"jsonc"});o&&typeof o=="string"&&o!=="auto"&&(i=o),this.g={eol:i,insertSpaces:!!this.d.getValue("editor.insertSpaces",{overrideIdentifier:"jsonc"}),tabSize:this.d.getValue("editor.tabSize",{overrideIdentifier:"jsonc"})}}return this.g}}}),define(se[68],oe([0,1,15]),function(Q,t,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Mm=k,t.$Nm=v,t.$Om=I,t.$Pm=D;function k(m){return m.scheme===O.Schemas.vscodeRemote?m.authority:void 0}function v(m){if(!m)return;const a=m.indexOf("+");return a<0?m:m.substr(0,a)}function I(m){const{host:a,port:l}=S(m);if(typeof l>"u")throw new Error(`Invalid remote authority: ${m}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:a,port:l}}function D(m,a){let{host:l,port:c}=S(m);return typeof c>"u"&&(c=a),{host:l,port:c}}function S(m){const a=m.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(a)return{host:a[1],port:parseInt(a[2],10)};const l=m.match(/^(\[[0-9a-z:]+\])$/);if(l)return{host:l[1],port:void 0};const c=m.match(/(.*):(\d+)$/);return c?{host:c[1],port:parseInt(c[2],10)}:{host:m,port:void 0}}}),define(se[26],oe([0,1,32,11,68]),function(Q,t,O,k,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$4m=t.$Ym=t.$Xm=t.$Wm=t.TargetPlatform=t.ExtensionType=t.$Vm=t.$Tm=t.$Sm=t.$Rm=t.$Qm=void 0,t.$Um=I,t.$Zm=c,t.$1m=f,t.$2m=p,t.$3m=y,t.$Qm="extensions.user.cache",t.$Rm="extensions.builtin.cache",t.$Sm="undefined_publisher",t.$Tm=["ui","workspace","web"];function I(N){if(typeof N=="object"&&N!==null&&N.supported!==!0)return N.description}t.$Vm=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","AI","Chat","Other"];var D;(function(N){N[N.System=0]="System",N[N.User=1]="User"})(D||(t.ExtensionType=D={}));var S;(function(N){N.WIN32_X64="win32-x64",N.WIN32_ARM64="win32-arm64",N.LINUX_X64="linux-x64",N.LINUX_ARM64="linux-arm64",N.LINUX_ARMHF="linux-armhf",N.ALPINE_X64="alpine-x64",N.ALPINE_ARM64="alpine-arm64",N.DARWIN_X64="darwin-x64",N.DARWIN_ARM64="darwin-arm64",N.WEB="web",N.UNIVERSAL="universal",N.UNKNOWN="unknown",N.UNDEFINED="undefined"})(S||(t.TargetPlatform=S={}));class m{constructor(g){this.value=g,this._lower=g.toLowerCase()}static equals(g,d){if(typeof g>"u"||g===null)return typeof d>"u"||d===null;if(typeof d>"u"||d===null)return!1;if(typeof g=="string"||typeof d=="string"){const $=typeof g=="string"?g:g.value,P=typeof d=="string"?d:d.value;return O.$Bf($,P)}return g._lower===d._lower}static toKey(g){return typeof g=="string"?g.toLowerCase():g._lower}}t.$Wm=m;class a{get size(){return this.c.size}constructor(g){if(this.c=new Set,g)for(const d of g)this.add(d)}add(g){this.c.add(m.toKey(g))}delete(g){return this.c.delete(m.toKey(g))}has(g){return this.c.has(m.toKey(g))}}t.$Xm=a;class l{constructor(){this.c=new Map}clear(){this.c.clear()}delete(g){this.c.delete(m.toKey(g))}get(g){return this.c.get(m.toKey(g))}has(g){return this.c.has(m.toKey(g))}set(g,d){this.c.set(m.toKey(g),d)}values(){return this.c.values()}forEach(g){this.c.forEach(g)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}t.$Ym=l;function c(N){return f(N)}function f(N){return N.contributes&&N.contributes.localizations?N.contributes.localizations.length>0:!1}function p(N){return N.contributes&&N.contributes.authentication?N.contributes.authentication.length>0:!1}function y(N,g){if(g){const d=`onResolveRemoteAuthority:${(0,v.$Nm)(g)}`;return!!N.activationEvents?.includes(d)}return!1}t.$4m=(0,k.$Ai)("IBuiltinExtensionsScannerService")}),define(se[21],oe([0,1,13,99,26,11]),function(Q,t,O,k,v,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$kp=t.$jp=t.$ip=t.$hp=t.$gp=t.$fp=t.$ep=t.$dp=t.ExtensionManagementErrorCode=t.$cp=t.ExtensionGalleryErrorCode=t.$bp=t.InstallOperation=t.StatisticType=t.SortOrder=t.SortBy=t.ExtensionInstallSource=t.$7o=t.$6o=t.$5o=t.$4o=t.$3o=t.$2o=t.$1o=void 0,t.$8o=S,t.$9o=m,t.$0o=a,t.$$o=l,t.$_o=c,t.$ap=f,t.$1o="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",t.$2o=new RegExp(t.$1o),t.$3o="__web_extension",t.$4o="skipWalkthrough",t.$5o="extensionInstallSource",t.$6o="dependecyOrPackExtensionInstall",t.$7o="clientTargetPlatform";var D;(function(u){u.COMMAND="command",u.SETTINGS_SYNC="settingsSync"})(D||(t.ExtensionInstallSource=D={}));function S(u){switch(u){case v.TargetPlatform.WIN32_X64:return"Windows 64 bit";case v.TargetPlatform.WIN32_ARM64:return"Windows ARM";case v.TargetPlatform.LINUX_X64:return"Linux 64 bit";case v.TargetPlatform.LINUX_ARM64:return"Linux ARM 64";case v.TargetPlatform.LINUX_ARMHF:return"Linux ARM";case v.TargetPlatform.ALPINE_X64:return"Alpine Linux 64 bit";case v.TargetPlatform.ALPINE_ARM64:return"Alpine ARM 64";case v.TargetPlatform.DARWIN_X64:return"Mac";case v.TargetPlatform.DARWIN_ARM64:return"Mac Silicon";case v.TargetPlatform.WEB:return"Web";case v.TargetPlatform.UNIVERSAL:return v.TargetPlatform.UNIVERSAL;case v.TargetPlatform.UNKNOWN:return v.TargetPlatform.UNKNOWN;case v.TargetPlatform.UNDEFINED:return v.TargetPlatform.UNDEFINED}}function m(u){switch(u){case v.TargetPlatform.WIN32_X64:return v.TargetPlatform.WIN32_X64;case v.TargetPlatform.WIN32_ARM64:return v.TargetPlatform.WIN32_ARM64;case v.TargetPlatform.LINUX_X64:return v.TargetPlatform.LINUX_X64;case v.TargetPlatform.LINUX_ARM64:return v.TargetPlatform.LINUX_ARM64;case v.TargetPlatform.LINUX_ARMHF:return v.TargetPlatform.LINUX_ARMHF;case v.TargetPlatform.ALPINE_X64:return v.TargetPlatform.ALPINE_X64;case v.TargetPlatform.ALPINE_ARM64:return v.TargetPlatform.ALPINE_ARM64;case v.TargetPlatform.DARWIN_X64:return v.TargetPlatform.DARWIN_X64;case v.TargetPlatform.DARWIN_ARM64:return v.TargetPlatform.DARWIN_ARM64;case v.TargetPlatform.WEB:return v.TargetPlatform.WEB;case v.TargetPlatform.UNIVERSAL:return v.TargetPlatform.UNIVERSAL;default:return v.TargetPlatform.UNKNOWN}}function a(u,i){switch(u){case O.Platform.Windows:return i==="x64"?v.TargetPlatform.WIN32_X64:i==="arm64"?v.TargetPlatform.WIN32_ARM64:v.TargetPlatform.UNKNOWN;case O.Platform.Linux:return i==="x64"?v.TargetPlatform.LINUX_X64:i==="arm64"?v.TargetPlatform.LINUX_ARM64:i==="arm"?v.TargetPlatform.LINUX_ARMHF:v.TargetPlatform.UNKNOWN;case"alpine":return i==="x64"?v.TargetPlatform.ALPINE_X64:i==="arm64"?v.TargetPlatform.ALPINE_ARM64:v.TargetPlatform.UNKNOWN;case O.Platform.Mac:return i==="x64"?v.TargetPlatform.DARWIN_X64:i==="arm64"?v.TargetPlatform.DARWIN_ARM64:v.TargetPlatform.UNKNOWN;case O.Platform.Web:return v.TargetPlatform.WEB}}function l(u,i){return i===v.TargetPlatform.WEB&&!u.includes(v.TargetPlatform.WEB)}function c(u,i,o){return l(i,o)?!1:u===v.TargetPlatform.UNDEFINED||u===v.TargetPlatform.UNIVERSAL?!0:u===v.TargetPlatform.UNKNOWN?!1:u===o}function f(u){return u&&typeof u=="object"&&typeof u.id=="string"&&(!u.uuid||typeof u.uuid=="string")}var p;(function(u){u[u.NoneOrRelevance=0]="NoneOrRelevance",u[u.LastUpdatedDate=1]="LastUpdatedDate",u[u.Title=2]="Title",u[u.PublisherName=3]="PublisherName",u[u.InstallCount=4]="InstallCount",u[u.PublishedDate=10]="PublishedDate",u[u.AverageRating=6]="AverageRating",u[u.WeightedRating=12]="WeightedRating"})(p||(t.SortBy=p={}));var y;(function(u){u[u.Default=0]="Default",u[u.Ascending=1]="Ascending",u[u.Descending=2]="Descending"})(y||(t.SortOrder=y={}));var N;(function(u){u.Install="install",u.Uninstall="uninstall"})(N||(t.StatisticType=N={}));var g;(function(u){u[u.None=1]="None",u[u.Install=2]="Install",u[u.Update=3]="Update",u[u.Migrate=4]="Migrate"})(g||(t.InstallOperation=g={})),t.$bp=(0,I.$Ai)("extensionGalleryService");var d;(function(u){u.Timeout="Timeout",u.Cancelled="Cancelled",u.Failed="Failed",u.DownloadFailedWriting="DownloadFailedWriting"})(d||(t.ExtensionGalleryErrorCode=d={}));class $ extends Error{constructor(i,o){super(i),this.code=o,this.name=o}}t.$cp=$;var P;(function(u){u.Unsupported="Unsupported",u.Deprecated="Deprecated",u.Malicious="Malicious",u.Incompatible="Incompatible",u.IncompatibleTargetPlatform="IncompatibleTargetPlatform",u.ReleaseVersionNotFound="ReleaseVersionNotFound",u.Invalid="Invalid",u.Download="Download",u.DownloadSignature="DownloadSignature",u.DownloadFailedWriting="DownloadFailedWriting",u.UpdateMetadata="UpdateMetadata",u.Extract="Extract",u.Scanning="Scanning",u.ScanningExtension="ScanningExtension",u.ReadUninstalled="ReadUninstalled",u.UnsetUninstalled="UnsetUninstalled",u.Delete="Delete",u.Rename="Rename",u.IntializeDefaultProfile="IntializeDefaultProfile",u.AddToProfile="AddToProfile",u.InstalledExtensionNotFound="InstalledExtensionNotFound",u.PostInstall="PostInstall",u.CorruptZip="CorruptZip",u.IncompleteZip="IncompleteZip",u.Signature="Signature",u.NotAllowed="NotAllowed",u.Gallery="Gallery",u.Cancelled="Cancelled",u.Unknown="Unknown",u.Internal="Internal"})(P||(t.ExtensionManagementErrorCode=P={}));class w extends Error{constructor(i,o){super(i),this.code=o,this.name=o}}t.$dp=w,t.$ep=(0,I.$Ai)("extensionManagementService"),t.$fp="extensionsIdentifiers/disabled",t.$gp="extensionsIdentifiers/enabled",t.$hp=(0,I.$Ai)("IGlobalExtensionEnablementService"),t.$ip=(0,I.$Ai)("IExtensionTipsService"),t.$jp=(0,k.localize2)(0,"Extensions"),t.$kp=(0,k.localize2)(1,"Preferences")}),define(se[142],oe([0,1,2,26,10]),function(Q,t,O,k,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Kq=void 0;class I extends O.$Uc{constructor(S,m,a,l,c){super(),this.a=S,this.b=m,this.c=a,this.f=c,this.B(l.onDidInstallExtensions(f=>this.g(f))),this.B(l.onDidUninstallExtension(f=>this.h(f)))}g(S){for(const m of S)m.local&&this.invalidate(m.profileLocation)}h(S){S.error||this.invalidate(S.profileLocation)}async invalidate(S){if(S)for(const m of this.a.profiles)this.c.extUri.isEqual(m.extensionsResource,S)&&await this.j(m);else await this.j(this.a.defaultProfile)}async j(S){try{await this.b.del(this.c.extUri.joinPath(S.cacheHome,k.$Qm))}catch(m){(0,v.$ll)(m)!==v.FileOperationResult.FILE_NOT_FOUND&&this.f.error(m)}}}t.$Kq=I}),define(se[69],oe([0,1,22,2,13,109,21,11]),function(Q,t,O,k,v,I,D,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$1r=t.$Zr=void 0,t.$Yr=m;function m(l){return l.tags.find(c=>c.startsWith("lp-"))?.split("lp-")[1]}t.$Zr=(0,S.$Ai)("languagePackService");let a=class extends k.$Uc{constructor(c){super(),this.c=c}async getAvailableLanguages(){const c=new O.$se;setTimeout(()=>c.cancel(),1e3);let f;try{f=await this.c.query({text:'category:"language packs"',pageSize:20},c.token)}catch{return[]}const y=f.firstPage.filter(N=>N.properties.localizedLanguages?.length&&N.tags.some(g=>g.startsWith("lp-"))).map(N=>{const g=N.properties.localizedLanguages?.[0],d=m(N);return{...this.f(d,g,N),extensionId:N.identifier.id,galleryExtension:N}});return y.push(this.f("en","English")),y}f(c,f,p){const y=f??c;let N;if(y!==c&&(N=`(${c})`),c.toLowerCase()===v.$w.toLowerCase()&&(N??="",N+=(0,I.localize)(0,null)),p?.installCount){N??="";const g=p.installCount;let d;g>1e6?d=`${Math.floor(g/1e5)/10}M`:g>1e3?d=`${Math.floor(g/1e3)}K`:d=String(g),N+=` $(cloud-download) ${d}`}return{id:c,label:y,description:N}}};t.$1r=a,t.$1r=a=we([ne(0,D.$bp)],a)}),define(se[45],oe([0,1,14,9,2,111,40,11,6,38]),function(Q,t,O,k,v,I,D,S,m,a){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Wp=t.$Vp=void 0,t.$Xp=f,t.$Yp=p,t.$Zp=y,t.$1p=N,t.$2p=g,t.$3p=d,t.$Vp=(0,S.$Ai)("requestService");class l{constructor(u){this.b=u}toJSON(){if(!this.a){const u=Object.create(null);for(const i in this.b)i.toLowerCase()==="authorization"||i.toLowerCase()==="proxy-authorization"?u[i]="*****":u[i]=this.b[i];this.a=u}return this.a}}class c extends v.$Uc{constructor(u){super(),this.b=0,this.a=u.createLogger("network",{name:(0,I.localize)(0,null),when:m.$mk.isEqualTo((0,m.$jk)(m.LogLevel.Trace)).serialize()})}async c(u,i,o){const s=`${u} #${++this.b}: ${i.url}`;this.a.trace(`${s} - begin`,i.type,new l(i.headers??{}));try{const e=await o();return this.a.trace(`${s} - end`,i.type,e.res.statusCode,e.res.headers),e}catch(e){throw this.a.error(`${s} - error`,i.type,(0,k.$0)(e)),e}}}t.$Wp=c;function f(w){return w.res.statusCode&&w.res.statusCode>=200&&w.res.statusCode<300||w.res.statusCode===1223}function p(w){return w.res.statusCode===204}async function y(w){return p(w)?null:(await(0,O.$Ve)(w.stream)).toString()}async function N(w){if(!f(w))throw new Error("Server returned "+w.res.statusCode);return y(w)}async function g(w){if(!f(w))throw new Error("Server returned "+w.res.statusCode);if(p(w))return null;const i=(await(0,O.$Ve)(w.stream)).toString();try{return JSON.parse(i)}catch(o){throw o.message+=`:
`+i,o}}function d(w){P(w)}let $;function P(w){const u=a.$jo.as(D.$oo.Configuration),i=$;$={id:"http",order:15,title:(0,I.localize)(1,null),type:"object",scope:w,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,I.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,I.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,I.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,I.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,I.localize)(6,null),(0,I.localize)(7,null),(0,I.localize)(8,null),(0,I.localize)(9,null)],default:"override",description:(0,I.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,I.localize)(11,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,I.localize)(12,null),restricted:!0}}},u.updateConfigurations({add:[$],remove:i?[i]:[]})}P(D.ConfigurationScope.APPLICATION)}),define(se[143],oe([0,1,22,15,10,45]),function(Q,t,O,k,v,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$xQ=void 0;let D=class{constructor(m,a){this.a=m,this.b=a}async download(m,a,l=O.CancellationToken.None){if(m.scheme===k.Schemas.file||m.scheme===k.Schemas.vscodeRemote){await this.b.copy(m,a);return}const c={type:"GET",url:m.toString(!0)},f=await this.a.request(c,l);if(f.res.statusCode===200)await this.b.writeFile(a,f.stream);else{const p=await(0,I.$1p)(f);throw new Error(`Expected 200, got back ${f.res.statusCode} instead.

${p}`)}}};t.$xQ=D,t.$xQ=D=we([ne(0,I.$Vp),ne(1,v.$7k)],D)}),define(se[144],oe([0,1,145,3]),function(Q,t,O,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$5r=I;function v(D,S){return D.protocol==="http:"?S.HTTP_PROXY||S.http_proxy||null:D.protocol==="https:"&&(S.HTTPS_PROXY||S.https_proxy||S.HTTP_PROXY||S.http_proxy)||null}async function I(D,S,m={}){const a=(0,O.parse)(D),l=m.proxyUrl||v(a,S);if(!l)return null;const c=(0,O.parse)(l);if(!/^https?:$/.test(c.protocol||""))return null;const f={host:c.hostname||"",port:(c.port?+c.port:0)||(c.protocol==="https"?443:80),auth:c.auth,rejectUnauthorized:(0,k.$gg)(m.strictSSL)?m.strictSSL:!0};return a.protocol==="http:"?new(await new Promise((p,y)=>{Q(["http-proxy-agent"],p,y)})).HttpProxyAgent(l,f):new(await new Promise((p,y)=>{Q(["https-proxy-agent"],p,y)})).HttpsProxyAgent(l,f)}}),define(se[146],oe([0,1,60,16,112,22,36,9,13,29,91,177,8,79]),function(Q,t,O,k,v,I,D,S,m,a,l,c,f,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Lm=N;let y;async function N(d,$,P,w){return P["force-disable-user-env"]?($.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):m.$i?($.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,c.$Fm)(w)&&!P["force-user-env"]?($.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,c.$Fm)(w)?$.trace("resolveShellEnv(): running (--force-user-env)"):$.trace("resolveShellEnv(): running (macOS/Linux)"),y||(y=f.Promises.withAsyncBody(async(u,i)=>{const o=new I.$se;let s=1e4;const e=d.getValue("application.shellEnvironmentResolutionTimeout");typeof e=="number"&&(s=(0,p.$Gm)(e,1,120)*1e3);const n=setTimeout(()=>{o.dispose(!0),i(new Error((0,v.localize)(0,null)))},s);try{u(await g($,o.token))}catch(r){!(0,S.$4)(r)&&!o.token.isCancellationRequested?i(new Error((0,v.localize)(1,null,(0,D.$lj)(r)))):u({})}finally{clearTimeout(n),o.dispose()}})),y)}async function g(d,$){const P=process.env.ELECTRON_RUN_AS_NODE;d.trace("getUnixShellEnvironment#runAsNode",P);const w=process.env.ELECTRON_NO_ATTACH_CONSOLE;d.trace("getUnixShellEnvironment#noAttach",w);const u=(0,a.$Wg)().replace(/-/g,"").substr(0,12),i=new RegExp(u+"({.*})"+u),o={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};d.trace("getUnixShellEnvironment#env",o);const s=await(0,l.$vm)(m.OS,o);return d.trace("getUnixShellEnvironment#shell",s),new Promise((e,n)=>{if($.isCancellationRequested)return n(new S.$5);const r=(0,k.$nc)(s);let h,E;const R="";/^pwsh(-preview)?$/.test(r)?(h=`& '${process.execPath}' ${R} -p '''${u}'' + JSON.stringify(process.env) + ''${u}'''`,E=["-Login","-Command"]):r==="nu"?(h=`^'${process.execPath}' ${R} -p '"${u}" + JSON.stringify(process.env) + "${u}"'`,E=["-i","-l","-c"]):r==="xonsh"?(h=`import os, json; print("${u}", json.dumps(dict(os.environ)), "${u}")`,E=["-i","-l","-c"]):(h=`'${process.execPath}' ${R} -p '"${u}" + JSON.stringify(process.env) + "${u}"'`,r==="tcsh"||r==="csh"?E=["-ic"]:E=["-i","-l","-c"]),d.trace("getUnixShellEnvironment#spawn",JSON.stringify(E),h);const A=(0,O.spawn)(s,[...E,h],{detached:!0,stdio:["ignore","pipe","pipe"],env:o});$.onCancellationRequested(()=>(A.kill(),n(new S.$5))),A.on("error",M=>{d.error("getUnixShellEnvironment#errorChildProcess",(0,D.$lj)(M)),n(M)});const T=[];A.stdout.on("data",M=>T.push(M));const C=[];A.stderr.on("data",M=>C.push(M)),A.on("close",(M,J)=>{const ae=Buffer.concat(T).toString("utf8");d.trace("getUnixShellEnvironment#raw",ae);const ie=Buffer.concat(C).toString("utf8");if(ie.trim()&&d.trace("getUnixShellEnvironment#stderr",ie),M||J)return n(new Error((0,v.localize)(2,null,M,J)));const ce=i.exec(ae),ue=ce?ce[1]:"{}";try{const le=JSON.parse(ue);P?le.ELECTRON_RUN_AS_NODE=P:delete le.ELECTRON_RUN_AS_NODE,w?le.ELECTRON_NO_ATTACH_CONSOLE=w:delete le.ELECTRON_NO_ATTACH_CONSOLE,delete le.VSCODE_RESOLVING_ENVIRONMENT,delete le.XDG_RUNTIME_DIR,d.trace("getUnixShellEnvironment#result",le),e(le)}catch(le){d.error("getUnixShellEnvironment#errorCaught",(0,D.$lj)(le)),n(le)}})})}}),define(se[147],oe([0,1,11]),function(Q,t,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$aQ=t.$_P=void 0,t.$_P=(0,O.$Ai)("stateReadService"),t.$aQ=(0,O.$Ai)("stateService")}),define(se[70],oe([0,1,8,14,2,3,18,10,6]),function(Q,t,O,k,v,I,D,S,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$dQ=t.$cQ=t.$bQ=t.SaveStrategy=void 0;var a;(function(p){p[p.IMMEDIATE=0]="IMMEDIATE",p[p.DELAYED=1]="DELAYED"})(a||(t.SaveStrategy=a={}));class l extends v.$Uc{constructor(y,N,g,d){super(),this.h=y,this.j=N,this.m=g,this.n=d,this.a=Object.create(null),this.b="",this.c=this.B(new O.$yh(this.j===a.IMMEDIATE?0:100)),this.f=void 0,this.g=void 0}init(){return this.f||(this.f=this.r()),this.f}async r(){try{this.b=(await this.n.readFile(this.h)).value.toString(),this.a=JSON.parse(this.b)}catch(y){y.fileOperationResult!==S.FileOperationResult.FILE_NOT_FOUND&&this.m.error(y)}}getItem(y,N){const g=this.a[y];return(0,I.$jg)(g)?N:g}setItem(y,N){this.setItems([{key:y,data:N}])}setItems(y){let N=!1;for(const{key:g,data:d}of y)this.a[g]!==d&&((0,I.$jg)(d)?(0,I.$hg)(this.a[g])||(this.a[g]=void 0,N=!0):(this.a[g]=d,N=!0));N&&this.s()}removeItem(y){(0,I.$hg)(this.a[y])||(this.a[y]=void 0,this.s())}async s(){if(!this.g)return this.c.trigger(()=>this.t())}async t(){if(!this.f)return;await this.f;const y=JSON.stringify(this.a,null,4);if(y!==this.b)try{await this.n.writeFile(this.h,k.$Je.fromString(y),{atomic:{postfix:".vsctmp"}}),this.b=y}catch(N){this.m.error(N)}}async close(){return this.g||(this.g=this.c.trigger(()=>this.t(),0)),this.g}}t.$bQ=l;let c=class extends v.$Uc{constructor(y,N,g,d){super(),this.a=this.B(new l(N.stateResource,y,g,d))}async init(){await this.a.init()}getItem(y,N){return this.a.getItem(y,N)}};t.$cQ=c,t.$cQ=c=we([ne(1,D.$Hi),ne(2,m.$7j),ne(3,S.$7k)],c);class f extends c{setItem(y,N){this.a.setItem(y,N)}setItems(y){this.a.setItems(y)}removeItem(y){this.a.removeItem(y)}close(){return this.a.close()}}t.$dQ=f}),define(se[71],oe([0,1,13,37,29]),function(Q,t,O,k,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$lp=D,t.$mp=S;function I(m){if(O.$u===O.Platform.Linux&&/^penguin(\.|$)/i.test(m))return"chromebook"}function D(m,a,l,c,f,p,y,N,g,d){const $=Object.create(null);$["common.machineId"]=p,$["common.sqmId"]=y,$["common.devDeviceId"]=N,$.sessionID=(0,v.$Wg)()+Date.now(),$.commitHash=c,$.version=f,$["common.platformVersion"]=(m||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),$["common.platform"]=(0,O.$h)(O.$u),$["common.nodePlatform"]=k.$dc,$["common.nodeArch"]=l,$["common.product"]=d||"desktop",g&&($["common.msftInternal"]=g);let P=0;const w=Date.now();Object.defineProperties($,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-w,enumerable:!0},"common.sequence":{get:()=>P++,enumerable:!0}}),O.$l&&($["common.snap"]="true");const u=I(a);return u&&($["common.platformDetail"]=u),$}function S(m){const a=k.env.USERDNSDOMAIN;if(!a)return!1;const l=a.toLowerCase();return m.some(c=>l===c)}}),define(se[19],oe([0,1,11]),function(Q,t,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.TelemetryConfiguration=t.TelemetryLevel=t.$em=t.$dm=t.$cm=t.$bm=t.$am=t.$_l=t.$$l=t.$0l=t.$9l=t.$8l=t.$7l=t.$6l=void 0,t.$6l=(0,O.$Ai)("telemetryService"),t.$7l=(0,O.$Ai)("customEndpointTelemetryService"),t.$8l="telemetry.currentSessionDate",t.$9l="telemetry.firstSessionDate",t.$0l="telemetry.lastSessionDate",t.$$l="telemetry.machineId",t.$_l="telemetry.sqmId",t.$am="telemetry.devDeviceId",t.$bm="telemetry",t.$cm="telemetry.telemetryLevel",t.$dm="telemetry.enableCrashReporter",t.$em="telemetry.enableTelemetry";var k;(function(I){I[I.NONE=0]="NONE",I[I.CRASH=1]="CRASH",I[I.ERROR=2]="ERROR",I[I.USAGE=3]="USAGE"})(k||(t.TelemetryLevel=k={}));var v;(function(I){I.OFF="off",I.CRASH="crash",I.ERROR="error",I.ON="all"})(v||(t.TelemetryConfiguration=v={}))}),define(se[72],oe([0,1,9,11,6,19]),function(Q,t,O,k,v,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$jq=t.$iq=t.ExtensionSignatureVerificationCode=t.$hq=void 0,t.$hq=(0,k.$Ai)("IExtensionSignatureVerificationService");var D;(function(a){a.None="None",a.RequiredArgumentMissing="RequiredArgumentMissing",a.InvalidArgument="InvalidArgument",a.PackageIsUnreadable="PackageIsUnreadable",a.UnhandledException="UnhandledException",a.SignatureManifestIsMissing="SignatureManifestIsMissing",a.SignatureManifestIsUnreadable="SignatureManifestIsUnreadable",a.SignatureIsMissing="SignatureIsMissing",a.SignatureIsUnreadable="SignatureIsUnreadable",a.CertificateIsUnreadable="CertificateIsUnreadable",a.SignatureArchiveIsUnreadable="SignatureArchiveIsUnreadable",a.FileAlreadyExists="FileAlreadyExists",a.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip",a.SignatureArchiveHasSameSignatureFile="SignatureArchiveHasSameSignatureFile",a.Success="Success",a.PackageIntegrityCheckFailed="PackageIntegrityCheckFailed",a.SignatureIsInvalid="SignatureIsInvalid",a.SignatureManifestIsInvalid="SignatureManifestIsInvalid",a.SignatureIntegrityCheckFailed="SignatureIntegrityCheckFailed",a.EntryIsMissing="EntryIsMissing",a.EntryIsTampered="EntryIsTampered",a.Untrusted="Untrusted",a.CertificateRevoked="CertificateRevoked",a.SignatureIsNotValid="SignatureIsNotValid",a.UnknownError="UnknownError",a.PackageIsInvalidZip="PackageIsInvalidZip",a.SignatureArchiveHasTooManyEntries="SignatureArchiveHasTooManyEntries"})(D||(t.ExtensionSignatureVerificationCode=D={}));class S extends Error{constructor(l){super(l),this.code=l}}t.$iq=S;let m=class{constructor(l,c){this.b=l,this.c=c}d(){return this.a||(this.a=new Promise((l,c)=>Q(["@vscode/vsce-sign"],async f=>l(f),c))),this.a}async verify(l,c,f,p){let y;const N=l.identifier.id;try{y=await this.d()}catch(P){return this.b.error("Could not load vsce-sign module",(0,O.$0)(P)),this.b.info(`Extension signature verification is not done: ${N}`),!1}const g=new Date().getTime();let d;try{this.b.trace(`Verifying extension signature for ${N}...`),d=await y.verify(c,f,this.b.getLevel()===v.LogLevel.Trace)}catch(P){d={code:D.UnknownError,didExecute:!1,output:(0,O.$0)(P)}}const $=new Date().getTime()-g;if(this.b.info(`Extension signature verification result for ${N}: ${d.code}. Executed: ${d.didExecute}. Duration: ${$}ms.`),this.b.trace(`Extension signature verification output for ${N}:
${d.output}`),this.c.publicLog2("extensionsignature:verification",{extensionId:N,extensionVersion:l.version,code:d.code,internalCode:d.internalCode,duration:$,didExecute:d.didExecute,clientTargetPlatform:p}),d.code===D.Success)return!0;throw new S(d.code)}};t.$jq=m,t.$jq=m=we([ne(0,v.$7j),ne(1,I.$6l)],m)}),define(se[41],oe([0,1,28,3,68,71,19]),function(Q,t,O,k,v,I,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$tp=t.$sp=t.$rp=t.$qp=t.$pp=t.$op=t.$np=void 0,t.$up=l,t.$vp=c,t.$wp=f,t.$xp=p,t.$yp=N,t.$zp=d,t.$Ap=$,t.$Bp=u;class S{constructor(o){this.value=o,this.isTrustedTelemetryValue=!0}}t.$np=S;class m{constructor(){this.telemetryLevel=D.TelemetryLevel.NONE,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.devDeviceId="someValue.devDeviceId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}t.$op=m,t.$pp=new m;class a{async publicLog(o,s,e){}async publicLogError(o,s,e){}}t.$qp=a,t.$rp="telemetry",t.$sp="extensionTelemetryLog",t.$tp={log:()=>null,flush:()=>Promise.resolve(null)};function l(i,o){return!o.isBuilt&&!o.disableTelemetry?!0:!(o.disableTelemetry||!i.enableTelemetry)}function c(i,o){return o.extensionTestsLocationURI?!0:!(o.isBuilt||o.disableTelemetry||i.enableTelemetry&&i.aiConfig?.ariaKey)}function f(i){const o=i.getValue(D.$cm),s=i.getValue(D.$dm);if(i.getValue(D.$em)===!1||s===!1)return D.TelemetryLevel.NONE;switch(o??D.TelemetryConfiguration.ON){case D.TelemetryConfiguration.ON:return D.TelemetryLevel.USAGE;case D.TelemetryConfiguration.ERROR:return D.TelemetryLevel.ERROR;case D.TelemetryConfiguration.CRASH:return D.TelemetryLevel.CRASH;case D.TelemetryConfiguration.OFF:return D.TelemetryLevel.NONE}}function p(i){const o={},s={},e={};g(i,e);for(let n in e){n=n.length>150?n.substr(n.length-149):n;const r=e[n];typeof r=="number"?s[n]=r:typeof r=="boolean"?s[n]=r?1:0:typeof r=="string"?(r.length>8192&&console.warn(`Telemetry property: ${n} has been trimmed to 8192, the original length is ${r.length}`),o[n]=r.substring(0,8191)):typeof r<"u"&&r!==null&&(o[n]=r)}return{properties:o,measurements:s}}const y=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function N(i){if(!i)return"none";const o=(0,v.$Nm)(i);return y.has(o)?o:"other"}function g(i,o,s=0,e){if(i)for(const n of Object.getOwnPropertyNames(i)){const r=i[n],h=e?e+n:n;Array.isArray(r)?o[h]=(0,O.$bo)(r):r instanceof Date?o[h]=r.toISOString():(0,k.$cg)(r)?s<2?g(r,o,s+1,h+"."):o[h]=(0,O.$bo)(r):o[h]=r}}function d(i,o){const s=i.msftInternalDomains||[],e=o.getValue("telemetry.internalTesting");return(0,I.$mp)(s)||e}function $(i){return[i.appRoot,i.extensionsPath,i.userHome.fsPath,i.tmpDir.fsPath,i.userDataPath]}function P(i,o){if(!i||!i.includes("/")&&!i.includes("\\"))return i;let s=i;const e=[];for(const E of o)for(;;){const R=E.exec(i);if(!R)break;e.push([R.index,E.lastIndex])}const n=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,r=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let h=0;for(s="";;){const E=r.exec(i);if(!E)break;const R=e.some(([A,T])=>E.index<T&&A<r.lastIndex);!n.test(E[0])&&!R&&(s+=i.substring(h,E.index)+"<REDACTED: user-file-path>",h=r.lastIndex)}return h<i.length&&(s+=i.substr(h)),s}function w(i){if(!i)return i;const o=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"CLI Credentials",regex:/((login|psexec|(certutil|psexec)\.exe).{1,50}(\s-u(ser(name)?)?\s+.{3,100})?\s-(admin|user|vm|root)?p(ass(word)?)?\s+["']?[^$\-\/\s]|(^|[\s\r\n\\])net(\.exe)?.{1,5}(user\s+|share\s+\/user:| user -? secrets ? set) \s + [^ $\s \/])/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const s of o)if(s.regex.test(i))return`<REDACTED: ${s.label}>`;return i}function u(i,o){return(0,O.$$n)(i,s=>{if(s instanceof S||Object.hasOwnProperty.call(s,"isTrustedTelemetryValue"))return s.value;if(typeof s=="string"){let e=s.replaceAll("%20"," ");e=P(e,o);for(const n of o)e=e.replace(n,"");return e=w(e),e}})}}),define(se[27],oe([0,1,32,21,26,13,12,9,37,41]),function(Q,t,O,k,v,I,D,S,m,a){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Lp=t.$Dp=void 0,t.$Cp=l,t.$Ep=y,t.$Fp=N,t.$Gp=g,t.$Hp=d,t.$Ip=$,t.$Jp=P,t.$Kp=w,t.$Mp=u,t.$Np=o;function l(s,e){return s.uuid&&e.uuid?s.uuid===e.uuid:s.id===e.id?!0:(0,O.$wf)(s.id,e.id)===0}const c=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class f{static create(e){const n=e.manifest?e.manifest.version:e.version,r=e.manifest?e.targetPlatform:e.properties.targetPlatform;return new f(e.identifier,n,r)}static parse(e){const n=c.exec(e);return n&&n[1]&&n[2]?new f({id:n[1]},n[2],n[4]||void 0):null}constructor(e,n,r=v.TargetPlatform.UNDEFINED){this.identifier=e,this.version=n,this.targetPlatform=r,this.id=e.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!==v.TargetPlatform.UNDEFINED?`-${this.targetPlatform}`:""}`}equals(e){return e instanceof f?l(this,e)&&this.version===e.version&&this.targetPlatform===e.targetPlatform:!1}}t.$Dp=f;const p=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function y(s){const e=p.exec(s);return e&&e[1]?[g(e[1]),e[2]]:[g(s),void 0]}function N(s,e){return`${s}.${e}`}function g(s){return s.toLowerCase()}function d(s,e){return g(N(s??v.$Sm,e))}function $(s,e){const n=[],r=h=>{for(const E of n)if(E.some(R=>l(e(R),e(h))))return E;return null};for(const h of s){const E=r(h);E?E.push(h):n.push([h])}return n}function P(s){return{id:s.identifier.id,name:s.manifest.name,galleryId:null,publisherId:s.publisherId,publisherName:s.manifest.publisher,publisherDisplayName:s.publisherDisplayName,dependencies:s.manifest.extensionDependencies&&s.manifest.extensionDependencies.length>0}}function w(s){return{id:new a.$np(s.identifier.id),name:new a.$np(s.name),version:s.version,galleryId:s.identifier.uuid,publisherId:s.publisherId,publisherName:s.publisher,publisherDisplayName:s.publisherDisplayName,isPreReleaseVersion:s.properties.isPreReleaseVersion,dependencies:!!(s.properties.dependencies&&s.properties.dependencies.length>0),isSigned:s.isSigned,...s.telemetryData}}t.$Lp=new v.$Wm("pprice.better-merge");function u(s,e){const n=[],r=e.manifest.extensionDependencies?.slice(0)??[];for(;r.length;){const h=r.shift();if(h&&n.every(E=>!l(E.identifier,{id:h}))){const E=s.filter(R=>l(R.identifier,{id:h}));E.length===1&&(n.push(E[0]),r.push(...E[0].manifest.extensionDependencies?.slice(0)??[]))}}return n}async function i(s,e){if(!I.$k)return!1;let n;try{n=(await s.readFile(D.URI.file("/etc/os-release"))).value.toString()}catch{try{n=(await s.readFile(D.URI.file("/usr/lib/os-release"))).value.toString()}catch(h){e.debug("Error while getting the os-release file.",(0,S.$0)(h))}}return!!n&&(n.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function o(s,e){const n=await i(s,e),r=(0,k.$0o)(n?"alpine":I.$u,m.$ec);return e.debug("ComputeTargetPlatform:",r),r}}),define(se[148],oe([0,1,22,9,15,17,44,12,100,21,27,26]),function(Q,t,O,k,v,I,D,S,m,a,l,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$kq=void 0;const f=N=>(0,m.localize)(0,null,N),p=(0,m.localize)(1,null,"ms-dotnettools.csharp");let y=class{constructor(g,d,$){this.a=g,this.b=d,this.d=$}get f(){}async listExtensions(g,d,$){let P=await this.b.getInstalled(c.ExtensionType.User,$);const w=c.$Vm.map(i=>i.toLowerCase());if(d&&d!==""){if(w.indexOf(d.toLowerCase())<0){this.a.info("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}P=P.filter(i=>i.manifest.categories?i.manifest.categories.map(s=>s.toLowerCase()).indexOf(d.toLowerCase())>-1:!1)}else if(d===""){this.a.info("Possible Categories: "),w.forEach(i=>{this.a.info(i)});return}this.f&&this.a.info((0,m.localize)(2,null,this.f)),P=P.sort((i,o)=>i.identifier.id.localeCompare(o.identifier.id));let u;for(const i of P)u!==i.identifier.id&&(u=i.identifier.id,this.a.info(g?`${u}@${i.manifest.version}`:u))}async installExtensions(g,d,$,P){const w=[];try{g.length&&this.a.info(this.f?(0,m.localize)(3,null,this.f):(0,m.localize)(4,null));const u=[],i=[],o=(e,n,r)=>{i.push({id:e,version:n!=="prerelease"?n:void 0,installOptions:{...$,isBuiltin:r,installPreReleaseVersion:n==="prerelease"||$.installPreReleaseVersion}})};for(const e of g)if(e instanceof S.URI)u.push({vsix:e,installOptions:$});else{const[n,r]=(0,l.$Ep)(e);o(n,r,!1)}for(const e of d)if(e instanceof S.URI)u.push({vsix:e,installOptions:{...$,isBuiltin:!0,donotIncludePackAndDependencies:!0}});else{const[n,r]=(0,l.$Ep)(e);o(n,r,!0)}const s=await this.b.getInstalled(void 0,$.profileLocation);if(u.length&&await Promise.all(u.map(async({vsix:e,installOptions:n})=>{try{await this.h(e,n,P,s)}catch(r){this.a.error(r),w.push(e.toString())}})),i.length){const e=await this.g(i,s,P);w.push(...e)}}catch(u){throw this.a.error((0,m.localize)(5,null,(0,k.$0)(u))),u}if(w.length)throw new Error((0,m.localize)(6,null,w.join(", ")))}async updateExtensions(g){const d=await this.b.getInstalled(c.ExtensionType.User,g),$=[];for(const i of d)i.identifier.uuid&&$.push({...i.identifier,preRelease:i.preRelease});this.a.trace((0,m.localize)(7,null,$.length));const P=await this.d.getExtensions($,{compatible:!0},O.CancellationToken.None),w=[];for(const i of P)for(const o of d)(0,l.$Cp)(o.identifier,i.identifier)&&(0,D.gt)(i.version,o.manifest.version)&&w.push({extension:i,options:{operation:a.InstallOperation.Update,installPreReleaseVersion:o.preRelease,profileLocation:g}});if(!w.length){this.a.info((0,m.localize)(8,null));return}this.a.info((0,m.localize)(9,null,w.map(i=>i.extension.identifier.id).join(", ")));const u=await this.b.installGalleryExtensions(w);for(const i of u)i.error?this.a.error((0,m.localize)(10,null,i.identifier.id,(0,k.$0)(i.error))):this.a.info((0,m.localize)(11,null,i.identifier.id,i.local?.manifest.version))}async g(g,d,$){if(g=g.filter(({id:i,version:o})=>{const s=d.find(e=>(0,l.$Cp)(e.identifier,{id:i}));if(s){if(!$&&(!o||o==="prerelease"&&s.preRelease))return this.a.info((0,m.localize)(12,null,i,s.manifest.version,i)),!1;if(o&&s.manifest.version===o)return this.a.info((0,m.localize)(13,null,`${i}@${o}`)),!1}return!0}),!g.length)return[];const P=[],w=[],u=await this.j(g);if(await Promise.all(g.map(async({id:i,version:o,installOptions:s})=>{const e=u.get(i.toLowerCase());if(!e){this.a.error(`${f(o?`${i}@${o}`:i)}
${p}`),P.push(i);return}try{const r=await this.d.getManifest(e,O.CancellationToken.None);if(r&&!this.k(r))return}catch(r){this.a.error(r.message||r.stack||r),P.push(i);return}const n=d.find(r=>(0,l.$Cp)(r.identifier,e.identifier));if(n){if(e.version===n.manifest.version){this.a.info((0,m.localize)(14,null,o?`${i}@${o}`:i));return}this.a.info((0,m.localize)(15,null,i,e.version))}s.isBuiltin?this.a.info(o?(0,m.localize)(16,null,i,o):(0,m.localize)(17,null,i)):this.a.info(o?(0,m.localize)(18,null,i,o):(0,m.localize)(19,null,i)),w.push({extension:e,options:{...s,installGivenVersion:!!o}})})),w.length){const i=await this.b.installGalleryExtensions(w);for(const o of i)o.error?(this.a.error((0,m.localize)(20,null,o.identifier.id,(0,k.$0)(o.error))),P.push(o.identifier.id)):this.a.info((0,m.localize)(21,null,o.identifier.id,o.local?.manifest.version))}return P}async h(g,d,$,P){const w=await this.b.getManifest(g);if(!w)throw new Error("Invalid vsix");if(await this.l(w,$,d.profileLocation,P))try{await this.b.install(g,d),this.a.info((0,m.localize)(22,null,(0,I.$$g)(g)))}catch(i){if((0,k.$4)(i))this.a.info((0,m.localize)(23,null,(0,I.$$g)(g)));else throw i}}async j(g){const d=new Map,$=g.some(u=>u.installOptions.installPreReleaseVersion),P=await this.b.getTargetPlatform(),w=[];for(const u of g)a.$2o.test(u.id)&&w.push({...u,preRelease:$});if(w.length){const u=await this.d.getExtensions(w,{targetPlatform:P},O.CancellationToken.None);for(const i of u)d.set(i.identifier.id.toLowerCase(),i)}return d}k(g){return!0}async l(g,d,$,P){if(!d){const w={id:(0,l.$Hp)(g.publisher,g.name)},u=P.find(i=>(0,l.$Cp)(w,i.identifier)&&(0,D.gt)(i.manifest.version,g.version));if(u)return this.a.info((0,m.localize)(24,null,u.identifier.id,u.manifest.version,g.version)),!1}return this.k(g)}async uninstallExtensions(g,d,$){const P=async u=>{if(u instanceof S.URI){const i=await this.b.getManifest(u);return(0,l.$Fp)(i.publisher,i.name)}return u},w=[];for(const u of g){const i=await P(u),s=(await this.b.getInstalled(void 0,$)).filter(e=>(0,l.$Cp)(e.identifier,{id:i}));if(!s.length)throw new Error(`${this.m(i)}
${p}`);if(s.some(e=>e.type===c.ExtensionType.System)){this.a.info((0,m.localize)(25,null,i));return}if(!d&&s.some(e=>e.isBuiltin)){this.a.info((0,m.localize)(26,null,i));return}this.a.info((0,m.localize)(27,null,i));for(const e of s)await this.b.uninstall(e,{profileLocation:$}),w.push(e);this.f?this.a.info((0,m.localize)(28,null,i,this.f)):this.a.info((0,m.localize)(29,null,i))}}async locateExtension(g){const d=await this.b.getInstalled();g.forEach($=>{d.forEach(P=>{if(P.identifier.id===$&&P.location.scheme===v.Schemas.file){this.a.info(P.location.fsPath);return}})})}m(g){return this.f?(0,m.localize)(30,null,g,this.f):(0,m.localize)(31,null,g)}};t.$kq=y,t.$kq=y=we([ne(1,a.$ep),ne(2,a.$bp)],y)}),define(se[149],oe([0,1,5,2,31,27,26,10]),function(Q,t,O,k,v,I,D,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Lq=void 0;class m extends k.$Uc{constructor(l,c,f,p,y,N,g){super(),this.f=l,this.g=c,this.h=f,this.j=p,this.m=y,this.n=N,this.r=g,this.a=this.B(new O.$he),this.onDidChangeExtensionsByAnotherSource=this.a.event,this.b=new Map,this.c=this.B(new k.$4c),this.s().then(null,d=>g.error(d))}async s(){await this.g.initializeDefaultProfileExtensions(),await this.u(this.h.profiles),this.t(),await this.H()}t(){this.B(this.h.onDidChangeProfiles(l=>this.u(l.added))),this.B(this.j.onAddExtensions(l=>this.w(l))),this.B(this.j.onDidAddExtensions(l=>this.y(l))),this.B(this.j.onRemoveExtensions(l=>this.z(l))),this.B(this.j.onDidRemoveExtensions(l=>this.C(l))),this.B(this.n.onDidFilesChange(l=>this.D(l)))}async u(l){try{l.length&&await Promise.all(l.map(c=>(this.c.set(c.id,(0,k.$Rc)(this.n.watch(this.m.extUri.dirname(c.extensionsResource)),this.n.watch(c.extensionsResource))),this.G(c.extensionsResource))))}catch(c){throw this.r.error(c),c}}async w(l){for(const c of l.extensions)this.I(this.L(c.identifier,c.version),l.profileLocation)}async y(l){for(const c of l.extensions){const f=this.L(c.identifier,c.version);l.error?this.J(f,l.profileLocation):this.I(f,l.profileLocation)}}async z(l){for(const c of l.extensions)this.J(this.L(c.identifier,c.version),l.profileLocation)}async C(l){const c=[],f=[];for(const p of l.extensions){const y=this.L(p.identifier,p.version);l.error?this.I(y,l.profileLocation):(this.J(y,l.profileLocation),this.b.has(y)||(this.r.debug("Extension is removed from all profiles",p.identifier.id,p.version),f.push(this.f.scanInstalledExtensionAtLocation(p.location).then(N=>{N?c.push(N):this.r.info("Extension not found at the location",p.location.toString())},N=>this.r.error(N)))))}try{await Promise.all(f),c.length&&await this.H(c)}catch(p){this.r.error(p)}}D(l){for(const c of this.h.profiles)l.contains(c.extensionsResource,S.FileChangeType.UPDATED,S.FileChangeType.ADDED)&&this.F(c.extensionsResource)}async F(l){const c=[],f=[],p=await this.j.scanProfileExtensions(l),y=new Set,N=new Set;for(const[g,d]of this.b)d.has(l)&&N.add(g);for(const g of p){const d=this.L(g.identifier,g.version);y.add(d),N.has(d)||(c.push(g.identifier),this.I(d,l))}for(const g of N)if(!y.has(g)){const d=this.M(g);d&&(f.push(d.identifier),this.J(g,l))}(c.length||f.length)&&this.a.fire({added:c.length?{extensions:c,profileLocation:l}:void 0,removed:f.length?{extensions:f,profileLocation:l}:void 0})}async G(l){const c=await this.j.scanProfileExtensions(l);for(const f of c)this.I(this.L(f.identifier,f.version),l)}async H(l){l||(l=(await this.f.scanAllUserInstalledExtensions()).filter(f=>!this.b.has(this.L(f.identifier,f.manifest.version)))),l.length&&await this.f.markAsUninstalled(...l)}I(l,c){let f=this.b.get(l);f||this.b.set(l,f=new v.$Bc(p=>this.m.extUri.getComparisonKey(p))),f.add(c)}J(l,c){const f=this.b.get(l);f&&f.delete(c),f?.size||this.b.delete(l)}L(l,c){return`${D.$Wm.toKey(l.id)}@${c}`}M(l){const[c,f]=(0,I.$Ep)(l);return f?{identifier:{id:c},version:f}:void 0}}t.$Lq=m}),define(se[150],oe([0,1,178,20,8,2,15,16,25,18,21,27,6,69,12]),function(Q,t,O,k,v,I,D,S,m,a,l,c,f,p,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$2r=void 0;let N=class extends p.$1r{constructor(P,w,u,i){super(u),this.h=P,this.j=i,this.g=this.B(new g(w,i)),this.h.registerParticipant({postInstall:async o=>this.m(o),postUninstall:async o=>this.n(o)})}async getBuiltInExtensionTranslationsUri(P,w){const i=(await this.g.getLanguagePacks())[w];if(!i){this.j.warn(`No language pack found for ${w}`);return}const o=i.translations[P];return o?y.URI.file(o):void 0}async getInstalledLanguages(){const P=await this.g.getLanguagePacks(),w=Object.keys(P).map(u=>{const i=P[u];return{...this.f(u,i.label),extensionId:i.extensions[0].extensionIdentifier.id}});return w.push(this.f("en","English")),w.sort((u,i)=>u.label.localeCompare(i.label)),w}async m(P){P&&P.manifest&&P.manifest.contributes&&P.manifest.contributes.localizations&&P.manifest.contributes.localizations.length&&(this.j.info("Adding language packs from the extension",P.identifier.id),await this.update())}async n(P){const w=await this.g.getLanguagePacks();Object.keys(w).some(u=>w[u]&&w[u].extensions.some(i=>(0,c.$Cp)(i.extensionIdentifier,P.identifier)))&&(this.j.info("Removing language packs from the extension",P.identifier.id),await this.update())}async update(){const[P,w]=await Promise.all([this.g.getLanguagePacks(),this.h.getInstalled()]),u=await this.g.update(w);return!(0,k.$ub)(Object.keys(P),Object.keys(u))}};t.$2r=N,t.$2r=N=we([ne(0,l.$ep),ne(1,a.$Ii),ne(2,l.$bp),ne(3,f.$7j)],N);let g=class extends I.$Uc{constructor(P,w){super(),this.j=w,this.c={},this.f=(0,S.$jc)(P.userDataPath,"languagepacks.json"),this.g=new v.$Hh}getLanguagePacks(){return this.g.size||!this.h?this.s().then(()=>this.c):Promise.resolve(this.c)}update(P){return this.s(w=>{Object.keys(w).forEach(u=>delete w[u]),this.m(w,...P)}).then(()=>this.c)}m(P,...w){for(const u of w)u&&u.manifest&&u.manifest.contributes&&u.manifest.contributes.localizations&&u.manifest.contributes.localizations.length&&this.n(P,u);Object.keys(P).forEach(u=>this.r(P[u]))}n(P,w){const u=w.identifier,i=w.manifest.contributes&&w.manifest.contributes.localizations?w.manifest.contributes.localizations:[];for(const o of i)if(w.location.scheme===D.Schemas.file&&d(o)){let s=P[o.languageId];s||(s={hash:"",extensions:[],translations:{},label:o.localizedLanguageName??o.languageName},P[o.languageId]=s);const e=s.extensions.filter(n=>(0,c.$Cp)(n.extensionIdentifier,u))[0];e?e.version=w.manifest.version:s.extensions.push({extensionIdentifier:u,version:w.manifest.version});for(const n of o.translations)s.translations[n.id]=(0,S.$jc)(w.location.fsPath,n.path)}}r(P){if(P){const w=(0,O.createHash)("md5");for(const u of P.extensions)w.update(u.extensionIdentifier.uuid||u.extensionIdentifier.id).update(u.version);P.hash=w.digest("hex")}}s(P=()=>null){return this.g.queue(()=>{let w=null;return m.Promises.readFile(this.f,"utf8").then(void 0,u=>u.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(u)).then(u=>{try{return JSON.parse(u)}catch{return{}}}).then(u=>(w=P(u),u)).then(u=>{for(const o of Object.keys(u))u[o]||delete u[o];this.c=u,this.h=!0;const i=JSON.stringify(this.c);return this.j.debug("Writing language packs",i),m.Promises.writeFile(this.f,i)}).then(()=>w,u=>this.j.error(u))})}};g=we([ne(0,a.$Ii),ne(1,f.$7j)],g);function d($){if(typeof $.languageId!="string"||!Array.isArray($.translations)||$.translations.length===0)return!1;for(const P of $.translations)if(typeof P.id!="string"||typeof P.path!="string")return!1;return!($.languageName&&typeof $.languageName!="string"||$.localizedLanguageName&&typeof $.localizedLanguageName!="string")}}),define(se[151],oe([0,1,88,9,28,41]),function(Q,t,O,k,v,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$8P=void 0;const D="https://mobile.events.data.microsoft.com/OneCollector/1.0",S="https://mobile.events.data.microsoft.com/ping";async function m(l,c,f){const p=await(0,O.$dE)("@microsoft/1ds-core-js","dist/ms.core.js"),y=await(0,O.$dE)("@microsoft/1ds-post-js","dist/ms.post.js"),N=new p.AppInsightsCore,g=new y.PostChannel,d={instrumentationKey:l,endpointUrl:D,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[g]]};if(f){d.extensionConfig={};const $={alwaysUseXhrOverride:!0,ignoreMc1Ms0CookieProcessing:!0,httpXHROverride:f};d.extensionConfig[g.identifier]=$}return N.initialize(d,[]),N.addTelemetryInitializer($=>{$.ext=$.ext??{},$.ext.web=$.ext.web??{},$.ext.web.consentDetails='{"GPC_DataSharingOptIn":false}',c&&($.ext.utc=$.ext.utc??{},$.ext.utc.flags=8462029)}),N}class a{constructor(c,f,p,y,N){this.e=c,this.f=f,this.g=p,this.h=N,this.c=D,this.d=S,this.g||(this.g={}),typeof y=="function"?this.a=y():this.a=y,this.b=null}i(c){if(this.a){if(typeof this.a!="string"){c(this.a);return}this.b||(this.b=m(this.a,this.e,this.h)),this.b.then(f=>{c(f)},f=>{(0,k.$1)(f),console.error(f)})}}log(c,f){if(!this.a)return;f=(0,v.$_n)(f,this.g),f=(0,I.$xp)(f);const p=this.f+"/"+c;try{this.i(y=>{y.pluginVersionString=f?.properties.version??"Unknown",y.track({name:p,baseData:{name:p,properties:f?.properties,measurements:f?.measurements}})})}catch{}}flush(){return this.a?new Promise(c=>{this.i(f=>{f.unload(!0,()=>{this.a=void 0,c(void 0)})})}):Promise.resolve(void 0)}}t.$8P=a}),define(se[152],oe([0,1,2,28,13,32,113,30,40,153,33,38,19,41]),function(Q,t,O,k,v,I,D,S,m,a,l,c,f,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$8r=void 0;let y=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor(d,$,P){this.k=$,this.l=P,this.d={},this.i=new O.$Tc,this.j=[],this.b=d.appenders,this.c=d.commonProperties??Object.create(null),this.sessionId=this.c.sessionID,this.machineId=this.c["common.machineId"],this.sqmId=this.c["common.sqmId"],this.devDeviceId=this.c["common.devDeviceId"],this.firstSessionDate=this.c["common.firstSessionDate"],this.msftInternal=this.c["common.msftInternal"],this.f=d.piiPaths||[],this.g=f.TelemetryLevel.USAGE,this.h=!!d.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const w of this.f)this.j.push(new RegExp((0,I.$df)(w),"gi")),w.indexOf("\\")>=0&&this.j.push(new RegExp((0,I.$df)(w.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(w=>{(w.affectsConfiguration(f.$cm)||w.affectsConfiguration(f.$em)||w.affectsConfiguration(f.$dm))&&this.m()}))}setExperimentProperty(d,$){this.d[d]=$}m(){let d=(0,p.$wp)(this.k);const $=this.l.enabledTelemetryLevels;if($){this.h=this.sendErrorTelemetry?$.error:!1;const P=$.usage?f.TelemetryLevel.USAGE:$.error?f.TelemetryLevel.ERROR:f.TelemetryLevel.NONE;d=Math.min(d,P)}this.g=d}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}dispose(){this.i.dispose()}n(d,$,P){this.g<$||(P=(0,k.$_n)(P,this.d),P=(0,p.$Bp)(P,this.j),P=(0,k.$_n)(P,this.c),this.b.forEach(w=>w.log(d,P)))}publicLog(d,$){this.n(d,f.TelemetryLevel.USAGE,$)}publicLog2(d,$){this.publicLog(d,$)}publicLogError(d,$){this.h&&this.n(d,f.TelemetryLevel.ERROR,$)}publicLogError2(d,$){this.publicLogError(d,$)}};t.$8r=y,t.$8r=y=we([ne(1,S.$7i),ne(2,l.$nk)],y);function N(){const g=(0,D.localize)(0,null,a.default.nameLong),d=a.default.privacyStatementUrl?(0,D.localize)(2,null,"https://aka.ms/vscode-telemetry",a.default.privacyStatementUrl):(0,D.localize)(1,null,"https://aka.ms/vscode-telemetry"),$=v.$o?"":(0,D.localize)(3,null),P=(0,D.localize)(4,null),w=(0,D.localize)(5,null),u=(0,D.localize)(6,null),i=(0,D.localize)(7,null),o=`
|       | ${P} | ${w} | ${u} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,s=(0,D.localize)(8,null);return`
${g} ${d} ${$}

&nbsp;

${i}
${o}

&nbsp;

${s}
`}c.$jo.as(m.$oo.Configuration).registerConfiguration({id:f.$bm,order:1,type:"object",title:(0,D.localize)(9,null),properties:{[f.$cm]:{type:"string",enum:[f.TelemetryConfiguration.ON,f.TelemetryConfiguration.ERROR,f.TelemetryConfiguration.CRASH,f.TelemetryConfiguration.OFF],enumDescriptions:[(0,D.localize)(10,null),(0,D.localize)(11,null),(0,D.localize)(12,null),(0,D.localize)(13,null)],markdownDescription:N(),default:f.TelemetryConfiguration.ON,restricted:!0,scope:m.ConfigurationScope.APPLICATION,tags:["usesOnlineServices","telemetry"]}}}),c.$jo.as(m.$oo.Configuration).registerConfiguration({id:f.$bm,order:110,type:"object",title:(0,D.localize)(14,null),properties:{[f.$em]:{type:"boolean",markdownDescription:a.default.privacyStatementUrl?(0,D.localize)(16,null,a.default.nameLong,a.default.privacyStatementUrl):(0,D.localize)(15,null,a.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,D.localize)(17,null,`\`#${f.$cm}#\``),scope:m.ConfigurationScope.APPLICATION,tags:["usesOnlineServices","telemetry"]}}})}),define(se[154],oe([0,1,14,22,179,151]),function(Q,t,O,k,v,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$9P=void 0;async function D(l,c){const f=await c.request(l,k.CancellationToken.None),p=(await(0,O.$Ve)(f.stream)).toString(),y=f.res.statusCode??200;return{headers:f.res.headers,statusCode:y,responseData:p}}async function S(l){const c={method:l.type,headers:l.headers};return new Promise((p,y)=>{const N=v.request(l.url??"",c,g=>{g.on("data",function(d){p({headers:g.headers,statusCode:g.statusCode??200,responseData:d.toString()})}),g.on("error",function(d){y(d)})});N.write(l.data,g=>{g&&y(g)}),N.end()})}async function m(l,c,f){const p=typeof c.data=="string"?c.data:new TextDecoder().decode(c.data),y={type:"POST",headers:{...c.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(c.data).toString()},url:c.urlString,data:p};try{const N=l?await D(y,l):await S(y);f(N.statusCode,N.headers,N.responseData)}catch{f(0,{})}}class a extends I.$8P{constructor(c,f,p,y,N){const g={sendPOST:(d,$)=>{m(c,d,$)}};super(f,p,y,N,g)}}t.$9P=a}),define(se[155],oe([0,1,16,25]),function(Q,t,O,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$bfc=v;async function v(I,D){const S=Object.create(null),m=(l,c)=>{const f=JSON.parse(l);S[c]=f};if(D){const l=[],c=await k.Promises.readdir(D);for(const p of c)try{(await k.Promises.stat((0,O.$jc)(D,p))).isDirectory()&&l.push(p)}catch{}const f=[];for(const p of l)(await k.Promises.readdir((0,O.$jc)(D,p))).filter(N=>N==="telemetry.json").length===1&&f.push(p);for(const p of f){const y=(await k.Promises.readFile((0,O.$jc)(D,p,"telemetry.json"))).toString();m(y,p)}}let a=(await k.Promises.readFile((0,O.$jc)(I,"telemetry-core.json"))).toString();return m(a,"vscode-core"),a=(await k.Promises.readFile((0,O.$jc)(I,"telemetry-extensions.json"))).toString(),m(a,"vscode-extensions"),JSON.stringify(S,null,4)}}),define(se[156],oe([0,1,13,89,19]),function(Q,t,O,k,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$xec=I,t.$yec=D,t.$zec=S;async function I(m,a){let l=m.getItem(v.$$l);return(typeof l!="string"||O.$j&&l==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(l=await(0,k.$Kn)(a.error.bind(a))),l}async function D(m,a){let l=m.getItem(v.$_l);return typeof l!="string"&&(l=await(0,k.$Ln)(a.error.bind(a))),l}async function S(m,a){let l=m.getItem(v.$am);return typeof l!="string"&&(l=await(0,k.$Mn)(a.error.bind(a))),l}}),define(se[23],oe([0,1,11]),function(Q,t,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$El=void 0,t.$El=(0,O.$Ai)("IUriIdentityService")}),define(se[157],oe([0,1,23,122,10,17,80,5,2]),function(Q,t,O,k,v,I,D,S,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Is=void 0;class a{static{this._clock=0}constructor(f){this.uri=f,this.time=a._clock++}touch(){return this.time=a._clock++,this}}let l=class{constructor(f){this.g=f,this.c=new m.$Tc,this.f=2**16;const p=new Map,y=N=>{let g=p.get(N.scheme);return g===void 0&&(g=f.hasProvider(N)&&!this.g.hasCapability(N,v.FileSystemProviderCapabilities.PathCaseSensitive),p.set(N.scheme,g)),g};this.c.add(S.Event.any(f.onDidChangeFileSystemProviderRegistrations,f.onDidChangeFileSystemProviderCapabilities)(N=>{p.delete(N.scheme)})),this.extUri=new I.$3g(y),this.d=new D.$Hs((N,g)=>this.extUri.compare(N,g,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(f){this.g.hasProvider(f)&&(f=(0,I.$ch)(f));const p=this.d.get(f);return p?p.touch().uri.with({fragment:f.fragment}):(this.d.set(f,new a(f)),this.h(),f)}h(){if(this.d.size<this.f)return;const f=[...this.d.entries()].sort((y,N)=>y[1].time<N[1].time?1:y[1].time>N[1].time?-1:0);a._clock=0,this.d.clear();const p=this.f*.5;for(let y=0;y<p;y++)this.d.set(f[y][0],f[y][1].touch())}};t.$Is=l,t.$Is=l=we([ne(0,v.$7k)],l),(0,k.$Fs)(O.$El,l,k.InstantiationType.Delayed)}),define(se[158],oe([0,1,5,2,10,48,31]),function(Q,t,O,k,v,I,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Xec=void 0;class S extends k.$Uc{constructor(a,l,c,f,p,y){super(),this.f=a,this.g=l,this.h=c,this.j=f,this.m=p,this.n=y,this.capabilities=this.g.capabilities,this.onDidChangeCapabilities=this.g.onDidChangeCapabilities,this.a=this.B(new O.$he),this.onDidChangeFile=this.a.event,this.b=I.$Gi.forUris(()=>!(this.capabilities&v.FileSystemProviderCapabilities.PathCaseSensitive)),this.c=new D.$Bc(N=>this.m.extUri.getComparisonKey(this.t(N))),this.r(),this.B(f.onDidChangeProfiles(()=>this.r())),this.B(this.g.onDidChangeFile(N=>this.s(N)))}r(){this.c.clear();for(const a of this.j.profiles)this.c.add(a.settingsResource),this.c.add(a.keybindingsResource),this.c.add(a.tasksResource),this.c.add(a.extensionsResource)}open(a,l){return this.g.open(this.t(a),l)}close(a){return this.g.close(a)}read(a,l,c,f,p){return this.g.read(a,l,c,f,p)}write(a,l,c,f,p){return this.g.write(a,l,c,f,p)}watch(a,l){this.b.set(a,a);const c=this.g.watch(this.t(a),l);return(0,k.$Sc)(()=>{this.b.delete(a),c.dispose()})}stat(a){return this.g.stat(this.t(a))}mkdir(a){return this.g.mkdir(this.t(a))}rename(a,l,c){return this.g.rename(this.t(a),this.t(l),c)}readFile(a,l){return this.g.readFile(this.t(a),l)}readFileStream(a,l,c){return this.g.readFileStream(this.t(a),l,c)}readdir(a){return this.g.readdir(this.t(a))}enforceAtomicReadFile(a){return this.c.has(a)}writeFile(a,l,c){return this.g.writeFile(this.t(a),l,c)}enforceAtomicWriteFile(a){return this.c.has(a)?{postfix:".vsctmp"}:!1}delete(a,l){return this.g.delete(this.t(a),l)}copy(a,l,c){if((0,v.$$k)(this.g))return this.g.copy(this.t(a),this.t(l),c);throw new Error("copy not supported")}cloneFile(a,l){if((0,v.$_k)(this.g))return this.g.cloneFile(this.t(a),this.t(l));throw new Error("clone not supported")}s(a){const l=[];for(const c of a){if(c.resource.scheme!==this.f)continue;const f=this.u(c.resource);this.b.findSubstr(f)&&l.push({resource:f,type:c.type,cId:c.cId})}l.length&&(this.n.debug("User data changed"),this.a.fire(l))}t(a){return a.with({scheme:this.f})}u(a){return a.with({scheme:this.h})}}t.$Xec=S}),define(se[159],oe([0,1,115,16,48,17,12,11,15]),function(Q,t,O,k,v,I,D,S,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$3i=t.$Zi=t.$Yi=t.$Xi=t.$Wi=t.$Ui=t.$Ti=t.WorkbenchState=t.$Ni=t.$Mi=t.$Ji=void 0,t.$Ki=a,t.$Li=l,t.$Oi=c,t.$Pi=f,t.$Qi=p,t.$Ri=N,t.$Si=g,t.$Vi=P,t.$1i=w,t.$2i=u,t.$4i=i,t.$5i=o,t.$6i=s,t.$Ji=(0,S.$Ai)("contextService");function a(e){const n=e;return typeof n?.id=="string"&&D.URI.isUri(n.uri)}function l(e){return typeof e?.id=="string"&&!a(e)&&!f(e)}t.$Mi={id:"ext-dev"},t.$Ni={id:"empty-window"};function c(e,n){if(typeof e=="string"||typeof e>"u")return typeof e=="string"?{id:(0,k.$nc)(e)}:n?t.$Mi:t.$Ni;const r=e;return r.configuration?{id:r.id,configPath:r.configuration}:r.folders.length===1?{id:r.id,uri:r.folders[0].uri}:{id:r.id}}function f(e){const n=e;return typeof n?.id=="string"&&D.URI.isUri(n.configPath)}function p(e){const n=e;if(n?.uri)return{id:n.id,uri:D.URI.revive(n.uri)};const r=e;if(r?.configPath)return{id:r.id,configPath:D.URI.revive(r.configPath)};if(e?.id)return{id:e.id}}var y;(function(e){e[e.EMPTY=1]="EMPTY",e[e.FOLDER=2]="FOLDER",e[e.WORKSPACE=3]="WORKSPACE"})(y||(t.WorkbenchState=y={}));function N(e){const n=e;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&Array.isArray(n.folders))}function g(e){const n=e;return!!(n&&typeof n=="object"&&D.URI.isUri(n.uri)&&typeof n.name=="string"&&typeof n.toResource=="function")}class d{constructor(n,r,h,E,R){this.h=n,this.j=h,this.k=E,this.l=R,this.c=v.$Gi.forUris(this.l,()=>!0),this.folders=r}update(n){this.h=n.id,this.k=n.configuration,this.j=n.transient,this.l=n.l,this.folders=n.folders}get folders(){return this.g}set folders(n){this.g=n,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(n){this.k=n}getFolder(n){return n&&this.c.findSubstr(n)||null}n(){this.c=v.$Gi.forUris(this.l,()=>!0);for(const n of this.folders)this.c.set(n.uri,n)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}t.$Ti=d;class ${constructor(n,r){this.raw=r,this.uri=n.uri,this.index=n.index,this.name=n.name}toResource(n){return(0,I.$bh)(this.uri,n)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}t.$Ui=$;function P(e){return new $({uri:e,index:0,name:(0,I.$0g)(e)},{uri:e.toString()})}t.$Wi="code-workspace",t.$Xi=`.${t.$Wi}`,t.$Yi=[{name:(0,O.localize)(0,null),extensions:[t.$Wi]}],t.$Zi="workspace.json";function w(e,n){return I.$5g.isEqualOrParent(e,n.untitledWorkspacesHome)}function u(e){let n;return D.URI.isUri(e)?n=e:n=e.configuration,n?.scheme===m.Schemas.tmp}t.$3i="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function i(e){return e.id===t.$3i}function o(e,n){return!w(e,n)&&!u(e)}function s(e){return(typeof e=="string"?(0,k.$oc)(e):(0,I.$_g)(e))===t.$Xi}}),define(se[24],oe([0,1,43,5,2,17,12,114,18,10,11,6,159,31,23,8,29,32,3]),function(Q,t,O,k,v,I,D,S,m,a,l,c,f,p,y,N,g,d,$){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Kl=t.$Jl=t.$Gl=t.ProfileResourceType=void 0,t.$Fl=w,t.$Hl=u,t.$Il=i;var P;(function(e){e.Settings="settings",e.Keybindings="keybindings",e.Snippets="snippets",e.Tasks="tasks",e.Extensions="extensions",e.GlobalState="globalState"})(P||(t.ProfileResourceType=P={}));function w(e){const n=e;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&typeof n.isDefault=="boolean"&&typeof n.name=="string"&&D.URI.isUri(n.location)&&D.URI.isUri(n.globalStorageHome)&&D.URI.isUri(n.settingsResource)&&D.URI.isUri(n.keybindingsResource)&&D.URI.isUri(n.tasksResource)&&D.URI.isUri(n.snippetsHome)&&D.URI.isUri(n.extensionsResource))}t.$Gl=(0,l.$Ai)("IUserDataProfilesService");function u(e,n){return{id:e.id,isDefault:e.isDefault,name:e.name,shortName:e.shortName,icon:e.icon,location:D.URI.revive(e.location).with({scheme:n}),globalStorageHome:D.URI.revive(e.globalStorageHome).with({scheme:n}),settingsResource:D.URI.revive(e.settingsResource).with({scheme:n}),keybindingsResource:D.URI.revive(e.keybindingsResource).with({scheme:n}),tasksResource:D.URI.revive(e.tasksResource).with({scheme:n}),snippetsHome:D.URI.revive(e.snippetsHome).with({scheme:n}),extensionsResource:D.URI.revive(e.extensionsResource).with({scheme:n}),cacheHome:D.URI.revive(e.cacheHome).with({scheme:n}),useDefaultFlags:e.useDefaultFlags,isTransient:e.isTransient}}function i(e,n,r,h,E,R){return{id:e,name:n,location:r,isDefault:!1,shortName:E?.shortName,icon:E?.icon,globalStorageHome:R&&E?.useDefaultFlags?.globalState?R.globalStorageHome:(0,I.$bh)(r,"globalStorage"),settingsResource:R&&E?.useDefaultFlags?.settings?R.settingsResource:(0,I.$bh)(r,"settings.json"),keybindingsResource:R&&E?.useDefaultFlags?.keybindings?R.keybindingsResource:(0,I.$bh)(r,"keybindings.json"),tasksResource:R&&E?.useDefaultFlags?.tasks?R.tasksResource:(0,I.$bh)(r,"tasks.json"),snippetsHome:R&&E?.useDefaultFlags?.snippets?R.snippetsHome:(0,I.$bh)(r,"snippets"),extensionsResource:R&&E?.useDefaultFlags?.extensions?R.extensionsResource:(0,I.$bh)(r,"extensions.json"),cacheHome:(0,I.$bh)(h,e),useDefaultFlags:E?.useDefaultFlags,isTransient:E?.transient}}let o=class extends v.$Uc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(n,r,h,E){super(),this.t=n,this.u=r,this.w=h,this.y=E,this.f=!0,this.h=this.B(new k.$he),this.onDidChangeProfiles=this.h.event,this.j=this.B(new k.$he),this.onWillCreateProfile=this.j.event,this.m=this.B(new k.$he),this.onWillRemoveProfile=this.m.event,this.n=this.B(new k.$he),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],workspaces:new p.$Ac,emptyWindows:new Map},this.profilesHome=(0,I.$bh)(this.t.userRoamingDataHome,"profiles"),this.g=(0,I.$bh)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(n){this.f!==n&&(this.z=void 0,this.f=n)}isEnabled(){return this.f}get C(){if(!this.z){const n=this.D(),r=[n];if(this.f)try{for(const R of this.O()){if(!R.name||!(0,$.$ag)(R.name)||!R.location){this.y.warn("Skipping the invalid stored profile",R.location||R.name);continue}r.push(i((0,I.$$g)(R.location),R.name,R.location,this.g,{shortName:R.shortName,icon:R.icon,useDefaultFlags:R.useDefaultFlags},n))}}catch(R){this.y.error(R)}const h=new p.$Ac,E=new Map;if(r.length)try{const R=this.Q();if(R.workspaces)for(const[A,T]of Object.entries(R.workspaces)){const C=D.URI.parse(A),M=r.find(J=>J.id===T);M&&h.set(C,M)}if(R.emptyWindows)for(const[A,T]of Object.entries(R.emptyWindows)){const C=r.find(M=>M.id===T);C&&E.set(A,C)}}catch(R){this.y.error(R)}this.z={profiles:r,workspaces:h,emptyWindows:E}}return this.z}D(){const n=i("__default__profile__",(0,S.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...n,extensionsResource:this.S()??n.extensionsResource,isDefault:!0}}async createTransientProfile(n){const r="Temp",h=new RegExp(`${(0,d.$df)(r)}\\s(\\d+)`);let E=0;for(const A of this.profiles){const T=h.exec(A.name),C=T?parseInt(T[1]):0;E=C>E?C:E}const R=`${r} ${E+1}`;return this.createProfile((0,O.$oj)((0,g.$Wg)()).toString(16),R,{transient:!0},n)}async createNamedProfile(n,r,h){return this.createProfile((0,O.$oj)((0,g.$Wg)()).toString(16),n,r,h)}async createProfile(n,r,h,E){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const R=await this.F(n,r,h);return E&&await this.setProfileForWorkspace(E,R),R}async F(n,r,h){if(!(0,$.$ag)(r)||!r)throw new Error("Name of the profile is mandatory and must be of type `string`");let E=this.r.get(r);return E||(E=(async()=>{try{if(this.profiles.find(C=>C.name===r||C.id===n))throw new Error(`Profile with ${r} name already exists`);const A=i(n,r,(0,I.$bh)(this.profilesHome,n),this.g,h,this.defaultProfile);await this.u.createFolder(A.location);const T=[];return this.j.fire({profile:A,join(C){T.push(C)}}),await N.Promises.settled(T),this.I([A],[],[]),A}finally{this.r.delete(r)}})(),this.r.set(r,E)),E}async updateProfile(n,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let h=this.profiles.find(E=>E.id===n.id);if(!h)throw new Error(`Profile '${n.name}' does not exist`);return h=i(h.id,r.name??h.name,h.location,this.g,{shortName:r.shortName??h.shortName,icon:r.icon===null?void 0:r.icon??h.icon,transient:r.transient??h.isTransient,useDefaultFlags:r.useDefaultFlags??h.useDefaultFlags},this.defaultProfile),this.I([],[],[h]),h}async removeProfile(n){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(n.isDefault)throw new Error("Cannot remove default profile");const r=this.profiles.find(E=>E.id===n.id);if(!r)throw new Error(`Profile '${n.name}' does not exist`);const h=[];this.m.fire({profile:r,join(E){h.push(E)}});try{await Promise.allSettled(h)}catch(E){this.y.error(E)}for(const E of[...this.C.emptyWindows.keys()])r.id===this.C.emptyWindows.get(E)?.id&&this.C.emptyWindows.delete(E);for(const E of[...this.C.workspaces.keys()])r.id===this.C.workspaces.get(E)?.id&&this.C.workspaces.delete(E);this.M(),this.I([],[r],[]);try{await this.u.del(r.cacheHome,{recursive:!0})}catch(E){(0,a.$ll)(E)!==a.FileOperationResult.FILE_NOT_FOUND&&this.y.error(E)}}async setProfileForWorkspace(n,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const h=this.profiles.find(E=>E.id===r.id);if(!h)throw new Error(`Profile '${r.name}' does not exist`);this.L(n,h)}unsetWorkspace(n,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(n,void 0,r)}async resetWorkspaces(){this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const n=await this.u.resolve(this.profilesHome);await Promise.all((n.children||[]).filter(r=>r.isDirectory&&this.profiles.every(h=>!this.w.extUri.isEqual(h.location,r.resource))).map(r=>this.u.del(r.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const n=this.s.profiles.filter(r=>!this.H(r));await Promise.allSettled(n.map(r=>this.removeProfile(r)))}getProfileForWorkspace(n){const r=this.G(n);return D.URI.isUri(r)?this.s.workspaces.get(r)??this.C.workspaces.get(r):this.s.emptyWindows.get(r)??this.C.emptyWindows.get(r)}G(n){return(0,f.$Ki)(n)?n.uri:(0,f.$Pi)(n)?n.configPath:n.id}H(n){return!!([...this.s.emptyWindows.values()].some(r=>this.w.extUri.isEqual(r.location,n.location))||[...this.s.workspaces.values()].some(r=>this.w.extUri.isEqual(r.location,n.location))||[...this.C.emptyWindows.values()].some(r=>this.w.extUri.isEqual(r.location,n.location))||[...this.C.workspaces.values()].some(r=>this.w.extUri.isEqual(r.location,n.location)))}I(n,r,h){const E=[...this.profiles,...n],R=[];this.s.profiles=[];for(let A of E)A.isDefault||r.some(T=>A.id===T.id)||(A=h.find(T=>A.id===T.id)??A,A.isTransient?this.s.profiles.push(A):R.push({location:A.location,name:A.name,shortName:A.shortName,icon:A.icon,useDefaultFlags:A.useDefaultFlags}));this.P(R),this.z=void 0,this.J(n,r,h)}J(n,r,h){this.h.fire({added:n,removed:r,updated:h,all:this.profiles})}L(n,r,h){h=r?.isTransient?!0:h,h||this.L(n,void 0,!0);const E=this.G(n),R=h?this.s:this.C;D.URI.isUri(E)?(R.workspaces.delete(E),r&&R.workspaces.set(E,r)):(R.emptyWindows.delete(E),r&&R.emptyWindows.set(E,r)),h||this.M()}M(){const n={};for(const[h,E]of this.C.workspaces.entries())n[h.toString()]=E.id;const r={};for(const[h,E]of this.C.emptyWindows.entries())r[h.toString()]=E.id;this.R({workspaces:n,emptyWindows:r}),this.z=void 0}N(n){const r={},h=this.D();if(n.workspaces)for(const[R,A]of Object.entries(n.workspaces)){const T=D.URI.parse(A);r[R]=this.w.extUri.isEqual(T,h.location)?h.id:this.w.extUri.basename(T)}const E={};if(n.emptyWindows)for(const[R,A]of Object.entries(n.emptyWindows)){const T=D.URI.parse(A);E[R]=this.w.extUri.isEqual(T,h.location)?h.id:this.w.extUri.basename(T)}return{workspaces:r,emptyWindows:E}}O(){return[]}P(n){throw new Error("not implemented")}Q(){return{}}R(n){throw new Error("not implemented")}S(){}};t.$Jl=o,t.$Jl=o=we([ne(0,m.$Hi),ne(1,a.$7k),ne(2,y.$El),ne(3,c.$7j)],o);class s extends o{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(n){this.a=n}Q(){return this.X}R(n){this.X=n}}t.$Kl=s}),define(se[53],oe([0,1,20,8,22,9,5,2,13,3,12,98,21,27,26,6,33,19,23,24]),function(Q,t,O,k,v,I,D,S,m,a,l,c,f,p,y,N,g,d,$,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$vq=t.$tq=void 0,t.$uq=u;let w=class extends S.$Uc{get onInstallExtension(){return this.n.event}get onDidInstallExtensions(){return this.s.event}get onUninstallExtension(){return this.t.event}get onDidUninstallExtension(){return this.u.event}get onDidUpdateExtensionMetadata(){return this.w.event}constructor(e,n,r,h,E,R){super(),this.z=e,this.C=n,this.D=r,this.F=h,this.G=E,this.H=R,this.h=0,this.j=new Map,this.m=new Map,this.n=this.B(new D.$he),this.s=this.B(new D.$he),this.t=this.B(new D.$he),this.u=this.B(new D.$he),this.w=this.B(new D.$he),this.y=[],this.B((0,S.$Sc)(()=>{this.j.forEach(({task:A})=>A.cancel()),this.m.forEach(A=>A.cancel()),this.j.clear(),this.m.clear()}))}async canInstall(e){const n=await this.getTargetPlatform();return e.allTargetPlatforms.some(r=>(0,f.$_o)(r,e.allTargetPlatforms,n))}async installFromGallery(e,n={}){try{const h=(await this.installGalleryExtensions([{extension:e,options:n}])).find(({identifier:E})=>(0,p.$Cp)(E,e.identifier));if(h?.local)return h?.local;throw h?.error?h.error:new f.$dp(`Unknown error while installing extension ${e.identifier.id}`,f.ExtensionManagementErrorCode.Unknown)}catch(r){throw u(r)}}async installGalleryExtensions(e){if(!this.z.isEnabled())throw new f.$dp(c.localize(0,null),f.ExtensionManagementErrorCode.NotAllowed);const n=[],r=[];return await Promise.allSettled(e.map(async({extension:h,options:E})=>{try{const R=await this.N(h,!!E?.installGivenVersion,!!E?.installPreReleaseVersion,E.productVersion??{version:this.G.version,date:this.G.date});r.push({...R,options:E})}catch(R){n.push({identifier:h.identifier,operation:f.InstallOperation.Install,source:h,error:R})}})),r.length&&n.push(...await this.I(r)),n}async uninstall(e,n={}){return this.F.trace("ExtensionManagementService#uninstall",e.identifier.id),this.P(e,n)}async toggleAppliationScope(e,n){if((0,y.$Zm)(e.manifest)||e.isBuiltin)return e;if(e.isApplicationScoped){let r=await this.updateMetadata(e,{isApplicationScoped:!1},this.H.defaultProfile.extensionsResource);this.D.extUri.isEqual(n,this.H.defaultProfile.extensionsResource)||(r=await this.$(e,this.H.defaultProfile.extensionsResource,n));for(const h of this.H.profiles){const E=(await this.getInstalled(y.ExtensionType.User,h.extensionsResource)).find(R=>(0,p.$Cp)(R.identifier,e.identifier));E?this.w.fire(E):this.u.fire({identifier:e.identifier,profileLocation:h.extensionsResource})}return r}else{const r=this.D.extUri.isEqual(n,this.H.defaultProfile.extensionsResource)?await this.updateMetadata(e,{isApplicationScoped:!0},this.H.defaultProfile.extensionsResource):await this.$(e,n,this.H.defaultProfile.extensionsResource,{isApplicationScoped:!0});return this.s.fire([{identifier:r.identifier,operation:f.InstallOperation.Install,local:r,profileLocation:this.H.defaultProfile.extensionsResource,applicationScoped:!0}]),r}}getExtensionsControlManifest(){const e=new Date().getTime();return(!this.g||e-this.h>1e3*60*5)&&(this.g=this.W(),this.h=e),this.g}registerParticipant(e){this.y.push(e)}async I(e){const n=new Map,r=new Map,h=[],E=(A,T)=>`${p.$Dp.create(A).toString()}-${T.toString()}`,R=(A,T,C,M)=>{const J=this.Y(A,T,C),ae=`${(0,p.$Hp)(A.publisher,A.name)}-${C.profileLocation.toString()}`;r.set(ae,{task:J,root:M}),this.n.fire({identifier:J.identifier,source:T,profileLocation:C.profileLocation}),this.F.info("Installing extension:",J.identifier.id,C.profileLocation.toString()),l.URI.isUri(T)||this.j.set(E(T,C.profileLocation),{task:J,waitingTasks:[]})};try{for(const{manifest:A,extension:T,options:C}of e){const M=C.isApplicationScoped||C.isBuiltin||(0,y.$Zm)(A),J={...C,installOnlyNewlyAddedFromExtensionPack:C.installOnlyNewlyAddedFromExtensionPack??!l.URI.isUri(T),isApplicationScoped:M,profileLocation:M?this.H.defaultProfile.extensionsResource:C.profileLocation??this.X(),productVersion:C.productVersion??{version:this.G.version,date:this.G.date}},ae=l.URI.isUri(T)?void 0:this.j.get(E(T,J.profileLocation));ae?(this.F.info("Extension is already requested to install",ae.task.identifier.id,J.profileLocation.toString()),h.push(ae.task.waitUntilTaskIsFinished())):R(A,T,J,void 0)}return await Promise.all([...r.values()].map(async({task:A})=>{if(A.options.donotIncludePackAndDependencies)this.F.info("Installing the extension without checking dependencies and pack",A.identifier.id);else try{const T=await this.M(A.identifier,A.manifest,!!A.options.installOnlyNewlyAddedFromExtensionPack,!!A.options.installPreReleaseVersion,A.options.profileLocation,A.options.productVersion),C=await this.getInstalled(void 0,A.options.profileLocation,A.options.productVersion),M={...A.options,context:{...A.options.context,[f.$6o]:!0}};for(const{gallery:J,manifest:ae}of(0,O.$Mb)(T,({gallery:ie})=>ie.identifier.id)){if(r.has(`${J.identifier.id.toLowerCase()}-${M.profileLocation.toString()}`))continue;const ie=this.j.get(E(J,M.profileLocation));if(ie){if(this.J(A,ie.task)){const ce=ie.task.identifier;this.F.info("Waiting for already requested installing extension",ce.id,A.identifier.id,M.profileLocation.toString()),ie.waitingTasks.push(A),h.push(D.Event.toPromise(D.Event.filter(this.onDidInstallExtensions,ue=>ue.some(le=>(0,p.$Cp)(le.identifier,ce)))).then(ue=>{if(this.F.info("Finished waiting for already requested installing extension",ce.id,A.identifier.id,M.profileLocation.toString()),!ue.find(x=>(0,p.$Cp)(x.identifier,ce))?.local)throw new Error(`Extension ${ce.id} is not installed`)}))}}else C.some(({identifier:ce})=>(0,p.$Cp)(ce,J.identifier))||R(ae,J,M,A)}}catch(T){if(l.URI.isUri(A.source))(0,O.$Lb)(A.manifest.extensionDependencies)&&this.F.warn("Cannot install dependencies of extension:",A.identifier.id,T.message),(0,O.$Lb)(A.manifest.extensionPack)&&this.F.warn("Cannot install packed extensions of extension:",A.identifier.id,T.message);else throw this.F.error("Error while preparing to install dependencies and extension packs of the extension:",A.identifier.id),T}})),await this.L([...r.entries()].map(async([A,{task:T}])=>{const C=new Date().getTime();let M;try{M=await T.run(),await this.L(this.y.map(J=>J.postInstall(M,T.source,T.options,v.CancellationToken.None)),f.ExtensionManagementErrorCode.PostInstall)}catch(J){const ae=u(J);throw l.URI.isUri(T.source)||i(this.C,T.operation===f.InstallOperation.Update?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,p.$Kp)(T.source),error:ae,source:T.options.context?.[f.$5o]}),n.set(A,{error:ae,identifier:T.identifier,operation:T.operation,source:T.source,context:T.options.context,profileLocation:T.options.profileLocation,applicationScoped:T.options.isApplicationScoped}),this.F.error("Error while installing the extension",T.identifier.id,(0,I.$0)(ae),T.options.profileLocation.toString()),ae}if(!l.URI.isUri(T.source)){const J=T.operation===f.InstallOperation.Update,ae=J?void 0:(new Date().getTime()-T.source.lastUpdated)/1e3;if(i(this.C,J?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,p.$Kp)(T.source),verificationStatus:T.verificationStatus,duration:new Date().getTime()-C,durationSinceUpdate:ae,source:T.options.context?.[f.$5o]}),m.$o&&T.operation!==f.InstallOperation.Update)try{await this.z.reportStatistic(M.manifest.publisher,M.manifest.name,M.manifest.version,f.StatisticType.Install)}catch{}}n.set(A,{local:M,identifier:T.identifier,operation:T.operation,source:T.source,context:T.options.context,profileLocation:T.options.profileLocation,applicationScoped:M.isApplicationScoped})})),h.length&&await this.L(h),[...n.values()]}catch(A){const T=(J,ae,ie)=>{const ce=[];J.manifest.extensionDependencies?.length&&ce.push(...J.manifest.extensionDependencies),J.manifest.extensionPack?.length&&ce.push(...J.manifest.extensionPack);for(const ue of ce){if(ie.includes(ue.toLowerCase()))continue;ie.push(ue.toLowerCase());const le=n.get(`${ue.toLowerCase()}-${ae.toString()}`);le?.local&&(ie=T(le.local,ae,ie))}return ie},C=J=>({identifier:J.identifier,operation:f.InstallOperation.Install,source:J.source,context:J.options.context,profileLocation:J.options.profileLocation,error:A}),M=[];for(const[J,{task:ae,root:ie}]of r){const ce=n.get(J);ce?ce.local&&ie&&!n.get(`${ie.identifier.id.toLowerCase()}-${ae.options.profileLocation.toString()}`)?.local&&(M.push(this.Z(ce.local,{versionOnly:!0,profileLocation:ae.options.profileLocation})),n.set(J,C(ae))):(ae.cancel(),n.set(J,C(ae)))}for(const[J,{task:ae}]of r){const ie=n.get(J);if(!ie?.local||ae.options.donotIncludePackAndDependencies)continue;T(ie.local,ae.options.profileLocation,[ie.local.identifier.id.toLowerCase()]).slice(1).some(ue=>r.has(`${ue.toLowerCase()}-${ae.options.profileLocation.toString()}`)&&!n.get(`${ue.toLowerCase()}-${ae.options.profileLocation.toString()}`)?.local)&&(M.push(this.Z(ie.local,{versionOnly:!0,profileLocation:ae.options.profileLocation})),n.set(J,C(ae)))}throw M.length&&await Promise.allSettled(M.map(async J=>{try{await J.run(),this.F.info("Rollback: Uninstalled extension",J.extension.identifier.id)}catch(ae){this.F.warn("Rollback: Error while uninstalling extension",J.extension.identifier.id,(0,I.$0)(ae))}})),A}finally{for(const{task:A}of r.values())A.source&&!l.URI.isUri(A.source)&&this.j.delete(E(A.source,A.options.profileLocation));if(n.size){const A=[...n.values()];for(const T of A)T.local&&this.F.info("Extension installed successfully:",T.identifier.id,T.profileLocation.toString());this.s.fire(A)}}}J(e,n){for(const[,{task:r,waitingTasks:h}]of this.j.entries())if(r===e&&(h.includes(n)||h.some(E=>this.J(E,n)))||r===n&&h[0]&&!this.J(e,h[0]))return!1;return!0}async L(e,n){const r=[],h=[],E=await Promise.allSettled(e);for(const A of E)A.status==="fulfilled"?r.push(A.value):h.push(u(A.reason,n));if(!h.length)return r;if(h.length===1)throw h[0];let R=new f.$dp("",f.ExtensionManagementErrorCode.Unknown);for(const A of h)R=new f.$dp(R.message?`${R.message}, ${A.message}`:A.message,A.code!==f.ExtensionManagementErrorCode.Unknown&&A.code!==f.ExtensionManagementErrorCode.Internal?A.code:R.code);throw R}async M(e,n,r,h,E,R){if(!this.z.isEnabled())return[];const A=await this.getInstalled(void 0,E,R),T=[],C=[],M=async(J,ae)=>{T.push(J);const ie=ae.extensionDependencies||[],ce=[...ie];if(ae.extensionPack){const ue=r?A.find(le=>(0,p.$Cp)(le.identifier,J)):void 0;for(const le of ae.extensionPack)ue&&ue.manifest.extensionPack&&ue.manifest.extensionPack.some(x=>(0,p.$Cp)({id:x},{id:le}))||ce.every(x=>!(0,p.$Cp)({id:x},{id:le}))&&ce.push(le)}if(ce.length){const ue=ce.filter(le=>T.every(x=>!(0,p.$Cp)(x,{id:le})));if(ue.length){const le=await this.z.getExtensions(ue.map(x=>({id:x,preRelease:h})),v.CancellationToken.None);for(const x of le){if(T.find(U=>(0,p.$Cp)(U,x.identifier)))continue;const _=ie.some(U=>(0,p.$Cp)({id:U},x.identifier));let B;try{B=await this.N(x,!1,h,R)}catch(U){if(_)throw U;this.F.info("Skipping the packed extension as it cannot be installed",x.identifier.id,(0,I.$0)(U));continue}C.push({gallery:B.extension,manifest:B.manifest}),await M(B.extension.identifier,B.manifest)}}}};return await M(e,n),C}async N(e,n,r,h){let E;const R=await this.getExtensionsControlManifest();if(R.malicious.some(C=>(0,p.$Cp)(e.identifier,C)))throw new f.$dp(c.localize(1,null,e.identifier.id),f.ExtensionManagementErrorCode.Malicious);const A=R.deprecated[e.identifier.id.toLowerCase()];if(A?.extension?.autoMigrate){if(this.F.info(`The '${e.identifier.id}' extension is deprecated, fetching the compatible '${A.extension.id}' extension instead.`),E=(await this.z.getExtensions([{id:A.extension.id,preRelease:A.extension.preRelease}],{targetPlatform:await this.getTargetPlatform(),compatible:!0,productVersion:h},v.CancellationToken.None))[0],!E)throw new f.$dp(c.localize(2,null,e.identifier.id,A.extension.id),f.ExtensionManagementErrorCode.Deprecated)}else{if(!await this.canInstall(e)){const C=await this.getTargetPlatform();throw new f.$dp(c.localize(3,null,e.identifier.id,this.G.nameLong,(0,f.$8o)(C)),f.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}if(E=await this.O(e,n,r,h),!E)throw!r&&e.properties.isPreReleaseVersion&&(await this.z.getExtensions([e.identifier],v.CancellationToken.None))[0]?new f.$dp(c.localize(4,null,e.displayName??e.identifier.id),f.ExtensionManagementErrorCode.ReleaseVersionNotFound):new f.$dp(c.localize(5,null,e.identifier.id,this.G.nameLong,this.G.version),f.ExtensionManagementErrorCode.Incompatible)}this.F.info("Getting Manifest...",E.identifier.id);const T=await this.z.getManifest(E,v.CancellationToken.None);if(T===null)throw new f.$dp(`Missing manifest for extension ${E.identifier.id}`,f.ExtensionManagementErrorCode.Invalid);if(T.version!==E.version)throw new f.$dp(`Cannot install '${E.identifier.id}' extension because of version mismatch in Marketplace`,f.ExtensionManagementErrorCode.Invalid);return{extension:E,manifest:T}}async O(e,n,r,h){const E=await this.getTargetPlatform();let R=null;return!n&&e.hasPreReleaseVersion&&e.properties.isPreReleaseVersion!==r&&(R=(await this.z.getExtensions([{...e.identifier,preRelease:r}],{targetPlatform:E,compatible:!0,productVersion:h},v.CancellationToken.None))[0]||null),!R&&await this.z.isExtensionCompatible(e,r,E,h)&&(R=e),R||(n?R=(await this.z.getExtensions([{...e.identifier,version:e.version}],{targetPlatform:E,compatible:!0,productVersion:h},v.CancellationToken.None))[0]||null:R=await this.z.getCompatibleExtension(e,r,E,h)),R}async P(e,n){const r={...n,profileLocation:e.isApplicationScoped?this.H.defaultProfile.extensionsResource:n.profileLocation??this.X()},h=M=>`${M.id.toLowerCase()}${r.versionOnly?`-${e.manifest.version}`:""}${r.profileLocation?`@${r.profileLocation.toString()}`:""}`,E=this.m.get(h(e.identifier));if(E)return this.F.info("Extensions is already requested to uninstall",e.identifier.id),E.waitUntilTaskIsFinished();const R=M=>{const J=this.Z(M,r);return this.m.set(h(J.extension.identifier),J),r.profileLocation?this.F.info("Uninstalling extension from the profile:",`${M.identifier.id}@${M.manifest.version}`,r.profileLocation.toString()):this.F.info("Uninstalling extension:",`${M.identifier.id}@${M.manifest.version}`),this.t.fire({identifier:M.identifier,profileLocation:r.profileLocation,applicationScoped:M.isApplicationScoped}),J},A=(M,J)=>{J?r.profileLocation?this.F.error("Failed to uninstall extension from the profile:",`${M.identifier.id}@${M.manifest.version}`,r.profileLocation.toString(),J.message):this.F.error("Failed to uninstall extension:",`${M.identifier.id}@${M.manifest.version}`,J.message):r.profileLocation?this.F.info("Successfully uninstalled extension from the profile",`${M.identifier.id}@${M.manifest.version}`,r.profileLocation.toString()):this.F.info("Successfully uninstalled extension:",`${M.identifier.id}@${M.manifest.version}`),i(this.C,"extensionGallery:uninstall",{extensionData:(0,p.$Jp)(M),error:J}),this.u.fire({identifier:M.identifier,error:J?.code,profileLocation:r.profileLocation,applicationScoped:M.isApplicationScoped})},T=[],C=[];try{T.push(R(e));const M=await this.getInstalled(y.ExtensionType.User,r.profileLocation);if(r.donotIncludePack)this.F.info("Uninstalling the extension without including packed extension",`${e.identifier.id}@${e.manifest.version}`);else{const J=this.S(e,M);for(const ae of J)this.m.has(h(ae.identifier))?this.F.info("Extensions is already requested to uninstall",ae.identifier.id):T.push(R(ae))}r.donotCheckDependents?this.F.info("Uninstalling the extension without checking dependents",`${e.identifier.id}@${e.manifest.version}`):this.Q(T.map(J=>J.extension),M,e),await this.L(T.map(async J=>{try{if(await J.run(),await this.L(this.y.map(ae=>ae.postUninstall(J.extension,r,v.CancellationToken.None))),J.extension.identifier.uuid)try{await this.z.reportStatistic(J.extension.manifest.publisher,J.extension.manifest.name,J.extension.manifest.version,f.StatisticType.Uninstall)}catch{}A(J.extension)}catch(ae){const ie=u(ae);throw A(J.extension,ie),ie}finally{C.push(J)}}))}catch(M){const J=u(M);for(const ae of T){try{ae.cancel()}catch{}C.includes(ae)||A(ae.extension,J)}throw J}finally{for(const M of T)this.m.delete(h(M.extension.identifier))||this.F.warn("Uninstallation task is not found in the cache",M.extension.identifier.id)}}Q(e,n,r){for(const h of e){const E=this.U(h,n);if(E.length){const R=E.filter(A=>!e.some(T=>(0,p.$Cp)(T.identifier,A.identifier)));if(R.length)throw new Error(this.R(h,R,r))}}}R(e,n,r){return r===e?n.length===1?c.localize(6,null,r.manifest.displayName||r.manifest.name,n[0].manifest.displayName||n[0].manifest.name):n.length===2?c.localize(7,null,r.manifest.displayName||r.manifest.name,n[0].manifest.displayName||n[0].manifest.name,n[1].manifest.displayName||n[1].manifest.name):c.localize(8,null,r.manifest.displayName||r.manifest.name,n[0].manifest.displayName||n[0].manifest.name,n[1].manifest.displayName||n[1].manifest.name):n.length===1?c.localize(9,null,r.manifest.displayName||r.manifest.name,e.manifest.displayName||e.manifest.name,n[0].manifest.displayName||n[0].manifest.name):n.length===2?c.localize(10,null,r.manifest.displayName||r.manifest.name,e.manifest.displayName||e.manifest.name,n[0].manifest.displayName||n[0].manifest.name,n[1].manifest.displayName||n[1].manifest.name):c.localize(11,null,r.manifest.displayName||r.manifest.name,e.manifest.displayName||e.manifest.name,n[0].manifest.displayName||n[0].manifest.name,n[1].manifest.displayName||n[1].manifest.name)}S(e,n,r=[]){if(r.indexOf(e)!==-1)return[];r.push(e);const h=e.manifest.extensionPack?e.manifest.extensionPack:[];if(h.length){const E=n.filter(A=>!A.isBuiltin&&h.some(T=>(0,p.$Cp)({id:T},A.identifier))),R=[];for(const A of E)R.push(...this.S(A,n,r));return[...E,...R]}return[]}U(e,n){return n.filter(r=>r.manifest.extensionDependencies&&r.manifest.extensionDependencies.some(h=>(0,p.$Cp)({id:h},e.identifier)))}async W(){try{return this.F.trace("ExtensionManagementService.updateControlCache"),await this.z.getExtensionsControlManifest()}catch(e){return this.F.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest",(0,I.$0)(e)),{malicious:[],deprecated:{},search:[]}}}};t.$tq=w,t.$tq=w=we([ne(0,f.$bp),ne(1,d.$6l),ne(2,$.$El),ne(3,N.$7j),ne(4,g.$nk),ne(5,P.$Gl)],w);function u(s,e){if(s instanceof f.$dp)return s;let n;return s instanceof f.$cp?n=new f.$dp(s.message,s.code===f.ExtensionGalleryErrorCode.DownloadFailedWriting?f.ExtensionManagementErrorCode.DownloadFailedWriting:f.ExtensionManagementErrorCode.Gallery):n=new f.$dp(s.message,(0,I.$4)(s)?f.ExtensionManagementErrorCode.Cancelled:e??f.ExtensionManagementErrorCode.Internal),n.stack=s.stack,n}function i(s,e,{extensionData:n,verificationStatus:r,duration:h,error:E,source:R,durationSinceUpdate:A}){let T,C;(0,a.$ig)(r)&&(r===!0?r="Verified":(r===!1||(T=f.ExtensionManagementErrorCode.Signature,C=r),r="Unverified")),E&&(T=E.code,E.code===f.ExtensionManagementErrorCode.Signature&&(C=E.message)),s.publicLog(e,{...n,verificationStatus:r,success:!E,duration:h,errorcode:T,errorcodeDetail:C,durationSinceUpdate:A,source:R})}class o{constructor(){this.d=new k.$zh}async waitUntilTaskIsFinished(){return await this.d.wait(),this.g}run(){return this.g||(this.g=(0,k.$nh)(e=>this.h(e))),this.d.open(),this.g}cancel(){this.g||(this.g=(0,k.$nh)(e=>new Promise((n,r)=>{const h=e.onCancellationRequested(()=>{h.dispose(),r(new I.$5)})})),this.d.open()),this.g.cancel()}}t.$vq=o}),define(se[42],oe([0,1,8,14,2,5,31,12,21,27,10,11,6,24,23,3,9,19]),function(Q,t,O,k,v,I,D,S,m,a,l,c,f,p,y,N,g,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$yq=t.$xq=t.$wq=t.ExtensionsProfileScanningErrorCode=void 0;var $;(function(o){o.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",o.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})($||(t.ExtensionsProfileScanningErrorCode=$={}));class P extends Error{constructor(s,e){super(s),this.code=e}}t.$wq=P,t.$xq=(0,c.$Ai)("IExtensionsProfileScannerService");let w=class extends v.$Uc{constructor(s,e,n,r,h,E){super(),this.j=s,this.m=e,this.n=n,this.r=r,this.s=h,this.t=E,this.b=this.B(new I.$he),this.onAddExtensions=this.b.event,this.c=this.B(new I.$he),this.onDidAddExtensions=this.c.event,this.f=this.B(new I.$he),this.onRemoveExtensions=this.f.event,this.g=this.B(new I.$he),this.onDidRemoveExtensions=this.g.event,this.h=new D.$Ac}scanProfileExtensions(s,e){return this.u(s,void 0,e)}async addExtensionsToProfile(s,e,n){const r=[],h=[];try{return await this.u(e,E=>{const R=[];if(n)R.push(...E);else for(const A of E)s.some(([T])=>(0,a.$Cp)(T.identifier,A.identifier)&&T.manifest.version!==A.version)?r.push(A):R.push(A);for(const[A,T]of s){const C=R.findIndex(J=>(0,a.$Cp)(J.identifier,A.identifier)&&J.version===A.manifest.version),M={identifier:A.identifier,version:A.manifest.version,location:A.location,metadata:T};C===-1?(h.push(M),R.push(M)):R.splice(C,1,M)}return h.length&&this.b.fire({extensions:h,profileLocation:e}),r.length&&this.f.fire({extensions:r,profileLocation:e}),R}),h.length&&this.c.fire({extensions:h,profileLocation:e}),r.length&&this.g.fire({extensions:r,profileLocation:e}),h}catch(E){throw h.length&&this.c.fire({extensions:h,error:E,profileLocation:e}),r.length&&this.g.fire({extensions:r,error:E,profileLocation:e}),E}}async updateMetadata(s,e){const n=[];return await this.u(e,r=>{const h=[];for(const E of r){const R=s.find(([A])=>(0,a.$Cp)(A.identifier,E.identifier)&&A.manifest.version===E.version);R&&(E.metadata={...E.metadata,...R[1]},n.push(E)),h.push(E)}return h}),n}async removeExtensionFromProfile(s,e){const n=[];try{await this.u(e,r=>{const h=[];for(const E of r)(0,a.$Cp)(E.identifier,s.identifier)?n.push(E):h.push(E);return n.length&&this.f.fire({extensions:n,profileLocation:e}),h}),n.length&&this.g.fire({extensions:n,profileLocation:e})}catch(r){throw n.length&&this.g.fire({extensions:n,error:r,profileLocation:e}),r}}async u(s,e,n){return this.F(s).queue(async()=>{let r=[],h;try{const E=await this.m.readFile(s);h=JSON.parse(E.value.toString().trim()||"[]")}catch(E){if((0,l.$ll)(E)!==l.FileOperationResult.FILE_NOT_FOUND)throw E;if(this.r.extUri.isEqual(s,this.n.defaultProfile.extensionsResource)&&(h=await this.D()),!h&&n?.bailOutWhenFileNotFound)throw new P((0,g.$0)(E),$.ERROR_PROFILE_NOT_FOUND)}if(h){Array.isArray(h)||this.w(s);let E=!1;for(const R of h){u(R)||this.w(s);let A;if((0,N.$ag)(R.relativeLocation)&&R.relativeLocation)A=this.z(R.relativeLocation);else if((0,N.$ag)(R.location)){this.t.warn(`Extensions profile: Ignoring extension with invalid location: ${R.location}`);continue}else{A=S.URI.revive(R.location);const T=this.y(A);T&&(E=!0,R.relativeLocation=T)}(0,N.$hg)(R.metadata?.hasPreReleaseVersion)&&R.metadata?.preRelease&&(E=!0,R.metadata.hasPreReleaseVersion=!0),r.push({identifier:R.identifier,location:A,version:R.version,metadata:R.metadata})}E&&await this.m.writeFile(s,k.$Je.fromString(JSON.stringify(h)))}if(e){r=e(r);const E=r.map(R=>({identifier:R.identifier,version:R.version,location:R.location.toJSON(),relativeLocation:this.y(R.location),metadata:R.metadata}));await this.m.writeFile(s,k.$Je.fromString(JSON.stringify(E)))}return r})}w(s){const e=new P(`Invalid extensions content in ${s.toString()}`,$.ERROR_INVALID_CONTENT);throw this.s.publicLogError2("extensionsProfileScanningError",{code:e.code}),e}y(s){return this.r.extUri.isEqual(this.r.extUri.dirname(s),this.j)?this.r.extUri.basename(s):void 0}z(s){return this.r.extUri.joinPath(this.j,s)}async D(){return this.C||(this.C=(async()=>{const s=this.r.extUri.joinPath(this.n.defaultProfile.location,"extensions.json"),e=this.r.extUri.joinPath(this.j,".init-default-profile-extensions");let n;try{n=(await this.m.readFile(s)).value.toString()}catch(h){if((0,l.$ll)(h)===l.FileOperationResult.FILE_NOT_FOUND)return;throw h}this.t.info("Migrating extensions from old default profile location",s.toString());let r;try{const h=JSON.parse(n);Array.isArray(h)&&h.every(E=>u(E))?r=h:this.t.warn("Skipping migrating from old default profile locaiton: Found invalid data",h)}catch(h){this.t.error(h)}if(r)try{await this.m.createFile(this.n.defaultProfile.extensionsResource,k.$Je.fromString(JSON.stringify(r)),{overwrite:!1}),this.t.info("Migrated extensions from old default profile location to new location",s.toString(),this.n.defaultProfile.extensionsResource.toString())}catch(h){if((0,l.$ll)(h)===l.FileOperationResult.FILE_MODIFIED_SINCE)this.t.info("Migration from old default profile location to new location is done by another window",s.toString(),this.n.defaultProfile.extensionsResource.toString());else throw h}try{await this.m.del(s)}catch(h){(0,l.$ll)(h)!==l.FileOperationResult.FILE_NOT_FOUND&&this.t.error(h)}try{await this.m.del(e)}catch(h){(0,l.$ll)(h)!==l.FileOperationResult.FILE_NOT_FOUND&&this.t.error(h)}return r})()),this.C}F(s){let e=this.h.get(s);return e||(e=new O.$Hh,this.h.set(s,e)),e}};t.$yq=w,t.$yq=w=we([ne(1,l.$7k),ne(2,p.$Gl),ne(3,y.$El),ne(4,d.$6l),ne(5,f.$7j)],w);function u(o){return(0,N.$cg)(o)&&(0,m.$ap)(o.identifier)&&(i(o.location)||(0,N.$ag)(o.location)&&o.location)&&((0,N.$hg)(o.relativeLocation)||(0,N.$ag)(o.relativeLocation))&&o.version&&(0,N.$ag)(o.version)}function i(o){return o?(0,N.$ag)(o.path)&&(0,N.$ag)(o.scheme):!1}}),define(se[54],oe([0,1,20,8,28,14,9,34,86,2,15,16,13,17,44,56,3,12,102,18,27,26,50,10,11,6,33,5,47,42,24,23,121]),function(Q,t,O,k,v,I,D,S,m,a,l,c,f,p,y,N,g,d,$,P,w,u,i,o,s,e,n,r,h,E,R,A,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Fq=t.$Dq=t.$Cq=t.$Bq=t.Translations=void 0,t.$Eq=ce;var C;(function(le){function x(_,B){if(_===B)return!0;const U=Object.keys(_),G=new Set;for(const Z of Object.keys(B))G.add(Z);if(U.length!==G.size)return!1;for(const Z of U){if(_[Z]!==B[Z])return!1;G.delete(Z)}return G.size===0}le.equals=x})(C||(t.Translations=C={})),t.$Bq=(0,s.$Ai)("IExtensionsScannerService");let M=class extends a.$Uc{constructor(x,_,B,U,G,Z,Y,F,z,H,V,b){super(),this.systemExtensionsLocation=x,this.userExtensionsLocation=_,this.r=B,this.s=U,this.t=G,this.u=Z,this.w=Y,this.y=F,this.z=z,this.C=H,this.D=V,this.F=b,this.g=this.B(new r.$he),this.onDidChangeCache=this.g.event,this.h=(0,p.$bh)(this.userExtensionsLocation,".obsolete"),this.j=this.B(this.F.createInstance(ie,this.s,this.h)),this.m=this.B(this.F.createInstance(ie,this.s,this.h)),this.n=this.B(this.F.createInstance(ae,this.h)),this.H=void 0,this.B(this.j.onDidChangeCache(()=>this.g.fire(u.ExtensionType.System))),this.B(this.m.onDidChangeCache(()=>this.g.fire(u.ExtensionType.User)))}getTargetPlatform(){return this.G||(this.G=(0,w.$Np)(this.w,this.y)),this.G}async scanAllExtensions(x,_,B){const[U,G]=await Promise.all([this.scanSystemExtensions(x),this.scanUserExtensions(_)]),Z=B?await this.scanExtensionsUnderDevelopment(x,[...U,...G]):[];return this.L(U,G,Z,await this.getTargetPlatform(),!0)}async scanSystemExtensions(x){const _=[];_.push(this.M(!!x.useCache,x.language)),_.push(this.N(x.language,!!x.checkControlFile));const[B,U]=await Promise.all(_);return this.J([...B,...U],u.ExtensionType.System,x,!1)}async scanUserExtensions(x){const _=x.profileLocation??this.userExtensionsLocation;this.y.trace("Started scanning user extensions",_);const B=this.D.extUri.isEqual(x.profileLocation,this.t.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,U=await this.P(_,!!x.profileLocation,u.ExtensionType.User,!x.includeUninstalled,x.language,!0,B,x.productVersion??this.R()),G=x.useCache&&!U.devMode&&U.excludeObsolete?this.m:this.n;let Z;try{Z=await G.scanExtensions(U)}catch(Y){if(Y instanceof E.$wq&&Y.code===E.ExtensionsProfileScanningErrorCode.ERROR_PROFILE_NOT_FOUND)await this.I(),Z=await G.scanExtensions(U);else throw Y}return Z=await this.J(Z,u.ExtensionType.User,x,!0),this.y.trace("Scanned user extensions:",Z.length),Z}async scanExtensionsUnderDevelopment(x,_){if(this.z.isExtensionDevelopment&&this.z.extensionDevelopmentLocationURI){const B=(await Promise.all(this.z.extensionDevelopmentLocationURI.filter(U=>U.scheme===l.Schemas.file).map(async U=>{const G=await this.P(U,!1,u.ExtensionType.User,!0,x.language,!1,void 0,x.productVersion??this.R());return(await this.n.scanOneOrMultipleExtensions(G)).map(Y=>(Y.type=_.find(F=>(0,w.$Cp)(F.identifier,Y.identifier))?.type??Y.type,this.n.validate(Y,G)))}))).flat();return this.J(B,"development",x,!0)}return[]}async scanExistingExtension(x,_,B){const U=await this.P(x,!1,_,!0,B.language,!0,void 0,B.productVersion??this.R()),G=await this.n.scanExtension(U);return!G||!B.includeInvalid&&!G.isValid?null:G}async scanOneOrMultipleExtensions(x,_,B){const U=await this.P(x,!1,_,!0,B.language,!0,void 0,B.productVersion??this.R()),G=await this.n.scanOneOrMultipleExtensions(U);return this.J(G,_,B,!0)}async scanMultipleExtensions(x,_,B){const U=[];return await Promise.all(x.map(async G=>{const Z=await this.scanOneOrMultipleExtensions(G,_,B);U.push(...Z)})),this.J(U,_,B,!0)}async scanMetadata(x){const _=(0,p.$bh)(x,"package.json"),B=(await this.w.readFile(_)).value.toString();return JSON.parse(B).__metadata}async updateMetadata(x,_){const B=(0,p.$bh)(x,"package.json"),U=(await this.w.readFile(B)).value.toString(),G=JSON.parse(U);_.isMachineScoped===!1&&delete _.isMachineScoped,_.isBuiltin===!1&&delete _.isBuiltin,G.__metadata={...G.__metadata,..._},await this.w.writeFile((0,p.$bh)(x,"package.json"),I.$Je.fromString(JSON.stringify(G,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.u.scanProfileExtensions(this.t.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(x){if(x instanceof E.$wq&&x.code===E.ExtensionsProfileScanningErrorCode.ERROR_PROFILE_NOT_FOUND)await this.I();else throw x}}async I(){return this.H||(this.H=(async()=>{try{this.y.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const x=await this.scanUserExtensions({includeInvalid:!0});if(x.length)await this.u.addExtensionsToProfile(x.map(_=>[_,_.metadata]),this.t.defaultProfile.extensionsResource);else try{await this.w.createFile(this.t.defaultProfile.extensionsResource,I.$Je.fromString(JSON.stringify([])))}catch(_){(0,o.$ll)(_)!==o.FileOperationResult.FILE_NOT_FOUND&&this.y.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,D.$0)(_))}this.y.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(x){this.y.error(x)}finally{this.H=void 0}})()),this.H}async J(x,_,B,U){return B.includeAllVersions||(x=this.L(_===u.ExtensionType.System?x:void 0,_===u.ExtensionType.User?x:void 0,_==="development"?x:void 0,await this.getTargetPlatform(),U)),B.includeInvalid||(x=x.filter(G=>G.isValid)),x.sort((G,Z)=>{const Y=c.$nc(G.location.fsPath),F=c.$nc(Z.location.fsPath);return Y<F?-1:Y>F?1:0})}L(x,_,B,U,G){const Z=(F,z,H)=>{if(F.isValid&&!z.isValid)return!1;if(F.isValid===z.isValid){if(G&&y.gt(F.manifest.version,z.manifest.version))return this.y.debug(`Skipping extension ${z.location.path} with lower version ${z.manifest.version} in favour of ${F.location.path} with version ${F.manifest.version}`),!1;if(y.eq(F.manifest.version,z.manifest.version)){if(F.type===u.ExtensionType.System)return this.y.debug(`Skipping extension ${z.location.path} in favour of system extension ${F.location.path} with same version`),!1;if(F.targetPlatform===U)return this.y.debug(`Skipping extension ${z.location.path} from different target platform ${z.targetPlatform}`),!1}}return H?this.y.warn(`Overwriting user extension ${F.location.path} with ${z.location.path}.`):this.y.debug(`Overwriting user extension ${F.location.path} with ${z.location.path}.`),!0},Y=new u.$Ym;return x?.forEach(F=>{const z=Y.get(F.identifier.id);(!z||Z(z,F,!1))&&Y.set(F.identifier.id,F)}),_?.forEach(F=>{const z=Y.get(F.identifier.id);if(!z&&x&&F.type===u.ExtensionType.System){this.y.debug(`Skipping obsolete system extension ${F.location.path}.`);return}(!z||Z(z,F,!1))&&Y.set(F.identifier.id,F)}),B?.forEach(F=>{const z=Y.get(F.identifier.id);(!z||Z(z,F,!0))&&Y.set(F.identifier.id,F),Y.set(F.identifier.id,F)}),[...Y.values()]}async M(x,_){this.y.trace("Started scanning system extensions");const B=await this.P(this.systemExtensionsLocation,!1,u.ExtensionType.System,!0,_,!0,void 0,this.R()),G=await(x&&!B.devMode?this.j:this.n).scanExtensions(B);return this.y.trace("Scanned system extensions:",G.length),G}async N(x,_){const B=this.z.isBuilt?[]:this.C.builtInExtensions;if(!B?.length)return[];this.y.trace("Started scanning dev system extensions");const U=_?await this.O():{},G=[],Z=d.URI.file(c.$hc(c.$jc(l.$Ug.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const F of B){const z=U[F.name]||"marketplace";switch(z){case"disabled":break;case"marketplace":G.push((0,p.$bh)(Z,F.name));break;default:G.push(d.URI.file(z));break}}const Y=await Promise.all(G.map(async F=>this.n.scanExtension(await this.P(F,!1,u.ExtensionType.System,!0,x,!0,void 0,this.R()))));return this.y.trace("Scanned dev system extensions:",Y.length),(0,O.$Hb)(Y)}async O(){try{const x=await this.w.readFile(this.r);return JSON.parse(x.value.toString())}catch{return{}}}async P(x,_,B,U,G,Z,Y,F){const z=await this.f(G??f.$w),H=await this.Q(x),V=_&&!this.D.extUri.isEqual(x,this.t.defaultProfile.extensionsResource)?this.t.defaultProfile.extensionsResource:void 0,b=V?await this.Q(V):void 0;return new J(x,H,V,b,_,Y,B,U,Z,F.version,F.date,this.C.commit,!this.z.isBuilt,G,z)}async Q(x){try{const _=await this.w.stat(x);if(typeof _.mtime=="number")return _.mtime}catch{}}R(){return{version:this.C.version,date:this.C.date}}};t.$Cq=M,t.$Cq=M=we([ne(4,R.$Gl),ne(5,E.$xq),ne(6,o.$7k),ne(7,e.$7j),ne(8,P.$Hi),ne(9,n.$nk),ne(10,A.$El),ne(11,s.$zi)],M);class J{constructor(x,_,B,U,G,Z,Y,F,z,H,V,b,L,j,q){this.location=x,this.mtime=_,this.applicationExtensionslocation=B,this.applicationExtensionslocationMtime=U,this.profile=G,this.profileScanOptions=Z,this.type=Y,this.excludeObsolete=F,this.validate=z,this.productVersion=H,this.productDate=V,this.productCommit=b,this.devMode=L,this.language=j,this.translations=q}static createNlsConfiguration(x){return{language:x.language,pseudo:x.language==="pseudo",devMode:x.devMode,translations:x.translations}}static equals(x,_){return(0,p.$7g)(x.location,_.location)&&x.mtime===_.mtime&&(0,p.$7g)(x.applicationExtensionslocation,_.applicationExtensionslocation)&&x.applicationExtensionslocationMtime===_.applicationExtensionslocationMtime&&x.profile===_.profile&&v.$ao(x.profileScanOptions,_.profileScanOptions)&&x.type===_.type&&x.excludeObsolete===_.excludeObsolete&&x.validate===_.validate&&x.productVersion===_.productVersion&&x.productDate===_.productDate&&x.productCommit===_.productCommit&&x.devMode===_.devMode&&x.language===_.language&&C.equals(x.translations,_.translations)}}t.$Dq=J;let ae=class extends a.$Uc{constructor(x,_,B,U,G){super(),this.f=x,this.g=_,this.h=B,this.j=U,this.m=G}async scanExtensions(x){const _=x.profile?await this.r(x):await this.n(x);let B={};if(x.excludeObsolete&&x.type===u.ExtensionType.User)try{const U=(await this.j.readFile(this.f)).value.toString();B=JSON.parse(U)}catch{}return(0,g.$ng)(B)?_:_.filter(U=>!B[w.$Dp.create(U).toString()])}async n(x){const _=await this.j.resolve(x.location);if(!_.children?.length)return[];const B=await Promise.all(_.children.map(async U=>{if(!U.isDirectory||x.type===u.ExtensionType.User&&(0,p.$$g)(U.resource).indexOf(".")===0)return null;const G=new J(U.resource,x.mtime,x.applicationExtensionslocation,x.applicationExtensionslocationMtime,x.profile,x.profileScanOptions,x.type,x.excludeObsolete,x.validate,x.productVersion,x.productDate,x.productCommit,x.devMode,x.language,x.translations);return this.scanExtension(G)}));return(0,O.$Hb)(B).sort((U,G)=>U.location.path<G.location.path?-1:1)}async r(x){let _=await this.s(x.location,()=>!0,x);if(x.applicationExtensionslocation&&!this.h.extUri.isEqual(x.location,x.applicationExtensionslocation)){_=_.filter(U=>!U.metadata?.isApplicationScoped);const B=await this.s(x.applicationExtensionslocation,U=>!!U.metadata?.isBuiltin||!!U.metadata?.isApplicationScoped,x);_.push(...B)}return _}async s(x,_,B){const U=await this.g.scanProfileExtensions(x,B.profileScanOptions);if(!U.length)return[];const G=await Promise.all(U.map(async Z=>{if(_(Z)){const Y=new J(Z.location,B.mtime,B.applicationExtensionslocation,B.applicationExtensionslocationMtime,B.profile,B.profileScanOptions,B.type,B.excludeObsolete,B.validate,B.productVersion,B.productDate,B.productCommit,B.devMode,B.language,B.translations);return this.scanExtension(Y,Z.metadata)}return null}));return(0,O.$Hb)(G)}async scanOneOrMultipleExtensions(x){try{if(await this.j.exists((0,p.$bh)(x.location,"package.json"))){const _=await this.scanExtension(x);return _?[_]:[]}else return await this.scanExtensions(x)}catch(_){return this.m.error(`Error scanning extensions at ${x.location.path}:`,(0,D.$0)(_)),[]}}async scanExtension(x,_){try{let B=await this.scanExtensionManifest(x.location);if(B){B.publisher||(B.publisher=u.$Sm),_=_??B.__metadata,delete B.__metadata;const U=(0,w.$Hp)(B.publisher,B.name),G=_?.id?{id:U,uuid:_.id}:{id:U},Z=_?.isSystem?u.ExtensionType.System:x.type,Y=Z===u.ExtensionType.System||!!_?.isBuiltin;B=await this.t(x.location,B,J.createNlsConfiguration(x));const F={type:Z,identifier:G,manifest:B,location:x.location,isBuiltin:Y,targetPlatform:_?.targetPlatform??u.TargetPlatform.UNDEFINED,publisherDisplayName:_?.publisherDisplayName,metadata:_,isValid:!0,validations:[]};return x.validate?this.validate(F,x):F}}catch(B){x.type!==u.ExtensionType.System&&this.m.error(B)}return null}validate(x,_){let B=!0;const U=(0,i.$Sp)(_.productVersion,_.productDate,_.location,x.manifest,x.isBuiltin);for(const[G,Z]of U)G===N.default.Error&&(B=!1,this.m.error(this.z(_.location,Z)));return x.isValid=B,x.validations=U,x}async scanExtensionManifest(x){const _=(0,p.$bh)(x,"package.json");let B;try{B=(await this.j.readFile(_)).value.toString()}catch(G){return(0,o.$ll)(G)!==o.FileOperationResult.FILE_NOT_FOUND&&this.m.error(this.z(x,(0,$.localize)(0,null,_.path,G.message))),null}let U;try{U=JSON.parse(B)}catch{const Z=[];(0,S.$Pn)(B,Z);for(const Y of Z)this.m.error(this.z(x,(0,$.localize)(1,null,_.path,Y.offset,Y.length,(0,m.$zq)(Y.error))));return null}return(0,S.$Yn)(U)!=="object"?(this.m.error(this.z(x,(0,$.localize)(2,null,_.path))),null):U}async t(x,_,B){const U=await this.u(x,_,B);if(U)try{const G=[],Z=await this.w(U.default,G);if(G.length>0)return G.forEach(F=>{this.m.error(this.z(x,(0,$.localize)(3,null,U.default?.path,(0,m.$zq)(F.error))))}),_;if((0,S.$Yn)(U)!=="object")return this.m.error(this.z(x,(0,$.localize)(4,null,U.default?.path))),_;const Y=U.values||Object.create(null);return(0,T.$Aq)(this.m,_,Y,Z)}catch{}return _}async u(x,_,B){const U=(0,p.$bh)(x,"package.nls.json"),G=(z,H)=>{H.forEach(V=>{this.m.error(this.z(x,(0,$.localize)(5,null,z?.path,(0,m.$zq)(V.error))))})},Z=z=>{this.m.error(this.z(x,(0,$.localize)(6,null,z?.path)))},Y=`${_.publisher}.${_.name}`,F=B.translations[Y];if(F)try{const z=d.URI.file(F),H=(await this.j.readFile(z)).value.toString(),V=[],b=(0,S.$Pn)(H,V);return V.length>0?(G(z,V),{values:void 0,default:U}):(0,S.$Yn)(b)!=="object"?(Z(z),{values:void 0,default:U}):{values:b.contents?b.contents.package:void 0,default:U}}catch{return{values:void 0,default:U}}else{if(!await this.j.exists(U))return;let H;try{H=await this.y(x,B)}catch{return}if(!H.localized)return{values:void 0,default:H.original};try{const V=(await this.j.readFile(H.localized)).value.toString(),b=[],L=(0,S.$Pn)(V,b);return b.length>0?(G(H.localized,b),{values:void 0,default:H.original}):(0,S.$Yn)(L)!=="object"?(Z(H.localized),{values:void 0,default:H.original}):{values:L,default:H.original}}catch{return{values:void 0,default:H.original}}}}async w(x,_){if(x)try{const B=(await this.j.readFile(x)).value.toString();return(0,S.$Pn)(B,_)}catch{}}y(x,_){return new Promise((B,U)=>{const G=Z=>{const Y=(0,p.$bh)(x,`package.nls.${Z}.json`);this.j.exists(Y).then(F=>{F&&B({localized:Y,original:(0,p.$bh)(x,"package.nls.json")});const z=Z.lastIndexOf("-");z===-1?B({localized:(0,p.$bh)(x,"package.nls.json"),original:null}):(Z=Z.substring(0,z),G(Z))})};if(_.devMode||_.pseudo||!_.language)return B({localized:(0,p.$bh)(x,"package.nls.json"),original:null});G(_.language)})}z(x,_){return`[${x.path}]: ${_}`}};ae=we([ne(1,E.$xq),ne(2,A.$El),ne(3,o.$7k),ne(4,e.$7j)],ae);let ie=class extends ae{constructor(x,_,B,U,G,Z,Y){super(_,U,G,Z,Y),this.G=x,this.H=B,this.D=this.B(new k.$yh(3e3)),this.F=this.B(new r.$he),this.onDidChangeCache=this.F.event}async scanExtensions(x){const _=this.M(x),B=await this.I(_);if(this.C=x,B&&B.input&&J.equals(B.input,this.C))return this.m.debug("Using cached extensions scan result",x.location.toString()),this.D.trigger(()=>this.L()),B.result.map(G=>(G.location=d.URI.revive(G.location),G));const U=await super.scanExtensions(x);return await this.J(_,{input:x,result:U}),U}async I(x){try{const _=await this.j.readFile(x),B=JSON.parse(_.value.toString());return{result:B.result,input:(0,h.$0h)(B.input)}}catch(_){this.m.debug("Error while reading the extension cache file:",x.path,(0,D.$0)(_))}return null}async J(x,_){try{await this.j.writeFile(x,I.$Je.fromString(JSON.stringify(_)))}catch(B){this.m.debug("Error while writing the extension cache file:",x.path,(0,D.$0)(B))}}async L(){if(!this.C)return;const x=this.M(this.C),_=await this.I(x);if(!_)return;const B=_.result,U=JSON.parse(JSON.stringify(await super.scanExtensions(this.C)));if(!v.$ao(U,B))try{this.m.info("Invalidating Cache",B,U),await this.j.del(x),this.F.fire()}catch(G){this.m.error(G)}}M(x){const _=this.N(x);return this.h.extUri.joinPath(_.cacheHome,x.type===u.ExtensionType.System?u.$Rm:u.$Qm)}N(x){return x.type===u.ExtensionType.System?this.H.defaultProfile:x.profile?this.h.extUri.isEqual(x.location,this.G.extensionsResource)?this.G:this.H.profiles.find(_=>this.h.extUri.isEqual(x.location,_.extensionsResource))??this.G:this.H.defaultProfile}};ie=we([ne(2,R.$Gl),ne(3,E.$xq),ne(4,A.$El),ne(5,o.$7k),ne(6,e.$7j)],ie);function ce(le,x){const _=(0,w.$Fp)(le.manifest.publisher,le.manifest.name);return{id:_,identifier:new u.$Wm(_),isBuiltin:le.type===u.ExtensionType.System,isUserBuiltin:le.type===u.ExtensionType.User&&le.isBuiltin,isUnderDevelopment:x,extensionLocation:le.location,uuid:le.identifier.uuid,targetPlatform:le.targetPlatform,publisherDisplayName:le.publisherDisplayName,...le.manifest}}class ue extends M{constructor(x,_,B,U,G,Z,Y,F,z,H,V,b){super(x,_,(0,p.$bh)(B,".vscode-oss-dev","extensions","control.json"),U,G,Z,Y,F,z,H,V,b),this.S=(async()=>{if(f.$z)try{const L=await this.w.readFile(d.URI.file(f.$z));return JSON.parse(L.value.toString())}catch{}return Object.create(null)})()}f(x){return this.S}}t.$Fq=ue}),define(se[160],oe([0,1,60,8,36,5,2,15,16,25,6,24]),function(Q,t,O,k,v,I,D,S,m,a,l,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Jq=void 0;let f=class extends D.$Uc{constructor(y,N){super(),this.b=y,this.f=N,this.a=new k.$Gh(5)}async postUninstall(y){const N=this.g(y,"uninstall");N&&(this.f.info(y.identifier.id,y.manifest.version,"Running post uninstall script"),await this.a.queue(async()=>{try{await this.h(N.script,"uninstall",N.args,!0,y),this.f.info("Finished running post uninstall script",y.identifier.id,y.manifest.version)}catch(g){this.f.error("Failed to run post uninstall script",y.identifier.id,y.manifest.version),this.f.error(g)}}));try{await a.Promises.rm(this.m(y))}catch(g){this.f.error("Error while removing extension storage path",y.identifier.id),this.f.error(g)}}g(y,N){const g=`vscode:${N}`;if(y.location.scheme===S.Schemas.file&&y.manifest&&y.manifest.scripts&&typeof y.manifest.scripts[g]=="string"){const d=y.manifest.scripts[g].split(" ");return d.length<2||d[0]!=="node"||!d[1]?(this.f.warn(y.identifier.id,y.manifest.version,`${g} should be a node script`),null):{script:(0,m.$jc)(y.location.fsPath,d[1]),args:d.slice(2)||[]}}return null}h(y,N,g,d,$){return new Promise((P,w)=>{const u=this.j(y,N,g,$);let i;const o=s=>{i&&(clearTimeout(i),i=null),s?w(s):P(void 0)};u.on("error",s=>{o((0,v.$lj)(s)||"Unknown")}),u.on("exit",(s,e)=>{o(s?`post-${N} process exited with code ${s}`:void 0)}),d&&(i=setTimeout(()=>{i=null,u.kill(),w("timed out")},5e3))})}j(y,N,g,d){const $={silent:!0,execArgv:void 0},P=(0,O.fork)(y,[`--type=extension-post-${N}`,...g],$);P.stdout.setEncoding("utf8"),P.stderr.setEncoding("utf8");const w=I.Event.fromNodeEventEmitter(P.stdout,"data"),u=I.Event.fromNodeEventEmitter(P.stderr,"data");this.B(w(s=>this.f.info(d.identifier.id,d.manifest.version,`post-${N}`,s))),this.B(u(s=>this.f.error(d.identifier.id,d.manifest.version,`post-${N}`,s)));const i=I.Event.any(I.Event.map(w,s=>({data:`%c${s}`,format:[""]}),this.q),I.Event.map(u,s=>({data:`%c${s}`,format:["color: red"]}),this.q));return I.Event.debounce(i,(s,e)=>s?{data:s.data+e.data,format:[...s.format,...e.format]}:{data:e.data,format:e.format},100,void 0,void 0,void 0,this.q)(s=>{console.group(d.identifier.id),console.log(s.data,...s.format),console.groupEnd()}),P}m(y){return(0,m.$jc)(this.b.defaultProfile.globalStorageHome.fsPath,y.identifier.id.toLowerCase())}};t.$Jq=f,t.$Jq=f=we([ne(0,c.$Gl),ne(1,l.$7j)],f)}),define(se[73],oe([0,1,49,104,53,21]),function(Q,t,O,k,v,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Gq=D,t.$Hq=S;function D(m){let a=I.ExtensionManagementErrorCode.Extract;return m instanceof O.$pq&&(m.type==="CorruptZip"?a=I.ExtensionManagementErrorCode.CorruptZip:m.type==="Incomplete"&&(a=I.ExtensionManagementErrorCode.IncompleteZip)),(0,v.$uq)(m,a)}async function S(m){let a;try{a=await(0,O.$sq)(m,"extension/package.json")}catch(l){throw D(l)}try{return JSON.parse(a.toString("utf8"))}catch{throw new I.$dp((0,k.localize)(0,null),I.ExtensionManagementErrorCode.Invalid)}}}),define(se[161],oe([0,1,8,9,2,15,17,44,3,29,25,49,30,18,53,21,27,73,72,10,6,19]),function(Q,t,O,k,v,I,D,S,m,a,l,c,f,p,y,N,g,d,$,P,w,u){"use strict";var i;Object.defineProperty(t,"__esModule",{value:!0}),t.$Iq=void 0;let o=class extends v.$Uc{static{i=this}static{this.c=".sigzip"}constructor(e,n,r,h,E,R,A){super(),this.h=n,this.j=r,this.m=h,this.n=E,this.r=R,this.t=A,this.extensionsDownloadDir=e.extensionsDownloadLocation,this.f=20,this.g=this.F()}async download(e,n,r,h){await this.g;const E=await this.w(e,n);let R=!1;if(r&&this.u(e)){let A;try{A=await this.y(e)}catch(T){try{await this.delete(E)}catch(C){this.t.error(C)}throw T}try{R=await this.n.verify(e,E.fsPath,A.fsPath,h)}catch(T){if(R=T.code,R===$.ExtensionSignatureVerificationCode.PackageIsInvalidZip||R===$.ExtensionSignatureVerificationCode.SignatureArchiveIsInvalidZip){try{await this.delete(E)}catch(C){this.t.error(C)}throw new N.$dp(c.$oq,N.ExtensionManagementErrorCode.CorruptZip)}}finally{try{await this.delete(A)}catch(T){this.t.error(T)}}}return{location:E,verificationStatus:R}}u(e){if(!e.isSigned)return this.t.info(`Extension is not signed: ${e.identifier.id}`),!1;const n=this.m.getValue("extensions.verifySignature");return(0,m.$gg)(n)?n:!0}async w(e,n){try{const r=(0,D.$bh)(this.extensionsDownloadDir,this.G(e)),h=await this.C(e,"vsix",async()=>{await this.z(e,r,E=>this.j.download(e,E,n));try{await this.D(r.fsPath,"extension/package.json")}catch(E){try{await this.h.del(r)}catch(R){this.t.warn(`Error while deleting: ${r.path}`,(0,k.$0)(R))}throw E}},2);return h>1&&this.r.publicLog2("extensiongallery:downloadvsix:retry",{extensionId:e.identifier.id,attempts:h}),r}catch(r){throw(0,y.$uq)(r,N.ExtensionManagementErrorCode.Download)}}async y(e){try{const n=(0,D.$bh)(this.extensionsDownloadDir,`.${(0,a.$Wg)()}`),r=await this.C(e,"sigzip",async()=>{await this.j.downloadSignatureArchive(e,n);try{await this.D(n.fsPath,".signature.p7s")}catch(h){try{await this.h.del(n)}catch(E){this.t.warn(`Error while deleting: ${n.path}`,(0,k.$0)(E))}throw h}},2);return r>1&&this.r.publicLog2("extensiongallery:downloadsigzip:retry",{extensionId:e.identifier.id,attempts:r}),n}catch(n){throw(0,y.$uq)(n,N.ExtensionManagementErrorCode.DownloadSignature)}}async z(e,n,r){if(await this.h.exists(n))return;if(n.scheme!==I.Schemas.file){await r(n);return}const h=(0,D.$bh)(this.extensionsDownloadDir,`.${(0,a.$Wg)()}`);try{await r(h)}catch(E){try{await this.h.del(h)}catch{}throw E}try{await l.Promises.rename(h.fsPath,n.fsPath,2*60*1e3)}catch(E){try{await this.h.del(h)}catch{}let R=!1;try{R=await this.h.exists(n)}catch{}if(R)this.t.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",e.identifier.id,n.path);else throw this.t.info(`Rename failed because of ${(0,k.$0)(E)}. Deleted the file from downloaded location`,h.path),E}}async C(e,n,r,h){let E=1;for(;;)try{return await r(),E}catch(R){if(E++>h)throw R;this.t.warn(`Failed downloading ${n}. ${(0,k.$0)(R)}. Retry again...`,e.identifier.id)}}async D(e,n){try{await(0,c.$sq)(e,n)}catch(r){throw(0,d.$Gq)(r)}}async delete(e){await this.g,await this.h.del(e)}async F(){try{if(!await this.h.exists(this.extensionsDownloadDir)){this.t.trace("Extension VSIX downloads cache dir does not exist");return}const e=await this.h.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(e.children){const n=[],r=[],h=[];for(const A of e.children)if(A.name.endsWith(i.c))h.push(A.resource);else{const T=g.$Dp.parse(A.name);T&&r.push([T,A])}const E=(0,g.$Ip)(r,([A])=>A),R=[];for(const A of E)A.sort((T,C)=>S.rcompare(T[0].version,C[0].version)),n.push(...A.slice(1).map(T=>T[1].resource)),R.push(A[0][1]);R.sort((A,T)=>A.mtime-T.mtime),n.push(...R.slice(0,Math.max(0,R.length-this.f)).map(A=>A.resource)),n.push(...h),await O.Promises.settled(n.map(A=>(this.t.trace("Deleting from cache",A.path),this.h.del(A))))}}catch(e){this.t.error(e)}}G(e){return this.f?g.$Dp.create(e).toString().toLowerCase():(0,a.$Wg)()}};t.$Iq=o,t.$Iq=o=i=we([ne(0,p.$Ii),ne(1,P.$7k),ne(2,N.$bp),ne(3,f.$7i),ne(4,$.$hq),ne(5,u.$6l),ne(6,w.$7j)],o)}),define(se[162],oe([0,1,8,14,22,36,9,5,43,2,31,15,16,17,44,3,12,29,25,49,103,62,18,53,21,27,42,54,161,160,73,142,149,26,50,10,11,6,33,19,23,24]),function(Q,t,O,k,v,I,D,S,m,a,l,c,f,p,y,N,g,d,$,P,w,u,i,o,s,e,n,r,h,E,R,A,T,C,M,J,ae,ie,ce,ue,le,x){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Oq=t.$Nq=t.$Mq=void 0,t.$Mq=(0,ae.$Bi)(s.$ep);const _=".vsctmp";let B=class extends o.$tq{constructor(F,z,H,V,b,L,j,q,X,K,re,fe){super(F,z,re,H,K,fe),this.eb=b,this.fb=L,this.gb=j,this.hb=q,this.ib=X,this.db=new Map,this.tb=new l.$Bc;const he=this.B(q.createInstance(E.$Jq));this.ab=this.B(q.createInstance(U,me=>he.postUninstall(me))),this.bb=this.B(new A.$Kq(fe,X,re,this,this.F)),this.cb=this.B(q.createInstance(h.$Iq));const ve=this.B(new T.$Lq(this,this.eb,fe,L,re,X,H));this.B(ve.onDidChangeExtensionsByAnotherSource(me=>this.sb(me))),this.ub()}getTargetPlatform(){return this.jb||(this.jb=(0,e.$Np)(this.ib,this.F)),this.jb}async zip(F){this.F.trace("ExtensionManagementService#zip",F.identifier.id);const z=await this.rb(F),H=await(0,P.zip)((0,p.$bh)(this.cb.extensionsDownloadDir,(0,d.$Wg)()).fsPath,z);return g.URI.file(H)}async unzip(F){return this.F.trace("ExtensionManagementService#unzip",F.toString()),(await this.install(F)).identifier}async getManifest(F){const{location:z,cleanup:H}=await this.lb(F),V=f.$kc(z.fsPath);try{return await(0,R.$Hq)(V)}finally{await H()}}getInstalled(F,z=this.H.defaultProfile.extensionsResource,H={version:this.G.version,date:this.G.date}){return this.ab.scanExtensions(F??null,z,H)}scanAllUserInstalledExtensions(){return this.ab.scanAllUserExtensions(!1)}scanInstalledExtensionAtLocation(F){return this.ab.scanUserExtensionAtLocation(F)}async install(F,z={}){this.F.trace("ExtensionManagementService#install",F.toString());const{location:H,cleanup:V}=await this.lb(F);try{const b=await(0,R.$Hq)(f.$kc(H.fsPath)),L=(0,e.$Hp)(b.publisher,b.name);if(b.engines&&b.engines.vscode&&!(0,M.$Up)(b.engines.vscode,this.G.version,this.G.date))throw new Error(w.localize(0,null,L,this.G.version));const q=(await this.I([{manifest:b,extension:H,options:z}])).find(({identifier:X})=>(0,e.$Cp)(X,{id:L}));if(q?.local)return q.local;throw q?.error?q.error:(0,o.$uq)(new Error(`Unknown error while installing extension ${L}`))}finally{await V()}}async installFromLocation(F,z){this.F.trace("ExtensionManagementService#installFromLocation",F.toString());const H=await this.ab.scanUserExtensionAtLocation(F);if(!H||!H.manifest.name||!H.manifest.version)throw new Error(`Cannot find a valid extension from the location ${F.toString()}`);return await this.wb([[H,{source:"resource"}]],z),this.F.info("Successfully installed extension",H.identifier.id,z.toString()),H}async installExtensionsFromProfile(F,z,H){this.F.trace("ExtensionManagementService#installExtensionsFromProfile",F,z.toString(),H.toString());const V=(await this.getInstalled(C.ExtensionType.User,z)).filter(b=>F.some(L=>(0,e.$Cp)(L,b.identifier)));if(V.length){const b=await Promise.all(V.map(L=>this.ab.scanMetadata(L,z)));await this.wb(V.map((L,j)=>[L,b[j]]),H),this.F.info("Successfully installed extensions",V.map(L=>L.identifier.id),H.toString())}return V}async updateMetadata(F,z,H=this.H.defaultProfile.extensionsResource){return this.F.trace("ExtensionManagementService#updateMetadata",F.identifier.id),z.isPreReleaseVersion&&(z.preRelease=!0,z.hasPreReleaseVersion=!0),z.isMachineScoped===!1&&(z.isMachineScoped=void 0),z.isBuiltin===!1&&(z.isBuiltin=void 0),z.pinned===!1&&(z.pinned=void 0),F=await this.ab.updateMetadata(F,z,H),this.bb.invalidate(H),this.w.fire(F),F}async reinstallFromGallery(F){if(this.F.trace("ExtensionManagementService#reinstallFromGallery",F.identifier.id),!this.z.isEnabled())throw new Error(w.localize(1,null));const z=await this.getTargetPlatform(),[H]=await this.z.getExtensions([{...F.identifier,preRelease:F.preRelease}],{targetPlatform:z,compatible:!0},v.CancellationToken.None);if(!H)throw new Error(w.localize(2,null));await this.ab.setUninstalled(F);try{await this.ab.removeUninstalledExtension(F)}catch(V){throw new Error(w.localize(3,null,(0,I.$lj)(V)))}return this.installFromGallery(H)}$(F,z,H,V){return this.ab.copyExtension(F,z,H,V)}copyExtensions(F,z){return this.ab.copyExtensions(F,z,{version:this.G.version,date:this.G.date})}markAsUninstalled(...F){return this.ab.setUninstalled(...F)}async cleanUp(){this.F.trace("ExtensionManagementService#cleanUp");try{await this.ab.cleanUp()}catch(F){this.F.error(F)}}async download(F,z,H){const{location:V}=await this.cb.download(F,z,!H);return V}async lb(F){if(F.scheme===c.Schemas.file)return{location:F,async cleanup(){}};this.F.trace("Downloading extension from",F.toString());const z=(0,p.$bh)(this.cb.extensionsDownloadDir,(0,d.$Wg)());return await this.gb.download(F,z),this.F.info("Downloaded extension to",z.toString()),{location:z,cleanup:async()=>{try{await this.ib.del(z)}catch(V){this.F.error(V)}}}}X(){return this.H.defaultProfile.extensionsResource}Y(F,z,H){const V=z instanceof g.URI?new e.$Dp({id:(0,e.$Hp)(F.publisher,F.name)},F.version):e.$Dp.create(z);return this.hb.createInstance(G,V,F,z,H,(b,L)=>{if(z instanceof g.URI)return this.qb(V,z,H,L);let j=this.db.get(V.toString());return j||(this.db.set(V.toString(),j=this.pb(V,z,b,H,L)),j.finally(()=>this.db.delete(V.toString()))),j},this.ab)}Z(F,z){return new Z(F,z.profileLocation,this.fb)}async pb(F,z,H,V,b){const{verificationStatus:L,location:j}=await this.cb.download(z,H,!V.donotVerifySignature,V.context?.[s.$7o]);try{if(b.isCancellationRequested)throw new D.$5;return await(0,R.$Hq)(j.fsPath),{local:await this.ab.extractUserExtension(F,j.fsPath,{id:z.identifier.uuid,publisherId:z.publisherId,publisherDisplayName:z.publisherDisplayName,targetPlatform:z.properties.targetPlatform,isApplicationScoped:V.isApplicationScoped,isMachineScoped:V.isMachineScoped,isBuiltin:V.isBuiltin,isPreReleaseVersion:z.properties.isPreReleaseVersion,hasPreReleaseVersion:z.properties.isPreReleaseVersion,installedTimestamp:Date.now(),pinned:V.installGivenVersion?!0:!!V.pinned,preRelease:(0,N.$gg)(V.preRelease)?V.preRelease:V.installPreReleaseVersion||z.properties.isPreReleaseVersion,source:"gallery"},!1,b),verificationStatus:L}}catch(q){try{await this.cb.delete(j)}catch(X){this.F.warn("Error while deleting the downloaded file",j.toString(),(0,D.$0)(X))}throw(0,o.$uq)(q)}}async qb(F,z,H,V){return{local:await this.ab.extractUserExtension(F,f.$kc(z.fsPath),{isApplicationScoped:H.isApplicationScoped,isMachineScoped:H.isMachineScoped,isBuiltin:H.isBuiltin,installedTimestamp:Date.now(),pinned:H.installGivenVersion?!0:!!H.pinned,source:"vsix"},!0,V)}}async rb(F){const z=async V=>{let b=await $.Promises.readdir(V);b=b.map(q=>f.$jc(V,q));const L=await Promise.all(b.map(q=>$.Promises.stat(q)));let j=Promise.resolve([]);return L.forEach((q,X)=>{const K=b[X];q.isFile()&&(j=j.then(re=>[...re,K])),q.isDirectory()&&(j=j.then(re=>z(K).then(fe=>[...re,...fe])))}),j};return(await z(F.location.fsPath)).map(V=>({path:`extension/${f.$lc(F.location.fsPath,V)}`,localPath:V}))}async sb({added:F,removed:z}){if(z){const H=F&&this.D.extUri.isEqual(z.profileLocation,F.profileLocation)?z.extensions.filter(V=>F.extensions.every(b=>!(0,e.$Cp)(b,V))):z.extensions;for(const V of H)this.F.info("Extensions removed from another source",V.id,z.profileLocation.toString()),this.u.fire({identifier:V,profileLocation:z.profileLocation})}if(F){const V=(await this.getInstalled(C.ExtensionType.User,F.profileLocation)).filter(b=>F.extensions.some(L=>(0,e.$Cp)(L,b.identifier)));this.s.fire(V.map(b=>(this.F.info("Extensions added from another source",b.identifier.id,F.profileLocation.toString()),{identifier:b.identifier,local:b,profileLocation:F.profileLocation,operation:s.InstallOperation.None})))}}async ub(){this.B(this.ab.onExtract(z=>this.tb.add(z)));const F=await this.ib.resolve(this.eb.userExtensionsLocation);for(const z of F.children??[])z.isDirectory&&this.tb.add(z.resource);this.B(this.ib.watch(this.eb.userExtensionsLocation)),this.B(this.ib.onDidFilesChange(z=>this.vb(z)))}async vb(F){if(!F.affects(this.eb.userExtensionsLocation,J.FileChangeType.ADDED))return;const z=[];for(const H of F.rawAdded){if(this.tb.has(H)||!this.D.extUri.isEqual(this.D.extUri.dirname(H),this.eb.userExtensionsLocation)||this.D.extUri.isEqual(H,this.D.extUri.joinPath(this.eb.userExtensionsLocation,".obsolete"))||this.D.extUri.basename(H).startsWith(".")||!(await this.ib.stat(H)).isDirectory)continue;const V=await this.ab.scanUserExtensionAtLocation(H);V&&V.installedTimestamp===void 0&&(this.tb.add(H),z.push(V))}z.length&&(await this.wb(z.map(H=>[H,void 0]),this.H.defaultProfile.extensionsResource),this.F.info("Added extensions to default profile from external source",z.map(H=>H.identifier.id)))}async wb(F,z){const H=F.map(V=>V[0]);await this.xb(H),await this.fb.addExtensionsToProfile(F,z),this.s.fire(H.map(V=>({local:V,identifier:V.identifier,operation:s.InstallOperation.None,profileLocation:z})))}async xb(F){const z=await this.ab.getUninstalledExtensions();for(const H of F){const V=e.$Dp.create(H);z[V.toString()]&&(this.F.trace("Removing the extension from uninstalled list:",V.id),await this.ab.setInstalled(V),this.F.info("Removed the extension from uninstalled list:",V.id))}}};t.$Nq=B,t.$Nq=B=we([ne(0,s.$bp),ne(1,ue.$6l),ne(2,ie.$7j),ne(3,i.$Ii),ne(4,r.$Bq),ne(5,n.$xq),ne(6,u.$Ro),ne(7,ae.$zi),ne(8,J.$7k),ne(9,ce.$nk),ne(10,le.$El),ne(11,x.$Gl)],B);let U=class extends a.$Uc{constructor(F,z,H,V,b,L){super(),this.j=F,this.m=z,this.n=H,this.s=V,this.t=b,this.u=L,this.h=this.B(new S.$he),this.onExtract=this.h.event,this.c=(0,p.$bh)(this.n.userExtensionsLocation,".obsolete"),this.g=new O.$Hh}async cleanUp(){await this.H(),await this.G()}async scanExtensions(F,z,H){try{const V={includeInvalid:!0,profileLocation:z,productVersion:H};let b=[];return F===null||F===C.ExtensionType.System?b.push(...await this.n.scanAllExtensions({includeInvalid:!0},V,!1)):F===C.ExtensionType.User&&b.push(...await this.n.scanUserExtensions(V)),b=F!==null?b.filter(L=>L.type===F):b,await Promise.all(b.map(L=>this.F(L)))}catch(V){throw(0,o.$uq)(V,s.ExtensionManagementErrorCode.Scanning)}}async scanAllUserExtensions(F){try{const z=await this.n.scanUserExtensions({includeAllVersions:!F,includeInvalid:!0});return await Promise.all(z.map(H=>this.F(H)))}catch(z){throw(0,o.$uq)(z,s.ExtensionManagementErrorCode.Scanning)}}async scanUserExtensionAtLocation(F){try{const z=await this.n.scanExistingExtension(F,C.ExtensionType.User,{includeInvalid:!0});if(z)return await this.F(z)}catch(z){this.u.error(z)}return null}async extractUserExtension(F,z,H,V,b){const L=F.toString(),j=g.URI.file(f.$jc(this.n.userExtensionsLocation.fsPath,`.${(0,d.$Wg)()}`)),q=g.URI.file(f.$jc(this.n.userExtensionsLocation.fsPath,L));let X=await this.m.exists(q);if(X&&V){try{await this.y(F.id,q,"removeExisting")}catch{throw new s.$dp(w.localize(4,null,q.fsPath,F.id),s.ExtensionManagementErrorCode.Delete)}X=!1}if(X)try{await this.n.updateMetadata(q,H)}catch(K){throw(0,o.$uq)(K,s.ExtensionManagementErrorCode.UpdateMetadata)}else try{if(b.isCancellationRequested)throw new D.$5;try{this.u.trace(`Started extracting the extension from ${z} to ${q.fsPath}`),await(0,P.$rq)(z,j.fsPath,{sourcePath:"extension",overwrite:!0},b),this.u.info(`Extracted extension to ${q}:`,F.id)}catch(K){throw(0,R.$Gq)(K)}try{await this.n.updateMetadata(j,H)}catch(K){throw(0,o.$uq)(K,s.ExtensionManagementErrorCode.UpdateMetadata)}if(b.isCancellationRequested)throw new D.$5;try{this.u.trace(`Started renaming the extension from ${j.fsPath} to ${q.fsPath}`),await this.C(j.fsPath,q.fsPath),this.u.info("Renamed to",q.fsPath)}catch(K){if(K.code==="ENOTEMPTY")this.u.info("Rename failed because extension was installed by another source. So ignoring renaming.",F.id);else throw this.u.info(`Rename failed because of ${(0,D.$0)(K)}. Deleted from extracted location`,j),K}this.h.fire(q)}catch(K){try{await this.m.del(j,{recursive:!0})}catch{}throw K}return this.D(q,C.ExtensionType.User)}async scanMetadata(F,z){return z?(await this.w(F,z))?.metadata:this.n.scanMetadata(F.location)}async w(F,z){return(await this.s.scanProfileExtensions(z)).find(V=>(0,e.$Cp)(V.identifier,F.identifier))}async updateMetadata(F,z,H){try{H?await this.s.updateMetadata([[F,z]],H):await this.n.updateMetadata(F.location,z)}catch(V){throw(0,o.$uq)(V,s.ExtensionManagementErrorCode.UpdateMetadata)}return this.D(F.location,F.type,H)}async getUninstalledExtensions(){try{return await this.z()}catch(F){throw(0,o.$uq)(F,s.ExtensionManagementErrorCode.ReadUninstalled)}}async setUninstalled(...F){const z=F.map(H=>e.$Dp.create(H));await this.z(H=>z.forEach(V=>{H[V.toString()]=!0,this.u.info("Marked extension as uninstalled",V.toString())}))}async setInstalled(F){try{await this.z(z=>delete z[F.toString()])}catch(z){throw(0,o.$uq)(z,s.ExtensionManagementErrorCode.UnsetUninstalled)}}async removeExtension(F,z){if(this.t.extUri.isEqualOrParent(F.location,this.n.userExtensionsLocation))return this.y(F.identifier.id,F.location,z)}async removeUninstalledExtension(F){await this.removeExtension(F,"uninstalled"),await this.z(z=>delete z[e.$Dp.create(F).toString()])}async copyExtension(F,z,H,V){const b=await this.w(F,z),L=await this.w(F,H);if(V={...b?.metadata,...V},L)if(this.t.extUri.isEqual(L.location,F.location))await this.s.updateMetadata([[F,{...L.metadata,...V}]],H);else{const j=await this.D(L.location,F.type,H);await this.s.removeExtensionFromProfile(j,H),await this.s.addExtensionsToProfile([[F,{...L.metadata,...V}]],H)}else await this.s.addExtensionsToProfile([[F,V]],H);return this.D(F.location,F.type,H)}async copyExtensions(F,z,H){const V=await this.scanExtensions(C.ExtensionType.User,F,H),b=await Promise.all(V.filter(L=>!L.isApplicationScoped).map(async L=>[L,await this.scanMetadata(L,F)]));await this.s.addExtensionsToProfile(b,z)}async y(F,z,H){this.u.trace(`Deleting ${H} extension from disk`,F,z.fsPath);const V=this.t.extUri.joinPath(this.t.extUri.dirname(z),`${this.t.extUri.basename(z)}.${(0,m.$oj)((0,d.$Wg)()).toString(16)}${_}`);await this.C(z.fsPath,V.fsPath),await this.m.del(V,{recursive:!0}),this.u.info(`Deleted ${H} extension from disk`,F,z.fsPath)}z(F){return this.g.queue(async()=>{let z;try{z=(await this.m.readFile(this.c,"utf8")).value.toString()}catch(V){if((0,J.$ll)(V)!==J.FileOperationResult.FILE_NOT_FOUND)throw V}let H={};if(z)try{H=JSON.parse(z)}catch{}return F&&(F(H),Object.keys(H).length?await this.m.writeFile(this.c,k.$Je.fromString(JSON.stringify(H))):await this.m.del(this.c)),H})}async C(F,z){try{await $.Promises.rename(F,z,2*60*1e3)}catch(H){throw(0,o.$uq)(H,s.ExtensionManagementErrorCode.Rename)}}async D(F,z,H){try{if(H){const b=(await this.n.scanUserExtensions({profileLocation:H})).find(L=>this.t.extUri.isEqual(L.location,F));if(b)return await this.F(b)}else{const V=await this.n.scanExistingExtension(F,z,{includeInvalid:!0});if(V)return await this.F(V)}throw new s.$dp(w.localize(5,null,F.path),s.ExtensionManagementErrorCode.ScanningExtension)}catch(V){throw(0,o.$uq)(V,s.ExtensionManagementErrorCode.ScanningExtension)}}async F(F){const z=await this.m.resolve(F.location);let H,V;return z.children&&(H=z.children.find(({name:b})=>/^readme(\.txt|\.md|)$/i.test(b))?.resource,V=z.children.find(({name:b})=>/^changelog(\.txt|\.md|)$/i.test(b))?.resource),{identifier:F.identifier,type:F.type,isBuiltin:F.isBuiltin||!!F.metadata?.isBuiltin,location:F.location,manifest:F.manifest,targetPlatform:F.targetPlatform,validations:F.validations,isValid:F.isValid,readmeUrl:H,changelogUrl:V,publisherDisplayName:F.metadata?.publisherDisplayName,publisherId:F.metadata?.publisherId||null,isApplicationScoped:!!F.metadata?.isApplicationScoped,isMachineScoped:!!F.metadata?.isMachineScoped,isPreReleaseVersion:!!F.metadata?.isPreReleaseVersion,hasPreReleaseVersion:!!F.metadata?.hasPreReleaseVersion,preRelease:!!F.metadata?.preRelease,installedTimestamp:F.metadata?.installedTimestamp,updated:!!F.metadata?.updated,pinned:!!F.metadata?.pinned,isWorkspaceScoped:!1,source:F.metadata?.source??(F.identifier.uuid?"gallery":"vsix")}}async G(){const F=await this.getUninstalledExtensions();if(Object.keys(F).length===0){this.u.debug("No uninstalled extensions found.");return}this.u.debug("Removing uninstalled extensions:",Object.keys(F));const z=await this.n.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),H=new Set;for(const b of z)F[e.$Dp.create(b).toString()]||H.add(b.identifier.id.toLowerCase());try{const b=(0,e.$Ip)(z,L=>L.identifier);await O.Promises.settled(b.map(async L=>{const j=L.sort((q,X)=>y.rcompare(q.manifest.version,X.manifest.version))[0];H.has(j.identifier.id.toLowerCase())||await this.j(await this.F(j))}))}catch(b){this.u.error(b)}const V=z.filter(b=>b.metadata&&F[e.$Dp.create(b).toString()]);await Promise.allSettled(V.map(b=>this.removeUninstalledExtension(b)))}async H(){this.u.trace("ExtensionManagementService#removeTempDeleteFolders");let F;try{F=await this.m.resolve(this.n.userExtensionsLocation)}catch(z){(0,J.$ll)(z)!==J.FileOperationResult.FILE_NOT_FOUND&&this.u.error(z);return}if(F?.children)try{await Promise.allSettled(F.children.map(async z=>{if(!(!z.isDirectory||!z.name.endsWith(_))){this.u.trace("Deleting the temporarily deleted folder",z.resource.toString());try{await this.m.del(z.resource,{recursive:!0}),this.u.trace("Deleted the temporarily deleted folder",z.resource.toString())}catch(H){(0,J.$ll)(H)!==J.FileOperationResult.FILE_NOT_FOUND&&this.u.error(H)}}}))}catch{}}};t.$Oq=U,t.$Oq=U=we([ne(1,J.$7k),ne(2,r.$Bq),ne(3,n.$xq),ne(4,le.$El),ne(5,ie.$7j)],U);let G=class extends o.$vq{get operation(){return this.options.operation??this.j}get verificationStatus(){return this.k}constructor(F,z,H,V,b,L,j,q,X,K,re,fe){super(),this.l=F,this.manifest=z,this.source=H,this.options=V,this.m=b,this.n=L,this.o=j,this.p=q,this.q=X,this.s=K,this.t=re,this.u=fe,this.j=s.InstallOperation.Install,this.identifier=this.l.identifier}async v(){return(await this.n.scanExtensions(null,this.options.profileLocation,this.options.productVersion)).find(z=>(0,e.$Cp)(z.identifier,this.identifier))}async h(F){const z=await this.v();z&&(this.j=s.InstallOperation.Update);const H={isApplicationScoped:this.options.isApplicationScoped||z?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||z?.isMachineScoped,isBuiltin:this.options.isBuiltin||z?.isBuiltin,isSystem:z?.type===C.ExtensionType.System?!0:void 0,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:this.options.pinned??z?.pinned,source:this.source instanceof g.URI?"vsix":"gallery"};if(this.source instanceof g.URI)if(z){if(this.l.equals(new e.$Dp(z.identifier,z.manifest.version)))try{await this.n.removeExtension(z,"existing")}catch{throw new Error(w.localize(6,null,this.manifest.displayName||this.manifest.name))}}else{const j=await this.x(this.l);if(j)try{await this.n.removeExtension(j,"existing")}catch{throw new Error(w.localize(7,null,this.manifest.displayName||this.manifest.name))}}else{if(H.id=this.source.identifier.uuid,H.publisherId=this.source.publisherId,H.publisherDisplayName=this.source.publisherDisplayName,H.targetPlatform=this.source.properties.targetPlatform,H.updated=!!z,H.isPreReleaseVersion=this.source.properties.isPreReleaseVersion,H.hasPreReleaseVersion=z?.hasPreReleaseVersion||this.source.properties.isPreReleaseVersion,H.preRelease=(0,N.$gg)(this.options.preRelease)?this.options.preRelease:this.options.installPreReleaseVersion||this.source.properties.isPreReleaseVersion||z?.preRelease,z&&z.type!==C.ExtensionType.System&&z.manifest.version===this.source.version)return this.n.updateMetadata(z,H);const j=await this.x(this.l);if(j)return j}if(F.isCancellationRequested)throw(0,o.$uq)(new D.$5);const{local:V,verificationStatus:b}=await this.m(this.operation,F);if(this.k=b,this.o.extUri.isEqual(this.q.defaultProfile.extensionsResource,this.options.profileLocation))try{await this.s.initializeDefaultProfileExtensions()}catch(j){throw(0,o.$uq)(j,s.ExtensionManagementErrorCode.IntializeDefaultProfile)}if(F.isCancellationRequested)throw(0,o.$uq)(new D.$5);try{await this.t.addExtensionsToProfile([[V,H]],this.options.profileLocation,!V.isValid)}catch(j){throw(0,o.$uq)(j,s.ExtensionManagementErrorCode.AddToProfile)}const L=await this.v();if(!L)throw new s.$dp("Cannot find the installed extension",s.ExtensionManagementErrorCode.InstalledExtensionNotFound);return this.source instanceof g.URI&&this.y(V,F),L}async x(F){return(await this.n.getUninstalledExtensions())[F.toString()]?(this.u.trace("Removing the extension from uninstalled list:",F.id),await this.n.setInstalled(F),this.u.info("Removed the extension from uninstalled list:",F.id),(await this.n.scanAllUserExtensions(!0)).find(V=>e.$Dp.create(V).equals(F))):void 0}async y(F,z){try{let[H]=await this.p.getExtensions([{id:F.identifier.id,version:F.manifest.version}],z);if(H||([H]=await this.p.getExtensions([{id:F.identifier.id}],z)),H){const V={id:H.identifier.uuid,publisherDisplayName:H.publisherDisplayName,publisherId:H.publisherId,isPreReleaseVersion:H.properties.isPreReleaseVersion,hasPreReleaseVersion:F.hasPreReleaseVersion||H.properties.isPreReleaseVersion,preRelease:H.properties.isPreReleaseVersion||this.options.installPreReleaseVersion};await this.n.updateMetadata(F,V,this.options.profileLocation)}}catch{}}};G=we([ne(6,le.$El),ne(7,s.$bp),ne(8,x.$Gl),ne(9,r.$Bq),ne(10,n.$xq),ne(11,ie.$7j)],G);class Z extends o.$vq{constructor(F,z,H){super(),this.extension=F,this.j=z,this.k=H}async h(F){await this.k.removeExtensionFromProfile(this.extension,this.j)}}}),define(se[163],oe([0,1,6,24,23,19,42,10,18,12]),function(Q,t,O,k,v,I,D,S,m,a){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$hQ=void 0;let l=class extends D.$yq{constructor(f,p,y,N,g,d){super(a.URI.file(f.extensionsPath),p,y,N,g,d)}};t.$hQ=l,t.$hQ=l=we([ne(0,m.$Ii),ne(1,S.$7k),ne(2,k.$Gl),ne(3,v.$El),ne(4,I.$6l),ne(5,O.$7j)],l)}),define(se[164],oe([0,1,12,18,42,54,10,11,6,33,23,24]),function(Q,t,O,k,v,I,D,S,m,a,l,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$uec=void 0;let f=class extends I.$Fq{constructor(y,N,g,d,$,P,w,u){super(O.URI.file($.builtinExtensionsPath),O.URI.file($.extensionsPath),$.userHome,y.defaultProfile,y,N,g,d,$,P,w,u)}};t.$uec=f,t.$uec=f=we([ne(0,c.$Gl),ne(1,v.$xq),ne(2,D.$7k),ne(3,m.$7j),ne(4,k.$Ii),ne(5,a.$nk),ne(6,l.$El),ne(7,S.$zi)],f)}),define(se[74],oe([0,1,8,5,2,132,3,93,11,24]),function(Q,t,O,k,v,I,D,S,m,a){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$aq=t.$$p=t.StorageTarget=t.StorageScope=t.WillSaveStateReason=t.$9p=t.$8p=t.$7p=void 0,t.$0p=p,t.$_p=N,t.$bq=d,t.$7p="__$__isNewStorageMarker",t.$8p="__$__targetStorageMarker",t.$9p=(0,m.$Ai)("storageService");var l;(function($){$[$.NONE=0]="NONE",$[$.SHUTDOWN=1]="SHUTDOWN"})(l||(t.WillSaveStateReason=l={}));var c;(function($){$[$.APPLICATION=-1]="APPLICATION",$[$.PROFILE=0]="PROFILE",$[$.WORKSPACE=1]="WORKSPACE"})(c||(t.StorageScope=c={}));var f;(function($){$[$.USER=0]="USER",$[$.MACHINE=1]="MACHINE"})(f||(t.StorageTarget=f={}));function p($){const P=$.get(t.$8p);if(P)try{return JSON.parse(P)}catch{}return Object.create(null)}class y extends v.$Uc{static{this.a=60*1e3}constructor(P={flushInterval:y.a}){super(),this.m=P,this.b=this.B(new k.$ke),this.c=this.B(new k.$ke),this.onDidChangeTarget=this.c.event,this.f=this.B(new k.$he),this.onWillSaveState=this.f.event,this.h=this.B(new O.$Mh(()=>this.n(),this.m.flushInterval)),this.j=this.B(new v.$Vc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(P,w,u){return k.Event.filter(this.b.event,i=>i.scope===P&&(w===void 0||i.key===w),u)}n(){this.j.value=(0,O.$Qh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,v.$Pc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,I.mark)("code/willInitStorage");try{await this.O()}finally{(0,I.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(P,w){const{key:u,external:i}=w;if(u===t.$8p){switch(P){case c.APPLICATION:this.H=void 0;break;case c.PROFILE:this.F=void 0;break;case c.WORKSPACE:this.C=void 0;break}this.c.fire({scope:P})}else this.b.fire({scope:P,key:u,target:this.J(P)[u],external:i})}w(P){this.f.fire({reason:P})}get(P,w,u){return this.P(w)?.get(P,u)}getBoolean(P,w,u){return this.P(w)?.getBoolean(P,u)}getNumber(P,w,u){return this.P(w)?.getNumber(P,u)}getObject(P,w,u){return this.P(w)?.getObject(P,u)}storeAll(P,w){this.y(()=>{for(const u of P)this.store(u.key,u.value,u.scope,u.target,w)})}store(P,w,u,i,o=!1){if((0,D.$jg)(w)){this.remove(P,u,o);return}this.y(()=>{this.z(P,u,i),this.P(u)?.set(P,w,o)})}remove(P,w,u=!1){this.y(()=>{this.z(P,w,void 0),this.P(w)?.delete(P,u)})}y(P){this.b.pause(),this.c.pause();try{P()}finally{this.b.resume(),this.c.resume()}}keys(P,w){const u=[],i=this.J(P);for(const o of Object.keys(i))i[o]===w&&u.push(o);return u}z(P,w,u,i=!1){const o=this.J(w);typeof u=="number"?o[P]!==u&&(o[P]=u,this.P(w)?.set(t.$8p,JSON.stringify(o),i)):typeof o[P]=="number"&&(delete o[P],this.P(w)?.set(t.$8p,JSON.stringify(o),i))}get D(){return this.C||(this.C=this.L(c.WORKSPACE)),this.C}get G(){return this.F||(this.F=this.L(c.PROFILE)),this.F}get I(){return this.H||(this.H=this.L(c.APPLICATION)),this.H}J(P){switch(P){case c.APPLICATION:return this.I;case c.PROFILE:return this.G;default:return this.D}}L(P){const w=this.P(P);return w?p(w):Object.create(null)}isNew(P){return this.getBoolean(t.$7p,P)===!0}async flush(P=l.NONE){this.f.fire({reason:P});const w=this.P(c.APPLICATION),u=this.P(c.PROFILE),i=this.P(c.WORKSPACE);switch(P){case l.NONE:await O.Promises.settled([w?.whenFlushed()??Promise.resolve(),u?.whenFlushed()??Promise.resolve(),i?.whenFlushed()??Promise.resolve()]);break;case l.SHUTDOWN:await O.Promises.settled([w?.flush(0)??Promise.resolve(),u?.flush(0)??Promise.resolve(),i?.flush(0)??Promise.resolve()]);break}}async log(){const P=this.P(c.APPLICATION)?.items??new Map,w=this.P(c.PROFILE)?.items??new Map,u=this.P(c.WORKSPACE)?.items??new Map;return d(P,w,u,this.Q(c.APPLICATION)??"",this.Q(c.PROFILE)??"",this.Q(c.WORKSPACE)??"")}async optimize(P){return await this.flush(),this.P(P)?.optimize()}async switch(P,w){return this.w(l.NONE),(0,a.$Fl)(P)?this.R(P,w):this.S(P,w)}M(P,w){return!(P.id===w.id||N(w)&&N(P))}N(P,w,u){this.y(()=>{const i=new Set;for(const[o,s]of P)i.add(o),w.get(o)!==s&&this.u(u,{key:o,external:!0});for(const[o]of w.items)i.has(o)||this.u(u,{key:o,external:!0})})}}t.$$p=y;function N($){return $.isDefault||!!$.useDefaultFlags?.globalState}class g extends y{constructor(){super(),this.U=this.B(new S.$5p(new S.$6p,{hint:S.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new S.$5p(new S.$6p,{hint:S.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new S.$5p(new S.$6p,{hint:S.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(P=>this.u(c.WORKSPACE,P))),this.B(this.W.onDidChangeStorage(P=>this.u(c.PROFILE,P))),this.B(this.U.onDidChangeStorage(P=>this.u(c.APPLICATION,P)))}P(P){switch(P){case c.APPLICATION:return this.U;case c.PROFILE:return this.W;default:return this.X}}Q(P){switch(P){case c.APPLICATION:return"inMemory (application)";case c.PROFILE:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(P){return!1}}t.$aq=g;async function d($,P,w,u,i,o){const s=C=>{try{return JSON.parse(C)}catch{return C}},e=new Map,n=new Map;$.forEach((C,M)=>{e.set(M,C),n.set(M,s(C))});const r=new Map,h=new Map;P.forEach((C,M)=>{r.set(M,C),h.set(M,s(C))});const E=new Map,R=new Map;w.forEach((C,M)=>{E.set(M,C),R.set(M,s(C))}),console.group(u!==i?`Storage: Application (path: ${u})`:`Storage: Application & Profile (path: ${u}, default profile)`);const A=[];if(e.forEach((C,M)=>{A.push({key:M,value:C})}),console.table(A),console.groupEnd(),console.log(n),u!==i){console.group(`Storage: Profile (path: ${i}, profile specific)`);const C=[];r.forEach((M,J)=>{C.push({key:J,value:M})}),console.table(C),console.groupEnd(),console.log(h)}console.group(`Storage: Workspace (path: ${o})`);const T=[];E.forEach((C,M)=>{T.push({key:M,value:C})}),console.table(T),console.groupEnd(),console.log(R)}}),define(se[165],oe([0,1,14,29,74]),function(Q,t,O,k,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$cq=I;async function I(D,S,m){let a=m&&m.get("storage.serviceMachineId",v.StorageScope.APPLICATION)||null;if(a)return a;try{const c=(await S.readFile(D.serviceMachineIdResource)).value.toString();a=(0,k.$Vg)(c)?c:null}catch{a=null}if(!a){a=(0,k.$Wg)();try{await S.writeFile(D.serviceMachineIdResource,O.$Je.fromString(a))}catch{}}return m?.store("storage.serviceMachineId",a,v.StorageScope.APPLICATION,v.StorageTarget.MACHINE),a}}),define(se[166],oe([0,1,165,19,41]),function(Q,t,O,k,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$dq=I;async function I(D,S,m,a,l,c,f){const p={"X-Market-Client-Id":`VSCode ${D}`,"User-Agent":`VSCode ${D} (${S.nameShort})`};if((0,v.$up)(S,m)&&(0,v.$wp)(a)===k.TelemetryLevel.USAGE){const y=await(0,O.$cq)(m,l,c);p["X-Market-User-Id"]=y,p["VSCode-SessionId"]=f.machineId||y}return p}}),define(se[167],oe([0,1,20,22,9,13,37,3,12,30,18,21,27,26,50,10,6,33,45,166,74,19,180]),function(Q,t,O,k,v,I,D,S,m,a,l,c,f,p,y,N,g,d,$,P,w,u,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$gq=t.$fq=void 0,t.$eq=Y;const o=I.$o?p.TargetPlatform.WEB:(0,c.$0o)(I.$u,D.$ec),s="X-Market-Search-Activity-Id";var e;(function(L){L[L.None=0]="None",L[L.IncludeVersions=1]="IncludeVersions",L[L.IncludeFiles=2]="IncludeFiles",L[L.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",L[L.IncludeSharedAccounts=8]="IncludeSharedAccounts",L[L.IncludeVersionProperties=16]="IncludeVersionProperties",L[L.ExcludeNonValidated=32]="ExcludeNonValidated",L[L.IncludeInstallationTargets=64]="IncludeInstallationTargets",L[L.IncludeAssetUri=128]="IncludeAssetUri",L[L.IncludeStatistics=256]="IncludeStatistics",L[L.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",L[L.Unpublished=4096]="Unpublished",L[L.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(e||(e={}));function n(...L){return String(L.reduce((j,q)=>j|q,0))}var r;(function(L){L[L.Tag=1]="Tag",L[L.ExtensionId=4]="ExtensionId",L[L.Category=5]="Category",L[L.ExtensionName=7]="ExtensionName",L[L.Target=8]="Target",L[L.Featured=9]="Featured",L[L.SearchText=10]="SearchText",L[L.ExcludeWithFlags=12]="ExcludeWithFlags"})(r||(r={}));const h={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},E={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink",SupportLink:"Microsoft.VisualStudio.Services.Links.Support"},A={pageNumber:1,pageSize:10,sortBy:c.SortBy.NoneOrRelevance,sortOrder:c.SortOrder.Default,flags:e.None,criteria:[],assetTypes:[]};class T{constructor(j=A){this.d=j}get pageNumber(){return this.d.pageNumber}get pageSize(){return this.d.pageSize}get sortBy(){return this.d.sortBy}get sortOrder(){return this.d.sortOrder}get flags(){return this.d.flags}get criteria(){return this.d.criteria}withPage(j,q=this.d.pageSize){return new T({...this.d,pageNumber:j,pageSize:q})}withFilter(j,...q){const X=[...this.d.criteria,...q.length?q.map(K=>({filterType:j,value:K})):[{filterType:j}]];return new T({...this.d,criteria:X})}withSortBy(j){return new T({...this.d,sortBy:j})}withSortOrder(j){return new T({...this.d,sortOrder:j})}withFlags(...j){return new T({...this.d,flags:j.reduce((q,X)=>q|X,0)})}withAssetTypes(...j){return new T({...this.d,assetTypes:j})}withSource(j){return new T({...this.d,source:j})}get raw(){const{criteria:j,pageNumber:q,pageSize:X,sortBy:K,sortOrder:re,flags:fe,assetTypes:he}=this.d;return{filters:[{criteria:j,pageNumber:q,pageSize:X,sortBy:K,sortOrder:re}],assetTypes:he,flags:fe}}get searchText(){const j=this.d.criteria.filter(q=>q.filterType===r.SearchText)[0];return j&&j.value?j.value:""}get telemetryData(){return{filterTypes:this.d.criteria.map(j=>String(j.filterType)),flags:this.d.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.d.source,searchTextLength:this.searchText.length}}}function C(L,j){const q=(L||[]).filter(X=>X.statisticName===j)[0];return q?q.value:0}function M(L){const j="Microsoft.VisualStudio.Code.Translation.";return L.files.filter(X=>X.assetType.indexOf(j)===0).reduce((X,K)=>{const re=ie(L,K.assetType);return re&&X.push([K.assetType.substring(j.length),re]),X},[])}function J(L){if(L.properties){const j=L.properties.filter(K=>K.key===h.Repository),q=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),X=j.filter(K=>q.test(K.value))[0];return X?{uri:X.value,fallbackUri:X.value}:null}return ie(L,h.Repository)}function ae(L){return{uri:`${L.fallbackAssetUri}/${h.VSIX}?redirect=true${L.targetPlatform?`&targetPlatform=${L.targetPlatform}`:""}`,fallbackUri:`${L.fallbackAssetUri}/${h.VSIX}${L.targetPlatform?`?targetPlatform=${L.targetPlatform}`:""}`}}function ie(L,j){return L.files.filter(X=>X.assetType===j)[0]?{uri:`${L.assetUri}/${j}${L.targetPlatform?`?targetPlatform=${L.targetPlatform}`:""}`,fallbackUri:`${L.fallbackAssetUri}/${j}${L.targetPlatform?`?targetPlatform=${L.targetPlatform}`:""}`}:null}function ce(L,j){const q=L.properties?L.properties.filter(K=>K.key===j):[],X=q.length>0&&q[0].value;return X?X.split(",").map(K=>(0,f.$Gp)(K)):[]}function ue(L){const j=L.properties?L.properties.filter(q=>q.key===E.Engine):[];return j.length>0&&j[0].value||""}function le(L){const j=L.properties?L.properties.filter(q=>q.key===E.PreRelease):[];return j.length>0&&j[0].value==="true"}function x(L){const j=L.properties?L.properties.filter(X=>X.key===E.LocalizedLanguages):[],q=j.length>0&&j[0].value||"";return q?q.split(","):[]}function _(L){return L.properties?.find(j=>j.key===E.SponsorLink)?.value}function B(L){return L.properties?.find(j=>j.key===E.SupportLink)?.value}function U(L){return L.indexOf("preview")!==-1}function G(L){return L.targetPlatform?(0,c.$9o)(L.targetPlatform):p.TargetPlatform.UNDEFINED}function Z(L){const j=(0,O.$Mb)(L.versions.map(G)),q=!!L.tags?.includes(c.$3o),X=j.indexOf(p.TargetPlatform.WEB);return q?X===-1&&j.push(p.TargetPlatform.WEB):X!==-1&&j.splice(X,1),j}function Y(L,j){for(let q=0;q<L.length;q++){const X=L[q];if(X.version===L[q-1]?.version){let K=q;if(G(X)===j)for(;K>0&&L[K-1].version===X.version;)K--;K!==q&&(L.splice(q,1),L.splice(K,0,X))}}return L}function F(L,j,q){L.telemetryData={index:j,querySource:q,queryActivityId:L.queryContext?.[s]}}function z(L,j,q,X){const K=L.versions[0],re={manifest:ie(j,h.Manifest),readme:ie(j,h.Details),changelog:ie(j,h.Changelog),license:ie(j,h.License),repository:J(j),download:ae(j),icon:ie(j,h.Icon),signature:ie(j,h.Signature),coreTranslations:M(j)};return{type:"gallery",identifier:{id:(0,f.$Hp)(L.publisher.publisherName,L.extensionName),uuid:L.extensionId},name:L.extensionName,version:j.version,displayName:L.displayName,publisherId:L.publisher.publisherId,publisher:L.publisher.publisherName,publisherDisplayName:L.publisher.displayName,publisherDomain:L.publisher.domain?{link:L.publisher.domain,verified:!!L.publisher.isDomainVerified}:void 0,publisherSponsorLink:_(K),description:L.shortDescription??"",installCount:C(L.statistics,"install"),rating:C(L.statistics,"averagerating"),ratingCount:C(L.statistics,"ratingcount"),categories:L.categories||[],tags:L.tags||[],releaseDate:Date.parse(L.releaseDate),lastUpdated:Date.parse(L.lastUpdated),allTargetPlatforms:q,assets:re,properties:{dependencies:ce(j,E.Dependency),extensionPack:ce(j,E.ExtensionPack),engine:ue(j),localizedLanguages:x(j),targetPlatform:G(j),isPreReleaseVersion:le(j)},hasPreReleaseVersion:le(K),hasReleaseVersion:!0,preview:U(L.flags),isSigned:!!re.signature,queryContext:X,supportLink:B(K)}}let H=class{constructor(j,q,X,K,re,fe,he,ve){this.k=q,this.l=X,this.n=K,this.o=re,this.q=fe,this.u=he,this.w=ve;const me=he.extensionsGallery,ge=me?.servicePPEUrl&&ve.getValue("_extensionsGallery.enablePPE");this.d=ge?me.servicePPEUrl:me?.serviceUrl,this.g=ge?void 0:me?.searchUrl,this.h=me?.controlUrl,this.j=(0,P.$dq)(he.version,he,this.n,this.w,this.q,j,this.o)}x(j=""){return`${this.d}${j}`}isEnabled(){return!!this.d}async getExtensions(j,q,X){const K=k.CancellationToken.isCancellationToken(q)?{}:q,re=k.CancellationToken.isCancellationToken(q)?q:X,fe=[],he=[],ve=[],me=[];let ge=!0;for(const ye of j){ye.uuid?he.push(ye.uuid):fe.push(ye.id);const Ie=!!(ye.version||ye.preRelease);ve.push({id:ye.id,uuid:ye.uuid,includePreRelease:Ie}),ye.version&&me.push({id:ye.id,uuid:ye.uuid,version:ye.version}),ge=ge&&!!ye.hasPreRelease&&!Ie}if(!he.length&&!fe.length)return[];let de=new T().withPage(1,j.length);he.length&&(de=de.withFilter(r.ExtensionId,...he)),fe.length&&(de=de.withFilter(r.ExtensionName,...fe)),(K.queryAllVersions||ge)&&(de=de.withFlags(de.flags,e.IncludeVersions)),K.source&&(de=de.withSource(K.source));const{extensions:$e}=await this.z(de,{targetPlatform:K.targetPlatform??o,includePreRelease:ve,versions:me,compatible:!!K.compatible,productVersion:K.productVersion??{version:this.u.version,date:this.u.date}},re);return K.source&&$e.forEach((ye,Ie)=>F(ye,Ie,K.source)),$e}async getCompatibleExtension(j,q,X,K={version:this.u.version,date:this.u.date}){if((0,c.$$o)(j.allTargetPlatforms,X))return null;if(await this.isExtensionCompatible(j,q,X))return j;const re=new T().withFlags(e.IncludeVersions).withPage(1,1).withFilter(r.ExtensionId,j.identifier.uuid),{extensions:fe}=await this.z(re,{targetPlatform:X,compatible:!0,includePreRelease:q,productVersion:K},k.CancellationToken.None);return fe[0]||null}async isExtensionCompatible(j,q,X,K={version:this.u.version,date:this.u.date}){if(!(0,c.$_o)(j.properties.targetPlatform,j.allTargetPlatforms,X)||!q&&j.properties.isPreReleaseVersion)return!1;let re=j.properties.engine;if(!re){const fe=await this.getManifest(j,k.CancellationToken.None);if(!fe)throw new Error("Manifest was not found");re=fe.engines.vscode}return(0,y.$Up)(re,K.version,K.date)}async y(j,q,X,K,re,fe,he={version:this.u.version,date:this.u.date}){if(!(0,c.$_o)(G(q),re,fe)||X!=="any"&&le(q)!==(X==="prerelease"))return!1;if(K)try{const ve=await this.E(j,q);if(!(0,y.$Up)(ve,he.version,he.date))return!1}catch(ve){return this.l.error(`Error while getting the engine for the version ${q.version}.`,(0,v.$0)(ve)),!1}return!0}async query(j,q){let X=j.text||"";const K=j.pageSize??50;let re=new T().withPage(1,K);X?(X=X.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ge,de,$e)=>(re=re.withFilter(r.Category,$e||de),"")),X=X.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ge,de,$e)=>(re=re.withFilter(r.Tag,$e||de),"")),X=X.replace(/\bfeatured(\s+|\b|$)/g,()=>(re=re.withFilter(r.Featured),"")),X=X.trim(),X&&(X=X.length<200?X:X.substring(0,200),re=re.withFilter(r.SearchText,X)),re=re.withSortBy(c.SortBy.NoneOrRelevance)):j.ids?re=re.withFilter(r.ExtensionId,...j.ids):j.names?re=re.withFilter(r.ExtensionName,...j.names):re=re.withSortBy(c.SortBy.InstallCount),typeof j.sortBy=="number"&&(re=re.withSortBy(j.sortBy)),typeof j.sortOrder=="number"&&(re=re.withSortOrder(j.sortOrder)),j.source&&(re=re.withSource(j.source));const fe=async(ge,de)=>{const{extensions:$e,total:ye}=await this.z(ge,{targetPlatform:o,compatible:!1,includePreRelease:!!j.includePreRelease,productVersion:j.productVersion??{version:this.u.version,date:this.u.date}},de);return $e.forEach((Ie,W)=>F(Ie,(ge.pageNumber-1)*ge.pageSize+W,j.source)),{extensions:$e,total:ye}},{extensions:he,total:ve}=await fe(re,q),me=async(ge,de)=>{if(de.isCancellationRequested)throw new v.$5;const{extensions:$e}=await fe(re.withPage(ge+1),de);return $e};return{firstPage:he,total:ve,pageSize:re.pageSize,getPage:me}}async z(j,q,X){const K=j.flags;j.flags&e.IncludeLatestVersionOnly&&j.flags&e.IncludeVersions&&(j=j.withFlags(j.flags&~e.IncludeVersions,e.IncludeLatestVersionOnly)),!(j.flags&e.IncludeLatestVersionOnly)&&!(j.flags&e.IncludeVersions)&&(j=j.withFlags(j.flags,e.IncludeLatestVersionOnly)),q.versions?.length&&(j=j.withFlags(j.flags&~e.IncludeLatestVersionOnly,e.IncludeVersions)),j=j.withFlags(j.flags,e.IncludeAssetUri,e.IncludeCategoryAndTags,e.IncludeFiles,e.IncludeStatistics,e.IncludeVersionProperties);const{galleryExtensions:re,total:fe,context:he}=await this.B(j,X);if(!(j.flags&e.IncludeLatestVersionOnly)){const de=[];for(const $e of re){const ye=await this.A($e,q,he);ye&&de.push(ye)}return{extensions:de,total:fe}}const me=[],ge=new Map;for(let de=0;de<re.length;de++){const $e=re[de],ye={id:(0,f.$Hp)($e.publisher.publisherName,$e.extensionName),uuid:$e.extensionId},Ie=(0,S.$gg)(q.includePreRelease)?q.includePreRelease:!!q.includePreRelease.find(ee=>(0,f.$Cp)(ee,ye))?.includePreRelease;if(q.compatible&&(0,c.$$o)(Z($e),q.targetPlatform))continue;const W=await this.A($e,q,he);!W||W.properties.isPreReleaseVersion&&(!Ie||!W.hasReleaseVersion)||!W.properties.isPreReleaseVersion&&W.properties.targetPlatform!==q.targetPlatform&&W.hasPreReleaseVersion?ge.set($e.extensionId,de):me.push([de,W])}if(ge.size){const de=new i.$be,$e=new T().withFlags(K&~e.IncludeLatestVersionOnly,e.IncludeVersions).withPage(1,ge.size).withFilter(r.ExtensionId,...ge.keys()),{extensions:ye}=await this.z($e,q,X);this.o.publicLog2("galleryService:additionalQuery",{duration:de.elapsed(),count:ge.size});for(const Ie of ye){const W=ge.get(Ie.identifier.uuid);me.push([W,Ie])}}return{extensions:me.sort((de,$e)=>de[0]-$e[0]).map(([,de])=>de),total:fe}}async A(j,q,X){const K={id:(0,f.$Hp)(j.publisher.publisherName,j.extensionName),uuid:j.extensionId},re=q.versions?.find(me=>(0,f.$Cp)(me,K))?.version,fe=(0,S.$gg)(q.includePreRelease)?q.includePreRelease:!!q.includePreRelease.find(me=>(0,f.$Cp)(me,K))?.includePreRelease,he=Z(j),ve=Y(j.versions,q.targetPlatform);if(q.compatible&&(0,c.$$o)(he,q.targetPlatform))return null;for(let me=0;me<ve.length;me++){const ge=ve[me];if(!(re&&ge.version!==re)){if(await this.y((0,f.$Hp)(j.publisher.publisherName,j.extensionName),ge,fe?"any":"release",q.compatible,he,q.targetPlatform,q.productVersion))return z(j,ge,he,X);if(re&&ge.version===re)return null}}return re||q.compatible?null:z(j,j.versions[0],he)}async B(j,q){if(!this.isEnabled())throw new Error("No extension gallery service configured.");j=j.withFlags(j.flags,e.ExcludeNonValidated).withFilter(r.Target,"Microsoft.VisualStudio.Code").withFilter(r.ExcludeWithFlags,n(e.Unpublished));const X=await this.j,K=JSON.stringify(j.raw),re={...X,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(K.length)},fe=new i.$be;let he,ve,me=0;try{if(he=await this.k.request({type:"POST",url:this.g&&j.criteria.some(de=>de.filterType===r.SearchText)?this.g:this.x("/extensionquery"),data:K,headers:re},q),he.res.statusCode&&he.res.statusCode>=400&&he.res.statusCode<500)return{galleryExtensions:[],total:me};const ge=await(0,$.$2p)(he);if(ge){const de=ge.results[0],$e=de.extensions,ye=de.resultMetadata&&de.resultMetadata.filter(Ie=>Ie.metadataType==="ResultCount")[0];return me=ye&&ye.metadataItems.filter(Ie=>Ie.name==="TotalCount")[0].count||0,{galleryExtensions:$e,total:me,context:{[s]:he.res.headers.activityid}}}return{galleryExtensions:[],total:me}}catch(ge){const de=(0,v.$4)(ge)?c.ExtensionGalleryErrorCode.Cancelled:(0,v.$0)(ge).startsWith("XHR timeout")?c.ExtensionGalleryErrorCode.Timeout:c.ExtensionGalleryErrorCode.Failed;throw ve=new c.$cp((0,v.$0)(ge),de),ve}finally{this.o.publicLog2("galleryService:query",{...j.telemetryData,requestBodySize:String(K.length),duration:fe.elapsed(),success:!!he&&(0,$.$Xp)(he),responseBodySize:he?.res.headers["Content-Length"],statusCode:he?String(he.res.statusCode):void 0,errorCode:ve?.code,count:String(me)})}}async reportStatistic(j,q,X,K){if(!this.isEnabled())return;const re=I.$o?this.x(`/itemName/${j}.${q}/version/${X}/statType/${K===c.StatisticType.Install?"1":"3"}/vscodewebextension`):this.x(`/publishers/${j}/extensions/${q}/${X}/stats?statType=${K}`),fe=I.$o?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",ve={...await this.j,Accept:fe};try{await this.k.request({type:"POST",url:re,headers:ve},k.CancellationToken.None)}catch{}}async download(j,q,X){this.l.trace("ExtensionGalleryService#download",j.identifier.id);const K=(0,f.$Kp)(j),re=new Date().getTime(),fe=X===c.InstallOperation.Install?"install":X===c.InstallOperation.Update?"update":"",he=fe?{uri:`${j.assets.download.uri}${m.URI.parse(j.assets.download.uri).query?"&":"?"}${fe}=true`,fallbackUri:`${j.assets.download.fallbackUri}${m.URI.parse(j.assets.download.fallbackUri).query?"&":"?"}${fe}=true`}:j.assets.download,ve=j.queryContext?.[s]?{[s]:j.queryContext[s]}:void 0,me=await this.D(j.identifier.id,he,h.VSIX,ve?{headers:ve}:void 0);try{await this.q.writeFile(q,me.stream)}catch(ge){try{await this.q.del(q)}catch(de){this.l.warn(`Error while deleting the file ${q.toString()}`,(0,v.$0)(de))}throw new c.$cp((0,v.$0)(ge),c.ExtensionGalleryErrorCode.DownloadFailedWriting)}this.o.publicLog("galleryService:downloadVSIX",{...K,duration:new Date().getTime()-re})}async downloadSignatureArchive(j,q){if(!j.assets.signature)throw new Error("No signature asset found");this.l.trace("ExtensionGalleryService#downloadSignatureArchive",j.identifier.id);const X=await this.D(j.identifier.id,j.assets.signature,h.Signature);try{await this.q.writeFile(q,X.stream)}catch(K){try{await this.q.del(q)}catch(re){this.l.warn(`Error while deleting the file ${q.toString()}`,(0,v.$0)(re))}throw new c.$cp((0,v.$0)(K),c.ExtensionGalleryErrorCode.DownloadFailedWriting)}}async getReadme(j,q){if(j.assets.readme){const X=await this.D(j.identifier.id,j.assets.readme,h.Details,{},q);return await(0,$.$1p)(X)||""}return""}async getManifest(j,q){if(j.assets.manifest){const X=await this.D(j.identifier.id,j.assets.manifest,h.Manifest,{},q),K=await(0,$.$1p)(X);return K?JSON.parse(K):null}return null}async C(j,q,X){const K=ie(q,h.Manifest);if(!K)throw new Error("Manifest was not found");const re={"Accept-Encoding":"gzip"},fe=await this.D(j,K,h.Manifest,{headers:re});return await(0,$.$2p)(fe)}async getCoreTranslation(j,q){const X=j.assets.coreTranslations.filter(K=>K[0]===q.toUpperCase())[0];if(X){const K=await this.D(j.identifier.id,X[1],X[0]),re=await(0,$.$1p)(K);return re?JSON.parse(re):null}return null}async getChangelog(j,q){if(j.assets.changelog){const X=await this.D(j.identifier.id,j.assets.changelog,h.Changelog,{},q);return await(0,$.$1p)(X)||""}return""}async getAllCompatibleVersions(j,q,X){let K=new T().withFlags(e.IncludeVersions,e.IncludeCategoryAndTags,e.IncludeFiles,e.IncludeVersionProperties).withPage(1,1);j.identifier.uuid?K=K.withFilter(r.ExtensionId,j.identifier.uuid):K=K.withFilter(r.ExtensionName,j.identifier.id);const{galleryExtensions:re}=await this.B(K,k.CancellationToken.None);if(!re.length)return[];const fe=Z(re[0]);if((0,c.$$o)(fe,X))return[];const he=[];await Promise.all(re[0].versions.map(async ge=>{try{await this.y(j.identifier.id,ge,q?"any":"release",!0,fe,X)&&he.push(ge)}catch{}}));const ve=[],me=new Set;for(const ge of Y(he,X))me.has(ge.version)||(me.add(ge.version),ve.push({version:ge.version,date:ge.lastUpdated,isPreReleaseVersion:le(ge)}));return ve}async D(j,q,X,K={},re=k.CancellationToken.None){const fe=await this.j,he={type:"GET"},ve={...fe,...K.headers||{}};K={...K,...he,headers:ve};const me=q.uri,ge=q.fallbackUri,de={...K,url:me};try{const $e=await this.k.request(de,re);if($e.res.statusCode===200)return $e;const ye=await(0,$.$1p)($e);throw new Error(`Expected 200, got back ${$e.res.statusCode} instead.

${ye}`)}catch($e){if((0,v.$4)($e))throw $e;const ye=(0,v.$0)($e);this.o.publicLog2("galleryService:cdnFallback",{extension:j,assetType:X,message:ye});const Ie={...K,url:ge};return this.k.request(Ie,re)}}async E(j,q){let X=ue(q);if(!X){this.o.publicLog2("galleryService:engineFallback",{extension:j,version:q.version});const K=await this.C(j,q,k.CancellationToken.None);if(!K)throw new Error("Manifest was not found");X=K.engines.vscode}return X}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.h)return{malicious:[],deprecated:{},search:[]};const j=await this.k.request({type:"GET",url:this.h},k.CancellationToken.None);if(j.res.statusCode!==200)throw new Error("Could not get extensions report.");const q=await(0,$.$2p)(j),X=[],K={},re=[];if(q){for(const fe of q.malicious)X.push({id:fe});if(q.migrateToPreRelease)for(const[fe,he]of Object.entries(q.migrateToPreRelease))(!he.engine||(0,y.$Up)(he.engine,this.u.version,this.u.date))&&(K[fe.toLowerCase()]={disallowInstall:!0,extension:{id:he.id,displayName:he.displayName,autoMigrate:{storage:!!he.migrateStorage},preRelease:!0}});if(q.deprecated)for(const[fe,he]of Object.entries(q.deprecated))he&&(K[fe.toLowerCase()]=(0,S.$gg)(he)?{}:he);if(q.search)for(const fe of q.search)re.push(fe)}return{malicious:X,deprecated:K,search:re}}};H=we([ne(1,$.$Vp),ne(2,g.$7j),ne(3,l.$Hi),ne(4,u.$6l),ne(5,N.$7k),ne(6,d.$nk),ne(7,a.$7i)],H);let V=class extends H{constructor(j,q,X,K,re,fe,he,ve){super(j,q,X,K,re,fe,he,ve)}};t.$fq=V,t.$fq=V=we([ne(0,w.$9p),ne(1,$.$Vp),ne(2,g.$7j),ne(3,l.$Hi),ne(4,u.$6l),ne(5,N.$7k),ne(6,d.$nk),ne(7,a.$7i)],V);let b=class extends H{constructor(j,q,X,K,re,fe,he){super(void 0,j,q,X,K,re,fe,he)}};t.$gq=b,t.$gq=b=we([ne(0,$.$Vp),ne(1,g.$7j),ne(2,l.$Hi),ne(3,u.$6l),ne(4,N.$7k),ne(5,d.$nk),ne(6,a.$7i)],b)}),define(se[168],oe([0,1,12,18,10,6,147,23,24,3,70]),function(Q,t,O,k,v,I,D,S,m,a,l){"use strict";var c,f;Object.defineProperty(t,"__esModule",{value:!0}),t.$gQ=t.$fQ=t.$eQ=void 0;let p=class extends m.$Jl{static{c=this}static{this.a="profileAssociationsMigration"}constructor(d,$,P,w,u){super(P,w,$,u),this.U=d,this.W=P}O(){return this.U.getItem(c.b,[]).map($=>({...$,location:(0,a.$ag)($.location)?this.w.extUri.joinPath(this.profilesHome,$.location):O.URI.revive($.location)}))}Q(){const d=this.U.getItem(c.c,{});return this.U.getItem(c.a,!1)?d:this.N(d)}S(){return this.w.extUri.joinPath(O.URI.file(this.W.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};t.$eQ=p,t.$eQ=p=c=we([ne(0,D.$_P),ne(1,S.$El),ne(2,k.$Ii),ne(3,v.$7k),ne(4,I.$7j)],p);let y=f=class extends p{constructor(d,$,P,w,u){super(d,$,P,w,u),this.$=d}P(d){d.length?this.$.setItem(f.b,d.map($=>({...$,location:this.w.extUri.basename($.location)}))):this.$.removeItem(f.b)}O(){const d=super.O();return this.$.getItem("userDataProfilesMigration",!1)||(this.P(d),this.$.setItem("userDataProfilesMigration",!0)),d}R(d){d.emptyWindows||d.workspaces?this.$.setItem(f.c,d):this.$.removeItem(f.c)}Q(){const d="workspaceAndProfileInfo",$=this.$.getItem(d,void 0);if($){this.$.removeItem(d);const w=$.reduce((u,{workspace:i,profile:o})=>(u[O.URI.revive(i).toString()]=O.URI.revive(o).toString(),u),{});this.$.setItem(f.c,{workspaces:w})}const P=super.Q();return this.$.getItem(f.a,!1)||(this.R(P),this.$.setItem(f.a,!0)),P}};t.$fQ=y,t.$fQ=y=f=we([ne(0,D.$aQ),ne(1,S.$El),ne(2,k.$Ii),ne(3,v.$7k),ne(4,I.$7j)],y);let N=class extends y{constructor(d,$,P,w){super(new l.$dQ(l.SaveStrategy.IMMEDIATE,$,w,P),d,$,P,w)}async init(){return await this.$.init(),super.init()}};t.$gQ=N,t.$gQ=N=we([ne(0,S.$El),ne(1,k.$Ii),ne(2,v.$7k),ne(3,I.$7j)],N)}),define(se[169],oe([0,1,145,8,14,9,3,30,18,146,6,45,144,181]),function(Q,t,O,k,v,I,D,S,m,a,l,c,f,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$6r=void 0,t.$7r=g;let y=class extends c.$Wp{constructor($,P,w,u){super(u),this.m=$,this.n=P,this.r=w,this.s(),this.B($.onDidChangeConfiguration(i=>{i.affectsConfiguration("http")&&this.s()}))}s(){const $=this.m.getValue("http");this.f=$?.proxy,this.g=!!$?.proxyStrictSSL,this.h=$?.proxyAuthorization}async request($,P){const{f:w,g:u}=this;let i;try{i=await(0,a.$Lm)(this.m,this.r,this.n.args,process.env)}catch(e){this.j||(this.j=!0,this.r.error("resolving shell environment failed",(0,I.$0)(e)))}const o={...process.env,...i},s=$.agent?$.agent:await(0,f.$5r)($.url||"",o,{proxyUrl:w,strictSSL:u});return $.agent=s,$.strictSSL=u,this.h&&($.headers={...$.headers||{},"Proxy-Authorization":this.h}),this.c($.isChromiumNetwork?"electron":"node",$,()=>g($,P))}async resolveProxy($){}async loadCertificates(){return(await new Promise((P,w)=>{Q(["@vscode/proxy-agent"],P,w)})).loadSystemCertificates({log:this.r})}};t.$6r=y,t.$6r=y=we([ne(0,S.$7i),ne(1,m.$Ii),ne(2,l.$7j),ne(3,l.$8j)],y);async function N(d){return((0,O.parse)(d.url).protocol==="https:"?await new Promise((w,u)=>{Q(["https"],w,u)}):await new Promise((w,u)=>{Q(["http"],w,u)})).request}async function g(d,$){return k.Promises.withAsyncBody(async(P,w)=>{const u=(0,O.parse)(d.url),i=d.getRawRequest?d.getRawRequest(d):await N(d),o={hostname:u.hostname,port:u.port?parseInt(u.port):u.protocol==="https:"?443:80,protocol:u.protocol,path:u.path,method:d.type||"GET",headers:d.headers,agent:d.agent,rejectUnauthorized:(0,D.$gg)(d.strictSSL)?d.strictSSL:!0};d.user&&d.password&&(o.auth=d.user+":"+d.password);const s=i(o,e=>{const n=(0,D.$eg)(d.followRedirects)?d.followRedirects:3;if(e.statusCode&&e.statusCode>=300&&e.statusCode<400&&n>0&&e.headers.location)g({...d,url:e.headers.location,followRedirects:n-1},$).then(P,w);else{let r=e;!d.isChromiumNetwork&&e.headers["content-encoding"]==="gzip"&&(r=e.pipe((0,p.createGunzip)())),P({res:e,stream:(0,v.$Ye)(r)})}});s.on("error",w),d.timeout&&s.setTimeout(d.timeout),d.isChromiumNetwork&&s.removeHeader("Content-Length"),d.data&&typeof d.data=="string"&&s.write(d.data),s.end(),$.onCancellationRequested(()=>{s.abort(),w(new I.$5)})})}}),define(se[182],oe([0,1,35,8,36,9,2,15,16,13,37,12,25,30,141,62,143,18,120,167,21,72,148,42,54,162,164,10,131,133,51,129,65,69,150,6,137,39,138,153,33,45,169,70,71,19,152,41,154,155,23,157,24,168,156,163,134,136,4,158,183]),function(Q,t,O,k,v,I,D,S,m,a,l,c,f,p,y,N,g,d,$,P,w,u,i,o,s,e,n,r,h,E,R,A,T,C,M,J,ae,ie,ce,ue,le,x,_,B,U,G,Z,Y,F,z,H,V,b,L,j,q,X,K,re,fe,he){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.main=me;class ve extends D.$Uc{constructor(de){super(),this.b=de,this.c()}c(){process.once("exit",()=>this.dispose())}async run(){const[de,$e]=await this.f();return de.invokeFunction(async ye=>{const Ie=ye.get(J.$7j),W=ye.get(r.$7k),ee=ye.get(d.$Ii),te=ye.get(b.$Gl);Ie.info("CLI main",this.b),this.h(Ie),await this.j(ee,W,te,de),await Promise.all($e.map(pe=>{(0,k.$rh)(pe.flush(),1e3)}))})}async f(){const de=new T.$yi,$e={_serviceBrand:void 0,...ue.default};de.set(le.$nk,$e);const ye=new $.$bn(this.b,$e);de.set(d.$Ii,ye),await Promise.all([this.g(ye.appSettingsHome.with({scheme:S.Schemas.file}).fsPath),this.g(ye.extensionsPath)].map(Pe=>Pe?f.Promises.mkdir(Pe,{recursive:!0}):void 0));const Ie=new K.$$P((0,J.$ik)(ye),ye.logsHome);de.set(J.$8j,Ie);const W=this.B(Ie.createLogger("cli",{name:(0,re.localize)(0,null)})),ee=[];Ie.getLogLevel()===J.LogLevel.Trace&&ee.push(new J.$ck(Ie.getLogLevel()));const te=this.B(new X.$iQ(W,ee));de.set(J.$7j,te);const pe=this.B(new h.$Qq(te));de.set(r.$7k,pe);const be=this.B(new E.$hr(te));pe.registerProvider(S.Schemas.file,be);const Ae=new V.$Is(pe);de.set(H.$El,Ae);const Se=new B.$cQ(B.SaveStrategy.DELAYED,ye,te,pe),Te=new L.$eQ(Se,Ae,ye,pe,te);de.set(b.$Gl,Te),pe.registerProvider(S.Schemas.vscodeUserData,new fe.$Xec(S.Schemas.file,be,S.Schemas.vscodeUserData,Te,Ae,te));const Oe=a.$i&&$e.win32RegValueName?this.B(new ce.$Vec(te,$e.win32RegValueName)):ye.policyFile?this.B(new ae.$Wec(ye.policyFile,pe,te)):new ie.$no;de.set(ie.$lo,Oe);const De=this.B(new y.$No(Te.defaultProfile.settingsResource,pe,Oe,te));de.set(p.$7i,De),await Promise.all([Se.init(),De.initialize()]);let Ue;try{Ue=await(0,j.$xec)(Se,te)}catch(Pe){Pe.code!=="ENOENT"&&te.error(Pe)}const Ne=await(0,j.$yec)(Se,te),Le=await(0,j.$zec)(Se,te);Te.init(),de.set(H.$El,new V.$Is(pe));const Ce=new _.$6r(De,ye,te,Ie);de.set(x.$Vp,Ce),de.set(N.$Ro,new R.$xi(g.$xQ,void 0,!0)),de.set(o.$xq,new R.$xi(q.$hQ,void 0,!0)),de.set(s.$Bq,new R.$xi(n.$uec,void 0,!0)),de.set(u.$hq,new R.$xi(u.$jq,void 0,!0)),de.set(e.$Mq,new R.$xi(e.$Nq,void 0,!0)),de.set(w.$bp,new R.$xi(P.$gq,void 0,!0)),de.set(C.$Zr,new R.$xi(M.$2r,void 0,!1));const Fe=[],Ee=(0,Y.$zp)($e,De);if((0,Y.$up)($e,ye)){$e.aiConfig&&$e.aiConfig.ariaKey&&Fe.push(new F.$9P(Ce,Ee,"monacoworkbench",null,$e.aiConfig.ariaKey));const Pe={appenders:Fe,sendErrorTelemetry:!1,commonProperties:(0,U.$lp)((0,O.release)(),(0,O.hostname)(),process.arch,$e.commit,$e.version,Ue,Ne,Le,Ee),piiPaths:(0,Y.$Ap)(ye)};de.set(G.$6l,new R.$xi(Z.$8r,[Pe],!1))}else de.set(G.$6l,Y.$pp);return[new A.$kr(de),Fe]}g(de){if(a.$i){const $e=(0,he.getUNCHost)(de);$e&&(0,he.addUNCHostToAllowlist)($e)}return de}h(de){(0,I.setUnexpectedErrorHandler)($e=>{const ye=(0,v.$lj)($e,!0);ye&&de.error(`[uncaught exception in CLI]: ${ye}`)}),process.on("uncaughtException",$e=>{(0,I.$Z)($e)||(0,I.$1)($e)}),process.on("unhandledRejection",$e=>(0,I.$1)($e))}async j(de,$e,ye,Ie){let W;if(de.args.profile&&(W=ye.profiles.find(te=>te.name===de.args.profile),!W))throw new Error(`Profile '${de.args.profile}' not found.`);const ee=(W??ye.defaultProfile).extensionsResource;if(this.b["list-extensions"])return Ie.createInstance(i.$kq,new J.$ck(J.LogLevel.Info,!1)).listExtensions(!!this.b["show-versions"],this.b.category,ee);if(this.b["install-extension"]||this.b["install-builtin-extension"]){const te={isMachineScoped:!!this.b["do-not-sync"],installPreReleaseVersion:!!this.b["pre-release"],profileLocation:ee};return Ie.createInstance(i.$kq,new J.$ck(J.LogLevel.Info,!1)).installExtensions(this.m(this.b["install-extension"]||[]),this.m(this.b["install-builtin-extension"]||[]),te,!!this.b.force)}else{if(this.b["uninstall-extension"])return Ie.createInstance(i.$kq,new J.$ck(J.LogLevel.Info,!1)).uninstallExtensions(this.m(this.b["uninstall-extension"]),!!this.b.force,ee);if(this.b["update-extensions"])return Ie.createInstance(i.$kq,new J.$ck(J.LogLevel.Info,!1)).updateExtensions(ee);if(this.b["locate-extension"])return Ie.createInstance(i.$kq,new J.$ck(J.LogLevel.Info,!1)).locateExtension(this.b["locate-extension"]);this.b.telemetry&&console.log(await(0,z.$bfc)(de.appRoot,de.extensionsPath))}}m(de){return de.map($e=>/\.vsix$/i.test($e)?c.URI.file((0,m.$ic)($e)?$e:(0,m.$jc)((0,l.cwd)(),$e)):$e)}}async function me(ge){const de=new ve(ge);try{await de.run()}finally{de.dispose()}}})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/fd11ed87fdf1f8e46575e027644406f51f0666f6/core/vs/code/node/cliProcessMain.js.map
