/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ge=["require","exports","vs/base/common/platform","vs/base/common/errors","vs/base/common/path","vs/base/common/uri","vs/base/common/lifecycle","vs/base/common/cancellation","vs/base/common/types","vs/base/common/charCode","vs/base/common/event","vs/base/common/buffer","vs/base/common/strings","vs/base/common/lazy","vs/base/common/objects","vs/base/common/process","vs/base/common/network","vs/base/common/async","vs/base/common/arrays","vs/base/common/functional","vs/base/common/map","vs/base/common/marshallingIds","vs/base/common/extpath","vs/base/common/processes","vs/base/common/resources","vs/base/common/amd","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/decorators","vs/base/common/iterator","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/stopwatch","vs/base/common/cache","vs/base/common/stream","vs/base/common/symbols","vs/base/common/uint","vs/base/common/uuid","vs/nls!vs/base/common/platform","vs/base/common/console","vs/base/common/marshalling","vs/amdX","vs/base/node/pfs","vs/base/node/processes","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/node/ipc.cp","vs/platform/instantiation/common/instantiation","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryUtils","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/node/1dsAppender","vs/nls","vs/nls!vs/workbench/contrib/debug/node/telemetryApp","fs","os","util","child_process","https","vs/workbench/contrib/debug/node/telemetryApp"],me=function(fe){for(var e=[],f=0,t=fe.length;f<t;f++)e[f]=ge[fe[f]];return e};define(ge[25],me([0,1]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U=e.$T=void 0,e.$T=!1;class f{static get(){const P=new Map,b=new Map,q=new Map,L=new Map;function a(N,R){N.has(R.detail)||N.set(R.detail,-R.timestamp)}function g(N,R){const s=N.get(R.detail);s&&(s>=0||N.set(R.detail,s+R.timestamp))}let M=[];typeof fe=="function"&&typeof fe.getStats=="function"&&(M=fe.getStats().slice(0).sort((N,R)=>N.timestamp-R.timestamp));for(const N of M)switch(N.type){case LoaderEventType.BeginLoadingScript:a(P,N);break;case LoaderEventType.EndLoadingScriptOK:case LoaderEventType.EndLoadingScriptError:g(P,N);break;case LoaderEventType.BeginInvokeFactory:a(b,N);break;case LoaderEventType.EndInvokeFactory:g(b,N);break;case LoaderEventType.NodeBeginNativeRequire:a(q,N);break;case LoaderEventType.NodeEndNativeRequire:g(q,N);break;case LoaderEventType.NodeBeginEvaluatingScript:a(L,N);break;case LoaderEventType.NodeEndEvaluatingScript:g(L,N);break}let H=0;q.forEach(N=>H+=N);function A(N){const R=[];return N.forEach((s,w)=>R.push([w,s])),R}return{amdLoad:A(P),amdInvoke:A(b),nodeRequire:A(q),nodeEval:A(L),nodeRequireTotal:H}}static toMarkdownTable(P,b){let q="";const L=[];return P.forEach((a,g)=>{L[g]=a.length}),b.forEach(a=>{a.forEach((g,M)=>{typeof g>"u"&&(g=a[M]="-");const H=g.toString().length;L[M]=Math.max(H,L[M])})}),P.forEach((a,g)=>{q+=`| ${a+" ".repeat(L[g]-a.toString().length)} `}),q+=`|
`,P.forEach((a,g)=>{q+=`| ${"-".repeat(L[g])} `}),q+=`|
`,b.forEach(a=>{a.forEach((g,M)=>{typeof g<"u"&&(q+=`| ${g+" ".repeat(L[M]-g.toString().length)} `)}),q+=`|
`}),q}}e.$U=f}),define(ge[26],me([0,1]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mb=void 0,e.$fb=f,e.$gb=t,e.$hb=P,e.$ib=b,e.$jb=q,e.$kb=L,e.$lb=a,e.$nb=M,e.$ob=H,e.$pb=A,e.$qb=N,e.$rb=R;function f(s,w){const T=t(s,w);if(T!==-1)return s[T]}function t(s,w,T=s.length-1){for(let m=T;m>=0;m--){const D=s[m];if(w(D))return m}return-1}function P(s,w){const T=b(s,w);return T===-1?void 0:s[T]}function b(s,w,T=0,m=s.length){let D=T,p=m;for(;D<p;){const o=Math.floor((D+p)/2);w(s[o])?D=o+1:p=o}return D-1}function q(s,w){const T=L(s,w);return T===s.length?void 0:s[T]}function L(s,w,T=0,m=s.length){let D=T,p=m;for(;D<p;){const o=Math.floor((D+p)/2);w(s[o])?p=o:D=o+1}return D}function a(s,w,T=0,m=s.length){const D=L(s,w,T,m);return D===s.length?-1:D}class g{static{this.assertInvariants=!1}constructor(w){this.e=w,this.c=0}findLastMonotonous(w){if(g.assertInvariants){if(this.d){for(const m of this.e)if(this.d(m)&&!w(m))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=w}const T=b(this.e,w,this.c);return this.c=T+1,T===-1?void 0:this.e[T]}}e.$mb=g;function M(s,w){if(s.length===0)return;let T=s[0];for(let m=1;m<s.length;m++){const D=s[m];w(D,T)>0&&(T=D)}return T}function H(s,w){if(s.length===0)return;let T=s[0];for(let m=1;m<s.length;m++){const D=s[m];w(D,T)>=0&&(T=D)}return T}function A(s,w){return M(s,(T,m)=>-w(T,m))}function N(s,w){if(s.length===0)return-1;let T=0;for(let m=1;m<s.length;m++){const D=s[m];w(D,s[T])>0&&(T=m)}return T}function R(s,w){for(const T of s){const m=w(T);if(m!==void 0)return m}}}),define(ge[9],me([0,1]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharCode=void 0;var f;(function(t){t[t.Null=0]="Null",t[t.Backspace=8]="Backspace",t[t.Tab=9]="Tab",t[t.LineFeed=10]="LineFeed",t[t.CarriageReturn=13]="CarriageReturn",t[t.Space=32]="Space",t[t.ExclamationMark=33]="ExclamationMark",t[t.DoubleQuote=34]="DoubleQuote",t[t.Hash=35]="Hash",t[t.DollarSign=36]="DollarSign",t[t.PercentSign=37]="PercentSign",t[t.Ampersand=38]="Ampersand",t[t.SingleQuote=39]="SingleQuote",t[t.OpenParen=40]="OpenParen",t[t.CloseParen=41]="CloseParen",t[t.Asterisk=42]="Asterisk",t[t.Plus=43]="Plus",t[t.Comma=44]="Comma",t[t.Dash=45]="Dash",t[t.Period=46]="Period",t[t.Slash=47]="Slash",t[t.Digit0=48]="Digit0",t[t.Digit1=49]="Digit1",t[t.Digit2=50]="Digit2",t[t.Digit3=51]="Digit3",t[t.Digit4=52]="Digit4",t[t.Digit5=53]="Digit5",t[t.Digit6=54]="Digit6",t[t.Digit7=55]="Digit7",t[t.Digit8=56]="Digit8",t[t.Digit9=57]="Digit9",t[t.Colon=58]="Colon",t[t.Semicolon=59]="Semicolon",t[t.LessThan=60]="LessThan",t[t.Equals=61]="Equals",t[t.GreaterThan=62]="GreaterThan",t[t.QuestionMark=63]="QuestionMark",t[t.AtSign=64]="AtSign",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.OpenSquareBracket=91]="OpenSquareBracket",t[t.Backslash=92]="Backslash",t[t.CloseSquareBracket=93]="CloseSquareBracket",t[t.Caret=94]="Caret",t[t.Underline=95]="Underline",t[t.BackTick=96]="BackTick",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.OpenCurlyBrace=123]="OpenCurlyBrace",t[t.Pipe=124]="Pipe",t[t.CloseCurlyBrace=125]="CloseCurlyBrace",t[t.Tilde=126]="Tilde",t[t.NoBreakSpace=160]="NoBreakSpace",t[t.U_Combining_Grave_Accent=768]="U_Combining_Grave_Accent",t[t.U_Combining_Acute_Accent=769]="U_Combining_Acute_Accent",t[t.U_Combining_Circumflex_Accent=770]="U_Combining_Circumflex_Accent",t[t.U_Combining_Tilde=771]="U_Combining_Tilde",t[t.U_Combining_Macron=772]="U_Combining_Macron",t[t.U_Combining_Overline=773]="U_Combining_Overline",t[t.U_Combining_Breve=774]="U_Combining_Breve",t[t.U_Combining_Dot_Above=775]="U_Combining_Dot_Above",t[t.U_Combining_Diaeresis=776]="U_Combining_Diaeresis",t[t.U_Combining_Hook_Above=777]="U_Combining_Hook_Above",t[t.U_Combining_Ring_Above=778]="U_Combining_Ring_Above",t[t.U_Combining_Double_Acute_Accent=779]="U_Combining_Double_Acute_Accent",t[t.U_Combining_Caron=780]="U_Combining_Caron",t[t.U_Combining_Vertical_Line_Above=781]="U_Combining_Vertical_Line_Above",t[t.U_Combining_Double_Vertical_Line_Above=782]="U_Combining_Double_Vertical_Line_Above",t[t.U_Combining_Double_Grave_Accent=783]="U_Combining_Double_Grave_Accent",t[t.U_Combining_Candrabindu=784]="U_Combining_Candrabindu",t[t.U_Combining_Inverted_Breve=785]="U_Combining_Inverted_Breve",t[t.U_Combining_Turned_Comma_Above=786]="U_Combining_Turned_Comma_Above",t[t.U_Combining_Comma_Above=787]="U_Combining_Comma_Above",t[t.U_Combining_Reversed_Comma_Above=788]="U_Combining_Reversed_Comma_Above",t[t.U_Combining_Comma_Above_Right=789]="U_Combining_Comma_Above_Right",t[t.U_Combining_Grave_Accent_Below=790]="U_Combining_Grave_Accent_Below",t[t.U_Combining_Acute_Accent_Below=791]="U_Combining_Acute_Accent_Below",t[t.U_Combining_Left_Tack_Below=792]="U_Combining_Left_Tack_Below",t[t.U_Combining_Right_Tack_Below=793]="U_Combining_Right_Tack_Below",t[t.U_Combining_Left_Angle_Above=794]="U_Combining_Left_Angle_Above",t[t.U_Combining_Horn=795]="U_Combining_Horn",t[t.U_Combining_Left_Half_Ring_Below=796]="U_Combining_Left_Half_Ring_Below",t[t.U_Combining_Up_Tack_Below=797]="U_Combining_Up_Tack_Below",t[t.U_Combining_Down_Tack_Below=798]="U_Combining_Down_Tack_Below",t[t.U_Combining_Plus_Sign_Below=799]="U_Combining_Plus_Sign_Below",t[t.U_Combining_Minus_Sign_Below=800]="U_Combining_Minus_Sign_Below",t[t.U_Combining_Palatalized_Hook_Below=801]="U_Combining_Palatalized_Hook_Below",t[t.U_Combining_Retroflex_Hook_Below=802]="U_Combining_Retroflex_Hook_Below",t[t.U_Combining_Dot_Below=803]="U_Combining_Dot_Below",t[t.U_Combining_Diaeresis_Below=804]="U_Combining_Diaeresis_Below",t[t.U_Combining_Ring_Below=805]="U_Combining_Ring_Below",t[t.U_Combining_Comma_Below=806]="U_Combining_Comma_Below",t[t.U_Combining_Cedilla=807]="U_Combining_Cedilla",t[t.U_Combining_Ogonek=808]="U_Combining_Ogonek",t[t.U_Combining_Vertical_Line_Below=809]="U_Combining_Vertical_Line_Below",t[t.U_Combining_Bridge_Below=810]="U_Combining_Bridge_Below",t[t.U_Combining_Inverted_Double_Arch_Below=811]="U_Combining_Inverted_Double_Arch_Below",t[t.U_Combining_Caron_Below=812]="U_Combining_Caron_Below",t[t.U_Combining_Circumflex_Accent_Below=813]="U_Combining_Circumflex_Accent_Below",t[t.U_Combining_Breve_Below=814]="U_Combining_Breve_Below",t[t.U_Combining_Inverted_Breve_Below=815]="U_Combining_Inverted_Breve_Below",t[t.U_Combining_Tilde_Below=816]="U_Combining_Tilde_Below",t[t.U_Combining_Macron_Below=817]="U_Combining_Macron_Below",t[t.U_Combining_Low_Line=818]="U_Combining_Low_Line",t[t.U_Combining_Double_Low_Line=819]="U_Combining_Double_Low_Line",t[t.U_Combining_Tilde_Overlay=820]="U_Combining_Tilde_Overlay",t[t.U_Combining_Short_Stroke_Overlay=821]="U_Combining_Short_Stroke_Overlay",t[t.U_Combining_Long_Stroke_Overlay=822]="U_Combining_Long_Stroke_Overlay",t[t.U_Combining_Short_Solidus_Overlay=823]="U_Combining_Short_Solidus_Overlay",t[t.U_Combining_Long_Solidus_Overlay=824]="U_Combining_Long_Solidus_Overlay",t[t.U_Combining_Right_Half_Ring_Below=825]="U_Combining_Right_Half_Ring_Below",t[t.U_Combining_Inverted_Bridge_Below=826]="U_Combining_Inverted_Bridge_Below",t[t.U_Combining_Square_Below=827]="U_Combining_Square_Below",t[t.U_Combining_Seagull_Below=828]="U_Combining_Seagull_Below",t[t.U_Combining_X_Above=829]="U_Combining_X_Above",t[t.U_Combining_Vertical_Tilde=830]="U_Combining_Vertical_Tilde",t[t.U_Combining_Double_Overline=831]="U_Combining_Double_Overline",t[t.U_Combining_Grave_Tone_Mark=832]="U_Combining_Grave_Tone_Mark",t[t.U_Combining_Acute_Tone_Mark=833]="U_Combining_Acute_Tone_Mark",t[t.U_Combining_Greek_Perispomeni=834]="U_Combining_Greek_Perispomeni",t[t.U_Combining_Greek_Koronis=835]="U_Combining_Greek_Koronis",t[t.U_Combining_Greek_Dialytika_Tonos=836]="U_Combining_Greek_Dialytika_Tonos",t[t.U_Combining_Greek_Ypogegrammeni=837]="U_Combining_Greek_Ypogegrammeni",t[t.U_Combining_Bridge_Above=838]="U_Combining_Bridge_Above",t[t.U_Combining_Equals_Sign_Below=839]="U_Combining_Equals_Sign_Below",t[t.U_Combining_Double_Vertical_Line_Below=840]="U_Combining_Double_Vertical_Line_Below",t[t.U_Combining_Left_Angle_Below=841]="U_Combining_Left_Angle_Below",t[t.U_Combining_Not_Tilde_Above=842]="U_Combining_Not_Tilde_Above",t[t.U_Combining_Homothetic_Above=843]="U_Combining_Homothetic_Above",t[t.U_Combining_Almost_Equal_To_Above=844]="U_Combining_Almost_Equal_To_Above",t[t.U_Combining_Left_Right_Arrow_Below=845]="U_Combining_Left_Right_Arrow_Below",t[t.U_Combining_Upwards_Arrow_Below=846]="U_Combining_Upwards_Arrow_Below",t[t.U_Combining_Grapheme_Joiner=847]="U_Combining_Grapheme_Joiner",t[t.U_Combining_Right_Arrowhead_Above=848]="U_Combining_Right_Arrowhead_Above",t[t.U_Combining_Left_Half_Ring_Above=849]="U_Combining_Left_Half_Ring_Above",t[t.U_Combining_Fermata=850]="U_Combining_Fermata",t[t.U_Combining_X_Below=851]="U_Combining_X_Below",t[t.U_Combining_Left_Arrowhead_Below=852]="U_Combining_Left_Arrowhead_Below",t[t.U_Combining_Right_Arrowhead_Below=853]="U_Combining_Right_Arrowhead_Below",t[t.U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below=854]="U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below",t[t.U_Combining_Right_Half_Ring_Above=855]="U_Combining_Right_Half_Ring_Above",t[t.U_Combining_Dot_Above_Right=856]="U_Combining_Dot_Above_Right",t[t.U_Combining_Asterisk_Below=857]="U_Combining_Asterisk_Below",t[t.U_Combining_Double_Ring_Below=858]="U_Combining_Double_Ring_Below",t[t.U_Combining_Zigzag_Above=859]="U_Combining_Zigzag_Above",t[t.U_Combining_Double_Breve_Below=860]="U_Combining_Double_Breve_Below",t[t.U_Combining_Double_Breve=861]="U_Combining_Double_Breve",t[t.U_Combining_Double_Macron=862]="U_Combining_Double_Macron",t[t.U_Combining_Double_Macron_Below=863]="U_Combining_Double_Macron_Below",t[t.U_Combining_Double_Tilde=864]="U_Combining_Double_Tilde",t[t.U_Combining_Double_Inverted_Breve=865]="U_Combining_Double_Inverted_Breve",t[t.U_Combining_Double_Rightwards_Arrow_Below=866]="U_Combining_Double_Rightwards_Arrow_Below",t[t.U_Combining_Latin_Small_Letter_A=867]="U_Combining_Latin_Small_Letter_A",t[t.U_Combining_Latin_Small_Letter_E=868]="U_Combining_Latin_Small_Letter_E",t[t.U_Combining_Latin_Small_Letter_I=869]="U_Combining_Latin_Small_Letter_I",t[t.U_Combining_Latin_Small_Letter_O=870]="U_Combining_Latin_Small_Letter_O",t[t.U_Combining_Latin_Small_Letter_U=871]="U_Combining_Latin_Small_Letter_U",t[t.U_Combining_Latin_Small_Letter_C=872]="U_Combining_Latin_Small_Letter_C",t[t.U_Combining_Latin_Small_Letter_D=873]="U_Combining_Latin_Small_Letter_D",t[t.U_Combining_Latin_Small_Letter_H=874]="U_Combining_Latin_Small_Letter_H",t[t.U_Combining_Latin_Small_Letter_M=875]="U_Combining_Latin_Small_Letter_M",t[t.U_Combining_Latin_Small_Letter_R=876]="U_Combining_Latin_Small_Letter_R",t[t.U_Combining_Latin_Small_Letter_T=877]="U_Combining_Latin_Small_Letter_T",t[t.U_Combining_Latin_Small_Letter_V=878]="U_Combining_Latin_Small_Letter_V",t[t.U_Combining_Latin_Small_Letter_X=879]="U_Combining_Latin_Small_Letter_X",t[t.LINE_SEPARATOR=8232]="LINE_SEPARATOR",t[t.PARAGRAPH_SEPARATOR=8233]="PARAGRAPH_SEPARATOR",t[t.NEXT_LINE=133]="NEXT_LINE",t[t.U_CIRCUMFLEX=94]="U_CIRCUMFLEX",t[t.U_GRAVE_ACCENT=96]="U_GRAVE_ACCENT",t[t.U_DIAERESIS=168]="U_DIAERESIS",t[t.U_MACRON=175]="U_MACRON",t[t.U_ACUTE_ACCENT=180]="U_ACUTE_ACCENT",t[t.U_CEDILLA=184]="U_CEDILLA",t[t.U_MODIFIER_LETTER_LEFT_ARROWHEAD=706]="U_MODIFIER_LETTER_LEFT_ARROWHEAD",t[t.U_MODIFIER_LETTER_RIGHT_ARROWHEAD=707]="U_MODIFIER_LETTER_RIGHT_ARROWHEAD",t[t.U_MODIFIER_LETTER_UP_ARROWHEAD=708]="U_MODIFIER_LETTER_UP_ARROWHEAD",t[t.U_MODIFIER_LETTER_DOWN_ARROWHEAD=709]="U_MODIFIER_LETTER_DOWN_ARROWHEAD",t[t.U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING=722]="U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING",t[t.U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING=723]="U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING",t[t.U_MODIFIER_LETTER_UP_TACK=724]="U_MODIFIER_LETTER_UP_TACK",t[t.U_MODIFIER_LETTER_DOWN_TACK=725]="U_MODIFIER_LETTER_DOWN_TACK",t[t.U_MODIFIER_LETTER_PLUS_SIGN=726]="U_MODIFIER_LETTER_PLUS_SIGN",t[t.U_MODIFIER_LETTER_MINUS_SIGN=727]="U_MODIFIER_LETTER_MINUS_SIGN",t[t.U_BREVE=728]="U_BREVE",t[t.U_DOT_ABOVE=729]="U_DOT_ABOVE",t[t.U_RING_ABOVE=730]="U_RING_ABOVE",t[t.U_OGONEK=731]="U_OGONEK",t[t.U_SMALL_TILDE=732]="U_SMALL_TILDE",t[t.U_DOUBLE_ACUTE_ACCENT=733]="U_DOUBLE_ACUTE_ACCENT",t[t.U_MODIFIER_LETTER_RHOTIC_HOOK=734]="U_MODIFIER_LETTER_RHOTIC_HOOK",t[t.U_MODIFIER_LETTER_CROSS_ACCENT=735]="U_MODIFIER_LETTER_CROSS_ACCENT",t[t.U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR=741]="U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR",t[t.U_MODIFIER_LETTER_HIGH_TONE_BAR=742]="U_MODIFIER_LETTER_HIGH_TONE_BAR",t[t.U_MODIFIER_LETTER_MID_TONE_BAR=743]="U_MODIFIER_LETTER_MID_TONE_BAR",t[t.U_MODIFIER_LETTER_LOW_TONE_BAR=744]="U_MODIFIER_LETTER_LOW_TONE_BAR",t[t.U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR=745]="U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR",t[t.U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK=746]="U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK",t[t.U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK=747]="U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK",t[t.U_MODIFIER_LETTER_UNASPIRATED=749]="U_MODIFIER_LETTER_UNASPIRATED",t[t.U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD=751]="U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD",t[t.U_MODIFIER_LETTER_LOW_UP_ARROWHEAD=752]="U_MODIFIER_LETTER_LOW_UP_ARROWHEAD",t[t.U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD=753]="U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD",t[t.U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD=754]="U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD",t[t.U_MODIFIER_LETTER_LOW_RING=755]="U_MODIFIER_LETTER_LOW_RING",t[t.U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT=756]="U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT",t[t.U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT=757]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT",t[t.U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT=758]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT",t[t.U_MODIFIER_LETTER_LOW_TILDE=759]="U_MODIFIER_LETTER_LOW_TILDE",t[t.U_MODIFIER_LETTER_RAISED_COLON=760]="U_MODIFIER_LETTER_RAISED_COLON",t[t.U_MODIFIER_LETTER_BEGIN_HIGH_TONE=761]="U_MODIFIER_LETTER_BEGIN_HIGH_TONE",t[t.U_MODIFIER_LETTER_END_HIGH_TONE=762]="U_MODIFIER_LETTER_END_HIGH_TONE",t[t.U_MODIFIER_LETTER_BEGIN_LOW_TONE=763]="U_MODIFIER_LETTER_BEGIN_LOW_TONE",t[t.U_MODIFIER_LETTER_END_LOW_TONE=764]="U_MODIFIER_LETTER_END_LOW_TONE",t[t.U_MODIFIER_LETTER_SHELF=765]="U_MODIFIER_LETTER_SHELF",t[t.U_MODIFIER_LETTER_OPEN_SHELF=766]="U_MODIFIER_LETTER_OPEN_SHELF",t[t.U_MODIFIER_LETTER_LOW_LEFT_ARROW=767]="U_MODIFIER_LETTER_LOW_LEFT_ARROW",t[t.U_GREEK_LOWER_NUMERAL_SIGN=885]="U_GREEK_LOWER_NUMERAL_SIGN",t[t.U_GREEK_TONOS=900]="U_GREEK_TONOS",t[t.U_GREEK_DIALYTIKA_TONOS=901]="U_GREEK_DIALYTIKA_TONOS",t[t.U_GREEK_KORONIS=8125]="U_GREEK_KORONIS",t[t.U_GREEK_PSILI=8127]="U_GREEK_PSILI",t[t.U_GREEK_PERISPOMENI=8128]="U_GREEK_PERISPOMENI",t[t.U_GREEK_DIALYTIKA_AND_PERISPOMENI=8129]="U_GREEK_DIALYTIKA_AND_PERISPOMENI",t[t.U_GREEK_PSILI_AND_VARIA=8141]="U_GREEK_PSILI_AND_VARIA",t[t.U_GREEK_PSILI_AND_OXIA=8142]="U_GREEK_PSILI_AND_OXIA",t[t.U_GREEK_PSILI_AND_PERISPOMENI=8143]="U_GREEK_PSILI_AND_PERISPOMENI",t[t.U_GREEK_DASIA_AND_VARIA=8157]="U_GREEK_DASIA_AND_VARIA",t[t.U_GREEK_DASIA_AND_OXIA=8158]="U_GREEK_DASIA_AND_OXIA",t[t.U_GREEK_DASIA_AND_PERISPOMENI=8159]="U_GREEK_DASIA_AND_PERISPOMENI",t[t.U_GREEK_DIALYTIKA_AND_VARIA=8173]="U_GREEK_DIALYTIKA_AND_VARIA",t[t.U_GREEK_DIALYTIKA_AND_OXIA=8174]="U_GREEK_DIALYTIKA_AND_OXIA",t[t.U_GREEK_VARIA=8175]="U_GREEK_VARIA",t[t.U_GREEK_OXIA=8189]="U_GREEK_OXIA",t[t.U_GREEK_DASIA=8190]="U_GREEK_DASIA",t[t.U_IDEOGRAPHIC_FULL_STOP=12290]="U_IDEOGRAPHIC_FULL_STOP",t[t.U_LEFT_CORNER_BRACKET=12300]="U_LEFT_CORNER_BRACKET",t[t.U_RIGHT_CORNER_BRACKET=12301]="U_RIGHT_CORNER_BRACKET",t[t.U_LEFT_BLACK_LENTICULAR_BRACKET=12304]="U_LEFT_BLACK_LENTICULAR_BRACKET",t[t.U_RIGHT_BLACK_LENTICULAR_BRACKET=12305]="U_RIGHT_BLACK_LENTICULAR_BRACKET",t[t.U_OVERLINE=8254]="U_OVERLINE",t[t.UTF8_BOM=65279]="UTF8_BOM",t[t.U_FULLWIDTH_SEMICOLON=65307]="U_FULLWIDTH_SEMICOLON",t[t.U_FULLWIDTH_COMMA=65292]="U_FULLWIDTH_COMMA"})(f||(e.CharCode=f={}))}),define(ge[27],me([0,1]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$K=f,e.$L=t,e.$M=P,e.$N=b;function f(q,L){const a=Object.create(null);for(const g of q){const M=L(g);let H=a[M];H||(H=a[M]=[]),H.push(g)}return a}function t(q,L){const a=[],g=[];for(const M of q)L.has(M)||a.push(M);for(const M of L)q.has(M)||g.push(M);return{removed:a,added:g}}function P(q,L){const a=[],g=[];for(const[M,H]of q)L.has(M)||a.push(H);for(const[M,H]of L)q.has(M)||g.push(H);return{removed:a,added:g}}function b(q,L){const a=new Set;for(const g of L)q.has(g)&&a.add(g);return a}}),define(ge[28],me([0,1]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5h=t,e.$6h=P,e.$7h=b;function f(q){return(L,a,g)=>{let M=null,H=null;if(typeof g.value=="function"?(M="value",H=g.value):typeof g.get=="function"&&(M="get",H=g.get),!H)throw new Error("not supported");g[M]=q(H,a)}}function t(q,L,a){let g=null,M=null;if(typeof a.value=="function"?(g="value",M=a.value,M.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof a.get=="function"&&(g="get",M=a.get),!M)throw new Error("not supported");const H=`$memoize$${L}`;a[g]=function(...A){return this.hasOwnProperty(H)||Object.defineProperty(this,H,{configurable:!1,enumerable:!1,writable:!1,value:M.apply(this,A)}),this[H]}}function P(q,L,a){return f((g,M)=>{const H=`$debounce$${M}`,A=`$debounce$result$${M}`;return function(...N){this[A]||(this[A]=a?a():void 0),clearTimeout(this[H]),L&&(this[A]=L(this[A],...N),N=[this[A]]),this[H]=setTimeout(()=>{g.apply(this,N),this[A]=a?a():void 0},q)}})}function b(q,L,a){return f((g,M)=>{const H=`$throttle$timer$${M}`,A=`$throttle$result$${M}`,N=`$throttle$lastRun$${M}`,R=`$throttle$pending$${M}`;return function(...s){if(this[A]||(this[A]=a?a():void 0),(this[N]===null||this[N]===void 0)&&(this[N]=-Number.MAX_VALUE),L&&(this[A]=L(this[A],...s)),this[R])return;const w=this[N]+q;w<=Date.now()?(this[N]=Date.now(),g.apply(this,[this[A]]),this[A]=a?a():void 0):(this[R]=!0,this[H]=setTimeout(()=>{this[R]=!1,this[N]=Date.now(),g.apply(this,[this[A]]),this[A]=a?a():void 0},w-Date.now()))}})}}),define(ge[3],me([0,1]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cb=e.$bb=e.$ab=e.$_=e.$$=e.$9=e.$5=e.$X=e.$W=void 0,e.setUnexpectedErrorHandler=t,e.$Z=P,e.$1=b,e.$2=q,e.$3=L,e.$4=g,e.$6=H,e.$7=A,e.$8=N,e.$0=s;class f{constructor(){this.b=[],this.a=function(n){setTimeout(()=>{throw n.stack?D.isErrorNoTelemetry(n)?new D(n.message+`

`+n.stack):new Error(n.message+`

`+n.stack):n},0)}}addListener(n){return this.b.push(n),()=>{this.d(n)}}c(n){this.b.forEach(i=>{i(n)})}d(n){this.b.splice(this.b.indexOf(n),1)}setUnexpectedErrorHandler(n){this.a=n}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(n){this.a(n),this.c(n)}onUnexpectedExternalError(n){this.a(n)}}e.$W=f,e.$X=new f;function t(o){e.$X.setUnexpectedErrorHandler(o)}function P(o){if(!o||typeof o!="object")return!1;const n=o;return n.code==="EPIPE"&&n.syscall?.toUpperCase()==="WRITE"}function b(o){g(o)||e.$X.onUnexpectedError(o)}function q(o){g(o)||e.$X.onUnexpectedExternalError(o)}function L(o){if(o instanceof Error){const{name:n,message:i}=o,r=o.stacktrace||o.stack;return{$isError:!0,name:n,message:i,stack:r,noTelemetry:D.isErrorNoTelemetry(o)}}return o}const a="Canceled";function g(o){return o instanceof M?!0:o instanceof Error&&o.name===a&&o.message===a}class M extends Error{constructor(){super(a),this.name=this.message}}e.$5=M;function H(){const o=new Error(a);return o.name=o.message,o}function A(o){return o?new Error(`Illegal argument: ${o}`):new Error("Illegal argument")}function N(o){return o?new Error(`Illegal state: ${o}`):new Error("Illegal state")}class R extends TypeError{constructor(n){super(n?`${n} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$9=R;function s(o){return o?o.message?o.message:o.stack?o.stack.split(`
`)[0]:String(o):"Error"}class w extends Error{constructor(n){super("NotImplemented"),n&&(this.message=n)}}e.$$=w;class T extends Error{constructor(n){super("NotSupported"),n&&(this.message=n)}}e.$_=T;class m extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$ab=m;class D extends Error{constructor(n){super(n),this.name="CodeExpectedError"}static fromError(n){if(n instanceof D)return n;const i=new D;return i.message=n.message,i.stack=n.stack,i}static isErrorNoTelemetry(n){return n.name==="CodeExpectedError"}}e.$bb=D;class p extends Error{constructor(n){super(n||"An unexpected bug occurred."),Object.setPrototypeOf(this,p.prototype)}}e.$cb=p}),define(ge[18],me([0,1,3,26]),function(fe,e,f,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ac=e.$_b=e.$$b=e.$9b=e.$8b=e.CompareResult=void 0,e.$sb=P,e.$tb=b,e.$ub=q,e.$vb=L,e.$wb=a,e.$xb=g,e.$yb=M,e.$zb=H,e.$Ab=A,e.$Bb=N,e.$Cb=R,e.$Db=s,e.$Eb=w,e.top=T,e.$Gb=m,e.$Hb=p,e.$Ib=o,e.$Jb=n,e.$Kb=i,e.$Lb=r,e.$Mb=v,e.$Nb=G,e.$Ob=_,e.$Pb=y,e.$Qb=l,e.$Rb=I,e.$Sb=E,e.$Tb=h,e.$Ub=c,e.$Vb=K,e.$Wb=te,e.$Xb=Q,e.$Yb=V,e.$Zb=x,e.$1b=z,e.$2b=Y,e.$3b=ne,e.$4b=se,e.$5b=U,e.$6b=J,e.$7b=ie,e.$0b=be;function P(S,B=0){return S[S.length-(1+B)]}function b(S){if(S.length===0)throw new Error("Invalid tail call");return[S.slice(0,S.length-1),S[S.length-1]]}function q(S,B,j=(O,u)=>O===u){if(S===B)return!0;if(!S||!B||S.length!==B.length)return!1;for(let O=0,u=S.length;O<u;O++)if(!j(S[O],B[O]))return!1;return!0}function L(S,B){const j=S.length-1;B<j&&(S[B]=S[j]),S.pop()}function a(S,B,j){return g(S.length,O=>j(S[O],B))}function g(S,B){let j=0,O=S-1;for(;j<=O;){const u=(j+O)/2|0,k=B(u);if(k<0)j=u+1;else if(k>0)O=u-1;else return u}return-(j+1)}function M(S,B,j){if(S=S|0,S>=B.length)throw new TypeError("invalid index");const O=B[Math.floor(B.length*Math.random())],u=[],k=[],X=[];for(const C of B){const le=j(C,O);le<0?u.push(C):le>0?k.push(C):X.push(C)}return S<u.length?M(S,u,j):S<u.length+X.length?X[0]:M(S-(u.length+X.length),k,j)}function H(S,B){const j=[];let O;for(const u of S.slice(0).sort(B))!O||B(O[0],u)!==0?(O=[u],j.push(O)):O.push(u);return j}function*A(S,B){let j,O;for(const u of S)O!==void 0&&B(O,u)?j.push(u):(j&&(yield j),j=[u]),O=u;j&&(yield j)}function N(S,B){for(let j=0;j<=S.length;j++)B(j===0?void 0:S[j-1],j===S.length?void 0:S[j])}function R(S,B){for(let j=0;j<S.length;j++)B(j===0?void 0:S[j-1],S[j],j+1===S.length?void 0:S[j+1])}function s(S,B,j){const O=[];function u(C,le,Re){if(le===0&&Re.length===0)return;const oe=O[O.length-1];oe&&oe.start+oe.deleteCount===C?(oe.deleteCount+=le,oe.toInsert.push(...Re)):O.push({start:C,deleteCount:le,toInsert:Re})}let k=0,X=0;for(;;){if(k===S.length){u(k,0,B.slice(X));break}if(X===B.length){u(k,S.length-k,[]);break}const C=S[k],le=B[X],Re=j(C,le);Re===0?(k+=1,X+=1):Re<0?(u(k,1,[]),k+=1):Re>0&&(u(k,0,[le]),X+=1)}return O}function w(S,B,j){const O=s(S,B,j),u=[],k=[];for(const X of O)u.push(...S.slice(X.start,X.start+X.deleteCount)),k.push(...X.toInsert);return{removed:u,added:k}}function T(S,B,j){if(j===0)return[];const O=S.slice(0,j).sort(B);return D(S,B,O,j,S.length),O}function m(S,B,j,O,u){return j===0?Promise.resolve([]):new Promise((k,X)=>{(async()=>{const C=S.length,le=S.slice(0,j).sort(B);for(let Re=j,oe=Math.min(j+O,C);Re<C;Re=oe,oe=Math.min(oe+O,C)){if(Re>j&&await new Promise(re=>setTimeout(re)),u&&u.isCancellationRequested)throw new f.$5;D(S,B,le,Re,oe)}return le})().then(k,X)})}function D(S,B,j,O,u){for(const k=j.length;O<u;O++){const X=S[O];if(B(X,j[k-1])<0){j.pop();const C=(0,t.$kb)(j,le=>B(X,le)<0);j.splice(C,0,X)}}}function p(S){return S.filter(B=>!!B)}function o(S){let B=0;for(let j=0;j<S.length;j++)S[j]&&(S[B]=S[j],B+=1);S.length=B}function n(S,B,j){S.splice(j,0,S.splice(B,1)[0])}function i(S){return!Array.isArray(S)||S.length===0}function r(S){return Array.isArray(S)&&S.length>0}function v(S,B=j=>j){const j=new Set;return S.filter(O=>{const u=B(O);return j.has(u)?!1:(j.add(u),!0)})}function G(S){const B=new Set;return j=>{const O=S(j);return B.has(O)?!1:(B.add(O),!0)}}function _(S,B){return S.length>0?S[0]:B}function y(S,B){return S.length>0?S[S.length-1]:B}function l(S,B,j=(O,u)=>O===u){let O=0;for(let u=0,k=Math.min(S.length,B.length);u<k&&j(S[u],B[u]);u++)O++;return O}function I(S,B){let j=typeof B=="number"?S:0;typeof B=="number"?j=S:(j=0,B=S);const O=[];if(j<=B)for(let u=j;u<B;u++)O.push(u);else for(let u=j;u>B;u--)O.push(u);return O}function E(S,B,j){return S.reduce((O,u)=>(O[B(u)]=j?j(u):u,O),Object.create(null))}function h(S,B){return S.push(B),()=>c(S,B)}function c(S,B){const j=S.indexOf(B);if(j>-1)return S.splice(j,1),B}function K(S,B,j){const O=S.slice(0,B),u=S.slice(B);return O.concat(j,u)}function te(S,B){let j;if(typeof B=="number"){let O=B;j=()=>{const u=Math.sin(O++)*179426549;return u-Math.floor(u)}}else j=Math.random;for(let O=S.length-1;O>0;O-=1){const u=Math.floor(j()*(O+1)),k=S[O];S[O]=S[u],S[u]=k}}function Q(S,B){const j=S.indexOf(B);j>-1&&(S.splice(j,1),S.unshift(B))}function V(S,B){const j=S.indexOf(B);j>-1&&(S.splice(j,1),S.push(B))}function x(S,B){for(const j of B)S.push(j)}function z(S,B){return Array.isArray(S)?S.map(B):B(S)}function Y(S){return Array.isArray(S)?S:[S]}function ne(S){return S[Math.floor(Math.random()*S.length)]}function se(S,B,j){const O=$(S,B),u=S.length,k=j.length;S.length=u+k;for(let X=u-1;X>=O;X--)S[X+k]=S[X];for(let X=0;X<k;X++)S[X+O]=j[X]}function U(S,B,j,O){const u=$(S,B);let k=S.splice(u,j);return k===void 0&&(k=[]),se(S,u,O),k}function $(S,B){return B<0?Math.max(B+S.length,0):Math.min(B,S.length)}var W;(function(S){function B(k){return k<0}S.isLessThan=B;function j(k){return k<=0}S.isLessThanOrEqual=j;function O(k){return k>0}S.isGreaterThan=O;function u(k){return k===0}S.isNeitherLessOrGreaterThan=u,S.greaterThan=1,S.lessThan=-1,S.neitherLessOrGreaterThan=0})(W||(e.CompareResult=W={}));function J(S,B){return(j,O)=>B(S(j),S(O))}function ie(...S){return(B,j)=>{for(const O of S){const u=O(B,j);if(!W.isNeitherLessOrGreaterThan(u))return u}return W.neitherLessOrGreaterThan}}const ce=(S,B)=>S-B;e.$8b=ce;const _e=(S,B)=>(0,e.$8b)(S?1:0,B?1:0);e.$9b=_e;function be(S){return(B,j)=>-S(B,j)}class ye{constructor(B){this.g=B,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(B){let j=this.c;for(;j<this.g.length&&B(this.g[j]);)j++;const O=j===this.c?null:this.g.slice(this.c,j);return this.c=j,O}takeFromEndWhile(B){let j=this.d;for(;j>=0&&B(this.g[j]);)j--;const O=j===this.d?null:this.g.slice(j+1,this.d+1);return this.d=j,O}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const B=this.g[this.c];return this.c++,B}removeLast(){const B=this.g[this.d];return this.d--,B}takeCount(B){const j=this.g.slice(this.c,this.c+B);return this.c+=B,j}}e.$$b=ye;class de{static{this.empty=new de(B=>{})}constructor(B){this.iterate=B}forEach(B){this.iterate(j=>(B(j),!0))}toArray(){const B=[];return this.iterate(j=>(B.push(j),!0)),B}filter(B){return new de(j=>this.iterate(O=>B(O)?j(O):!0))}map(B){return new de(j=>this.iterate(O=>j(B(O))))}some(B){let j=!1;return this.iterate(O=>(j=B(O),!j)),j}findFirst(B){let j;return this.iterate(O=>B(O)?(j=O,!1):!0),j}findLast(B){let j;return this.iterate(O=>(B(O)&&(j=O),!0)),j}findLastMaxBy(B){let j,O=!0;return this.iterate(u=>((O||W.isGreaterThan(B(u,j)))&&(O=!1,j=u),!0)),j}}e.$_b=de;class Ee{constructor(B){this.c=B}static createSortPermutation(B,j){const O=Array.from(B.keys()).sort((u,k)=>j(B[u],B[k]));return new Ee(O)}apply(B){return B.map((j,O)=>B[this.c[O]])}inverse(){const B=this.c.slice();for(let j=0;j<this.c.length;j++)B[this.c[j]]=j;return new Ee(B)}}e.$ac=Ee}),define(ge[19],me([0,1]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$db=f;function f(t,P){const b=this;let q=!1,L;return function(){if(q)return L;if(q=!0,P)try{L=t.apply(b,arguments)}finally{P()}else L=t.apply(b,arguments);return L}}}),define(ge[29],me([0,1]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var f;(function(t){function P(n){return n&&typeof n=="object"&&typeof n[Symbol.iterator]=="function"}t.is=P;const b=Object.freeze([]);function q(){return b}t.empty=q;function*L(n){yield n}t.single=L;function a(n){return P(n)?n:L(n)}t.wrap=a;function g(n){return n||b}t.from=g;function*M(n){for(let i=n.length-1;i>=0;i--)yield n[i]}t.reverse=M;function H(n){return!n||n[Symbol.iterator]().next().done===!0}t.isEmpty=H;function A(n){return n[Symbol.iterator]().next().value}t.first=A;function N(n,i){for(const r of n)if(i(r))return!0;return!1}t.some=N;function R(n,i){for(const r of n)if(i(r))return r}t.find=R;function*s(n,i){for(const r of n)i(r)&&(yield r)}t.filter=s;function*w(n,i){let r=0;for(const v of n)yield i(v,r++)}t.map=w;function*T(...n){for(const i of n)yield*i}t.concat=T;function m(n,i,r){let v=r;for(const G of n)v=i(v,G);return v}t.reduce=m;function*D(n,i,r=n.length){for(i<0&&(i+=n.length),r<0?r+=n.length:r>n.length&&(r=n.length);i<r;i++)yield n[i]}t.slice=D;function p(n,i=Number.POSITIVE_INFINITY){const r=[];if(i===0)return[r,n];const v=n[Symbol.iterator]();for(let G=0;G<i;G++){const _=v.next();if(_.done)return[r,t.empty()];r.push(_.value)}return[r,{[Symbol.iterator](){return v}}]}t.consume=p;async function o(n){const i=[];for await(const r of n)i.push(r);return Promise.resolve(i)}t.asyncToArray=o})(f||(e.Iterable=f={}))}),define(ge[13],me([0,1]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V=void 0;class f{constructor(P){this.d=P,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(P){this.c=P}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$V=f}),define(ge[30],me([0,1]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5c=void 0;class f{static{this.Undefined=new f(void 0)}constructor(b){this.element=b,this.next=f.Undefined,this.prev=f.Undefined}}class t{constructor(){this.a=f.Undefined,this.b=f.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===f.Undefined}clear(){let b=this.a;for(;b!==f.Undefined;){const q=b.next;b.prev=f.Undefined,b.next=f.Undefined,b=q}this.a=f.Undefined,this.b=f.Undefined,this.c=0}unshift(b){return this.d(b,!1)}push(b){return this.d(b,!0)}d(b,q){const L=new f(b);if(this.a===f.Undefined)this.a=L,this.b=L;else if(q){const g=this.b;this.b=L,L.prev=g,g.next=L}else{const g=this.a;this.a=L,L.next=g,g.prev=L}this.c+=1;let a=!1;return()=>{a||(a=!0,this.e(L))}}shift(){if(this.a!==f.Undefined){const b=this.a.element;return this.e(this.a),b}}pop(){if(this.b!==f.Undefined){const b=this.b.element;return this.e(this.b),b}}e(b){if(b.prev!==f.Undefined&&b.next!==f.Undefined){const q=b.prev;q.next=b.next,b.next.prev=q}else b.prev===f.Undefined&&b.next===f.Undefined?(this.a=f.Undefined,this.b=f.Undefined):b.next===f.Undefined?(this.b=this.b.prev,this.b.next=f.Undefined):b.prev===f.Undefined&&(this.a=this.a.next,this.a.prev=f.Undefined);this.c-=1}*[Symbol.iterator](){let b=this.a;for(;b!==f.Undefined;)yield b.element,b=b.next}}e.$5c=t}),define(ge[20],me([0,1]),function(fe,e){"use strict";var f,t,P;Object.defineProperty(e,"__esModule",{value:!0}),e.$Hc=e.$Gc=e.$Fc=e.$Ec=e.$Dc=e.$Cc=e.Touch=e.$Bc=e.$Ac=void 0,e.$xc=b,e.$yc=q,e.$zc=L,e.$Ic=p;function b(o,n,i){let r=o.get(n);return r===void 0&&(r=i,o.set(n,r)),r}function q(o){const n=[];return o.forEach((i,r)=>{n.push(`${r} => ${i}`)}),`Map(${o.size}) {${n.join(", ")}}`}function L(o){const n=[];return o.forEach(i=>{n.push(i)}),`Set(${o.size}) {${n.join(", ")}}`}class a{constructor(n,i){this.uri=n,this.value=i}}function g(o){return Array.isArray(o)}class M{static{this.c=n=>n.toString()}constructor(n,i){if(this[f]="ResourceMap",n instanceof M)this.d=new Map(n.d),this.e=i??M.c;else if(g(n)){this.d=new Map,this.e=i??M.c;for(const[r,v]of n)this.set(r,v)}else this.d=new Map,this.e=n??M.c}set(n,i){return this.d.set(this.e(n),new a(n,i)),this}get(n){return this.d.get(this.e(n))?.value}has(n){return this.d.has(this.e(n))}get size(){return this.d.size}clear(){this.d.clear()}delete(n){return this.d.delete(this.e(n))}forEach(n,i){typeof i<"u"&&(n=n.bind(i));for(const[r,v]of this.d)n(v.value,v.uri,this)}*values(){for(const n of this.d.values())yield n.value}*keys(){for(const n of this.d.values())yield n.uri}*entries(){for(const n of this.d.values())yield[n.uri,n.value]}*[(f=Symbol.toStringTag,Symbol.iterator)](){for(const[,n]of this.d)yield[n.uri,n.value]}}e.$Ac=M;class H{constructor(n,i){this[t]="ResourceSet",!n||typeof n=="function"?this.c=new M(n):(this.c=new M(i),n.forEach(this.add,this))}get size(){return this.c.size}add(n){return this.c.set(n,n),this}clear(){this.c.clear()}delete(n){return this.c.delete(n)}forEach(n,i){this.c.forEach((r,v)=>n.call(i,v,v,this))}has(n){return this.c.has(n)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(t=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Bc=H;var A;(function(o){o[o.None=0]="None",o[o.AsOld=1]="AsOld",o[o.AsNew=2]="AsNew"})(A||(e.Touch=A={}));class N{constructor(){this[P]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has(n){return this.c.has(n)}get(n,i=A.None){const r=this.c.get(n);if(r)return i!==A.None&&this.m(r,i),r.value}set(n,i,r=A.None){let v=this.c.get(n);if(v)v.value=i,r!==A.None&&this.m(v,r);else{switch(v={key:n,value:i,next:void 0,previous:void 0},r){case A.None:this.k(v);break;case A.AsOld:this.j(v);break;case A.AsNew:this.k(v);break;default:this.k(v);break}this.c.set(n,v),this.f++}return this}delete(n){return!!this.remove(n)}remove(n){const i=this.c.get(n);if(i)return this.c.delete(n),this.l(i),this.f--,i.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const n=this.d;return this.c.delete(n.key),this.l(n),this.f--,n.value}forEach(n,i){const r=this.g;let v=this.d;for(;v;){if(i?n.bind(i)(v.value,v.key,this):n(v.value,v.key,this),this.g!==r)throw new Error("LinkedMap got modified during iteration.");v=v.next}}keys(){const n=this,i=this.g;let r=this.d;const v={[Symbol.iterator](){return v},next(){if(n.g!==i)throw new Error("LinkedMap got modified during iteration.");if(r){const G={value:r.key,done:!1};return r=r.next,G}else return{value:void 0,done:!0}}};return v}values(){const n=this,i=this.g;let r=this.d;const v={[Symbol.iterator](){return v},next(){if(n.g!==i)throw new Error("LinkedMap got modified during iteration.");if(r){const G={value:r.value,done:!1};return r=r.next,G}else return{value:void 0,done:!0}}};return v}entries(){const n=this,i=this.g;let r=this.d;const v={[Symbol.iterator](){return v},next(){if(n.g!==i)throw new Error("LinkedMap got modified during iteration.");if(r){const G={value:[r.key,r.value],done:!1};return r=r.next,G}else return{value:void 0,done:!0}}};return v}[(P=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h(n){if(n>=this.size)return;if(n===0){this.clear();return}let i=this.d,r=this.size;for(;i&&r>n;)this.c.delete(i.key),i=i.next,r--;this.d=i,this.f=r,i&&(i.previous=void 0),this.g++}i(n){if(n>=this.size)return;if(n===0){this.clear();return}let i=this.e,r=this.size;for(;i&&r>n;)this.c.delete(i.key),i=i.previous,r--;this.e=i,this.f=r,i&&(i.next=void 0),this.g++}j(n){if(!this.d&&!this.e)this.e=n;else if(this.d)n.next=this.d,this.d.previous=n;else throw new Error("Invalid list");this.d=n,this.g++}k(n){if(!this.d&&!this.e)this.d=n;else if(this.e)n.previous=this.e,this.e.next=n;else throw new Error("Invalid list");this.e=n,this.g++}l(n){if(n===this.d&&n===this.e)this.d=void 0,this.e=void 0;else if(n===this.d){if(!n.next)throw new Error("Invalid list");n.next.previous=void 0,this.d=n.next}else if(n===this.e){if(!n.previous)throw new Error("Invalid list");n.previous.next=void 0,this.e=n.previous}else{const i=n.next,r=n.previous;if(!i||!r)throw new Error("Invalid list");i.previous=r,r.next=i}n.next=void 0,n.previous=void 0,this.g++}m(n,i){if(!this.d||!this.e)throw new Error("Invalid list");if(!(i!==A.AsOld&&i!==A.AsNew)){if(i===A.AsOld){if(n===this.d)return;const r=n.next,v=n.previous;n===this.e?(v.next=void 0,this.e=v):(r.previous=v,v.next=r),n.previous=void 0,n.next=this.d,this.d.previous=n,this.d=n,this.g++}else if(i===A.AsNew){if(n===this.e)return;const r=n.next,v=n.previous;n===this.d?(r.previous=void 0,this.d=r):(r.previous=v,v.next=r),n.next=void 0,n.previous=this.e,this.e.next=n,this.e=n,this.g++}}}toJSON(){const n=[];return this.forEach((i,r)=>{n.push([r,i])}),n}fromJSON(n){this.clear();for(const[i,r]of n)this.set(i,r)}}e.$Cc=N;class R extends N{constructor(n,i=1){super(),this.n=n,this.o=Math.min(Math.max(0,i),1)}get limit(){return this.n}set limit(n){this.n=n,this.p()}get ratio(){return this.o}set ratio(n){this.o=Math.min(Math.max(0,n),1),this.p()}get(n,i=A.AsNew){return super.get(n,i)}peek(n){return super.get(n,A.None)}set(n,i){return super.set(n,i,A.AsNew),this}p(){this.size>this.n&&this.q(Math.round(this.n*this.o))}}class s extends R{constructor(n,i=1){super(n,i)}q(n){this.h(n)}set(n,i){return super.set(n,i),this.p(),this}}e.$Dc=s;class w extends R{constructor(n,i=1){super(n,i)}q(n){this.i(n)}set(n,i){return this.n<=this.size&&!this.has(n)&&this.q(Math.round(this.n*this.o)-1),super.set(n,i),this}}e.$Ec=w;class T{constructor(){this.c=new Map}add(n){return this.c.set(n,(this.c.get(n)||0)+1),this}delete(n){let i=this.c.get(n)||0;return i===0?!1:(i--,i===0?this.c.delete(n):this.c.set(n,i),!0)}has(n){return this.c.has(n)}}e.$Fc=T;class m{constructor(n){if(this.c=new Map,this.d=new Map,n)for(const[i,r]of n)this.set(i,r)}clear(){this.c.clear(),this.d.clear()}set(n,i){this.c.set(n,i),this.d.set(i,n)}get(n){return this.c.get(n)}getKey(n){return this.d.get(n)}delete(n){const i=this.c.get(n);return i===void 0?!1:(this.c.delete(n),this.d.delete(i),!0)}forEach(n,i){this.c.forEach((r,v)=>{n.call(i,r,v,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}e.$Gc=m;class D{constructor(){this.c=new Map}add(n,i){let r=this.c.get(n);r||(r=new Set,this.c.set(n,r)),r.add(i)}delete(n,i){const r=this.c.get(n);r&&(r.delete(i),r.size===0&&this.c.delete(n))}forEach(n,i){const r=this.c.get(n);r&&r.forEach(i)}get(n){const i=this.c.get(n);return i||new Set}}e.$Hc=D;function p(o,n){if(o===n)return!0;if(o.size!==n.size)return!1;for(const[i,r]of o)if(!n.has(i)||n.get(i)!==r)return!1;for(const[i]of n)if(!o.has(i))return!1;return!0}}),define(ge[6],me([0,1,18,27,20,19,29]),function(fe,e,f,t,P,b,q){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4c=e.$2c=e.$1c=e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Tc=e.$Jc=void 0,e.$Kc=M,e.$Lc=H,e.$Mc=A,e.$Nc=s,e.$Oc=w,e.$Pc=T,e.$Qc=m,e.$Rc=D,e.$Sc=p,e.$3c=I;const L=!1;let a=null;class g{constructor(){this.b=new Map}static{this.a=0}c(c){let K=this.b.get(c);return K||(K={parent:null,source:null,isSingleton:!1,value:c,idx:g.a++},this.b.set(c,K)),K}trackDisposable(c){const K=this.c(c);K.source||(K.source=new Error().stack)}setParent(c,K){const te=this.c(c);te.parent=K}markAsDisposed(c){this.b.delete(c)}markAsSingleton(c){this.c(c).isSingleton=!0}f(c,K){const te=K.get(c);if(te)return te;const Q=c.parent?this.f(this.c(c.parent),K):c;return K.set(c,Q),Q}getTrackedDisposables(){const c=new Map;return[...this.b.entries()].filter(([,te])=>te.source!==null&&!this.f(te,c).isSingleton).flatMap(([te])=>te)}computeLeakingDisposables(c=10,K){let te;if(K)te=K;else{const Y=new Map,ne=[...this.b.values()].filter(U=>U.source!==null&&!this.f(U,Y).isSingleton);if(ne.length===0)return;const se=new Set(ne.map(U=>U.value));if(te=ne.filter(U=>!(U.parent&&se.has(U.parent))),te.length===0)throw new Error("There are cyclic diposable chains!")}if(!te)return;function Q(Y){function ne(U,$){for(;U.length>0&&$.some(W=>typeof W=="string"?W===U[0]:U[0].match(W));)U.shift()}const se=Y.source.split(`
`).map(U=>U.trim().replace("at ","")).filter(U=>U!=="");return ne(se,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),se.reverse()}const V=new P.$Hc;for(const Y of te){const ne=Q(Y);for(let se=0;se<=ne.length;se++)V.add(ne.slice(0,se).join(`
`),Y)}te.sort((0,f.$6b)(Y=>Y.idx,f.$8b));let x="",z=0;for(const Y of te.slice(0,c)){z++;const ne=Q(Y),se=[];for(let U=0;U<ne.length;U++){let $=ne[U];$=`(shared with ${V.get(ne.slice(0,U+1).join(`
`)).size}/${te.length} leaks) at ${$}`;const J=V.get(ne.slice(0,U).join(`
`)),ie=(0,t.$K)([...J].map(ce=>Q(ce)[U]),ce=>ce);delete ie[ne[U]];for(const[ce,_e]of Object.entries(ie))se.unshift(`    - stacktraces of ${_e.length} other leaks continue with ${ce}`);se.unshift($)}x+=`


==================== Leaking disposable ${z}/${te.length}: ${Y.value.constructor.name} ====================
${se.join(`
`)}
============================================================

`}return te.length>c&&(x+=`


... and ${te.length-c} more leaking disposables

`),{leaks:te,details:x}}}e.$Jc=g;function M(h){a=h}if(L){const h="__is_disposable_tracked__";M(new class{trackDisposable(c){const K=new Error("Potentially leaked disposable").stack;setTimeout(()=>{c[h]||console.log(K)},3e3)}setParent(c,K){if(c&&c!==n.None)try{c[h]=!0}catch{}}markAsDisposed(c){if(c&&c!==n.None)try{c[h]=!0}catch{}}markAsSingleton(c){}})}function H(h){return a?.trackDisposable(h),h}function A(h){a?.markAsDisposed(h)}function N(h,c){a?.setParent(h,c)}function R(h,c){if(a)for(const K of h)a.setParent(K,c)}function s(h){return a?.markAsSingleton(h),h}function w(h){return typeof h=="object"&&h!==null&&typeof h.dispose=="function"&&h.dispose.length===0}function T(h){if(q.Iterable.is(h)){const c=[];for(const K of h)if(K)try{K.dispose()}catch(te){c.push(te)}if(c.length===1)throw c[0];if(c.length>1)throw new AggregateError(c,"Encountered errors while disposing of store");return Array.isArray(h)?[]:h}else if(h)return h.dispose(),h}function m(h){for(const c of h)w(c)&&c.dispose();return[]}function D(...h){const c=p(()=>T(h));return R(h,c),c}function p(h){const c=H({dispose:(0,b.$db)(()=>{A(c),h()})});return c}class o{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,H(this)}dispose(){this.g||(A(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{T(this.f)}finally{this.f.clear()}}add(c){if(!c)return c;if(c===this)throw new Error("Cannot register a disposable on itself!");return N(c,this),this.g?o.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(c),c}delete(c){if(c){if(c===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(c),c.dispose()}}deleteAndLeak(c){c&&this.f.has(c)&&(this.f.delete(c),N(c,null))}}e.$Tc=o;class n{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new o,H(this),N(this.q,this)}dispose(){A(this),this.q.dispose()}B(c){if(c===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(c)}}e.$Uc=n;class i{constructor(){this.b=!1,H(this)}get value(){return this.b?void 0:this.a}set value(c){this.b||c===this.a||(this.a?.dispose(),c&&N(c,this),this.a=c)}clear(){this.value=void 0}dispose(){this.b=!0,A(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const c=this.a;return this.a=void 0,c&&N(c,null),c}}e.$Vc=i;class r{constructor(c){this.a=new i,this.b=!1,this.a.value=c}get value(){return this.a.value}set value(c){this.b||c===this.a.value||(this.a.value=c)}dispose(){this.b=!0,this.a.dispose()}}e.$Wc=r;class v{constructor(c){this.b=c,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$Xc=v;class G{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,H(this)}set(c){let K=c;return this.unset=()=>K=void 0,this.isset=()=>K!==void 0,this.dispose=()=>{K&&(K(),K=void 0,A(this))},this}}e.$Yc=G;class _{constructor(){this.a=new Map}acquire(c,...K){let te=this.a.get(c);te||(te={counter:0,object:this.b(c,...K)},this.a.set(c,te));const{object:Q}=te,V=(0,b.$db)(()=>{--te.counter===0&&(this.c(c,te.object),this.a.delete(c))});return te.counter++,{object:Q,dispose:V}}}e.$Zc=_;class y{constructor(c){this.a=c}async acquire(c,...K){const te=this.a.acquire(c,...K);try{return{object:await te.object,dispose:()=>te.dispose()}}catch(Q){throw te.dispose(),Q}}}e.$1c=y;class l{constructor(c){this.object=c}dispose(){}}e.$2c=l;function I(h){const c=new o;try{h(c)}finally{c.dispose()}}class E{constructor(){this.a=new Map,this.b=!1,H(this)}dispose(){A(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{T(this.a.values())}finally{this.a.clear()}}has(c){return this.a.has(c)}get size(){return this.a.size}get(c){return this.a.get(c)}set(c,K,te=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),te||this.a.get(c)?.dispose(),this.a.set(c,K)}deleteAndDispose(c){this.a.get(c)?.dispose(),this.a.delete(c)}deleteAndLeak(c){const K=this.a.get(c);return this.a.delete(c),K}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$4c=E}),define(ge[21],me([0,1]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MarshalledId=void 0;var f;(function(t){t[t.Uri=1]="Uri",t[t.Regexp=2]="Regexp",t[t.ScmResource=3]="ScmResource",t[t.ScmResourceGroup=4]="ScmResourceGroup",t[t.ScmProvider=5]="ScmProvider",t[t.CommentController=6]="CommentController",t[t.CommentThread=7]="CommentThread",t[t.CommentThreadInstance=8]="CommentThreadInstance",t[t.CommentThreadReply=9]="CommentThreadReply",t[t.CommentNode=10]="CommentNode",t[t.CommentThreadNode=11]="CommentThreadNode",t[t.TimelineActionContext=12]="TimelineActionContext",t[t.NotebookCellActionContext=13]="NotebookCellActionContext",t[t.NotebookActionContext=14]="NotebookActionContext",t[t.TerminalContext=15]="TerminalContext",t[t.TestItemContext=16]="TestItemContext",t[t.Date=17]="Date",t[t.TestMessageMenuArgs=18]="TestMessageMenuArgs"})(f||(e.MarshalledId=f={}))}),define(ge[31],me([0,1,20]),function(fe,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$im=void 0,e.$gm=P,e.$hm=q;const t=new f.$Dc(1e4);function P(g){return a(g,"NFC",t)}const b=new f.$Dc(1e4);function q(g){return a(g,"NFD",b)}const L=/[^\u0000-\u0080]/;function a(g,M,H){if(!g)return g;const A=H.get(g);if(A)return A;let N;return L.test(g)?N=g.normalize(M):N=g,H.set(g,N),N}e.$im=function(){const g=/[\u0300-\u036f]/g;return function(M){return q(M).replace(g,"")}}()}),define(ge[32],me([0,1]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$be=void 0;const f=globalThis.performance&&typeof globalThis.performance.now=="function";class t{static create(b){return new t(b)}constructor(b){this.c=f&&b===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$be=t}),define(ge[10],me([0,1,3,19,6,30,32]),function(fe,e,f,t,P,b,q){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$ie=e.$he=e.$ge=e.$fe=e.$de=e.Event=void 0,e.$ee=N;const L=!1,a=!1,g=!1;var M;(function(Q){Q.None=()=>P.$Uc.None;function V(oe){if(g){const{onDidAddListener:re}=oe,he=s.create();let ue=0;oe.onDidAddListener=()=>{++ue===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),he.print()),re?.()}}}function x(oe,re){return ce(oe,()=>{},0,void 0,!0,void 0,re)}Q.defer=x;function z(oe){return(re,he=null,ue)=>{let $e=!1,Ae;return Ae=oe(Le=>{if(!$e)return Ae?Ae.dispose():$e=!0,re.call(he,Le)},null,ue),$e&&Ae.dispose(),Ae}}Q.once=z;function Y(oe,re,he){return J((ue,$e=null,Ae)=>oe(Le=>ue.call($e,re(Le)),null,Ae),he)}Q.map=Y;function ne(oe,re,he){return J((ue,$e=null,Ae)=>oe(Le=>{re(Le),ue.call($e,Le)},null,Ae),he)}Q.forEach=ne;function se(oe,re,he){return J((ue,$e=null,Ae)=>oe(Le=>re(Le)&&ue.call($e,Le),null,Ae),he)}Q.filter=se;function U(oe){return oe}Q.signal=U;function $(...oe){return(re,he=null,ue)=>{const $e=(0,P.$Rc)(...oe.map(Ae=>Ae(Le=>re.call(he,Le))));return ie($e,ue)}}Q.any=$;function W(oe,re,he,ue){let $e=he;return Y(oe,Ae=>($e=re($e,Ae),$e),ue)}Q.reduce=W;function J(oe,re){let he;const ue={onWillAddFirstListener(){he=oe($e.fire,$e)},onDidRemoveLastListener(){he?.dispose()}};re||V(ue);const $e=new i(ue);return re?.add($e),$e.event}function ie(oe,re){return re instanceof Array?re.push(oe):re&&re.add(oe),oe}function ce(oe,re,he=100,ue=!1,$e=!1,Ae,Le){let Ue,Ie,Fe,Be=0,we;const Te={leakWarningThreshold:Ae,onWillAddFirstListener(){Ue=oe(He=>{Be++,Ie=re(Ie,He),ue&&!Fe&&(je.fire(Ie),Ie=void 0),we=()=>{const ze=Ie;Ie=void 0,Fe=void 0,(!ue||Be>1)&&je.fire(ze),Be=0},typeof he=="number"?(clearTimeout(Fe),Fe=setTimeout(we,he)):Fe===void 0&&(Fe=0,queueMicrotask(we))})},onWillRemoveListener(){$e&&Be>0&&we?.()},onDidRemoveLastListener(){we=void 0,Ue.dispose()}};Le||V(Te);const je=new i(Te);return Le?.add(je),je.event}Q.debounce=ce;function _e(oe,re=0,he){return Q.debounce(oe,(ue,$e)=>ue?(ue.push($e),ue):[$e],re,void 0,!0,void 0,he)}Q.accumulate=_e;function be(oe,re=(ue,$e)=>ue===$e,he){let ue=!0,$e;return se(oe,Ae=>{const Le=ue||!re(Ae,$e);return ue=!1,$e=Ae,Le},he)}Q.latch=be;function ye(oe,re,he){return[Q.filter(oe,re,he),Q.filter(oe,ue=>!re(ue),he)]}Q.split=ye;function de(oe,re=!1,he=[],ue){let $e=he.slice(),Ae=oe(Ie=>{$e?$e.push(Ie):Ue.fire(Ie)});ue&&ue.add(Ae);const Le=()=>{$e?.forEach(Ie=>Ue.fire(Ie)),$e=null},Ue=new i({onWillAddFirstListener(){Ae||(Ae=oe(Ie=>Ue.fire(Ie)),ue&&ue.add(Ae))},onDidAddFirstListener(){$e&&(re?setTimeout(Le):Le())},onDidRemoveLastListener(){Ae&&Ae.dispose(),Ae=null}});return ue&&ue.add(Ue),Ue.event}Q.buffer=de;function Ee(oe,re){return(ue,$e,Ae)=>{const Le=re(new B);return oe(function(Ue){const Ie=Le.evaluate(Ue);Ie!==S&&ue.call($e,Ie)},void 0,Ae)}}Q.chain=Ee;const S=Symbol("HaltChainable");class B{constructor(){this.f=[]}map(re){return this.f.push(re),this}forEach(re){return this.f.push(he=>(re(he),he)),this}filter(re){return this.f.push(he=>re(he)?he:S),this}reduce(re,he){let ue=he;return this.f.push($e=>(ue=re(ue,$e),ue)),this}latch(re=(he,ue)=>he===ue){let he=!0,ue;return this.f.push($e=>{const Ae=he||!re($e,ue);return he=!1,ue=$e,Ae?$e:S}),this}evaluate(re){for(const he of this.f)if(re=he(re),re===S)break;return re}}function j(oe,re,he=ue=>ue){const ue=(...Ue)=>Le.fire(he(...Ue)),$e=()=>oe.on(re,ue),Ae=()=>oe.removeListener(re,ue),Le=new i({onWillAddFirstListener:$e,onDidRemoveLastListener:Ae});return Le.event}Q.fromNodeEventEmitter=j;function O(oe,re,he=ue=>ue){const ue=(...Ue)=>Le.fire(he(...Ue)),$e=()=>oe.addEventListener(re,ue),Ae=()=>oe.removeEventListener(re,ue),Le=new i({onWillAddFirstListener:$e,onDidRemoveLastListener:Ae});return Le.event}Q.fromDOMEventEmitter=O;function u(oe){return new Promise(re=>z(oe)(re))}Q.toPromise=u;function k(oe){const re=new i;return oe.then(he=>{re.fire(he)},()=>{re.fire(void 0)}).finally(()=>{re.dispose()}),re.event}Q.fromPromise=k;function X(oe,re,he){return re(he),oe(ue=>re(ue))}Q.runAndSubscribe=X;class C{constructor(re,he){this._observable=re,this.f=0,this.g=!1;const ue={onWillAddFirstListener:()=>{re.addObserver(this)},onDidRemoveLastListener:()=>{re.removeObserver(this)}};he||V(ue),this.emitter=new i(ue),he&&he.add(this.emitter)}beginUpdate(re){this.f++}handlePossibleChange(re){}handleChange(re,he){this.g=!0}endUpdate(re){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function le(oe,re){return new C(oe,re).emitter.event}Q.fromObservable=le;function Re(oe){return(re,he,ue)=>{let $e=0,Ae=!1;const Le={beginUpdate(){$e++},endUpdate(){$e--,$e===0&&(oe.reportChanges(),Ae&&(Ae=!1,re.call(he)))},handlePossibleChange(){},handleChange(){Ae=!0}};oe.addObserver(Le),oe.reportChanges();const Ue={dispose(){oe.removeObserver(Le)}};return ue instanceof P.$Tc?ue.add(Ue):Array.isArray(ue)&&ue.push(Ue),Ue}}Q.fromObservableLight=Re})(M||(e.Event=M={}));class H{static{this.all=new Set}static{this.f=0}constructor(V){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${V}_${H.f++}`,H.all.add(this)}start(V){this.g=new q.$be,this.listenerCount=V}stop(){if(this.g){const V=this.g.elapsed();this.durations.push(V),this.elapsedOverall+=V,this.invocationCount+=1,this.g=void 0}}}e.$de=H;let A=-1;function N(Q){const V=A;return A=Q,{dispose(){A=V}}}class R{constructor(V,x,z=Math.random().toString(18).slice(2,5)){this.h=V,this.threshold=x,this.name=z,this.g=0}dispose(){this.f?.clear()}check(V,x){const z=this.threshold;if(z<=0||x<z)return;this.f||(this.f=new Map);const Y=this.f.get(V.value)||0;if(this.f.set(V.value,Y+1),this.g-=1,this.g<=0){this.g=z*.5;const[ne,se]=this.getMostFrequentStack(),U=`[${this.name}] potential listener LEAK detected, having ${x} listeners already. MOST frequent listener (${se}):`;console.warn(U),console.warn(ne);const $=new w(U,ne);this.h($)}return()=>{const ne=this.f.get(V.value)||0;this.f.set(V.value,ne-1)}}getMostFrequentStack(){if(!this.f)return;let V,x=0;for(const[z,Y]of this.f)(!V||x<Y)&&(V=[z,Y],x=Y);return V}}class s{static create(){const V=new Error;return new s(V.stack??"")}constructor(V){this.value=V}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class w extends Error{constructor(V,x){super(V),this.name="ListenerLeakError",this.stack=x}}e.$fe=w;class T extends Error{constructor(V,x){super(V),this.name="ListenerRefusalError",this.stack=x}}e.$ge=T;let m=0;class D{constructor(V){this.value=V,this.id=m++}}const p=2,o=(Q,V)=>{if(Q instanceof D)V(Q);else for(let x=0;x<Q.length;x++){const z=Q[x];z&&V(z)}},n=L?new FinalizationRegistry(Q=>{typeof Q=="string"&&(console.warn("[LEAKING LISTENER] GC'ed a listener that was NOT yet disposed. This is where is was created:"),console.warn(Q))}):void 0;class i{constructor(V){this.w=0,this.f=V,this.g=A>0||this.f?.leakWarningThreshold?new R(V?.onListenerError??f.$1,this.f?.leakWarningThreshold??A):void 0,this.j=this.f?._profName?new H(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(a){const V=this.t;queueMicrotask(()=>{o(V,x=>x.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(V,x,z)=>{if(this.g&&this.w>this.g.threshold**2){const $=`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far (${this.w} vs ${this.g.threshold})`;console.warn($);const W=this.g.getMostFrequentStack()??["UNKNOWN stack",-1],J=new T(`${$}. HINT: Stack shows most frequent listener (${W[1]}-times)`,W[0]);return(this.f?.onListenerError||f.$1)(J),P.$Uc.None}if(this.m)return P.$Uc.None;x&&(V=V.bind(x));const Y=new D(V);let ne,se;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(Y.stack=s.create(),ne=this.g.check(Y.stack,this.w+1)),a&&(Y.stack=se??s.create()),this.t?this.t instanceof D?(this.u??=new v,this.t=[this.t,Y]):this.t.push(Y):(this.f?.onWillAddFirstListener?.(this),this.t=Y,this.f?.onDidAddFirstListener?.(this)),this.w++;const U=(0,P.$Sc)(()=>{n?.unregister(U),ne?.(),this.x(Y)});if(z instanceof P.$Tc?z.add(U):Array.isArray(z)&&z.push(U),n){const $=new Error().stack.split(`
`).slice(2).join(`
`).trim();n.register(U,$,U)}return U},this.q}x(V){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const x=this.t,z=x.indexOf(V);if(z===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,x[z]=void 0;const Y=this.u.current===this;if(this.w*p<=x.length){let ne=0;for(let se=0;se<x.length;se++)x[se]?x[ne++]=x[se]:Y&&(this.u.end--,ne<this.u.i&&this.u.i--);x.length=ne}}y(V,x){if(!V)return;const z=this.f?.onListenerError||f.$1;if(!z){V.value(x);return}try{V.value(x)}catch(Y){z(Y)}}z(V){const x=V.current.t;for(;V.i<V.end;)this.y(x[V.i++],V.value);V.reset()}fire(V){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof D)this.y(this.t,V);else{const x=this.u;x.enqueue(this,V,this.t.length),this.z(x)}this.j?.stop()}hasListeners(){return this.w>0}}e.$he=i;const r=()=>new v;e.$ie=r;class v{constructor(){this.i=-1,this.end=0}enqueue(V,x,z){this.i=0,this.end=z,this.current=V,this.value=x}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class G extends i{async fireAsync(V,x,z){if(this.t)for(this.h||(this.h=new b.$5c),o(this.t,Y=>this.h.push([Y.value,V]));this.h.size>0&&!x.isCancellationRequested;){const[Y,ne]=this.h.shift(),se=[],U={...ne,token:x,waitUntil:$=>{if(Object.isFrozen(se))throw new Error("waitUntil can NOT be called asynchronous");z&&($=z($,Y)),se.push($)}};try{Y(U)}catch($){(0,f.$1)($);continue}Object.freeze(se),await Promise.allSettled(se).then($=>{for(const W of $)W.status==="rejected"&&(0,f.$1)(W.reason)})}}}e.$je=G;class _ extends i{get isPaused(){return this.h!==0}constructor(V){super(V),this.h=0,this.s=new b.$5c,this.A=V?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const V=Array.from(this.s);this.s.clear(),super.fire(this.A(V))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(V){this.w&&(this.h!==0?this.s.push(V):super.fire(V))}}e.$ke=_;class y extends _{constructor(V){super(V),this.k=V.delay??100}fire(V){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(V)}}e.$le=y;class l extends i{constructor(V){super(V),this.h=[],this.k=V?.merge}fire(V){this.hasListeners()&&(this.h.push(V),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(x=>super.fire(x)),this.h=[]}))}}e.$me=l;class I{constructor(){this.g=!1,this.h=[],this.f=new i({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(V){const x={event:V,listener:null};this.h.push(x),this.g&&this.m(x);const z=()=>{this.g&&this.o(x);const Y=this.h.indexOf(x);this.h.splice(Y,1)};return(0,P.$Sc)((0,t.$db)(z))}j(){this.g=!0,this.h.forEach(V=>this.m(V))}k(){this.g=!1,this.h.forEach(V=>this.o(V))}m(V){V.listener=V.event(x=>this.f.fire(x))}o(V){V.listener?.dispose(),V.listener=null}dispose(){this.f.dispose();for(const V of this.h)V.listener?.dispose();this.h=[]}}e.$ne=I;class E{constructor(V,x,z,Y){this.f=new P.$Tc;const ne=this.f.add(new I),se=this.f.add(new P.$4c);function U($){se.set($,ne.add(Y($)))}for(const $ of V)U($);this.f.add(x($=>{U($)})),this.f.add(z($=>{se.deleteAndDispose($)})),this.event=ne.event}dispose(){this.f.dispose()}}e.$oe=E;class h{constructor(){this.f=[]}wrapEvent(V,x,z){return(Y,ne,se)=>V(U=>{const $=this.f[this.f.length-1];if(!x){$?$.buffers.push(()=>Y.call(ne,U)):Y.call(ne,U);return}const W=$;if(!W){Y.call(ne,x(z,U));return}W.items??=[],W.items.push(U),W.buffers.length===0&&$.buffers.push(()=>{W.reducedResult??=z?W.items.reduce(x,z):W.items.reduce(x),Y.call(ne,W.reducedResult)})},void 0,se)}bufferEvents(V){const x={buffers:new Array};this.f.push(x);const z=V();return this.f.pop(),x.buffers.forEach(Y=>Y()),z}}e.$pe=h;class c{constructor(){this.f=!1,this.g=M.None,this.h=P.$Uc.None,this.j=new i({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(V){this.g=V,this.f&&(this.h.dispose(),this.h=V(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$qe=c;class K{static const(V){return new te(V)}constructor(V){this.g=V,this.f=new i,this.onDidChange=this.f.event}get value(){return this.g}set value(V){V!==this.g&&(this.g=V,this.f.fire(void 0))}}e.$re=K;class te{constructor(V){this.value=V,this.onDidChange=M.None}}}),define(ge[7],me([0,1,10]),function(fe,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$se=e.CancellationToken=void 0,e.$te=L;const t=Object.freeze(function(a,g){const M=setTimeout(a.bind(g),0);return{dispose(){clearTimeout(M)}}});var P;(function(a){function g(M){return M===a.None||M===a.Cancelled||M instanceof b?!0:!M||typeof M!="object"?!1:typeof M.isCancellationRequested=="boolean"&&typeof M.onCancellationRequested=="function"}a.isCancellationToken=g,a.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:f.Event.None}),a.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:t})})(P||(e.CancellationToken=P={}));class b{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?t:(this.b||(this.b=new f.$he),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class q{constructor(g){this.f=void 0,this.g=void 0,this.g=g&&g.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new b),this.f}cancel(){this.f?this.f instanceof b&&this.f.cancel():this.f=P.Cancelled}dispose(g=!1){g&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof b&&this.f.dispose():this.f=P.None}}e.$se=q;function L(a){const g=new q;return a.add({dispose(){g.cancel()}}),g.token}}),define(ge[33],me([0,1,7]),function(fe,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8e=e.$7e=e.$5e=void 0,e.$6e=P;class t{constructor(a){this.b=a,this.a=null}get(){if(this.a)return this.a;const a=new f.$se,g=this.b(a.token);return this.a={promise:g,dispose:()=>{this.a=null,a.cancel(),a.dispose()}},this.a}}e.$5e=t;function P(L){return L}class b{constructor(a,g){this.a=void 0,this.b=void 0,typeof a=="function"?(this.c=a,this.d=P):(this.c=g,this.d=a.getCacheKey)}get(a){const g=this.d(a);return this.b!==g&&(this.b=g,this.a=this.c(a)),this.a}}e.$7e=b;class q{get cachedValues(){return this.a}constructor(a,g){this.a=new Map,this.b=new Map,typeof a=="function"?(this.c=a,this.d=P):(this.c=g,this.d=a.getCacheKey)}get(a){const g=this.d(a);if(this.b.has(g))return this.b.get(g);const M=this.c(a);return this.a.set(a,M),this.b.set(g,M),M}}e.$8e=q}),define(ge[34],me([0,1,3,6]),function(fe,e,f,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ue=P,e.$ve=b,e.$we=q,e.$xe=L,e.$ye=g,e.$ze=M,e.$Ae=H,e.$Be=A,e.$Ce=N,e.$De=R,e.$Ee=s,e.$Fe=w,e.$Ge=T,e.$He=m,e.$Ie=D;function P(p){const o=p;return o?typeof o.read=="function":!1}function b(p){const o=p;return o?[o.on,o.pause,o.resume,o.destroy].every(n=>typeof n=="function"):!1}function q(p){const o=p;return o?b(o.stream)&&Array.isArray(o.buffer)&&typeof o.ended=="boolean":!1}function L(p,o){return new a(p,o)}class a{constructor(o,n){this.e=o,this.f=n,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(o){if(!this.a.destroyed){if(this.a.flowing)this.g(o);else if(this.b.data.push(o),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(n=>this.d.push(n))}}error(o){this.a.destroyed||(this.a.flowing?this.h(o):this.b.error.push(o))}end(o){this.a.destroyed||(typeof o<"u"&&this.write(o),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(o){this.c.data.slice(0).forEach(n=>n(o))}h(o){this.c.error.length===0?(0,f.$1)(o):this.c.error.slice(0).forEach(n=>n(o))}i(){this.c.end.slice(0).forEach(o=>o())}on(o,n){if(!this.a.destroyed)switch(o){case"data":this.c.data.push(n),this.resume();break;case"end":this.c.end.push(n),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(n),this.a.flowing&&this.k();break}}removeListener(o,n){if(this.a.destroyed)return;let i;switch(o){case"data":i=this.c.data;break;case"end":i=this.c.end;break;case"error":i=this.c.error;break}if(i){const r=i.indexOf(n);r>=0&&i.splice(r,1)}}j(){if(this.b.data.length>0){const o=this.e(this.b.data);this.g(o),this.b.data.length=0;const n=[...this.d];this.d.length=0,n.forEach(i=>i())}}k(){if(this.c.error.length>0){for(const o of this.b.error)this.h(o);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function g(p,o){const n=[];let i;for(;(i=p.read())!==null;)n.push(i);return o(n)}function M(p,o,n){const i=[];let r;for(;(r=p.read())!==null&&i.length<n;)i.push(r);return r===null&&i.length>0?o(i):{read:()=>{if(i.length>0)return i.shift();if(typeof r<"u"){const v=r;return r=void 0,v}return p.read()}}}function H(p,o){return new Promise((n,i)=>{const r=[];A(p,{onData:v=>{o&&r.push(v)},onError:v=>{o?i(v):n(void 0)},onEnd:()=>{n(o?o(r):void 0)}})})}function A(p,o,n){p.on("error",i=>{n?.isCancellationRequested||o.onError(i)}),p.on("end",()=>{n?.isCancellationRequested||o.onEnd()}),p.on("data",i=>{n?.isCancellationRequested||o.onData(i)})}function N(p,o){return new Promise((n,i)=>{const r=new t.$Tc,v=[],G=l=>{if(v.push(l),v.length>o)return r.dispose(),p.pause(),n({stream:p,buffer:v,ended:!1})},_=l=>(r.dispose(),i(l)),y=()=>(r.dispose(),n({stream:p,buffer:v,ended:!0}));r.add((0,t.$Sc)(()=>p.removeListener("error",_))),p.on("error",_),r.add((0,t.$Sc)(()=>p.removeListener("end",y))),p.on("end",y),r.add((0,t.$Sc)(()=>p.removeListener("data",G))),p.on("data",G)})}function R(p,o){const n=L(o);return n.end(p),n}function s(){const p=L(()=>{throw new Error("not supported")});return p.end(),p}function w(p){let o=!1;return{read:()=>o?null:(o=!0,p)}}function T(p,o,n){const i=L(n);return A(p,{onData:r=>i.write(o.data(r)),onError:r=>i.error(o.error?o.error(r):r),onEnd:()=>i.end()}),i}function m(p,o,n){let i=!1;return{read:()=>{const r=o.read();return i?r:(i=!0,r!==null?n([p,r]):p)}}}function D(p,o,n){let i=!1;const r=L(n);return A(o,{onData:v=>i?r.write(v):(i=!0,r.write(n([p,v]))),onError:v=>r.error(v),onEnd:()=>{i||(i=!0,r.write(p)),r.end()}}),r}}),define(ge[11],me([0,1,13,34]),function(fe,e,f,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Je=void 0,e.$Ke=g,e.$Le=M,e.$Me=H,e.$Ne=A,e.$Oe=N,e.$Pe=R,e.$Qe=s,e.$Re=w,e.$Se=T,e.$Te=m,e.$Ue=D,e.$Ve=p,e.$We=o,e.$Xe=n,e.$Ye=i,e.$Ze=r,e.$1e=v,e.$2e=G,e.$3e=_,e.$4e=I;const P=typeof Buffer<"u",b=new f.$V(()=>new Uint8Array(256));let q,L;class a{static alloc(h){return P?new a(Buffer.allocUnsafe(h)):new a(new Uint8Array(h))}static wrap(h){return P&&!Buffer.isBuffer(h)&&(h=Buffer.from(h.buffer,h.byteOffset,h.byteLength)),new a(h)}static fromString(h,c){return!(c?.dontUseNodeBuffer||!1)&&P?new a(Buffer.from(h)):(q||(q=new TextEncoder),new a(q.encode(h)))}static fromByteArray(h){const c=a.alloc(h.length);for(let K=0,te=h.length;K<te;K++)c.buffer[K]=h[K];return c}static concat(h,c){if(typeof c>"u"){c=0;for(let Q=0,V=h.length;Q<V;Q++)c+=h[Q].byteLength}const K=a.alloc(c);let te=0;for(let Q=0,V=h.length;Q<V;Q++){const x=h[Q];K.set(x,te),te+=x.byteLength}return K}constructor(h){this.buffer=h,this.byteLength=this.buffer.byteLength}clone(){const h=a.alloc(this.byteLength);return h.set(this),h}toString(){return P?this.buffer.toString():(L||(L=new TextDecoder),L.decode(this.buffer))}slice(h,c){return new a(this.buffer.subarray(h,c))}set(h,c){if(h instanceof a)this.buffer.set(h.buffer,c);else if(h instanceof Uint8Array)this.buffer.set(h,c);else if(h instanceof ArrayBuffer)this.buffer.set(new Uint8Array(h),c);else if(ArrayBuffer.isView(h))this.buffer.set(new Uint8Array(h.buffer,h.byteOffset,h.byteLength),c);else throw new Error("Unknown argument 'array'")}readUInt32BE(h){return A(this.buffer,h)}writeUInt32BE(h,c){N(this.buffer,h,c)}readUInt32LE(h){return R(this.buffer,h)}writeUInt32LE(h,c){s(this.buffer,h,c)}readUInt8(h){return w(this.buffer,h)}writeUInt8(h,c){T(this.buffer,h,c)}indexOf(h,c=0){return g(this.buffer,h instanceof a?h.buffer:h,c)}}e.$Je=a;function g(E,h,c=0){const K=h.byteLength,te=E.byteLength;if(K===0)return 0;if(K===1)return E.indexOf(h[0]);if(K>te-c)return-1;const Q=b.value;Q.fill(h.length);for(let Y=0;Y<h.length;Y++)Q[h[Y]]=h.length-Y-1;let V=c+h.length-1,x=V,z=-1;for(;V<te;)if(E[V]===h[x]){if(x===0){z=V;break}V--,x--}else V+=Math.max(h.length-x,Q[E[V]]),x=h.length-1;return z}function M(E,h){return E[h+0]<<0>>>0|E[h+1]<<8>>>0}function H(E,h,c){E[c+0]=h&255,h=h>>>8,E[c+1]=h&255}function A(E,h){return E[h]*2**24+E[h+1]*2**16+E[h+2]*2**8+E[h+3]}function N(E,h,c){E[c+3]=h,h=h>>>8,E[c+2]=h,h=h>>>8,E[c+1]=h,h=h>>>8,E[c]=h}function R(E,h){return E[h+0]<<0>>>0|E[h+1]<<8>>>0|E[h+2]<<16>>>0|E[h+3]<<24>>>0}function s(E,h,c){E[c+0]=h&255,h=h>>>8,E[c+1]=h&255,h=h>>>8,E[c+2]=h&255,h=h>>>8,E[c+3]=h&255}function w(E,h){return E[h]}function T(E,h,c){E[c]=h}function m(E){return t.$ye(E,h=>a.concat(h))}function D(E){return t.$Fe(E)}function p(E){return t.$Ae(E,h=>a.concat(h))}async function o(E){return E.ended?a.concat(E.buffer):a.concat([...E.buffer,await p(E.stream)])}function n(E){return t.$De(E,h=>a.concat(h))}function i(E){return t.$Ge(E,{data:h=>typeof h=="string"?a.fromString(h):a.wrap(h)},h=>a.concat(h))}function r(E){return t.$xe(h=>a.concat(h),E)}function v(E,h){return t.$He(E,h,c=>a.concat(c))}function G(E,h){return t.$Ie(E,h,c=>a.concat(c))}function _(E){let h=0,c=0,K=0;const te=new Uint8Array(Math.floor(E.length/4*3)),Q=x=>{switch(c){case 3:te[K++]=h|x,c=0;break;case 2:te[K++]=h|x>>>2,h=x<<6,c=3;break;case 1:te[K++]=h|x>>>4,h=x<<4,c=2;break;default:h=x<<2,c=1}};for(let x=0;x<E.length;x++){const z=E.charCodeAt(x);if(z>=65&&z<=90)Q(z-65);else if(z>=97&&z<=122)Q(z-97+26);else if(z>=48&&z<=57)Q(z-48+52);else if(z===43||z===45)Q(62);else if(z===47||z===95)Q(63);else{if(z===61)break;throw new SyntaxError(`Unexpected base64 character ${E[x]}`)}}const V=K;for(;c>0;)Q(0);return a.wrap(te).slice(0,V)}const y="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",l="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function I({buffer:E},h=!0,c=!1){const K=c?l:y;let te="";const Q=E.byteLength%3;let V=0;for(;V<E.byteLength-Q;V+=3){const x=E[V+0],z=E[V+1],Y=E[V+2];te+=K[x>>>2],te+=K[(x<<4|z>>>4)&63],te+=K[(z<<2|Y>>>6)&63],te+=K[Y&63]}if(Q===1){const x=E[V+0];te+=K[x>>>2],te+=K[x<<4&63],h&&(te+="==")}else if(Q===2){const x=E[V+0],z=E[V+1];te+=K[x>>>2],te+=K[(x<<4|z>>>4)&63],te+=K[z<<2&63],h&&(te+="=")}return te}}),define(ge[35],me([0,1]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ce=void 0,e.$ce=Symbol("MicrotaskDelay")}),define(ge[8],me([0,1]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ag=f,e.$bg=t,e.$cg=P,e.$dg=b,e.$eg=q,e.$fg=L,e.$gg=a,e.$hg=g,e.$ig=M,e.$jg=H,e.$kg=A,e.$lg=N,e.$mg=R,e.$ng=w,e.$og=T,e.$pg=m,e.$qg=D,e.$rg=p;function f(o){return typeof o=="string"}function t(o){return Array.isArray(o)&&o.every(n=>f(n))}function P(o){return typeof o=="object"&&o!==null&&!Array.isArray(o)&&!(o instanceof RegExp)&&!(o instanceof Date)}function b(o){const n=Object.getPrototypeOf(Uint8Array);return typeof o=="object"&&o instanceof n}function q(o){return typeof o=="number"&&!isNaN(o)}function L(o){return!!o&&typeof o[Symbol.iterator]=="function"}function a(o){return o===!0||o===!1}function g(o){return typeof o>"u"}function M(o){return!H(o)}function H(o){return g(o)||o===null}function A(o,n){if(!o)throw new Error(n?`Unexpected type, expected '${n}'`:"Unexpected type")}function N(o){if(H(o))throw new Error("Assertion Failed: argument is undefined or null");return o}function R(...o){const n=[];for(let i=0;i<o.length;i++){const r=o[i];if(H(r))throw new Error(`Assertion Failed: argument at index ${i} is undefined or null`);n.push(r)}return n}const s=Object.prototype.hasOwnProperty;function w(o){if(!P(o))return!1;for(const n in o)if(s.call(o,n))return!1;return!0}function T(o){return typeof o=="function"}function m(...o){return o.length>0&&o.every(T)}function D(o,n){const i=Math.min(o.length,n.length);for(let r=0;r<i;r++)p(o[r],n[r])}function p(o,n){if(f(n)){if(typeof o!==n)throw new Error(`argument does not match constraint: typeof ${n}`)}else if(T(n)){try{if(o instanceof n)return}catch{}if(!H(o)&&o.constructor===n||n.length===1&&n.call(void 0,o)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}}),define(ge[14],me([0,1,8]),function(fe,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9n=t,e.$0n=P,e.$$n=q,e.$_n=a,e.$ao=g,e.$bo=M,e.$co=H,e.$do=A,e.$eo=N,e.$fo=R,e.$go=s,e.$ho=w,e.$io=T;function t(m){if(!m||typeof m!="object"||m instanceof RegExp)return m;const D=Array.isArray(m)?[]:{};return Object.entries(m).forEach(([p,o])=>{D[p]=o&&typeof o=="object"?t(o):o}),D}function P(m){if(!m||typeof m!="object")return m;const D=[m];for(;D.length>0;){const p=D.shift();Object.freeze(p);for(const o in p)if(b.call(p,o)){const n=p[o];typeof n=="object"&&!Object.isFrozen(n)&&!(0,f.$dg)(n)&&D.push(n)}}return m}const b=Object.prototype.hasOwnProperty;function q(m,D){return L(m,D,new Set)}function L(m,D,p){if((0,f.$jg)(m))return m;const o=D(m);if(typeof o<"u")return o;if(Array.isArray(m)){const n=[];for(const i of m)n.push(L(i,D,p));return n}if((0,f.$cg)(m)){if(p.has(m))throw new Error("Cannot clone recursive data-structure");p.add(m);const n={};for(const i in m)b.call(m,i)&&(n[i]=L(m[i],D,p));return p.delete(m),n}return m}function a(m,D,p=!0){return(0,f.$cg)(m)?((0,f.$cg)(D)&&Object.keys(D).forEach(o=>{o in m?p&&((0,f.$cg)(m[o])&&(0,f.$cg)(D[o])?a(m[o],D[o],p):m[o]=D[o]):m[o]=D[o]}),m):D}function g(m,D){if(m===D)return!0;if(m==null||D===null||D===void 0||typeof m!=typeof D||typeof m!="object"||Array.isArray(m)!==Array.isArray(D))return!1;let p,o;if(Array.isArray(m)){if(m.length!==D.length)return!1;for(p=0;p<m.length;p++)if(!g(m[p],D[p]))return!1}else{const n=[];for(o in m)n.push(o);n.sort();const i=[];for(o in D)i.push(o);if(i.sort(),!g(n,i))return!1;for(p=0;p<n.length;p++)if(!g(m[n[p]],D[n[p]]))return!1}return!0}function M(m){const D=new Set;return JSON.stringify(m,(p,o)=>{if((0,f.$cg)(o)||Array.isArray(o)){if(D.has(o))return"[Circular]";D.add(o)}return typeof o=="bigint"?`[BigInt ${o.toString()}]`:o})}function H(m,D){const p=Object.create(null);return!m||!D||Object.keys(D).forEach(n=>{const i=m[n],r=D[n];g(i,r)||(p[n]=r)}),p}function A(m,D){const p=D.toLowerCase(),o=Object.keys(m).find(n=>n.toLowerCase()===p);return o?m[o]:m[D]}function N(m,D){const p=Object.create(null);for(const[o,n]of Object.entries(m))D(o,n)&&(p[o]=n);return p}function R(m){let D=[];for(;Object.prototype!==m;)D=D.concat(Object.getOwnPropertyNames(m)),m=Object.getPrototypeOf(m);return D}function s(m){const D=[];for(const p of R(m))typeof m[p]=="function"&&D.push(p);return D}function w(m,D){const p=n=>function(){const i=Array.prototype.slice.call(arguments,0);return D(n,i)},o={};for(const n of m)o[n]=p(n);return o}function T(m,D){const p={};for(const[o,n]of Object.entries(m))p[o]=D(n,o);return p}}),define(ge[36],me([0,1]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Constants=void 0,e.$9e=t,e.$0e=P;var f;(function(b){b[b.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",b[b.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",b[b.MAX_UINT_8=255]="MAX_UINT_8",b[b.MAX_UINT_16=65535]="MAX_UINT_16",b[b.MAX_UINT_32=4294967295]="MAX_UINT_32",b[b.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(f||(e.Constants=f={}));function t(b){return b<0?0:b>f.MAX_UINT_8?f.MAX_UINT_8:b|0}function P(b){return b<0?0:b>f.MAX_UINT_32?f.MAX_UINT_32:b|0}}),define(ge[12],me([0,1,33,9,13,36]),function(fe,e,f,t,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_f=e.$$f=e.$0f=e.GraphemeBreakType=e.$Zf=e.$Rf=e.$Kf=e.$Jf=void 0,e.$$e=q,e.$_e=a,e.$af=M,e.$bf=H,e.$cf=A,e.$df=N,e.$ef=R,e.$ff=s,e.$gf=w,e.$hf=T,e.$if=m,e.$jf=D,e.$kf=p,e.$lf=o,e.$mf=n,e.$nf=i,e.$of=r,e.$pf=v,e.$qf=G,e.$rf=_,e.$sf=y,e.$tf=l,e.$uf=I,e.$vf=E,e.$wf=h,e.$xf=c,e.$yf=K,e.$zf=te,e.$Af=Q,e.$Bf=V,e.$Cf=x,e.$Df=z,e.$Ef=Y,e.$Ff=ne,e.$Gf=se,e.$Hf=U,e.$If=$,e.$Lf=ce,e.$Mf=_e,e.$Nf=be,e.$Of=ye,e.$Pf=S,e.$Qf=j,e.$Sf=O,e.$Tf=u,e.$Uf=k,e.$Vf=X,e.$Wf=le,e.$Xf=Re,e.$Yf=re,e.$1f=he,e.$2f=ue,e.$3f=$e,e.$4f=Ae,e.$5f=Le,e.$6f=Ue,e.$7f=Ie,e.$8f=Fe,e.$9f=He;function q(d){return!d||typeof d!="string"?!0:d.trim().length===0}const L=/{(\d+)}/g;function a(d,...F){return F.length===0?d:d.replace(L,function(Z,ee){const ae=parseInt(ee,10);return isNaN(ae)||ae<0||ae>=F.length?Z:F[ae]})}const g=/{([^}]+)}/g;function M(d,F){return Object.keys(F).length===0?d:d.replace(g,(Z,ee)=>F[ee]??Z)}function H(d){return d.replace(/[<>"'&]/g,F=>{switch(F){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return F})}function A(d){return d.replace(/[<>&]/g,function(F){switch(F){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return F}})}function N(d){return d.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function R(d,F){let Z=0,ee=d.indexOf(F);for(;ee!==-1;)Z++,ee=d.indexOf(F,ee+F.length);return Z}function s(d,F,Z="\u2026"){return d.length<=F?d:`${d.substr(0,F)}${Z}`}function w(d,F,Z="\u2026"){if(d.length<=F)return d;const ee=Math.ceil(F/2)-Z.length/2,ae=Math.floor(F/2)-Z.length/2;return`${d.substr(0,ee)}${Z}${d.substr(d.length-ae)}`}function T(d,F=" "){const Z=m(d,F);return D(Z,F)}function m(d,F){if(!d||!F)return d;const Z=F.length;if(Z===0||d.length===0)return d;let ee=0;for(;d.indexOf(F,ee)===ee;)ee=ee+Z;return d.substring(ee)}function D(d,F){if(!d||!F)return d;const Z=F.length,ee=d.length;if(Z===0||ee===0)return d;let ae=ee,ve=-1;for(;ve=d.lastIndexOf(F,ae-1),!(ve===-1||ve+Z!==ae);){if(ve===0)return"";ae=ve}return d.substring(0,ae)}function p(d){return d.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function o(d){return d.replace(/\*/g,"")}function n(d,F,Z={}){if(!d)throw new Error("Cannot create regex from empty string");F||(d=N(d)),Z.wholeWord&&(/\B/.test(d.charAt(0))||(d="\\b"+d),/\B/.test(d.charAt(d.length-1))||(d=d+"\\b"));let ee="";return Z.global&&(ee+="g"),Z.matchCase||(ee+="i"),Z.multiline&&(ee+="m"),Z.unicode&&(ee+="u"),new RegExp(d,ee)}function i(d){return d.source==="^"||d.source==="^$"||d.source==="$"||d.source==="^\\s*$"?!1:!!(d.exec("")&&d.lastIndex===0)}function r(d){return d.split(/\r\n|\r|\n/)}function v(d){const F=[],Z=d.split(/(\r\n|\r|\n)/);for(let ee=0;ee<Math.ceil(Z.length/2);ee++)F.push(Z[2*ee]+(Z[2*ee+1]??""));return F}function G(d){for(let F=0,Z=d.length;F<Z;F++){const ee=d.charCodeAt(F);if(ee!==t.CharCode.Space&&ee!==t.CharCode.Tab)return F}return-1}function _(d,F=0,Z=d.length){for(let ee=F;ee<Z;ee++){const ae=d.charCodeAt(ee);if(ae!==t.CharCode.Space&&ae!==t.CharCode.Tab)return d.substring(F,ee)}return d.substring(F,Z)}function y(d,F=d.length-1){for(let Z=F;Z>=0;Z--){const ee=d.charCodeAt(Z);if(ee!==t.CharCode.Space&&ee!==t.CharCode.Tab)return Z}return-1}function l(d,F,Z){const ee=[];let ae=0;for(const ve of d.matchAll(F)){if(ee.push(d.slice(ae,ve.index)),ve.index===void 0)throw new Error("match.index should be defined");ae=ve.index+ve[0].length,ee.push(Z(ve[0],...ve.slice(1),ve.index,d,ve.groups))}return ee.push(d.slice(ae)),Promise.all(ee).then(ve=>ve.join(""))}function I(d,F){return d<F?-1:d>F?1:0}function E(d,F,Z=0,ee=d.length,ae=0,ve=F.length){for(;Z<ee&&ae<ve;Z++,ae++){const Se=d.charCodeAt(Z),Pe=F.charCodeAt(ae);if(Se<Pe)return-1;if(Se>Pe)return 1}const Oe=ee-Z,Me=ve-ae;return Oe<Me?-1:Oe>Me?1:0}function h(d,F){return c(d,F,0,d.length,0,F.length)}function c(d,F,Z=0,ee=d.length,ae=0,ve=F.length){for(;Z<ee&&ae<ve;Z++,ae++){let Se=d.charCodeAt(Z),Pe=F.charCodeAt(ae);if(Se===Pe)continue;if(Se>=128||Pe>=128)return E(d.toLowerCase(),F.toLowerCase(),Z,ee,ae,ve);te(Se)&&(Se-=32),te(Pe)&&(Pe-=32);const De=Se-Pe;if(De!==0)return De}const Oe=ee-Z,Me=ve-ae;return Oe<Me?-1:Oe>Me?1:0}function K(d){return d>=t.CharCode.Digit0&&d<=t.CharCode.Digit9}function te(d){return d>=t.CharCode.a&&d<=t.CharCode.z}function Q(d){return d>=t.CharCode.A&&d<=t.CharCode.Z}function V(d,F){return d.length===F.length&&c(d,F)===0}function x(d,F){const Z=F.length;return F.length>d.length?!1:c(d,F,0,Z)===0}function z(d,F){const Z=Math.min(d.length,F.length);let ee;for(ee=0;ee<Z;ee++)if(d.charCodeAt(ee)!==F.charCodeAt(ee))return ee;return Z}function Y(d,F){const Z=Math.min(d.length,F.length);let ee;const ae=d.length-1,ve=F.length-1;for(ee=0;ee<Z;ee++)if(d.charCodeAt(ae-ee)!==F.charCodeAt(ve-ee))return ee;return Z}function ne(d){return 55296<=d&&d<=56319}function se(d){return 56320<=d&&d<=57343}function U(d,F){return(d-55296<<10)+(F-56320)+65536}function $(d,F,Z){const ee=d.charCodeAt(Z);if(ne(ee)&&Z+1<F){const ae=d.charCodeAt(Z+1);if(se(ae))return U(ee,ae)}return ee}function W(d,F){const Z=d.charCodeAt(F-1);if(se(Z)&&F>1){const ee=d.charCodeAt(F-2);if(ne(ee))return U(ee,Z)}return Z}class J{get offset(){return this.e}constructor(F,Z=0){this.c=F,this.d=F.length,this.e=Z}setOffset(F){this.e=F}prevCodePoint(){const F=W(this.c,this.e);return this.e-=F>=b.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,F}nextCodePoint(){const F=$(this.c,this.d,this.e);return this.e+=F>=b.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,F}eol(){return this.e>=this.d}}e.$Jf=J;class ie{get offset(){return this.c.offset}constructor(F,Z=0){this.c=new J(F,Z)}nextGraphemeLength(){const F=Te.getInstance(),Z=this.c,ee=Z.offset;let ae=F.getGraphemeBreakType(Z.nextCodePoint());for(;!Z.eol();){const ve=Z.offset,Oe=F.getGraphemeBreakType(Z.nextCodePoint());if(Be(ae,Oe)){Z.setOffset(ve);break}ae=Oe}return Z.offset-ee}prevGraphemeLength(){const F=Te.getInstance(),Z=this.c,ee=Z.offset;let ae=F.getGraphemeBreakType(Z.prevCodePoint());for(;Z.offset>0;){const ve=Z.offset,Oe=F.getGraphemeBreakType(Z.prevCodePoint());if(Be(Oe,ae)){Z.setOffset(ve);break}ae=Oe}return ee-Z.offset}eol(){return this.c.eol()}}e.$Kf=ie;function ce(d,F){return new ie(d,F).nextGraphemeLength()}function _e(d,F){return new ie(d,F).prevGraphemeLength()}function be(d,F){F>0&&se(d.charCodeAt(F))&&F--;const Z=F+ce(d,F);return[Z-_e(d,Z),Z]}function ye(d){const F=new ie(d);let Z=0;for(;!F.eol();)Z++,F.nextGraphemeLength();return Z}let de;function Ee(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function S(d){return de||(de=Ee()),de.test(d)}const B=/^[\t\n\r\x20-\x7E]*$/;function j(d){return B.test(d)}e.$Rf=/[\u2028\u2029]/;function O(d){return e.$Rf.test(d)}function u(d){return d>=11904&&d<=55215||d>=63744&&d<=64255||d>=65281&&d<=65374}function k(d){return d>=127462&&d<=127487||d===8986||d===8987||d===9200||d===9203||d>=9728&&d<=10175||d===11088||d===11093||d>=127744&&d<=128591||d>=128640&&d<=128764||d>=128992&&d<=129008||d>=129280&&d<=129535||d>=129648&&d<=129782}function X(d,F,Z=""){const ee=d.trimStart();if(ee.length<F)return ee;const ae=/\b/g;let ve=0;for(;ae.test(ee)&&!(ee.length-ae.lastIndex<F);)ve=ae.lastIndex,ae.lastIndex+=1;return ve===0?ee:Z+ee.substring(ve).trimStart()}const C=/(?:(?:\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~])|(:?\x1b\].*?\x07)/g;function*le(d){let F=0;for(const Z of d.matchAll(C))F!==Z.index&&(yield{isCode:!1,str:d.substring(F,Z.index)}),yield{isCode:!0,str:Z[0]},F=Z.index+Z[0].length;F!==d.length&&(yield{isCode:!1,str:d.substring(F)})}function Re(d){return d&&(d=d.replace(C,"")),d}const oe=/\\\[.*?\\\]/g;function re(d){return Re(d).replace(oe,"")}e.$Zf=String.fromCharCode(t.CharCode.UTF8_BOM);function he(d){return!!(d&&d.length>0&&d.charCodeAt(0)===t.CharCode.UTF8_BOM)}function ue(d){return he(d)?d.substr(1):d}function $e(d,F){if(!d||!F||d.length<F.length)return!1;const Z=F.length,ee=d.toLowerCase();let ae=0,ve=-1;for(;ae<Z;){const Oe=ee.indexOf(F[ae],ve+1);if(Oe<0)return!1;ve=Oe,ae++}return!0}function Ae(d,F=!1){return d?(F&&(d=d.replace(/\\./g,"")),d.toLowerCase()!==d):!1}function Le(d){return d.charAt(0).toUpperCase()+d.slice(1)}function Ue(d,F=1){if(F===0)return"";let Z=-1;do Z=d.indexOf(`
`,Z+1),F--;while(F>0&&Z>=0);return Z===-1?d:(d[Z-1]==="\r"&&Z--,d.substr(0,Z))}function Ie(d){const F=t.CharCode.Z-t.CharCode.A+1;return d=d%(2*F),d<F?String.fromCharCode(t.CharCode.a+d):String.fromCharCode(t.CharCode.A+d-F)}function Fe(d){return Te.getInstance().getGraphemeBreakType(d)}function Be(d,F){return d===we.Other?F!==we.Extend&&F!==we.SpacingMark:d===we.CR&&F===we.LF?!1:d===we.Control||d===we.CR||d===we.LF||F===we.Control||F===we.CR||F===we.LF?!0:!(d===we.L&&(F===we.L||F===we.V||F===we.LV||F===we.LVT)||(d===we.LV||d===we.V)&&(F===we.V||F===we.T)||(d===we.LVT||d===we.T)&&F===we.T||F===we.Extend||F===we.ZWJ||F===we.SpacingMark||d===we.Prepend||d===we.ZWJ&&F===we.Extended_Pictographic||d===we.Regional_Indicator&&F===we.Regional_Indicator)}var we;(function(d){d[d.Other=0]="Other",d[d.Prepend=1]="Prepend",d[d.CR=2]="CR",d[d.LF=3]="LF",d[d.Control=4]="Control",d[d.Extend=5]="Extend",d[d.Regional_Indicator=6]="Regional_Indicator",d[d.SpacingMark=7]="SpacingMark",d[d.L=8]="L",d[d.V=9]="V",d[d.T=10]="T",d[d.LV=11]="LV",d[d.LVT=12]="LVT",d[d.ZWJ=13]="ZWJ",d[d.Extended_Pictographic=14]="Extended_Pictographic"})(we||(e.GraphemeBreakType=we={}));class Te{static{this.c=null}static getInstance(){return Te.c||(Te.c=new Te),Te.c}constructor(){this.d=je()}getGraphemeBreakType(F){if(F<32)return F===t.CharCode.LineFeed?we.LF:F===t.CharCode.CarriageReturn?we.CR:we.Control;if(F<127)return we.Other;const Z=this.d,ee=Z.length/3;let ae=1;for(;ae<=ee;)if(F<Z[3*ae])ae=2*ae;else if(F>Z[3*ae+1])ae=2*ae+1;else return Z[3*ae+2];return we.Other}}function je(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function He(d,F){if(d===0)return 0;const Z=ze(d,F);if(Z!==void 0)return Z;const ee=new J(F,d);return ee.prevCodePoint(),ee.offset}function ze(d,F){const Z=new J(F,d);let ee=Z.prevCodePoint();for(;Xe(ee)||ee===We.emojiVariantSelector||ee===We.enclosingKeyCap;){if(Z.offset===0)return;ee=Z.prevCodePoint()}if(!k(ee))return;let ae=Z.offset;return ae>0&&Z.prevCodePoint()===We.zwj&&(ae=Z.offset),ae}function Xe(d){return 127995<=d&&d<=127999}var We;(function(d){d[d.zwj=8205]="zwj",d[d.emojiVariantSelector=65039]="emojiVariantSelector",d[d.enclosingKeyCap=8419]="enclosingKeyCap"})(We||(We={})),e.$0f="\xA0";class pe{static{this.c=new P.$V(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new f.$7e({getCacheKey:JSON.stringify},F=>{function Z(De){const ke=new Map;for(let Ne=0;Ne<De.length;Ne+=2)ke.set(De[Ne],De[Ne+1]);return ke}function ee(De,ke){const Ne=new Map(De);for(const[Ge,Ve]of ke)Ne.set(Ge,Ve);return Ne}function ae(De,ke){if(!De)return ke;const Ne=new Map;for(const[Ge,Ve]of De)ke.has(Ge)&&Ne.set(Ge,Ve);return Ne}const ve=this.c.value;let Oe=F.filter(De=>!De.startsWith("_")&&De in ve);Oe.length===0&&(Oe=["_default"]);let Me;for(const De of Oe){const ke=Z(ve[De]);Me=ae(Me,ke)}const Se=Z(ve._common),Pe=ee(Se,Me);return new pe(Pe)})}static getInstance(F){return pe.d.get(Array.from(F))}static{this.e=new P.$V(()=>Object.keys(pe.c.value).filter(F=>!F.startsWith("_")))}static getLocales(){return pe.e.value}constructor(F){this.f=F}isAmbiguous(F){return this.f.has(F)}containsAmbiguousCharacter(F){for(let Z=0;Z<F.length;Z++){const ee=F.codePointAt(Z);if(typeof ee=="number"&&this.isAmbiguous(ee))return!0}return!1}getPrimaryConfusable(F){return this.f.get(F)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$$f=pe;class qe{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(qe.c())),this.d}static isInvisibleCharacter(F){return qe.e().has(F)}static containsInvisibleCharacter(F){for(let Z=0;Z<F.length;Z++){const ee=F.codePointAt(Z);if(typeof ee=="number"&&qe.isInvisibleCharacter(ee))return!0}return!1}static get codePoints(){return qe.e()}}e.$_f=qe}),define(ge[37],me([0,1]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wg=void 0,e.$Vg=t;const f=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function t(P){return f.test(P)}e.$Wg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let P;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?P=crypto.getRandomValues.bind(crypto):P=function(L){for(let a=0;a<L.length;a++)L[a]=Math.floor(Math.random()*256);return L};const b=new Uint8Array(16),q=[];for(let L=0;L<256;L++)q.push(L.toString(16).padStart(2,"0"));return function(){P(b),b[6]=b[6]&15|64,b[8]=b[8]&63|128;let a=0,g="";return g+=q[b[a++]],g+=q[b[a++]],g+=q[b[a++]],g+=q[b[a++]],g+="-",g+=q[b[a++]],g+=q[b[a++]],g+="-",g+=q[b[a++]],g+=q[b[a++]],g+="-",g+=q[b[a++]],g+=q[b[a++]],g+="-",g+=q[b[a++]],g+=q[b[a++]],g+=q[b[a++]],g+=q[b[a++]],g+=q[b[a++]],g+=q[b[a++]],g}}()}),define(ge[38],me([54,55]),function(fe,e){return fe.create("vs/base/common/platform",e)}),define(ge[2],me([0,1,38]),function(fe,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$I=e.$H=e.$G=e.$F=e.$E=e.OS=e.OperatingSystem=e.$B=e.$A=e.$z=e.$y=e.$x=e.Language=e.$w=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.Platform=e.$g=void 0,e.$h=i,e.$D=l,e.$J=I,e.$g="en";let t=!1,P=!1,b=!1,q=!1,L=!1,a=!1,g=!1,M=!1,H=!1,A=!1,N,R=e.$g,s=e.$g,w,T;const m=globalThis;let D;typeof m.vscode<"u"&&typeof m.vscode.process<"u"?D=m.vscode.process:typeof process<"u"&&typeof process?.versions?.node=="string"&&(D=process);const p=typeof D?.versions?.electron=="string",o=p&&D?.type==="renderer";if(typeof D=="object"){t=D.platform==="win32",P=D.platform==="darwin",b=D.platform==="linux",q=b&&!!D.env.SNAP&&!!D.env.SNAP_REVISION,g=p,H=!!D.env.CI||!!D.env.BUILD_ARTIFACTSTAGINGDIRECTORY,N=e.$g,R=e.$g;const E=D.env.VSCODE_NLS_CONFIG;if(E)try{const h=JSON.parse(E),c=h.availableLanguages["*"];N=h.locale,s=h.osLocale,R=c||e.$g,w=h._translationsConfigFile}catch{}L=!0}else typeof navigator=="object"&&!o?(T=navigator.userAgent,t=T.indexOf("Windows")>=0,P=T.indexOf("Macintosh")>=0,M=(T.indexOf("Macintosh")>=0||T.indexOf("iPad")>=0||T.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,b=T.indexOf("Linux")>=0,A=T?.indexOf("Mobi")>=0,a=!0,N=f.getConfiguredDefaultLocale(f.localize(0,null))||e.$g,R=N,s=navigator.language):console.error("Unable to resolve platform.");var n;(function(E){E[E.Web=0]="Web",E[E.Mac=1]="Mac",E[E.Linux=2]="Linux",E[E.Windows=3]="Windows"})(n||(e.Platform=n={}));function i(E){switch(E){case n.Web:return"Web";case n.Mac:return"Mac";case n.Linux:return"Linux";case n.Windows:return"Windows"}}let r=n.Web;P?r=n.Mac:t?r=n.Windows:b&&(r=n.Linux),e.$i=t,e.$j=P,e.$k=b,e.$l=q,e.$m=L,e.$n=g,e.$o=a,e.$p=a&&typeof m.importScripts=="function",e.$q=e.$p?m.origin:void 0,e.$r=M,e.$s=A,e.$t=H,e.$u=r,e.$v=T,e.$w=R;var v;(function(E){function h(){return e.$w}E.value=h;function c(){return e.$w.length===2?e.$w==="en":e.$w.length>=3?e.$w[0]==="e"&&e.$w[1]==="n"&&e.$w[2]==="-":!1}E.isDefaultVariant=c;function K(){return e.$w==="en"}E.isDefault=K})(v||(e.Language=v={})),e.$x=N,e.$y=s,e.$z=w,e.$A=typeof m.postMessage=="function"&&!m.importScripts,e.$B=(()=>{if(e.$A){const E=[];m.addEventListener("message",c=>{if(c.data&&c.data.vscodeScheduleAsyncWork)for(let K=0,te=E.length;K<te;K++){const Q=E[K];if(Q.id===c.data.vscodeScheduleAsyncWork){E.splice(K,1),Q.callback();return}}});let h=0;return c=>{const K=++h;E.push({id:K,callback:c}),m.postMessage({vscodeScheduleAsyncWork:K},"*")}}return E=>setTimeout(E)})();var G;(function(E){E[E.Windows=1]="Windows",E[E.Macintosh=2]="Macintosh",E[E.Linux=3]="Linux"})(G||(e.OperatingSystem=G={})),e.OS=P||M?G.Macintosh:t?G.Windows:G.Linux;let _=!0,y=!1;function l(){if(!y){y=!0;const E=new Uint8Array(2);E[0]=1,E[1]=2,_=new Uint16Array(E.buffer)[0]===513}return _}e.$E=!!(e.$v&&e.$v.indexOf("Chrome")>=0),e.$F=!!(e.$v&&e.$v.indexOf("Firefox")>=0),e.$G=!!(!e.$E&&e.$v&&e.$v.indexOf("Safari")>=0),e.$H=!!(e.$v&&e.$v.indexOf("Edg/")>=0),e.$I=!!(e.$v&&e.$v.indexOf("Android")>=0);function I(E){return parseFloat(E)>=20}}),define(ge[15],me([0,1,2]),function(fe,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ec=e.$dc=e.env=e.cwd=void 0;let t;const P=globalThis.vscode;if(typeof P<"u"&&typeof P.process<"u"){const b=P.process;t={get platform(){return b.platform},get arch(){return b.arch},get env(){return b.env},cwd(){return b.cwd()}}}else typeof process<"u"?t={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:t={get platform(){return f.$i?"win32":f.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=t.cwd,e.env=t.env,e.$dc=t.platform,e.$ec=t.arch}),define(ge[4],me([0,1,15]),function(fe,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tc=e.sep=e.$rc=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=e.$gc=e.$fc=void 0;const t=65,P=97,b=90,q=122,L=46,a=47,g=92,M=58,H=63;class A extends Error{constructor(i,r,v){let G;typeof r=="string"&&r.indexOf("not ")===0?(G="must not be",r=r.replace(/^not /,"")):G="must be";const _=i.indexOf(".")!==-1?"property":"argument";let y=`The "${i}" ${_} ${G} of type ${r}`;y+=`. Received type ${typeof v}`,super(y),this.code="ERR_INVALID_ARG_TYPE"}}function N(n,i){if(n===null||typeof n!="object")throw new A(i,"Object",n)}function R(n,i){if(typeof n!="string")throw new A(i,"string",n)}const s=f.$dc==="win32";function w(n){return n===a||n===g}function T(n){return n===a}function m(n){return n>=t&&n<=b||n>=P&&n<=q}function D(n,i,r,v){let G="",_=0,y=-1,l=0,I=0;for(let E=0;E<=n.length;++E){if(E<n.length)I=n.charCodeAt(E);else{if(v(I))break;I=a}if(v(I)){if(!(y===E-1||l===1))if(l===2){if(G.length<2||_!==2||G.charCodeAt(G.length-1)!==L||G.charCodeAt(G.length-2)!==L){if(G.length>2){const h=G.lastIndexOf(r);h===-1?(G="",_=0):(G=G.slice(0,h),_=G.length-1-G.lastIndexOf(r)),y=E,l=0;continue}else if(G.length!==0){G="",_=0,y=E,l=0;continue}}i&&(G+=G.length>0?`${r}..`:"..",_=2)}else G.length>0?G+=`${r}${n.slice(y+1,E)}`:G=n.slice(y+1,E),_=E-y-1;y=E,l=0}else I===L&&l!==-1?++l:l=-1}return G}function p(n,i){N(i,"pathObject");const r=i.dir||i.root,v=i.base||`${i.name||""}${i.ext||""}`;return r?r===i.root?`${r}${v}`:`${r}${n}${v}`:v}e.$fc={resolve(...n){let i="",r="",v=!1;for(let G=n.length-1;G>=-1;G--){let _;if(G>=0){if(_=n[G],R(_,"path"),_.length===0)continue}else i.length===0?_=f.cwd():(_=f.env[`=${i}`]||f.cwd(),(_===void 0||_.slice(0,2).toLowerCase()!==i.toLowerCase()&&_.charCodeAt(2)===g)&&(_=`${i}\\`));const y=_.length;let l=0,I="",E=!1;const h=_.charCodeAt(0);if(y===1)w(h)&&(l=1,E=!0);else if(w(h))if(E=!0,w(_.charCodeAt(1))){let c=2,K=c;for(;c<y&&!w(_.charCodeAt(c));)c++;if(c<y&&c!==K){const te=_.slice(K,c);for(K=c;c<y&&w(_.charCodeAt(c));)c++;if(c<y&&c!==K){for(K=c;c<y&&!w(_.charCodeAt(c));)c++;(c===y||c!==K)&&(I=`\\\\${te}\\${_.slice(K,c)}`,l=c)}}}else l=1;else m(h)&&_.charCodeAt(1)===M&&(I=_.slice(0,2),l=2,y>2&&w(_.charCodeAt(2))&&(E=!0,l=3));if(I.length>0)if(i.length>0){if(I.toLowerCase()!==i.toLowerCase())continue}else i=I;if(v){if(i.length>0)break}else if(r=`${_.slice(l)}\\${r}`,v=E,E&&i.length>0)break}return r=D(r,!v,"\\",w),v?`${i}\\${r}`:`${i}${r}`||"."},normalize(n){R(n,"path");const i=n.length;if(i===0)return".";let r=0,v,G=!1;const _=n.charCodeAt(0);if(i===1)return T(_)?"\\":n;if(w(_))if(G=!0,w(n.charCodeAt(1))){let l=2,I=l;for(;l<i&&!w(n.charCodeAt(l));)l++;if(l<i&&l!==I){const E=n.slice(I,l);for(I=l;l<i&&w(n.charCodeAt(l));)l++;if(l<i&&l!==I){for(I=l;l<i&&!w(n.charCodeAt(l));)l++;if(l===i)return`\\\\${E}\\${n.slice(I)}\\`;l!==I&&(v=`\\\\${E}\\${n.slice(I,l)}`,r=l)}}}else r=1;else m(_)&&n.charCodeAt(1)===M&&(v=n.slice(0,2),r=2,i>2&&w(n.charCodeAt(2))&&(G=!0,r=3));let y=r<i?D(n.slice(r),!G,"\\",w):"";return y.length===0&&!G&&(y="."),y.length>0&&w(n.charCodeAt(i-1))&&(y+="\\"),v===void 0?G?`\\${y}`:y:G?`${v}\\${y}`:`${v}${y}`},isAbsolute(n){R(n,"path");const i=n.length;if(i===0)return!1;const r=n.charCodeAt(0);return w(r)||i>2&&m(r)&&n.charCodeAt(1)===M&&w(n.charCodeAt(2))},join(...n){if(n.length===0)return".";let i,r;for(let _=0;_<n.length;++_){const y=n[_];R(y,"path"),y.length>0&&(i===void 0?i=r=y:i+=`\\${y}`)}if(i===void 0)return".";let v=!0,G=0;if(typeof r=="string"&&w(r.charCodeAt(0))){++G;const _=r.length;_>1&&w(r.charCodeAt(1))&&(++G,_>2&&(w(r.charCodeAt(2))?++G:v=!1))}if(v){for(;G<i.length&&w(i.charCodeAt(G));)G++;G>=2&&(i=`\\${i.slice(G)}`)}return e.$fc.normalize(i)},relative(n,i){if(R(n,"from"),R(i,"to"),n===i)return"";const r=e.$fc.resolve(n),v=e.$fc.resolve(i);if(r===v||(n=r.toLowerCase(),i=v.toLowerCase(),n===i))return"";let G=0;for(;G<n.length&&n.charCodeAt(G)===g;)G++;let _=n.length;for(;_-1>G&&n.charCodeAt(_-1)===g;)_--;const y=_-G;let l=0;for(;l<i.length&&i.charCodeAt(l)===g;)l++;let I=i.length;for(;I-1>l&&i.charCodeAt(I-1)===g;)I--;const E=I-l,h=y<E?y:E;let c=-1,K=0;for(;K<h;K++){const Q=n.charCodeAt(G+K);if(Q!==i.charCodeAt(l+K))break;Q===g&&(c=K)}if(K!==h){if(c===-1)return v}else{if(E>h){if(i.charCodeAt(l+K)===g)return v.slice(l+K+1);if(K===2)return v.slice(l+K)}y>h&&(n.charCodeAt(G+K)===g?c=K:K===2&&(c=3)),c===-1&&(c=0)}let te="";for(K=G+c+1;K<=_;++K)(K===_||n.charCodeAt(K)===g)&&(te+=te.length===0?"..":"\\..");return l+=c,te.length>0?`${te}${v.slice(l,I)}`:(v.charCodeAt(l)===g&&++l,v.slice(l,I))},toNamespacedPath(n){if(typeof n!="string"||n.length===0)return n;const i=e.$fc.resolve(n);if(i.length<=2)return n;if(i.charCodeAt(0)===g){if(i.charCodeAt(1)===g){const r=i.charCodeAt(2);if(r!==H&&r!==L)return`\\\\?\\UNC\\${i.slice(2)}`}}else if(m(i.charCodeAt(0))&&i.charCodeAt(1)===M&&i.charCodeAt(2)===g)return`\\\\?\\${i}`;return n},dirname(n){R(n,"path");const i=n.length;if(i===0)return".";let r=-1,v=0;const G=n.charCodeAt(0);if(i===1)return w(G)?n:".";if(w(G)){if(r=v=1,w(n.charCodeAt(1))){let l=2,I=l;for(;l<i&&!w(n.charCodeAt(l));)l++;if(l<i&&l!==I){for(I=l;l<i&&w(n.charCodeAt(l));)l++;if(l<i&&l!==I){for(I=l;l<i&&!w(n.charCodeAt(l));)l++;if(l===i)return n;l!==I&&(r=v=l+1)}}}}else m(G)&&n.charCodeAt(1)===M&&(r=i>2&&w(n.charCodeAt(2))?3:2,v=r);let _=-1,y=!0;for(let l=i-1;l>=v;--l)if(w(n.charCodeAt(l))){if(!y){_=l;break}}else y=!1;if(_===-1){if(r===-1)return".";_=r}return n.slice(0,_)},basename(n,i){i!==void 0&&R(i,"ext"),R(n,"path");let r=0,v=-1,G=!0,_;if(n.length>=2&&m(n.charCodeAt(0))&&n.charCodeAt(1)===M&&(r=2),i!==void 0&&i.length>0&&i.length<=n.length){if(i===n)return"";let y=i.length-1,l=-1;for(_=n.length-1;_>=r;--_){const I=n.charCodeAt(_);if(w(I)){if(!G){r=_+1;break}}else l===-1&&(G=!1,l=_+1),y>=0&&(I===i.charCodeAt(y)?--y===-1&&(v=_):(y=-1,v=l))}return r===v?v=l:v===-1&&(v=n.length),n.slice(r,v)}for(_=n.length-1;_>=r;--_)if(w(n.charCodeAt(_))){if(!G){r=_+1;break}}else v===-1&&(G=!1,v=_+1);return v===-1?"":n.slice(r,v)},extname(n){R(n,"path");let i=0,r=-1,v=0,G=-1,_=!0,y=0;n.length>=2&&n.charCodeAt(1)===M&&m(n.charCodeAt(0))&&(i=v=2);for(let l=n.length-1;l>=i;--l){const I=n.charCodeAt(l);if(w(I)){if(!_){v=l+1;break}continue}G===-1&&(_=!1,G=l+1),I===L?r===-1?r=l:y!==1&&(y=1):r!==-1&&(y=-1)}return r===-1||G===-1||y===0||y===1&&r===G-1&&r===v+1?"":n.slice(r,G)},format:p.bind(null,"\\"),parse(n){R(n,"path");const i={root:"",dir:"",base:"",ext:"",name:""};if(n.length===0)return i;const r=n.length;let v=0,G=n.charCodeAt(0);if(r===1)return w(G)?(i.root=i.dir=n,i):(i.base=i.name=n,i);if(w(G)){if(v=1,w(n.charCodeAt(1))){let c=2,K=c;for(;c<r&&!w(n.charCodeAt(c));)c++;if(c<r&&c!==K){for(K=c;c<r&&w(n.charCodeAt(c));)c++;if(c<r&&c!==K){for(K=c;c<r&&!w(n.charCodeAt(c));)c++;c===r?v=c:c!==K&&(v=c+1)}}}}else if(m(G)&&n.charCodeAt(1)===M){if(r<=2)return i.root=i.dir=n,i;if(v=2,w(n.charCodeAt(2))){if(r===3)return i.root=i.dir=n,i;v=3}}v>0&&(i.root=n.slice(0,v));let _=-1,y=v,l=-1,I=!0,E=n.length-1,h=0;for(;E>=v;--E){if(G=n.charCodeAt(E),w(G)){if(!I){y=E+1;break}continue}l===-1&&(I=!1,l=E+1),G===L?_===-1?_=E:h!==1&&(h=1):_!==-1&&(h=-1)}return l!==-1&&(_===-1||h===0||h===1&&_===l-1&&_===y+1?i.base=i.name=n.slice(y,l):(i.name=n.slice(y,_),i.base=n.slice(y,l),i.ext=n.slice(_,l))),y>0&&y!==v?i.dir=n.slice(0,y-1):i.dir=i.root,i},sep:"\\",delimiter:";",win32:null,posix:null};const o=(()=>{if(s){const n=/\\/g;return()=>{const i=f.cwd().replace(n,"/");return i.slice(i.indexOf("/"))}}return()=>f.cwd()})();e.$gc={resolve(...n){let i="",r=!1;for(let v=n.length-1;v>=-1&&!r;v--){const G=v>=0?n[v]:o();R(G,"path"),G.length!==0&&(i=`${G}/${i}`,r=G.charCodeAt(0)===a)}return i=D(i,!r,"/",T),r?`/${i}`:i.length>0?i:"."},normalize(n){if(R(n,"path"),n.length===0)return".";const i=n.charCodeAt(0)===a,r=n.charCodeAt(n.length-1)===a;return n=D(n,!i,"/",T),n.length===0?i?"/":r?"./":".":(r&&(n+="/"),i?`/${n}`:n)},isAbsolute(n){return R(n,"path"),n.length>0&&n.charCodeAt(0)===a},join(...n){if(n.length===0)return".";let i;for(let r=0;r<n.length;++r){const v=n[r];R(v,"path"),v.length>0&&(i===void 0?i=v:i+=`/${v}`)}return i===void 0?".":e.$gc.normalize(i)},relative(n,i){if(R(n,"from"),R(i,"to"),n===i||(n=e.$gc.resolve(n),i=e.$gc.resolve(i),n===i))return"";const r=1,v=n.length,G=v-r,_=1,y=i.length-_,l=G<y?G:y;let I=-1,E=0;for(;E<l;E++){const c=n.charCodeAt(r+E);if(c!==i.charCodeAt(_+E))break;c===a&&(I=E)}if(E===l)if(y>l){if(i.charCodeAt(_+E)===a)return i.slice(_+E+1);if(E===0)return i.slice(_+E)}else G>l&&(n.charCodeAt(r+E)===a?I=E:E===0&&(I=0));let h="";for(E=r+I+1;E<=v;++E)(E===v||n.charCodeAt(E)===a)&&(h+=h.length===0?"..":"/..");return`${h}${i.slice(_+I)}`},toNamespacedPath(n){return n},dirname(n){if(R(n,"path"),n.length===0)return".";const i=n.charCodeAt(0)===a;let r=-1,v=!0;for(let G=n.length-1;G>=1;--G)if(n.charCodeAt(G)===a){if(!v){r=G;break}}else v=!1;return r===-1?i?"/":".":i&&r===1?"//":n.slice(0,r)},basename(n,i){i!==void 0&&R(i,"ext"),R(n,"path");let r=0,v=-1,G=!0,_;if(i!==void 0&&i.length>0&&i.length<=n.length){if(i===n)return"";let y=i.length-1,l=-1;for(_=n.length-1;_>=0;--_){const I=n.charCodeAt(_);if(I===a){if(!G){r=_+1;break}}else l===-1&&(G=!1,l=_+1),y>=0&&(I===i.charCodeAt(y)?--y===-1&&(v=_):(y=-1,v=l))}return r===v?v=l:v===-1&&(v=n.length),n.slice(r,v)}for(_=n.length-1;_>=0;--_)if(n.charCodeAt(_)===a){if(!G){r=_+1;break}}else v===-1&&(G=!1,v=_+1);return v===-1?"":n.slice(r,v)},extname(n){R(n,"path");let i=-1,r=0,v=-1,G=!0,_=0;for(let y=n.length-1;y>=0;--y){const l=n.charCodeAt(y);if(l===a){if(!G){r=y+1;break}continue}v===-1&&(G=!1,v=y+1),l===L?i===-1?i=y:_!==1&&(_=1):i!==-1&&(_=-1)}return i===-1||v===-1||_===0||_===1&&i===v-1&&i===r+1?"":n.slice(i,v)},format:p.bind(null,"/"),parse(n){R(n,"path");const i={root:"",dir:"",base:"",ext:"",name:""};if(n.length===0)return i;const r=n.charCodeAt(0)===a;let v;r?(i.root="/",v=1):v=0;let G=-1,_=0,y=-1,l=!0,I=n.length-1,E=0;for(;I>=v;--I){const h=n.charCodeAt(I);if(h===a){if(!l){_=I+1;break}continue}y===-1&&(l=!1,y=I+1),h===L?G===-1?G=I:E!==1&&(E=1):G!==-1&&(E=-1)}if(y!==-1){const h=_===0&&r?1:_;G===-1||E===0||E===1&&G===y-1&&G===_+1?i.base=i.name=n.slice(h,y):(i.name=n.slice(h,G),i.base=n.slice(h,y),i.ext=n.slice(G,y))}return _>0?i.dir=n.slice(0,_-1):r&&(i.dir="/"),i},sep:"/",delimiter:":",win32:null,posix:null},e.$gc.win32=e.$fc.win32=e.$fc,e.$gc.posix=e.$fc.posix=e.$gc,e.$hc=s?e.$fc.normalize:e.$gc.normalize,e.$ic=s?e.$fc.isAbsolute:e.$gc.isAbsolute,e.$jc=s?e.$fc.join:e.$gc.join,e.$kc=s?e.$fc.resolve:e.$gc.resolve,e.$lc=s?e.$fc.relative:e.$gc.relative,e.$mc=s?e.$fc.dirname:e.$gc.dirname,e.$nc=s?e.$fc.basename:e.$gc.basename,e.$oc=s?e.$fc.extname:e.$gc.extname,e.$pc=s?e.$fc.format:e.$gc.format,e.$qc=s?e.$fc.parse:e.$gc.parse,e.$rc=s?e.$fc.toNamespacedPath:e.$gc.toNamespacedPath,e.sep=s?e.$fc.sep:e.$gc.sep,e.$tc=s?e.$fc.delimiter:e.$gc.delimiter}),define(ge[22],me([0,1,9,4,2,12,8]),function(fe,e,f,t,P,b,q){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sg=L,e.$tg=a,e.$ug=g,e.$vg=M,e.$wg=H,e.$xg=s,e.$yg=w,e.$zg=T,e.$Ag=m,e.$Bg=D,e.$Cg=p,e.$Dg=o,e.$Eg=n,e.$Fg=i,e.$Gg=r,e.$Hg=v,e.$Ig=y;function L(l){return l===f.CharCode.Slash||l===f.CharCode.Backslash}function a(l){return l.replace(/[\\/]/g,t.$gc.sep)}function g(l){return l.indexOf("/")===-1&&(l=a(l)),/^[a-zA-Z]:(\/|$)/.test(l)&&(l="/"+l),l}function M(l,I=t.$gc.sep){if(!l)return"";const E=l.length,h=l.charCodeAt(0);if(L(h)){if(L(l.charCodeAt(1))&&!L(l.charCodeAt(2))){let K=3;const te=K;for(;K<E&&!L(l.charCodeAt(K));K++);if(te!==K&&!L(l.charCodeAt(K+1))){for(K+=1;K<E;K++)if(L(l.charCodeAt(K)))return l.slice(0,K+1).replace(/[\\/]/g,I)}}return I}else if(m(h)&&l.charCodeAt(1)===f.CharCode.Colon)return L(l.charCodeAt(2))?l.slice(0,2)+I:l.slice(0,2);let c=l.indexOf("://");if(c!==-1){for(c+=3;c<E;c++)if(L(l.charCodeAt(c)))return l.slice(0,c+1)}return""}function H(l){if(!P.$i||!l||l.length<5)return!1;let I=l.charCodeAt(0);if(I!==f.CharCode.Backslash||(I=l.charCodeAt(1),I!==f.CharCode.Backslash))return!1;let E=2;const h=E;for(;E<l.length&&(I=l.charCodeAt(E),I!==f.CharCode.Backslash);E++);return!(h===E||(I=l.charCodeAt(E+1),isNaN(I)||I===f.CharCode.Backslash))}const A=/[\\/:\*\?"<>\|]/g,N=/[/]/g,R=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function s(l,I=P.$i){const E=I?A:N;return!(!l||l.length===0||/^\s+$/.test(l)||(E.lastIndex=0,E.test(l))||I&&R.test(l)||l==="."||l===".."||I&&l[l.length-1]==="."||I&&l.length!==l.trim().length||l.length>255)}function w(l,I,E){const h=l===I;return!E||h?h:!l||!I?!1:(0,b.$Bf)(l,I)}function T(l,I,E,h=t.sep){if(l===I)return!0;if(!l||!I||I.length>l.length)return!1;if(E){if(!(0,b.$Cf)(l,I))return!1;if(I.length===l.length)return!0;let K=I.length;return I.charAt(I.length-1)===h&&K--,l.charAt(K)===h}return I.charAt(I.length-1)!==h&&(I+=h),l.indexOf(I)===0}function m(l){return l>=f.CharCode.A&&l<=f.CharCode.Z||l>=f.CharCode.a&&l<=f.CharCode.z}function D(l,I){return P.$i&&l.endsWith(":")&&(l+=t.sep),(0,t.$ic)(l)||(l=(0,t.$jc)(I,l)),l=(0,t.$hc)(l),p(l)}function p(l){return P.$i?(l=(0,b.$jf)(l,t.sep),l.endsWith(":")&&(l+=t.sep)):(l=(0,b.$jf)(l,t.sep),l||(l=t.sep)),l}function o(l){const I=(0,t.$hc)(l);return P.$i?l.length>3?!1:n(I)&&(l.length===2||I.charCodeAt(2)===f.CharCode.Backslash):I===t.$gc.sep}function n(l,I=P.$i){return I?m(l.charCodeAt(0))&&l.charCodeAt(1)===f.CharCode.Colon:!1}function i(l,I=P.$i){return n(l,I)?l[0]:void 0}function r(l,I,E){return I.length>l.length?-1:l===I?0:(E&&(l=l.toLowerCase(),I=I.toLowerCase()),l.indexOf(I))}function v(l){const I=l.split(":");let E,h,c;for(const K of I){const te=Number(K);(0,q.$eg)(te)?h===void 0?h=te:c===void 0&&(c=te):E=E?[E,K].join(":"):K}if(!E)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:E,line:h!==void 0?h:void 0,column:c!==void 0?c:h!==void 0?1:void 0}}const G="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",_="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function y(l,I,E=8){let h="";for(let K=0;K<E;K++){let te;K===0&&P.$i&&!I&&(E===3||E===4)?te=_:te=G,h+=te.charAt(Math.floor(Math.random()*te.length))}let c;return I?c=`${I}-${h}`:c=h,l?(0,t.$jc)(l,c):c}}),define(ge[23],me([0,1,2]),function(fe,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminateResponseCode=e.Source=void 0,e.$rm=b,e.$sm=q;var t;(function(L){L[L.stdout=0]="stdout",L[L.stderr=1]="stderr"})(t||(e.Source=t={}));var P;(function(L){L[L.Success=0]="Success",L[L.Unknown=1]="Unknown",L[L.AccessDenied=2]="AccessDenied",L[L.ProcessNotFound=3]="ProcessNotFound"})(P||(e.TerminateResponseCode=P={}));function b(L,...a){const g=a.reduce((A,N)=>(A[N]=!0,A),{}),M=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(L).filter(A=>!g[A]).forEach(A=>{for(let N=0;N<M.length;N++)if(A.search(M[N])!==-1){delete L[A];break}})}function q(L){L&&(delete L.DEBUG,f.$j&&delete L.DYLD_LIBRARY_PATH,f.$k&&delete L.LD_PRELOAD)}}),define(ge[5],me([0,1,9,21,4,2]),function(fe,e,f,t,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URI=void 0,e.$vc=w,e.$wc=n;const q=/^\w[\w\d+.-]*$/,L=/^\//,a=/^\/\//;function g(_,y){if(!_.scheme&&y)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${_.authority}", path: "${_.path}", query: "${_.query}", fragment: "${_.fragment}"}`);if(_.scheme&&!q.test(_.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(_.path){if(_.authority){if(!L.test(_.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(a.test(_.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function M(_,y){return!_&&!y?"file":_}function H(_,y){switch(_){case"https":case"http":case"file":y?y[0]!==N&&(y=N+y):y=N;break}return y}const A="",N="/",R=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class s{static isUri(y){return y instanceof s?!0:y?typeof y.authority=="string"&&typeof y.fragment=="string"&&typeof y.path=="string"&&typeof y.query=="string"&&typeof y.scheme=="string"&&typeof y.fsPath=="string"&&typeof y.with=="function"&&typeof y.toString=="function":!1}constructor(y,l,I,E,h,c=!1){typeof y=="object"?(this.scheme=y.scheme||A,this.authority=y.authority||A,this.path=y.path||A,this.query=y.query||A,this.fragment=y.fragment||A):(this.scheme=M(y,c),this.authority=l||A,this.path=H(this.scheme,I||A),this.query=E||A,this.fragment=h||A,g(this,c))}get fsPath(){return n(this,!1)}with(y){if(!y)return this;let{scheme:l,authority:I,path:E,query:h,fragment:c}=y;return l===void 0?l=this.scheme:l===null&&(l=A),I===void 0?I=this.authority:I===null&&(I=A),E===void 0?E=this.path:E===null&&(E=A),h===void 0?h=this.query:h===null&&(h=A),c===void 0?c=this.fragment:c===null&&(c=A),l===this.scheme&&I===this.authority&&E===this.path&&h===this.query&&c===this.fragment?this:new m(l,I,E,h,c)}static parse(y,l=!1){const I=R.exec(y);return I?new m(I[2]||A,G(I[4]||A),G(I[5]||A),G(I[7]||A),G(I[9]||A),l):new m(A,A,A,A,A)}static file(y){let l=A;if(b.$i&&(y=y.replace(/\\/g,N)),y[0]===N&&y[1]===N){const I=y.indexOf(N,2);I===-1?(l=y.substring(2),y=N):(l=y.substring(2,I),y=y.substring(I)||N)}return new m("file",l,y,A,A)}static from(y,l){return new m(y.scheme,y.authority,y.path,y.query,y.fragment,l)}static joinPath(y,...l){if(!y.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let I;return b.$i&&y.scheme==="file"?I=s.file(P.$fc.join(n(y,!0),...l)).path:I=P.$gc.join(y.path,...l),y.with({path:I})}toString(y=!1){return i(this,y)}toJSON(){return this}static revive(y){if(y){if(y instanceof s)return y;{const l=new m(y);return l._formatted=y.external??null,l._fsPath=y._sep===T?y.fsPath??null:null,l}}else return y}}e.URI=s;function w(_){return!_||typeof _!="object"?!1:typeof _.scheme=="string"&&(typeof _.authority=="string"||typeof _.authority>"u")&&(typeof _.path=="string"||typeof _.path>"u")&&(typeof _.query=="string"||typeof _.query>"u")&&(typeof _.fragment=="string"||typeof _.fragment>"u")}const T=b.$i?1:void 0;class m extends s{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=n(this,!1)),this._fsPath}toString(y=!1){return y?i(this,!0):(this._formatted||(this._formatted=i(this,!1)),this._formatted)}toJSON(){const y={$mid:t.MarshalledId.Uri};return this._fsPath&&(y.fsPath=this._fsPath,y._sep=T),this._formatted&&(y.external=this._formatted),this.path&&(y.path=this.path),this.scheme&&(y.scheme=this.scheme),this.authority&&(y.authority=this.authority),this.query&&(y.query=this.query),this.fragment&&(y.fragment=this.fragment),y}}const D={[f.CharCode.Colon]:"%3A",[f.CharCode.Slash]:"%2F",[f.CharCode.QuestionMark]:"%3F",[f.CharCode.Hash]:"%23",[f.CharCode.OpenSquareBracket]:"%5B",[f.CharCode.CloseSquareBracket]:"%5D",[f.CharCode.AtSign]:"%40",[f.CharCode.ExclamationMark]:"%21",[f.CharCode.DollarSign]:"%24",[f.CharCode.Ampersand]:"%26",[f.CharCode.SingleQuote]:"%27",[f.CharCode.OpenParen]:"%28",[f.CharCode.CloseParen]:"%29",[f.CharCode.Asterisk]:"%2A",[f.CharCode.Plus]:"%2B",[f.CharCode.Comma]:"%2C",[f.CharCode.Semicolon]:"%3B",[f.CharCode.Equals]:"%3D",[f.CharCode.Space]:"%20"};function p(_,y,l){let I,E=-1;for(let h=0;h<_.length;h++){const c=_.charCodeAt(h);if(c>=f.CharCode.a&&c<=f.CharCode.z||c>=f.CharCode.A&&c<=f.CharCode.Z||c>=f.CharCode.Digit0&&c<=f.CharCode.Digit9||c===f.CharCode.Dash||c===f.CharCode.Period||c===f.CharCode.Underline||c===f.CharCode.Tilde||y&&c===f.CharCode.Slash||l&&c===f.CharCode.OpenSquareBracket||l&&c===f.CharCode.CloseSquareBracket||l&&c===f.CharCode.Colon)E!==-1&&(I+=encodeURIComponent(_.substring(E,h)),E=-1),I!==void 0&&(I+=_.charAt(h));else{I===void 0&&(I=_.substr(0,h));const K=D[c];K!==void 0?(E!==-1&&(I+=encodeURIComponent(_.substring(E,h)),E=-1),I+=K):E===-1&&(E=h)}}return E!==-1&&(I+=encodeURIComponent(_.substring(E))),I!==void 0?I:_}function o(_){let y;for(let l=0;l<_.length;l++){const I=_.charCodeAt(l);I===f.CharCode.Hash||I===f.CharCode.QuestionMark?(y===void 0&&(y=_.substr(0,l)),y+=D[I]):y!==void 0&&(y+=_[l])}return y!==void 0?y:_}function n(_,y){let l;return _.authority&&_.path.length>1&&_.scheme==="file"?l=`//${_.authority}${_.path}`:_.path.charCodeAt(0)===f.CharCode.Slash&&(_.path.charCodeAt(1)>=f.CharCode.A&&_.path.charCodeAt(1)<=f.CharCode.Z||_.path.charCodeAt(1)>=f.CharCode.a&&_.path.charCodeAt(1)<=f.CharCode.z)&&_.path.charCodeAt(2)===f.CharCode.Colon?y?l=_.path.substr(1):l=_.path[1].toLowerCase()+_.path.substr(2):l=_.path,b.$i&&(l=l.replace(/\//g,"\\")),l}function i(_,y){const l=y?o:p;let I="",{scheme:E,authority:h,path:c,query:K,fragment:te}=_;if(E&&(I+=E,I+=":"),(h||E==="file")&&(I+=N,I+=N),h){let Q=h.indexOf("@");if(Q!==-1){const V=h.substr(0,Q);h=h.substr(Q+1),Q=V.lastIndexOf(":"),Q===-1?I+=l(V,!1,!1):(I+=l(V.substr(0,Q),!1,!1),I+=":",I+=l(V.substr(Q+1),!1,!0)),I+="@"}h=h.toLowerCase(),Q=h.lastIndexOf(":"),Q===-1?I+=l(h,!1,!0):(I+=l(h.substr(0,Q),!1,!0),I+=h.substr(Q))}if(c){if(c.length>=3&&c.charCodeAt(0)===f.CharCode.Slash&&c.charCodeAt(2)===f.CharCode.Colon){const Q=c.charCodeAt(1);Q>=f.CharCode.A&&Q<=f.CharCode.Z&&(c=`/${String.fromCharCode(Q+32)}:${c.substr(3)}`)}else if(c.length>=2&&c.charCodeAt(1)===f.CharCode.Colon){const Q=c.charCodeAt(0);Q>=f.CharCode.A&&Q<=f.CharCode.Z&&(c=`${String.fromCharCode(Q+32)}:${c.substr(2)}`)}I+=l(c,!0,!1)}return K&&(I+="?",I+=l(K,!1,!1)),te&&(I+="#",I+=y?te:p(te,!1,!1)),I}function r(_){try{return decodeURIComponent(_)}catch{return _.length>3?_.substr(0,3)+r(_.substr(3)):_}}const v=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function G(_){return _.match(v)?_.replace(v,y=>r(y)):_}}),define(ge[39],me([0,1,5]),function(fe,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4q=t,e.$5q=P,e.$6q=b,e.log=L;function t(g){const M=g;return M&&typeof M.type=="string"&&typeof M.severity=="string"}function P(g){const M=[];let H;try{const A=JSON.parse(g.arguments),N=A[A.length-1];N&&N.__$stack&&(A.pop(),H=N.__$stack),M.push(...A)}catch{M.push("Unable to log remote console arguments",g.arguments)}return{args:M,stack:H}}function b(g){if(typeof g!="string")return b(P(g).stack);const M=g;if(M){const H=q(M),A=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(H||"");if(A&&A.length===4)return{uri:f.URI.file(A[1]),line:Number(A[2]),column:Number(A[3])}}}function q(g){if(!g)return g;const M=g.indexOf(`
`);return M===-1?g:g.substring(0,M)}function L(g,M){const{args:H,stack:A}=P(g),N=typeof H[0]=="string"&&H.length===1;let R=q(A);R&&(R=`(${R.trim()})`);let s=[];if(typeof H[0]=="string"?R&&N?s=[`%c[${M}] %c${H[0]} %c${R}`,a("blue"),a(""),a("grey")]:s=[`%c[${M}] %c${H[0]}`,a("blue"),a(""),...H.slice(1)]:s=[`%c[${M}]%`,a("blue"),...H],R&&!N&&s.push(R),typeof console[g.severity]!="function")throw new Error("Unknown console method");console[g.severity].apply(console,s)}function a(g){return`color: ${g}`}}),define(ge[40],me([0,1,11,5,21]),function(fe,e,f,t,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8h=b,e.$9h=q,e.$0h=a;function b(g){return JSON.stringify(g,L)}function q(g){let M=JSON.parse(g);return M=a(M),M}function L(g,M){return M instanceof RegExp?{$mid:P.MarshalledId.Regexp,source:M.source,flags:M.flags}:M}function a(g,M=0){if(!g||M>200)return g;if(typeof g=="object"){switch(g.$mid){case P.MarshalledId.Uri:return t.URI.revive(g);case P.MarshalledId.Regexp:return new RegExp(g.source,g.flags);case P.MarshalledId.Date:return new Date(g.source)}if(g instanceof f.$Je||g instanceof Uint8Array)return g;if(Array.isArray(g))for(let H=0;H<g.length;++H)g[H]=a(g[H],M+1);else for(const H in g)Object.hasOwnProperty.call(g,H)&&(g[H]=a(g[H],M+1))}return g}}),define(ge[16],me([0,1,3,2,12,5,4]),function(fe,e,f,t,P,b,q){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Qg=e.$Pg=e.$Ng=e.$Mg=e.$Lg=e.Schemas=void 0,e.$Jg=a,e.$Kg=g,e.$Og=H;var L;(function(R){R.inMemory="inmemory",R.vscode="vscode",R.internal="private",R.walkThrough="walkThrough",R.walkThroughSnippet="walkThroughSnippet",R.http="http",R.https="https",R.file="file",R.mailto="mailto",R.untitled="untitled",R.data="data",R.command="command",R.vscodeRemote="vscode-remote",R.vscodeRemoteResource="vscode-remote-resource",R.vscodeManagedRemoteResource="vscode-managed-remote-resource",R.vscodeUserData="vscode-userdata",R.vscodeCustomEditor="vscode-custom-editor",R.vscodeNotebookCell="vscode-notebook-cell",R.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",R.vscodeNotebookCellOutput="vscode-notebook-cell-output",R.vscodeInteractiveInput="vscode-interactive-input",R.vscodeSettings="vscode-settings",R.vscodeWorkspaceTrust="vscode-workspace-trust",R.vscodeTerminal="vscode-terminal",R.vscodeChatCodeBlock="vscode-chat-code-block",R.vscodeChatCodeCompareBlock="vscode-chat-code-compare-block",R.vscodeChatSesssion="vscode-chat-editor",R.webviewPanel="webview-panel",R.vscodeWebview="vscode-webview",R.extension="extension",R.vscodeFileResource="vscode-file",R.tmp="tmp",R.vsls="vsls",R.vscodeSourceControl="vscode-scm",R.commentsInput="comment",R.codeSetting="code-setting"})(L||(e.Schemas=L={}));function a(R,s){return b.URI.isUri(R)?(0,P.$Bf)(R.scheme,s):(0,P.$Cf)(R,s+":")}function g(R,...s){return s.some(w=>a(R,w))}e.$Lg="vscode-tkn",e.$Mg="tkn";class M{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f="/"}setPreferredWebSchema(s){this.d=s}setDelegate(s){this.e=s}setServerRootPath(s,w){this.f=H(s,w)}getServerRootPath(){return this.f}get g(){return q.$gc.join(this.f,L.vscodeRemoteResource)}set(s,w,T){this.a[s]=w,this.b[s]=T}setConnectionToken(s,w){this.c[s]=w}getPreferredWebSchema(){return this.d}rewrite(s){if(this.e)try{return this.e(s)}catch(o){return f.$1(o),s}const w=s.authority;let T=this.a[w];T&&T.indexOf(":")!==-1&&T.indexOf("[")===-1&&(T=`[${T}]`);const m=this.b[w],D=this.c[w];let p=`path=${encodeURIComponent(s.path)}`;return typeof D=="string"&&(p+=`&${e.$Mg}=${encodeURIComponent(D)}`),b.URI.from({scheme:t.$o?this.d:L.vscodeRemoteResource,authority:`${T}:${m}`,path:this.g,query:p})}}e.$Ng=new M;function H(R,s){return q.$gc.join(s??"/",`${R.quality??"oss"}-${R.commit??"dev"}`)}e.$Pg="vs/../../extensions",e.$Qg="vs/../../node_modules",e.$Rg="vs/../../node_modules.asar",e.$Sg="vs/../../node_modules.asar.unpacked",e.$Tg="vscode-app";class A{static{this.a=e.$Tg}asBrowserUri(s){const w=this.b(s,fe);return this.uriToBrowserUri(w)}uriToBrowserUri(s){return s.scheme===L.vscodeRemote?e.$Ng.rewrite(s):s.scheme===L.file&&(t.$m||t.$q===`${L.vscodeFileResource}://${A.a}`)?s.with({scheme:L.vscodeFileResource,authority:s.authority||A.a,query:null,fragment:null}):s}asFileUri(s){const w=this.b(s,fe);return this.uriToFileUri(w)}uriToFileUri(s){return s.scheme===L.vscodeFileResource?s.with({scheme:L.file,authority:s.authority!==A.a?s.authority:null,query:null,fragment:null}):s}b(s,w){return b.URI.isUri(s)?s:b.URI.parse(w.toUrl(s))}}e.$Ug=new A;var N;(function(R){const s=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);R.CoopAndCoep=Object.freeze(s.get("3"));const w="vscode-coi";function T(D){let p;typeof D=="string"?p=new URL(D).searchParams:D instanceof URL?p=D.searchParams:b.URI.isUri(D)&&(p=new URL(D.toString(!0)).searchParams);const o=p?.get(w);if(o)return s.get(o)}R.getHeadersFromQuery=T;function m(D,p,o){if(!globalThis.crossOriginIsolated)return;const n=p&&o?"3":o?"2":"1";D instanceof URLSearchParams?D.set(w,n):D[w]=n}R.addSearchParam=m})(N||(e.COI=N={}))}),define(ge[41],me([0,1,25,16,2,5]),function(fe,e,f,t,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dE=M;class q{constructor(A,N,R){this.id=A,this.dependencies=N,this.callback=R}}class L{static{this.INSTANCE=new L}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(A,N,R)=>{typeof A!="string"&&(R=N,N=A,A=null),(typeof N!="object"||!Array.isArray(N))&&(R=N,N=null),this.c.push(new q(A,N,R))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(A){if(A.startsWith(window.location.origin)||A.startsWith("vscode-file://vscode-app"))return A;throw new Error(`[trusted_script_src] Invalid script url: ${A}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(A){return A}})))}async load(A){this.g();const N=await(this.a?this.i(A):this.b?this.h(A):this.j(A));if(!N)throw new Error(`Did not receive a define call from script ${A}`);if(Array.isArray(N.dependencies)&&N.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${A}. The dependencies are: ${N.dependencies.join(", ")}`);return typeof N.callback=="function"?N.callback([]):N.callback}h(A){return new Promise((N,R)=>{const s=document.createElement("script");s.setAttribute("async","async"),s.setAttribute("type","text/javascript");const w=()=>{s.removeEventListener("load",T),s.removeEventListener("error",m)},T=D=>{w(),N(this.c.pop())},m=D=>{w(),R(D)};s.addEventListener("load",T),s.addEventListener("error",m),this.f&&(A=this.f.createScriptURL(A)),s.setAttribute("src",A),window.document.getElementsByTagName("head")[0].appendChild(s)})}i(A){return new Promise((N,R)=>{try{this.f&&(A=this.f.createScriptURL(A)),importScripts(A),N(this.c.pop())}catch(s){R(s)}})}async j(A){try{const N=globalThis._VSCODE_NODE_MODULES.fs,R=globalThis._VSCODE_NODE_MODULES.vm,s=globalThis._VSCODE_NODE_MODULES.module,w=b.URI.parse(A).fsPath,T=N.readFileSync(w).toString(),m=s.wrap(T.replace(/^#!.*/,""));return new R.Script(m).runInThisContext().apply(),this.c.pop()}catch(N){throw N}}}const a=new Map;let g={};typeof globalThis.require=="object"&&(g=globalThis.require.paths??{});async function M(H,A,N){if(f.$T){N===void 0&&(N=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),g[H]&&(H=g[H]);const R=`${H}/${A}`;if(a.has(R))return a.get(R);let s;if(/^\w[\w\d+.-]*:\/\//.test(R))s=R;else{const D=`${N&&!P.$o?t.$Rg:t.$Qg}/${R}`;s=t.$Ug.asBrowserUri(D).toString(!0)}const w=L.INSTANCE.load(s);return a.set(R,w),w}else return await new Promise((R,s)=>{fe([H],R,s)})}}),define(ge[24],me([0,1,9,22,16,4,2,12,5]),function(fe,e,f,t,P,b,q,L,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.$jh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=void 0,e.$2g=g,e.$kh=H,e.$lh=N;function g(R){return(0,a.$wc)(R,!0)}class M{constructor(s){this.a=s}compare(s,w,T=!1){return s===w?0:(0,L.$uf)(this.getComparisonKey(s,T),this.getComparisonKey(w,T))}isEqual(s,w,T=!1){return s===w?!0:!s||!w?!1:this.getComparisonKey(s,T)===this.getComparisonKey(w,T)}getComparisonKey(s,w=!1){return s.with({path:this.a(s)?s.path.toLowerCase():void 0,fragment:w?null:void 0}).toString()}ignorePathCasing(s){return this.a(s)}isEqualOrParent(s,w,T=!1){if(s.scheme===w.scheme){if(s.scheme===P.Schemas.file)return t.$zg(g(s),g(w),this.a(s))&&s.query===w.query&&(T||s.fragment===w.fragment);if((0,e.$gh)(s.authority,w.authority))return t.$zg(s.path,w.path,this.a(s),"/")&&s.query===w.query&&(T||s.fragment===w.fragment)}return!1}joinPath(s,...w){return a.URI.joinPath(s,...w)}basenameOrAuthority(s){return(0,e.$$g)(s)||s.authority}basename(s){return b.$gc.basename(s.path)}extname(s){return b.$gc.extname(s.path)}dirname(s){if(s.path.length===0)return s;let w;return s.scheme===P.Schemas.file?w=a.URI.file(b.$mc(g(s))).path:(w=b.$gc.dirname(s.path),s.authority&&w.length&&w.charCodeAt(0)!==f.CharCode.Slash&&(console.error(`dirname("${s.toString})) resulted in a relative path`),w="/")),s.with({path:w})}normalizePath(s){if(!s.path.length)return s;let w;return s.scheme===P.Schemas.file?w=a.URI.file(b.$hc(g(s))).path:w=b.$gc.normalize(s.path),s.with({path:w})}relativePath(s,w){if(s.scheme!==w.scheme||!(0,e.$gh)(s.authority,w.authority))return;if(s.scheme===P.Schemas.file){const D=b.$lc(g(s),g(w));return q.$i?t.$tg(D):D}let T=s.path||"/";const m=w.path||"/";if(this.a(s)){let D=0;for(const p=Math.min(T.length,m.length);D<p&&!(T.charCodeAt(D)!==m.charCodeAt(D)&&T.charAt(D).toLowerCase()!==m.charAt(D).toLowerCase());D++);T=m.substr(0,D)+T.substr(D)}return b.$gc.relative(T,m)}resolvePath(s,w){if(s.scheme===P.Schemas.file){const T=a.URI.file(b.$kc(g(s),w));return s.with({authority:T.authority,path:T.path})}return w=t.$ug(w),s.with({path:b.$gc.resolve(s.path,w)})}isAbsolutePath(s){return!!s.path&&s.path[0]==="/"}isEqualAuthority(s,w){return s===w||s!==void 0&&w!==void 0&&(0,L.$Bf)(s,w)}hasTrailingPathSeparator(s,w=b.sep){if(s.scheme===P.Schemas.file){const T=g(s);return T.length>t.$vg(T).length&&T[T.length-1]===w}else{const T=s.path;return T.length>1&&T.charCodeAt(T.length-1)===f.CharCode.Slash&&!/^[a-zA-Z]:(\/$|\\$)/.test(s.fsPath)}}removeTrailingPathSeparator(s,w=b.sep){return(0,e.$hh)(s,w)?s.with({path:s.path.substr(0,s.path.length-1)}):s}addTrailingPathSeparator(s,w=b.sep){let T=!1;if(s.scheme===P.Schemas.file){const m=g(s);T=m!==void 0&&m.length===t.$vg(m).length&&m[m.length-1]===w}else{w="/";const m=s.path;T=m.length===1&&m.charCodeAt(m.length-1)===f.CharCode.Slash}return!T&&!(0,e.$hh)(s,w)?s.with({path:s.path+"/"}):s}}e.$3g=M,e.$4g=new M(()=>!1),e.$5g=new M(R=>R.scheme===P.Schemas.file?!q.$k:!0),e.$6g=new M(R=>!0),e.$7g=e.$4g.isEqual.bind(e.$4g),e.$8g=e.$4g.isEqualOrParent.bind(e.$4g),e.$9g=e.$4g.getComparisonKey.bind(e.$4g),e.$0g=e.$4g.basenameOrAuthority.bind(e.$4g),e.$$g=e.$4g.basename.bind(e.$4g),e.$_g=e.$4g.extname.bind(e.$4g),e.$ah=e.$4g.dirname.bind(e.$4g),e.$bh=e.$4g.joinPath.bind(e.$4g),e.$ch=e.$4g.normalizePath.bind(e.$4g),e.$dh=e.$4g.relativePath.bind(e.$4g),e.$eh=e.$4g.resolvePath.bind(e.$4g),e.$fh=e.$4g.isAbsolutePath.bind(e.$4g),e.$gh=e.$4g.isEqualAuthority.bind(e.$4g),e.$hh=e.$4g.hasTrailingPathSeparator.bind(e.$4g),e.$ih=e.$4g.removeTrailingPathSeparator.bind(e.$4g),e.$jh=e.$4g.addTrailingPathSeparator.bind(e.$4g);function H(R,s){const w=[];for(let T=0;T<R.length;T++){const m=s(R[T]);R.some((D,p)=>p===T?!1:(0,e.$8g)(m,s(D)))||w.push(R[T])}return w}var A;(function(R){R.META_DATA_LABEL="label",R.META_DATA_DESCRIPTION="description",R.META_DATA_SIZE="size",R.META_DATA_MIME="mime";function s(w){const T=new Map;w.path.substring(w.path.indexOf(";")+1,w.path.lastIndexOf(";")).split(";").forEach(p=>{const[o,n]=p.split(":");o&&n&&T.set(o,n)});const D=w.path.substring(0,w.path.indexOf(";"));return D&&T.set(R.META_DATA_MIME,D),T}R.parseMetaData=s})(A||(e.DataUri=A={}));function N(R,s,w){if(s){let T=R.path;return T&&T[0]!==b.$gc.sep&&(T=b.$gc.sep+T),R.with({scheme:w,authority:s,path:T})}return R.with({scheme:w})}}),define(ge[17],me([0,1,7,3,10,6,24,2,35,13]),function(fe,e,f,t,P,b,q,L,a,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4h=e.$2h=e.$1h=e.$Zh=e.$Yh=e.Promises=e.$Xh=e.$Wh=e.$Vh=e.$Th=e.$Sh=e.$Rh=e.$Qh=e.$Ph=e.$Oh=e.$Nh=e.$Mh=e.$Lh=e.$Kh=e.$Jh=e.$Ih=e.$Hh=e.$Gh=e.$Ah=e.$zh=e.$yh=e.$xh=e.$wh=e.$vh=e.$uh=void 0,e.$mh=M,e.$nh=H,e.$oh=A,e.$ph=N,e.$qh=R,e.$rh=s,e.$sh=w,e.$th=T,e.$Bh=_,e.$Ch=y,e.$Dh=l,e.$Eh=I,e.$Fh=E,e.$Uh=$,e.$3h=B;function M(O){return!!O&&typeof O.then=="function"}function H(O){const u=new f.$se,k=O(u.token),X=new Promise((C,le)=>{const Re=u.token.onCancellationRequested(()=>{Re.dispose(),le(new t.$5)});Promise.resolve(k).then(oe=>{Re.dispose(),u.dispose(),C(oe)},oe=>{Re.dispose(),u.dispose(),le(oe)})});return new class{cancel(){u.cancel(),u.dispose()}then(C,le){return X.then(C,le)}catch(C){return this.then(void 0,C)}finally(C){return X.finally(C)}}}function A(O,u,k){return new Promise((X,C)=>{const le=u.onCancellationRequested(()=>{le.dispose(),X(k)});O.then(X,C).finally(()=>le.dispose())})}function N(O,u){return new Promise((k,X)=>{const C=u.onCancellationRequested(()=>{C.dispose(),X(new t.$5)});O.then(k,X).finally(()=>C.dispose())})}async function R(O){let u=-1;const k=O.map((X,C)=>X.then(le=>(u=C,le)));try{return await Promise.race(k)}finally{O.forEach((X,C)=>{C!==u&&X.cancel()})}}function s(O,u,k){let X;const C=setTimeout(()=>{X?.(void 0),k?.()},u);return Promise.race([O.finally(()=>clearTimeout(C)),new Promise(le=>X=le)])}function w(O){return new Promise((u,k)=>{const X=O();M(X)?X.then(u,k):u(X)})}function T(){let O,u;return{promise:new Promise((X,C)=>{O=X,u=C}),resolve:O,reject:u}}class m{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(u){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=u,!this.b){const k=()=>{if(this.b=null,this.f)return;const X=this.queue(this.d);return this.d=null,X};this.b=new Promise(X=>{this.a.then(k,k).then(X)})}return new Promise((k,X)=>{this.b.then(k,X)})}return this.a=u(),new Promise((k,X)=>{this.a.then(C=>{this.a=null,k(C)},C=>{this.a=null,X(C)})})}dispose(){this.f=!0}}e.$uh=m;class D{constructor(){this.a=Promise.resolve(null)}queue(u){return this.a=this.a.then(()=>u(),()=>u())}}e.$vh=D;class p{constructor(){this.a=new Map}queue(u,k){const C=(this.a.get(u)??Promise.resolve()).catch(()=>{}).then(k).finally(()=>{this.a.get(u)===C&&this.a.delete(u)});return this.a.set(u,C),C}}e.$wh=p;const o=(O,u)=>{let k=!0;const X=setTimeout(()=>{k=!1,u()},O);return{isTriggered:()=>k,dispose:()=>{clearTimeout(X),k=!1}}},n=O=>{let u=!0;return queueMicrotask(()=>{u&&(u=!1,O())}),{isTriggered:()=>u,dispose:()=>{u=!1}}};class i{constructor(u){this.defaultDelay=u,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(u,k=this.defaultDelay){this.g=u,this.h(),this.b||(this.b=new Promise((C,le)=>{this.d=C,this.f=le}).then(()=>{if(this.b=null,this.d=null,this.g){const C=this.g;return this.g=null,C()}}));const X=()=>{this.a=null,this.d?.(null)};return this.a=k===a.$ce?n(X):o(k,X),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new t.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$xh=i;class r{constructor(u){this.a=new i(u),this.b=new m}trigger(u,k){return this.a.trigger(()=>this.b.queue(u),k)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$yh=r;class v{constructor(){this.a=!1,this.b=new Promise((u,k)=>{this.d=u})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$zh=v;class G extends v{constructor(u){super(),this.f=setTimeout(()=>this.open(),u)}open(){clearTimeout(this.f),super.open()}}e.$Ah=G;function _(O,u){return u?new Promise((k,X)=>{const C=setTimeout(()=>{le.dispose(),k()},O),le=u.onCancellationRequested(()=>{clearTimeout(C),le.dispose(),X(new t.$5)})}):H(k=>_(O,k))}function y(O,u=0,k){const X=setTimeout(()=>{O(),k&&C.dispose()},u),C=(0,b.$Sc)(()=>{clearTimeout(X),k?.deleteAndLeak(C)});return k?.add(C),C}function l(O){const u=[];let k=0;const X=O.length;function C(){return k<X?O[k++]():null}function le(Re){Re!=null&&u.push(Re);const oe=C();return oe?oe.then(le):Promise.resolve(u)}return Promise.resolve(null).then(le)}function I(O,u=X=>!!X,k=null){let X=0;const C=O.length,le=()=>{if(X>=C)return Promise.resolve(k);const Re=O[X++];return Promise.resolve(Re()).then(re=>u(re)?Promise.resolve(re):le())};return le()}function E(O,u=X=>!!X,k=null){if(O.length===0)return Promise.resolve(k);let X=O.length;const C=()=>{X=-1;for(const le of O)le.cancel?.()};return new Promise((le,Re)=>{for(const oe of O)oe.then(re=>{--X>=0&&u(re)?(C(),le(re)):X===0&&le(k)}).catch(re=>{--X>=0&&(C(),Re(re))})})}class h{constructor(u){this.a=0,this.b=!1,this.f=u,this.g=[],this.d=0,this.h=new P.$he}whenIdle(){return this.size>0?P.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(u){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((k,X)=>{this.g.push({factory:u,c:k,e:X}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const u=this.g.shift();this.d++;const k=u.factory();k.then(u.c,u.e),k.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$Gh=h;class c extends h{constructor(){super(1)}}e.$Hh=c;class K{constructor(){this.a=new W,this.b=0}queue(u){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,u())):this.a.run(this.b++,u())}}e.$Ih=K;class te{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const u=new ce;return this.b.add(u),u.p}g(){for(const[,u]of this.a)if(u.size>0)return!1;return!0}queueSize(u,k=q.$4g){const X=k.getComparisonKey(u);return this.a.get(X)?.size??0}queueFor(u,k,X=q.$4g){const C=X.getComparisonKey(u);let le=this.a.get(C);if(!le){le=new c;const Re=this.f++,oe=P.Event.once(le.onDrained)(()=>{le?.dispose(),this.a.delete(C),this.h(),this.d?.deleteAndDispose(Re),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new b.$4c),this.d.set(Re,oe),this.a.set(C,le)}return le.queue(k)}h(){this.g()&&this.j()}j(){for(const u of this.b)u.complete();this.b.clear()}dispose(){for(const[,u]of this.a)u.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$Jh=te;class Q{constructor(u,k){this.b=!1,this.a=-1,typeof u=="function"&&typeof k=="number"&&this.setIfNotSet(u,k)}dispose(){this.cancel(),this.b=!0}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(u,k){if(this.b)throw new t.$cb("Calling 'cancelAndSet' on a disposed TimeoutTimer");this.cancel(),this.a=setTimeout(()=>{this.a=-1,u()},k)}setIfNotSet(u,k){if(this.b)throw new t.$cb("Calling 'setIfNotSet' on a disposed TimeoutTimer");this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,u()},k))}}e.$Kh=Q;class V{constructor(){this.d=void 0,this.f=!1}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(u,k,X=globalThis){if(this.f)throw new t.$cb("Calling 'cancelAndSet' on a disposed IntervalTimer");this.cancel();const C=X.setInterval(()=>{u()},k);this.d=(0,b.$Sc)(()=>{X.clearInterval(C),this.d=void 0})}dispose(){this.cancel(),this.f=!0}}e.$Lh=V;class x{constructor(u,k){this.b=-1,this.a=u,this.d=k,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(u=this.d){this.cancel(),this.b=setTimeout(this.f,u)}get delay(){return this.d}set delay(u){this.d=u}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$Mh=x;class z{constructor(u,k){k%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${k}ms is not a multiple of 1000ms.`),this.a=u,this.b=k,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(u=this.b){u%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${u}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(u/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$Nh=z;class Y extends x{constructor(u,k){super(u,k),this.j=[]}work(u){this.j.push(u),this.isScheduled()||this.schedule()}h(){const u=this.j;this.j=[],this.a?.(u)}dispose(){this.j=[],super.dispose()}}e.$Oh=Y;class ne extends b.$Uc{constructor(u,k){super(),this.g=u,this.h=k,this.a=[],this.b=this.B(new b.$Vc),this.f=!1}get pending(){return this.a.length}work(u){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+u.length>this.g.maxBufferedWork)return!1}else if(this.pending+u.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const k of u)this.a.push(k);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new x(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$Ph=ne,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$Rh=(O,u)=>{(0,L.$B)(()=>{if(k)return;const X=Date.now()+15;u(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,X-Date.now())}}))});let k=!1;return{dispose(){k||(k=!0)}}}:e.$Rh=(O,u,k)=>{const X=O.requestIdleCallback(u,typeof k=="number"?{timeout:k}:void 0);let C=!1;return{dispose(){C||(C=!0,O.cancelIdleCallback(X))}}},e.$Qh=O=>(0,e.$Rh)(globalThis,O)}();class se{constructor(u,k){this.g=!1,this.d=()=>{try{this.j=k()}catch(X){this.l=X}finally{this.g=!0}},this.f=(0,e.$Rh)(u,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$Sh=se;class U extends se{constructor(u){super(globalThis,u)}}e.$Th=U;async function $(O,u,k){let X;for(let C=0;C<k;C++)try{return await O()}catch(le){X=le,await _(u)}throw X}class W{isRunning(u){return typeof u=="number"?this.a?.taskId===u:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(u,k,X){return this.a={taskId:u,cancel:()=>X?.(),promise:k},k.then(()=>this.d(u),()=>this.d(u)),k}d(u){this.a&&u===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const u=this.b;this.b=void 0,u.run().then(u.promiseResolve,u.promiseReject)}}queue(u){if(this.b)this.b.run=u;else{const{promise:k,resolve:X,reject:C}=T();this.b={run:u,promise:k,promiseResolve:X,promiseReject:C}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$Vh=W;class J{constructor(u,k=()=>Date.now()){this.d=u,this.f=k,this.a=0,this.b=0}increment(){const u=this.f();return u-this.a>this.d&&(this.a=u,this.b=0),this.b++,this.b}}e.$Wh=J;var ie;(function(O){O[O.Resolved=0]="Resolved",O[O.Rejected=1]="Rejected"})(ie||(ie={}));class ce{get isRejected(){return this.d?.outcome===ie.Rejected}get isResolved(){return this.d?.outcome===ie.Resolved}get isSettled(){return!!this.d}get value(){return this.d?.outcome===ie.Resolved?this.d?.value:void 0}constructor(){this.p=new Promise((u,k)=>{this.a=u,this.b=k})}complete(u){return new Promise(k=>{this.a(u),this.d={outcome:ie.Resolved,value:u},k()})}error(u){return new Promise(k=>{this.b(u),this.d={outcome:ie.Rejected,value:u},k()})}cancel(){return this.error(new t.$5)}}e.$Xh=ce;var _e;(function(O){async function u(X){let C;const le=await Promise.all(X.map(Re=>Re.then(oe=>oe,oe=>{C||(C=oe)})));if(typeof C<"u")throw C;return le}O.settled=u;function k(X){return new Promise(async(C,le)=>{try{await X(C,le)}catch(Re){le(Re)}})}O.withAsyncBody=k})(_e||(e.Promises=_e={}));class be{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(u){this.a=void 0,this.b=void 0,this.d=!1,this.promise=u.then(k=>(this.a=k,this.d=!0,k),k=>{throw this.b=k,this.d=!0,k})}requireValue(){if(!this.d)throw new t.$cb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$Yh=be;class ye{constructor(u){this.b=u,this.a=new g.$V(()=>new be(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$Zh=ye;var de;(function(O){O[O.Initial=0]="Initial",O[O.DoneOK=1]="DoneOK",O[O.DoneError=2]="DoneError"})(de||(de={}));class Ee{static fromArray(u){return new Ee(k=>{k.emitMany(u)})}static fromPromise(u){return new Ee(async k=>{k.emitMany(await u)})}static fromPromises(u){return new Ee(async k=>{await Promise.all(u.map(async X=>k.emitOne(await X)))})}static merge(u){return new Ee(async k=>{await Promise.all(u.map(async X=>{for await(const C of X)k.emitOne(C)}))})}static{this.EMPTY=Ee.fromArray([])}constructor(u,k){this.a=de.Initial,this.b=[],this.d=null,this.f=k,this.g=new P.$he,queueMicrotask(async()=>{const X={emitOne:C=>this.h(C),emitMany:C=>this.j(C),reject:C=>this.l(C)};try{await Promise.resolve(u(X)),this.k()}catch(C){this.l(C)}finally{X.emitOne=void 0,X.emitMany=void 0,X.reject=void 0}})}[Symbol.asyncIterator](){let u=0;return{next:async()=>{do{if(this.a===de.DoneError)throw this.d;if(u<this.b.length)return{done:!1,value:this.b[u++]};if(this.a===de.DoneOK)return{done:!0,value:void 0};await P.Event.toPromise(this.g.event)}while(!0)},return:async()=>(this.f?.(),{done:!0,value:void 0})}}static map(u,k){return new Ee(async X=>{for await(const C of u)X.emitOne(k(C))})}map(u){return Ee.map(this,u)}static filter(u,k){return new Ee(async X=>{for await(const C of u)k(C)&&X.emitOne(C)})}filter(u){return Ee.filter(this,u)}static coalesce(u){return Ee.filter(u,k=>!!k)}coalesce(){return Ee.coalesce(this)}static async toPromise(u){const k=[];for await(const X of u)k.push(X);return k}toPromise(){return Ee.toPromise(this)}h(u){this.a===de.Initial&&(this.b.push(u),this.g.fire())}j(u){this.a===de.Initial&&(this.b=this.b.concat(u),this.g.fire())}k(){this.a===de.Initial&&(this.a=de.DoneOK,this.g.fire())}l(u){this.a===de.Initial&&(this.a=de.DoneError,this.d=u,this.g.fire())}}e.$1h=Ee;class S extends Ee{constructor(u,k){super(k),this.m=u}cancel(){this.m.cancel()}}e.$2h=S;function B(O){const u=new f.$se,k=O(u.token);return new S(u,async X=>{const C=u.token.onCancellationRequested(()=>{C.dispose(),u.dispose(),X.reject(new t.$5)});try{for await(const le of k){if(u.token.isCancellationRequested)return;X.emitOne(le)}C.dispose(),u.dispose()}catch(le){C.dispose(),u.dispose(),X.reject(le)}})}class j{constructor(u){this.a=new ce,this.b=new Ee(C=>{if(k){C.reject(k);return}return X&&C.emitMany(X),this.d=le=>C.reject(le),this.f=le=>C.emitOne(le),this.a.p},u);let k,X;this.f=C=>{X||(X=[]),X.push(C)},this.d=C=>{k||(k=C)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(u){this.d(u),this.a.complete()}emitOne(u){this.f(u)}}e.$4h=j}),define(ge[42],me([0,1,56,57,58,17,22,31,4,2,24,5]),function(fe,e,f,t,P,b,q,L,a,g,M,H){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.SymlinkSupport=e.RimRafMode=void 0,e.rimrafSync=w,e.readdirSync=D,e.whenDeleted=n,e.configureFlushOnWrite=_,e.writeFileSync=l;var A;(function(z){z[z.UNLINK=0]="UNLINK",z[z.MOVE=1]="MOVE"})(A||(e.RimRafMode=A={}));async function N(z,Y=A.UNLINK,ne){if((0,q.$Dg)(z))throw new Error("rimraf - will refuse to recursively delete root");return Y===A.UNLINK?s(z):R(z,ne)}async function R(z,Y=(0,q.$Ig)((0,t.tmpdir)())){try{try{await f.promises.rename(z,Y)}catch(ne){return ne.code==="ENOENT"?void 0:s(z)}s(Y).catch(ne=>{})}catch(ne){if(ne.code!=="ENOENT")throw ne}}async function s(z){return(0,P.promisify)(f.rm)(z,{recursive:!0,force:!0,maxRetries:3})}function w(z){if((0,q.$Dg)(z))throw new Error("rimraf - will refuse to recursively delete root");f.rmSync(z,{recursive:!0,force:!0,maxRetries:3})}async function T(z,Y){return p(await(Y?m(z):(0,P.promisify)(f.readdir)(z)))}async function m(z){try{return await(0,P.promisify)(f.readdir)(z,{withFileTypes:!0})}catch(se){console.warn("[node.js fs] readdir with filetypes failed with error: ",se)}const Y=[],ne=await T(z);for(const se of ne){let U=!1,$=!1,W=!1;try{const J=await e.Promises.lstat((0,a.$jc)(z,se));U=J.isFile(),$=J.isDirectory(),W=J.isSymbolicLink()}catch(J){console.warn("[node.js fs] unexpected error from lstat after readdir: ",J)}Y.push({name:se,isFile:()=>U,isDirectory:()=>$,isSymbolicLink:()=>W})}return Y}function D(z){return p(f.readdirSync(z))}function p(z){return z.map(Y=>typeof Y=="string"?g.$j?(0,L.$gm)(Y):Y:(Y.name=g.$j?(0,L.$gm)(Y.name):Y.name,Y))}async function o(z){const Y=await T(z),ne=[];for(const se of Y)await i.existsDirectory((0,a.$jc)(z,se))&&ne.push(se);return ne}function n(z,Y=1e3){return new Promise(ne=>{let se=!1;const U=setInterval(()=>{se||(se=!0,f.access(z,$=>{se=!1,$&&(clearInterval(U),ne(void 0))}))},Y)})}var i;(function(z){async function Y(U){let $;try{if($=await e.Promises.lstat(U),!$.isSymbolicLink())return{stat:$}}catch{}try{return{stat:await e.Promises.stat(U),symbolicLink:$?.isSymbolicLink()?{dangling:!1}:void 0}}catch(W){if(W.code==="ENOENT"&&$)return{stat:$,symbolicLink:{dangling:!0}};if(g.$i&&W.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(U)),symbolicLink:{dangling:!1}}}catch(J){if(J.code==="ENOENT"&&$)return{stat:$,symbolicLink:{dangling:!0}};throw J}throw W}}z.stat=Y;async function ne(U){try{const{stat:$,symbolicLink:W}=await z.stat(U);return $.isFile()&&W?.dangling!==!0}catch{}return!1}z.existsFile=ne;async function se(U){try{const{stat:$,symbolicLink:W}=await z.stat(U);return $.isDirectory()&&W?.dangling!==!0}catch{}return!1}z.existsDirectory=se})(i||(e.SymlinkSupport=i={}));const r=new b.$Jh;function v(z,Y,ne){return r.queueFor(H.URI.file(z),()=>{const se=I(ne);return new Promise((U,$)=>y(z,Y,se,W=>W?$(W):U()))},M.$5g)}let G=!0;function _(z){G=z}function y(z,Y,ne,se){if(!G)return f.writeFile(z,Y,{mode:ne.mode,flag:ne.flag},se);f.open(z,ne.flag,ne.mode,(U,$)=>{if(U)return se(U);f.writeFile($,Y,W=>{if(W)return f.close($,()=>se(W));f.fdatasync($,J=>(J&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",J),_(!1)),f.close($,ie=>se(ie))))})})}function l(z,Y,ne){const se=I(ne);if(!G)return f.writeFileSync(z,Y,{mode:se.mode,flag:se.flag});const U=f.openSync(z,se.flag,se.mode);try{f.writeFileSync(U,Y);try{f.fdatasyncSync(U)}catch($){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",$),_(!1)}}finally{f.closeSync(U)}}function I(z){return z?{mode:typeof z.mode=="number"?z.mode:438,flag:typeof z.flag=="string"?z.flag:"w"}:{mode:438,flag:"w"}}async function E(z,Y,ne=6e4){if(z!==Y)try{g.$i&&typeof ne=="number"?await h(z,Y,Date.now(),ne):await(0,P.promisify)(f.rename)(z,Y)}catch(se){if(z.toLowerCase()!==Y.toLowerCase()&&se.code==="EXDEV"||z.endsWith("."))await c(z,Y,{preserveSymlinks:!1}),await N(z,A.MOVE);else throw se}}async function h(z,Y,ne,se,U=0){try{return await(0,P.promisify)(f.rename)(z,Y)}catch($){if($.code!=="EACCES"&&$.code!=="EPERM"&&$.code!=="EBUSY")throw $;if(Date.now()-ne>=se)throw console.error(`[node.js fs] rename failed after ${U} retries with error: ${$}`),$;if(U===0){let W=!1;try{const{stat:J}=await i.stat(Y);J.isFile()||(W=!0)}catch{}if(W)throw $}return await(0,b.$Bh)(Math.min(100,U*10)),h(z,Y,ne,se,U+1)}}async function c(z,Y,ne){return te(z,Y,{root:{source:z,target:Y},options:ne,handledSourcePaths:new Set})}const K=511;async function te(z,Y,ne){if(ne.handledSourcePaths.has(z))return;ne.handledSourcePaths.add(z);const{stat:se,symbolicLink:U}=await i.stat(z);if(U){if(ne.options.preserveSymlinks)try{return await x(z,Y,ne)}catch{}if(U.dangling)return}return se.isDirectory()?Q(z,Y,se.mode&K,ne):V(z,Y,se.mode&K)}async function Q(z,Y,ne,se){await e.Promises.mkdir(Y,{recursive:!0,mode:ne});const U=await T(z);for(const $ of U)await te((0,a.$jc)(z,$),(0,a.$jc)(Y,$),se)}async function V(z,Y,ne){await e.Promises.copyFile(z,Y),await e.Promises.chmod(Y,ne)}async function x(z,Y,ne){let se=await e.Promises.readlink(z);(0,q.$zg)(se,ne.root.source,!g.$k)&&(se=(0,a.$jc)(ne.root.target,se.substr(ne.root.source.length+1))),await e.Promises.symlink(se,Y)}e.Promises=new class{get access(){return(0,P.promisify)(f.access)}get stat(){return(0,P.promisify)(f.stat)}get lstat(){return(0,P.promisify)(f.lstat)}get utimes(){return(0,P.promisify)(f.utimes)}get read(){return(z,Y,ne,se,U)=>new Promise(($,W)=>{f.read(z,Y,ne,se,U,(J,ie,ce)=>J?W(J):$({bytesRead:ie,buffer:ce}))})}get readFile(){return(0,P.promisify)(f.readFile)}get write(){return(z,Y,ne,se,U)=>new Promise(($,W)=>{f.write(z,Y,ne,se,U,(J,ie,ce)=>J?W(J):$({bytesWritten:ie,buffer:ce}))})}get appendFile(){return(0,P.promisify)(f.appendFile)}get fdatasync(){return(0,P.promisify)(f.fdatasync)}get truncate(){return(0,P.promisify)(f.truncate)}get copyFile(){return(0,P.promisify)(f.copyFile)}get open(){return(0,P.promisify)(f.open)}get close(){return(0,P.promisify)(f.close)}get symlink(){return(0,P.promisify)(f.symlink)}get readlink(){return(0,P.promisify)(f.readlink)}get chmod(){return(0,P.promisify)(f.chmod)}get mkdir(){return(0,P.promisify)(f.mkdir)}get unlink(){return(0,P.promisify)(f.unlink)}get rmdir(){return(0,P.promisify)(f.rmdir)}get realpath(){return(0,P.promisify)(f.realpath)}async exists(z){try{return await e.Promises.access(z),!0}catch{return!1}}get readdir(){return T}get readDirsInDir(){return o}get writeFile(){return v}get rm(){return N}get rename(){return E}get copy(){return c}}}),define(ge[43],me([0,1,4,2,15,23,8,42]),function(fe,e,f,t,P,b,q,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.TerminateResponseCode=e.Source=void 0,e.$tm=a,e.$um=g,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return b.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return b.TerminateResponseCode}});function a(H=P.env){return H.comspec||"cmd.exe"}function g(H){let A=[],N=!1;const R=function(s){if(N){A.push(s);return}(!H.send(s,T=>{if(T&&console.error(T),N=!1,A.length>0){const m=A.slice(0);A=[],m.forEach(D=>R(D))}})||t.$i)&&(N=!0)};return{send:R}}var M;(function(H){async function A(N,R,s){if(f.$ic(N))return N;if(R===void 0&&(R=P.cwd()),f.$mc(N)!=="."||(s===void 0&&q.$ag(P.env.PATH)&&(s=P.env.PATH.split(f.$tc)),s===void 0||s.length===0))return f.$jc(R,N);async function T(m){if(await L.Promises.exists(m)){let D;try{D=await L.Promises.stat(m)}catch(p){p.message.startsWith("EACCES")&&(D=await L.Promises.lstat(m))}return D?!D.isDirectory():!1}return!1}for(const m of s){let D;if(f.$ic(m)?D=f.$jc(m,N):D=f.$jc(R,m,N),await T(D))return D;let p=D+".com";if(await T(p)||(p=D+".exe",await T(p)))return p}return f.$jc(R,N)}H.findExecutable=A})(M||(e.win32=M={}))});var Ke=this&&this.__decorate||function(fe,e,f,t){var P=arguments.length,b=P<3?e:t===null?t=Object.getOwnPropertyDescriptor(e,f):t,q;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")b=Reflect.decorate(fe,e,f,t);else for(var L=fe.length-1;L>=0;L--)(q=fe[L])&&(b=(P<3?q(b):P>3?q(e,f,b):q(e,f))||b);return P>3&&b&&Object.defineProperty(e,f,b),b};define(ge[44],me([0,1,18,17,11,7,28,3,10,6,40,12,8]),function(fe,e,f,t,P,b,q,L,a,g,M,H,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ji=e.ProxyChannel=e.$ii=e.$fi=e.$ei=e.$di=e.RequestInitiator=e.$ci=e.$_h=e.$$h=void 0,e.$ai=_,e.$bi=y,e.$gi=K,e.$hi=te;var N;(function(U){U[U.Promise=100]="Promise",U[U.PromiseCancel=101]="PromiseCancel",U[U.EventListen=102]="EventListen",U[U.EventDispose=103]="EventDispose"})(N||(N={}));function R(U){switch(U){case N.Promise:return"req";case N.PromiseCancel:return"cancel";case N.EventListen:return"subscribe";case N.EventDispose:return"unsubscribe"}}var s;(function(U){U[U.Initialize=200]="Initialize",U[U.PromiseSuccess=201]="PromiseSuccess",U[U.PromiseError=202]="PromiseError",U[U.PromiseErrorObj=203]="PromiseErrorObj",U[U.EventFire=204]="EventFire"})(s||(s={}));function w(U){switch(U){case s.Initialize:return"init";case s.PromiseSuccess:return"reply:";case s.PromiseError:case s.PromiseErrorObj:return"replyErr:";case s.EventFire:return"event:"}}var T;(function(U){U[U.Uninitialized=0]="Uninitialized",U[U.Idle=1]="Idle"})(T||(T={}));function m(U){let $=0;for(let W=0;;W+=7){const J=U.read(1);if($|=(J.buffer[0]&127)<<W,!(J.buffer[0]&128))return $}}const D=r(0);function p(U,$){if($===0){U.write(D);return}let W=0;for(let ie=$;ie!==0;ie=ie>>>7)W++;const J=P.$Je.alloc(W);for(let ie=0;$!==0;ie++)J.buffer[ie]=$&127,$=$>>>7,$>0&&(J.buffer[ie]|=128);U.write(J)}class o{constructor($){this.b=$,this.a=0}read($){const W=this.b.slice(this.a,this.a+$);return this.a+=W.byteLength,W}}e.$$h=o;class n{constructor(){this.a=[]}get buffer(){return P.$Je.concat(this.a)}write($){this.a.push($)}}e.$_h=n;var i;(function(U){U[U.Undefined=0]="Undefined",U[U.String=1]="String",U[U.Buffer=2]="Buffer",U[U.VSBuffer=3]="VSBuffer",U[U.Array=4]="Array",U[U.Object=5]="Object",U[U.Int=6]="Int"})(i||(i={}));function r(U){const $=P.$Je.alloc(1);return $.writeUInt8(U,0),$}const v={Undefined:r(i.Undefined),String:r(i.String),Buffer:r(i.Buffer),VSBuffer:r(i.VSBuffer),Array:r(i.Array),Object:r(i.Object),Uint:r(i.Int)},G=typeof Buffer<"u";function _(U,$){if(typeof $>"u")U.write(v.Undefined);else if(typeof $=="string"){const W=P.$Je.fromString($);U.write(v.String),p(U,W.byteLength),U.write(W)}else if(G&&Buffer.isBuffer($)){const W=P.$Je.wrap($);U.write(v.Buffer),p(U,W.byteLength),U.write(W)}else if($ instanceof P.$Je)U.write(v.VSBuffer),p(U,$.byteLength),U.write($);else if(Array.isArray($)){U.write(v.Array),p(U,$.length);for(const W of $)_(U,W)}else if(typeof $=="number"&&($|0)===$)U.write(v.Uint),p(U,$);else{const W=P.$Je.fromString(JSON.stringify($));U.write(v.Object),p(U,W.byteLength),U.write(W)}}function y(U){switch(U.read(1).readUInt8(0)){case i.Undefined:return;case i.String:return U.read(m(U)).toString();case i.Buffer:return U.read(m(U)).buffer;case i.VSBuffer:return U.read(m(U));case i.Array:{const W=m(U),J=[];for(let ie=0;ie<W;ie++)J.push(y(U));return J}case i.Object:return JSON.parse(U.read(m(U)).toString());case i.Int:return m(U)}}class l{constructor($,W,J=null,ie=1e3){this.h=$,this.j=W,this.k=J,this.l=ie,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(ce=>this.q(ce)),this.m({type:s.Initialize})}registerChannel($,W){this.b.set($,W),setTimeout(()=>this.w($),0)}m($){switch($.type){case s.Initialize:{const W=this.o([$.type]);this.k?.logOutgoing(W,0,I.OtherSide,w($.type));return}case s.PromiseSuccess:case s.PromiseError:case s.EventFire:case s.PromiseErrorObj:{const W=this.o([$.type,$.id],$.data);this.k?.logOutgoing(W,$.id,I.OtherSide,w($.type),$.data);return}}}o($,W=void 0){const J=new n;return _(J,$),_(J,W),this.p(J.buffer)}p($){try{return this.h.send($),$.byteLength}catch{return 0}}q($){const W=new o($),J=y(W),ie=y(W),ce=J[0];switch(ce){case N.Promise:return this.k?.logIncoming($.byteLength,J[1],I.OtherSide,`${R(ce)}: ${J[2]}.${J[3]}`,ie),this.s({type:ce,id:J[1],channelName:J[2],name:J[3],arg:ie});case N.EventListen:return this.k?.logIncoming($.byteLength,J[1],I.OtherSide,`${R(ce)}: ${J[2]}.${J[3]}`,ie),this.t({type:ce,id:J[1],channelName:J[2],name:J[3],arg:ie});case N.PromiseCancel:return this.k?.logIncoming($.byteLength,J[1],I.OtherSide,`${R(ce)}`),this.u({type:ce,id:J[1]});case N.EventDispose:return this.k?.logIncoming($.byteLength,J[1],I.OtherSide,`${R(ce)}`),this.u({type:ce,id:J[1]})}}s($){const W=this.b.get($.channelName);if(!W){this.v($);return}const J=new b.$se;let ie;try{ie=W.call(this.j,$.name,$.arg,J.token)}catch(be){ie=Promise.reject(be)}const ce=$.id;ie.then(be=>{this.m({id:ce,data:be,type:s.PromiseSuccess})},be=>{be instanceof Error?this.m({id:ce,data:{message:be.message,name:be.name,stack:be.stack?be.stack.split?be.stack.split(`
`):be.stack:void 0},type:s.PromiseError}):this.m({id:ce,data:be,type:s.PromiseErrorObj})}).finally(()=>{_e.dispose(),this.d.delete($.id)});const _e=(0,g.$Sc)(()=>J.cancel());this.d.set($.id,_e)}t($){const W=this.b.get($.channelName);if(!W){this.v($);return}const J=$.id,ce=W.listen(this.j,$.name,$.arg)(_e=>this.m({id:J,data:_e,type:s.EventFire}));this.d.set($.id,ce)}u($){const W=this.d.get($.id);W&&(W.dispose(),this.d.delete($.id))}v($){let W=this.g.get($.channelName);W||(W=[],this.g.set($.channelName,W));const J=setTimeout(()=>{console.error(`Unknown channel: ${$.channelName}`),$.type===N.Promise&&this.m({id:$.id,data:{name:"Unknown channel",message:`Channel name '${$.channelName}' timed out after ${this.l}ms`,stack:void 0},type:s.PromiseError})},this.l);W.push({request:$,timeoutTimer:J})}w($){const W=this.g.get($);if(W){for(const J of W)switch(clearTimeout(J.timeoutTimer),J.request.type){case N.Promise:this.s(J.request);break;case N.EventListen:this.t(J.request);break}this.g.delete($)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,g.$Pc)(this.d.values()),this.d.clear()}}e.$ci=l;var I;(function(U){U[U.LocalSide=0]="LocalSide",U[U.OtherSide=1]="OtherSide"})(I||(e.RequestInitiator=I={}));class E{constructor($,W=null){this.l=$,this.a=!1,this.b=T.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new a.$he,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(J=>this.s(J)),this.j=W}getChannel($){const W=this;return{call(J,ie,ce){return W.a?Promise.reject(new L.$5):W.m($,J,ie,ce)},listen(J,ie){return W.a?a.Event.None:W.o($,J,ie)}}}m($,W,J,ie=b.CancellationToken.None){const ce=this.g++,_e=N.Promise,be={id:ce,type:_e,channelName:$,name:W,arg:J};if(ie.isCancellationRequested)return Promise.reject(new L.$5);let ye;return new Promise((Ee,S)=>{if(ie.isCancellationRequested)return S(new L.$5);const B=()=>{const k=X=>{switch(X.type){case s.PromiseSuccess:this.f.delete(ce),Ee(X.data);break;case s.PromiseError:{this.f.delete(ce);const C=new Error(X.data.message);C.stack=Array.isArray(X.data.stack)?X.data.stack.join(`
`):X.data.stack,C.name=X.data.name,S(C);break}case s.PromiseErrorObj:this.f.delete(ce),S(X.data);break}};this.f.set(ce,k),this.p(be)};let j=null;this.b===T.Idle?B():(j=(0,t.$nh)(k=>this.u()),j.then(()=>{j=null,B()}));const O=()=>{j?(j.cancel(),j=null):this.p({id:ce,type:N.PromiseCancel}),S(new L.$5)},u=ie.onCancellationRequested(O);ye=(0,g.$Rc)((0,g.$Sc)(O),u),this.d.add(ye)}).finally(()=>{ye.dispose(),this.d.delete(ye)})}o($,W,J){const ie=this.g++,ce=N.EventListen,_e={id:ie,type:ce,channelName:$,name:W,arg:J};let be=null;const ye=new a.$he({onWillAddFirstListener:()=>{be=(0,t.$nh)(Ee=>this.u()),be.then(()=>{be=null,this.d.add(ye),this.p(_e)})},onDidRemoveLastListener:()=>{be?(be.cancel(),be=null):(this.d.delete(ye),this.p({id:ie,type:N.EventDispose}))}}),de=Ee=>ye.fire(Ee.data);return this.f.set(ie,de),ye.event}p($){switch($.type){case N.Promise:case N.EventListen:{const W=this.q([$.type,$.id,$.channelName,$.name],$.arg);this.j?.logOutgoing(W,$.id,I.LocalSide,`${R($.type)}: ${$.channelName}.${$.name}`,$.arg);return}case N.PromiseCancel:case N.EventDispose:{const W=this.q([$.type,$.id]);this.j?.logOutgoing(W,$.id,I.LocalSide,R($.type));return}}}q($,W=void 0){const J=new n;return _(J,$),_(J,W),this.r(J.buffer)}r($){try{return this.l.send($),$.byteLength}catch{return 0}}s($){const W=new o($),J=y(W),ie=y(W),ce=J[0];switch(ce){case s.Initialize:return this.j?.logIncoming($.byteLength,0,I.LocalSide,w(ce)),this.t({type:J[0]});case s.PromiseSuccess:case s.PromiseError:case s.EventFire:case s.PromiseErrorObj:return this.j?.logIncoming($.byteLength,J[1],I.LocalSide,w(ce),ie),this.t({type:J[0],id:J[1],data:ie})}}t($){if($.type===s.Initialize){this.b=T.Idle,this.k.fire();return}this.f.get($.id)?.($)}get onDidInitializePromise(){return a.Event.toPromise(this.onDidInitialize)}u(){return this.b===T.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,g.$Pc)(this.d.values()),this.d.clear()}}e.$di=E,Ke([q.$5h],E.prototype,"onDidInitializePromise",null);class h{get connections(){const $=[];return this.f.forEach(W=>$.push(W)),$}constructor($,W,J){this.a=new Map,this.f=new Set,this.g=new a.$he,this.onDidAddConnection=this.g.event,this.h=new a.$he,this.onDidRemoveConnection=this.h.event,this.j=new g.$Tc,this.j.add($(({protocol:ie,onDidClientDisconnect:ce})=>{const _e=a.Event.once(ie.onMessage);this.j.add(_e(be=>{const ye=new o(be),de=y(ye),Ee=new l(ie,de,W,J),S=new E(ie,W);this.a.forEach((j,O)=>Ee.registerChannel(O,j));const B={channelServer:Ee,channelClient:S,ctx:de};this.f.add(B),this.g.fire(B),this.j.add(ce(()=>{Ee.dispose(),S.dispose(),this.f.delete(B),this.h.fire(B)}))}))}))}getChannel($,W){const J=this;return{call(ie,ce,_e){let be;if((0,A.$og)(W)){const de=(0,f.$3b)(J.connections.filter(W));be=de?Promise.resolve(de):a.Event.toPromise(a.Event.filter(J.onDidAddConnection,W))}else be=W.routeCall(J,ie,ce);const ye=be.then(de=>de.channelClient.getChannel($));return K(ye).call(ie,ce,_e)},listen(ie,ce){if((0,A.$og)(W))return J.k($,W,ie,ce);const _e=W.routeEvent(J,ie,ce).then(be=>be.channelClient.getChannel($));return K(_e).listen(ie,ce)}}}k($,W,J,ie){const ce=this;let _e;const be=new a.$he({onWillAddFirstListener:()=>{_e=new g.$Tc;const ye=new a.$ne,de=new Map,Ee=B=>{const O=B.channelClient.getChannel($).listen(J,ie),u=ye.add(O);de.set(B,u)},S=B=>{const j=de.get(B);j&&(j.dispose(),de.delete(B))};ce.connections.filter(W).forEach(Ee),a.Event.filter(ce.onDidAddConnection,W)(Ee,void 0,_e),ce.onDidRemoveConnection(S,void 0,_e),ye.event(be.fire,be,_e),_e.add(ye)},onDidRemoveLastListener:()=>{_e?.dispose(),_e=void 0}});return be.event}registerChannel($,W){this.a.set($,W);for(const J of this.f)J.channelServer.registerChannel($,W)}dispose(){this.j.dispose();for(const $ of this.f)$.channelClient.dispose(),$.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$ei=h;class c{constructor($,W,J=null){const ie=new n;_(ie,W),$.send(ie.buffer),this.a=new E($,J),this.d=new l($,W,J)}getChannel($){return this.a.getChannel($)}registerChannel($,W){this.d.registerChannel($,W)}dispose(){this.a.dispose(),this.d.dispose()}}e.$fi=c;function K(U){return{call($,W,J){return U.then(ie=>ie.call($,W,J))},listen($,W){const J=new a.$qe;return U.then(ie=>J.input=ie.listen($,W)),J.event}}}function te(U){let $=!1;return{call(W,J,ie){return $?U.call(W,J,ie):(0,t.$Bh)(0).then(()=>$=!0).then(()=>U.call(W,J,ie))},listen(W,J){if($)return U.listen(W,J);const ie=new a.$qe;return(0,t.$Bh)(0).then(()=>$=!0).then(()=>ie.input=U.listen(W,J)),ie.event}}}class Q{constructor($){this.a=$}routeCall($){return this.b($)}routeEvent($){return this.b($)}async b($){for(const W of $.connections)if(await Promise.resolve(this.a(W.ctx)))return Promise.resolve(W);return await a.Event.toPromise($.onDidAddConnection),await this.b($)}}e.$ii=Q;var V;(function(U){function $(ce,_e,be){const ye=ce,de=be&&be.disableMarshalling,Ee=new Map;for(const S in ye)J(S)&&Ee.set(S,a.Event.buffer(ye[S],!0,void 0,_e));return new class{listen(S,B,j){const O=Ee.get(B);if(O)return O;const u=ye[B];if(typeof u=="function"){if(ie(B))return u.call(ye,j);if(J(B))return Ee.set(B,a.Event.buffer(ye[B],!0,void 0,_e)),Ee.get(B)}throw new L.$bb(`Event not found: ${B}`)}call(S,B,j){const O=ye[B];if(typeof O=="function"){if(!de&&Array.isArray(j))for(let k=0;k<j.length;k++)j[k]=(0,M.$0h)(j[k]);let u=O.apply(ye,j);return u instanceof Promise||(u=Promise.resolve(u)),u}throw new L.$bb(`Method not found: ${B}`)}}}U.fromService=$;function W(ce,_e){const be=_e&&_e.disableMarshalling;return new Proxy({},{get(ye,de){if(typeof de=="string")return _e?.properties?.has(de)?_e.properties.get(de):ie(de)?function(Ee){return ce.listen(de,Ee)}:J(de)?ce.listen(de):async function(...Ee){let S;_e&&!(0,A.$jg)(_e.context)?S=[_e.context,...Ee]:S=Ee;const B=await ce.call(de,S);return be?B:(0,M.$0h)(B)};throw new L.$bb(`Property not found: ${String(de)}`)}})}U.toService=W;function J(ce){return ce[0]==="o"&&ce[1]==="n"&&H.$Af(ce.charCodeAt(2))}function ie(ce){return/^onDynamic/.test(ce)&&H.$Af(ce.charCodeAt(9))}})(V||(e.ProxyChannel=V={}));const x=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function z(U){if(Array.isArray(U))return U;if(U&&typeof U=="object"&&typeof U.toString=="function"){const $=U.toString();if($!=="[object Object]")return $}return U}function Y(U){return Array.isArray(U)?U.map(z):z(U)}function ne(U,$,W,J,ie,ce,_e){_e=Y(_e);const be=x[ie],ye=be[J%be.length];let de=[`%c[${U}]%c[${String($).padStart(7," ")}]%c[len: ${String(W).padStart(5," ")}]%c${String(J).padStart(5," ")} - ${ce}`,"color: darkgreen","color: grey","color: grey",`color: ${ye}`];/\($/.test(ce)?(de=de.concat(_e),de.push(")")):de.push(_e),console.log.apply(console,de)}class se{constructor($,W){this.d=$,this.f=W,this.a=0,this.b=0}logOutgoing($,W,J,ie,ce){this.b+=$,ne(this.d,this.b,$,W,J,ie,ce)}logIncoming($,W,J,ie,ce){this.a+=$,ne(this.f,this.a,$,W,J,ie,ce)}}e.$ji=se}),define(ge[45],me([0,1,59,17,11,7,39,3,10,6,14,43,23,44]),function(fe,e,f,t,P,b,q,L,a,g,M,H,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9q=e.$8q=void 0;class R extends N.$ci{constructor(T){super({send:m=>{try{process.send?.(m.buffer.toString("base64"))}catch{}},onMessage:a.Event.fromNodeEventEmitter(process,"message",m=>P.$Je.wrap(Buffer.from(m,"base64")))},T),process.once("disconnect",()=>this.dispose())}}e.$8q=R;class s{constructor(T,m){this.i=T,this.j=m,this.c=new Set,this.g=new Map,this.h=new a.$he,this.onDidProcessExit=this.h.event;const D=m&&m.timeout?m.timeout:6e4;this.b=new t.$xh(D),this.d=null,this.f=null}getChannel(T){const m=this;return{call(D,p,o){return m.k(T,D,p,o)},listen(D,p){return m.l(T,D,p)}}}k(T,m,D,p=b.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(p.isCancellationRequested)return Promise.reject(L.$6());this.b.cancel();const o=this.n(T),n=(0,t.$nh)(v=>o.call(m,D,v)),i=p.onCancellationRequested(()=>n.cancel()),r=(0,g.$Sc)(()=>n.cancel());return this.c.add(r),n.finally(()=>{i.dispose(),this.c.delete(r),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),n}l(T,m,D){if(!this.b)return a.Event.None;this.b.cancel();let p;const o=new a.$he({onWillAddFirstListener:()=>{p=this.n(T).listen(m,D)(o.fire,o),this.c.add(p)},onDidRemoveLastListener:()=>{this.c.delete(p),p.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return o.event}get m(){if(!this.f){const T=this.j&&this.j.args?this.j.args:[],m=Object.create(null);m.env={...(0,M.$9n)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(m.env={...m.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(m.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(m.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(m.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),m.execArgv===void 0&&(m.execArgv=process.execArgv.filter(_=>!/^--inspect(-brk)?=/.test(_)).filter(_=>!_.startsWith("--vscode-"))),(0,A.$sm)(m.env),this.d=(0,f.fork)(this.i,T,m);const D=new a.$he,o=a.Event.fromNodeEventEmitter(this.d,"message",_=>_)(_=>{if((0,q.$4q)(_)){(0,q.log)(_,`IPC Library: ${this.j.serverName}`);return}D.fire(P.$Je.wrap(Buffer.from(_,"base64")))}),n=this.j.useQueue?(0,H.$um)(this.d):this.d,i=_=>this.d&&this.d.connected&&n.send(_.buffer.toString("base64")),r=D.event,v={send:i,onMessage:r};this.f=new N.$di(v);const G=()=>this.o();process.once("exit",G),this.d.on("error",_=>console.warn('IPC "'+this.j.serverName+'" errored with '+_)),this.d.on("exit",(_,y)=>{process.removeListener("exit",G),o.dispose(),this.c.forEach(l=>(0,g.$Pc)(l)),this.c.clear(),_!==0&&y!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+_+" and signal "+y),this.b?.cancel(),this.o(),this.h.fire({code:_,signal:y})})}return this.f}n(T){let m=this.g.get(T);return m||(m=this.m.getChannel(T),this.g.set(T,m)),m}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$9q=s}),define(ge[46],me([0,1]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zi=e._util=void 0,e.$Ai=P,e.$Bi=b;var f;(function(q){q.serviceIds=new Map,q.DI_TARGET="$di$target",q.DI_DEPENDENCIES="$di$dependencies";function L(a){return a[q.DI_DEPENDENCIES]||[]}q.getServiceDependencies=L})(f||(e._util=f={})),e.$zi=P("instantiationService");function t(q,L,a){L[f.DI_TARGET]===L?L[f.DI_DEPENDENCIES].push({id:q,index:a}):(L[f.DI_DEPENDENCIES]=[{id:q,index:a}],L[f.DI_TARGET]=L)}function P(q){if(f.serviceIds.has(q))return f.serviceIds.get(q);const L=function(a,g,M){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");t(L,a,M)};return L.toString=()=>q,f.serviceIds.set(q,L),L}function b(q){return q}}),define(ge[47],me([0,1,16]),function(fe,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mm=t,e.$Nm=P,e.$Om=b,e.$Pm=q;function t(a){return a.scheme===f.Schemas.vscodeRemote?a.authority:void 0}function P(a){if(!a)return;const g=a.indexOf("+");return g<0?a:a.substr(0,g)}function b(a){const{host:g,port:M}=L(a);if(typeof M>"u")throw new Error(`Invalid remote authority: ${a}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:g,port:M}}function q(a,g){let{host:M,port:H}=L(a);return typeof H>"u"&&(H=g),{host:M,port:H}}function L(a){const g=a.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(g)return{host:g[1],port:parseInt(g[2],10)};const M=a.match(/^(\[[0-9a-z:]+\])$/);if(M)return{host:M[1],port:void 0};const H=a.match(/(.*):(\d+)$/);return H?{host:H[1],port:parseInt(H[2],10)}:{host:a,port:void 0}}}),define(ge[48],me([0,1,2,15,37]),function(fe,e,f,t,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lp=q,e.$mp=L;function b(a){if(f.$u===f.Platform.Linux&&/^penguin(\.|$)/i.test(a))return"chromebook"}function q(a,g,M,H,A,N,R,s,w,T){const m=Object.create(null);m["common.machineId"]=N,m["common.sqmId"]=R,m["common.devDeviceId"]=s,m.sessionID=(0,P.$Wg)()+Date.now(),m.commitHash=H,m.version=A,m["common.platformVersion"]=(a||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),m["common.platform"]=(0,f.$h)(f.$u),m["common.nodePlatform"]=t.$dc,m["common.nodeArch"]=M,m["common.product"]=T||"desktop",w&&(m["common.msftInternal"]=w);let D=0;const p=Date.now();Object.defineProperties(m,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-p,enumerable:!0},"common.sequence":{get:()=>D++,enumerable:!0}}),f.$l&&(m["common.snap"]="true");const o=b(g);return o&&(m["common.platformDetail"]=o),m}function L(a){const g=t.env.USERDNSDOMAIN;if(!g)return!1;const M=g.toLowerCase();return a.some(H=>M===H)}}),define(ge[49],me([0,1,46]),function(fe,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$em=e.$dm=e.$cm=e.$bm=e.$am=e.$_l=e.$$l=e.$0l=e.$9l=e.$8l=e.$7l=e.$6l=void 0,e.$6l=(0,f.$Ai)("telemetryService"),e.$7l=(0,f.$Ai)("customEndpointTelemetryService"),e.$8l="telemetry.currentSessionDate",e.$9l="telemetry.firstSessionDate",e.$0l="telemetry.lastSessionDate",e.$$l="telemetry.machineId",e.$_l="telemetry.sqmId",e.$am="telemetry.devDeviceId",e.$bm="telemetry",e.$cm="telemetry.telemetryLevel",e.$dm="telemetry.enableCrashReporter",e.$em="telemetry.enableTelemetry";var t;(function(b){b[b.NONE=0]="NONE",b[b.CRASH=1]="CRASH",b[b.ERROR=2]="ERROR",b[b.USAGE=3]="USAGE"})(t||(e.TelemetryLevel=t={}));var P;(function(b){b.OFF="off",b.CRASH="crash",b.ERROR="error",b.ON="all"})(P||(e.TelemetryConfiguration=P={}))}),define(ge[50],me([0,1]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9dc=e.$8dc=void 0;class f{constructor(b){this.b=b}listen(b,q){throw new Error(`Event not found: ${q}`)}call(b,q,{eventName:L,data:a}){return this.b.forEach(g=>g.log(L,a)),Promise.resolve(null)}}e.$8dc=f;class t{constructor(b){this.b=b}log(b,q){return this.b.call("log",{eventName:b,data:q}).then(void 0,L=>`Failed to log telemetry: ${console.warn(L)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.$9dc=t}),define(ge[51],me([0,1,14,8,47,48,49]),function(fe,e,f,t,P,b,q){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tp=e.$sp=e.$rp=e.$qp=e.$pp=e.$op=e.$np=void 0,e.$up=M,e.$vp=H,e.$wp=A,e.$xp=N,e.$yp=s,e.$zp=T,e.$Ap=m,e.$Bp=o;class L{constructor(i){this.value=i,this.isTrustedTelemetryValue=!0}}e.$np=L;class a{constructor(){this.telemetryLevel=q.TelemetryLevel.NONE,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.devDeviceId="someValue.devDeviceId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$op=a,e.$pp=new a;class g{async publicLog(i,r,v){}async publicLogError(i,r,v){}}e.$qp=g,e.$rp="telemetry",e.$sp="extensionTelemetryLog",e.$tp={log:()=>null,flush:()=>Promise.resolve(null)};function M(n,i){return!i.isBuilt&&!i.disableTelemetry?!0:!(i.disableTelemetry||!n.enableTelemetry)}function H(n,i){return i.extensionTestsLocationURI?!0:!(i.isBuilt||i.disableTelemetry||n.enableTelemetry&&n.aiConfig?.ariaKey)}function A(n){const i=n.getValue(q.$cm),r=n.getValue(q.$dm);if(n.getValue(q.$em)===!1||r===!1)return q.TelemetryLevel.NONE;switch(i??q.TelemetryConfiguration.ON){case q.TelemetryConfiguration.ON:return q.TelemetryLevel.USAGE;case q.TelemetryConfiguration.ERROR:return q.TelemetryLevel.ERROR;case q.TelemetryConfiguration.CRASH:return q.TelemetryLevel.CRASH;case q.TelemetryConfiguration.OFF:return q.TelemetryLevel.NONE}}function N(n){const i={},r={},v={};w(n,v);for(let G in v){G=G.length>150?G.substr(G.length-149):G;const _=v[G];typeof _=="number"?r[G]=_:typeof _=="boolean"?r[G]=_?1:0:typeof _=="string"?(_.length>8192&&console.warn(`Telemetry property: ${G} has been trimmed to 8192, the original length is ${_.length}`),i[G]=_.substring(0,8191)):typeof _<"u"&&_!==null&&(i[G]=_)}return{properties:i,measurements:r}}const R=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function s(n){if(!n)return"none";const i=(0,P.$Nm)(n);return R.has(i)?i:"other"}function w(n,i,r=0,v){if(n)for(const G of Object.getOwnPropertyNames(n)){const _=n[G],y=v?v+G:G;Array.isArray(_)?i[y]=(0,f.$bo)(_):_ instanceof Date?i[y]=_.toISOString():(0,t.$cg)(_)?r<2?w(_,i,r+1,y+"."):i[y]=(0,f.$bo)(_):i[y]=_}}function T(n,i){const r=n.msftInternalDomains||[],v=i.getValue("telemetry.internalTesting");return(0,b.$mp)(r)||v}function m(n){return[n.appRoot,n.extensionsPath,n.userHome.fsPath,n.tmpDir.fsPath,n.userDataPath]}function D(n,i){if(!n||!n.includes("/")&&!n.includes("\\"))return n;let r=n;const v=[];for(const l of i)for(;;){const I=l.exec(n);if(!I)break;v.push([I.index,l.lastIndex])}const G=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,_=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let y=0;for(r="";;){const l=_.exec(n);if(!l)break;const I=v.some(([E,h])=>l.index<h&&E<_.lastIndex);!G.test(l[0])&&!I&&(r+=n.substring(y,l.index)+"<REDACTED: user-file-path>",y=_.lastIndex)}return y<n.length&&(r+=n.substr(y)),r}function p(n){if(!n)return n;const i=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"CLI Credentials",regex:/((login|psexec|(certutil|psexec)\.exe).{1,50}(\s-u(ser(name)?)?\s+.{3,100})?\s-(admin|user|vm|root)?p(ass(word)?)?\s+["']?[^$\-\/\s]|(^|[\s\r\n\\])net(\.exe)?.{1,5}(user\s+|share\s+\/user:| user -? secrets ? set) \s + [^ $\s \/])/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const r of i)if(r.regex.test(n))return`<REDACTED: ${r.label}>`;return n}function o(n,i){return(0,f.$$n)(n,r=>{if(r instanceof L||Object.hasOwnProperty.call(r,"isTrustedTelemetryValue"))return r.value;if(typeof r=="string"){let v=r.replaceAll("%20"," ");v=D(v,i);for(const G of i)v=v.replace(G,"");return v=p(v),v}})}}),define(ge[52],me([0,1,41,3,14,51]),function(fe,e,f,t,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8P=void 0;const q="https://mobile.events.data.microsoft.com/OneCollector/1.0",L="https://mobile.events.data.microsoft.com/ping";async function a(M,H,A){const N=await(0,f.$dE)("@microsoft/1ds-core-js","dist/ms.core.js"),R=await(0,f.$dE)("@microsoft/1ds-post-js","dist/ms.post.js"),s=new N.AppInsightsCore,w=new R.PostChannel,T={instrumentationKey:M,endpointUrl:q,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[w]]};if(A){T.extensionConfig={};const m={alwaysUseXhrOverride:!0,ignoreMc1Ms0CookieProcessing:!0,httpXHROverride:A};T.extensionConfig[w.identifier]=m}return s.initialize(T,[]),s.addTelemetryInitializer(m=>{m.ext=m.ext??{},m.ext.web=m.ext.web??{},m.ext.web.consentDetails='{"GPC_DataSharingOptIn":false}',H&&(m.ext.utc=m.ext.utc??{},m.ext.utc.flags=8462029)}),s}class g{constructor(H,A,N,R,s){this.e=H,this.f=A,this.g=N,this.h=s,this.c=q,this.d=L,this.g||(this.g={}),typeof R=="function"?this.a=R():this.a=R,this.b=null}i(H){if(this.a){if(typeof this.a!="string"){H(this.a);return}this.b||(this.b=a(this.a,this.e,this.h)),this.b.then(A=>{H(A)},A=>{(0,t.$1)(A),console.error(A)})}}log(H,A){if(!this.a)return;A=(0,P.$_n)(A,this.g),A=(0,b.$xp)(A);const N=this.f+"/"+H;try{this.i(R=>{R.pluginVersionString=A?.properties.version??"Unknown",R.track({name:N,baseData:{name:N,properties:A?.properties,measurements:A?.measurements}})})}catch{}}flush(){return this.a?new Promise(H=>{this.i(A=>{A.unload(!0,()=>{this.a=void 0,H(void 0)})})}):Promise.resolve(void 0)}}e.$8P=g}),define(ge[53],me([0,1,11,7,60,52]),function(fe,e,f,t,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9P=void 0;async function q(M,H){const A=await H.request(M,t.CancellationToken.None),N=(await(0,f.$Ve)(A.stream)).toString(),R=A.res.statusCode??200;return{headers:A.res.headers,statusCode:R,responseData:N}}async function L(M){const H={method:M.type,headers:M.headers};return new Promise((N,R)=>{const s=P.request(M.url??"",H,w=>{w.on("data",function(T){N({headers:w.headers,statusCode:w.statusCode??200,responseData:T.toString()})}),w.on("error",function(T){R(T)})});s.write(M.data,w=>{w&&R(w)}),s.end()})}async function a(M,H,A){const N=typeof H.data=="string"?H.data:new TextDecoder().decode(H.data),R={type:"POST",headers:{...H.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(H.data).toString()},url:H.urlString,data:N};try{const s=M?await q(R,M):await L(R);A(s.statusCode,s.headers,s.responseData)}catch{A(0,{})}}class g extends b.$8P{constructor(H,A,N,R,s){const w={sendPOST:(T,m)=>{a(H,T,m)}};super(A,N,R,s,w)}}e.$9P=g}),define(ge[61],me([0,1,45,50,53]),function(fe,e,f,t,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0});const b=new P.$9P(void 0,!1,process.argv[2],JSON.parse(process.argv[3]),process.argv[4]);process.once("exit",()=>b.flush());const q=new t.$8dc([b]);new f.$8q("telemetry").registerChannel("telemetryAppender",q)})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/fd11ed87fdf1f8e46575e027644406f51f0666f6/core/vs/workbench/contrib/debug/node/telemetryApp.js.map
