/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var K=["require","exports","vs/base/common/lifecycle","vs/base/common/platform","vs/base/common/observableInternal/debugName","vs/base/common/observableInternal/logging","vs/base/common/observableInternal/base","vs/base/common/errors","vs/base/common/equals","vs/base/common/observableInternal/autorun","vs/base/common/observableInternal/derived","vs/editor/common/tokens/lineTokens","vs/editor/common/encodedTokenAttributes","vs/base/common/uri","vs/base/common/arrays","vs/base/common/event","vs/base/common/observable","vs/base/common/buffer","vs/editor/common/core/eolCounter","vs/base/common/charCode","vs/editor/common/core/lineRange","vs/editor/common/tokens/contiguousMultilineTokensBuilder","vs/base/common/path","vs/base/common/strings","vs/base/common/network","vs/base/common/resources","vs/base/common/async","vs/editor/common/languages/nullTokenize","vs/base/common/amd","vs/base/common/assert","vs/base/common/observableInternal/promise","vs/base/common/cancellation","vs/base/common/observableInternal/utils","vs/base/common/stream","vs/base/common/lazy","vs/base/common/symbols","vs/editor/common/model/fixedArray","vs/editor/common/tokens/contiguousTokensEditing","vs/editor/common/tokens/contiguousMultilineTokens","vs/base/common/extpath","vs/amdX","vs/editor/common/languages","vs/editor/common/model/textModelTokens","vs/base/common/stopwatch","vs/workbench/services/textMate/browser/tokenizationSupport/textMateTokenizationSupport","vs/workbench/services/textMate/browser/tokenizationSupport/tokenizationSupportWithLineLimit","vs/workbench/services/textMate/browser/backgroundTokenization/worker/textMateWorkerTokenizer","vs/workbench/services/textMate/common/TMScopeRegistry","vs/workbench/services/textMate/common/TMGrammarFactory","vs/editor/common/core/position","vs/base/common/types","vs/editor/common/core/offsetRange","vs/editor/common/model/mirrorTextModel","vs/workbench/services/textMate/browser/backgroundTokenization/worker/textMateTokenizationWorker.worker"],G=function(B){for(var e=[],L=0,w=B.length;L<w;L++)e[L]=K[B[L]];return e};define(K[28],G([0,1]),function(B,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U=e.$T=void 0,e.$T=!1;class L{static get(){const j=new Map,C=new Map,s=new Map,h=new Map;function a(o,i){o.has(i.detail)||o.set(i.detail,-i.timestamp)}function d(o,i){const t=o.get(i.detail);t&&(t>=0||o.set(i.detail,t+i.timestamp))}let f=[];typeof B=="function"&&typeof B.getStats=="function"&&(f=B.getStats().slice(0).sort((o,i)=>o.timestamp-i.timestamp));for(const o of f)switch(o.type){case LoaderEventType.BeginLoadingScript:a(j,o);break;case LoaderEventType.EndLoadingScriptOK:case LoaderEventType.EndLoadingScriptError:d(j,o);break;case LoaderEventType.BeginInvokeFactory:a(C,o);break;case LoaderEventType.EndInvokeFactory:d(C,o);break;case LoaderEventType.NodeBeginNativeRequire:a(s,o);break;case LoaderEventType.NodeEndNativeRequire:d(s,o);break;case LoaderEventType.NodeBeginEvaluatingScript:a(h,o);break;case LoaderEventType.NodeEndEvaluatingScript:d(h,o);break}let l=0;s.forEach(o=>l+=o);function g(o){const i=[];return o.forEach((t,n)=>i.push([n,t])),i}return{amdLoad:g(j),amdInvoke:g(C),nodeRequire:g(s),nodeEval:g(h),nodeRequireTotal:l}}static toMarkdownTable(j,C){let s="";const h=[];return j.forEach((a,d)=>{h[d]=a.length}),C.forEach(a=>{a.forEach((d,f)=>{typeof d>"u"&&(d=a[f]="-");const l=d.toString().length;h[f]=Math.max(l,h[f])})}),j.forEach((a,d)=>{s+=`| ${a+" ".repeat(h[d]-a.toString().length)} `}),s+=`|
`,j.forEach((a,d)=>{s+=`| ${"-".repeat(h[d])} `}),s+=`|
`,C.forEach(a=>{a.forEach((d,f)=>{typeof d<"u"&&(s+=`| ${d+" ".repeat(h[f]-d.toString().length)} `)}),s+=`|
`}),s}}e.$U=L}),define(K[8],G([0,1,14]),function(B,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6c=void 0,e.$7c=j,e.$8c=C,e.$9c=s,e.$0c=h,e.$$c=a,e.$_c=d;const w=(o,i)=>o===i;e.$6c=w;function j(o=e.$6c){return(i,t)=>L.$ub(i,t,o)}function C(){return(o,i)=>JSON.stringify(o)===JSON.stringify(i)}function s(){return(o,i)=>o.equals(i)}function h(o,i,t){return!o||!i?o===i:t(o,i)}function a(o,i){if(o===i)return!0;if(Array.isArray(o)&&Array.isArray(i)){if(o.length!==i.length)return!1;for(let t=0;t<o.length;t++)if(!a(o[t],i[t]))return!1;return!0}if(o&&typeof o=="object"&&i&&typeof i=="object"&&Object.getPrototypeOf(o)===Object.prototype&&Object.getPrototypeOf(i)===Object.prototype){const t=o,n=i,r=Object.keys(t),$=Object.keys(n),O=new Set($);if(r.length!==$.length)return!1;for(const S of r)if(!O.has(S)||!a(t[S],n[S]))return!1;return!0}return!1}function d(o){return JSON.stringify(g(o))}let f=0;const l=new WeakMap;function g(o){if(Array.isArray(o))return o.map(g);if(o&&typeof o=="object")if(Object.getPrototypeOf(o)===Object.prototype){const i=o,t=Object.create(null);for(const n of Object.keys(i).sort())t[n]=g(i[n]);return t}else{let i=l.get(o);return i===void 0&&(i=f++,l.set(o,i)),i+"----2b76a038c20c4bcc"}return o}}),define(K[4],G([0,1]),function(B,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ad=void 0,e.$bd=C,e.$cd=g;class L{constructor(i,t,n){this.owner=i,this.debugNameSource=t,this.referenceFn=n}getDebugName(i){return C(i,this)}}e.$ad=L;const w=new Map,j=new WeakMap;function C(o,i){const t=j.get(o);if(t)return t;const n=s(o,i);if(n){let r=w.get(n)??0;r++,w.set(n,r);const $=r===1?n:`${n}#${r}`;return j.set(o,$),$}}function s(o,i){const t=j.get(o);if(t)return t;const n=i.owner?f(i.owner)+".":"";let r;const $=i.debugNameSource;if($!==void 0)if(typeof $=="function"){if(r=$(),r!==void 0)return n+r}else return n+$;const O=i.referenceFn;if(O!==void 0&&(r=g(O),r!==void 0))return n+r;if(i.owner!==void 0){const S=h(i.owner,o);if(S!==void 0)return n+S}}function h(o,i){for(const t in o)if(o[t]===i)return t}const a=new Map,d=new WeakMap;function f(o){const i=d.get(o);if(i)return i;const t=l(o);let n=a.get(t)??0;n++,a.set(t,n);const r=n===1?t:`${t}#${n}`;return d.set(o,r),r}function l(o){const i=o.constructor;return i?i.name:"Object"}function g(o){const i=o.toString(),n=/\/\*\*\s*@description\s*([^*]*)\*\//.exec(i);return(n?n[1]:void 0)?.trim()}}),define(K[5],G([0,1]),function(B,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jd=void 0,e.$Hd=w,e.$Id=j;let L;function w(t){L=t}function j(){return L}class C{constructor(){this.a=0,this.d=new WeakMap}b(n){return s([h(o("|  ",this.a)),n])}c(n){return n.hadValue?n.didChange?[h(" "),d(f(n.oldValue,70),{color:"red",strikeThrough:!0}),h(" "),d(f(n.newValue,60),{color:"green"})]:[h(" (unchanged)")]:[h(" "),d(f(n.newValue,60),{color:"green"}),h(" (initial)")]}handleObservableChanged(n,r){console.log(...this.b([a("observable value changed"),d(n.debugName,{color:"BlueViolet"}),...this.c(r)]))}formatChanges(n){if(n.size!==0)return d(" (changed deps: "+[...n].map(r=>r.debugName).join(", ")+")",{color:"gray"})}handleDerivedCreated(n){const r=n.handleChange;this.d.set(n,new Set),n.handleChange=($,O)=>(this.d.get(n).add($),r.apply(n,[$,O]))}handleDerivedRecomputed(n,r){const $=this.d.get(n);console.log(...this.b([a("derived recomputed"),d(n.debugName,{color:"BlueViolet"}),...this.c(r),this.formatChanges($),{data:[{fn:n._computeFn}]}])),$.clear()}handleFromEventObservableTriggered(n,r){console.log(...this.b([a("observable from event triggered"),d(n.debugName,{color:"BlueViolet"}),...this.c(r),{data:[{fn:n._getValue}]}]))}handleAutorunCreated(n){const r=n.handleChange;this.d.set(n,new Set),n.handleChange=($,O)=>(this.d.get(n).add($),r.apply(n,[$,O]))}handleAutorunTriggered(n){const r=this.d.get(n);console.log(...this.b([a("autorun"),d(n.debugName,{color:"BlueViolet"}),this.formatChanges(r),{data:[{fn:n._runFn}]}])),r.clear(),this.a++}handleAutorunFinished(n){this.a--}handleBeginTransaction(n){let r=n.getDebugName();r===void 0&&(r=""),console.log(...this.b([a("transaction"),d(r,{color:"BlueViolet"}),{data:[{fn:n._fn}]}])),this.a++}handleEndTransaction(){this.a--}}e.$Jd=C;function s(t){const n=new Array,r=[];let $="";function O(E){if("length"in E)for(const I of E)I&&O(I);else"text"in E?($+=`%c${E.text}`,n.push(E.style),E.data&&r.push(...E.data)):"data"in E&&r.push(...E.data)}O(t);const S=[$,...n];return S.push(...r),S}function h(t){return d(t,{color:"black"})}function a(t){return d(i(`${t}: `,10),{color:"black",bold:!0})}function d(t,n={color:"black"}){function r(O){return Object.entries(O).reduce((S,[E,I])=>`${S}${E}:${I};`,"")}const $={color:n.color};return n.strikeThrough&&($["text-decoration"]="line-through"),n.bold&&($["font-weight"]="bold"),{text:t,style:r($)}}function f(t,n){switch(typeof t){case"number":return""+t;case"string":return t.length+2<=n?`"${t}"`:`"${t.substr(0,n-7)}"+...`;case"boolean":return t?"true":"false";case"undefined":return"undefined";case"object":return t===null?"null":Array.isArray(t)?l(t,n):g(t,n);case"symbol":return t.toString();case"function":return`[[Function${t.name?" "+t.name:""}]]`;default:return""+t}}function l(t,n){let r="[ ",$=!0;for(const O of t){if($||(r+=", "),r.length-5>n){r+="...";break}$=!1,r+=`${f(O,n-r.length)}`}return r+=" ]",r}function g(t,n){let r="{ ",$=!0;for(const[O,S]of Object.entries(t)){if($||(r+=", "),r.length-5>n){r+="...";break}$=!1,r+=`${O}: ${f(S,n-r.length)}`}return r+=" }",r}function o(t,n){let r="";for(let $=1;$<=n;$++)r+=t;return r}function i(t,n){for(;t.length<n;)t+=" ";return t}}),define(K[9],G([0,1,29,2,4,5]),function(B,e,L,w,j,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pd=void 0,e.$jd=s,e.$kd=h,e.$ld=a,e.$md=d,e.$nd=f,e.$od=l;function s(i){return new o(new j.$ad(void 0,void 0,i),i,void 0,void 0)}function h(i,t){return new o(new j.$ad(i.owner,i.debugName,i.debugReferenceFn??t),t,void 0,void 0)}function a(i,t){return new o(new j.$ad(i.owner,i.debugName,i.debugReferenceFn??t),t,i.createEmptyChangeSummary,i.handleChange)}function d(i,t){const n=new w.$Tc,r=a({owner:i.owner,debugName:i.debugName,debugReferenceFn:i.debugReferenceFn,createEmptyChangeSummary:i.createEmptyChangeSummary,handleChange:i.handleChange},($,O)=>{n.clear(),t($,O,n)});return(0,w.$Sc)(()=>{r.dispose(),n.dispose()})}function f(i){const t=new w.$Tc,n=h({owner:void 0,debugName:void 0,debugReferenceFn:i},r=>{t.clear(),i(r,t)});return(0,w.$Sc)(()=>{n.dispose(),t.dispose()})}function l(i,t){let n;return h({debugReferenceFn:t},r=>{const $=i.read(r),O=n;n=$,t({lastValue:O,newValue:$})})}var g;(function(i){i[i.dependenciesMightHaveChanged=1]="dependenciesMightHaveChanged",i[i.stale=2]="stale",i[i.upToDate=3]="upToDate"})(g||(g={}));class o{get debugName(){return this.h.getDebugName(this)??"(anonymous)"}constructor(t,n,r,$){this.h=t,this._runFn=n,this.i=r,this.j=$,this.a=g.stale,this.b=0,this.c=!1,this.e=new Set,this.f=new Set,this.g=this.i?.(),(0,C.$Id)()?.handleAutorunCreated(this),this.k(),(0,w.$Lc)(this)}dispose(){this.c=!0;for(const t of this.e)t.removeObserver(this);this.e.clear(),(0,w.$Mc)(this)}k(){if(this.a===g.upToDate)return;const t=this.f;this.f=this.e,this.e=t,this.a=g.upToDate;const n=this.c;try{if(!n){(0,C.$Id)()?.handleAutorunTriggered(this);const r=this.g;this.g=this.i?.(),this._runFn(this,r)}}finally{n||(0,C.$Id)()?.handleAutorunFinished(this);for(const r of this.f)r.removeObserver(this);this.f.clear()}}toString(){return`Autorun<${this.debugName}>`}beginUpdate(){this.a===g.upToDate&&(this.a=g.dependenciesMightHaveChanged),this.b++}endUpdate(){if(this.b===1)do{if(this.a===g.dependenciesMightHaveChanged){this.a=g.upToDate;for(const t of this.e)if(t.reportChanges(),this.a===g.stale)break}this.k()}while(this.a!==g.upToDate);this.b--,(0,L.$hd)(()=>this.b>=0)}handlePossibleChange(t){this.a===g.upToDate&&this.e.has(t)&&!this.f.has(t)&&(this.a=g.dependenciesMightHaveChanged)}handleChange(t,n){this.e.has(t)&&!this.f.has(t)&&(!this.j||this.j({changedObservable:t,change:n,didChange:$=>$===t},this.g))&&(this.a=g.stale)}readObservable(t){if(this.c)return t.get();t.addObserver(this);const n=t.get();return this.e.add(t),this.f.delete(t),n}}e.$pd=o,function(i){i.Observer=o}(s||(e.$jd=s={}))}),define(K[6],G([0,1,8,4,5]),function(B,e,L,w,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7d=e.$5d=e.$2d=e.$Wd=e.$Vd=void 0,e.$Sd=s,e.$Td=a,e.$Ud=f,e.$Xd=o,e.$Yd=t,e.$Zd=n,e.$1d=r,e.$3d=O,e.$4d=S,e.$6d=I;let C;function s(v){C=v}let h;function a(v){h=v}let d;function f(v){d=v}class l{get TChange(){return null}reportChanges(){this.get()}read(y){return y?y.readObservable(this):this.get()}map(y,D){const q=D===void 0?void 0:y,F=D===void 0?y:D;return d({owner:q,debugName:()=>{const k=(0,w.$cd)(F);if(k!==void 0)return k;const m=/^\s*\(?\s*([a-zA-Z_$][a-zA-Z_$0-9]*)\s*\)?\s*=>\s*\1(?:\??)\.([a-zA-Z_$][a-zA-Z_$0-9]*)\s*$/.exec(F.toString());if(m)return`${this.debugName}.${m[2]}`;if(!q)return`${this.debugName} (mapped)`},debugReferenceFn:F},k=>F(this.read(k),k))}recomputeInitiallyAndOnChange(y,D){return y.add(C(this,D)),this}keepObserved(y){return y.add(h(this)),this}get a(){return this.get()}}e.$Vd=l;class g extends l{constructor(){super(...arguments),this.b=new Set}addObserver(y){const D=this.b.size;this.b.add(y),D===0&&this.c()}removeObserver(y){this.b.delete(y)&&this.b.size===0&&this.f()}c(){}f(){}}e.$Wd=g;function o(v,y){const D=new $(v,y);try{v(D)}finally{D.finish()}}let i;function t(v){if(i)v(i);else{const y=new $(v,void 0);i=y;try{v(y)}finally{y.finish(),i=void 0}}}async function n(v,y){const D=new $(v,y);try{await v(D)}finally{D.finish()}}function r(v,y,D){v?y(v):o(y,D)}class ${constructor(y,D){this._fn=y,this.b=D,this.a=[],(0,j.$Id)()?.handleBeginTransaction(this)}getDebugName(){return this.b?this.b():(0,w.$cd)(this._fn)}updateObserver(y,D){this.a.push({observer:y,observable:D}),y.beginUpdate(D)}finish(){const y=this.a;for(let D=0;D<y.length;D++){const{observer:q,observable:F}=y[D];q.endUpdate(F)}this.a=null,(0,j.$Id)()?.handleEndTransaction()}}e.$2d=$;function O(v,y){let D;return typeof v=="string"?D=new w.$ad(void 0,v,void 0):D=new w.$ad(v,void 0,void 0),new E(D,y,L.$6c)}function S(v,y){return new E(new w.$ad(v.owner,v.debugName,void 0),y,v.equalsFn??L.$6c)}class E extends g{get debugName(){return this.e.getDebugName(this)??"ObservableValue"}constructor(y,D,q){super(),this.e=y,this.g=q,this.d=D}get(){return this.d}set(y,D,q){if(q===void 0&&this.g(this.d,y))return;let F;D||(D=F=new $(()=>{},()=>`Setting ${this.debugName}`));try{const k=this.d;this.h(y),(0,j.$Id)()?.handleObservableChanged(this,{oldValue:k,newValue:y,change:q,didChange:!0,hadValue:!0});for(const M of this.b)D.updateObserver(M,this),M.handleChange(this,q)}finally{F&&F.finish()}}toString(){return`${this.debugName}: ${this.d}`}h(y){this.d=y}}e.$5d=E;function I(v,y){let D;return typeof v=="string"?D=new w.$ad(void 0,v,void 0):D=new w.$ad(v,void 0,void 0),new b(D,y,L.$6c)}class b extends E{h(y){this.d!==y&&(this.d&&this.d.dispose(),this.d=y)}dispose(){this.d?.dispose()}}e.$7d=b}),define(K[10],G([0,1,29,8,2,6,4,5]),function(B,e,L,w,j,C,s,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rd=e.$Qd=void 0,e.$Kd=a,e.$Ld=d,e.$Md=f,e.$Nd=l,e.$Od=g,e.$Pd=o;function a(r,$){return $!==void 0?new t(new s.$ad(r,void 0,$),$,void 0,void 0,void 0,w.$6c):new t(new s.$ad(void 0,void 0,r),r,void 0,void 0,void 0,w.$6c)}function d(r,$,O){return new n(new s.$ad(r,void 0,$),$,void 0,void 0,void 0,w.$6c,O)}function f(r,$){return new t(new s.$ad(r.owner,r.debugName,r.debugReferenceFn),$,void 0,void 0,r.onLastObserverRemoved,r.equalsFn??w.$6c)}(0,C.$Ud)(f);function l(r,$){return new t(new s.$ad(r.owner,r.debugName,void 0),$,r.createEmptyChangeSummary,r.handleChange,void 0,r.equalityComparer??w.$6c)}function g(r,$){let O,S;$===void 0?(O=r,S=void 0):(S=r,O=$);const E=new j.$Tc;return new t(new s.$ad(S,void 0,O),I=>(E.clear(),O(I,E)),void 0,void 0,()=>E.dispose(),w.$6c)}function o(r,$){let O,S;$===void 0?(O=r,S=void 0):(S=r,O=$);const E=new j.$Tc;return new t(new s.$ad(S,void 0,O),I=>{E.clear();const b=O(I);return b&&E.add(b),b},void 0,void 0,()=>E.dispose(),w.$6c)}var i;(function(r){r[r.initial=0]="initial",r[r.dependenciesMightHaveChanged=1]="dependenciesMightHaveChanged",r[r.stale=2]="stale",r[r.upToDate=3]="upToDate"})(i||(i={}));class t extends C.$Wd{get debugName(){return this.m.getDebugName(this)??"(anonymous)"}constructor($,O,S,E,I=void 0,b){super(),this.m=$,this._computeFn=O,this.n=S,this.p=E,this.q=I,this.s=b,this.e=i.initial,this.g=void 0,this.h=0,this.j=new Set,this.k=new Set,this.l=void 0,this.l=this.n?.(),(0,h.$Id)()?.handleDerivedCreated(this)}f(){this.e=i.initial,this.g=void 0;for(const $ of this.j)$.removeObserver(this);this.j.clear(),this.q?.()}get(){if(this.b.size===0){const $=this._computeFn(this,this.n?.());return this.f(),$}else{do{if(this.e===i.dependenciesMightHaveChanged){for(const $ of this.j)if($.reportChanges(),this.e===i.stale)break}this.e===i.dependenciesMightHaveChanged&&(this.e=i.upToDate),this.u()}while(this.e!==i.upToDate);return this.g}}u(){if(this.e===i.upToDate)return;const $=this.k;this.k=this.j,this.j=$;const O=this.e!==i.initial,S=this.g;this.e=i.upToDate;const E=this.l;this.l=this.n?.();try{this.g=this._computeFn(this,E)}finally{for(const b of this.k)b.removeObserver(this);this.k.clear()}const I=O&&!this.s(S,this.g);if((0,h.$Id)()?.handleDerivedRecomputed(this,{oldValue:S,newValue:this.g,change:void 0,didChange:I,hadValue:O}),I)for(const b of this.b)b.handleChange(this,void 0)}toString(){return`LazyDerived<${this.debugName}>`}beginUpdate($){this.h++;const O=this.h===1;if(this.e===i.upToDate&&(this.e=i.dependenciesMightHaveChanged,!O))for(const S of this.b)S.handlePossibleChange(this);if(O)for(const S of this.b)S.beginUpdate(this)}endUpdate($){if(this.h--,this.h===0){const O=[...this.b];for(const S of O)S.endUpdate(this)}(0,L.$hd)(()=>this.h>=0)}handlePossibleChange($){if(this.e===i.upToDate&&this.j.has($)&&!this.k.has($)){this.e=i.dependenciesMightHaveChanged;for(const O of this.b)O.handlePossibleChange(this)}}handleChange($,O){if(this.j.has($)&&!this.k.has($)){const S=this.p?this.p({changedObservable:$,change:O,didChange:I=>I===$},this.l):!0,E=this.e===i.upToDate;if(S&&(this.e===i.dependenciesMightHaveChanged||E)&&(this.e=i.stale,E))for(const I of this.b)I.handlePossibleChange(this)}}readObservable($){$.addObserver(this);const O=$.get();return this.j.add($),this.k.delete($),O}addObserver($){const O=!this.b.has($)&&this.h>0;super.addObserver($),O&&$.beginUpdate(this)}removeObserver($){const O=this.b.has($)&&this.h>0;super.removeObserver($),O&&$.endUpdate(this)}}e.$Qd=t;class n extends t{constructor($,O,S,E,I=void 0,b,v){super($,O,S,E,I,b),this.set=v}}e.$Rd=n}),define(K[30],G([0,1,9,6,10,31,4,8,7]),function(B,e,L,w,j,C,s,h,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$d=e.$0d=e.$9d=e.$8d=void 0,e.$_d=o,e.$ae=i;class d{get cachedValue(){return this.a}constructor(n){this.b=n,this.a=(0,w.$3d)(this,void 0)}getValue(){let n=this.a.get();return n||(n=this.b(),this.a.set(n,void 0)),n}}e.$8d=d;class f{constructor(n){this.a=(0,w.$3d)(this,void 0),this.promiseResult=this.a,this.promise=n.then(r=>((0,w.$Xd)($=>{this.a.set(new l(r,void 0),$)}),r),r=>{throw(0,w.$Xd)($=>{this.a.set(new l(void 0,r),$)}),r})}}e.$9d=f;class l{constructor(n,r){this.data=n,this.error=r}getDataOrThrow(){if(this.error)throw this.error;return this.data}}e.$0d=l;class g{constructor(n){this.b=n,this.a=new d(()=>new f(this.b())),this.cachedPromiseResult=(0,j.$Kd)(this,r=>this.a.cachedValue.read(r)?.promiseResult.read(r))}getPromise(){return this.a.getValue().promise}}e.$$d=g;function o(t,n,r,$){return n||(n=O=>O!=null),new Promise((O,S)=>{let E=!0,I=!1;const b=t.map(y=>({isFinished:n(y),error:r?r(y):!1,state:y})),v=(0,L.$jd)(y=>{const{isFinished:D,error:q,state:F}=b.read(y);(D||q)&&(E?I=!0:v.dispose(),q?S(q===!0?F:q):O(F))});if($){const y=$.onCancellationRequested(()=>{v.dispose(),y.dispose(),S(new a.$5)});if($.isCancellationRequested){v.dispose(),y.dispose(),S(new a.$5);return}}E=!1,I&&v.dispose()})}function i(t,n){let r,$;n===void 0?(r=t,$=void 0):($=t,r=n);let O;return new j.$Qd(new s.$ad($,void 0,r),S=>(O&&O.dispose(!0),O=new C.$se,r(S,O.token)),void 0,void 0,()=>O?.dispose(),h.$6c)}}),define(K[32],G([0,1,15,2,9,6,4,10,5]),function(B,e,L,w,j,C,s,h,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fd=e.$Bd=e.$td=void 0,e.$qd=d,e.$rd=l,e.$sd=g,e.$ud=i,e.$vd=n,e.$wd=$,e.$xd=O,e.$yd=S,e.$zd=E,e.$Ad=I,e.$Cd=v,e.$Dd=y,e.$Ed=D,e.$Gd=k;function d(M){return new f(M)}class f extends C.$Vd{constructor(m){super(),this.b=m}get debugName(){return this.toString()}get(){return this.b}addObserver(m){}removeObserver(m){}toString(){return`Const: ${this.b}`}}function l(M){const m=(0,C.$3d)("promiseValue",{});return M.then(u=>{m.set({value:u},void 0)}),m}function g(M,m){return new o(M,m)}class o extends C.$Wd{constructor(m,u){super(),this.j=m,this._getValue=u,this.g=!1,this.n=P=>{const A=this._getValue(P),z=this.e,W=!this.g||z!==A;let H=!1;W&&(this.e=A,this.g&&(H=!0,(0,C.$1d)(o.globalTransaction,V=>{(0,a.$Id)()?.handleFromEventObservableTriggered(this,{oldValue:z,newValue:A,change:void 0,didChange:W,hadValue:this.g});for(const Z of this.b)V.updateObserver(Z,this),Z.handleChange(this,void 0)},()=>{const V=this.k();return"Event fired"+(V?`: ${V}`:"")})),this.g=!0),H||(0,a.$Id)()?.handleFromEventObservableTriggered(this,{oldValue:z,newValue:A,change:void 0,didChange:W,hadValue:this.g})}}k(){return(0,s.$cd)(this._getValue)}get debugName(){const m=this.k();return"From Event"+(m?`: ${m}`:"")}c(){this.h=this.j(this.n)}f(){this.h.dispose(),this.h=void 0,this.g=!1,this.e=void 0}get(){return this.h?(this.g||this.n(void 0),this.e):this._getValue(void 0)}}e.$td=o,function(M){M.Observer=o;function m(u,P){let A=!1;o.globalTransaction===void 0&&(o.globalTransaction=u,A=!0);try{P()}finally{A&&(o.globalTransaction=void 0)}}M.batchEventsGlobally=m}(g||(e.$sd=g={}));function i(M,m){return new t(M,m)}class t extends C.$Wd{constructor(m,u){super(),this.debugName=m,this.g=u,this.j=()=>{(0,C.$Xd)(P=>{for(const A of this.b)P.updateObserver(A,this),A.handleChange(this,void 0)},()=>this.debugName)}}c(){this.e=this.g(this.j)}f(){this.e.dispose(),this.e=void 0}get(){}}function n(M){return typeof M=="string"?new r(M):new r(void 0,M)}class r extends C.$Wd{get debugName(){return new s.$ad(this.g,this.e,void 0).getDebugName(this)??"Observable Signal"}constructor(m,u){super(),this.e=m,this.g=u}trigger(m,u){if(!m){(0,C.$Xd)(P=>{this.trigger(P,u)},()=>`Trigger signal ${this.debugName}`);return}for(const P of this.b)m.updateObserver(P,this),P.handleChange(this,u)}get(){}}function $(M,m,u){const P=(0,C.$3d)("debounced",void 0);let A;return u.add((0,j.$jd)(z=>{const W=M.read(z);A&&clearTimeout(A),A=setTimeout(()=>{(0,C.$Xd)(H=>{P.set(W,H)})},m)})),P}function O(M,m){let u=!1,P,A;return g(z=>{const W=(0,j.$jd)(H=>{const V=M.read(H);u?(A&&clearTimeout(A),A=setTimeout(()=>{P=V,z()},m)):(u=!0,P=V)});return{dispose(){W.dispose(),u=!1,P=void 0}}},()=>u?P:M.get())}function S(M,m,u){const P=(0,C.$3d)("triggeredRecently",!1);let A;return u.add(M(()=>{P.set(!0,void 0),A&&clearTimeout(A),A=setTimeout(()=>{P.set(!1,void 0)},m)})),P}function E(M){const m=new b(!1,void 0);return M.addObserver(m),(0,w.$Sc)(()=>{M.removeObserver(m)})}(0,C.$Td)(E);function I(M,m){const u=new b(!0,m);return M.addObserver(u),m?m(M.get()):M.reportChanges(),(0,w.$Sc)(()=>{M.removeObserver(u)})}(0,C.$Sd)(I);class b{constructor(m,u){this.b=m,this.c=u,this.a=0}beginUpdate(m){this.a++}endUpdate(m){this.a--,this.a===0&&this.b&&(this.c?this.c(m.get()):m.reportChanges())}handlePossibleChange(m){}handleChange(m,u){}}e.$Bd=b;function v(M,m){let u;return(0,h.$Kd)(M,A=>(u=m(A,u),u))}function y(M,m){let u;const P=n("derivedObservableWithWritableCache"),A=(0,h.$Kd)(M,z=>(P.read(z),u=m(z,u),u));return Object.assign(A,{clearCache:z=>{u=void 0,P.trigger(z)},setCache:(z,W)=>{u=z,P.trigger(W)}})}function D(M,m,u,P){let A=new q(u,P);return(0,h.$Md)({debugReferenceFn:u,owner:M,onLastObserverRemoved:()=>{A.dispose(),A=new q(u)}},W=>(A.setItems(m.read(W)),A.getItems()))}class q{constructor(m,u){this.c=m,this.e=u,this.a=new Map,this.b=[]}dispose(){this.a.forEach(m=>m.store.dispose()),this.a.clear()}setItems(m){const u=[],P=new Set(this.a.keys());for(const A of m){const z=this.e?this.e(A):A;let W=this.a.get(z);if(W)P.delete(z);else{const H=new w.$Tc;W={out:this.c(A,H),store:H},this.a.set(z,W)}u.push(W.out)}for(const A of P)this.a.get(A).store.dispose(),this.a.delete(A);this.b=u}getItems(){return this.b}}class F{constructor(m){this.observable=m}get onDidChange(){return L.Event.fromObservableLight(this.observable)}get value(){return this.observable.get()}}e.$Fd=F;function k(M,m){return m instanceof F?m.observable:g(m.onDidChange,()=>m.value)}}),define(K[16],G([0,1,6,10,9,32,30,5]),function(B,e,L,w,j,C,s,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.derivedWithCancellationToken=e.waitForState=e.PromiseResult=e.ObservablePromise=e.ObservableLazyPromise=e.ObservableLazy=e.wasEventTriggeredRecently=e.observableSignalFromEvent=e.observableSignal=e.observableFromPromise=e.observableFromEvent=e.recomputeInitiallyAndOnChange=e.keepObserved=e.derivedObservableWithWritableCache=e.derivedObservableWithCache=e.debouncedObservable=e.constObservable=e.autorunWithStoreHandleChanges=e.autorunOpts=e.autorunWithStore=e.autorunHandleChanges=e.autorunDelta=e.autorun=e.derivedWithStore=e.derivedHandleChanges=e.derivedOpts=e.derived=e.subtransaction=e.transaction=e.disposableObservableValue=e.observableValue=void 0,Object.defineProperty(e,"observableValue",{enumerable:!0,get:function(){return L.$3d}}),Object.defineProperty(e,"disposableObservableValue",{enumerable:!0,get:function(){return L.$6d}}),Object.defineProperty(e,"transaction",{enumerable:!0,get:function(){return L.$Xd}}),Object.defineProperty(e,"subtransaction",{enumerable:!0,get:function(){return L.$1d}}),Object.defineProperty(e,"derived",{enumerable:!0,get:function(){return w.$Kd}}),Object.defineProperty(e,"derivedOpts",{enumerable:!0,get:function(){return w.$Md}}),Object.defineProperty(e,"derivedHandleChanges",{enumerable:!0,get:function(){return w.$Nd}}),Object.defineProperty(e,"derivedWithStore",{enumerable:!0,get:function(){return w.$Od}}),Object.defineProperty(e,"autorun",{enumerable:!0,get:function(){return j.$jd}}),Object.defineProperty(e,"autorunDelta",{enumerable:!0,get:function(){return j.$od}}),Object.defineProperty(e,"autorunHandleChanges",{enumerable:!0,get:function(){return j.$ld}}),Object.defineProperty(e,"autorunWithStore",{enumerable:!0,get:function(){return j.$nd}}),Object.defineProperty(e,"autorunOpts",{enumerable:!0,get:function(){return j.$kd}}),Object.defineProperty(e,"autorunWithStoreHandleChanges",{enumerable:!0,get:function(){return j.$md}}),Object.defineProperty(e,"constObservable",{enumerable:!0,get:function(){return C.$qd}}),Object.defineProperty(e,"debouncedObservable",{enumerable:!0,get:function(){return C.$wd}}),Object.defineProperty(e,"derivedObservableWithCache",{enumerable:!0,get:function(){return C.$Cd}}),Object.defineProperty(e,"derivedObservableWithWritableCache",{enumerable:!0,get:function(){return C.$Dd}}),Object.defineProperty(e,"keepObserved",{enumerable:!0,get:function(){return C.$zd}}),Object.defineProperty(e,"recomputeInitiallyAndOnChange",{enumerable:!0,get:function(){return C.$Ad}}),Object.defineProperty(e,"observableFromEvent",{enumerable:!0,get:function(){return C.$sd}}),Object.defineProperty(e,"observableFromPromise",{enumerable:!0,get:function(){return C.$rd}}),Object.defineProperty(e,"observableSignal",{enumerable:!0,get:function(){return C.$vd}}),Object.defineProperty(e,"observableSignalFromEvent",{enumerable:!0,get:function(){return C.$ud}}),Object.defineProperty(e,"wasEventTriggeredRecently",{enumerable:!0,get:function(){return C.$yd}}),Object.defineProperty(e,"ObservableLazy",{enumerable:!0,get:function(){return s.$8d}}),Object.defineProperty(e,"ObservableLazyPromise",{enumerable:!0,get:function(){return s.$$d}}),Object.defineProperty(e,"ObservablePromise",{enumerable:!0,get:function(){return s.$9d}}),Object.defineProperty(e,"PromiseResult",{enumerable:!0,get:function(){return s.$0d}}),Object.defineProperty(e,"waitForState",{enumerable:!0,get:function(){return s.$_d}}),Object.defineProperty(e,"derivedWithCancellationToken",{enumerable:!0,get:function(){return s.$ae}}),!1&&(0,h.$Hd)(new h.$Jd)}),define(K[33],G([0,1,7,2]),function(B,e,L,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ue=j,e.$ve=C,e.$we=s,e.$xe=h,e.$ye=d,e.$ze=f,e.$Ae=l,e.$Be=g,e.$Ce=o,e.$De=i,e.$Ee=t,e.$Fe=n,e.$Ge=r,e.$He=$,e.$Ie=O;function j(S){const E=S;return E?typeof E.read=="function":!1}function C(S){const E=S;return E?[E.on,E.pause,E.resume,E.destroy].every(I=>typeof I=="function"):!1}function s(S){const E=S;return E?C(E.stream)&&Array.isArray(E.buffer)&&typeof E.ended=="boolean":!1}function h(S,E){return new a(S,E)}class a{constructor(E,I){this.e=E,this.f=I,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(E){if(!this.a.destroyed){if(this.a.flowing)this.g(E);else if(this.b.data.push(E),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(I=>this.d.push(I))}}error(E){this.a.destroyed||(this.a.flowing?this.h(E):this.b.error.push(E))}end(E){this.a.destroyed||(typeof E<"u"&&this.write(E),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(E){this.c.data.slice(0).forEach(I=>I(E))}h(E){this.c.error.length===0?(0,L.$1)(E):this.c.error.slice(0).forEach(I=>I(E))}i(){this.c.end.slice(0).forEach(E=>E())}on(E,I){if(!this.a.destroyed)switch(E){case"data":this.c.data.push(I),this.resume();break;case"end":this.c.end.push(I),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(I),this.a.flowing&&this.k();break}}removeListener(E,I){if(this.a.destroyed)return;let b;switch(E){case"data":b=this.c.data;break;case"end":b=this.c.end;break;case"error":b=this.c.error;break}if(b){const v=b.indexOf(I);v>=0&&b.splice(v,1)}}j(){if(this.b.data.length>0){const E=this.e(this.b.data);this.g(E),this.b.data.length=0;const I=[...this.d];this.d.length=0,I.forEach(b=>b())}}k(){if(this.c.error.length>0){for(const E of this.b.error)this.h(E);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function d(S,E){const I=[];let b;for(;(b=S.read())!==null;)I.push(b);return E(I)}function f(S,E,I){const b=[];let v;for(;(v=S.read())!==null&&b.length<I;)b.push(v);return v===null&&b.length>0?E(b):{read:()=>{if(b.length>0)return b.shift();if(typeof v<"u"){const y=v;return v=void 0,y}return S.read()}}}function l(S,E){return new Promise((I,b)=>{const v=[];g(S,{onData:y=>{E&&v.push(y)},onError:y=>{E?b(y):I(void 0)},onEnd:()=>{I(E?E(v):void 0)}})})}function g(S,E,I){S.on("error",b=>{I?.isCancellationRequested||E.onError(b)}),S.on("end",()=>{I?.isCancellationRequested||E.onEnd()}),S.on("data",b=>{I?.isCancellationRequested||E.onData(b)})}function o(S,E){return new Promise((I,b)=>{const v=new w.$Tc,y=[],D=k=>{if(y.push(k),y.length>E)return v.dispose(),S.pause(),I({stream:S,buffer:y,ended:!1})},q=k=>(v.dispose(),b(k)),F=()=>(v.dispose(),I({stream:S,buffer:y,ended:!0}));v.add((0,w.$Sc)(()=>S.removeListener("error",q))),S.on("error",q),v.add((0,w.$Sc)(()=>S.removeListener("end",F))),S.on("end",F),v.add((0,w.$Sc)(()=>S.removeListener("data",D))),S.on("data",D)})}function i(S,E){const I=h(E);return I.end(S),I}function t(){const S=h(()=>{throw new Error("not supported")});return S.end(),S}function n(S){let E=!1;return{read:()=>E?null:(E=!0,S)}}function r(S,E,I){const b=h(I);return g(S,{onData:v=>b.write(E.data(v)),onError:v=>b.error(E.error?E.error(v):v),onEnd:()=>b.end()}),b}function $(S,E,I){let b=!1;return{read:()=>{const v=E.read();return b?v:(b=!0,v!==null?I([S,v]):S)}}}function O(S,E,I){let b=!1;const v=h(I);return g(E,{onData:y=>b?v.write(y):(b=!0,v.write(I([S,y]))),onError:y=>v.error(y),onEnd:()=>{b||(b=!0,v.write(S)),v.end()}}),v}}),define(K[17],G([0,1,34,33]),function(B,e,L,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Je=void 0,e.$Ke=d,e.$Le=f,e.$Me=l,e.$Ne=g,e.$Oe=o,e.$Pe=i,e.$Qe=t,e.$Re=n,e.$Se=r,e.$Te=$,e.$Ue=O,e.$Ve=S,e.$We=E,e.$Xe=I,e.$Ye=b,e.$Ze=v,e.$1e=y,e.$2e=D,e.$3e=q,e.$4e=M;const j=typeof Buffer<"u",C=new L.$V(()=>new Uint8Array(256));let s,h;class a{static alloc(u){return j?new a(Buffer.allocUnsafe(u)):new a(new Uint8Array(u))}static wrap(u){return j&&!Buffer.isBuffer(u)&&(u=Buffer.from(u.buffer,u.byteOffset,u.byteLength)),new a(u)}static fromString(u,P){return!(P?.dontUseNodeBuffer||!1)&&j?new a(Buffer.from(u)):(s||(s=new TextEncoder),new a(s.encode(u)))}static fromByteArray(u){const P=a.alloc(u.length);for(let A=0,z=u.length;A<z;A++)P.buffer[A]=u[A];return P}static concat(u,P){if(typeof P>"u"){P=0;for(let W=0,H=u.length;W<H;W++)P+=u[W].byteLength}const A=a.alloc(P);let z=0;for(let W=0,H=u.length;W<H;W++){const V=u[W];A.set(V,z),z+=V.byteLength}return A}constructor(u){this.buffer=u,this.byteLength=this.buffer.byteLength}clone(){const u=a.alloc(this.byteLength);return u.set(this),u}toString(){return j?this.buffer.toString():(h||(h=new TextDecoder),h.decode(this.buffer))}slice(u,P){return new a(this.buffer.subarray(u,P))}set(u,P){if(u instanceof a)this.buffer.set(u.buffer,P);else if(u instanceof Uint8Array)this.buffer.set(u,P);else if(u instanceof ArrayBuffer)this.buffer.set(new Uint8Array(u),P);else if(ArrayBuffer.isView(u))this.buffer.set(new Uint8Array(u.buffer,u.byteOffset,u.byteLength),P);else throw new Error("Unknown argument 'array'")}readUInt32BE(u){return g(this.buffer,u)}writeUInt32BE(u,P){o(this.buffer,u,P)}readUInt32LE(u){return i(this.buffer,u)}writeUInt32LE(u,P){t(this.buffer,u,P)}readUInt8(u){return n(this.buffer,u)}writeUInt8(u,P){r(this.buffer,u,P)}indexOf(u,P=0){return d(this.buffer,u instanceof a?u.buffer:u,P)}}e.$Je=a;function d(m,u,P=0){const A=u.byteLength,z=m.byteLength;if(A===0)return 0;if(A===1)return m.indexOf(u[0]);if(A>z-P)return-1;const W=C.value;W.fill(u.length);for(let _=0;_<u.length;_++)W[u[_]]=u.length-_-1;let H=P+u.length-1,V=H,Z=-1;for(;H<z;)if(m[H]===u[V]){if(V===0){Z=H;break}H--,V--}else H+=Math.max(u.length-V,W[m[H]]),V=u.length-1;return Z}function f(m,u){return m[u+0]<<0>>>0|m[u+1]<<8>>>0}function l(m,u,P){m[P+0]=u&255,u=u>>>8,m[P+1]=u&255}function g(m,u){return m[u]*2**24+m[u+1]*2**16+m[u+2]*2**8+m[u+3]}function o(m,u,P){m[P+3]=u,u=u>>>8,m[P+2]=u,u=u>>>8,m[P+1]=u,u=u>>>8,m[P]=u}function i(m,u){return m[u+0]<<0>>>0|m[u+1]<<8>>>0|m[u+2]<<16>>>0|m[u+3]<<24>>>0}function t(m,u,P){m[P+0]=u&255,u=u>>>8,m[P+1]=u&255,u=u>>>8,m[P+2]=u&255,u=u>>>8,m[P+3]=u&255}function n(m,u){return m[u]}function r(m,u,P){m[P]=u}function $(m){return w.$ye(m,u=>a.concat(u))}function O(m){return w.$Fe(m)}function S(m){return w.$Ae(m,u=>a.concat(u))}async function E(m){return m.ended?a.concat(m.buffer):a.concat([...m.buffer,await S(m.stream)])}function I(m){return w.$De(m,u=>a.concat(u))}function b(m){return w.$Ge(m,{data:u=>typeof u=="string"?a.fromString(u):a.wrap(u)},u=>a.concat(u))}function v(m){return w.$xe(u=>a.concat(u),m)}function y(m,u){return w.$He(m,u,P=>a.concat(P))}function D(m,u){return w.$Ie(m,u,P=>a.concat(P))}function q(m){let u=0,P=0,A=0;const z=new Uint8Array(Math.floor(m.length/4*3)),W=V=>{switch(P){case 3:z[A++]=u|V,P=0;break;case 2:z[A++]=u|V>>>2,u=V<<6,P=3;break;case 1:z[A++]=u|V>>>4,u=V<<4,P=2;break;default:u=V<<2,P=1}};for(let V=0;V<m.length;V++){const Z=m.charCodeAt(V);if(Z>=65&&Z<=90)W(Z-65);else if(Z>=97&&Z<=122)W(Z-97+26);else if(Z>=48&&Z<=57)W(Z-48+52);else if(Z===43||Z===45)W(62);else if(Z===47||Z===95)W(63);else{if(Z===61)break;throw new SyntaxError(`Unexpected base64 character ${m[V]}`)}}const H=A;for(;P>0;)W(0);return a.wrap(z).slice(0,H)}const F="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",k="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function M({buffer:m},u=!0,P=!1){const A=P?k:F;let z="";const W=m.byteLength%3;let H=0;for(;H<m.byteLength-W;H+=3){const V=m[H+0],Z=m[H+1],_=m[H+2];z+=A[V>>>2],z+=A[(V<<4|Z>>>4)&63],z+=A[(Z<<2|_>>>6)&63],z+=A[_&63]}if(W===1){const V=m[H+0];z+=A[V>>>2],z+=A[V<<4&63],u&&(z+="==")}else if(W===2){const V=m[H+0],Z=m[H+1];z+=A[V>>>2],z+=A[(V<<4|Z>>>4)&63],z+=A[Z<<2&63],u&&(z+="=")}return z}}),define(K[35],G([0,1]),function(B,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ce=void 0,e.$ce=Symbol("MicrotaskDelay")}),define(K[18],G([0,1,19]),function(B,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringEOL=void 0,e.$iv=j;var w;(function(C){C[C.Unknown=0]="Unknown",C[C.Invalid=3]="Invalid",C[C.LF=1]="LF",C[C.CRLF=2]="CRLF"})(w||(e.StringEOL=w={}));function j(C){let s=0,h=0,a=0,d=w.Unknown;for(let f=0,l=C.length;f<l;f++){const g=C.charCodeAt(f);g===L.CharCode.CarriageReturn?(s===0&&(h=f),s++,f+1<l&&C.charCodeAt(f+1)===L.CharCode.LineFeed?(d|=w.CRLF,f++):d|=w.Invalid,a=f+1):g===L.CharCode.LineFeed&&(d|=w.LF,s===0&&(h=f),s++,a=f+1)}return s===0&&(h=C.length),[s,h,C.length-a,d]}}),define(K[36],G([0,1,14]),function(B,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bD=void 0;class w{constructor(s){this.b=s,this.a=[]}get(s){return s<this.a.length?this.a[s]:this.b}set(s,h){for(;s>=this.a.length;)this.a[this.a.length]=this.b;this.a[s]=h}replace(s,h,a){if(s>=this.a.length)return;if(h===0){this.insert(s,a);return}else if(a===0){this.delete(s,h);return}const d=this.a.slice(0,s),f=this.a.slice(s+h),l=j(a,this.b);this.a=d.concat(l,f)}delete(s,h){h===0||s>=this.a.length||this.a.splice(s,h)}insert(s,h){if(h===0||s>=this.a.length)return;const a=[];for(let d=0;d<h;d++)a[d]=this.b;this.a=(0,L.$Vb)(this.a,s,a)}}e.$bD=w;function j(C,s){const h=[];for(let a=0;a<C;a++)h[a]=s;return h}}),define(K[11],G([0,1,12]),function(B,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xt=void 0;class w{static{this.defaultTokenMetadata=(L.FontStyle.None<<L.MetadataConsts.FONT_STYLE_OFFSET|L.ColorId.DefaultForeground<<L.MetadataConsts.FOREGROUND_OFFSET|L.ColorId.DefaultBackground<<L.MetadataConsts.BACKGROUND_OFFSET)>>>0}static createEmpty(s,h){const a=w.defaultTokenMetadata,d=new Uint32Array(2);return d[0]=s.length,d[1]=a,new w(d,s,h)}constructor(s,h,a){this._lineTokensBrand=void 0,this.a=s,this.b=this.a.length>>>1,this.c=h,this.d=a}equals(s){return s instanceof w?this.slicedEquals(s,0,this.b):!1}slicedEquals(s,h,a){if(this.c!==s.c||this.b!==s.b)return!1;const d=h<<1,f=d+(a<<1);for(let l=d;l<f;l++)if(this.a[l]!==s.a[l])return!1;return!0}getLineContent(){return this.c}getCount(){return this.b}getStartOffset(s){return s>0?this.a[s-1<<1]:0}getMetadata(s){return this.a[(s<<1)+1]}getLanguageId(s){const h=this.a[(s<<1)+1],a=L.$ft.getLanguageId(h);return this.d.decodeLanguageId(a)}getStandardTokenType(s){const h=this.a[(s<<1)+1];return L.$ft.getTokenType(h)}getForeground(s){const h=this.a[(s<<1)+1];return L.$ft.getForeground(h)}getClassName(s){const h=this.a[(s<<1)+1];return L.$ft.getClassNameFromMetadata(h)}getInlineStyle(s,h){const a=this.a[(s<<1)+1];return L.$ft.getInlineStyleFromMetadata(a,h)}getPresentation(s){const h=this.a[(s<<1)+1];return L.$ft.getPresentationFromMetadata(h)}getEndOffset(s){return this.a[s<<1]}findTokenIndexAtOffset(s){return w.findIndexInTokensArray(this.a,s)}inflate(){return this}sliceAndInflate(s,h,a){return new j(this,s,h,a)}static convertToEndOffset(s,h){const d=(s.length>>>1)-1;for(let f=0;f<d;f++)s[f<<1]=s[f+1<<1];s[d<<1]=h}static findIndexInTokensArray(s,h){if(s.length<=2)return 0;let a=0,d=(s.length>>>1)-1;for(;a<d;){const f=a+Math.floor((d-a)/2),l=s[f<<1];if(l===h)return f+1;l<h?a=f+1:l>h&&(d=f)}return a}withInserted(s){if(s.length===0)return this;let h=0,a=0,d="";const f=new Array;let l=0;for(;;){const g=h<this.b?this.a[h<<1]:-1,o=a<s.length?s[a]:null;if(g!==-1&&(o===null||g<=o.offset)){d+=this.c.substring(l,g);const i=this.a[(h<<1)+1];f.push(d.length,i),h++,l=g}else if(o){if(o.offset>l){d+=this.c.substring(l,o.offset);const i=this.a[(h<<1)+1];f.push(d.length,i),l=o.offset}d+=o.text,f.push(d.length,o.tokenMetadata),a++}else break}return new w(new Uint32Array(f),d,this.d)}}e.$xt=w;class j{constructor(s,h,a,d){this.a=s,this.b=h,this.c=a,this.d=d,this.e=s.findTokenIndexAtOffset(h),this.f=0;for(let f=this.e,l=s.getCount();f<l&&!(s.getStartOffset(f)>=a);f++)this.f++}getMetadata(s){return this.a.getMetadata(this.e+s)}getLanguageId(s){return this.a.getLanguageId(this.e+s)}getLineContent(){return this.a.getLineContent().substring(this.b,this.c)}equals(s){return s instanceof j?this.b===s.b&&this.c===s.c&&this.d===s.d&&this.a.slicedEquals(s.a,this.e,this.f):!1}getCount(){return this.f}getForeground(s){return this.a.getForeground(this.e+s)}getEndOffset(s){const h=this.a.getEndOffset(this.e+s);return Math.min(this.c,h)-this.b+this.d}getClassName(s){return this.a.getClassName(this.e+s)}getInlineStyle(s,h){return this.a.getInlineStyle(this.e+s,h)}getPresentation(s){return this.a.getPresentation(this.e+s)}findTokenIndexAtOffset(s){return this.a.findTokenIndexAtOffset(s+this.b-this.d)-this.e}}}),define(K[37],G([0,1,11]),function(B,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yv=e.$xv=void 0,e.$zv=j,e.$xv=new Uint32Array(0).buffer;class w{static deleteBeginning(s,h){return s===null||s===e.$xv?s:w.delete(s,0,h)}static deleteEnding(s,h){if(s===null||s===e.$xv)return s;const a=j(s),d=a[a.length-2];return w.delete(s,h,d)}static delete(s,h,a){if(s===null||s===e.$xv||h===a)return s;const d=j(s),f=d.length>>>1;if(h===0&&d[d.length-2]===a)return e.$xv;const l=L.$xt.findIndexInTokensArray(d,h),g=l>0?d[l-1<<1]:0,o=d[l<<1];if(a<o){const $=a-h;for(let O=l;O<f;O++)d[O<<1]-=$;return s}let i,t;g!==h?(d[l<<1]=h,i=l+1<<1,t=h):(i=l<<1,t=g);const n=a-h;for(let $=l+1;$<f;$++){const O=d[$<<1]-n;O>t&&(d[i++]=O,d[i++]=d[($<<1)+1],t=O)}if(i===d.length)return s;const r=new Uint32Array(i);return r.set(d.subarray(0,i),0),r.buffer}static append(s,h){if(h===e.$xv)return s;if(s===e.$xv)return h;if(s===null)return s;if(h===null)return null;const a=j(s),d=j(h),f=d.length>>>1,l=new Uint32Array(a.length+d.length);l.set(a,0);let g=a.length;const o=a[a.length-2];for(let i=0;i<f;i++)l[g++]=d[i<<1]+o,l[g++]=d[(i<<1)+1];return l.buffer}static insert(s,h,a){if(s===null||s===e.$xv)return s;const d=j(s),f=d.length>>>1;let l=L.$xt.findIndexInTokensArray(d,h);l>0&&d[l-1<<1]===h&&l--;for(let g=l;g<f;g++)d[g<<1]+=a;return s}}e.$yv=w;function j(C){return C instanceof Uint32Array?C:new Uint32Array(C)}}),define(K[38],G([0,1,14,17,49,18,37,20]),function(B,e,L,w,j,C,s,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ev=void 0;class a{static deserialize(f,l,g){const o=new Uint32Array(f.buffer),i=(0,w.$Ne)(f,l);l+=4;const t=(0,w.$Ne)(f,l);l+=4;const n=[];for(let r=0;r<t;r++){const $=(0,w.$Ne)(f,l);l+=4,n.push(o.subarray(l/4,l/4+$/4)),l+=$}return g.push(new a(i,n)),l}get startLineNumber(){return this.a}get endLineNumber(){return this.a+this.b.length-1}constructor(f,l){this.a=f,this.b=l}getLineRange(){return new h.$Cv(this.a,this.a+this.b.length)}getLineTokens(f){return this.b[f-this.a]}appendLineTokens(f){this.b.push(f)}serializeSize(){let f=0;f+=4,f+=4;for(let l=0;l<this.b.length;l++){const g=this.b[l];if(!(g instanceof Uint32Array))throw new Error("Not supported!");f+=4,f+=g.byteLength}return f}serialize(f,l){(0,w.$Oe)(f,this.a,l),l+=4,(0,w.$Oe)(f,this.b.length,l),l+=4;for(let g=0;g<this.b.length;g++){const o=this.b[g];if(!(o instanceof Uint32Array))throw new Error("Not supported!");(0,w.$Oe)(f,o.byteLength,l),l+=4,f.set(new Uint8Array(o.buffer),l),l+=o.byteLength}return l}applyEdit(f,l){const[g,o]=(0,C.$iv)(l);this.c(f),this.d(new j.$bt(f.startLineNumber,f.startColumn),g,o)}c(f){if(f.startLineNumber===f.endLineNumber&&f.startColumn===f.endColumn)return;const l=f.startLineNumber-this.a,g=f.endLineNumber-this.a;if(g<0){const o=g-l;this.a-=o;return}if(!(l>=this.b.length)){if(l<0&&g>=this.b.length){this.a=0,this.b=[];return}if(l===g){this.b[l]=s.$yv.delete(this.b[l],f.startColumn-1,f.endColumn-1);return}if(l>=0)if(this.b[l]=s.$yv.deleteEnding(this.b[l],f.startColumn-1),g<this.b.length){const o=s.$yv.deleteBeginning(this.b[g],f.endColumn-1);this.b[l]=s.$yv.append(this.b[l],o),this.b.splice(l+1,g-l)}else this.b[l]=s.$yv.append(this.b[l],null),this.b=this.b.slice(0,l+1);else{const o=-l;this.a-=o,this.b[g]=s.$yv.deleteBeginning(this.b[g],f.endColumn-1),this.b=this.b.slice(g)}}}d(f,l,g){if(l===0&&g===0)return;const o=f.lineNumber-this.a;if(o<0){this.a+=l;return}if(!(o>=this.b.length)){if(l===0){this.b[o]=s.$yv.insert(this.b[o],f.column-1,g);return}this.b[o]=s.$yv.deleteEnding(this.b[o],f.column-1),this.b[o]=s.$yv.insert(this.b[o],f.column-1,g),this.e(f.lineNumber,l)}}e(f,l){if(l===0)return;const g=[];for(let o=0;o<l;o++)g[o]=null;this.b=L.$Vb(this.b,f,g)}}e.$Ev=a}),define(K[21],G([0,1,17,38]),function(B,e,L,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cD=void 0;class j{static deserialize(s){let h=0;const a=(0,L.$Ne)(s,h);h+=4;const d=[];for(let f=0;f<a;f++)h=w.$Ev.deserialize(s,h,d);return d}constructor(){this.a=[]}add(s,h){if(this.a.length>0){const a=this.a[this.a.length-1];if(a.endLineNumber+1===s){a.appendLineTokens(h);return}}this.a.push(new w.$Ev(s,[h]))}finalize(){return this.a}serialize(){const s=this.b(),h=new Uint8Array(s);return this.c(h),h}b(){let s=0;s+=4;for(let h=0;h<this.a.length;h++)s+=this.a[h].serializeSize();return s}c(s){let h=0;(0,L.$Oe)(s,this.a.length,h),h+=4;for(let a=0;a<this.a.length;a++)h=this.a[a].serialize(s,h)}}e.$cD=j}),define(K[39],G([0,1,19,22,3,23,50]),function(B,e,L,w,j,C,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sg=h,e.$tg=a,e.$ug=d,e.$vg=f,e.$wg=l,e.$xg=t,e.$yg=n,e.$zg=r,e.$Ag=$,e.$Bg=O,e.$Cg=S,e.$Dg=E,e.$Eg=I,e.$Fg=b,e.$Gg=v,e.$Hg=y,e.$Ig=F;function h(k){return k===L.CharCode.Slash||k===L.CharCode.Backslash}function a(k){return k.replace(/[\\/]/g,w.$gc.sep)}function d(k){return k.indexOf("/")===-1&&(k=a(k)),/^[a-zA-Z]:(\/|$)/.test(k)&&(k="/"+k),k}function f(k,M=w.$gc.sep){if(!k)return"";const m=k.length,u=k.charCodeAt(0);if(h(u)){if(h(k.charCodeAt(1))&&!h(k.charCodeAt(2))){let A=3;const z=A;for(;A<m&&!h(k.charCodeAt(A));A++);if(z!==A&&!h(k.charCodeAt(A+1))){for(A+=1;A<m;A++)if(h(k.charCodeAt(A)))return k.slice(0,A+1).replace(/[\\/]/g,M)}}return M}else if($(u)&&k.charCodeAt(1)===L.CharCode.Colon)return h(k.charCodeAt(2))?k.slice(0,2)+M:k.slice(0,2);let P=k.indexOf("://");if(P!==-1){for(P+=3;P<m;P++)if(h(k.charCodeAt(P)))return k.slice(0,P+1)}return""}function l(k){if(!j.$i||!k||k.length<5)return!1;let M=k.charCodeAt(0);if(M!==L.CharCode.Backslash||(M=k.charCodeAt(1),M!==L.CharCode.Backslash))return!1;let m=2;const u=m;for(;m<k.length&&(M=k.charCodeAt(m),M!==L.CharCode.Backslash);m++);return!(u===m||(M=k.charCodeAt(m+1),isNaN(M)||M===L.CharCode.Backslash))}const g=/[\\/:\*\?"<>\|]/g,o=/[/]/g,i=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function t(k,M=j.$i){const m=M?g:o;return!(!k||k.length===0||/^\s+$/.test(k)||(m.lastIndex=0,m.test(k))||M&&i.test(k)||k==="."||k===".."||M&&k[k.length-1]==="."||M&&k.length!==k.trim().length||k.length>255)}function n(k,M,m){const u=k===M;return!m||u?u:!k||!M?!1:(0,C.$Bf)(k,M)}function r(k,M,m,u=w.sep){if(k===M)return!0;if(!k||!M||M.length>k.length)return!1;if(m){if(!(0,C.$Cf)(k,M))return!1;if(M.length===k.length)return!0;let A=M.length;return M.charAt(M.length-1)===u&&A--,k.charAt(A)===u}return M.charAt(M.length-1)!==u&&(M+=u),k.indexOf(M)===0}function $(k){return k>=L.CharCode.A&&k<=L.CharCode.Z||k>=L.CharCode.a&&k<=L.CharCode.z}function O(k,M){return j.$i&&k.endsWith(":")&&(k+=w.sep),(0,w.$ic)(k)||(k=(0,w.$jc)(M,k)),k=(0,w.$hc)(k),S(k)}function S(k){return j.$i?(k=(0,C.$jf)(k,w.sep),k.endsWith(":")&&(k+=w.sep)):(k=(0,C.$jf)(k,w.sep),k||(k=w.sep)),k}function E(k){const M=(0,w.$hc)(k);return j.$i?k.length>3?!1:I(M)&&(k.length===2||M.charCodeAt(2)===L.CharCode.Backslash):M===w.$gc.sep}function I(k,M=j.$i){return M?$(k.charCodeAt(0))&&k.charCodeAt(1)===L.CharCode.Colon:!1}function b(k,M=j.$i){return I(k,M)?k[0]:void 0}function v(k,M,m){return M.length>k.length?-1:k===M?0:(m&&(k=k.toLowerCase(),M=M.toLowerCase()),k.indexOf(M))}function y(k){const M=k.split(":");let m,u,P;for(const A of M){const z=Number(A);(0,s.$eg)(z)?u===void 0?u=z:P===void 0&&(P=z):m=m?[m,A].join(":"):A}if(!m)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:m,line:u!==void 0?u:void 0,column:P!==void 0?P:u!==void 0?1:void 0}}const D="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",q="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function F(k,M,m=8){let u="";for(let A=0;A<m;A++){let z;A===0&&j.$i&&!M&&(m===3||m===4)?z=q:z=D,u+=z.charAt(Math.floor(Math.random()*z.length))}let P;return M?P=`${M}-${u}`:P=u,k?(0,w.$jc)(k,P):P}}),define(K[24],G([0,1,7,3,23,13,22]),function(B,e,L,w,j,C,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Qg=e.$Pg=e.$Ng=e.$Mg=e.$Lg=e.Schemas=void 0,e.$Jg=a,e.$Kg=d,e.$Og=l;var h;(function(i){i.inMemory="inmemory",i.vscode="vscode",i.internal="private",i.walkThrough="walkThrough",i.walkThroughSnippet="walkThroughSnippet",i.http="http",i.https="https",i.file="file",i.mailto="mailto",i.untitled="untitled",i.data="data",i.command="command",i.vscodeRemote="vscode-remote",i.vscodeRemoteResource="vscode-remote-resource",i.vscodeManagedRemoteResource="vscode-managed-remote-resource",i.vscodeUserData="vscode-userdata",i.vscodeCustomEditor="vscode-custom-editor",i.vscodeNotebookCell="vscode-notebook-cell",i.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",i.vscodeNotebookCellOutput="vscode-notebook-cell-output",i.vscodeInteractiveInput="vscode-interactive-input",i.vscodeSettings="vscode-settings",i.vscodeWorkspaceTrust="vscode-workspace-trust",i.vscodeTerminal="vscode-terminal",i.vscodeChatCodeBlock="vscode-chat-code-block",i.vscodeChatCodeCompareBlock="vscode-chat-code-compare-block",i.vscodeChatSesssion="vscode-chat-editor",i.webviewPanel="webview-panel",i.vscodeWebview="vscode-webview",i.extension="extension",i.vscodeFileResource="vscode-file",i.tmp="tmp",i.vsls="vsls",i.vscodeSourceControl="vscode-scm",i.commentsInput="comment",i.codeSetting="code-setting"})(h||(e.Schemas=h={}));function a(i,t){return C.URI.isUri(i)?(0,j.$Bf)(i.scheme,t):(0,j.$Cf)(i,t+":")}function d(i,...t){return t.some(n=>a(i,n))}e.$Lg="vscode-tkn",e.$Mg="tkn";class f{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f="/"}setPreferredWebSchema(t){this.d=t}setDelegate(t){this.e=t}setServerRootPath(t,n){this.f=l(t,n)}getServerRootPath(){return this.f}get g(){return s.$gc.join(this.f,h.vscodeRemoteResource)}set(t,n,r){this.a[t]=n,this.b[t]=r}setConnectionToken(t,n){this.c[t]=n}getPreferredWebSchema(){return this.d}rewrite(t){if(this.e)try{return this.e(t)}catch(E){return L.$1(E),t}const n=t.authority;let r=this.a[n];r&&r.indexOf(":")!==-1&&r.indexOf("[")===-1&&(r=`[${r}]`);const $=this.b[n],O=this.c[n];let S=`path=${encodeURIComponent(t.path)}`;return typeof O=="string"&&(S+=`&${e.$Mg}=${encodeURIComponent(O)}`),C.URI.from({scheme:w.$o?this.d:h.vscodeRemoteResource,authority:`${r}:${$}`,path:this.g,query:S})}}e.$Ng=new f;function l(i,t){return s.$gc.join(t??"/",`${i.quality??"oss"}-${i.commit??"dev"}`)}e.$Pg="vs/../../extensions",e.$Qg="vs/../../node_modules",e.$Rg="vs/../../node_modules.asar",e.$Sg="vs/../../node_modules.asar.unpacked",e.$Tg="vscode-app";class g{static{this.a=e.$Tg}asBrowserUri(t){const n=this.b(t,B);return this.uriToBrowserUri(n)}uriToBrowserUri(t){return t.scheme===h.vscodeRemote?e.$Ng.rewrite(t):t.scheme===h.file&&(w.$m||w.$q===`${h.vscodeFileResource}://${g.a}`)?t.with({scheme:h.vscodeFileResource,authority:t.authority||g.a,query:null,fragment:null}):t}asFileUri(t){const n=this.b(t,B);return this.uriToFileUri(n)}uriToFileUri(t){return t.scheme===h.vscodeFileResource?t.with({scheme:h.file,authority:t.authority!==g.a?t.authority:null,query:null,fragment:null}):t}b(t,n){return C.URI.isUri(t)?t:C.URI.parse(n.toUrl(t))}}e.$Ug=new g;var o;(function(i){const t=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);i.CoopAndCoep=Object.freeze(t.get("3"));const n="vscode-coi";function r(O){let S;typeof O=="string"?S=new URL(O).searchParams:O instanceof URL?S=O.searchParams:C.URI.isUri(O)&&(S=new URL(O.toString(!0)).searchParams);const E=S?.get(n);if(E)return t.get(E)}i.getHeadersFromQuery=r;function $(O,S,E){if(!globalThis.crossOriginIsolated)return;const I=S&&E?"3":E?"2":"1";O instanceof URLSearchParams?O.set(n,I):O[n]=I}i.addSearchParam=$})(o||(e.COI=o={}))}),define(K[40],G([0,1,28,24,3,13]),function(B,e,L,w,j,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dE=f;class s{constructor(g,o,i){this.id=g,this.dependencies=o,this.callback=i}}class h{static{this.INSTANCE=new h}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(g,o,i)=>{typeof g!="string"&&(i=o,o=g,g=null),(typeof o!="object"||!Array.isArray(o))&&(i=o,o=null),this.c.push(new s(g,o,i))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(g){if(g.startsWith(window.location.origin)||g.startsWith("vscode-file://vscode-app"))return g;throw new Error(`[trusted_script_src] Invalid script url: ${g}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(g){return g}})))}async load(g){this.g();const o=await(this.a?this.i(g):this.b?this.h(g):this.j(g));if(!o)throw new Error(`Did not receive a define call from script ${g}`);if(Array.isArray(o.dependencies)&&o.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${g}. The dependencies are: ${o.dependencies.join(", ")}`);return typeof o.callback=="function"?o.callback([]):o.callback}h(g){return new Promise((o,i)=>{const t=document.createElement("script");t.setAttribute("async","async"),t.setAttribute("type","text/javascript");const n=()=>{t.removeEventListener("load",r),t.removeEventListener("error",$)},r=O=>{n(),o(this.c.pop())},$=O=>{n(),i(O)};t.addEventListener("load",r),t.addEventListener("error",$),this.f&&(g=this.f.createScriptURL(g)),t.setAttribute("src",g),window.document.getElementsByTagName("head")[0].appendChild(t)})}i(g){return new Promise((o,i)=>{try{this.f&&(g=this.f.createScriptURL(g)),importScripts(g),o(this.c.pop())}catch(t){i(t)}})}async j(g){try{const o=globalThis._VSCODE_NODE_MODULES.fs,i=globalThis._VSCODE_NODE_MODULES.vm,t=globalThis._VSCODE_NODE_MODULES.module,n=C.URI.parse(g).fsPath,r=o.readFileSync(n).toString(),$=t.wrap(r.replace(/^#!.*/,""));return new i.Script($).runInThisContext().apply(),this.c.pop()}catch(o){throw o}}}const a=new Map;let d={};typeof globalThis.require=="object"&&(d=globalThis.require.paths??{});async function f(l,g,o){if(L.$T){o===void 0&&(o=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),d[l]&&(l=d[l]);const i=`${l}/${g}`;if(a.has(i))return a.get(i);let t;if(/^\w[\w\d+.-]*:\/\//.test(i))t=i;else{const O=`${o&&!j.$o?w.$Rg:w.$Qg}/${i}`;t=w.$Ug.asBrowserUri(O).toString(!0)}const n=h.INSTANCE.load(t);return a.set(i,n),n}else return await new Promise((i,t)=>{B([l],i,t)})}}),define(K[25],G([0,1,19,39,24,22,3,23,13]),function(B,e,L,w,j,C,s,h,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.$jh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=void 0,e.$2g=d,e.$kh=l,e.$lh=o;function d(i){return(0,a.$wc)(i,!0)}class f{constructor(t){this.a=t}compare(t,n,r=!1){return t===n?0:(0,h.$uf)(this.getComparisonKey(t,r),this.getComparisonKey(n,r))}isEqual(t,n,r=!1){return t===n?!0:!t||!n?!1:this.getComparisonKey(t,r)===this.getComparisonKey(n,r)}getComparisonKey(t,n=!1){return t.with({path:this.a(t)?t.path.toLowerCase():void 0,fragment:n?null:void 0}).toString()}ignorePathCasing(t){return this.a(t)}isEqualOrParent(t,n,r=!1){if(t.scheme===n.scheme){if(t.scheme===j.Schemas.file)return w.$zg(d(t),d(n),this.a(t))&&t.query===n.query&&(r||t.fragment===n.fragment);if((0,e.$gh)(t.authority,n.authority))return w.$zg(t.path,n.path,this.a(t),"/")&&t.query===n.query&&(r||t.fragment===n.fragment)}return!1}joinPath(t,...n){return a.URI.joinPath(t,...n)}basenameOrAuthority(t){return(0,e.$$g)(t)||t.authority}basename(t){return C.$gc.basename(t.path)}extname(t){return C.$gc.extname(t.path)}dirname(t){if(t.path.length===0)return t;let n;return t.scheme===j.Schemas.file?n=a.URI.file(C.$mc(d(t))).path:(n=C.$gc.dirname(t.path),t.authority&&n.length&&n.charCodeAt(0)!==L.CharCode.Slash&&(console.error(`dirname("${t.toString})) resulted in a relative path`),n="/")),t.with({path:n})}normalizePath(t){if(!t.path.length)return t;let n;return t.scheme===j.Schemas.file?n=a.URI.file(C.$hc(d(t))).path:n=C.$gc.normalize(t.path),t.with({path:n})}relativePath(t,n){if(t.scheme!==n.scheme||!(0,e.$gh)(t.authority,n.authority))return;if(t.scheme===j.Schemas.file){const O=C.$lc(d(t),d(n));return s.$i?w.$tg(O):O}let r=t.path||"/";const $=n.path||"/";if(this.a(t)){let O=0;for(const S=Math.min(r.length,$.length);O<S&&!(r.charCodeAt(O)!==$.charCodeAt(O)&&r.charAt(O).toLowerCase()!==$.charAt(O).toLowerCase());O++);r=$.substr(0,O)+r.substr(O)}return C.$gc.relative(r,$)}resolvePath(t,n){if(t.scheme===j.Schemas.file){const r=a.URI.file(C.$kc(d(t),n));return t.with({authority:r.authority,path:r.path})}return n=w.$ug(n),t.with({path:C.$gc.resolve(t.path,n)})}isAbsolutePath(t){return!!t.path&&t.path[0]==="/"}isEqualAuthority(t,n){return t===n||t!==void 0&&n!==void 0&&(0,h.$Bf)(t,n)}hasTrailingPathSeparator(t,n=C.sep){if(t.scheme===j.Schemas.file){const r=d(t);return r.length>w.$vg(r).length&&r[r.length-1]===n}else{const r=t.path;return r.length>1&&r.charCodeAt(r.length-1)===L.CharCode.Slash&&!/^[a-zA-Z]:(\/$|\\$)/.test(t.fsPath)}}removeTrailingPathSeparator(t,n=C.sep){return(0,e.$hh)(t,n)?t.with({path:t.path.substr(0,t.path.length-1)}):t}addTrailingPathSeparator(t,n=C.sep){let r=!1;if(t.scheme===j.Schemas.file){const $=d(t);r=$!==void 0&&$.length===w.$vg($).length&&$[$.length-1]===n}else{n="/";const $=t.path;r=$.length===1&&$.charCodeAt($.length-1)===L.CharCode.Slash}return!r&&!(0,e.$hh)(t,n)?t.with({path:t.path+"/"}):t}}e.$3g=f,e.$4g=new f(()=>!1),e.$5g=new f(i=>i.scheme===j.Schemas.file?!s.$k:!0),e.$6g=new f(i=>!0),e.$7g=e.$4g.isEqual.bind(e.$4g),e.$8g=e.$4g.isEqualOrParent.bind(e.$4g),e.$9g=e.$4g.getComparisonKey.bind(e.$4g),e.$0g=e.$4g.basenameOrAuthority.bind(e.$4g),e.$$g=e.$4g.basename.bind(e.$4g),e.$_g=e.$4g.extname.bind(e.$4g),e.$ah=e.$4g.dirname.bind(e.$4g),e.$bh=e.$4g.joinPath.bind(e.$4g),e.$ch=e.$4g.normalizePath.bind(e.$4g),e.$dh=e.$4g.relativePath.bind(e.$4g),e.$eh=e.$4g.resolvePath.bind(e.$4g),e.$fh=e.$4g.isAbsolutePath.bind(e.$4g),e.$gh=e.$4g.isEqualAuthority.bind(e.$4g),e.$hh=e.$4g.hasTrailingPathSeparator.bind(e.$4g),e.$ih=e.$4g.removeTrailingPathSeparator.bind(e.$4g),e.$jh=e.$4g.addTrailingPathSeparator.bind(e.$4g);function l(i,t){const n=[];for(let r=0;r<i.length;r++){const $=t(i[r]);i.some((O,S)=>S===r?!1:(0,e.$8g)($,t(O)))||n.push(i[r])}return n}var g;(function(i){i.META_DATA_LABEL="label",i.META_DATA_DESCRIPTION="description",i.META_DATA_SIZE="size",i.META_DATA_MIME="mime";function t(n){const r=new Map;n.path.substring(n.path.indexOf(";")+1,n.path.lastIndexOf(";")).split(";").forEach(S=>{const[E,I]=S.split(":");E&&I&&r.set(E,I)});const O=n.path.substring(0,n.path.indexOf(";"));return O&&r.set(i.META_DATA_MIME,O),r}i.parseMetaData=t})(g||(e.DataUri=g={}));function o(i,t,n){if(t){let r=i.path;return r&&r[0]!==C.$gc.sep&&(r=C.$gc.sep+r),i.with({scheme:n,authority:t,path:r})}return i.with({scheme:n})}}),define(K[26],G([0,1,31,7,15,2,25,3,35,34]),function(B,e,L,w,j,C,s,h,a,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4h=e.$2h=e.$1h=e.$Zh=e.$Yh=e.Promises=e.$Xh=e.$Wh=e.$Vh=e.$Th=e.$Sh=e.$Rh=e.$Qh=e.$Ph=e.$Oh=e.$Nh=e.$Mh=e.$Lh=e.$Kh=e.$Jh=e.$Ih=e.$Hh=e.$Gh=e.$Ah=e.$zh=e.$yh=e.$xh=e.$wh=e.$vh=e.$uh=void 0,e.$mh=f,e.$nh=l,e.$oh=g,e.$ph=o,e.$qh=i,e.$rh=t,e.$sh=n,e.$th=r,e.$Bh=q,e.$Ch=F,e.$Dh=k,e.$Eh=M,e.$Fh=m,e.$Uh=ue,e.$3h=le;function f(R){return!!R&&typeof R.then=="function"}function l(R){const c=new L.$se,T=R(c.token),p=new Promise((N,U)=>{const X=c.token.onCancellationRequested(()=>{X.dispose(),U(new w.$5)});Promise.resolve(T).then(Y=>{X.dispose(),c.dispose(),N(Y)},Y=>{X.dispose(),c.dispose(),U(Y)})});return new class{cancel(){c.cancel(),c.dispose()}then(N,U){return p.then(N,U)}catch(N){return this.then(void 0,N)}finally(N){return p.finally(N)}}}function g(R,c,T){return new Promise((p,N)=>{const U=c.onCancellationRequested(()=>{U.dispose(),p(T)});R.then(p,N).finally(()=>U.dispose())})}function o(R,c){return new Promise((T,p)=>{const N=c.onCancellationRequested(()=>{N.dispose(),p(new w.$5)});R.then(T,p).finally(()=>N.dispose())})}async function i(R){let c=-1;const T=R.map((p,N)=>p.then(U=>(c=N,U)));try{return await Promise.race(T)}finally{R.forEach((p,N)=>{N!==c&&p.cancel()})}}function t(R,c,T){let p;const N=setTimeout(()=>{p?.(void 0),T?.()},c);return Promise.race([R.finally(()=>clearTimeout(N)),new Promise(U=>p=U)])}function n(R){return new Promise((c,T)=>{const p=R();f(p)?p.then(c,T):c(p)})}function r(){let R,c;return{promise:new Promise((p,N)=>{R=p,c=N}),resolve:R,reject:c}}class ${constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(c){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=c,!this.b){const T=()=>{if(this.b=null,this.f)return;const p=this.queue(this.d);return this.d=null,p};this.b=new Promise(p=>{this.a.then(T,T).then(p)})}return new Promise((T,p)=>{this.b.then(T,p)})}return this.a=c(),new Promise((T,p)=>{this.a.then(N=>{this.a=null,T(N)},N=>{this.a=null,p(N)})})}dispose(){this.f=!0}}e.$uh=$;class O{constructor(){this.a=Promise.resolve(null)}queue(c){return this.a=this.a.then(()=>c(),()=>c())}}e.$vh=O;class S{constructor(){this.a=new Map}queue(c,T){const N=(this.a.get(c)??Promise.resolve()).catch(()=>{}).then(T).finally(()=>{this.a.get(c)===N&&this.a.delete(c)});return this.a.set(c,N),N}}e.$wh=S;const E=(R,c)=>{let T=!0;const p=setTimeout(()=>{T=!1,c()},R);return{isTriggered:()=>T,dispose:()=>{clearTimeout(p),T=!1}}},I=R=>{let c=!0;return queueMicrotask(()=>{c&&(c=!1,R())}),{isTriggered:()=>c,dispose:()=>{c=!1}}};class b{constructor(c){this.defaultDelay=c,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(c,T=this.defaultDelay){this.g=c,this.h(),this.b||(this.b=new Promise((N,U)=>{this.d=N,this.f=U}).then(()=>{if(this.b=null,this.d=null,this.g){const N=this.g;return this.g=null,N()}}));const p=()=>{this.a=null,this.d?.(null)};return this.a=T===a.$ce?I(p):E(T,p),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new w.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$xh=b;class v{constructor(c){this.a=new b(c),this.b=new $}trigger(c,T){return this.a.trigger(()=>this.b.queue(c),T)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$yh=v;class y{constructor(){this.a=!1,this.b=new Promise((c,T)=>{this.d=c})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$zh=y;class D extends y{constructor(c){super(),this.f=setTimeout(()=>this.open(),c)}open(){clearTimeout(this.f),super.open()}}e.$Ah=D;function q(R,c){return c?new Promise((T,p)=>{const N=setTimeout(()=>{U.dispose(),T()},R),U=c.onCancellationRequested(()=>{clearTimeout(N),U.dispose(),p(new w.$5)})}):l(T=>q(R,T))}function F(R,c=0,T){const p=setTimeout(()=>{R(),T&&N.dispose()},c),N=(0,C.$Sc)(()=>{clearTimeout(p),T?.deleteAndLeak(N)});return T?.add(N),N}function k(R){const c=[];let T=0;const p=R.length;function N(){return T<p?R[T++]():null}function U(X){X!=null&&c.push(X);const Y=N();return Y?Y.then(U):Promise.resolve(c)}return Promise.resolve(null).then(U)}function M(R,c=p=>!!p,T=null){let p=0;const N=R.length,U=()=>{if(p>=N)return Promise.resolve(T);const X=R[p++];return Promise.resolve(X()).then(ee=>c(ee)?Promise.resolve(ee):U())};return U()}function m(R,c=p=>!!p,T=null){if(R.length===0)return Promise.resolve(T);let p=R.length;const N=()=>{p=-1;for(const U of R)U.cancel?.()};return new Promise((U,X)=>{for(const Y of R)Y.then(ee=>{--p>=0&&c(ee)?(N(),U(ee)):p===0&&U(T)}).catch(ee=>{--p>=0&&(N(),X(ee))})})}class u{constructor(c){this.a=0,this.b=!1,this.f=c,this.g=[],this.d=0,this.h=new j.$he}whenIdle(){return this.size>0?j.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(c){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((T,p)=>{this.g.push({factory:c,c:T,e:p}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const c=this.g.shift();this.d++;const T=c.factory();T.then(c.c,c.e),T.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$Gh=u;class P extends u{constructor(){super(1)}}e.$Hh=P;class A{constructor(){this.a=new ie,this.b=0}queue(c){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,c())):this.a.run(this.b++,c())}}e.$Ih=A;class z{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const c=new te;return this.b.add(c),c.p}g(){for(const[,c]of this.a)if(c.size>0)return!1;return!0}queueSize(c,T=s.$4g){const p=T.getComparisonKey(c);return this.a.get(p)?.size??0}queueFor(c,T,p=s.$4g){const N=p.getComparisonKey(c);let U=this.a.get(N);if(!U){U=new P;const X=this.f++,Y=j.Event.once(U.onDrained)(()=>{U?.dispose(),this.a.delete(N),this.h(),this.d?.deleteAndDispose(X),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new C.$4c),this.d.set(X,Y),this.a.set(N,U)}return U.queue(T)}h(){this.g()&&this.j()}j(){for(const c of this.b)c.complete();this.b.clear()}dispose(){for(const[,c]of this.a)c.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$Jh=z;class W{constructor(c,T){this.b=!1,this.a=-1,typeof c=="function"&&typeof T=="number"&&this.setIfNotSet(c,T)}dispose(){this.cancel(),this.b=!0}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(c,T){if(this.b)throw new w.$cb("Calling 'cancelAndSet' on a disposed TimeoutTimer");this.cancel(),this.a=setTimeout(()=>{this.a=-1,c()},T)}setIfNotSet(c,T){if(this.b)throw new w.$cb("Calling 'setIfNotSet' on a disposed TimeoutTimer");this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,c()},T))}}e.$Kh=W;class H{constructor(){this.d=void 0,this.f=!1}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(c,T,p=globalThis){if(this.f)throw new w.$cb("Calling 'cancelAndSet' on a disposed IntervalTimer");this.cancel();const N=p.setInterval(()=>{c()},T);this.d=(0,C.$Sc)(()=>{p.clearInterval(N),this.d=void 0})}dispose(){this.cancel(),this.f=!0}}e.$Lh=H;class V{constructor(c,T){this.b=-1,this.a=c,this.d=T,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(c=this.d){this.cancel(),this.b=setTimeout(this.f,c)}get delay(){return this.d}set delay(c){this.d=c}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$Mh=V;class Z{constructor(c,T){T%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${T}ms is not a multiple of 1000ms.`),this.a=c,this.b=T,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(c=this.b){c%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${c}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(c/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$Nh=Z;class _ extends V{constructor(c,T){super(c,T),this.j=[]}work(c){this.j.push(c),this.isScheduled()||this.schedule()}h(){const c=this.j;this.j=[],this.a?.(c)}dispose(){this.j=[],super.dispose()}}e.$Oh=_;class oe extends C.$Uc{constructor(c,T){super(),this.g=c,this.h=T,this.a=[],this.b=this.B(new C.$Vc),this.f=!1}get pending(){return this.a.length}work(c){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+c.length>this.g.maxBufferedWork)return!1}else if(this.pending+c.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const T of c)this.a.push(T);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new V(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$Ph=oe,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$Rh=(R,c)=>{(0,h.$B)(()=>{if(T)return;const p=Date.now()+15;c(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,p-Date.now())}}))});let T=!1;return{dispose(){T||(T=!0)}}}:e.$Rh=(R,c,T)=>{const p=R.requestIdleCallback(c,typeof T=="number"?{timeout:T}:void 0);let N=!1;return{dispose(){N||(N=!0,R.cancelIdleCallback(p))}}},e.$Qh=R=>(0,e.$Rh)(globalThis,R)}();class ne{constructor(c,T){this.g=!1,this.d=()=>{try{this.j=T()}catch(p){this.l=p}finally{this.g=!0}},this.f=(0,e.$Rh)(c,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$Sh=ne;class he extends ne{constructor(c){super(globalThis,c)}}e.$Th=he;async function ue(R,c,T){let p;for(let N=0;N<T;N++)try{return await R()}catch(U){p=U,await q(c)}throw p}class ie{isRunning(c){return typeof c=="number"?this.a?.taskId===c:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(c,T,p){return this.a={taskId:c,cancel:()=>p?.(),promise:T},T.then(()=>this.d(c),()=>this.d(c)),T}d(c){this.a&&c===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const c=this.b;this.b=void 0,c.run().then(c.promiseResolve,c.promiseReject)}}queue(c){if(this.b)this.b.run=c;else{const{promise:T,resolve:p,reject:N}=r();this.b={run:c,promise:T,promiseResolve:p,promiseReject:N}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$Vh=ie;class ce{constructor(c,T=()=>Date.now()){this.d=c,this.f=T,this.a=0,this.b=0}increment(){const c=this.f();return c-this.a>this.d&&(this.a=c,this.b=0),this.b++,this.b}}e.$Wh=ce;var x;(function(R){R[R.Resolved=0]="Resolved",R[R.Rejected=1]="Rejected"})(x||(x={}));class te{get isRejected(){return this.d?.outcome===x.Rejected}get isResolved(){return this.d?.outcome===x.Resolved}get isSettled(){return!!this.d}get value(){return this.d?.outcome===x.Resolved?this.d?.value:void 0}constructor(){this.p=new Promise((c,T)=>{this.a=c,this.b=T})}complete(c){return new Promise(T=>{this.a(c),this.d={outcome:x.Resolved,value:c},T()})}error(c){return new Promise(T=>{this.b(c),this.d={outcome:x.Rejected,value:c},T()})}cancel(){return this.error(new w.$5)}}e.$Xh=te;var se;(function(R){async function c(p){let N;const U=await Promise.all(p.map(X=>X.then(Y=>Y,Y=>{N||(N=Y)})));if(typeof N<"u")throw N;return U}R.settled=c;function T(p){return new Promise(async(N,U)=>{try{await p(N,U)}catch(X){U(X)}})}R.withAsyncBody=T})(se||(e.Promises=se={}));class re{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(c){this.a=void 0,this.b=void 0,this.d=!1,this.promise=c.then(T=>(this.a=T,this.d=!0,T),T=>{throw this.b=T,this.d=!0,T})}requireValue(){if(!this.d)throw new w.$cb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$Yh=re;class de{constructor(c){this.b=c,this.a=new d.$V(()=>new re(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$Zh=de;var J;(function(R){R[R.Initial=0]="Initial",R[R.DoneOK=1]="DoneOK",R[R.DoneError=2]="DoneError"})(J||(J={}));class Q{static fromArray(c){return new Q(T=>{T.emitMany(c)})}static fromPromise(c){return new Q(async T=>{T.emitMany(await c)})}static fromPromises(c){return new Q(async T=>{await Promise.all(c.map(async p=>T.emitOne(await p)))})}static merge(c){return new Q(async T=>{await Promise.all(c.map(async p=>{for await(const N of p)T.emitOne(N)}))})}static{this.EMPTY=Q.fromArray([])}constructor(c,T){this.a=J.Initial,this.b=[],this.d=null,this.f=T,this.g=new j.$he,queueMicrotask(async()=>{const p={emitOne:N=>this.h(N),emitMany:N=>this.j(N),reject:N=>this.l(N)};try{await Promise.resolve(c(p)),this.k()}catch(N){this.l(N)}finally{p.emitOne=void 0,p.emitMany=void 0,p.reject=void 0}})}[Symbol.asyncIterator](){let c=0;return{next:async()=>{do{if(this.a===J.DoneError)throw this.d;if(c<this.b.length)return{done:!1,value:this.b[c++]};if(this.a===J.DoneOK)return{done:!0,value:void 0};await j.Event.toPromise(this.g.event)}while(!0)},return:async()=>(this.f?.(),{done:!0,value:void 0})}}static map(c,T){return new Q(async p=>{for await(const N of c)p.emitOne(T(N))})}map(c){return Q.map(this,c)}static filter(c,T){return new Q(async p=>{for await(const N of c)T(N)&&p.emitOne(N)})}filter(c){return Q.filter(this,c)}static coalesce(c){return Q.filter(c,T=>!!T)}coalesce(){return Q.coalesce(this)}static async toPromise(c){const T=[];for await(const p of c)T.push(p);return T}toPromise(){return Q.toPromise(this)}h(c){this.a===J.Initial&&(this.b.push(c),this.g.fire())}j(c){this.a===J.Initial&&(this.b=this.b.concat(c),this.g.fire())}k(){this.a===J.Initial&&(this.a=J.DoneOK,this.g.fire())}l(c){this.a===J.Initial&&(this.a=J.DoneError,this.d=c,this.g.fire())}}e.$1h=Q;class ae extends Q{constructor(c,T){super(T),this.m=c}cancel(){this.m.cancel()}}e.$2h=ae;function le(R){const c=new L.$se,T=R(c.token);return new ae(c,async p=>{const N=c.token.onCancellationRequested(()=>{N.dispose(),c.dispose(),p.reject(new w.$5)});try{for await(const U of T){if(c.token.isCancellationRequested)return;p.emitOne(U)}N.dispose(),c.dispose()}catch(U){N.dispose(),c.dispose(),p.reject(U)}})}class fe{constructor(c){this.a=new te,this.b=new Q(N=>{if(T){N.reject(T);return}return p&&N.emitMany(p),this.d=U=>N.reject(U),this.f=U=>N.emitOne(U),this.a.p},c);let T,p;this.f=N=>{p||(p=[]),p.push(N)},this.d=N=>{T||(T=N)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(c){this.d(c),this.a.complete()}emitOne(c){this.f(c)}}e.$4h=fe}),define(K[27],G([0,1,41,12]),function(B,e,L,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$C=void 0,e.$_C=j,e.$aD=C,e.$$C=new class{clone(){return this}equals(s){return this===s}};function j(s,h){return new L.$Hv([new L.$Gv(0,"",s)],h)}function C(s,h){const a=new Uint32Array(2);return a[0]=0,a[1]=(s<<w.MetadataConsts.LANGUAGEID_OFFSET|w.StandardTokenType.Other<<w.MetadataConsts.TOKEN_TYPE_OFFSET|w.FontStyle.None<<w.MetadataConsts.FONT_STYLE_OFFSET|w.ColorId.DefaultForeground<<w.MetadataConsts.FOREGROUND_OFFSET|w.ColorId.DefaultBackground<<w.MetadataConsts.BACKGROUND_OFFSET)>>>0,new L.$Iv(a,h===null?e.$$C:h)}}),define(K[42],G([0,1,26,7,3,43,18,20,51,12,27,36,21,11]),function(B,e,L,w,j,C,s,h,a,d,f,l,g,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iD=e.$hD=e.$gD=e.$fD=e.$eD=e.$dD=void 0;var i;(function(I){I[I.CHEAP_TOKENIZATION_LENGTH_LIMIT=2048]="CHEAP_TOKENIZATION_LENGTH_LIMIT"})(i||(i={}));class t{constructor(b,v){this.tokenizationSupport=v,this.a=this.tokenizationSupport.getInitialState(),this.store=new r(b)}getStartState(b){return this.store.getStartState(b,this.a)}getFirstInvalidLine(){return this.store.getFirstInvalidLine(this.a)}}e.$dD=t;class n extends t{constructor(b,v,y,D){super(b,v),this._textModel=y,this._languageIdCodec=D}updateTokensUntilLine(b,v){const y=this._textModel.getLanguageId();for(;;){const D=this.getFirstInvalidLine();if(!D||D.lineNumber>v)break;const q=this._textModel.getLineContent(D.lineNumber),F=S(this._languageIdCodec,y,this.tokenizationSupport,q,!0,D.startState);b.add(D.lineNumber,F.tokens),this.store.setEndState(D.lineNumber,F.endState)}}getTokenTypeIfInsertingCharacter(b,v){const y=this.getStartState(b.lineNumber);if(!y)return d.StandardTokenType.Other;const D=this._textModel.getLanguageId(),q=this._textModel.getLineContent(b.lineNumber),F=q.substring(0,b.column-1)+v+q.substring(b.column-1),k=S(this._languageIdCodec,D,this.tokenizationSupport,F,!0,y),M=new o.$xt(k.tokens,F,this._languageIdCodec);if(M.getCount()===0)return d.StandardTokenType.Other;const m=M.findTokenIndexAtOffset(b.column-1);return M.getStandardTokenType(m)}tokenizeLineWithEdit(b,v,y){const D=b.lineNumber,q=b.column,F=this.getStartState(D);if(!F)return null;const k=this._textModel.getLineContent(D),M=k.substring(0,q-1)+y+k.substring(q-1+v),m=this._textModel.getLanguageIdAtPosition(D,0),u=S(this._languageIdCodec,m,this.tokenizationSupport,M,!0,F);return new o.$xt(u.tokens,M,this._languageIdCodec)}hasAccurateTokensForLine(b){const v=this.store.getFirstInvalidEndStateLineNumberOrMax();return b<v}isCheapToTokenize(b){const v=this.store.getFirstInvalidEndStateLineNumberOrMax();return b<v||b===v&&this._textModel.getLineLength(b)<i.CHEAP_TOKENIZATION_LENGTH_LIMIT}tokenizeHeuristically(b,v,y){if(y<=this.store.getFirstInvalidEndStateLineNumberOrMax())return{heuristicTokens:!1};if(v<=this.store.getFirstInvalidEndStateLineNumberOrMax())return this.updateTokensUntilLine(b,y),{heuristicTokens:!1};let D=this.b(v);const q=this._textModel.getLanguageId();for(let F=v;F<=y;F++){const k=this._textModel.getLineContent(F),M=S(this._languageIdCodec,q,this.tokenizationSupport,k,!0,D);b.add(F,M.tokens),D=M.endState}return{heuristicTokens:!0}}b(b){let v=this._textModel.getLineFirstNonWhitespaceColumn(b);const y=[];let D=null;for(let k=b-1;v>1&&k>=1;k--){const M=this._textModel.getLineFirstNonWhitespaceColumn(k);if(M!==0&&M<v&&(y.push(this._textModel.getLineContent(k)),v=M,D=this.getStartState(k),D))break}D||(D=this.tokenizationSupport.getInitialState()),y.reverse();const q=this._textModel.getLanguageId();let F=D;for(const k of y)F=S(this._languageIdCodec,q,this.tokenizationSupport,k,!1,F).endState;return F}}e.$eD=n;class r{constructor(b){this.d=b,this.a=new $,this.b=new O,this.b.addRange(new a.$Av(1,b+1))}getEndState(b){return this.a.getEndState(b)}setEndState(b,v){if(!v)throw new w.$cb("Cannot set null/undefined state");this.b.delete(b);const y=this.a.setEndState(b,v);return y&&b<this.d&&this.b.addRange(new a.$Av(b+1,b+2)),y}acceptChange(b,v){this.d+=v-b.length,this.a.acceptChange(b,v),this.b.addRangeAndResize(new a.$Av(b.startLineNumber,b.endLineNumberExclusive),v)}acceptChanges(b){for(const v of b){const[y]=(0,s.$iv)(v.text);this.acceptChange(new h.$Cv(v.range.startLineNumber,v.range.endLineNumber+1),y+1)}}invalidateEndStateRange(b){this.b.addRange(new a.$Av(b.startLineNumber,b.endLineNumberExclusive))}getFirstInvalidEndStateLineNumber(){return this.b.min}getFirstInvalidEndStateLineNumberOrMax(){return this.getFirstInvalidEndStateLineNumber()||Number.MAX_SAFE_INTEGER}allStatesValid(){return this.b.min===null}getStartState(b,v){return b===1?v:this.getEndState(b-1)}getFirstInvalidLine(b){const v=this.getFirstInvalidEndStateLineNumber();if(v===null)return null;const y=this.getStartState(v,b);if(!y)throw new w.$cb("Start state must be defined");return{lineNumber:v,startState:y}}}e.$fD=r;class ${constructor(){this.a=new l.$bD(null)}getEndState(b){return this.a.get(b)}setEndState(b,v){const y=this.a.get(b);return y&&y.equals(v)?!1:(this.a.set(b,v),!0)}acceptChange(b,v){let y=b.length;v>0&&y>0&&(y--,v--),this.a.replace(b.startLineNumber,y,v)}acceptChanges(b){for(const v of b){const[y]=(0,s.$iv)(v.text);this.acceptChange(new h.$Cv(v.range.startLineNumber,v.range.endLineNumber+1),y+1)}}}e.$gD=$;class O{constructor(){this.a=[]}getRanges(){return this.a}get min(){return this.a.length===0?null:this.a[0].start}removeMin(){if(this.a.length===0)return null;const b=this.a[0];return b.start+1===b.endExclusive?this.a.shift():this.a[0]=new a.$Av(b.start+1,b.endExclusive),b.start}delete(b){const v=this.a.findIndex(y=>y.contains(b));if(v!==-1){const y=this.a[v];y.start===b?y.endExclusive===b+1?this.a.splice(v,1):this.a[v]=new a.$Av(b+1,y.endExclusive):y.endExclusive===b+1?this.a[v]=new a.$Av(y.start,b):this.a.splice(v,1,new a.$Av(y.start,b),new a.$Av(b+1,y.endExclusive))}}addRange(b){a.$Av.addRange(b,this.a)}addRangeAndResize(b,v){let y=0;for(;!(y>=this.a.length||b.start<=this.a[y].endExclusive);)y++;let D=y;for(;!(D>=this.a.length||b.endExclusive<this.a[D].start);)D++;const q=v-b.length;for(let F=D;F<this.a.length;F++)this.a[F]=this.a[F].delta(q);if(y===D){const F=new a.$Av(b.start,b.start+v);F.isEmpty||this.a.splice(y,0,F)}else{const F=Math.min(b.start,this.a[y].start),k=Math.max(b.endExclusive,this.a[D-1].endExclusive),M=new a.$Av(F,k+q);M.isEmpty?this.a.splice(y,D-y):this.a.splice(y,D-y,M)}}toString(){return this.a.map(b=>b.toString()).join(" + ")}}e.$hD=O;function S(I,b,v,y,D,q){let F=null;if(v)try{F=v.tokenizeEncoded(y,D,q.clone())}catch(k){(0,w.$1)(k)}return F||(F=(0,f.$aD)(I.encodeLanguageId(b),q)),o.$xt.convertToEndOffset(F.tokens,y.length),F}class E{constructor(b,v){this.b=b,this.d=v,this.a=!1,this.f=!1}dispose(){this.a=!0}handleChanges(){this.g()}g(){this.f||!this.b._textModel.isAttachedToEditor()||!this.k()||(this.f=!0,(0,L.$Qh)(b=>{this.f=!1,this.h(b)}))}h(b){const v=Date.now()+b.timeRemaining(),y=()=>{this.a||!this.b._textModel.isAttachedToEditor()||!this.k()||(this.j(),Date.now()<v?(0,j.$B)(y):this.g())};y()}j(){const b=this.b._textModel.getLineCount(),v=new g.$cD,y=C.$be.create(!1);do if(y.elapsed()>1||this.l(v)>=b)break;while(this.k());this.d.setTokens(v.finalize()),this.checkFinished()}k(){return this.b?!this.b.store.allStatesValid():!1}l(b){const v=this.b?.getFirstInvalidLine();return v?(this.b.updateTokensUntilLine(b,v.lineNumber),v.lineNumber):this.b._textModel.getLineCount()+1}checkFinished(){this.a||this.b.store.allStatesValid()&&this.d.backgroundTokenizationFinished()}requestTokens(b,v){this.b.store.invalidateEndStateRange(new h.$Cv(b,v))}}e.$iD=E}),define(K[44],G([0,1,15,2,43,12,41]),function(B,e,L,w,j,C,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$JMb=void 0;class h extends w.$Uc{constructor(d,f,l,g,o,i,t){super(),this.c=d,this.f=f,this.g=l,this.h=g,this.j=o,this.m=i,this.n=t,this.a=[],this.b=this.B(new L.$he),this.onDidEncounterLanguage=this.b.event}get backgroundTokenizerShouldOnlyVerifyTokens(){return this.j()}getInitialState(){return this.f}tokenize(d,f,l){throw new Error("Not supported!")}createBackgroundTokenizer(d,f){if(this.h)return this.h(d,f)}tokenizeEncoded(d,f,l){const g=Math.random()*1e4<1,o=this.n||g,i=o?new j.$be(!0):void 0,t=this.c.tokenizeLine2(d,l,500);if(o){const r=i.elapsed();(g||r>32)&&this.m(r,d.length,g)}if(t.stoppedEarly)return console.warn(`Time limit reached when tokenizing line: ${d.substring(0,100)}`),new s.$Iv(t.tokens,l);if(this.g){const r=this.a,$=t.tokens;for(let O=0,S=$.length>>>1;O<S;O++){const E=$[(O<<1)+1],I=C.$ft.getLanguageId(E);r[I]||(r[I]=!0,this.b.fire(I))}}let n;return l.equals(t.ruleStack)?n=l:n=t.ruleStack,new s.$Iv(t.tokens,n)}}e.$JMb=h}),define(K[45],G([0,1,27,2,16]),function(B,e,L,w,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KMb=void 0;class C extends w.$Uc{get backgroundTokenizerShouldOnlyVerifyTokens(){return this.b.backgroundTokenizerShouldOnlyVerifyTokens}constructor(h,a,d){super(),this.a=h,this.b=a,this.c=d,this.B((0,j.keepObserved)(this.c))}getInitialState(){return this.b.getInitialState()}tokenize(h,a,d){throw new Error("Not supported!")}tokenizeEncoded(h,a,d){return h.length>=this.c.get()?(0,L.$aD)(this.a,d):this.b.tokenizeEncoded(h,a,d)}createBackgroundTokenizer(h,a){if(this.b.createBackgroundTokenizer)return this.b.createBackgroundTokenizer(h,a)}}e.$KMb=C}),define(K[46],G([0,1,40,26,16,3,20,52,42,21,11,44,45]),function(B,e,L,w,j,C,s,h,a,d,f,l,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PMb=void 0;class o extends h.$bw{constructor(n,r,$,O,S,E,I,b){super(n,r,$,O),this.s=S,this.t=E,this.u=I,this.a=null,this.b=!1,this.c=(0,j.observableValue)(this,-1),this.q=new w.$Mh(()=>this.w(),10),this.c.set(b,void 0),this.v()}dispose(){this.b=!0,super.dispose()}onLanguageId(n,r){this.t=n,this.u=r,this.v()}onEvents(n){super.onEvents(n),this.a?.store.acceptChanges(n.changes),this.q.schedule()}acceptMaxTokenizationLineLength(n){this.c.set(n,void 0)}retokenize(n,r){this.a&&(this.a.store.invalidateEndStateRange(new s.$Cv(n,r)),this.q.schedule())}async v(){this.a=null;const n=this.t,r=this.u,$=await this.s.getOrCreateGrammar(n,r);if(!(this.b||n!==this.t||r!==this.u||!$)){if($.grammar){const O=new g.$KMb(this.u,new l.$JMb($.grammar,$.initialState,!1,void 0,()=>!1,(S,E,I)=>{this.s.reportTokenizationTime(S,n,$.sourceExtensionId,E,I)},!1),this.c);this.a=new a.$dD(this.f.length,O)}else this.a=null;this.w()}}async w(){if(this.b||!this.a)return;if(!this.m){const{diffStateStacksRefEq:r}=await(0,L.$dE)("vscode-textmate","release/main.js");this.m=r}const n=new Date().getTime();for(;;){let r=0;const $=new d.$cD,O=new i;for(;;){const I=this.a.getFirstInvalidLine();if(I===null||r>200)break;r++;const b=this.f[I.lineNumber-1],v=this.a.tokenizationSupport.tokenizeEncoded(b,!0,I.startState);if(this.a.store.setEndState(I.lineNumber,v.endState)){const D=this.m(I.startState,v.endState);O.setState(I.lineNumber,D)}else O.setState(I.lineNumber,null);if(f.$xt.convertToEndOffset(v.tokens,b.length),$.add(I.lineNumber,v.tokens),new Date().getTime()-n>20)break}if(r===0)break;const S=O.getStateDeltas();if(this.s.setTokensAndStates(this.h,$.serialize(),S),new Date().getTime()-n>20){(0,C.$B)(()=>this.w());return}}}}e.$PMb=o;class i{constructor(){this.a=-1,this.b=[]}setState(n,r){n===this.a+1?this.b[this.b.length-1].stateDeltas.push(r):this.b.push({startLineNumber:n,stateDeltas:[r]}),this.a=n}getStateDeltas(){return this.b}}}),define(K[47],G([0,1,25]),function(B,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MMb=void 0;class w{constructor(){this.a=Object.create(null)}reset(){this.a=Object.create(null)}register(C){if(this.a[C.scopeName]){const s=this.a[C.scopeName];L.$7g(s.location,C.location)||console.warn(`Overwriting grammar scope name to file mapping for scope ${C.scopeName}.
Old grammar file: ${s.location.toString()}.
New grammar file: ${C.location.toString()}`)}this.a[C.scopeName]=C}getGrammarDefinition(C){return this.a[C]||null}}e.$MMb=w}),define(K[48],G([0,1,2,47]),function(B,e,L,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OMb=e.$NMb=void 0,e.$NMb="No TM Grammar registered for this language.";class j extends L.$Uc{constructor(s,h,a,d){super(),this.a=s,this.b=a.INITIAL,this.c=new w.$MMb,this.f={},this.g={},this.h=new Map,this.j=this.B(new a.Registry({onigLib:d,loadGrammar:async f=>{const l=this.c.getGrammarDefinition(f);if(!l)return this.a.logTrace(`No grammar found for scope ${f}`),null;const g=l.location;try{const o=await this.a.readFile(g);return a.parseRawGrammar(o,g.path)}catch(o){return this.a.logError(`Unable to load and parse grammar for scope ${f} from ${g}`,o),null}},getInjections:f=>{const l=f.split(".");let g=[];for(let o=1;o<=l.length;o++){const i=l.slice(0,o).join(".");g=[...g,...this.f[i]||[]]}return g}}));for(const f of h){if(this.c.register(f),f.injectTo){for(const l of f.injectTo){let g=this.f[l];g||(this.f[l]=g=[]),g.push(f.scopeName)}if(f.embeddedLanguages)for(const l of f.injectTo){let g=this.g[l];g||(this.g[l]=g=[]),g.push(f.embeddedLanguages)}}f.language&&this.h.set(f.language,f.scopeName)}}has(s){return this.h.has(s)}setTheme(s,h){this.j.setTheme(s,h)}getColorMap(){return this.j.getColorMap()}async createGrammar(s,h){const a=this.h.get(s);if(typeof a!="string")throw new Error(e.$NMb);const d=this.c.getGrammarDefinition(a);if(!d)throw new Error(e.$NMb);const f=d.embeddedLanguages;if(this.g[a]){const o=this.g[a];for(const i of o)for(const t of Object.keys(i))f[t]=i[t]}const l=Object.keys(f).length>0;let g;try{g=await this.j.loadGrammarWithConfiguration(a,h,{embeddedLanguages:f,tokenTypes:d.tokenTypes,balancedBracketSelectors:d.balancedBracketSelectors,unbalancedBracketSelectors:d.unbalancedBracketSelectors})}catch(o){throw o.message&&o.message.startsWith("No grammar provided for")?new Error(e.$NMb):o}return{languageId:s,grammar:g,initialState:this.b,containsEmbeddedLanguages:l,sourceExtensionId:d.sourceExtensionId}}}e.$OMb=j}),define(K[53],G([0,1,13,48,46]),function(B,e,L,w,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextMateTokenizationWorker=void 0,e.create=C;function C(h,a){return new s(h,a)}class s{constructor(a,d){this.f=d,this.b=new Map,this.c=[],this.a=a.host;const f=d.grammarDefinitions.map(l=>({location:L.URI.revive(l.location),language:l.language,scopeName:l.scopeName,embeddedLanguages:l.embeddedLanguages,tokenTypes:l.tokenTypes,injectTo:l.injectTo,balancedBracketSelectors:l.balancedBracketSelectors,unbalancedBracketSelectors:l.unbalancedBracketSelectors,sourceExtensionId:l.sourceExtensionId}));this.d=this.g(f)}async g(a){const d=this.f.textmateMainUri,f=await new Promise((t,n)=>{B([d],t,n)}),l=await new Promise((t,n)=>{B([this.f.onigurumaMainUri],t,n)}),o=await(await fetch(this.f.onigurumaWASMUri)).arrayBuffer();await l.loadWASM(o);const i=Promise.resolve({createOnigScanner:t=>l.createOnigScanner(t),createOnigString:t=>l.createOnigString(t)});return new w.$OMb({logTrace:t=>{},logError:(t,n)=>console.error(t,n),readFile:t=>this.a.readFile(t)},a,f,i)}acceptNewModel(a){const d=L.URI.revive(a.uri),f=this;this.b.set(a.controllerId,new j.$PMb(d,a.lines,a.EOL,a.versionId,{async getOrCreateGrammar(l,g){const o=await f.d;return o?(f.c[g]||(f.c[g]=o.createGrammar(l,g)),f.c[g]):Promise.resolve(null)},setTokensAndStates(l,g,o){f.a.setTokensAndStates(a.controllerId,l,g,o)},reportTokenizationTime(l,g,o,i,t){f.a.reportTokenizationTime(l,g,o,i,t)}},a.languageId,a.encodedLanguageId,a.maxTokenizationLineLength))}acceptModelChanged(a,d){this.b.get(a).onEvents(d)}retokenize(a,d,f){this.b.get(a).retokenize(d,f)}acceptModelLanguageChanged(a,d,f){this.b.get(a).onLanguageId(d,f)}acceptRemovedModel(a){const d=this.b.get(a);d&&(d.dispose(),this.b.delete(a))}async acceptTheme(a,d){(await this.d)?.setTheme(a,d)}acceptMaxTokenizationLineLength(a,d){this.b.get(a).acceptMaxTokenizationLineLength(d)}}e.TextMateTokenizationWorker=s})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/fd11ed87fdf1f8e46575e027644406f51f0666f6/core/vs/workbench/services/textMate/browser/backgroundTokenization/worker/textMateTokenizationWorker.worker.js.map
